/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/event","vs/base/common/types","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/functional","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/objects","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(O){for(var n=[],P=0,t=O.length;P<t;P++)n[P]=te[O[P]];return n},Se=this,Ie=typeof global=="object"?global:{},ue;(function(O){O.global=Se;var n=function(){function P(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(P.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),P.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=P._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},P._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},P}();O.Environment=n})(ue||(ue={}));var ue;(function(O){var n=function(){function F(a,y,h){this.type=a,this.detail=y,this.timestamp=h}return F}();O.LoaderEvent=n;var P=function(){function F(a){this._events=[new n(1,"",a)]}return F.prototype.record=function(a,y){this._events.push(new n(a,y,O.Utilities.getHighPerformanceTimestamp()))},F.prototype.getEvents=function(){return this._events},F}();O.LoaderEventRecorder=P;var t=function(){function F(){}return F.prototype.record=function(a,y){},F.prototype.getEvents=function(){return[]},F.INSTANCE=new F,F}();O.NullLoaderEventRecorder=t})(ue||(ue={}));var ue;(function(O){var n=function(){function P(){}return P.fileUriToFilePath=function(t,F){if(F=decodeURI(F).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(F))return F.substr(8);if(/^file:\/\//.test(F))return F.substr(5)}else if(/^file:\/\//.test(F))return F.substr(7);return F},P.startsWith=function(t,F){return t.length>=F.length&&t.substr(0,F.length)===F},P.endsWith=function(t,F){return t.length>=F.length&&t.substr(t.length-F.length)===F},P.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},P.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},P.forEachProperty=function(t,F){if(t){var a=void 0;for(a in t)t.hasOwnProperty(a)&&F(a,t[a])}},P.isEmpty=function(t){var F=!0;return P.forEachProperty(t,function(){F=!1}),F},P.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var F=Array.isArray(t)?[]:{};return P.forEachProperty(t,function(a,y){y&&typeof y=="object"?F[a]=P.recursiveClone(y):F[a]=y}),F},P.generateAnonymousModule=function(){return"===anonymous"+P.NEXT_ANONYMOUS_ID+++"==="},P.isAnonymousModule=function(t){return P.startsWith(t,"===anonymous")},P.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()},P.NEXT_ANONYMOUS_ID=1,P.PERFORMANCE_NOW_PROBED=!1,P.HAS_PERFORMANCE_NOW=!1,P}();O.Utilities=n})(ue||(ue={}));var ue;(function(O){function n(F){if(F instanceof Error)return F;var a=new Error(F.message||String(F)||"Unknown Error");return F.stack&&(a.stack=F.stack),a}O.ensureError=n;var P=function(){function F(){}return F.validateConfigurationOptions=function(a){function y(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory method of "'+o.moduleId+'" has thrown an exception'),console.error(o);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError=="undefined"&&(a.catchError=!1),typeof a.recordStats=="undefined"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=y),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(O.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags=="undefined"&&(a.preferScriptTags=!1),Array.isArray(a.nodeModules)||(a.nodeModules=[]),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){var h=n(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",a.onError(h),a.nodeCachedData=void 0}return a},F.mergeConfigurationOptions=function(a,y){a===void 0&&(a=null),y===void 0&&(y=null);var h=O.Utilities.recursiveClone(y||{});return O.Utilities.forEachProperty(a,function(o,c){o==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules!="undefined"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(c):o==="paths"&&typeof h.paths!="undefined"?O.Utilities.forEachProperty(c,function(N,M){return h.paths[N]=M}):o==="config"&&typeof h.config!="undefined"?O.Utilities.forEachProperty(c,function(N,M){return h.config[N]=M}):h[o]=O.Utilities.recursiveClone(c)}),F.validateConfigurationOptions(h)},F}();O.ConfigurationOptionsUtil=P;var t=function(){function F(a,y){if(this._env=a,this.options=P.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var h=this.options.nodeRequire.main.filename,o=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var h=this.options.nodeMain,o=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,o+1)}}}return F.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0},F.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var a=0,y=this.options.nodeModules;a<y.length;a++){var h=y[a];this.nodeModulesMap[h]=!0}},F.prototype._createSortedPathsRules=function(){var a=this;this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,function(y,h){Array.isArray(h)?a.sortedPathsRules.push({from:y,to:h}):a.sortedPathsRules.push({from:y,to:[h]})}),this.sortedPathsRules.sort(function(y,h){return h.from.length-y.from.length})},F.prototype.cloneAndMerge=function(a){return new F(this._env,P.mergeConfigurationOptions(a,this.options))},F.prototype.getOptionsLiteral=function(){return this.options},F.prototype._applyPaths=function(a){for(var y,h=0,o=this.sortedPathsRules.length;h<o;h++)if(y=this.sortedPathsRules[h],O.Utilities.startsWith(a,y.from)){for(var c=[],N=0,M=y.to.length;N<M;N++)c.push(y.to[N]+a.substr(y.from.length));return c}return[a]},F.prototype._addUrlArgsToUrl=function(a){return O.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs},F.prototype._addUrlArgsIfNecessaryToUrl=function(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a},F.prototype._addUrlArgsIfNecessaryToUrls=function(a){if(this.options.urlArgs)for(var y=0,h=a.length;y<h;y++)a[y]=this._addUrlArgsToUrl(a[y]);return a},F.prototype.moduleIdToPaths=function(a){if(this._env.isNode){var y=this.nodeModulesMap[a]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a);if(y)return this.isBuild()?["empty:"]:["node|"+a]}var h=a,o;if(!O.Utilities.endsWith(h,".js")&&!O.Utilities.isAbsolutePath(h)){o=this._applyPaths(h);for(var c=0,N=o.length;c<N;c++)this.isBuild()&&o[c]==="empty:"||(O.Utilities.isAbsolutePath(o[c])||(o[c]=this.options.baseUrl+o[c]),!O.Utilities.endsWith(o[c],".js")&&!O.Utilities.containsQueryString(o[c])&&(o[c]=o[c]+".js"))}else!O.Utilities.endsWith(h,".js")&&!O.Utilities.containsQueryString(h)&&(h=h+".js"),o=[h];return this._addUrlArgsIfNecessaryToUrls(o)},F.prototype.requireToUrl=function(a){var y=a;return O.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],O.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)},F.prototype.isBuild=function(){return this.options.isBuild},F.prototype.isDuplicateMessageIgnoredFor=function(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)},F.prototype.getConfigForModule=function(a){if(this.options.config)return this.options.config[a]},F.prototype.shouldCatchError=function(){return this.options.catchError},F.prototype.shouldRecordStats=function(){return this.options.recordStats},F.prototype.onError=function(a){this.options.onError(a)},F}();O.Configuration=t})(ue||(ue={}));var ue;(function(O){var n=function(){function o(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(c,N,M,w){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new F;else if(this._env.isElectronRenderer){var e=c.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new P:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new P;var L={callback:M,errorback:w};if(this._callbackMap.hasOwnProperty(N)){this._callbackMap[N].push(L);return}this._callbackMap[N]=[L],this._scriptLoader.load(c,N,function(){return m.triggerCallback(N)},function(C){return m.triggerErrorback(N,C)})},o.prototype.triggerCallback=function(c){var N=this._callbackMap[c];delete this._callbackMap[c];for(var M=0;M<N.length;M++)N[M].callback()},o.prototype.triggerErrorback=function(c,N){var M=this._callbackMap[c];delete this._callbackMap[c];for(var w=0;w<M.length;w++)M[w].errorback(N)},o}(),P=function(){function o(){}return o.prototype.attachListeners=function(c,N,M){var w=function(){c.removeEventListener("load",m),c.removeEventListener("error",e)},m=function(L){w(),N()},e=function(L){w(),M(L)};c.addEventListener("load",m),c.addEventListener("error",e)},o.prototype.load=function(c,N,M,w){if(/^node\|/.test(N)){var m=c.getConfig().getOptionsLiteral(),e=y(c.getRecorder(),m.nodeRequire||O.global.nodeRequire),L=N.split("|"),C=null;try{C=e(L[1])}catch(i){w(i);return}c.enqueueDefineAnonymousModule([],function(){return C}),M()}else{var v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript"),this.attachListeners(v,M,w);var f=c.getConfig().getOptionsLiteral().trustedTypesPolicy;f&&(N=f.createScriptURL(N)),v.setAttribute("src",N);var s=c.getConfig().getOptionsLiteral().cspNonce;s&&v.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(v)}},o}();function t(o){var c=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var N=c?self.eval(c.createScript("","true")):new Function("true");return N.call(self),!0}catch{return!1}}var F=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(c)),this._cachedCanUseEval},o.prototype.load=function(c,N,M,w){if(/^node\|/.test(N)){var m=c.getConfig().getOptionsLiteral(),e=y(c.getRecorder(),m.nodeRequire||O.global.nodeRequire),L=N.split("|"),C=null;try{C=e(L[1])}catch(s){w(s);return}c.enqueueDefineAnonymousModule([],function(){return C}),M()}else{var v=c.getConfig().getOptionsLiteral().trustedTypesPolicy,f=/^((http:)|(https:)|(file:))/.test(N)&&N.substring(0,self.origin.length)!==self.origin;if(!f&&this._canUseEval(c)){fetch(N).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+N;var i=v?self.eval(v.createScript("",s)):new Function(s);i.call(self),M()}).then(void 0,w);return}try{v&&(N=v.createScriptURL(N)),importScripts(N),M()}catch(s){w(s)}}},o}(),a=function(){function o(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},o.prototype._initNodeRequire=function(c,N){var M=N.getConfig().getOptionsLiteral().nodeCachedData;if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,m=c("module");function e(L){var C=L.constructor,v=function(s){try{return L.require(s)}finally{}};return v.resolve=function(s,i){return C._resolveFilename(s,L,!1,i)},v.resolve.paths=function(s){return C._resolveLookupPaths(s,L)},v.main=process.mainModule,v.extensions=C._extensions,v.cache=C._cache,v}m.prototype._compile=function(L,C){var v=m.wrap(L.replace(/^#!.*/,"")),f=N.getRecorder(),s=w._getCachedDataPath(M,C),i={filename:C},l;try{var _=w._fs.readFileSync(s);l=_.slice(0,16),i.cachedData=_.slice(16),f.record(60,s)}catch{f.record(61,s)}var p=new w._vm.Script(v,i),g=p.runInThisContext(i),u=w._path.dirname(C),d=e(this),b=[this.exports,d,this,C,u,process,Ie,Buffer],A=g.apply(this.exports,b);return w._handleCachedData(p,v,s,!i.cachedData,N),w._verifyCachedData(p,v,s,l,N),A}},o.prototype.load=function(c,N,M,w){var m=this,e=c.getConfig().getOptionsLiteral(),L=y(c.getRecorder(),e.nodeRequire||O.global.nodeRequire),C=e.nodeInstrumenter||function(g){return g};this._init(L),this._initNodeRequire(L,c);var v=c.getRecorder();if(/^node\|/.test(N)){var f=N.split("|"),s=null;try{s=L(f[1])}catch(g){w(g);return}c.enqueueDefineAnonymousModule([],function(){return s}),M()}else{N=O.Utilities.fileUriToFilePath(this._env.isWindows,N);var i=this._path.normalize(N),l=this._getElectronRendererScriptPathOrUri(i),_=Boolean(e.nodeCachedData),p=_?this._getCachedDataPath(e.nodeCachedData,N):void 0;this._readSourceAndCachedData(i,p,v,function(g,u,d,b){if(g){w(g);return}var A;u.charCodeAt(0)===o._BOM?A=o._PREFIX+u.substring(1)+o._SUFFIX:A=o._PREFIX+u+o._SUFFIX,A=C(A,i);var R={filename:l,cachedData:d},S=m._createAndEvalScript(c,A,R,M,w);m._handleCachedData(S,A,p,_&&!d,c),m._verifyCachedData(S,A,p,b,c)})}},o.prototype._createAndEvalScript=function(c,N,M,w,m){var e=c.getRecorder();e.record(31,M.filename);var L=new this._vm.Script(N,M),C=L.runInThisContext(M),v=c.getGlobalAMDDefineFunc(),f=!1,s=function(){return f=!0,v.apply(null,arguments)};return s.amd=v.amd,C.call(O.global,c.getGlobalAMDRequireFunc(),s,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),f?w():m(new Error("Didn't receive define call in "+M.filename+"!")),L},o.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var N=c.match(/^([a-z])\:(.*)/i);return N?"file:///"+(N[1].toUpperCase()+":"+N[2]).replace(/\\/g,"/"):"file://"+c},o.prototype._getCachedDataPath=function(c,N){var M=this._crypto.createHash("md5").update(N,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(N).replace(/\.js$/,"");return this._path.join(c.path,w+"-"+M+".code")},o.prototype._handleCachedData=function(c,N,M,w,m){var e=this;c.cachedDataRejected?this._fs.unlink(M,function(L){m.getRecorder().record(62,M),e._createAndWriteCachedData(c,N,M,m),L&&m.getConfig().onError(L)}):w&&this._createAndWriteCachedData(c,N,M,m)},o.prototype._createAndWriteCachedData=function(c,N,M,w){var m=this,e=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,C=0,v=void 0,f=function(){setTimeout(function(){v||(v=m._crypto.createHash("md5").update(N,"utf8").digest());var s=c.createCachedData();if(!(s.length===0||s.length===L||C>=5)){if(s.length<L){f();return}L=s.length,m._fs.writeFile(M,Buffer.concat([v,s]),function(i){i&&w.getConfig().onError(i),w.getRecorder().record(63,M),f()})}},e*Math.pow(4,C++))};f()},o.prototype._readSourceAndCachedData=function(c,N,M,w){if(!N)this._fs.readFile(c,{encoding:"utf8"},w);else{var m=void 0,e=void 0,L=void 0,C=2,v=function(f){f?w(f):--C==0&&w(void 0,m,e,L)};this._fs.readFile(c,{encoding:"utf8"},function(f,s){m=s,v(f)}),this._fs.readFile(N,function(f,s){!f&&s&&s.length>0?(L=s.slice(0,16),e=s.slice(16),M.record(60,N)):M.record(61,N),v()})}},o.prototype._verifyCachedData=function(c,N,M,w,m){var e=this;!w||c.cachedDataRejected||setTimeout(function(){var L=e._crypto.createHash("md5").update(N,"utf8").digest();w.equals(L)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+M+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(M,function(C){C&&m.getConfig().onError(C)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function y(o,c){if(c.__$__isRecorded)return c;var N=function(w){o.record(33,w);try{return c(w)}finally{o.record(34,w)}};return N.__$__isRecorded=!0,N}O.ensureRecordedNodeRequire=y;function h(o){return new n(o)}O.createScriptLoader=h})(ue||(ue={}));var ue;(function(O){var n=function(){function h(o){var c=o.lastIndexOf("/");c!==-1?this.fromModulePath=o.substr(0,c+1):this.fromModulePath=""}return h._normalizeModuleId=function(o){var c=o,N;for(N=/\/\.\//;N.test(c);)c=c.replace(N,"/");for(c=c.replace(/^\.\//g,""),N=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;N.test(c);)c=c.replace(N,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},h.prototype.resolveModule=function(o){var c=o;return O.Utilities.isAbsolutePath(c)||(O.Utilities.startsWith(c,"./")||O.Utilities.startsWith(c,"../"))&&(c=h._normalizeModuleId(this.fromModulePath+c)),c},h.ROOT=new h(""),h}();O.ModuleIdResolver=n;var P=function(){function h(o,c,N,M,w,m){this.id=o,this.strId=c,this.dependencies=N,this._callback=M,this._errorback=w,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return h._safeInvokeFunction=function(o,c){try{return{returnedValue:o.apply(O.global,c),producedError:null}}catch(N){return{returnedValue:null,producedError:N}}},h._invokeFactory=function(o,c,N,M){return o.isBuild()&&!O.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:o.shouldCatchError()?this._safeInvokeFunction(N,M):{returnedValue:N.apply(O.global,M),producedError:null}},h.prototype.complete=function(o,c,N){this._isComplete=!0;var M=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var w=h._invokeFactory(c,this.strId,this._callback,N);M=w.producedError,o.record(22,this.strId),!M&&typeof w.returnedValue!="undefined"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=w.returnedValue)}else this.exports=this._callback;if(M){var m=O.ensureError(M);m.phase="factory",m.moduleId=this.strId,this.error=m,c.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},h.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},h.prototype.isComplete=function(){return this._isComplete},h}();O.Module=P;var t=function(){function h(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return h.prototype.getMaxModuleId=function(){return this._nextId},h.prototype.getModuleId=function(o){var c=this._strModuleIdToIntModuleId.get(o);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(o,c),this._intModuleIdToStrModuleId[c]=o),c},h.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},h}(),F=function(){function h(o){this.id=o}return h.EXPORTS=new h(0),h.MODULE=new h(1),h.REQUIRE=new h(2),h}();O.RegularDependency=F;var a=function(){function h(o,c,N){this.id=o,this.pluginId=c,this.pluginParam=N}return h}();O.PluginDependency=a;var y=function(){function h(o,c,N,M,w){w===void 0&&(w=0),this._env=o,this._scriptLoader=c,this._loaderAvailableTimestamp=w,this._defineFunc=N,this._requireFunc=M,this._moduleIdProvider=new t,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return h.prototype.reset=function(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},h.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},h.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},h._findRelevantLocationInStack=function(o,c){for(var N=function(i){return i.replace(/\\/g,"/")},M=N(o),w=c.split(/\n/),m=0;m<w.length;m++){var e=w[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){var L=e[1],C=e[2],v=e[3],f=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(f),L=N(L),L===M){var s={line:parseInt(C,10),col:parseInt(v,10)};return s.line===1&&(s.col-="(function (require, define, __filename, __dirname) { ".length),s}}}throw new Error("Could not correlate define call site for needle "+o)},h.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],c=0,N=0,M=this._modules2.length;N<M;N++){var w=this._modules2[N];if(!!w){var m=this._buildInfoPath[w.id]||null,e=this._buildInfoDefineStack[w.id]||null,L=this._buildInfoDependencies[w.id];o[c++]={id:w.strId,path:m,defineLocation:m&&e?h._findRelevantLocationInStack(m,e):null,dependencies:L,shim:null,exports:w.exports}}}return o},h.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder},h.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},h.prototype.enqueueDefineAnonymousModule=function(o,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var N=null;this._config.isBuild()&&(N=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:N,dependencies:o,callback:c}},h.prototype.defineModule=function(o,c,N,M,w,m){var e=this;m===void 0&&(m=new n(o));var L=this._moduleIdProvider.getModuleId(o);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var C=new P(L,o,this._normalizeDependencies(c,m),N,M,m);this._modules2[L]=C,this._config.isBuild()&&(this._buildInfoDefineStack[L]=w,this._buildInfoDependencies[L]=(C.dependencies||[]).map(function(v){return e._moduleIdProvider.getStrModuleId(v.id)})),this._resolve(C)},h.prototype._normalizeDependency=function(o,c){if(o==="exports")return F.EXPORTS;if(o==="module")return F.MODULE;if(o==="require")return F.REQUIRE;var N=o.indexOf("!");if(N>=0){var M=c.resolveModule(o.substr(0,N)),w=c.resolveModule(o.substr(N+1)),m=this._moduleIdProvider.getModuleId(M+"!"+w),e=this._moduleIdProvider.getModuleId(M);return new a(m,e,w)}return new F(this._moduleIdProvider.getModuleId(c.resolveModule(o)))},h.prototype._normalizeDependencies=function(o,c){for(var N=[],M=0,w=0,m=o.length;w<m;w++)N[M++]=this._normalizeDependency(o[w],c);return N},h.prototype._relativeRequire=function(o,c,N,M){if(typeof c=="string")return this.synchronousRequire(c,o);this.defineModule(O.Utilities.generateAnonymousModule(),c,N,M,null,o)},h.prototype.synchronousRequire=function(o,c){c===void 0&&(c=new n(o));var N=this._normalizeDependency(o,c),M=this._modules2[N.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports},h.prototype.configure=function(o,c){var N=this._config.shouldRecordStats();c?this._config=new O.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!N&&(this._recorder=null)},h.prototype.getConfig=function(){return this._config},h.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),c.dependencies,c.callback,null,c.stack)}},h.prototype._createLoadError=function(o,c){var N=this,M=this._moduleIdProvider.getStrModuleId(o),w=(this._inverseDependencies2[o]||[]).map(function(e){return N._moduleIdProvider.getStrModuleId(e)}),m=O.ensureError(c);return m.phase="loading",m.moduleId=M,m.neededBy=w,m},h.prototype._onLoadError=function(o,c){var N=this._createLoadError(o,c);this._modules2[o]||(this._modules2[o]=new P(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var M=[],w=0,m=this._moduleIdProvider.getMaxModuleId();w<m;w++)M[w]=!1;var e=!1,L=[];for(L.push(o),M[o]=!0;L.length>0;){var C=L.shift(),v=this._modules2[C];v&&(e=v.onDependencyError(N)||e);var f=this._inverseDependencies2[C];if(f)for(var w=0,m=f.length;w<m;w++){var s=f[w];M[s]||(L.push(s),M[s]=!0)}}e||this._config.onError(N)},h.prototype._hasDependencyPath=function(o,c){var N=this._modules2[o];if(!N)return!1;for(var M=[],w=0,m=this._moduleIdProvider.getMaxModuleId();w<m;w++)M[w]=!1;var e=[];for(e.push(N),M[o]=!0;e.length>0;){var L=e.shift(),C=L.dependencies;if(C)for(var w=0,m=C.length;w<m;w++){var v=C[w];if(v.id===c)return!0;var f=this._modules2[v.id];f&&!M[v.id]&&(M[v.id]=!0,e.push(f))}}return!1},h.prototype._findCyclePath=function(o,c,N){if(o===c||N===50)return[o];var M=this._modules2[o];if(!M)return null;var w=M.dependencies;if(w)for(var m=0,e=w.length;m<e;m++){var L=this._findCyclePath(w[m].id,c,N+1);if(L!==null)return L.push(o),L}return null},h.prototype._createRequire=function(o){var c=this,N=function(M,w,m){return c._relativeRequire(o,M,w,m)};return N.toUrl=function(M){return c._config.requireToUrl(o.resolveModule(M))},N.getStats=function(){return c.getLoaderEvents()},N.hasDependencyCycle=function(){return c._hasDependencyCycle},N.config=function(M,w){w===void 0&&(w=!1),c.configure(M,w)},N.__$__nodeRequire=O.global.nodeRequire,N},h.prototype._loadModule=function(o){var c=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var N=this._moduleIdProvider.getStrModuleId(o),M=this._config.moduleIdToPaths(N),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(N.indexOf("/")===-1||w.test(N))&&M.push("node|"+N);var m=-1,e=function(L){if(m++,m>=M.length)c._onLoadError(o,L);else{var C=M[m],v=c.getRecorder();if(c._config.isBuild()&&C==="empty:"){c._buildInfoPath[o]=C,c.defineModule(c._moduleIdProvider.getStrModuleId(o),[],null,null,null),c._onLoad(o);return}v.record(10,C),c._scriptLoader.load(c,C,function(){c._config.isBuild()&&(c._buildInfoPath[o]=C),v.record(11,C),c._onLoad(o)},function(f){v.record(12,C),e(f)})}};e(null)}},h.prototype._loadPluginDependency=function(o,c){var N=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var M=function(w){N.defineModule(N._moduleIdProvider.getStrModuleId(c.id),[],w,null,null)};M.error=function(w){N._config.onError(N._createLoadError(c.id,w))},o.load(c.pluginParam,this._createRequire(n.ROOT),M,this._config.getOptionsLiteral())}},h.prototype._resolve=function(o){var c=this,N=o.dependencies;if(N)for(var M=0,w=N.length;M<w;M++){var m=N[M];if(m===F.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(m===F.MODULE){o.unresolvedDependenciesCount--;continue}if(m===F.REQUIRE){o.unresolvedDependenciesCount--;continue}var e=this._modules2[m.id];if(e&&e.isComplete()){if(e.error){o.onDependencyError(e.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var L=this._findCyclePath(m.id,o.id,0)||[];L.reverse(),L.push(m.id),console.warn(L.map(function(f){return c._moduleIdProvider.getStrModuleId(f)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(o.id),m instanceof a){var C=this._modules2[m.pluginId];if(C&&C.isComplete()){this._loadPluginDependency(C.exports,m);continue}var v=this._inversePluginDependencies2.get(m.pluginId);v||(v=[],this._inversePluginDependencies2.set(m.pluginId,v)),v.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},h.prototype._onModuleComplete=function(o){var c=this,N=this.getRecorder();if(!o.isComplete()){var M=o.dependencies,w=[];if(M)for(var m=0,e=M.length;m<e;m++){var L=M[m];if(L===F.EXPORTS){w[m]=o.exports;continue}if(L===F.MODULE){w[m]={id:o.strId,config:function(){return c._config.getConfigForModule(o.strId)}};continue}if(L===F.REQUIRE){w[m]=this._createRequire(o.moduleIdResolver);continue}var C=this._modules2[L.id];if(C){w[m]=C.exports;continue}w[m]=null}o.complete(N,this._config,w);var v=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,v)for(var m=0,e=v.length;m<e;m++){var f=v[m],s=this._modules2[f];s.unresolvedDependenciesCount--,s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}var i=this._inversePluginDependencies2.get(o.id);if(i){this._inversePluginDependencies2.delete(o.id);for(var m=0,e=i.length;m<e;m++)this._loadPluginDependency(o.exports,i[m])}}},h}();O.ModuleManager=y})(ue||(ue={}));var x,ue;(function(O){var n=new O.Environment,P=null,t=function(h,o,c){typeof h!="string"&&(c=o,o=h,h=null),(typeof o!="object"||!Array.isArray(o))&&(c=o,o=null),o||(o=["require","exports","module"]),h?P.defineModule(h,o,c,null,null):P.enqueueDefineAnonymousModule(o,c)};t.amd={jQuery:!0};var F=function(h,o){o===void 0&&(o=!1),P.configure(h,o)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){F(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=F,a.getConfig=function(){return P.getConfig().getOptionsLiteral()},a.reset=function(){P=P.reset()},a.getBuildInfo=function(){return P.getBuildInfo()},a.getStats=function(){return P.getLoaderEvents()},a.define=t;function y(){if(typeof O.global.require!="undefined"||typeof require!="undefined"){var h=O.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){var o=O.ensureRecordedNodeRequire(P.getRecorder(),h);O.global.nodeRequire=o,a.nodeRequire=o,a.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=a,require=a):(n.isElectronRenderer||(O.global.define=t),O.global.require=a)}O.init=y,(typeof O.global.define!="function"||!O.global.define.amd)&&(P=new O.ModuleManager(n,O.createScriptLoader(n),t,a,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require!="undefined"&&typeof O.global.require!="function"&&a.config(O.global.require),x=function(){return t.apply(null,arguments)},x.amd=t.amd,typeof doNotInitLoader=="undefined"&&y())})(ue||(ue={}));var ke=this,Fe;(function(O){var n=ke||{},P=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,t=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function F(c,N){var M;return N.length===0?M=c:M=c.replace(/\{(\d+)\}/g,function(w,m){var e=m[0];return typeof N[e]!="undefined"?N[e]:w}),t&&(M="\uFF3B"+M.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M}function a(c,N){var M=c[N];return M||(M=c["*"],M)?M:null}function y(c,N){for(var M=[],w=0;w<arguments.length-2;w++)M[w]=arguments[w+2];return F(N,M)}function h(c){return function(N,M){var w=Array.prototype.slice.call(arguments,2);return F(c[N],w)}}var o=function(){function c(){this.localize=y}return c.prototype.setPseudoTranslation=function(N){t=N},c.prototype.create=function(N,M){return{localize:h(M[N])}},c.prototype.load=function(N,M,w,m){if(m=m||{},!N||N.length===0)w({localize:y});else{var e=void 0;if(P&&P.getString)e=".nls.keys",M([N+e],function(v){w({localize:function(f,s){if(!v[f])return"NLS error: unknown key "+f;var i=v[f].keys;if(s>=i.length)return"NLS error unknown index "+s;var l=i[s],_=[];_[0]=f+"_"+l;for(var p=0;p<arguments.length-2;p++)_[p+1]=arguments[p+2];return P.getString.apply(P,_)}})});else if(m.isBuild)M([N+".nls",N+".nls.keys"],function(v,f){c.BUILD_MAP[N]=v,c.BUILD_MAP_KEYS[N]=f,w(v)});else{var L=m["vs/nls"]||{},C=L.availableLanguages?a(L.availableLanguages,N):null;e=".nls",C!==null&&C!==c.DEFAULT_TAG&&(e=e+"."+C),M([N+e],function(v){Array.isArray(v)?v.localize=h(v):v.localize=h(v[N]),w(v)})}}},c.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},c.prototype.write=function(N,M,w){var m=w.getEntryPoint(),e=this._getEntryPointsMap();e[m]=e[m]||[],e[m].push(M),M!==m&&w.asModule(N+"!"+M,"define(['vs/nls', 'vs/nls!"+m+`'], function(nls, data) { return nls.create("`+M+'", data); });')},c.prototype.writeFile=function(N,M,w,m,e){var L=this._getEntryPointsMap();if(L.hasOwnProperty(M)){for(var C=w.toUrl(M+".nls.js"),v=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],f=L[M],s={},i=0;i<f.length;i++)s[f[i]]=c.BUILD_MAP[f[i]];v.push('define("'+M+'.nls", '+JSON.stringify(s,null,"	")+");"),m(C,v.join(`\r
`))}},c.prototype.finishBuild=function(N){N("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();O.NLSPlugin=o,function(){x("vs/nls",new o)}()})(Fe||(Fe={})),x(te[18],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function P(y){return y?y.replace(/\$\((.*?)\)/g,(h,o)=>` ${o} `).trim():""}n.getCodiconAriaLabel=P;class t{constructor(h,o,c){this.id=h,this.definition=o,this.description=c,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function F(y,h){const o=["codicon","codicon-"+y];return h&&o.push("codicon-modifier-"+h),o}n.getClassNamesArray=F;var a;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function o(M){if(M instanceof t)return["codicon","codicon-"+M.id];const w=h.exec(M.id);if(!w)return o(t.error);let[,m,e]=w;const L=["codicon","codicon-"+m];return e&&L.push("codicon-modifier-"+e.substr(1)),L}y.asClassNameArray=o;function c(M){return o(M).join(" ")}y.asClassName=c;function N(M){return"."+o(M).join(".")}y.asCSSSelector=N})(a=n.CSSIcon||(n.CSSIcon={}))}),x(te[19],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class P{constructor(F,a,y,h){this.originalStart=F,this.originalLength=a,this.modifiedStart=y,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=P}),x(te[8],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(_=>{_(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}n.ErrorHandler=P,n.errorHandler=new P;function t(i){n.errorHandler.setUnexpectedErrorHandler(i)}n.setUnexpectedErrorHandler=t;function F(i){o(i)||n.errorHandler.onUnexpectedError(i)}n.onUnexpectedError=F;function a(i){o(i)||n.errorHandler.onUnexpectedExternalError(i)}n.onUnexpectedExternalError=a;function y(i){if(i instanceof Error){let{name:l,message:_}=i;const p=i.stacktrace||i.stack;return{$isError:!0,name:l,message:_,stack:p}}return i}n.transformErrorForSerialization=y;const h="Canceled";function o(i){return i instanceof c?!0:i instanceof Error&&i.name===h&&i.message===h}n.isCancellationError=o;class c extends Error{constructor(){super(h);this.name=this.message}}n.CancellationError=c;function N(){const i=new Error(h);return i.name=i.message,i}n.canceled=N;function M(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}n.illegalArgument=M;function w(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}n.illegalState=w;function m(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=m;function e(i){const l=new Error(`${i} has been disposed`);return l.name="DISPOSED",l}n.disposed=e;function L(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}n.getErrorMessage=L;class C extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}n.NotImplementedError=C;class v extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}n.NotSupportedError=v;class f extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=f;class s extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(l){if(l&&l instanceof Error){const _=new s;return _.name=l.name,_.message=l.message,_.stack=l.stack,_}return new s(l)}}n.ErrorNoTelemetry=s}),x(te[20],re([0,1,8]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function t(I,T=0){return I[I.length-(1+T)]}n.tail=t;function F(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=F;function a(I,T,U=(H,$)=>H===$){if(I===T)return!0;if(!I||!T||I.length!==T.length)return!1;for(let H=0,$=I.length;H<$;H++)if(!U(I[H],T[H]))return!1;return!0}n.equals=a;function y(I,T,U){let H=0,$=I.length-1;for(;H<=$;){const se=(H+$)/2|0,ie=U(I[se],T);if(ie<0)H=se+1;else if(ie>0)$=se-1;else return se}return-(H+1)}n.binarySearch=y;function h(I,T){let U=0,H=I.length;if(H===0)return 0;for(;U<H;){const $=Math.floor((U+H)/2);T(I[$])?H=$:U=$+1}return U}n.findFirstInSorted=h;function o(I,T,U){if(I=I|0,I>=T.length)throw new TypeError("invalid index");let H=T[Math.floor(T.length*Math.random())],$=[],se=[],ie=[];for(let ce of T){const fe=U(ce,H);fe<0?$.push(ce):fe>0?se.push(ce):ie.push(ce)}return I<$.length?o(I,$,U):I<$.length+ie.length?ie[0]:o(I-($.length+ie.length),se,U)}n.quickSelect=o;function c(I,T){const U=[];let H;for(const $ of I.slice(0).sort(T))!H||T(H[0],$)!==0?(H=[$],U.push(H)):H.push($);return U}n.groupBy=c;function N(I,T,U){const H=[];function $(ce,fe,ge){if(fe===0&&ge.length===0)return;const _e=H[H.length-1];_e&&_e.start+_e.deleteCount===ce?(_e.deleteCount+=fe,_e.toInsert.push(...ge)):H.push({start:ce,deleteCount:fe,toInsert:ge})}let se=0,ie=0;for(;;){if(se===I.length){$(se,0,T.slice(ie));break}if(ie===T.length){$(se,I.length-se,[]);break}const ce=I[se],fe=T[ie],ge=U(ce,fe);ge===0?(se+=1,ie+=1):ge<0?($(se,1,[]),se+=1):ge>0&&($(se,0,[fe]),ie+=1)}return H}n.sortedDiff=N;function M(I,T,U){const H=N(I,T,U),$=[],se=[];for(const ie of H)$.push(...I.slice(ie.start,ie.start+ie.deleteCount)),se.push(...ie.toInsert);return{removed:$,added:se}}n.delta=M;function w(I,T,U){if(U===0)return[];const H=I.slice(0,U).sort(T);return e(I,T,H,U,I.length),H}n.top=w;function m(I,T,U,H,$){return U===0?Promise.resolve([]):new Promise((se,ie)=>{(async()=>{const ce=I.length,fe=I.slice(0,U).sort(T);for(let ge=U,_e=Math.min(U+H,ce);ge<ce;ge=_e,_e=Math.min(_e+H,ce)){if(ge>U&&await new Promise(Me=>setTimeout(Me)),$&&$.isCancellationRequested)throw(0,P.canceled)();e(I,T,fe,ge,_e)}return fe})().then(se,ie)})}n.topAsync=m;function e(I,T,U,H,$){for(const se=U.length;H<$;H++){const ie=I[H];if(T(ie,U[se-1])<0){U.pop();const ce=h(U,fe=>T(ie,fe)<0);U.splice(ce,0,ie)}}}function L(I){return I.filter(T=>!!T)}n.coalesce=L;function C(I){let T=0;for(let U=0;U<I.length;U++)I[U]&&(I[T]=I[U],T+=1);I.length=T}n.coalesceInPlace=C;function v(I,T,U){I.splice(U,0,I.splice(T,1)[0])}n.move=v;function f(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=f;function s(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=s;function i(I,T=U=>U){const U=new Set;return I.filter(H=>{const $=T(H);return U.has($)?!1:(U.add($),!0)})}n.distinct=i;function l(I){const T=new Set;return U=>{const H=I(U);return T.has(H)?!1:(T.add(H),!0)}}n.uniqueFilter=l;function _(I,T){const U=p(I,T);if(U!==-1)return I[U]}n.findLast=_;function p(I,T){for(let U=I.length-1;U>=0;U--){const H=I[U];if(T(H))return U}return-1}n.lastIndex=p;function g(I,T){return I.length>0?I[0]:T}n.firstOrDefault=g;function u(I,T){return I.length>0?I[I.length-1]:T}n.lastOrDefault=u;function d(I,T,U=(H,$)=>H===$){let H=0;for(let $=0,se=Math.min(I.length,T.length);$<se&&U(I[$],T[$]);$++)H++;return H}n.commonPrefixLength=d;function b(I){return[].concat(...I)}n.flatten=b;function A(I,T){let U=typeof T=="number"?I:0;typeof T=="number"?U=I:(U=0,T=I);const H=[];if(U<=T)for(let $=U;$<T;$++)H.push($);else for(let $=U;$>T;$--)H.push($);return H}n.range=A;function R(I,T,U){return I.reduce((H,$)=>(H[T($)]=U?U($):$,H),Object.create(null))}n.index=R;function S(I,T){return I.push(T),()=>V(I,T)}n.insert=S;function V(I,T){const U=I.indexOf(T);if(U>-1)return I.splice(U,1),T}n.remove=V;function q(I,T,U){const H=I.slice(0,T),$=I.slice(T);return H.concat(U,$)}n.arrayInsert=q;function j(I,T){let U;if(typeof T=="number"){let H=T;U=()=>{const $=Math.sin(H++)*179426549;return $-Math.floor($)}}else U=Math.random;for(let H=I.length-1;H>0;H-=1){const $=Math.floor(U()*(H+1)),se=I[H];I[H]=I[$],I[$]=se}}n.shuffle=j;function Z(I,T){const U=I.indexOf(T);U>-1&&(I.splice(U,1),I.unshift(T))}n.pushToStart=Z;function E(I,T){const U=I.indexOf(T);U>-1&&(I.splice(U,1),I.push(T))}n.pushToEnd=E;function W(I,T){for(const U of T)I.push(U)}n.pushMany=W;function J(I,T){return Array.isArray(I)?I.map(T):T(I)}n.mapArrayOrNot=J;function z(I){return Array.isArray(I)?I:[I]}n.asArray=z;function r(I){return I[Math.floor(Math.random()*I.length)]}n.getRandomElement=r;function oe(I,T){for(const U of I){const H=T(U);if(H!==void 0)return H}}n.mapFind=oe;function de(I,T,U){const H=Ce(I,T),$=I.length,se=U.length;I.length=$+se;for(let ie=$-1;ie>=H;ie--)I[ie+se]=I[ie];for(let ie=0;ie<se;ie++)I[ie+H]=U[ie]}n.insertInto=de;function me(I,T,U,H){const $=Ce(I,T),se=I.splice($,U);return de(I,$,H),se}n.splice=me;function Ce(I,T){return T<0?Math.max(T+I.length,0):Math.min(T,I.length)}function Ae(I,T){return(U,H)=>T(I(U),I(H))}n.compareBy=Ae;const ee=(I,T)=>I-T;n.numberComparator=ee;function Y(I,T){if(I.length===0)return;let U=I[0];for(let H=1;H<I.length;H++){const $=I[H];T($,U)>0&&(U=$)}return U}n.findMaxBy=Y;function K(I,T){if(I.length===0)return;let U=I[0];for(let H=1;H<I.length;H++){const $=I[H];T($,U)>=0&&(U=$)}return U}n.findLastMaxBy=K;function X(I,T){return Y(I,(U,H)=>-T(U,H))}n.findMinBy=X;class ne{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let U=this.firstIdx;for(;U<this.items.length&&T(this.items[U]);)U++;const H=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,H}takeFromEndWhile(T){let U=this.lastIdx;for(;U>=0&&T(this.items[U]);)U--;const H=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,H}peek(){return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const U=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,U}}n.ArrayQueue=ne}),x(te[11],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function P(t){const F=this;let a=!1,y;return function(){return a||(a=!0,y=t.apply(F,arguments)),y}}n.once=P}),x(te[21],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var P;(function(t){function F(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=F;const a=Object.freeze([]);function y(){return a}t.empty=y;function*h(l){yield l}t.single=h;function o(l){return l||a}t.from=o;function c(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=c;function N(l){return l[Symbol.iterator]().next().value}t.first=N;function M(l,_){for(const p of l)if(_(p))return!0;return!1}t.some=M;function w(l,_){for(const p of l)if(_(p))return p}t.find=w;function*m(l,_){for(const p of l)_(p)&&(yield p)}t.filter=m;function*e(l,_){let p=0;for(const g of l)yield _(g,p++)}t.map=e;function*L(...l){for(const _ of l)for(const p of _)yield p}t.concat=L;function*C(l){for(const _ of l)for(const p of _)yield p}t.concatNested=C;function v(l,_,p){let g=p;for(const u of l)g=_(g,u);return g}t.reduce=v;function*f(l,_,p=l.length){for(_<0&&(_+=l.length),p<0?p+=l.length:p>l.length&&(p=l.length);_<p;_++)yield l[_]}t.slice=f;function s(l,_=Number.POSITIVE_INFINITY){const p=[];if(_===0)return[p,l];const g=l[Symbol.iterator]();for(let u=0;u<_;u++){const d=g.next();if(d.done)return[p,t.empty()];p.push(d.value)}return[p,{[Symbol.iterator](){return g}}]}t.consume=s;function i(l,_,p=(g,u)=>g===u){const g=l[Symbol.iterator](),u=_[Symbol.iterator]();for(;;){const d=g.next(),b=u.next();if(d.done!==b.done)return!1;if(d.done)return!0;if(!p(d.value,b.value))return!1}}t.equals=i})(P=n.Iterable||(n.Iterable={}))}),x(te[22],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(P=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class F{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,C){this._keyCodeToStr[L]=C,this._strToKeyCode[C.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||0}}const a=new F,y=new F,h=new F;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const o=[],c=Object.create(null),N=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>N[e]||0,toEnum:e=>c[e]||0,toString:e=>o[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",L=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let C=[],v=[];for(const f of L){const[s,i,l,_,p,g,u,d,b,A]=f;if(v[l]||(v[l]=!0,o[l]=_,c[_]=l,N[_.toLowerCase()]=l,i&&(n.IMMUTABLE_CODE_TO_KEY_CODE[l]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[p]=l))),!C[p]){if(C[p]=!0,!g)throw new Error(`String representation missing for key code ${p} around scan code ${_}`);a.define(p,g),y.define(p,b||g),h.define(p,A||b||g)}u&&(n.EVENT_KEY_CODE_MAP[u]=p),d&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=p)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function L(l){return a.keyCodeToStr(l)}e.toString=L;function C(l){return a.strToKeyCode(l)}e.fromString=C;function v(l){return y.keyCodeToStr(l)}e.toUserSettingsUS=v;function f(l){return h.keyCodeToStr(l)}e.toUserSettingsGeneral=f;function s(l){return y.strToKeyCode(l)||h.strToKeyCode(l)}e.fromUserSettings=s;function i(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return a.keyCodeToStr(l)}e.toElectronAccelerator=i})(M=n.KeyCodeUtils||(n.KeyCodeUtils={}));var w;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(w=n.KeyMod||(n.KeyMod={}));function m(e,L){const C=(L&65535)<<16>>>0;return(e|C)>>>0}n.KeyChord=m}),x(te[23],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class P{constructor(F){this.executor=F,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(F){this._error=F}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(F){return new P(()=>F(this.getValue()))}}n.Lazy=P}),x(te[9],re([0,1,11,21]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const F=!1;let a=null;function y(d){a=d}if(n.setDisposableTracker=y,F){const d="__is_disposable_tracked__";y(new class{trackDisposable(b){const A=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[d]||console.log(A)},3e3)}setParent(b,A){if(b&&b!==f.None)try{b[d]=!0}catch{}}markAsDisposed(b){if(b&&b!==f.None)try{b[d]=!0}catch{}}markAsSingleton(b){}})}function h(d){return a?.trackDisposable(d),d}function o(d){a?.markAsDisposed(d)}function c(d,b){a?.setParent(d,b)}function N(d,b){if(!!a)for(const A of d)a.setParent(A,b)}function M(d){return a?.markAsSingleton(d),d}n.markAsSingleton=M;class w extends Error{constructor(b){super(`Encountered errors while disposing of store. Errors: [${b.join(", ")}]`);this.errors=b}}n.MultiDisposeError=w;function m(d){return typeof d.dispose=="function"&&d.dispose.length===0}n.isDisposable=m;function e(d){if(t.Iterable.is(d)){let b=[];for(const A of d)if(A)try{A.dispose()}catch(R){b.push(R)}if(b.length===1)throw b[0];if(b.length>1)throw new w(b);return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}n.dispose=e;function L(...d){const b=C(()=>e(d));return N(d,b),b}n.combinedDisposable=L;function C(d){const b=h({dispose:(0,P.once)(()=>{o(b),d()})});return b}n.toDisposable=C;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return c(b,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(b),b}}n.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new v,h(this),c(this._store,this)}dispose(){o(this),this._store.dispose()}_register(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(b)}}n.Disposable=f,f.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(b){this._isDisposed||b===this._value||(this._value?.dispose(),b&&c(b,this),this._value=b)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const b=this._value;return this._value=void 0,b&&c(b,null),b}}n.MutableDisposable=s;class i{constructor(b){this._disposable=b,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=i;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(b){let A=b;return this.unset=()=>A=void 0,this.isset=()=>A!==void 0,this.dispose=()=>{A&&(A(),A=void 0,o(this))},this}}n.SafeDisposable=l;class _{constructor(){this.references=new Map}acquire(b,...A){let R=this.references.get(b);R||(R={counter:0,object:this.createReferencedObject(b,...A)},this.references.set(b,R));const{object:S}=R,V=(0,P.once)(()=>{--R.counter==0&&(this.destroyReferencedObject(b,R.object),this.references.delete(b))});return R.counter++,{object:S,dispose:V}}}n.ReferenceCollection=_;class p{constructor(b){this.referenceCollection=b}async acquire(b,...A){const R=this.referenceCollection.acquire(b,...A);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(S){throw R.dispose(),S}}}n.AsyncReferenceCollection=p;class g{constructor(b){this.object=b}dispose(){}}n.ImmortalReference=g;function u(d){const b=new v;try{d(b)}finally{b.dispose()}}n.disposeOnReturn=u}),x(te[24],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class P{constructor(a){this.element=a,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class t{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let a=this._first;for(;a!==P.Undefined;){const y=a.next;a.prev=P.Undefined,a.next=P.Undefined,a=y}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(a){return this._insert(a,!1)}push(a){return this._insert(a,!0)}_insert(a,y){const h=new P(a);if(this._first===P.Undefined)this._first=h,this._last=h;else if(y){const c=this._last;this._last=h,h.prev=c,c.next=h}else{const c=this._first;this._first=h,h.next=c,c.prev=h}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(h))}}shift(){if(this._first!==P.Undefined){const a=this._first.element;return this._remove(this._first),a}}pop(){if(this._last!==P.Undefined){const a=this._last.element;return this._remove(this._last),a}}_remove(a){if(a.prev!==P.Undefined&&a.next!==P.Undefined){const y=a.prev;y.next=a.next,a.next.prev=y}else a.prev===P.Undefined&&a.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):a.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):a.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let a=this._first;for(;a!==P.Undefined;)yield a.element,a=a.next}}n.LinkedList=t}),x(te[5],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.isElectronSandboxed=n.globals=void 0;const P="en";let t=!1,F=!1,a=!1,y=!1,h=!1,o=!1,c=!1,N=!1,M=!1,w,m=P,e,L;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?C=n.globals.vscode.process:typeof process!="undefined"&&(C=process);const v=typeof C?.versions?.electron=="string",f=v&&C?.type==="renderer";if(n.isElectronSandboxed=f&&C?.sandboxed,typeof navigator=="object"&&!f)L=navigator.userAgent,t=L.indexOf("Windows")>=0,F=L.indexOf("Macintosh")>=0,N=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=L.indexOf("Linux")>=0,o=!0,w=navigator.language,m=w;else if(typeof C=="object"){t=C.platform==="win32",F=C.platform==="darwin",a=C.platform==="linux",y=a&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,c=v,M=!!C.env.CI||!!C.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=P,m=P;const b=C.env.VSCODE_NLS_CONFIG;if(b)try{const A=JSON.parse(b),R=A.availableLanguages["*"];w=A.locale,m=R||P,e=A._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var s;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(s=n.Platform||(n.Platform={}));function i(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=i;let l=0;F?l=1:t?l=3:a&&(l=2),n.isWindows=t,n.isMacintosh=F,n.isLinux=a,n.isLinuxSnap=y,n.isNative=h,n.isElectron=c,n.isWeb=o,n.isWebWorker=o&&typeof n.globals.importScripts=="function",n.isIOS=N,n.isCI=M,n.platform=l,n.userAgent=L,n.language=m;var _;(function(b){function A(){return n.language}b.value=A;function R(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}b.isDefaultVariant=R;function S(){return n.language==="en"}b.isDefault=S})(_=n.Language||(n.Language={})),n.locale=w,n.translationsConfigFile=e,n.setTimeout0=(()=>{if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let b=[];n.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let S=0,V=b.length;S<V;S++){const q=b[S];if(q.id===R.data.vscodeScheduleAsyncWork){b.splice(S,1),q.callback();return}}});let A=0;return R=>{const S=++A;b.push({id:S,callback:R}),n.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return b=>setTimeout(b)})();var p;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(p=n.OperatingSystem||(n.OperatingSystem={})),n.OS=F||N?2:t?1:3;let g=!0,u=!1;function d(){if(!u){u=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,g=new Uint16Array(b.buffer)[0]===(2<<8)+1}return g}n.isLittleEndian=d,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),x(te[25],re([0,1,5]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const F=P.globals.vscode.process;t={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),x(te[26],re([0,1,25]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,F=97,a=90,y=122,h=46,o=47,c=92,N=58,M=63;class w extends Error{constructor(i,l,_){let p;typeof l=="string"&&l.indexOf("not ")===0?(p="must not be",l=l.replace(/^not /,"")):p="must be";const g=i.indexOf(".")!==-1?"property":"argument";let u=`The "${i}" ${g} ${p} of type ${l}`;u+=`. Received type ${typeof _}`;super(u);this.code="ERR_INVALID_ARG_TYPE"}}function m(s,i){if(typeof s!="string")throw new w(i,"string",s)}function e(s){return s===o||s===c}function L(s){return s===o}function C(s){return s>=t&&s<=a||s>=F&&s<=y}function v(s,i,l,_){let p="",g=0,u=-1,d=0,b=0;for(let A=0;A<=s.length;++A){if(A<s.length)b=s.charCodeAt(A);else{if(_(b))break;b=o}if(_(b)){if(!(u===A-1||d===1))if(d===2){if(p.length<2||g!==2||p.charCodeAt(p.length-1)!==h||p.charCodeAt(p.length-2)!==h){if(p.length>2){const R=p.lastIndexOf(l);R===-1?(p="",g=0):(p=p.slice(0,R),g=p.length-1-p.lastIndexOf(l)),u=A,d=0;continue}else if(p.length!==0){p="",g=0,u=A,d=0;continue}}i&&(p+=p.length>0?`${l}..`:"..",g=2)}else p.length>0?p+=`${l}${s.slice(u+1,A)}`:p=s.slice(u+1,A),g=A-u-1;u=A,d=0}else b===h&&d!==-1?++d:d=-1}return p}function f(s,i){if(i===null||typeof i!="object")throw new w("pathObject","Object",i);const l=i.dir||i.root,_=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${_}`:`${l}${s}${_}`:_}n.win32={resolve(...s){let i="",l="",_=!1;for(let p=s.length-1;p>=-1;p--){let g;if(p>=0){if(g=s[p],m(g,"path"),g.length===0)continue}else i.length===0?g=P.cwd():(g=P.env[`=${i}`]||P.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==i.toLowerCase()&&g.charCodeAt(2)===c)&&(g=`${i}\\`));const u=g.length;let d=0,b="",A=!1;const R=g.charCodeAt(0);if(u===1)e(R)&&(d=1,A=!0);else if(e(R))if(A=!0,e(g.charCodeAt(1))){let S=2,V=S;for(;S<u&&!e(g.charCodeAt(S));)S++;if(S<u&&S!==V){const q=g.slice(V,S);for(V=S;S<u&&e(g.charCodeAt(S));)S++;if(S<u&&S!==V){for(V=S;S<u&&!e(g.charCodeAt(S));)S++;(S===u||S!==V)&&(b=`\\\\${q}\\${g.slice(V,S)}`,d=S)}}}else d=1;else C(R)&&g.charCodeAt(1)===N&&(b=g.slice(0,2),d=2,u>2&&e(g.charCodeAt(2))&&(A=!0,d=3));if(b.length>0)if(i.length>0){if(b.toLowerCase()!==i.toLowerCase())continue}else i=b;if(_){if(i.length>0)break}else if(l=`${g.slice(d)}\\${l}`,_=A,A&&i.length>0)break}return l=v(l,!_,"\\",e),_?`${i}\\${l}`:`${i}${l}`||"."},normalize(s){m(s,"path");const i=s.length;if(i===0)return".";let l=0,_,p=!1;const g=s.charCodeAt(0);if(i===1)return L(g)?"\\":s;if(e(g))if(p=!0,e(s.charCodeAt(1))){let d=2,b=d;for(;d<i&&!e(s.charCodeAt(d));)d++;if(d<i&&d!==b){const A=s.slice(b,d);for(b=d;d<i&&e(s.charCodeAt(d));)d++;if(d<i&&d!==b){for(b=d;d<i&&!e(s.charCodeAt(d));)d++;if(d===i)return`\\\\${A}\\${s.slice(b)}\\`;d!==b&&(_=`\\\\${A}\\${s.slice(b,d)}`,l=d)}}}else l=1;else C(g)&&s.charCodeAt(1)===N&&(_=s.slice(0,2),l=2,i>2&&e(s.charCodeAt(2))&&(p=!0,l=3));let u=l<i?v(s.slice(l),!p,"\\",e):"";return u.length===0&&!p&&(u="."),u.length>0&&e(s.charCodeAt(i-1))&&(u+="\\"),_===void 0?p?`\\${u}`:u:p?`${_}\\${u}`:`${_}${u}`},isAbsolute(s){m(s,"path");const i=s.length;if(i===0)return!1;const l=s.charCodeAt(0);return e(l)||i>2&&C(l)&&s.charCodeAt(1)===N&&e(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,l;for(let g=0;g<s.length;++g){const u=s[g];m(u,"path"),u.length>0&&(i===void 0?i=l=u:i+=`\\${u}`)}if(i===void 0)return".";let _=!0,p=0;if(typeof l=="string"&&e(l.charCodeAt(0))){++p;const g=l.length;g>1&&e(l.charCodeAt(1))&&(++p,g>2&&(e(l.charCodeAt(2))?++p:_=!1))}if(_){for(;p<i.length&&e(i.charCodeAt(p));)p++;p>=2&&(i=`\\${i.slice(p)}`)}return n.win32.normalize(i)},relative(s,i){if(m(s,"from"),m(i,"to"),s===i)return"";const l=n.win32.resolve(s),_=n.win32.resolve(i);if(l===_||(s=l.toLowerCase(),i=_.toLowerCase(),s===i))return"";let p=0;for(;p<s.length&&s.charCodeAt(p)===c;)p++;let g=s.length;for(;g-1>p&&s.charCodeAt(g-1)===c;)g--;const u=g-p;let d=0;for(;d<i.length&&i.charCodeAt(d)===c;)d++;let b=i.length;for(;b-1>d&&i.charCodeAt(b-1)===c;)b--;const A=b-d,R=u<A?u:A;let S=-1,V=0;for(;V<R;V++){const j=s.charCodeAt(p+V);if(j!==i.charCodeAt(d+V))break;j===c&&(S=V)}if(V!==R){if(S===-1)return _}else{if(A>R){if(i.charCodeAt(d+V)===c)return _.slice(d+V+1);if(V===2)return _.slice(d+V)}u>R&&(s.charCodeAt(p+V)===c?S=V:V===2&&(S=3)),S===-1&&(S=0)}let q="";for(V=p+S+1;V<=g;++V)(V===g||s.charCodeAt(V)===c)&&(q+=q.length===0?"..":"\\..");return d+=S,q.length>0?`${q}${_.slice(d,b)}`:(_.charCodeAt(d)===c&&++d,_.slice(d,b))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const i=n.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===c){if(i.charCodeAt(1)===c){const l=i.charCodeAt(2);if(l!==M&&l!==h)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(C(i.charCodeAt(0))&&i.charCodeAt(1)===N&&i.charCodeAt(2)===c)return`\\\\?\\${i}`;return s},dirname(s){m(s,"path");const i=s.length;if(i===0)return".";let l=-1,_=0;const p=s.charCodeAt(0);if(i===1)return e(p)?s:".";if(e(p)){if(l=_=1,e(s.charCodeAt(1))){let d=2,b=d;for(;d<i&&!e(s.charCodeAt(d));)d++;if(d<i&&d!==b){for(b=d;d<i&&e(s.charCodeAt(d));)d++;if(d<i&&d!==b){for(b=d;d<i&&!e(s.charCodeAt(d));)d++;if(d===i)return s;d!==b&&(l=_=d+1)}}}}else C(p)&&s.charCodeAt(1)===N&&(l=i>2&&e(s.charCodeAt(2))?3:2,_=l);let g=-1,u=!0;for(let d=i-1;d>=_;--d)if(e(s.charCodeAt(d))){if(!u){g=d;break}}else u=!1;if(g===-1){if(l===-1)return".";g=l}return s.slice(0,g)},basename(s,i){i!==void 0&&m(i,"ext"),m(s,"path");let l=0,_=-1,p=!0,g;if(s.length>=2&&C(s.charCodeAt(0))&&s.charCodeAt(1)===N&&(l=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let u=i.length-1,d=-1;for(g=s.length-1;g>=l;--g){const b=s.charCodeAt(g);if(e(b)){if(!p){l=g+1;break}}else d===-1&&(p=!1,d=g+1),u>=0&&(b===i.charCodeAt(u)?--u==-1&&(_=g):(u=-1,_=d))}return l===_?_=d:_===-1&&(_=s.length),s.slice(l,_)}for(g=s.length-1;g>=l;--g)if(e(s.charCodeAt(g))){if(!p){l=g+1;break}}else _===-1&&(p=!1,_=g+1);return _===-1?"":s.slice(l,_)},extname(s){m(s,"path");let i=0,l=-1,_=0,p=-1,g=!0,u=0;s.length>=2&&s.charCodeAt(1)===N&&C(s.charCodeAt(0))&&(i=_=2);for(let d=s.length-1;d>=i;--d){const b=s.charCodeAt(d);if(e(b)){if(!g){_=d+1;break}continue}p===-1&&(g=!1,p=d+1),b===h?l===-1?l=d:u!==1&&(u=1):l!==-1&&(u=-1)}return l===-1||p===-1||u===0||u===1&&l===p-1&&l===_+1?"":s.slice(l,p)},format:f.bind(null,"\\"),parse(s){m(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const l=s.length;let _=0,p=s.charCodeAt(0);if(l===1)return e(p)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(e(p)){if(_=1,e(s.charCodeAt(1))){let S=2,V=S;for(;S<l&&!e(s.charCodeAt(S));)S++;if(S<l&&S!==V){for(V=S;S<l&&e(s.charCodeAt(S));)S++;if(S<l&&S!==V){for(V=S;S<l&&!e(s.charCodeAt(S));)S++;S===l?_=S:S!==V&&(_=S+1)}}}}else if(C(p)&&s.charCodeAt(1)===N){if(l<=2)return i.root=i.dir=s,i;if(_=2,e(s.charCodeAt(2))){if(l===3)return i.root=i.dir=s,i;_=3}}_>0&&(i.root=s.slice(0,_));let g=-1,u=_,d=-1,b=!0,A=s.length-1,R=0;for(;A>=_;--A){if(p=s.charCodeAt(A),e(p)){if(!b){u=A+1;break}continue}d===-1&&(b=!1,d=A+1),p===h?g===-1?g=A:R!==1&&(R=1):g!==-1&&(R=-1)}return d!==-1&&(g===-1||R===0||R===1&&g===d-1&&g===u+1?i.base=i.name=s.slice(u,d):(i.name=s.slice(u,g),i.base=s.slice(u,d),i.ext=s.slice(g,d))),u>0&&u!==_?i.dir=s.slice(0,u-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...s){let i="",l=!1;for(let _=s.length-1;_>=-1&&!l;_--){const p=_>=0?s[_]:P.cwd();m(p,"path"),p.length!==0&&(i=`${p}/${i}`,l=p.charCodeAt(0)===o)}return i=v(i,!l,"/",L),l?`/${i}`:i.length>0?i:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===o,l=s.charCodeAt(s.length-1)===o;return s=v(s,!i,"/",L),s.length===0?i?"/":l?"./":".":(l&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let i;for(let l=0;l<s.length;++l){const _=s[l];m(_,"path"),_.length>0&&(i===void 0?i=_:i+=`/${_}`)}return i===void 0?".":n.posix.normalize(i)},relative(s,i){if(m(s,"from"),m(i,"to"),s===i||(s=n.posix.resolve(s),i=n.posix.resolve(i),s===i))return"";const l=1,_=s.length,p=_-l,g=1,u=i.length-g,d=p<u?p:u;let b=-1,A=0;for(;A<d;A++){const S=s.charCodeAt(l+A);if(S!==i.charCodeAt(g+A))break;S===o&&(b=A)}if(A===d)if(u>d){if(i.charCodeAt(g+A)===o)return i.slice(g+A+1);if(A===0)return i.slice(g+A)}else p>d&&(s.charCodeAt(l+A)===o?b=A:A===0&&(b=0));let R="";for(A=l+b+1;A<=_;++A)(A===_||s.charCodeAt(A)===o)&&(R+=R.length===0?"..":"/..");return`${R}${i.slice(g+b)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===o;let l=-1,_=!0;for(let p=s.length-1;p>=1;--p)if(s.charCodeAt(p)===o){if(!_){l=p;break}}else _=!1;return l===-1?i?"/":".":i&&l===1?"//":s.slice(0,l)},basename(s,i){i!==void 0&&m(i,"ext"),m(s,"path");let l=0,_=-1,p=!0,g;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let u=i.length-1,d=-1;for(g=s.length-1;g>=0;--g){const b=s.charCodeAt(g);if(b===o){if(!p){l=g+1;break}}else d===-1&&(p=!1,d=g+1),u>=0&&(b===i.charCodeAt(u)?--u==-1&&(_=g):(u=-1,_=d))}return l===_?_=d:_===-1&&(_=s.length),s.slice(l,_)}for(g=s.length-1;g>=0;--g)if(s.charCodeAt(g)===o){if(!p){l=g+1;break}}else _===-1&&(p=!1,_=g+1);return _===-1?"":s.slice(l,_)},extname(s){m(s,"path");let i=-1,l=0,_=-1,p=!0,g=0;for(let u=s.length-1;u>=0;--u){const d=s.charCodeAt(u);if(d===o){if(!p){l=u+1;break}continue}_===-1&&(p=!1,_=u+1),d===h?i===-1?i=u:g!==1&&(g=1):i!==-1&&(g=-1)}return i===-1||_===-1||g===0||g===1&&i===_-1&&i===l+1?"":s.slice(i,_)},format:f.bind(null,"/"),parse(s){m(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const l=s.charCodeAt(0)===o;let _;l?(i.root="/",_=1):_=0;let p=-1,g=0,u=-1,d=!0,b=s.length-1,A=0;for(;b>=_;--b){const R=s.charCodeAt(b);if(R===o){if(!d){g=b+1;break}continue}u===-1&&(d=!1,u=b+1),R===h?p===-1?p=b:A!==1&&(A=1):p!==-1&&(A=-1)}if(u!==-1){const R=g===0&&l?1:g;p===-1||A===0||A===1&&p===u-1&&p===g+1?i.base=i.name=s.slice(R,u):(i.name=s.slice(R,p),i.base=s.slice(R,u),i.ext=s.slice(p,u))}return g>0?i.dir=s.slice(0,g-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=P.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=P.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=P.platform==="win32"?n.win32.join:n.posix.join,n.resolve=P.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=P.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=P.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=P.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=P.platform==="win32"?n.win32.extname:n.posix.extname,n.format=P.platform==="win32"?n.win32.format:n.posix.format,n.parse=P.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=P.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=P.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=P.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),x(te[12],re([0,1,5]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=P.globals.performance&&typeof P.globals.performance.now=="function";class F{constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new F(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}n.StopWatch=F}),x(te[6],re([0,1,8,11,9,24,12]),function(O,n,P,t,F,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;let h=!1,o=!1;var c;(function(g){g.None=()=>F.Disposable.None;function u(ee){if(o){const{onListenerDidAdd:Y}=ee,K=e.create();let X=0;ee.onListenerDidAdd=()=>{++X==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),Y?.()}}}function d(ee){return(Y,K=null,X)=>{let ne=!1,I;return I=ee(T=>{if(!ne)return I?I.dispose():ne=!0,Y.call(K,T)},null,X),ne&&I.dispose(),I}}g.once=d;function b(ee,Y,K){return j((X,ne=null,I)=>ee(T=>X.call(ne,Y(T)),null,I),K)}g.map=b;function A(ee,Y,K){return j((X,ne=null,I)=>ee(T=>{Y(T),X.call(ne,T)},null,I),K)}g.forEach=A;function R(ee,Y,K){return j((X,ne=null,I)=>ee(T=>Y(T)&&X.call(ne,T),null,I),K)}g.filter=R;function S(ee){return ee}g.signal=S;function V(...ee){return(Y,K=null,X)=>(0,F.combinedDisposable)(...ee.map(ne=>ne(I=>Y.call(K,I),null,X)))}g.any=V;function q(ee,Y,K,X){let ne=K;return b(ee,I=>(ne=Y(ne,I),ne),X)}g.reduce=q;function j(ee,Y){let K;const X={onFirstListenerAdd(){K=ee(ne.fire,ne)},onLastListenerRemove(){K.dispose()}};Y||u(X);const ne=new C(X);return Y&&Y.add(ne),ne.event}function Z(ee,Y,K=100,X=!1,ne,I){let T,U,H,$=0;const se={leakWarningThreshold:ne,onFirstListenerAdd(){T=ee(ce=>{$++,U=Y(U,ce),X&&!H&&(ie.fire(U),U=void 0),clearTimeout(H),H=setTimeout(()=>{const fe=U;U=void 0,H=void 0,(!X||$>1)&&ie.fire(fe),$=0},K)})},onLastListenerRemove(){T.dispose()}};I||u(se);const ie=new C(se);return I&&I.add(ie),ie.event}g.debounce=Z;function E(ee,Y=(X,ne)=>X===ne,K){let X=!0,ne;return R(ee,I=>{const T=X||!Y(I,ne);return X=!1,ne=I,T},K)}g.latch=E;function W(ee,Y,K){return[g.filter(ee,Y,K),g.filter(ee,X=>!Y(X),K)]}g.split=W;function J(ee,Y=!1,K=[]){let X=K.slice(),ne=ee(U=>{X?X.push(U):T.fire(U)});const I=()=>{X&&X.forEach(U=>T.fire(U)),X=null},T=new C({onFirstListenerAdd(){ne||(ne=ee(U=>T.fire(U)))},onFirstListenerDidAdd(){X&&(Y?setTimeout(I):I())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return T.event}g.buffer=J;class z{constructor(Y){this.event=Y}map(Y){return new z(b(this.event,Y))}forEach(Y){return new z(A(this.event,Y))}filter(Y){return new z(R(this.event,Y))}reduce(Y,K){return new z(q(this.event,Y,K))}latch(){return new z(E(this.event))}debounce(Y,K=100,X=!1,ne){return new z(Z(this.event,Y,K,X,ne))}on(Y,K,X){return this.event(Y,K,X)}once(Y,K,X){return d(this.event)(Y,K,X)}}function r(ee){return new z(ee)}g.chain=r;function oe(ee,Y,K=X=>X){const X=(...U)=>T.fire(K(...U)),ne=()=>ee.on(Y,X),I=()=>ee.removeListener(Y,X),T=new C({onFirstListenerAdd:ne,onLastListenerRemove:I});return T.event}g.fromNodeEventEmitter=oe;function de(ee,Y,K=X=>X){const X=(...U)=>T.fire(K(...U)),ne=()=>ee.addEventListener(Y,X),I=()=>ee.removeEventListener(Y,X),T=new C({onFirstListenerAdd:ne,onLastListenerRemove:I});return T.event}g.fromDOMEventEmitter=de;function me(ee){return new Promise(Y=>d(ee)(Y))}g.toPromise=me;function Ce(ee,Y){return Y(void 0),ee(K=>Y(K))}g.runAndSubscribe=Ce;function Ae(ee,Y){let K=null;function X(I){K?.dispose(),K=new F.DisposableStore,Y(I,K)}X(void 0);const ne=ee(I=>X(I));return(0,F.toDisposable)(()=>{ne.dispose(),K?.dispose()})}g.runAndSubscribeWithStore=Ae})(c=n.Event||(n.Event={}));class N{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${N._idPool++}`}start(u){this._stopWatch=new y.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}N._idPool=0;let M=-1;function w(g){const u=M;return M=g,{dispose(){M=u}}}n.setGlobalLeakWarningThreshold=w;class m{constructor(u,d=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,d){let b=M;if(typeof this.customThreshold=="number"&&(b=this.customThreshold),b<=0||d<b)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let R,S=0;for(const[V,q]of this._stacks)(!R||S<q)&&(R=V,S=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${S}):`),console.warn(R)}return()=>{const R=this._stacks.get(u.value)||0;this._stacks.set(u.value,R-1)}}}class e{constructor(u){this.value=u}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class L{constructor(u,d,b){this.callback=u,this.callbackThis=d,this.stack=b,this.subscription=new F.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class C{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=M>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new N(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(h){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const d of u)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,d,b)=>{this._listeners||(this._listeners=new a.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,S;this._leakageMon&&this._listeners.size>=30&&(S=e.create(),R=this._leakageMon.check(S,this._listeners.size+1)),h&&(S=S??e.create());const V=new L(u,d,S),q=this._listeners.push(V);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,d);const j=V.subscription.set(()=>{R&&R(),this._disposed||(q(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return b instanceof F.DisposableStore?b.add(j):Array.isArray(b)&&b.push(j),j}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new a.LinkedList);for(let d of this._listeners)this._deliveryQueue.push([d,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[d,b]=this._deliveryQueue.shift();try{d.invoke(b)}catch(A){(0,P.onUnexpectedError)(A)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=C;class v extends C{async fireAsync(u,d,b){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new a.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,u]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[A,R]=this._asyncDeliveryQueue.shift(),S=[],V={...R,token:d,waitUntil:q=>{if(Object.isFrozen(S))throw new Error("waitUntil can NOT be called asynchronous");b&&(q=b(q,A.callback)),S.push(q)}};try{A.invoke(V)}catch(q){(0,P.onUnexpectedError)(q);continue}Object.freeze(S),await Promise.allSettled(S).then(q=>{for(const j of q)j.status==="rejected"&&(0,P.onUnexpectedError)(j.reason)})}}}}n.AsyncEmitter=v;class f extends C{constructor(u){super(u);this._isPaused=0,this._eventQueue=new a.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}n.PauseableEmitter=f;class s extends f{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}n.DebounceEmitter=s;class i extends C{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]})}}n.MicrotaskEmitter=i;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const d={event:u,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const b=()=>{this.hasListeners&&this.unhook(d);const A=this.events.indexOf(d);this.events.splice(A,1)};return(0,F.toDisposable)((0,t.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(d=>this.emitter.fire(d))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=l;class _{constructor(){this.buffers=[]}wrapEvent(u){return(d,b,A)=>u(R=>{const S=this.buffers[this.buffers.length-1];S?S.push(()=>d.call(b,R)):d.call(b,R)},void 0,A)}bufferEvents(u){const d=[];this.buffers.push(d);const b=u();return this.buffers.pop(),d.forEach(A=>A()),b}}n.EventBufferer=_;class p{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=F.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=p}),x(te[13],re([0,1,6]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(h,o){const c=setTimeout(h.bind(o),0);return{dispose(){clearTimeout(c)}}});var F;(function(h){function o(c){return c===h.None||c===h.Cancelled||c instanceof a?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}h.isCancellationToken=o,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(F=n.CancellationToken||(n.CancellationToken={}));class a{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new a),this._token}cancel(){this._token?this._token instanceof a&&this._token.cancel():this._token=F.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof a&&this._token.dispose():this._token=F.None}}n.CancellationTokenSource=y}),x(te[27],re([0,1,13]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LRUCachedComputed=n.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new P.CancellationTokenSource,h=this.task(y.token);return this.result={promise:h,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}n.Cache=t;class F{constructor(y){this.computeFn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const h=JSON.stringify(y);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.computeFn(y)),this.lastCache}}n.LRUCachedComputed=F}),x(te[2],re([0,1,27,23]),function(O,n,P,t){"use strict";var F;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function a(D){return!D||typeof D!="string"?!0:D.trim().length===0}n.isFalsyOrWhitespace=a;const y=/{(\d+)}/g;function h(D,...k){return k.length===0?D:D.replace(y,function(B,G){const Q=parseInt(G,10);return isNaN(Q)||Q<0||Q>=k.length?B:k[Q]})}n.format=h;const o=/{([^}]+)}/g;function c(D,k){return D.replace(o,(B,G)=>k[G]??B)}n.format2=c;function N(D){return D.replace(/[<>&]/g,function(k){switch(k){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return k}})}n.escape=N;function M(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=M;function w(D,k){let B=0;const G=k.charCodeAt(0);for(let Q=D.length-1;Q>=0;Q--)D.charCodeAt(Q)===G&&B++;return B}n.count=w;function m(D,k,B="\u2026"){return D.length<=k?D:`${D.substr(0,k)}${B}`}n.truncate=m;function e(D,k=" "){const B=L(D,k);return C(B,k)}n.trim=e;function L(D,k){if(!D||!k)return D;const B=k.length;if(B===0||D.length===0)return D;let G=0;for(;D.indexOf(k,G)===G;)G=G+B;return D.substring(G)}n.ltrim=L;function C(D,k){if(!D||!k)return D;const B=k.length,G=D.length;if(B===0||G===0)return D;let Q=G,ae=-1;for(;ae=D.lastIndexOf(k,Q-1),!(ae===-1||ae+B!==Q);){if(ae===0)return"";Q=ae}return D.substring(0,Q)}n.rtrim=C;function v(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=v;function f(D){return D.replace(/\*/g,"")}n.stripWildcards=f;function s(D,k,B={}){if(!D)throw new Error("Cannot create regex from empty string");k||(D=M(D)),B.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let G="";return B.global&&(G+="g"),B.matchCase||(G+="i"),B.multiline&&(G+="m"),B.unicode&&(G+="u"),new RegExp(D,G)}n.createRegExp=s;function i(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}n.regExpLeadsToEndlessLoop=i;function l(D){return!!D.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=l;function _(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}n.regExpFlags=_;function p(D){return D.split(/\r\n|\r|\n/)}n.splitLines=p;function g(D){for(let k=0,B=D.length;k<B;k++){const G=D.charCodeAt(k);if(G!==32&&G!==9)return k}return-1}n.firstNonWhitespaceIndex=g;function u(D,k=0,B=D.length){for(let G=k;G<B;G++){const Q=D.charCodeAt(G);if(Q!==32&&Q!==9)return D.substring(k,G)}return D.substring(k,B)}n.getLeadingWhitespace=u;function d(D,k=D.length-1){for(let B=k;B>=0;B--){const G=D.charCodeAt(B);if(G!==32&&G!==9)return B}return-1}n.lastNonWhitespaceIndex=d;function b(D,k){return D<k?-1:D>k?1:0}n.compare=b;function A(D,k,B=0,G=D.length,Q=0,ae=k.length){for(;B<G&&Q<ae;B++,Q++){let ve=D.charCodeAt(B),le=k.charCodeAt(Q);if(ve<le)return-1;if(ve>le)return 1}const he=G-B,Ne=ae-Q;return he<Ne?-1:he>Ne?1:0}n.compareSubstring=A;function R(D,k){return S(D,k,0,D.length,0,k.length)}n.compareIgnoreCase=R;function S(D,k,B=0,G=D.length,Q=0,ae=k.length){for(;B<G&&Q<ae;B++,Q++){let ve=D.charCodeAt(B),le=k.charCodeAt(Q);if(ve===le)continue;if(ve>=128||le>=128)return A(D.toLowerCase(),k.toLowerCase(),B,G,Q,ae);V(ve)&&(ve-=32),V(le)&&(le-=32);const be=ve-le;if(be!==0)return be}const he=G-B,Ne=ae-Q;return he<Ne?-1:he>Ne?1:0}n.compareSubstringIgnoreCase=S;function V(D){return D>=97&&D<=122}n.isLowerAsciiLetter=V;function q(D){return D>=65&&D<=90}n.isUpperAsciiLetter=q;function j(D,k){return D.length===k.length&&S(D,k)===0}n.equalsIgnoreCase=j;function Z(D,k){const B=k.length;return k.length>D.length?!1:S(D,k,0,B)===0}n.startsWithIgnoreCase=Z;function E(D,k){let B,G=Math.min(D.length,k.length);for(B=0;B<G;B++)if(D.charCodeAt(B)!==k.charCodeAt(B))return B;return G}n.commonPrefixLength=E;function W(D,k){let B,G=Math.min(D.length,k.length);const Q=D.length-1,ae=k.length-1;for(B=0;B<G;B++)if(D.charCodeAt(Q-B)!==k.charCodeAt(ae-B))return B;return G}n.commonSuffixLength=W;function J(D){return 55296<=D&&D<=56319}n.isHighSurrogate=J;function z(D){return 56320<=D&&D<=57343}n.isLowSurrogate=z;function r(D,k){return(D-55296<<10)+(k-56320)+65536}n.computeCodePoint=r;function oe(D,k,B){const G=D.charCodeAt(B);if(J(G)&&B+1<k){const Q=D.charCodeAt(B+1);if(z(Q))return r(G,Q)}return G}n.getNextCodePoint=oe;function de(D,k){const B=D.charCodeAt(k-1);if(z(B)&&k>1){const G=D.charCodeAt(k-2);if(J(G))return r(G,B)}return B}class me{constructor(k,B=0){this._str=k,this._len=k.length,this._offset=B}get offset(){return this._offset}setOffset(k){this._offset=k}prevCodePoint(){const k=de(this._str,this._offset);return this._offset-=k>=65536?2:1,k}nextCodePoint(){const k=oe(this._str,this._len,this._offset);return this._offset+=k>=65536?2:1,k}eol(){return this._offset>=this._len}}n.CodePointIterator=me;class Ce{constructor(k,B=0){this._iterator=new me(k,B)}get offset(){return this._iterator.offset}nextGraphemeLength(){const k=pe.getInstance(),B=this._iterator,G=B.offset;let Q=k.getGraphemeBreakType(B.nextCodePoint());for(;!B.eol();){const ae=B.offset,he=k.getGraphemeBreakType(B.nextCodePoint());if(Pe(Q,he)){B.setOffset(ae);break}Q=he}return B.offset-G}prevGraphemeLength(){const k=pe.getInstance(),B=this._iterator,G=B.offset;let Q=k.getGraphemeBreakType(B.prevCodePoint());for(;B.offset>0;){const ae=B.offset,he=k.getGraphemeBreakType(B.prevCodePoint());if(Pe(he,Q)){B.setOffset(ae);break}Q=he}return G-B.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Ce;function Ae(D,k){return new Ce(D,k).nextGraphemeLength()}n.nextCharLength=Ae;function ee(D,k){return new Ce(D,k).prevGraphemeLength()}n.prevCharLength=ee;function Y(D,k){k>0&&z(D.charCodeAt(k))&&k--;const B=k+Ae(D,k);return[B-ee(D,B),B]}n.getCharContainingOffset=Y;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(D){return K.test(D)}n.containsRTL=X;const ne=/^[\t\n\r\x20-\x7E]*$/;function I(D){return ne.test(D)}n.isBasicASCII=I,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(D){return n.UNUSUAL_LINE_TERMINATORS.test(D)}n.containsUnusualLineTerminators=T;function U(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}n.isFullWidthCharacter=U;function H(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}n.isEmojiImprecise=H;function $(D,k){if(D.length<k)return D;const B=/\b/g;let G=0;for(;B.test(D)&&!(D.length-B.lastIndex<k);)G=B.lastIndex,B.lastIndex+=1;return D.substring(G).replace(/^\s/,"")}n.lcut=$;const se=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function fe(D){return D&&(D=D.replace(se,""),D=D.replace(ie,""),D=D.replace(ce,"")),D}n.removeAnsiEscapeCodes=fe,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ge;function _e(D){return ge(D)?D.substr(1):D}n.stripUTF8BOM=_e;function Me(D,k){if(!D||!k||D.length<k.length)return!1;const B=k.length,G=D.toLowerCase();let Q=0,ae=-1;for(;Q<B;){const he=G.indexOf(k[Q],ae+1);if(he<0)return!1;ae=he,Q++}return!0}n.fuzzyContains=Me;function Te(D,k=!1){return D?(k&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}n.containsUppercaseCharacter=Te;function Ue(D){return D.charAt(0).toUpperCase()+D.slice(1)}n.uppercaseFirstLetter=Ue;function Oe(D,k=1){if(k===0)return"";let B=-1;do B=D.indexOf(`
`,B+1),k--;while(k>0&&B>=0);return B===-1?D:(D[B-1]==="\r"&&B--,D.substr(0,B))}n.getNLines=Oe;function Be(D){const k=90-65+1;return D=D%(2*k),D<k?String.fromCharCode(97+D):String.fromCharCode(65+D-k)}n.singleLetterHash=Be;function Ve(D){return pe.getInstance().getGraphemeBreakType(D)}n.getGraphemeBreakType=Ve;function Pe(D,k){return D===0?k!==5&&k!==7:D===2&&k===3?!1:D===4||D===2||D===3||k===4||k===2||k===3?!0:!(D===8&&(k===8||k===9||k===11||k===12)||(D===11||D===9)&&(k===9||k===10)||(D===12||D===10)&&k===10||k===5||k===13||k===7||D===1||D===13&&k===14||D===6&&k===6)}var We;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(We=n.GraphemeBreakType||(n.GraphemeBreakType={}));class pe{constructor(){this._data=qe()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(k){if(k<32)return k===10?3:k===13?2:4;if(k<127)return 0;const B=this._data,G=B.length/3;let Q=1;for(;Q<=G;)if(k<B[3*Q])Q=2*Q;else if(k>B[3*Q+1])Q=2*Q+1;else return B[3*Q+2];return 0}}pe._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(D,k){if(D===0)return 0;const B=ze(D,k);if(B!==void 0)return B;const G=new me(k,D);return G.prevCodePoint(),G.offset}n.getLeftDeleteOffset=He;function ze(D,k){const B=new me(k,D);let G=B.prevCodePoint();for(;je(G)||G===65039||G===8419;){if(B.offset===0)return;G=B.prevCodePoint()}if(!H(G))return;let Q=B.offset;return Q>0&&B.prevCodePoint()===8205&&(Q=B.offset),Q}function je(D){return 127995<=D&&D<=127999}var Re;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),n.noBreakWhitespace="\xA0";class we{constructor(k){this.confusableDictionary=k}static getInstance(k){return we.cache.get(Array.from(k))}static getLocales(){return we._locales.getValue()}isAmbiguous(k){return this.confusableDictionary.has(k)}getPrimaryConfusable(k){return this.confusableDictionary.get(k)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=we,F=we,we.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),we.cache=new P.LRUCachedComputed(D=>{function k(le){const be=new Map;for(let Le=0;Le<le.length;Le+=2)be.set(le[Le],le[Le+1]);return be}function B(le,be){const Le=new Map(le);for(const[ye,De]of be)Le.set(ye,De);return Le}function G(le,be){if(!le)return be;const Le=new Map;for(const[ye,De]of le)be.has(ye)&&Le.set(ye,De);return Le}const Q=F.ambiguousCharacterData.getValue();let ae=D.filter(le=>!le.startsWith("_")&&le in Q);ae.length===0&&(ae=["_default"]);let he;for(const le of ae){const be=k(Q[le]);he=G(he,be)}const Ne=k(Q._common),ve=B(Ne,he);return new we(ve)}),we._locales=new t.Lazy(()=>Object.keys(we.ambiguousCharacterData.getValue()).filter(D=>!D.startsWith("_")));class Ee{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ee.getRawData())),this._data}static isInvisibleCharacter(k){return Ee.getData().has(k)}static get codePoints(){return Ee.getData()}}n.InvisibleCharacters=Ee,Ee._data=void 0}),x(te[28],re([0,1,2]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(v){return F(v,0)}n.hash=t;function F(v,f){switch(typeof v){case"object":return v===null?a(349,f):Array.isArray(v)?o(v,f):c(v,f);case"string":return h(v,f);case"boolean":return y(v,f);case"number":return a(v,f);case"undefined":return a(937,f);default:return a(617,f)}}n.doHash=F;function a(v,f){return(f<<5)-f+v|0}n.numberHash=a;function y(v,f){return a(v?433:863,f)}function h(v,f){f=a(149417,f);for(let s=0,i=v.length;s<i;s++)f=a(v.charCodeAt(s),f);return f}n.stringHash=h;function o(v,f){return f=a(104579,f),v.reduce((s,i)=>F(i,s),f)}function c(v,f){return f=a(181387,f),Object.keys(v).sort().reduce((s,i)=>(s=h(i,s),F(v[i],s)),f)}class N{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=F(f,this._value),this._value}}n.Hasher=N;var M;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function w(v,f,s=32){const i=s-f,l=~((1<<i)-1);return(v<<f|(l&v)>>>i)>>>0}function m(v,f=0,s=v.byteLength,i=0){for(let l=0;l<s;l++)v[f+l]=i}function e(v,f,s="0"){for(;v.length<f;)v=s+v;return v}function L(v,f=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(s=>s.toString(16).padStart(2,"0")).join(""):e((v>>>0).toString(16),f/4)}n.toHexString=L;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const s=f.length;if(s===0)return;const i=this._buff;let l=this._buffLen,_=this._leftoverHighSurrogate,p,g;for(_!==0?(p=_,g=-1,_=0):(p=f.charCodeAt(0),g=0);;){let u=p;if(P.isHighSurrogate(p))if(g+1<s){const d=f.charCodeAt(g+1);P.isLowSurrogate(d)?(g++,u=P.computeCodePoint(p,d)):u=65533}else{_=p;break}else P.isLowSurrogate(p)&&(u=65533);if(l=this._push(i,l,u),g++,g<s)p=f.charCodeAt(g);else break}this._buffLen=l,this._leftoverHighSurrogate=_}_push(f,s,i){return i<128?f[s++]=i:i<2048?(f[s++]=192|(i&1984)>>>6,f[s++]=128|(i&63)>>>0):i<65536?(f[s++]=224|(i&61440)>>>12,f[s++]=128|(i&4032)>>>6,f[s++]=128|(i&63)>>>0):(f[s++]=240|(i&1835008)>>>18,f[s++]=128|(i&258048)>>>12,f[s++]=128|(i&4032)>>>6,f[s++]=128|(i&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),L(this._h0)+L(this._h1)+L(this._h2)+L(this._h3)+L(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=C._bigBlock32,s=this._buffDV;for(let A=0;A<64;A+=4)f.setUint32(A,s.getUint32(A,!1),!1);for(let A=64;A<320;A+=4)f.setUint32(A,w(f.getUint32(A-12,!1)^f.getUint32(A-32,!1)^f.getUint32(A-56,!1)^f.getUint32(A-64,!1),1),!1);let i=this._h0,l=this._h1,_=this._h2,p=this._h3,g=this._h4,u,d,b;for(let A=0;A<80;A++)A<20?(u=l&_|~l&p,d=1518500249):A<40?(u=l^_^p,d=1859775393):A<60?(u=l&_|l&p|_&p,d=2400959708):(u=l^_^p,d=3395469782),b=w(i,5)+u+g+d+f.getUint32(A*4,!1)&4294967295,g=p,p=_,_=w(l,30),l=i,i=b;this._h0=this._h0+i&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+_&4294967295,this._h3=this._h3+p&4294967295,this._h4=this._h4+g&4294967295}}n.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),x(te[14],re([0,1,19,28]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class F{constructor(w){this.source=w}getElements(){const w=this.source,m=new Int32Array(w.length);for(let e=0,L=w.length;e<L;e++)m[e]=w.charCodeAt(e);return m}}n.StringDiffSequence=F;function a(M,w,m){return new N(new F(M),new F(w)).ComputeDiff(m).changes}n.stringDiff=a;class y{static Assert(w,m){if(!w)throw new Error(m)}}n.Debug=y;class h{static Copy(w,m,e,L,C){for(let v=0;v<C;v++)e[L+v]=w[m+v]}static Copy2(w,m,e,L,C){for(let v=0;v<C;v++)e[L+v]=w[m+v]}}n.MyArray=h;var o;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(w,m){this.m_originalStart=Math.min(this.m_originalStart,w),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(w,m){this.m_originalStart=Math.min(this.m_originalStart,w),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class N{constructor(w,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=w,this._modifiedSequence=m;const[L,C,v]=N._getElements(w),[f,s,i]=N._getElements(m);this._hasStrings=v&&i,this._originalStringElements=L,this._originalElementsOrHash=C,this._modifiedStringElements=f,this._modifiedElementsOrHash=s,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(w){return w.length>0&&typeof w[0]=="string"}static _getElements(w){const m=w.getElements();if(N._isStringArray(m)){const e=new Int32Array(m.length);for(let L=0,C=m.length;L<C;L++)e[L]=(0,t.stringHash)(m[L],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(w,m){return this._originalElementsOrHash[w]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[w]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(w,m){if(!this.ElementsAreEqual(w,m))return!1;const e=N._getStrictElement(this._originalSequence,w),L=N._getStrictElement(this._modifiedSequence,m);return e===L}static _getStrictElement(w,m){return typeof w.getStrictElement=="function"?w.getStrictElement(m):null}OriginalElementsAreEqual(w,m){return this._originalElementsOrHash[w]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[w]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(w,m){return this._modifiedElementsOrHash[w]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[w]===this._modifiedStringElements[m]:!0}ComputeDiff(w){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,w)}_ComputeDiff(w,m,e,L,C){const v=[!1];let f=this.ComputeDiffRecursive(w,m,e,L,v);return C&&(f=this.PrettifyChanges(f)),{quitEarly:v[0],changes:f}}ComputeDiffRecursive(w,m,e,L,C){for(C[0]=!1;w<=m&&e<=L&&this.ElementsAreEqual(w,e);)w++,e++;for(;m>=w&&L>=e&&this.ElementsAreEqual(m,L);)m--,L--;if(w>m||e>L){let _;return e<=L?(y.Assert(w===m+1,"originalStart should only be one more than originalEnd"),_=[new P.DiffChange(w,0,e,L-e+1)]):w<=m?(y.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),_=[new P.DiffChange(w,m-w+1,e,0)]):(y.Assert(w===m+1,"originalStart should only be one more than originalEnd"),y.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),_=[]),_}const v=[0],f=[0],s=this.ComputeRecursionPoint(w,m,e,L,v,f,C),i=v[0],l=f[0];if(s!==null)return s;if(!C[0]){const _=this.ComputeDiffRecursive(w,i,e,l,C);let p=[];return C[0]?p=[new P.DiffChange(i+1,m-(i+1)+1,l+1,L-(l+1)+1)]:p=this.ComputeDiffRecursive(i+1,m,l+1,L,C),this.ConcatenateChanges(_,p)}return[new P.DiffChange(w,m-w+1,e,L-e+1)]}WALKTRACE(w,m,e,L,C,v,f,s,i,l,_,p,g,u,d,b,A,R){let S=null,V=null,q=new c,j=m,Z=e,E=g[0]-b[0]-L,W=-1073741824,J=this.m_forwardHistory.length-1;do{const z=E+w;z===j||z<Z&&i[z-1]<i[z+1]?(_=i[z+1],u=_-E-L,_<W&&q.MarkNextChange(),W=_,q.AddModifiedElement(_+1,u),E=z+1-w):(_=i[z-1]+1,u=_-E-L,_<W&&q.MarkNextChange(),W=_-1,q.AddOriginalElement(_,u+1),E=z-1-w),J>=0&&(i=this.m_forwardHistory[J],w=i[0],j=1,Z=i.length-1)}while(--J>=-1);if(S=q.getReverseChanges(),R[0]){let z=g[0]+1,r=b[0]+1;if(S!==null&&S.length>0){const oe=S[S.length-1];z=Math.max(z,oe.getOriginalEnd()),r=Math.max(r,oe.getModifiedEnd())}V=[new P.DiffChange(z,p-z+1,r,d-r+1)]}else{q=new c,j=v,Z=f,E=g[0]-b[0]-s,W=1073741824,J=A?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const z=E+C;z===j||z<Z&&l[z-1]>=l[z+1]?(_=l[z+1]-1,u=_-E-s,_>W&&q.MarkNextChange(),W=_+1,q.AddOriginalElement(_+1,u+1),E=z+1-C):(_=l[z-1],u=_-E-s,_>W&&q.MarkNextChange(),W=_,q.AddModifiedElement(_+1,u+1),E=z-1-C),J>=0&&(l=this.m_reverseHistory[J],C=l[0],j=1,Z=l.length-1)}while(--J>=-1);V=q.getChanges()}return this.ConcatenateChanges(S,V)}ComputeRecursionPoint(w,m,e,L,C,v,f){let s=0,i=0,l=0,_=0,p=0,g=0;w--,e--,C[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const u=m-w+(L-e),d=u+1,b=new Int32Array(d),A=new Int32Array(d),R=L-e,S=m-w,V=w-e,q=m-L,Z=(S-R)%2==0;b[R]=w,A[S]=m,f[0]=!1;for(let E=1;E<=u/2+1;E++){let W=0,J=0;l=this.ClipDiagonalBound(R-E,E,R,d),_=this.ClipDiagonalBound(R+E,E,R,d);for(let r=l;r<=_;r+=2){r===l||r<_&&b[r-1]<b[r+1]?s=b[r+1]:s=b[r-1]+1,i=s-(r-R)-V;const oe=s;for(;s<m&&i<L&&this.ElementsAreEqual(s+1,i+1);)s++,i++;if(b[r]=s,s+i>W+J&&(W=s,J=i),!Z&&Math.abs(r-S)<=E-1&&s>=A[r])return C[0]=s,v[0]=i,oe<=A[r]&&1447>0&&E<=1447+1?this.WALKTRACE(R,l,_,V,S,p,g,q,b,A,s,m,C,i,L,v,Z,f):null}const z=(W-w+(J-e)-E)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(W,z))return f[0]=!0,C[0]=W,v[0]=J,z>0&&1447>0&&E<=1447+1?this.WALKTRACE(R,l,_,V,S,p,g,q,b,A,s,m,C,i,L,v,Z,f):(w++,e++,[new P.DiffChange(w,m-w+1,e,L-e+1)]);p=this.ClipDiagonalBound(S-E,E,S,d),g=this.ClipDiagonalBound(S+E,E,S,d);for(let r=p;r<=g;r+=2){r===p||r<g&&A[r-1]>=A[r+1]?s=A[r+1]-1:s=A[r-1],i=s-(r-S)-q;const oe=s;for(;s>w&&i>e&&this.ElementsAreEqual(s,i);)s--,i--;if(A[r]=s,Z&&Math.abs(r-R)<=E&&s<=b[r])return C[0]=s,v[0]=i,oe>=b[r]&&1447>0&&E<=1447+1?this.WALKTRACE(R,l,_,V,S,p,g,q,b,A,s,m,C,i,L,v,Z,f):null}if(E<=1447){let r=new Int32Array(_-l+2);r[0]=R-l+1,h.Copy2(b,l,r,1,_-l+1),this.m_forwardHistory.push(r),r=new Int32Array(g-p+2),r[0]=S-p+1,h.Copy2(A,p,r,1,g-p+1),this.m_reverseHistory.push(r)}}return this.WALKTRACE(R,l,_,V,S,p,g,q,b,A,s,m,C,i,L,v,Z,f)}PrettifyChanges(w){for(let m=0;m<w.length;m++){const e=w[m],L=m<w.length-1?w[m+1].originalStart:this._originalElementsOrHash.length,C=m<w.length-1?w[m+1].modifiedStart:this._modifiedElementsOrHash.length,v=e.originalLength>0,f=e.modifiedLength>0;for(;e.originalStart+e.originalLength<L&&e.modifiedStart+e.modifiedLength<C&&(!v||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!f||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const i=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!i)break;e.originalStart++,e.modifiedStart++}let s=[null];if(m<w.length-1&&this.ChangesOverlap(w[m],w[m+1],s)){w[m]=s[0],w.splice(m+1,1),m--;continue}}for(let m=w.length-1;m>=0;m--){const e=w[m];let L=0,C=0;if(m>0){const _=w[m-1];L=_.originalStart+_.originalLength,C=_.modifiedStart+_.modifiedLength}const v=e.originalLength>0,f=e.modifiedLength>0;let s=0,i=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let _=1;;_++){const p=e.originalStart-_,g=e.modifiedStart-_;if(p<L||g<C||v&&!this.OriginalElementsAreEqual(p,p+e.originalLength)||f&&!this.ModifiedElementsAreEqual(g,g+e.modifiedLength))break;const d=(p===L&&g===C?5:0)+this._boundaryScore(p,e.originalLength,g,e.modifiedLength);d>i&&(i=d,s=_)}e.originalStart-=s,e.modifiedStart-=s;const l=[null];if(m>0&&this.ChangesOverlap(w[m-1],w[m],l)){w[m-1]=l[0],w.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=w.length;m<e;m++){const L=w[m-1],C=w[m],v=C.originalStart-L.originalStart-L.originalLength,f=L.originalStart,s=C.originalStart+C.originalLength,i=s-f,l=L.modifiedStart,_=C.modifiedStart+C.modifiedLength,p=_-l;if(v<5&&i<20&&p<20){const g=this._findBetterContiguousSequence(f,i,l,p,v);if(g){const[u,d]=g;(u!==L.originalStart+L.originalLength||d!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=u-L.originalStart,L.modifiedLength=d-L.modifiedStart,C.originalStart=u+v,C.modifiedStart=d+v,C.originalLength=s-C.originalStart,C.modifiedLength=_-C.modifiedStart)}}}return w}_findBetterContiguousSequence(w,m,e,L,C){if(m<C||L<C)return null;const v=w+m-C+1,f=e+L-C+1;let s=0,i=0,l=0;for(let _=w;_<v;_++)for(let p=e;p<f;p++){const g=this._contiguousSequenceScore(_,p,C);g>0&&g>s&&(s=g,i=_,l=p)}return s>0?[i,l]:null}_contiguousSequenceScore(w,m,e){let L=0;for(let C=0;C<e;C++){if(!this.ElementsAreEqual(w+C,m+C))return 0;L+=this._originalStringElements[w+C].length}return L}_OriginalIsBoundary(w){return w<=0||w>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[w])}_OriginalRegionIsBoundary(w,m){if(this._OriginalIsBoundary(w)||this._OriginalIsBoundary(w-1))return!0;if(m>0){const e=w+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(w){return w<=0||w>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[w])}_ModifiedRegionIsBoundary(w,m){if(this._ModifiedIsBoundary(w)||this._ModifiedIsBoundary(w-1))return!0;if(m>0){const e=w+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(w,m,e,L){const C=this._OriginalRegionIsBoundary(w,m)?1:0,v=this._ModifiedRegionIsBoundary(e,L)?1:0;return C+v}ConcatenateChanges(w,m){let e=[];if(w.length===0||m.length===0)return m.length>0?m:w;if(this.ChangesOverlap(w[w.length-1],m[0],e)){const L=new Array(w.length+m.length-1);return h.Copy(w,0,L,0,w.length-1),L[w.length-1]=e[0],h.Copy(m,1,L,w.length,m.length-1),L}else{const L=new Array(w.length+m.length);return h.Copy(w,0,L,0,w.length),h.Copy(m,0,L,w.length,m.length),L}}ChangesOverlap(w,m,e){if(y.Assert(w.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),y.Assert(w.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),w.originalStart+w.originalLength>=m.originalStart||w.modifiedStart+w.modifiedLength>=m.modifiedStart){const L=w.originalStart;let C=w.originalLength;const v=w.modifiedStart;let f=w.modifiedLength;return w.originalStart+w.originalLength>=m.originalStart&&(C=m.originalStart+m.originalLength-w.originalStart),w.modifiedStart+w.modifiedLength>=m.modifiedStart&&(f=m.modifiedStart+m.modifiedLength-w.modifiedStart),e[0]=new P.DiffChange(L,C,v,f),!0}else return e[0]=null,!1}ClipDiagonalBound(w,m,e,L){if(w>=0&&w<L)return w;const C=e,v=L-e-1,f=m%2==0;if(w<0){const s=C%2==0;return f===s?0:1}else{const s=v%2==0;return f===s?L-1:L-2}}}n.LcsDiff=N}),x(te[7],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function P(A){return Array.isArray(A)}n.isArray=P;function t(A){return typeof A=="string"}n.isString=t;function F(A){return Array.isArray(A)&&A.every(R=>t(R))}n.isStringArray=F;function a(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}n.isObject=a;function y(A){return typeof A=="object"&&(A instanceof Uint8Array||A instanceof Uint16Array||A instanceof Uint32Array||A instanceof Float32Array||A instanceof Float64Array||A instanceof Int8Array||A instanceof Int16Array||A instanceof Int32Array||A instanceof BigInt64Array||A instanceof BigUint64Array||A instanceof Uint8ClampedArray)}n.isTypedArray=y;function h(A){return typeof A=="number"&&!isNaN(A)}n.isNumber=h;function o(A){return!!A&&typeof A[Symbol.iterator]=="function"}n.isIterable=o;function c(A){return A===!0||A===!1}n.isBoolean=c;function N(A){return typeof A=="undefined"}n.isUndefined=N;function M(A){return!w(A)}n.isDefined=M;function w(A){return N(A)||A===null}n.isUndefinedOrNull=w;function m(A,R){if(!A)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}n.assertType=m;function e(A){if(w(A))throw new Error("Assertion Failed: argument is undefined or null");return A}n.assertIsDefined=e;function L(...A){const R=[];for(let S=0;S<A.length;S++){const V=A[S];if(w(V))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);R.push(V)}return R}n.assertAllDefined=L;const C=Object.prototype.hasOwnProperty;function v(A){if(!a(A))return!1;for(let R in A)if(C.call(A,R))return!1;return!0}n.isEmptyObject=v;function f(A){return typeof A=="function"}n.isFunction=f;function s(...A){return A.length>0&&A.every(f)}n.areFunctions=s;function i(A,R){const S=Math.min(A.length,R.length);for(let V=0;V<S;V++)l(A[V],R[V])}n.validateConstraints=i;function l(A,R){if(t(R)){if(typeof A!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(f(R)){try{if(A instanceof R)return}catch{}if(!w(A)&&A.constructor===R||R.length===1&&R.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=l;function _(A){let R=[],S=Object.getPrototypeOf(A);for(;Object.prototype!==S;)R=R.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return R}n.getAllPropertyNames=_;function p(A){const R=[];for(const S of _(A))typeof A[S]=="function"&&R.push(S);return R}n.getAllMethodNames=p;function g(A,R){const S=q=>function(){const j=Array.prototype.slice.call(arguments,0);return R(q,j)};let V={};for(const q of A)V[q]=S(q);return V}n.createProxyObject=g;function u(A){return A===null?void 0:A}n.withNullAsUndefined=u;function d(A){return typeof A=="undefined"?null:A}n.withUndefinedAsNull=d;function b(A,R="Unreachable"){throw new Error(R)}n.assertNever=b}),x(te[29],re([0,1,7]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.filter=n.getCaseInsensitive=n.distinct=n.getOrDefault=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const C=Array.isArray(L)?[]:{};return Object.keys(L).forEach(v=>{L[v]&&typeof L[v]=="object"?C[v]=t(L[v]):C[v]=L[v]}),C}n.deepClone=t;function F(L){if(!L||typeof L!="object")return L;const C=[L];for(;C.length>0;){const v=C.shift();Object.freeze(v);for(const f in v)if(a.call(v,f)){const s=v[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,P.isTypedArray)(s)&&C.push(s)}}return L}n.deepFreeze=F;const a=Object.prototype.hasOwnProperty;function y(L,C){return h(L,C,new Set)}n.cloneAndChange=y;function h(L,C,v){if((0,P.isUndefinedOrNull)(L))return L;const f=C(L);if(typeof f!="undefined")return f;if((0,P.isArray)(L)){const s=[];for(const i of L)s.push(h(i,C,v));return s}if((0,P.isObject)(L)){if(v.has(L))throw new Error("Cannot clone recursive data-structure");v.add(L);const s={};for(let i in L)a.call(L,i)&&(s[i]=h(L[i],C,v));return v.delete(L),s}return L}function o(L,C,v=!0){return(0,P.isObject)(L)?((0,P.isObject)(C)&&Object.keys(C).forEach(f=>{f in L?v&&((0,P.isObject)(L[f])&&(0,P.isObject)(C[f])?o(L[f],C[f],v):L[f]=C[f]):L[f]=C[f]}),L):C}n.mixin=o;function c(L,C){if(L===C)return!0;if(L==null||C===null||C===void 0||typeof L!=typeof C||typeof L!="object"||Array.isArray(L)!==Array.isArray(C))return!1;let v,f;if(Array.isArray(L)){if(L.length!==C.length)return!1;for(v=0;v<L.length;v++)if(!c(L[v],C[v]))return!1}else{const s=[];for(f in L)s.push(f);s.sort();const i=[];for(f in C)i.push(f);if(i.sort(),!c(s,i))return!1;for(v=0;v<s.length;v++)if(!c(L[s[v]],C[s[v]]))return!1}return!0}n.equals=c;function N(L){const C=new Set;return JSON.stringify(L,(v,f)=>{if((0,P.isObject)(f)||Array.isArray(f)){if(C.has(f))return"[Circular]";C.add(f)}return f})}n.safeStringify=N;function M(L,C,v){const f=C(L);return typeof f=="undefined"?v:f}n.getOrDefault=M;function w(L,C){const v=Object.create(null);return!L||!C||Object.keys(C).forEach(s=>{const i=L[s],l=C[s];c(i,l)||(v[s]=l)}),v}n.distinct=w;function m(L,C){const v=C.toLowerCase(),f=Object.keys(L).find(s=>s.toLowerCase()===v);return f?L[f]:L[C]}n.getCaseInsensitive=m;function e(L,C){const v=Object.create(null);for(const[f,s]of Object.entries(L))C(f,s)&&(v[f]=s);return v}n.filter=e}),x(te[15],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var P;(function(a){a[a.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",a[a.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",a[a.MAX_UINT_8=255]="MAX_UINT_8",a[a.MAX_UINT_16=65535]="MAX_UINT_16",a[a.MAX_UINT_32=4294967295]="MAX_UINT_32",a[a.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=n.Constants||(n.Constants={}));function t(a){return a<0?0:a>255?255:a|0}n.toUint8=t;function F(a){return a<0?0:a>4294967295?4294967295:a|0}n.toUint32=F}),x(te[10],re([0,1,26,5]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const F=/^\w[\w\d+.-]*$/,a=/^\//,y=/^\/\//;function h(g,u){if(!g.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!F.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!a.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(g,u){return!g&&!u?"file":g}function c(g,u){switch(g){case"https":case"http":case"file":u?u[0]!==M&&(u=M+u):u=M;break}return u}const N="",M="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(u,d,b,A,R,S=!1){typeof u=="object"?(this.scheme=u.scheme||N,this.authority=u.authority||N,this.path=u.path||N,this.query=u.query||N,this.fragment=u.fragment||N):(this.scheme=o(u,S),this.authority=d||N,this.path=c(this.scheme,b||N),this.query=A||N,this.fragment=R||N,h(this,S))}static isUri(u){return u instanceof m?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return s(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:b,path:A,query:R,fragment:S}=u;return d===void 0?d=this.scheme:d===null&&(d=N),b===void 0?b=this.authority:b===null&&(b=N),A===void 0?A=this.path:A===null&&(A=N),R===void 0?R=this.query:R===null&&(R=N),S===void 0?S=this.fragment:S===null&&(S=N),d===this.scheme&&b===this.authority&&A===this.path&&R===this.query&&S===this.fragment?this:new L(d,b,A,R,S)}static parse(u,d=!1){const b=w.exec(u);return b?new L(b[2]||N,p(b[4]||N),p(b[5]||N),p(b[7]||N),p(b[9]||N),d):new L(N,N,N,N,N)}static file(u){let d=N;if(t.isWindows&&(u=u.replace(/\\/g,M)),u[0]===M&&u[1]===M){const b=u.indexOf(M,2);b===-1?(d=u.substring(2),u=M):(d=u.substring(2,b),u=u.substring(b)||M)}return new L("file",d,u,N,N)}static from(u){const d=new L(u.scheme,u.authority,u.path,u.query,u.fragment);return h(d,!0),d}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return t.isWindows&&u.scheme==="file"?b=m.file(P.win32.join(s(u,!0),...d)).path:b=P.posix.join(u.path,...d),u.with({path:b})}toString(u=!1){return i(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof m)return u;{const d=new L(u);return d._formatted=u.external,d._fsPath=u._sep===e?u.fsPath:null,d}}else return u}}n.URI=m;const e=t.isWindows?1:void 0;class L extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(u=!1){return u?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=e),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(g,u){let d,b=-1;for(let A=0;A<g.length;A++){const R=g.charCodeAt(A);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||u&&R===47)b!==-1&&(d+=encodeURIComponent(g.substring(b,A)),b=-1),d!==void 0&&(d+=g.charAt(A));else{d===void 0&&(d=g.substr(0,A));const S=C[R];S!==void 0?(b!==-1&&(d+=encodeURIComponent(g.substring(b,A)),b=-1),d+=S):b===-1&&(b=A)}}return b!==-1&&(d+=encodeURIComponent(g.substring(b))),d!==void 0?d:g}function f(g){let u;for(let d=0;d<g.length;d++){const b=g.charCodeAt(d);b===35||b===63?(u===void 0&&(u=g.substr(0,d)),u+=C[b]):u!==void 0&&(u+=g[d])}return u!==void 0?u:g}function s(g,u){let d;return g.authority&&g.path.length>1&&g.scheme==="file"?d=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?u?d=g.path.substr(1):d=g.path[1].toLowerCase()+g.path.substr(2):d=g.path,t.isWindows&&(d=d.replace(/\//g,"\\")),d}n.uriToFsPath=s;function i(g,u){const d=u?f:v;let b="",{scheme:A,authority:R,path:S,query:V,fragment:q}=g;if(A&&(b+=A,b+=":"),(R||A==="file")&&(b+=M,b+=M),R){let j=R.indexOf("@");if(j!==-1){const Z=R.substr(0,j);R=R.substr(j+1),j=Z.indexOf(":"),j===-1?b+=d(Z,!1):(b+=d(Z.substr(0,j),!1),b+=":",b+=d(Z.substr(j+1),!1)),b+="@"}R=R.toLowerCase(),j=R.indexOf(":"),j===-1?b+=d(R,!1):(b+=d(R.substr(0,j),!1),b+=R.substr(j))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const j=S.charCodeAt(1);j>=65&&j<=90&&(S=`/${String.fromCharCode(j+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const j=S.charCodeAt(0);j>=65&&j<=90&&(S=`${String.fromCharCode(j+32)}:${S.substr(2)}`)}b+=d(S,!0)}return V&&(b+="?",b+=d(V,!1)),q&&(b+="#",b+=u?q:v(q,!1)),b}function l(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+l(g.substr(3)):g}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function p(g){return g.match(_)?g.replace(_,u=>l(u)):g}}),x(te[44],re([0,1,8,6,9,5,7,2]),function(O,n,P,t,F,a,y,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let c=!1;function N(g){!a.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}n.logOnceWebWorkerWarning=N;var M;(function(g){g[g.Request=0]="Request",g[g.Reply=1]="Reply",g[g.SubscribeEvent=2]="SubscribeEvent",g[g.Event=3]="Event",g[g.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class w{constructor(u,d,b,A){this.vsWorker=u,this.req=d,this.method=b,this.args=A,this.type=0}}class m{constructor(u,d,b,A){this.vsWorker=u,this.seq=d,this.res=b,this.err=A,this.type=1}}class e{constructor(u,d,b,A){this.vsWorker=u,this.req=d,this.eventName=b,this.arg=A,this.type=2}}class L{constructor(u,d,b){this.vsWorker=u,this.req=d,this.event=b,this.type=3}}class C{constructor(u,d){this.vsWorker=u,this.req=d,this.type=4}}class v{constructor(u){this._workerId=-1,this._handler=u,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(u){this._workerId=u}sendMessage(u,d){const b=String(++this._lastSentReq);return new Promise((A,R)=>{this._pendingReplies[b]={resolve:A,reject:R},this._send(new w(this._workerId,b,u,d))})}listen(u,d){let b=null;const A=new t.Emitter({onFirstListenerAdd:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,A),this._send(new e(this._workerId,b,u,d))},onLastListenerRemove:()=>{this._pendingEmitters.delete(b),this._send(new C(this._workerId,b)),b=null}});return A.event}handleMessage(u){!u||!u.vsWorker||this._workerId!==-1&&u.vsWorker!==this._workerId||this._handleMessage(u)}_handleMessage(u){switch(u.type){case 1:return this._handleReplyMessage(u);case 0:return this._handleRequestMessage(u);case 2:return this._handleSubscribeEventMessage(u);case 3:return this._handleEventMessage(u);case 4:return this._handleUnsubscribeEventMessage(u)}}_handleReplyMessage(u){if(!this._pendingReplies[u.seq]){console.warn("Got reply to unknown seq");return}let d=this._pendingReplies[u.seq];if(delete this._pendingReplies[u.seq],u.err){let b=u.err;u.err.$isError&&(b=new Error,b.name=u.err.name,b.message=u.err.message,b.stack=u.err.stack),d.reject(b);return}d.resolve(u.res)}_handleRequestMessage(u){let d=u.req;this._handler.handleMessage(u.method,u.args).then(A=>{this._send(new m(this._workerId,d,A,void 0))},A=>{A.detail instanceof Error&&(A.detail=(0,P.transformErrorForSerialization)(A.detail)),this._send(new m(this._workerId,d,void 0,(0,P.transformErrorForSerialization)(A)))})}_handleSubscribeEventMessage(u){const d=u.req,b=this._handler.handleEvent(u.eventName,u.arg)(A=>{this._send(new L(this._workerId,d,A))});this._pendingEvents.set(d,b)}_handleEventMessage(u){if(!this._pendingEmitters.has(u.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(u.req).fire(u.event)}_handleUnsubscribeEventMessage(u){if(!this._pendingEvents.has(u.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(u.req).dispose(),this._pendingEvents.delete(u.req)}_send(u){let d=[];if(u.type===0)for(let b=0;b<u.args.length;b++)u.args[b]instanceof ArrayBuffer&&d.push(u.args[b]);else u.type===1&&u.res instanceof ArrayBuffer&&d.push(u.res);this._handler.sendMessage(u,d)}}class f extends F.Disposable{constructor(u,d,b){super();let A=null;this._worker=this._register(u.create("vs/base/common/worker/simpleWorker",j=>{this._protocol.handleMessage(j)},j=>{A&&A(j)})),this._protocol=new v({sendMessage:(j,Z)=>{this._worker.postMessage(j,Z)},handleMessage:(j,Z)=>{if(typeof b[j]!="function")return Promise.reject(new Error("Missing method "+j+" on main thread host."));try{return Promise.resolve(b[j].apply(b,Z))}catch(E){return Promise.reject(E)}},handleEvent:(j,Z)=>{if(i(j)){const E=b[j].call(b,Z);if(typeof E!="function")throw new Error(`Missing dynamic event ${j} on main thread host.`);return E}if(s(j)){const E=b[j];if(typeof E!="function")throw new Error(`Missing event ${j} on main thread host.`);return E}throw new Error(`Malformed event name ${j}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;typeof a.globals.require!="undefined"&&typeof a.globals.require.getConfig=="function"?R=a.globals.require.getConfig():typeof a.globals.requirejs!="undefined"&&(R=a.globals.requirejs.s.contexts._.config);const S=y.getAllMethodNames(b);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(R)),d,S]);const V=(j,Z)=>this._request(j,Z),q=(j,Z)=>this._protocol.listen(j,Z);this._lazyProxy=new Promise((j,Z)=>{A=Z,this._onModuleLoaded.then(E=>{j(l(E,V,q))},E=>{Z(E),this._onError("Worker failed to load "+d,E)})})}getProxyObject(){return this._lazyProxy}_request(u,d){return new Promise((b,A)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(u,d).then(b,A)},A)})}_onError(u,d){console.error(u),console.info(d)}}n.SimpleWorkerClient=f;function s(g){return g[0]==="o"&&g[1]==="n"&&h.isUpperAsciiLetter(g.charCodeAt(2))}function i(g){return/^onDynamic/.test(g)&&h.isUpperAsciiLetter(g.charCodeAt(9))}function l(g,u,d){const b=S=>function(){const V=Array.prototype.slice.call(arguments,0);return u(S,V)},A=S=>function(V){return d(S,V)};let R={};for(const S of g){if(i(S)){R[S]=A(S);continue}if(s(S)){R[S]=d(S,void 0);continue}R[S]=b(S)}return R}class _{constructor(u,d){this._requestHandlerFactory=d,this._requestHandler=null,this._protocol=new v({sendMessage:(b,A)=>{u(b,A)},handleMessage:(b,A)=>this._handleMessage(b,A),handleEvent:(b,A)=>this._handleEvent(b,A)})}onmessage(u){this._protocol.handleMessage(u)}_handleMessage(u,d){if(u===o)return this.initialize(d[0],d[1],d[2],d[3]);if(!this._requestHandler||typeof this._requestHandler[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this._requestHandler[u].apply(this._requestHandler,d))}catch(b){return Promise.reject(b)}}_handleEvent(u,d){if(!this._requestHandler)throw new Error("Missing requestHandler");if(i(u)){const b=this._requestHandler[u].call(this._requestHandler,d);if(typeof b!="function")throw new Error(`Missing dynamic event ${u} on request handler.`);return b}if(s(u)){const b=this._requestHandler[u];if(typeof b!="function")throw new Error(`Missing event ${u} on request handler.`);return b}throw new Error(`Malformed event name ${u}`)}initialize(u,d,b,A){this._protocol.setWorkerId(u);const V=l(A,(q,j)=>this._protocol.sendMessage(q,j),(q,j)=>this._protocol.listen(q,j));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(V),Promise.resolve(y.getAllMethodNames(this._requestHandler))):(d&&(typeof d.baseUrl!="undefined"&&delete d.baseUrl,typeof d.paths!="undefined"&&typeof d.paths.vs!="undefined"&&delete d.paths.vs,typeof d.trustedTypesPolicy!==void 0&&delete d.trustedTypesPolicy,d.catchError=!0,a.globals.require.config(d)),new Promise((q,j)=>{(a.globals.require||O)([b],E=>{if(this._requestHandler=E.create(V),!this._requestHandler){j(new Error("No RequestHandler!"));return}q(y.getAllMethodNames(this._requestHandler))},j)}))}}n.SimpleWorkerServer=_;function p(g){return new _(g,null)}n.create=p}),x(te[16],re([0,1,15]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(h){const o=(0,P.toUint8)(h);this._defaultValue=o,this._asciiMap=t._createAsciiMap(o),this._map=new Map}static _createAsciiMap(h){const o=new Uint8Array(256);for(let c=0;c<256;c++)o[c]=h;return o}set(h,o){const c=(0,P.toUint8)(o);h>=0&&h<256?this._asciiMap[h]=c:this._map.set(h,c)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}}n.CharacterClassifier=t;var F;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(F||(F={}));class a{constructor(){this._actual=new t(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}}n.CharacterSet=a}),x(te[3],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class P{constructor(F,a){this.lineNumber=F,this.column=a}with(F=this.lineNumber,a=this.column){return F===this.lineNumber&&a===this.column?this:new P(F,a)}delta(F=0,a=0){return this.with(this.lineNumber+F,this.column+a)}equals(F){return P.equals(this,F)}static equals(F,a){return!F&&!a?!0:!!F&&!!a&&F.lineNumber===a.lineNumber&&F.column===a.column}isBefore(F){return P.isBefore(this,F)}static isBefore(F,a){return F.lineNumber<a.lineNumber?!0:a.lineNumber<F.lineNumber?!1:F.column<a.column}isBeforeOrEqual(F){return P.isBeforeOrEqual(this,F)}static isBeforeOrEqual(F,a){return F.lineNumber<a.lineNumber?!0:a.lineNumber<F.lineNumber?!1:F.column<=a.column}static compare(F,a){const y=F.lineNumber|0,h=a.lineNumber|0;if(y===h){const o=F.column|0,c=a.column|0;return o-c}return y-h}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(F){return new P(F.lineNumber,F.column)}static isIPosition(F){return F&&typeof F.lineNumber=="number"&&typeof F.column=="number"}}n.Position=P}),x(te[4],re([0,1,3]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(a,y,h,o){a>h||a===h&&y>o?(this.startLineNumber=h,this.startColumn=o,this.endLineNumber=a,this.endColumn=y):(this.startLineNumber=a,this.startColumn=y,this.endLineNumber=h,this.endColumn=o)}isEmpty(){return t.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return t.containsPosition(this,a)}static containsPosition(a,y){return!(y.lineNumber<a.startLineNumber||y.lineNumber>a.endLineNumber||y.lineNumber===a.startLineNumber&&y.column<a.startColumn||y.lineNumber===a.endLineNumber&&y.column>a.endColumn)}static strictContainsPosition(a,y){return!(y.lineNumber<a.startLineNumber||y.lineNumber>a.endLineNumber||y.lineNumber===a.startLineNumber&&y.column<=a.startColumn||y.lineNumber===a.endLineNumber&&y.column>=a.endColumn)}containsRange(a){return t.containsRange(this,a)}static containsRange(a,y){return!(y.startLineNumber<a.startLineNumber||y.endLineNumber<a.startLineNumber||y.startLineNumber>a.endLineNumber||y.endLineNumber>a.endLineNumber||y.startLineNumber===a.startLineNumber&&y.startColumn<a.startColumn||y.endLineNumber===a.endLineNumber&&y.endColumn>a.endColumn)}strictContainsRange(a){return t.strictContainsRange(this,a)}static strictContainsRange(a,y){return!(y.startLineNumber<a.startLineNumber||y.endLineNumber<a.startLineNumber||y.startLineNumber>a.endLineNumber||y.endLineNumber>a.endLineNumber||y.startLineNumber===a.startLineNumber&&y.startColumn<=a.startColumn||y.endLineNumber===a.endLineNumber&&y.endColumn>=a.endColumn)}plusRange(a){return t.plusRange(this,a)}static plusRange(a,y){let h,o,c,N;return y.startLineNumber<a.startLineNumber?(h=y.startLineNumber,o=y.startColumn):y.startLineNumber===a.startLineNumber?(h=y.startLineNumber,o=Math.min(y.startColumn,a.startColumn)):(h=a.startLineNumber,o=a.startColumn),y.endLineNumber>a.endLineNumber?(c=y.endLineNumber,N=y.endColumn):y.endLineNumber===a.endLineNumber?(c=y.endLineNumber,N=Math.max(y.endColumn,a.endColumn)):(c=a.endLineNumber,N=a.endColumn),new t(h,o,c,N)}intersectRanges(a){return t.intersectRanges(this,a)}static intersectRanges(a,y){let h=a.startLineNumber,o=a.startColumn,c=a.endLineNumber,N=a.endColumn,M=y.startLineNumber,w=y.startColumn,m=y.endLineNumber,e=y.endColumn;return h<M?(h=M,o=w):h===M&&(o=Math.max(o,w)),c>m?(c=m,N=e):c===m&&(N=Math.min(N,e)),h>c||h===c&&o>N?null:new t(h,o,c,N)}equalsRange(a){return t.equalsRange(this,a)}static equalsRange(a,y){return!!a&&!!y&&a.startLineNumber===y.startLineNumber&&a.startColumn===y.startColumn&&a.endLineNumber===y.endLineNumber&&a.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(a){return new P.Position(a.endLineNumber,a.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(a){return new P.Position(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,y){return new t(this.startLineNumber,this.startColumn,a,y)}setStartPosition(a,y){return new t(a,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(a){return new t(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}static fromPositions(a,y=a){return new t(a.lineNumber,a.column,y.lineNumber,y.column)}static lift(a){return a?new t(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,y){return!(a.endLineNumber<y.startLineNumber||a.endLineNumber===y.startLineNumber&&a.endColumn<y.startColumn||y.endLineNumber<a.startLineNumber||y.endLineNumber===a.startLineNumber&&y.endColumn<a.startColumn)}static areIntersecting(a,y){return!(a.endLineNumber<y.startLineNumber||a.endLineNumber===y.startLineNumber&&a.endColumn<=y.startColumn||y.endLineNumber<a.startLineNumber||y.endLineNumber===a.startLineNumber&&y.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,y){if(a&&y){const c=a.startLineNumber|0,N=y.startLineNumber|0;if(c===N){const M=a.startColumn|0,w=y.startColumn|0;if(M===w){const m=a.endLineNumber|0,e=y.endLineNumber|0;if(m===e){const L=a.endColumn|0,C=y.endColumn|0;return L-C}return m-e}return M-w}return c-N}return(a?1:0)-(y?1:0)}static compareRangesUsingEnds(a,y){return a.endLineNumber===y.endLineNumber?a.endColumn===y.endColumn?a.startLineNumber===y.startLineNumber?a.startColumn-y.startColumn:a.startLineNumber-y.startLineNumber:a.endColumn-y.endColumn:a.endLineNumber-y.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}n.Range=t}),x(te[30],re([0,1,3,4]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var F;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(F=n.SelectionDirection||(n.SelectionDirection={}));class a extends t.Range{constructor(h,o,c,N){super(h,o,c,N);this.selectionStartLineNumber=h,this.selectionStartColumn=o,this.positionLineNumber=c,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return a.selectionsEqual(this,h)}static selectionsEqual(h,o){return h.selectionStartLineNumber===o.selectionStartLineNumber&&h.selectionStartColumn===o.selectionStartColumn&&h.positionLineNumber===o.positionLineNumber&&h.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,o){return this.getDirection()===0?new a(this.startLineNumber,this.startColumn,h,o):new a(h,o,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,o){return this.getDirection()===0?new a(h,o,this.endLineNumber,this.endColumn):new a(this.endLineNumber,this.endColumn,h,o)}static fromPositions(h,o=h){return new a(h.lineNumber,h.column,o.lineNumber,o.column)}static fromRange(h,o){return o===0?new a(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new a(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new a(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,o){if(h&&!o||!h&&o)return!1;if(!h&&!o)return!0;if(h.length!==o.length)return!1;for(let c=0,N=h.length;c<N;c++)if(!this.selectionsEqual(h[c],o[c]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,o,c,N,M){return M===0?new a(h,o,c,N):new a(c,N,h,o)}}n.Selection=a}),x(te[31],re([0,1,16]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class F extends P.CharacterClassifier{constructor(h){super(0);for(let o=0,c=h.length;o<c;o++)this.set(h.charCodeAt(o),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=F;function a(y){const h={};return o=>(h.hasOwnProperty(o)||(h[o]=y(o)),h[o])}n.getMapForWordSeparators=a(y=>new F(y))}),x(te[17],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(h=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const c of n.USUAL_WORD_SEPARATORS)h.indexOf(c)>=0||(o+="\\"+c);return o+="\\s]+)",new RegExp(o,"g")}n.DEFAULT_WORD_REGEXP=P();function t(h){let o=n.DEFAULT_WORD_REGEXP;if(h&&h instanceof RegExp)if(h.global)o=h;else{let c="g";h.ignoreCase&&(c+="i"),h.multiline&&(c+="m"),h.unicode&&(c+="u"),o=new RegExp(h.source,c)}return o.lastIndex=0,o}n.ensureValidWordDefinition=t;const F={maxLen:1e3,windowSize:15,timeBudget:150};function a(h,o,c,N,M=F){if(c.length>M.maxLen){let C=h-M.maxLen/2;return C<0?C=0:N+=C,c=c.substring(C,h+M.maxLen/2),a(h,o,c,N,M)}const w=Date.now(),m=h-1-N;let e=-1,L=null;for(let C=1;!(Date.now()-w>=M.timeBudget);C++){const v=m-M.windowSize*C;o.lastIndex=Math.max(0,v);const f=y(o,c,m,e);if(!f&&L||(L=f,v<=0))break;e=v}if(L){const C={word:L[0],startColumn:N+1+L.index,endColumn:N+1+L.index+L[0].length};return o.lastIndex=0,C}return null}n.getWordAtText=a;function y(h,o,c,N){let M;for(;M=h.exec(o);){const w=M.index||0;if(w<=c&&h.lastIndex>=c)return M;if(N>0&&w>N)return null}return null}}),x(te[32],re([0,1,14,2]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const F=3;function a(L,C,v,f){return new P.LcsDiff(L,C,v).ComputeDiff(f)}class y{constructor(C){const v=[],f=[];for(let s=0,i=C.length;s<i;s++)v[s]=w(C[s],1),f[s]=m(C[s],1);this.lines=C,this._startColumns=v,this._endColumns=f}getElements(){const C=[];for(let v=0,f=this.lines.length;v<f;v++)C[v]=this.lines[v].substring(this._startColumns[v]-1,this._endColumns[v]-1);return C}getStrictElement(C){return this.lines[C]}getStartLineNumber(C){return C+1}getEndLineNumber(C){return C+1}createCharSequence(C,v,f){const s=[],i=[],l=[];let _=0;for(let p=v;p<=f;p++){const g=this.lines[p],u=C?this._startColumns[p]:1,d=C?this._endColumns[p]:g.length+1;for(let b=u;b<d;b++)s[_]=g.charCodeAt(b-1),i[_]=p+1,l[_]=b,_++}return new h(s,i,l)}}class h{constructor(C,v,f){this._charCodes=C,this._lineNumbers=v,this._columns=f}getElements(){return this._charCodes}getStartLineNumber(C){return this._lineNumbers[C]}getStartColumn(C){return this._columns[C]}getEndLineNumber(C){return this._lineNumbers[C]}getEndColumn(C){return this._columns[C]+1}}class o{constructor(C,v,f,s,i,l,_,p){this.originalStartLineNumber=C,this.originalStartColumn=v,this.originalEndLineNumber=f,this.originalEndColumn=s,this.modifiedStartLineNumber=i,this.modifiedStartColumn=l,this.modifiedEndLineNumber=_,this.modifiedEndColumn=p}static createFromDiffChange(C,v,f){let s,i,l,_,p,g,u,d;return C.originalLength===0?(s=0,i=0,l=0,_=0):(s=v.getStartLineNumber(C.originalStart),i=v.getStartColumn(C.originalStart),l=v.getEndLineNumber(C.originalStart+C.originalLength-1),_=v.getEndColumn(C.originalStart+C.originalLength-1)),C.modifiedLength===0?(p=0,g=0,u=0,d=0):(p=f.getStartLineNumber(C.modifiedStart),g=f.getStartColumn(C.modifiedStart),u=f.getEndLineNumber(C.modifiedStart+C.modifiedLength-1),d=f.getEndColumn(C.modifiedStart+C.modifiedLength-1)),new o(s,i,l,_,p,g,u,d)}}function c(L){if(L.length<=1)return L;const C=[L[0]];let v=C[0];for(let f=1,s=L.length;f<s;f++){const i=L[f],l=i.originalStart-(v.originalStart+v.originalLength),_=i.modifiedStart-(v.modifiedStart+v.modifiedLength);Math.min(l,_)<F?(v.originalLength=i.originalStart+i.originalLength-v.originalStart,v.modifiedLength=i.modifiedStart+i.modifiedLength-v.modifiedStart):(C.push(i),v=i)}return C}class N{constructor(C,v,f,s,i){this.originalStartLineNumber=C,this.originalEndLineNumber=v,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=s,this.charChanges=i}static createFromDiffResult(C,v,f,s,i,l,_){let p,g,u,d,b;if(v.originalLength===0?(p=f.getStartLineNumber(v.originalStart)-1,g=0):(p=f.getStartLineNumber(v.originalStart),g=f.getEndLineNumber(v.originalStart+v.originalLength-1)),v.modifiedLength===0?(u=s.getStartLineNumber(v.modifiedStart)-1,d=0):(u=s.getStartLineNumber(v.modifiedStart),d=s.getEndLineNumber(v.modifiedStart+v.modifiedLength-1)),l&&v.originalLength>0&&v.originalLength<20&&v.modifiedLength>0&&v.modifiedLength<20&&i()){const A=f.createCharSequence(C,v.originalStart,v.originalStart+v.originalLength-1),R=s.createCharSequence(C,v.modifiedStart,v.modifiedStart+v.modifiedLength-1);let S=a(A,R,i,!0).changes;_&&(S=c(S)),b=[];for(let V=0,q=S.length;V<q;V++)b.push(o.createFromDiffChange(S[V],A,R))}return new N(p,g,u,d,b)}}class M{constructor(C,v,f){this.shouldComputeCharChanges=f.shouldComputeCharChanges,this.shouldPostProcessCharChanges=f.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=f.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=f.shouldMakePrettyDiff,this.originalLines=C,this.modifiedLines=v,this.original=new y(C),this.modified=new y(v),this.continueLineDiff=e(f.maxComputationTime),this.continueCharDiff=e(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const C=a(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),v=C.changes,f=C.quitEarly;if(this.shouldIgnoreTrimWhitespace){const _=[];for(let p=0,g=v.length;p<g;p++)_.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,v[p],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:f,changes:_}}const s=[];let i=0,l=0;for(let _=-1,p=v.length;_<p;_++){const g=_+1<p?v[_+1]:null,u=g?g.originalStart:this.originalLines.length,d=g?g.modifiedStart:this.modifiedLines.length;for(;i<u&&l<d;){const b=this.originalLines[i],A=this.modifiedLines[l];if(b!==A){{let R=w(b,1),S=w(A,1);for(;R>1&&S>1;){const V=b.charCodeAt(R-2),q=A.charCodeAt(S-2);if(V!==q)break;R--,S--}(R>1||S>1)&&this._pushTrimWhitespaceCharChange(s,i+1,1,R,l+1,1,S)}{let R=m(b,1),S=m(A,1);const V=b.length+1,q=A.length+1;for(;R<V&&S<q;){const j=b.charCodeAt(R-1),Z=b.charCodeAt(S-1);if(j!==Z)break;R++,S++}(R<V||S<q)&&this._pushTrimWhitespaceCharChange(s,i+1,R,V,l+1,S,q)}}i++,l++}g&&(s.push(N.createFromDiffResult(this.shouldIgnoreTrimWhitespace,g,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=g.originalLength,l+=g.modifiedLength)}return{quitEarly:f,changes:s}}_pushTrimWhitespaceCharChange(C,v,f,s,i,l,_){if(this._mergeTrimWhitespaceCharChange(C,v,f,s,i,l,_))return;let p;this.shouldComputeCharChanges&&(p=[new o(v,f,v,s,i,l,i,_)]),C.push(new N(v,v,i,i,p))}_mergeTrimWhitespaceCharChange(C,v,f,s,i,l,_){const p=C.length;if(p===0)return!1;const g=C[p-1];return g.originalEndLineNumber===0||g.modifiedEndLineNumber===0?!1:g.originalEndLineNumber+1===v&&g.modifiedEndLineNumber+1===i?(g.originalEndLineNumber=v,g.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&g.charChanges&&g.charChanges.push(new o(v,f,v,s,i,l,i,_)),!0):!1}}n.DiffComputer=M;function w(L,C){const v=t.firstNonWhitespaceIndex(L);return v===-1?C:v+1}function m(L,C){const v=t.lastNonWhitespaceIndex(L);return v===-1?C:v+2}function e(L){if(L===0)return()=>!0;const C=Date.now();return()=>Date.now()-C<L}}),x(te[33],re([0,1,16]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class F{constructor(e,L,C){const v=new Uint8Array(e*L);for(let f=0,s=e*L;f<s;f++)v[f]=C;this._data=v,this.rows=e,this.cols=L}get(e,L){return this._data[e*this.cols+L]}set(e,L,C){this._data[e*this.cols+L]=C}}n.Uint8Matrix=F;class a{constructor(e){let L=0,C=0;for(let f=0,s=e.length;f<s;f++){const[i,l,_]=e[f];l>L&&(L=l),i>C&&(C=i),_>C&&(C=_)}L++,C++;const v=new F(C,L,0);for(let f=0,s=e.length;f<s;f++){const[i,l,_]=e[f];v.set(i,l,_)}this._states=v,this._maxCharCode=L}nextState(e,L){return L<0||L>=this._maxCharCode?0:this._states.get(e,L)}}n.StateMachine=a;let y=null;function h(){return y===null&&(y=new a([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var o;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let c=null;function N(){if(c===null){c=new P.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<m.length;L++)c.set(m.charCodeAt(L),1);const e=".,;";for(let L=0;L<e.length;L++)c.set(e.charCodeAt(L),2)}return c}class M{static _createLink(e,L,C,v,f){let s=f-1;do{const i=L.charCodeAt(s);if(e.get(i)!==2)break;s--}while(s>v);if(v>0){const i=L.charCodeAt(v-1),l=L.charCodeAt(s);(i===40&&l===41||i===91&&l===93||i===123&&l===125)&&s--}return{range:{startLineNumber:C,startColumn:v+1,endLineNumber:C,endColumn:s+2},url:L.substring(v,s+1)}}static computeLinks(e,L=h()){const C=N(),v=[];for(let f=1,s=e.getLineCount();f<=s;f++){const i=e.getLineContent(f),l=i.length;let _=0,p=0,g=0,u=1,d=!1,b=!1,A=!1,R=!1;for(;_<l;){let S=!1;const V=i.charCodeAt(_);if(u===13){let q;switch(V){case 40:d=!0,q=0;break;case 41:q=d?0:1;break;case 91:A=!0,b=!0,q=0;break;case 93:A=!1,q=b?0:1;break;case 123:R=!0,q=0;break;case 125:q=R?0:1;break;case 39:q=g===34||g===96?0:1;break;case 34:q=g===39||g===96?0:1;break;case 96:q=g===39||g===34?0:1;break;case 42:q=g===42?1:0;break;case 124:q=g===124?1:0;break;case 32:q=A?0:1;break;default:q=C.get(V)}q===1&&(v.push(M._createLink(C,i,f,p,_)),S=!0)}else if(u===12){let q;V===91?(b=!0,q=0):q=C.get(V),q===1?S=!0:u=13}else u=L.nextState(u,V),u===0&&(S=!0);S&&(u=1,d=!1,b=!1,R=!1,p=_+1,g=V),_++}u===13&&v.push(M._createLink(C,i,f,p,l))}return v}}n.LinkComputer=M;function w(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:M.computeLinks(m)}n.computeLinks=w}),x(te[34],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(F,a,y,h,o){if(F&&a){const c=this.doNavigateValueSet(a,o);if(c)return{range:F,value:c}}if(y&&h){const c=this.doNavigateValueSet(h,o);if(c)return{range:y,value:c}}return null}doNavigateValueSet(F,a){const y=this.numberReplace(F,a);return y!==null?y:this.textReplace(F,a)}numberReplace(F,a){const y=Math.pow(10,F.length-(F.lastIndexOf(".")+1));let h=Number(F),o=parseFloat(F);return!isNaN(h)&&!isNaN(o)&&h===o?h===0&&!a?null:(h=Math.floor(h*y),h+=a?y:-y,String(h/y)):null}textReplace(F,a){return this.valueSetsReplace(this._defaultValueSet,F,a)}valueSetsReplace(F,a,y){let h=null;for(let o=0,c=F.length;h===null&&o<c;o++)h=this.valueSetReplace(F[o],a,y);return h}valueSetReplace(F,a,y){let h=F.indexOf(a);return h>=0?(h+=y?1:-1,h<0?h=F.length-1:h%=F.length,F[h]):null}}n.BasicInplaceReplace=P,P.INSTANCE=new P}),x(te[35],re([0,1,29]),function(O,n,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var F;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(F=n.MinimapPosition||(n.MinimapPosition={}));var a;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(a=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var y;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(y=n.EndOfLinePreference||(n.EndOfLinePreference={}));var h;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var o;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(o=n.EndOfLineSequence||(n.EndOfLineSequence={}));class c{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}n.TextModelResolvedOptions=c;class N{constructor(s,i){this._findMatchBrand=void 0,this.range=s,this.matches=i}}n.FindMatch=N;var M;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(M=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var w;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None"})(w=n.PositionAffinity||(n.PositionAffinity={}));var m;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m=n.ModelConstants||(n.ModelConstants={}));class e{constructor(s,i,l,_,p,g){this.identifier=s,this.range=i,this.text=l,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=p,this._isTracked=g}}n.ValidAnnotatedEditOperation=e;class L{constructor(s,i,l){this.regex=s,this.wordSeparators=i,this.simpleSearch=l}}n.SearchData=L;class C{constructor(s,i,l){this.reverseEdits=s,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}n.ApplyEditsResult=C;function v(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}n.shouldSynchronizeModel=v}),x(te[36],re([0,1,20,15]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class F{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(o,c){o=(0,t.toUint32)(o);const N=this.values,M=this.prefixSum,w=c.length;return w===0?!1:(this.values=new Uint32Array(N.length+w),this.values.set(N.subarray(0,o),0),this.values.set(N.subarray(o),o+w),this.values.set(c,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,c){return o=(0,t.toUint32)(o),c=(0,t.toUint32)(c),this.values[o]===c?!1:(this.values[o]=c,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,c){o=(0,t.toUint32)(o),c=(0,t.toUint32)(c);const N=this.values,M=this.prefixSum;if(o>=N.length)return!1;const w=N.length-o;return c>=w&&(c=w),c===0?!1:(this.values=new Uint32Array(N.length-c),this.values.set(N.subarray(0,o),0),this.values.set(N.subarray(o+c),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,t.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let c=this.prefixSumValidIndex[0]+1;c===0&&(this.prefixSum[0]=this.values[0],c++),o>=this.values.length&&(o=this.values.length-1);for(let N=c;N<=o;N++)this.prefixSum[N]=this.prefixSum[N-1]+this.values[N];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let c=0,N=this.values.length-1,M=0,w=0,m=0;for(;c<=N;)if(M=c+(N-c)/2|0,w=this.prefixSum[M],m=w-this.values[M],o<m)N=M-1;else if(o>=w)c=M+1;else break;return new y(M,o-m)}}n.PrefixSumComputer=F;class a{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const c=this._indexBySum[o],N=c>0?this._prefixSum[c-1]:0;return new y(c,o-N)}removeValues(o,c){this._values.splice(o,c),this._invalidate(o)}insertValues(o,c){this._values=(0,P.arrayInsert)(this._values,o,c),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,c=this._values.length;o<c;o++){const N=this._values[o],M=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=M+N;for(let w=0;w<N;w++)this._indexBySum[M+w]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,c){this._values[o]!==c&&(this._values[o]=c,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=a;class y{constructor(o,c){this.index=o,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=c}}n.PrefixSumIndexOfResult=y}),x(te[37],re([0,1,2,3,36]),function(O,n,P,t,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class a{constructor(h,o,c,N){this._uri=h,this._lines=o,this._eol=c,this._versionId=N,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const o=h.changes;for(const c of o)this._acceptDeleteRange(c.range),this._acceptInsertText(new t.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,o=this._lines.length,c=new Uint32Array(o);for(let N=0;N<o;N++)c[N]=this._lines[N].length+h;this._lineStarts=new F.PrefixSumComputer(c)}}_setLineText(h,o){this._lines[h]=o,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,o){if(o.length===0)return;const c=(0,P.splitLines)(o);if(c.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+c[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}c[c.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+c[0]);const N=new Uint32Array(c.length-1);for(let M=1;M<c.length;M++)this._lines.splice(h.lineNumber+M-1,0,c[M]),N[M-1]=c[M].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,N)}}n.MirrorTextModel=a}),x(te[38],re([0,1,2,31,3,4,35]),function(O,n,P,t,F,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const h=999;class o{constructor(f,s,i,l){this.searchString=f,this.isRegex=s,this.matchCase=i,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=c(this.searchString):f=this.searchString.indexOf(`
`)>=0;let s=null;try{s=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!f;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new y.SearchData(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}}n.SearchParams=o;function c(v){if(!v||v.length===0)return!1;for(let f=0,s=v.length;f<s;f++)if(v.charCodeAt(f)===92){if(f++,f>=s)break;const l=v.charCodeAt(f);if(l===110||l===114||l===87)return!0}return!1}n.isMultilineRegexSource=c;function N(v,f,s){if(!s)return new y.FindMatch(v,null);const i=[];for(let l=0,_=f.length;l<_;l++)i[l]=f[l];return new y.FindMatch(v,i)}n.createFindMatch=N;class M{constructor(f){const s=[];let i=0;for(let l=0,_=f.length;l<_;l++)f.charCodeAt(l)===10&&(s[i++]=l);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(f){const s=this._lineFeedsOffsets;let i=0,l=s.length-1;if(l===-1||f<=s[0])return 0;for(;i<l;){const _=i+((l-i)/2>>0);s[_]>=f?l=_-1:s[_+1]>=f?(i=_,l=_):i=_+1}return i+1}}class w{static findMatches(f,s,i,l,_){const p=s.parseSearchRequest();return p?p.regex.multiline?this._doFindMatchesMultiline(f,i,new C(p.wordSeparators,p.regex),l,_):this._doFindMatchesLineByLine(f,i,p,l,_):[]}static _getMultilineMatchRange(f,s,i,l,_,p){let g,u=0;l?(u=l.findLineFeedCountBeforeOffset(_),g=s+_+u):g=s+_;let d;if(l){const S=l.findLineFeedCountBeforeOffset(_+p.length)-u;d=g+p.length+S}else d=g+p.length;const b=f.getPositionAt(g),A=f.getPositionAt(d);return new a.Range(b.lineNumber,b.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(f,s,i,l,_){const p=f.getOffsetAt(s.getStartPosition()),g=f.getValueInRange(s,1),u=f.getEOL()===`\r
`?new M(g):null,d=[];let b=0,A;for(i.reset(0);A=i.next(g);)if(d[b++]=N(this._getMultilineMatchRange(f,p,g,u,A.index,A[0]),A,l),b>=_)return d;return d}static _doFindMatchesLineByLine(f,s,i,l,_){const p=[];let g=0;if(s.startLineNumber===s.endLineNumber){const d=f.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return g=this._findMatchesInLine(i,d,s.startLineNumber,s.startColumn-1,g,p,l,_),p}const u=f.getLineContent(s.startLineNumber).substring(s.startColumn-1);g=this._findMatchesInLine(i,u,s.startLineNumber,s.startColumn-1,g,p,l,_);for(let d=s.startLineNumber+1;d<s.endLineNumber&&g<_;d++)g=this._findMatchesInLine(i,f.getLineContent(d),d,0,g,p,l,_);if(g<_){const d=f.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);g=this._findMatchesInLine(i,d,s.endLineNumber,0,g,p,l,_)}return p}static _findMatchesInLine(f,s,i,l,_,p,g,u){const d=f.wordSeparators;if(!g&&f.simpleSearch){const R=f.simpleSearch,S=R.length,V=s.length;let q=-S;for(;(q=s.indexOf(R,q+S))!==-1;)if((!d||L(d,s,V,q,S))&&(p[_++]=new y.FindMatch(new a.Range(i,q+1+l,i,q+1+S+l),null),_>=u))return _;return _}const b=new C(f.wordSeparators,f.regex);let A;b.reset(0);do if(A=b.next(s),A&&(p[_++]=N(new a.Range(i,A.index+1+l,i,A.index+1+A[0].length+l),A,g),_>=u))return _;while(A);return _}static findNextMatch(f,s,i,l){const _=s.parseSearchRequest();if(!_)return null;const p=new C(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindNextMatchMultiline(f,i,p,l):this._doFindNextMatchLineByLine(f,i,p,l)}static _doFindNextMatchMultiline(f,s,i,l){const _=new F.Position(s.lineNumber,1),p=f.getOffsetAt(_),g=f.getLineCount(),u=f.getValueInRange(new a.Range(_.lineNumber,_.column,g,f.getLineMaxColumn(g)),1),d=f.getEOL()===`\r
`?new M(u):null;i.reset(s.column-1);let b=i.next(u);return b?N(this._getMultilineMatchRange(f,p,u,d,b.index,b[0]),b,l):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(f,new F.Position(1,1),i,l):null}static _doFindNextMatchLineByLine(f,s,i,l){const _=f.getLineCount(),p=s.lineNumber,g=f.getLineContent(p),u=this._findFirstMatchInLine(i,g,p,s.column,l);if(u)return u;for(let d=1;d<=_;d++){const b=(p+d-1)%_,A=f.getLineContent(b+1),R=this._findFirstMatchInLine(i,A,b+1,1,l);if(R)return R}return null}static _findFirstMatchInLine(f,s,i,l,_){f.reset(l-1);const p=f.next(s);return p?N(new a.Range(i,p.index+1,i,p.index+1+p[0].length),p,_):null}static findPreviousMatch(f,s,i,l){const _=s.parseSearchRequest();if(!_)return null;const p=new C(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindPreviousMatchMultiline(f,i,p,l):this._doFindPreviousMatchLineByLine(f,i,p,l)}static _doFindPreviousMatchMultiline(f,s,i,l){const _=this._doFindMatchesMultiline(f,new a.Range(1,1,s.lineNumber,s.column),i,l,10*h);if(_.length>0)return _[_.length-1];const p=f.getLineCount();return s.lineNumber!==p||s.column!==f.getLineMaxColumn(p)?this._doFindPreviousMatchMultiline(f,new F.Position(p,f.getLineMaxColumn(p)),i,l):null}static _doFindPreviousMatchLineByLine(f,s,i,l){const _=f.getLineCount(),p=s.lineNumber,g=f.getLineContent(p).substring(0,s.column-1),u=this._findLastMatchInLine(i,g,p,l);if(u)return u;for(let d=1;d<=_;d++){const b=(_+p-d-1)%_,A=f.getLineContent(b+1),R=this._findLastMatchInLine(i,A,b+1,l);if(R)return R}return null}static _findLastMatchInLine(f,s,i,l){let _=null,p;for(f.reset(0);p=f.next(s);)_=N(new a.Range(i,p.index+1,i,p.index+1+p[0].length),p,l);return _}}n.TextModelSearch=w;function m(v,f,s,i,l){if(i===0)return!0;const _=f.charCodeAt(i-1);if(v.get(_)!==0||_===13||_===10)return!0;if(l>0){const p=f.charCodeAt(i);if(v.get(p)!==0)return!0}return!1}function e(v,f,s,i,l){if(i+l===s)return!0;const _=f.charCodeAt(i+l);if(v.get(_)!==0||_===13||_===10)return!0;if(l>0){const p=f.charCodeAt(i+l-1);if(v.get(p)!==0)return!0}return!1}function L(v,f,s,i,l){return m(v,f,s,i,l)&&e(v,f,s,i,l)}n.isValidMatch=L;class C{constructor(f,s){this._wordSeparators=f,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(f){this._searchRegex.lastIndex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(f){const s=f.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(i=this._searchRegex.exec(f),!i))return null;const l=i.index,_=i[0].length;if(l===this._prevMatchStartIndex&&_===this._prevMatchLength){if(_===0){P.getNextCodePoint(f,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=_,!this._wordSeparators||L(this._wordSeparators,f,s,l,_))return i}while(i);return null}}n.Searcher=C}),x(te[39],re([0,1,4,38,2,7,17]),function(O,n,P,t,F,a,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,L,C){const v=C?C.startLineNumber:1,f=C?C.endLineNumber:e.getLineCount(),s=new N(L),i=s.getCandidateCodePoints();let l;i==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${o(Array.from(i))}`,"g");const _=new t.Searcher(null,l),p=[];let g=!1,u,d=0,b=0,A=0;e:for(let R=v,S=f;R<=S;R++){const V=e.getLineContent(R),q=V.length;_.reset(0);do if(u=_.next(V),u){let j=u.index,Z=u.index+u[0].length;if(j>0){const z=V.charCodeAt(j-1);F.isHighSurrogate(z)&&j--}if(Z+1<q){const z=V.charCodeAt(Z-1);F.isHighSurrogate(z)&&Z++}const E=V.substring(j,Z),W=(0,y.getWordAtText)(j+1,y.DEFAULT_WORD_REGEXP,V,0),J=s.shouldHighlightNonBasicASCII(E,W?W.word:null);if(J!==0){J===3?d++:J===2?b++:J===1?A++:(0,a.assertNever)(J);const z=1e3;if(p.length>=z){g=!0;break e}p.push(new P.Range(R,j+1,R,Z+1))}}while(u)}return{ranges:p,hasMore:g,ambiguousCharacterCount:d,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:A}}static computeUnicodeHighlightReason(e,L){const C=new N(L);switch(C.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const f=e.codePointAt(0),s=C.ambiguousCharacters.getPrimaryConfusable(f),i=F.AmbiguousCharacters.getLocales().filter(l=>!F.AmbiguousCharacters.getInstance(new Set([...L.allowedLocales,l])).isAmbiguous(f));return{kind:0,confusableWith:String.fromCodePoint(s),notAmbiguousInLocales:i}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=h;function o(m,e){return`[${F.escapeRegExpCharacters(m.map(C=>String.fromCodePoint(C)).join(""))}]`}var c;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(c=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class N{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=F.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const L of F.InvisibleCharacters.codePoints)M(String.fromCodePoint(L))||e.add(L);if(this.options.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.allowedCodePoints)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const C=e.codePointAt(0);if(this.allowedCodePoints.has(C))return 0;if(this.options.nonBasicASCII)return 1;let v=!1,f=!1;if(L)for(let s of L){const i=s.codePointAt(0),l=F.isBasicASCII(s);v=v||l,!l&&!this.ambiguousCharacters.isAmbiguous(i)&&!F.InvisibleCharacters.isInvisibleCharacter(i)&&(f=!0)}return!v&&f?0:this.options.invisibleCharacters&&!M(e)&&F.InvisibleCharacters.isInvisibleCharacter(C)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(C)?3:0}}function M(m){return m===" "||m===`
`||m==="	"}var w;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(w||(w={}))}),x(te[40],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var P;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(P=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(t=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var F;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(F=n.CompletionItemKind||(n.CompletionItemKind={}));var a;(function(r){r[r.Deprecated=1]="Deprecated"})(a=n.CompletionItemTag||(n.CompletionItemTag={}));var y;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var h;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(h=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var o;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(o=n.CursorChangeReason||(n.CursorChangeReason={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var N;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(N=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var M;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(M=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var w;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.emptySelectionClipboard=32]="emptySelectionClipboard",r[r.extraEditorClassName=33]="extraEditorClassName",r[r.fastScrollSensitivity=34]="fastScrollSensitivity",r[r.find=35]="find",r[r.fixedOverflowWidgets=36]="fixedOverflowWidgets",r[r.folding=37]="folding",r[r.foldingStrategy=38]="foldingStrategy",r[r.foldingHighlight=39]="foldingHighlight",r[r.foldingImportsByDefault=40]="foldingImportsByDefault",r[r.foldingMaximumRegions=41]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=43]="fontFamily",r[r.fontInfo=44]="fontInfo",r[r.fontLigatures=45]="fontLigatures",r[r.fontSize=46]="fontSize",r[r.fontWeight=47]="fontWeight",r[r.formatOnPaste=48]="formatOnPaste",r[r.formatOnType=49]="formatOnType",r[r.glyphMargin=50]="glyphMargin",r[r.gotoLocation=51]="gotoLocation",r[r.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",r[r.hover=53]="hover",r[r.inDiffEditor=54]="inDiffEditor",r[r.inlineSuggest=55]="inlineSuggest",r[r.letterSpacing=56]="letterSpacing",r[r.lightbulb=57]="lightbulb",r[r.lineDecorationsWidth=58]="lineDecorationsWidth",r[r.lineHeight=59]="lineHeight",r[r.lineNumbers=60]="lineNumbers",r[r.lineNumbersMinChars=61]="lineNumbersMinChars",r[r.linkedEditing=62]="linkedEditing",r[r.links=63]="links",r[r.matchBrackets=64]="matchBrackets",r[r.minimap=65]="minimap",r[r.mouseStyle=66]="mouseStyle",r[r.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=68]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",r[r.multiCursorModifier=70]="multiCursorModifier",r[r.multiCursorPaste=71]="multiCursorPaste",r[r.occurrencesHighlight=72]="occurrencesHighlight",r[r.overviewRulerBorder=73]="overviewRulerBorder",r[r.overviewRulerLanes=74]="overviewRulerLanes",r[r.padding=75]="padding",r[r.parameterHints=76]="parameterHints",r[r.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",r[r.quickSuggestions=79]="quickSuggestions",r[r.quickSuggestionsDelay=80]="quickSuggestionsDelay",r[r.readOnly=81]="readOnly",r[r.renameOnType=82]="renameOnType",r[r.renderControlCharacters=83]="renderControlCharacters",r[r.renderFinalNewline=84]="renderFinalNewline",r[r.renderLineHighlight=85]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=87]="renderValidationDecorations",r[r.renderWhitespace=88]="renderWhitespace",r[r.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",r[r.roundedSelection=90]="roundedSelection",r[r.rulers=91]="rulers",r[r.scrollbar=92]="scrollbar",r[r.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=94]="scrollBeyondLastLine",r[r.scrollPredominantAxis=95]="scrollPredominantAxis",r[r.selectionClipboard=96]="selectionClipboard",r[r.selectionHighlight=97]="selectionHighlight",r[r.selectOnLineNumbers=98]="selectOnLineNumbers",r[r.showFoldingControls=99]="showFoldingControls",r[r.showUnused=100]="showUnused",r[r.snippetSuggestions=101]="snippetSuggestions",r[r.smartSelect=102]="smartSelect",r[r.smoothScrolling=103]="smoothScrolling",r[r.stickyTabStops=104]="stickyTabStops",r[r.stopRenderingLineAfter=105]="stopRenderingLineAfter",r[r.suggest=106]="suggest",r[r.suggestFontSize=107]="suggestFontSize",r[r.suggestLineHeight=108]="suggestLineHeight",r[r.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",r[r.suggestSelection=110]="suggestSelection",r[r.tabCompletion=111]="tabCompletion",r[r.tabIndex=112]="tabIndex",r[r.unicodeHighlighting=113]="unicodeHighlighting",r[r.unusualLineTerminators=114]="unusualLineTerminators",r[r.useShadowDOM=115]="useShadowDOM",r[r.useTabStops=116]="useTabStops",r[r.wordSeparators=117]="wordSeparators",r[r.wordWrap=118]="wordWrap",r[r.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=121]="wordWrapColumn",r[r.wordWrapOverride1=122]="wordWrapOverride1",r[r.wordWrapOverride2=123]="wordWrapOverride2",r[r.wrappingIndent=124]="wrappingIndent",r[r.wrappingStrategy=125]="wrappingStrategy",r[r.showDeprecated=126]="showDeprecated",r[r.inlayHints=127]="inlayHints",r[r.editorClassName=128]="editorClassName",r[r.pixelRatio=129]="pixelRatio",r[r.tabFocusMode=130]="tabFocusMode",r[r.layoutInfo=131]="layoutInfo",r[r.wrappingInfo=132]="wrappingInfo"})(w=n.EditorOption||(n.EditorOption={}));var m;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(m=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var L;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(L=n.IndentAction||(n.IndentAction={}));var C;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(C=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var v;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(v=n.InlayHintKind||(n.InlayHintKind={}));var f;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(f=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(s=n.KeyCode||(n.KeyCode={}));var i;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=n.MarkerTag||(n.MarkerTag={}));var _;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(_=n.MinimapPosition||(n.MinimapPosition={}));var p;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(p=n.MouseTargetType||(n.MouseTargetType={}));var g;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(g=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var u;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(u=n.OverviewRulerLane||(n.OverviewRulerLane={}));var d;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None"})(d=n.PositionAffinity||(n.PositionAffinity={}));var b;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(b=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var A;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(A=n.RenderMinimap||(n.RenderMinimap={}));var R;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(R=n.ScrollType||(n.ScrollType={}));var S;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(S=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var V;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(V=n.SelectionDirection||(n.SelectionDirection={}));var q;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(q=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var j;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(j=n.SymbolKind||(n.SymbolKind={}));var Z;(function(r){r[r.Deprecated=1]="Deprecated"})(Z=n.SymbolTag||(n.SymbolTag={}));var E;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(E=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var W;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(W=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var J;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(J=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var z;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(z=n.WrappingIndent||(n.WrappingIndent={}))}),x(te[41],re([0,1,6,9]),function(O,n,P,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class F{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,o){return this._map.set(h,o),this.fire([h]),(0,t.toDisposable)(()=>{this._map.get(h)===o&&(this._map.delete(h),this.fire([h]))})}registerFactory(h,o){this._factories.get(h)?.dispose();const c=new a(this,h,o);return this._factories.set(h,c),(0,t.toDisposable)(()=>{const N=this._factories.get(h);!N||N!==c||(this._factories.delete(h),N.dispose())})}async getOrCreate(h){const o=this.get(h);if(o)return o;const c=this._factories.get(h);return!c||c.isResolved?null:(await c.resolve(),this.get(h))}get(h){return this._map.get(h)||null}isResolved(h){if(this.get(h))return!0;const c=this._factories.get(h);return!!(!c||c.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=F;class a extends t.Disposable{constructor(h,o,c){super();this._registry=h,this._languageId=o,this._factory=c,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),x(te[42],re([0,1,10,4,41,18]),function(O,n,P,t,F,a){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=n.TokenMetadata=n.MetadataConsts=n.StandardTokenType=n.ColorId=n.FontStyle=n.LanguageId=void 0;var y;(function(E){E[E.Null=0]="Null",E[E.PlainText=1]="PlainText"})(y=n.LanguageId||(n.LanguageId={}));var h;(function(E){E[E.NotSet=-1]="NotSet",E[E.None=0]="None",E[E.Italic=1]="Italic",E[E.Bold=2]="Bold",E[E.Underline=4]="Underline",E[E.Strikethrough=8]="Strikethrough"})(h=n.FontStyle||(n.FontStyle={}));var o;(function(E){E[E.None=0]="None",E[E.DefaultForeground=1]="DefaultForeground",E[E.DefaultBackground=2]="DefaultBackground"})(o=n.ColorId||(n.ColorId={}));var c;(function(E){E[E.Other=0]="Other",E[E.Comment=1]="Comment",E[E.String=2]="String",E[E.RegEx=3]="RegEx"})(c=n.StandardTokenType||(n.StandardTokenType={}));var N;(function(E){E[E.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",E[E.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",E[E.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",E[E.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",E[E.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",E[E.ITALIC_MASK=1024]="ITALIC_MASK",E[E.BOLD_MASK=2048]="BOLD_MASK",E[E.UNDERLINE_MASK=4096]="UNDERLINE_MASK",E[E.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",E[E.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",E[E.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",E[E.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",E[E.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",E[E.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",E[E.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",E[E.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",E[E.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",E[E.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",E[E.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",E[E.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(N=n.MetadataConsts||(n.MetadataConsts={}));class M{static getLanguageId(W){return(W&255)>>>0}static getTokenType(W){return(W&768)>>>8}static getFontStyle(W){return(W&15360)>>>10}static getForeground(W){return(W&8372224)>>>14}static getBackground(W){return(W&4286578688)>>>23}static getClassNameFromMetadata(W){const J=this.getForeground(W);let z="mtk"+J;const r=this.getFontStyle(W);return r&1&&(z+=" mtki"),r&2&&(z+=" mtkb"),r&4&&(z+=" mtku"),r&8&&(z+=" mtks"),z}static getInlineStyleFromMetadata(W,J){const z=this.getForeground(W),r=this.getFontStyle(W);let oe=`color: ${J[z]};`;r&1&&(oe+="font-style: italic;"),r&2&&(oe+="font-weight: bold;");let de="";return r&4&&(de+=" underline"),r&8&&(de+=" line-through"),de&&(oe+=`text-decoration:${de};`),oe}static getPresentationFromMetadata(W){const J=this.getForeground(W),z=this.getFontStyle(W);return{foreground:J,italic:Boolean(z&1),bold:Boolean(z&2),underline:Boolean(z&4),strikethrough:Boolean(z&8)}}}n.TokenMetadata=M;class w{constructor(W,J,z){this._tokenBrand=void 0,this.offset=W,this.type=J,this.language=z}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=w;class m{constructor(W,J){this._tokenizationResultBrand=void 0,this.tokens=W,this.endState=J}}n.TokenizationResult=m;class e{constructor(W,J){this._encodedTokenizationResultBrand=void 0,this.tokens=W,this.endState=J}}n.EncodedTokenizationResult=e;var L;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(L=n.CompletionItemKind||(n.CompletionItemKind={}));var C;(function(E){const W=new Map;W.set(0,a.Codicon.symbolMethod),W.set(1,a.Codicon.symbolFunction),W.set(2,a.Codicon.symbolConstructor),W.set(3,a.Codicon.symbolField),W.set(4,a.Codicon.symbolVariable),W.set(5,a.Codicon.symbolClass),W.set(6,a.Codicon.symbolStruct),W.set(7,a.Codicon.symbolInterface),W.set(8,a.Codicon.symbolModule),W.set(9,a.Codicon.symbolProperty),W.set(10,a.Codicon.symbolEvent),W.set(11,a.Codicon.symbolOperator),W.set(12,a.Codicon.symbolUnit),W.set(13,a.Codicon.symbolValue),W.set(15,a.Codicon.symbolEnum),W.set(14,a.Codicon.symbolConstant),W.set(15,a.Codicon.symbolEnum),W.set(16,a.Codicon.symbolEnumMember),W.set(17,a.Codicon.symbolKeyword),W.set(27,a.Codicon.symbolSnippet),W.set(18,a.Codicon.symbolText),W.set(19,a.Codicon.symbolColor),W.set(20,a.Codicon.symbolFile),W.set(21,a.Codicon.symbolReference),W.set(22,a.Codicon.symbolCustomColor),W.set(23,a.Codicon.symbolFolder),W.set(24,a.Codicon.symbolTypeParameter),W.set(25,a.Codicon.account),W.set(26,a.Codicon.issues);function J(oe){let de=W.get(oe);return de||(console.info("No codicon found for CompletionItemKind "+oe),de=a.Codicon.symbolProperty),de}E.toIcon=J;const z=new Map;z.set("method",0),z.set("function",1),z.set("constructor",2),z.set("field",3),z.set("variable",4),z.set("class",5),z.set("struct",6),z.set("interface",7),z.set("module",8),z.set("property",9),z.set("event",10),z.set("operator",11),z.set("unit",12),z.set("value",13),z.set("constant",14),z.set("enum",15),z.set("enum-member",16),z.set("enumMember",16),z.set("keyword",17),z.set("snippet",27),z.set("text",18),z.set("color",19),z.set("file",20),z.set("reference",21),z.set("customcolor",22),z.set("folder",23),z.set("type-parameter",24),z.set("typeParameter",24),z.set("account",25),z.set("issue",26);function r(oe,de){let me=z.get(oe);return typeof me=="undefined"&&!de&&(me=9),me}E.fromString=r})(C=n.CompletionItemKinds||(n.CompletionItemKinds={}));var v;(function(E){E[E.Deprecated=1]="Deprecated"})(v=n.CompletionItemTag||(n.CompletionItemTag={}));var f;(function(E){E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(f=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var s;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(s=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var i;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(i=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var l;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(l=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var _;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(_=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var p;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(p=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function g(E){return E&&P.URI.isUri(E.uri)&&t.Range.isIRange(E.range)&&(t.Range.isIRange(E.originSelectionRange)||t.Range.isIRange(E.targetSelectionRange))}n.isLocationLink=g;var u;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(u=n.SymbolKind||(n.SymbolKind={}));var d;(function(E){E[E.Deprecated=1]="Deprecated"})(d=n.SymbolTag||(n.SymbolTag={}));var b;(function(E){const W=new Map;W.set(0,a.Codicon.symbolFile),W.set(1,a.Codicon.symbolModule),W.set(2,a.Codicon.symbolNamespace),W.set(3,a.Codicon.symbolPackage),W.set(4,a.Codicon.symbolClass),W.set(5,a.Codicon.symbolMethod),W.set(6,a.Codicon.symbolProperty),W.set(7,a.Codicon.symbolField),W.set(8,a.Codicon.symbolConstructor),W.set(9,a.Codicon.symbolEnum),W.set(10,a.Codicon.symbolInterface),W.set(11,a.Codicon.symbolFunction),W.set(12,a.Codicon.symbolVariable),W.set(13,a.Codicon.symbolConstant),W.set(14,a.Codicon.symbolString),W.set(15,a.Codicon.symbolNumber),W.set(16,a.Codicon.symbolBoolean),W.set(17,a.Codicon.symbolArray),W.set(18,a.Codicon.symbolObject),W.set(19,a.Codicon.symbolKey),W.set(20,a.Codicon.symbolNull),W.set(21,a.Codicon.symbolEnumMember),W.set(22,a.Codicon.symbolStruct),W.set(23,a.Codicon.symbolEvent),W.set(24,a.Codicon.symbolOperator),W.set(25,a.Codicon.symbolTypeParameter);function J(z){let r=W.get(z);return r||(console.info("No codicon found for SymbolKind "+z),r=a.Codicon.symbolProperty),r}E.toIcon=J})(b=n.SymbolKinds||(n.SymbolKinds={}));class A{constructor(W){this.value=W}}n.FoldingRangeKind=A,A.Comment=new A("comment"),A.Imports=new A("imports"),A.Region=new A("region");var R;(function(E){function W(J){return!J||typeof J!="object"?!1:typeof J.id=="string"&&typeof J.title=="string"}E.is=W})(R=n.Command||(n.Command={}));var S;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(S=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var V;(function(E){E[E.Unresolved=0]="Unresolved",E[E.Resolved=1]="Resolved"})(V=n.CommentThreadState||(n.CommentThreadState={}));var q;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(q=n.CommentMode||(n.CommentMode={}));var j;(function(E){E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(j=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new F.TokenizationRegistry;var Z;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(Z=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),x(te[43],re([0,1,13,6,22,10,3,4,30,42,40]),function(O,n,P,t,F,a,y,h,o,c,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class M{static chord(e,L){return(0,F.KeyChord)(e,L)}}n.KeyMod=M,M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:t.Emitter,KeyCode:N.KeyCode,KeyMod:M,Position:y.Position,Range:h.Range,Selection:o.Selection,SelectionDirection:N.SelectionDirection,MarkerSeverity:N.MarkerSeverity,MarkerTag:N.MarkerTag,Uri:a.URI,Token:c.Token}}n.createMonacoBaseAPI=w}),x(te[45],re([0,1,14,5,10,3,4,32,37,17,33,34,43,7,12,39]),function(O,n,P,t,F,a,y,h,o,c,N,M,w,m,e,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class C extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,l){const _=(0,c.getWordAtText)(i.column,(0,c.ensureValidWordDefinition)(l),this._lines[i.lineNumber-1],0);return _?new y.Range(i.lineNumber,_.startColumn,i.lineNumber,_.endColumn):null}getWordUntilPosition(i,l){const _=this.getWordAtPosition(i,l);return _?{word:this._lines[i.lineNumber-1].substring(_.startColumn-1,i.column-1),startColumn:_.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this._lines,_=this._wordenize.bind(this);let p=0,g="",u=0,d=[];return{*[Symbol.iterator](){for(;;)if(u<d.length){const b=g.substring(d[u].start,d[u].end);u+=1,yield b}else if(p<l.length)g=l[p],d=_(g,i),u=0,p+=1;else break}}}getLineWords(i,l){const _=this._lines[i-1],p=this._wordenize(_,l),g=[];for(const u of p)g.push({word:_.substring(u.start,u.end),startColumn:u.start+1,endColumn:u.end+1});return g}_wordenize(i,l){const _=[];let p;for(l.lastIndex=0;(p=l.exec(i))&&p[0].length!==0;)_.push({start:p.index,end:p.index+p[0].length});return _}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this._eol,_=i.startLineNumber-1,p=i.endLineNumber-1,g=[];g.push(this._lines[_].substring(i.startColumn-1));for(let u=_+1;u<p;u++)g.push(this._lines[u]);return g.push(this._lines[p].substring(0,i.endColumn-1)),g.join(l)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(i),_=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,_)}}_validateRange(i){const l=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),_=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||_.lineNumber!==i.endLineNumber||_.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:_.lineNumber,endColumn:_.column}:i}_validatePosition(i){if(!a.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:_}=i,p=!1;if(l<1)l=1,_=1,p=!0;else if(l>this._lines.length)l=this._lines.length,_=this._lines[l-1].length+1,p=!0;else{const g=this._lines[l-1].length+1;_<1?(_=1,p=!0):_>g&&(_=g,p=!0)}return p?{lineNumber:l,column:_}:i}}n.MirrorModel=C;class v{constructor(i,l){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(l=>i.push(this._models[l])),i}acceptNewModel(i){this._models[i.url]=new C(F.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this._models[i])return;this._models[i].onEvents(l)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeUnicodeHighlights(i,l,_){const p=this._getModel(i);return p?L.UnicodeTextModelHighlighter.computeUnicodeHighlights(p,l,_):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,_,p){const g=this._getModel(i),u=this._getModel(l);if(!g||!u)return null;const d=g.getLinesContent(),b=u.getLinesContent(),R=new h.DiffComputer(d,b,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:_,shouldMakePrettyDiff:!0,maxComputationTime:p}).computeDiff(),S=R.changes.length>0?!1:this._modelsAreIdentical(g,u);return{quitEarly:R.quitEarly,identical:S,changes:R.changes}}_modelsAreIdentical(i,l){const _=i.getLineCount(),p=l.getLineCount();if(_!==p)return!1;for(let g=1;g<=_;g++){const u=i.getLineContent(g),d=l.getLineContent(g);if(u!==d)return!1}return!0}async computeDirtyDiff(i,l,_){const p=this._getModel(i),g=this._getModel(l);if(!p||!g)return null;const u=p.getLinesContent(),d=g.getLinesContent();return new h.DiffComputer(u,d,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:_,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,l){const _=this._getModel(i);if(!_)return l;const p=[];let g;l=l.slice(0).sort((u,d)=>{if(u.range&&d.range)return y.Range.compareRangesUsingStarts(u.range,d.range);const b=u.range?0:1,A=d.range?0:1;return b-A});for(let{range:u,text:d,eol:b}of l){if(typeof b=="number"&&(g=b),y.Range.isEmpty(u)&&!d)continue;const A=_.getValueInRange(u);if(d=d.replace(/\r\n|\n|\r/g,_.eol),A===d)continue;if(Math.max(d.length,A.length)>v._diffLimit){p.push({range:u,text:d});continue}const R=(0,P.stringDiff)(A,d,!1),S=_.offsetAt(y.Range.lift(u).getStartPosition());for(const V of R){const q=_.positionAt(S+V.originalStart),j=_.positionAt(S+V.originalStart+V.originalLength),Z={text:d.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:j.lineNumber,endColumn:j.column}};_.getValueInRange(Z.range)!==Z.text&&p.push(Z)}}return typeof g=="number"&&p.push({eol:g,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),p}async computeLinks(i){const l=this._getModel(i);return l?(0,N.computeLinks)(l):null}async textualSuggest(i,l,_,p){const g=new e.StopWatch(!0),u=new RegExp(_,p),d=new Set;e:for(let b of i){const A=this._getModel(b);if(!!A){for(let R of A.words(u))if(!(R===l||!isNaN(Number(R)))&&(d.add(R),d.size>v._suggestionsLimit))break e}}return{words:Array.from(d),duration:g.elapsed()}}async computeWordRanges(i,l,_,p){const g=this._getModel(i);if(!g)return Object.create(null);const u=new RegExp(_,p),d=Object.create(null);for(let b=l.startLineNumber;b<l.endLineNumber;b++){const A=g.getLineWords(b,u);for(const R of A){if(!isNaN(Number(R.word)))continue;let S=d[R.word];S||(S=[],d[R.word]=S),S.push({startLineNumber:b,startColumn:R.startColumn,endLineNumber:b,endColumn:R.endColumn})}}return d}async navigateValueSet(i,l,_,p,g){const u=this._getModel(i);if(!u)return null;const d=new RegExp(p,g);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const b=u.getValueInRange(l),A=u.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},d);if(!A)return null;const R=u.getValueInRange(A);return M.BasicInplaceReplace.INSTANCE.navigateValueSet(l,b,A,R,_)}loadForeignModule(i,l,_){const p=(d,b)=>this._host.fhr(d,b),u={host:m.createProxyObject(_,p),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(u,l),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((d,b)=>{O([i],A=>{this._foreignModule=A.create(u,l),d(m.getAllMethodNames(this._foreignModule))},b)})}fmr(i,l){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,l))}catch(_){return Promise.reject(_)}}}n.EditorSimpleWorker=v,v._diffLimit=1e5,v._suggestionsLimit=1e4;function f(s){return new v(s,null)}n.create=f,typeof importScripts=="function"&&(t.globals.monaco=(0,w.createMonacoBaseAPI)())}),function(){const O=self.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:o=>o,createScript:(o,...c)=>{const N=c.slice(0,-1).join(","),M=c.pop().toString();return`(function anonymous(${N}) {
${M}
})`}}):void 0;function t(){try{return(P?self.eval(P.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function F(){return new Promise((o,c)=>{if(typeof self.define=="function"&&self.define.amd)return o();const N=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(N)&&N.substring(0,self.origin.length)!==self.origin)&&t()){fetch(N).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${N}`,(P?self.eval(P.createScript("",w)):new Function(w)).call(self),o()}).then(void 0,c);return}P?importScripts(P.createScriptURL(N)):importScripts(N),o()})}const a=function(o){F().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//}),require([o],function(c){setTimeout(function(){let N=c.create((M,w)=>{self.postMessage(M,w)},null);for(self.onmessage=M=>N.onmessage(M.data,M.ports);h.length>0;)self.onmessage(h.shift())},0)})})};let y=!0,h=[];self.onmessage=o=>{if(!y){h.push(o);return}y=!1,a(o.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/base/worker/workerMain.js.map
