/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/process","os","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(Y){for(var e=[],k=0,n=Y.length;k<n;k++)e[k]=ne[Y[k]];return e};define(ne[99],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(n,T){if(!n)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=k}),define(ne[48],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(P,I,C){this.id=P,this.definition=I,this.description=C,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function T(A,P){const I=["codicon","codicon-"+A];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=T;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function I(E){if(E instanceof n)return["codicon","codicon-"+E.id];const m=P.exec(E.id);if(!m)return I(n.error);let[,S,d]=m;const v=["codicon","codicon-"+S];return d&&v.push("codicon-modifier-"+d.substr(1)),v}A.asClassNameArray=I;function C(E){return I(E).join(" ")}A.asClassName=C;function R(E){return"."+I(E).join(".")}A.asCSSSelector=R})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[68],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function n(R){const E=[];for(let m in R)k.call(R,m)&&E.push(R[m]);return E}e.values=n;function T(R,E){for(let m in R)if(k.call(R,m)&&E({key:m,value:R[m]},function(){delete R[m]})===!1)return}e.forEach=T;function L(R,E){const m=Object.create(null);for(const S of R){const d=E(S);let v=m[d];v||(v=m[d]=[]),v.push(S)}return m}e.groupBy=L;function A(R){const E=Object.create(null);return R&&R.forEach((m,S)=>{E[S]=m}),E}e.fromMap=A;function P(R,E){const m=[],S=[];for(let d of R)E.has(d)||m.push(d);for(let d of E)R.has(d)||S.push(d);return{removed:m,added:S}}e.diffSets=P;function I(R,E){const m=[],S=[];for(let[d,v]of R)E.has(d)||m.push(v);for(let[d,v]of E)R.has(d)||S.push(v);return{removed:m,added:S}}e.diffMaps=I;class C{constructor(){this.map=new Map}add(E,m){let S=this.map.get(E);S||(S=new Set,this.map.set(E,S)),S.add(m)}delete(E,m){const S=this.map.get(E);!S||(S.delete(m),S.size===0&&this.map.delete(E))}forEach(E,m){const S=this.map.get(E);!S||S.forEach(m)}}e.SetMap=C}),define(ne[54],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(P,I,C)=>{let R=null,E=null;if(typeof C.value=="function"?(R="value",E=C.value):typeof C.get=="function"&&(R="get",E=C.get),!E)throw new Error("not supported");C[R]=A(E,I)}}e.createDecorator=k;function n(A,P,I){let C=null,R=null;if(typeof I.value=="function"?(C="value",R=I.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(C="get",R=I.get),!R)throw new Error("not supported");const E=`$memoize$${P}`;I[C]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[E]}}e.memoize=n;function T(A,P,I){return k((C,R)=>{const E=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...S){this[m]||(this[m]=I?I():void 0),clearTimeout(this[E]),P&&(this[m]=P(this[m],...S),S=[this[m]]),this[E]=setTimeout(()=>{C.apply(this,S),this[m]=I?I():void 0},A)}})}e.debounce=T;function L(A,P,I){return k((C,R)=>{const E=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...v){if(this[m]||(this[m]=I?I():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...v)),this[d])return;const g=this[S]+A;g<=Date.now()?(this[S]=Date.now(),C.apply(this,[this[m]]),this[m]=I?I():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),C.apply(this,[this[m]]),this[m]=I?I():void 0},g-Date.now()))}})}e.throttle=L}),define(ne[7],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(r=>{r(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=k,e.errorHandler=new k;function n(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=n;function T(p){I(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=T;function L(p){I(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=L;function A(p){if(p instanceof Error){let{name:u,message:r}=p;const c=p.stacktrace||p.stack;return{$isError:!0,name:u,message:r,stack:c}}return p}e.transformErrorForSerialization=A;const P="Canceled";function I(p){return p instanceof C?!0:p instanceof Error&&p.name===P&&p.message===P}e.isCancellationError=I;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function R(){const p=new Error(P);return p.name=p.message,p}e.canceled=R;function E(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=E;function m(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=m;function S(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function d(p){const u=new Error(`${p} has been disposed`);return u.name="DISPOSED",u}e.disposed=d;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class g extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=g;class h extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=h;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;class w extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(u){if(u&&u instanceof Error){const r=new w;return r.name=u.name,r.message=u.message,r.stack=u.stack,r}return new w(u)}}e.ErrorNoTelemetry=w}),define(ne[16],ie([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(U,z=0){return U[U.length-(1+z)]}e.tail=n;function T(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=T;function L(U,z,j=(ee,se)=>ee===se){if(U===z)return!0;if(!U||!z||U.length!==z.length)return!1;for(let ee=0,se=U.length;ee<se;ee++)if(!j(U[ee],z[ee]))return!1;return!0}e.equals=L;function A(U,z,j){let ee=0,se=U.length-1;for(;ee<=se;){const le=(ee+se)/2|0,he=j(U[le],z);if(he<0)ee=le+1;else if(he>0)se=le-1;else return le}return-(ee+1)}e.binarySearch=A;function P(U,z){let j=0,ee=U.length;if(ee===0)return 0;for(;j<ee;){const se=Math.floor((j+ee)/2);z(U[se])?ee=se:j=se+1}return j}e.findFirstInSorted=P;function I(U,z,j){if(U=U|0,U>=z.length)throw new TypeError("invalid index");let ee=z[Math.floor(z.length*Math.random())],se=[],le=[],he=[];for(let Se of z){const we=j(Se,ee);we<0?se.push(Se):we>0?le.push(Se):he.push(Se)}return U<se.length?I(U,se,j):U<se.length+he.length?he[0]:I(U-(se.length+he.length),le,j)}e.quickSelect=I;function C(U,z){const j=[];let ee;for(const se of U.slice(0).sort(z))!ee||z(ee[0],se)!==0?(ee=[se],j.push(ee)):ee.push(se);return j}e.groupBy=C;function R(U,z,j){const ee=[];function se(Se,we,ge){if(we===0&&ge.length===0)return;const pe=ee[ee.length-1];pe&&pe.start+pe.deleteCount===Se?(pe.deleteCount+=we,pe.toInsert.push(...ge)):ee.push({start:Se,deleteCount:we,toInsert:ge})}let le=0,he=0;for(;;){if(le===U.length){se(le,0,z.slice(he));break}if(he===z.length){se(le,U.length-le,[]);break}const Se=U[le],we=z[he],ge=j(Se,we);ge===0?(le+=1,he+=1):ge<0?(se(le,1,[]),le+=1):ge>0&&(se(le,0,[we]),he+=1)}return ee}e.sortedDiff=R;function E(U,z,j){const ee=R(U,z,j),se=[],le=[];for(const he of ee)se.push(...U.slice(he.start,he.start+he.deleteCount)),le.push(...he.toInsert);return{removed:se,added:le}}e.delta=E;function m(U,z,j){if(j===0)return[];const ee=U.slice(0,j).sort(z);return d(U,z,ee,j,U.length),ee}e.top=m;function S(U,z,j,ee,se){return j===0?Promise.resolve([]):new Promise((le,he)=>{(async()=>{const Se=U.length,we=U.slice(0,j).sort(z);for(let ge=j,pe=Math.min(j+ee,Se);ge<Se;ge=pe,pe=Math.min(pe+ee,Se)){if(ge>j&&await new Promise(Te=>setTimeout(Te)),se&&se.isCancellationRequested)throw(0,k.canceled)();d(U,z,we,ge,pe)}return we})().then(le,he)})}e.topAsync=S;function d(U,z,j,ee,se){for(const le=j.length;ee<se;ee++){const he=U[ee];if(z(he,j[le-1])<0){j.pop();const Se=P(j,we=>z(he,we)<0);j.splice(Se,0,he)}}}function v(U){return U.filter(z=>!!z)}e.coalesce=v;function g(U){let z=0;for(let j=0;j<U.length;j++)U[j]&&(U[z]=U[j],z+=1);U.length=z}e.coalesceInPlace=g;function h(U,z,j){U.splice(j,0,U.splice(z,1)[0])}e.move=h;function y(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=y;function w(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=w;function p(U,z=j=>j){const j=new Set;return U.filter(ee=>{const se=z(ee);return j.has(se)?!1:(j.add(se),!0)})}e.distinct=p;function u(U){const z=new Set;return j=>{const ee=U(j);return z.has(ee)?!1:(z.add(ee),!0)}}e.uniqueFilter=u;function r(U,z){const j=c(U,z);if(j!==-1)return U[j]}e.findLast=r;function c(U,z){for(let j=U.length-1;j>=0;j--){const ee=U[j];if(z(ee))return j}return-1}e.lastIndex=c;function i(U,z){return U.length>0?U[0]:z}e.firstOrDefault=i;function t(U,z){return U.length>0?U[U.length-1]:z}e.lastOrDefault=t;function s(U,z,j=(ee,se)=>ee===se){let ee=0;for(let se=0,le=Math.min(U.length,z.length);se<le&&j(U[se],z[se]);se++)ee++;return ee}e.commonPrefixLength=s;function o(U){return[].concat(...U)}e.flatten=o;function a(U,z){let j=typeof z=="number"?U:0;typeof z=="number"?j=U:(j=0,z=U);const ee=[];if(j<=z)for(let se=j;se<z;se++)ee.push(se);else for(let se=j;se>z;se--)ee.push(se);return ee}e.range=a;function l(U,z,j){return U.reduce((ee,se)=>(ee[z(se)]=j?j(se):se,ee),Object.create(null))}e.index=l;function f(U,z){return U.push(z),()=>b(U,z)}e.insert=f;function b(U,z){const j=U.indexOf(z);if(j>-1)return U.splice(j,1),z}e.remove=b;function _(U,z,j){const ee=U.slice(0,z),se=U.slice(z);return ee.concat(j,se)}e.arrayInsert=_;function O(U,z){let j;if(typeof z=="number"){let ee=z;j=()=>{const se=Math.sin(ee++)*179426549;return se-Math.floor(se)}}else j=Math.random;for(let ee=U.length-1;ee>0;ee-=1){const se=Math.floor(j()*(ee+1)),le=U[ee];U[ee]=U[se],U[se]=le}}e.shuffle=O;function M(U,z){const j=U.indexOf(z);j>-1&&(U.splice(j,1),U.unshift(z))}e.pushToStart=M;function D(U,z){const j=U.indexOf(z);j>-1&&(U.splice(j,1),U.push(z))}e.pushToEnd=D;function F(U,z){for(const j of z)U.push(j)}e.pushMany=F;function $(U,z){return Array.isArray(U)?U.map(z):z(U)}e.mapArrayOrNot=$;function q(U){return Array.isArray(U)?U:[U]}e.asArray=q;function x(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=x;function G(U,z){for(const j of U){const ee=z(j);if(ee!==void 0)return ee}}e.mapFind=G;function B(U,z,j){const ee=H(U,z),se=U.length,le=j.length;U.length=se+le;for(let he=se-1;he>=ee;he--)U[he+le]=U[he];for(let he=0;he<le;he++)U[he+ee]=j[he]}e.insertInto=B;function W(U,z,j,ee){const se=H(U,z),le=U.splice(se,j);return B(U,se,ee),le}e.splice=W;function H(U,z){return z<0?Math.max(z+U.length,0):Math.min(z,U.length)}function te(U,z){return(j,ee)=>z(U(j),U(ee))}e.compareBy=te;const V=(U,z)=>U-z;e.numberComparator=V;function Z(U,z){if(U.length===0)return;let j=U[0];for(let ee=1;ee<U.length;ee++){const se=U[ee];z(se,j)>0&&(j=se)}return j}e.findMaxBy=Z;function J(U,z){if(U.length===0)return;let j=U[0];for(let ee=1;ee<U.length;ee++){const se=U[ee];z(se,j)>=0&&(j=se)}return j}e.findLastMaxBy=J;function Q(U,z){return Z(U,(j,ee)=>-z(j,ee))}e.findMinBy=Q;class N{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let j=this.firstIdx;for(;j<this.items.length&&z(this.items[j]);)j++;const ee=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,ee}takeFromEndWhile(z){let j=this.lastIdx;for(;j>=0&&z(this.items[j]);)j--;const ee=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,ee}peek(){return this.items[this.firstIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}takeCount(z){const j=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,j}}e.ArrayQueue=N}),define(ne[69],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(n){const T=this;let L=!1,A;return function(){return L||(L=!0,A=n.apply(T,arguments)),A}}e.once=k}),define(ne[55],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(n){function T(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=T;const L=Object.freeze([]);function A(){return L}n.empty=A;function*P(u){yield u}n.single=P;function I(u){return u||L}n.from=I;function C(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=C;function R(u){return u[Symbol.iterator]().next().value}n.first=R;function E(u,r){for(const c of u)if(r(c))return!0;return!1}n.some=E;function m(u,r){for(const c of u)if(r(c))return c}n.find=m;function*S(u,r){for(const c of u)r(c)&&(yield c)}n.filter=S;function*d(u,r){let c=0;for(const i of u)yield r(i,c++)}n.map=d;function*v(...u){for(const r of u)for(const c of r)yield c}n.concat=v;function*g(u){for(const r of u)for(const c of r)yield c}n.concatNested=g;function h(u,r,c){let i=c;for(const t of u)i=r(i,t);return i}n.reduce=h;function*y(u,r,c=u.length){for(r<0&&(r+=u.length),c<0?c+=u.length:c>u.length&&(c=u.length);r<c;r++)yield u[r]}n.slice=y;function w(u,r=Number.POSITIVE_INFINITY){const c=[];if(r===0)return[c,u];const i=u[Symbol.iterator]();for(let t=0;t<r;t++){const s=i.next();if(s.done)return[c,n.empty()];c.push(s.value)}return[c,{[Symbol.iterator](){return i}}]}n.consume=w;function p(u,r,c=(i,t)=>i===t){const i=u[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=i.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!c(s.value,o.value))return!1}}n.equals=p})(k=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(r,c=!1){let i=0,t=r.length,s="",o=0,a=16,l=0;function f($){let q=0,x=0;for(;q<$;){const G=r.charCodeAt(i);if(G>=48&&G<=57)x=x*16+G-48;else if(G>=65&&G<=70)x=x*16+G-65+10;else if(G>=97&&G<=102)x=x*16+G-97+10;else break;i++,q++}return q<$&&(x=-1),x}function b($){i=$,s="",o=0,a=16,l=0}function _(){const $=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&C(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&C(r.charCodeAt(i)))for(i++;i<r.length&&C(r.charCodeAt(i));)i++;else return l=3,r.substring($,i);let q=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&C(r.charCodeAt(i))){for(i++;i<r.length&&C(r.charCodeAt(i));)i++;q=i}else l=3;return r.substring($,q)}function O(){let $="",q=i;for(;;){if(i>=t){$+=r.substring(q,i),l=2;break}const x=r.charCodeAt(i);if(x===34){$+=r.substring(q,i),i++;break}if(x===92){if($+=r.substring(q,i),i++,i>=t){l=2;break}switch(r.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const B=f(4);B>=0?$+=String.fromCharCode(B):l=4;break}default:l=5}q=i;continue}if(x>=0&&x<=31)if(I(x)){$+=r.substring(q,i),l=2;break}else l=6;i++}return $}function M(){if(s="",l=0,o=i,i>=t)return o=t,a=17;let $=r.charCodeAt(i);if(P($)){do i++,s+=String.fromCharCode($),$=r.charCodeAt(i);while(P($));return a=15}if(I($))return i++,s+=String.fromCharCode($),$===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch($){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=O(),a=10;case 47:{const q=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!I(r.charCodeAt(i));)i++;return s=r.substring(q,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const x=t-1;let G=!1;for(;i<x;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,l=1),s=r.substring(q,i),a=13}return s+=String.fromCharCode($),i++,a=16}case 45:if(s+=String.fromCharCode($),i++,i===t||!C(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=_(),a=11;default:for(;i<t&&D($);)i++,$=r.charCodeAt(i);if(o!==i){switch(s=r.substring(o,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode($),i++,a=16}}function D($){if(P($)||I($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:b,getPosition:()=>i,scan:c?F:M,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>l}}e.createScanner=A;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function I(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function E(r,c){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(f,b,_,O){o.value=f,o.offset=b,o.length=_,o.type=O,o.colonOffset=void 0,s=o}try{w(r,{onObjectBegin:(f,b)=>{if(c<=f)throw t;s=void 0,a=c>f,i.push("")},onObjectProperty:(f,b,_)=>{if(c<b||(l(f,b,_,"property"),i[i.length-1]=f,c<=b+_))throw t},onObjectEnd:(f,b)=>{if(c<=f)throw t;s=void 0,i.pop()},onArrayBegin:(f,b)=>{if(c<=f)throw t;s=void 0,i.push(0)},onArrayEnd:(f,b)=>{if(c<=f)throw t;s=void 0,i.pop()},onLiteralValue:(f,b,_)=>{if(c<b||(l(f,b,_,u(f)),c<=b+_))throw t},onSeparator:(f,b,_)=>{if(c<=b)throw t;if(f===":"&&s&&s.type==="property")s.colonOffset=b,a=!1,s=void 0;else if(f===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(f){if(f!==t)throw f}return{path:i,previousNode:s,isAtPropertyKey:a,matches:f=>{let b=0;for(let _=0;b<f.length&&_<i.length;_++)if(f[b]===i[_]||f[b]==="*")b++;else if(f[b]!=="**")return!1;return b===f.length}}}e.getLocation=E;function m(r,c=[],i=L.DEFAULT){let t=null,s=[];const o=[];function a(f){Array.isArray(s)?s.push(f):t!==null&&(s[t]=f)}return w(r,{onObjectBegin:()=>{const f={};a(f),o.push(s),s=f,t=null},onObjectProperty:f=>{t=f},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const f=[];a(f),o.push(s),s=f,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(f,b,_)=>{c.push({error:f,offset:b,length:_})}},i),s[0]}e.parse=m;function S(r,c=[],i=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(f){t.type==="property"&&(t.length=f-t.offset,t=t.parent)}function o(f){return t.children.push(f),f}w(r,{onObjectBegin:f=>{t=o({type:"object",offset:f,length:-1,parent:t,children:[]})},onObjectProperty:(f,b,_)=>{t=o({type:"property",offset:b,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:f,offset:b,length:_,parent:t})},onObjectEnd:(f,b)=>{t.length=f+b-t.offset,t=t.parent,s(f+b)},onArrayBegin:(f,b)=>{t=o({type:"array",offset:f,length:-1,parent:t,children:[]})},onArrayEnd:(f,b)=>{t.length=f+b-t.offset,t=t.parent,s(f+b)},onLiteralValue:(f,b,_)=>{o({type:u(f),offset:b,length:_,parent:t,value:f}),s(b+_)},onSeparator:(f,b,_)=>{t.type==="property"&&(f===":"?t.colonOffset=b:f===","&&s(b))},onError:(f,b,_)=>{c.push({error:f,offset:b,length:_})}},i);const l=t.children[0];return l&&delete l.parent,l}e.parseTree=S;function d(r,c){if(!r)return;let i=r;for(let t of c)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=d;function v(r){if(!r.parent||!r.parent.children)return[];const c=v(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;c.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&c.push(i)}return c}e.getNodePath=v;function g(r){switch(r.type){case"array":return r.children.map(g);case"object":{const c=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(c[i.children[0].value]=g(t))}return c}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=g;function h(r,c,i=!1){return c>=r.offset&&c<r.offset+r.length||i&&c===r.offset+r.length}e.contains=h;function y(r,c,i=!1){if(h(r,c,i)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=c;s++){const o=y(t[s],c,i);if(o)return o}return r}}e.findNodeAtOffset=y;function w(r,c,i=L.DEFAULT){const t=A(r,!1);function s(J){return J?()=>J(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(J){return J?Q=>J(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=s(c.onObjectBegin),l=o(c.onObjectProperty),f=s(c.onObjectEnd),b=s(c.onArrayBegin),_=s(c.onArrayEnd),O=o(c.onLiteralValue),M=o(c.onSeparator),D=s(c.onComment),F=o(c.onError),$=i&&i.disallowComments,q=i&&i.allowTrailingComma;function x(){for(;;){const J=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:$||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(J){case 12:case 13:$?G(10):D();break;case 16:G(1);break;case 15:case 14:break;default:return J}}}function G(J,Q=[],N=[]){if(F(J),Q.length+N.length>0){let U=t.getToken();for(;U!==17;){if(Q.indexOf(U)!==-1){x();break}else if(N.indexOf(U)!==-1)break;U=x()}}}function B(J){const Q=t.getTokenValue();return J?O(Q):l(Q),x(),!0}function W(){switch(t.getToken()){case 11:{let J=0;try{J=JSON.parse(t.getTokenValue()),typeof J!="number"&&(G(2),J=0)}catch{G(2)}O(J);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function H(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(B(!1),t.getToken()===6?(M(":"),x(),Z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function te(){a(),x();let J=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(J||G(4,[],[]),M(","),x(),t.getToken()===2&&q)break}else J&&G(6,[],[]);H()||G(4,[],[2,5]),J=!0}return f(),t.getToken()!==2?G(7,[2],[]):x(),!0}function V(){b(),x();let J=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(J||G(4,[],[]),M(","),x(),t.getToken()===4&&q)break}else J&&G(6,[],[]);Z()||G(4,[],[4,5]),J=!0}return _(),t.getToken()!==4?G(8,[4],[]):x(),!0}function Z(){switch(t.getToken()){case 3:return V();case 1:return te();case 10:return B(!0);default:return W()}}return x(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=w;function p(r,c){let i=A(r),t=[],s,o=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==a&&t.push(r.substring(o,a)),c!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,c)),o=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=p;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ne[49],ie([0,1,35]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(C,R,E){let m,S,d,v,g;if(R){for(v=R.offset,g=v+R.length,d=v;d>0&&!I(C,d-1);)d--;let a=g;for(;a<C.length&&!I(C,a);)a++;S=C.substring(d,a),m=A(S,E)}else S=C,m=0,d=0,v=0,g=C.length;const h=P(E,C);let y=!1,w=0,p;E.insertSpaces?p=L(" ",E.tabSize||4):p="	";const u=(0,k.createScanner)(S,!1);let r=!1;function c(){return h+L(p,m+w)}function i(){let a=u.scan();for(y=!1;a===15||a===14;)y=y||a===14,a=u.scan();return r=a===16||u.getTokenError()!==0,a}const t=[];function s(a,l,f){!r&&l<g&&f>v&&C.substring(l,f)!==a&&t.push({offset:l,length:f-l,content:a})}let o=i();if(o!==17){const a=u.getTokenOffset()+d,l=L(p,m);s(l,d,a)}for(;o!==17;){let a=u.getTokenOffset()+u.getTokenLength()+d,l=i(),f="";for(;!y&&(l===12||l===13);){const _=u.getTokenOffset()+d;s(" ",a,_),a=u.getTokenOffset()+u.getTokenLength()+d,f=l===12?c():"",l=i()}if(l===2)o!==1&&(w--,f=c());else if(l===4)o!==3&&(w--,f=c());else{switch(o){case 3:case 1:w++,f=c();break;case 5:case 12:f=c();break;case 13:y?f=c():f=" ";break;case 6:f=" ";break;case 10:if(l===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?f=" ":l!==5&&l!==17&&(r=!0);break;case 16:r=!0;break}y&&(l===12||l===13)&&(f=c())}const b=u.getTokenOffset()+d;s(f,a,b),o=l}return t}e.format=n;function T(C,R){const E=JSON.stringify(C,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?E.replace(/\r\n|\r|\n/g,R.eol):E}e.toFormattedString=T;function L(C,R){let E="";for(let m=0;m<R;m++)E+=C;return E}function A(C,R){let E=0,m=0;const S=R.tabSize||4;for(;E<C.length;){const d=C.charAt(E);if(d===" ")m++;else if(d==="	")m+=S;else break;E++}return Math.floor(m/S)}function P(C,R){for(let E=0;E<R.length;E++){const m=R.charAt(E);if(m==="\r")return E+1<R.length&&R.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=P;function I(C,R){return`\r
`.indexOf(C.charAt(R))!==-1}e.isEOL=I}),define(ne[70],ie([0,1,35,49]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(C,R,E){return L(C,R,void 0,E)}e.removeProperty=T;function L(C,R,E,m,S){const d=R.slice(),v=[],g=(0,k.parseTree)(C,v);let h,y;for(;d.length>0&&(y=d.pop(),h=(0,k.findNodeAtLocation)(g,d),h===void 0&&E!==void 0);)typeof y=="string"?E={[y]:E}:E=[E];if(h)if(h.type==="object"&&typeof y=="string"&&Array.isArray(h.children)){const w=(0,k.findNodeAtLocation)(h,[y]);if(w!==void 0)if(E===void 0){if(!w.parent)throw new Error("Malformed AST");const p=h.children.indexOf(w.parent);let u,r=w.parent.offset+w.parent.length;if(p>0){const c=h.children[p-1];u=c.offset+c.length}else u=h.offset+1,h.children.length>1&&(r=h.children[1].offset);return A(C,{offset:u,length:r-u,content:""},m)}else return A(C,{offset:w.offset,length:w.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const p=`${JSON.stringify(y)}: ${JSON.stringify(E)}`,u=S?S(h.children.map(c=>c.children[0].value)):h.children.length;let r;if(u>0){const c=h.children[u-1];r={offset:c.offset+c.length,length:0,content:","+p}}else h.children.length===0?r={offset:h.offset+1,length:0,content:p}:r={offset:h.offset+1,length:0,content:p+","};return A(C,r,m)}}else if(h.type==="array"&&typeof y=="number"&&Array.isArray(h.children))if(E!==void 0){const w=`${JSON.stringify(E)}`;let p;if(h.children.length===0||y===0)p={offset:h.offset+1,length:0,content:h.children.length===0?w:w+","};else{const u=y===-1||y>h.children.length?h.children.length:y,r=h.children[u-1];p={offset:r.offset+r.length,length:0,content:","+w}}return A(C,p,m)}else{const w=y,p=h.children[w];let u;if(h.children.length===1)u={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===w){const r=h.children[w-1],c=r.offset+r.length,i=h.offset+h.length;u={offset:c,length:i-2-c,content:""}}else u={offset:p.offset,length:h.children[w+1].offset-p.offset,content:""};return A(C,u,m)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(E)},m)}}e.setProperty=L;function A(C,R,E){let m=P(C,R),S=R.offset,d=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;S>0&&!(0,n.isEOL)(m,S-1);)S--;for(;d<m.length&&!(0,n.isEOL)(m,d);)d++}const v=(0,n.format)(m,{offset:S,length:d-S},E);for(let h=v.length-1;h>=0;h--){const y=v[h];m=P(m,y),S=Math.min(S,y.offset),d=Math.max(d,y.offset+y.length),d+=y.content.length-y.length}const g=C.length-(m.length-d)-S;return[{offset:S,length:g,content:m.substring(S,d)}]}e.withFormatting=A;function P(C,R){return C.substring(0,R.offset)+R.content+C.substring(R.offset+R.length)}e.applyEdit=P;function I(C,R){let E=R.slice(0).sort((S,d)=>{const v=S.offset-d.offset;return v===0?S.length-d.length:v}),m=C.length;for(let S=E.length-1;S>=0;S--){let d=E[S];if(d.offset+d.length<=m)C=P(C,d);else throw new Error("Overlapping edit");m=d.offset}return C}e.applyEdits=I}),define(ne[100],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new k(()=>T(this.getValue()))}}e.Lazy=k}),define(ne[2],ie([0,1,69,55]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let L=null;function A(s){L=s}if(e.setDisposableTracker=A,T){const s="__is_disposable_tracked__";A(new class{trackDisposable(o){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[s]||console.log(a)},3e3)}setParent(o,a){if(o&&o!==y.None)try{o[s]=!0}catch{}}markAsDisposed(o){if(o&&o!==y.None)try{o[s]=!0}catch{}}markAsSingleton(o){}})}function P(s){return L?.trackDisposable(s),s}function I(s){L?.markAsDisposed(s)}function C(s,o){L?.setParent(s,o)}function R(s,o){if(!!L)for(const a of s)L.setParent(a,o)}function E(s){return L?.markAsSingleton(s),s}e.markAsSingleton=E;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function S(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=S;function d(s){if(n.Iterable.is(s)){let o=[];for(const a of s)if(a)try{a.dispose()}catch(l){o.push(l)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=d;function v(...s){const o=g(()=>d(s));return R(s,o),o}e.combinedDisposable=v;function g(s){const o=P({dispose:(0,k.once)(()=>{I(o),s()})});return o}e.toDisposable=g;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return C(o,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new h,P(this),C(this._store,this)}dispose(){I(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&C(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&C(o,null),o}}e.MutableDisposable=w;class p{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let a=o;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,I(this))},this}}e.SafeDisposable=u;class r{constructor(){this.references=new Map}acquire(o,...a){let l=this.references.get(o);l||(l={counter:0,object:this.createReferencedObject(o,...a)},this.references.set(o,l));const{object:f}=l,b=(0,k.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(o,l.object),this.references.delete(o))});return l.counter++,{object:f,dispose:b}}}e.ReferenceCollection=r;class c{constructor(o){this.referenceCollection=o}async acquire(o,...a){const l=this.referenceCollection.acquire(o,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=c;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function t(s){const o=new h;try{s(o)}finally{o.dispose()}}e.disposeOnReturn=t}),define(ne[101],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(L){this.element=L,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class n{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let L=this._first;for(;L!==k.Undefined;){const A=L.next;L.prev=k.Undefined,L.next=k.Undefined,L=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const P=new k(L);if(this._first===k.Undefined)this._first=P,this._last=P;else if(A){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(P))}}shift(){if(this._first!==k.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==k.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==k.Undefined&&L.next!==k.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===k.Undefined&&L.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):L.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):L.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==k.Undefined;)yield L.element,L=L.next}}e.LinkedList=n}),function(){function Y(T){const L=[];typeof T=="number"&&L.push("code/timeOrigin",T);function A(I){L.push(I,Date.now())}function P(){const I=[];for(let C=0;C<L.length;C+=2)I.push({name:L[C],startTime:L[C+1]});return I}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(T+A.startTime)});return L}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=k(n))}(),define(ne[4],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let n=!1,T=!1,L=!1,A=!1,P=!1,I=!1,C=!1,R=!1,E=!1,m,S=k,d,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const h=typeof g?.versions?.electron=="string",y=h&&g?.type==="renderer";if(e.isElectronSandboxed=y&&g?.sandboxed,typeof navigator=="object"&&!y)v=navigator.userAgent,n=v.indexOf("Windows")>=0,T=v.indexOf("Macintosh")>=0,R=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=v.indexOf("Linux")>=0,I=!0,m=navigator.language,S=m;else if(typeof g=="object"){n=g.platform==="win32",T=g.platform==="darwin",L=g.platform==="linux",A=L&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,C=h,E=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=k,S=k;const o=g.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),l=a.availableLanguages["*"];m=a.locale,S=l||k,d=a._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function p(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let u=0;T?u=1:n?u=3:L&&(u=2),e.isWindows=n,e.isMacintosh=T,e.isLinux=L,e.isLinuxSnap=A,e.isNative=P,e.isElectron=C,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isCI=E,e.platform=u,e.userAgent=v,e.language=S;var r;(function(o){function a(){return e.language}o.value=a;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=l;function f(){return e.language==="en"}o.isDefault=f})(r=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let f=0,b=o.length;f<b;f++){const _=o[f];if(_.id===l.data.vscodeScheduleAsyncWork){o.splice(f,1),_.callback();return}}});let a=0;return l=>{const f=++a;o.push({id:f,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return o=>setTimeout(o)})();var c;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||R?2:n?1:3;let i=!0,t=!1;function s(){if(!t){t=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,i=new Uint16Array(o.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[33],ie([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const T=k.globals.vscode.process;n={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[10],ie([0,1,33]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,T=97,L=90,A=122,P=46,I=47,C=92,R=58,E=63;class m extends Error{constructor(p,u,r){let c;typeof u=="string"&&u.indexOf("not ")===0?(c="must not be",u=u.replace(/^not /,"")):c="must be";const i=p.indexOf(".")!==-1?"property":"argument";let t=`The "${p}" ${i} ${c} of type ${u}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(w,p){if(typeof w!="string")throw new m(p,"string",w)}function d(w){return w===I||w===C}function v(w){return w===I}function g(w){return w>=n&&w<=L||w>=T&&w<=A}function h(w,p,u,r){let c="",i=0,t=-1,s=0,o=0;for(let a=0;a<=w.length;++a){if(a<w.length)o=w.charCodeAt(a);else{if(r(o))break;o=I}if(r(o)){if(!(t===a-1||s===1))if(s===2){if(c.length<2||i!==2||c.charCodeAt(c.length-1)!==P||c.charCodeAt(c.length-2)!==P){if(c.length>2){const l=c.lastIndexOf(u);l===-1?(c="",i=0):(c=c.slice(0,l),i=c.length-1-c.lastIndexOf(u)),t=a,s=0;continue}else if(c.length!==0){c="",i=0,t=a,s=0;continue}}p&&(c+=c.length>0?`${u}..`:"..",i=2)}else c.length>0?c+=`${u}${w.slice(t+1,a)}`:c=w.slice(t+1,a),i=a-t-1;t=a,s=0}else o===P&&s!==-1?++s:s=-1}return c}function y(w,p){if(p===null||typeof p!="object")throw new m("pathObject","Object",p);const u=p.dir||p.root,r=p.base||`${p.name||""}${p.ext||""}`;return u?u===p.root?`${u}${r}`:`${u}${w}${r}`:r}e.win32={resolve(...w){let p="",u="",r=!1;for(let c=w.length-1;c>=-1;c--){let i;if(c>=0){if(i=w[c],S(i,"path"),i.length===0)continue}else p.length===0?i=k.cwd():(i=k.env[`=${p}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===C)&&(i=`${p}\\`));const t=i.length;let s=0,o="",a=!1;const l=i.charCodeAt(0);if(t===1)d(l)&&(s=1,a=!0);else if(d(l))if(a=!0,d(i.charCodeAt(1))){let f=2,b=f;for(;f<t&&!d(i.charCodeAt(f));)f++;if(f<t&&f!==b){const _=i.slice(b,f);for(b=f;f<t&&d(i.charCodeAt(f));)f++;if(f<t&&f!==b){for(b=f;f<t&&!d(i.charCodeAt(f));)f++;(f===t||f!==b)&&(o=`\\\\${_}\\${i.slice(b,f)}`,s=f)}}}else s=1;else g(l)&&i.charCodeAt(1)===R&&(o=i.slice(0,2),s=2,t>2&&d(i.charCodeAt(2))&&(a=!0,s=3));if(o.length>0)if(p.length>0){if(o.toLowerCase()!==p.toLowerCase())continue}else p=o;if(r){if(p.length>0)break}else if(u=`${i.slice(s)}\\${u}`,r=a,a&&p.length>0)break}return u=h(u,!r,"\\",d),r?`${p}\\${u}`:`${p}${u}`||"."},normalize(w){S(w,"path");const p=w.length;if(p===0)return".";let u=0,r,c=!1;const i=w.charCodeAt(0);if(p===1)return v(i)?"\\":w;if(d(i))if(c=!0,d(w.charCodeAt(1))){let s=2,o=s;for(;s<p&&!d(w.charCodeAt(s));)s++;if(s<p&&s!==o){const a=w.slice(o,s);for(o=s;s<p&&d(w.charCodeAt(s));)s++;if(s<p&&s!==o){for(o=s;s<p&&!d(w.charCodeAt(s));)s++;if(s===p)return`\\\\${a}\\${w.slice(o)}\\`;s!==o&&(r=`\\\\${a}\\${w.slice(o,s)}`,u=s)}}}else u=1;else g(i)&&w.charCodeAt(1)===R&&(r=w.slice(0,2),u=2,p>2&&d(w.charCodeAt(2))&&(c=!0,u=3));let t=u<p?h(w.slice(u),!c,"\\",d):"";return t.length===0&&!c&&(t="."),t.length>0&&d(w.charCodeAt(p-1))&&(t+="\\"),r===void 0?c?`\\${t}`:t:c?`${r}\\${t}`:`${r}${t}`},isAbsolute(w){S(w,"path");const p=w.length;if(p===0)return!1;const u=w.charCodeAt(0);return d(u)||p>2&&g(u)&&w.charCodeAt(1)===R&&d(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let p,u;for(let i=0;i<w.length;++i){const t=w[i];S(t,"path"),t.length>0&&(p===void 0?p=u=t:p+=`\\${t}`)}if(p===void 0)return".";let r=!0,c=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++c;const i=u.length;i>1&&d(u.charCodeAt(1))&&(++c,i>2&&(d(u.charCodeAt(2))?++c:r=!1))}if(r){for(;c<p.length&&d(p.charCodeAt(c));)c++;c>=2&&(p=`\\${p.slice(c)}`)}return e.win32.normalize(p)},relative(w,p){if(S(w,"from"),S(p,"to"),w===p)return"";const u=e.win32.resolve(w),r=e.win32.resolve(p);if(u===r||(w=u.toLowerCase(),p=r.toLowerCase(),w===p))return"";let c=0;for(;c<w.length&&w.charCodeAt(c)===C;)c++;let i=w.length;for(;i-1>c&&w.charCodeAt(i-1)===C;)i--;const t=i-c;let s=0;for(;s<p.length&&p.charCodeAt(s)===C;)s++;let o=p.length;for(;o-1>s&&p.charCodeAt(o-1)===C;)o--;const a=o-s,l=t<a?t:a;let f=-1,b=0;for(;b<l;b++){const O=w.charCodeAt(c+b);if(O!==p.charCodeAt(s+b))break;O===C&&(f=b)}if(b!==l){if(f===-1)return r}else{if(a>l){if(p.charCodeAt(s+b)===C)return r.slice(s+b+1);if(b===2)return r.slice(s+b)}t>l&&(w.charCodeAt(c+b)===C?f=b:b===2&&(f=3)),f===-1&&(f=0)}let _="";for(b=c+f+1;b<=i;++b)(b===i||w.charCodeAt(b)===C)&&(_+=_.length===0?"..":"\\..");return s+=f,_.length>0?`${_}${r.slice(s,o)}`:(r.charCodeAt(s)===C&&++s,r.slice(s,o))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const p=e.win32.resolve(w);if(p.length<=2)return w;if(p.charCodeAt(0)===C){if(p.charCodeAt(1)===C){const u=p.charCodeAt(2);if(u!==E&&u!==P)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(g(p.charCodeAt(0))&&p.charCodeAt(1)===R&&p.charCodeAt(2)===C)return`\\\\?\\${p}`;return w},dirname(w){S(w,"path");const p=w.length;if(p===0)return".";let u=-1,r=0;const c=w.charCodeAt(0);if(p===1)return d(c)?w:".";if(d(c)){if(u=r=1,d(w.charCodeAt(1))){let s=2,o=s;for(;s<p&&!d(w.charCodeAt(s));)s++;if(s<p&&s!==o){for(o=s;s<p&&d(w.charCodeAt(s));)s++;if(s<p&&s!==o){for(o=s;s<p&&!d(w.charCodeAt(s));)s++;if(s===p)return w;s!==o&&(u=r=s+1)}}}}else g(c)&&w.charCodeAt(1)===R&&(u=p>2&&d(w.charCodeAt(2))?3:2,r=u);let i=-1,t=!0;for(let s=p-1;s>=r;--s)if(d(w.charCodeAt(s))){if(!t){i=s;break}}else t=!1;if(i===-1){if(u===-1)return".";i=u}return w.slice(0,i)},basename(w,p){p!==void 0&&S(p,"ext"),S(w,"path");let u=0,r=-1,c=!0,i;if(w.length>=2&&g(w.charCodeAt(0))&&w.charCodeAt(1)===R&&(u=2),p!==void 0&&p.length>0&&p.length<=w.length){if(p===w)return"";let t=p.length-1,s=-1;for(i=w.length-1;i>=u;--i){const o=w.charCodeAt(i);if(d(o)){if(!c){u=i+1;break}}else s===-1&&(c=!1,s=i+1),t>=0&&(o===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=w.length),w.slice(u,r)}for(i=w.length-1;i>=u;--i)if(d(w.charCodeAt(i))){if(!c){u=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":w.slice(u,r)},extname(w){S(w,"path");let p=0,u=-1,r=0,c=-1,i=!0,t=0;w.length>=2&&w.charCodeAt(1)===R&&g(w.charCodeAt(0))&&(p=r=2);for(let s=w.length-1;s>=p;--s){const o=w.charCodeAt(s);if(d(o)){if(!i){r=s+1;break}continue}c===-1&&(i=!1,c=s+1),o===P?u===-1?u=s:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||c===-1||t===0||t===1&&u===c-1&&u===r+1?"":w.slice(u,c)},format:y.bind(null,"\\"),parse(w){S(w,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return p;const u=w.length;let r=0,c=w.charCodeAt(0);if(u===1)return d(c)?(p.root=p.dir=w,p):(p.base=p.name=w,p);if(d(c)){if(r=1,d(w.charCodeAt(1))){let f=2,b=f;for(;f<u&&!d(w.charCodeAt(f));)f++;if(f<u&&f!==b){for(b=f;f<u&&d(w.charCodeAt(f));)f++;if(f<u&&f!==b){for(b=f;f<u&&!d(w.charCodeAt(f));)f++;f===u?r=f:f!==b&&(r=f+1)}}}}else if(g(c)&&w.charCodeAt(1)===R){if(u<=2)return p.root=p.dir=w,p;if(r=2,d(w.charCodeAt(2))){if(u===3)return p.root=p.dir=w,p;r=3}}r>0&&(p.root=w.slice(0,r));let i=-1,t=r,s=-1,o=!0,a=w.length-1,l=0;for(;a>=r;--a){if(c=w.charCodeAt(a),d(c)){if(!o){t=a+1;break}continue}s===-1&&(o=!1,s=a+1),c===P?i===-1?i=a:l!==1&&(l=1):i!==-1&&(l=-1)}return s!==-1&&(i===-1||l===0||l===1&&i===s-1&&i===t+1?p.base=p.name=w.slice(t,s):(p.name=w.slice(t,i),p.base=w.slice(t,s),p.ext=w.slice(i,s))),t>0&&t!==r?p.dir=w.slice(0,t-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let p="",u=!1;for(let r=w.length-1;r>=-1&&!u;r--){const c=r>=0?w[r]:k.cwd();S(c,"path"),c.length!==0&&(p=`${c}/${p}`,u=c.charCodeAt(0)===I)}return p=h(p,!u,"/",v),u?`/${p}`:p.length>0?p:"."},normalize(w){if(S(w,"path"),w.length===0)return".";const p=w.charCodeAt(0)===I,u=w.charCodeAt(w.length-1)===I;return w=h(w,!p,"/",v),w.length===0?p?"/":u?"./":".":(u&&(w+="/"),p?`/${w}`:w)},isAbsolute(w){return S(w,"path"),w.length>0&&w.charCodeAt(0)===I},join(...w){if(w.length===0)return".";let p;for(let u=0;u<w.length;++u){const r=w[u];S(r,"path"),r.length>0&&(p===void 0?p=r:p+=`/${r}`)}return p===void 0?".":e.posix.normalize(p)},relative(w,p){if(S(w,"from"),S(p,"to"),w===p||(w=e.posix.resolve(w),p=e.posix.resolve(p),w===p))return"";const u=1,r=w.length,c=r-u,i=1,t=p.length-i,s=c<t?c:t;let o=-1,a=0;for(;a<s;a++){const f=w.charCodeAt(u+a);if(f!==p.charCodeAt(i+a))break;f===I&&(o=a)}if(a===s)if(t>s){if(p.charCodeAt(i+a)===I)return p.slice(i+a+1);if(a===0)return p.slice(i+a)}else c>s&&(w.charCodeAt(u+a)===I?o=a:a===0&&(o=0));let l="";for(a=u+o+1;a<=r;++a)(a===r||w.charCodeAt(a)===I)&&(l+=l.length===0?"..":"/..");return`${l}${p.slice(i+o)}`},toNamespacedPath(w){return w},dirname(w){if(S(w,"path"),w.length===0)return".";const p=w.charCodeAt(0)===I;let u=-1,r=!0;for(let c=w.length-1;c>=1;--c)if(w.charCodeAt(c)===I){if(!r){u=c;break}}else r=!1;return u===-1?p?"/":".":p&&u===1?"//":w.slice(0,u)},basename(w,p){p!==void 0&&S(p,"ext"),S(w,"path");let u=0,r=-1,c=!0,i;if(p!==void 0&&p.length>0&&p.length<=w.length){if(p===w)return"";let t=p.length-1,s=-1;for(i=w.length-1;i>=0;--i){const o=w.charCodeAt(i);if(o===I){if(!c){u=i+1;break}}else s===-1&&(c=!1,s=i+1),t>=0&&(o===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=w.length),w.slice(u,r)}for(i=w.length-1;i>=0;--i)if(w.charCodeAt(i)===I){if(!c){u=i+1;break}}else r===-1&&(c=!1,r=i+1);return r===-1?"":w.slice(u,r)},extname(w){S(w,"path");let p=-1,u=0,r=-1,c=!0,i=0;for(let t=w.length-1;t>=0;--t){const s=w.charCodeAt(t);if(s===I){if(!c){u=t+1;break}continue}r===-1&&(c=!1,r=t+1),s===P?p===-1?p=t:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===u+1?"":w.slice(p,r)},format:y.bind(null,"/"),parse(w){S(w,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return p;const u=w.charCodeAt(0)===I;let r;u?(p.root="/",r=1):r=0;let c=-1,i=0,t=-1,s=!0,o=w.length-1,a=0;for(;o>=r;--o){const l=w.charCodeAt(o);if(l===I){if(!s){i=o+1;break}continue}t===-1&&(s=!1,t=o+1),l===P?c===-1?c=o:a!==1&&(a=1):c!==-1&&(a=-1)}if(t!==-1){const l=i===0&&u?1:i;c===-1||a===0||a===1&&c===t-1&&c===i+1?p.base=p.name=w.slice(l,t):(p.name=w.slice(l,c),p.base=w.slice(l,t),p.ext=w.slice(c,t))}return i>0?p.dir=w.slice(0,i-1):u&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[102],ie([0,1,10]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex",E.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const m=(0,k.extname)(E),S=T[m.toLowerCase()];return S!==void 0?S:P(E)}e.getMediaOrTextMime=A;function P(E){const m=(0,k.extname)(E);return L[m.toLowerCase()]}e.getMediaMime=P;function I(E){for(const m in L)if(L[m]===E)return m}e.getExtensionForMimeType=I;const C=/^(.+)\/(.+?)(;.+)?$/;function R(E,m){const S=C.exec(E);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:m?void 0:E}e.normalizeMimeType=R}),define(ne[103],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var n;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(L,...A){const P=A.reduce((R,E)=>(R[E]=!0,R),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(R=>!P[R]).forEach(R=>{for(let E=0;E<I.length;E++)if(R.search(I[E])!==-1){delete L[R];break}})}e.sanitizeProcessEnvironment=T}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var n in k)(typeof exports=="object"?exports:Y)[n]=k[n]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function k(n){if(e[n])return e[n].exports;var T=e[n]={i:n,l:!1,exports:{}};return Y[n].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=Y,k.c=e,k.d=function(n,T,L){k.o(n,T)||Object.defineProperty(n,T,{enumerable:!0,get:L})},k.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},k.t=function(n,T){if(1&T&&(n=k(n)),8&T||4&T&&typeof n=="object"&&n&&n.__esModule)return n;var L=Object.create(null);if(k.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:n}),2&T&&typeof n!="string")for(var A in n)k.d(L,A,function(P){return n[P]}.bind(null,A));return L},k.n=function(n){var T=n&&n.__esModule?function(){return n.default}:function(){return n};return k.d(T,"a",T),T},k.o=function(n,T){return Object.prototype.hasOwnProperty.call(n,T)},k.p="",k(k.s=0)}([function(Y,e,k){(function(n){var T;e=Y.exports=N,T=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],C=0,R=C++;I[R]="0|[1-9]\\d*";var E=C++;I[E]="[0-9]+";var m=C++;I[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=C++;I[S]="("+I[R]+")\\.("+I[R]+")\\.("+I[R]+")";var d=C++;I[d]="("+I[E]+")\\.("+I[E]+")\\.("+I[E]+")";var v=C++;I[v]="(?:"+I[R]+"|"+I[m]+")";var g=C++;I[g]="(?:"+I[E]+"|"+I[m]+")";var h=C++;I[h]="(?:-("+I[v]+"(?:\\."+I[v]+")*))";var y=C++;I[y]="(?:-?("+I[g]+"(?:\\."+I[g]+")*))";var w=C++;I[w]="[0-9A-Za-z-]+";var p=C++;I[p]="(?:\\+("+I[w]+"(?:\\."+I[w]+")*))";var u=C++,r="v?"+I[S]+I[h]+"?"+I[p]+"?";I[u]="^"+r+"$";var c="[v=\\s]*"+I[d]+I[y]+"?"+I[p]+"?",i=C++;I[i]="^"+c+"$";var t=C++;I[t]="((?:<|>)?=?)";var s=C++;I[s]=I[E]+"|x|X|\\*";var o=C++;I[o]=I[R]+"|x|X|\\*";var a=C++;I[a]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[h]+")?"+I[p]+"?)?)?";var l=C++;I[l]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[y]+")?"+I[p]+"?)?)?";var f=C++;I[f]="^"+I[t]+"\\s*"+I[a]+"$";var b=C++;I[b]="^"+I[t]+"\\s*"+I[l]+"$";var _=C++;I[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=C++;I[O]="(?:~>?)";var M=C++;I[M]="(\\s*)"+I[O]+"\\s+",P[M]=new RegExp(I[M],"g");var D=C++;I[D]="^"+I[O]+I[a]+"$";var F=C++;I[F]="^"+I[O]+I[l]+"$";var $=C++;I[$]="(?:\\^)";var q=C++;I[q]="(\\s*)"+I[$]+"\\s+",P[q]=new RegExp(I[q],"g");var x=C++;I[x]="^"+I[$]+I[a]+"$";var G=C++;I[G]="^"+I[$]+I[l]+"$";var B=C++;I[B]="^"+I[t]+"\\s*("+c+")$|^$";var W=C++;I[W]="^"+I[t]+"\\s*("+r+")$|^$";var H=C++;I[H]="(\\s*)"+I[t]+"\\s*("+c+"|"+I[a]+")",P[H]=new RegExp(I[H],"g");var te=C++;I[te]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var V=C++;I[V]="^\\s*("+I[l]+")\\s+-\\s+("+I[l]+")\\s*$";var Z=C++;I[Z]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)T(J,I[J]),P[J]||(P[J]=new RegExp(I[J]));function Q(re,ae){if(re instanceof N)return re;if(typeof re!="string"||re.length>L||!(ae?P[i]:P[u]).test(re))return null;try{return new N(re,ae)}catch{return null}}function N(re,ae){if(re instanceof N){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof N))return new N(re,ae);T("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?P[i]:P[u]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var be=+Ee;if(be>=0&&be<A)return be}return Ee}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Q,e.valid=function(re,ae){var ue=Q(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=Q(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(re){return T("SemVer.compare",this.version,this.loose,re),re instanceof N||(re=new N(re,this.loose)),this.compareMain(re)||this.comparePre(re)},N.prototype.compareMain=function(re){return re instanceof N||(re=new N(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},N.prototype.comparePre=function(re){if(re instanceof N||(re=new N(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],Ee=re.prerelease[ae];if(T("prerelease compare",ae,ue,Ee),ue===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ee)return z(ue,Ee)}while(++ae)},N.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,Ee){typeof ue=="string"&&(Ee=ue,ue=void 0);try{return new N(re,ue).inc(ae,Ee).version}catch{return null}},e.diff=function(re,ae){if(le(re,ae))return null;var ue=Q(re),Ee=Q(ae);if(ue.prerelease.length||Ee.prerelease.length){for(var be in ue)if((be==="major"||be==="minor"||be==="patch")&&ue[be]!==Ee[be])return"pre"+be;return"prerelease"}for(var be in ue)if((be==="major"||be==="minor"||be==="patch")&&ue[be]!==Ee[be])return be},e.compareIdentifiers=z;var U=/^[0-9]+$/;function z(re,ae){var ue=U.test(re),Ee=U.test(ae);return ue&&Ee&&(re=+re,ae=+ae),ue&&!Ee?-1:Ee&&!ue?1:re<ae?-1:re>ae?1:0}function j(re,ae,ue){return new N(re,ue).compare(new N(ae,ue))}function ee(re,ae,ue){return j(re,ae,ue)>0}function se(re,ae,ue){return j(re,ae,ue)<0}function le(re,ae,ue){return j(re,ae,ue)===0}function he(re,ae,ue){return j(re,ae,ue)!==0}function Se(re,ae,ue){return j(re,ae,ue)>=0}function we(re,ae,ue){return j(re,ae,ue)<=0}function ge(re,ae,ue,Ee){var be;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),be=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),be=re!==ue;break;case"":case"=":case"==":be=le(re,ue,Ee);break;case"!=":be=he(re,ue,Ee);break;case">":be=ee(re,ue,Ee);break;case">=":be=Se(re,ue,Ee);break;case"<":be=se(re,ue,Ee);break;case"<=":be=we(re,ue,Ee);break;default:throw new TypeError("Invalid operator: "+ae)}return be}function pe(re,ae){if(re instanceof pe){if(re.loose===ae)return re;re=re.value}if(!(this instanceof pe))return new pe(re,ae);T("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new N(re,ae).major},e.minor=function(re,ae){return new N(re,ae).minor},e.patch=function(re,ae){return new N(re,ae).patch},e.compare=j,e.compareLoose=function(re,ae){return j(re,ae,!0)},e.rcompare=function(re,ae,ue){return j(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,Ee){return e.compare(ue,Ee,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,Ee){return e.rcompare(ue,Ee,ae)})},e.gt=ee,e.lt=se,e.eq=le,e.neq=he,e.gte=Se,e.lte=we,e.cmp=ge,e.Comparator=pe;var Te={};function Ce(re,ae){if(re instanceof Ce)return re.loose===ae?re:new Ce(re.raw,ae);if(re instanceof pe)return new Ce(re.value,ae);if(!(this instanceof Ce))return new Ce(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function qe(re,ae,ue,Ee,be,Me,Le,Oe,_e,X,oe,ce,fe){return((ae=De(ue)?"":De(Ee)?">="+ue+".0.0":De(be)?">="+ue+"."+Ee+".0":">="+ae)+" "+(Oe=De(_e)?"":De(X)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+X+1)+".0":ce?"<="+_e+"."+X+"."+oe+"-"+ce:"<="+Oe)).trim()}function Je(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(T(re[ue].semver),re[ue].semver!==Te&&re[ue].semver.prerelease.length>0){var Ee=re[ue].semver;if(Ee.major===ae.major&&Ee.minor===ae.minor&&Ee.patch===ae.patch)return!0}return!1}return!0}function Ve(re,ae,ue){try{ae=new Ce(ae,ue)}catch{return!1}return ae.test(re)}function je(re,ae,ue,Ee){var be,Me,Le,Oe,_e;switch(re=new N(re,Ee),ae=new Ce(ae,Ee),ue){case">":be=ee,Me=we,Le=se,Oe=">",_e=">=";break;case"<":be=se,Me=Se,Le=ee,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(re,ae,Ee))return!1;for(var X=0;X<ae.set.length;++X){var oe=ae.set[X],ce=null,fe=null;if(oe.forEach(function(me){me.semver===Te&&(me=new pe(">=0.0.0")),ce=ce||me,fe=fe||me,be(me.semver,ce.semver,Ee)?ce=me:Le(me.semver,fe.semver,Ee)&&(fe=me)}),ce.operator===Oe||ce.operator===_e||(!fe.operator||fe.operator===Oe)&&Me(re,fe.semver)||fe.operator===_e&&Le(re,fe.semver))return!1}return!0}pe.prototype.parse=function(re){var ae=this.loose?P[B]:P[W],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new N(ue[2],this.loose):this.semver=Te},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(re){return T("Comparator.test",re,this.loose),this.semver===Te||(typeof re=="string"&&(re=new N(re,this.loose)),ge(re,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(re,ae){if(!(re instanceof pe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ce(re.value,ae),Ve(this.value,ue,ae);if(re.operator==="")return ue=new Ce(this.value,ae),Ve(re.semver,ue,ae);var Ee=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Me=this.semver.version===re.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=ge(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=ge(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Ee||be||Me&&Le||Oe||_e},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),T("range",re,ae);var ue=ae?P[V]:P[te];re=re.replace(ue,qe),T("hyphen replace",re),re=re.replace(P[H],"$1$2$3"),T("comparator trim",re,P[H]),re=(re=(re=re.replace(P[M],"$1~")).replace(P[q],"$1^")).split(/\s+/).join(" ");var Ee=ae?P[B]:P[W],be=re.split(" ").map(function(Me){return function(Le,Oe){return T("comp",Le),Le=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){T("caret",ce,fe);var me=fe?P[G]:P[x];return ce.replace(me,function(ke,ye,Pe,Re,Ie){var Ae;return T("caret",ce,ke,ye,Pe,Re,Ie),De(ye)?Ae="":De(Pe)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(Re)?Ae=ye==="0"?">="+ye+"."+Pe+".0 <"+ye+"."+(+Pe+1)+".0":">="+ye+"."+Pe+".0 <"+(+ye+1)+".0.0":Ie?(T("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=ye==="0"?Pe==="0"?">="+ye+"."+Pe+"."+Re+Ie+" <"+ye+"."+Pe+"."+(+Re+1):">="+ye+"."+Pe+"."+Re+Ie+" <"+ye+"."+(+Pe+1)+".0":">="+ye+"."+Pe+"."+Re+Ie+" <"+(+ye+1)+".0.0"):(T("no pr"),Ae=ye==="0"?Pe==="0"?">="+ye+"."+Pe+"."+Re+" <"+ye+"."+Pe+"."+(+Re+1):">="+ye+"."+Pe+"."+Re+" <"+ye+"."+(+Pe+1)+".0":">="+ye+"."+Pe+"."+Re+" <"+(+ye+1)+".0.0"),T("caret return",Ae),Ae})}(oe,X)}).join(" ")}(Le,Oe),T("caret",Le),Le=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(ce,fe){var me=fe?P[F]:P[D];return ce.replace(me,function(ke,ye,Pe,Re,Ie){var Ae;return T("tilde",ce,ke,ye,Pe,Re,Ie),De(ye)?Ae="":De(Pe)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(Re)?Ae=">="+ye+"."+Pe+".0 <"+ye+"."+(+Pe+1)+".0":Ie?(T("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+ye+"."+Pe+"."+Re+Ie+" <"+ye+"."+(+Pe+1)+".0"):Ae=">="+ye+"."+Pe+"."+Re+" <"+ye+"."+(+Pe+1)+".0",T("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(Le,Oe),T("tildes",Le),Le=function(_e,X){return T("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(ce,fe){ce=ce.trim();var me=fe?P[b]:P[f];return ce.replace(me,function(ke,ye,Pe,Re,Ie,Ae){T("xRange",ce,ke,ye,Pe,Re,Ie,Ae);var Fe=De(Pe),ze=Fe||De(Re),We=ze||De(Ie);return ye==="="&&We&&(ye=""),Fe?ke=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(ze&&(Re=0),We&&(Ie=0),ye===">"?(ye=">=",ze?(Pe=+Pe+1,Re=0,Ie=0):We&&(Re=+Re+1,Ie=0)):ye==="<="&&(ye="<",ze?Pe=+Pe+1:Re=+Re+1),ke=ye+Pe+"."+Re+"."+Ie):ze?ke=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":We&&(ke=">="+Pe+"."+Re+".0 <"+Pe+"."+(+Re+1)+".0"),T("xRange return",ke),ke})}(oe,X)}).join(" ")}(Le,Oe),T("xrange",Le),Le=function(_e,X){return T("replaceStars",_e,X),_e.trim().replace(P[Z],"")}(Le,Oe),T("stars",Le),Le}(Me,ae)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Me){return!!Me.match(Ee)})),be=be.map(function(Me){return new pe(Me,ae)})},Ce.prototype.intersects=function(re,ae){if(!(re instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ee){return re.set.some(function(be){return be.every(function(Me){return Ee.intersects(Me,ae)})})})})},e.toComparators=function(re,ae){return new Ce(re,ae).set.map(function(ue){return ue.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new N(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Je(this.set[ae],re))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(re,ae,ue){var Ee=null,be=null;try{var Me=new Ce(ae,ue)}catch{return null}return re.forEach(function(Le){Me.test(Le)&&(Ee&&be.compare(Le)!==-1||(be=new N(Ee=Le,ue)))}),Ee},e.minSatisfying=function(re,ae,ue){var Ee=null,be=null;try{var Me=new Ce(ae,ue)}catch{return null}return re.forEach(function(Le){Me.test(Le)&&(Ee&&be.compare(Le)!==1||(be=new N(Ee=Le,ue)))}),Ee},e.validRange=function(re,ae){try{return new Ce(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return je(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return je(re,ae,">",ue)},e.outside=je,e.prerelease=function(re,ae){var ue=Q(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new Ce(re,ue),ae=new Ce(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof N)return re;if(typeof re!="string")return null;var ae=re.match(P[_]);return ae==null?null:Q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,k(1))},function(Y,e){var k,n,T=Y.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(g){if(k===setTimeout)return setTimeout(g,0);if((k===L||!k)&&setTimeout)return k=setTimeout,setTimeout(g,0);try{return k(g,0)}catch{try{return k.call(null,g,0)}catch{return k.call(this,g,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:L}catch{k=L}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var I,C=[],R=!1,E=-1;function m(){R&&I&&(R=!1,I.length?C=I.concat(C):E=-1,C.length&&S())}function S(){if(!R){var g=P(m);R=!0;for(var h=C.length;h;){for(I=C,C=[];++E<h;)I&&I[E].run();E=-1,h=C.length}I=null,R=!1,function(y){if(n===clearTimeout)return clearTimeout(y);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(y);try{n(y)}catch{try{return n.call(null,y)}catch{return n.call(this,y)}}}(g)}}function d(g,h){this.fun=g,this.array=h}function v(){}T.nextTick=function(g){var h=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)h[y-1]=arguments[y];C.push(new d(g,h)),C.length!==1||R||P(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=v,T.addListener=v,T.once=v,T.off=v,T.removeListener=v,T.removeAllListeners=v,T.emit=v,T.prependListener=v,T.prependOnceListener=v,T.listeners=function(g){return[]},T.binding=function(g){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(g){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ne[104],ie([0,1]),function(Y,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(P,I,C){this.level=P,this.key=I,this.value=C,this.forward=[]}}const T=void 0;class L{constructor(P,I=2**16){this.comparator=P,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new n(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,T,T)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,I){return L._insert(this,P,I,this.comparator)&&(this._size+=1),this}delete(P){const I=L._delete(this,P,this.comparator);return I&&(this._size-=1),I}forEach(P,I){let C=this._header.forward[0];for(;C;)P.call(I,C.value,C.key,this),C=C.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this._header.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static _search(P,I,C){let R=P._header;for(let E=P._level-1;E>=0;E--)for(;R.forward[E]&&C(R.forward[E].key,I)<0;)R=R.forward[E];if(R=R.forward[0],R&&C(R.key,I)===0)return R}static _insert(P,I,C,R){let E=[],m=P._header;for(let S=P._level-1;S>=0;S--){for(;m.forward[S]&&R(m.forward[S].key,I)<0;)m=m.forward[S];E[S]=m}if(m=m.forward[0],m&&R(m.key,I)===0)return m.value=C,!1;{let S=L._randomLevel(P);if(S>P._level){for(let d=P._level;d<S;d++)E[d]=P._header;P._level=S}m=new n(S,I,C);for(let d=0;d<S;d++)m.forward[d]=E[d].forward[d],E[d].forward[d]=m;return!0}}static _randomLevel(P,I=.5){let C=1;for(;Math.random()<I&&C<P._maxLevel;)C+=1;return C}static _delete(P,I,C){let R=[],E=P._header;for(let m=P._level-1;m>=0;m--){for(;E.forward[m]&&C(E.forward[m].key,I)<0;)E=E.forward[m];R[m]=E}if(E=E.forward[0],!E||C(E.key,I)!==0)return!1;for(let m=0;m<P._level&&R[m].forward[m]===E;m++)R[m].forward[m]=E.forward[m];for(;P._level>0&&P._header.forward[P._level-1]===T;)P._level-=1;return!0}}e.SkipList=L}),define(ne[105],ie([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=k.globals.performance&&typeof k.globals.performance.now=="function";class T{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new T(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ne[3],ie([0,1,7,69,2,101,105]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let P=!1,I=!1;var C;(function(i){i.None=()=>T.Disposable.None;function t(V){if(I){const{onListenerDidAdd:Z}=V,J=d.create();let Q=0;V.onListenerDidAdd=()=>{++Q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),Z?.()}}}function s(V){return(Z,J=null,Q)=>{let N=!1,U;return U=V(z=>{if(!N)return U?U.dispose():N=!0,Z.call(J,z)},null,Q),N&&U.dispose(),U}}i.once=s;function o(V,Z,J){return O((Q,N=null,U)=>V(z=>Q.call(N,Z(z)),null,U),J)}i.map=o;function a(V,Z,J){return O((Q,N=null,U)=>V(z=>{Z(z),Q.call(N,z)},null,U),J)}i.forEach=a;function l(V,Z,J){return O((Q,N=null,U)=>V(z=>Z(z)&&Q.call(N,z),null,U),J)}i.filter=l;function f(V){return V}i.signal=f;function b(...V){return(Z,J=null,Q)=>(0,T.combinedDisposable)(...V.map(N=>N(U=>Z.call(J,U),null,Q)))}i.any=b;function _(V,Z,J,Q){let N=J;return o(V,U=>(N=Z(N,U),N),Q)}i.reduce=_;function O(V,Z){let J;const Q={onFirstListenerAdd(){J=V(N.fire,N)},onLastListenerRemove(){J.dispose()}};Z||t(Q);const N=new g(Q);return Z&&Z.add(N),N.event}function M(V,Z,J=100,Q=!1,N,U){let z,j,ee,se=0;const le={leakWarningThreshold:N,onFirstListenerAdd(){z=V(Se=>{se++,j=Z(j,Se),Q&&!ee&&(he.fire(j),j=void 0),clearTimeout(ee),ee=setTimeout(()=>{const we=j;j=void 0,ee=void 0,(!Q||se>1)&&he.fire(we),se=0},J)})},onLastListenerRemove(){z.dispose()}};U||t(le);const he=new g(le);return U&&U.add(he),he.event}i.debounce=M;function D(V,Z=(Q,N)=>Q===N,J){let Q=!0,N;return l(V,U=>{const z=Q||!Z(U,N);return Q=!1,N=U,z},J)}i.latch=D;function F(V,Z,J){return[i.filter(V,Z,J),i.filter(V,Q=>!Z(Q),J)]}i.split=F;function $(V,Z=!1,J=[]){let Q=J.slice(),N=V(j=>{Q?Q.push(j):z.fire(j)});const U=()=>{Q&&Q.forEach(j=>z.fire(j)),Q=null},z=new g({onFirstListenerAdd(){N||(N=V(j=>z.fire(j)))},onFirstListenerDidAdd(){Q&&(Z?setTimeout(U):U())},onLastListenerRemove(){N&&N.dispose(),N=null}});return z.event}i.buffer=$;class q{constructor(Z){this.event=Z}map(Z){return new q(o(this.event,Z))}forEach(Z){return new q(a(this.event,Z))}filter(Z){return new q(l(this.event,Z))}reduce(Z,J){return new q(_(this.event,Z,J))}latch(){return new q(D(this.event))}debounce(Z,J=100,Q=!1,N){return new q(M(this.event,Z,J,Q,N))}on(Z,J,Q){return this.event(Z,J,Q)}once(Z,J,Q){return s(this.event)(Z,J,Q)}}function x(V){return new q(V)}i.chain=x;function G(V,Z,J=Q=>Q){const Q=(...j)=>z.fire(J(...j)),N=()=>V.on(Z,Q),U=()=>V.removeListener(Z,Q),z=new g({onFirstListenerAdd:N,onLastListenerRemove:U});return z.event}i.fromNodeEventEmitter=G;function B(V,Z,J=Q=>Q){const Q=(...j)=>z.fire(J(...j)),N=()=>V.addEventListener(Z,Q),U=()=>V.removeEventListener(Z,Q),z=new g({onFirstListenerAdd:N,onLastListenerRemove:U});return z.event}i.fromDOMEventEmitter=B;function W(V){return new Promise(Z=>s(V)(Z))}i.toPromise=W;function H(V,Z){return Z(void 0),V(J=>Z(J))}i.runAndSubscribe=H;function te(V,Z){let J=null;function Q(U){J?.dispose(),J=new T.DisposableStore,Z(U,J)}Q(void 0);const N=V(U=>Q(U));return(0,T.toDisposable)(()=>{N.dispose(),J?.dispose()})}i.runAndSubscribeWithStore=te})(C=e.Event||(e.Event={}));class R{constructor(t){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${t}_${R._idPool++}`}start(t){this._stopWatch=new A.StopWatch(!0),this._listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this._elapsedOverall+=t,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${t.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let E=-1;function m(i){const t=E;return E=i,{dispose(){E=t}}}e.setGlobalLeakWarningThreshold=m;class S{constructor(t,s=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,s){let o=E;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||s<o)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let l,f=0;for(const[b,_]of this._stacks)(!l||f<_)&&(l=b,f=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${f}):`),console.warn(l)}return()=>{const l=this._stacks.get(t.value)||0;this._stacks.set(t.value,l-1)}}}class d{constructor(t){this.value=t}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(t,s,o){this.callback=t,this.callbackThis=s,this.stack=o,this.subscription=new T.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class g{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=E>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const s of t)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,s,o)=>{this._listeners||(this._listeners=new L.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let l,f;this._leakageMon&&this._listeners.size>=30&&(f=d.create(),l=this._leakageMon.check(f,this._listeners.size+1)),P&&(f=f??d.create());const b=new v(t,s,f),_=this._listeners.push(b);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,s);const O=b.subscription.set(()=>{l&&l(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof T.DisposableStore?o.add(O):Array.isArray(o)&&o.push(O),O}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,t]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,o]=this._deliveryQueue.shift();try{s.invoke(o)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class h extends g{async fireAsync(t,s,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,t]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[a,l]=this._asyncDeliveryQueue.shift(),f=[],b={...l,token:s,waitUntil:_=>{if(Object.isFrozen(f))throw new Error("waitUntil can NOT be called asynchronous");o&&(_=o(_,a.callback)),f.push(_)}};try{a.invoke(b)}catch(_){(0,k.onUnexpectedError)(_);continue}Object.freeze(f),await Promise.allSettled(f).then(_=>{for(const O of _)O.status==="rejected"&&(0,k.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=h;class y extends g{constructor(t){super(t);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=y;class w extends y{constructor(t){super(t);this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=w;class p extends g{constructor(t){super(t);this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=p;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const s={event:t,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const o=()=>{this.hasListeners&&this.unhook(s);const a=this.events.indexOf(s);this.events.splice(a,1)};return(0,T.toDisposable)((0,n.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(s=>this.emitter.fire(s))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class r{constructor(){this.buffers=[]}wrapEvent(t){return(s,o,a)=>t(l=>{const f=this.buffers[this.buffers.length-1];f?f.push(()=>s.call(o,l)):s.call(o,l)},void 0,a)}bufferEvents(t){const s=[];this.buffers.push(s);const o=t();return this.buffers.pop(),s.forEach(a=>a()),o}}e.EventBufferer=r;class c{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=T.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(ne[25],ie([0,1,3]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(P,I){const C=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(C)}}});var T;(function(P){function I(C){return C===P.None||C===P.Cancelled||C instanceof L?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(T=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=T.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=A}),define(ne[106],ie([0,1,25]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new k.CancellationTokenSource,P=this.task(A.token);return this.result={promise:P,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=n;class T{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const P=JSON.stringify(A);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=T}),define(ne[40],ie([0,1,7,2]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(p){const u=p;return u?typeof u.read=="function":!1}e.isReadable=T;function L(p){const u=p;return u?[u.on,u.pause,u.resume,u.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function A(p){const u=p;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(p,u){return new I(p,u)}e.newWriteableStream=P;class I{constructor(u,r){this.reducer=u,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(r=>r(u))}emitError(u){this.listeners.error.length===0?(0,k.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(r=>r(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,r){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(u,r){if(this.state.destroyed)return;let c;switch(u){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const i=c.indexOf(r);i>=0&&c.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(p,u){const r=[];let c;for(;(c=p.read())!==null;)r.push(c);return u(r)}e.consumeReadable=C;function R(p,u,r){const c=[];let i;for(;(i=p.read())!==null&&c.length<r;)c.push(i);return i===null&&c.length>0?u(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i!="undefined"){const t=i;return i=void 0,t}return p.read()}}}e.peekReadable=R;function E(p,u){return new Promise((r,c)=>{const i=[];m(p,{onData:t=>{u&&i.push(t)},onError:t=>{u?c(t):r(void 0)},onEnd:()=>{r(u?u(i):void 0)}})})}e.consumeStream=E;function m(p,u){let r=!1;return p.on("error",c=>{r||u.onError(c)}),p.on("end",()=>{r||u.onEnd()}),p.on("data",c=>{r||u.onData(c)}),(0,n.toDisposable)(()=>r=!0)}e.listenStream=m;function S(p,u){return new Promise((r,c)=>{const i=new n.DisposableStore,t=[],s=l=>{if(t.push(l),t.length>u)return i.dispose(),p.pause(),r({stream:p,buffer:t,ended:!1})},o=l=>c(l),a=()=>r({stream:p,buffer:t,ended:!0});i.add((0,n.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),i.add((0,n.toDisposable)(()=>p.removeListener("end",a))),p.on("end",a),i.add((0,n.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=S;function d(p,u){const r=P(u);return r.end(p),r}e.toStream=d;function v(){const p=P(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=v;function g(p){let u=!1;return{read:()=>u?null:(u=!0,p)}}e.toReadable=g;function h(p,u,r){const c=P(r);return m(p,{onData:i=>c.write(u.data(i)),onError:i=>c.error(u.error?u.error(i):i),onEnd:()=>c.end()}),c}e.transform=h;function y(p,u,r){let c=!1;return{read:()=>{const i=u.read();return c?i:(c=!0,i!==null?r([p,i]):p)}}}e.prefixedReadable=y;function w(p,u,r){let c=!1;const i=P(r);return m(u,{onData:t=>c?i.write(t):(c=!0,i.write(r([p,t]))),onError:t=>i.error(t),onEnd:()=>{c||(c=!0,i.write(p)),i.end()}}),i}e.prefixedStream=w}),define(ne[17],ie([0,1,40]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let T,L;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,f){return!(f?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(l)):(T||(T=new TextEncoder),new A(T.encode(l)))}static fromByteArray(l){const f=A.alloc(l.length);for(let b=0,_=l.length;b<_;b++)f.buffer[b]=l[b];return f}static concat(l,f){if(typeof f=="undefined"){f=0;for(let O=0,M=l.length;O<M;O++)f+=l[O].byteLength}const b=A.alloc(f);let _=0;for(let O=0,M=l.length;O<M;O++){const D=l[O];b.set(D,_),_+=D.byteLength}return b}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(l,f){return new A(this.buffer.subarray(l,f))}set(l,f){if(l instanceof A)this.buffer.set(l.buffer,f);else if(l instanceof Uint8Array)this.buffer.set(l,f);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),f);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return C(this.buffer,l)}writeUInt32BE(l,f){R(this.buffer,l,f)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,f){m(this.buffer,l,f)}readUInt8(l){return S(this.buffer,l)}writeUInt8(l,f){d(this.buffer,l,f)}}e.VSBuffer=A;function P(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=P;function I(a,l,f){a[f+0]=l&255,l=l>>>8,a[f+1]=l&255}e.writeUInt16LE=I;function C(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=C;function R(a,l,f){a[f+3]=l,l=l>>>8,a[f+2]=l,l=l>>>8,a[f+1]=l,l=l>>>8,a[f]=l}e.writeUInt32BE=R;function E(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=E;function m(a,l,f){a[f+0]=l&255,l=l>>>8,a[f+1]=l&255,l=l>>>8,a[f+2]=l&255,l=l>>>8,a[f+3]=l&255}e.writeUInt32LE=m;function S(a,l){return a[l]}e.readUInt8=S;function d(a,l,f){a[f]=l}e.writeUInt8=d;function v(a){return k.consumeReadable(a,l=>A.concat(l))}e.readableToBuffer=v;function g(a){return k.toReadable(a)}e.bufferToReadable=g;function h(a){return k.consumeStream(a,l=>A.concat(l))}e.streamToBuffer=h;async function y(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=y;function w(a){return k.toStream(a,l=>A.concat(l))}e.bufferToStream=w;function p(a){return k.transform(a,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=p;function u(a){return k.newWriteableStream(l=>A.concat(l),a)}e.newWriteableBufferStream=u;function r(a,l){return k.prefixedReadable(a,l,f=>A.concat(f))}e.prefixedBufferReadable=r;function c(a,l){return k.prefixedStream(a,l,f=>A.concat(f))}e.prefixedBufferStream=c;function i(a){let l=0,f=0,b=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=D=>{switch(f){case 3:_[b++]=l|D,f=0;break;case 2:_[b++]=l|D>>>2,l=D<<6,f=3;break;case 1:_[b++]=l|D>>>4,l=D<<4,f=2;break;default:l=D<<2,f=1}};for(let D=0;D<a.length;D++){const F=a.charCodeAt(D);if(F>=65&&F<=90)O(F-65);else if(F>=97&&F<=122)O(F-97+26);else if(F>=48&&F<=57)O(F-48+52);else if(F===43||F===45)O(62);else if(F===47||F===95)O(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${a[D]}`)}}const M=b;for(;f>0;)O(0);return A.wrap(_).slice(0,M)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},l=!0,f=!1){const b=f?s:t;let _="";const O=a.byteLength%3;let M=0;for(;M<a.byteLength-O;M+=3){const D=a[M+0],F=a[M+1],$=a[M+2];_+=b[D>>>2],_+=b[(D<<4|F>>>4)&63],_+=b[(F<<2|$>>>6)&63],_+=b[$&63]}if(O===1){const D=a[M+0];_+=b[D>>>2],_+=b[D<<4&63],l&&(_+="==")}else if(O===2){const D=a[M+0],F=a[M+1];_+=b[D>>>2],_+=b[(D<<4|F>>>4)&63],_+=b[F<<2&63],l&&(_+="=")}return _}e.encodeBase64=o}),define(ne[27],ie([0,1,106,100]),function(Y,e,k,n){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function P(X,...oe){return oe.length===0?X:X.replace(A,function(ce,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?ce:oe[me]})}e.format=P;const I=/{([^}]+)}/g;function C(X,oe){return X.replace(I,(ce,fe)=>oe[fe]??ce)}e.format2=C;function R(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=R;function E(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function m(X,oe){let ce=0;const fe=oe.charCodeAt(0);for(let me=X.length-1;me>=0;me--)X.charCodeAt(me)===fe&&ce++;return ce}e.count=m;function S(X,oe,ce="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ce}`}e.truncate=S;function d(X,oe=" "){const ce=v(X,oe);return g(ce,oe)}e.trim=d;function v(X,oe){if(!X||!oe)return X;const ce=oe.length;if(ce===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+ce;return X.substring(fe)}e.ltrim=v;function g(X,oe){if(!X||!oe)return X;const ce=oe.length,fe=X.length;if(ce===0||fe===0)return X;let me=fe,ke=-1;for(;ke=X.lastIndexOf(oe,me-1),!(ke===-1||ke+ce!==me);){if(ke===0)return"";me=ke}return X.substring(0,me)}e.rtrim=g;function h(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function y(X){return X.replace(/\*/g,"")}e.stripWildcards=y;function w(X,oe,ce={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=E(X)),ce.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return ce.global&&(fe+="g"),ce.matchCase||(fe+="i"),ce.multiline&&(fe+="m"),ce.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=w;function p(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function u(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=r;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function i(X){for(let oe=0,ce=X.length;oe<ce;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(X,oe=0,ce=X.length){for(let fe=oe;fe<ce;fe++){const me=X.charCodeAt(fe);if(me!==32&&me!==9)return X.substring(oe,fe)}return X.substring(oe,ce)}e.getLeadingWhitespace=t;function s(X,oe=X.length-1){for(let ce=oe;ce>=0;ce--){const fe=X.charCodeAt(ce);if(fe!==32&&fe!==9)return ce}return-1}e.lastNonWhitespaceIndex=s;function o(X,oe){return X<oe?-1:X>oe?1:0}e.compare=o;function a(X,oe,ce=0,fe=X.length,me=0,ke=oe.length){for(;ce<fe&&me<ke;ce++,me++){let Re=X.charCodeAt(ce),Ie=oe.charCodeAt(me);if(Re<Ie)return-1;if(Re>Ie)return 1}const ye=fe-ce,Pe=ke-me;return ye<Pe?-1:ye>Pe?1:0}e.compareSubstring=a;function l(X,oe){return f(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=l;function f(X,oe,ce=0,fe=X.length,me=0,ke=oe.length){for(;ce<fe&&me<ke;ce++,me++){let Re=X.charCodeAt(ce),Ie=oe.charCodeAt(me);if(Re===Ie)continue;if(Re>=128||Ie>=128)return a(X.toLowerCase(),oe.toLowerCase(),ce,fe,me,ke);b(Re)&&(Re-=32),b(Ie)&&(Ie-=32);const Ae=Re-Ie;if(Ae!==0)return Ae}const ye=fe-ce,Pe=ke-me;return ye<Pe?-1:ye>Pe?1:0}e.compareSubstringIgnoreCase=f;function b(X){return X>=97&&X<=122}e.isLowerAsciiLetter=b;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function O(X,oe){return X.length===oe.length&&f(X,oe)===0}e.equalsIgnoreCase=O;function M(X,oe){const ce=oe.length;return oe.length>X.length?!1:f(X,oe,0,ce)===0}e.startsWithIgnoreCase=M;function D(X,oe){let ce,fe=Math.min(X.length,oe.length);for(ce=0;ce<fe;ce++)if(X.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return fe}e.commonPrefixLength=D;function F(X,oe){let ce,fe=Math.min(X.length,oe.length);const me=X.length-1,ke=oe.length-1;for(ce=0;ce<fe;ce++)if(X.charCodeAt(me-ce)!==oe.charCodeAt(ke-ce))return ce;return fe}e.commonSuffixLength=F;function $(X){return 55296<=X&&X<=56319}e.isHighSurrogate=$;function q(X){return 56320<=X&&X<=57343}e.isLowSurrogate=q;function x(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=x;function G(X,oe,ce){const fe=X.charCodeAt(ce);if($(fe)&&ce+1<oe){const me=X.charCodeAt(ce+1);if(q(me))return x(fe,me)}return fe}e.getNextCodePoint=G;function B(X,oe){const ce=X.charCodeAt(oe-1);if(q(ce)&&oe>1){const fe=X.charCodeAt(oe-2);if($(fe))return x(fe,ce)}return ce}class W{constructor(oe,ce=0){this._str=oe,this._len=oe.length,this._offset=ce}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=B(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class H{constructor(oe,ce=0){this._iterator=new W(oe,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const ke=ce.offset,ye=oe.getGraphemeBreakType(ce.nextCodePoint());if(je(me,ye)){ce.setOffset(ke);break}me=ye}return ce.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),ce=this._iterator,fe=ce.offset;let me=oe.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const ke=ce.offset,ye=oe.getGraphemeBreakType(ce.prevCodePoint());if(je(ye,me)){ce.setOffset(ke);break}me=ye}return fe-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function te(X,oe){return new H(X,oe).nextGraphemeLength()}e.nextCharLength=te;function V(X,oe){return new H(X,oe).prevGraphemeLength()}e.prevCharLength=V;function Z(X,oe){oe>0&&q(X.charCodeAt(oe))&&oe--;const ce=oe+te(X,oe);return[ce-V(X,ce),ce]}e.getCharContainingOffset=Z;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(X){return J.test(X)}e.containsRTL=Q;const N=/^[\t\n\r\x20-\x7E]*$/;function U(X){return N.test(X)}e.isBasicASCII=U,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=z;function j(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=j;function ee(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=ee;function se(X,oe){if(X.length<oe)return X;const ce=/\b/g;let fe=0;for(;ce.test(X)&&!(X.length-ce.lastIndex<oe);)fe=ce.lastIndex,ce.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const le=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function we(X){return X&&(X=X.replace(le,""),X=X.replace(he,""),X=X.replace(Se,"")),X}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function pe(X){return ge(X)?X.substr(1):X}e.stripUTF8BOM=pe;function Te(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ce=oe.length,fe=X.toLowerCase();let me=0,ke=-1;for(;me<ce;){const ye=fe.indexOf(oe[me],ke+1);if(ye<0)return!1;ke=ye,me++}return!0}e.fuzzyContains=Te;function Ce(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ce;function De(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=De;function qe(X,oe=1){if(oe===0)return"";let ce=-1;do ce=X.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?X:(X[ce-1]==="\r"&&ce--,X.substr(0,ce))}e.getNLines=qe;function Je(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Je;function Ve(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ve;function je(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var re;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,fe=ce.length/3;let me=1;for(;me<=fe;)if(oe<ce[3*me])me=2*me;else if(oe>ce[3*me+1])me=2*me+1;else return ce[3*me+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(X,oe){if(X===0)return 0;const ce=be(X,oe);if(ce!==void 0)return ce;const fe=new W(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=Ee;function be(X,oe){const ce=new W(oe,X);let fe=ce.prevCodePoint();for(;Me(fe)||fe===65039||fe===8419;){if(ce.offset===0)return;fe=ce.prevCodePoint()}if(!ee(fe))return;let me=ce.offset;return me>0&&ce.prevCodePoint()===8205&&(me=ce.offset),me}function Me(X){return 127995<=X&&X<=127999}var Le;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,T=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new k.LRUCachedComputed(X=>{function oe(Ie){const Ae=new Map;for(let Fe=0;Fe<Ie.length;Fe+=2)Ae.set(Ie[Fe],Ie[Fe+1]);return Ae}function ce(Ie,Ae){const Fe=new Map(Ie);for(const[ze,We]of Ae)Fe.set(ze,We);return Fe}function fe(Ie,Ae){if(!Ie)return Ae;const Fe=new Map;for(const[ze,We]of Ie)Ae.has(ze)&&Fe.set(ze,We);return Fe}const me=T.ambiguousCharacterData.getValue();let ke=X.filter(Ie=>!Ie.startsWith("_")&&Ie in me);ke.length===0&&(ke=["_default"]);let ye;for(const Ie of ke){const Ae=oe(me[Ie]);ye=fe(ye,Ae)}const Pe=oe(me._common),Re=ce(Pe,ye);return new Oe(Re)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[71],ie([0,1,27]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(h){return T(h,0)}e.hash=n;function T(h,y){switch(typeof h){case"object":return h===null?L(349,y):Array.isArray(h)?I(h,y):C(h,y);case"string":return P(h,y);case"boolean":return A(h,y);case"number":return L(h,y);case"undefined":return L(937,y);default:return L(617,y)}}e.doHash=T;function L(h,y){return(y<<5)-y+h|0}e.numberHash=L;function A(h,y){return L(h?433:863,y)}function P(h,y){y=L(149417,y);for(let w=0,p=h.length;w<p;w++)y=L(h.charCodeAt(w),y);return y}e.stringHash=P;function I(h,y){return y=L(104579,y),h.reduce((w,p)=>T(p,w),y)}function C(h,y){return y=L(181387,y),Object.keys(h).sort().reduce((w,p)=>(w=P(p,w),T(h[p],w)),y)}class R{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=T(y,this._value),this._value}}e.Hasher=R;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(h,y,w=32){const p=w-y,u=~((1<<p)-1);return(h<<y|(u&h)>>>p)>>>0}function S(h,y=0,w=h.byteLength,p=0){for(let u=0;u<w;u++)h[y+u]=p}function d(h,y,w="0"){for(;h.length<y;)h=w+h;return h}function v(h,y=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(w=>w.toString(16).padStart(2,"0")).join(""):d((h>>>0).toString(16),y/4)}e.toHexString=v;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const w=y.length;if(w===0)return;const p=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,c,i;for(r!==0?(c=r,i=-1,r=0):(c=y.charCodeAt(0),i=0);;){let t=c;if(k.isHighSurrogate(c))if(i+1<w){const s=y.charCodeAt(i+1);k.isLowSurrogate(s)?(i++,t=k.computeCodePoint(c,s)):t=65533}else{r=c;break}else k.isLowSurrogate(c)&&(t=65533);if(u=this._push(p,u,t),i++,i<w)c=y.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(y,w,p){return p<128?y[w++]=p:p<2048?(y[w++]=192|(p&1984)>>>6,y[w++]=128|(p&63)>>>0):p<65536?(y[w++]=224|(p&61440)>>>12,y[w++]=128|(p&4032)>>>6,y[w++]=128|(p&63)>>>0):(y[w++]=240|(p&1835008)>>>18,y[w++]=128|(p&258048)>>>12,y[w++]=128|(p&4032)>>>6,y[w++]=128|(p&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=g._bigBlock32,w=this._buffDV;for(let a=0;a<64;a+=4)y.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)y.setUint32(a,m(y.getUint32(a-12,!1)^y.getUint32(a-32,!1)^y.getUint32(a-56,!1)^y.getUint32(a-64,!1),1),!1);let p=this._h0,u=this._h1,r=this._h2,c=this._h3,i=this._h4,t,s,o;for(let a=0;a<80;a++)a<20?(t=u&r|~u&c,s=1518500249):a<40?(t=u^r^c,s=1859775393):a<60?(t=u&r|u&c|r&c,s=2400959708):(t=u^r^c,s=3395469782),o=m(p,5)+t+i+s+y.getUint32(a*4,!1)&4294967295,i=c,c=r,r=m(u,30),u=p,p=o;this._h0=this._h0+p&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var wt=this&&this.__classPrivateFieldSet||function(Y,e,k,n,T){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?T.call(Y,k):T?T.value=k:e.set(Y,k),k},xe=this&&this.__classPrivateFieldGet||function(Y,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!n:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(Y):n?n.value:e.get(Y)};define(ne[39],ie([0,1,16,27]),function(Y,e,k,n){"use strict";var T,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(i,t,s){let o=i.get(t);return o===void 0&&(o=s,i.set(t,o)),o}e.getOrSet=P;function I(i){const t=[];return i.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=I;function C(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=C;class R{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=R;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var S;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(S||(S={}));class d{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(g||(g={}));class h{constructor(t){this._iter=t}static forUris(t=()=>!1){return new h(new d(t))}static forPaths(t=!1){return new h(new m(void 0,!t))}static forStrings(){return new h(new R)}static forConfigKeys(){return new h(new E)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,k.shuffle)(o);for(let a of o)this.set(a,t)}else{const o=t.slice(0);(0,k.shuffle)(o);for(let a of o)this.set(a[0],a[1])}}set(t,s){const o=this._iter.reset(t);let a;this._root||(this._root=new v,this._root.segment=o.value());const l=[];for(a=this._root;;){const b=o.cmp(a.segment);if(b>0)a.left||(a.left=new v,a.left.segment=o.value()),l.push([-1,a]),a=a.left;else if(b<0)a.right||(a.right=new v,a.right.segment=o.value()),l.push([1,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new v,a.mid.segment=o.value()),l.push([0,a]),a=a.mid;else break}const f=a.value;a.value=s,a.key=t;for(let b=l.length-1;b>=0;b--){const _=l[b][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const M=l[b][0],D=l[b+1][0];if(M===1&&D===1)l[b][1]=_.rotateLeft();else if(M===-1&&D===-1)l[b][1]=_.rotateRight();else if(M===1&&D===-1)_.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=_.rotateLeft();else if(M===-1&&D===1)_.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=_.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this._root=l[0][1]}}return f}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const a=s.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),a=[];let l=this._root;for(;l;){const f=o.cmp(l.segment);if(f>0)a.push([-1,l]),l=l.left;else if(f<0)a.push([1,l]),l=l.right;else if(o.hasNext())o.next(),a.push([0,l]),l=l.mid;else break}if(!!l){if(s?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const f=this._min(l.right),{key:b,value:_,segment:O}=f;this._delete(f.key,!1),l.key=b,l.value=_,l.segment=O}else{const f=l.left??l.right;if(a.length>0){const[b,_]=a[a.length-1];switch(b){case-1:_.left=f;break;case 0:_.mid=f;break;case 1:_.right=f;break}}else this._root=f}for(let f=a.length-1;f>=0;f--){const b=a[f][1];b.updateHeight();const _=b.balanceFactor();if(_>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),a[f][1]=b.rotateLeft()):_<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),a[f][1]=b.rotateRight()),f>0)switch(a[f-1][0]){case-1:a[f-1][1].left=a[f][1];break;case 1:a[f-1][1].right=a[f][1];break;case 0:a[f-1][1].mid=a[f][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,a;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const a=s.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=h;class y{constructor(t,s){this.uri=t,this.value=s}}class w{constructor(t,s){this[T]="ResourceMap",t instanceof w?(this.map=new Map(t.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=t??w.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new y(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=w,w.defaultToKey=i=>i.toString();var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class u{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let a=this._map.get(t);if(a)a.value=s,o!==0&&this.touch(a,o);else{switch(a={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let a=this._head;for(;a;){if(s?t.bind(s)(a.value,a.key,this):t(a.value,a.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,s=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.key,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return a}values(){const t=this,s=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.value,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return a}entries(){const t=this,s=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:[o.key,o.value],done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return a}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(o.previous=a,a.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,a=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=a,a.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=u;class r extends u{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class c{constructor(t){A.set(this,void 0),wt(this,A,t,"f")}get size(){return xe(this,A,"f").size}forEach(t,s){xe(this,A,"f").forEach(t,s)}get(t){return xe(this,A,"f").get(t)}has(t){return xe(this,A,"f").has(t)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(ne[72],ie([0,1,39]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new k.LRUCache(1e4);function T(C){return I(C,"NFC",n)}e.normalizeNFC=T;const L=new k.LRUCache(1e4);function A(C){return I(C,"NFD",L)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function I(C,R,E){if(!C)return C;const m=E.get(C);if(m)return m;let S;return P.test(C)?S=C.normalize(R):S=C,E.set(C,S),S}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return A(R).replace(C,"")}}()}),define(ne[15],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(a){return Array.isArray(a)}e.isArray=k;function n(a){return typeof a=="string"}e.isString=n;function T(a){return Array.isArray(a)&&a.every(l=>n(l))}e.isStringArray=T;function L(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=L;function A(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=A;function P(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=P;function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=I;function C(a){return a===!0||a===!1}e.isBoolean=C;function R(a){return typeof a=="undefined"}e.isUndefined=R;function E(a){return!m(a)}e.isDefined=E;function m(a){return R(a)||a===null}e.isUndefinedOrNull=m;function S(a,l){if(!a)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=S;function d(a){if(m(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=d;function v(...a){const l=[];for(let f=0;f<a.length;f++){const b=a[f];if(m(b))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);l.push(b)}return l}e.assertAllDefined=v;const g=Object.prototype.hasOwnProperty;function h(a){if(!L(a))return!1;for(let l in a)if(g.call(a,l))return!1;return!0}e.isEmptyObject=h;function y(a){return typeof a=="function"}e.isFunction=y;function w(...a){return a.length>0&&a.every(y)}e.areFunctions=w;function p(a,l){const f=Math.min(a.length,l.length);for(let b=0;b<f;b++)u(a[b],l[b])}e.validateConstraints=p;function u(a,l){if(n(l)){if(typeof a!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(y(l)){try{if(a instanceof l)return}catch{}if(!m(a)&&a.constructor===l||l.length===1&&l.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function r(a){let l=[],f=Object.getPrototypeOf(a);for(;Object.prototype!==f;)l=l.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return l}e.getAllPropertyNames=r;function c(a){const l=[];for(const f of r(a))typeof a[f]=="function"&&l.push(f);return l}e.getAllMethodNames=c;function i(a,l){const f=_=>function(){const O=Array.prototype.slice.call(arguments,0);return l(_,O)};let b={};for(const _ of a)b[_]=f(_);return b}e.createProxyObject=i;function t(a){return a===null?void 0:a}e.withNullAsUndefined=t;function s(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=s;function o(a,l="Unreachable"){throw new Error(l)}e.assertNever=o}),define(ne[41],ie([0,1,10,4,27,15]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function P(s){return s.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function C(s,o=k.posix.sep){if(!s)return"";const a=s.length,l=s.charCodeAt(0);if(A(l)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let b=3;const _=b;for(;b<a&&!A(s.charCodeAt(b));b++);if(_!==b&&!A(s.charCodeAt(b+1))){for(b+=1;b<a;b++)if(A(s.charCodeAt(b)))return s.slice(0,b+1).replace(/[\\/]/g,o)}}return o}else if(h(l)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(A(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=C;function R(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let a=2;const l=a;for(;a<s.length&&(o=s.charCodeAt(a),o!==92);a++);return!(l===a||(o=s.charCodeAt(a+1),isNaN(o)||o===92))}e.isUNC=R;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,o=n.isWindows){const a=o?E:m;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||o&&S.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function v(s,o,a){const l=s===o;return!a||l?l:!s||!o?!1:(0,T.equalsIgnoreCase)(s,o)}e.isEqual=v;function g(s,o,a,l=k.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(a){if(!(0,T.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let b=o.length;return o.charAt(o.length-1)===l&&b--,s.charAt(b)===l}return o.charAt(o.length-1)!==l&&(o+=l),s.indexOf(o)===0}e.isEqualOrParent=g;function h(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=h;function y(s,o){return n.isWindows&&s.endsWith(":")&&(s+=k.sep),(0,k.isAbsolute)(s)||(s=(0,k.join)(o,s)),s=(0,k.normalize)(s),n.isWindows?(s=(0,T.rtrim)(s,k.sep),s.endsWith(":")&&(s+=k.sep)):(s=(0,T.rtrim)(s,k.sep),s||(s=k.sep)),s}e.sanitizeFilePath=y;function w(s){const o=(0,k.normalize)(s);return n.isWindows?s.length>3?!1:p(o)&&(s.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=w;function p(s,o){return(o!==void 0?o:n.isWindows)?h(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function u(s){return p(s)?s[0]:void 0}e.getDriveLetter=u;function r(s,o,a){return o.length>s.length?-1:s===o?0:(a&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function c(s){const o=s.split(":");let a,l,f;for(const b of o){const _=Number(b);(0,L.isNumber)(_)?l===void 0?l=_:f===void 0&&(f=_):a=a?[a,b].join(":"):b}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,a=8){let l="";for(let b=0;b<a;b++)l+=i.charAt(Math.floor(Math.random()*i.length));let f;return o?f=`${o}-${l}`:f=l,s?(0,k.join)(s,f):f}e.randomPath=t}),define(ne[29],ie([0,1,15]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const g=Array.isArray(v)?[]:{};return Object.keys(v).forEach(h=>{v[h]&&typeof v[h]=="object"?g[h]=n(v[h]):g[h]=v[h]}),g}e.deepClone=n;function T(v){if(!v||typeof v!="object")return v;const g=[v];for(;g.length>0;){const h=g.shift();Object.freeze(h);for(const y in h)if(L.call(h,y)){const w=h[y];typeof w=="object"&&!Object.isFrozen(w)&&!(0,k.isTypedArray)(w)&&g.push(w)}}return v}e.deepFreeze=T;const L=Object.prototype.hasOwnProperty;function A(v,g){return P(v,g,new Set)}e.cloneAndChange=A;function P(v,g,h){if((0,k.isUndefinedOrNull)(v))return v;const y=g(v);if(typeof y!="undefined")return y;if((0,k.isArray)(v)){const w=[];for(const p of v)w.push(P(p,g,h));return w}if((0,k.isObject)(v)){if(h.has(v))throw new Error("Cannot clone recursive data-structure");h.add(v);const w={};for(let p in v)L.call(v,p)&&(w[p]=P(v[p],g,h));return h.delete(v),w}return v}function I(v,g,h=!0){return(0,k.isObject)(v)?((0,k.isObject)(g)&&Object.keys(g).forEach(y=>{y in v?h&&((0,k.isObject)(v[y])&&(0,k.isObject)(g[y])?I(v[y],g[y],h):v[y]=g[y]):v[y]=g[y]}),v):g}e.mixin=I;function C(v,g){if(v===g)return!0;if(v==null||g===null||g===void 0||typeof v!=typeof g||typeof v!="object"||Array.isArray(v)!==Array.isArray(g))return!1;let h,y;if(Array.isArray(v)){if(v.length!==g.length)return!1;for(h=0;h<v.length;h++)if(!C(v[h],g[h]))return!1}else{const w=[];for(y in v)w.push(y);w.sort();const p=[];for(y in g)p.push(y);if(p.sort(),!C(w,p))return!1;for(h=0;h<w.length;h++)if(!C(v[w[h]],g[w[h]]))return!1}return!0}e.equals=C;function R(v){const g=new Set;return JSON.stringify(v,(h,y)=>{if((0,k.isObject)(y)||Array.isArray(y)){if(g.has(y))return"[Circular]";g.add(y)}return y})}e.safeStringify=R;function E(v,g,h){const y=g(v);return typeof y=="undefined"?h:y}e.getOrDefault=E;function m(v,g){const h=Object.create(null);return!v||!g||Object.keys(g).forEach(w=>{const p=v[w],u=g[w];C(p,u)||(h[w]=u)}),h}e.distinct=m;function S(v,g){const h=g.toLowerCase(),y=Object.keys(v).find(w=>w.toLowerCase()===h);return y?v[y]:v[g]}e.getCaseInsensitive=S;function d(v,g){const h=Object.create(null);for(const[y,w]of Object.entries(v))g(y,w)&&(h[y]=w);return h}e.filter=d}),define(ne[8],ie([0,1,10,4]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function P(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!T.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,t){return!i&&!t?"file":i}function C(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const R="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,s,o,a,l,f=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=I(t,f),this.authority=s||R,this.path=C(this.scheme,o||R),this.query=a||R,this.fragment=l||R,P(this,f))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return w(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:a,query:l,fragment:f}=t;return s===void 0?s=this.scheme:s===null&&(s=R),o===void 0?o=this.authority:o===null&&(o=R),a===void 0?a=this.path:a===null&&(a=R),l===void 0?l=this.query:l===null&&(l=R),f===void 0?f=this.fragment:f===null&&(f=R),s===this.scheme&&o===this.authority&&a===this.path&&l===this.query&&f===this.fragment?this:new v(s,o,a,l,f)}static parse(t,s=!1){const o=m.exec(t);return o?new v(o[2]||R,c(o[4]||R),c(o[5]||R),c(o[7]||R),c(o[9]||R),s):new v(R,R,R,R,R)}static file(t){let s=R;if(n.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(s=t.substring(2),t=E):(s=t.substring(2,o),t=t.substring(o)||E)}return new v("file",s,t,R,R)}static from(t){const s=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return P(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&t.scheme==="file"?o=S.file(k.win32.join(w(t,!0),...s)).path:o=k.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return p(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const s=new v(t);return s._formatted=t.external,s._fsPath=t._sep===d?t.fsPath:null,s}}else return t}}e.URI=S;const d=n.isWindows?1:void 0;class v extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(t=!1){return t?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=d),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,t){let s,o=-1;for(let a=0;a<i.length;a++){const l=i.charCodeAt(a);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||t&&l===47)o!==-1&&(s+=encodeURIComponent(i.substring(o,a)),o=-1),s!==void 0&&(s+=i.charAt(a));else{s===void 0&&(s=i.substr(0,a));const f=g[l];f!==void 0?(o!==-1&&(s+=encodeURIComponent(i.substring(o,a)),o=-1),s+=f):o===-1&&(o=a)}}return o!==-1&&(s+=encodeURIComponent(i.substring(o))),s!==void 0?s:i}function y(i){let t;for(let s=0;s<i.length;s++){const o=i.charCodeAt(s);o===35||o===63?(t===void 0&&(t=i.substr(0,s)),t+=g[o]):t!==void 0&&(t+=i[s])}return t!==void 0?t:i}function w(i,t){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=w;function p(i,t){const s=t?y:h;let o="",{scheme:a,authority:l,path:f,query:b,fragment:_}=i;if(a&&(o+=a,o+=":"),(l||a==="file")&&(o+=E,o+=E),l){let O=l.indexOf("@");if(O!==-1){const M=l.substr(0,O);l=l.substr(O+1),O=M.indexOf(":"),O===-1?o+=s(M,!1):(o+=s(M.substr(0,O),!1),o+=":",o+=s(M.substr(O+1),!1)),o+="@"}l=l.toLowerCase(),O=l.indexOf(":"),O===-1?o+=s(l,!1):(o+=s(l.substr(0,O),!1),o+=l.substr(O))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const O=f.charCodeAt(1);O>=65&&O<=90&&(f=`/${String.fromCharCode(O+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const O=f.charCodeAt(0);O>=65&&O<=90&&(f=`${String.fromCharCode(O+32)}:${f.substr(2)}`)}o+=s(f,!0)}return b&&(o+="?",o+=s(b,!1)),_&&(o+="#",o+=t?_:h(_,!1)),o}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(r)?i.replace(r,t=>u(t)):i}}),define(ne[107],ie([0,1,8]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(C){const R=C;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=n;function T(C){const R=[];let E;try{const m=JSON.parse(C.arguments),S=m[m.length-1];S&&S.__$stack&&(m.pop(),E=S.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",C.arguments)}return{args:R,stack:E}}e.parse=T;function L(C){if(typeof C!="string")return L(T(C).stack);const R=C;if(R){const E=A(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:k.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function A(C){if(!C)return C;const R=C.indexOf(`
`);return R===-1?C:C.substring(0,R)}function P(C,R){const{args:E,stack:m}=T(C),S=typeof E[0]=="string"&&E.length===1;let d=A(m);d&&(d=`(${d.trim()})`);let v=[];if(typeof E[0]=="string"?d&&S?v=[`%c[${R}] %c${E[0]} %c${d}`,I("blue"),I(""),I("grey")]:v=[`%c[${R}] %c${E[0]}`,I("blue"),I(""),...E.slice(1)]:v=[`%c[${R}]%`,I("blue"),...E],d&&!S&&v.push(d),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,v)}e.log=P;function I(C){return`color: ${C}`}}),define(ne[108],ie([0,1,17,27,8]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(C){return JSON.stringify(C,P)}e.stringify=L;function A(C){let R=JSON.parse(C);return R=I(R),R}e.parse=A;function P(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,n.regExpFlags)(R)}:R}function I(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return T.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 14:return new Date(C.source)}if(C instanceof k.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=I(C[E],R+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=I(C[E],R+1))}return C}e.revive=I}),define(ne[19],ie([0,1,4,8]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(T=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}set(I,C,R){this._hosts[I]=C,this._ports[I]=R}setConnectionToken(I,C){this._connectionTokens[I]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)return this._delegate(I);const C=I.authority;let R=this._hosts[C];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const E=this._ports[C],m=this._connectionTokens[C];let S=`path=${encodeURIComponent(I.path)}`;return typeof m=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),n.URI.from({scheme:k.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${R}:${E}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new L;class A{asBrowserUri(I,C){const R=this.toUri(I,C);return R.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===T.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${T.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?R.with({scheme:T.vscodeFileResource,authority:R.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(I,C){const R=this.toUri(I,C);return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==A.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(I,C){return n.URI.isUri(I)?I:n.URI.parse(C.toUrl(I))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[20],ie([0,1,41,19,10,4,27,8]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(S){return(0,P.uriToFsPath)(S,!0)}e.originalFSPath=I;class C{constructor(d){this._ignorePathCasing=d}compare(d,v,g=!1){return d===v?0:(0,A.compare)(this.getComparisonKey(d,g),this.getComparisonKey(v,g))}isEqual(d,v,g=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,g)===this.getComparisonKey(v,g)}getComparisonKey(d,v=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,v,g=!1){if(d.scheme===v.scheme){if(d.scheme===n.Schemas.file)return k.isEqualOrParent(I(d),I(v),this._ignorePathCasing(d))&&d.query===v.query&&(g||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return k.isEqualOrParent(d.path,v.path,this._ignorePathCasing(d),"/")&&d.query===v.query&&(g||d.fragment===v.fragment)}return!1}joinPath(d,...v){return P.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===n.Schemas.file?v=P.URI.file(T.dirname(I(d))).path:(v=T.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===n.Schemas.file?v=P.URI.file(T.normalize(I(d))).path:v=T.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===n.Schemas.file){const y=T.relative(I(d),I(v));return L.isWindows?k.toSlashes(y):y}let g=d.path||"/",h=v.path||"/";if(this._ignorePathCasing(d)){let y=0;for(const w=Math.min(g.length,h.length);y<w&&!(g.charCodeAt(y)!==h.charCodeAt(y)&&g.charAt(y).toLowerCase()!==h.charAt(y).toLowerCase());y++);g=h.substr(0,y)+g.substr(y)}return T.posix.relative(g,h)}resolvePath(d,v){if(d.scheme===n.Schemas.file){const g=P.URI.file(T.resolve(I(d),v));return d.with({authority:g.authority,path:g.path})}return v=k.toPosixPath(v),d.with({path:T.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=T.sep){if(d.scheme===n.Schemas.file){const g=I(d);return g.length>k.getRoot(g).length&&g[g.length-1]===v}else{const g=d.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=T.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=T.sep){let g=!1;if(d.scheme===n.Schemas.file){const h=I(d);g=h!==void 0&&h.length===k.getRoot(h).length&&h[h.length-1]===v}else{v="/";const h=d.path;g=h.length===1&&h.charCodeAt(h.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(S=>S.scheme===n.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new C(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(S,d){const v=[];for(let g=0;g<S.length;g++){const h=d(S[g]);S.some((y,w)=>w===g?!1:(0,e.isEqualOrParent)(h,d(y)))||v.push(S[g])}return v}e.distinctParents=R;var E;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function d(v){const g=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(w=>{const[p,u]=w.split(":");p&&u&&g.set(p,u)});const y=v.path.substring(0,v.path.indexOf(";"));return y&&g.set(S.META_DATA_MIME,y),g}S.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function m(S,d,v){if(d){let g=S.path;return g&&g[0]!==T.posix.sep&&(g=T.posix.sep+g),S.with({scheme:v,authority:d,path:g})}return S.with({scheme:v})}e.toLocalResource=m}),define(ne[5],ie([0,1,25,7,3,2,20,4]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=I;function C(Q){const N=new k.CancellationTokenSource,U=Q(N.token),z=new Promise((j,ee)=>{const se=N.token.onCancellationRequested(()=>{se.dispose(),N.dispose(),ee(new n.CancellationError)});Promise.resolve(U).then(le=>{se.dispose(),N.dispose(),j(le)},le=>{se.dispose(),N.dispose(),ee(le)})});return new class{cancel(){N.cancel()}then(j,ee){return z.then(j,ee)}catch(j){return this.then(void 0,j)}finally(j){return z.finally(j)}}}e.createCancelablePromise=C;function R(Q,N,U){return new Promise((z,j)=>{const ee=N.onCancellationRequested(()=>{ee.dispose(),z(U)});Q.then(z,j).finally(()=>ee.dispose())})}e.raceCancellation=R;function E(Q,N){return new Promise((U,z)=>{const j=N.onCancellationRequested(()=>{j.dispose(),z(new n.CancellationError)});Q.then(U,z).finally(()=>j.dispose())})}e.raceCancellationError=E;async function m(Q){let N=-1;const U=Q.map((j,ee)=>j.then(se=>(N=ee,se))),z=await Promise.race(U);return Q.forEach((j,ee)=>{ee!==N&&j.cancel()}),z}e.raceCancellablePromises=m;function S(Q,N,U){let z;const j=setTimeout(()=>{z?.(void 0),U?.()},N);return Promise.race([Q.finally(()=>clearTimeout(j)),new Promise(ee=>z=ee)])}e.raceTimeout=S;function d(Q){return new Promise((N,U)=>{const z=Q();I(z)?z.then(N,U):N(z)})}e.asPromise=d;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(U,U).then(z)})}return new Promise((U,z)=>{this.queuedPromise.then(U,z)})}return this.activePromise=N(),new Promise((U,z)=>{this.activePromise.then(j=>{this.activePromise=null,U(j)},j=>{this.activePromise=null,z(j)})})}}e.Throttler=v;class g{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=g;class h{constructor(){this.promiseMap=new Map}queue(N,U){const j=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(N)===j&&this.promiseMap.delete(N)});return this.promiseMap.set(N,j),j}}e.SequencerByKey=h;const y=(Q,N)=>{let U=!0;const z=setTimeout(()=>{U=!1,N()},Q);return{isTriggered:()=>U,dispose:()=>{clearTimeout(z),U=!1}}},w=Q=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,Q())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,U=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,ee)=>{this.doResolve=j,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?w(z):y(U,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class u{constructor(N){this.delayer=new p(N),this.throttler=new v}trigger(N,U){return this.delayer.trigger(()=>this.throttler.queue(N),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class r{constructor(){this._isOpen=!1,this._promise=new Promise((N,U)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class c extends r{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function i(Q,N){return N?new Promise((U,z)=>{const j=setTimeout(()=>{ee.dispose(),U()},Q),ee=N.onCancellationRequested(()=>{clearTimeout(j),ee.dispose(),z(new n.CancellationError)})}):C(U=>i(Q,U))}e.timeout=i;function t(Q,N=0){const U=setTimeout(Q,N);return(0,L.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function s(Q){const N=[];let U=0;const z=Q.length;function j(){return U<z?Q[U++]():null}function ee(se){se!=null&&N.push(se);const le=j();return le?le.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.sequence=s;function o(Q,N=z=>!!z,U=null){let z=0;const j=Q.length,ee=()=>{if(z>=j)return Promise.resolve(U);const se=Q[z++];return Promise.resolve(se()).then(he=>N(he)?Promise.resolve(he):ee())};return ee()}e.first=o;function a(Q,N=z=>!!z,U=null){if(Q.length===0)return Promise.resolve(U);let z=Q.length;const j=()=>{z=-1;for(const ee of Q)ee.cancel?.()};return new Promise((ee,se)=>{for(const le of Q)le.then(he=>{--z>=0&&N(he)?(j(),ee(he)):z===0&&ee(U)}).catch(he=>{--z>=0&&(j(),se(he))})})}e.firstParallel=a;class l{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(N){return this._size++,new Promise((U,z)=>{this.outstandingPromises.push({factory:N,c:U,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const U=N.factory();U.then(N.c,N.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class f extends l{constructor(){super(1)}}e.Queue=f;class b{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new W;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,U=A.extUri){const z=U.getComparisonKey(N);let j=this.queues.get(z);return j||(j=new f,T.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(z),this.onDidQueueDrain()}),this.queues.set(z,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=b;class _{constructor(N,U){this._token=-1,typeof N=="function"&&typeof U=="number"&&this.setIfNotSet(N,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},U)}setIfNotSet(N,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},U))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,U){this.cancel(),this._token=setInterval(()=>{N()},U)}}e.IntervalTimer=O;class M{constructor(N,U){this.timeoutToken=-1,this.runner=N,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class D{constructor(N,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class F extends M{constructor(N,U){super(N,U);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class $ extends L.Disposable{constructor(N,U){super();this.options=N,this.handler=U,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,P.setTimeout0)(()=>{if(N)return;const U=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(Q,N)=>{const U=requestIdleCallback(Q,typeof N=="number"?{timeout:N}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(U))}}}}();class q{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function x(Q,N,U){let z;for(let j=0;j<U;j++)try{return await Q()}catch(ee){z=ee,await i(N)}throw z}e.retry=x;class G{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,U,z){return this._pending={taskId:N,cancel:()=>z?.(),promise:U},U.then(()=>this.donePending(N),()=>this.donePending(N)),U}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let U,z;const j=new Promise((ee,se)=>{U=ee,z=se});this._next={run:N,promise:j,promiseResolve:U,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=G;class B{constructor(N,U=()=>Date.now()){this.interval=N,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,U)=>{this.completeCallback=N,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(U=>{this.completeCallback(N),this.resolved=!0,U()})}error(N){return new Promise(U=>{this.errorCallback(N),this.rejected=!0,U()})}cancel(){new Promise(N=>{this.errorCallback(new n.CancellationError),this.rejected=!0,N()})}}e.DeferredPromise=W;var H;(function(Q){async function N(z){let j;const ee=await Promise.all(z.map(se=>se.then(le=>le,le=>{j||(j=le)})));if(typeof j!="undefined")throw j;return ee}Q.settled=N;function U(z){return new Promise(async(j,ee)=>{try{await z(j,ee)}catch(se){ee(se)}})}Q.withAsyncBody=U})(H=e.Promises||(e.Promises={}));var te;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(te||(te={}));class V{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const U={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(N(U)),this.resolve()}catch(z){this.reject(z)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(N){return new V(U=>{U.emitMany(N)})}static fromPromise(N){return new V(async U=>{U.emitMany(await N)})}static fromPromises(N){return new V(async U=>{await Promise.all(N.map(async z=>U.emitOne(await z)))})}static merge(N){return new V(async U=>{await Promise.all(N.map(async z=>{for await(const j of z)U.emitOne(j)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,U){return new V(async z=>{for await(const j of N)z.emitOne(U(j))})}map(N){return V.map(this,N)}static filter(N,U){return new V(async z=>{for await(const j of N)U(j)&&z.emitOne(j)})}filter(N){return V.filter(this,N)}static coalesce(N){return V.filter(N,U=>!!U)}coalesce(){return V.coalesce(this)}static async toPromise(N){const U=[];for await(const z of N)U.push(z);return U}toPromise(){return V.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class Z extends V{constructor(N,U){super(U);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function J(Q){const N=new k.CancellationTokenSource,U=Q(N.token);return new Z(N,async z=>{const j=N.token.onCancellationRequested(()=>{j.dispose(),N.dispose(),z.reject(new n.CancellationError)});try{for await(const ee of U){if(N.token.isCancellationRequested)return;z.emitOne(ee)}j.dispose(),N.dispose()}catch(ee){j.dispose(),N.dispose(),z.reject(ee)}})}e.createCancelableAsyncIterable=J}),define(ne[109],ie([0,1,5,41,39,10,4,27]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",R="[^/\\\\]",E=/\//g;function m(G,B){switch(G){case 0:return"";case 1:return`${R}*?`;default:return`(?:${C}|${R}+${C}${B?`|${C}${R}+`:""})*?`}}function S(G,B){if(!G)return[];const W=[];let H=!1,te=!1,V="";for(const Z of G){switch(Z){case B:if(!H&&!te){W.push(V),V="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":te=!0;break;case"]":te=!1;break}V+=Z}return V&&W.push(V),W}e.splitGlobAware=S;function d(G){if(!G)return"";let B="";const W=S(G,e.GLOB_SPLIT);if(W.every(H=>H===e.GLOBSTAR))B=".*";else{let H=!1;W.forEach((te,V)=>{if(te===e.GLOBSTAR){if(H)return;B+=m(2,V===W.length-1)}else{let Z=!1,J="",Q=!1,N="";for(const U of te){if(U!=="}"&&Z){J+=U;continue}if(Q&&(U!=="]"||!N)){let z;U==="-"?z=U:(U==="^"||U==="!")&&!N?z="^":U===e.GLOB_SPLIT?z="":z=(0,P.escapeRegExpCharacters)(U),N+=z;continue}switch(U){case"{":Z=!0;continue;case"[":Q=!0;continue;case"}":{B+=`(?:${S(J,",").map(ee=>d(ee)).join("|")})`,Z=!1,J="";break}case"]":{B+="["+N+"]",Q=!1,N="";break}case"?":B+=R;continue;case"*":B+=m(1);continue;default:B+=(0,P.escapeRegExpCharacters)(U)}}V<W.length-1&&(W[V+1]!==e.GLOBSTAR||V+2<W.length)&&(B+=C)}H=te===e.GLOBSTAR})}return B}const v=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new T.LRUCache(1e4),r=function(){return!1},c=function(){return null};function i(G,B){if(!G)return c;let W;typeof G!="string"?W=G.pattern:W=G,W=W.trim();const H=`${W}_${!!B.trimForExclusions}`;let te=u.get(H);if(te)return t(te,G);let V;return v.test(W)?te=o(W.substr(4),W):(V=g.exec(s(W,B)))?te=a(V[1],W):(B.trimForExclusions?y:h).test(W)?te=l(W,B):(V=w.exec(s(W,B)))?te=f(V[1].substr(1),W,!0):(V=p.exec(s(W,B)))?te=f(V[1],W,!1):te=b(W),u.set(H,te),t(te,G)}function t(G,B){return typeof B=="string"?G:function(W,H){return(0,n.isEqualOrParent)(W,B.base,!A.isLinux)?G(W.substr(B.base.length+1),H):null}}function s(G,B){return B.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function o(G,B){return function(W,H){return typeof W=="string"&&W.endsWith(G)?B:null}}function a(G,B){const W=`/${G}`,H=`\\${G}`,te=function(Z,J){return typeof Z!="string"?null:J?J===G?B:null:Z===G||Z.endsWith(W)||Z.endsWith(H)?B:null},V=[G];return te.basenames=V,te.patterns=[B],te.allBasenames=V,te}function l(G,B){const W=x(G.slice(1,-1).split(",").map(J=>i(J,B)).filter(J=>J!==c),G),H=W.length;if(!H)return c;if(H===1)return W[0];const te=function(J,Q){for(let N=0,U=W.length;N<U;N++)if(W[N](J,Q))return G;return null},V=W.find(J=>!!J.allBasenames);V&&(te.allBasenames=V.allBasenames);const Z=W.reduce((J,Q)=>Q.allPaths?J.concat(Q.allPaths):J,[]);return Z.length&&(te.allPaths=Z),te}function f(G,B,W){const H=L.sep===L.posix.sep,te=H?G:G.replace(E,L.sep),V=L.sep+te,Z=L.posix.sep+G;let J;return W?J=function(Q,N){return typeof Q=="string"&&(Q===te||Q.endsWith(V)||!H&&(Q===G||Q.endsWith(Z)))?B:null}:J=function(Q,N){return typeof Q=="string"&&(Q===te||!H&&Q===G)?B:null},J.allPaths=[(W?"*/":"./")+G],J}function b(G){try{const B=new RegExp(`^${d(G)}$`);return function(W){return B.lastIndex=0,typeof W=="string"&&B.test(W)?G:null}}catch{return c}}function _(G,B,W){return!G||typeof B!="string"?!1:O(G)(B,void 0,W)}e.match=_;function O(G,B={}){if(!G)return r;if(typeof G=="string"||M(G)){const W=i(G,B);if(W===c)return r;const H=function(te,V){return!!W(te,V)};return W.allBasenames&&(H.allBasenames=W.allBasenames),W.allPaths&&(H.allPaths=W.allPaths),H}return $(G,B)}e.parse=O;function M(G){const B=G;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=M;function D(G){return G.allBasenames||[]}e.getBasenameTerms=D;function F(G){return G.allPaths||[]}e.getPathTerms=F;function $(G,B){const W=x(Object.getOwnPropertyNames(G).map(J=>q(J,G[J],B)).filter(J=>J!==c)),H=W.length;if(!H)return c;if(!W.some(J=>!!J.requiresSiblings)){if(H===1)return W[0];const J=function(U,z){for(let j=0,ee=W.length;j<ee;j++){const se=W[j](U,z);if(se)return se}return null},Q=W.find(U=>!!U.allBasenames);Q&&(J.allBasenames=Q.allBasenames);const N=W.reduce((U,z)=>z.allPaths?U.concat(z.allPaths):U,[]);return N.length&&(J.allPaths=N),J}const te=function(J,Q,N){let U;for(let z=0,j=W.length;z<j;z++){const ee=W[z];ee.requiresSiblings&&N&&(Q||(Q=(0,L.basename)(J)),U||(U=Q.substr(0,Q.length-(0,L.extname)(J).length)));const se=ee(J,Q,U,N);if(se)return se}return null},V=W.find(J=>!!J.allBasenames);V&&(te.allBasenames=V.allBasenames);const Z=W.reduce((J,Q)=>Q.allPaths?J.concat(Q.allPaths):J,[]);return Z.length&&(te.allPaths=Z),te}function q(G,B,W){if(B===!1)return c;const H=i(G,W);if(H===c)return c;if(typeof B=="boolean")return H;if(B){const te=B.when;if(typeof te=="string"){const V=(Z,J,Q,N)=>{if(!N||!H(Z,J))return null;const U=te.replace("$(basename)",Q),z=N(U);return(0,k.isThenable)(z)?z.then(j=>j?G:null):z?G:null};return V.requiresSiblings=!0,V}}return H}function x(G,B){const W=G.filter(J=>!!J.basenames);if(W.length<2)return G;const H=W.reduce((J,Q)=>{const N=Q.basenames;return N?J.concat(N):J},[]);let te;if(B){te=[];for(let J=0,Q=H.length;J<Q;J++)te.push(B)}else te=W.reduce((J,Q)=>{const N=Q.patterns;return N?J.concat(N):J},[]);const V=function(J,Q){if(typeof J!="string")return null;if(!Q){let U;for(U=J.length;U>0;U--){const z=J.charCodeAt(U-1);if(z===47||z===92)break}Q=J.substr(U)}const N=H.indexOf(Q);return N!==-1?te[N]:null};V.basenames=H,V.patterns=te,V.allBasenames=H;const Z=G.filter(J=>!J.basenames);return Z.push(V),Z}}),define(ne[110],ie([0,1,8]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(R){return R.toJSON()}class T{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:n(k.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:n(k.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:k.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,E,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof k.URI)return E.transformOutgoing(R);for(let S in R)if(Object.hasOwnProperty.call(R,S)){const d=L(R[S],E,m+1);d!==null&&(R[S]=d)}}return null}function A(R,E){const m=L(R,E,0);return m===null?R:m}e.transformOutgoingURIs=A;function P(R,E,m,S){if(!R||S>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?k.URI.revive(E.transformIncoming(R)):E.transformIncoming(R);for(let d in R)if(Object.hasOwnProperty.call(R,d)){const v=P(R[d],E,m,S+1);v!==null&&(R[d]=v)}}return null}function I(R,E){const m=P(R,E,!1,0);return m===null?R:m}e.transformIncomingURIs=I;function C(R,E){const m=P(R,E,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=C}),define(ne[30],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(I){return k.test(I)}e.isUUID=n;const T=new Uint8Array(16),L=[];for(let I=0;I<256;I++)L.push(I.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};function P(){A(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let I=0,C="";return C+=L[T[I++]],C+=L[T[I++]],C+=L[T[I++]],C+=L[T[I++]],C+="-",C+=L[T[I++]],C+=L[T[I++]],C+="-",C+=L[T[I++]],C+=L[T[I++]],C+="-",C+=L[T[I++]],C+=L[T[I++]],C+="-",C+=L[T[I++]],C+=L[T[I++]],C+=L[T[I++]],C+=L[T[I++]],C+=L[T[I++]],C+=L[T[I++]],C}e.generateUuid=P}),define(ne[111],ie([0,1,250]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(L="utf8"){this.stringDecoder=new k.StringDecoder(L),this.remaining=null}write(L){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(P.length<1)return A;let I=0,C,R=I;for(;R<P.length;)if(C=P.charCodeAt(R),C===13||C===10){if(A.push(P.substring(I,R)),R++,R<P.length){const E=C;C=P.charCodeAt(R),(E===13&&C===10||E===10&&C===13)&&R++}I=R}else R++;return this.remaining=I<P.length?P.substr(I):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,34]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(A){const P=A.replace(/\-/g,":").toLowerCase();return!n.has(P)}function L(){const A=(0,k.networkInterfaces)();for(let P in A){const I=A[P];if(I){for(const{mac:C}of I)if(T(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[113],ie([0,1,34,7,39,30,112]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,E=0;const m=(0,k.networkInterfaces)();for(let S in m){const d=m[S];if(d)for(const{mac:v,internal:g}of d)g||(E+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(R+=1))}this._value=E>0?R/E:0}return this._value}};let P;async function I(){return P||(P=(async()=>await C()||L.generateUuid())()),P}e.getMachineId=I;async function C(){try{const R=await new Promise((m,S)=>{Y(["crypto"],m,S)}),E=(0,A.getMac)();return R.createHash("sha256").update(E,"utf8").digest("hex")}catch(R){n.onUnexpectedError(R);return}}}),define(ne[22],ie([0,1,50,34,251,5,41,72,10,4,20,8]),function(Y,e,k,n,T,L,A,P,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function S($,q=m.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return q===m.UNLINK?v($):d($)}async function d($){try{const q=(0,A.randomPath)((0,n.tmpdir)());try{await k.promises.rename($,q)}catch{return v($)}v(q).catch(x=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function v($){return(0,T.promisify)(k.rm)($,{recursive:!0,force:!0,maxRetries:3})}function g($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function h($,q){return p(await(q?y($):(0,T.promisify)(k.readdir)($)))}async function y($){try{return await(0,T.promisify)(k.readdir)($,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const q=[],x=await h($);for(const G of x){let B=!1,W=!1,H=!1;try{const te=await e.Promises.lstat((0,I.join)($,G));B=te.isFile(),W=te.isDirectory(),H=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}q.push({name:G,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>H})}return q}function w($){return p(k.readdirSync($))}e.readdirSync=w;function p($){return $.map(q=>typeof q=="string"?C.isMacintosh?(0,P.normalizeNFC)(q):q:(q.name=C.isMacintosh?(0,P.normalizeNFC)(q.name):q.name,q))}async function u($){const q=await h($),x=[];for(const G of q)await c.existsDirectory((0,I.join)($,G))&&x.push(G);return x}function r($,q=1e3){return new Promise(x=>{let G=!1;const B=setInterval(()=>{G||(G=!0,k.access($,W=>{G=!1,W&&(clearInterval(B),x(void 0))}))},q)})}e.whenDeleted=r;var c;(function($){async function q(B){let W;try{if(W=await e.Promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(C.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw te}throw H}}$.stat=q;async function x(B){try{const{stat:W,symbolicLink:H}=await $.stat(B);return W.isFile()&&H?.dangling!==!0}catch{}return!1}$.existsFile=x;async function G(B){try{const{stat:W,symbolicLink:H}=await $.stat(B);return W.isDirectory()&&H?.dangling!==!0}catch{}return!1}$.existsDirectory=G})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function t($,q,x){return i.queueFor(E.URI.file($),R.extUriBiasedIgnorePathCase).queue(()=>{const G=l(x);return new Promise((B,W)=>o($,q,G,H=>H?W(H):B()))})}let s=!0;function o($,q,x,G){if(!s)return k.writeFile($,q,{mode:x.mode,flag:x.flag},G);k.open($,x.flag,x.mode,(B,W)=>{if(B)return G(B);k.writeFile(W,q,H=>{if(H)return k.close(W,()=>G(H));k.fdatasync(W,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),s=!1),k.close(W,V=>G(V))))})})}function a($,q,x){const G=l(x);if(!s)return k.writeFileSync($,q,{mode:G.mode,flag:G.flag});const B=k.openSync($,G.flag,G.mode);try{k.writeFileSync(B,q);try{k.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),s=!1}}finally{k.closeSync(B)}}e.writeFileSync=a;function l($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function f($,q){if($!==q)try{await e.Promises.rename($,q)}catch(x){if($.toLowerCase()!==q.toLowerCase()&&x.code==="EXDEV"||$.endsWith("."))await b($,q,{preserveSymlinks:!1}),await S($,m.MOVE);else throw x}}async function b($,q,x){return O($,q,{root:{source:$,target:q},options:x,handledSourcePaths:new Set})}const _=511;async function O($,q,x){if(x.handledSourcePaths.has($))return;x.handledSourcePaths.add($);const{stat:G,symbolicLink:B}=await c.stat($);if(B){if(x.options.preserveSymlinks)try{return await F($,q,x)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(B.dangling)return}return G.isDirectory()?M($,q,G.mode&_,x):D($,q,G.mode&_)}async function M($,q,x,G){await e.Promises.mkdir(q,{recursive:!0,mode:x});const B=await h($);for(const W of B)await O((0,I.join)($,W),(0,I.join)(q,W),G)}async function D($,q,x){await e.Promises.copyFile($,q),await e.Promises.chmod(q,x)}async function F($,q,x){let G=await e.Promises.readlink($);(0,A.isEqualOrParent)(G,x.root.source,!C.isLinux)&&(G=(0,I.join)(x.root.target,G.substr(x.root.source.length+1))),await e.Promises.symlink(G,q)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return($,q,x,G,B)=>new Promise((W,H)=>{k.read($,q,x,G,B,(te,V,Z)=>te?H(te):W({bytesRead:V,buffer:Z}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return($,q,x,G,B)=>new Promise((W,H)=>{k.write($,q,x,G,B,(te,V,Z)=>te?H(te):W({bytesWritten:V,buffer:Z}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get rename(){return(0,T.promisify)(k.rename)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return S}get move(){return f}get copy(){return b}}}),define(ne[114],ie([0,1,50,10,4,27,22]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(m){if(T.isLinux)return m;const S=(0,n.dirname)(m);if(m===S)return m;const d=((0,n.basename)(m)||m).toLowerCase();try{const g=(0,A.readdirSync)(S).filter(h=>h.toLowerCase()===d);if(g.length===1){const h=P(S);if(h)return(0,n.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(d);if(h>=0){const y=P(S);if(y)return(0,n.join)(y,g[h])}}}catch{}return null}e.realcaseSync=P;async function I(m){if(T.isLinux)return m;const S=(0,n.dirname)(m);if(m===S)return m;const d=((0,n.basename)(m)||m).toLowerCase();try{const g=(await A.Promises.readdir(S)).filter(h=>h.toLowerCase()===d);if(g.length===1){const h=await I(S);if(h)return(0,n.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(d);if(h>=0){const y=await I(S);if(y)return(0,n.join)(y,g[h])}}}catch{}return null}e.realcase=I;async function C(m){try{return await A.Promises.realpath(m)}catch{const d=E(m);return await A.Promises.access(d,k.constants.R_OK),d}}e.realpath=C;function R(m){try{return k.realpathSync(m)}catch{const d=E(m);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=R;function E(m){return(0,L.rtrim)((0,n.normalize)(m),n.sep)}}),define(ne[115],ie([0,1,56]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(P,I,C,R=1){let E=!1;return new Promise(m=>{const S=setTimeout(()=>{if(!E)return E=!0,m(0)},C);T(P,I,R,d=>{if(!E)return E=!0,clearTimeout(S),m(d)})})}e.findFreePort=n;function T(P,I,C,R){if(I===0)return R(0);const E=new k.Socket;E.once("connect",()=>(A(E),T(P+C,I-1,C,R))),E.once("data",()=>{}),E.once("error",m=>(A(E),m.code!=="ECONNREFUSED"?T(P+C,I-1,C,R):R(P))),E.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,I,C){let R=!1,E,m=1;const S=k.createServer({pauseOnConnect:!0});function d(v,g){R||(R=!0,S.removeAllListeners(),S.close(),E&&clearTimeout(E),g(v))}return new Promise(v=>{E=setTimeout(()=>{d(0,v)},C),S.on("listening",()=>{d(P,v)}),S.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&m<I?(P++,m++,S.listen(P,"127.0.0.1")):d(0,v)}),S.on("close",()=>{d(0,v)}),S.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(ne[73],ie([0,1,34,10,22]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(I||(I={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class E{constructor(u,r,c){this.exePath=u,this.displayName=r,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await T.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:p=!1}={}){return p?C===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:p=!1,findPreview:u=!1}={}){const r=m({useAlternateBitness:p});if(!r)return null;const c=n.join(r,"PowerShell");if(!await T.SymlinkSupport.existsDirectory(c))return null;let i=-1,t=null;for(const a of await T.Promises.readdir(c)){let l=-1;if(u){const b=a.indexOf("-");if(b<0)continue;const _=a.substring(0,b);if(!L.test(_)||a.substring(b+1)!=="preview")continue;l=parseInt(_,10)}else{if(!L.test(a))continue;l=parseInt(a,10)}if(l<=i)continue;const f=n.join(c,a,"pwsh.exe");!await T.SymlinkSupport.existsFile(f)||(t=f,i=l)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=u?" Preview":"";return new E(t,`PowerShell${o}${s}`,!0)}async function d({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const u=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await T.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:c}=p?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await T.Promises.readdir(u))if(r.test(i)){const t=n.join(u,i,"pwsh.exe");return new E(t,c)}return null}function v(){const p=n.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(p,".NET Core PowerShell Global Tool")}function g(){const p=n.join(process.env.windir,C===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(p,"Windows PowerShell",!0)}async function*h(){let p=await S();p&&(yield p),p=await S({useAlternateBitness:!0}),p&&(yield p),p=await d(),p&&(yield p),p=v(),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await S({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=g(),p&&(yield p)}async function*y(){for await(const p of h())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=y;async function w(){for await(const p of y())return p;return null}e.getFirstAvailablePowerShellInstallation=w}),define(ne[116],ie([0,1,45,19]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(A){return new Promise((P,I)=>{let C;const R=new Map;function E(S,d,v,g,h){const y=R.get(d);if(S===A||y){const w={name:m(v),cmd:v,pid:S,ppid:d,load:g,mem:h};R.set(S,w),S===A&&(C=w),y&&(y.children||(y.children=[]),y.children.push(w),y.children.length>1&&(y.children=y.children.sort((p,u)=>p.pid-u.pid)))}}function m(S){const d=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,y=/--crashes-directory/,w=/\\pipe\\winpty-control/,p=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(y.exec(S))return"electron-crash-reporter";if(w.exec(S))return"winpty-process";if(p.exec(S))return"console-window-host (Windows internal process)";let r=u.exec(S);if(r&&r.length===2)return r[1]==="renderer"?d.exec(S)?"shared-process":v.exec(S)?"issue-reporter":g.exec(S)?"process-explorer":"window":r[1]==="utility"&&h.exec(S)?"utility-network-service":r[1];const c=/[a-zA-Z-]+\.js/g;let i="";do r=c.exec(S),r&&(i+=r+" ");while(r);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{Y(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(A,v=>{d.getProcessCpuUsage(v,g=>{const h=new Map;g.forEach(y=>{const w=S(y.commandLine||"");h.set(y.pid,{name:m(w),cmd:w,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),C=h.get(A),C?(h.forEach(y=>{const w=h.get(y.ppid);w&&(w.children||(w.children=[]),w.children.push(y))}),h.forEach(y=>{y.children&&(y.children=y.children.sort((w,p)=>w.pid-p.pid))}),P(C)):I(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let S=function(){let d=[C];const v=[];for(;d.length;){const h=d.shift();h&&(v.push(h.pid),h.children&&(d=d.concat(h.children)))}let g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);g+=" "+v.join(" "),(0,k.exec)(g,{},(h,y,w)=>{if(h||w)I(h||new Error(w.toString()));else{const p=y.toString().split(`
`);for(let u=0;u<v.length;u++){const r=R.get(v[u]);r.load=parseFloat(p[u])}if(!C){I(new Error(`Root process ${A} not found`));return}P(C)}})};(0,k.exec)("which ps",{},(d,v,g)=>{if(d||g)if(process.platform!=="linux")I(d||new Error(g.toString()));else{const h=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,k.exec)(h,{},(y,w,p)=>{y||p?I(y||new Error(p.toString())):(L(w,E),S())})}else{const h=v.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${h} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,p,u)=>{w||u&&!u.includes("screen size is bogus")?I(w||new Error(u.toString())):(L(p,E),process.platform==="linux"?S():C?P(C):I(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=T;function L(A,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=A.toString().split(`
`);for(const R of C){const E=I.exec(R.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var de=this&&this.__decorate||function(Y,e,k,n){var T=arguments.length,L=T<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,k):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Y,e,k,n);else for(var P=Y.length-1;P>=0;P--)(A=Y[P])&&(L=(T<3?A(L):T>3?A(e,k,L):A(e,k))||L);return T>3&&L&&Object.defineProperty(e,k,L),L};define(ne[36],ie([0,1,16,5,17,25,54,7,3,2,108,27,15]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function g(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(h||(h={}));class y{constructor(H){this.buffer=H,this.pos=0}read(H){const te=this.buffer.slice(this.pos,this.pos+H);return this.pos+=te.byteLength,te}}class w{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var p;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(p||(p={}));function u(W){const H=T.VSBuffer.alloc(4);return H.writeUInt32BE(W,0),H}function r(W){return W.read(4).readUInt32BE(0)}function c(W){const H=T.VSBuffer.alloc(1);return H.writeUInt8(W,0),H}const i={Undefined:c(p.Undefined),String:c(p.String),Buffer:c(p.Buffer),VSBuffer:c(p.VSBuffer),Array:c(p.Array),Object:c(p.Object)},t=typeof Buffer!="undefined";function s(W,H){if(typeof H=="undefined")W.write(i.Undefined);else if(typeof H=="string"){const te=T.VSBuffer.fromString(H);W.write(i.String),W.write(u(te.byteLength)),W.write(te)}else if(t&&Buffer.isBuffer(H)){const te=T.VSBuffer.wrap(H);W.write(i.Buffer),W.write(u(te.byteLength)),W.write(te)}else if(H instanceof T.VSBuffer)W.write(i.VSBuffer),W.write(u(H.byteLength)),W.write(H);else if(Array.isArray(H)){W.write(i.Array),W.write(u(H.length));for(const te of H)s(W,te)}else{const te=T.VSBuffer.fromString(JSON.stringify(H));W.write(i.Object),W.write(u(te.byteLength)),W.write(te)}}function o(W){switch(W.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return W.read(r(W)).toString();case p.Buffer:return W.read(r(W)).buffer;case p.VSBuffer:return W.read(r(W));case p.Array:{const te=r(W),V=[];for(let Z=0;Z<te;Z++)V.push(o(W));return V}case p.Object:return JSON.parse(W.read(r(W)).toString())}}class a{constructor(H,te,V=null,Z=1e3){this.protocol=H,this.ctx=te,this.logger=V,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(H,te){this.channels.set(H,te),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const te=this.send([H.type]);this.logger?.logOutgoing(te,0,1,g(H.type));return}case 201:case 202:case 204:case 203:{const te=this.send([H.type,H.id],H.data);this.logger?.logOutgoing(te,H.id,1,g(H.type),H.data);return}}}send(H,te=void 0){const V=new w;return s(V,H),s(V,te),this.sendBuffer(V.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const te=new y(H),V=o(te),Z=o(te),J=V[0];switch(J){case 100:return this.logger?.logIncoming(H.byteLength,V[1],1,`${d(J)}: ${V[2]}.${V[3]}`,Z),this.onPromise({type:J,id:V[1],channelName:V[2],name:V[3],arg:Z});case 102:return this.logger?.logIncoming(H.byteLength,V[1],1,`${d(J)}: ${V[2]}.${V[3]}`,Z),this.onEventListen({type:J,id:V[1],channelName:V[2],name:V[3],arg:Z});case 101:return this.logger?.logIncoming(H.byteLength,V[1],1,`${d(J)}`),this.disposeActiveRequest({type:J,id:V[1]});case 103:return this.logger?.logIncoming(H.byteLength,V[1],1,`${d(J)}`),this.disposeActiveRequest({type:J,id:V[1]})}}onPromise(H){const te=this.channels.get(H.channelName);if(!te){this.collectPendingRequest(H);return}const V=new L.CancellationTokenSource;let Z;try{Z=te.call(this.ctx,H.name,H.arg,V.token)}catch(N){Z=Promise.reject(N)}const J=H.id;Z.then(N=>{this.sendResponse({id:J,data:N,type:201}),this.activeRequests.delete(H.id)},N=>{N instanceof Error?this.sendResponse({id:J,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:J,data:N,type:203}),this.activeRequests.delete(H.id)});const Q=(0,C.toDisposable)(()=>V.cancel());this.activeRequests.set(H.id,Q)}onEventListen(H){const te=this.channels.get(H.channelName);if(!te){this.collectPendingRequest(H);return}const V=H.id,J=te.listen(this.ctx,H.name,H.arg)(Q=>this.sendResponse({id:V,data:Q,type:204}));this.activeRequests.set(H.id,J)}disposeActiveRequest(H){const te=this.activeRequests.get(H.id);te&&(te.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let te=this.pendingRequests.get(H.channelName);te||(te=[],this.pendingRequests.set(H.channelName,te));const V=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);te.push({request:H,timeoutTimer:V})}flushPendingRequests(H){const te=this.pendingRequests.get(H);if(te){for(const V of te)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var l;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(H,te=null){this.protocol=H,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=te}getChannel(H){const te=this;return{call(V,Z,J){return te.isDisposed?Promise.reject(P.canceled()):te.requestPromise(H,V,Z,J)},listen(V,Z){return te.isDisposed?I.Event.None:te.requestEvent(H,V,Z)}}}requestPromise(H,te,V,Z=L.CancellationToken.None){const J=this.lastRequestId++,N={id:J,type:100,channelName:H,name:te,arg:V};if(Z.isCancellationRequested)return Promise.reject(P.canceled());let U;return new Promise((j,ee)=>{if(Z.isCancellationRequested)return ee(P.canceled());const se=()=>{const we=ge=>{switch(ge.type){case 201:this.handlers.delete(J),j(ge.data);break;case 202:{this.handlers.delete(J);const pe=new Error(ge.data.message);pe.stack=ge.data.stack,pe.name=ge.data.name,ee(pe);break}case 203:this.handlers.delete(J),ee(ge.data);break}};this.handlers.set(J,we),this.sendRequest(N)};let le=null;this.state===h.Idle?se():(le=(0,n.createCancelablePromise)(we=>this.whenInitialized()),le.then(()=>{le=null,se()}));const he=()=>{le?(le.cancel(),le=null):this.sendRequest({id:J,type:101}),ee(P.canceled())},Se=Z.onCancellationRequested(he);U=(0,C.combinedDisposable)((0,C.toDisposable)(he),Se),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(H,te,V){const Z=this.lastRequestId++,Q={id:Z,type:102,channelName:H,name:te,arg:V};let N=null;const U=new I.Emitter({onFirstListenerAdd:()=>{N=(0,n.createCancelablePromise)(j=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(U),this.sendRequest(Q)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(U),this.sendRequest({id:Z,type:103}))}}),z=j=>U.fire(j.data);return this.handlers.set(Z,z),U.event}sendRequest(H){switch(H.type){case 100:case 102:{const te=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(te,H.id,0,`${d(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const te=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(te,H.id,0,d(H.type));return}}}send(H,te=void 0){const V=new w;return s(V,H),s(V,te),this.sendBuffer(V.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const te=new y(H),V=o(te),Z=o(te),J=V[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,g(J)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,V[1],0,g(J),Z),this.onResponse({type:V[0],id:V[1],data:Z})}}onResponse(H){if(H.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}const te=this.handlers.get(H.id);te&&te(H)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([A.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class b{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:te,onDidClientDisconnect:V})=>{I.Event.once(te.onMessage)(J=>{const Q=new y(J),N=o(Q),U=new a(te,N),z=new f(te);this.channels.forEach((ee,se)=>U.registerChannel(se,ee));const j={channelServer:U,channelClient:z,ctx:N};this._connections.add(j),this._onDidAddConnection.fire(j),V(()=>{U.dispose(),z.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const H=[];return this._connections.forEach(te=>H.push(te)),H}getChannel(H,te){const V=this;return{call(Z,J,Q){let N;if((0,m.isFunction)(te)){let z=(0,k.getRandomElement)(V.connections.filter(te));N=z?Promise.resolve(z):I.Event.toPromise(I.Event.filter(V.onDidAddConnection,te))}else N=te.routeCall(V,Z,J);const U=N.then(z=>z.channelClient.getChannel(H));return O(U).call(Z,J,Q)},listen(Z,J){if((0,m.isFunction)(te))return V.getMulticastEvent(H,te,Z,J);const Q=te.routeEvent(V,Z,J).then(N=>N.channelClient.getChannel(H));return O(Q).listen(Z,J)}}}getMulticastEvent(H,te,V,Z){const J=this;let Q=new C.DisposableStore;const N=new I.Emitter({onFirstListenerAdd:()=>{Q=new C.DisposableStore;const U=new I.EventMultiplexer,z=new Map,j=se=>{const he=se.channelClient.getChannel(H).listen(V,Z),Se=U.add(he);z.set(se,Se)},ee=se=>{const le=z.get(se);!le||(le.dispose(),z.delete(se))};J.connections.filter(te).forEach(j),I.Event.filter(J.onDidAddConnection,te)(j,void 0,Q),J.onDidRemoveConnection(ee,void 0,Q),U.event(N.fire,N,Q),Q.add(U)},onLastListenerRemove:()=>{Q.dispose()}});return N.event}registerChannel(H,te){this.channels.set(H,te),this._connections.forEach(V=>{V.channelServer.registerChannel(H,te)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class _{constructor(H,te,V=null){const Z=new w;s(Z,te),H.send(Z.buffer),this.channelClient=new f(H,V),this.channelServer=new a(H,te,V)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,te){this.channelServer.registerChannel(H,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(W){return{call(H,te,V){return W.then(Z=>Z.call(H,te,V))},listen(H,te){const V=new I.Relay;return W.then(Z=>V.input=Z.listen(H,te)),V.event}}}e.getDelayedChannel=O;function M(W){let H=!1;return{call(te,V,Z){return H?W.call(te,V,Z):(0,n.timeout)(0).then(()=>H=!0).then(()=>W.call(te,V,Z))},listen(te,V){if(H)return W.listen(te,V);const Z=new I.Relay;return(0,n.timeout)(0).then(()=>H=!0).then(()=>Z.input=W.listen(te,V)),Z.event}}}e.getNextTickChannel=M;class D{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const te of H.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await I.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=D;var F;(function(W){function H(J,Q){const N=J,U=Q&&Q.disableMarshalling,z=new Map;for(const j in N)V(j)&&z.set(j,I.Event.buffer(N[j],!0));return new class{listen(j,ee,se){const le=z.get(ee);if(le)return le;if(Z(ee)){const he=N[ee];if(typeof he=="function")return he.call(N,se)}throw new Error(`Event not found: ${ee}`)}call(j,ee,se){const le=N[ee];if(typeof le=="function"){if(!U&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,R.revive)(se[he]);return le.apply(N,se)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=H;function te(J,Q){const N=Q&&Q.disableMarshalling;return new Proxy({},{get(U,z){if(typeof z=="string")return Q?.properties?.has(z)?Q.properties.get(z):Z(z)?function(j){return J.listen(z,j)}:V(z)?J.listen(z):async function(...j){let ee;Q&&!(0,m.isUndefinedOrNull)(Q.context)?ee=[Q.context,...j]:ee=j;const se=await J.call(z,ee);return N?se:(0,R.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}W.toService=te;function V(J){return J[0]==="o"&&J[1]==="n"&&E.isUpperAsciiLetter(J.charCodeAt(2))}function Z(J){return/^onDynamic/.test(J)&&E.isUpperAsciiLetter(J.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let H=W.toString();if(H!=="[object Object]")return H}return W}function x(W){return Array.isArray(W)?W.map(q):q(W)}function G(W,H,te,V,Z,J,Q){Q=x(Q);const N=$[Z],U=N[V%N.length];let z=[`%c[${W}]%c[${String(H).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(J)?(z=z.concat(Q),z.push(")")):z.push(Q),console.log.apply(console,z)}e.logWithColors=G;class B{constructor(H,te){this._outgoingPrefix=H,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,te,V,Z,J){this._totalOutgoing+=H,G(this._outgoingPrefix,this._totalOutgoing,H,te,V,Z,J)}logIncoming(H,te,V,Z,J){this._totalIncoming+=H,G(this._incomingPrefix,this._totalIncoming,H,te,V,Z,J)}}e.IPCLogger=B}),define(ne[117],ie([0,1,17,3,36]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(I){this.port=I,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",C=>k.VSBuffer.wrap(C.data)),I.start()}send(I){this.port.postMessage(I.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends T.IPCClient{constructor(I,C){const R=new L(I);super(R,C);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[74],ie([0,1,17,3,2,36]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function a(f,b){if(!s.has(f)){const _=String(++o);s.set(f,_)}return s.get(f)}function l(f,b,_,O){if(!t.enableDiagnostics)return;const M=a(f,b);if(O instanceof k.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const D=k.VSBuffer.alloc(O.byteLength);D.set(O),t.records.push({timestamp:Date.now(),id:M,label:b,type:_,buff:D})}else t.records.push({timestamp:Date.now(),id:M,label:b,type:_,data:O})}t.traceSocketEvent=l})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=k.VSBuffer.alloc(0)),C}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const b=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),b}if(this._chunks[0].byteLength>s){const b=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),b}let a=k.VSBuffer.alloc(s),l=0,f=0;for(;s>0;){const b=this._chunks[f];if(b.byteLength>s){const _=b.slice(0,s);a.set(_,l),l+=s,o&&(this._chunks[f]=b.slice(s),this._totalLength-=s),s-=s}else a.set(b,l),l+=b.byteLength,o?(this._chunks.shift(),this._totalLength-=b.byteLength):f++,s-=b.byteLength}return a}}e.ChunkStream=E;var m;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(m||(m={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(s,o,a,l){this.type=s,this.id=o,this.ack=a,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends T.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,l=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new v(a,l,f,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=k.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const a=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,a}_bufferTake(){const s=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class y extends T.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new v(1,0,0,s))}}e.Protocol=y;class w extends L.IPCClient{constructor(s,o,a=null){super(s,o,a);this.protocol=s}static fromSocket(s,o){return new w(new y(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class u{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,a=this._first;for(;a;)s[o++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new u(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<c._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=c._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),o=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let l=0;l<c._HISTORY_LENGTH;l++)s-this.lastRuns[l]<=o&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class i{constructor(s,o=null,a=c.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new v(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new v(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new v(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,R());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let a=0,l=o.length;a<l;a++)this._socketWriter.write(o[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new v(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let a=0,l=o.length;a<l;a++)this._socketWriter.write(o[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new v(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const o=new v(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&a>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const f=Math.max(2e4-o,2e4-a,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,R());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,75,3,36,117]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends T.IPCServer{static getOnDidClientConnect(){const I=n.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(C,R)=>R);return n.Event.map(I,C=>{const{port1:R,port2:E}=new MessageChannel,S={protocol:new L.Protocol(R),onDidClientDisconnect:n.Event.fromDOMEventEmitter(R,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[E]),S})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[119],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function n(L){return L instanceof T?!0:L instanceof Error&&L.name===k&&L.message===k}e.isOfflineError=n;class T extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=T}),define(ne[120],ie([0,1,17,7,119]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(I,C){if(!navigator.onLine)throw new T.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const R=new XMLHttpRequest;return new Promise((E,m)=>{R.open(I.type||"GET",I.url||"",!0,I.user,I.password),A(R,I),R.responseType="arraybuffer",R.onerror=S=>m(new Error(R.statusText&&"XHR failed: "+R.statusText||"XHR failed")),R.onload=S=>{E({res:{statusCode:R.status,headers:P(R)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(R.response)))})},R.ontimeout=S=>m(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(R.timeout=I.timeout),R.send(I.data),C.onCancellationRequested(()=>{R.abort(),m((0,n.canceled)())})})}e.request=L;function A(I,C){if(C.headers){e:for(let R in C.headers){switch(R){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(R,C.headers[R])}}}function P(I){const C=Object.create(null);for(const R of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(R){const E=R.indexOf(":");C[R.substr(0,E).trim().toLowerCase()]=R.substr(E+1).trim()}return C}}),define(ne[76],ie([0,1,5,3,2,15]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class C extends T.Disposable{constructor(m,S=Object.create(null)){super();this.database=m,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=I.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((S,d)=>this.accept(d,S)),m.deleted?.forEach(S=>this.accept(S,void 0))}accept(m,S){if(this.state===I.Closed)return;let d=!1;(0,L.isUndefinedOrNull)(S)?d=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),d=!0),d&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===I.None&&(this.state=I.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const d=this.cache.get(m);return(0,L.isUndefinedOrNull)(d)?S:d}getBoolean(m,S){const d=this.get(m);return(0,L.isUndefinedOrNull)(d)?S:d==="true"}getNumber(m,S){const d=this.get(m);return(0,L.isUndefinedOrNull)(d)?S:parseInt(d,10)}async set(m,S){if(this.state===I.Closed)return;if((0,L.isUndefinedOrNull)(S))return this.delete(m);const d=String(S);if(this.cache.get(m)!==d)return this.cache.set(m,d),this.pendingInserts.set(m,d),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===I.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=I.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class R{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((S,d)=>this.items.set(d,S)),m.delete&&m.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=R}),define(ne[121],ie([11,12]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ne[57],ie([0,1,121]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,T=n*60,L=T*24,A=L*7,P=L*30,I=L*365;function C(E,m,S){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,k.localize)(0,null,C(new Date().getTime()+d*1e3,!1));if(d<30)return(0,k.localize)(1,null);let v;return d<n?(v=d,m?v===1?S?(0,k.localize)(2,null,v):(0,k.localize)(3,null,v):S?(0,k.localize)(4,null,v):(0,k.localize)(5,null,v):v===1?S?(0,k.localize)(6,null,v):(0,k.localize)(7,null,v):S?(0,k.localize)(8,null,v):(0,k.localize)(9,null,v)):d<T?(v=Math.floor(d/n),m?v===1?S?(0,k.localize)(10,null,v):(0,k.localize)(11,null,v):S?(0,k.localize)(12,null,v):(0,k.localize)(13,null,v):v===1?S?(0,k.localize)(14,null,v):(0,k.localize)(15,null,v):S?(0,k.localize)(16,null,v):(0,k.localize)(17,null,v)):d<L?(v=Math.floor(d/T),m?v===1?S?(0,k.localize)(18,null,v):(0,k.localize)(19,null,v):S?(0,k.localize)(20,null,v):(0,k.localize)(21,null,v):v===1?S?(0,k.localize)(22,null,v):(0,k.localize)(23,null,v):S?(0,k.localize)(24,null,v):(0,k.localize)(25,null,v)):d<A?(v=Math.floor(d/L),m?v===1?(0,k.localize)(26,null,v):(0,k.localize)(27,null,v):v===1?(0,k.localize)(28,null,v):(0,k.localize)(29,null,v)):d<P?(v=Math.floor(d/A),m?v===1?S?(0,k.localize)(30,null,v):(0,k.localize)(31,null,v):S?(0,k.localize)(32,null,v):(0,k.localize)(33,null,v):v===1?S?(0,k.localize)(34,null,v):(0,k.localize)(35,null,v):S?(0,k.localize)(36,null,v):(0,k.localize)(37,null,v)):d<I?(v=Math.floor(d/P),m?v===1?S?(0,k.localize)(38,null,v):(0,k.localize)(39,null,v):S?(0,k.localize)(40,null,v):(0,k.localize)(41,null,v):v===1?S?(0,k.localize)(42,null,v):(0,k.localize)(43,null,v):S?(0,k.localize)(44,null,v):(0,k.localize)(45,null,v)):(v=Math.floor(d/I),m?v===1?S?(0,k.localize)(46,null,v):(0,k.localize)(47,null,v):S?(0,k.localize)(48,null,v):(0,k.localize)(49,null,v):v===1?S?(0,k.localize)(50,null,v):(0,k.localize)(51,null,v):S?(0,k.localize)(52,null,v):(0,k.localize)(53,null,v))}e.fromNow=C;function R(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ne[122],ie([11,12]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,122]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(E,m){return m&&(E.stack||E.stacktrace)?T.localize(0,null,P(E),A(E.stack)||A(E.stacktrace)):P(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?T.localize(1,null,E.message):E.message||T.localize(2,null)}function I(E=null,m=!1){if(!E)return T.localize(3,null);if(Array.isArray(E)){const S=k.coalesce(E),d=I(S[0],m);return S.length>1?T.localize(4,null,d,S.length):d}if(n.isString(E))return E;if(E.detail){const S=E.detail;if(S.error)return L(S.error,m);if(S.exception)return L(S.exception,m)}return E.stack?L(E,m):E.message?E.message:T.localize(5,null)}e.toErrorMessage=I;function C(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=C;function R(E,m=Object.create(null)){const S=new Error(E);return m.actions&&(S.actions=m.actions),S}e.createErrorWithActions=R}),define(ne[123],ie([11,12]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ne[77],ie([0,1,45,41,19,29,10,4,33,103,15,111,22,123]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function d(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(r,c){if(P.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const t=k.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,a)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(P.isLinux||P.isMacintosh)try{const i=T.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{k.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,a)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function g(r){!r||(delete r.DEBUG,P.isMacintosh&&delete r.DYLD_LIBRARY_PATH,P.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function h(r=I.env){return r.comspec||"cmd.exe"}e.getWindowsShell=h;class y{constructor(c,i,t,s){if(i!==void 0&&t!==void 0&&s!==void 0)this.cmd=c,this.args=i,this.shell=t,this.options=s;else{const o=c;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(I.env).forEach(a=>{o[a]=I.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(A.sep);return i!==-1&&(c=c.substring(i+1)),y.WellKnowCommands[c]?c:"other"}start(c){return P.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(I.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let t,s;const o=new Promise((a,l)=>{t=a,s=l});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(l,f,b)=>{this.childProcess=null;const _=l;_&&_.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:b.toString()}):this.handleExec(t,c,l,f,b)})}else{let a=null;const l=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,t,c,s);const b={terminated:this.terminateRequested};R.isNumber(f)&&(b.cmdCode=f),t(b)};if(this.shell&&P.isWindows){const f=L.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let b=!1,_=!1;const O=[];let M=this.ensureQuotes(this.cmd);O.push(M.value),b=M.quoted,this.args&&this.args.forEach(F=>{M=this.ensureQuotes(F),O.push(M.value),_=_&&M.quoted});const D=["/s","/c"];b?_?D.push('"'+O.join(" ")+'"'):O.length>1?D.push('"'+O[0]+'" '+O.slice(1).join(" ")):D.push('"'+O[0]+'"'):D.push(O.join(" ")),a=k.spawn(h(),D,f)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(R.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",l),this.handleSpawn(a,t,c,s,!0)))}return o})}handleClose(c,i,t,s){}ensureQuotes(c){return y.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,v(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!P.isWindows)return c(!1);const i=k.spawn(h(),["/s","/c"]);i.on("error",t=>c(!0)),i.on("exit",t=>c(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class w extends y{constructor(c,i,t,s){super(c,i,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,t,s,o){[s,o].forEach((a,l)=>{const f=new E.LineDecoder;f.write(a).forEach(O=>{i({line:O,source:l===0?0:1})});const _=f.end();_&&i({line:_,source:l===0?0:1})}),c({terminated:this.terminateRequested,error:t})}handleSpawn(c,i,t,s,o){const a=new E.LineDecoder,l=new E.LineDecoder;c.stdout.on("data",f=>{a.write(f).forEach(_=>t({line:_,source:0}))}),c.stderr.on("data",f=>{l.write(f).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=l}handleClose(c,i,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=w;function p(r){let c=[],i=!1;const t=function(s){if(i){c.push(s);return}(!r.send(s,a=>{if(a&&console.error(a),i=!1,c.length>0){const l=c.slice(0);c=[],l.forEach(f=>t(f))}})||P.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=p;var u;(function(r){async function c(i,t,s){if(A.isAbsolute(i))return i;if(t===void 0&&(t=I.cwd()),A.dirname(i)!=="."||(s===void 0&&R.isString(I.env.PATH)&&(s=I.env.PATH.split(A.delimiter)),s===void 0||s.length===0))return A.join(t,i);async function a(l){if(await m.Promises.exists(l)){let f;try{f=await m.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&(f=await m.Promises.lstat(l))}return f?!f.isDirectory():!1}return!1}for(let l of s){let f;if(A.isAbsolute(l)?f=A.join(l,i):f=A.join(t,l,i),await a(f))return f;let b=f+".com";if(await a(b)||(b=f+".exe",await a(b)))return b}return A.join(t,i)}r.findExecutable=c})(u=e.win32||(e.win32={}))}),define(ne[124],ie([0,1,34,4,73,77]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(S,d){return S===1?n.isWindows?E():L.getWindowsShell(d):C(S,d)}e.getSystemShell=A;function P(S,d){return S===1?n.isWindows?m(d):L.getWindowsShell(d):C(S,d)}e.getSystemShellSync=P;let I=null;function C(S,d){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!I){let v;if(n.isWindows)v="/bin/bash";else{if(v=d.SHELL,!v)try{v=(0,k.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}I=v}return I}let R=null;async function E(){return R||(R=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),R}function m(S){if(R)return R;const d=n.isWindows&&parseFloat((0,k.release)())>=10,v=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${S.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?g:L.getWindowsShell(S)}}),define(ne[58],ie([0,1,45,5,17,25,107,7,3,2,29,77,36]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends m.ChannelServer{constructor(g){super({send:h=>{try{process.send&&process.send(h.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",h=>T.VSBuffer.wrap(Buffer.from(h,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=S;class d{constructor(g,h){this.modulePath=g,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new n.Delayer(y),this.child=null,this._client=null}getChannel(g){const h=this;return{call(y,w,p){return h.requestPromise(g,y,w,p)},listen(y,w){return h.requestEvent(g,y,w)}}}requestPromise(g,h,y,w=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(g),u=(0,n.createCancelablePromise)(i=>p.call(h,y,i)),r=w.onCancellationRequested(()=>u.cancel()),c=(0,C.toDisposable)(()=>u.cancel());return this.activeRequests.add(c),u.finally(()=>{r.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(g,h,y){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let w;const p=new I.Emitter({onFirstListenerAdd:()=>{w=this.getCachedChannel(g).listen(h,y)(p.fire,p),this.activeRequests.add(w)},onLastListenerRemove:()=>{this.activeRequests.delete(w),w.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(h.env),this.child=(0,k.fork)(this.modulePath,g,h);const y=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,A.isRemoteConsoleLog)(t)){(0,A.log)(t,`IPC Library: ${this.options.serverName}`);return}y.fire(T.VSBuffer.wrap(Buffer.from(t,"base64")))});const p=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,u=t=>this.child&&this.child.connected&&p.send(t.buffer.toString("base64")),r=y.event,c={send:u,onMessage:r};this._client=new m.ChannelClient(c);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,C.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(g){let h=this.channels.get(g);return h||(h=this.client.getChannel(g),this.channels.set(g,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(ne[125],ie([11,12]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(ne[126],ie([11,12]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[127],ie([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(ne[128],ie([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(ne[129],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(Y,e){return Y.create("vs/platform/shell/node/shellEnv",e)}),define(ne[142],ie([11,12]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[143],ie([11,12]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[144],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[145],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[146],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[147],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[148],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[149],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[78],ie([0,1,57,54,19,10,33,20,8]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(v,g,h){this._args=v,this.paths=g,this.productService=h}get appRoot(){return(0,L.dirname)(T.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=A.env.VSCODE_PORTABLE;return v?I.URI.file((0,L.join)(v,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,L.resolve)(v):(0,L.normalize)((0,L.join)(T.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=this.args["extensions-download-dir"];return v?(0,L.resolve)(v):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,L.resolve)(v);const g=A.env.VSCODE_EXTENSIONS;if(g)return g;const h=A.env.VSCODE_PORTABLE;return h?(0,L.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(g=>/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,L.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,L.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return I.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],C.prototype,"appRoot",null),de([n.memoize],C.prototype,"userHome",null),de([n.memoize],C.prototype,"userDataPath",null),de([n.memoize],C.prototype,"appSettingsHome",null),de([n.memoize],C.prototype,"tmpDir",null),de([n.memoize],C.prototype,"cacheHome",null),de([n.memoize],C.prototype,"userRoamingDataHome",null),de([n.memoize],C.prototype,"settingsResource",null),de([n.memoize],C.prototype,"userDataSyncHome",null),de([n.memoize],C.prototype,"userDataSyncLogResource",null),de([n.memoize],C.prototype,"sync",null),de([n.memoize],C.prototype,"machineSettingsResource",null),de([n.memoize],C.prototype,"globalStorageHome",null),de([n.memoize],C.prototype,"workspaceStorageHome",null),de([n.memoize],C.prototype,"localHistoryHome",null),de([n.memoize],C.prototype,"keybindingsResource",null),de([n.memoize],C.prototype,"keyboardLayoutResource",null),de([n.memoize],C.prototype,"argvResource",null),de([n.memoize],C.prototype,"snippetsHome",null),de([n.memoize],C.prototype,"isExtensionDevelopment",null),de([n.memoize],C.prototype,"untitledWorkspacesHome",null),de([n.memoize],C.prototype,"installSourcePath",null),de([n.memoize],C.prototype,"builtinExtensionsPath",null),de([n.memoize],C.prototype,"extensionsPath",null),de([n.memoize],C.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],C.prototype,"extensionDevelopmentKind",null),de([n.memoize],C.prototype,"extensionTestsLocationURI",null),de([n.memoize],C.prototype,"debugExtensionHost",null),de([n.memoize],C.prototype,"serviceMachineIdResource",null),de([n.memoize],C.prototype,"telemetryLogResource",null),de([n.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function R(d,v){return S(d["inspect-extensions"],d["inspect-brk-extensions"],5870,v,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=R;function E(d,v){return S(d["inspect-search"],d["inspect-brk-search"],5876,v,d.extensionEnvironment)}e.parseSearchPort=E;function m(d,v){return S(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,v,d.extensionEnvironment)}e.parsePtyHostPort=m;function S(d,v,g,h,y,w){const u=Number(v||d)||(h?null:g),r=u?Boolean(!!v):!1;let c;if(w)try{c=JSON.parse(w)}catch{}return{port:u,break:r,debugId:y,env:c}}}),define(ne[150],ie([0,1,252,4,127]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,T.localize)(0,null),e:(0,T.localize)(1,null),t:(0,T.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,T.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,T.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,T.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,T.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,T.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,T.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,T.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,T.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,T.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,T.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,T.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,T.localize)(14,null)},category:{type:"string",cat:"e",description:(0,T.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,T.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,T.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,T.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,T.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,T.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,T.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,T.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,T.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,T.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,T.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,T.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,T.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,T.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,T.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,T.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,T.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,T.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function P(d,v,g=A){const h={},y=["_"],w=[];for(let c in v){const i=v[c];i.alias&&(h[c]=i.alias),i.type==="string"||i.type==="string[]"?(y.push(c),i.deprecates&&y.push(...i.deprecates)):i.type==="boolean"&&(w.push(c),i.deprecates&&w.push(...i.deprecates))}const p=k(d,{string:y,boolean:w,alias:h}),u={},r=p;u._=p._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(let c in v){const i=v[c];i.alias&&delete r[i.alias];let t=r[c];if(i.deprecates)for(const s of i.deprecates)r.hasOwnProperty(s)&&(t||(t=r[s],t&&g.onDeprecatedOption(s,i.deprecationMessage||(0,T.localize)(33,null))),delete r[s]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),g.onMultipleValues(c,t)),u[c]=t,i.deprecationMessage&&g.onDeprecatedOption(c,i.deprecationMessage)),delete r[c]}for(let c in r)g.onUnknownOption(c);return u}e.parseArgs=P;function I(d,v){let g="";return v.args&&(Array.isArray(v.args)?g=` <${v.args.join("> <")}>`:g=` <${v.args}>`),v.alias?`-${v.alias} --${d}${g}`:`--${d}${g}`}function C(d,v){let g=0,h=[];for(const u in d){const r=d[u],c=I(u,r);g=Math.max(g,c.length),h.push([c,r.description])}let y=g+2+1;if(v-y<25)return h.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let w=v-y-1,p=[];for(const u of h){let r=u[0],c=E(u[1],w),i=R(y-r.length-2);p.push("  "+r+i+c[0]);for(let t=1;t<c.length;t++)p.push(R(y)+c[t])}return p}e.formatOptions=C;function R(d){return" ".repeat(d)}function E(d,v){let g=[];for(;d.length;){let h=d.length<v?d.length:d.lastIndexOf(" ",v),y=d.slice(0,h).trim();d=d.slice(h),g.push(y)}return g}function m(d,v,g,h,y){const w=process.stdout.isTTY&&process.stdout.columns||80,p=y?.noInputFiles!==!0?`[${(0,T.localize)(34,null)}...]`:"",u=[`${d} ${g}`];u.push(""),u.push(`${(0,T.localize)(35,null)}: ${v} [${(0,T.localize)(36,null)}]${p}`),u.push(""),y?.noPipe!==!0&&(n.isWindows?u.push((0,T.localize)(37,null,v)):u.push((0,T.localize)(38,null,v)),u.push(""));const r={};for(const c in h){const i=h[c];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[c]=i}}for(let c in r){const i=c;let t=r[i];t&&(u.push(L[i]),u.push(...C(t,w)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=m;function S(d,v){return`${d||(0,T.localize)(39,null)}
${v||(0,T.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=S}),define(ne[151],ie([0,1,253,128,150]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(m,S){const d={onUnknownOption:g=>{console.warn((0,n.localize)(0,null,g))},onMultipleValues:(g,h)=>{console.warn((0,n.localize)(1,null,g,h))},onDeprecatedOption:(g,h)=>{console.warn((0,n.localize)(2,null,g,h))}},v=(0,T.parseArgs)(m,T.OPTIONS,S?d:void 0);return v.goto&&v._.forEach(g=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,n.localize)(3,null))),v["max-memory"]&&k(parseInt(v["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),v}function P(m){const S=m.findIndex(d=>!/^-/.test(d));if(S>-1)return[...m.slice(0,S),...m.slice(S+1)]}function I(m){let[,...S]=m;process.env.VSCODE_DEV&&(S=P(S)||[]);const d=!E(process.env);return A(S,d)}e.parseMainProcessArgv=I;function C(m){const[,,...S]=m;return A(S,!0)}e.parseCLIProcessArgv=C;function R(m,...S){const d=m.indexOf("--");return d===-1?m.push(...S):m.splice(d,0,...S),m}e.addArg=R;function E(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function Y(e,k,n,T){function L(P){const I=A(P),C=[I];return e.isAbsolute(I)||C.unshift(T),e.resolve(...C)}function A(P){const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,n);const R=P["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(E,"AppData","Roaming")}break;case"darwin":C=e.join(k.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,n)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[152],ie([0,254,34,19,20,33]),function(e,k,n,T,L,A){const P=L.dirname(T.FileAccess.asFileUri("",e)),I=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return Y(k,n,I.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),n=require("os");module.exports=Y(k,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[153],ie([0,1,34,78,152]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends n.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(P)},I)}}e.NativeEnvironmentService=L}),define(ne[154],ie([0,1,8]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,T=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(g){const h=g.match(A);return h?h[1]:null}function R(g){if(g.indexOf("://")===-1){const h=g.match(n);return h?C(h[2]):null}try{const h=k.URI.parse(g);if(h.authority)return C(h.authority)}catch{}return null}function E(g,h){const y=new Set;let w;for(;w=P.exec(g);){const u=R(w[1]);u&&y.add(u)}const p=new Set(h);return Array.from(y).map(u=>p.has(u)?u:u.replace(I,"a"))}e.getDomainsOfRemotes=E;function m(g){const h=g.match(L);return h?h[2]:null}function S(g,h,y){return g&&h?(y&&h.endsWith(".git")&&(h=h.substr(0,h.length-4)),h.indexOf("/")===0?`${g}${h}`:`${g}/${h}`):null}function d(g,h){if(g.indexOf("://")===-1){const y=g.match(T);if(y)return S(y[2],y[3],h)}try{const y=k.URI.parse(g);if(y.authority)return S(m(y.authority),y.path,h)}catch{}return null}function v(g,h=!1){const y=[];let w;for(;w=P.exec(g);){const p=d(w[1],h);p&&y.push(p)}return y}e.getRemotes=v}),define(ne[155],ie([0,1,29]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function T(L,A){const P=I=>{if(typeof I!="string")return;const C=n.exec(I);if(!C)return;const R=A[C[1]]??I;return typeof R=="string"?R:typeof R.message=="string"?R.message:I};return(0,k.cloneAndChange)(L,P)}e.localizeManifest=T}),define(ne[156],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,P,I){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,P,I])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class n{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[79],ie([0,1,135]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function L(m){return m=m.trim(),m==="*"||n.test(m)}e.isValidVersionStr=L;function A(m){if(!L(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=m.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=A;function P(m){if(!m)return null;let S=m.majorBase,d=m.majorMustEqual,v=m.minorBase,g=m.minorMustEqual,h=m.patchBase,y=m.patchMustEqual;m.hasCaret&&(S===0||(g=!1),y=!1);let w=0;if(m.preRelease){const p=T.exec(m.preRelease);if(p){const[,u,r,c]=p;w=Date.UTC(Number(u),Number(r)-1,Number(c))}}return{majorBase:S,majorMustEqual:d,minorBase:v,minorMustEqual:g,patchBase:h,patchMustEqual:y,isMinimum:m.hasGreaterEquals,notBefore:w}}e.normalizeVersion=P;function I(m,S,d){let v;typeof m=="string"?v=P(A(m)):v=m;let g;S instanceof Date?g=S.getTime():typeof S=="string"&&(g=new Date(S).getTime());let h;if(typeof d=="string"?h=P(A(d)):h=d,!v||!h)return!1;let y=v.majorBase,w=v.minorBase,p=v.patchBase,u=h.majorBase,r=h.minorBase,c=h.patchBase,i=h.notBefore,t=h.majorMustEqual,s=h.minorMustEqual,o=h.patchMustEqual;return h.isMinimum?y>u?!0:y<u?!1:w>r?!0:w<r||g&&g<i?!1:p>=c:(y===1&&u===0&&(!t||!s||!o)&&(u=1,r=0,c=0,t=!0,s=!1,o=!1),y<u?!1:y>u?!t:w<r?!1:w>r?!s:p<c?!1:p>c?!o:!(g&&g<i))}e.isValidVersion=I;function C(m,S,d,v,g){return v||typeof d.main=="undefined"&&typeof d.browser=="undefined"?!0:E(m,S,d.engines.vscode,g)}e.isValidExtensionVersion=C;function R(m,S,d){return m==="*"||E(S,d,m)}e.isEngineValid=R;function E(m,S,d,v=[]){let g=P(A(d));if(!g)return v.push(k.localize(0,null,d)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return v.push(k.localize(1,null,d)),!1}else if(!g.majorMustEqual)return v.push(k.localize(2,null,d)),!1;return I(m,S,g)?!0:(v.push(k.localize(3,null,m,d)),!1)}}),define(ne[46],ie([0,1,17,30]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(L,A,P){let I=P&&P.get("storage.serviceMachineId",0)||null;if(I)return I;try{const R=(await A.readFile(L.serviceMachineIdResource)).value.toString();I=(0,n.isUUID)(R)?R:null}catch{I=null}if(!I){I=(0,n.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return P&&P.store("storage.serviceMachineId",I,0,1),I}e.getServiceMachineId=T}),define(ne[51],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(T,L=[],A=!1){this.ctor=T,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(ne[80],ie([0,1,51]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function T(A,P,I){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],I)),n.push([A,P])}e.registerSingleton=T;function L(){return n}e.getSingletonServiceDescriptors=L}),define(ne[157],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=k;class n{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const P=this.lookupOrInsertNode(L),I=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),I),I.incoming.set(this._hashFn(L),P)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let P=this._nodes.get(A);return P||(P=new k(L),this._nodes.set(A,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[A,P]of this._nodes)L.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,A]of this._nodes){const P=new Set([L]),I=this._findCycle(A,P);if(I)return I}}_findCycle(L,A){for(let[P,I]of L.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const C=this._findCycle(I,A);if(C)return C;A.delete(P)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(k=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function n(A,P,I){P[k.DI_TARGET]===P?P[k.DI_DEPENDENCIES].push({id:A,index:I}):(P[k.DI_DEPENDENCIES]=[{id:A,index:I}],P[k.DI_TARGET]=P)}function T(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const P=function(I,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(P,I,R)};return P.toString=()=>A,k.serviceIds.set(A,P),P}e.createDecorator=T;function L(A){return A}e.refineServiceDecorator=L}),define(ne[158],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(ne[18],ie([0,1,15,8,6]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof n.URI)}e.isConfigurationOverrides=L;function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||k.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function C(h,y){const w=Object.create(null);for(let p in h)R(w,p,h[p],y);return w}e.toValuesTree=C;function R(h,y,w,p){const u=y.split("."),r=u.pop();let c=h;for(let i=0;i<u.length;i++){let t=u[i],s=c[t];switch(typeof s){case"undefined":s=c[t]=Object.create(null);break;case"object":break;default:p(`Ignoring ${y} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}c=s}if(typeof c=="object"&&c!==null)try{c[r]=w}catch{p(`Ignoring ${y} as ${u.join(".")} is ${JSON.stringify(c)}`)}else p(`Ignoring ${y} as ${u.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=R;function E(h,y){const w=y.split(".");m(h,w)}e.removeFromValueTree=E;function m(h,y){const w=y.shift();if(y.length===0){delete h[w];return}if(Object.keys(h).indexOf(w)!==-1){const p=h[w];typeof p=="object"&&!Array.isArray(p)&&(m(p,y),Object.keys(p).length===0&&delete h[w])}}function S(h,y,w){function p(c,i){let t=c;for(const s of i){if(typeof t!="object"||t===null)return;t=t[s]}return t}const u=y.split("."),r=p(h,u);return typeof r=="undefined"?w:r}e.getConfigurationValue=S;function d(h,y,w){Object.keys(y).forEach(p=>{p!=="__proto__"&&(p in h?k.isObject(h[p])&&k.isObject(y[p])?d(h[p],y[p],w):w&&(h[p]=y[p]):h[p]=y[p])})}e.merge=d;function v(h,y,w){const p=h.inspect(y),u=h.inspect(w);return typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:p.defaultValue}e.getMigratedSettingValue=v;function g(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(ne[159],ie([0,1,4,27,6]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",k.isMacintosh),L.set("isLinux",k.isLinux),L.set("isWindows",k.isWindows),L.set("isWeb",k.isWeb),L.set("isMacNative",k.isMacintosh&&!k.isWeb),L.set("isEdge",k.isEdge),L.set("isFirefox",k.isFirefox),L.set("isChrome",k.isChrome),L.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var P;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return E.INSTANCE}static true(){return m.INSTANCE}static has(D){return S.create(D)}static equals(D,F){return d.create(D,F)}static notEquals(D,F){return h.create(D,F)}static regex(D,F){return i.create(D,F)}static in(D,F){return v.create(D,F)}static not(D){return y.create(D)}static and(...D){return o.create(D,null)}static or(...D){return a.create(D,null,!0)}static greater(D,F){return p.create(D,F)}static greaterEquals(D,F){return u.create(D,F)}static smaller(D,F){return r.create(D,F)}static smallerEquals(D,F){return c.create(D,F)}static deserialize(D,F=!1){if(!!D)return this._deserializeOrExpression(D,F)}static _deserializeOrExpression(D,F){let $=D.split("||");return a.create($.map(q=>this._deserializeAndExpression(q,F)),null,!0)}static _deserializeAndExpression(D,F){let $=D.split("&&");return o.create($.map(q=>this._deserializeOne(q,F)),null)}static _deserializeOne(D,F){if(D=D.trim(),D.indexOf("!=")>=0){let $=D.split("!=");return h.create($[0].trim(),this._deserializeValue($[1],F))}if(D.indexOf("==")>=0){let $=D.split("==");return d.create($[0].trim(),this._deserializeValue($[1],F))}if(D.indexOf("=~")>=0){let $=D.split("=~");return i.create($[0].trim(),this._deserializeRegexValue($[1],F))}if(D.indexOf(" in ")>=0){let $=D.split(" in ");return v.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const $=D.split(">=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const $=D.split(">");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const $=D.split("<=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const $=D.split("<");return r.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(D)?y.create(D.substr(1).trim()):S.create(D)}static _deserializeValue(D,F){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let $=/^'([^']*)'$/.exec(D);return $?$[1].trim():D}static _deserializeRegexValue(D,F){if((0,n.isFalsyOrWhitespace)(D)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=D.indexOf("/"),q=D.lastIndexOf("/");if($===q||$<0){if(F)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let x=D.slice($+1,q),G=D[q+1]==="i"?"i":"";try{return new RegExp(x,G)}catch(B){if(F)throw new Error(`bad regexp-value '${D}', parse error: ${B}`);return console.warn(`bad regexp-value '${D}', parse error: ${B}`),null}}}e.ContextKeyExpr=I;function C(M,D){const F=M?M.substituteConstants():void 0,$=D?D.substituteConstants():void 0;return!F&&!$?!0:!F||!$?!1:F.equals($)}e.expressionsAreEqualWithConstantSubstitution=C;function R(M,D){return M.cmp(D)}class E{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class S{constructor(D,F){this.key=D,this.negated=F,this.type=2}static create(D,F=null){const $=L.get(D);return typeof $=="boolean"?$?m.INSTANCE:E.INSTANCE:new S(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:f(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=L.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:E.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class d{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=4}static create(D,F,$=null){if(typeof F=="boolean")return F?S.create(D,$):y.create(D,$);const q=L.get(D);return typeof q=="boolean"?F===(q?"true":"false")?m.INSTANCE:E.INSTANCE:new d(D,F,$)}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=L.get(this.key);if(typeof D=="boolean"){const F=D?"true":"false";return this.value===F?m.INSTANCE:E.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class v{constructor(D,F){this.key=D,this.valueKey=F,this.type=10,this.negated=null}static create(D,F){return new v(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const F=D.getValue(this.valueKey),$=D.getValue(this.key);return Array.isArray(F)?F.indexOf($)>=0:typeof $=="string"&&typeof F=="object"&&F!==null?A.call(F,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=v;class g{constructor(D){this._actual=D,this.type=11}static create(D){return new g(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new g(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class h{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=5}static create(D,F,$=null){if(typeof F=="boolean")return F?y.create(D,$):S.create(D,$);const q=L.get(D);return typeof q=="boolean"?F===(q?"true":"false")?E.INSTANCE:m.INSTANCE:new h(D,F,$)}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=L.get(this.key);if(typeof D=="boolean"){const F=D?"true":"false";return this.value===F?E.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class y{constructor(D,F){this.key=D,this.negated=F,this.type=3}static create(D,F=null){const $=L.get(D);return typeof $=="boolean"?$?E.INSTANCE:m.INSTANCE:new y(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:f(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=L.get(this.key);return typeof D=="boolean"?D?E.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;function w(M,D){if(typeof M=="string"){const F=parseFloat(M);isNaN(F)||(M=F)}return typeof M=="string"||typeof M=="number"?D(M):E.INSTANCE}class p{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=12}static create(D,F,$=null){return w(F,q=>new p(D,q,$))}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class u{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=13}static create(D,F,$=null){return w(F,q=>new u(D,q,$))}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class r{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=14}static create(D,F,$=null){return w(F,q=>new r(D,q,$))}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class c{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=15}static create(D,F,$=null){return w(F,q=>new c(D,q,$))}cmp(D){return D.type!==this.type?this.type-D.type:b(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class i{constructor(D,F){this.key=D,this.regexp=F,this.type=7,this.negated=null}static create(D,F){return new i(D,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const F=this.regexp?this.regexp.source:"",$=D.regexp?D.regexp.source:"";return F<$?-1:F>$?1:0}equals(D){if(D.type===this.type){const F=this.regexp?this.regexp.source:"",$=D.regexp?D.regexp.source:"";return this.key===D.key&&F===$}return!1}substituteConstants(){return this}evaluate(D){let F=D.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class t{constructor(D){this._actual=D,this.type=8}static create(D){return new t(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new t(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function s(M){let D=null;for(let F=0,$=M.length;F<$;F++){const q=M[F].substituteConstants();if(M[F]!==q&&D===null){D=[];for(let x=0;x<F;x++)D[x]=M[x]}D!==null&&(D[F]=q)}return D===null?M:D}class o{constructor(D,F){this.expr=D,this.negated=F,this.type=6}static create(D,F){return o._normalizeArr(D,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const q=R(this.expr[F],D.expr[F]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:o.create(D,this.negated)}evaluate(D){for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].evaluate(D))return!1;return!0}static _normalizeArr(D,F){const $=[];let q=!1;for(const x of D)if(!!x){if(x.type===1){q=!0;continue}if(x.type===0)return E.INSTANCE;if(x.type===6){$.push(...x.expr);continue}$.push(x)}if($.length===0&&q)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let x=1;x<$.length;x++)$[x-1].equals($[x])&&($.splice(x,1),x--);if($.length===1)return $[0];for(;$.length>1;){const x=$[$.length-1];if(x.type!==9)break;$.pop();const G=$.pop(),B=$.length===0,W=a.create(x.expr.map(H=>o.create([H,G],null)),null,B);W&&($.push(W),$.sort(R))}return $.length===1?$[0]:new o($,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let F of this.expr)D.push(...F.keys());return D}map(D){return new o(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.negated){const D=[];for(let F of this.expr)D.push(F.negate());this.negated=a.create(D,this,!0)}return this.negated}}class a{constructor(D,F){this.expr=D,this.negated=F,this.type=9}static create(D,F,$){return a._normalizeArr(D,F,$)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const q=R(this.expr[F],D.expr[F]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:a.create(D,this.negated,!1)}evaluate(D){for(let F=0,$=this.expr.length;F<$;F++)if(this.expr[F].evaluate(D))return!0;return!1}static _normalizeArr(D,F,$){let q=[],x=!1;if(D){for(let G=0,B=D.length;G<B;G++){const W=D[G];if(!!W){if(W.type===0){x=!0;continue}if(W.type===1)return m.INSTANCE;if(W.type===9){q=q.concat(W.expr);continue}q.push(W)}}if(q.length===0&&x)return E.INSTANCE;q.sort(R)}if(q.length!==0){if(q.length===1)return q[0];for(let G=1;G<q.length;G++)q[G-1].equals(q[G])&&(q.splice(G,1),G--);if(q.length===1)return q[0];if($){for(let G=0;G<q.length;G++)for(let B=G+1;B<q.length;B++)_(q[G],q[B])&&(q.splice(B,1),B--);if(q.length===1)return q[0]}return new a(q,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let F of this.expr)D.push(...F.keys());return D}map(D){return new a(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.negated){let D=[];for(let F of this.expr)D.push(F.negate());for(;D.length>1;){const F=D.shift(),$=D.shift(),q=[];for(const G of O(F))for(const B of O($))q.push(o.create([G,B],null));const x=D.length===0;D.unshift(a.create(q,null,x))}this.negated=D[0]}return this.negated}}class l extends S{constructor(D,F,$){super(D,null);this._defaultValue=F,typeof $=="object"?l._info.push({...$,key:D}):$!==!0&&l._info.push({key:D,description:$,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return d.create(this.key,D)}notEqualsTo(D){return h.create(this.key,D)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(M,D){return M<D?-1:M>D?1:0}function b(M,D,F,$){return M<F?-1:M>F?1:D<$?-1:D>$?1:0}function _(M,D){if(D.type===6&&M.type!==9&&M.type!==6){for(const q of D.expr)if(M.equals(q))return!0}const F=M.negate(),$=O(F).concat(O(D));$.sort(R);for(let q=0;q<$.length;q++){const G=$[q].negate();for(let B=q+1;B<$.length;B++){const W=$[B];if(G.equals(W))return!0}}return!1}e.implies=_;function O(M){return M.type===9?M.expr:[M]}}),define(ne[81],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n;class T{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=T}),define(ne[82],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(ne[13],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[28],ie([0,1,130,6]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(h,y){switch(h){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(h,y){return y==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(h,y,w){return P(y,w)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===w?!0:C(w).includes(h)}e.isTargetPlatformCompatible=I;function C(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var S;(function(h){h.Install="install",h.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var v;(function(h){h.Unsupported="Unsupported",h.UnsupportedPreRelease="UnsupportedPreRelease",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(y,w){super(y);this.code=w,this.name=w}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(ne[160],ie([0,1,3,2,29,8,110,28]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(v,g){return L.URI.revive(g?g.transformIncoming(v):v)}function C(v,g){return g?g.transformOutgoingURI(v):v}function R(v,g){g=g||A.DefaultURITransformer;const h=v.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...v,manifest:void 0},g),manifest:h}}function E(v,g){return g?(0,T.cloneAndChange)(v,h=>h instanceof L.URI?g.transformOutgoingURI(h):void 0):v}class m{constructor(g,h){this.service=g,this.getUriTransformer=h,this.onInstallExtension=k.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,h){const y=this.getUriTransformer(g);switch(h){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,w=>w.map(p=>({...p,local:p.local?E(p.local,y):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,h,y){const w=this.getUriTransformer(g);switch(h){case"zip":return this.service.zip(R(y[0],w)).then(p=>C(p,w));case"unzip":return this.service.unzip(I(y[0],w));case"install":return this.service.install(I(y[0],w),y[1]);case"getManifest":return this.service.getManifest(I(y[0],w));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(R(y[0],w),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(R(y[0],w));case"getInstalled":return this.service.getInstalled(y[0]).then(p=>p.map(u=>E(u,w)));case"updateMetadata":return this.service.updateMetadata(R(y[0],w),y[1]).then(p=>E(p,w));case"updateExtensionScope":return this.service.updateExtensionScope(R(y[0],w),y[1]).then(p=>E(p,w));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class S extends n.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(h=>this._onInstallExtension.fire({identifier:h.identifier,source:this.isUriComponents(h.source)?L.URI.revive(h.source):h.source}))),this._register(this.channel.listen("onDidInstallExtensions")(h=>this._onDidInstallExtensions.fire(h.map(y=>({...y,local:y.local?R(y.local,null):y.local,source:this.isUriComponents(y.source)?L.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(h=>this._onUninstallExtension.fire(h))),this._register(this.channel.listen("onDidUninstallExtension")(h=>this._onDidUninstallExtension.fire(h)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const h=await this.getTargetPlatform();return g.allTargetPlatforms.some(y=>(0,P.isTargetPlatformCompatible)(y,g.allTargetPlatforms,h))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(h=>L.URI.revive(h)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,h){return Promise.resolve(this.channel.call("install",[g,h])).then(y=>R(y,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,h){return Promise.resolve(this.channel.call("installFromGallery",[g,h])).then(y=>R(y,null))}uninstall(g,h){return Promise.resolve(this.channel.call("uninstall",[g,h]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(h=>h.map(y=>R(y,null)))}updateMetadata(g,h){return Promise.resolve(this.channel.call("updateMetadata",[g,h])).then(y=>R(y,null))}updateExtensionScope(g,h){return Promise.resolve(this.channel.call("updateExtensionScope",[g,h])).then(y=>R(y,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class d{constructor(g){this.service=g}listen(g,h){throw new Error("Invalid listen")}call(g,h,y){switch(h){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(ne[83],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function T(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],ie([0,1,7,39,10,27,15,8,137,6]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function R(B){return B.create===!0}e.isFileOpenForWriteOptions=R;var E;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var m;(function(B){B[B.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var S;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=d;function v(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=v;function g(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=g;function h(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function y(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=y;function w(B){return d(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var p;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(W,H){super(W);this.code=H}}e.FileSystemProviderError=u;function r(B,W){const H=new u(B.toString(),W);return i(H,W),H}e.createFileSystemProviderError=r;function c(B){return B||r((0,I.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=c;function i(B,W){return B.name=W?`${W} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=i;function t(B){if(!B)return p.Unknown;if(B instanceof u)return B.code;const W=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!W)return p.Unknown;switch(W[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function s(B){if(B instanceof _)return B.fileOperationResult;switch(t(B)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(W,H,te){this.resource=W,this.operation=H,this.target=te}isOperation(W){return this.operation===W}}e.FileOperationEvent=a;var l;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class f{constructor(W,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const te=new Map;for(const V of W){const Z=te.get(V.type);switch(Z?Z.push([V.resource,V]):te.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,Z]of te)switch(V){case 1:this.added=n.TernarySearchTree.forUris(()=>H),this.added.fill(Z);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>H),this.updated.fill(Z);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>H),this.deleted.fill(Z);break}}contains(W,...H){return this.doContains(W,{includeChildren:!1},...H)}affects(W,...H){return this.doContains(W,{includeChildren:!0},...H)}doContains(W,H,...te){if(!W)return!1;const V=te.length>0;return!!((!V||te.includes(1))&&(this.added?.get(W)||H.includeChildren&&this.added?.findSuperstr(W))||(!V||te.includes(0))&&(this.updated?.get(W)||H.includeChildren&&this.updated?.findSuperstr(W))||(!V||te.includes(2))&&(this.deleted?.findSubstr(W)||H.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function b(B,W,H){return!B||!W||B===W||W.length>B.length?!1:(W.charAt(W.length-1)!==T.sep&&(W+=T.sep),H?(0,L.startsWithIgnoreCase)(B,W):B.indexOf(W)===0)}e.isParent=b;class _ extends k.ErrorNoTelemetry{constructor(W,H,te){super(W);this.fileOperationResult=H,this.options=te}}e.FileOperationError=_;class O extends _{constructor(W,H,te){super(W,2,te);this.stat=H}}e.NotModifiedSinceFileOperationError=O;var M;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=F;async function $(B,W){if(!W.hasProvider(P.URI.from({scheme:B.scheme})))return new Promise(H=>{const te=W.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===B.scheme&&V.added&&(te.dispose(),H())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class q{static formatSize(W){return(0,A.isNumber)(W)||(W=0),W<q.KB?(0,I.localize)(1,null,W.toFixed(0)):W<q.MB?(0,I.localize)(2,null,(W/q.KB).toFixed(2)):W<q.GB?(0,I.localize)(3,null,(W/q.MB).toFixed(2)):W<q.TB?(0,I.localize)(4,null,(W/q.GB).toFixed(2)):(0,I.localize)(5,null,(W/q.TB).toFixed(2))}}e.ByteSize=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;var x;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function G(B){return{maxFileSize:B===0?300*q.MB:16*q.GB,maxHeapSize:B===0?700*q.MB:2*700*q.MB}}e.getPlatformLimits=G});var K=this&&this.__param||function(Y,e){return function(k,n){e(k,n,Y)}};define(ne[161],ie([0,1,84,40,14]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const I=(await this.fileService.readFileStream(P)).value;return new Promise((C,R)=>{const E=(0,k.createHash)("md5");(0,n.listenStream)(I,{onData:m=>E.update(m.buffer),onError:m=>R(m),onEnd:()=>C(E.digest("base64").replace(/=+$/,""))})})}};L=de([K(0,T.IFileService)],L),e.ChecksumService=L}),define(ne[162],ie([0,1,17,37,7,3,2,40,8,30,14]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(S,d){super();this.channel=S,this.extraCapabilities=d,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,C.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,d){const{buffer:v}=await this.channel.call("readFile",[S,d]);return v}readFileStream(S,d,v){const g=(0,P.newWriteableStream)(y=>k.VSBuffer.concat(y.map(w=>k.VSBuffer.wrap(w))).buffer),h=this.channel.listen("readFileStream",[S,d])(y=>{if(y instanceof k.VSBuffer)g.write(y.buffer);else{if(y==="end")g.end();else{let w=y;w instanceof Error||(w=(0,R.createFileSystemProviderError)((0,n.toErrorMessage)(w),R.FileSystemProviderErrorCode.Unknown)),g.error(w),g.end()}h.dispose()}});return v.onCancellationRequested(()=>{g.error((0,T.canceled)()),g.end(),h.dispose()}),g}writeFile(S,d,v){return this.channel.call("writeFile",[S,k.VSBuffer.wrap(d),v])}open(S,d){return this.channel.call("open",[S,d])}close(S){return this.channel.call("close",[S])}async read(S,d,v,g,h){const[y,w]=await this.channel.call("read",[S,d,h]);return v.set(y.buffer.slice(0,w),g),w}write(S,d,v,g,h){return this.channel.call("write",[S,d,k.VSBuffer.wrap(v),g,h])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,d){return this.channel.call("delete",[S,d])}rename(S,d,v){return this.channel.call("rename",[S,d,v])}copy(S,d,v){return this.channel.call("copy",[S,d,v])}cloneFile(S,d){return this.channel.call("cloneFile",[S,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const d=S;this._onDidChange.fire(d.map(v=>({resource:I.URI.revive(v.resource),type:v.type})))}else{const d=S;this._onDidWatchError.fire(d)}}))}watch(S,d){const v=(0,C.generateUuid)();return this.channel.call("watch",[this.sessionId,v,S,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=E}),define(ne[85],ie([0,1,17,7,138,14]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(R,E,m,S,d,v){let g;try{await P(R,E,m,S,d,v)}catch(h){g=h}finally{g&&d.errorTransformer&&(g=d.errorTransformer(g)),typeof g!="undefined"&&m.error(g),m.end()}}e.readFileIntoStream=A;async function P(R,E,m,S,d,v){I(v);const g=await R.open(E,{create:!1});try{I(v);let h=0,y=0,w=d&&typeof d.length=="number"?d.length:void 0,p=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof w=="number"?w:d.bufferSize)),u=d&&typeof d.position=="number"?d.position:0,r=0;do y=await R.read(g,u,p.buffer,r,p.byteLength-r),u+=y,r+=y,h+=y,typeof w=="number"&&(w-=y),r===p.byteLength&&(await m.write(S(p)),p=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof w=="number"?w:d.bufferSize)),r=0);while(y>0&&(typeof w!="number"||w>0)&&I(v)&&C(h,d));if(r>0){let c=r;typeof w=="number"&&(c=Math.min(r,w)),m.write(S(p.slice(0,c)))}}catch(h){throw(0,L.ensureFileSystemProviderError)(h)}finally{await R.close(g)}}function I(R){if(R.isCancellationRequested)throw(0,n.canceled)();return!0}function C(R,E){if(E?.limits){if(typeof E.limits.memory=="number"&&R>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,T.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&R>E.limits.size)throw(0,L.createFileSystemProviderError)((0,T.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[52],ie([0,1,2,4,8,14]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(S){return S.recursive===!0}e.isRecursiveWatchRequest=A;class P extends k.Disposable{constructor(d,v,g,h){super();this.onFileChanges=d,this.onLogMessage=v,this.verboseLogging=g,this.options=h,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new k.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),d.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),d.add(this.watcher.onDidError(v=>this.onError(v)))}onError(d){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class I extends P{constructor(d,v,g){super(d,v,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class C extends P{constructor(d,v,g){super(d,v,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function R(S){return S.map(d=>({type:d.type,resource:T.URI.file(d.path)}))}e.toFileChanges=R;function E(S){const d=new m;for(const v of S)d.processEvent(v);return d.coalesce()}e.coalesceEvents=E;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return n.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const v=this.mapPathToChange.get(this.toKey(d));let g=!1;if(v){const h=v.type,y=d.type;v.path!==d.path&&(d.type===2||d.type===1)?g=!0:h===1&&y===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(v)):h===2&&y===1?v.type=0:h===1&&y===0||(v.type=y)}else g=!0;g&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],v=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(d.push(g),!1):!0).sort((g,h)=>g.path.length-h.path.length).filter(g=>v.some(h=>(0,L.isParent)(g.path,h,!n.isLinux))?!1:(v.push(g.path),!0)).concat(d)}}}),define(ne[163],ie([0,1,50,5,25,41,109,2,72,10,4,114,22,52]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends P.Disposable{constructor(h,y,w,p){super();this.request=h,this.onDidFilesChange=y,this.onLogMessage=w,this.verboseLogging=p,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(u=>(0,A.parse)(u)),this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const y=await m.Promises.stat(h);this._register(await this.doWatch(h,y.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let y=h.path;try{y=await m.Promises.realpath(h.path),h.path===y&&(y=await(0,E.realcase)(h.path)??h.path),h.path!==y&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${y})`)}catch{}return y}async doWatch(h,y){if(R.isMacintosh&&(0,L.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.Disposable.None;const w=new T.CancellationTokenSource(this.cts.token);let p=new P.DisposableStore;try{const u=(0,C.basename)(h),r=(0,k.watch)(h);p.add((0,P.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${h}'`);const c=new Set;if(y)try{for(const t of await m.Promises.readdir(h))c.add(t)}catch(t){this.error(t)}const i=new Map;p.add((0,P.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,s)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),r.on("change",(t,s)=>{if(w.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),R.isMacintosh&&(o=(0,I.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(y)if(t==="rename"){i.get(o)?.dispose();const a=setTimeout(async()=>{if(i.delete(o),o===u&&!await m.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,C.join)(h,o));if(w.token.isCancellationRequested)return;let f;l?c.has(o)?f=0:(f=1,c.add(o)):(c.delete(o),f=2),this.onFileChange({path:(0,C.join)(this.request.path,o),type:f})},d.FILE_DELETE_HANDLER_DELAY);i.set(o,(0,P.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(o)?a=0:(a=1,c.add(o)),this.onFileChange({path:(0,C.join)(this.request.path,o),type:a})}else if(t==="rename"||o!==u){const a=setTimeout(async()=>{const l=await m.Promises.exists(h);w.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),p.add(await this.doWatch(h,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);p.clear(),p.add((0,P.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await m.Promises.exists(h)&&!w.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${u.toString()})`)}return(0,P.toDisposable)(()=>{w.dispose(!0),p.dispose()})}async onFileChange(h,y=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!y&&this.excludes.some(w=>w(h.path))?this.verboseLogging&&this.trace(` >> ignored ${h.path}`):this.fileChangesBuffer.push(h);try{await this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.coalesceEvents)(w);if(p.length>0){if(this.verboseLogging)for(const r of p)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(p)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${p.length}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(h){if(R.isLinux)return m.Promises.exists(h);try{const y=(0,C.basename)(h);return(await m.Promises.readdir((0,C.dirname)(h))).some(p=>p===y)}catch(y){return this.trace(y),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function v(g,h,y,w,p=512){const u=await m.Promises.open(g,"r"),r=Buffer.allocUnsafe(p),c=new T.CancellationTokenSource(w);let i,t=!1;const s={path:g,excludes:[],recursive:!1},o=new d(s,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:f}=await m.Promises.read(u,r,0,p,null);if(!f||c.token.isCancellationRequested)break;h(r.slice(0,f))}}catch(f){i=new Error(f),c.dispose(!0)}finally{t=!1}}})()});return await o.ready,y(),new Promise((a,l)=>{c.token.onCancellationRequested(async()=>{o.dispose();try{await m.Promises.close(u)}catch(f){i=new Error(f)}i?l(i):a()})})}e.watchFileContents=v}),define(ne[164],ie([0,1,16,3,2,4,163]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends T.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const R=this.normalizeRequests(C),E=R.filter(S=>{const d=this.watchers.get(S.path);return d?!(0,k.equals)(d.request.excludes,S.excludes):!0}),m=Array.from(this.watchers.values()).filter(({request:S})=>!R.find(d=>d.path===S.path&&(0,k.equals)(d.excludes,S.excludes))).map(({request:S})=>S.path);E.length&&this.trace(`Request to start watching: ${E.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const S of m)this.stopWatching(S);for(const S of E)this.startWatching(S)}startWatching(C){const R=new A.NodeJSFileWatcherLibrary(C,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),E={request:C,instance:R};this.watchers.set(C.path,E)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const R=this.watchers.get(C);R&&(this.watchers.delete(C),R.instance.dispose())}normalizeRequests(C){const R=new Map;for(const E of C){const m=L.isLinux?E.path:E.path.toLowerCase();R.set(m,E)}return Array.from(R.values())}async setVerboseLogging(C){this.verboseLogging=C;for(const[,R]of this.watchers)R.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,R){return R?`[File Watcher (node.js)] ${C} (path: ${R.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=P}),define(ne[165],ie([0,1,52,164]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends k.AbstractNonRecursiveWatcherClient{constructor(A,P,I){super(A,P,I);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=T}),define(ne[166],ie([0,1,19,36,58,52]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(I,C,R){super(I,C,R);this.init()}createWatcher(I){const C=I.add(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(C.onDidProcessExit(({code:R,signal:E})=>this.onError(`terminated by itself with code ${R}, signal: ${E}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[86],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...T){this._entries=new Map;for(let[L,A]of T)this.set(L,A)}set(T,L){const A=this._entries.get(T);return this._entries.set(T,L),A}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=k}),define(ne[167],ie([0,1,5,7,51,157,6,86]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class C extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class R{constructor(d=new P.ServiceCollection,v=!1,g){this._activeInstantiations=new Set,this._services=d,this._strict=v,this._parent=g,this._services.set(A.IInstantiationService,this)}createChild(d){return new R(d,this._strict,this)}invokeFunction(d,...v){let g=m.traceInvocation(d),h=!1;try{return d({get:w=>{if(h)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(w,g);if(!p)throw new Error(`[invokeFunction] unknown service '${w}'`);return p}},...v)}finally{h=!0,g.stop()}}createInstance(d,...v){let g,h;return d instanceof T.SyncDescriptor?(g=m.traceCreation(d.ctor),h=this._createInstance(d.ctor,d.staticArguments.concat(v),g)):(g=m.traceCreation(d),h=this._createInstance(d,v,g)),g.stop(),h}_createInstance(d,v=[],g){let h=A._util.getServiceDependencies(d).sort((p,u)=>p.index-u.index),y=[];for(const p of h){let u=this._getOrCreateServiceInstance(p.id,g);u||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${p.id}.`,!1),y.push(u)}let w=h.length>0?h[0].index:v.length;if(v.length!==w){console.trace(`[createInstance] First service dependency of ${d.name} at position ${w+1} conflicts with ${v.length} static arguments`);let p=w-v.length;p>0?v=v.concat(new Array(p)):v=v.slice(0,w)}return new d(...[...v,...y])}_setServiceInstance(d,v){if(this._services.get(d)instanceof T.SyncDescriptor)this._services.set(d,v);else if(this._parent)this._parent._setServiceInstance(d,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let v=this._services.get(d);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):v}_getOrCreateServiceInstance(d,v){let g=this._getServiceInstanceOrDescriptor(d);return g instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,g,v.branch(d,!0)):(v.branch(d,!1),g)}_safeCreateAndCacheServiceInstance(d,v,g){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,v,g)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,v,g){const h=new L.Graph(p=>p.id.toString());let y=0;const w=[{id:d,desc:v,_trace:g}];for(;w.length;){const p=w.pop();if(h.lookupOrInsertNode(p),y++>1e3)throw new C(h);for(let u of A._util.getServiceDependencies(p.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),r instanceof T.SyncDescriptor){const c={id:u.id,desc:r,_trace:p._trace.branch(u.id,!0)};h.insertEdge(p,c),w.push(c)}}}for(;;){const p=h.roots();if(p.length===0){if(!h.isEmpty())throw new C(h);break}for(const{data:u}of p){if(this._getServiceInstanceOrDescriptor(u.id)instanceof T.SyncDescriptor){const c=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,c)}h.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,v,g=[],h,y){if(this._services.get(d)instanceof T.SyncDescriptor)return this._createServiceInstance(v,g,h,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,v,g,h,y);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(d,v=[],g,h){if(g){const y=new k.IdleValue(()=>this._createInstance(d,v,h));return new Proxy(Object.create(null),{get(w,p){if(p in w)return w[p];let u=y.value,r=u[p];return typeof r!="function"||(r=r.bind(u),w[p]=r),r},set(w,p,u){return y.value[p]=u,!0}})}else return this._createInstance(d,v,h)}_throwIfStrict(d,v){if(v&&console.warn(v),this._strict)throw new Error(d)}}e.InstantiationService=R;var E;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(E||(E={}));class m{constructor(d,v){this.type=d,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return I?new m(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(d){return I?new m(0,d.name):m._None}branch(d,v){let g=new m(2,d.toString());return this._dep.push([d,v,g]),g}stop(){let d=Date.now()-this._start;m._totals+=d;let v=!1;function g(y,w){let p=[],u=new Array(y+1).join("	");for(const[r,c,i]of w._dep)if(c&&i){v=!0,p.push(`${u}CREATES -> ${r}`);let t=g(y+1,i);t&&p.push(t)}else p.push(`${u}uses -> ${r}`);return p.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(d>2||v)&&console.log(h.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ne[168],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(T,L){this.server=T,this.router=L}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,L){this.server.registerChannel(T,L)}}e.MessagePortMainProcessService=k}),define(ne[169],ie([0,1,36,51,80,6]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(S,d,v){const g=v.getChannel(S);return P(d)?new d.channelClientCtor(g):k.ProxyChannel.toService(g,d?.proxyOptions)}}function P(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let I=class extends A{constructor(S,d,v){super(S,d,v)}};I=de([K(2,e.IMainProcessService)],I);function C(m,S,d){(0,T.registerSingleton)(m,new n.SyncDescriptor(I,[S,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let R=class extends A{constructor(S,d,v){super(S,d,v)}};R=de([K(2,e.ISharedProcessService)],R);function E(m,S,d){(0,T.registerSingleton)(m,new n.SyncDescriptor(R,[S,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(ne[59],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function n(T){if(typeof T.languageId!="string"||!Array.isArray(T.translations)||T.translations.length===0)return!1;for(const L of T.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(T.languageName&&typeof T.languageName!="string"||T.localizedLanguageName&&typeof T.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[170],ie([0,1,2,59]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};T=de([K(0,n.ILocalizationsService)],T),e.LocalizationsUpdater=T}),define(ne[9],ie([0,1,37,3,2,4,6]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var I;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(I=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=I.Info;function C(c,i,t){switch(i){case I.Trace:c.trace(t);break;case I.Debug:c.debug(t);break;case I.Info:c.info(t);break;case I.Warning:c.warn(t);break;case I.Error:c.error(t);break;case I.Critical:c.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function R(c){let i="";for(let t=0;t<c.length;t++){let s=c[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(t>0?" ":"")+s}return i}e.format=R;class E extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(I.Trace)&&this.log(I.Trace,R([i,...t]))}debug(i,...t){this.checkLogLevel(I.Debug)&&this.log(I.Debug,R([i,...t]))}info(i,...t){this.checkLogLevel(I.Info)&&this.log(I.Info,R([i,...t]))}warn(i,...t){this.checkLogLevel(I.Warning)&&this.log(I.Warning,R([i,...t]))}error(i,...t){if(this.checkLogLevel(I.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(I.Error,R(s))}else this.log(I.Error,R([i,...t]))}critical(i,...t){this.checkLogLevel(I.Critical)&&this.log(I.Critical,R([i,...t]))}flush(){}}e.AbstractMessageLogger=m;class S extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...t){this.getLevel()<=I.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}debug(i,...t){this.getLevel()<=I.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}info(i,...t){this.getLevel()<=I.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}warn(i,...t){this.getLevel()<=I.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...t):console.warn(`[main ${P()}]`,i,...t))}error(i,...t){this.getLevel()<=I.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}critical(i,...t){this.getLevel()<=I.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class d extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=I.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=I.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=I.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=I.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=I.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=I.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=d;class v extends E{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=I.Trace&&this.adapter.log(I.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=I.Debug&&this.adapter.log(I.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=I.Info&&this.adapter.log(I.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=I.Warning&&this.adapter.log(I.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=I.Error&&this.adapter.log(I.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=I.Critical&&this.adapter.log(I.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=I.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class g extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const s of this.logServices)s.trace(i,...t)}debug(i,...t){for(const s of this.logServices)s.debug(i,...t)}info(i,...t){for(const s of this.logServices)s.info(i,...t)}warn(i,...t){for(const s of this.logServices)s.warn(i,...t)}error(i,...t){for(const s of this.logServices)s.error(i,...t)}critical(i,...t){for(const s of this.logServices)s.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=g;class h extends T.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=h;class y extends T.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,t?.always?I.Trace:this.logLevel,t),this.loggers.set(i.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class w{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return I.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=w;function p(c){if(c.verbose)return I.Trace;if(typeof c.logLevel=="string"){const i=u(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function u(c){switch(c){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Critical;case"off":return I.Off}}e.parseLogLevel=u;function r(c){switch(c){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Critical:return"critical";case I.Off:return"off"}}e.LogLevelToString=r}),define(ne[171],ie([0,1,5,7,2,10,22,13,9]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends T.Disposable{constructor(E,m){super();this.environmentService=E,this.logService=m,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,L.basename)(this.environmentService.logsPath),m=(0,L.dirname)(this.environmentService.logsPath),v=(await A.Promises.readdir(m)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==E),g=v.slice(0,Math.max(0,v.length-9));g.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(h=>A.Promises.rm((0,L.join)(m,h)))))}catch(E){(0,n.onUnexpectedError)(E)}}};C=de([K(0,P.IEnvironmentService),K(1,I.ILogService)],C),e.LogsDataCleaner=C}),define(ne[172],ie([0,1,5,7,2,10,22,13,9]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class ht extends T.Disposable{constructor(E,m,S){super();this.backupWorkspacesPath=E,this.environmentService=m,this.logService=S,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(E).emptyWorkspaceInfos.map(v=>v.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async v=>{v.length===ht.NON_EMPTY_WORKSPACE_ID_LENGTH||v===ht.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(v)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${v}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,v)))}))}catch(E){(0,n.onUnexpectedError)(E)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=de([K(1,P.INativeEnvironmentService),K(2,I.ILogService)],C),e.StorageDataCleaner=C}),define(ne[173],ie([0,1,45,5,37,3,2,19,10,22,13,9]),function(Y,e,k,n,T,L,A,P,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends A.Disposable{constructor(d,v){super();this.environmentService=d,this.logService=v,this.processesLimiter=new n.Limiter(5)}async postUninstall(d){const v=this.parseScript(d,"uninstall");return v&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${g}`)))),C.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(d,v){const g=`vscode:${v}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[g]=="string"){const h=d.manifest.scripts[g].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${g} should be a node script`),null):{script:(0,I.join)(d.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(d,v,g,h,y){return new Promise((w,p)=>{const u=this.start(d,v,g,y);let r;const c=i=>{r&&(clearTimeout(r),r=null),i?p(i):w(void 0)};u.on("error",i=>{c((0,T.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,t)=>{c(i?`post-${v} process exited with code ${i}`:void 0)}),h&&(r=setTimeout(()=>{r=null,u.kill(),p("timed out")},5e3))})}start(d,v,g,h){const y={silent:!0,execArgv:void 0},w=(0,k.fork)(d,[`--type=extension-post-${v}`,...g],y);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const p=L.Event.fromNodeEventEmitter(w.stdout,"data"),u=L.Event.fromNodeEventEmitter(w.stderr,"data");p(i=>this.logService.info(h.identifier.id,h.manifest.version,`post-${v}`,i)),u(i=>this.logService.error(h.identifier.id,h.manifest.version,`post-${v}`,i));const r=L.Event.any(L.Event.map(p,i=>({data:`%c${i}`,format:[""]})),L.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}getExtensionStoragePath(d){return(0,I.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};m=de([K(0,R.IEnvironmentService),K(1,E.ILogService)],m),e.ExtensionsLifecycle=m}),define(ne[174],ie([0,1,16,5,7,3,2,10,52,9]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends A.Disposable{constructor(m,S){super();this.logService=m,this.options=S,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(m,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,S):this.watchNonRecursive(m,S)}watchUniversal(m,S){const d={path:this.toFilePath(m),excludes:S.excludes,recursive:S.recursive},v=(0,k.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,T.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,I.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const S of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const S of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(S)&&m.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,S){const d={path:this.toFilePath(m),excludes:S.excludes,recursive:!1},v=(0,k.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,T.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,I.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,P.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(ne[175],ie([0,1,16,5,17,25,3,71,55,2,39,19,176,20,40,136,14,85,9]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends C.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(u,r){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${u}`);const c=new C.DisposableStore;return this.provider.set(u,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:r}),c.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new g.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&c.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),c.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:u}))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:r}),this.provider.delete(u),(0,C.dispose)(c)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(c){r.push(c)}}),!this.provider.has(u)&&await n.Promises.settled(r)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,r){const c=this.provider.get(u.scheme);return!!(c&&c.capabilities&r)}listCapabilities(){return I.Iterable.map(this.provider,([u,r])=>({scheme:u,capabilities:r.capabilities}))}async withProvider(u){if(!(0,S.isAbsolutePath)(u))throw new g.FileOperationError((0,v.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const r=this.provider.get(u.scheme);if(!r){const c=new Error;throw c.name="ENOPRO",c.message=(0,v.localize)(1,null,u.toString()),c}return r}async withReadProvider(u){const r=await this.withProvider(u);if((0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasReadWriteCapability)(r)||(0,g.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const r=await this.withProvider(u);if((0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,r){try{return await this.doResolveFile(u,r)}catch(c){throw(0,g.toFileSystemProviderErrorCode)(c)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,v.localize)(2,null,this.resourceForError(u)),1):(0,g.ensureFileSystemProviderError)(c)}}async doResolveFile(u,r){const c=await this.withProvider(u),i=this.isPathCaseSensitive(c),t=r?.resolveTo,s=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,a=await c.stat(u);let l;return this.toFileStat(c,u,a,void 0,!!o,(f,b)=>(l||(l=R.TernarySearchTree.forUris(()=>!i),l.set(u,!0),t&&l.fill(!0,t)),l.get(f.resource)||l.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&s?b===1:!1))}async toFileStat(u,r,c,i,t,s){const{providerExtUri:o}=this.getExtUri(u),a={resource:r,name:o.basename(r),isFile:(c.type&g.FileType.File)!=0,isDirectory:(c.type&g.FileType.Directory)!=0,isSymbolicLink:(c.type&g.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&g.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,g.etag)({mtime:c.mtime,size:c.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const l=await u.readdir(r),f=await n.Promises.settled(l.map(async([b,_])=>{try{const O=o.joinPath(r,b),M=t?await u.stat(O):{type:_};return await this.toFileStat(u,O,M,l.length,t,s)}catch(O){return this.logService.trace(O),null}}));a.children=(0,k.coalesce)(f)}catch(l){this.logService.trace(l),a.children=[]}return a}return a}async resolveAll(u){return n.Promises.settled(u.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async stat(u){const r=await this.withProvider(u),c=await r.stat(u);return this.toFileStat(r,u,c,void 0,!0,()=>!1)}async exists(u){const r=await this.withProvider(u);try{return!!await r.stat(u)}catch{return!1}}async canCreateFile(u,r){try{await this.doValidateCreateFile(u,r)}catch(c){return c}return!0}async doValidateCreateFile(u,r){if(!r?.overwrite&&await this.exists(u))throw new g.FileOperationError((0,v.localize)(3,null,this.resourceForError(u)),3,r)}async createFile(u,r=T.VSBuffer.fromString(""),c){await this.doValidateCreateFile(u,c);const i=await this.writeFile(u,r);return this._onDidRunOperation.fire(new g.FileOperationEvent(u,0,i)),i}async writeFile(u,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,u,c)||await this.mkdirp(i,t.dirname(u));let o;if((0,g.hasReadWriteCapability)(i)&&!(r instanceof T.VSBuffer))if((0,d.isReadableStream)(r)){const a=await(0,d.peekStream)(r,3);a.ended?o=T.VSBuffer.concat(a.buffer):o=a}else o=(0,d.peekReadable)(r,a=>T.VSBuffer.concat(a),3);else o=r;!(0,g.hasOpenReadWriteCloseCapability)(i)||(0,g.hasReadWriteCapability)(i)&&o instanceof T.VSBuffer?await this.doWriteUnbuffered(i,u,c,o):await this.doWriteBuffered(i,u,c,o instanceof T.VSBuffer?(0,T.bufferToReadable)(o):o),this._onDidRunOperation.fire(new g.FileOperationEvent(u,4))}catch(s){throw new g.FileOperationError((0,v.localize)(4,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),c)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,r,c){if(!!c?.unlock&&!(u.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(r)));let t;try{t=await u.stat(r)}catch{return}if((t.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,v.localize)(6,null,this.resourceForError(r)),0,c);if(this.throwIfFileIsReadonly(r,t),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==g.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&c.mtime<t.mtime&&c.etag!==(0,g.etag)({mtime:c.mtime,size:t.size}))throw new g.FileOperationError((0,v.localize)(7,null),3,c);return t}async readFile(u,r,c){const i=await this.withReadProvider(u);return r?.atomic?this.doReadFileAtomic(i,u,r,c):this.doReadFile(i,u,r,c)}async doReadFileAtomic(u,r,c,i){return new Promise((t,s)=>{this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(u,r,c,i);t(o)}catch(o){s(o)}})})}async doReadFile(u,r,c,i){const t=await this.doReadFileStream(u,r,{...c,preferUnbuffered:!0},i);return{...t,value:await(0,T.streamToBuffer)(t.value)}}async readFileStream(u,r,c){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,r,c)}async doReadFileStream(u,r,c,i){const t=new L.CancellationTokenSource(i),s=this.validateReadFile(r,c).then(a=>a,a=>{throw t.cancel(),a});let o;try{return typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&await s,c?.atomic&&(0,g.hasFileAtomicReadCapability)(u)||!((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasFileReadStreamCapability)(u))||(0,g.hasReadWriteCapability)(u)&&c?.preferUnbuffered?o=this.readFileUnbuffered(u,r,c):(0,g.hasFileReadStreamCapability)(u)?o=this.readFileStreamed(u,r,t.token,c):o=this.readFileBuffered(u,r,t.token,c),{...await s,value:o}}catch(a){o&&await(0,d.consumeStream)(o);const l=(0,v.localize)(8,null,this.resourceForError(r),(0,g.ensureFileSystemProviderError)(a).toString());throw a instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(l,a.stat,c):new g.FileOperationError(l,(0,g.toFileOperationResult)(a),c)}}readFileStreamed(u,r,c,i=Object.create(null)){const t=u.readFileStream(r,i,c);return(0,d.transform)(t,{data:s=>s instanceof T.VSBuffer?s:T.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,v.localize)(9,null,this.resourceForError(r),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),i)},s=>T.VSBuffer.concat(s))}readFileBuffered(u,r,c,i=Object.create(null)){const t=(0,T.newWriteableBufferStream)();return(0,h.readFileIntoStream)(u,r,t,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,v.localize)(10,null,this.resourceForError(r),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),i)},c),t}readFileUnbuffered(u,r,c){const i=(0,d.newWriteableStream)(t=>T.VSBuffer.concat(t));return(async()=>{try{let t;c?.atomic&&(0,g.hasFileAtomicReadCapability)(u)?t=await u.readFile(r,{atomic:!0}):t=await u.readFile(r),typeof c?.position=="number"&&(t=t.slice(c.position)),typeof c?.length=="number"&&(t=t.slice(0,c.length)),this.validateReadFileLimits(r,t.byteLength,c),i.end(T.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(u,r){const c=await this.resolve(u,{resolveMetadata:!0});if(c.isDirectory)throw new g.FileOperationError((0,v.localize)(11,null,this.resourceForError(u)),0,r);if(typeof r?.etag=="string"&&r.etag!==g.ETAG_DISABLED&&r.etag===c.etag)throw new g.NotModifiedSinceFileOperationError((0,v.localize)(12,null),c,r);return this.validateReadFileLimits(u,c.size,r),c}validateReadFileLimits(u,r,c){if(c?.limits){let i;if(typeof c.limits.memory=="number"&&r>c.limits.memory&&(i=9),typeof c.limits.size=="number"&&r>c.limits.size&&(i=7),typeof i=="number")throw new g.FileOperationError((0,v.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,r,c){return this.doCanMoveCopy(u,r,"move",c)}async canCopy(u,r,c){return this.doCanMoveCopy(u,r,"copy",c)}async doCanMoveCopy(u,r,c,i){if(u.toString()!==r.toString())try{const t=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,u,s,r,c,i)}catch(t){return t}return!0}async move(u,r,c){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,u,t,r,"move",!!c),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(u,s==="move"?2:3,o)),o}async copy(u,r,c){const i=await this.withReadProvider(u),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,u,t,r,"copy",!!c),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(u,s==="copy"?3:2,o)),o}async doMoveCopy(u,r,c,i,t,s){if(r.toString()===i.toString())return t;const{exists:o,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(u,r,c,i,t,s);if(o&&!a&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(i)),t==="copy"){if(u===c&&(0,g.hasFileFolderCopyCapability)(u))await u.copy(r,i,{overwrite:s});else{const l=await this.resolve(r);l.isDirectory?await this.doCopyFolder(u,l,c,i):await this.doCopyFile(u,r,c,i)}return t}else return u===c?(await u.rename(r,i,{overwrite:s}),t):(await this.doMoveCopy(u,r,c,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(u,r,c,i){if((0,g.hasOpenReadWriteCloseCapability)(u)&&(0,g.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(u,r,c,i);if((0,g.hasOpenReadWriteCloseCapability)(u)&&(0,g.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(u,r,c,i);if((0,g.hasReadWriteCapability)(u)&&(0,g.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(u,r,c,i);if((0,g.hasReadWriteCapability)(u)&&(0,g.hasReadWriteCapability)(c))return this.doPipeUnbuffered(u,r,c,i)}async doCopyFolder(u,r,c,i){await c.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const s=this.getExtUri(c).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(u,await this.resolve(t.resource),c,s):this.doCopyFile(u,t.resource,c,s)}))}async doValidateMoveCopy(u,r,c,i,t,s){let o=!1;if(u===c){const{providerExtUri:l,isPathCaseSensitive:f}=this.getExtUri(u);if(f||(o=l.isEqual(r,i)),o&&t==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!o&&l.isEqualOrParent(i,r))throw new Error((0,v.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!o){if(!s)throw new g.FileOperationError((0,v.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(u===c){const{providerExtUri:l}=this.getExtUri(u);if(l.isEqualOrParent(r,i))throw new Error((0,v.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:o}}getExtUri(u){const r=this.isPathCaseSensitive(u);return{providerExtUri:r?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(r,u);const c=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(u,0,c)),c}async mkdirp(u,r){const c=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(r,i.dirname(r));)try{if(((await u.stat(r)).type&g.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,g.toFileSystemProviderErrorCode)(t)!==g.FileSystemProviderErrorCode.FileNotFound)throw t;c.push(i.basename(r)),r=i.dirname(r)}for(let t=c.length-1;t>=0;t--){r=i.joinPath(r,c[t]);try{await u.mkdir(r)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(u,r){try{await this.doValidateDelete(u,r)}catch(c){return c}return!0}async doValidateDelete(u,r){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!r?.useTrash&&!(c.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(u)));let t;try{t=await c.stat(u)}catch{}if(t)this.throwIfFileIsReadonly(u,t);else throw new g.FileOperationError((0,v.localize)(20,null,this.resourceForError(u)),1);if(!!!r?.recursive){const o=await this.resolve(u);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(u)))}return c}async del(u,r){const c=await this.doValidateDelete(u,r),i=!!r?.useTrash,t=!!r?.recursive;await c.delete(u,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new g.FileOperationEvent(u,1))}async cloneFile(u,r){const c=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(c===i&&this.getExtUri(c).providerExtUri.isEqual(u,r))return;if(c===i&&(0,g.hasFileCloneCapability)(c))return c.cloneFile(u,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const t=this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri);return c===i&&(0,g.hasFileFolderCopyCapability)(c)?t.queue(()=>c.copy(u,r,{overwrite:!0})):t.queue(()=>this.doCopyFile(c,u,i,r))}watch(u,r={recursive:!1,excludes:[]}){const c=new C.DisposableStore;let i=!1,t=()=>{i=!0};return c.add((0,C.toDisposable)(()=>t())),(async()=>{try{const s=await this.doWatch(u,r);i?(0,C.dispose)(s):t=()=>(0,C.dispose)(s)}catch(s){this.logService.error(s)}})(),c}async doWatch(u,r){const c=await this.withProvider(u),i=(0,P.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(u),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:c.watch(u,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,C.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,C.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,C.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{const t=await u.open(r,{create:!0,unlock:c?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,t,i):await this.doWriteReadableBufferedQueued(u,t,i)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await u.close(t)}})}async doWriteStreamBufferedQueued(u,r,c){let i=0,t;if((0,d.isReadableBufferedStream)(c)){if(c.buffer.length>0){const s=T.VSBuffer.concat(c.buffer);await this.doWriteBuffer(u,r,s,s.byteLength,i,0),i+=s.byteLength}if(c.ended)return;t=c.stream}else t=c;return new Promise((s,o)=>{(0,d.listenStream)(t,{onData:async a=>{t.pause();try{await this.doWriteBuffer(u,r,a,a.byteLength,i,0)}catch(l){return o(l)}i+=a.byteLength,setTimeout(()=>t.resume())},onError:a=>o(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(u,r,c){let i=0,t;for(;(t=c.read())!==null;)await this.doWriteBuffer(u,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(u,r,c,i,t,s){let o=0;for(;o<i;)o+=await u.write(r,t+o,c.buffer,s+o,i-o)}async doWriteUnbuffered(u,r,c,i){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,r,c,i))}async doWriteUnbufferedQueued(u,r,c,i){let t;i instanceof T.VSBuffer?t=i:(0,d.isReadableStream)(i)?t=await(0,T.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?t=await(0,T.bufferedStreamToBuffer)(i):t=(0,T.readableToBuffer)(i),await u.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(u,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,r,c,i))}async doPipeBufferedQueued(u,r,c,i){let t,s;try{t=await u.open(r,{create:!1}),s=await c.open(i,{create:!0,unlock:!1});const o=T.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,l=0,f=0;do f=await u.read(t,a,o.buffer,l,o.byteLength-l),await this.doWriteBuffer(c,s,o,f,a,l),a+=f,l+=f,l===o.byteLength&&(l=0);while(f>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof t=="number"?u.close(t):Promise.resolve(),typeof s=="number"?c.close(s):Promise.resolve()])}}async doPipeUnbuffered(u,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,r,c,i))}async doPipeUnbufferedQueued(u,r,c,i){return c.writeFile(i,await u.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,r,c,i){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,r,c,i))}async doPipeUnbufferedToBufferedQueued(u,r,c,i){const t=await c.open(i,{create:!0,unlock:!1});try{const s=await u.readFile(r);await this.doWriteBuffer(c,t,T.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await c.close(t)}}async doPipeBufferedToUnbuffered(u,r,c,i){const t=await(0,T.streamToBuffer)(this.readFileBuffered(u,r,L.CancellationToken.None));await this.doWriteUnbuffered(c,i,void 0,t)}throwIfFileSystemIsReadonly(u,r){if(u.capabilities&2048)throw new g.FileOperationError((0,v.localize)(22,null,this.resourceForError(r)),6);return u}throwIfFileIsReadonly(u,r){if((r.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,v.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===E.Schemas.file?u.fsPath:u.toString(!0)}};w=de([K(0,y.ILogService)],w),e.FileService=w}),define(ne[177],ie([0,1,50,255,5,39,17,3,41,2,10,4,20,40,22,139,14,85,174,37,166,165]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(k)}catch(c){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(c)}`)}})();class r extends y.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,o.name))).type:a=this.toType(o),s.push([o.name,a])}catch(a){this.logService.trace(a)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let s;return t?.dangling?s=g.FileType.Unknown:i.isFile()?s=g.FileType.File:i.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,t&&(s|=g.FileType.SymbolicLink),s}async createResourceLock(i){const t=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const o=new T.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,C.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(i)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),o.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const o=this.toFilePath(i);return await d.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(i,t,s){const o=(0,S.newWriteableStream)(a=>A.VSBuffer.concat(a.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,h.readFileIntoStream)(this,i,o,a=>a.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){let o;try{const a=this.toFilePath(i);if(!s.create||!s.overwrite){if(await d.Promises.exists(a)){if(!s.overwrite)throw(0,g.createFileSystemProviderError)((0,v.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.createFileSystemProviderError)((0,v.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof o=="number"&&await this.close(o)}}async open(i,t){const s=this.toFilePath(i);let o;(0,g.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(i));let a;try{if((0,g.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:f}=await d.SymlinkSupport.stat(s);f.mode&128||await d.Promises.chmod(s,f.mode|128)}catch(f){this.logService.trace(f)}let l;if((0,g.isFileOpenForWriteOptions)(t)){if(E.isWindows)try{await d.Promises.truncate(s,0),l="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}l||(l="w")}else l="r";a=await d.Promises.open(s,l)}catch(l){throw o?.dispose(),(0,g.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(a,0),(0,g.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(a,i),o){const l=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,o),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),l.dispose())}return a}async close(i){const t=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await d.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{t&&(this.mapHandleToLock.get(i)===t&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,o,a){const l=this.normalizePos(i,t);let f=null;try{f=(await d.Promises.read(i,s,o,a,l)).bytesRead}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(i,l,f)}return f}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,s){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,o+s):this.mapHandleToPos.delete(i)))}async write(i,t,s,o,a){return(0,T.retry)(()=>this.doWrite(i,t,s,o,a),100,3)}async doWrite(i,t,s,o,a){const l=this.normalizePos(i,t);let f=null;try{f=(await d.Promises.write(i,s,o,a,l)).bytesWritten}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),b)}finally{this.updatePos(i,l,f)}return f}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const s=this.toFilePath(i);t.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,t,s){const o=this.toFilePath(i),a=this.toFilePath(t);if(o!==a)try{await this.validateTargetDeleted(i,t,"move",s.overwrite),await d.Promises.move(o,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,v.localize)(2,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(i,t,s){const o=this.toFilePath(i),a=this.toFilePath(t);if(o!==a)try{await this.validateTargetDeleted(i,t,"copy",s.overwrite),await d.Promises.copy(o,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,v.localize)(3,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(i,t,s,o){const a=this.toFilePath(i),l=this.toFilePath(t);let f=!1;if(!!(this.capabilities&1024)||(f=(0,I.isEqual)(a,l,!0)),f&&s==="copy")throw(0,g.createFileSystemProviderError)((0,v.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!f&&await d.Promises.exists(l)){if(!o)throw(0,g.createFileSystemProviderError)((0,v.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}async cloneFile(i,t){return this.doCloneFile(i,t,!1)}async doCloneFile(i,t,s){const o=this.toFilePath(i),a=this.toFilePath(t),l=!!(this.capabilities&1024);if((0,I.isEqual)(o,a,!l))return;const f=new C.DisposableStore;try{const[b,_]=await Promise.all([this.createResourceLock(i),this.createResourceLock(t)]);f.add(b),f.add(_),s&&await d.Promises.mkdir((0,R.dirname)(a),{recursive:!0}),await d.Promises.copyFile(o,a)}catch(b){if(b.code==="ENOENT"&&!s)return this.doCloneFile(i,t,!0);throw this.toFileSystemProviderError(b)}finally{f.dispose()}}createUniversalWatcher(i,t,s){return new p.UniversalWatcherClient(o=>i(o),o=>t(o),s)}createNonRecursiveWatcher(i,t,s){return new u.NodeJSWatcherClient(o=>i(o),o=>t(o),s)}toFileSystemProviderError(i){if(i instanceof g.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=g.FileSystemProviderErrorCode.NoPermissions;break;default:t=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let s=this.toFileSystemProviderError(t);if(i&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(s=(0,g.createFileSystemProviderError)(t,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(ne[87],ie([0,1,3,8,9]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(m){this.service=m,this.onDidChangeLogLevel=k.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(m,S,d){switch(S){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=L;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,S){return m.call("setLevel",S)}}e.LogLevelChannelClient=A;class P{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,S){throw new Error(`Event not found: ${S}`)}async call(m,S,d){switch(S){case"createLogger":this.createLogger(n.URI.revive(d[0]),d[1]);return;case"log":return this.log(n.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${S}`)}createLogger(m,S){this.loggers.set(m.toString(),this.loggerService.createLogger(m,S))}consoleLog(m,S){let d=console.log;switch(m){case T.LogLevel.Error:d=console.error;break;case T.LogLevel.Warning:d=console.warn;break;case T.LogLevel.Info:d=console.info;break}d.call(console,...S)}log(m,S){const d=this.loggers.get(m.toString());if(!d)throw new Error("Create the logger before logging");for(const[v,g]of S)(0,T.log)(d,v,g)}}e.LoggerChannel=P;class I extends T.AbstractLoggerService{constructor(m,S,d){super(m,S);this.channel=d}createConsoleMainLogger(){return new T.AdapterLogger({log:(m,S)=>{this.channel.call("consoleLog",[m,S])}})}doCreateLogger(m,S,d){return new C(this.channel,m,S,d)}}e.LoggerChannelClient=I;class C extends T.AbstractMessageLogger{constructor(m,S,d,v){super(v?.always);this.channel=m,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[S,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,S){const d=[[m,S]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(m){this.channel.call("log",[this.file,m])}}class R extends T.LogService{constructor(m,S){super(S);this.parent=m,this._register(m.onDidChangeLogLevel(d=>S.setLevel(d)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=R}),define(ne[60],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(ne[88],ie([0,1,19,4,33,20]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const P=n.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const P=(0,L.dirname)(k.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const I=Y.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:I.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[26],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[178],ie([0,1,5,7,2,10,22,9,26]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends T.Disposable{constructor(E,m,S){super();this.productService=m,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),S=(0,L.dirname)(E),d=(0,L.basename)(E),v=await A.Promises.readdir(S);await Promise.all(v.map(async g=>{if(g===d)return;const h=(0,L.join)(S,g),y=await A.Promises.stat(h);if(y.isDirectory()&&m-y.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),A.Promises.rm(h)}))}catch(m){(0,n.onUnexpectedError)(m)}}};C=de([K(1,I.IProductService),K(2,P.ILogService)],C),e.CodeCacheCleaner=C}),define(ne[179],ie([0,1,5,7,2,10,22,13,9,26]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends T.Disposable{constructor(m,S,d){super();this.environmentService=m,this.logService=S,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),S=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(S)){const w=S[y];m[`${w.hash}.${y}`]=!0}const d=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const g=await A.Promises.readdir(d);for(const y of g){if(m[y]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await A.Promises.rm((0,L.join)(d,y))}const h=Date.now();for(const y of Object.keys(m)){const w=(0,L.join)(d,y),p=await A.Promises.readdir(w);for(const u of p){if(u==="tcf.json")continue;const r=(0,L.join)(w,u),c=await A.Promises.stat(r);c.isDirectory()&&h-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(y,u)}`),await A.Promises.rm(r))}}}catch(m){(0,n.onUnexpectedError)(m)}}};R=de([K(0,P.INativeEnvironmentService),K(1,I.ILogService),K(2,C.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(ne[180],ie([0,1,10,6]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var T;(function(L){function A(P,I="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(I,(0,k.basename)(C.callFrame.url)));return P}L.rewriteAbsolutePaths=A})(T=e.Utils||(e.Utils={}))}),define(ne[181],ie([0,1,30]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((C,R)=>{Y(["v8-inspect-profiler"],C,R)})).startProfiling({port:L.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this._sessions.set(I,P),I}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const P=await A.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,99,15]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(A,P){k.ok(n.isString(A)),k.ok(n.isObject(P)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new T}),define(ne[89],ie([0,1,3,38]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,C){this.schemasById[T(I)]=C,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],ie([0,1,16,3,15,126,18,89,38]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=I.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,c=!0){this.registerConfigurations([r],c)}registerConfigurations(r,c=!0){const i=this.doRegisterConfigurations(r,c);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const c=this.doDeregisterConfigurations(r);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:r,remove:c}){const i=[];i.push(...this.doDeregisterConfigurations(c)),i.push(...this.doRegisterConfigurations(r,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(i)})}registerDefaultConfigurations(r){const c=[],i=[];for(const{overrides:t,source:s}of r)for(const o in t)if(c.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a={...this.configurationDefaultsOverrides.get(o)?.value||{},...t[o]};this.configurationDefaultsOverrides.set(o,{source:s,value:a});const l=(0,A.getLanguageTagSettingPlainKey)(o),f={type:"object",default:a,description:L.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:T.isString(s)?void 0:s};i.push(...v(o)),this.configurationProperties[o]=f,this.defaultLanguageConfigurationOverridesNode.properties[o]=f}else{this.configurationDefaultsOverrides.set(o,{value:t[o],source:s});const a=this.configurationProperties[o];a&&(this.updatePropertyDefaultValue(o,a),this.updateSchema(o,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const c=[];for(const{overrides:i,source:t}of r)for(const s in i){const o=this.configurationDefaultsOverrides.get(s),a=T.isString(t)?t:t?.id,l=T.isString(o?.source)?o?.source:o?.source?.id;if(a===l)if(c.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const f=this.configurationProperties[s];f&&(this.updatePropertyDefaultValue(s,f),this.updateSchema(s,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const c of r)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,c){const i=[];return r.forEach(t=>{i.push(...this.validateAndRegisterProperties(t,c,t.extensionInfo,t.restrictedProperties)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),i}doDeregisterConfigurations(r){const c=[],i=t=>{if(t.properties)for(const s in t.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>i(s))};for(const t of r){i(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(r,c=!0,i,t,s=3){s=T.isUndefinedOrNull(r.scope)?s:r.scope;let o=[],a=r.properties;if(a)for(let f in a){if(c&&w(f)){delete a[f];continue}const b=a[f];if(b.source=i,b.defaultDefaultValue=a[f].default,this.updatePropertyDefaultValue(f,b),e.OVERRIDE_PROPERTY_REGEX.test(f)?b.scope=void 0:(b.scope=T.isUndefinedOrNull(b.scope)?s:b.scope,b.restricted=T.isUndefinedOrNull(b.restricted)?!!t?.includes(f):b.restricted),a[f].hasOwnProperty("included")&&!a[f].included){this.excludedConfigurationProperties[f]=a[f],delete a[f];continue}else this.configurationProperties[f]=a[f];!a[f].deprecationMessage&&a[f].markdownDeprecationMessage&&(a[f].deprecationMessage=a[f].markdownDeprecationMessage),o.push(f)}let l=r.allOf;if(l)for(let f of l)o.push(...this.validateAndRegisterProperties(f,c,i,t,s));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const c=i=>{let t=i.properties;if(t)for(const o in t)this.updateSchema(o,t[o]);let s=i.allOf;s&&s.forEach(c)};c(r)}updateSchema(r,c){switch(e.allSettings.properties[r]=c,c.scope){case 1:e.applicationSettings.properties[r]=c;break;case 2:e.machineSettings.properties[r]=c;break;case 6:e.machineOverridableSettings.properties[r]=c;break;case 3:e.windowSettings.properties[r]=c;break;case 4:e.resourceSettings.properties[r]=c;break;case 5:e.resourceSettings.properties[r]=c,this.resourceLanguageSettingsSchema.properties[r]=c;break}}removeFromSchema(r,c){switch(delete e.allSettings.properties[r],c.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const c=`[${r}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,c){const i=this.configurationDefaultsOverrides.get(r);let t=i?.value,s=i?.source;T.isUndefined(t)&&(t=c.defaultDefaultValue,s=void 0),T.isUndefined(t)&&(t=h(c.type)),c.default=t,c.defaultValueSource=s}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(u){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let c=d.exec(u);for(;c?.length;){const i=c[1].trim();i&&r.push(i),c=d.exec(u)}}return(0,k.distinct)(r)}e.overrideIdentifiersFromKey=v;function g(u){return u.reduce((r,c)=>`${r}[${c}]`,"")}e.keyFromOverrideIdentifiers=g;function h(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const y=new m;I.Registry.add(e.Extensions.Configuration,y);function w(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?L.localize(7,null,u):y.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):null:L.localize(6,null)}e.validateProperty=w;function p(){const u=[],r=y.getConfigurationProperties();for(const c of Object.keys(r))u.push([c,r[c].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=p}),define(ne[90],ie([0,1,16,3,35,2,39,29,15,8,18,42,38]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},t=[],s=[]){this._contents=i,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const s=this.getContentsForOverrideIdentifer(t);return s?i?(0,R.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return k.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=P.deepClone(this.contents),s=P.deepClone(this.overrides),o=[...this.keys];for(const a of i){this.mergeContents(t,a.contents);for(const l of a.overrides){const[f]=s.filter(b=>k.equals(b.identifiers,l.identifiers));f?(this.mergeContents(f.contents,l.contents),f.keys.push(...l.keys),f.keys=k.distinct(f.keys)):s.push(P.deepClone(l))}for(const l of a.keys)o.indexOf(l)===-1&&o.push(l)}return new S(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[o],l=t[o];l&&(typeof a=="object"&&typeof l=="object"?(a=P.deepClone(a),this.mergeContents(a,l)):a=l),s[o]=a}return new S(s,this.keys,this.overrides)}mergeContents(i,t){for(const s of Object.keys(t)){if(s in i&&I.isObject(i[s])&&I.isObject(t[s])){this.mergeContents(i[s],t[s]);continue}i[s]=P.deepClone(t[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,s=null;const o=a=>{a&&(s?this.mergeContents(s,a):s=P.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[i])?t=a.contents:a.identifiers.includes(i)&&o(a.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,R.addToValueTree)(this.contents,i,t,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let s=0;s<t;s++)i.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class d extends S{constructor(i={}){const t=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),a=[];for(const l in t){const f=i[l],b=f!==void 0?f:t[l].default;(0,R.addToValueTree)(o,l,b,_=>console.error(`Conflict in default settings: ${_}`))}for(const l of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(l)&&a.push({identifiers:(0,E.overrideIdentifiersFromKey)(l),keys:Object.keys(o[l]),contents:(0,R.toValuesTree)(o[l],f=>console.error(`Conflict in default settings file: ${f}`))});super(o,s,a)}}e.DefaultConfigurationModel=d;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!I.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:s,keys:o,overrides:a,restricted:l}=this.doParseRaw(i,t);this._configurationModel=new S(s,o,a),this._restrictedConfigurations=l||[]}doParseContent(i){let t={},s=null,o=[],a=[],l=[];function f(_){Array.isArray(o)?o.push(_):s!==null&&(o[s]=_)}let b={onObjectBegin:()=>{let _={};f(_),a.push(o),o=_,s=null},onObjectProperty:_=>{s=_},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let _=[];f(_),a.push(o),o=_,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:f,onError:(_,O,M)=>{l.push({error:_,offset:O,length:M})}};if(i)try{T.visit(i,b),t=o[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const s=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,s,!0,t);i=o.raw;const a=(0,R.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(i),f=this.toOverrides(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:a,keys:l,overrides:f,restricted:o.restricted}}filter(i,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const a={},l=[];for(let f in i)if(E.OVERRIDE_PROPERTY_REGEX.test(f)&&s){const b=this.filter(i[f],t,!1,o);a[f]=b.raw,l.push(...b.restricted)}else{const b=t[f],_=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(f),(_===void 0||o.scopes===void 0||o.scopes.includes(_))&&(o.skipRestricted&&b?.restricted||(a[f]=i[f]))}return{raw:a,restricted:l}}toOverrides(i,t){const s=[];for(const o of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in i[o])a[l]=i[o][l];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,R.toValuesTree)(a,t)})}return s}}e.ConfigurationModelParser=v;class g extends L.Disposable{constructor(i,t,s,o){super();this.userSettingsResource=i,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class h{constructor(i,t,s=new S,o=new S,a=new A.ResourceMap,l=new S,f=new A.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=l,this._memoryConfigurationByResource=f,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new S,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,s){const o=this.getConsolidateConfigurationModel(t,s),a=this.getFolderConfigurationModelForResource(t.resource,s),l=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,f=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),M=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,D=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,F=t.overrideIdentifier?l.override(t.overrideIdentifier).getValue(i):l.getValue(i),$=o.getValue(i),q=k.distinct(k.flatten(o.overrides.map(x=>x.identifiers))).filter(x=>o.getOverrideValue(i,x)!==void 0);return{defaultValue:f,userValue:b,userLocalValue:_,userRemoteValue:O,workspaceValue:M,workspaceFolderValue:D,memoryValue:F,value:$,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:a?.freeze().getValue(i),override:t.overrideIdentifier?a?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(i),override:t.overrideIdentifier?l.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:a,removed:l}=u(this._defaultConfiguration,i);t=[...o,...a,...l]}for(const o of t)for(const a of(0,E.overrideIdentifiersFromKey)(o)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=i.getKeysForOverrideIdentifier(a),b=[...f.filter(_=>l.indexOf(_)===-1),...l.filter(_=>f.indexOf(_)===-1),...l.filter(_=>!P.equals(this._defaultConfiguration.override(a).getValue(_),i.override(a).getValue(_)))];s.push([a,b])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:a}=u(this.localUserConfiguration,i),l=[...t,...s,...o];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:a}=u(this.remoteUserConfiguration,i);let l=[...t,...s,...o];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:a}=u(this.workspaceConfiguration,i);let l=[...t,...s,...o];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:a,removed:l,overrides:f}=u(s,t);let b=[...o,...a,...l];return(b.length||!s)&&this.updateFolderConfiguration(i,t),{keys:b,overrides:f}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:a,overrides:l}=u(t,void 0);return{keys:[...s,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let s=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const o=t.getFolder(i);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const a=this._memoryConfigurationByResource.get(i);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=s}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:a}=this._folderConfigurations.get(t);return i.push([t,{contents:s,overrides:o,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((l,f)=>(l.set(C.URI.revive(f[0]),this.parseConfigurationModel(f[1])),l),new A.ResourceMap);return new h(t,s,new S,o,a,new S,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=h;function y(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,t=new Map;for(const o of c)o.keys.forEach(a=>i.add(a)),o.overrides.forEach(([a,l])=>{const f=(0,A.getOrSet)(t,a,new Set);l.forEach(b=>f.add(b))});const s=[];return t.forEach((o,a)=>s.push([a,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=y;class w{constructor(i,t,s,o){this.change=i,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(f=>a.add(f)),i.overrides.forEach(([,f])=>f.forEach(b=>a.add(b))),this.affectedKeys=[...a.values()];const l=new S;this.affectedKeys.forEach(f=>l.setValue(f,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!P.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let s=(0,R.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(i=i[o],!i)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=w;class p extends w{constructor(i,t,s,o){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=p;function u(c,i){const{added:t,removed:s,updated:o}=r(i,c),a=[],l=c?.getAllOverrideIdentifiers()||[],f=i?.getAllOverrideIdentifiers()||[];if(i){const b=f.filter(_=>!l.includes(_));for(const _ of b)a.push([_,i.getKeysForOverrideIdentifier(_)])}if(c){const b=l.filter(_=>!f.includes(_));for(const _ of b)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(i&&c){for(const b of l)if(f.includes(b)){const _=r({contents:c.getOverrideValue(void 0,b)||{},keys:c.getKeysForOverrideIdentifier(b)},{contents:i.getOverrideValue(void 0,b)||{},keys:i.getKeysForOverrideIdentifier(b)});a.push([b,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:s,updated:o,overrides:a}}function r(c,i){const t=c?i?c.keys.filter(a=>i.keys.indexOf(a)===-1):[...c.keys]:[],s=i?c?i.keys.filter(a=>c.keys.indexOf(a)===-1):[...i.keys]:[],o=[];if(c&&i){for(const a of i.keys)if(c.keys.indexOf(a)!==-1){const l=(0,R.getConfigurationValue)(i.contents,a),f=(0,R.getConfigurationValue)(c.contents,a);P.equals(l,f)||o.push(a)}}return{added:t,removed:s,updated:o}}}),define(ne[182],ie([0,1,5,3,2,20,18,90,42,38]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends T.Disposable{constructor(m,S){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,S)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,S){const d=typeof m=="string"?m:void 0,v=(0,A.isConfigurationOverrides)(m)?m:(0,A.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(d,v,void 0)}updateValue(m,S,d,v){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(d,S,1)}onDidDefaultConfigurationChange(m){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,m);this.trigger(d,S,6)}trigger(m,S,d){const v=new P.ConfigurationChangeEvent(m,{data:S},this.configuration);v.source=d,v.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(ne[183],ie([0,1,7,6]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends k.ErrorNoTelemetry{constructor(P,I=T.Unknown,C){super(P);this._message=P,this._code=I,this._detail=C,this.isHandled=I===T.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===T.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===T.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[184],ie([0,1,5,17,25,7,3,2,30,74,183]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var m;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function S(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(V){const Z=new T.CancellationTokenSource;return setTimeout(()=>Z.cancel(),V),Z.token}function v(V,Z){if(V.isCancellationRequested||Z.isCancellationRequested)return T.CancellationToken.Cancelled;const J=new T.CancellationTokenSource;return V.onCancellationRequested(()=>J.cancel()),Z.onCancellationRequested(()=>J.cancel()),J.token}class g{constructor(Z){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((J,Q)=>{this._resolvePromise=J,this._rejectPromise=Q}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function h(V,Z){const J=new g(Z);return J.registerDisposable(V.onControlMessage(Q=>{const N=JSON.parse(Q.toString()),U=G(N);U?J.reject(U):J.resolve(N)})),J.promise}function y(V,Z,J,Q,N,U,z){const j=new g(z);return Z.connect(J,Q,N,U,(ee,se)=>{j.didTimeout?(ee&&V.error(ee),se?.dispose()):ee||!se?j.reject(ee):j.resolve(se)}),j.promise}function w(V,Z){const J=new g(Z);return V.then(Q=>{J.didTimeout||J.resolve(Q)},Q=>{J.didTimeout||J.reject(Q)}),J.promise}async function p(V,Z,J,Q){const N=H(V,Z);V.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let U;try{U=await y(V.logService,V.socketFactory,V.host,V.port,`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${S(Z)}-${V.reconnectionToken}`,Q)}catch(le){throw V.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),V.logService.error(le),le}V.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let z,j;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(U,null),z=V.reconnectionProtocol,j=!1):(z=new C.PersistentProtocol(U,null),j=!0),V.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ee=await w(V.signService.createNewMessage((0,I.generateUuid)()),Q),se={type:"auth",auth:V.connectionToken||"00000000000000000000",data:ee.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const le=await h(z,v(Q,d(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(V.logService.trace(`${N} 4/6. received SignRequest control message.`),!await w(V.signService.validate(ee,le.signedData),Q)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const Se=await w(V.signService.sign(le.data),Q),we={type:"connectionType",commit:V.commit,signedData:Se,desiredConnectionType:Z};return J&&(we.args=J),V.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(we))),{protocol:z,ownsProtocol:j}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(V.logService.error(`${N} the handshake timed out. Error:`),V.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${N} received error control message when negotiating connection. Error:`),V.logService.error(le)),j&&x(z),le}}async function u(V,Z,J,Q){const N=Date.now(),U=H(V,Z),{protocol:z,ownsProtocol:j}=await p(V,Z,J,Q),ee=new g(Q);return ee.registerDisposable(z.onControlMessage(se=>{const le=JSON.parse(se.toString()),he=G(le);he?(V.logService.error(`${U} received error control message when negotiating connection. Error:`),V.logService.error(he),j&&x(z),ee.reject(he)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${te(N)}!`),ee.resolve({protocol:z,firstMessage:le}))})),ee.promise}async function r(V,Z){const{protocol:J}=await u(V,1,void 0,Z);return{protocol:J}}async function c(V,Z,J){const{protocol:Q,firstMessage:N}=await u(V,2,Z,J),U=N&&N.debugPort;return{protocol:Q,debugPort:U}}async function i(V,Z,J){const Q=Date.now(),N=H(V,3),{protocol:U}=await p(V,3,Z,J);return V.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${te(Q)}!`),U}async function t(V,Z,J){const{host:Q,port:N,connectionToken:U}=await V.addressProvider.getAddress();return{commit:V.commit,host:Q,port:N,connectionToken:U,reconnectionToken:Z,reconnectionProtocol:J,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function s(V,Z,J){try{const Q=(0,I.generateUuid)(),N=await t(V,Q,null),{protocol:U}=await r(N,T.CancellationToken.None);return new $(V,Z,J,Q,U)}catch(Q){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(Q),F.triggerPermanentFailure(0,0,R.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=s;async function o(V,Z){try{const J=(0,I.generateUuid)(),Q=await t(V,J,null),{protocol:N,debugPort:U}=await c(Q,Z,T.CancellationToken.None);return new q(V,Z,J,N,U)}catch(J){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(J),F.triggerPermanentFailure(0,0,R.RemoteAuthorityResolverError.isHandled(J)),J}}e.connectRemoteAgentExtensionHost=o;async function a(V,Z,J){const Q=await t(V,(0,I.generateUuid)(),null);return await i(Q,{host:Z,port:J},T.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function l(V){return(0,k.createCancelablePromise)(Z=>new Promise((J,Q)=>{const N=setTimeout(J,V*1e3);Z.onCancellationRequested(()=>{clearTimeout(N),J()})}))}var f;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(f=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class b{constructor(Z,J){this.reconnectionToken=Z,this.millisSinceLastIncomingData=J,this.type=0}}e.ConnectionLostEvent=b;class _{constructor(Z,J,Q,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=J,this.durationSeconds=Q,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,J,Q){this.reconnectionToken=Z,this.millisSinceLastIncomingData=J,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=O;class M{constructor(Z,J,Q){this.reconnectionToken=Z,this.millisSinceLastIncomingData=J,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=M;class D{constructor(Z,J,Q,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=J,this.attempt=Q,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=D;class F extends P.Disposable{constructor(Z,J,Q,N,U){super();this._connectionType=Z,this._options=J,this.reconnectionToken=Q,this.protocol=N,this._reconnectionFailureIsFatal=U,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new M(this.reconnectionToken,0,0)),this._register(N.onSocketClose(z=>{const j=W(this._connectionType,this.reconnectionToken,!0);z?z.type===0?(this._options.logService.info(`${j} received socket close event (hadError: ${z.hadError}).`),z.error&&this._options.logService.error(z.error)):(this._options.logService.info(`${j} received socket close event (wasClean: ${z.wasClean}, code: ${z.code}, reason: ${z.reason}).`),z.event&&this._options.logService.error(z.event)):this._options.logService.info(`${j} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const z=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} received socket timeout event.`),this._beginReconnecting()})),F._instances.push(this),this._register((0,P.toDisposable)(()=>{const z=F._instances.indexOf(this);z>=0&&F._instances.splice(z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}static triggerPermanentFailure(Z,J,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=J,this._permanentFailureHandled=Q,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||F._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const Z=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new b(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const N=Q<J.length?J[Q]:J[J.length-1];try{if(N>0){const z=l(N);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,z)),this._options.logService.info(`${Z} waiting for ${N} seconds before reconnecting...`);try{await z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${Z} resolving connection...`);const U=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,d(E)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(R.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,L.isCancellationError)(U)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof R.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,R.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(Z,J,Q){this._reconnectionFailureIsFatal?F.triggerPermanentFailure(Z,J,Q):this._gotoPermanentFailure(Z,J,Q)}_gotoPermanentFailure(Z,J,Q){this._onDidStateChange.fire(new D(this.reconnectionToken,Z,J,Q)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=F,F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class $ extends F{constructor(Z,J,Q,N,U){super(1,Z,N,U,!0);this.client=this._register(new C.Client(U,{remoteAuthority:J,clientId:Q},Z.ipcLogger))}async _reconnect(Z,J){await r(Z,J)}}e.ManagementPersistentConnection=$;class q extends F{constructor(Z,J,Q,N,U){super(2,Z,Q,N,!1);this._startArguments=J,this.debugPort=U}async _reconnect(Z,J){await c(Z,this._startArguments,J)}}e.ExtensionHostPersistentConnection=q;function x(V){try{V.acceptDisconnect();const Z=V.getSocket();V.dispose(),Z.dispose()}catch(Z){(0,L.onUnexpectedError)(Z)}}function G(V){if(V&&V.type==="error"){const Z=new Error(`Connection error: ${V.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function B(V,Z){for(;V.length<Z;)V+=" ";return V}function W(V,Z,J){return`[remote-connection][${B(S(V),13)}][${Z.substr(0,5)}\u2026][${J?"reconnect":"initial"}]`}function H(V,Z){return`${W(Z,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function te(V){return`${Date.now()-V} ms`}}),define(ne[185],ie([0,1,19]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(L){return L.scheme===k.Schemas.vscodeRemote?L.authority:void 0}e.getRemoteAuthority=n;function T(L){if(!L)return;const A=L.indexOf("+");return A<0?L:L.substr(0,A)}e.getRemoteName=T}),define(ne[61],ie([0,1,27,6,185]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=L;function A(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,v){if(typeof d=="undefined"||d===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof d=="string"||typeof v=="string"){let g=typeof d=="string"?d:d.value,h=typeof v=="string"?v:v.value;return k.equalsIgnoreCase(g,h)}return d._lower===v._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=C;function R(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function E(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function m(S,d){if(d){const v=`onResolveRemoteAuthority:${(0,T.getRemoteName)(d)}`;return S.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[31],ie([0,1,27,28,61,4,8,7,33]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,k.compareIgnoreCase)(i.id,t.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(t,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=t.id}static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,s,o)}static parse(t){const s=R.exec(t);return s&&s[1]&&s[2]?new E({id:s[1]},s[2],s[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?C(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=E;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const t=m.exec(i);return t&&t[1]?[v(t[1]),t[2]]:[v(i),void 0]}e.getIdAndVersion=S;function d(i,t){return`${i}.${t}`}e.getExtensionId=d;function v(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function g(i,t){return v(d(i,t))}e.getGalleryExtensionId=g;function h(i,t){const s=[],o=a=>{for(const l of s)if(l.some(f=>C(t(f),t(a))))return l;return null};for(const a of i){const l=o(a);l?l.push(a):s.push([a])}return s}e.groupByExtension=h;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function w(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function p(i){const t=new Set;if(i.malicious)for(const s of i.malicious)t.add(s.id);return t}e.getMaliciousExtensionsSet=p;function u(i,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&s.every(l=>!C(l.identifier,{id:a}))){const l=i.filter(f=>C(f.identifier,{id:a}));l.length===1&&(s.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=u;async function r(i,t){if(!L.isLinux)return!1;let s;try{s=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(a))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function c(i,t){const s=await r(i,t),o=(0,n.getTargetPlatform)(s?"alpine":L.platform,I.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=c}),define(ne[186],ie([0,1,25,31]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(L,A,P,I,C){try{const R=await L.getExtensionsControlManifest();if(!R.unsupportedPreReleaseExtensions)return;const E=await L.getInstalled(1);for(const[m,{id:S,migrateStorage:d}]of Object.entries(R.unsupportedPreReleaseExtensions)){const v=E.find(h=>(0,n.areSameExtensions)(h.identifier,{id:m}));if(!v)continue;const g=(await A.getExtensions([{id:S,preRelease:!0}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!g){C.info(`Skipping migrating '${v.identifier.id}' extension because, the comaptible target '${S}' extension is not found`);continue}try{C.info(`Migrating '${v.identifier.id}' extension to '${S}' extension...`);const h=!I.getDisabledExtensions().some(w=>(0,n.areSameExtensions)(w,v.identifier));await L.uninstall(v),C.info(`Uninstalled the unsupported extension '${v.identifier.id}'`);let y=E.find(w=>(0,n.areSameExtensions)(w.identifier,{id:S}));(!y||!y.isPreReleaseVersion&&h)&&(y=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:v.isMachineScoped,operation:4}),C.info(`Installed the pre-release extension '${y.identifier.id}'`),h||(await I.disableExtension(y.identifier),C.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${v.identifier.id}' is disabled`)),d&&(P.addToMigrationList((0,n.getExtensionId)(v.manifest.publisher,v.manifest.name),(0,n.getExtensionId)(y.manifest.publisher,y.manifest.name)),C.info("Added pre-release extension to the storage migration list"))),C.info(`Migrated '${v.identifier.id}' extension to '${S}' extension.`)}catch(h){C.error(h)}}}catch(R){C.error(R)}}e.migrateUnsupportedExtensions=T}),define(ne[187],ie([0,1,5,7,2,4,20,62,8,30,22,13,28,31,14,9]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class extends T.Disposable{constructor(y,w,p,u){super();this.fileService=w,this.extensionGalleryService=p,this.logService=u,this.extensionsDownloadDir=I.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,w){await this.cleanUpPromise;const p=this.getName(y),u=(0,A.joinPath)(this.extensionsDownloadDir,p);if(!await this.fileService.exists(u)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(y,r,w);try{await this.rename(r,u,Date.now()+2*60*1e3)}catch(c){try{await this.fileService.del(r)}catch{}if(c.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(c)}. Deleted the vsix from downloaded location`,r.path),c}}return u}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,w,p){try{await R.Promises.rename(y.fsPath,w.fsPath)}catch(u){if(L.isWindows&&u&&u.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${y} to ${w} with 'EPERM' error. Trying again...`),this.rename(y,w,p);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const w=[],p=[];for(const c of y.children){const i=S.ExtensionKey.parse(c.name);i&&p.push([i,c])}const u=(0,S.groupByExtension)(p,([c])=>c),r=[];for(const c of u)c.sort((i,t)=>P.rcompare(i[0].version,t[0].version)),w.push(...c.slice(1).map(i=>i[1].resource)),r.push(c[0][1]);r.sort((c,i)=>c.mtime-i.mtime),w.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(c=>c.resource)),await k.Promises.settled(w.map(c=>(this.logService.trace("Deleting vsix from cache",c.path),this.fileService.del(c))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?S.ExtensionKey.create(y).toString().toLowerCase():(0,C.generateUuid)()}};g=de([K(0,E.INativeEnvironmentService),K(1,d.IFileService),K(2,m.IExtensionGalleryService),K(3,v.ILogService)],g),e.ExtensionsDownloader=g}),define(ne[188],ie([0,1,2,10,22,61]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(I,C){super();this.environmentService=I,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(C.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtensions(I){I.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(I){I.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[189],ie([0,1,84,16,5,2,19,10,22,13,28,31,59,9]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends L.Disposable{constructor(h,y,w){super();this.extensionManagementService=h,this.logService=w,this.cache=this._register(new v(y,w)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const h=await this.cache.getLanguagePacks(),y=["en",...Object.keys(h)];return(0,n.distinct)(y)}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const y=await this.cache.getLanguagePacks();Object.keys(y).some(w=>y[w]&&y[w].extensions.some(p=>(0,E.areSameExtensions)(p.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(y);return!(0,n.equals)(Object.keys(h),Object.keys(w))}};d=de([K(0,R.IExtensionManagementService),K(1,C.INativeEnvironmentService),K(2,S.ILogService)],d),e.LocalizationsService=d;let v=class extends L.Disposable{constructor(h,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(y=>{Object.keys(y).forEach(w=>delete y[w]),this.createLanguagePacksFromExtensions(y,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...y){for(const w of y)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,w);Object.keys(h).forEach(w=>this.updateHash(h[w]))}createLanguagePacksFromExtension(h,y){const w=y.identifier,p=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const u of p)if(y.location.scheme===A.Schemas.file&&(0,m.isValidLocalization)(u)){let r=h[u.languageId];r||(r={hash:"",extensions:[],translations:{}},h[u.languageId]=r);let c=r.extensions.filter(i=>(0,E.areSameExtensions)(i.extensionIdentifier,w))[0];c?c.version=y.manifest.version:r.extensions.push({extensionIdentifier:w,version:y.manifest.version});for(const i of u.translations)r.translations[i.id]=(0,P.join)(y.location.fsPath,i.path)}}updateHash(h){if(h){const y=(0,k.createHash)("md5");for(const w of h.extensions)y.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);h.hash=y.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(y=h(w),w)).then(w=>{for(const u of Object.keys(w))w[u]||delete w[u];this.languagePacks=w,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),I.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>y,w=>this.logService.error(w))})}};v=de([K(0,C.INativeEnvironmentService),K(1,S.ILogService)],v)}),define(ne[190],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[191],ie([0,1,120,18,9]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,I){this.configurationService=P,this.logService=I}request(P,I){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(P,I)}async resolveProxy(P){}};L=de([K(0,n.IConfigurationService),K(1,T.ILogService)],L),e.RequestService=L}),define(ne[43],ie([0,1,17,140,42,6,38]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=P;function I(d){return d.res.statusCode===204}async function C(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);return I(d)?null:(await(0,k.streamToBuffer)(d.stream)).toString()}e.asText=C;async function R(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);if(I(d))return null;const g=(await(0,k.streamToBuffer)(d.stream)).toString();try{return JSON.parse(g)}catch(h){throw h.message+=`:
`+g,h}}e.asJson=R;function E(d){S(d)}e.updateProxyConfigurationsScope=E;let m;function S(d){const v=A.Registry.as(T.Extensions.Configuration),g=m;m={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[m],remove:g?[g]:[]})}S(2)}),define(ne[192],ie([0,1,25,19,14,43]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(I,C){this.requestService=I,this.fileService=C}async download(I,C,R=k.CancellationToken.None){if(I.scheme===n.Schemas.file||I.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(I,C);return}const E={type:"GET",url:I.toString()},m=await this.requestService.request(E,R);if(m.res.statusCode===200)await this.fileService.writeFile(C,m.stream);else{const S=await(0,L.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${S}`)}}};A=de([K(0,L.IRequestService),K(1,T.IFileService)],A),e.DownloadService=A}),define(ne[193],ie([0,1,16,25,68,2,20,154,14,9,26,43]),function(Y,e,k,n,T,L,A,P,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends L.Disposable{constructor(d,v,g,h){super();this.fileService=d,this.productService=v,this.requestService=g,this.logService=h,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,T.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const v=[];for(const[g,h]of this.allConfigBasedTips)if(!(h.configScheme&&h.configScheme!==d.scheme))try{const y=await this.fileService.readFile((0,A.joinPath)(d,g)),w=new Map;(0,T.forEach)(h.recommendations,({key:u,value:r})=>{if((0,k.isNonEmptyArray)(r.remotes))for(const c of r.remotes)w.set(c,{extensionId:u,extensionName:r.name,configName:h.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled});else v.push({extensionId:u,extensionName:r.name,configName:h.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled})});const p=(0,P.getDomainsOfRemotes)(y.value.toString(),[...w.keys()]);for(const u of p){const r=w.get(u);r&&v.push(r)}}catch{}return v}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(d.res.statusCode!==200)return[];const v=await(0,E.asJson)(d);return v?v.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};m=de([K(0,I.IFileService),K(1,R.IProductService),K(2,E.IRequestService),K(3,C.ILogService)],m),e.ExtensionTipsService=m}),define(ne[91],ie([0,1,71,6]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function T(L){return(0,k.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=T,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[194],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[195],ie([0,1,75,5,25,3,2,19,30,9,91,194]),function(Y,e,k,n,T,L,A,P,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(v){this.logService=v,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const g=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${g})`);const h=(0,R.hash)(v);this.processeDisposables.has(h)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${g})`),this.doDisposeWorker(v));const y=new T.CancellationTokenSource;let w,p,u;this.processeDisposables.set(h,t=>{y.dispose(!0),w?.terminate(v,T.CancellationToken.None),p?.close(),u?.close(),this.processeDisposables.delete(h);const s=this.processResolvers.get(h);s&&(this.processResolvers.delete(h),s({reason:t}))}),w=await this.getOrCreateWebWorker(v);const r=new Promise(t=>{this.processResolvers.set(h,t)});if(y.token.isCancellationRequested)return r;const{port1:c,port2:i}=new MessageChannel;return p=c,u=i,await w.spawn(v,u,y.token),y.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${g})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[p])),r}getOrCreateWebWorker(v){let g=this.workers.get(v.process.moduleId);if(!g){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const h=new S(v.process.type,this.logService);g=h.init(),h.onDidProcessSelfTerminate(({configuration:y,reason:w})=>{this.doDisposeWorker(y,w)}),this.workers.set(v.process.moduleId,g)}return g}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,g){const h=this.processeDisposables.get((0,R.hash)(v));h&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),h(g))}};m=de([K(0,C.ILogService)],m),e.SharedProcessWorkerService=m;class S extends A.Disposable{constructor(v,g){super();this.type=v,this.logService=g,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const v=new n.DeferredPromise,g=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return g.onerror=h=>{this.logService.error(`SharedProcess: worker error (${this.type})`,h.message)},g.onmessageerror=h=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,h)},g.onmessage=h=>{const{id:y,message:w,configuration:p,nonce:u}=h.data;switch(y){case E.SharedProcessWorkerMessages.Ready:v.complete(g);break;case E.SharedProcessWorkerMessages.Ack:if(u){const r=this.mapMessageNonceToPendingMessageResolve.get(u);r&&(this.mapMessageNonceToPendingMessageResolve.delete(u),r())}break;case E.SharedProcessWorkerMessages.SelfTerminated:p&&w&&this._onDidProcessSelfTerminate.fire({configuration:p,reason:JSON.parse(w)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,w);break;case E.SharedProcessWorkerMessages.Info:w&&this.logService.info(w);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,w);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,w);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,h)}},g.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async send(v,g,h){const y=await this.workerReady;if(!g.isCancellationRequested)return new Promise(w=>{const p=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(p,w);const u={...v,nonce:p};h?y.postMessage(u,[h]):y.postMessage(u),g.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(p)&&w()})})}spawn(v,g,h){const y={id:E.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Y).fsPath}};return this.send(y,h,g)}terminate(v,g){const h={id:E.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(h,g)}}}),define(ne[196],ie([0,1,54,19,153]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends T.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}de([k.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[197],ie([0,1,45,10,141,25,37,7,4,30,124,151,5]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let d;async function v(h,y,w){return y["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(w)&&!y["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(w)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=m.Promises.withAsyncBody(async(p,u)=>{const r=new L.CancellationTokenSource,c=setTimeout(()=>{r.dispose(!0),u(new Error((0,T.localize)(0,null)))},S);try{p(await g(h,r.token))}catch(i){!(0,P.isCancellationError)(i)&&!r.token.isCancellationRequested?u(new Error((0,T.localize)(1,null,(0,A.toErrorMessage)(i)))):p({})}finally{clearTimeout(c),r.dispose()}})),d)}e.getResolvedShellEnv=v;async function g(h,y){const w=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",w);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const u=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",c);const i=await(0,R.getSystemShell)(I.OS,c);return h.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(y.isCancellationRequested)return s((0,P.canceled)());const o=(0,n.basename)(i);let a,l;const f=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${f} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' ${f} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?l=["-ic"]:l=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const b=(0,k.spawn)(i,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});y.onCancellationRequested(()=>(b.kill(),s((0,P.canceled)()))),b.on("error",M=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(M)),s(M)});const _=[];b.stdout.on("data",M=>_.push(M));const O=[];b.stderr.on("data",M=>O.push(M)),b.on("close",(M,D)=>{const F=Buffer.concat(_).toString("utf8");h.trace("getUnixShellEnvironment#raw",F);const $=Buffer.concat(O).toString("utf8");if($.trim()&&h.trace("getUnixShellEnvironment#stderr",$),M||D)return s(new Error((0,T.localize)(2,null,M,D)));const q=r.exec(F),x=q?q[1]:"{}";try{const G=JSON.parse(x);w?G.ELECTRON_RUN_AS_NODE=w:delete G.ELECTRON_RUN_AS_NODE,p?G.ELECTRON_NO_ATTACH_CONSOLE=p:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){h.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(G)),s(G)}})})}}),define(ne[92],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[198],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((T,L)=>Y(["vsda"],T,L))}async createNewMessage(T){try{const L=await this.vsda(),A=new L.validator;if(A){const P=String(k._nextId++);return this.validators.set(P,A),{id:P,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,L){if(!T.id)return!0;const A=this.validators.get(T.id);if(!A)return!1;this.validators.delete(T.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(T){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(T)}catch{}return T}}e.SignService=k,k._nextId=1}),define(ne[23],ie([0,1,5,3,2,176,15,76,6]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,I.createDecorator)("storageService");var R;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class S extends T.Disposable{constructor(h={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=h,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,y){y===C?(h===0?this._globalKeyTargets=void 0:h===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:h})):this._onDidChangeValue.fire({scope:h,key:y,target:this.getKeyTargets(h)[y]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,y,w){return this.getStorage(y)?.get(h,w)}getBoolean(h,y,w){return this.getStorage(y)?.getBoolean(h,w)}getNumber(h,y,w){return this.getStorage(y)?.getNumber(h,w)}store(h,y,w,p){if((0,A.isUndefinedOrNull)(y)){this.remove(h,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,w,p),this.getStorage(w)?.set(h,y)})}remove(h,y){this.withPausedEmitters(()=>{this.updateKeyTarget(h,y,void 0),this.getStorage(y)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,y){const w=[],p=this.getKeyTargets(h);for(const u of Object.keys(p))p[u]===y&&w.push(u);return w}updateKeyTarget(h,y,w){const p=this.getKeyTargets(y);typeof w=="number"?p[h]!==w&&(p[h]=w,this.getStorage(y)?.set(C,JSON.stringify(p))):typeof p[h]=="number"&&(delete p[h],this.getStorage(y)?.set(C,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(h){return h===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(h){const y=this.get(C,h);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}async flush(h=R.NONE){this._onWillSaveState.fire({reason:h});const y=this.getStorage(0),w=this.getStorage(1);switch(h){case R.NONE:await k.Promises.settled([y?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await k.Promises.settled([y?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve()]);break}}async logStorage(){const h=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return v(h,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends S{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.globalStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h)))}getStorage(h){return h===0?this.globalStorage:this.workspaceStorage}getLogDetails(h){return h===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(h){}}e.InMemoryStorageService=d;async function v(g,h,y,w){const p=o=>{try{return JSON.parse(o)}catch{return o}},u=new Map,r=new Map;g.forEach((o,a)=>{u.set(a,o),r.set(a,p(o))});const c=new Map,i=new Map;h.forEach((o,a)=>{c.set(a,o),i.set(a,p(o))}),console.group(`Storage: Global (path: ${y})`);let t=[];u.forEach((o,a)=>{t.push({key:a,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${w})`);let s=[];c.forEach((o,a)=>{s.push({key:a,value:o})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=v}),define(ne[199],ie([0,1,3,2,15,28,31,23]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends n.Disposable{constructor(E,m){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(E)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(m.onDidInstallExtensions(S=>S.forEach(({local:d,operation:v})=>{d&&v===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(E,m){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:m}),!0):!1}async disableExtension(E,m){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let m=this.getDisabledExtensions();return m.every(S=>!(0,A.areSameExtensions)(S,E))?(m.push(E),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(E){let m=this.getDisabledExtensions();for(let S=0;S<m.length;S++){const d=m[S];if((0,A.areSameExtensions)(d,E))return m.splice(S,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(E){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,m){this.storageManger.set(E,m,0)}};I=de([K(0,P.IStorageService),K(1,L.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class C extends n.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(E,m){let S;return m===0?((0,T.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,m)),S=this.storage[E]):S=this._get(E,m),JSON.parse(S)}set(E,m,S){let d=JSON.stringify(m.map(({id:g,uuid:h})=>({id:g,uuid:h})));this._get(E,S)!==d&&(S===0&&(m.length?this.storage[E]=d:delete this.storage[E]),this._set(E,m.length?d:void 0,S))}onDidStorageChange(E){if(E.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const S=this.get(E.key,E.scope);delete this.storage[E.key];const d=this.get(E.key,E.scope),v=S.filter(h=>!d.some(y=>(0,A.areSameExtensions)(h,y))),g=d.filter(h=>!S.some(y=>(0,A.areSameExtensions)(y,h)));(v.length||g.length)&&this._onDidChange.fire([...v,...g])}}_get(E,m){return this.storageService.get(E,m,"[]")}_set(E,m,S){m?this.storageService.store(E,m,S,1):this.storageService.remove(E,S)}}e.StorageManager=C}),define(ne[63],ie([0,1,6,3,2,23,31,26,16,9,15]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class nt extends T.Disposable{constructor(d,v,g){super();this.storageService=d,this.productService=v,this.logService=g,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const v=E.exec(d);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const d=this.storageService.keys(0,1);for(const v of d){const g=nt.fromKey(v);g&&this.extensionsWithKeysForSync.add(g.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=nt.fromKey(d.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(d){if((0,R.isString)(d))return d;const v=d.manifest?d.manifest.publisher:d.publisher,g=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(v,g)}getExtensionState(d,v){const g=this.getExtensionId(d),h=this.storageService.get(g,v?0:1);if(h)try{return JSON.parse(h)}catch(y){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${v}): ${y}`)}}setExtensionState(d,v,g){const h=this.getExtensionId(d);v===void 0?this.storageService.remove(h,g?0:1):this.storageService.store(h,JSON.stringify(v),g?0:1,1)}setKeysForSync(d,v){this.storageService.store(nt.toKey(d),JSON.stringify(v),0,1)}getKeysForSync(d){const v=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],g=this.storageService.get(nt.toKey(d),0),h=g?JSON.parse(g):void 0;return h&&v?(0,I.distinct)([...h,...v]):h||v}addToMigrationList(d,v){if(d!==v){const g=this.migrationList.filter(h=>!h.includes(d)&&!h.includes(v));g.push([d,v]),this.migrationList=g}}getSourceExtensionToMigrate(d){const v=this.migrationList.find(([,g])=>d===g);return v?v[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const v=JSON.parse(d);if((0,R.isArray)(v))return v}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};m=de([K(0,L.IStorageService),K(1,P.IProductService),K(2,C.ILogService)],m),e.ExtensionStorageService=m}),define(ne[200],ie([0,1,2,28,63,186,9]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let P=class extends k.Disposable{constructor(C,R,E,m,S){super();C.removeDeprecatedExtensions(),(0,L.migrateUnsupportedExtensions)(C,R,E,m,S)}};P=de([K(0,n.IExtensionManagementService),K(1,n.IExtensionGalleryService),K(2,T.IExtensionStorageService),K(3,n.IGlobalExtensionEnablementService),K(4,A.ILogService)],P),e.ExtensionsCleaner=P}),define(ne[201],ie([0,1,3,2]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class T extends n.Disposable{constructor(C,R){super();this.channel=C,this.workspace=R}async getItems(){const C={workspace:this.workspace},R=await this.channel.call("getItems",C);return new Map(R)}updateItems(C){const R={workspace:this.workspace};return C.insert&&(R.insert=Array.from(C.insert.entries())),C.delete&&(R.delete=Array.from(C.delete.values())),this.channel.call("updateItems",R)}}class L extends T{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class A extends T{constructor(C,R){super(C,R);this.onDidChangeItemsExternal=k.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class P extends n.Disposable{constructor(C,R){super();this.channel=C,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(ne[202],ie([0,1,5,2,20,76,23,201]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class I extends A.AbstractStorageService{constructor(R,E,m){super();this.mainProcessService=E,this.environmentService=m,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(R)}createGlobalStorage(){const R=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new L.Storage(R.globalStorage);return this._register(E.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),E}createWorkspaceStorage(R){const E=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),R);if(E.workspaceStorage){const m=new L.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=m.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=R?.id,m}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(R){return R===0?this.globalStorage:this.workspaceStorage}getLogDetails(R){return R===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(R){const E=this.workspaceStorage,m=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(R),await this.workspaceStorage.init();for(const[S,d]of m)this.workspaceStorage.set(S,d)}}e.NativeStorageService=I}),define(ne[203],ie([0,1,4,33,8,30]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(C){if(k.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function P(C,R,E,m,S,d,v,g,h,y){const w=Object.create(null);w["common.machineId"]=v,w.sessionID=(0,L.generateUuid)()+Date.now(),w.commitHash=S,w.version=d,w["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,k.PlatformToString)(k.platform),w["common.nodePlatform"]=n.platform,w["common.nodeArch"]=m,w["common.product"]=y||"desktop";const p=I(g||[]);p&&(w["common.msftInternal"]=p);let u=0;const r=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),k.isLinuxSnap&&(w["common.snap"]="true");const c=A(E);c&&(w["common.platformDetail"]=c);try{const i=await C.readFile(T.URI.file(h));w["common.source"]=i.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=P;function I(C){const R=n.env.USERDNSDOMAIN;if(!R)return!1;const E=R.toLowerCase();return C.some(m=>E===m)}e.verifyMicrosoftInternalDomain=I}),define(ne[21],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[204],ie([0,1,34,55,5,35,19,10,4,8,113,22,116,81,14,26,21]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function y(c,i){const t=`${c}::${i.join(":")}`,s=h.get(t);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,l=new Map,f=2e4;function b(O,M,D,F){const $=M.substring(O.length+1);return T.Promises.withAsyncBody(async q=>{let x;try{x=await E.Promises.readdir(M,{withFileTypes:!0})}catch{q();return}if(F.count>=f){F.count+=x.length,F.maxReached=!0,q();return}let G=x.length;if(G===0){q();return}let B=x;F.count+x.length>f&&(F.maxReached=!0,G=f-F.count,B=x.slice(0,G)),F.count+=x.length;for(const W of B)if(W.isDirectory()){if(D.includes(W.name)||await b(O,(0,P.join)(M,W.name),D,F),--G==0){q();return}}else{const H=W.name.lastIndexOf(".");if(H>=0){const te=W.name.substring(H+1);te&&a.set(te,(a.get(te)??0)+1)}for(const te of o)te.relativePathPattern?.test($)!==!1&&te.filePattern.test(W.name)&&l.set(te.tag,(l.get(te.tag)??0)+1);if(--G==0){q();return}}})}const _=T.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await b(c,c,i,M);const D=await u(c);O({configFiles:w(l),fileTypes:w(a),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:D})});return h.set(t,_),_}e.collectWorkspaceStats=y;function w(c){return[...n.Iterable.map(c.entries(),([i,t])=>({name:i,count:t}))].sort((i,t)=>t.count-i.count)}function p(){const c={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=p;async function u(c){try{const i=new Map,t=(0,P.join)(c,".vscode","launch.json"),s=await E.Promises.readFile(t),o=[],a=(0,L.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${t}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const l of a.configurations){const f=l.type;f&&(i.has(f)?i.set(f,i.get(f)+1):i.set(f,1))}return w(i)}catch{return[]}}e.collectLaunchConfigs=u;let r=class{constructor(i,t){this.telemetryService=i,this.productService=t}formatMachineInfo(i){const t=[];return t.push(`OS Version:       ${i.os}`),t.push(`CPUs:             ${i.cpus}`),t.push(`Memory (System):  ${i.memory}`),t.push(`VM:               ${i.vmHint}`),t.join(`
`)}formatEnvironment(i){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&t.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||t.push(`Load (avg):       ${k.loadavg().map(o=>Math.round(o)).join(", ")}`),t.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${i.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(i,t){return Promise.all([(0,m.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[o,a]=s,l=this.formatProcessList(i,o);return t.forEach(f=>{if((0,S.isRemoteDiagnosticError)(f))l+=`
${f.errorMessage}`,a+=`
${f.errorMessage}`;else if(l+=`

Remote: ${f.hostName}`,f.processes&&(l+=`
${this.formatProcessList(i,f.processes)}`),f.workspaceMetadata){a+=`
|  Remote: ${f.hostName}`;for(const b of Object.keys(f.workspaceMetadata)){const _=f.workspaceMetadata[b];let O=`${_.fileCount} files`;_.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${b}): ${O}`,a+=this.formatWorkspaceStats(_)}}}),{processInfo:l,workspaceInfo:a}})}async getSystemInfo(i,t){const{memory:s,vmHint:o,os:a,cpus:l}=p(),f={os:a,memory:s,cpus:l,vmHint:o,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:t};return I.isWindows||(f.load=`${k.loadavg().map(b=>Math.round(b)).join(", ")}`),I.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(i,t){const s=[];return(0,m.listProcesses)(i.mainPID).then(async o=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,o)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),t.forEach(a=>{if((0,S.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.formatMachineInfo(a.machineInfo)),a.processes&&s.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const l of Object.keys(a.workspaceMetadata)){const f=a.workspaceMetadata[l];let b=`${f.fileCount} files`;f.maxFilesReached&&(b=`more than ${b}`),s.push(`Folder (${l}): ${b}`),s.push(this.formatWorkspaceStats(f))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const t=[],s=60;let o=0;const a=(_,O)=>{const M=` ${_}(${O})`;o+M.length>s?(t.push(l),l="|                 ",o=l.length):o+=M.length,l+=M};let l="|      File types:";const f=10;let b=i.fileTypes.length>f?f:i.fileTypes.length;for(let _=0;_<b;_++){const O=i.fileTypes[_];a(O.name,O.count)}if(t.push(l),i.configFiles.length>=0&&(l="|      Conf files:",o=0,i.configFiles.forEach(_=>{a(_.name,_.count)}),t.push(l)),i.launchConfigFiles.length>0){let _="|      Launch Configs:";i.launchConfigFiles.forEach(O=>{_+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),t.push(_)}return t.join(`
`)}expandGPUFeatures(i){const t=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(t-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const t=[],s=[];return i.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(t.push(`|  Window (${o.title})`),o.folderURIs.forEach(a=>{const l=C.URI.revive(a);if(l.scheme===A.Schemas.file){const f=l.fsPath;s.push(y(f,["node_modules",".git"]).then(b=>{let _=`${b.fileCount} files`;b.maxFilesReached&&(_=`more than ${_}`),t.push(`|    Folder (${(0,P.basename)(f)}): ${_}`),t.push(this.formatWorkspaceStats(b))}).catch(b=>{t.push(`|      Error: Unable to collect workspace stats for folder ${f} (${b.toString()})`)}))}else t.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>t.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(i,t){const s=new Map;i.windows.forEach(a=>s.set(a.pid,a.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(i.mainPID,s,o,t,0),o.join(`
`)}formatProcessItem(i,t,s,o,a){const l=a===0;let f;l?f=o.pid===i?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(a)} ${o.name}`,o.name==="window"&&(f=`${f} (${t.get(o.pid)})`));const b=process.platform==="win32"?o.mem:k.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(b/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(o.children)&&o.children.forEach(_=>this.formatProcessItem(i,t,s,_,a+1))}async getWorkspaceFileExtensions(i){const t=new Set;for(const{uri:s}of i.folders){const o=C.URI.revive(s);if(o.scheme!==A.Schemas.file)continue;const a=o.fsPath;try{(await y(a,["node_modules",".git"])).fileTypes.forEach(f=>t.add(f.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(i){for(const{uri:t}of i.folders){const s=C.URI.revive(t);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{const a=await y(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),a.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),a.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};r=de([K(0,g.ITelemetryService),K(1,v.IProductService)],r),e.DiagnosticsService=r}),define(ne[205],ie([0,1,16,5,25,7,3,2,4,8,129,28,31,9,26,21]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{constructor(r,c,i,t){super();this.galleryService=r,this.telemetryService=c,this.logService=i,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const c=await this.getTargetPlatform();return r.allTargetPlatforms.some(i=>(0,E.isTargetPlatformCompatible)(i,r.allTargetPlatforms,c))}async installFromGallery(r,c={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(R.localize(0,null),E.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(r,!c.installGivenVersion,!!c.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,c)}catch(i){throw w(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(r),void 0,i),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(i),y(i)}}async uninstall(r,c={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,c)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const c=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...r.identifier,preRelease:r.preRelease}],{targetPlatform:c,compatible:!0},T.CancellationToken.None);if(!i)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,c,i){if(!C.URI.isUri(c)){let l=this.installingExtensions.get(m.ExtensionKey.create(c).toString());if(l)return this.logService.info("Extensions is already requested to install",c.identifier.id),l.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],s=[],o=this.createInstallExtensionTask(r,c,i);C.URI.isUri(c)||this.installingExtensions.set(m.ExtensionKey.create(c).toString(),o),this._onInstallExtension.fire({identifier:o.identifier,source:c}),this.logService.info("Installing extension:",o.identifier.id),t.push({task:o,manifest:r});let a=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const f=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,r,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:b,manifest:_}of f){a=a||!!_.extensionDependencies?.some(M=>(0,m.areSameExtensions)({id:M},o.identifier));const O=m.ExtensionKey.create(b).toString();if(this.installingExtensions.has(O))this.logService.info("Extension is already requested to install",b.identifier.id);else{const M=this.createInstallExtensionTask(_,b,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(O,M),this._onInstallExtension.fire({identifier:M.identifier,source:b}),this.logService.info("Installing extension:",M.identifier.id),t.push({task:M,manifest:_})}}}catch(f){if(C.URI.isUri(o.source))(0,k.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,f.message),(0,k.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,f.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),f}const l=t.reduce((f,{task:b,manifest:_})=>(f.set(b.identifier.id.toLowerCase(),{task:b,manifest:_}),f),new Map);for(;l.size;){let f;const b=[...l.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(O=>l.has(O.toLowerCase())));b.length?f=l.size===1?b:b.filter(({task:_})=>!(_===o&&!a)):(this.logService.info("Found extensions with circular dependencies",b.map(({task:_})=>_.identifier.id)),f=[...l.values()]),await this.joinAllSettled(f.map(async({task:_})=>{const O=new Date().getTime();try{const M=await _.run();if(await this.joinAllSettled(this.participants.map(D=>D.postInstall(M,_.source,i,T.CancellationToken.None))),!C.URI.isUri(_.source)&&(w(this.telemetryService,_.operation===3?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-O,void 0),I.isWeb&&_.operation!==3))try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}s.push({local:M,identifier:_.identifier,operation:_.operation,source:_.source})}catch(M){throw C.URI.isUri(_.source)||w(this.telemetryService,_.operation===3?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-O,M),this.logService.error("Error while installing the extension:",_.identifier.id),M}finally{l.delete(_.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:f})=>this.logService.info("Extension installed successfully:",f.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:f})=>(0,m.areSameExtensions)(f,o.identifier))[0].local}catch(l){if(t.forEach(({task:f})=>f.cancel()),s.length)try{const f=await Promise.allSettled(s.map(({local:b})=>this.createUninstallExtensionTask(b,{versionOnly:!0}).run()));for(let b=0;b<f.length;b++){const _=f[b],{identifier:O}=s[b];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,L.getErrorMessage)(_.reason))}}catch(f){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(f),s.map(({identifier:b})=>b.id))}throw this._onDidInstallExtensions.fire(t.map(({task:f})=>({identifier:f.identifier,operation:2,source:f.source}))),l}finally{for(const{task:l}of t)if(!C.URI.isUri(l.source)){const f=m.ExtensionKey.create(l.source).toString();this.installingExtensions.delete(f)||this.logService.warn("Installation task is not found in the cache",f)}}}async joinAllSettled(r){const c=[],i=[],t=await Promise.allSettled(r);for(const s of t)s.status==="fulfilled"?c.push(s.value):i.push(s.reason);if(i.length)throw h(i);return c}async getAllDepsAndPackExtensionsToInstall(r,c,i,t){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const o=[r,...s.map(f=>f.identifier)],a=[],l=async(f,b)=>{const _=b.extensionDependencies||[],O=[..._];if(b.extensionPack){const M=i?s.find(D=>(0,m.areSameExtensions)(D.identifier,f)):void 0;for(const D of b.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(F=>(0,m.areSameExtensions)({id:F},{id:D}))||O.every(F=>!(0,m.areSameExtensions)({id:F},{id:D}))&&O.push(D)}if(O.length){const M=[...o,...a.map(F=>F.gallery.identifier)],D=O.filter(F=>M.every($=>!(0,m.areSameExtensions)($,{id:F})));if(D.length){const F=await this.galleryService.getExtensions(D.map($=>({id:$,preRelease:t})),T.CancellationToken.None);for(const $ of F){if(M.find(G=>(0,m.areSameExtensions)(G,$.identifier)))continue;const q=_.some(G=>(0,m.areSameExtensions)({id:G},$.identifier));let x;try{x=await this.checkAndGetCompatibleVersion($,!0,t)}catch(G){if(G instanceof E.ExtensionManagementError&&G.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw G}a.push({gallery:x.extension,manifest:x.manifest}),await l(x.extension.identifier,x.manifest)}}}};return await l(r,c),s=await this.getInstalled(),a.filter(f=>!s.some(b=>(0,m.areSameExtensions)(b.identifier,f.gallery.identifier)))}async checkAndGetCompatibleVersion(r,c,i){const t=await this.getExtensionsControlManifest();if((0,m.getMaliciousExtensionsSet)(t).has(r.identifier.id))throw new E.ExtensionManagementError(R.localize(3,null,r.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!!t.unsupportedPreReleaseExtensions&&!!t.unsupportedPreReleaseExtensions[r.identifier.id])throw new E.ExtensionManagementError(R.localize(4,null,r.identifier.id,t.unsupportedPreReleaseExtensions[r.identifier.id].displayName),E.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const a=await this.getTargetPlatform();throw new E.ExtensionManagementError(R.localize(5,null,r.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(a)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(r,c,i);if(s){if(i&&c&&r.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(R.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],T.CancellationToken.None))[0]?new E.ExtensionManagementError(R.localize(7,null,r.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(R.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const o=await this.galleryService.getManifest(s,T.CancellationToken.None);if(o===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(o.version!==s.version)throw new E.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:o}}async getCompatibleVersion(r,c,i){const t=await this.getTargetPlatform();let s=null;return c&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==i&&(s=(await this.galleryService.getExtensions([{...r.identifier,preRelease:i}],{targetPlatform:t,compatible:!0},T.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(r,i,t)&&(s=r),!s&&c&&(s=await this.galleryService.getCompatibleExtension(r,i,t)),s}async unininstallExtension(r,c){const i=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),i.waitUntilTaskIsFinished();const t=(l,f)=>{const b=this.createUninstallExtensionTask(l,f);return this.uninstallingExtensions.set(b.extension.identifier.id.toLowerCase(),b),this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier),b},s=(l,f)=>{f?this.logService.error("Failed to uninstall extension:",l.identifier.id,f.message):this.logService.info("Successfully uninstalled extension:",l.identifier.id),w(this.telemetryService,"extensionGallery:uninstall",(0,m.getLocalExtensionTelemetryData)(l),void 0,f),this._onDidUninstallExtension.fire({identifier:l.identifier,error:f?.code})},o=[],a=[];try{o.push(t(r,{}));const l=await this.getInstalled(1);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const f=this.getAllPackExtensionsToUninstall(r,l);for(const b of f)this.uninstallingExtensions.has(b.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",b.identifier.id):o.push(t(b,{}))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(o.map(f=>f.extension),l,r),await this.joinAllSettled(o.map(async f=>{try{if(await f.run(),await this.joinAllSettled(this.participants.map(b=>b.postUninstall(f.extension,c,T.CancellationToken.None))),f.extension.identifier.uuid)try{await this.galleryService.reportStatistic(f.extension.manifest.publisher,f.extension.manifest.name,f.extension.manifest.version,"uninstall")}catch{}s(f.extension)}catch(b){const _=b instanceof E.ExtensionManagementError?b:new E.ExtensionManagementError((0,L.getErrorMessage)(b),E.ExtensionManagementErrorCode.Internal);throw s(f.extension,_),_}finally{a.push(f)}}))}catch(l){const f=l instanceof E.ExtensionManagementError?l:new E.ExtensionManagementError((0,L.getErrorMessage)(l),E.ExtensionManagementErrorCode.Internal);for(const b of o){try{b.cancel()}catch{}a.includes(b)||s(b.extension,f)}throw f}finally{for(const l of o)this.uninstallingExtensions.delete(l.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",l.extension.identifier.id)}}checkForDependents(r,c,i){for(const t of r){const s=this.getDependents(t,c);if(s.length){const o=s.filter(a=>!r.some(l=>(0,m.areSameExtensions)(l.identifier,a.identifier)));if(o.length)throw new Error(this.getDependentsErrorMessage(t,o,i))}}}getDependentsErrorMessage(r,c,i){return i===r?c.length===1?R.localize(9,null,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?R.localize(10,null,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):R.localize(11,null,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?R.localize(12,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?R.localize(13,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):R.localize(14,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}getAllPackExtensionsToUninstall(r,c,i=[]){if(i.indexOf(r)!==-1)return[];i.push(r);const t=r.manifest.extensionPack?r.manifest.extensionPack:[];if(t.length){const s=c.filter(a=>!a.isBuiltin&&t.some(l=>(0,m.areSameExtensions)({id:l},a.identifier))),o=[];for(const a of s)o.push(...this.getAllPackExtensionsToUninstall(a,c,i));return[...s,...o]}return[]}getDependents(r,c){return c.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(t=>(0,m.areSameExtensions)({id:t},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=de([K(0,E.IExtensionGalleryService),K(1,v.ITelemetryService),K(2,S.ILogService),K(3,d.IProductService)],g),e.AbstractExtensionManagementService=g;function h(u){const r=Array.isArray(u)?u:[u];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((c,i)=>new Error(`${c.message}${c.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=h;function y(u){if(u instanceof E.ExtensionManagementError)return u;const r=new E.ExtensionManagementError(u.message,E.ExtensionManagementErrorCode.Internal);return r.stack=u.stack,r}function w(u,r,c,i,t){const s=t?t instanceof E.ExtensionManagementError?t.code:E.ExtensionManagementErrorCode.Internal:void 0;u.publicLogError(r,{...c,success:!t,duration:i,errorcode:s})}e.reportTelemetry=w;class p{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(r=>new Promise((c,i)=>{const t=r.onCancellationRequested(()=>{t.dispose(),i((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=p}),define(ne[206],ie([0,1,16,5,68,3,10,4,33,8,131,13,28,31,193,83,14,9,60,26,43,23,21]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const c="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let t=class extends d.ExtensionTipsService{constructor(o,a,l,f,b,_,O,M,D,F){super(O,M,D,F);this.environmentService=o,this.telemetryService=a,this.extensionManagementService=l,this.storageService=f,this.nativeHostService=b,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,M.exeBasedExtensionTips&&(0,T.forEach)(M.exeBasedExtensionTips,({key:$,value:q})=>{const x=[],G=[],B=[];(0,T.forEach)(q.recommendations,({key:W,value:H})=>{H.important?q.important?x.push({extensionId:W,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):G.push({extensionId:W,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):B.push({extensionId:W,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),x.length&&this.highImportanceExecutableTips.set($,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:x}),G.length&&this.mediumImportanceExecutableTips.set($,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:G}),B.length&&this.allOtherExecutableTips.set($,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:B})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,l)}groupImportantTipsByExe(o,a){const l=new Map;o.forEach(M=>l.set(M.extensionId.toLowerCase(),M));const{installed:f,uninstalled:b}=this.groupByInstalled([...l.keys()],a);for(const M of f){const D=l.get(M);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:M,exeName:D.exeName})}for(const M of b){const D=l.get(M);D&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:M,exeName:D.exeName})}const _=this.getPromptedExecutableTips(),O=new Map;for(const M of b){const D=l.get(M);if(D&&(!_[D.exeName]||!_[D.exeName].includes(D.extensionId))){let F=O.get(D.exeName);F||(F=[],O.set(D.exeName,F)),F.push(D)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const f=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const f=this._register((0,n.disposableTimeout)(()=>{f.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),a=Date.now()-o,l=7*24*60*60*1e3;if(a<l){const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},l-a));return}const[f,b]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(b).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(b[0].exeName,b);const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(o){const a=await this.extensionManagementService.getInstalled(1),l=o.filter(b=>!b.whenNotInstalled||b.whenNotInstalled.every(_=>a.every(O=>!(0,S.areSameExtensions)(O.identifier,{id:_})))).map(({extensionId:b})=>b.toLowerCase()),f=(0,R.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,f,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(i,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(i,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(c,0,"{}"))}addToRecommendedExecutables(o,a){const l=this.getPromptedExecutableTips();l[o]=a.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(c,JSON.stringify(l),0,0)}groupByInstalled(o,a){const l=[],f=[],b=a.reduce((_,O)=>(_.add(O.identifier.id.toLowerCase()),_),new Set);return o.forEach(_=>{b.has(_.toLowerCase())?l.push(_):f.push(_)}),{installed:l,uninstalled:f}}async getValidExecutableBasedExtensionTips(o){const a=[],l=new Map;for(const f of o.keys()){const b=o.get(f);if(!b||!(0,k.isNonEmptyArray)(b.recommendations))continue;const _=[];P.isWindows?b.windowsPath&&_.push(b.windowsPath.replace("%USERPROFILE%",I.env.USERPROFILE).replace("%ProgramFiles(x86)%",I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",I.env.ProgramFiles).replace("%APPDATA%",I.env.APPDATA).replace("%WINDIR%",I.env.WINDIR)):(_.push((0,A.join)("/usr/local/bin",f)),_.push((0,A.join)("/usr/bin",f)),_.push((0,A.join)(this.environmentService.userHome.fsPath,f)));for(const O of _){let M=l.get(O);if(M===void 0&&(M=await this.fileService.exists(C.URI.file(O)),l.set(O,M)),M)for(const{extensionId:D,extensionName:F,isExtensionPack:$,whenNotInstalled:q}of b.recommendations)a.push({extensionId:D,extensionName:F,isExtensionPack:$,exeName:f,exeFriendlyName:b.exeFriendlyName,windowsPath:b.windowsPath,whenNotInstalled:q})}}return a}};t=de([K(0,E.INativeEnvironmentService),K(1,r.ITelemetryService),K(2,m.IExtensionManagementService),K(3,u.IStorageService),K(4,y.INativeHostService),K(5,v.IExtensionRecommendationNotificationService),K(6,g.IFileService),K(7,w.IProductService),K(8,p.IRequestService),K(9,h.ILogService)],t),e.ExtensionTipsService=t}),define(ne[93],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:P,data:I}){return this.appenders.forEach(C=>C.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class n{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[47],ie([0,1,29,15,18,21]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,w){return Promise.resolve(void 0)}publicLog2(y,w){return this.publicLog(y,w)}publicLogError(y,w){return Promise.resolve(void 0)}publicLogError2(y,w){return this.publicLogError(y,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class P{async publicLog(y,w,p){}async publicLogError(y,w,p){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(h,y){return y.onDidChangeConfiguration(w=>{w.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(w.source),configurationKeys:d(w.sourceConfig)})})}e.configurationTelemetry=I;function C(h,y){return!(y.disableTelemetry||!h.enableTelemetry||y.extensionTestsLocationURI)}e.supportsTelemetry=C;function R(h){const y=h.getValue(L.TELEMETRY_SETTING_ID),w=h.getValue("telemetry.enableCrashReporter");if(h.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=R;function E(h){const y=Object.create(null),w=Object.create(null),p=Object.create(null);S(h,p);for(let u in p){u=u.length>150?u.substr(u.length-149):u;const r=p[u];typeof r=="number"?w[u]=r:typeof r=="boolean"?w[u]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${r.length}`),y[u]=r.substring(0,8191)):typeof r!="undefined"&&r!==null&&(y[u]=r)}return{properties:y,measurements:w}}e.validateTelemetryData=E;function m(h){if(!h)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{h.indexOf(`${p}+`)===0&&(y=p)}),y}e.cleanRemoteAuthority=m;function S(h,y,w=0,p){if(!!h)for(let u of Object.getOwnPropertyNames(h)){const r=h[u],c=p?p+u:u;Array.isArray(r)?y[c]=(0,k.safeStringify)(r):r instanceof Date?y[c]=r.toISOString():(0,n.isObject)(r)?w<2?S(r,y,w+1,c+"."):y[c]=(0,k.safeStringify)(r):y[c]=r}}function d(h){if(!h)return[];const y=[];return v(y,"",h),y}function v(h,y,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(p=>v(h,y?`${y}.${p}`:p,w[p])):h.push(y)}function g(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(ne[207],ie([0,1,46,47]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(L,A,P,I,C,R){const E={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},m=await(0,k.getServiceMachineId)(P,C,R);return(0,n.supportsTelemetry)(A,P)&&(0,n.getTelemetryLevel)(I)===3&&(E["X-Market-User-Id"]=m),E}e.resolveMarketplaceHeaders=T}),define(ne[208],ie([0,1,16,25,7,29,4,33,15,8,18,13,28,31,79,14,9,26,43,207,23,21]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=A.isWeb?"web":(0,m.getTargetPlatform)(A.platform,P.arch);var c;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(c||(c={}));function i(...N){return String(N.reduce((U,z)=>U|z,0))}var t;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class f{constructor(U=l){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,z=this.state.pageSize){return new f({...this.state,pageNumber:U,pageSize:z})}withFilter(U,...z){const j=[...this.state.criteria,...z.length?z.map(ee=>({filterType:U,value:ee})):[{filterType:U}]];return new f({...this.state,criteria:j})}withSortBy(U){return new f({...this.state,sortBy:U})}withSortOrder(U){return new f({...this.state,sortOrder:U})}withFlags(...U){return new f({...this.state,flags:U.reduce((z,j)=>z|j,0)})}withAssetTypes(...U){return new f({...this.state,assetTypes:U})}get raw(){const{criteria:U,pageNumber:z,pageSize:j,sortBy:ee,sortOrder:se,flags:le,assetTypes:he}=this.state;return{filters:[{criteria:U,pageNumber:z,pageSize:j,sortBy:ee,sortOrder:se}],assetTypes:he,flags:le}}get searchText(){const U=this.state.criteria.filter(z=>z.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber)}}}function b(N,U){const z=(N||[]).filter(j=>j.statisticName===U)[0];return z?z.value:0}function _(N){const U="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(j=>j.assetType.indexOf(U)===0).reduce((j,ee)=>{const se=D(N,ee.assetType);return se&&j.push([ee.assetType.substring(U.length),se]),j},[])}function O(N){if(N.properties){const U=N.properties.filter(ee=>ee.key===s.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=U.filter(ee=>z.test(ee.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return D(N,s.Repository)}function M(N){return{uri:`${N.fallbackAssetUri}/${s.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${s.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function D(N,U){return N.files.filter(j=>j.assetType===U)[0]?{uri:`${N.assetUri}/${U}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${U}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function F(N,U){const z=N.properties?N.properties.filter(ee=>ee.key===U):[],j=z.length>0&&z[0].value;return j?j.split(",").map(ee=>(0,S.adoptToGalleryExtensionId)(ee)):[]}function $(N){const U=N.properties?N.properties.filter(z=>z.key===o.Engine):[];return U.length>0&&U[0].value||""}function q(N){const U=N.properties?N.properties.filter(z=>z.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function x(N){const U=N.properties?N.properties.filter(j=>j.key===o.LocalizedLanguages):[],z=U.length>0&&U[0].value||"";return z?z.split(","):[]}function G(N){return N.indexOf("preview")!==-1}function B(N){return N.targetPlatform?(0,m.toTargetPlatform)(N.targetPlatform):"undefined"}function W(N){const U=(0,k.distinct)(N.versions.map(B)),z=!!N.tags?.includes(m.WEB_EXTENSION_TAG),j=U.indexOf("web");return z?j===-1&&U.push("web"):j!==-1&&U.splice(j,1),U}function H(N,U){const z=(0,m.getFallbackTargetPlarforms)(U);for(let j=0;j<N.length;j++){const ee=N[j];if(ee.version===N[j-1]?.version){let se=j;const le=B(ee);if(le===U)for(;se>0&&N[se-1].version===ee.version;)se--;else if(z.includes(le))for(;se>0&&N[se-1].version===ee.version&&B(N[se-1])!==U;)se--;se!==j&&(N.splice(j,1),N.splice(se,0,ee))}}return N}e.sortExtensionVersions=H;function te(N,U,z){N.telemetryData={index:U,querySource:z}}function V(N,U,z){const j=N.versions[0],ee={manifest:D(U,s.Manifest),readme:D(U,s.Details),changelog:D(U,s.Changelog),license:D(U,s.License),repository:O(U),download:M(U),icon:D(U,s.Icon),coreTranslations:_(U)};return{identifier:{id:(0,S.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:U.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:b(N.statistics,"install"),rating:b(N.statistics,"averagerating"),ratingCount:b(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:z,assets:ee,properties:{dependencies:F(U,o.Dependency),extensionPack:F(U,o.ExtensionPack),engine:$(U),localizedLanguages:x(U),targetPlatform:B(U),isPreReleaseVersion:q(U)},hasPreReleaseVersion:q(j),hasReleaseVersion:!0,preview:G(N.flags)}}let Z=class{constructor(U,z,j,ee,se,le,he,Se){this.requestService=z,this.logService=j,this.environmentService=ee,this.telemetryService=se,this.fileService=le,this.productService=he,this.configurationService=Se;const we=he.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=(0,w.resolveMarketplaceHeaders)(he.version,he,this.environmentService,this.configurationService,this.fileService,U)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,z,j){const ee=n.CancellationToken.isCancellationToken(z)?{}:z,se=n.CancellationToken.isCancellationToken(z)?z:j,le=[],he=[],Se=[],we=[];let ge=!0;for(const Ce of U){Ce.uuid?he.push(Ce.uuid):le.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);Se.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&we.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),ge=ge&&!!Ce.hasPreRelease&&!De}if(!he.length&&!le.length)return[];let pe=new f().withPage(1,U.length);he.length&&(pe=pe.withFilter(t.ExtensionId,...he)),le.length&&(pe=pe.withFilter(t.ExtensionName,...le)),(ee.queryAllVersions||ge)&&(pe=pe.withFlags(pe.flags,c.IncludeVersions));const{extensions:Te}=await this.queryGalleryExtensions(pe,{targetPlatform:ee.targetPlatform??r,includePreRelease:Se,versions:we,compatible:!!ee.compatible},se);return ee.source&&Te.forEach((Ce,De)=>te(Ce,De,ee.source)),Te}async getCompatibleExtension(U,z,j){if((0,m.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(U,z,j))return U;const ee=new f().withFlags(c.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,U.identifier.uuid),{extensions:se}=await this.queryGalleryExtensions(ee,{targetPlatform:j,compatible:!0,includePreRelease:z},n.CancellationToken.None);return se[0]||null}async isExtensionCompatible(U,z,j){if(!(0,m.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,j)||!z&&U.properties.isPreReleaseVersion)return!1;let ee=U.properties.engine;if(!ee){const se=await this.getManifest(U,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");ee=se.engines.vscode}return(0,d.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(U,z,j,ee,se){if(!(0,m.isTargetPlatformCompatible)(B(U),ee,se)||z!=="any"&&q(U)!==(z==="prerelease"))return!1;if(j){const le=await this.getEngine(U);if(!(0,d.isEngineValid)(le,this.productService.version,this.productService.date))return!1}return!0}async query(U,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=U.text||"";const ee=(0,L.getOrDefault)(U,ge=>ge.pageSize,50);let se=new f().withPage(1,ee);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Te)=>(se=se.withFilter(t.Category,Te||pe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Te)=>(se=se.withFilter(t.Tag,Te||pe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),se=se.withFilter(t.SearchText,j)),se=se.withSortBy(0)):U.ids?se=se.withFilter(t.ExtensionId,...U.ids):U.names?se=se.withFilter(t.ExtensionName,...U.names):se=se.withSortBy(4),typeof U.sortBy=="number"&&(se=se.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(se=se.withSortOrder(U.sortOrder));const le=async(ge,pe)=>{const{extensions:Te,total:Ce}=await this.queryGalleryExtensions(ge,{targetPlatform:r,compatible:!1,includePreRelease:!!U.includePreRelease},pe);return Te.forEach((De,qe)=>te(De,(ge.pageNumber-1)*ge.pageSize+qe,U.source)),{extensions:Te,total:Ce}},{extensions:he,total:Se}=await le(se,z),we=async(ge,pe)=>{if(pe.isCancellationRequested)throw new T.CancellationError;const{extensions:Te}=await le(se.withPage(ge+1),pe);return Te};return{firstPage:he,total:Se,pageSize:se.pageSize,getPage:we}}async queryGalleryExtensions(U,z,j){const ee=U.flags;!!(U.flags&c.IncludeLatestVersionOnly)&&!!(U.flags&c.IncludeVersions)&&(U=U.withFlags(U.flags&~c.IncludeVersions,c.IncludeLatestVersionOnly)),!(U.flags&c.IncludeLatestVersionOnly)&&!(U.flags&c.IncludeVersions)&&(U=U.withFlags(U.flags,c.IncludeLatestVersionOnly)),z.versions?.length&&(U=U.withFlags(U.flags&~c.IncludeLatestVersionOnly,c.IncludeVersions)),U=U.withFlags(U.flags,c.IncludeAssetUri,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeStatistics,c.IncludeVersionProperties);const{galleryExtensions:se,total:le}=await this.queryRawGalleryExtensions(U,j);if(!(U.flags&c.IncludeLatestVersionOnly)){const ge=[];for(const pe of se){const Te=await this.toGalleryExtensionWithCriteria(pe,z);Te&&ge.push(Te)}return{extensions:ge,total:le}}const Se=[],we=new Map;for(let ge=0;ge<se.length;ge++){const pe=se[ge],Te={id:(0,S.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ce=(0,I.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(qe=>(0,S.areSameExtensions)(qe,Te))?.includePreRelease;if(z.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(W(pe),z.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(pe,z);!De||De.properties.isPreReleaseVersion&&(!Ce||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==z.targetPlatform&&De.hasPreReleaseVersion?we.set(pe.extensionId,ge):Se.push([ge,De])}if(we.size){const ge=new Date().getTime(),pe=new f().withFlags(ee&~c.IncludeLatestVersionOnly,c.IncludeVersions).withPage(1,we.size).withFilter(t.ExtensionId,...we.keys()),{extensions:Te}=await this.queryGalleryExtensions(pe,z,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:we.size});for(const Ce of Te){const De=we.get(Ce.identifier.uuid);Se.push([De,Ce])}}return{extensions:Se.sort((ge,pe)=>ge[0]-pe[0]).map(([,ge])=>ge),total:le}}async toGalleryExtensionWithCriteria(U,z){const j={id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},ee=z.versions?.find(Se=>(0,S.areSameExtensions)(Se,j))?.version,se=(0,I.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Se=>(0,S.areSameExtensions)(Se,j))?.includePreRelease,le=W(U),he=H(U.versions,z.targetPlatform);if(z.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(le,z.targetPlatform))return null;for(let Se=0;Se<he.length;Se++){const we=he[Se];if(!(ee&&we.version!==ee)){if(await this.isValidVersion(we,se?"any":"release",z.compatible,le,z.targetPlatform))return V(U,we,le);if(ee&&we.version===ee)return null}}return ee||z.compatible?null:V(U,U.versions[0],le)}async queryRawGalleryExtensions(U,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,c.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(c.Unpublished));const j=await this.commonHeadersPromise,ee=JSON.stringify(U.raw),se={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},le=new Date().getTime();let he,Se,we=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ee,headers:se},z),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:we};const ge=await(0,y.asJson)(he);if(ge){const pe=ge.results[0],Te=pe.extensions,Ce=pe.resultMetadata&&pe.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return we=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:we}}return{galleryExtensions:[],total:we}}catch(ge){throw Se=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-le,success:!!he&&(0,y.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:Se?(0,T.isCancellationError)(Se)?"canceled":(0,T.getErrorMessage)(Se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(U,z,j,ee){if(!this.isEnabled())return;const se=A.isWeb?this.api(`/itemName/${U}.${z}/version/${j}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${z}/${j}/stats?statType=${ee}`),le=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Se={...await this.commonHeadersPromise,Accept:le};try{await this.requestService.request({type:"POST",url:se,headers:Se},n.CancellationToken.None)}catch{}}async download(U,z,j){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const ee=(0,S.getGalleryExtensionTelemetryData)(U),se=new Date().getTime(),le=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:ge}),he=j===2?"install":j===3?"update":"",Se=he?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:U.assets.download,we=await this.getAsset(Se);await this.fileService.writeFile(z,we.stream),le(new Date().getTime()-se)}async getReadme(U,z){if(U.assets.readme){const j=await this.getAsset(U.assets.readme,{},z);return await(0,y.asText)(j)||""}return""}async getManifest(U,z){if(U.assets.manifest){const j=await this.getAsset(U.assets.manifest,{},z),ee=await(0,y.asText)(j);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(U,z){const j=D(U,s.Manifest);if(!j)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},se=await this.getAsset(j,{headers:ee});return await(0,y.asJson)(se)}async getCoreTranslation(U,z){const j=U.assets.coreTranslations.filter(ee=>ee[0]===z.toUpperCase())[0];if(j){const ee=await this.getAsset(j[1]),se=await(0,y.asText)(ee);return se?JSON.parse(se):null}return null}async getChangelog(U,z){if(U.assets.changelog){const j=await this.getAsset(U.assets.changelog,{},z);return await(0,y.asText)(j)||""}return""}async getAllCompatibleVersions(U,z,j){let ee=new f().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?ee=ee.withFilter(t.ExtensionId,U.identifier.uuid):ee=ee.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:se}=await this.queryRawGalleryExtensions(ee,n.CancellationToken.None);if(!se.length)return[];const le=W(se[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(le,j))return[];const he=[];await Promise.all(se[0].versions.map(async ge=>{try{await this.isValidVersion(ge,z?"any":"release",!0,le,j)&&he.push(ge)}catch{}}));const Se=[],we=new Set;for(const ge of H(he,j))we.has(ge.version)||(we.add(ge.version),Se.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:q(ge)}));return Se}async getAsset(U,z={},j=n.CancellationToken.None){const ee=await this.commonHeadersPromise,se={type:"GET"},le={...ee,...z.headers||{}};z={...z,...se,headers:le};const he=U.uri,Se=U.fallbackUri,we={...z,url:he};try{const ge=await this.requestService.request(we,j);if(ge.res.statusCode===200)return ge;const pe=await(0,y.asText)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${pe}`)}catch(ge){if((0,T.isCancellationError)(ge))throw ge;const pe=(0,T.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:he,message:pe});const Te={...z,url:Se};return this.requestService.request(Te,j)}}async getEngine(U){let z=$(U);if(!z){const j=await this.getManifestFromRawExtensionVersion(U,n.CancellationToken.None);if(!j)throw new Error("Manifest was not found");z=j.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,y.asJson)(U),j=[],ee={};if(z){for(const se of z.malicious)j.push({id:se});if(z.unsupported)for(const se of Object.keys(z.unsupported)){const le=z.unsupported[se];(0,I.isBoolean)(le)||(ee[se.toLowerCase()]=le.preReleaseExtension)}if(z.migrateToPreRelease)for(const[se,le]of Object.entries(z.migrateToPreRelease))(!le.engine||(0,d.isEngineValid)(le.engine,this.productService.version,this.productService.date))&&(ee[se.toLowerCase()]=le)}return{malicious:j,unsupportedPreReleaseExtensions:ee}}};Z=de([K(1,y.IRequestService),K(2,g.ILogService),K(3,E.IEnvironmentService),K(4,u.ITelemetryService),K(5,v.IFileService),K(6,h.IProductService),K(7,R.IConfigurationService)],Z);let J=class extends Z{constructor(U,z,j,ee,se,le,he,Se){super(U,z,j,ee,se,le,he,Se)}};J=de([K(0,p.IStorageService),K(1,y.IRequestService),K(2,g.ILogService),K(3,E.IEnvironmentService),K(4,u.ITelemetryService),K(5,v.IFileService),K(6,h.IProductService),K(7,R.IConfigurationService)],J),e.ExtensionGalleryService=J;let Q=class extends Z{constructor(U,z,j,ee,se,le,he){super(void 0,U,z,j,ee,se,le,he)}};Q=de([K(0,y.IRequestService),K(1,g.ILogService),K(2,E.IEnvironmentService),K(3,u.ITelemetryService),K(4,v.IFileService),K(5,h.IProductService),K(6,R.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q}),define(ne[94],ie([0,1,2,13,9,47]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(I,C,R=""){super();this.prefix=R;const E=I.getLogger(C.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(I.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,C){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,L.validateTelemetryData)(C))}};A=de([K(0,T.ILoggerService),K(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[95],ie([0,1,2,29,4,27,142,18,42,88,26,38,21,47]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(h,y,w){this._configurationService=y,this._productService=w,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(p),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(h,y){this._experimentProperties[h]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const y=h.usage?3:h.error?2:0;this._telemetryLevel=Math.min(this._telemetryLevel,y)}}get telemetryLevel(){return this._telemetryLevel}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const h=await this._commonProperties;let y=h.sessionID,w=h["common.machineId"],p=h["common.firstSessionDate"],u=h["common.msftInternal"];return{sessionId:y,machineId:w,firstSessionDate:p,msftInternal:u}}dispose(){this._disposables.dispose()}_log(h,y,w,p){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(u=>{w=(0,n.mixin)(w,u),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,r=>{if(typeof r=="string")return this._cleanupInfo(r,p)}),this._appenders.forEach(r=>r.log(h,w))},u=>{console.error(u)})}publicLog(h,y,w){return this._log(h,3,y,w)}publicLog2(h,y,w){return this.publicLog(h,y,w)}publicLogError(h,y){return this._sendErrorTelemetry?this._log(h,2,y,!0):Promise.resolve(void 0)}publicLogError2(h,y){return this.publicLogError(h,y)}_anonymizeFilePaths(h){let y=h;const w=[];for(let c of this._cleanupPatterns)for(;;){const i=c.exec(h);if(!i)break;w.push([i.index,c.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(y="";;){const c=u.exec(h);if(!c)break;!p.test(c[0])&&w.every(([i,t])=>c.index<i||c.index>=t)&&(y+=h.substring(r,c.index)+"<REDACTED: user-file-path>",r=u.lastIndex)}return r<h.length&&(y+=h.substr(r)),y}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const y=h.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,p=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,u=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return p.test(y)?"<REDACTED: secret>":w.test(y)?"<REDACTED: email>":u.test(y)?"<REDACTED: token>":h}_cleanupInfo(h,y){let w=h;y&&(w=this._anonymizeFilePaths(w));for(let p of this._cleanupPatterns)w=w.replace(p,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=de([K(1,P.IConfigurationService),K(2,R.IProductService)],d),e.TelemetryService=d;function v(){const g=(0,A.localize)(0,null,C.default.nameLong),h=C.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=T.isWeb?"":(0,A.localize)(3,null),w=(0,A.localize)(4,null),p=(0,A.localize)(5,null),u=(0,A.localize)(6,null),r=(0,A.localize)(7,null),c=`
|       | ${w} | ${p} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,A.localize)(8,null);return`
${g} ${h} ${y}

&nbsp;

${r}
${c}

&nbsp;

${i}
`}E.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,A.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,A.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[209],ie([0,1,7,29,47]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(P){const I=await new Promise((R,E)=>{Y(["applicationinsights"],R,E)});let C;return I.defaultClient?(C=new I.TelemetryClient(P),C.channel.setUseDiskRetryCaching(!0)):(I.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=I.defaultClient),P.indexOf("AIF-")===0&&(C.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),C}class A{constructor(I,C,R){this._eventPrefix=I,this._defaultData=C,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(I){if(!!this._aiClient){if(typeof this._aiClient!="string"){I(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(C=>{I(C)},C=>{(0,k.onUnexpectedError)(C),console.error(C)})}}log(I,C){if(!!this._aiClient){C=(0,n.mixin)(C,this._defaultData),C=(0,T.validateTelemetryData)(C);try{this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+I,properties:C.properties,measurements:C.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(I=>{this._withAIClient(C=>{try{C.flush({callback:()=>{this._aiClient=void 0,I(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(ne[210],ie([0,1,19,58,18,13,9,26,21,93,94,95]),function(Y,e,k,n,T,L,A,P,I,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(d,v,g,h,y){this.configurationService=d,this.telemetryService=v,this.loggerService=g,this.environmentService=h,this.productService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:v,sessionId:g}=await this.telemetryService.getTelemetryInfo(),h=Object.create(null);h["common.vscodemachineid"]=v,h["common.vscodesessionid"]=g;const y=[d.id,JSON.stringify(h),d.aiKey],p=new n.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new C.TelemetryAppenderClient(p),new R.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new E.TelemetryService({appenders:u,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,v,g){await(await this.getCustomTelemetryService(d)).publicLog(v,g)}async publicLogError(d,v,g){await(await this.getCustomTelemetryService(d)).publicLogError(v,g)}};m=de([K(0,T.IConfigurationService),K(1,I.ITelemetryService),K(2,A.ILoggerService),K(3,L.IEnvironmentService),K(4,P.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(ne[211],ie([0,1,5,25,3,2,9]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(C,R){super();this._logService=R,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new T.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((R,E)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,R),this._onCreateRequest.fire({requestId:m,...C});const S=new n.CancellationTokenSource;(0,k.timeout)(this._timeout,S.token).then(()=>E(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,L.toDisposable)(()=>S.cancel())])})}acceptReply(C,R){const E=this._pendingRequests.get(C);E?(this._pendingRequests.delete(C),(0,L.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),E(R)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};P=de([K(1,A.ILogService)],P),e.RequestStore=P}),define(ne[96],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var T;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",g.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",g.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(T=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var A;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(g){g.TerminalView="view",g.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var S;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var d;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(d=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(ne[212],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(ne[213],ie([0,1,34,19,29,10,4,33,27,15,22]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let u=0;return p&&p.length===4&&(u=parseInt(p[3])),u}e.getWindowsBuildNumber=E;async function m(p,u,r,c=P.env,i=R.Promises.exists){if(L.isAbsolute(p))return await i(p)?p:void 0;if(u===void 0&&(u=P.cwd()),L.dirname(p)!=="."){const a=L.join(u,p);return await i(a)?a:void 0}const s=(0,T.getCaseInsensitive)(c,"PATH");if(r===void 0&&(0,C.isString)(s)&&(r=s.split(L.delimiter)),r===void 0||r.length===0){const a=L.join(u,p);return await i(a)?a:void 0}for(let a of r){let l;if(L.isAbsolute(a)?l=L.join(a,p):l=L.join(u,a,p),await i(l))return l;if(A.isWindows){let f=l+".com";if(await i(f)||(f=l+".exe",await i(f)))return f}}const o=L.join(u,p);return await i(o)?o:void 0}e.findExecutable=m;function S(p,u){if(!u.enabled||!p.executable||p.isFeatureTerminal)return;const r=p.args,c=P.platform==="win32"?L.basename(p.executable).toLowerCase():L.basename(p.executable),i=L.dirname(n.FileAccess.asFileUri("",Y).fsPath);let t;if(A.isWindows){if(c==="pwsh.exe"){if(!r||y(r)?t=e.shellIntegrationArgs.get(d.WindowsPwsh):h(r)&&(t=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),!t)return;if(t){const o=u.showWelcome?"":" -HideWelcome";t=[...t],t[t.length-1]=(0,I.format)(t[t.length-1],i,o)}return{newArgs:t}}return}const s={};switch(c){case"bash":return!r||r.length===0?t=e.shellIntegrationArgs.get(d.Bash):w(r)&&(s.VSCODE_SHELL_LOGIN="1",t=e.shellIntegrationArgs.get(d.Bash)),t?(t=[...t],t[t.length-1]=(0,I.format)(t[t.length-1],i),u.showWelcome||(s.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:s}):void 0;case"pwsh":{if(!r||y(r)?t=e.shellIntegrationArgs.get(d.Pwsh):h(r)&&(t=e.shellIntegrationArgs.get(d.PwshLogin)),!t)return;const o=u.showWelcome?"":" -HideWelcome";return t=[...t],t[t.length-1]=(0,I.format)(t[t.length-1],i,o),{newArgs:t}}case"zsh":{if(!r||r.length===0?t=e.shellIntegrationArgs.get(d.Zsh):w(r)?t=e.shellIntegrationArgs.get(d.ZshLogin):(r===e.shellIntegrationArgs.get(d.Zsh)||r===e.shellIntegrationArgs.get(d.ZshLogin))&&(t=r),!t)return;t=[...t],t[t.length-1]=(0,I.format)(t[t.length-1],i);const o=L.join(k.tmpdir(),"vscode-zsh");s.ZDOTDIR=o;const a=[];return a.push({source:L.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration.zsh"),dest:L.join(o,".zshrc")}),u.showWelcome||(s.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:s,filesToCopy:a}}}}e.getShellIntegrationInjection=S;var d;(function(p){p.WindowsPwsh="windows-pwsh",p.WindowsPwshLogin="windows-pwsh-login",p.Pwsh="pwsh",p.PwshLogin="pwsh-login",p.Zsh="zsh",p.ZshLogin="zsh-login",p.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],g=["-nol","-nologo"];function h(p){return typeof p=="string"?v.includes(p.toLowerCase()):p.length===1&&v.includes(p[0].toLowerCase())||p.length===2&&(v.includes(p[0].toLowerCase())||v.includes(p[1].toLowerCase()))&&(g.includes(p[0].toLowerCase())||g.includes(p[1].toLowerCase()))}function y(p){return typeof p=="string"?g.includes(p.toLowerCase()):p.length===0||p?.length===1&&g.includes(p[0].toLowerCase())}function w(p){return p==="string"&&v.includes(p.toLowerCase())||typeof p!="string"&&p.length===1&&v.includes(p[0].toLowerCase())}}),define(ne[214],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var k;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function n(T){return T===k.HIGH_CONTRAST_DARK||T===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=n}),define(ne[97],ie([0,1,48,3,2,6,38,214]),function(Y,e,k,n,T,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var I;(function(g){function h(y){return y&&typeof y=="object"&&typeof y.id=="string"}g.isThemeColor=h})(I=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var R;(function(g){function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||I.isThemeColor(t.color))}g.isThemeIcon=h;const y=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function w(t){const s=y.exec(t);if(!s)return;let[,o]=s;return{id:o}}g.fromString=w;function p(t){return{id:t}}g.fromId=p;function u(t,s){let o=t.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),s&&(o=`${o}~${s}`),{id:o}}g.modify=u;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}g.getModifier=r;function c(t,s){return t.id===s.id&&t.color?.id===s.color?.id}g.isEqual=c;function i(t,s){return{id:t.id,color:s?C(s):void 0}}g.asThemeIcon=i,g.asClassNameArray=k.CSSIcon.asClassNameArray,g.asClassName=k.CSSIcon.asClassName,g.asCSSSelector=k.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(g){switch(g){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,T.toDisposable)(()=>{const y=this.themingParticipants.indexOf(h);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new m;A.Registry.add(e.Extensions.ThemingContribution,S);function d(g){return S.onColorThemeChange(g)}e.registerThemingParticipant=d;class v extends T.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,y){let w=this.theme.getColor(h);return w&&y&&(w=y(w,this.theme)),w?w.toString():null}}e.Themable=v}),define(ne[215],ie([0,1,48,8,97]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(E,m){const S=E.map(d=>({name:d.profileName,description:A(d)}));return m&&S.push(...m.map(d=>({name:d.title,description:P(d)}))),{values:S.map(d=>d.name),markdownDescriptions:S.map(d=>d.description)}}e.createProfileSchemaEnums=L;function A(E){let m=`$(${T.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?m+=`
- args: "${E.args}"`:m+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(m+=`
- overrideName: ${E.overrideName}`),E.color&&(m+=`
- color: ${E.color}`),E.env&&(m+=`
- env: ${JSON.stringify(E.env)}`),m}function P(E){return`$(${T.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function I(E,m){if(!E&&!m)return!0;if(typeof E=="string"&&typeof m=="string")return E===m;if(Array.isArray(E)&&Array.isArray(m)){if(E.length!==m.length)return!1;for(let S=0;S<E.length;S++)if(E[S]!==m[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=I;function C(E,m){if(!E&&!m)return!0;if(!E||!m)return!1;if(T.ThemeIcon.isThemeIcon(E)&&T.ThemeIcon.isThemeIcon(m))return E.id===m.id&&E.color===m.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof m=="object"&&m&&"light"in m&&"dark"in m){const S=E,d=m;if((n.URI.isUri(S.light)||R(S.light))&&(n.URI.isUri(S.dark)||R(S.dark))&&(n.URI.isUri(d.light)||R(d.light))&&(n.URI.isUri(d.dark)||R(d.dark)))return S.light.path===d.light.path&&S.dark.path===d.dark.path}if(n.URI.isUri(E)&&n.URI.isUri(m)||R(E)||R(m)){const S=E,d=m;return S.path===d.path&&S.scheme===d.scheme}return!1}e.terminalIconsEqual=C;function R(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=R}),define(ne[216],ie([0,1,48,143,42,38,215]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),p=>p.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),p=>`$(${p.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},C={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...P}},R=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),g={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){L.Registry.as(T.Extensions.Configuration).registerConfiguration(g),w()}e.registerTerminalPlatformConfiguration=h;let y;function w(p,u){const r=L.Registry.as(T.Extensions.Configuration);let c;p&&(c=(0,A.createProfileSchemaEnums)(p?.profiles,u));const i=y;y={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:p?.os===3?c?.values:void 0,markdownEnumDescriptions:p?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:p?.os===2?c?.values:void 0,markdownEnumDescriptions:p?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:p?.os===1?c?.values:void 0,markdownEnumDescriptions:p?.os===1?c?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[y],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(ne[217],ie([0,1,45,48,10,4,22,73,213,97]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R,E=!0;function m(c,i,t,s,o=process.env,a,l,f,b){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?S(t,a,o,l,s.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),b,f):p(a,l,t,c&&typeof c=="object"?{...c}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),b,f,o)}e.detectAvailableProfiles=m;async function S(c,i,t,s,o,a,l,f,b){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let M=!1;(0,I.getWindowsBuildNumber)()>=16299&&(M=!0),await g(f);const D=new Map;c&&(D.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),u(a,D);const F=await d(D.entries(),l,i,t,s,b);if(c||!c&&o)try{const $=await y(`${O}\\${M?"wsl":"bash"}.exe`,l);for(const q of $)(!a||!(q.profileName in a))&&F.push(q)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return F}async function d(c,i,t,s=process.env,o,a){const l=[];for(const[f,b]of c){if(b===null)continue;let _,O,M;if("source"in b){const $=R?.get(b.source);if(!$)continue;_=$.paths,O=b.args||$.args,b.icon?M=v(b.icon):$.icon&&(M=$.icon)}else _=Array.isArray(b.path)?b.path:[b.path],O=L.isWindows||Array.isArray(b.args)?b.args:void 0,M=v(b.icon);const D=await a?.(_)||_.slice(),F=await r(f,i,D,t,s,O,b.env,b.overrideName,b.isAutoDetected,o);F?(F.isAutoDetected=b.isAutoDetected,F.icon=M,F.color=b.color,l.push(F)):o?.trace("profile not validated",f,_)}return l}function v(c){return typeof c=="string"?{id:c}:c}async function g(c){R&&!c||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:c||await h(),icon:C.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function h(){const c=[];for await(const i of(0,P.enumeratePowerShellInstallations)())c.push(i.exePath);return c}async function y(c,i){const t=[],s=await new Promise((l,f)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(b,_)=>{if(b)return f("Problem occurred when getting wsl distros");l(_)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),a=s.split(o).filter(l=>l.trim().length>0&&l!=="");for(const l of a){if(l===""||l.startsWith("docker-desktop"))continue;const f=`${l} (WSL)`,b={profileName:f,path:c,args:["-d",`${l}`],isDefault:f===i,icon:w(l),isAutoDetected:!1};t.push(b)}return t}function w(c){return c.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):c.includes("Debian")?C.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function p(c,i,t,s,o,a,l,f){const b=new Map;if(t){const _=(await c.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),M=new Map;for(const D of O){let F=(0,T.basename)(D),$=M.get(F)||0;$++,$>1&&(F=`${F} (${$})`),M.set(F,$),b.set(F,{path:D,isAutoDetected:!0})}}return u(s,b),await d(b.entries(),o,c,f,i,l)}function u(c,i){if(!!c)for(const[t,s]of Object.entries(c))s===null||!("path"in s)&&!("source"in s)?i.delete(t):(s.icon=s.icon||i.get(t)?.icon,i.set(t,s))}async function r(c,i,t,s,o,a,l,f,b,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(c,i,t,s,o,a,l,f,b);const M={profileName:c,path:O,args:a,env:l,overrideName:f,isAutoDetected:b,isDefault:c===i};if((0,T.basename)(O)===O){const F=o.PATH?o.PATH.split(T.delimiter):void 0,$=await(0,I.findExecutable)(O,void 0,F,void 0,s.existsFile);return $?(M.path=$,M.isFromPath=!0,M):r(c,i,t,s,o,a)}return await s.existsFile((0,T.normalize)(O))?M:r(c,i,t,s,o,a,l,f,b)}}),define(ne[218],ie([0,1,3,2,19,4,36,58,18,13,78,197,9,87,211,96,216,217]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let w=0,p=class extends n.Disposable{constructor(r,c,i,t){super();this._reconnectConstants=r,this._configurationService=c,this._environmentService=i,this._logService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:w,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},c=(0,R.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);c&&(c.break&&c.port?r.debugBrk=c.port:!c.break&&c.port&&(r.debug=c.port));const i=new P.Client(T.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,r);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=i.getChannel(v.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const o=A.ProxyChannel.toService(i.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(o.onProcessData(a=>this._onProcessData.fire(a))),this._register(o.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(o.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(o.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(o.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(o.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(o.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[i,o]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,c,i,t,s,o,a,l,f,b,_){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(r,c,i,t,s,o,a,l,f,b,_);return clearTimeout(O),w=Math.max(w,M),M}updateTitle(r,c,i){return this._proxy.updateTitle(r,c,i)}updateIcon(r,c,i){return this._proxy.updateIcon(r,c,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,c){return this._proxy.shutdown(r,c)}input(r,c){return this._proxy.input(r,c)}processBinary(r,c){return this._proxy.processBinary(r,c)}resize(r,c,i){return this._proxy.resize(r,c,i)}acknowledgeDataEvent(r,c){return this._proxy.acknowledgeDataEvent(r,c)}setUnicodeVersion(r,c){return this._proxy.setUnicodeVersion(r,c)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,c){return this._proxy.installAutoReply(r,c)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,c,i,t=!1){const s=await this._shellEnv;return(0,h.detectAvailableProfiles)(c,i,t,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,c){return this._proxy.requestDetachInstance(r,c)}async acceptDetachInstanceReply(r,c){return this._proxy.acceptDetachInstanceReply(r,c)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,c){return this._proxy.reviveTerminalProcesses(r,c)}async refreshProperty(r,c){return this._proxy.refreshProperty(r,c)}async updateProperty(r,c,i){return this._proxy.updateProperty(r,c,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,c){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:c})}async acceptPtyHostResolvedVariables(r,c){this._resolveVariablesRequestStore.acceptReply(r,c)}};p=de([K(1,I.IConfigurationService),K(2,C.IEnvironmentService),K(3,m.ILogService)],p),e.PtyHostService=p}),define(ne[64],ie([0,1,3,4,6,9]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=E;function m(d,v){return v?v!==1&&d<1024:!n.isWindows&&d<1024}e.isPortPrivileged=m;let S=class{constructor(v){this.logService=v,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],g=Array.from(this._tunnels.values());for(let h of g){const y=Array.from(h.values());for(let w of y){const p=await w.value;p&&v.push(p)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:g}of v.values())await g.then(h=>h?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,g,h,y,w=!1,p=P.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${h} on local port ${y}.`),!v)return;g||(g="localhost");const r=this.retainOrCreateTunnel(v,g,h,y,w,p,u);return r?r.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,h);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(c);return(c.tunnelRemoteHost!==g||c.tunnelRemotePort!==h)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const g=this._tunnels.get(v.tunnelRemoteHost);if(g){const h=g.get(v.tunnelRemotePort);h&&(h.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,h))}}}}async tryDisposeTunnel(v,g,h){if(h.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${g}.`);const y=h.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(g),y}}async closeTunnel(v,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${g} `);const h=this._tunnels.get(v);if(h&&h.has(g)){const y=h.get(g);y.refcount=0,await this.tryDisposeTunnel(v,g,y)}}addTunnelToMap(v,g,h){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(g,{refcount:1,value:h})}async removeEmptyTunnelFromMap(v,g){const h=this._tunnels.get(v);h&&(await h.get(g)||h.delete(g),h.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,g){let h=[v];R(v)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):E(v)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const y=h.map(w=>this._tunnels.get(w));for(const w of y){const p=w?.get(g);if(p)return p}}canTunnel(v){return!!C(v)}createWithProvider(v,g,h,y,w,p,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${h} on local port ${y}.`);const c={elevationRequired:w?m(y===void 0?h:y):!1},i={remoteAddress:{host:g,port:h},localAddressPort:y,privacy:p,public:p!==P.Private,protocol:u},t=v.forwardPort(i,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(g,h,t),t}};S=de([K(0,L.ILogService)],S),e.AbstractTunnelService=S}),define(ne[219],ie([0,1,9,64,2,7,5]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends T.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(R){this._address=R,this._addressPromise&&(this._addressPromise.complete(R),this._addressPromise=null)}setTunnel(R){this._register(R)}}let I=class yt extends T.Disposable{constructor(R,E){super();this._tunnelService=R,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(R=>R.dispose())}async createTunnel(){return{id:String(++yt._lastId)}}async startTunnel(R,E,m,S,d,v){const g=new P,h=await Promise.resolve(this._tunnelService.openTunnel(R,g,m,S,d,v));if(!h)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${S} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),g.dispose(),await h.dispose(),(0,L.canceled)();return g.setTunnel(h),this._tunnels.set(E,g),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${h.localAddress} (local) to ${m}:${S} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(R,E){const m=this._tunnels.get(R);!m||m.setAddress(E)}async destroyTunnel(R){const E=this._tunnels.get(R);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${R}.`),this._tunnels.delete(R),await E.dispose();return}this._disposedTunnels.add(R)}};I._lastId=0,I=de([K(0,n.ISharedTunnelsService),K(1,k.ILogService)],I),e.SharedProcessTunnelService=I}),define(ne[32],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(ne[220],ie([0,1,3,2,8,13,31,14,9,32]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends n.Disposable{constructor(m,S,d,v,g){super();this.extensionsManagementService=m,this.logService=v,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(y=>{this.installedExtensions=y.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(y=>this.onInstallExtension(y))),this._register(m.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(m.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const h=T.URI.file(d.extensionsPath);this._register(S.watch(h)),this._register(k.Event.filter(S.onDidFilesChange,y=>y.rawChanges.some(w=>this.doesChangeAffects(w,h)))(()=>this.onDidChange()))}doesChangeAffects(m,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),S)?this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(m.type!==1&&m.type!==2||this.uriIdentityService.extUri.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const S of m)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(S=>!(0,A.areSameExtensions)(S,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,A.areSameExtensions)(S,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),S=m.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,A.areSameExtensions)(g,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),d=this.installedExtensions.filter(v=>this.installingExtensions.some(g=>(0,A.areSameExtensions)(g,v))?!1:m.every(g=>!(0,A.areSameExtensions)(g.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=m.map(v=>v.identifier),(S.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:d})}}};R=de([K(1,P.IFileService),K(2,L.INativeEnvironmentService),K(3,I.ILogService),K(4,C.IUriIdentityService)],R),e.ExtensionsWatcher=R}),define(ne[221],ie([0,1,32,80,14,20,104,3,2]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(m){this.uri=m,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let R=class{constructor(m){this._fileService=m,this._dispooables=new I.DisposableStore,this._limit=2**16;const S=new Map,d=v=>{let g=S.get(v.scheme);return g===void 0&&(g=m.hasProvider(v)&&!this._fileService.hasCapability(v,1024),S.set(v.scheme,g)),g};this._dispooables.add(P.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(v=>{S.delete(v.scheme)})),this.extUri=new L.ExtUri(d),this._canonicalUris=new A.SkipList((v,g)=>this.extUri.compare(v,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,L.normalizePath)(m));let S=this._canonicalUris.get(m);return S?S.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new C(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((d,v)=>d[1].touch<v[1].touch?1:d[1].touch>v[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let d=0;d<S;d++)this._canonicalUris.set(m[d][0],m[d][1].touch())}};R=de([K(0,T.IFileService)],R),e.UriIdentityService=R,(0,n.registerSingleton)(k.IUriIdentityService,R,!0)}),define(ne[222],ie([0,1,3,2,40,39,17]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{constructor(C,R,E,m){super();this.fileSystemScheme=C,this.fileSystemProvider=R,this.userDataScheme=E,this.logService=m,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(S=>this.handleFileChanges(S)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(C,R){this.watchResources.set(C,C);const E=this.fileSystemProvider.watch(this.toFileSystemResource(C),R);return(0,n.toDisposable)(()=>{this.watchResources.delete(C),E.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,R,E){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(R),E)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,R,E){const m=(0,T.newWriteableStream)(S=>A.VSBuffer.concat(S.map(d=>A.VSBuffer.wrap(d))).buffer);return(async()=>{try{const S=await this.readFile(C);m.end(S)}catch(S){m.error(S),m.end()}})(),m}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,R,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),R,E)}delete(C,R){return this.fileSystemProvider.delete(this.toFileSystemResource(C),R)}handleFileChanges(C){const R=[];for(const E of C){if(E.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(E.resource);this.watchResources.findSubstr(m)&&R.push({resource:m,type:E.type})}R.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(R))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(ne[53],ie([0,1,70]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,P,I,C){const R=(0,k.setProperty)(A,P,I,C)[0];return R&&(A=A.substring(0,R.offset)+R.content+A.substring(R.offset+R.length)),A}e.edit=n;function T(A,P,I){let C=I;for(;C>=0;){if(A.charAt(C)===P.charAt(P.length-1)&&P.length===1)return C+1;if(C--,P.length===2&&C>=0&&A.charAt(C)===P.charAt(0))return C+2}return 0}e.getLineStartOffset=T;function L(A,P,I){let C=I;for(;C>=0;)if(A.charAt(C)===P.charAt(P.length-1)&&P.length===1||(C++,P.length===2&&C>=0&&A.charAt(C)===P.charAt(1)))return C;return A.length-1}e.getLineEndOffset=L}),define(ne[223],ie([0,1,29,62,15]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(m,S,d,v,g){const h=[],y=[],w=[];if(!S){const O=m.filter(({identifier:M})=>g.every(D=>D.toLowerCase()!==M.id.toLowerCase()));return{local:{added:h,removed:y,updated:w},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}m=m.map(R),S=S.map(R),d=d?d.map(R):null;const p=new Map,u=O=>{O.uuid&&p.set(O.id.toLowerCase(),O.uuid)};m.forEach(({identifier:O})=>u(O)),S.forEach(({identifier:O})=>u(O)),d&&d.forEach(({identifier:O})=>u(O));const r=O=>{const M=O.identifier.uuid||p.get(O.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${O.identifier.id.toLowerCase()}`},c=(O,M)=>(O.set(r(M),M),O),i=m.reduce(c,new Map),t=S.reduce(c,new Map),s=S.reduce((O,M)=>{const D=r(M);M=(0,k.deepClone)(M);const F=i.get(D);return F&&(F.installed&&(M.installed=!0),M.version||(M.version=F.version)),c(O,M)},new Map),o=d?d.reduce(c,new Map):null,a=v.reduce(c,new Map),l=g.reduce((O,M)=>{const D=p.get(M.toLowerCase());return O.add(D?`uuid:${D}`:`id:${M.toLowerCase()}`)},new Set),f=A(i,t,l);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const O=A(o,i,l),M=A(o,t,l),D=(F,$)=>{const q=i.get(F);if(q){const x=t.get(F),G=$?x:q;return{...G,version:x.version&&(!q.installed||n.gt(x.version,q.version))?x.version:q.version,state:P(q,x,o?.get(F)),preRelease:(0,T.isUndefined)(G.preRelease)?q.preRelease:q.installed?G.preRelease:x.preRelease}}};for(const F of M.removed.values()){const $=i.get(F);$&&y.push($.identifier)}for(const F of M.added.values())if(O.added.has(F)){if(f.updated.has(F)){const $=D(F,!0);$&&(w.push(E($,F)),s.set(F,$))}}else{const $=t.get(F);$.installed&&h.push(E($,F))}for(const F of M.updated.values()){const $=D(F,!0);$&&(w.push(E($,F)),s.set(F,$))}for(const F of O.added.values())M.added.has(F)||s.set(F,i.get(F));for(const F of O.updated.values())if(!M.removed.has(F)&&!M.updated.has(F)){const $=D(F,!1);$&&(s.get(F)?.installed&&($.installed=!0),s.set(F,$))}for(const F of O.removed.values())!a.has(F)&&!M.updated.has(F)&&o?.get(F)?.installed&&s.delete(F)}const b=[],_=A(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&s.forEach((O,M)=>b.push(E(O,M))),{local:{added:h,removed:y,updated:w},remote:b.length?{added:[..._.added].map(O=>s.get(O)),updated:[..._.updated].map(O=>s.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:b}:null}}e.merge=L;function A(m,S,d,{checkInstalledProperty:v,checkVersionProperty:g}={checkInstalledProperty:!1,checkVersionProperty:!1}){const h=m?[...m.keys()].filter(r=>!d.has(r)):[],y=[...S.keys()].filter(r=>!d.has(r)),w=y.filter(r=>h.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),p=h.filter(r=>y.indexOf(r)===-1).reduce((r,c)=>(r.add(c),r),new Set),u=new Set;for(const r of h){if(p.has(r))continue;const c=m.get(r),i=S.get(r);(!i||c.disabled!==i.disabled||c.installed&&i.installed&&c.preRelease!==i.preRelease||!C(c.state,i.state)||g&&c.version!==i.version||v&&c.installed!==i.installed)&&u.add(r)}return{added:w,removed:p,updated:u}}function P(m,S,d){const v=m.state,g=S.state,h=d?.state;if(!S.version||v&&n.gt(m.version,S.version))return v;if(g&&n.gt(S.version,m.version)||!v)return g;if(!g)return v;const y=(0,k.deepClone)(v),w=h?I(h,g):{added:Object.keys(g).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},p=h?I(h,v):{added:Object.keys(v).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...w.added.values(),...w.updated.values()])y[u]=g[u];for(const u of w.removed.values())p.updated.has(u)||delete y[u];return y}function I(m,S){const d=Object.keys(m),v=Object.keys(S),g=v.filter(w=>d.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),h=d.filter(w=>v.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),y=new Set;for(const w of d){if(h.has(w))continue;const p=m[w],u=S[w];(0,k.equals)(p,u)||y.add(w)}return{added:g,removed:h,updated:y}}function C(m={},S={}){const{added:d,removed:v,updated:g}=I(m,S);return d.size===0&&v.size===0&&g.size===0}function R(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function E(m,S){const d={identifier:{id:m.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!m.preRelease};return m.version&&(d.version=m.version),m.disabled&&(d.disabled=!0),m.installed&&(d.installed=!0),m.state&&(d.state=m.state),d}}),define(ne[98],ie([0,1,16,18,6]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return C=C.filter(R=>R!==P&&R!==`-${P}`),I&&C.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(P,I){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return C=C.filter(R=>R!==P&&R!==`-${P}`),I&&C.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(P){const I=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),R=[],E=[];if(Array.isArray(C))for(const m of C)m.startsWith("-")?E.push(m.substring(1)):R.push(m);return(0,k.distinct)([...I,...R].filter(m=>E.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};L=de([K(0,n.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[224],ie([0,1,16,35,29,159,53]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(p){return(0,n.parse)(p)||[]}e.parseKeybindings=P;async function I(p,u,r,c,i){const t=P(p),s=P(u),o=r?P(r):null,a=[...t,...s,...o||[]].map(x=>x.key),l=await i.resolveUserBindings(a);let f=R(t,s,o,l);if(!f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!f.hasLocalForwarded&&f.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(f.hasLocalForwarded&&!f.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const b=m(t),_=m(s),O=o?m(o):null,M=d(b,_,l),D=O?d(O,b,l):{added:[...b.keys()].reduce((x,G)=>(x.add(G),x),new Set),removed:new Set,updated:new Set},F=O?d(O,_,l):{added:[..._.keys()].reduce((x,G)=>(x.add(G),x),new Set),removed:new Set,updated:new Set},$=C(M,D,F);let q=p;for(const x of $.removed.values())$.conflicts.has(x)||(q=y(q,x,c));for(const x of $.added.values()){if($.conflicts.has(x))continue;const G=_.get(x);if(G.some(B=>B.command!==`-${x}`&&f.conflicts.has(l[B.key]))){$.conflicts.add(x);continue}q=h(q,G,c)}for(const x of $.updated.values()){if($.conflicts.has(x))continue;const G=_.get(x);if(G.some(B=>B.command!==`-${x}`&&f.conflicts.has(l[B.key]))){$.conflicts.add(x);continue}q=w(q,x,G,c)}return{mergeContent:q,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=I;function C(p,u,r){const c=new Set,i=new Set,t=new Set,s=new Set;for(const o of u.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(u.updated.has(o)?s.add(o):i.add(o));for(const o of u.added.values())s.has(o)||r.added.has(o)&&p.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(u.added.has(o)?p.updated.has(o)&&s.add(o):c.add(o));for(const o of u.updated.values())s.has(o)||r.updated.has(o)&&p.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(u.updated.has(o)?p.updated.has(o)&&s.add(o):t.add(o));return{added:c,removed:i,updated:t,conflicts:s}}function R(p,u,r,c){const i=new Set,t=E(p,c),s=E(u,c),o=r?E(r,c):null,a=S(t,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const l=o?S(o,t):{added:[...t.keys()].reduce((D,F)=>(D.add(F),D),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const f=o?S(o,s):{added:[...s.keys()].reduce((D,F)=>(D.add(F),D),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:b,removed:_,updated:O,conflicts:M}=C(a,l,f);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:b,removed:_,updated:O,conflicts:M}}function E(p,u){const r=new Map;for(const c of p){const i=u[c.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(c)}return r}function m(p){const u=new Map;for(const r of p){const c=r.command[0]==="-"?r.command.substring(1):r.command;let i=u.get(c);i||(i=[],u.set(c,i)),i.push(r)}return u}function S(p,u){const r=[...p.keys()],c=[...u.keys()],i=c.filter(o=>r.indexOf(o)===-1).reduce((o,a)=>(o.add(a),o),new Set),t=r.filter(o=>c.indexOf(o)===-1).reduce((o,a)=>(o.add(a),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const a=p.get(o).map(f=>({...f,key:o})),l=u.get(o).map(f=>({...f,key:o}));(0,k.equals)(a,l,(f,b)=>g(f,b))||s.add(o)}return{added:i,removed:t,updated:s}}function d(p,u,r){const c=[...p.keys()],i=[...u.keys()],t=i.filter(a=>c.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),s=c.filter(a=>i.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),o=new Set;for(const a of c){if(s.has(a))continue;const l=p.get(a).map(b=>({...b,key:r[b.key]})),f=u.get(a).map(b=>({...b,key:r[b.key]}));v(l,f)||o.add(a)}return{added:t,removed:s,updated:o}}function v(p,u){return!(!(0,k.equals)(p.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,c)=>g(r,c))||!(0,k.equals)(p.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,c)=>g(r,c)))}function g(p,u){if(p.command!==u.command||p.key!==u.key)return!1;const r=L.ContextKeyExpr.deserialize(p.when),c=L.ContextKeyExpr.deserialize(u.when);return!(r&&!c||!r&&c||r&&c&&!r.equals(c)||!T.equals(p.args,u.args))}function h(p,u,r){for(const c of u)p=A.edit(p,[-1],c,r);return p}function y(p,u,r){const c=P(p);for(let i=c.length-1;i>=0;i--)(c[i].command===u||c[i].command===`-${u}`)&&(p=A.edit(p,[i],void 0,r));return p}function w(p,u,r,c){const i=P(p),t=i.findIndex(s=>s.command===u||s.command===`-${u}`);for(let s=i.length-1;s>=0;s--)(i[s].command===u||i[s].command===`-${u}`)&&(p=A.edit(p,[s],void 0,c));for(let s=r.length-1;s>=0;s--)p=A.edit(p,[t],r[s],c);return p}}),define(ne[225],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(L,A,P){const I={},C={},R=new Set;if(!A)return{local:{added:I,updated:C,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=n(L,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:I,updated:C,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=n(P,L),S=n(P,A),d={},v={},g=new Set,h=new Set;for(const y of m.removed.values())S.updated.has(y)?I[y]=A[y]:g.add(y);for(const y of S.removed.values())h.has(y)||(m.updated.has(y)?h.add(y):R.add(y));for(const y of m.updated.values())h.has(y)||(S.updated.has(y)?E.updated.has(y)&&h.add(y):v[y]=L[y]);for(const y of S.updated.values())h.has(y)||(m.updated.has(y)?E.updated.has(y)&&h.add(y):L[y]!==void 0&&(C[y]=A[y]));for(const y of m.added.values())h.has(y)||(S.added.has(y)?E.updated.has(y)&&h.add(y):d[y]=L[y]);for(const y of S.added.values())h.has(y)||(m.added.has(y)?E.updated.has(y)&&h.add(y):I[y]=A[y]);return{local:{added:I,removed:[...R.values()],updated:C},remote:{added:d,removed:[...g.values()],updated:v},conflicts:[...h.values()]}}e.merge=k;function n(L,A){const P=L?Object.keys(L):[],I=A?Object.keys(A):[],C=I.filter(m=>P.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),R=P.filter(m=>I.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),E=new Set;for(const m of P){if(R.has(m))continue;const S=L[m],d=A[m];S!==d&&E.add(m)}return{added:C,removed:R,updated:E}}function T(L,A){const{added:P,removed:I,updated:C}=n(L,A);return P.size===0&&I.size===0&&C.size===0}e.areSame=T}),define(ne[24],ie([0,1,16,20,15,148,42,28,6,89,38]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(a=>!!o[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function m(){const o=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(o).filter(b=>!!o[b].ignoreSync),l=Object.keys(o).filter(b=>o[b].scope===2||o[b].scope===6),f=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...l,...f])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const o="vscode://schemas/ignoredSettings",a=R.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=R.Registry.as(C.Extensions.JSONContribution),f=()=>{const b=E(),_=m().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(F=>_.indexOf(F)===-1),M=_.filter(F=>b.indexOf(F)===-1),D={items:{type:"string",enum:[...O,...M.map(F=>`-${F}`)]}};l.registerSchema(o,D)};return a.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=S;function d(o){return o&&(0,T.isObject)(o)&&(0,T.isString)(o.id)&&(0,T.isArray)(o.scopes)}e.isAuthenticationProvider=d;var v;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(v=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function g(o,a,l){return l.joinPath(a.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=g,e.IUserDataSyncStoreManagementService=(0,I.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,I.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,I.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(o){const a={};return a[e.HEADER_EXECUTION_ID]=o,a}e.createSyncHeaders=h;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(a,l,f,b){super(a);this.code=l,this.resource=f,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class p extends w{constructor(a,l,f,b,_){super(a,f,void 0,_);this.url=l,this.serverCode=b}}e.UserDataSyncStoreError=p;class u extends w{constructor(a,l){super(a,l)}}e.UserDataAutoSyncError=u,function(o){function a(l){if(l instanceof o)return l;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(f&&f[1]){const b=f[2]==="unknown"?void 0:f[2],_=f[3]==="unknown"?void 0:f[3];return new o(l.message,f[1],b,_)}return new o(l.message,"Unknown")}o.toUserDataSyncError=a}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var c;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,I.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,I.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,I.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,I.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,I.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,a){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,n.isEqualOrParent)(o,(0,n.joinPath)(a.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ne[44],ie([0,1,16,5,17,25,3,35,2,27,15,8,144,18,13,14,9,46,23,21,32,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let c=class extends I.Disposable{constructor(a,l,f,b,_,O,M,D,F,$,q){super();this.resource=a,this.fileService=l,this.environmentService=f,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=M,this.telemetryService=D,this.logService=F,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=q.extUri,this.syncFolder=this.extUri.joinPath(f.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(a,f,this.extUri),this.currentMachineIdPromise=(0,h.getServiceMachineId)(f,l,b)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const l=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,l={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),l)}async preview(a,l,f={}){return this._sync(a,!1,l,f)}async apply(a,l={}){try{this.syncHeaders={...l};const f=await this.doApply(a);return this.setStatus(f),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,l,f,b){try{if(this.syncHeaders={...b},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(M,O,l,f),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const l=await this.resolveContent(a);if(!l)return!1;const f=this.parseSyncData(l);if(!f)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,b),O=await this.isRemoteDataFromCurrentMachine(_),M=await this.generateSyncPreview({ref:_.ref,syncData:f},b,O,this.getUserDataSyncConfiguration(),L.CancellationToken.None),D=[];for(const F of M){const $=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:q}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);D.push([F,{...$,remoteChange:q!==0?q:2}])}await this.applyResult(_,b,D,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const l=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===l}async getLatestRemoteUserData(a,l){if(l){const f=a&&a.latest?a.latest[this.resource]:void 0;if(l.ref===f||f===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(a,l,f,b){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,l,f,b)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,l,f,b);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(a,l,f,b)}throw _}}async doSync(a,l,f,b){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,l,f,b,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":f?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async l=>{const f=await this.getMergeResult(l,L.CancellationToken.None);await this.fileService.writeFile(l.previewResource,T.VSBuffer.fromString(f?.content||""));const b=f&&!f.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,L.CancellationToken.None):void 0;return l.acceptResult=b,l.mergeState=f.hasConflicts?"conflict":b?"accepted":"preview",l.localChange=b?b.localChange:f.localChange,l.remoteChange=b?b.remoteChange:f.remoteChange,l}),this.syncPreviewPromise}async accept(a,l){return await this.updateSyncResourcePreview(a,async f=>{const b=await this.getAcceptResult(f,a,l,L.CancellationToken.None);return f.acceptResult=b,f.mergeState="accepted",f.localChange=b.localChange,f.remoteChange=b.remoteChange,f}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async l=>{const f=await this.getMergeResult(l,L.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,T.VSBuffer.fromString(f.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=f.localChange,l.remoteChange=f.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(a,l){if(!this.syncPreviewPromise)return;let f=await this.syncPreviewPromise;const b=f.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:M})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(M,a));b!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...f.resourcePreviews];return O[b]=await l(O[b]),{...f,resourcePreviews:O}}),f=await this.syncPreviewPromise,this.updateConflicts(f.resourcePreviews),f.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:f})=>f!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(f=>[f,f.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const l=a.filter(({mergeState:f})=>f==="conflict");(0,k.equals)(this._conflicts,l,(f,b)=>this.extUri.isEqual(f.previewResource,b.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){const a=await this.getLastSyncUserData();return!!a&&a.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:f})=>({created:l,uri:this.toRemoteBackupResource(f)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:f})=>({created:l,uri:this.toLocalBackupResource(f)}))}toRemoteBackupResource(a){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const l=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(l))){const{content:f}=await this.getUserData(l);if(f)return this.parseSyncData(f)?.machineId}}async resolveContent(a){const l=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(l))){const{content:f}=await this.getUserData(l);return f}return this.extUri.isEqual(a,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(a){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const f of l.resourcePreviews){if(this.extUri.isEqual(f.acceptedResource,a))return f.acceptResult?f.acceptResult.content:null;if(this.extUri.isEqual(f.remoteResource,a))return f.remoteContent;if(this.extUri.isEqual(f.localResource,a))return f.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,l,f,b,_){const O=await this.isRemoteDataFromCurrentMachine(a),M=await this.generateSyncPreview(a,l,O,b,_),D=[];for(const F of M){const $=F.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)D.push({...F,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const q=f?await this.getMergeResult(F,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,T.VSBuffer.fromString(q?.content||""));const x=q&&!q.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,_):void 0;D.push({...F,acceptResult:x,mergeState:q?.hasConflicts?"conflict":x?"accepted":"preview",localChange:x?x.localChange:q?q.localChange:F.localChange,remoteChange:x?x.remoteChange:q?q.remoteChange:F.remoteChange})}}return{remoteUserData:a,lastSyncUserData:l,resourcePreviews:D,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(a.value.toString()),f=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&f&&l.version!==f,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${f}.`),await this.resetLocal(),null;const b=l;if(b.content===null)return{ref:l.ref,syncData:null};const _=JSON.parse(b.content);if(r(_))return{...l,syncData:_,content:void 0}}catch(a){a instanceof v.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const f=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),b={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:f,...l};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(b)))}async getRemoteUserData(a){const{ref:l,content:f}=await this.getUserData(a);let b=null;return f!==null&&(b=this.parseSyncData(f)),{ref:l,syncData:b}}parseSyncData(a){try{const l=JSON.parse(a);if(r(l))return l}catch(l){this.logService.error(l)}throw new u.UserDataSyncError((0,m.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,R.isString)(a)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:l}}else{const l=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(a,l){const f=await this.currentMachineIdPromise,b={version:this.version,machineId:f,content:a};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(b),l,this.syncHeaders),{ref:l,syncData:b}}async backupLocal(a){const l={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=de([K(1,v.IFileService),K(2,d.IEnvironmentService),K(3,y.IStorageService),K(4,u.IUserDataSyncStoreService),K(5,u.IUserDataSyncBackupStoreService),K(6,u.IUserDataSyncEnablementService),K(7,w.ITelemetryService),K(8,u.IUserDataSyncLogService),K(9,S.IConfigurationService),K(10,p.IUriIdentityService)],c),e.AbstractSynchroniser=c;let i=class extends c{constructor(a,l,f,b,_,O,M,D,F,$,q,x){super(l,f,b,_,O,M,D,F,$,q,x);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,l,f){try{l?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(a),f?void 0:l):await this.fileService.createFile(this.file,T.VSBuffer.fromString(a),{overwrite:f})}catch(b){throw b instanceof v.FileOperationError&&b.fileOperationResult===1||b instanceof v.FileOperationError&&b.fileOperationResult===3?new u.UserDataSyncError(b.message,"LocalPreconditionFailed"):b}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};i=de([K(2,v.IFileService),K(3,d.IEnvironmentService),K(4,y.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncEnablementService),K(8,w.ITelemetryService),K(9,u.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,p.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(a,l,f,b,_,O,M,D,F,$,q,x,G){super(a,l,f,b,_,O,M,D,F,$,x,G);this.userDataSyncUtilService=q,this._formattingOptions=void 0}hasErrors(a){const l=[];return(0,P.parse)(a,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([K(2,v.IFileService),K(3,d.IEnvironmentService),K(4,y.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncEnablementService),K(8,w.ITelemetryService),K(9,u.IUserDataSyncLogService),K(10,u.IUserDataSyncUtilService),K(11,S.IConfigurationService),K(12,p.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(a,l,f,b,_){this.resource=a,this.environmentService=l,this.logService=f,this.fileService=b,this.extUri=_.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,l,this.extUri)}async initialize({ref:a,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const f=this.parseSyncData(l);if(!!f)try{await this.doInitialize({ref:a,syncData:f})}catch(b){this.logService.error(b)}}parseSyncData(a){try{const l=JSON.parse(a);if(r(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,l={}){const f={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(f)))}};s=de([K(1,d.IEnvironmentService),K(2,g.ILogService),K(3,v.IFileService),K(4,p.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ne[226],ie([0,1,5,25,7,3,49,27,8,18,13,28,31,63,14,9,23,21,32,44,223,98,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(s,o){const a=JSON.parse(s.content);if(s.version===1||s.version===2){const l=(await o.getInstalled(0)).filter(f=>f.isBuiltin);for(const f of a)s.version===1&&(f.enabled===!1&&(f.disabled=!0),delete f.enabled),s.version===2&&l.every(b=>!(0,m.areSameExtensions)(b.identifier,f.identifier))&&(f.installed=!0)}return a}let i=class dt extends w.AbstractSynchroniser{constructor(o,a,l,f,b,_,O,M,D,F,$,q,x,G,B){super("extensions",a,o,l,f,b,q,x,D,$,B);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=M,this.extensionGalleryService=F,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:H})=>!!H)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,a){const l=o.syncData?await c(o.syncData,this.extensionManagementService):null,f=a?.skippedExtensions||[],b=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);l?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:D,remote:F}=(0,p.merge)(O,l,b,f,M),$={local:D,remote:F,content:this.getPreviewContent(O,D.added,D.updated,D.removed),localChange:D.added.length>0||D.removed.length>0||D.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:f,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:l?this.stringify(l,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const a=o.syncData?await c(o.syncData,this.extensionManagementService):null,l=await this.extensionManagementService.getInstalled(void 0,!0),f=this.getLocalExtensions(l),b=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),{remote:_}=(0,p.merge)(f,a,a,o.skippedExtensions||[],b);return _!==null}getPreviewContent(o,a,l,f){const b=[...a,...l],_=new Set,O=M=>{_.add(M.id.toLowerCase()),M.uuid&&_.add(M.uuid)};b.forEach(({identifier:M})=>O(M)),f.forEach(O);for(const M of o)_.has(M.identifier.id.toLowerCase())||M.identifier.uuid&&_.has(M.identifier.uuid)||b.push(M);return this.stringify(b,!1)}async getMergeResult(o,a){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,a,l,f){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(a,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(o){const a=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),f=(0,p.merge)(o.localExtensions,null,null,o.skippedExtensions,l),{local:b,remote:_}=f;return{content:o.localContent,local:b,remote:_,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const a=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),f=o.remoteContent?JSON.parse(o.remoteContent):null;if(f!==null){const b=(0,p.merge)(o.localExtensions,f,o.localExtensions,[],l),{local:_,remote:O}=b;return{content:o.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,a,l,f){let{skippedExtensions:b,localExtensions:_}=l[0][0],{local:O,remote:M,localChange:D,remoteChange:F}=l[0][1];if(D===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),D!==0&&(await this.backupLocal(JSON.stringify(_)),b=await this.updateLocalExtensions(O.added,O.removed,O.updated,b)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const $=JSON.stringify(M.all);o=await this.updateRemoteUserData($,f?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${M.added.length?` Added: ${JSON.stringify(M.added.map(q=>q.identifier.id))}.`:""}${M.updated.length?` Updated: ${JSON.stringify(M.updated.map(q=>q.identifier.id))}.`:""}${M.removed.length?` Removed: ${JSON.stringify(M.removed.map(q=>q.identifier.id))}.`:""}`)}a?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:b}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${b.length?` Skipped: ${JSON.stringify(b.map($=>$.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:dt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,dt.EXTENSIONS_DATA_URI)){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),b=this.getLocalExtensions(l).filter(_=>!f.some(O=>(0,m.areSameExtensions)({id:O},_.identifier)));return this.stringify(b,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const l=await this.resolvePreviewContent(o);return l&&this.stringify(JSON.parse(l),!0)}let a=await super.resolveContent(o);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(o)),a){const l=this.parseSyncData(a);if(l)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(l),!0)}}return null}stringify(o,a){return o.sort((l,f)=>!l.identifier.uuid&&f.identifier.uuid?-1:l.identifier.uuid&&!f.identifier.uuid?1:(0,P.compare)(l.identifier.id,f.identifier.id)),a?(0,A.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(l=>l.installed||l.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,a,l,f){const b=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const D=O.filter(({identifier:F,isBuiltin:$})=>!$&&a.some(q=>(0,m.areSameExtensions)(F,q)));await k.Promises.settled(D.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),b.push(F.identifier)}))}(o.length||l.length)&&await k.Promises.settled([...o,...l].map(async D=>{const F=O.find(q=>(0,m.areSameExtensions)(q.identifier,D.identifier));if(F&&F.isBuiltin){D.state&&F.manifest.version===D.version&&this.updateExtensionState(D.state,F,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(x=>(0,m.areSameExtensions)(x,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id),await this.extensionEnablementService.disableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id),await this.extensionEnablementService.enableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id))),b.push(D.identifier);return}const $=(await this.extensionGalleryService.getExtensions([{...D.identifier,preRelease:D.preRelease}],n.CancellationToken.None))[0];if(D.state&&(F?F.manifest.version===D.version:!!$)&&this.updateExtensionState(D.state,F||$,F?.manifest.version),$)try{this.extensionEnablementService.getDisabledExtensions().some(x=>(0,m.areSameExtensions)(x,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id,$.version))),(!F||F.preRelease!==D.preRelease)&&(await this.extensionManagementService.canInstall($)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,D.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:D.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,D.identifier.id,$.version),b.push($.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),_.push(D)))}catch(q){_.push(D),q instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):(this.logService.error(q),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id))}else _.push(D),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}));const M=[];for(const D of f)b.some(F=>(0,m.areSameExtensions)(F,D.identifier))||M.push(D);for(const D of _)M.some(F=>(0,m.areSameExtensions)(F.identifier,D.identifier))||M.push(D);return M}updateExtensionState(o,a,l){const f=this.extensionStorageService.getExtensionState(a,!0)||{},b=l?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:l}):void 0;b?b.forEach(_=>{f[_]=o[_]}):Object.keys(o).forEach(_=>f[_]=o[_]),this.extensionStorageService.setExtensionState(a,f,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const a=this.extensionEnablementService.getDisabledExtensions();return o.map(l=>{const{identifier:f,isBuiltin:b,manifest:_,preRelease:O}=l,M={identifier:f,preRelease:O,version:_.version};a.some(D=>(0,m.areSameExtensions)(D,f))&&(M.disabled=!0),b||(M.installed=!0);try{const D=this.extensionStorageService.getKeysForSync({id:f.id,version:_.version});if(D){const F=this.extensionStorageService.getExtensionState(l,!0)||{};M.state=Object.keys(F).reduce(($,q)=>(D.includes(q)&&($[q]=F[q]),$),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,T.getErrorMessage)(D))}return M})}};i.EXTENSIONS_DATA_URI=I.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([K(0,R.IEnvironmentService),K(1,d.IFileService),K(2,g.IStorageService),K(3,r.IUserDataSyncStoreService),K(4,r.IUserDataSyncBackupStoreService),K(5,E.IExtensionManagementService),K(6,E.IGlobalExtensionEnablementService),K(7,u.IIgnoredExtensionsManagementService),K(8,r.IUserDataSyncLogService),K(9,E.IExtensionGalleryService),K(10,C.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,h.ITelemetryService),K(13,S.IExtensionStorageService),K(14,y.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends w.AbstractInitializer{constructor(o,a,l,f,b,_){super("extensions",f,b,l,_);this.extensionManagementService=o,this.ignoredExtensionsManagementService=a}async parseExtensions(o){return o.syncData?await c(o.syncData,this.extensionManagementService):null}generatePreview(o,a){const l=[],f=[],b=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(M=>(0,m.areSameExtensions)(M.identifier,_.identifier));O?(l.push(O),_.disabled&&b.push(_.identifier)):_.installed&&(f.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&b.push(_.identifier))}return{installedExtensions:l,newExtensions:f,disabledExtensions:b,remoteExtensions:o}}};t=de([K(0,E.IExtensionManagementService),K(1,u.IIgnoredExtensionsManagementService),K(2,d.IFileService),K(3,R.IEnvironmentService),K(4,v.ILogService),K(5,y.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(ne[227],ie([0,1,29,24]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(P,I,C,R,E){if(!I)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const m=L(P,I);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=C?L(C,I):{added:Object.keys(I).reduce((y,w)=>(y.add(w),y),new Set),removed:new Set,updated:new Set},d=C?L(C,P):{added:Object.keys(P).reduce((y,w)=>(y.add(w),y),new Set),removed:new Set,updated:new Set},v={added:{},removed:[],updated:{}},g=k.deepClone(I),h=!C;for(const y of d.added.values())y!==n.SYNC_SERVICE_URL_TYPE&&h&&S.added.has(y)||(g[y]=P[y]);for(const y of d.updated.values())g[y]=P[y];for(const y of d.removed.values())R.unregistered.includes(y)||delete g[y];for(const y of S.added.values()){const w=I[y];if(R.machine.includes(y)){E.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(C&&d.added.has(y))continue;const p=P[y];p&&p.value===w.value||y===n.SYNC_SERVICE_URL_TYPE&&h&&d.added.has(y)||(p?v.updated[y]=w:v.added[y]=w)}for(const y of S.updated.values()){const w=I[y];if(R.machine.includes(y)){E.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(y)||d.removed.has(y))continue;const p=P[y];p&&p.value===w.value||(v.updated[y]=w)}for(const y of S.removed.values()){if(R.machine.includes(y)){E.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}d.updated.has(y)||d.removed.has(y)||v.removed.push(y)}return{local:v,remote:A(g,I)?null:g}}e.merge=T;function L(P,I){const C=Object.keys(P),R=Object.keys(I),E=R.filter(d=>C.indexOf(d)===-1).reduce((d,v)=>(d.add(v),d),new Set),m=C.filter(d=>R.indexOf(d)===-1).reduce((d,v)=>(d.add(v),d),new Set),S=new Set;for(const d of C){if(m.has(d))continue;const v=P[d],g=I[d];k.equals(v,g)||S.add(d)}return{added:E,removed:m,updated:S}}function A(P,I){const{added:C,removed:R,updated:E}=L(P,I);return C.size===0&&R.size===0&&E.size===0}}),define(ne[228],ie([0,1,17,7,3,35,49,4,8,30,18,13,14,9,46,23,21,32,44,53,227,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",c=["locale"];function i(l,f){const b=l.storage?Object.keys(l.storage).sort():[],_={};return b.forEach(O=>_[O]=l.storage[O]),l.storage=_,f?(0,A.toFormattedString)(l,{}):JSON.stringify(l)}const t=1;let s=class ft extends y.AbstractSynchroniser{constructor(f,b,_,O,M,D,F,$,q,x){super("globalState",f,M,q,b,_,D,F,O,$,x);this.storageService=q,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(f.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),T.Event.filter(q.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:q.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,b,_){const O=f.syncData?JSON.parse(f.syncData.content):null;b=b===null&&_?f:b;const M=b&&b.syncData?JSON.parse(b.syncData.content):null,D=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(M),{local:$,remote:q}=(0,p.merge)(D.storage,O?O.storage:null,M?M.storage:null,F,this.logService),x={content:null,local:$,remote:q,localChange:Object.keys($.added).length>0||Object.keys($.updated).length>0||$.removed.length>0?2:0,remoteChange:q!==null?2:0};return[{localResource:this.localResource,localContent:i(D,!1),localUserData:D,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async hasRemoteChanged(f){const b=f.syncData?JSON.parse(f.syncData.content):null;if(b===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(b),{remote:M}=(0,p.merge)(_.storage,b.storage,b.storage,O,this.logService);return M!==null}async getMergeResult(f,b){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,b,_,O){if(this.extUri.isEqual(b,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(b,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(b,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async acceptLocal(f){return{content:f.localContent,local:{added:{},removed:[],updated:{}},remote:f.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(f){if(f.remoteContent!==null){const b=JSON.parse(f.remoteContent),{local:_,remote:O}=(0,p.merge)(f.localUserData.storage,b.storage,null,f.storageKeys,this.logService);return{content:f.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:f.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(f,b,_,O){let{localUserData:M}=_[0][0],{local:D,remote:F,localChange:$,remoteChange:q}=_[0][1];if($===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.writeLocalGlobalState(D),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),q!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const x=JSON.stringify({storage:F});f=await this.updateRemoteUserData(x,O?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}b?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,ft.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f)){const _=await this.resolvePreviewContent(f);return _&&i(JSON.parse(_),!0)}let b=await super.resolveContent(f);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(f)),b){const _=this.parseSyncData(b);if(_)switch(this.extUri.basename(f)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:f}=await this.getLocalGlobalState();if(Object.keys(f).length>1||f[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const f={},b=await this.getLocalArgvContent(),_=(0,L.parse)(b);for(const O of c)_[O]!==void 0&&(f[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const M=this.storageService.get(O,0);M&&(f[O]={version:1,value:M})}return{storage:f}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const f=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),f.value.toString()}catch(f){this.logService.debug((0,n.getErrorMessage)(f))}return"{}"}async writeLocalGlobalState({added:f,removed:b,updated:_}){const O={},M={},D=($,q)=>{for(const x of $){if(x.startsWith(r)){O[x.substring(r.length)]=q?q[x].value:void 0;continue}if(q){const G=q[x];G.value!==String(this.storageService.get(x,0))&&(M[x]=G.value)}else this.storageService.get(x,0)!==void 0&&(M[x]=void 0)}};if(D(Object.keys(f),f),D(Object.keys(_),_),D(b),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(M).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(M))this.storageService.store($,M[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(M))}}async updateArgv(f){const b=await this.getLocalArgvContent();let _=b;for(const O of Object.keys(f))_=(0,w.edit)(_,[O],f[O],{});b!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(f){const b=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...b,..._],M=f?.storage?Object.keys(f.storage).filter(D=>!D.startsWith(r)&&!O.includes(D)&&this.storageService.get(D,0)!==void 0):[];if(!P.isWeb){const D=[...u.ALL_SYNC_RESOURCES.map(F=>(0,u.getEnablementKey)(F)),u.SYNC_SERVICE_URL_TYPE];M.push(...D),_.push(...D)}return{user:b,machine:_,unregistered:M}}};s.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([K(0,m.IFileService),K(1,u.IUserDataSyncStoreService),K(2,u.IUserDataSyncBackupStoreService),K(3,u.IUserDataSyncLogService),K(4,E.IEnvironmentService),K(5,u.IUserDataSyncEnablementService),K(6,g.ITelemetryService),K(7,R.IConfigurationService),K(8,v.IStorageService),K(9,h.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends y.AbstractInitializer{constructor(f,b,_,O,M){super("globalState",_,O,b,M);this.storageService=f}async doInitialize(f){const b=f.syncData?JSON.parse(f.syncData.content):null;if(!b){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const M of Object.keys(b.storage))M.startsWith(r)?_[M.substring(r.length)]=b.storage[M].value:this.storageService.get(M,0)===void 0&&(O[M]=b.storage[M].value);if(Object.keys(_).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const D of Object.keys(_))M=(0,w.edit)(M,[D],_[D],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(M))}if(Object.keys(O).length)for(const M of Object.keys(O))this.storageService.store(M,O[M],0,0)}};o=de([K(0,v.IStorageService),K(1,m.IFileService),K(2,E.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,h.IUriIdentityService)],o),e.GlobalStateInitializer=o;let a=class{constructor(f,b,_,O,M){this.userDataSyncStoreClient=f,this.storageService=b,this.environmentService=_,this.fileService=O,this.logService=M}getSyncStoreType(f){return this.parseGlobalState(f)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(f){const b=(0,u.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(f,b)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(f,b)}throw _}}async doSync(f,b){const _=await this.userDataSyncStoreClient.read("globalState",null,b),O=this.parseGlobalState(_)||{storage:{}};O.storage[u.SYNC_SERVICE_URL_TYPE]={value:f,version:t};const M=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),D={version:t,machineId:M,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(D),_.ref,b)}parseGlobalState({content:f}){if(!f)return null;const b=JSON.parse(f);if((0,y.isSyncData)(b))return b?JSON.parse(b.content):null;throw new Error("Invalid remote data")}};a=de([K(1,v.IStorageService),K(2,E.IEnvironmentService),K(3,m.IFileService),K(4,S.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(ne[229],ie([0,1,16,17,3,35,4,15,145,18,13,14,23,21,32,44,224,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function y(u,r,c){try{const i=JSON.parse(u);if(!r)return(0,P.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,P.isUndefined)(i.mac)?null:i.mac;case 3:return(0,P.isUndefined)(i.linux)?null:i.linux;case 1:return(0,P.isUndefined)(i.windows)?null:i.windows}}catch(i){return c.error(i),null}}e.getKeybindingsContentFromSyncContent=y;let w=class extends v.AbstractJsonFileSynchroniser{constructor(r,c,i,t,s,o,a,l,f,b,_){super(a.keybindingsResource,"keybindings",o,a,l,r,c,s,b,i,f,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,c,i,t){const s=r.syncData?y(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&i?r:c;const o=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),l=await this.getFormattingOptions();let f=null,b=!1,_=!1,O=!1;if(s){let D=a?a.value.toString():"[]";if(D=D||"[]",this.hasErrors(D))throw new h.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==D||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,g.merge)(D,s,o,l,this.userDataSyncUtilService);F.hasChanges&&(f=F.mergeContent,O=F.hasConflicts,b=O||F.mergeContent!==D,_=O||F.mergeContent!==s)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=a.value.toString(),_=!0);const M={content:f,localChange:b?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getKeybindingsContentFromLastSyncUserData(r);if(c===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",s=await this.getFormattingOptions(),o=await(0,g.merge)(t||"[]",c,c,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==c}async getMergeResult(r,c){return r.previewResult}async getAcceptResult(r,c,i,t){if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:a,remoteChange:l}=i[0][1];if(a===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new h.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const f=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(f,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=(0,L.parse)(r.value.toString());if((0,k.isNonEmptyArray)(c))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return y(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:y(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,c){let i={};try{i=JSON.parse(c||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=de([K(0,h.IUserDataSyncStoreService),K(1,h.IUserDataSyncBackupStoreService),K(2,h.IUserDataSyncLogService),K(3,C.IConfigurationService),K(4,h.IUserDataSyncEnablementService),K(5,E.IFileService),K(6,R.IEnvironmentService),K(7,m.IStorageService),K(8,h.IUserDataSyncUtilService),K(9,S.ITelemetryService),K(10,d.IUriIdentityService)],w),e.KeybindingsSynchroniser=w;let p=class extends v.AbstractInitializer{constructor(r,c,i,t){super("keybindings",c,i,r,t)}async doInitialize(r){const c=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(c)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,L.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(c)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return y(r,!0,this.logService)}catch(c){return this.logService.error(c),null}}};p=de([K(0,E.IFileService),K(1,R.IEnvironmentService),K(2,h.IUserDataSyncLogService),K(3,d.IUriIdentityService)],p),e.KeybindingsInitializer=p}),define(ne[230],ie([0,1,16,35,70,49,29,53,24]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(o,a,l){let f=[];l?f=E(l):f=R(a);const b=[],_=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(f))for(const O of f)O.startsWith("-")?_.push(O.substring(1)):b.push(O);return(0,k.distinct)([...o,...b].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=C;function R(o){let a=o.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=o.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const a=(0,n.parse)(o);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function m(o,a,l,f){if(l.length){const b=s(a),_=(0,n.parse)(a)||{},O=(0,n.parse)(o);if(!O)return o;const M=[];for(const D of l){const F=_[D],$=O[D];F===void 0?o=P.edit(o,[D],void 0,f):$!==void 0?o=P.edit(o,[D],F,f):M.push(u(D,b))}M.sort((D,F)=>D.startOffset-F.startOffset),M.forEach(D=>o=h(D.setting.key,a,o,f))}return o}e.updateIgnoredSettings=m;function S(o,a,l,f,b,_){const O=m(o,a,f,_),M=l!==O,D=l!==a;if(!M&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!D)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(D&&!M)return{conflictsSettings:[],localContent:m(a,o,f,_),remoteContent:null,hasConflicts:!1};if(l===null&&v(o)){const z=d(o,a,f)?null:m(a,o,f,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let F=o,$=a;const q=(0,n.parse)(o),x=(0,n.parse)(a),G=l?(0,n.parse)(l):null,B=f.reduce((z,j)=>(z.add(j),z),new Set),W=g(q,x,B),H=g(G,q,B),te=g(G,x,B),V=new Map,Z=new Set,J=z=>{Z.add(z);const j=b.filter(({key:ee})=>ee===z)[0];j?(F=P.edit(F,[z],j.value,_),$=P.edit($,[z],j.value,_)):V.set(z,{key:z,localValue:q[z],remoteValue:x[z]})};for(const z of H.removed.values())te.updated.has(z)?J(z):$=P.edit($,[z],void 0,_);for(const z of te.removed.values())Z.has(z)||(H.updated.has(z)?J(z):F=P.edit(F,[z],void 0,_));for(const z of H.updated.values())Z.has(z)||(te.updated.has(z)?W.updated.has(z)&&J(z):$=P.edit($,[z],q[z],_));for(const z of te.updated.values())Z.has(z)||(H.updated.has(z)?W.updated.has(z)&&J(z):F=P.edit(F,[z],x[z],_));for(const z of H.added.values())Z.has(z)||(te.added.has(z)?W.updated.has(z)&&J(z):$=h(z,F,$,_));for(const z of te.added.values())Z.has(z)||(H.added.has(z)?W.updated.has(z)&&J(z):F=h(z,$,F,_));const Q=V.size>0||!d(F,$,f),N=Q||!d(F,o,[]),U=Q||!d($,a,[]);return{localContent:N?F:null,remoteContent:U?$:null,conflictsSettings:[...V.values()],hasConflicts:Q}}e.merge=S;function d(o,a,l){if(o===a)return!0;const f=(0,n.parse)(o),b=(0,n.parse)(a),_=l.reduce((D,F)=>(D.add(F),D),new Set),O=s(o).filter(D=>!(D.setting&&_.has(D.setting.key))),M=s(a).filter(D=>!(D.setting&&_.has(D.setting.key)));if(O.length!==M.length)return!1;for(let D=0;D<O.length;D++){const F=O[D],$=M[D];if(F.setting&&$.setting){if(F.setting.key!==$.setting.key||!A.equals(f[F.setting.key],b[F.setting.key]))return!1}else if(!F.setting&&!$.setting){if(F.value!==$.value)return!1}else return!1}return!0}e.areSame=d;function v(o){return o?s(o).length===0:!0}e.isEmpty=v;function g(o,a,l){const f=o?Object.keys(o).filter(D=>!l.has(D)):[],b=Object.keys(a).filter(D=>!l.has(D)),_=b.filter(D=>f.indexOf(D)===-1).reduce((D,F)=>(D.add(F),D),new Set),O=f.filter(D=>b.indexOf(D)===-1).reduce((D,F)=>(D.add(F),D),new Set),M=new Set;if(o)for(const D of f){if(O.has(D))continue;const F=o[D],$=a[D];A.equals(F,$)||M.add(D)}return{added:_,removed:O,updated:M}}function h(o,a,l,f){const b=(0,n.parse)(a),_=s(a),O=s(l),M=y(o,_,O);return w(l,o,b[o],M,O,f)}e.addSetting=h;function y(o,a,l){const f=a.findIndex(_=>_.setting?.key===o),b=a[f-1];if(b){if(b.setting){const O=u(b.setting.key,l);if(O)return{index:l.indexOf(O),insertAfter:!0}}else{const O=r(f,a);if(O){const M=u(O.setting.key,l);if(M){const D=c(l.indexOf(M),l),F=i(a,O,a[f]);if(D){const $=i(l,M,D),q=t(F,$);return q?{index:l.indexOf(q),insertAfter:!0}:{index:l.indexOf(D),insertAfter:!1}}else{const $=i(l,M,l[l.length-1]),q=t(F,$);return q?{index:l.indexOf(q),insertAfter:!0}:{index:l.length-1,insertAfter:!0}}}}}const _=a[f+1];if(_)if(_.setting){const O=u(_.setting.key,l);if(O)return{index:l.indexOf(O),insertAfter:!1}}else{const O=c(f,a);if(O){const M=u(O.setting.key,l);if(M){const D=r(l.indexOf(M),l),F=i(a,a[f],O);if(D){const $=i(l,D,M),q=t(F.reverse(),$.reverse());return q?{index:l.indexOf(q),insertAfter:!1}:{index:l.indexOf(D),insertAfter:!0}}else{const $=i(l,l[0],M),q=t(F.reverse(),$.reverse());return q?{index:l.indexOf(q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:l.length-1,insertAfter:!0}}function w(o,a,l,f,b,_){let O;return f.index===-1?O=(0,T.setProperty)(o,[a],l,_):O=p(o,a,l,f,b,_).map(M=>(0,T.withFormatting)(o,M,_)[0]),(0,T.applyEdits)(o,O)}function p(o,a,l,f,b,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(l)}`,M=(0,L.getEOL)(_,o),D=b[f.index];if(f.insertAfter){const F=[];if(D.setting)F.push({offset:D.endOffset,length:0,content:","+O});else{const $=c(f.index,b),q=r(f.index,b),x=q?.setting?.commaOffset;q&&x===void 0&&F.push({offset:q.endOffset,length:0,content:","});const G=x!==void 0&&x>D.endOffset;F.push({offset:G?x+1:D.endOffset,length:0,content:$?M+O+",":M+O})}return F}else{if(D.setting)return[{offset:D.startOffset,length:0,content:O+","}];const F=(b[f.index-1]&&!b[f.index-1].setting?M:"")+O+(c(f.index,b)?",":"")+M;return[{offset:D.startOffset,length:0,content:F}]}}function u(o,a){return a.filter(l=>l.setting?.key===o)[0]}function r(o,a){for(let l=o-1;l>=0;l--)if(a[l].setting)return a[l]}function c(o,a){for(let l=o+1;l<a.length;l++)if(a[l].setting)return a[l]}function i(o,a,l){const f=o.indexOf(a),b=o.indexOf(l);return o.filter((_,O)=>f<O&&O<b)}function t(o,a){if(o.length&&a.length){let l=0;for(;l<a.length&&l<o.length;l++)if(o[l].value!==a[l].value)return a[l-1];return a[l-1]}}function s(o){const a=[];let l=-1,f,b;const _={onObjectBegin:O=>{l++},onObjectProperty:(O,M,D)=>{l===0&&(f=M,b=O)},onObjectEnd:(O,M)=>{l--,l===0&&a.push({startOffset:f,endOffset:O+M,value:o.substring(f,O+M),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(O,M)=>{l++},onArrayEnd:(O,M)=>{l--,l===0&&a.push({startOffset:f,endOffset:O+M,value:o.substring(f,O+M),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(O,M,D)=>{l===0&&a.push({startOffset:f,endOffset:M+D,value:o.substring(f,M+D),setting:{key:b,commaOffset:void 0}})},onSeparator:(O,M,D)=>{if(l===0&&O===","){let F=a.length-1;for(;F>=0&&!a[F].setting;F--);const $=a[F];$&&a.splice(F,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:M}})}},onComment:(O,M)=>{l===0&&a.push({startOffset:O,endOffset:O+M,value:o.substring(O,O+M)})}};return(0,n.visit)(o,_),a}}),define(ne[231],ie([0,1,17,3,146,18,90,13,28,14,23,21,32,44,53,230,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function y(u){const r=JSON.parse(u);return h(r)?r:{settings:u}}e.parseSettingsSyncContent=y;let w=class extends S.AbstractJsonFileSynchroniser{constructor(r,c,i,t,s,o,a,l,f,b,_,O){super(c.settingsResource,"settings",r,c,i,t,s,f,b,o,a,l,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const c=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,c),t=this.getSettingsSyncContent(i),s=new A.ConfigurationModelParser(g.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,c,i){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);c=c===null&&i?r:c;const a=c?this.getSettingsSyncContent(c):null,l=await this.getIgnoredSettings();let f=null,b=!1,_=!1,O=!1;if(o){let D=t?t.value.toString().trim():"{}";D=D||"{}",this.validateContent(D),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,v.merge)(D,o.settings,a?a.settings:null,l,[],s);f=F.localContent||F.remoteContent,b=F.localContent!==null,_=F.remoteContent!==null,O=F.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),f=t.value.toString(),_=!0);const M={content:f,localChange:b?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const c=this.getSettingsSyncContent(r);if(c===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,v.merge)(t||"{}",c.settings,c.settings,s,[],o).remoteContent!==null}async getMergeResult(r,c){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,v.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,c,i,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:r.fileContent?(0,v.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:r.remoteContent!==null?(0,v.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,v.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(r,c,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:a,remoteChange:l}=i[0][1];if(a===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),l!==0){const f=await this.getFormattingOptions(),b=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(o);o=(0,v.updateIgnoredSettings)(o,b?b.settings:"{}",_,f),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const c=await this.getFormattingOptions(),i=(0,d.edit)(r.value.toString(),[g.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,v.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:c}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let c=await super.resolveContent(r);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(r)),c){const i=this.parseSyncData(c);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let c=await super.resolvePreviewContent(r);if(c){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();c=(0,v.updateIgnoredSettings)(c,"{}",t,i)}return c}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return y(r)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(c,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new g.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};w=de([K(0,C.IFileService),K(1,P.IEnvironmentService),K(2,R.IStorageService),K(3,g.IUserDataSyncStoreService),K(4,g.IUserDataSyncBackupStoreService),K(5,g.IUserDataSyncLogService),K(6,g.IUserDataSyncUtilService),K(7,L.IConfigurationService),K(8,g.IUserDataSyncEnablementService),K(9,E.ITelemetryService),K(10,I.IExtensionManagementService),K(11,m.IUriIdentityService)],w),e.SettingsSynchroniser=w;let p=class extends S.AbstractInitializer{constructor(r,c,i,t){super("settings",c,i,r,t)}async doInitialize(r){const c=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return y(r)}catch(c){this.logService.error(c)}return null}};p=de([K(0,C.IFileService),K(1,P.IEnvironmentService),K(2,g.IUserDataSyncLogService),K(3,m.IUriIdentityService)],p),e.SettingsInitializer=p}),define(ne[232],ie([0,1,17,3,29,18,13,14,23,21,32,44,225,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends E.AbstractSynchroniser{constructor(h,y,w,p,u,r,c,i,t,s){super("snippets",y,h,w,p,u,i,t,r,c,s);this.version=1,this.snippetsFolder=h.snippetsHome,this._register(this.fileService.watch(h.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(h,y,w){const p=await this.getSnippetsFileContents(),u=this.toSnippetsContents(p),r=h.syncData?this.parseSnippets(h.syncData):null;y=y===null&&w?h:y;const c=y&&y.syncData?this.parseSnippets(y.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,m.merge)(u,r,c);return this.getResourcePreviews(i,p,r||{})}async hasRemoteChanged(h){const y=h.syncData?this.parseSnippets(h.syncData):null;if(y===null)return!0;const w=await this.getSnippetsFileContents(),p=this.toSnippetsContents(w),u=(0,m.merge)(p,y,y);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(h,y){return h.previewResult}async getAcceptResult(h,y,w,p){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder))return w===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:w,localChange:w===null?h.fileContent!==null?3:0:2,remoteChange:w===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async applyResult(h,y,w,p){const u=w.map(([r,c])=>({...r,acceptResult:c}));u.every(({localChange:r,remoteChange:c})=>r===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,p)),u.some(({remoteChange:r})=>r!==0)&&(h=await this.updateRemoteSnippets(u,h,p)),y?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of u)try{await this.fileService.del(r)}catch{}}getResourcePreviews(h,y,w){const p=new Map;for(const u of Object.keys(h.local.added)){const r={content:h.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};p.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(h.local.updated)){const r={content:h.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of h.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(h.remote.added)){const r={content:h.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(h.remote.updated)){const r={content:h.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u],localContent:y[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of h.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of h.conflicts){const r={content:y[u]?y[u].value.toString():null,hasConflicts:!0,localChange:y[u]?2:1,remoteChange:w[u]?2:1};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u]||null,localContent:y[u]?y[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(y))if(!p.has(u)){const r={content:y[u]?y[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[u]||null,localContent:y[u]?y[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:h}){let y=await super.resolveContent(h);if(y){const w=this.parseSyncData(y);if(w){const p=this.parseSnippets(w),u=[];for(const r of Object.keys(p)){const c=this.extUri.joinPath(h,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);u.push({resource:c,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(h){if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(h);let y=await super.resolveContent(h);if(y)return y;if(y=await super.resolveContent(this.extUri.dirname(h)),y){const w=this.parseSyncData(y);if(w)return this.parseSnippets(w)[this.extUri.basename(h)]||null}return null}async hasLocalData(){try{const h=await this.getSnippetsFileContents();if(Object.keys(h).length)return!0}catch{}return!1}async updateLocalBackup(h){const y={};for(const w of h)w.fileContent&&(y[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(y)))}async updateLocalSnippets(h,y){for(const{fileContent:w,acceptResult:p,localResource:u,remoteResource:r,localChange:c}of h)if(c!==0){const i=r?this.extUri.basename(r):this.extUri.basename(u),t=this.extUri.joinPath(this.snippetsFolder,i);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,k.VSBuffer.fromString(p.content),{overwrite:y}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,k.VSBuffer.fromString(p.content),y?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(h,y,w){const p=y.syncData?this.parseSnippets(y.syncData):{},u=(0,T.deepClone)(p);for(const{acceptResult:r,localResource:c,remoteResource:i,remoteChange:t}of h)if(t!==0){const s=c?this.extUri.basename(c):this.extUri.basename(i);t===3?delete u[s]:u[s]=r.content}return(0,m.areSame)(p,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),y=await this.updateRemoteUserData(JSON.stringify(u),w?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),y}parseSnippets(h){return JSON.parse(h.content)}toSnippetsContents(h){const y={};for(const w of Object.keys(h))y[w]=h[w].value.toString();return y}async getSnippetsFileContents(){const h={};let y;try{y=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof P.FileOperationError&&w.fileOperationResult===1)return h;throw w}for(const w of y.children||[]){const p=w.resource,u=this.extUri.extname(p);if(u===".json"||u===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,p),c=await this.fileService.readFile(p);h[r]=c}}return h}};d=de([K(0,A.IEnvironmentService),K(1,P.IFileService),K(2,I.IStorageService),K(3,S.IUserDataSyncStoreService),K(4,S.IUserDataSyncBackupStoreService),K(5,S.IUserDataSyncLogService),K(6,L.IConfigurationService),K(7,S.IUserDataSyncEnablementService),K(8,C.ITelemetryService),K(9,R.IUriIdentityService)],d),e.SnippetsSynchroniser=d;let v=class extends E.AbstractInitializer{constructor(h,y,w,p){super("snippets",y,w,h,p)}async doInitialize(h){const y=h.syncData?JSON.parse(h.syncData.content):null;if(!y){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(y)){const u=y[p];if(u){const r=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(r,k.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(h)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};v=de([K(0,P.IFileService),K(1,A.IEnvironmentService),K(2,S.IUserDataSyncLogService),K(3,R.IUriIdentityService)],v),e.SnippetsInitializer=v}),define(ne[233],ie([0,1,17,18,13,14,23,21,32,44,24]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function E(v,g){try{return JSON.parse(v).tasks}catch(h){return g.error(h),null}}e.getTasksContentFromSyncContent=E;let m=class extends C.AbstractFileSynchroniser{constructor(g,h,y,w,p,u,r,c,i,t){super(t.extUri.joinPath(t.extUri.dirname(r.settingsResource),"tasks.json"),"tasks",u,r,c,g,h,p,i,y,w,t);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(g,h,y,w){const p=g.syncData?E(g.syncData.content,this.logService):null;h=h===null&&y?g:h;const u=h?.syncData?E(h.syncData.content,this.logService):null,r=await this.getLocalFileContent();let c=null,i=!1,t=!1,s=!1;if(p){const a=r?r.value.toString():null;if(!u||u!==a||u!==p){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=d(a,p,u);c=l.content,s=l.hasConflicts,i=l.hasLocalChanged,t=l.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),c=r.value.toString(),t=!0);const o={content:c,localChange:i?r?2:1:0,remoteChange:t?2:0,hasConflicts:s};return[{fileContent:r,localResource:this.localResource,localContent:r?r.value.toString():null,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:p,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(g){const h=g?.syncData?E(g.syncData.content,this.logService):null;if(h===null)return!0;const y=await this.getLocalFileContent(),w=y?y.value.toString():null,p=d(w,h,h);return p.hasLocalChanged||p.hasRemoteChanged}async getMergeResult(g,h){return g.previewResult}async getAcceptResult(g,h,y,w){if(this.extUri.isEqual(h,this.localResource))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(h,this.remoteResource))return{content:g.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(h,this.previewResource))return y===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:y,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(g,h,y,w){const{fileContent:p}=y[0][0];let{content:u,localChange:r,remoteChange:c}=y[0][1];if(r===0&&c===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),p&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(p.value.toString()))),await this.updateLocalFileContent(u||"{}",p,w),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),c!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(u||"{}"));g=await this.updateRemoteUserData(i,w?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}h?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:g}){const h=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(g,"tasks.json"),comparableResource:h}]}async resolveContent(g){if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let h=await super.resolveContent(g);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(g)),h){const y=this.parseSyncData(h);if(y)switch(this.extUri.basename(g)){case"tasks.json":return E(y.content,this.logService)}}return null}toTasksSyncContent(g){return{tasks:g}}};m=de([K(0,R.IUserDataSyncStoreService),K(1,R.IUserDataSyncBackupStoreService),K(2,R.IUserDataSyncLogService),K(3,n.IConfigurationService),K(4,R.IUserDataSyncEnablementService),K(5,L.IFileService),K(6,T.IEnvironmentService),K(7,A.IStorageService),K(8,P.ITelemetryService),K(9,I.IUriIdentityService)],m),e.TasksSynchroniser=m;let S=class extends C.AbstractInitializer{constructor(g,h,y,w){super("tasks",h,y,g,w);this.uriIdentityService=w,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(g){const h=g.syncData?E(g.syncData.content,this.logService):null;if(!h){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(h)),await this.updateLastSyncUserData(g)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};S=de([K(0,L.IFileService),K(1,T.IEnvironmentService),K(2,R.IUserDataSyncLogService),K(3,I.IUriIdentityService)],S),e.TasksInitializer=S;function d(v,g,h){if(v===null&&g===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===g)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const y=h!==v,w=h!==g;return!y&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:y&&!w?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!y?{content:g,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[65],ie([0,1,3,2,6,24]),function(Y,e,k,n,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(I,C){super();this.userDataSyncStoreService=I,this.logService=C,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};A=de([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[234],ie([0,1,5,17,57,2,20,18,13,14,24]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends L.Disposable{constructor(S,d,v,g){super();this.environmentService=S,this.fileService=d,this.configurationService=v,this.logService=g,R.ALL_SYNC_RESOURCES.forEach(h=>this.cleanUpBackup(h))}async getAllRefs(S){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),v=await this.fileService.resolve(d);return v.children?v.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort().reverse().map(h=>({ref:h.name,created:this.getCreationTime(h)})):[]}async resolveContent(S,d){if(!d){const v=await this.getAllRefs(S);v.length&&(d=v[v.length-1].ref)}if(d){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,S,d);return(await this.fileService.readFile(v)).value.toString()}return null}async backup(S,d){const v=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),g=(0,A.joinPath)(v,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,n.VSBuffer.fromString(d))}catch(h){this.logService.error(h)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(d))return}catch{return}const v=await this.fileService.resolve(d);if(v.children){const g=v.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=g.filter(p=>Date.now()-this.getCreationTime(p)>h);const w=g.length-y.length;w<10&&(y=y.slice(10-w)),await k.Promises.settled(y.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};E=de([K(0,I.IEnvironmentService),K(1,C.IFileService),K(2,P.IConfigurationService),K(3,R.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(ne[235],ie([0,1,3,2,4,13,23,21,24]),function(Y,e,k,n,T,L,A,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let R=class extends n.Disposable{constructor(m,S,d,v){super();this.storageService=m,this.telemetryService=S,this.environmentService=d,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(g=>this.onDidStorageChange(g)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:m}),this.storageService.store(C,m,0,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,I.getEnablementKey)(m),0,!0)}setResourceEnablement(m,S){if(this.isResourceEnabled(m)!==S){const d=(0,I.getEnablementKey)(m);this.storeResourceEnablement(d,S)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,S){this.storageService.store(m,S,0,T.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==0)return;if(C===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=I.ALL_SYNC_RESOURCES.filter(d=>(0,I.getEnablementKey)(d)===m.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};R=de([K(0,A.IStorageService),K(1,P.ITelemetryService),K(2,L.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],R),e.UserDataSyncEnablementService=R}),define(ne[236],ie([0,1,2,8]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(m){this.service=m}listen(m,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(m,S,d){switch(S){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class L{constructor(m){this.service=m}listen(m,S){throw new Error(`Event not found: ${S}`)}call(m,S,d){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(m){this.service=m}listen(m,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(m,S,d){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(m){this.service=m}listen(m,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(m,S,d){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class C{constructor(m){this.service=m}listen(m,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(m,S,d){switch(S){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class R extends k.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:n.URI.revive(m.url),type:m.type,defaultUrl:n.URI.revive(m.defaultUrl),insidersUrl:n.URI.revive(m.insidersUrl),stableUrl:n.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(ne[237],ie([0,1,13,9]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends n.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};T=de([K(0,n.ILoggerService),K(1,k.IEnvironmentService)],T),e.UserDataSyncLogService=T}),define(ne[66],ie([0,1,3,2,4,27,149,13,14,6,26,46,23,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",v="Safari",g="Chrome",h="Edge",y="Firefox",w="Android";function p(c){switch(c){case v:case g:case h:case y:case w:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=p;function u(){return T.isSafari?v:T.isChrome?g:T.isEdge?h:T.isFirefox?y:T.isAndroid?w:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let r=class Ze extends n.Disposable{constructor(i,t,s,o,a,l){super();this.storageService=s,this.userDataSyncStoreService=o,this.logService=a,this.productService=l,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(i,t,s)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,s=await this.readMachinesData(i);s.machines.some(({id:o})=>o===t)||(s.machines.push({id:t,name:this.computeCurrentMachineName(s.machines),platform:u()}),await this.writeMachinesData(s))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,s=await this.readMachinesData(i),o=s.machines.filter(({id:a})=>a!==t);o.length!==s.machines.length&&(s.machines=o,await this.writeMachinesData(s))}async renameMachine(i,t,s){const o=await this.readMachinesData(s),a=o.machines.find(({id:l})=>l===i);if(a){a.name=t,await this.writeMachinesData(o);const l=await this.currentMachineIdPromise;i===l&&this.storageService.store(d,t,0,1)}}async setEnablements(i){const t=await this.readMachinesData();for(const[s,o]of i){const a=t.machines.find(l=>l.id===s);a&&(a.disabled=o?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(i){const t=this.storageService.get(d,0);if(t)return t;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,o=new RegExp(`${(0,L.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const l of i){const f=o.exec(l.name),b=f?parseInt(f[1]):0;a=b>a?b:a}return`${s} #${a+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),s=await this.userDataSyncStoreService.write(Ze.RESOURCE,t,this.userData?.ref||null);this.userData={ref:s,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:Ze.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=de([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,m.IStorageService),K(3,S.IUserDataSyncStoreService),K(4,S.IUserDataSyncLogService),K(5,R.IProductService)],r),e.UserDataSyncMachinesService=r}),define(ne[238],ie([0,1,5,57,37,7,3,2,4,20,8,147,26,23,21,24,65,66]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const y="sync.disableMachineEventually",w="sync.sessionId",p="sync.storeUrl",u="sync.productQuality";let r=class extends P.Disposable{constructor(t,s,o,a,l,f,b,_,O,M){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=a,this.userDataSyncService=l,this.logService=f,this.userDataSyncAccountService=b,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=M,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(b.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(D=>this.triggerSync([D],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,D])=>D)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(p,0);return t?R.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),0,1):this.storageService.remove(p,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(t){t?this.storageService.store(u,t,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(w,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(s)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=v.UserDataSyncError.toUserDataSyncError(t);s instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(y,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(y,0,!1)}stopDisableMachineEventually(){this.storageService.remove(y,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};r=de([K(0,m.IProductService),K(1,v.IUserDataSyncStoreManagementService),K(2,v.IUserDataSyncStoreService),K(3,v.IUserDataSyncEnablementService),K(4,v.IUserDataSyncService),K(5,v.IUserDataSyncLogService),K(6,g.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,h.IUserDataSyncMachinesService),K(9,S.IStorageService)],r),e.UserDataAutoSyncService=r;class c extends P.Disposable{constructor(t,s,o,a,l,f,b,_){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=a,this.userDataSyncService=l,this.userDataSyncMachinesService=f,this.logService=b,this.storageService=_,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,L.isCancellationError)(l))return}return this.doSync(t,s,a)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,C.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,C.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,C.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const l=this.storageService.get(w,0);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const f=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const b=f.find(_=>_.isCurrent);if(b?.disabled)throw new v.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new v.UserDataAutoSyncError((0,T.toErrorMessage)(_),_ instanceof v.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(w,this.manifest.session,0,1),o.isCancellationRequested)return;b||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),a=l}this._onDidFinishSync.fire(a)}register(t){return super._register(t)}}c.INTERVAL_SYNCING="Interval"}),define(ne[239],ie([0,1,16,5,37,3,2,20,15,30,18,28,6,23,21,226,228,229,231,232,233,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let c=class extends A.Disposable{constructor(a,l,f,b,_,O,M,D){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=l,this.instantiationService=f,this.configurationService=b,this.logService=_,this.telemetryService=O,this.storageService=M,this.userDataSyncEnablementService=D,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(r,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,l){this.checkEnablement();const f=(0,C.generateUuid)();try{const D=(0,u.createSyncHeaders)(f);l&&(D["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,D)}catch(D){const F=u.UserDataSyncError.toUserDataSyncError(D);throw this.reportUserDataSyncError(F,f),F}let b=!1;const _=this,O=this.getEnabledSynchronizers();let M;return{manifest:a,async run(){if(b)throw new Error("Can run a task only once");return M=(0,n.createCancelablePromise)(D=>_.sync(O,a,f,D)),M.finally(()=>M=void 0)},async stop(){if(M&&M.cancel(),_.status!=="idle")return _.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,C.generateUuid)(),l=(0,u.createSyncHeaders)(a);let f;try{f=await this.userDataSyncStoreService.manifest(null,l)}catch(O){const M=u.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(M,a),M}await this.resetLocal();const b=this.getEnabledSynchronizers(),_=async()=>{await this.stop(b),await this.resetLocal()};return new i(a,f,l,b,_,this.configurationService,this.logService)}async sync(a,l,f,b){if(b.isCancellationRequested||!a.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,u.createSyncHeaders)(f);for(const M of a){if(b.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(M.resource))return;try{await M.sync(l,O)}catch(D){let F=!1;if(D instanceof u.UserDataSyncError)switch(D.code){case"TooLarge":D=new u.UserDataSyncError(D.message,D.code,M.resource),F=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":F=!0;break}const $=u.UserDataSyncError.toUserDataSyncError(D);if(this.reportUserDataSyncError($,f),F)throw $;this.logService.error(D),this.logService.error(`${M.resource}: ${(0,T.toErrorMessage)(D)}`),this._syncErrors.push([M.resource,$])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(O){const M=u.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(M,f),M}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const l of a)try{l.status!=="idle"&&await l.stop()}catch(f){this.logService.error(f)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(a))return!0})}async accept(a,l,f,b){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===a)return await _.accept(l,f),b&&await _.apply(!1,(0,u.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async l=>{const f=await l.resolveContent(a);if(f)return f})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async f=>{if(f.resource===a)return f.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async f=>{if(f.resource===a)return f.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,l){return await this.performSynchronizerAction(async b=>{if(b.resource===a)return b.getAssociatedResources(l)})||[]}async getMachineId(a,l){return await this.performSynchronizerAction(async b=>{if(b.resource===a)return await b.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(r,0),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(l){this.logService.error(`${a.resource}: ${(0,T.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const l=new A.DisposableStore;try{const f=this.synchronizers.value||l.add(this.instantiationService.createInstance(t,()=>{},()=>{},()=>{})),b=[...f.enabled,...f.disabled.map(_=>l.add(f.createSynchronizer(_)))];for(const _ of b){const O=await a(_);if(!(0,I.isUndefined)(O))return O}return null}finally{l.dispose()}}setStatus(a){const l=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const l=this.computeStatus(a);this.setStatus(l)}updateConflicts(a){const l=this.computeConflicts(a);(0,k.equals)(this._conflicts,l,([f,b],[_,O])=>f===f&&(0,k.equals)(b,O,(M,D)=>(0,P.isEqual)(M.previewResource,D.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(l))}computeConflicts(a){return a.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(s)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(l=>l.status==="hasConflicts")?"hasConflicts":a.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(r,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,l){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof u.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof u.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(t,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=de([K(0,u.IUserDataSyncStoreService),K(1,u.IUserDataSyncStoreManagementService),K(2,m.IInstantiationService),K(3,R.IConfigurationService),K(4,u.IUserDataSyncLogService),K(5,d.ITelemetryService),K(6,S.IStorageService),K(7,u.IUserDataSyncEnablementService)],c),e.UserDataSyncService=c;class i extends A.Disposable{constructor(a,l,f,b,_,O,M){super();this.id=a,this.manifest=l,this.syncHeaders=f,this.synchronisers=b,this.onStop=_,this.configurationService=O,this.logService=M,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,l){try{return await this.performAction(a,f=>f.accept(a,l))}catch(f){throw this.logService.error(f),f}}async merge(a){try{return a?await this.performAction(a,l=>l.merge(a)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(a){try{return await this.performAction(a,l=>l.discard(a))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,l]of this.previews)for(const f of l.resourcePreviews)f.mergeState==="conflict"&&a.push(f.previewResource);for(const l of a)await this.discard(l);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[l,f]of this.previews){this.synchronizingResources.push([l,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const b=this.synchronisers.find(O=>O.resource===l);for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await b.merge(O.previewResource);const _=await b.apply(!1,this.syncHeaders);_&&a.push(this.toSyncResourcePreview(b.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(b=>b.resource===a);for(const b of l.resourcePreviews)await f.accept(b.remoteResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(b=>b.resource===a);for(const b of l.resourcePreviews)await f.accept(b.localResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const f=this.previews.findIndex(([,q])=>q.resourcePreviews.some(({localResource:x,previewResource:G,remoteResource:B})=>(0,P.isEqual)(a,x)||(0,P.isEqual)(a,G)||(0,P.isEqual)(a,B)));if(f===-1)return this.previews;const[b,_]=this.previews[f],O=_.resourcePreviews.find(({localResource:q,remoteResource:x,previewResource:G})=>(0,P.isEqual)(q,a)||(0,P.isEqual)(x,a)||(0,P.isEqual)(G,a));if(!O)return this.previews;let M=this.synchronizingResources.find(q=>q[0]===b);M||(M=[b,[]],this.synchronizingResources.push(M)),M[1].some(q=>(0,P.isEqual)(q,O.localResource))||(M[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const D=this.synchronisers.find(q=>q.resource===this.previews[f][0]),F=await l(D);F?this.previews.splice(f,1,this.toSyncResourcePreview(D.resource,F)):this.previews.splice(f,1);const $=this.synchronizingResources.findIndex(q=>q[0]===b);return this.synchronizingResources[$][1].splice(M[1].findIndex(q=>(0,P.isEqual)(q,O.localResource)),1),M[1].length||(this.synchronizingResources.splice($,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[l,f]of this.previews){this.synchronizingResources.push([l,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const b=this.synchronisers.find(O=>O.resource===l);let _=f;for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(_=await b.merge(O.previewResource));_&&a.push(this.toSyncResourcePreview(b.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const l=[],f=await this.getUserDataSyncConfiguration();for(const b of this.synchronisers){if(a.isCancellationRequested)return[];const _=await b.preview(this.manifest,f,this.syncHeaders);_&&l.push(this.toSyncResourcePreview(b.resource,_))}return l}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(f=>f instanceof y.SettingsSynchroniser);if(l){const f=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...f}}return a}toSyncResourcePreview(a,l){return[a,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let t=class extends A.Disposable{constructor(a,l,f,b,_,O,M){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=l,this.onDidChangeLocal=f,this.userDataSyncEnablementService=b,this.instantiationService=_,this.extensionGalleryService=O,this.logService=M,this._enabled=[],this._register(b.onDidChangeResourceEnablement(([D,F])=>this.onDidChangeResourceEnablement(D,F))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,D])=>D.dispose())));for(const D of u.ALL_SYNC_RESOURCES)b.isResourceEnabled(D)&&this.registerSynchronizer(D)}get enabled(){return this._enabled.sort((a,l)=>a[1]-l[1]).map(([a])=>a)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,l){l?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([_])=>_.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,f=l.add(this.createSynchronizer(a));l.add(f.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(f.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(f.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const b=this.getOrder(a);this._enabled.push([f,b,l])}deRegisterSynchronizer(a){const l=this._enabled.findIndex(([f])=>f.resource===a);if(l!==-1){const f=this._enabled.splice(l,1);for(const[b,,_]of f){if(b.status!=="idle"){const O=b.conflicts.length>0;b.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(y.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(h.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(w.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(p.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(g.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(v.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};t=de([K(3,u.IUserDataSyncEnablementService),K(4,m.IInstantiationService),K(5,E.IExtensionGalleryService),K(6,u.IUserDataSyncLogService)],t);function s(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(ne[240],ie([0,1,3,2,15,8,24]),function(Y,e,k,n,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(E,m){this.service=E,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(E,m,S){try{return await this._call(E,m,S)}catch(d){throw this.logService.error(d),d}}async _call(E,m,S){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],L.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:L.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:L.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const d=m.substring("manualSync/".length),v=S[0],g=this.getManualSyncTask(v);switch(S=S.slice(1),d){case"preview":return g.preview();case"accept":return g.accept(L.URI.revive(S[0]),S[1]);case"merge":return g.merge(L.URI.revive(S[0]));case"discard":return g.discard(L.URI.revive(S[0]));case"discardConflicts":return g.discardConflicts();case"apply":return g.apply();case"pull":return g.pull();case"push":return g.push();case"stop":return g.stop();case"_getStatus":return g.status;case"dispose":return this.disposeManualSyncTask(g)}}throw new Error("Invalid call")}getManualSyncTask(E){const m=this.manualSyncTasks.get(this.createKey(E));if(!m)throw new Error(`Manual sync taks not found: ${E}`);return m.manualSyncTask}async createManualSyncTask(){const E=new n.DisposableStore,m=E.add(await this.service.createManualSyncTask());return E.add(m.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:S}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:E}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(E){E.dispose();const m=this.createKey(E.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=P;class I extends n.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,S,d){return E.call(m,S,d).then(null,v=>{throw A.UserDataSyncError.toUserDataSyncError(v)})},listen(m,S){return E.listen(m,S)}},this.channel.call("_getInitialData").then(([m,S,d])=>{this.updateStatus(m),this.updateConflicts(S),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(v=>this.updateStatus(v))),this._register(this.channel.listen("onDidChangeLastSyncTime")(v=>this.updateLastSyncTime(v)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([S,d])=>[S,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:m,status:S}=await this.channel.call("createManualSyncTask"),d=this,v=new C(E,m,S,{async call(g,h,y){return d.channel.call(`manualSync/${g}`,[E,...(0,T.isArray)(h)?h:[h]],y)},listen(g,h){return k.Event.map(k.Event.filter(d.channel.listen(`manualSync/${g}`,h),y=>!v.isDiposed()&&y.manualSyncTaskId===E),y=>y.data)}});return v}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,m,S,d){return this.channel.call("accept",[E,m,S,d])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:S,uri:d})=>({created:S,uri:L.URI.revive(d)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:S,uri:d})=>({created:S,uri:L.URI.revive(d)}))}async getAssociatedResources(E,m){return(await this.channel.call("getAssociatedResources",[E,m])).map(({resource:d,comparableResource:v})=>({resource:L.URI.revive(d),comparableResource:L.URI.revive(v)}))}async getMachineId(E,m){return this.channel.call("getMachineId",[E,m])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([m,S])=>[m,S.map(d=>({...d,localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=I;class C extends n.Disposable{constructor(E,m,S,d){super();this.id=E,this.manifest=m,this._disposed=!1,this._status=S;const v=this;this.channel={async call(g,h,y){try{const w=await d.call(g,h,y);return v.isDiposed()||(v._status=await d.call("_getStatus")),w}catch(w){throw A.UserDataSyncError.toUserDataSyncError(w)}},listen(g,h){return d.listen(g,h)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,m){const S=await this.channel.call("accept",[E,m]);return this.deserializePreviews(S)}async merge(E){const m=await this.channel.call("merge",[E]);return this.deserializePreviews(m)}async discard(E){const m=await this.channel.call("discard",[E]);return this.deserializePreviews(m)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([m,S])=>[m,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(d=>({...d,localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource),acceptedResource:L.URI.revive(d.acceptedResource)}))}])}}}),define(ne[241],ie([0,1,5,25,7,3,2,102,4,20,15,8,30,18,13,14,26,43,46,23,24]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",c="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends A.Disposable{constructor(O,M,D){super();this.productService=O,this.configurationService=M,this.storageService=D,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(D.onDidChangeValue,F=>F.key===p.SYNC_SERVICE_URL_TYPE&&F.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,O,0,I.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[p.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,M){O=I.isWeb&&O?.web?{...O,...O.web}:O;const D={...O||{},...M||{}};if(D&&(0,R.isString)(D.url)&&(0,R.isObject)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(F=>(0,R.isArray)(D.authenticationProviders[F].scopes))){const F=D,$=!!F.canSwitch&&!M?.url,q=F.url===F.insidersUrl?"insiders":"stable",x=($?this.userDataSyncStoreType:void 0)||q,G=M?.url||(x==="insiders"?F.insidersUrl:x==="stable"?F.stableUrl:F.url);return{url:E.URI.parse(G),type:x,defaultType:q,defaultUrl:E.URI.parse(F.url),stableUrl:E.URI.parse(F.stableUrl),insidersUrl:E.URI.parse(F.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(F.authenticationProviders).reduce((B,W)=>(B.push({id:W,scopes:F.authenticationProviders[W].scopes}),B),[])}}}};o=de([K(0,g.IProductService),K(1,S.IConfigurationService),K(2,w.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let a=class extends o{constructor(O,M,D){super(O,M,D);const F=this.storageService.get(u,0);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const $=this.productService[p.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(u,JSON.stringify($),0,1):this.storageService.remove(u,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=de([K(0,g.IProductService),K(1,S.IConfigurationService),K(2,w.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let l=class extends A.Disposable{constructor(O,M,D,F,$,q,x){super();this.requestService=D,this.logService=F,this.storageService=x,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,y.getServiceMachineId)($,q,x).then(G=>{const B={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(B["X-Client-Commit"]=M.commit),B}),this.session=new b(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,M){this.authToken={token:O,type:M}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,C.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(M=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O),D={},F=await this.request(M.toString(),{type:"GET",headers:D},[],n.CancellationToken.None);return(await(0,h.asJson)(F)||[]).map(({url:q,created:x})=>({ref:(0,C.relativePath)(M,M.with({path:q})),created:x*1e3}))}async resolveContent(O,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O,M).toString(),F={};F["Cache-Control"]="no-cache";const $=await this.request(D,{type:"GET",headers:F},[],n.CancellationToken.None);return await(0,h.asText)($)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),D={};await this.request(M,{type:"DELETE",headers:D},[],n.CancellationToken.None)}async read(O,M,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();D={...D},D["Cache-Control"]="no-cache",M&&(D["If-None-Match"]=M.ref);const $=await this.request(F,{type:"GET",headers:D},[304],n.CancellationToken.None);let q=null;if($.res.statusCode===304&&(q=M),q===null){const x=$.res.headers.etag;if(!x)throw new p.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,h.asText)($);if(!G&&$.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",F,"EmptyResponse",$.res.statusCode,$.res.headers[p.HEADER_OPERATION_ID]);q={ref:x,content:G}}return q}async write(O,M,D,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();F={...F},F["Content-Type"]=P.Mimes.text,D&&(F["If-Match"]=D);const q=await this.request($,{type:"POST",data:M,headers:F},[],n.CancellationToken.None),x=q.res.headers.etag;if(!x)throw new p.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",q.res.statusCode,q.res.headers[p.HEADER_OPERATION_ID]);return x}async manifest(O,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const F=await this.request(D,{type:"GET",headers:M},[304],n.CancellationToken.None);let $=null;if(F.res.statusCode===304&&($=O),!$){const x=F.res.headers.etag;if(!x)throw new p.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",F.res.statusCode,F.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,h.asText)(F);if(!G&&F.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",D,"EmptyResponse",F.res.statusCode,F.res.headers[p.HEADER_OPERATION_ID]);G&&($={...JSON.parse(G),ref:x})}const q=this.storageService.get(c,0);return q&&$&&q!==$.session&&this.clearSession(),$===null&&q&&this.clearSession(),$&&this.storageService.store(c,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:M},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(i,0)}async request(O,M,D,F){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;M.headers={...M.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let q;try{q=await this.session.request(O,M,F)}catch(W){if(!(W instanceof p.UserDataSyncStoreError)){let H="RequestFailed";const te=(0,T.getErrorMessage)(W).toLowerCase();te.includes("xhr timeout")?H="RequestTimeout":te.includes("protocol")&&te.includes("not supported")?H="RequestProtocolNotSupported":te.includes("request path contains unescaped characters")?H="RequestPathNotEscaped":te.includes("headers must be an object")?H="RequestHeadersNotObject":(0,T.isCancellationError)(W)&&(H="RequestCanceled"),W=new p.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,H,void 0,void 0)}throw this.logService.info("Request failed",O),W}const x=q.res.headers[p.HEADER_OPERATION_ID],G={url:O,status:q.res.statusCode,"execution-id":M.headers[p.HEADER_EXECUTION_ID],"operation-id":x},B=(0,h.isSuccess)(q)||q.res.statusCode&&D.indexOf(q.res.statusCode)!==-1;if(B?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new p.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",q.res.statusCode,x);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",q.res.statusCode,x);if(q.res.statusCode===410)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",q.res.statusCode,x);if(q.res.statusCode===412)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",q.res.statusCode,x);if(q.res.statusCode===413)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",q.res.statusCode,x);if(q.res.statusCode===426)throw new p.UserDataSyncStoreError(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",q.res.statusCode,x);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",q.res.statusCode,x)):new p.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",q.res.statusCode,x)}if(!B)throw new p.UserDataSyncStoreError("Server returned "+q.res.statusCode,O,"Unknown",q.res.statusCode,x);return q}addSessionHeaders(O){let M=this.storageService.get(i,0);M===void 0&&(M=(0,m.generateUuid)(),this.storageService.store(i,M,0,1)),O["X-Machine-Session-Id"]=M;const D=this.storageService.get(c,0);D!==void 0&&(O["X-User-Session-Id"]=D)}};l=de([K(1,g.IProductService),K(2,h.IRequestService),K(3,p.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,v.IFileService),K(6,w.IStorageService)],l),e.UserDataSyncStoreClient=l;let f=class extends l{constructor(O,M,D,F,$,q,x){super(O.userDataSyncStore?.url,M,D,F,$,q,x);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};f=de([K(0,p.IUserDataSyncStoreManagementService),K(1,g.IProductService),K(2,h.IRequestService),K(3,p.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,v.IFileService),K(6,w.IStorageService)],f),e.UserDataSyncStoreService=f;class b{constructor(O,M,D,F){this.limit=O,this.interval=M,this.requestService=D,this.logService=F,this.requests=[],this.startTime=void 0}request(O,M,D){if(this.isExpired()&&this.reset(),M.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(M,D)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(ne[242],ie([0,1,3,60,26,23,21,238,24,65,66]),function(Y,e,k,n,T,L,A,P,I,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends P.UserDataAutoSyncService{constructor(S,d,v,g,h,y,w,p,u,r,c){super(S,d,v,g,h,w,p,u,r,c);this._register(k.Event.debounce(k.Event.any(k.Event.map(y.onDidFocusWindow,()=>"windowFocus"),k.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};E=de([K(0,T.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,n.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,C.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,R.IUserDataSyncMachinesService),K(10,L.IStorageService)],E),e.UserDataAutoSyncService=E}),define(ne[243],ie([0,1,5,3,2]),function(Y,e,k,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends T.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:C}){super();this.disposables=this._register(new T.DisposableStore),n.Event.latch(n.Event.any(P,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>C()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[67],ie([0,1,50,5,10,15,22,125,256,257]),function(Y,e,k,n,T,L,A,P,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(r,c){let i=c.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=c}}e.ExtractError=R;function E(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(c=>r&c).reduce((c,i)=>c+i,r&61440)}function m(u){if(u instanceof R)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new R(r,u)}function S(u,r,c,i,t,s){const o=T.dirname(r),a=T.join(i,o);if(!a.startsWith(i))return Promise.reject(new Error(P.localize(0,null,r)));const l=T.join(i,r);let f;return s.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((b,_)=>{if(!s.isCancellationRequested)try{f=(0,k.createWriteStream)(l,{mode:c}),f.once("close",()=>b()),f.once("error",_),u.once("error",_),u.pipe(f)}catch(O){_(O)}}))}function d(u,r,c,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{t.cancel(),u.close()}),new Promise((o,a)=>{const l=new n.Sequencer,f=b=>{b.isCancellationRequested||(s++,u.readEntry())};u.once("error",a),u.once("close",()=>t.then(()=>{i.isCancellationRequested||u.entryCount===s?o():a(new R("Incomplete",new Error(P.localize(1,null,s,u.entryCount))))},a)),u.readEntry(),u.on("entry",b=>{if(i.isCancellationRequested)return;if(!c.sourcePathRegex.test(b.fileName)){f(i);return}const _=b.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const D=T.join(r,_);t=(0,n.createCancelablePromise)(F=>A.Promises.mkdir(D,{recursive:!0}).then(()=>f(F)).then(void 0,a));return}const O=g(u,b),M=E(b);t=(0,n.createCancelablePromise)(D=>l.queue(()=>O.then(F=>S(F,_,M,r,c,D).then(()=>f(D)))).then(null,a))})})}function v(u,r=!1){return new Promise((c,i)=>{(0,I.open)(u,r?{lazyEntries:!0}:void 0,(t,s)=>{t?i(m(t)):c((0,L.assertIsDefined)(s))})})}function g(u,r){return new Promise((c,i)=>{u.openReadStream(r,(t,s)=>{t?i(m(t)):c((0,L.assertIsDefined)(s))})})}function h(u,r){return new Promise((c,i)=>{const t=new C.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,k.createWriteStream)(u);t.outputStream.pipe(s),t.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>c(u))})}e.zip=h;function y(u,r,c={},i){const t=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let s=v(u,!0);return c.overwrite&&(s=s.then(o=>A.Promises.rm(r).then(()=>o))),s.then(o=>d(o,r,{sourcePathRegex:t},i))}e.extract=y;function w(u,r){return v(u).then(c=>new Promise((i,t)=>{c.on("entry",s=>{s.fileName===r&&g(c,s).then(o=>i(o),o=>t(o))}),c.once("close",()=>t(new Error(P.localize(2,null,r))))}))}function p(u,r){return w(u,r).then(c=>new Promise((i,t)=>{const s=[];c.once("error",t),c.on("data",o=>s.push(o)),c.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=p}),define(ne[244],ie([0,1,67,133]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(L){return(0,k.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=T}),define(ne[245],ie([0,1,16,5,7,2,19,10,4,20,62,8,30,22,67,134,13,28,31,155,61,14,9,26]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends L.Disposable{constructor(s,o,a,l,f,b){super();this.beforeRemovingExtension=s,this.targetPlatform=o,this.fileService=a,this.logService=l,this.environmentService=f,this.productService=b,this._devSystemExtensionsLocation=null,this.systemExtensionsLocation=E.URI.file(f.builtinExtensionsPath),this.userExtensionsLocation=E.URI.file(f.extensionsPath),this.uninstalledPath=(0,C.joinPath)(this.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const o=[];s===null||s===0?(o.push(this.scanDefaultSystemExtensions()),o.push(this.environmentService.isBuilt?Promise.resolve([]):this.scanDevSystemExtensions())):(o.push(Promise.resolve([])),o.push(Promise.resolve([]))),o.push(this.scanUserExtensions(!1));try{const[a,l,f]=await Promise.all(o),b=this.dedupExtensions([...a,...l,...f],await this.targetPlatform);return s!==null?b.filter(_=>_.type===s):b}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[o,a]=await Promise.all([this.getUninstalledExtensions(),this.scanFromUserExtensionsLocation()]);return a=a.filter(l=>!o[y.ExtensionKey.create(l).toString()]),a=s?this.dedupExtensions(a,await this.targetPlatform):a,this.logService.trace("Scanned user extensions:",a.length),a}async extractUserExtension(s,o,a,l){const f=s.toString(),b=P.join(this.userExtensionsLocation.fsPath,`.${(0,m.generateUuid)()}`),_=P.join(this.userExtensionsLocation.fsPath,f);try{await S.Promises.rm(_)}catch{throw new h.ExtensionManagementError((0,v.localize)(0,null,_,s.id),h.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(s,o,b,l);let O=await this.scanExtension(E.URI.file(b),1);if(!O)throw new Error((0,v.localize)(1,null,b));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(s,b,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(M){try{await S.Promises.rm(b)}catch{}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",s.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(M)}. Deleted from extracted location`,b),M}try{O=await this.scanExtension(E.URI.file(_),1)}catch{}if(O)return O;throw new Error((0,v.localize)(2,null,this.userExtensionsLocation.fsPath))}async saveMetadataForLocalExtension(s,o){return this.setMetadata(s,o),await this.storeMetadata(s,{...o,installedTimestamp:s.installedTimestamp}),s}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...s){const o=s.map(a=>y.ExtensionKey.create(a));await this.withUninstalledExtensions(a=>{o.forEach(l=>a[l.toString()]=!0)})}async setInstalled(s){await this.withUninstalledExtensions(l=>delete l[s.toString()]);const a=(await this.scanUserExtensions(!0)).find(l=>y.ExtensionKey.create(l).equals(s))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,a.type)):null}async removeExtension(s,o){this.logService.trace(`Deleting ${o} extension from disk`,s.identifier.id,s.location.fsPath),await S.Promises.rm(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[y.ExtensionKey.create(s).toString()])}async storeMetadata(s,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const a=P.join(s.location.fsPath,"package.json"),l=await S.Promises.readFile(a,"utf8"),{manifest:f}=await this.parseManifest(l);return f.__metadata=o,await S.Promises.writeFile(a,JSON.stringify(f,null,"	")),s}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(l){if(l.code!=="ENOENT")throw l}let a={};if(o)try{a=JSON.parse(o)}catch{}return s&&(s(a),Object.keys(a).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await S.Promises.rm(this.uninstalledPath)),a})}async extractAtLocation(s,o,a,l){this.logService.trace(`Started extracting the extension from ${o} to ${a}`);try{await S.Promises.rm(a)}catch(f){throw new h.ExtensionManagementError(this.joinErrors(f).message,h.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(o,a,{sourcePath:"extension",overwrite:!0},l),this.logService.info(`Extracted extension to ${a}:`,s.id)}catch(f){try{await S.Promises.rm(a)}catch{}let b=h.ExtensionManagementErrorCode.Extract;throw f instanceof d.ExtractError&&(f.type==="CorruptZip"?b=h.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(b=h.ExtensionManagementErrorCode.IncompleteZip)),new h.ExtensionManagementError(f.message,b)}}async rename(s,o,a,l){try{await S.Promises.rename(o,a)}catch(f){if(I.isWindows&&f&&f.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${o} to ${a} with 'EPERM' error. Trying again...`,s.id),this.rename(s,o,a,l);throw new h.ExtensionManagementError(f.message||(0,v.localize)(3,null,o,a),f.code||h.ExtensionManagementErrorCode.Rename)}}async scanExtensionsInLocation(s,o){const a=new n.Limiter(10),l=await this.fileService.resolve(s);return l.children?(await Promise.all(l.children.filter(b=>b.isDirectory).map(b=>a.queue(async()=>(0,C.isEqualOrParent)(b.resource,this.userExtensionsLocation)&&(0,C.basename)(b.resource).indexOf(".")===0?null:this.scanExtension(b.resource,o))))).filter(b=>b&&b.identifier):[]}async scanExtension(s,o){try{const a=await this.fileService.resolve(s);if(a.children){const{manifest:l,metadata:f}=await this.readManifest(s.fsPath),b=a.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,_=a.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource,O={id:(0,y.getGalleryExtensionId)(l.publisher,l.name)},M=f?.isSystem?0:o,D={type:M,identifier:O,manifest:l,location:s,readmeUrl:b,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:M===0};return this.setMetadata(D,f),D}}catch(a){o!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=await this.scanExtensionsInLocation(this.systemExtensionsLocation,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){this.logService.trace("Started scanning dev system extensions");const s=this.getDevSystemExtensionsList();if(s.length){const o=await this.scanExtensionsInLocation(this.devSystemExtensionsLocation,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(a=>s.some(l=>(0,y.areSameExtensions)(a.identifier,{id:l})))}else return[]}async scanFromUserExtensionsLocation(){return this.scanExtensionsInLocation(this.userExtensionsLocation,1)}dedupExtensions(s,o){const a=new Map;for(const l of s){const f=p.ExtensionIdentifier.toKey(l.identifier.id),b=a.get(f);if(b){if(R.gt(b.manifest.version,l.manifest.version)){this.logService.debug(`Skipping extension ${l.location.fsPath} with lower version ${l.manifest.version}.`);continue}if(R.eq(b.manifest.version,l.manifest.version)&&b.targetPlatform===o){this.logService.debug(`Skipping extension ${l.location.fsPath} from different target platform ${l.targetPlatform}`);continue}b.type===0?this.logService.debug(`Overwriting system extension ${b.location.fsPath} with ${l.location.fsPath}.`):this.logService.warn(`Overwriting user extension ${b.location.fsPath} with ${l.location.fsPath}.`)}a.set(f,l)}return[...a.values()]}setMetadata(s,o){s.publisherDisplayName=o?.publisherDisplayName||null,s.publisherId=o?.publisherId||null,s.identifier.uuid=o?.id,s.isMachineScoped=!!o?.isMachineScoped,s.isPreReleaseVersion=!!o?.isPreReleaseVersion,s.preRelease=!!o?.preRelease,s.isBuiltin=s.type===0||!!o?.isBuiltin,s.installedTimestamp=o?.installedTimestamp,s.targetPlatform=o?.targetPlatform??"undefined",s.updated=!!o?.updated}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),o=await this.scanFromUserExtensionsLocation(),a=new Set;for(const b of o)s[y.ExtensionKey.create(b).toString()]||a.add(b.identifier.id.toLowerCase());const l=(0,y.groupByExtension)(o,b=>b.identifier);await n.Promises.settled(l.map(async b=>{const _=b.sort((O,M)=>R.rcompare(O.manifest.version,M.manifest.version))[0];a.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(_)}));const f=o.filter(b=>s[y.ExtensionKey.create(b).toString()]);await n.Promises.settled(f.map(b=>this.removeUninstalledExtension(b)))}async removeOutdatedExtensions(){const s=await this.scanFromUserExtensionsLocation(),o=[],a=await this.targetPlatform,l=(0,y.groupByExtension)(s,f=>f.identifier);o.push(...(0,k.flatten)(l.map(f=>f.sort((b,_)=>{const O=R.rcompare(b.manifest.version,_.manifest.version);return O!==0?O:b.targetPlatform===a?-1:1}).slice(1)))),await n.Promises.settled(o.map(f=>this.removeExtension(f,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const o=Array.isArray(s)?s:[s];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((a,l)=>new Error(`${a.message}${a.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}get devSystemExtensionsLocation(){return this._devSystemExtensionsLocation||(this._devSystemExtensionsLocation=E.URI.file(P.normalize(P.join(A.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions")))),this._devSystemExtensionsLocation}async readManifest(s){const o=[S.Promises.readFile(P.join(s,"package.json"),"utf8").then(b=>this.parseManifest(b)),S.Promises.readFile(P.join(s,"package.nls.json"),"utf8").then(void 0,b=>b.code!=="ENOENT"?Promise.reject(b):"{}").then(b=>JSON.parse(b))],[{manifest:a,metadata:l},f]=await Promise.all(o);return{manifest:(0,w.localizeManifest)(a,f),metadata:l}}parseManifest(s){return new Promise((o,a)=>{try{const l=JSON.parse(s);l.publisher||(l.publisher=p.UNDEFINED_PUBLISHER);const f=l.__metadata||null;o({manifest:l,metadata:f})}catch{a(new Error((0,v.localize)(4,null)))}})}};i=de([K(2,u.IFileService),K(3,r.ILogService),K(4,g.INativeEnvironmentService),K(5,c.IProductService)],i),e.ExtensionsScanner=i}),define(ne[246],ie([0,1,37,7,19,10,4,20,62,15,8,30,22,67,132,82,13,205,28,31,187,173,244,188,245,220,79,14,6,9,26,21,32]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u,r,c,i,t,s,o,a,l,f,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends h.AbstractExtensionManagementService{constructor(x,G,B,W,H,te,V,Z,J){super(x,G,B,Z);this.environmentService=W,this.downloadService=H,this.fileService=V;const Q=this._register(te.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(te.createInstance(i.ExtensionsScanner,U=>Q.postUninstall(U),this.getTargetPlatform())),this.manifestCache=this._register(new c.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(te.createInstance(p.ExtensionsDownloader));const N=this._register(new t.ExtensionsWatcher(this,V,W,B,J));this._register(N.onDidChangeExtensionsByAnotherSource(({added:U,removed:z})=>{U.length&&this._onDidInstallExtensions.fire(U.map(j=>({identifier:j.identifier,operation:1,local:j}))),z.forEach(j=>this._onDidUninstallExtension.fire({identifier:j}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,w.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const G=await this.collectFiles(x),B=await(0,S.zip)((0,P.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,G);return R.URI.file(B)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const G=await this.downloadVsix(x),B=L.resolve(G.fsPath);return(0,r.getManifest)(B)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,G={}){this.logService.trace("ExtensionManagementService#install",x.toString());const B=await this.downloadVsix(x),W=await(0,r.getManifest)(L.resolve(B.fsPath));if(W.engines&&W.engines.vscode&&!(0,s.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,(0,w.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return this.installExtension(W,B,G)}async updateMetadata(x,G){this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id);const B={...x.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(B.preRelease=!0),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,B),this.manifestCache.invalidate(),x}async updateExtensionScope(x,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===T.Schemas.file)return x;const G=(0,P.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(x,G),G}createInstallExtensionTask(x,G,B){return R.URI.isUri(G)?new F(x,G,B,this.galleryService,this.extensionsScanner,this.logService):new D(G,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,G){return new $(x,G,this.extensionsScanner)}async collectFiles(x){const G=async W=>{let H=await m.Promises.readdir(W);H=H.map(Z=>L.join(W,Z));const te=await Promise.all(H.map(Z=>m.Promises.stat(Z)));let V=Promise.resolve([]);return te.forEach((Z,J)=>{const Q=H[J];Z.isFile()&&(V=V.then(N=>[...N,Q])),Z.isDirectory()&&(V=V.then(N=>G(Q).then(U=>[...N,...U])))}),V};return(await G(x.location.fsPath)).map(W=>({path:`extension/${L.relative(x.location.fsPath,W)}`,localPath:W}))}};O=de([K(0,y.IExtensionGalleryService),K(1,b.ITelemetryService),K(2,l.ILogService),K(3,g.INativeEnvironmentService),K(4,v.IDownloadService),K(5,a.IInstantiationService),K(6,o.IFileService),K(7,f.IProductService),K(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class M extends h.AbstractExtensionTask{constructor(x,G,B,W,H){super();this.identifier=x,this.source=G,this.options=B,this.extensionsScanner=W,this.logService=H,this._operation=2}get operation(){return(0,C.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(x,G){try{const B=await this.unsetUninstalledAndGetLocal(x.key);if(B)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...x.metadata}):B}catch{throw A.isMacintosh?new y.ExtensionManagementError(d.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(d.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(x,G)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const B=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),B}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.toString()]}async extract({zipPath:x,key:G,metadata:B},W){let H=await this.extensionsScanner.extractUserExtension(G,x,B,W);return this.logService.info("Extracting completed.",G.id),H}}class D extends M{constructor(x,G,B,W,H){super(x.identifier,x,G,W,H);this.gallery=x,this.extensionsDownloader=B}async doRun(x){const B=(await this.extensionsScanner.scanExtensions(null)).find(H=>(0,w.areSameExtensions)(H.identifier,this.gallery.identifier));B&&(this._operation=3);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin,W.metadata.isSystem=B?.type===0?!0:void 0,W.metadata.updated=!!B,W.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,W.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:B?.preRelease);try{const H=await this.installExtension(W,x);return B&&(B.targetPlatform!==H.targetPlatform||I.neq(B.manifest.version,H.manifest.version))&&await this.extensionsScanner.setUninstalled(B),H}catch(H){throw await this.deleteDownloadedVSIX(W.zipPath),H}}async deleteDownloadedVSIX(x){try{await this.extensionsDownloader.delete(R.URI.file(x))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",x.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(x,G){const B={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName,targetPlatform:x.properties.targetPlatform};let W;try{this.logService.trace("Started downloading extension:",x.identifier.id),W=(await this.extensionsDownloader.downloadExtension(x,G)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,W)}catch(H){throw new y.ExtensionManagementError((0,h.joinErrors)(H).message,y.ExtensionManagementErrorCode.Download)}try{return await(0,r.getManifest)(W),{zipPath:W,key:w.ExtensionKey.create(x),metadata:B}}catch(H){throw await this.deleteDownloadedVSIX(W),new y.ExtensionManagementError((0,h.joinErrors)(H).message,y.ExtensionManagementErrorCode.Invalid)}}}class F extends M{constructor(x,G,B,W,H,te){super({id:(0,w.getGalleryExtensionId)(x.publisher,x.name)},G,B,H,te);this.manifest=x,this.location=G,this.galleryService=W}async doRun(x){const G=new w.ExtensionKey(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(te=>(0,w.areSameExtensions)(this.identifier,te.identifier)),H=await this.getMetadata(this.identifier.id,this.manifest.version,x);if(H.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,H.isBuiltin=this.options.isBuiltin||W?.isBuiltin,W)if(this._operation=3,G.equals(new w.ExtensionKey(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const te=await this.unsetUninstalledAndGetLocal(G);if(te)try{await this.extensionsScanner.removeExtension(te,"existing")}catch{throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),key:G,metadata:H},x)}async getMetadata(x,G,B){try{let[W]=await this.galleryService.getExtensions([{id:x,version:G}],B);if(W||([W]=await this.galleryService.getExtensions([{id:x}],B)),W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class $ extends h.AbstractExtensionTask{constructor(x,G,B){super();this.extension=x,this.options=G,this.extensionsScanner=B}async doRun(x){const G=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=w.ExtensionKey.create(this.extension);G.push(...B.filter(H=>W.equals(w.ExtensionKey.create(H))))}else G.push(...B.filter(W=>(0,w.areSameExtensions)(W.identifier,this.extension.identifier)));if(!G.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const W of G)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(H){throw new Error(d.localize(6,null,(0,k.toErrorMessage)(H)))}}}}),define(ne[247],ie([0,1,84,56,34,17,7,3,2,10,4,30,36,74,258]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(b,_=""){this.debugLabel=_,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(b,_){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(b){const _=O=>{this.traceSocketEvent("read",O),b(L.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(b){const _=O=>{this.traceSocketEvent("close",{hadError:O}),b({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(b){const _=()=>{this.traceSocketEvent("nodeEndReceived"),b()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(b){if(!this.socket.destroyed)try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=v;var g;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var h;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(h||(h={}));class y extends I.Disposable{constructor(b,_,O,M){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new w(this,_,O,M,this._onData,(D,F)=>this._write(D,F))),this._register(this._flowManager.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,_){this.socket.traceSocketEvent(b,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._flowManager.writeMessage(b)}_write(b,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let O=2;b.byteLength<126?O+=0:b.byteLength<2**16?O+=2:O+=8;const M=L.VSBuffer.alloc(O);if(_?M.writeUInt8(194,0):M.writeUInt8(130,0),b.byteLength<126)M.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){M.writeUInt8(126,1);let D=1;M.writeUInt8(b.byteLength>>>8&255,++D),M.writeUInt8(b.byteLength>>>0&255,++D)}else{M.writeUInt8(127,1);let D=1;M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(b.byteLength>>>24&255,++D),M.writeUInt8(b.byteLength>>>16&255,++D),M.writeUInt8(b.byteLength>>>8&255,++D),M.writeUInt8(b.byteLength>>>0&255,++D)}this.socket.write(L.VSBuffer.concat([M,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),M=(O&128)>>>7,D=(O&64)>>>6,F=_.readUInt8(1),$=(F&128)>>>7,q=F&127;this._state.state=2,this._state.readLen=2+($?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),M=(O&128)>>>7;let D=O&127,F=1;D===126?D=_.readUInt8(++F)*2**8+_.readUInt8(++F):D===127&&(D=_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*0+_.readUInt8(++F)*2**24+_.readUInt8(++F)*2**16+_.readUInt8(++F)*2**8+_.readUInt8(++F));let $=0;M&&($=_.readUInt8(++F)*2**24+_.readUInt8(++F)*2**16+_.readUInt8(++F)*2**8+_.readUInt8(++F)),this._state.state=3,this._state.readLen=D,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class w extends I.Disposable{constructor(b,_,O,M,D,F){super();this._tracer=b,this._onData=D,this._writeFn=F,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new p(this._tracer,M,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(_,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,_){return new Promise((O,M)=>{b.write(_),b.flush(D=>O(D))})}acceptFrame(b,_,O){this._readQueue.push({data:b,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1}}_inflateFrame(b,_,O){return new Promise((M,D)=>{b.write(_),O&&b.write(L.VSBuffer.fromByteArray([0,0,255,255])),b.flush(F=>M(F))})}}class p extends I.Disposable{constructor(b,_,O,M){super();this._tracer=b,this._recordInflateBytes=_,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(M),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(L.VSBuffer.wrap(D))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(_)})}}class u extends I.Disposable{constructor(b,_){super();this._tracer=b,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(L.VSBuffer.wrap(O))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),b(_)})}}function r(f,b){if(b===0)return;let _=f.byteLength>>>2;for(let q=0;q<_;q++){const x=f.readUInt32BE(q*4);f.writeUInt32BE(x^b,q*4)}let O=_*4,M=f.byteLength-O;const D=b>>>24&255,F=b>>>16&255,$=b>>>8&255;M>=1&&f.writeUInt8(f.readUInt8(O)^D,O),M>=2&&f.writeUInt8(f.readUInt8(O+1)^F,O+1),M>=3&&f.writeUInt8(f.readUInt8(O+2)^$,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function i(){const f=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):b=(0,C.join)((0,T.tmpdir)(),`vscode-ipc-${f}.sock`),s(b),b}e.createRandomIPCHandle=i;function t(f,b,_){const O=(0,k.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${b}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${b}.sock`):M=(0,C.join)(f,`${_}-${b}.sock`),s(M),M}e.createStaticIPCHandle=t;function s(f){const b=c[R.platform];typeof b=="number"&&f.length>=b&&console.warn(`WARNING: IPC handle "${f}" is longer than ${b} chars, try a shorter --user-data-dir`)}class o extends m.IPCServer{constructor(b){super(o.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const _=P.Event.fromNodeEventEmitter(b,"connection");return P.Event.map(_,O=>({protocol:new S.Protocol(new v(O,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function a(f){return new Promise((b,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(f,()=>{O.removeListener("error",_),b(new o(O))})})}e.serve=a;function l(f,b){return new Promise((_,O)=>{const M=(0,n.createConnection)(f,()=>{M.removeListener("error",O),_(S.Client.fromSocket(new v(M,`ipc-client${b}`),b))});M.once("error",O)})}e.connect=l}),define(ne[248],ie([0,1,56,247]),function(Y,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(T,L,A,P,I){const C=E=>I(E,void 0),R=k.createConnection({host:T,port:L},()=>{R.removeListener("error",C);const E=Buffer.alloc(16);for(let v=0;v<16;v++)E[v]=Math.round(Math.random()*256);const m=E.toString("base64"),S=[`GET ws://${/:/.test(T)?`[${T}]`:T}:${L}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];R.write(S.join(`\r
`)+`\r
\r
`);const d=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(R.off("data",d),I(void 0,new n.NodeSocket(R,P)))};R.on("data",d)});R.setNoDelay(!0),R.once("error",C)}}}),define(ne[249],ie([0,1,56,115,248,5,2,18,9,26,184,64,92]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(y,w,p,u,r){let c;for(let i=3;i&&(c&&c.dispose(),c=await new d(y,w,p,u,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));i--);return c}class d extends A.Disposable{constructor(w,p,u,r,c){super();this.defaultTunnelHost=p,this.suggestedLocalPort=c,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=k.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let w=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(w=0,this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(w){w.pause();const p=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,R.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),r=u.getSocket().socket,c=u.readEntireBuffer();u.dispose(),c.byteLength>0&&w.write(c.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),r.end()}),w.on("close",()=>r.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),r.destroy()}),r.on("end",()=>w.end()),r.on("close",()=>w.end()),r.on("error",()=>{w.destroy()}),w.pipe(r),r.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),r.end()})}}let v=class extends E.AbstractTunnelService{constructor(w,p,u,r,c){super(p);this.socketFactory=w,this.signService=u,this.productService=r,this.configurationService=c}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(w,p,u,r,c,i,t){const s=this.getTunnelFromMap(p,u);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,u,r,c,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${u} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},a=S(o,this.defaultTunnelHost,p,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,u,a),a}}};v=de([K(1,I.ILogService),K(2,m.ISignService),K(3,C.IProductService),K(4,P.IConfigurationService)],v),e.BaseTunnelService=v;let g=class extends v{constructor(w,p,u,r){super(T.nodeSocketFactory,w,p,u,r)}};g=de([K(0,I.ILogService),K(1,m.ISignService),K(2,C.IProductService),K(3,P.IConfigurationService)],g),e.TunnelService=g;let h=class extends A.Disposable{constructor(w,p,u,r){super();this.logService=w,this.productService=p,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(w,p,u,r,c,i,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${c}.`),!this._tunnelServices.has(w)){const o=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(w,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(p,u,r,c,i,t,s)}};h=de([K(0,I.ILogService),K(1,C.IProductService),K(2,m.ISignService),K(3,P.IConfigurationService)],h),e.SharedTunnelsService=h}),define(ne[259],ie([0,1,75,34,37,7,2,19,20,8,36,118,178,200,179,170,171,172,158,161,18,182,81,204,82,192,13,196,199,208,28,160,206,246,83,156,14,175,177,51,6,167,86,168,169,59,189,9,87,60,88,26,191,43,23,202,203,21,93,94,95,47,209,210,96,212,218,63,98,24,65,234,236,237,66,235,239,240,241,242,243,92,198,64,249,190,219,91,195,32,221,4,222,162,181,180]),function(Y,e,k,n,T,L,A,P,I,C,R,E,m,S,d,v,g,h,y,w,p,u,r,c,i,t,s,o,a,l,f,b,_,O,M,D,F,$,q,x,G,B,W,H,te,V,Z,J,Q,N,U,z,j,ee,se,le,he,Se,we,ge,pe,Te,Ce,De,qe,Je,Ve,je,re,ae,ue,Ee,be,Me,Le,Oe,_e,X,oe,ce,fe,me,ke,ye,Pe,Re,Ie,Ae,Fe,ze,We,Et,bt,gt,Ct,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class It extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",$e=(He,Ne)=>this.onDisposeWorker(Ne);k.ipcRenderer.on(Ue,$e),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,$e)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Ue=>{const $e=Ue.get(J.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(ve.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(d.LanguagePackCachedDataCleaner),ve.createInstance(h.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(g.LogsDataCleaner),ve.createInstance(v.LocalizationsUpdater),ve.createInstance(S.ExtensionsCleaner)))}async initServices(){const ve=new W.ServiceCollection,Ue={_serviceBrand:void 0,...U.default};ve.set(z.IProductService,Ue);const $e=new R.StaticRouter(Be=>Be==="main"),He=new H.MessagePortMainProcessService(this.server,$e);ve.set(te.IMainProcessService,He);const Ne=new o.SharedProcessEnvironmentService(this.configuration.args,Ue);ve.set(s.INativeEnvironmentService,Ne);const it=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Qe=new Q.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,He.getChannel("logger"));ve.set(J.ILoggerService,Qe);const st=this._register(new J.MultiplexLogService([this._register(new J.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,I.joinPath)(C.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new Q.FollowerLogService(it,st));ve.set(J.ILogService,Ge),this.sharedProcessWorkerService=new Fe.SharedProcessWorkerService(Ge),ve.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ke=this._register(new $.FileService(Ge));ve.set(F.IFileService,Ke);const ot=this._register(new q.DiskFileSystemProvider(Ge));Ke.registerProvider(P.Schemas.file,ot);const at=this._register(new bt.FileUserDataProvider(P.Schemas.file,this._register(new gt.DiskFileSystemProviderClient(He.getChannel(gt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Et.isLinux})),P.Schemas.vscodeUserData,Ge));Ke.registerProvider(P.Schemas.vscodeUserData,at);const Ye=this._register(new u.ConfigurationService(Ne.settingsResource,Ke));ve.set(p.IConfigurationService,Ye);const et=new le.NativeStorageService(void 0,He,Ne);ve.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]),ve.set(ze.IUriIdentityService,new We.UriIdentityService(Ke)),ve.set(ee.IRequestService,new x.SyncDescriptor(j.RequestService)),ve.set(y.IChecksumService,new x.SyncDescriptor(w.ChecksumService)),ve.set(mt.IV8InspectProfilingService,new x.SyncDescriptor(Ct.InspectProfilingService));const rt=R.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(N.INativeHostService,rt),ve.set(i.IDownloadService,new x.SyncDescriptor(t.DownloadService));const ct=this._register(new fe.ActiveWindowManager(rt)),lt=new R.StaticRouter(Be=>ct.getActiveClientId().then(ut=>Be===ut));ve.set(M.IExtensionRecommendationNotificationService,new D.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Xe;const tt=[];if((0,Te.supportsTelemetry)(Ue,Ne)){const Be=new ge.TelemetryLogAppender(Qe,Ne);tt.push(Be);const{installSourcePath:ut}=Ne;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const St=new Ce.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>St.flush())),tt.push(St)}Xe=new pe.TelemetryService({appenders:tt,commonProperties:(0,he.resolveCommonProperties)(Ke,(0,n.release)(),(0,n.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,ut),sendErrorTelemetry:!0,piiPaths:(0,Te.getPiiPathsFromEnvironment)(Ne)},Ye,Ue)}else{Xe=Te.NullTelemetryService;const Be=Te.NullAppender;tt.push(Be)}this.server.registerChannel("telemetryAppender",new we.TelemetryAppenderChannel(tt)),ve.set(Se.ITelemetryService,Xe);const Rt=new De.CustomEndpointTelemetryService(Ye,Xe,Qe,Ne,Ue);ve.set(Se.ICustomEndpointTelemetryService,Rt),ve.set(f.IExtensionManagementService,new x.SyncDescriptor(O.ExtensionManagementService)),ve.set(f.IExtensionGalleryService,new x.SyncDescriptor(l.ExtensionGalleryService)),ve.set(f.IExtensionTipsService,new x.SyncDescriptor(_.ExtensionTipsService)),ve.set(V.ILocalizationsService,new x.SyncDescriptor(Z.LocalizationsService)),ve.set(r.IDiagnosticsService,new x.SyncDescriptor(c.DiagnosticsService)),ve.set(ue.IUserDataSyncAccountService,new x.SyncDescriptor(ue.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new x.SyncDescriptor(Me.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(f.IGlobalExtensionEnablementService,new x.SyncDescriptor(a.GlobalExtensionEnablementService)),ve.set(re.IIgnoredExtensionsManagementService,new x.SyncDescriptor(re.IgnoredExtensionsManagementService)),ve.set(je.IExtensionStorageService,new x.SyncDescriptor(je.ExtensionStorageService)),ve.set(ae.IUserDataSyncStoreManagementService,new x.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new x.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(Le.IUserDataSyncMachinesService,new x.SyncDescriptor(Le.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new x.SyncDescriptor(Ee.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataSyncEnablementService,new x.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ae.IUserDataSyncService,new x.SyncDescriptor(_e.UserDataSyncService));const pt=new Ve.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,Ne,Ge);return await pt.initialize(),ve.set(Je.ILocalPtyService,this._register(pt)),ve.set(me.ISignService,new x.SyncDescriptor(ke.SignService)),ve.set(ye.ISharedTunnelsService,new x.SyncDescriptor(Pe.SharedTunnelsService)),ve.set(Re.ISharedProcessTunnelService,new x.SyncDescriptor(Ie.SharedProcessTunnelService)),new B.InstantiationService(ve)}initChannels(ve){const Ue=new b.ExtensionManagementChannel(ve.get(f.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const $e=R.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",$e);const He=R.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const Ne=new b.ExtensionTipsChannel(ve.get(f.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const it=R.ProxyChannel.fromService(ve.get(y.IChecksumService));this.server.registerChannel("checksum",it);const Qe=R.ProxyChannel.fromService(ve.get(mt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Qe);const st=new be.UserDataSyncMachinesServiceChannel(ve.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",st);const Ge=R.ProxyChannel.fromService(ve.get(Se.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Ke=new be.UserDataSyncAccountServiceChannel(ve.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const ot=new be.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ot);const at=new X.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(J.ILogService));this.server.registerChannel("userDataSync",at);const Ye=this._register(ve.get(G.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),et=new be.UserDataAutoSyncChannel(Ye);this.server.registerChannel("userDataAutoSync",et);const rt=ve.get(Je.ILocalPtyService),ct=R.ProxyChannel.fromService(rt);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,ct);const lt=R.ProxyChannel.fromService(ve.get(Re.ISharedProcessTunnelService));this.server.registerChannel(Re.ipcSharedProcessTunnelChannelName,lt);const Xe=R.ProxyChannel.fromService(ve.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,L.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Ue=>{const $e=(0,T.toErrorMessage)(Ue,!0);!$e||ve.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Pt(vt){const ve=new It(vt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Pt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
