/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/event","vs/base/common/types","vs/base/common/uri","vs/base/common/path","vs/base/common/platform","vs/base/common/network","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","os","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var i=[],L=0,R=x.length;L<R;L++)i[L]=Y[x[L]];return i};define(Y[55],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function L(R,P){if(!R)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=L}),define(Y[44],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function L(O){return(b,c,g)=>{let C=null,D=null;if(typeof g.value=="function"?(C="value",D=g.value):typeof g.get=="function"&&(C="get",D=g.get),!D)throw new Error("not supported");g[C]=O(D,c)}}i.createDecorator=L;function R(O,b,c){let g=null,C=null;if(typeof c.value=="function"?(g="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",C=c.get),!C)throw new Error("not supported");const D=`$memoize$${b}`;c[g]=function(...v){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[D]}}i.memoize=R;function P(O,b,c){return L((g,C)=>{const D=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...w){this[v]||(this[v]=c?c():void 0),clearTimeout(this[D]),b&&(this[v]=b(this[v],...w),w=[this[v]]),this[D]=setTimeout(()=>{g.apply(this,w),this[v]=c?c():void 0},O)}})}i.debounce=P;function I(O,b,c){return L((g,C)=>{const D=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,w=`$throttle$lastRun$${C}`,E=`$throttle$pending$${C}`;return function(...m){if(this[v]||(this[v]=c?c():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),b&&(this[v]=b(this[v],...m)),this[E])return;const p=this[w]+O;p<=Date.now()?(this[w]=Date.now(),g.apply(this,[this[v]]),this[v]=c?c():void 0):(this[E]=!0,this[D]=setTimeout(()=>{this[E]=!1,this[w]=Date.now(),g.apply(this,[this[v]]),this[v]=c?c():void 0},p-Date.now()))}})}i.throttle=I}),define(Y[56],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L=i.ScanError||(i.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=i.ParseOptions||(i.ParseOptions={}));function O(t,r=!1){let e=0,n=t.length,s="",l=0,u=16,f=0;function d(ne){let fe=0,B=0;for(;fe<ne;){const _=t.charCodeAt(e);if(_>=48&&_<=57)B=B*16+_-48;else if(_>=65&&_<=70)B=B*16+_-65+10;else if(_>=97&&_<=102)B=B*16+_-97+10;else break;e++,fe++}return fe<ne&&(B=-1),B}function T(ne){e=ne,s="",l=0,u=16,f=0}function M(){const ne=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&g(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&g(t.charCodeAt(e)))for(e++;e<t.length&&g(t.charCodeAt(e));)e++;else return f=3,t.substring(ne,e);let fe=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&g(t.charCodeAt(e))){for(e++;e<t.length&&g(t.charCodeAt(e));)e++;fe=e}else f=3;return t.substring(ne,fe)}function H(){let ne="",fe=e;for(;;){if(e>=n){ne+=t.substring(fe,e),f=2;break}const B=t.charCodeAt(e);if(B===34){ne+=t.substring(fe,e),e++;break}if(B===92){if(ne+=t.substring(fe,e),e++,e>=n){f=2;break}switch(t.charCodeAt(e++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const re=d(4);re>=0?ne+=String.fromCharCode(re):f=4;break}default:f=5}fe=e;continue}if(B>=0&&B<=31)if(c(B)){ne+=t.substring(fe,e),f=2;break}else f=6;e++}return ne}function X(){if(s="",f=0,l=e,e>=n)return l=n,u=17;let ne=t.charCodeAt(e);if(b(ne)){do e++,s+=String.fromCharCode(ne),ne=t.charCodeAt(e);while(b(ne));return u=15}if(c(ne))return e++,s+=String.fromCharCode(ne),ne===13&&t.charCodeAt(e)===10&&(e++,s+=`
`),u=14;switch(ne){case 123:return e++,u=1;case 125:return e++,u=2;case 91:return e++,u=3;case 93:return e++,u=4;case 58:return e++,u=6;case 44:return e++,u=5;case 34:return e++,s=H(),u=10;case 47:{const fe=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!c(t.charCodeAt(e));)e++;return s=t.substring(fe,e),u=12}if(t.charCodeAt(e+1)===42){e+=2;const B=n-1;let _=!1;for(;e<B;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,_=!0;break}e++}return _||(e++,f=1),s=t.substring(fe,e),u=13}return s+=String.fromCharCode(ne),e++,u=16}case 45:if(s+=String.fromCharCode(ne),e++,e===n||!g(t.charCodeAt(e)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=M(),u=11;default:for(;e<n&&ee(ne);)e++,ne=t.charCodeAt(e);if(l!==e){switch(s=t.substring(l,e),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ne),e++,u=16}}function ee(ne){if(b(ne)||c(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=X();while(ne>=12&&ne<=15);return ne}return{setPosition:T,getPosition:()=>e,scan:r?ie:X,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>e-l,getTokenError:()=>f}}i.createScanner=O;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function c(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function D(t,r){const e=[],n=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(d,T,M,H){l.value=d,l.offset=T,l.length=M,l.type=H,l.colonOffset=void 0,s=l}try{y(t,{onObjectBegin:(d,T)=>{if(r<=d)throw n;s=void 0,u=r>d,e.push("")},onObjectProperty:(d,T,M)=>{if(r<T||(f(d,T,M,"property"),e[e.length-1]=d,r<=T+M))throw n},onObjectEnd:(d,T)=>{if(r<=d)throw n;s=void 0,e.pop()},onArrayBegin:(d,T)=>{if(r<=d)throw n;s=void 0,e.push(0)},onArrayEnd:(d,T)=>{if(r<=d)throw n;s=void 0,e.pop()},onLiteralValue:(d,T,M)=>{if(r<T||(f(d,T,M,o(d)),r<=T+M))throw n},onSeparator:(d,T,M)=>{if(r<=T)throw n;if(d===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(d===","){const H=e[e.length-1];typeof H=="number"?e[e.length-1]=H+1:(u=!0,e[e.length-1]=""),s=void 0}}})}catch(d){if(d!==n)throw d}return{path:e,previousNode:s,isAtPropertyKey:u,matches:d=>{let T=0;for(let M=0;T<d.length&&M<e.length;M++)if(d[T]===e[M]||d[T]==="*")T++;else if(d[T]!=="**")return!1;return T===d.length}}}i.getLocation=D;function v(t,r=[],e=I.DEFAULT){let n=null,s=[];const l=[];function u(d){Array.isArray(s)?s.push(d):n!==null&&(s[n]=d)}return y(t,{onObjectBegin:()=>{const d={};u(d),l.push(s),s=d,n=null},onObjectProperty:d=>{n=d},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const d=[];u(d),l.push(s),s=d,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:u,onError:(d,T,M)=>{r.push({error:d,offset:T,length:M})}},e),s[0]}i.parse=v;function w(t,r=[],e=I.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(d){n.type==="property"&&(n.length=d-n.offset,n=n.parent)}function l(d){return n.children.push(d),d}y(t,{onObjectBegin:d=>{n=l({type:"object",offset:d,length:-1,parent:n,children:[]})},onObjectProperty:(d,T,M)=>{n=l({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:d,offset:T,length:M,parent:n})},onObjectEnd:(d,T)=>{n.length=d+T-n.offset,n=n.parent,s(d+T)},onArrayBegin:(d,T)=>{n=l({type:"array",offset:d,length:-1,parent:n,children:[]})},onArrayEnd:(d,T)=>{n.length=d+T-n.offset,n=n.parent,s(d+T)},onLiteralValue:(d,T,M)=>{l({type:o(d),offset:T,length:M,parent:n,value:d}),s(T+M)},onSeparator:(d,T,M)=>{n.type==="property"&&(d===":"?n.colonOffset=T:d===","&&s(T))},onError:(d,T,M)=>{r.push({error:d,offset:T,length:M})}},e);const f=n.children[0];return f&&delete f.parent,f}i.parseTree=w;function E(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const l of e.children)if(Array.isArray(l.children)&&l.children[0].value===n){e=l.children[1],s=!0;break}if(!s)return}else{const s=n;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}i.findNodeAtLocation=E;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=m;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=p(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=p;function a(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=a;function h(t,r,e=!1){if(a(t,r,e)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const l=h(n[s],r,e);if(l)return l}return t}}i.findNodeAtOffset=h;function y(t,r,e=I.DEFAULT){const n=O(t,!1);function s(J){return J?()=>J(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(J){return J?Z=>J(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),f=l(r.onObjectProperty),d=s(r.onObjectEnd),T=s(r.onArrayBegin),M=s(r.onArrayEnd),H=l(r.onLiteralValue),X=l(r.onSeparator),ee=s(r.onComment),ie=l(r.onError),ne=e&&e.disallowComments,fe=e&&e.allowTrailingComma;function B(){for(;;){const J=n.scan();switch(n.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:ne||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(J){case 12:case 13:ne?_(10):ee();break;case 16:_(1);break;case 15:case 14:break;default:return J}}}function _(J,Z=[],k=[]){if(ie(J),Z.length+k.length>0){let A=n.getToken();for(;A!==17;){if(Z.indexOf(A)!==-1){B();break}else if(k.indexOf(A)!==-1)break;A=B()}}}function re(J){const Z=n.getTokenValue();return J?H(Z):f(Z),B(),!0}function U(){switch(n.getToken()){case 11:{let J=0;try{J=JSON.parse(n.getTokenValue()),typeof J!="number"&&(_(2),J=0)}catch{_(2)}H(J);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return B(),!0}function N(){return n.getToken()!==10?(_(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(X(":"),B(),te()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function W(){u(),B();let J=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(J||_(4,[],[]),X(","),B(),n.getToken()===2&&fe)break}else J&&_(6,[],[]);N()||_(4,[],[2,5]),J=!0}return d(),n.getToken()!==2?_(7,[2],[]):B(),!0}function K(){T(),B();let J=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(J||_(4,[],[]),X(","),B(),n.getToken()===4&&fe)break}else J&&_(6,[],[]);te()||_(4,[],[4,5]),J=!0}return M(),n.getToken()!==4?_(8,[4],[]):B(),!0}function te(){switch(n.getToken()){case 3:return K();case 1:return W();case 10:return re(!0);default:return U()}}return B(),n.getToken()===17?e.allowEmptyContent?!0:(_(4,[],[]),!1):te()?(n.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}i.visit=y;function S(t,r){let e=O(t),n=[],s,l=0,u;do switch(u=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:l!==u&&n.push(t.substring(l,u)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),l=e.getPosition();break}while(s!==17);return n.join("")}i.stripComments=S;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=o}),function(){function x(P){const I=[];typeof P=="number"&&I.push("code/timeOrigin",P);function O(c){I.push(c,Date.now())}function b(){const c=[];for(let g=0;g<I.length;g+=2)c.push({name:I[g],startTime:I[g+1]});return c}return{mark:O,getMarks:b}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const O of performance.getEntriesByType("mark"))I.push({name:O.name,startTime:Math.round(P+O.startTime)});return I}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function L(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=L(R))}(),define(Y[57],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L=i.Source||(i.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=i.TerminateResponseCode||(i.TerminateResponseCode={}));function P(I,...O){const b=O.reduce((C,D)=>(C[D]=!0,C),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(C=>!b[C]).forEach(C=>{for(let D=0;D<c.length;D++)if(C.search(c[D])!==-1){delete I[C];break}})}i.sanitizeProcessEnvironment=P}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var L=i();for(var R in L)(typeof exports=="object"?exports:x)[R]=L[R]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function L(R){if(i[R])return i[R].exports;var P=i[R]={i:R,l:!1,exports:{}};return x[R].call(P.exports,P,P.exports,L),P.l=!0,P.exports}return L.m=x,L.c=i,L.d=function(R,P,I){L.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:I})},L.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},L.t=function(R,P){if(1&P&&(R=L(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(L.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var O in R)L.d(I,O,function(b){return R[b]}.bind(null,O));return I},L.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return L.d(P,"a",P),P},L.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},L.p="",L(L.s=0)}([function(x,i,L){(function(R){var P;i=x.exports=k,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var I=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,b=i.re=[],c=i.src=[],g=0,C=g++;c[C]="0|[1-9]\\d*";var D=g++;c[D]="[0-9]+";var v=g++;c[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=g++;c[w]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var E=g++;c[E]="("+c[D]+")\\.("+c[D]+")\\.("+c[D]+")";var m=g++;c[m]="(?:"+c[C]+"|"+c[v]+")";var p=g++;c[p]="(?:"+c[D]+"|"+c[v]+")";var a=g++;c[a]="(?:-("+c[m]+"(?:\\."+c[m]+")*))";var h=g++;c[h]="(?:-?("+c[p]+"(?:\\."+c[p]+")*))";var y=g++;c[y]="[0-9A-Za-z-]+";var S=g++;c[S]="(?:\\+("+c[y]+"(?:\\."+c[y]+")*))";var o=g++,t="v?"+c[w]+c[a]+"?"+c[S]+"?";c[o]="^"+t+"$";var r="[v=\\s]*"+c[E]+c[h]+"?"+c[S]+"?",e=g++;c[e]="^"+r+"$";var n=g++;c[n]="((?:<|>)?=?)";var s=g++;c[s]=c[D]+"|x|X|\\*";var l=g++;c[l]=c[C]+"|x|X|\\*";var u=g++;c[u]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[a]+")?"+c[S]+"?)?)?";var f=g++;c[f]="[v=\\s]*("+c[s]+")(?:\\.("+c[s]+")(?:\\.("+c[s]+")(?:"+c[h]+")?"+c[S]+"?)?)?";var d=g++;c[d]="^"+c[n]+"\\s*"+c[u]+"$";var T=g++;c[T]="^"+c[n]+"\\s*"+c[f]+"$";var M=g++;c[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=g++;c[H]="(?:~>?)";var X=g++;c[X]="(\\s*)"+c[H]+"\\s+",b[X]=new RegExp(c[X],"g");var ee=g++;c[ee]="^"+c[H]+c[u]+"$";var ie=g++;c[ie]="^"+c[H]+c[f]+"$";var ne=g++;c[ne]="(?:\\^)";var fe=g++;c[fe]="(\\s*)"+c[ne]+"\\s+",b[fe]=new RegExp(c[fe],"g");var B=g++;c[B]="^"+c[ne]+c[u]+"$";var _=g++;c[_]="^"+c[ne]+c[f]+"$";var re=g++;c[re]="^"+c[n]+"\\s*("+r+")$|^$";var U=g++;c[U]="^"+c[n]+"\\s*("+t+")$|^$";var N=g++;c[N]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[u]+")",b[N]=new RegExp(c[N],"g");var W=g++;c[W]="^\\s*("+c[u]+")\\s+-\\s+("+c[u]+")\\s*$";var K=g++;c[K]="^\\s*("+c[f]+")\\s+-\\s+("+c[f]+")\\s*$";var te=g++;c[te]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)P(J,c[J]),b[J]||(b[J]=new RegExp(c[J]));function Z(F,j){if(F instanceof k)return F;if(typeof F!="string"||F.length>I||!(j?b[e]:b[o]).test(F))return null;try{return new k(F,j)}catch{return null}}function k(F,j){if(F instanceof k){if(F.loose===j)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof k))return new k(F,j);P("SemVer",F,j),this.loose=j;var $=F.trim().match(j?b[e]:b[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ce){if(/^[0-9]+$/.test(ce)){var de=+ce;if(de>=0&&de<O)return de}return ce}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,j){var $=Z(F,j);return $?$.version:null},i.clean=function(F,j){var $=Z(F.trim().replace(/^[=v]+/,""),j);return $?$.version:null},i.SemVer=k,k.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},k.prototype.toString=function(){return this.version},k.prototype.compare=function(F){return P("SemVer.compare",this.version,this.loose,F),F instanceof k||(F=new k(F,this.loose)),this.compareMain(F)||this.comparePre(F)},k.prototype.compareMain=function(F){return F instanceof k||(F=new k(F,this.loose)),z(this.major,F.major)||z(this.minor,F.minor)||z(this.patch,F.patch)},k.prototype.comparePre=function(F){if(F instanceof k||(F=new k(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var j=0;do{var $=this.prerelease[j],ce=F.prerelease[j];if(P("prerelease compare",j,$,ce),$===void 0&&ce===void 0)return 0;if(ce===void 0)return 1;if($===void 0)return-1;if($!==ce)return z($,ce)}while(++j)},k.prototype.inc=function(F,j){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",j);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",j);break;case"prepatch":this.prerelease.length=0,this.inc("patch",j),this.inc("pre",j);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",j),this.inc("pre",j);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}j&&(this.prerelease[0]===j?isNaN(this.prerelease[1])&&(this.prerelease=[j,0]):this.prerelease=[j,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,j,$,ce){typeof $=="string"&&(ce=$,$=void 0);try{return new k(F,$).inc(j,ce).version}catch{return null}},i.diff=function(F,j){if(se(F,j))return null;var $=Z(F),ce=Z(j);if($.prerelease.length||ce.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==ce[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==ce[de])return de},i.compareIdentifiers=z;var A=/^[0-9]+$/;function z(F,j){var $=A.test(F),ce=A.test(j);return $&&ce&&(F=+F,j=+j),$&&!ce?-1:ce&&!$?1:F<j?-1:F>j?1:0}function V(F,j,$){return new k(F,$).compare(new k(j,$))}function G(F,j,$){return V(F,j,$)>0}function q(F,j,$){return V(F,j,$)<0}function se(F,j,$){return V(F,j,$)===0}function le(F,j,$){return V(F,j,$)!==0}function ge(F,j,$){return V(F,j,$)>=0}function me(F,j,$){return V(F,j,$)<=0}function oe(F,j,$,ce){var de;switch(j){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F!==$;break;case"":case"=":case"==":de=se(F,$,ce);break;case"!=":de=le(F,$,ce);break;case">":de=G(F,$,ce);break;case">=":de=ge(F,$,ce);break;case"<":de=q(F,$,ce);break;case"<=":de=me(F,$,ce);break;default:throw new TypeError("Invalid operator: "+j)}return de}function ue(F,j){if(F instanceof ue){if(F.loose===j)return F;F=F.value}if(!(this instanceof ue))return new ue(F,j);P("comparator",F,j),this.loose=j,this.parse(F),this.semver===we?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(F,j){return z(j,F)},i.major=function(F,j){return new k(F,j).major},i.minor=function(F,j){return new k(F,j).minor},i.patch=function(F,j){return new k(F,j).patch},i.compare=V,i.compareLoose=function(F,j){return V(F,j,!0)},i.rcompare=function(F,j,$){return V(j,F,$)},i.sort=function(F,j){return F.sort(function($,ce){return i.compare($,ce,j)})},i.rsort=function(F,j){return F.sort(function($,ce){return i.rcompare($,ce,j)})},i.gt=G,i.lt=q,i.eq=se,i.neq=le,i.gte=ge,i.lte=me,i.cmp=oe,i.Comparator=ue;var we={};function ve(F,j){if(F instanceof ve)return F.loose===j?F:new ve(F.raw,j);if(F instanceof ue)return new ve(F.value,j);if(!(this instanceof ve))return new ve(F,j);if(this.loose=j,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function ye(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ne(F,j,$,ce,de,De,Se,Oe,Ie,Te,Fe,Re,Le){return((j=ye($)?"":ye(ce)?">="+$+".0.0":ye(de)?">="+$+"."+ce+".0":">="+j)+" "+(Oe=ye(Ie)?"":ye(Te)?"<"+(+Ie+1)+".0.0":ye(Fe)?"<"+Ie+"."+(+Te+1)+".0":Re?"<="+Ie+"."+Te+"."+Fe+"-"+Re:"<="+Oe)).trim()}function je(F,j){for(var $=0;$<F.length;$++)if(!F[$].test(j))return!1;if(j.prerelease.length){for($=0;$<F.length;$++)if(P(F[$].semver),F[$].semver!==we&&F[$].semver.prerelease.length>0){var ce=F[$].semver;if(ce.major===j.major&&ce.minor===j.minor&&ce.patch===j.patch)return!0}return!1}return!0}function ze(F,j,$){try{j=new ve(j,$)}catch{return!1}return j.test(F)}function xe(F,j,$,ce){var de,De,Se,Oe,Ie;switch(F=new k(F,ce),j=new ve(j,ce),$){case">":de=G,De=me,Se=q,Oe=">",Ie=">=";break;case"<":de=q,De=ge,Se=G,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(F,j,ce))return!1;for(var Te=0;Te<j.set.length;++Te){var Fe=j.set[Te],Re=null,Le=null;if(Fe.forEach(function(ke){ke.semver===we&&(ke=new ue(">=0.0.0")),Re=Re||ke,Le=Le||ke,de(ke.semver,Re.semver,ce)?Re=ke:Se(ke.semver,Le.semver,ce)&&(Le=ke)}),Re.operator===Oe||Re.operator===Ie||(!Le.operator||Le.operator===Oe)&&De(F,Le.semver)||Le.operator===Ie&&Se(F,Le.semver))return!1}return!0}ue.prototype.parse=function(F){var j=this.loose?b[re]:b[U],$=F.match(j);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new k($[2],this.loose):this.semver=we},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(F){return P("Comparator.test",F,this.loose),this.semver===we||(typeof F=="string"&&(F=new k(F,this.loose)),oe(F,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(F,j){if(!(F instanceof ue))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new ve(F.value,j),ze(this.value,$,j);if(F.operator==="")return $=new ve(this.value,j),ze(F.semver,$,j);var ce=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),De=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Oe=oe(this.semver,"<",F.semver,j)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Ie=oe(this.semver,">",F.semver,j)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ce||de||De&&Se||Oe||Ie},i.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(F){var j=this.loose;F=F.trim(),P("range",F,j);var $=j?b[K]:b[W];F=F.replace($,Ne),P("hyphen replace",F),F=F.replace(b[N],"$1$2$3"),P("comparator trim",F,b[N]),F=(F=(F=F.replace(b[X],"$1~")).replace(b[fe],"$1^")).split(/\s+/).join(" ");var ce=j?b[re]:b[U],de=F.split(" ").map(function(De){return function(Se,Oe){return P("comp",Se),Se=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,Le){P("caret",Re,Le);var ke=Le?b[_]:b[B];return Re.replace(ke,function(Ae,pe,Ee,be,Pe){var Ce;return P("caret",Re,Ae,pe,Ee,be,Pe),ye(pe)?Ce="":ye(Ee)?Ce=">="+pe+".0.0 <"+(+pe+1)+".0.0":ye(be)?Ce=pe==="0"?">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+".0 <"+(+pe+1)+".0.0":Pe?(P("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ce=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+be+Pe+" <"+pe+"."+Ee+"."+(+be+1):">="+pe+"."+Ee+"."+be+Pe+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+be+Pe+" <"+(+pe+1)+".0.0"):(P("no pr"),Ce=pe==="0"?Ee==="0"?">="+pe+"."+Ee+"."+be+" <"+pe+"."+Ee+"."+(+be+1):">="+pe+"."+Ee+"."+be+" <"+pe+"."+(+Ee+1)+".0":">="+pe+"."+Ee+"."+be+" <"+(+pe+1)+".0.0"),P("caret return",Ce),Ce})}(Fe,Te)}).join(" ")}(Se,Oe),P("caret",Se),Se=function(Ie,Te){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,Le){var ke=Le?b[ie]:b[ee];return Re.replace(ke,function(Ae,pe,Ee,be,Pe){var Ce;return P("tilde",Re,Ae,pe,Ee,be,Pe),ye(pe)?Ce="":ye(Ee)?Ce=">="+pe+".0.0 <"+(+pe+1)+".0.0":ye(be)?Ce=">="+pe+"."+Ee+".0 <"+pe+"."+(+Ee+1)+".0":Pe?(P("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ce=">="+pe+"."+Ee+"."+be+Pe+" <"+pe+"."+(+Ee+1)+".0"):Ce=">="+pe+"."+Ee+"."+be+" <"+pe+"."+(+Ee+1)+".0",P("tilde return",Ce),Ce})}(Fe,Te)}).join(" ")}(Se,Oe),P("tildes",Se),Se=function(Ie,Te){return P("replaceXRanges",Ie,Te),Ie.split(/\s+/).map(function(Fe){return function(Re,Le){Re=Re.trim();var ke=Le?b[T]:b[d];return Re.replace(ke,function(Ae,pe,Ee,be,Pe,Ce){P("xRange",Re,Ae,pe,Ee,be,Pe,Ce);var Ve=ye(Ee),Me=Ve||ye(be),Ue=Me||ye(Pe);return pe==="="&&Ue&&(pe=""),Ve?Ae=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Ue?(Me&&(be=0),Ue&&(Pe=0),pe===">"?(pe=">=",Me?(Ee=+Ee+1,be=0,Pe=0):Ue&&(be=+be+1,Pe=0)):pe==="<="&&(pe="<",Me?Ee=+Ee+1:be=+be+1),Ae=pe+Ee+"."+be+"."+Pe):Me?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ue&&(Ae=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),P("xRange return",Ae),Ae})}(Fe,Te)}).join(" ")}(Se,Oe),P("xrange",Se),Se=function(Ie,Te){return P("replaceStars",Ie,Te),Ie.trim().replace(b[te],"")}(Se,Oe),P("stars",Se),Se}(De,j)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(De){return!!De.match(ce)})),de=de.map(function(De){return new ue(De,j)})},ve.prototype.intersects=function(F,j){if(!(F instanceof ve))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ce){return F.set.some(function(de){return de.every(function(De){return ce.intersects(De,j)})})})})},i.toComparators=function(F,j){return new ve(F,j).set.map(function($){return $.map(function(ce){return ce.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new k(F,this.loose));for(var j=0;j<this.set.length;j++)if(je(this.set[j],F))return!0;return!1},i.satisfies=ze,i.maxSatisfying=function(F,j,$){var ce=null,de=null;try{var De=new ve(j,$)}catch{return null}return F.forEach(function(Se){De.test(Se)&&(ce&&de.compare(Se)!==-1||(de=new k(ce=Se,$)))}),ce},i.minSatisfying=function(F,j,$){var ce=null,de=null;try{var De=new ve(j,$)}catch{return null}return F.forEach(function(Se){De.test(Se)&&(ce&&de.compare(Se)!==1||(de=new k(ce=Se,$)))}),ce},i.validRange=function(F,j){try{return new ve(F,j).range||"*"}catch{return null}},i.ltr=function(F,j,$){return xe(F,j,"<",$)},i.gtr=function(F,j,$){return xe(F,j,">",$)},i.outside=xe,i.prerelease=function(F,j){var $=Z(F,j);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,j,$){return F=new ve(F,$),j=new ve(j,$),F.intersects(j)},i.coerce=function(F){if(F instanceof k)return F;if(typeof F!="string")return null;var j=F.match(b[M]);return j==null?null:Z((j[1]||"0")+"."+(j[2]||"0")+"."+(j[3]||"0"))}}).call(this,L(1))},function(x,i){var L,R,P=x.exports={};function I(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function b(p){if(L===setTimeout)return setTimeout(p,0);if((L===I||!L)&&setTimeout)return L=setTimeout,setTimeout(p,0);try{return L(p,0)}catch{try{return L.call(null,p,0)}catch{return L.call(this,p,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:I}catch{L=I}try{R=typeof clearTimeout=="function"?clearTimeout:O}catch{R=O}})();var c,g=[],C=!1,D=-1;function v(){C&&c&&(C=!1,c.length?g=c.concat(g):D=-1,g.length&&w())}function w(){if(!C){var p=b(v);C=!0;for(var a=g.length;a;){for(c=g,g=[];++D<a;)c&&c[D].run();D=-1,a=g.length}c=null,C=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===O||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(p)}}function E(p,a){this.fun=p,this.array=a}function m(){}P.nextTick=function(p){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];g.push(new E(p,a)),g.length!==1||C||b(w)},E.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=m,P.addListener=m,P.once=m,P.off=m,P.removeListener=m,P.removeAllListeners=m,P.emit=m,P.prependListener=m,P.prependOnceListener=m,P.listeners=function(p){return[]},P.binding=function(p){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(p){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Y[58],Q([0,1]),function(x,i){"use strict";var L;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(b,c,g){this.level=b,this.key=c,this.value=g,this.forward=[]}}const P=void 0;class I{constructor(b,c=2**16){this.comparator=b,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new R(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,P,P)}has(b){return Boolean(I._search(this,b,this.comparator))}get(b){return I._search(this,b,this.comparator)?.value}set(b,c){return I._insert(this,b,c,this.comparator)&&(this._size+=1),this}delete(b){const c=I._delete(this,b,this.comparator);return c&&(this._size-=1),c}forEach(b,c){let g=this._header.forward[0];for(;g;)b.call(c,g.value,g.key,this),g=g.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",c=this._header.forward[0];for(;c;)b+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return b}static _search(b,c,g){let C=b._header;for(let D=b._level-1;D>=0;D--)for(;C.forward[D]&&g(C.forward[D].key,c)<0;)C=C.forward[D];if(C=C.forward[0],C&&g(C.key,c)===0)return C}static _insert(b,c,g,C){let D=[],v=b._header;for(let w=b._level-1;w>=0;w--){for(;v.forward[w]&&C(v.forward[w].key,c)<0;)v=v.forward[w];D[w]=v}if(v=v.forward[0],v&&C(v.key,c)===0)return v.value=g,!1;{let w=I._randomLevel(b);if(w>b._level){for(let E=b._level;E<w;E++)D[E]=b._header;b._level=w}v=new R(w,c,g);for(let E=0;E<w;E++)v.forward[E]=D[E].forward[E],D[E].forward[E]=v;return!0}}static _randomLevel(b,c=.5){let g=1;for(;Math.random()<c&&g<b._maxLevel;)g+=1;return g}static _delete(b,c,g){let C=[],D=b._header;for(let v=b._level-1;v>=0;v--){for(;D.forward[v]&&g(D.forward[v].key,c)<0;)D=D.forward[v];C[v]=D}if(D=D.forward[0],!D||g(D.key,c)!==0)return!1;for(let v=0;v<b._level&&C[v].forward[v]===D;v++)C[v].forward[v]=D.forward[v];for(;b._level>0&&b._header.forward[b._level-1]===P;)b._level-=1;return!0}}i.SkipList=I}),define(Y[38],Q([0,1,6,2]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function P(S){const o=S;return o?typeof o.read=="function":!1}i.isReadable=P;function I(S){const o=S;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}i.isReadableStream=I;function O(S){const o=S;return o?I(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}i.isReadableBufferedStream=O;function b(S,o){return new c(S,o)}i.newWriteableStream=b;class c{constructor(o,t){this.reducer=o,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(t=>t(o))}emitError(o){this.listeners.error.length===0?(0,L.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(t=>t(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,t){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(o,t){if(this.state.destroyed)return;let r;switch(o){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const e=r.indexOf(t);e>=0&&r.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(S,o){const t=[];let r;for(;(r=S.read())!==null;)t.push(r);return o(t)}i.consumeReadable=g;function C(S,o,t){const r=[];let e;for(;(e=S.read())!==null&&r.length<t;)r.push(e);return e===null&&r.length>0?o(r):{read:()=>{if(r.length>0)return r.shift();if(typeof e!="undefined"){const n=e;return e=void 0,n}return S.read()}}}i.peekReadable=C;function D(S,o){return new Promise((t,r)=>{const e=[];v(S,{onData:n=>{o&&e.push(n)},onError:n=>{o?r(n):t(void 0)},onEnd:()=>{t(o?o(e):void 0)}})})}i.consumeStream=D;function v(S,o){let t=!1;return S.on("error",r=>{t||o.onError(r)}),S.on("end",()=>{t||o.onEnd()}),S.on("data",r=>{t||o.onData(r)}),(0,R.toDisposable)(()=>t=!0)}i.listenStream=v;function w(S,o){return new Promise((t,r)=>{const e=new R.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>o)return e.dispose(),S.pause(),t({stream:S,buffer:n,ended:!1})},l=f=>r(f),u=()=>t({stream:S,buffer:n,ended:!0});e.add((0,R.toDisposable)(()=>S.removeListener("error",l))),S.on("error",l),e.add((0,R.toDisposable)(()=>S.removeListener("end",u))),S.on("end",u),e.add((0,R.toDisposable)(()=>S.removeListener("data",s))),S.on("data",s)})}i.peekStream=w;function E(S,o){const t=b(o);return t.end(S),t}i.toStream=E;function m(){const S=b(()=>{throw new Error("not supported")});return S.end(),S}i.emptyStream=m;function p(S){let o=!1;return{read:()=>o?null:(o=!0,S)}}i.toReadable=p;function a(S,o,t){const r=b(t);return v(S,{onData:e=>r.write(o.data(e)),onError:e=>r.error(o.error?o.error(e):e),onEnd:()=>r.end()}),r}i.transform=a;function h(S,o,t){let r=!1;return{read:()=>{const e=o.read();return r?e:(r=!0,e!==null?t([S,e]):S)}}}i.prefixedReadable=h;function y(S,o,t){let r=!1;const e=b(t);return v(o,{onData:n=>r?e.write(n):(r=!0,e.write(t([S,n]))),onError:n=>e.error(n),onEnd:()=>{r||(r=!0,e.write(S)),e.end()}}),e}i.prefixedStream=y}),define(Y[17],Q([0,1,38]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer!="undefined";let P,I;class O{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return R?new O(Buffer.allocUnsafe(f)):new O(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new O(f)}static fromString(f,d){return!(d?.dontUseNodeBuffer||!1)&&R?new O(Buffer.from(f)):(P||(P=new TextEncoder),new O(P.encode(f)))}static fromByteArray(f){const d=O.alloc(f.length);for(let T=0,M=f.length;T<M;T++)d.buffer[T]=f[T];return d}static concat(f,d){if(typeof d=="undefined"){d=0;for(let H=0,X=f.length;H<X;H++)d+=f[H].byteLength}const T=O.alloc(d);let M=0;for(let H=0,X=f.length;H<X;H++){const ee=f[H];T.set(ee,M),M+=ee.byteLength}return T}clone(){const f=O.alloc(this.byteLength);return f.set(this),f}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(f,d){return new O(this.buffer.subarray(f,d))}set(f,d){if(f instanceof O)this.buffer.set(f.buffer,d);else if(f instanceof Uint8Array)this.buffer.set(f,d);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),d);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return g(this.buffer,f)}writeUInt32BE(f,d){C(this.buffer,f,d)}readUInt32LE(f){return D(this.buffer,f)}writeUInt32LE(f,d){v(this.buffer,f,d)}readUInt8(f){return w(this.buffer,f)}writeUInt8(f,d){E(this.buffer,f,d)}}i.VSBuffer=O;function b(u,f){return u[f+0]<<0>>>0|u[f+1]<<8>>>0}i.readUInt16LE=b;function c(u,f,d){u[d+0]=f&255,f=f>>>8,u[d+1]=f&255}i.writeUInt16LE=c;function g(u,f){return u[f]*2**24+u[f+1]*2**16+u[f+2]*2**8+u[f+3]}i.readUInt32BE=g;function C(u,f,d){u[d+3]=f,f=f>>>8,u[d+2]=f,f=f>>>8,u[d+1]=f,f=f>>>8,u[d]=f}i.writeUInt32BE=C;function D(u,f){return u[f+0]<<0>>>0|u[f+1]<<8>>>0|u[f+2]<<16>>>0|u[f+3]<<24>>>0}i.readUInt32LE=D;function v(u,f,d){u[d+0]=f&255,f=f>>>8,u[d+1]=f&255,f=f>>>8,u[d+2]=f&255,f=f>>>8,u[d+3]=f&255}i.writeUInt32LE=v;function w(u,f){return u[f]}i.readUInt8=w;function E(u,f,d){u[d]=f}i.writeUInt8=E;function m(u){return L.consumeReadable(u,f=>O.concat(f))}i.readableToBuffer=m;function p(u){return L.toReadable(u)}i.bufferToReadable=p;function a(u){return L.consumeStream(u,f=>O.concat(f))}i.streamToBuffer=a;async function h(u){return u.ended?O.concat(u.buffer):O.concat([...u.buffer,await a(u.stream)])}i.bufferedStreamToBuffer=h;function y(u){return L.toStream(u,f=>O.concat(f))}i.bufferToStream=y;function S(u){return L.transform(u,{data:f=>typeof f=="string"?O.fromString(f):O.wrap(f)},f=>O.concat(f))}i.streamToBufferReadableStream=S;function o(u){return L.newWriteableStream(f=>O.concat(f),u)}i.newWriteableBufferStream=o;function t(u,f){return L.prefixedReadable(u,f,d=>O.concat(d))}i.prefixedBufferReadable=t;function r(u,f){return L.prefixedStream(u,f,d=>O.concat(d))}i.prefixedBufferStream=r;function e(u){let f=0,d=0,T=0;const M=new Uint8Array(Math.floor(u.length/4*3)),H=ee=>{switch(d){case 3:M[T++]=f|ee,d=0;break;case 2:M[T++]=f|ee>>>2,f=ee<<6,d=3;break;case 1:M[T++]=f|ee>>>4,f=ee<<4,d=2;break;default:f=ee<<2,d=1}};for(let ee=0;ee<u.length;ee++){const ie=u.charCodeAt(ee);if(ie>=65&&ie<=90)H(ie-65);else if(ie>=97&&ie<=122)H(ie-97+26);else if(ie>=48&&ie<=57)H(ie-48+52);else if(ie===43||ie===45)H(62);else if(ie===47||ie===95)H(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${u[ee]}`)}}const X=T;for(;d>0;)H(0);return O.wrap(M).slice(0,X)}i.decodeBase64=e;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:u},f=!0,d=!1){const T=d?s:n;let M="";const H=u.byteLength%3;let X=0;for(;X<u.byteLength-H;X+=3){const ee=u[X+0],ie=u[X+1],ne=u[X+2];M+=T[ee>>>2],M+=T[(ee<<4|ie>>>4)&63],M+=T[(ie<<2|ne>>>6)&63],M+=T[ne&63]}if(H===1){const ee=u[X+0];M+=T[ee>>>2],M+=T[ee<<4&63],f&&(M+="==")}else if(H===2){const ee=u[X+0],ie=u[X+1];M+=T[ee>>>2],M+=T[(ee<<4|ie>>>4)&63],M+=T[ie<<2&63],f&&(M+="=")}return M}i.encodeBase64=l}),define(Y[59],Q([0,1,26]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function R(a){return P(a,0)}i.hash=R;function P(a,h){switch(typeof a){case"object":return a===null?I(349,h):Array.isArray(a)?c(a,h):g(a,h);case"string":return b(a,h);case"boolean":return O(a,h);case"number":return I(a,h);case"undefined":return I(937,h);default:return I(617,h)}}i.doHash=P;function I(a,h){return(h<<5)-h+a|0}i.numberHash=I;function O(a,h){return I(a?433:863,h)}function b(a,h){h=I(149417,h);for(let y=0,S=a.length;y<S;y++)h=I(a.charCodeAt(y),h);return h}i.stringHash=b;function c(a,h){return h=I(104579,h),a.reduce((y,S)=>P(S,y),h)}function g(a,h){return h=I(181387,h),Object.keys(a).sort().reduce((y,S)=>(y=b(S,y),P(a[S],y)),h)}class C{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=P(h,this._value),this._value}}i.Hasher=C;var D;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function v(a,h,y=32){const S=y-h,o=~((1<<S)-1);return(a<<h|(o&a)>>>S)>>>0}function w(a,h=0,y=a.byteLength,S=0){for(let o=0;o<y;o++)a[h+o]=S}function E(a,h,y="0"){for(;a.length<h;)a=y+a;return a}function m(a,h=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(y=>y.toString(16).padStart(2,"0")).join(""):E((a>>>0).toString(16),h/4)}i.toHexString=m;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const y=h.length;if(y===0)return;const S=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,e;for(t!==0?(r=t,e=-1,t=0):(r=h.charCodeAt(0),e=0);;){let n=r;if(L.isHighSurrogate(r))if(e+1<y){const s=h.charCodeAt(e+1);L.isLowSurrogate(s)?(e++,n=L.computeCodePoint(r,s)):n=65533}else{t=r;break}else L.isLowSurrogate(r)&&(n=65533);if(o=this._push(S,o,n),e++,e<y)r=h.charCodeAt(e);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(h,y,S){return S<128?h[y++]=S:S<2048?(h[y++]=192|(S&1984)>>>6,h[y++]=128|(S&63)>>>0):S<65536?(h[y++]=224|(S&61440)>>>12,h[y++]=128|(S&4032)>>>6,h[y++]=128|(S&63)>>>0):(h[y++]=240|(S&1835008)>>>18,h[y++]=128|(S&258048)>>>12,h[y++]=128|(S&4032)>>>6,h[y++]=128|(S&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=p._bigBlock32,y=this._buffDV;for(let u=0;u<64;u+=4)h.setUint32(u,y.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)h.setUint32(u,v(h.getUint32(u-12,!1)^h.getUint32(u-32,!1)^h.getUint32(u-56,!1)^h.getUint32(u-64,!1),1),!1);let S=this._h0,o=this._h1,t=this._h2,r=this._h3,e=this._h4,n,s,l;for(let u=0;u<80;u++)u<20?(n=o&t|~o&r,s=1518500249):u<40?(n=o^t^r,s=1859775393):u<60?(n=o&t|o&r|t&r,s=2400959708):(n=o^t^r,s=3395469782),l=v(S,5)+n+e+s+h.getUint32(u*4,!1)&4294967295,e=r,r=t,t=v(o,30),o=S,S=l;this._h0=this._h0+S&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}i.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Y[22],Q([0,1,8]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.keys(m).forEach(a=>{m[a]&&typeof m[a]=="object"?p[a]=R(m[a]):p[a]=m[a]}),p}i.deepClone=R;function P(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const a=p.shift();Object.freeze(a);for(const h in a)if(I.call(a,h)){const y=a[h];typeof y=="object"&&!Object.isFrozen(y)&&!(0,L.isTypedArray)(y)&&p.push(y)}}return m}i.deepFreeze=P;const I=Object.prototype.hasOwnProperty;function O(m,p){return b(m,p,new Set)}i.cloneAndChange=O;function b(m,p,a){if((0,L.isUndefinedOrNull)(m))return m;const h=p(m);if(typeof h!="undefined")return h;if((0,L.isArray)(m)){const y=[];for(const S of m)y.push(b(S,p,a));return y}if((0,L.isObject)(m)){if(a.has(m))throw new Error("Cannot clone recursive data-structure");a.add(m);const y={};for(let S in m)I.call(m,S)&&(y[S]=b(m[S],p,a));return a.delete(m),y}return m}function c(m,p,a=!0){return(0,L.isObject)(m)?((0,L.isObject)(p)&&Object.keys(p).forEach(h=>{h in m?a&&((0,L.isObject)(m[h])&&(0,L.isObject)(p[h])?c(m[h],p[h],a):m[h]=p[h]):m[h]=p[h]}),m):p}i.mixin=c;function g(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let a,h;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(a=0;a<m.length;a++)if(!g(m[a],p[a]))return!1}else{const y=[];for(h in m)y.push(h);y.sort();const S=[];for(h in p)S.push(h);if(S.sort(),!g(y,S))return!1;for(a=0;a<y.length;a++)if(!g(m[y[a]],p[y[a]]))return!1}return!0}i.equals=g;function C(m){const p=new Set;return JSON.stringify(m,(a,h)=>{if((0,L.isObject)(h)||Array.isArray(h)){if(p.has(h))return"[Circular]";p.add(h)}return h})}i.safeStringify=C;function D(m,p,a){const h=p(m);return typeof h=="undefined"?a:h}i.getOrDefault=D;function v(m,p){const a=Object.create(null);return!m||!p||Object.keys(p).forEach(y=>{const S=m[y],o=p[y];g(S,o)||(a[y]=o)}),a}i.distinct=v;function w(m,p){const a=p.toLowerCase(),h=Object.keys(m).find(y=>y.toLowerCase()===a);return h?m[h]:m[p]}i.getCaseInsensitive=w;function E(m,p){const a=Object.create(null);for(const[h,y]of Object.entries(m))p(h,y)&&(a[h]=y);return a}i.filter=E}),define(Y[60],Q([0,1,9]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}i.isRemoteConsoleLog=R;function P(g){const C=[];let D;try{const v=JSON.parse(g.arguments),w=v[v.length-1];w&&w.__$stack&&(v.pop(),D=w.__$stack),C.push(...v)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:D}}i.parse=P;function I(g){if(typeof g!="string")return I(P(g).stack);const C=g;if(C){const D=O(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(v&&v.length===4)return{uri:L.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}i.getFirstFrame=I;function O(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function b(g,C){const{args:D,stack:v}=P(g),w=typeof D[0]=="string"&&D.length===1;let E=O(v);E&&(E=`(${E.trim()})`);let m=[];if(typeof D[0]=="string"?E&&w?m=[`%c[${C}] %c${D[0]} %c${E}`,c("blue"),c(""),c("grey")]:m=[`%c[${C}] %c${D[0]}`,c("blue"),c(""),...D.slice(1)]:m=[`%c[${C}]%`,c("blue"),...D],E&&!w&&m.push(E),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,m)}i.log=b;function c(g){return`color: ${g}`}}),define(Y[61],Q([0,1,17,26,9]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function I(g){return JSON.stringify(g,b)}i.stringify=I;function O(g){let C=JSON.parse(g);return C=c(C),C}i.parse=O;function b(g,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function c(g,C=0){if(!g||C>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return P.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 14:return new Date(g.source)}if(g instanceof L.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let D=0;D<g.length;++D)g[D]=c(g[D],C+1);else for(const D in g)Object.hasOwnProperty.call(g,D)&&(g[D]=c(g[D],C+1))}return g}i.revive=c}),define(Y[62],Q([0,1,45,12,10,11,19,26,9]),function(x,i,L,R,P,I,O,b,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function g(n,s,l){if(typeof n=="string"&&(n=c.URI.file(n)),l){const f=l.getWorkspaceFolder(n);if(f){const d=l.getWorkspace().folders.length>1;let T;if((0,O.isEqual)(f.uri,n)?T="":T=(0,O.relativePath)(f.uri,n),d){const M=f.name?f.name:(0,O.basename)(f.uri);T=T?M+" \u2022 "+T:M}return T}}if(n.scheme!==R.Schemas.file&&n.scheme!==R.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,L.hasDriveLetter)(n.fsPath))return(0,P.normalize)(D(n.fsPath));let u=(0,P.normalize)(n.fsPath);return!I.isWindows&&s?.userHome&&(u=w(u,s.userHome.fsPath)),u}i.getPathLabel=g;function C(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const s=(0,O.basename)(n)||(n.scheme===R.Schemas.file?n.fsPath:n.path);return I.isWindows&&(0,L.isRootOrDriveLetter)(s)?D(s):s}i.getBaseLabel=C;function D(n,s){return(0,L.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=D;let v=Object.create(null);function w(n,s){if(I.isWindows||!n||!s)return n;let l=v.original===s?v.normalized:void 0;return l||(l=`${(0,b.rtrim)(s,P.posix.sep)}${P.posix.sep}`,v={original:s,normalized:l}),(I.isLinux?n.startsWith(l):(0,b.startsWithIgnoreCase)(n,l))&&(n=`~/${n.substr(l.length)}`),n}i.tildify=w;function E(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=E;const m="\u2026",p="\\\\",a="~";function h(n,s=P.sep){const l=new Array(n.length);let u=!1;for(let f=0;f<n.length;f++){let d=n[f];if(d===""){l[f]=`.${s}`;continue}if(!d){l[f]=d;continue}u=!0;let T="";d.indexOf(p)===0?(T=d.substr(0,d.indexOf(p)+p.length),d=d.substr(d.indexOf(p)+p.length)):d.indexOf(s)===0?(T=d.substr(0,d.indexOf(s)+s.length),d=d.substr(d.indexOf(s)+s.length)):d.indexOf(a)===0&&(T=d.substr(0,d.indexOf(a)+a.length),d=d.substr(d.indexOf(a)+a.length));const M=d.split(s);for(let H=1;u&&H<=M.length;H++)for(let X=M.length-H;u&&X>=0;X--){u=!1;let ee=M.slice(X,X+H).join(s);for(let ie=0;!u&&ie<n.length;ie++)if(ie!==f&&n[ie]&&n[ie].indexOf(ee)>-1){const ne=X+H===M.length,fe=X>0&&n[ie].indexOf(s)>-1?s+ee:ee,B=n[ie].endsWith(fe);u=!ne||B}if(!u){let ie="";(M[0].endsWith(":")||T!=="")&&(X===1&&(X=0,H++,ee=M[0]+s+ee),X>0&&(ie=M[0]+s),ie=T+ie),X>0&&(ie=ie+m+s),ie=ie+ee,X+H<M.length&&(ie=ie+s+m),l[f]=ie}}u&&(l[f]=d)}return l}i.shorten=h;var y;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(y||(y={}));function S(n,s=Object.create(null)){const l=[];let u=!1,f="";for(const d of n)if(d==="$"||u&&d==="{")f&&l.push({value:f,type:y.TEXT}),f="",u=!0;else if(d==="}"&&u){const T=s[f];if(typeof T=="string")T.length&&l.push({value:T,type:y.VARIABLE});else if(T){const M=l[l.length-1];(!M||M.type!==y.SEPARATOR)&&l.push({value:T.label,type:y.SEPARATOR})}f="",u=!1}else f+=d;return f&&!u&&l.push({value:f,type:y.TEXT}),l.filter((d,T)=>{if(d.type===y.SEPARATOR){const M=l[T-1],H=l[T+1];return[M,H].every(X=>X&&(X.type===y.VARIABLE||X.type===y.TEXT)&&X.value.length>0)}return!0}).map(d=>d.value).join("")}i.template=S;function o(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}i.mnemonicMenuLabel=o;function t(n,s){return I.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(n){const s=n.indexOf("/")!==-1?P.posix:P.win32,l=s.basename(n),u=s.dirname(n);return l.length?{name:l,parentPath:u}:{name:u,parentPath:""}}i.splitName=e}),define(Y[27],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(c){return L.test(c)}i.isUUID=R;const P=new Uint8Array(16),I=[];for(let c=0;c<256;c++)I.push(c.toString(16).padStart(2,"0"));let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(c){for(let g=0;g<c.length;g++)c[g]=Math.floor(Math.random()*256);return c};function b(){O(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let c=0,g="";return g+=I[P[c++]],g+=I[P[c++]],g+=I[P[c++]],g+=I[P[c++]],g+="-",g+=I[P[c++]],g+=I[P[c++]],g+="-",g+=I[P[c++]],g+=I[P[c++]],g+="-",g+=I[P[c++]],g+=I[P[c++]],g+="-",g+=I[P[c++]],g+=I[P[c++]],g+=I[P[c++]],g+=I[P[c++]],g+=I[P[c++]],g+=I[P[c++]],g}i.generateUuid=b}),define(Y[63],Q([0,1,132]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class R{constructor(I="utf8"){this.stringDecoder=new L.StringDecoder(I),this.remaining=null}write(I){const O=[],b=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(b.length<1)return O;let c=0,g,C=c;for(;C<b.length;)if(g=b.charCodeAt(C),g===13||g===10){if(O.push(b.substring(c,C)),C++,C<b.length){const D=g;g=b.charCodeAt(C),(D===13&&g===10||D===10&&g===13)&&C++}c=C}else C++;return this.remaining=c<b.length?b.substr(c):null,O}end(){return this.remaining}}i.LineDecoder=R}),define(Y[64],Q([0,1,33,10,15]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,O=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var c;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(c||(c={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class D{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:S=!1}={}){return S?g===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:S=!1,findPreview:o=!1}={}){const t=v({useAlternateBitness:S});if(!t)return null;const r=R.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const u of await P.Promises.readdir(r)){let f=-1;if(o){const T=u.indexOf("-");if(T<0)continue;const M=u.substring(0,T);if(!I.test(M)||u.substring(T+1)!=="preview")continue;f=parseInt(M,10)}else{if(!I.test(u))continue;f=parseInt(u,10)}if(f<=e)continue;const d=R.join(r,u,"pwsh.exe");!await P.SymlinkSupport.existsFile(d)||(n=d,e=f)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new D(n,`PowerShell${l}${s}`,!0)}async function E({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const o=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=S?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const e of await P.Promises.readdir(o))if(t.test(e)){const n=R.join(o,e,"pwsh.exe");return new D(n,r)}return null}function m(){const S=R.join(L.homedir(),".dotnet","tools","pwsh.exe");return new D(S,".NET Core PowerShell Global Tool")}function p(){const S=R.join(process.env.windir,g===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(S,"Windows PowerShell",!0)}async function*a(){let S=await w();S&&(yield S),S=await w({useAlternateBitness:!0}),S&&(yield S),S=await E(),S&&(yield S),S=m(),S&&(yield S),S=await w({findPreview:!0}),S&&(yield S),S=await E({findPreview:!0}),S&&(yield S),S=await w({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=p(),S&&(yield S)}async function*h(){for await(const S of a())await S.exists()&&(yield S)}i.enumeratePowerShellInstallations=h;async function y(){for await(const S of h())return S;return null}i.getFirstAvailablePowerShellInstallation=y});var he=this&&this.__decorate||function(x,i,L,R){var P=arguments.length,I=P<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,L):R,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(x,i,L,R);else for(var b=x.length-1;b>=0;b--)(O=x[b])&&(I=(P<3?O(I):P>3?O(i,L,I):O(i,L))||I);return P>3&&I&&Object.defineProperty(i,L,I),I};define(Y[46],Q([0,1,18,3,17,25,44,6,7,2,61,26,8]),function(x,i,L,R,P,I,O,b,c,g,C,D,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var w;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(w=i.RequestType||(i.RequestType={}));function E(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(m=i.ResponseType||(i.ResponseType={}));function p(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(a||(a={}));class h{constructor(N){this.buffer=N,this.pos=0}read(N){const W=this.buffer.slice(this.pos,this.pos+N);return this.pos+=W.byteLength,W}}class y{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var S;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(S||(S={}));function o(U){const N=P.VSBuffer.alloc(4);return N.writeUInt32BE(U,0),N}function t(U){return U.read(4).readUInt32BE(0)}function r(U){const N=P.VSBuffer.alloc(1);return N.writeUInt8(U,0),N}const e={Undefined:r(S.Undefined),String:r(S.String),Buffer:r(S.Buffer),VSBuffer:r(S.VSBuffer),Array:r(S.Array),Object:r(S.Object)},n=typeof Buffer!="undefined";function s(U,N){if(typeof N=="undefined")U.write(e.Undefined);else if(typeof N=="string"){const W=P.VSBuffer.fromString(N);U.write(e.String),U.write(o(W.byteLength)),U.write(W)}else if(n&&Buffer.isBuffer(N)){const W=P.VSBuffer.wrap(N);U.write(e.Buffer),U.write(o(W.byteLength)),U.write(W)}else if(N instanceof P.VSBuffer)U.write(e.VSBuffer),U.write(o(N.byteLength)),U.write(N);else if(Array.isArray(N)){U.write(e.Array),U.write(o(N.length));for(const W of N)s(U,W)}else{const W=P.VSBuffer.fromString(JSON.stringify(N));U.write(e.Object),U.write(o(W.byteLength)),U.write(W)}}function l(U){switch(U.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return U.read(t(U)).toString();case S.Buffer:return U.read(t(U)).buffer;case S.VSBuffer:return U.read(t(U));case S.Array:{const W=t(U),K=[];for(let te=0;te<W;te++)K.push(l(U));return K}case S.Object:return JSON.parse(U.read(t(U)).toString())}}class u{constructor(N,W,K=null,te=1e3){this.protocol=N,this.ctx=W,this.logger=K,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(N,W){this.channels.set(N,W),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const W=this.send([N.type]);this.logger?.logOutgoing(W,0,1,p(N.type));return}case 201:case 202:case 204:case 203:{const W=this.send([N.type,N.id],N.data);this.logger?.logOutgoing(W,N.id,1,p(N.type),N.data);return}}}send(N,W=void 0){const K=new y;return s(K,N),s(K,W),this.sendBuffer(K.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onRawMessage(N){const W=new h(N),K=l(W),te=l(W),J=K[0];switch(J){case 100:return this.logger?.logIncoming(N.byteLength,K[1],1,`${E(J)}: ${K[2]}.${K[3]}`,te),this.onPromise({type:J,id:K[1],channelName:K[2],name:K[3],arg:te});case 102:return this.logger?.logIncoming(N.byteLength,K[1],1,`${E(J)}: ${K[2]}.${K[3]}`,te),this.onEventListen({type:J,id:K[1],channelName:K[2],name:K[3],arg:te});case 101:return this.logger?.logIncoming(N.byteLength,K[1],1,`${E(J)}`),this.disposeActiveRequest({type:J,id:K[1]});case 103:return this.logger?.logIncoming(N.byteLength,K[1],1,`${E(J)}`),this.disposeActiveRequest({type:J,id:K[1]})}}onPromise(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const K=new I.CancellationTokenSource;let te;try{te=W.call(this.ctx,N.name,N.arg,K.token)}catch(k){te=Promise.reject(k)}const J=N.id;te.then(k=>{this.sendResponse({id:J,data:k,type:201}),this.activeRequests.delete(N.id)},k=>{k instanceof Error?this.sendResponse({id:J,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:J,data:k,type:203}),this.activeRequests.delete(N.id)});const Z=(0,g.toDisposable)(()=>K.cancel());this.activeRequests.set(N.id,Z)}onEventListen(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const K=N.id,J=W.listen(this.ctx,N.name,N.arg)(Z=>this.sendResponse({id:K,data:Z,type:204}));this.activeRequests.set(N.id,J)}disposeActiveRequest(N){const W=this.activeRequests.get(N.id);W&&(W.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let W=this.pendingRequests.get(N.channelName);W||(W=[],this.pendingRequests.set(N.channelName,W));const K=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:N,timeoutTimer:K})}flushPendingRequests(N){const W=this.pendingRequests.get(N);if(W){for(const K of W)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=u;var f;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(f=i.RequestInitiator||(i.RequestInitiator={}));class d{constructor(N,W=null){this.protocol=N,this.isDisposed=!1,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=W}getChannel(N){const W=this;return{call(K,te,J){return W.isDisposed?Promise.reject(b.canceled()):W.requestPromise(N,K,te,J)},listen(K,te){return W.isDisposed?c.Event.None:W.requestEvent(N,K,te)}}}requestPromise(N,W,K,te=I.CancellationToken.None){const J=this.lastRequestId++,k={id:J,type:100,channelName:N,name:W,arg:K};if(te.isCancellationRequested)return Promise.reject(b.canceled());let A;return new Promise((V,G)=>{if(te.isCancellationRequested)return G(b.canceled());const q=()=>{const me=oe=>{switch(oe.type){case 201:this.handlers.delete(J),V(oe.data);break;case 202:{this.handlers.delete(J);const ue=new Error(oe.data.message);ue.stack=oe.data.stack,ue.name=oe.data.name,G(ue);break}case 203:this.handlers.delete(J),G(oe.data);break}};this.handlers.set(J,me),this.sendRequest(k)};let se=null;this.state===a.Idle?q():(se=(0,R.createCancelablePromise)(me=>this.whenInitialized()),se.then(()=>{se=null,q()}));const le=()=>{se?(se.cancel(),se=null):this.sendRequest({id:J,type:101}),G(b.canceled())},ge=te.onCancellationRequested(le);A=(0,g.combinedDisposable)((0,g.toDisposable)(le),ge),this.activeRequests.add(A)}).finally(()=>{this.activeRequests.delete(A)})}requestEvent(N,W,K){const te=this.lastRequestId++,Z={id:te,type:102,channelName:N,name:W,arg:K};let k=null;const A=new c.Emitter({onFirstListenerAdd:()=>{k=(0,R.createCancelablePromise)(V=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(A),this.sendRequest(Z)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(A),this.sendRequest({id:te,type:103}))}}),z=V=>A.fire(V.data);return this.handlers.set(te,z),A.event}sendRequest(N){switch(N.type){case 100:case 102:{const W=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(W,N.id,0,`${E(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const W=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(W,N.id,0,E(N.type));return}}}send(N,W=void 0){const K=new y;return s(K,N),s(K,W),this.sendBuffer(K.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onBuffer(N){const W=new h(N),K=l(W),te=l(W),J=K[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,p(J)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,K[1],0,p(J),te),this.onResponse({type:K[0],id:K[1],data:te})}}onResponse(N){if(N.type===200){this.state=a.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(N.id);W&&W(N)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([O.memoize],d.prototype,"onDidInitializePromise",null),i.ChannelClient=d;class T{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:W,onDidClientDisconnect:K})=>{c.Event.once(W.onMessage)(J=>{const Z=new h(J),k=l(Z),A=new u(W,k),z=new d(W);this.channels.forEach((G,q)=>A.registerChannel(q,G));const V={channelServer:A,channelClient:z,ctx:k};this._connections.add(V),this._onDidAddConnection.fire(V),K(()=>{A.dispose(),z.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const N=[];return this._connections.forEach(W=>N.push(W)),N}getChannel(N,W){const K=this;return{call(te,J,Z){let k;if((0,v.isFunction)(W)){let z=(0,L.getRandomElement)(K.connections.filter(W));k=z?Promise.resolve(z):c.Event.toPromise(c.Event.filter(K.onDidAddConnection,W))}else k=W.routeCall(K,te,J);const A=k.then(z=>z.channelClient.getChannel(N));return H(A).call(te,J,Z)},listen(te,J){if((0,v.isFunction)(W))return K.getMulticastEvent(N,W,te,J);const Z=W.routeEvent(K,te,J).then(k=>k.channelClient.getChannel(N));return H(Z).listen(te,J)}}}getMulticastEvent(N,W,K,te){const J=this;let Z=new g.DisposableStore;const k=new c.Emitter({onFirstListenerAdd:()=>{Z=new g.DisposableStore;const A=new c.EventMultiplexer,z=new Map,V=q=>{const le=q.channelClient.getChannel(N).listen(K,te),ge=A.add(le);z.set(q,ge)},G=q=>{const se=z.get(q);!se||(se.dispose(),z.delete(q))};J.connections.filter(W).forEach(V),c.Event.filter(J.onDidAddConnection,W)(V,void 0,Z),J.onDidRemoveConnection(G,void 0,Z),A.event(k.fire,k,Z),Z.add(A)},onLastListenerRemove:()=>{Z.dispose()}});return k.event}registerChannel(N,W){this.channels.set(N,W),this._connections.forEach(K=>{K.channelServer.registerChannel(N,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=T;class M{constructor(N,W,K=null){const te=new y;s(te,W),N.send(te.buffer),this.channelClient=new d(N,K),this.channelServer=new u(N,W,K)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,W){this.channelServer.registerChannel(N,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=M;function H(U){return{call(N,W,K){return U.then(te=>te.call(N,W,K))},listen(N,W){const K=new c.Relay;return U.then(te=>K.input=te.listen(N,W)),K.event}}}i.getDelayedChannel=H;function X(U){let N=!1;return{call(W,K,te){return N?U.call(W,K,te):(0,R.timeout)(0).then(()=>N=!0).then(()=>U.call(W,K,te))},listen(W,K){if(N)return U.listen(W,K);const te=new c.Relay;return(0,R.timeout)(0).then(()=>N=!0).then(()=>te.input=U.listen(W,K)),te.event}}}i.getNextTickChannel=X;class ee{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const W of N.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await c.Event.toPromise(N.onDidAddConnection),await this.route(N)}}i.StaticRouter=ee;var ie;(function(U){function N(J,Z){const k=J,A=Z&&Z.disableMarshalling,z=new Map;for(const V in k)K(V)&&z.set(V,c.Event.buffer(k[V],!0));return new class{listen(V,G,q){const se=z.get(G);if(se)return se;if(te(G)){const le=k[G];if(typeof le=="function")return le.call(k,q)}throw new Error(`Event not found: ${G}`)}call(V,G,q){const se=k[G];if(typeof se=="function"){if(!A&&Array.isArray(q))for(let le=0;le<q.length;le++)q[le]=(0,C.revive)(q[le]);return se.apply(k,q)}throw new Error(`Method not found: ${G}`)}}}U.fromService=N;function W(J,Z){const k=Z&&Z.disableMarshalling;return new Proxy({},{get(A,z){if(typeof z=="string")return Z?.properties?.has(z)?Z.properties.get(z):te(z)?function(V){return J.listen(z,V)}:K(z)?J.listen(z):async function(...V){let G;Z&&!(0,v.isUndefinedOrNull)(Z.context)?G=[Z.context,...V]:G=V;const q=await J.call(z,G);return k?q:(0,C.revive)(q)};throw new Error(`Property not found: ${String(z)}`)}})}U.toService=W;function K(J){return J[0]==="o"&&J[1]==="n"&&D.isUpperAsciiLetter(J.charCodeAt(2))}function te(J){return/^onDynamic/.test(J)&&D.isUpperAsciiLetter(J.charCodeAt(9))}})(ie=i.ProxyChannel||(i.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let N=U.toString();if(N!=="[object Object]")return N}return U}function B(U){return Array.isArray(U)?U.map(fe):fe(U)}function _(U,N,W,K,te,J,Z){Z=B(Z);const k=ne[te],A=k[K%k.length];let z=[`%c[${U}]%c[${String(N).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(J)?(z=z.concat(Z),z.push(")")):z.push(Z),console.log.apply(console,z)}i.logWithColors=_;class re{constructor(N,W){this._outgoingPrefix=N,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,W,K,te,J){this._totalOutgoing+=N,_(this._outgoingPrefix,this._totalOutgoing,N,W,K,te,J)}logIncoming(N,W,K,te,J){this._totalIncoming+=N,_(this._incomingPrefix,this._totalIncoming,N,W,K,te,J)}}i.IPCLogger=re}),define(Y[65],Q([0,1,3,7,2,8]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var O;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=i.StorageHint||(i.StorageHint={}));function b(D){const v=D;return v?.changed instanceof Map||v?.deleted instanceof Set}i.isStorageItemsChangeEvent=b;var c;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(c=i.StorageState||(i.StorageState={}));class g extends P.Disposable{constructor(v,w=Object.create(null)){super();this.database=v,this.options=w,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((w,E)=>this.accept(E,w)),v.deleted?.forEach(w=>this.accept(w,void 0))}accept(v,w){if(this.state===c.Closed)return;let E=!1;(0,I.isUndefinedOrNull)(w)?E=this.cache.delete(v):this.cache.get(v)!==w&&(this.cache.set(v,w),E=!0),E&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,w){const E=this.cache.get(v);return(0,I.isUndefinedOrNull)(E)?w:E}getBoolean(v,w){const E=this.get(v);return(0,I.isUndefinedOrNull)(E)?w:E==="true"}getNumber(v,w){const E=this.get(v);return(0,I.isUndefinedOrNull)(E)?w:parseInt(E,10)}async set(v,w){if(this.state===c.Closed)return;if((0,I.isUndefinedOrNull)(w))return this.delete(v);const E=String(w);if(this.cache.get(v)!==E)return this.cache.set(v,E),this.pendingInserts.set(v,E),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===c.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((w,E)=>this.items.set(E,w)),v.delete&&v.delete.forEach(w=>this.items.delete(w))}async close(){}}i.InMemoryStorageDatabase=C}),define(Y[66],Q([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(Y[67],Q([0,1,66]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,P=R*60,I=P*24,O=I*7,b=I*30,c=I*365;function g(D,v,w){typeof D!="number"&&(D=D.getTime());const E=Math.round((new Date().getTime()-D)/1e3);if(E<-30)return(0,L.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(E<30)return(0,L.localize)(1,null);let m;return E<R?(m=E,v?m===1?w?(0,L.localize)(2,null,m):(0,L.localize)(3,null,m):w?(0,L.localize)(4,null,m):(0,L.localize)(5,null,m):m===1?w?(0,L.localize)(6,null,m):(0,L.localize)(7,null,m):w?(0,L.localize)(8,null,m):(0,L.localize)(9,null,m)):E<P?(m=Math.floor(E/R),v?m===1?w?(0,L.localize)(10,null,m):(0,L.localize)(11,null,m):w?(0,L.localize)(12,null,m):(0,L.localize)(13,null,m):m===1?w?(0,L.localize)(14,null,m):(0,L.localize)(15,null,m):w?(0,L.localize)(16,null,m):(0,L.localize)(17,null,m)):E<I?(m=Math.floor(E/P),v?m===1?w?(0,L.localize)(18,null,m):(0,L.localize)(19,null,m):w?(0,L.localize)(20,null,m):(0,L.localize)(21,null,m):m===1?w?(0,L.localize)(22,null,m):(0,L.localize)(23,null,m):w?(0,L.localize)(24,null,m):(0,L.localize)(25,null,m)):E<O?(m=Math.floor(E/I),v?m===1?(0,L.localize)(26,null,m):(0,L.localize)(27,null,m):m===1?(0,L.localize)(28,null,m):(0,L.localize)(29,null,m)):E<b?(m=Math.floor(E/O),v?m===1?w?(0,L.localize)(30,null,m):(0,L.localize)(31,null,m):w?(0,L.localize)(32,null,m):(0,L.localize)(33,null,m):m===1?w?(0,L.localize)(34,null,m):(0,L.localize)(35,null,m):w?(0,L.localize)(36,null,m):(0,L.localize)(37,null,m)):E<c?(m=Math.floor(E/b),v?m===1?w?(0,L.localize)(38,null,m):(0,L.localize)(39,null,m):w?(0,L.localize)(40,null,m):(0,L.localize)(41,null,m):m===1?w?(0,L.localize)(42,null,m):(0,L.localize)(43,null,m):w?(0,L.localize)(44,null,m):(0,L.localize)(45,null,m)):(m=Math.floor(E/c),v?m===1?w?(0,L.localize)(46,null,m):(0,L.localize)(47,null,m):w?(0,L.localize)(48,null,m):(0,L.localize)(49,null,m):m===1?w?(0,L.localize)(50,null,m):(0,L.localize)(51,null,m):w?(0,L.localize)(52,null,m):(0,L.localize)(53,null,m))}i.fromNow=g;function C(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=C}),define(Y[68],Q([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(Y[28],Q([0,1,18,8,68]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function I(D,v){return v&&(D.stack||D.stacktrace)?P.localize(0,null,b(D),O(D.stack)||O(D.stacktrace)):b(D)}function O(D){return Array.isArray(D)?D.join(`
`):D}function b(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function c(D=null,v=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const w=L.coalesce(D),E=c(w[0],v);return w.length>1?P.localize(4,null,E,w.length):E}if(R.isString(D))return D;if(D.detail){const w=D.detail;if(w.error)return I(w.error,v);if(w.exception)return I(w.exception,v)}return D.stack?I(D,v):D.message?D.message:P.localize(5,null)}i.toErrorMessage=c;function g(D){const v=D;return v instanceof Error&&Array.isArray(v.actions)}i.isErrorWithActions=g;function C(D,v=Object.create(null)){const w=new Error(D);return v.actions&&(w.actions=v.actions),w}i.createErrorWithActions=C}),define(Y[69],Q([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(Y[47],Q([0,1,39,45,12,22,10,11,29,57,8,63,15,69]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function E(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(t,r){if(b.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=L.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(s=>{n.once("error",l=>{s({success:!1,error:l})}),n.once("exit",(l,u)=>{s(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?E(e.status):1})}else if(b.isLinux||b.isMacintosh)try{const e=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{L.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(s,l,u)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function p(t){!t||(delete t.DEBUG,b.isMacintosh&&delete t.DYLD_LIBRARY_PATH,b.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=p;function a(t=c.env){return t.comspec||"cmd.exe"}i.getWindowsShell=a;class h{constructor(r,e,n,s){if(e!==void 0&&n!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=s;else{const l=r;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(c.env).forEach(u=>{l[u]=c.env[u]}),Object.keys(this.options.env).forEach(u=>{l[u]=this.options.env[u]}),this.options.env=l}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(O.sep);return e!==-1&&(r=r.substring(e+1)),h.WellKnowCommands[r]?r:"other"}start(r){return b.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(c.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(e=>{let n,s;const l=new Promise((u,f)=>{n=u,s=f});if(e){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=L.exec(u,this.options,(f,d,T)=>{this.childProcess=null;const M=f;M&&M.killed?s({killed:this.terminateRequested,stdout:d.toString(),stderr:T.toString()}):this.handleExec(n,r,f,d,T)})}else{let u=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,r,s);const T={terminated:this.terminateRequested};C.isNumber(d)&&(T.cmdCode=d),n(T)};if(this.shell&&b.isWindows){const d=I.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let T=!1,M=!1;const H=[];let X=this.ensureQuotes(this.cmd);H.push(X.value),T=X.quoted,this.args&&this.args.forEach(ie=>{X=this.ensureQuotes(ie),H.push(X.value),M=M&&X.quoted});const ee=["/s","/c"];T?M?ee.push('"'+H.join(" ")+'"'):H.length>1?ee.push('"'+H[0]+'" '+H.slice(1).join(" ")):ee.push('"'+H[0]+'"'):ee.push(H.join(" ")),u=L.spawn(a(),ee,d)}else this.cmd&&(u=L.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",d=>{this.childProcess=null,s({terminated:this.terminateRequested,error:d})}),u.pid&&(this.childProcess.on("close",f),this.handleSpawn(u,n,r,s,!0)))}return l})}handleClose(r,e,n,s){}ensureQuotes(r){return h.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,m(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!b.isWindows)return r(!1);const e=L.spawn(a(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}i.AbstractProcess=h,h.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},h.regexp=/^[^"].* .*[^"]/;class y extends h{constructor(r,e,n,s){super(r,e,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,s,l){[s,l].forEach((u,f)=>{const d=new D.LineDecoder;d.write(u).forEach(H=>{e({line:H,source:f===0?0:1})});const M=d.end();M&&e({line:M,source:f===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,s,l){const u=new D.LineDecoder,f=new D.LineDecoder;r.stdout.on("data",d=>{u.write(d).forEach(M=>n({line:M,source:0}))}),r.stderr.on("data",d=>{f.write(d).forEach(M=>n({line:M,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=f}handleClose(r,e,n,s){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}i.LineProcess=y;function S(t){let r=[],e=!1;const n=function(s){if(e){r.push(s);return}(!t.send(s,u=>{if(u&&console.error(u),e=!1,r.length>0){const f=r.slice(0);r=[],f.forEach(d=>n(d))}})||b.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=S;var o;(function(t){async function r(e,n,s){if(O.isAbsolute(e))return e;if(n===void 0&&(n=c.cwd()),O.dirname(e)!=="."||(s===void 0&&C.isString(c.env.PATH)&&(s=c.env.PATH.split(O.delimiter)),s===void 0||s.length===0))return O.join(n,e);async function u(f){if(await v.Promises.exists(f)){let d;try{d=await v.Promises.stat(f)}catch(T){T.message.startsWith("EACCES")&&(d=await v.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(let f of s){let d;if(O.isAbsolute(f)?d=O.join(f,e):d=O.join(n,f,e),await u(d))return d;let T=d+".com";if(await u(T)||(T=d+".exe",await u(T)))return T}return O.join(n,e)}t.findExecutable=r})(o=i.win32||(i.win32={}))}),define(Y[70],Q([0,1,33,11,64,47]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function O(w,E){return w===1?R.isWindows?D():I.getWindowsShell(E):g(w,E)}i.getSystemShell=O;function b(w,E){return w===1?R.isWindows?v(E):I.getWindowsShell(E):g(w,E)}i.getSystemShellSync=b;let c=null;function g(w,E){if(R.isLinux&&w===2||R.isMacintosh&&w===3)return"/bin/bash";if(!c){let m;if(R.isWindows)m="/bin/bash";else{if(m=E.SHELL,!m)try{m=(0,L.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}c=m}return c}let C=null;async function D(){return C||(C=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),C}function v(w){if(C)return C;const E=R.isWindows&&parseFloat((0,L.release)())>=10,m=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${w.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return E?p:I.getWindowsShell(w)}}),define(Y[71],Q([0,1,39,3,17,25,60,6,7,2,22,47,46]),function(x,i,L,R,P,I,O,b,c,g,C,D,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class w extends v.ChannelServer{constructor(p){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",a=>P.VSBuffer.wrap(Buffer.from(a,"base64")))},p);process.once("disconnect",()=>this.dispose())}}i.Server=w;class E{constructor(p,a){this.modulePath=p,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new R.Delayer(h),this.child=null,this._client=null}getChannel(p){const a=this;return{call(h,y,S){return a.requestPromise(p,h,y,S)},listen(h,y){return a.requestEvent(p,h,y)}}}requestPromise(p,a,h,y=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(p),o=(0,R.createCancelablePromise)(e=>S.call(a,h,e)),t=y.onCancellationRequested(()=>o.cancel()),r=(0,g.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{t.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(p,a,h){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let y;const S=new c.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(p).listen(a,h)(S.fire,S),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(a.env={...a.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,D.removeDangerousEnvVariables)(a.env),this.child=(0,L.fork)(this.modulePath,p,a);const h=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,O.isRemoteConsoleLog)(n)){(0,O.log)(n,`IPC Library: ${this.options.serverName}`);return}h.fire(P.VSBuffer.wrap(Buffer.from(n,"base64")))});const S=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&S.send(n.buffer.toString("base64")),t=h.event,r={send:o,onMessage:t};this._client=new v.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(l=>(0,g.dispose)(l)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(p){let a=this.channels.get(p);return a||(a=this.client.getChannel(p),this.channels.set(p,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=E}),define(Y[72],Q([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(Y[73],Q([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Y[74],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Y[75],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Y[76],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Y[77],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Y[78],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Y[79],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Y[80],Q([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(Y[81],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(Y[82],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(Y[83],Q([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Y[84],Q([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(Y[85],Q([4,5]),function(x,i){return x.create("vs/platform/shell/node/shellEnv",i)}),define(Y[86],Q([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(Y[87],Q([0,1,67,44,12,10,29,19,9]),function(x,i,L,R,P,I,O,b,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class g{constructor(m,p,a){this._args=m,this.paths=p,this.productService=a}get appRoot(){return(0,I.dirname)(P.FileAccess.asFileUri("",x).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(c.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=O.env.VSCODE_PORTABLE;return m?c.URI.file((0,I.join)(m,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,I.resolve)(m):(0,I.normalize)((0,I.join)(P.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,I.resolve)(m):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,I.resolve)(m);const p=O.env.VSCODE_EXTENSIONS;if(p)return p;const a=O.env.VSCODE_PORTABLE;return a?(0,I.join)(a,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(p=>/^[^:/?#]+?:\/\//.test(p)?c.URI.parse(p):c.URI.file((0,I.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?c.URI.parse(m):c.URI.file((0,I.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([R.memoize],g.prototype,"appRoot",null),he([R.memoize],g.prototype,"userHome",null),he([R.memoize],g.prototype,"userDataPath",null),he([R.memoize],g.prototype,"appSettingsHome",null),he([R.memoize],g.prototype,"tmpDir",null),he([R.memoize],g.prototype,"cacheHome",null),he([R.memoize],g.prototype,"userRoamingDataHome",null),he([R.memoize],g.prototype,"settingsResource",null),he([R.memoize],g.prototype,"userDataSyncHome",null),he([R.memoize],g.prototype,"userDataSyncLogResource",null),he([R.memoize],g.prototype,"sync",null),he([R.memoize],g.prototype,"machineSettingsResource",null),he([R.memoize],g.prototype,"globalStorageHome",null),he([R.memoize],g.prototype,"workspaceStorageHome",null),he([R.memoize],g.prototype,"localHistoryHome",null),he([R.memoize],g.prototype,"keybindingsResource",null),he([R.memoize],g.prototype,"keyboardLayoutResource",null),he([R.memoize],g.prototype,"argvResource",null),he([R.memoize],g.prototype,"snippetsHome",null),he([R.memoize],g.prototype,"isExtensionDevelopment",null),he([R.memoize],g.prototype,"untitledWorkspacesHome",null),he([R.memoize],g.prototype,"installSourcePath",null),he([R.memoize],g.prototype,"builtinExtensionsPath",null),he([R.memoize],g.prototype,"extensionsPath",null),he([R.memoize],g.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],g.prototype,"extensionDevelopmentKind",null),he([R.memoize],g.prototype,"extensionTestsLocationURI",null),he([R.memoize],g.prototype,"debugExtensionHost",null),he([R.memoize],g.prototype,"serviceMachineIdResource",null),he([R.memoize],g.prototype,"telemetryLogResource",null),he([R.memoize],g.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=g;function C(E,m){return w(E["inspect-extensions"],E["inspect-brk-extensions"],5870,m,E.debugId,E.extensionEnvironment)}i.parseExtensionHostPort=C;function D(E,m){return w(E["inspect-search"],E["inspect-brk-search"],5876,m,E.extensionEnvironment)}i.parseSearchPort=D;function v(E,m){return w(E["inspect-ptyhost"],E["inspect-brk-ptyhost"],5877,m,E.extensionEnvironment)}i.parsePtyHostPort=v;function w(E,m,p,a,h,y){const o=Number(m||E)||(a?null:p),t=o?Boolean(!!m):!1;let r;if(y)try{r=JSON.parse(y)}catch{}return{port:o,break:t,debugId:h,env:r}}}),function(){"use strict";function x(i,L,R,P){function I(b){const c=O(b),g=[c];return i.isAbsolute(c)||g.unshift(P),i.resolve(...g)}function O(b){const c=process.env.VSCODE_PORTABLE;if(c)return i.join(c,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return i.join(g,R);const C=b["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=i.join(D,"AppData","Roaming")}break;case"darwin":g=i.join(L.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||i.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(g,R)}return{getUserDataPath:I}}if(typeof define=="function")define(Y[88],Q([0,133,33,12,19,29]),function(i,L,R,P,I,O){const b=I.dirname(P.FileAccess.asFileUri("",i)),c=i.__$__nodeRequire(I.joinPath(b,"package.json").fsPath);return x(L,R,c.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),L=require("path"),R=require("os");module.exports=x(L,R,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],Q([0,1,33,87,88]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class I extends R.AbstractNativeEnvironmentService{constructor(b,c){super(b,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,P.getUserDataPath)(b)},c)}}i.NativeEnvironmentService=I}),define(Y[90],Q([0,1,22]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function P(I,O){const b=c=>{if(typeof c!="string")return;const g=R.exec(c);if(!g)return;const C=O[g[1]]??c;return typeof C=="string"?C:typeof C.message=="string"?C.message:c};return(0,L.cloneAndChange)(I,b)}i.localizeManifest=P}),define(Y[48],Q([0,1,80]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(v){return v=v.trim(),v==="*"||R.test(v)}i.isValidVersionStr=I;function O(v){if(!I(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=v.match(R);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}i.parseVersion=O;function b(v){if(!v)return null;let w=v.majorBase,E=v.majorMustEqual,m=v.minorBase,p=v.minorMustEqual,a=v.patchBase,h=v.patchMustEqual;v.hasCaret&&(w===0||(p=!1),h=!1);let y=0;if(v.preRelease){const S=P.exec(v.preRelease);if(S){const[,o,t,r]=S;y=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:w,majorMustEqual:E,minorBase:m,minorMustEqual:p,patchBase:a,patchMustEqual:h,isMinimum:v.hasGreaterEquals,notBefore:y}}i.normalizeVersion=b;function c(v,w,E){let m;typeof v=="string"?m=b(O(v)):m=v;let p;w instanceof Date?p=w.getTime():typeof w=="string"&&(p=new Date(w).getTime());let a;if(typeof E=="string"?a=b(O(E)):a=E,!m||!a)return!1;let h=m.majorBase,y=m.minorBase,S=m.patchBase,o=a.majorBase,t=a.minorBase,r=a.patchBase,e=a.notBefore,n=a.majorMustEqual,s=a.minorMustEqual,l=a.patchMustEqual;return a.isMinimum?h>o?!0:h<o?!1:y>t?!0:y<t||p&&p<e?!1:S>=r:(h===1&&o===0&&(!n||!s||!l)&&(o=1,t=0,r=0,n=!0,s=!1,l=!1),h<o?!1:h>o?!n:y<t?!1:y>t?!s:S<r?!1:S>r?!l:!(p&&p<e))}i.isValidVersion=c;function g(v,w,E,m,p){return m||typeof E.main=="undefined"&&typeof E.browser=="undefined"?!0:D(v,w,E.engines.vscode,p)}i.isValidExtensionVersion=g;function C(v,w,E){return v==="*"||D(w,E,v)}i.isEngineValid=C;function D(v,w,E,m=[]){let p=b(O(E));if(!p)return m.push(L.localize(0,null,E)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return m.push(L.localize(1,null,E)),!1}else if(!p.majorMustEqual)return m.push(L.localize(2,null,E)),!1;return c(v,w,p)?!0:(m.push(L.localize(3,null,v,E)),!1)}}),define(Y[91],Q([0,1,17,27]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(I,O,b){let c=b&&b.get("storage.serviceMachineId",0)||null;if(c)return c;try{const C=(await O.readFile(I.serviceMachineIdResource)).value.toString();c=(0,R.isUUID)(C)?C:null}catch{c=null}if(!c){c=(0,R.generateUuid)();try{await O.writeFile(I.serviceMachineIdResource,L.VSBuffer.fromString(c))}catch{}}return b&&b.store("storage.serviceMachineId",c,0,1),c}i.getServiceMachineId=P}),define(Y[40],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class L{constructor(P,I=[],O=!1){this.ctor=P,this.staticArguments=I,this.supportsDelayedInstantiation=O}}i.SyncDescriptor=L}),define(Y[92],Q([0,1,40]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const R=[];function P(O,b,c){b instanceof L.SyncDescriptor||(b=new L.SyncDescriptor(b,[],c)),R.push([O,b])}i.registerSingleton=P;function I(){return R}i.getSingletonServiceDescriptors=I}),define(Y[93],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class L{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}i.Node=L;class R{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let O of this._nodes.values())O.outgoing.size===0&&I.push(O);return I}insertEdge(I,O){const b=this.lookupOrInsertNode(I),c=this.lookupOrInsertNode(O);b.outgoing.set(this._hashFn(O),c),c.incoming.set(this._hashFn(I),b)}removeNode(I){const O=this._hashFn(I);this._nodes.delete(O);for(let b of this._nodes.values())b.outgoing.delete(O),b.incoming.delete(O)}lookupOrInsertNode(I){const O=this._hashFn(I);let b=this._nodes.get(O);return b||(b=new L(I),this._nodes.set(O,b)),b}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[O,b]of this._nodes)I.push(`${O}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,O]of this._nodes){const b=new Set([I]),c=this._findCycle(O,b);if(c)return c}}_findCycle(I,O){for(let[b,c]of I.outgoing){if(O.has(b))return[...O,b].join(" -> ");O.add(b);const g=this._findCycle(c,O);if(g)return g;O.delete(b)}}}i.Graph=R}),define(Y[23],Q([0,1,8,9,13]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function I(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}i.isConfigurationOverrides=I;function O(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||L.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=O;var b;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(b=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=c;function g(a,h){const y=Object.create(null);for(let S in a)C(y,S,a[S],h);return y}i.toValuesTree=g;function C(a,h,y,S){const o=h.split("."),t=o.pop();let r=a;for(let e=0;e<o.length;e++){let n=o[e],s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:S(`Ignoring ${h} as ${o.slice(0,e+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[t]=y}catch{S(`Ignoring ${h} as ${o.join(".")} is ${JSON.stringify(r)}`)}else S(`Ignoring ${h} as ${o.join(".")} is ${JSON.stringify(r)}`)}i.addToValueTree=C;function D(a,h){const y=h.split(".");v(a,y)}i.removeFromValueTree=D;function v(a,h){const y=h.shift();if(h.length===0){delete a[y];return}if(Object.keys(a).indexOf(y)!==-1){const S=a[y];typeof S=="object"&&!Array.isArray(S)&&(v(S,h),Object.keys(S).length===0&&delete a[y])}}function w(a,h,y){function S(r,e){let n=r;for(const s of e){if(typeof n!="object"||n===null)return;n=n[s]}return n}const o=h.split("."),t=S(a,o);return typeof t=="undefined"?y:t}i.getConfigurationValue=w;function E(a,h,y){Object.keys(h).forEach(S=>{S!=="__proto__"&&(S in a?L.isObject(a[S])&&L.isObject(h[S])?E(a[S],h[S],y):y&&(a[S]=h[S]):a[S]=h[S])})}i.merge=E;function m(a,h,y){const S=a.inspect(h),o=a.inspect(y);return typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:S.defaultValue}i.getMigratedSettingValue=m;function p(a){return a.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=p}),define(Y[49],Q([0,1,13]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,L.createDecorator)("downloadService")}),define(Y[20],Q([0,1,13]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,L.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,L.refineServiceDecorator)(i.IEnvironmentService)}),define(Y[21],Q([0,1,75,13]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function P(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=P;function I(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=I;function O(a,h){switch(a){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=O;function b(a,h){return h==="web"&&!a.includes("web")}i.isNotWebExtensionInWebTargetPlatform=b;function c(a,h,y){return b(h,y)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===y?!0:g(y).includes(a)}i.isTargetPlatformCompatible=c;function g(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=g;function C(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}i.isIExtensionIdentifier=C;var D;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(D=i.SortBy||(i.SortBy={}));var v;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(v=i.SortOrder||(i.SortOrder={}));var w;(function(a){a.Install="install",a.Uninstall="uninstall"})(w=i.StatisticType||(i.StatisticType={}));var E;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(E=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var m;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class p extends Error{constructor(h,y){super(h);this.code=y,this.name=y}}i.ExtensionManagementError=p,i.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,L.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,L.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Y[50],Q([0,1,17,6,82,16]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function O(C,D,v,w,E,m){let p;try{await b(C,D,v,w,E,m)}catch(a){p=a}finally{p&&E.errorTransformer&&(p=E.errorTransformer(p)),typeof p!="undefined"&&v.error(p),v.end()}}i.readFileIntoStream=O;async function b(C,D,v,w,E,m){c(m);const p=await C.open(D,{create:!1});try{c(m);let a=0,h=0,y=E&&typeof E.length=="number"?E.length:void 0,S=L.VSBuffer.alloc(Math.min(E.bufferSize,typeof y=="number"?y:E.bufferSize)),o=E&&typeof E.position=="number"?E.position:0,t=0;do h=await C.read(p,o,S.buffer,t,S.byteLength-t),o+=h,t+=h,a+=h,typeof y=="number"&&(y-=h),t===S.byteLength&&(await v.write(w(S)),S=L.VSBuffer.alloc(Math.min(E.bufferSize,typeof y=="number"?y:E.bufferSize)),t=0);while(h>0&&(typeof y!="number"||y>0)&&c(m)&&g(a,E));if(t>0){let r=t;typeof y=="number"&&(r=Math.min(t,y)),v.write(w(S.slice(0,r)))}}catch(a){throw(0,I.ensureFileSystemProviderError)(a)}finally{await C.close(p)}}function c(C){if(C.isCancellationRequested)throw(0,R.canceled)();return!0}function g(C,D){if(D?.limits){if(typeof D.limits.memory=="number"&&C>D.limits.memory)throw(0,I.createFileSystemProviderError)((0,P.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof D.limits.size=="number"&&C>D.limits.size)throw(0,I.createFileSystemProviderError)((0,P.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[94],Q([0,1,18,7,2,11,134]),function(x,i,L,R,P,I,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class b extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(g){const C=this.normalizeRequests(g),D=C.filter(w=>{const E=this.watchers.get(w.path);return E?!(0,L.equals)(E.request.excludes,w.excludes):!0}),v=Array.from(this.watchers.values()).filter(({request:w})=>!C.find(E=>E.path===w.path&&(0,L.equals)(E.excludes,w.excludes))).map(({request:w})=>w.path);D.length&&this.trace(`Request to start watching: ${D.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const w of v)this.stopWatching(w);for(const w of D)this.startWatching(w)}startWatching(g){const C=new O.NodeJSFileWatcherLibrary(g,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),D={request:g,instance:C};this.watchers.set(g.path,D)}async stop(){for(const[g]of this.watchers)this.stopWatching(g);this.watchers.clear()}stopWatching(g){const C=this.watchers.get(g);C&&(this.watchers.delete(g),C.instance.dispose())}normalizeRequests(g){const C=new Map;for(const D of g){const v=I.isLinux?D.path:D.path.toLowerCase();C.set(v,D)}return Array.from(C.values())}async setVerboseLogging(g){this.verboseLogging=g;for(const[,C]of this.watchers)C.instance.setVerboseLogging(g)}trace(g){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(g)})}toMessage(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}i.NodeJSWatcher=b}),define(Y[95],Q([0,1,51,94]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends L.AbstractNonRecursiveWatcherClient{constructor(O,b,c){super(O,b,c);this.init()}createWatcher(){return new R.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(Y[96],Q([0,1,12,46,71,51]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class O extends I.AbstractUniversalWatcherClient{constructor(c,g,C){super(c,g,C);this.init()}createWatcher(c){const g=c.add(new P.Client(L.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(g.onDidProcessExit(({code:C,signal:D})=>this.onError(`terminated by itself with code ${C}, signal: ${D}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(g.getChannel("watcher")))}}i.UniversalWatcherClient=O}),define(Y[52],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class L{constructor(...P){this._entries=new Map;for(let[I,O]of P)this.set(I,O)}set(P,I){const O=this._entries.get(P);return this._entries.set(P,I),O}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=L}),define(Y[97],Q([0,1,3,6,40,93,13,52]),function(x,i,L,R,P,I,O,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const c=!1;class g extends Error{constructor(E){super("cyclic dependency between services");this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class C{constructor(E=new b.ServiceCollection,m=!1,p){this._activeInstantiations=new Set,this._services=E,this._strict=m,this._parent=p,this._services.set(O.IInstantiationService,this)}createChild(E){return new C(E,this._strict,this)}invokeFunction(E,...m){let p=v.traceInvocation(E),a=!1;try{return E({get:y=>{if(a)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(y,p);if(!S)throw new Error(`[invokeFunction] unknown service '${y}'`);return S}},...m)}finally{a=!0,p.stop()}}createInstance(E,...m){let p,a;return E instanceof P.SyncDescriptor?(p=v.traceCreation(E.ctor),a=this._createInstance(E.ctor,E.staticArguments.concat(m),p)):(p=v.traceCreation(E),a=this._createInstance(E,m,p)),p.stop(),a}_createInstance(E,m=[],p){let a=O._util.getServiceDependencies(E).sort((S,o)=>S.index-o.index),h=[];for(const S of a){let o=this._getOrCreateServiceInstance(S.id,p);o||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${S.id}.`,!1),h.push(o)}let y=a.length>0?a[0].index:m.length;if(m.length!==y){console.trace(`[createInstance] First service dependency of ${E.name} at position ${y+1} conflicts with ${m.length} static arguments`);let S=y-m.length;S>0?m=m.concat(new Array(S)):m=m.slice(0,y)}return new E(...[...m,...h])}_setServiceInstance(E,m){if(this._services.get(E)instanceof P.SyncDescriptor)this._services.set(E,m);else if(this._parent)this._parent._setServiceInstance(E,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){let m=this._services.get(E);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):m}_getOrCreateServiceInstance(E,m){let p=this._getServiceInstanceOrDescriptor(E);return p instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,p,m.branch(E,!0)):(m.branch(E,!1),p)}_safeCreateAndCacheServiceInstance(E,m,p){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,m,p)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,m,p){const a=new I.Graph(S=>S.id.toString());let h=0;const y=[{id:E,desc:m,_trace:p}];for(;y.length;){const S=y.pop();if(a.lookupOrInsertNode(S),h++>1e3)throw new g(a);for(let o of O._util.getServiceDependencies(S.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),t instanceof P.SyncDescriptor){const r={id:o.id,desc:t,_trace:S._trace.branch(o.id,!0)};a.insertEdge(S,r),y.push(r)}}}for(;;){const S=a.roots();if(S.length===0){if(!a.isEmpty())throw new g(a);break}for(const{data:o}of S){if(this._getServiceInstanceOrDescriptor(o.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}a.removeNode(o)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,m,p=[],a,h){if(this._services.get(E)instanceof P.SyncDescriptor)return this._createServiceInstance(m,p,a,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,m,p,a,h);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(E,m=[],p,a){if(p){const h=new L.IdleValue(()=>this._createInstance(E,m,a));return new Proxy(Object.create(null),{get(y,S){if(S in y)return y[S];let o=h.value,t=o[S];return typeof t!="function"||(t=t.bind(o),y[S]=t),t},set(y,S,o){return h.value[S]=o,!0}})}else return this._createInstance(E,m,a)}_throwIfStrict(E,m){if(m&&console.warn(m),this._strict)throw new Error(E)}}i.InstantiationService=C;var D;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(D||(D={}));class v{constructor(E,m){this.type=E,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(E){return c?new v(1,E.name||E.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(E){return c?new v(0,E.name):v._None}branch(E,m){let p=new v(2,E.toString());return this._dep.push([E,m,p]),p}stop(){let E=Date.now()-this._start;v._totals+=E;let m=!1;function p(h,y){let S=[],o=new Array(h+1).join("	");for(const[t,r,e]of y._dep)if(r&&e){m=!0,S.push(`${o}CREATES -> ${t}`);let n=p(h+1,e);n&&S.push(n)}else S.push(`${o}uses -> ${t}`);return S.join(`
`)}let a=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(E>2||m)&&console.log(a.join(`
`))}}i.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(Y[53],Q([0,1,13]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,L.createDecorator)("localizationsService");function R(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const I of P.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}i.isValidLocalization=R}),define(Y[14],Q([0,1,28,7,2,11,13]),function(x,i,L,R,P,I,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,O.createDecorator)("logService"),i.ILoggerService=(0,O.createDecorator)("loggerService");function b(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function g(r,e,n){switch(e){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=g;function C(r){let e="";for(let n=0;n<r.length;n++){let s=r[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(n>0?" ":"")+s}return e}i.format=C;class D extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=D;class v extends D{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,C([e,...n]))}debug(e,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,C([e,...n]))}info(e,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,C([e,...n]))}warn(e,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,C([e,...n]))}error(e,...n){if(this.checkLogLevel(c.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(c.Error,C(s))}else this.log(c.Error,C([e,...n]))}critical(e,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,C([e,...n]))}flush(){}}i.AbstractMessageLogger=v;class w extends D{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...n):console.log(`[main ${b()}]`,e,...n))}debug(e,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...n):console.log(`[main ${b()}]`,e,...n))}info(e,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...n):console.log(`[main ${b()}]`,e,...n))}warn(e,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,e,...n):console.warn(`[main ${b()}]`,e,...n))}error(e,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,e,...n):console.error(`[main ${b()}]`,e,...n))}critical(e,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,e,...n):console.error(`[main ${b()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=w;class E extends D{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=E;class m extends D{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,L.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=m;class p extends D{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const s of this.logServices)s.trace(e,...n)}debug(e,...n){for(const s of this.logServices)s.debug(e,...n)}info(e,...n){for(const s of this.logServices)s.info(e,...n)}warn(e,...n){for(const s of this.logServices)s.warn(e,...n)}error(e,...n){for(const s of this.logServices)s.error(e,...n)}critical(e,...n){for(const s of this.logServices)s.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=p;class a extends P.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=a;class h extends P.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,n?.always?c.Trace:this.logLevel,n),this.loggers.set(e.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=h;class y{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=y;function S(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=o(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=S;function o(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=o;function t(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=t});var ae=this&&this.__param||function(x,i){return function(L,R){i(L,R,x)}};define(Y[98],Q([0,1,39,3,28,7,2,12,10,15,20,14]),function(x,i,L,R,P,I,O,b,c,g,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let v=class extends O.Disposable{constructor(E,m){super();this.environmentService=E,this.logService=m,this.processesLimiter=new R.Limiter(5)}async postUninstall(E){const m=this.parseScript(E,"uninstall");return m&&(this.logService.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,E).then(()=>this.logService.info(E.identifier.id,E.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(E.identifier.id,E.manifest.version,`Failed to run post uninstall script: ${p}`)))),g.Promises.rm(this.getExtensionStoragePath(E)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(E,m){const p=`vscode:${m}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[p]=="string"){const a=E.manifest.scripts[p].split(" ");return a.length<2||a[0]!=="node"||!a[1]?(this.logService.warn(E.identifier.id,E.manifest.version,`${p} should be a node script`),null):{script:(0,c.join)(E.location.fsPath,a[1]),args:a.slice(2)||[]}}return null}runLifecycleHook(E,m,p,a,h){return new Promise((y,S)=>{const o=this.start(E,m,p,h);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?S(e):y(void 0)};o.on("error",e=>{r((0,P.toErrorMessage)(e)||"Unknown")}),o.on("exit",(e,n)=>{r(e?`post-${m} process exited with code ${e}`:void 0)}),a&&(t=setTimeout(()=>{t=null,o.kill(),S("timed out")},5e3))})}start(E,m,p,a){const h={silent:!0,execArgv:void 0},y=(0,L.fork)(E,[`--type=extension-post-${m}`,...p],h);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const S=I.Event.fromNodeEventEmitter(y.stdout,"data"),o=I.Event.fromNodeEventEmitter(y.stderr,"data");S(e=>this.logService.info(a.identifier.id,a.manifest.version,`post-${m}`,e)),o(e=>this.logService.error(a.identifier.id,a.manifest.version,`post-${m}`,e));const t=I.Event.any(I.Event.map(S,e=>({data:`%c${e}`,format:[""]})),I.Event.map(o,e=>({data:`%c${e}`,format:["color: red"]})));return I.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(a.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),y}getExtensionStoragePath(E){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};v=he([ae(0,C.IEnvironmentService),ae(1,D.ILogService)],v),i.ExtensionsLifecycle=v}),define(Y[99],Q([0,1,18,3,6,7,2,10,51,14]),function(x,i,L,R,P,I,O,b,c,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class C extends O.Disposable{constructor(v,w){super();this.logService=v,this.options=w,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(v,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,w):this.watchNonRecursive(v,w)}watchUniversal(v,w){const E={path:this.toFilePath(v),excludes:w.excludes,recursive:w.recursive},m=(0,L.insert)(this.universalPathsToWatch,E);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,P.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,c.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const w of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const w of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(w)&&v.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,w){const E={path:this.toFilePath(v),excludes:w.excludes,recursive:!1},m=(0,L.insert)(this.nonRecursivePathsToWatch,E);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,P.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,c.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,b.normalize)(v.fsPath)}}i.AbstractDiskFileSystemProvider=C}),define(Y[100],Q([0,1,18,3,17,25,7,59,135,2,54,12,101,19,38,81,16,50,14]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m,p,a,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let y=class extends g.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(o,t){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const r=new g.DisposableStore;return this.provider.set(o,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:t}),r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new p.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:o}))),(0,g.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:t}),this.provider.delete(o),(0,g.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){t.push(r)}}),!this.provider.has(o)&&await R.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,t){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return c.Iterable.map(this.provider,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async withProvider(o){if(!(0,w.isAbsolutePath)(o))throw new p.FileOperationError((0,m.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const t=this.provider.get(o.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,m.localize)(1,null,o.toString()),r}return t}async withReadProvider(o){const t=await this.withProvider(o);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t)||(0,p.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const t=await this.withProvider(o);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.doResolveFile(o,t)}catch(r){throw(0,p.toFileSystemProviderErrorCode)(r)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,m.localize)(2,null,this.resourceForError(o)),1):(0,p.ensureFileSystemProviderError)(r)}}async doResolveFile(o,t){const r=await this.withProvider(o),e=this.isPathCaseSensitive(r),n=t?.resolveTo,s=t?.resolveSingleChildDescendants,l=t?.resolveMetadata,u=await r.stat(o);let f;return this.toFileStat(r,o,u,void 0,!!l,(d,T)=>(f||(f=C.TernarySearchTree.forUris(()=>!e),f.set(o,!0),n&&f.fill(!0,n)),f.get(d.resource)||f.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&s?T===1:!1))}async toFileStat(o,t,r,e,n,s){const{providerExtUri:l}=this.getExtUri(o),u={resource:t,name:l.basename(t),isFile:(r.type&p.FileType.File)!=0,isDirectory:(r.type&p.FileType.Directory)!=0,isSymbolicLink:(r.type&p.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&p.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,p.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(u.isDirectory&&s(u,e)){try{const f=await o.readdir(t),d=await R.Promises.settled(f.map(async([T,M])=>{try{const H=l.joinPath(t,T),X=n?await o.stat(H):{type:M};return await this.toFileStat(o,H,X,f.length,n,s)}catch(H){return this.logService.trace(H),null}}));u.children=(0,L.coalesce)(d)}catch(f){this.logService.trace(f),u.children=[]}return u}return u}async resolveAll(o){return R.Promises.settled(o.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.withProvider(o),r=await t.stat(o);return this.toFileStat(t,o,r,void 0,!0,()=>!1)}async exists(o){const t=await this.withProvider(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.doValidateCreateFile(o,t)}catch(r){return r}return!0}async doValidateCreateFile(o,t){if(!t?.overwrite&&await this.exists(o))throw new p.FileOperationError((0,m.localize)(3,null,this.resourceForError(o)),3,t)}async createFile(o,t=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const e=await this.writeFile(o,t);return this._onDidRunOperation.fire(new p.FileOperationEvent(o,0,e)),e}async writeFile(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(e);try{await this.validateWriteFile(e,o,r)||await this.mkdirp(e,n.dirname(o));let l;if((0,p.hasReadWriteCapability)(e)&&!(t instanceof P.VSBuffer))if((0,E.isReadableStream)(t)){const u=await(0,E.peekStream)(t,3);u.ended?l=P.VSBuffer.concat(u.buffer):l=u}else l=(0,E.peekReadable)(t,u=>P.VSBuffer.concat(u),3);else l=t;!(0,p.hasOpenReadWriteCloseCapability)(e)||(0,p.hasReadWriteCapability)(e)&&l instanceof P.VSBuffer?await this.doWriteUnbuffered(e,o,r,l):await this.doWriteBuffered(e,o,r,l instanceof P.VSBuffer?(0,P.bufferToReadable)(l):l),this._onDidRunOperation.fire(new p.FileOperationEvent(o,4))}catch(s){throw new p.FileOperationError((0,m.localize)(4,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,t,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(t)));let n;try{n=await o.stat(t)}catch{return}if((n.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,m.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==p.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,p.etag)({mtime:r.mtime,size:n.size}))throw new p.FileOperationError((0,m.localize)(7,null),3,r);return n}async readFile(o,t,r){const e=await this.withReadProvider(o);return t?.atomic?this.doReadFileAtomic(e,o,t,r):this.doReadFile(e,o,t,r)}async doReadFileAtomic(o,t,r,e){return new Promise((n,s)=>{this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(o,t,r,e);n(l)}catch(l){s(l)}})})}async doReadFile(o,t,r,e){const n=await this.doReadFileStream(o,t,{...r,preferUnbuffered:!0},e);return{...n,value:await(0,P.streamToBuffer)(n.value)}}async readFileStream(o,t,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,t,r)}async doReadFileStream(o,t,r,e){const n=new I.CancellationTokenSource(e),s=this.validateReadFile(t,r).then(u=>u,u=>{throw n.cancel(),u});let l;try{return typeof r?.etag=="string"&&r.etag!==p.ETAG_DISABLED&&await s,r?.atomic&&(0,p.hasFileAtomicReadCapability)(o)||!((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasFileReadStreamCapability)(o))||(0,p.hasReadWriteCapability)(o)&&r?.preferUnbuffered?l=this.readFileUnbuffered(o,t,r):(0,p.hasFileReadStreamCapability)(o)?l=this.readFileStreamed(o,t,n.token,r):l=this.readFileBuffered(o,t,n.token,r),{...await s,value:l}}catch(u){l&&await(0,E.consumeStream)(l);const f=(0,m.localize)(8,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(u).toString());throw u instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(f,u.stat,r):new p.FileOperationError(f,(0,p.toFileOperationResult)(u),r)}}readFileStreamed(o,t,r,e=Object.create(null)){const n=o.readFileStream(t,e,r);return(0,E.transform)(n,{data:s=>s instanceof P.VSBuffer?s:P.VSBuffer.wrap(s),error:s=>new p.FileOperationError((0,m.localize)(9,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),e)},s=>P.VSBuffer.concat(s))}readFileBuffered(o,t,r,e=Object.create(null)){const n=(0,P.newWriteableBufferStream)();return(0,a.readFileIntoStream)(o,t,n,s=>s,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new p.FileOperationError((0,m.localize)(10,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(s).toString()),(0,p.toFileOperationResult)(s),e)},r),n}readFileUnbuffered(o,t,r){const e=(0,E.newWriteableStream)(n=>P.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,p.hasFileAtomicReadCapability)(o)?n=await o.readFile(t,{atomic:!0}):n=await o.readFile(t),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(t,n.byteLength,r),e.end(P.VSBuffer.wrap(n))}catch(n){e.error(n),e.end()}})(),e}async validateReadFile(o,t){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new p.FileOperationError((0,m.localize)(11,null,this.resourceForError(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&t.etag===r.etag)throw new p.NotModifiedSinceFileOperationError((0,m.localize)(12,null),r,t);return this.validateReadFileLimits(o,r.size,t),r}validateReadFileLimits(o,t,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&t>r.limits.size&&(e=7),typeof e=="number")throw new p.FileOperationError((0,m.localize)(13,null,this.resourceForError(o)),e)}}async canMove(o,t,r){return this.doCanMoveCopy(o,t,"move",r)}async canCopy(o,t,r){return this.doCanMoveCopy(o,t,"copy",r)}async doCanMoveCopy(o,t,r,e){if(o.toString()!==t.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,o,s,t,r,e)}catch(n){return n}return!0}async move(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"move",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,t,r){const e=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"copy",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,t,r,e,n,s){if(t.toString()===e.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,t,r,e,n,s);if(l&&!u&&s&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),n==="copy"){if(o===r&&(0,p.hasFileFolderCopyCapability)(o))await o.copy(t,e,{overwrite:s});else{const f=await this.resolve(t);f.isDirectory?await this.doCopyFolder(o,f,r,e):await this.doCopyFile(o,t,r,e)}return n}else return o===r?(await o.rename(t,e,{overwrite:s}),n):(await this.doMoveCopy(o,t,r,e,"copy",s),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(o,t,r,e){if((0,p.hasOpenReadWriteCloseCapability)(o)&&(0,p.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,t,r,e);if((0,p.hasOpenReadWriteCloseCapability)(o)&&(0,p.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,t,r,e);if((0,p.hasReadWriteCapability)(o)&&(0,p.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,t,r,e);if((0,p.hasReadWriteCapability)(o)&&(0,p.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,t,r,e)}async doCopyFolder(o,t,r,e){await r.mkdir(e),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async n=>{const s=this.getExtUri(r).providerExtUri.joinPath(e,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),r,s):this.doCopyFile(o,n.resource,r,s)}))}async doValidateMoveCopy(o,t,r,e,n,s){let l=!1;if(o===r){const{providerExtUri:f,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(l=f.isEqual(t,e)),l&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(t),this.resourceForError(e)));if(!l&&f.isEqualOrParent(e,t))throw new Error((0,m.localize)(15,null,this.resourceForError(t),this.resourceForError(e)))}const u=await this.exists(e);if(u&&!l){if(!s)throw new p.FileOperationError((0,m.localize)(16,null,this.resourceForError(t),this.resourceForError(e)),4);if(o===r){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(t,e))throw new Error((0,m.localize)(17,null,this.resourceForError(t),this.resourceForError(e)))}}return{exists:u,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const t=this.isPathCaseSensitive(o);return{providerExtUri:t?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(t,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(o,0,r)),r}async mkdirp(o,t){const r=[],{providerExtUri:e}=this.getExtUri(o);for(;!e.isEqual(t,e.dirname(t));)try{if(((await o.stat(t)).type&p.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(t)));break}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(e.basename(t)),t=e.dirname(t)}for(let n=r.length-1;n>=0;n--){t=e.joinPath(t,r[n]);try{await o.mkdir(t)}catch(s){if((0,p.toFileSystemProviderErrorCode)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,t){try{await this.doValidateDelete(o,t)}catch(r){return r}return!0}async doValidateDelete(o,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new p.FileOperationError((0,m.localize)(20,null,this.resourceForError(o)),1);if(!!!t?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(o)))}return r}async del(o,t){const r=await this.doValidateDelete(o,t),e=!!t?.useTrash,n=!!t?.recursive;await r.delete(o,{recursive:n,useTrash:e}),this._onDidRunOperation.fire(new p.FileOperationEvent(o,1))}async cloneFile(o,t){const r=await this.withProvider(o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(r===e&&this.getExtUri(r).providerExtUri.isEqual(o,t))return;if(r===e&&(0,p.hasFileCloneCapability)(r))return r.cloneFile(o,t);await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(t));const n=this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri);return r===e&&(0,p.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(o,t,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,o,e,t))}watch(o,t={recursive:!1,excludes:[]}){const r=new g.DisposableStore;let e=!1,n=()=>{e=!0};return r.add((0,g.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(o,t);e?(0,g.dispose)(s):n=()=>(0,g.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,t){const r=await this.withProvider(o),e=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),t]);let n=this.activeWatchers.get(e);return n||(n={count:0,disposable:r.watch(o,t)},this.activeWatchers.set(e,n)),n.count+=1,(0,g.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,g.dispose)(n.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,g.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,E.isReadableStream)(e)||(0,E.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,n,e):await this.doWriteReadableBufferedQueued(o,n,e)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,t,r){let e=0,n;if((0,E.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,t,s,s.byteLength,e,0),e+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,l)=>{(0,E.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(o,t,u,u.byteLength,e,0)}catch(f){return l(f)}e+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>l(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,t,r){let e=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(o,t,n,n.byteLength,e,0),e+=n.byteLength}async doWriteBuffer(o,t,r,e,n,s){let l=0;for(;l<e;)l+=await o.write(t,n+l,r.buffer,s+l,e-l)}async doWriteUnbuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,t,r,e))}async doWriteUnbufferedQueued(o,t,r,e){let n;e instanceof P.VSBuffer?n=e:(0,E.isReadableStream)(e)?n=await(0,P.streamToBuffer)(e):(0,E.isReadableBufferedStream)(e)?n=await(0,P.bufferedStreamToBuffer)(e):n=(0,P.readableToBuffer)(e),await o.writeFile(t,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,t,r,e))}async doPipeBufferedQueued(o,t,r,e){let n,s;try{n=await o.open(t,{create:!1}),s=await r.open(e,{create:!0,unlock:!1});const l=P.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,f=0,d=0;do d=await o.read(n,u,l.buffer,f,l.byteLength-f),await this.doWriteBuffer(r,s,l,d,u,f),u+=d,f+=d,f===l.byteLength&&(f=0);while(d>0)}catch(l){throw(0,p.ensureFileSystemProviderError)(l)}finally{await R.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,t,r,e))}async doPipeUnbufferedQueued(o,t,r,e){return r.writeFile(e,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,t,r,e))}async doPipeUnbufferedToBufferedQueued(o,t,r,e){const n=await r.open(e,{create:!0,unlock:!1});try{const s=await o.readFile(t);await this.doWriteBuffer(r,n,P.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,p.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(o,t,r,e){const n=await(0,P.streamToBuffer)(this.readFileBuffered(o,t,I.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,n)}throwIfFileSystemIsReadonly(o,t){if(o.capabilities&2048)throw new p.FileOperationError((0,m.localize)(22,null,this.resourceForError(t)),6);return o}throwIfFileIsReadonly(o,t){if((t.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,m.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===D.Schemas.file?o.fsPath:o.toString(!0)}};y=he([ae(0,h.ILogService)],y),i.FileService=y}),define(Y[102],Q([0,1,103,136,3,54,17,7,45,2,10,11,19,38,15,83,16,50,99,28,96,95]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m,p,a,h,y,S,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(r)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(e,n){super(e,n);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new I.ResourceMap(s=>v.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,D.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:n,symbolicLink:s}=await E.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(e){try{const n=await E.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async l=>{try{let u;l.isSymbolicLink()?u=(await this.stat((0,v.joinPath)(e,l.name))).type:u=this.toType(l),s.push([l.name,u])}catch(u){this.logService.trace(u)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(e,n){let s;return n?.dangling?s=p.FileType.Unknown:e.isFile()?s=p.FileType.File:e.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,n&&(s|=p.FileType.SymbolicLink),s}async createResourceLock(e){const n=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const l=new P.Barrier;return this.resourceLocks.set(e,l),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(e)===l&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(e,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const l=this.toFilePath(e);return await E.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}readFileStream(e,n,s){const l=(0,w.newWriteableStream)(u=>O.VSBuffer.concat(u.map(f=>O.VSBuffer.wrap(f))).buffer);return(0,a.readFileIntoStream)(this,e,l,u=>u.buffer,{...n,bufferSize:256*1024},s),l}async writeFile(e,n,s){let l;try{const u=this.toFilePath(e);if(!s.create||!s.overwrite){if(await E.Promises.exists(u)){if(!s.overwrite)throw(0,p.createFileSystemProviderError)((0,m.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.createFileSystemProviderError)((0,m.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(e,u)}finally{typeof l=="number"&&await this.close(l)}}async open(e,n){const s=this.toFilePath(e);let l;(0,p.isFileOpenForWriteOptions)(n)&&(l=await this.createResourceLock(e));let u;try{if((0,p.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:d}=await E.SymlinkSupport.stat(s);d.mode&128||await E.Promises.chmod(s,d.mode|128)}catch(d){this.logService.trace(d)}let f;if((0,p.isFileOpenForWriteOptions)(n)){if(D.isWindows)try{await E.Promises.truncate(s,0),f="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}f||(f="w")}else f="r";u=await E.Promises.open(s,f)}catch(f){throw l?.dispose(),(0,p.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(e,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(u,0),(0,p.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(u,e),l){const f=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,l),f&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),f.dispose())}return u}async close(e){const n=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await E.Promises.fdatasync(e)}catch(s){this.canFlush=!1,this.logService.error(s)}return await E.Promises.close(e)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(e)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),n.dispose())}}async read(e,n,s,l,u){const f=this.normalizePos(e,n);let d=null;try{d=(await E.Promises.read(e,s,l,u,f)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(e,f,d)}return d}normalizePos(e,n){return n===this.mapHandleToPos.get(e)?null:n}updatePos(e,n,s){const l=this.mapHandleToPos.get(e);typeof l=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,l+s):this.mapHandleToPos.delete(e)))}async write(e,n,s,l,u){return(0,P.retry)(()=>this.doWrite(e,n,s,l,u),100,3)}async doWrite(e,n,s,l,u){const f=this.normalizePos(e,n);let d=null;try{d=(await E.Promises.write(e,s,l,u,f)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),T)}finally{this.updatePos(e,f,d)}return d}async mkdir(e){try{await E.Promises.mkdir(this.toFilePath(e))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(e,n){try{const s=this.toFilePath(e);n.recursive?await E.Promises.rm(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n);if(l!==u)try{await this.validateTargetDeleted(e,n,"move",s.overwrite),await E.Promises.move(l,u)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,m.localize)(2,null,(0,C.basename)(l),(0,C.basename)((0,C.dirname)(u)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n);if(l!==u)try{await this.validateTargetDeleted(e,n,"copy",s.overwrite),await E.Promises.copy(l,u,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,m.localize)(3,null,(0,C.basename)(l),(0,C.basename)((0,C.dirname)(u)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(e,n,s,l){const u=this.toFilePath(e),f=this.toFilePath(n);let d=!1;if(!!(this.capabilities&1024)||(d=(0,c.isEqual)(u,f,!0)),d&&s==="copy")throw(0,p.createFileSystemProviderError)((0,m.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!d&&await E.Promises.exists(f)){if(!l)throw(0,p.createFileSystemProviderError)((0,m.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(e,n){return this.doCloneFile(e,n,!1)}async doCloneFile(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n),f=!!(this.capabilities&1024);if((0,c.isEqual)(l,u,!f))return;const d=new g.DisposableStore;try{const[T,M]=await Promise.all([this.createResourceLock(e),this.createResourceLock(n)]);d.add(T),d.add(M),s&&await E.Promises.mkdir((0,C.dirname)(u),{recursive:!0}),await E.Promises.copyFile(l,u)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(e,n,!0);throw this.toFileSystemProviderError(T)}finally{d.dispose()}}createUniversalWatcher(e,n,s){return new S.UniversalWatcherClient(l=>e(l),l=>n(l),s)}createNonRecursiveWatcher(e,n,s){return new o.NodeJSWatcherClient(l=>e(l),l=>n(l),s)}toFileSystemProviderError(e){if(e instanceof p.FileSystemProviderError)return e;let n;switch(e.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(e,n){let s=this.toFileSystemProviderError(n);if(e&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await E.SymlinkSupport.stat(this.toFilePath(e));l.mode&128||(s=(0,p.createFileSystemProviderError)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}i.DiskFileSystemProvider=t}),define(Y[104],Q([0,1,16,14]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(b,c,g,C,D){try{const v=await new Promise((E,m)=>{x(["spdlog"],E,m)});v.setFlushOn(R.LogLevel.Trace);const w=await v.createAsyncRotatingLogger(b,c,g,C);return D&&w.clearFormatters(),w}catch(v){console.error(v)}return null}function I(b,c,g){switch(c){case R.LogLevel.Trace:b.trace(g);break;case R.LogLevel.Debug:b.debug(g);break;case R.LogLevel.Info:b.info(g);break;case R.LogLevel.Warning:b.warn(g);break;case R.LogLevel.Error:b.error(g);break;case R.LogLevel.Critical:b.critical(g);break;default:throw new Error("Invalid log level")}}class O extends R.AbstractMessageLogger{constructor(c,g,C,D,v){super();this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(c,g,C,D),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(c,g,C,D){const v=C?6:1,w=30/v*L.ByteSize.MB,E=await P(c,g,w,v,D);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:m,message:p}of this.buffer)I(this._logger,m,p);this.buffer=[]}}log(c,g){this._logger?I(this._logger,c,g):this.getLevel()<=c&&this.buffer.push({level:c,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=O}),define(Y[30],Q([0,1,13]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,L.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Y[31],Q([0,1,55,8]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(O,b){L.ok(R.isString(O)),L.ok(R.isObject(b)),L.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,b)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}i.Registry=new P}),define(Y[105],Q([0,1,7,31]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,g){this.schemasById[P(c)]=g,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new I;R.Registry.add(i.Extensions.JSONContribution,O)}),define(Y[34],Q([0,1,18,7,8,73,23,105,31]),function(x,i,L,R,P,I,O,b,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var g;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(g=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var C;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=c.Registry.as(b.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const e=this.doRegisterConfigurations(t,r);D.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}deregisterConfigurations(t){const r=this.doDeregisterConfigurations(t);D.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const e=[];e.push(...this.doDeregisterConfigurations(r)),e.push(...this.doRegisterConfigurations(t,!1)),D.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(e)})}registerDefaultConfigurations(t){const r=[],e=[];for(const{overrides:n,source:s}of t)for(const l in n)if(r.push(l),i.OVERRIDE_PROPERTY_REGEX.test(l)){const u={...this.configurationDefaultsOverrides.get(l)?.value||{},...n[l]};this.configurationDefaultsOverrides.set(l,{source:s,value:u});const f=(0,O.getLanguageTagSettingPlainKey)(l),d={type:"object",default:u,description:I.localize(1,null,f),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:P.isString(s)?void 0:s};e.push(...m(l)),this.configurationProperties[l]=d,this.defaultLanguageConfigurationOverridesNode.properties[l]=d}else{this.configurationDefaultsOverrides.set(l,{value:n[l],source:s});const u=this.configurationProperties[l];u&&(this.updatePropertyDefaultValue(l,u),this.updateSchema(l,u))}this.registerOverrideIdentifiers(e),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const r=[];for(const{overrides:e,source:n}of t)for(const s in e){const l=this.configurationDefaultsOverrides.get(s),u=P.isString(n)?n:n?.id,f=P.isString(l?.source)?l?.source:l?.source?.id;if(u===f)if(r.push(s),this.configurationDefaultsOverrides.delete(s),i.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const d=this.configurationProperties[s];d&&(this.updatePropertyDefaultValue(s,d),this.updateSchema(s,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r){const e=[];return t.forEach(n=>{e.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),e}doDeregisterConfigurations(t){const r=[],e=n=>{if(n.properties)for(const s in n.properties)r.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s]);n.allOf&&n.allOf.forEach(s=>e(s))};for(const n of t){e(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return r}validateAndRegisterProperties(t,r=!0,e,n,s=3){s=P.isUndefinedOrNull(t.scope)?s:t.scope;let l=[],u=t.properties;if(u)for(let d in u){if(r&&y(d)){delete u[d];continue}const T=u[d];if(T.source=e,T.defaultDefaultValue=u[d].default,this.updatePropertyDefaultValue(d,T),i.OVERRIDE_PROPERTY_REGEX.test(d)?T.scope=void 0:(T.scope=P.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=P.isUndefinedOrNull(T.restricted)?!!n?.includes(d):T.restricted),u[d].hasOwnProperty("included")&&!u[d].included){this.excludedConfigurationProperties[d]=u[d],delete u[d];continue}else this.configurationProperties[d]=u[d];!u[d].deprecationMessage&&u[d].markdownDeprecationMessage&&(u[d].deprecationMessage=u[d].markdownDeprecationMessage),l.push(d)}let f=t.allOf;if(f)for(let d of f)l.push(...this.validateAndRegisterProperties(d,r,e,n,s));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=e=>{let n=e.properties;if(n)for(const l in n)this.updateSchema(l,n[l]);let s=e.allOf;s&&s.forEach(r)};r(t)}updateSchema(t,r){switch(i.allSettings.properties[t]=r,r.scope){case 1:i.applicationSettings.properties[t]=r;break;case 2:i.machineSettings.properties[t]=r;break;case 6:i.machineOverridableSettings.properties[t]=r;break;case 3:i.windowSettings.properties[t]=r;break;case 4:i.resourceSettings.properties[t]=r;break;case 5:i.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete i.allSettings.properties[t],r.scope){case 1:delete i.applicationSettings.properties[t];break;case 2:delete i.machineSettings.properties[t];break;case 6:delete i.machineOverridableSettings.properties[t];break;case 3:delete i.windowSettings.properties[t];break;case 4:case 5:delete i.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,e={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,e),i.allSettings.properties[r]=e,i.applicationSettings.properties[r]=e,i.machineSettings.properties[r]=e,i.machineOverridableSettings.properties[r]=e,i.windowSettings.properties[r]=e,i.resourceSettings.properties[r]=e}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const e=this.configurationDefaultsOverrides.get(t);let n=e?.value,s=e?.source;P.isUndefined(n)&&(n=r.defaultDefaultValue,s=void 0),P.isUndefined(n)&&(n=a(r.type)),r.default=n,r.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",E=new RegExp(w,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function m(o){const t=[];if(i.OVERRIDE_PROPERTY_REGEX.test(o)){let r=E.exec(o);for(;r?.length;){const e=r[1].trim();e&&t.push(e),r=E.exec(o)}}return(0,L.distinct)(t)}i.overrideIdentifiersFromKey=m;function p(o){return o.reduce((t,r)=>`${t}[${r}]`,"")}i.keyFromOverrideIdentifiers=p;function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const h=new v;c.Registry.add(i.Extensions.Configuration,h);function y(o){return o.trim()?i.OVERRIDE_PROPERTY_REGEX.test(o)?I.localize(7,null,o):h.getConfigurationProperties()[o]!==void 0?I.localize(8,null,o):null:I.localize(6,null)}i.validateProperty=y;function S(){const o=[],t=h.getConfigurationProperties();for(const r of Object.keys(t))o.push([r,t[r].scope]);return o.push(["launch",4]),o.push(["task",4]),o}i.getScopes=S}),define(Y[106],Q([0,1,18,7,56,2,54,22,8,9,23,34,31]),function(x,i,L,R,P,I,O,b,c,g,C,D,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class w{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,C.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,C.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const s of this.overrides)s.identifiers.includes(e)&&n.push(...s.keys);return L.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return L.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=b.deepClone(this.contents),s=b.deepClone(this.overrides),l=[...this.keys];for(const u of e){this.mergeContents(n,u.contents);for(const f of u.overrides){const[d]=s.filter(T=>L.equals(T.identifiers,f.identifiers));d?(this.mergeContents(d.contents,f.contents),d.keys.push(...f.keys),d.keys=L.distinct(d.keys)):s.push(b.deepClone(f))}for(const f of u.keys)l.indexOf(f)===-1&&l.push(f)}return new w(n,l,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const l of L.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[l],f=n[l];f&&(typeof u=="object"&&typeof f=="object"?(u=b.deepClone(u),this.mergeContents(u,f)):u=f),s[l]=u}return new w(s,this.keys,this.overrides)}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&c.isObject(e[s])&&c.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=b.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?b.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,s=null;const l=u=>{u&&(s?this.mergeContents(s,u):s=b.deepClone(u))};for(const u of this.overrides)L.equals(u.identifiers,[e])?n=u.contents:u.identifiers.includes(e)&&l(u.contents);return l(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,C.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,C.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=w;class E extends w{constructor(e={}){const n=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),l=Object.create(null),u=[];for(const f in n){const d=e[f],T=d!==void 0?d:n[f].default;(0,C.addToValueTree)(l,f,T,M=>console.error(`Conflict in default settings: ${M}`))}for(const f of Object.keys(l))D.OVERRIDE_PROPERTY_REGEX.test(f)&&u.push({identifiers:(0,D.overrideIdentifiersFromKey)(f),keys:Object.keys(l[f]),contents:(0,C.toValuesTree)(l[f],d=>console.error(`Conflict in default settings file: ${d}`))});super(l,s,u)}}i.DefaultConfigurationModel=E;class m{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:s,keys:l,overrides:u,restricted:f}=this.doParseRaw(e,n);this._configurationModel=new w(s,l,u),this._restrictedConfigurations=f||[]}doParseContent(e){let n={},s=null,l=[],u=[],f=[];function d(M){Array.isArray(l)?l.push(M):s!==null&&(l[s]=M)}let T={onObjectBegin:()=>{let M={};d(M),u.push(l),l=M,s=null},onObjectProperty:M=>{s=M},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{let M=[];d(M),u.push(l),l=M,s=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:d,onError:(M,H,X)=>{f.push({error:M,offset:H,length:X})}};if(e)try{P.visit(e,T),n=l[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return n}doParseRaw(e,n){const s=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),l=this.filter(e,s,!0,n);e=l.raw;const u=(0,C.toValuesTree)(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),f=Object.keys(e),d=this.toOverrides(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:u,keys:f,overrides:d,restricted:l.restricted}}filter(e,n,s,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:e,restricted:[]};const u={},f=[];for(let d in e)if(D.OVERRIDE_PROPERTY_REGEX.test(d)&&s){const T=this.filter(e[d],n,!1,l);u[d]=T.raw,f.push(...T.restricted)}else{const T=n[d],M=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&f.push(d),(M===void 0||l.scopes===void 0||l.scopes.includes(M))&&(l.skipRestricted&&T?.restricted||(u[d]=e[d]))}return{raw:u,restricted:f}}toOverrides(e,n){const s=[];for(const l of Object.keys(e))if(D.OVERRIDE_PROPERTY_REGEX.test(l)){const u={};for(const f in e[l])u[f]=e[l][f];s.push({identifiers:(0,D.overrideIdentifiersFromKey)(l),keys:Object.keys(u),contents:(0,C.toValuesTree)(u,n)})}return s}}i.ConfigurationModelParser=m;class p extends I.Disposable{constructor(e,n,s,l){super();this.userSettingsResource=e,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&s.isEqual(u.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=p;class a{constructor(e,n,s=new w,l=new w,u=new O.ResourceMap,f=new w,d=new O.ResourceMap,T=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=d,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let l;s.resource?(l=this._memoryConfigurationByResource.get(s.resource),l||(l=new w,this._memoryConfigurationByResource.set(s.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(e):l.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const l=this.getConsolidateConfigurationModel(n,s),u=this.getFolderConfigurationModelForResource(n.resource,s),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,d=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),T=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),M=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),H=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),X=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ee=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,ie=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(e):f.getValue(e),ne=l.getValue(e),fe=L.distinct(L.flatten(l.overrides.map(B=>B.identifiers))).filter(B=>l.getOverrideValue(e,B)!==void 0);return{defaultValue:d,userValue:T,userLocalValue:M,userRemoteValue:H,workspaceValue:X,workspaceFolderValue:ee,memoryValue:ie,value:ne,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:H!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:X!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:u?.freeze().getValue(e),override:n.overrideIdentifier?u?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:f.getValue(e),override:n.overrideIdentifier?f.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=[];if(!n){const{added:l,updated:u,removed:f}=o(this._defaultConfiguration,e);n=[...l,...u,...f]}for(const l of n)for(const u of(0,D.overrideIdentifiersFromKey)(l)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),d=e.getKeysForOverrideIdentifier(u),T=[...d.filter(M=>f.indexOf(M)===-1),...f.filter(M=>d.indexOf(M)===-1),...f.filter(M=>!b.equals(this._defaultConfiguration.override(u).getValue(M),e.override(u).getValue(M)))];s.push([u,T])}return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.localUserConfiguration,e),f=[...n,...s,...l];return f.length&&this.updateLocalUserConfiguration(e),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.remoteUserConfiguration,e);let f=[...n,...s,...l];return f.length&&this.updateRemoteUserConfiguration(e),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.workspaceConfiguration,e);let f=[...n,...s,...l];return f.length&&this.updateWorkspaceConfiguration(e),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:l,updated:u,removed:f,overrides:d}=o(s,n);let T=[...l,...u,...f];return(T.length||!s)&&this.updateFolderConfiguration(e,n),{keys:T,overrides:d}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:l,removed:u,overrides:f}=o(n,void 0);return{keys:[...s,...l,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const l=n.getFolder(e);l&&(s=this.getFolderConsolidatedConfiguration(l.uri)||s);const u=this._memoryConfigurationByResource.get(e);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(e);l?(n=s.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:l,keys:u}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:l,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(l=>n.add(l))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),l=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((f,d)=>(f.set(g.URI.revive(d[0]),this.parseConfigurationModel(d[1])),f),new O.ResourceMap);return new a(n,s,new w,l,u,new w,new O.ResourceMap,!1)}static parseConfigurationModel(e){return new w(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=a;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const l of r)l.keys.forEach(u=>e.add(u)),l.overrides.forEach(([u,f])=>{const d=(0,O.getOrSet)(n,u,new Set);f.forEach(T=>d.add(T))});const s=[];return n.forEach((l,u)=>s.push([u,[...l.values()]])),{keys:[...e.values()],overrides:s}}i.mergeChanges=h;class y{constructor(e,n,s,l){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=l,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(d=>u.add(d)),e.overrides.forEach(([,d])=>d.forEach(T=>u.add(T))),this.affectedKeys=[...u.values()];const f=new w;this.affectedKeys.forEach(d=>f.setValue(d,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!b.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,C.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof s=="object"&&(l=Object.keys(s)[0]);){if(e=e[l],!e)return!1;s=s[l]}return!0}}i.ConfigurationChangeEvent=y;class S extends y{constructor(e,n,s,l){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=l}}i.AllKeysConfigurationChangeEvent=S;function o(r,e){const{added:n,removed:s,updated:l}=t(e,r),u=[],f=r?.getAllOverrideIdentifiers()||[],d=e?.getAllOverrideIdentifiers()||[];if(e){const T=d.filter(M=>!f.includes(M));for(const M of T)u.push([M,e.getKeysForOverrideIdentifier(M)])}if(r){const T=f.filter(M=>!d.includes(M));for(const M of T)u.push([M,r.getKeysForOverrideIdentifier(M)])}if(e&&r){for(const T of f)if(d.includes(T)){const M=t({contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)},{contents:e.getOverrideValue(void 0,T)||{},keys:e.getKeysForOverrideIdentifier(T)});u.push([T,[...M.added,...M.removed,...M.updated]])}}return{added:n,removed:s,updated:l,overrides:u}}function t(r,e){const n=r?e?r.keys.filter(u=>e.keys.indexOf(u)===-1):[...r.keys]:[],s=e?r?e.keys.filter(u=>r.keys.indexOf(u)===-1):[...e.keys]:[],l=[];if(r&&e){for(const u of e.keys)if(r.keys.indexOf(u)!==-1){const f=(0,C.getConfigurationValue)(e.contents,u),d=(0,C.getConfigurationValue)(r.contents,u);b.equals(f,d)||l.push(u)}}return{added:n,removed:s,updated:l}}}),define(Y[107],Q([0,1,3,7,2,19,23,106,34,31]),function(x,i,L,R,P,I,O,b,c,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class C extends P.Disposable{constructor(v,w){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,w)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:E})=>this.onDidDefaultConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,w){const E=typeof v=="string"?v:void 0,m=(0,O.isConfigurationOverrides)(v)?v:(0,O.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(E,m,void 0)}updateValue(v,w,E,m){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const w=this.configuration.toData(),E=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(E,w,1)}onDidDefaultConfigurationChange(v){const w=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,v);this.trigger(E,w,6)}trigger(v,w,E){const m=new b.ConfigurationChangeEvent(v,{data:w},this.configuration);m.source=E,m.sourceConfig=this.getTargetConfiguration(E),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=C}),define(Y[108],Q([0,1,12]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteName=i.getRemoteAuthority=void 0;function R(I){return I.scheme===L.Schemas.vscodeRemote?I.authority:void 0}i.getRemoteAuthority=R;function P(I){if(!I)return;const O=I.indexOf("+");return O<0?I:I.substr(0,O)}i.getRemoteName=P}),define(Y[35],Q([0,1,26,13,108]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}i.getWorkspaceSupportTypeMessage=I;function O(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}i.isIExtensionIdentifier=O,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(b=i.ExtensionType||(i.ExtensionType={}));var c;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(c=i.TargetPlatform||(i.TargetPlatform={}));class g{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,m){if(typeof E=="undefined"||E===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof E=="string"||typeof m=="string"){let p=typeof E=="string"?E:E.value,a=typeof m=="string"?m:m.value;return L.equalsIgnoreCase(p,a)}return E._lower===m._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=g;function C(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}i.isLanguagePackExtension=C;function D(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=D;function v(w,E){if(E){const m=`onResolveRemoteAuthority:${(0,P.getRemoteName)(E)}`;return w.activationEvents?.indexOf(m)!==-1}return!1}i.isResolverExtension=v,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[24],Q([0,1,26,21,35,11,9,6,29]),function(x,i,L,R,P,I,O,b,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function g(e,n){return e.uuid&&n.uuid?e.uuid===n.uuid:e.id===n.id?!0:(0,L.compareIgnoreCase)(e.id,n.id)===0}i.areSameExtensions=g;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class D{constructor(n,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=n.id}static create(n){const s=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new D(n.identifier,s,l)}static parse(n){const s=C.exec(n);return s&&s[1]&&s[2]?new D({id:s[1]},s[2],s[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof D?g(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}i.ExtensionKey=D;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(e){const n=v.exec(e);return n&&n[1]?[m(n[1]),n[2]]:[m(e),void 0]}i.getIdAndVersion=w;function E(e,n){return`${e}.${n}`}i.getExtensionId=E;function m(e){return e.toLocaleLowerCase()}i.adoptToGalleryExtensionId=m;function p(e,n){return m(E(e,n))}i.getGalleryExtensionId=p;function a(e,n){const s=[],l=u=>{for(const f of s)if(f.some(d=>g(n(d),n(u))))return f;return null};for(const u of e){const f=l(u);f?f.push(u):s.push([u])}return s}i.groupByExtension=a;function h(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=h;function y(e){return{id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,isPreReleaseVersion:e.properties.isPreReleaseVersion,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0),...e.telemetryData}}i.getGalleryExtensionTelemetryData=y,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function S(e){const n=new Set;if(e.malicious)for(const s of e.malicious)n.add(s.id);return n}i.getMaliciousExtensionsSet=S;function o(e,n){const s=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const u=l.shift();if(u&&s.every(f=>!g(f.identifier,{id:u}))){const f=e.filter(d=>g(d.identifier,{id:u}));f.length===1&&(s.push(f[0]),l.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}i.getExtensionDependencies=o;async function t(e,n){if(!I.isLinux)return!1;let s;try{s=(await e.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await e.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=t;async function r(e,n){const s=await t(e,n),l=(0,R.getTargetPlatform)(s?"alpine":I.platform,c.arch);return n.debug("ComputeTargetPlatform:",l),l}i.computeTargetPlatform=r}),define(Y[109],Q([0,1,25,6,62,12,41,9,76,21,24,35]),function(x,i,L,R,P,I,O,b,c,g,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const v=p=>(0,c.localize)(0,null,p),w=(0,c.localize)(1,null,"ms-dotnettools.csharp");function E(p,a){return a?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let m=class{constructor(a,h){this.extensionManagementService=a,this.extensionGalleryService=h}get location(){}async listExtensions(a,h,y=console){let S=await this.extensionManagementService.getInstalled(1);const o=D.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(h&&h!==""){if(o.indexOf(h.toLowerCase())<0){y.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}S=S.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){y.log("Possible Categories: "),o.forEach(r=>{y.log(r)});return}this.location&&y.log((0,c.localize)(2,null,this.location)),S=S.sort((r,e)=>r.identifier.id.localeCompare(e.identifier.id));let t;for(let r of S)t!==r.identifier.id&&(t=r.identifier.id,y.log(E(r.manifest,a)))}async installExtensions(a,h,y,S,o=console){const t=[],r=[];a.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),n=(f,d)=>{const T=e.find(M=>(0,C.areSameExtensions)(M.identifier,{id:f}));if(T){if(!S&&(!d||d==="prerelease"&&T.preRelease))return o.log((0,c.localize)(5,null,f,T.manifest.version,f)),!1;if(d&&T.manifest.version===d)return o.log((0,c.localize)(6,null,`${f}@${d}`)),!1}return!0},s=(f,d,T)=>{u.push({id:f,version:d!=="prerelease"?d:void 0,installOptions:{...y,isBuiltin:T,installPreReleaseVersion:d==="prerelease"||y.installPreReleaseVersion}})},l=[],u=[];for(const f of a)if(f instanceof b.URI)l.push(f);else{const[d,T]=(0,C.getIdAndVersion)(f);n(d,T)&&s(d,T,!1)}for(const f of h){const[d,T]=(0,C.getIdAndVersion)(f);n(d,T)&&s(d,T,!0)}if(l.length&&await Promise.all(l.map(async f=>{try{const d=await this.installVSIX(f,{...y,isBuiltin:!1},S,o);d&&r.push(d)}catch(d){o.error(d.message||d.stack||d),t.push(f.toString())}})),u.length){const f=await this.getGalleryExtensions(u);await Promise.all(u.map(async d=>{const T=f.get(d.id.toLowerCase());if(T)try{const M=await this.installFromGallery(d,T,e,S,o);M&&r.push(M)}catch(M){o.error(M.message||M.stack||M),t.push(d.id)}else o.error(`${v(d.version?`${d.id}@${d.version}`:d.id)}
${w}`),t.push(d.id)}))}if(t.length)throw new Error((0,c.localize)(7,null,t.join(", ")))}async installVSIX(a,h,y,S){const o=await this.extensionManagementService.getManifest(a);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,y,S))try{return await this.extensionManagementService.install(a,h),S.log((0,c.localize)(8,null,(0,P.getBaseLabel)(a))),o}catch(r){if((0,R.isCancellationError)(r))return S.log((0,c.localize)(9,null,(0,P.getBaseLabel)(a))),null;throw r}return null}async getGalleryExtensions(a){const h=new Map,y=a.some(o=>o.installOptions.installPreReleaseVersion),S=await this.extensionGalleryService.getExtensions(a.map(o=>({...o,preRelease:y})),L.CancellationToken.None);for(const o of S)h.set(o.identifier.id.toLowerCase(),o);return h}async installFromGallery({id:a,version:h,installOptions:y},S,o,t,r){const e=await this.extensionGalleryService.getManifest(S,L.CancellationToken.None);if(e&&!this.validateExtensionKind(e,r))return null;const n=o.find(s=>(0,C.areSameExtensions)(s.identifier,S.identifier));if(n){if(S.version===n.manifest.version)return r.log((0,c.localize)(10,null,h?`${a}@${h}`:a)),null;r.log((0,c.localize)(11,null,a,S.version))}try{return y.isBuiltin?r.log(h?(0,c.localize)(12,null,a,h):(0,c.localize)(13,null,a)):r.log(h?(0,c.localize)(14,null,a,h):(0,c.localize)(15,null,a)),await this.extensionManagementService.installFromGallery(S,{...y,installGivenVersion:!!h}),r.log((0,c.localize)(16,null,a,S.version)),e}catch(s){if((0,R.isCancellationError)(s))return r.log((0,c.localize)(17,null,a)),null;throw s}}validateExtensionKind(a,h){return!0}async validateVSIX(a,h,y){const S={id:(0,C.getGalleryExtensionId)(a.publisher,a.name)},t=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,C.areSameExtensions)(S,r.identifier)&&(0,O.gt)(r.manifest.version,a.version));return t&&!h?(y.log((0,c.localize)(18,null,t.identifier.id,t.manifest.version,a.version)),!1):this.validateExtensionKind(a,y)}async uninstallExtensions(a,h,y=console){const S=async t=>{if(t instanceof b.URI){const r=await this.extensionManagementService.getManifest(t);return E(r)}return t},o=[];for(const t of a){const r=await S(t),n=(await this.extensionManagementService.getInstalled()).filter(s=>(0,C.areSameExtensions)(s.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${w}`);if(n.some(s=>s.type===0)){y.log((0,c.localize)(19,null,r));return}if(!h&&n.some(s=>s.isBuiltin)){y.log((0,c.localize)(20,null,r));return}y.log((0,c.localize)(21,null,r));for(const s of n)await this.extensionManagementService.uninstall(s),o.push(s);this.location?y.log((0,c.localize)(22,null,r,this.location)):y.log((0,c.localize)(23,null,r))}}async locateExtension(a,h=console){const y=await this.extensionManagementService.getInstalled();a.forEach(S=>{y.forEach(o=>{if(o.identifier.id===S&&o.location.scheme===I.Schemas.file){h.log(o.location.fsPath);return}})})}notInstalled(a){return this.location?(0,c.localize)(24,null,a,this.location):(0,c.localize)(25,null,a)}};m=he([ae(0,g.IExtensionManagementService),ae(1,g.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(Y[110],Q([0,1,3,6,2,11,19,41,9,27,15,20,21,24,16,14]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let p=class extends P.Disposable{constructor(h,y,S,o){super();this.fileService=y,this.extensionGalleryService=S,this.logService=o,this.extensionsDownloadDir=c.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,y){await this.cleanUpPromise;const S=this.getName(h),o=(0,O.joinPath)(this.extensionsDownloadDir,S);if(!await this.fileService.exists(o)){const t=(0,O.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(h,t,y);try{await this.rename(t,o,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(t)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,t.path),r}}return o}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,y,S){try{await C.Promises.rename(h.fsPath,y.fsPath)}catch(o){if(I.isWindows&&o&&o.code==="EPERM"&&Date.now()<S)return this.logService.info(`Failed renaming ${h} to ${y} with 'EPERM' error. Trying again...`),this.rename(h,y,S);throw o}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const y=[],S=[];for(const r of h.children){const e=w.ExtensionKey.parse(r.name);e&&S.push([e,r])}const o=(0,w.groupByExtension)(S,([r])=>r),t=[];for(const r of o)r.sort((e,n)=>b.rcompare(e[0].version,n[0].version)),y.push(...r.slice(1).map(e=>e[1].resource)),t.push(r[0][1]);t.sort((r,e)=>r.mtime-e.mtime),y.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(r=>r.resource)),await L.Promises.settled(y.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?w.ExtensionKey.create(h).toString().toLowerCase():(0,g.generateUuid)()}};p=he([ae(0,D.INativeEnvironmentService),ae(1,E.IFileService),ae(2,v.IExtensionGalleryService),ae(3,m.ILogService)],p),i.ExtensionsDownloader=p}),define(Y[111],Q([0,1,2,10,15,35]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class O extends L.Disposable{constructor(c,g){super();this.environmentService=c,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(g.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(c){c.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=O}),define(Y[112],Q([0,1,137,18,3,2,12,10,15,20,21,24,53,14]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let E=class extends I.Disposable{constructor(a,h,y){super();this.extensionManagementService=a,this.logService=y,this.cache=this._register(new m(h,y)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const a=await this.cache.getLanguagePacks(),h=["en",...Object.keys(a)];return(0,R.distinct)(h)}async postInstallExtension(a){a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",a.identifier.id),await this.update())}async postUninstallExtension(a){const h=await this.cache.getLanguagePacks();Object.keys(h).some(y=>h[y]&&h[y].extensions.some(S=>(0,D.areSameExtensions)(S.extensionIdentifier,a.identifier)))&&(this.logService.info("Removing language packs from the extension",a.identifier.id),await this.update())}async update(){const[a,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(h);return!(0,R.equals)(Object.keys(a),Object.keys(y))}};E=he([ae(0,C.IExtensionManagementService),ae(1,g.INativeEnvironmentService),ae(2,w.ILogService)],E),i.LocalizationsService=E;let m=class extends I.Disposable{constructor(a,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(a.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(a){return this.withLanguagePacks(h=>{Object.keys(h).forEach(y=>delete h[y]),this.createLanguagePacksFromExtensions(h,...a)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(a,...h){for(const y of h)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(a,y);Object.keys(a).forEach(y=>this.updateHash(a[y]))}createLanguagePacksFromExtension(a,h){const y=h.identifier,S=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const o of S)if(h.location.scheme===O.Schemas.file&&(0,v.isValidLocalization)(o)){let t=a[o.languageId];t||(t={hash:"",extensions:[],translations:{}},a[o.languageId]=t);let r=t.extensions.filter(e=>(0,D.areSameExtensions)(e.extensionIdentifier,y))[0];r?r.version=h.manifest.version:t.extensions.push({extensionIdentifier:y,version:h.manifest.version});for(const e of o.translations)t.translations[e.id]=(0,b.join)(h.location.fsPath,e.path)}}updateHash(a){if(a){const h=(0,L.createHash)("md5");for(const y of a.extensions)h.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);a.hash=h.digest("hex")}}withLanguagePacks(a=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(h=a(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.languagePacks=y,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),c.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>h,y=>this.logService.error(y))})}};m=he([ae(0,g.INativeEnvironmentService),ae(1,w.ILogService)],m)}),define(Y[42],Q([0,1,17,84,34,13,31]),function(x,i,L,R,P,I,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,I.createDecorator)("requestService");function b(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}i.isSuccess=b;function c(E){return E.res.statusCode===204}async function g(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);return c(E)?null:(await(0,L.streamToBuffer)(E.stream)).toString()}i.asText=g;async function C(E){if(!b(E))throw new Error("Server returned "+E.res.statusCode);if(c(E))return null;const p=(await(0,L.streamToBuffer)(E.stream)).toString();try{return JSON.parse(p)}catch(a){throw a.message+=`:
`+p,a}}i.asJson=C;function D(E){w(E)}i.updateProxyConfigurationsScope=D;let v;function w(E){const m=O.Registry.as(P.Extensions.Configuration),p=v;v={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[v],remove:p?[p]:[]})}w(2)}),define(Y[113],Q([0,1,25,12,16,42]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let O=class{constructor(c,g){this.requestService=c,this.fileService=g}async download(c,g,C=L.CancellationToken.None){if(c.scheme===R.Schemas.file||c.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(c,g);return}const D={type:"GET",url:c.toString()},v=await this.requestService.request(D,C);if(v.res.statusCode===200)await this.fileService.writeFile(g,v.stream);else{const w=await(0,I.asText)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${w}`)}}};O=he([ae(0,I.IRequestService),ae(1,P.IFileService)],O),i.DownloadService=O}),define(Y[114],Q([0,1,115,8]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(O,b){return O.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:O.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function I(O,b,c={}){const g=(0,L.parse)(O),C=c.proxyUrl||P(g,b);if(!C)return null;const D=(0,L.parse)(C);if(!/^https?:$/.test(D.protocol||""))return null;const v={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((w,E)=>{x(["http-proxy-agent"],w,E)}))(v):new(await new Promise((w,E)=>{x(["https-proxy-agent"],w,E)}))(v)}i.getProxyAgent=I}),define(Y[116],Q([0,1,39,10,85,25,28,6,11,27,70,138,3]),function(x,i,L,R,P,I,O,b,c,g,C,D,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const w=1e4;let E;async function m(a,h,y){return h["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,D.isLaunchedFromCli)(y)&&!h["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,D.isLaunchedFromCli)(y)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=v.Promises.withAsyncBody(async(S,o)=>{const t=new I.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),o(new Error((0,P.localize)(0,null)))},w);try{S(await p(a,t.token))}catch(e){!(0,b.isCancellationError)(e)&&!t.token.isCancellationRequested?o(new Error((0,P.localize)(1,null,(0,O.toErrorMessage)(e)))):S({})}finally{clearTimeout(r),t.dispose()}})),E)}i.getResolvedShellEnv=m;async function p(a,h){const y=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",y);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",S);const o=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",r);const e=await(0,C.getSystemShell)(c.OS,r);return a.trace("getUnixShellEnvironment#shell",e),new Promise((n,s)=>{if(h.isCancellationRequested)return s((0,b.canceled)());const l=(0,R.basename)(e);let u,f;const d=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(u=`& '${process.execPath}' ${d} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' ${d} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?f=["-ic"]:f=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const T=(0,L.spawn)(e,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});h.onCancellationRequested(()=>(T.kill(),s((0,b.canceled)()))),T.on("error",X=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(X)),s(X)});const M=[];T.stdout.on("data",X=>M.push(X));const H=[];T.stderr.on("data",X=>H.push(X)),T.on("close",(X,ee)=>{const ie=Buffer.concat(M).toString("utf8");a.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(H).toString("utf8");if(ne.trim()&&a.trace("getUnixShellEnvironment#stderr",ne),X||ee)return s(new Error((0,P.localize)(2,null,X,ee)));const fe=t.exec(ie),B=fe?fe[1]:"{}";try{const _=JSON.parse(B);y?_.ELECTRON_RUN_AS_NODE=y:delete _.ELECTRON_RUN_AS_NODE,S?_.ELECTRON_NO_ATTACH_CONSOLE=S:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",_),n(_)}catch(_){a.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(_)),s(_)}})})}}),define(Y[117],Q([0,1,3,7,2,101,8,65,13]),function(x,i,L,R,P,I,O,b,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var C;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(C=i.WillSaveStateReason||(i.WillSaveStateReason={}));var D;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(D=i.StorageScope||(i.StorageScope={}));var v;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(v=i.StorageTarget||(i.StorageTarget={}));class w extends P.Disposable{constructor(a={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=a,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,h){h===g?(a===0?this._globalKeyTargets=void 0:a===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:a})):this._onDidChangeValue.fire({scope:a,key:h,target:this.getKeyTargets(a)[h]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,h,y){return this.getStorage(h)?.get(a,y)}getBoolean(a,h,y){return this.getStorage(h)?.getBoolean(a,y)}getNumber(a,h,y){return this.getStorage(h)?.getNumber(a,y)}store(a,h,y,S){if((0,O.isUndefinedOrNull)(h)){this.remove(a,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,y,S),this.getStorage(y)?.set(a,h)})}remove(a,h){this.withPausedEmitters(()=>{this.updateKeyTarget(a,h,void 0),this.getStorage(h)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,h){const y=[],S=this.getKeyTargets(a);for(const o of Object.keys(S))S[o]===h&&y.push(o);return y}updateKeyTarget(a,h,y){const S=this.getKeyTargets(h);typeof y=="number"?S[a]!==y&&(S[a]=y,this.getStorage(h)?.set(g,JSON.stringify(S))):typeof S[a]=="number"&&(delete S[a],this.getStorage(h)?.set(g,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(a){return a===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(a){const h=this.get(g,a);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(a){return this.getBoolean(i.IS_NEW_KEY,a)===!0}async flush(a=C.NONE){this._onWillSaveState.fire({reason:a});const h=this.getStorage(0),y=this.getStorage(1);switch(a){case C.NONE:await L.Promises.settled([h?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await L.Promises.settled([h?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const a=this.getStorage(0)?.items??new Map,h=this.getStorage(1)?.items??new Map;return m(a,h,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends w{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.globalStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a)))}getStorage(a){return a===0?this.globalStorage:this.workspaceStorage}getLogDetails(a){return a===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(a){}}i.InMemoryStorageService=E;async function m(p,a,h,y){const S=l=>{try{return JSON.parse(l)}catch{return l}},o=new Map,t=new Map;p.forEach((l,u)=>{o.set(u,l),t.set(u,S(l))});const r=new Map,e=new Map;a.forEach((l,u)=>{r.set(u,l),e.set(u,S(l))}),console.group(`Storage: Global (path: ${h})`);let n=[];o.forEach((l,u)=>{n.push({key:u,value:l})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${y})`);let s=[];r.forEach((l,u)=>{s.push({key:u,value:l})}),console.table(s),console.groupEnd(),console.log(e)}i.logStorage=m}),define(Y[118],Q([0,1,11,29,9,27]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function O(g){if(L.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function b(g,C,D,v,w,E,m,p,a,h){const y=Object.create(null);y["common.machineId"]=m,y.sessionID=(0,I.generateUuid)()+Date.now(),y.commitHash=w,y.version=E,y["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,L.PlatformToString)(L.platform),y["common.nodePlatform"]=R.platform,y["common.nodeArch"]=v,y["common.product"]=h||"desktop";const S=c(p||[]);S&&(y["common.msftInternal"]=S);let o=0;const t=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),L.isLinuxSnap&&(y["common.snap"]="true");const r=O(D);r&&(y["common.platformDetail"]=r);try{const e=await g.readFile(P.URI.file(a));y["common.source"]=e.value.toString().slice(0,30)}catch{}return y}i.resolveCommonProperties=b;function c(g){const C=R.env.USERDNSDOMAIN;if(!C)return!1;const D=C.toLowerCase();return g.some(v=>D===v)}i.verifyMicrosoftInternalDomain=c}),define(Y[32],Q([0,1,13]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,L.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Y[119],Q([0,1,18,3,25,6,7,2,11,9,74,21,24,14,30,32]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let p=class extends b.Disposable{constructor(t,r,e,n){super();this.galleryService=t,this.telemetryService=r,this.logService=e,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new O.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new O.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new O.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(e=>(0,D.isTargetPlatformCompatible)(e,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new D.ExtensionManagementError(C.localize(0,null),D.ExtensionManagementErrorCode.Internal);const e=await this.checkAndGetCompatibleVersion(t,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(e.manifest,e.extension,r)}catch(e){throw y(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(t),void 0,e),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(e),h(e)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const r=await this.getTargetPlatform(),[e]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},P.CancellationToken.None);if(!e)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,e){if(!g.URI.isUri(r)){let f=this.installingExtensions.get(v.ExtensionKey.create(r).toString());if(f)return this.logService.info("Extensions is already requested to install",r.identifier.id),f.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],l=this.createInstallExtensionTask(t,r,e);g.URI.isUri(r)||this.installingExtensions.set(v.ExtensionKey.create(r).toString(),l),this._onInstallExtension.fire({identifier:l.identifier,source:r}),this.logService.info("Installing extension:",l.identifier.id),n.push({task:l,manifest:t});let u=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",l.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(l.identifier,t,!!e.installOnlyNewlyAddedFromExtensionPack,!!e.installPreReleaseVersion);for(const{gallery:T,manifest:M}of d){u=u||!!M.extensionDependencies?.some(X=>(0,v.areSameExtensions)({id:X},l.identifier));const H=v.ExtensionKey.create(T).toString();if(this.installingExtensions.has(H))this.logService.info("Extension is already requested to install",T.identifier.id);else{const X=this.createInstallExtensionTask(M,T,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(H,X),this._onInstallExtension.fire({identifier:X.identifier,source:T}),this.logService.info("Installing extension:",X.identifier.id),n.push({task:X,manifest:M})}}}catch(d){if(g.URI.isUri(l.source))(0,L.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",l.identifier.id,d.message),(0,L.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",l.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",l.identifier.id),d}const f=n.reduce((d,{task:T,manifest:M})=>(d.set(T.identifier.id.toLowerCase(),{task:T,manifest:M}),d),new Map);for(;f.size;){let d;const T=[...f.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(H=>f.has(H.toLowerCase())));T.length?d=f.size===1?T:T.filter(({task:M})=>!(M===l&&!u)):(this.logService.info("Found extensions with circular dependencies",T.map(({task:M})=>M.identifier.id)),d=[...f.values()]),await this.joinAllSettled(d.map(async({task:M})=>{const H=new Date().getTime();try{const X=await M.run();if(await this.joinAllSettled(this.participants.map(ee=>ee.postInstall(X,M.source,e,P.CancellationToken.None))),!g.URI.isUri(M.source)&&(y(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-H,void 0),c.isWeb&&M.operation!==3))try{await this.galleryService.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}s.push({local:X,identifier:M.identifier,operation:M.operation,source:M.source})}catch(X){throw g.URI.isUri(M.source)||y(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-H,X),this.logService.error("Error while installing the extension:",M.identifier.id),X}finally{f.delete(M.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:d})=>(0,v.areSameExtensions)(d,l.identifier))[0].local}catch(f){if(n.forEach(({task:d})=>d.cancel()),s.length)try{const d=await Promise.allSettled(s.map(({local:T})=>this.createUninstallExtensionTask(T,{versionOnly:!0}).run()));for(let T=0;T<d.length;T++){const M=d[T],{identifier:H}=s[T];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",H.id):this.logService.warn("Rollback: Error while uninstalling extension",H.id,(0,I.getErrorMessage)(M.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(d),s.map(({identifier:T})=>T.id))}throw this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:2,source:d.source}))),f}finally{for(const{task:f}of n)if(!g.URI.isUri(f.source)){const d=v.ExtensionKey.create(f.source).toString();this.installingExtensions.delete(d)||this.logService.warn("Installation task is not found in the cache",d)}}}async joinAllSettled(t){const r=[],e=[],n=await Promise.allSettled(t);for(const s of n)s.status==="fulfilled"?r.push(s.value):e.push(s.reason);if(e.length)throw a(e);return r}async getAllDepsAndPackExtensionsToInstall(t,r,e,n){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const l=[t,...s.map(d=>d.identifier)],u=[],f=async(d,T)=>{const M=T.extensionDependencies||[],H=[...M];if(T.extensionPack){const X=e?s.find(ee=>(0,v.areSameExtensions)(ee.identifier,d)):void 0;for(const ee of T.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(ie=>(0,v.areSameExtensions)({id:ie},{id:ee}))||H.every(ie=>!(0,v.areSameExtensions)({id:ie},{id:ee}))&&H.push(ee)}if(H.length){const X=[...l,...u.map(ie=>ie.gallery.identifier)],ee=H.filter(ie=>X.every(ne=>!(0,v.areSameExtensions)(ne,{id:ie})));if(ee.length){const ie=await this.galleryService.getExtensions(ee.map(ne=>({id:ne,preRelease:n})),P.CancellationToken.None);for(const ne of ie){if(X.find(_=>(0,v.areSameExtensions)(_,ne.identifier)))continue;const fe=M.some(_=>(0,v.areSameExtensions)({id:_},ne.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(ne,!0,n)}catch(_){if(_ instanceof D.ExtensionManagementError&&_.code===D.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!fe){this.logService.info("Skipping the packed extension as it cannot be installed",ne.identifier.id);continue}else throw _}u.push({gallery:B.extension,manifest:B.manifest}),await f(B.extension.identifier,B.manifest)}}}};return await f(t,r),s=await this.getInstalled(),u.filter(d=>!s.some(T=>(0,v.areSameExtensions)(T.identifier,d.gallery.identifier)))}async checkAndGetCompatibleVersion(t,r,e){const n=await this.getExtensionsControlManifest();if((0,v.getMaliciousExtensionsSet)(n).has(t.identifier.id))throw new D.ExtensionManagementError(C.localize(3,null,t.identifier.id),D.ExtensionManagementErrorCode.Malicious);if(!!n.unsupportedPreReleaseExtensions&&!!n.unsupportedPreReleaseExtensions[t.identifier.id])throw new D.ExtensionManagementError(C.localize(4,null,t.identifier.id,n.unsupportedPreReleaseExtensions[t.identifier.id].displayName),D.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(t)){const u=await this.getTargetPlatform();throw new D.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.productService.nameLong,(0,D.TargetPlatformToString)(u)),D.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(t,r,e);if(s){if(e&&r&&t.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new D.ExtensionManagementError(C.localize(6,null,t.identifier.id,this.productService.nameLong,this.productService.version),D.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!e&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],P.CancellationToken.None))[0]?new D.ExtensionManagementError(C.localize(7,null,t.identifier.id),D.ExtensionManagementErrorCode.ReleaseVersionNotFound):new D.ExtensionManagementError(C.localize(8,null,t.identifier.id,this.productService.nameLong,this.productService.version),D.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const l=await this.galleryService.getManifest(s,P.CancellationToken.None);if(l===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,D.ExtensionManagementErrorCode.Invalid);if(l.version!==s.version)throw new D.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,D.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:l}}async getCompatibleVersion(t,r,e){const n=await this.getTargetPlatform();let s=null;return r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==e&&(s=(await this.galleryService.getExtensions([{...t.identifier,preRelease:e}],{targetPlatform:n,compatible:!0},P.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(t,e,n)&&(s=t),!s&&r&&(s=await this.galleryService.getCompatibleExtension(t,e,n)),s}async unininstallExtension(t,r){const e=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),e.waitUntilTaskIsFinished();const n=(f,d)=>{const T=this.createUninstallExtensionTask(f,d);return this.uninstallingExtensions.set(T.extension.identifier.id.toLowerCase(),T),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),T},s=(f,d)=>{d?this.logService.error("Failed to uninstall extension:",f.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)(f),void 0,d),this._onDidUninstallExtension.fire({identifier:f.identifier,error:d?.code})},l=[],u=[];try{l.push(n(t,{}));const f=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(t,f);for(const T of d)this.uninstallingExtensions.has(T.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",T.identifier.id):l.push(n(T,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(l.map(d=>d.extension),f,t),await this.joinAllSettled(l.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(T=>T.postUninstall(d.extension,r,P.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch{}s(d.extension)}catch(T){const M=T instanceof D.ExtensionManagementError?T:new D.ExtensionManagementError((0,I.getErrorMessage)(T),D.ExtensionManagementErrorCode.Internal);throw s(d.extension,M),M}finally{u.push(d)}}))}catch(f){const d=f instanceof D.ExtensionManagementError?f:new D.ExtensionManagementError((0,I.getErrorMessage)(f),D.ExtensionManagementErrorCode.Internal);for(const T of l){try{T.cancel()}catch{}u.includes(T)||s(T.extension,d)}throw d}finally{for(const f of l)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(t,r,e){for(const n of t){const s=this.getDependents(n,r);if(s.length){const l=s.filter(u=>!t.some(f=>(0,v.areSameExtensions)(f.identifier,u.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(n,l,e))}}}getDependentsErrorMessage(t,r,e){return e===t?r.length===1?C.localize(9,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(10,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(11,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(12,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(13,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(14,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,e=[]){if(e.indexOf(t)!==-1)return[];e.push(t);const n=t.manifest.extensionPack?t.manifest.extensionPack:[];if(n.length){const s=r.filter(u=>!u.isBuiltin&&n.some(f=>(0,v.areSameExtensions)({id:f},u.identifier))),l=[];for(const u of s)l.push(...this.getAllPackExtensionsToUninstall(u,r,e));return[...s,...l]}return[]}getDependents(t,r){return r.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(n=>(0,v.areSameExtensions)({id:n},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};p=he([ae(0,D.IExtensionGalleryService),ae(1,m.ITelemetryService),ae(2,w.ILogService),ae(3,E.IProductService)],p),i.AbstractExtensionManagementService=p;function a(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,e)=>new Error(`${r.message}${r.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}i.joinErrors=a;function h(o){if(o instanceof D.ExtensionManagementError)return o;const t=new D.ExtensionManagementError(o.message,D.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function y(o,t,r,e,n){const s=n?n instanceof D.ExtensionManagementError?n.code:D.ExtensionManagementErrorCode.Internal:void 0;o.publicLogError(t,{...r,success:!n,duration:e,errorcode:s})}i.reportTelemetry=y;class S{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(t=>new Promise((r,e)=>{const n=t.onCancellationRequested(()=>{n.dispose(),e((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=S}),define(Y[36],Q([0,1,22,8,23,32]),function(x,i,L,R,P,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(h,y){return Promise.resolve(void 0)}publicLog2(h,y){return this.publicLog(h,y)}publicLogError(h,y){return Promise.resolve(void 0)}publicLogError2(h,y){return this.publicLogError(h,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=O,i.NullTelemetryService=new O;class b{async publicLog(h,y,S){}async publicLogError(h,y,S){}}i.NullEndpointTelemetryService=b,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,h){return h.onDidChangeConfiguration(y=>{y.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(y.source),configurationKeys:E(y.sourceConfig)})})}i.configurationTelemetry=c;function g(a,h){return!(h.disableTelemetry||!a.enableTelemetry||h.extensionTestsLocationURI)}i.supportsTelemetry=g;function C(a){const h=a.getValue(I.TELEMETRY_SETTING_ID),y=a.getValue("telemetry.enableCrashReporter");if(a.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=C;function D(a){const h=Object.create(null),y=Object.create(null),S=Object.create(null);w(a,S);for(let o in S){o=o.length>150?o.substr(o.length-149):o;const t=S[o];typeof t=="number"?y[o]=t:typeof t=="boolean"?y[o]=t?1:0:typeof t=="string"?(t.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${t.length}`),h[o]=t.substring(0,8191)):typeof t!="undefined"&&t!==null&&(h[o]=t)}return{properties:h,measurements:y}}i.validateTelemetryData=D;function v(a){if(!a)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{a.indexOf(`${S}+`)===0&&(h=S)}),h}i.cleanRemoteAuthority=v;function w(a,h,y=0,S){if(!!a)for(let o of Object.getOwnPropertyNames(a)){const t=a[o],r=S?S+o:o;Array.isArray(t)?h[r]=(0,L.safeStringify)(t):t instanceof Date?h[r]=t.toISOString():(0,R.isObject)(t)?y<2?w(t,h,y+1,r+"."):h[r]=(0,L.safeStringify)(t):h[r]=t}}function E(a){if(!a)return[];const h=[];return m(h,"",a),h}function m(a,h,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(S=>m(a,h?`${h}.${S}`:S,y[S])):a.push(h)}function p(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}i.getPiiPathsFromEnvironment=p}),define(Y[120],Q([0,1,91,36]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(I,O,b,c,g,C){const D={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${O.nameShort})`},v=await(0,L.getServiceMachineId)(b,g,C);return(0,R.supportsTelemetry)(O,b)&&(0,R.getTelemetryLevel)(c)===3&&(D["X-Market-User-Id"]=v),D}i.resolveMarketplaceHeaders=P}),define(Y[121],Q([0,1,18,25,6,22,11,29,8,9,23,20,21,24,48,16,14,30,42,120,117,32]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m,p,a,h,y,S,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const t=O.isWeb?"web":(0,v.getTargetPlatform)(O.platform,b.arch);var r;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function e(...k){return String(k.reduce((A,z)=>A|z,0))}var n;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class d{constructor(A=f){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,z=this.state.pageSize){return new d({...this.state,pageNumber:A,pageSize:z})}withFilter(A,...z){const V=[...this.state.criteria,...z.length?z.map(G=>({filterType:A,value:G})):[{filterType:A}]];return new d({...this.state,criteria:V})}withSortBy(A){return new d({...this.state,sortBy:A})}withSortOrder(A){return new d({...this.state,sortOrder:A})}withFlags(...A){return new d({...this.state,flags:A.reduce((z,V)=>z|V,0)})}withAssetTypes(...A){return new d({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:z,pageSize:V,sortBy:G,sortOrder:q,flags:se,assetTypes:le}=this.state;return{filters:[{criteria:A,pageNumber:z,pageSize:V,sortBy:G,sortOrder:q}],assetTypes:le,flags:se}}get searchText(){const A=this.state.criteria.filter(z=>z.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber)}}}function T(k,A){const z=(k||[]).filter(V=>V.statisticName===A)[0];return z?z.value:0}function M(k){const A="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,G)=>{const q=ee(k,G.assetType);return q&&V.push([G.assetType.substring(A.length),q]),V},[])}function H(k){if(k.properties){const A=k.properties.filter(G=>G.key===s.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(G=>z.test(G.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return ee(k,s.Repository)}function X(k){return{uri:`${k.fallbackAssetUri}/${s.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${s.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function ee(k,A){return k.files.filter(V=>V.assetType===A)[0]?{uri:`${k.assetUri}/${A}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${A}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function ie(k,A){const z=k.properties?k.properties.filter(G=>G.key===A):[],V=z.length>0&&z[0].value;return V?V.split(",").map(G=>(0,w.adoptToGalleryExtensionId)(G)):[]}function ne(k){const A=k.properties?k.properties.filter(z=>z.key===l.Engine):[];return A.length>0&&A[0].value||""}function fe(k){const A=k.properties?k.properties.filter(z=>z.key===l.PreRelease):[];return A.length>0&&A[0].value==="true"}function B(k){const A=k.properties?k.properties.filter(V=>V.key===l.LocalizedLanguages):[],z=A.length>0&&A[0].value||"";return z?z.split(","):[]}function _(k){return k.indexOf("preview")!==-1}function re(k){return k.targetPlatform?(0,v.toTargetPlatform)(k.targetPlatform):"undefined"}function U(k){const A=(0,L.distinct)(k.versions.map(re)),z=!!k.tags?.includes(v.WEB_EXTENSION_TAG),V=A.indexOf("web");return z?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function N(k,A){const z=(0,v.getFallbackTargetPlarforms)(A);for(let V=0;V<k.length;V++){const G=k[V];if(G.version===k[V-1]?.version){let q=V;const se=re(G);if(se===A)for(;q>0&&k[q-1].version===G.version;)q--;else if(z.includes(se))for(;q>0&&k[q-1].version===G.version&&re(k[q-1])!==A;)q--;q!==V&&(k.splice(V,1),k.splice(q,0,G))}}return k}i.sortExtensionVersions=N;function W(k,A,z){k.telemetryData={index:A,querySource:z}}function K(k,A,z){const V=k.versions[0],G={manifest:ee(A,s.Manifest),readme:ee(A,s.Details),changelog:ee(A,s.Changelog),license:ee(A,s.License),repository:H(A),download:X(A),icon:ee(A,s.Icon),coreTranslations:M(A)};return{identifier:{id:(0,w.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:A.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,description:k.shortDescription||"",installCount:T(k.statistics,"install"),rating:T(k.statistics,"averagerating"),ratingCount:T(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:z,assets:G,properties:{dependencies:ie(A,l.Dependency),extensionPack:ie(A,l.ExtensionPack),engine:ne(A),localizedLanguages:B(A),targetPlatform:re(A),isPreReleaseVersion:fe(A)},hasPreReleaseVersion:fe(V),hasReleaseVersion:!0,preview:_(k.flags)}}let te=class{constructor(A,z,V,G,q,se,le,ge){this.requestService=z,this.logService=V,this.environmentService=G,this.telemetryService=q,this.fileService=se,this.productService=le,this.configurationService=ge;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,z,V){const G=R.CancellationToken.isCancellationToken(z)?{}:z,q=R.CancellationToken.isCancellationToken(z)?z:V,se=[],le=[],ge=[],me=[];let oe=!0;for(const ve of A){ve.uuid?le.push(ve.uuid):se.push(ve.id);const ye=!!(ve.version||ve.preRelease);ge.push({id:ve.id,uuid:ve.uuid,includePreRelease:ye}),ve.version&&me.push({id:ve.id,uuid:ve.uuid,version:ve.version}),oe=oe&&!!ve.hasPreRelease&&!ye}if(!le.length&&!se.length)return[];let ue=new d().withPage(1,A.length);le.length&&(ue=ue.withFilter(n.ExtensionId,...le)),se.length&&(ue=ue.withFilter(n.ExtensionName,...se)),(G.queryAllVersions||oe)&&(ue=ue.withFlags(ue.flags,r.IncludeVersions));const{extensions:we}=await this.queryGalleryExtensions(ue,{targetPlatform:G.targetPlatform??t,includePreRelease:ge,versions:me,compatible:!!G.compatible},q);return G.source&&we.forEach((ve,ye)=>W(ve,ye,G.source)),we}async getCompatibleExtension(A,z,V){if((0,v.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(A,z,V))return A;const G=new d().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,A.identifier.uuid),{extensions:q}=await this.queryGalleryExtensions(G,{targetPlatform:V,compatible:!0,includePreRelease:z},R.CancellationToken.None);return q[0]||null}async isExtensionCompatible(A,z,V){if(!(0,v.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,V)||!z&&A.properties.isPreReleaseVersion)return!1;let G=A.properties.engine;if(!G){const q=await this.getManifest(A,R.CancellationToken.None);if(!q)throw new Error("Manifest was not found");G=q.engines.vscode}return(0,E.isEngineValid)(G,this.productService.version,this.productService.date)}async isValidVersion(A,z,V,G,q){if(!(0,v.isTargetPlatformCompatible)(re(A),G,q)||z!=="any"&&fe(A)!==(z==="prerelease"))return!1;if(V){const se=await this.getEngine(A);if(!(0,E.isEngineValid)(se,this.productService.version,this.productService.date))return!1}return!0}async query(A,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=A.text||"";const G=(0,I.getOrDefault)(A,oe=>oe.pageSize,50);let q=new d().withPage(1,G);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,ue,we)=>(q=q.withFilter(n.Category,we||ue),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,ue,we)=>(q=q.withFilter(n.Tag,we||ue),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(n.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),q=q.withFilter(n.SearchText,V)),q=q.withSortBy(0)):A.ids?q=q.withFilter(n.ExtensionId,...A.ids):A.names?q=q.withFilter(n.ExtensionName,...A.names):q=q.withSortBy(4),typeof A.sortBy=="number"&&(q=q.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(q=q.withSortOrder(A.sortOrder));const se=async(oe,ue)=>{const{extensions:we,total:ve}=await this.queryGalleryExtensions(oe,{targetPlatform:t,compatible:!1,includePreRelease:!!A.includePreRelease},ue);return we.forEach((ye,Ne)=>W(ye,(oe.pageNumber-1)*oe.pageSize+Ne,A.source)),{extensions:we,total:ve}},{extensions:le,total:ge}=await se(q,z),me=async(oe,ue)=>{if(ue.isCancellationRequested)throw new P.CancellationError;const{extensions:we}=await se(q.withPage(oe+1),ue);return we};return{firstPage:le,total:ge,pageSize:q.pageSize,getPage:me}}async queryGalleryExtensions(A,z,V){const G=A.flags;!!(A.flags&r.IncludeLatestVersionOnly)&&!!(A.flags&r.IncludeVersions)&&(A=A.withFlags(A.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(A.flags&r.IncludeLatestVersionOnly)&&!(A.flags&r.IncludeVersions)&&(A=A.withFlags(A.flags,r.IncludeLatestVersionOnly)),z.versions?.length&&(A=A.withFlags(A.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),A=A.withFlags(A.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:q,total:se}=await this.queryRawGalleryExtensions(A,V);if(!(A.flags&r.IncludeLatestVersionOnly)){const oe=[];for(const ue of q){const we=await this.toGalleryExtensionWithCriteria(ue,z);we&&oe.push(we)}return{extensions:oe,total:se}}const ge=[],me=new Map;for(let oe=0;oe<q.length;oe++){const ue=q[oe],we={id:(0,w.getGalleryExtensionId)(ue.publisher.publisherName,ue.extensionName),uuid:ue.extensionId},ve=(0,c.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ne=>(0,w.areSameExtensions)(Ne,we))?.includePreRelease;if(z.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(U(ue),z.targetPlatform))continue;const ye=await this.toGalleryExtensionWithCriteria(ue,z);!ye||ye.properties.isPreReleaseVersion&&(!ve||!ye.hasReleaseVersion)||!ye.properties.isPreReleaseVersion&&ye.properties.targetPlatform!==z.targetPlatform&&ye.hasPreReleaseVersion?me.set(ue.extensionId,oe):ge.push([oe,ye])}if(me.size){const oe=new Date().getTime(),ue=new d().withFlags(G&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:we}=await this.queryGalleryExtensions(ue,z,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-oe,count:me.size});for(const ve of we){const ye=me.get(ve.identifier.uuid);ge.push([ye,ve])}}return{extensions:ge.sort((oe,ue)=>oe[0]-ue[0]).map(([,oe])=>oe),total:se}}async toGalleryExtensionWithCriteria(A,z){const V={id:(0,w.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},G=z.versions?.find(ge=>(0,w.areSameExtensions)(ge,V))?.version,q=(0,c.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(ge=>(0,w.areSameExtensions)(ge,V))?.includePreRelease,se=U(A),le=N(A.versions,z.targetPlatform);if(z.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(se,z.targetPlatform))return null;for(let ge=0;ge<le.length;ge++){const me=le[ge];if(!(G&&me.version!==G)){if(await this.isValidVersion(me,q?"any":"release",z.compatible,se,z.targetPlatform))return K(A,me,se);if(G&&me.version===G)return null}}return G||z.compatible?null:K(A,A.versions[0],se)}async queryRawGalleryExtensions(A,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,e(r.Unpublished));const V=await this.commonHeadersPromise,G=JSON.stringify(A.raw),q={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},se=new Date().getTime();let le,ge,me=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:G,headers:q},z),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:me};const oe=await(0,h.asJson)(le);if(oe){const ue=oe.results[0],we=ue.extensions,ve=ue.resultMetadata&&ue.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return me=ve&&ve.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:me}}return{galleryExtensions:[],total:me}}catch(oe){throw ge=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-se,success:!!le&&(0,h.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ge?(0,P.isCancellationError)(ge)?"canceled":(0,P.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(A,z,V,G){if(!this.isEnabled())return;const q=O.isWeb?this.api(`/itemName/${A}.${z}/version/${V}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${z}/${V}/stats?statType=${G}`),se=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:q,headers:ge},R.CancellationToken.None)}catch{}}async download(A,z,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const G=(0,w.getGalleryExtensionTelemetryData)(A),q=new Date().getTime(),se=oe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...G,duration:oe}),le=V===2?"install":V===3?"update":"",ge=le?{uri:`${A.assets.download.uri}${g.URI.parse(A.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${A.assets.download.fallbackUri}${g.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:A.assets.download,me=await this.getAsset(ge);await this.fileService.writeFile(z,me.stream),se(new Date().getTime()-q)}async getReadme(A,z){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},z);return await(0,h.asText)(V)||""}return""}async getManifest(A,z){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},z),G=await(0,h.asText)(V);return G?JSON.parse(G):null}return null}async getManifestFromRawExtensionVersion(A,z){const V=ee(A,s.Manifest);if(!V)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},q=await this.getAsset(V,{headers:G});return await(0,h.asJson)(q)}async getCoreTranslation(A,z){const V=A.assets.coreTranslations.filter(G=>G[0]===z.toUpperCase())[0];if(V){const G=await this.getAsset(V[1]),q=await(0,h.asText)(G);return q?JSON.parse(q):null}return null}async getChangelog(A,z){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},z);return await(0,h.asText)(V)||""}return""}async getAllCompatibleVersions(A,z,V){let G=new d().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?G=G.withFilter(n.ExtensionId,A.identifier.uuid):G=G.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:q}=await this.queryRawGalleryExtensions(G,R.CancellationToken.None);if(!q.length)return[];const se=U(q[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(se,V))return[];const le=[];await Promise.all(q[0].versions.map(async oe=>{try{await this.isValidVersion(oe,z?"any":"release",!0,se,V)&&le.push(oe)}catch{}}));const ge=[],me=new Set;for(const oe of N(le,V))me.has(oe.version)||(me.add(oe.version),ge.push({version:oe.version,date:oe.lastUpdated,isPreReleaseVersion:fe(oe)}));return ge}async getAsset(A,z={},V=R.CancellationToken.None){const G=await this.commonHeadersPromise,q={type:"GET"},se={...G,...z.headers||{}};z={...z,...q,headers:se};const le=A.uri,ge=A.fallbackUri,me={...z,url:le};try{const oe=await this.requestService.request(me,V);if(oe.res.statusCode===200)return oe;const ue=await(0,h.asText)(oe);throw new Error(`Expected 200, got back ${oe.res.statusCode} instead.

${ue}`)}catch(oe){if((0,P.isCancellationError)(oe))throw oe;const ue=(0,P.getErrorMessage)(oe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:ue});const we={...z,url:ge};return this.requestService.request(we,V)}}async getEngine(A){let z=ne(A);if(!z){const V=await this.getManifestFromRawExtensionVersion(A,R.CancellationToken.None);if(!V)throw new Error("Manifest was not found");z=V.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,h.asJson)(A),V=[],G={};if(z){for(const q of z.malicious)V.push({id:q});if(z.unsupported)for(const q of Object.keys(z.unsupported)){const se=z.unsupported[q];(0,c.isBoolean)(se)||(G[q.toLowerCase()]=se.preReleaseExtension)}if(z.migrateToPreRelease)for(const[q,se]of Object.entries(z.migrateToPreRelease))(!se.engine||(0,E.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&(G[q.toLowerCase()]=se)}return{malicious:V,unsupportedPreReleaseExtensions:G}}};te=he([ae(1,h.IRequestService),ae(2,p.ILogService),ae(3,D.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,m.IFileService),ae(6,a.IProductService),ae(7,C.IConfigurationService)],te);let J=class extends te{constructor(A,z,V,G,q,se,le,ge){super(A,z,V,G,q,se,le,ge)}};J=he([ae(0,S.IStorageService),ae(1,h.IRequestService),ae(2,p.ILogService),ae(3,D.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,m.IFileService),ae(6,a.IProductService),ae(7,C.IConfigurationService)],J),i.ExtensionGalleryService=J;let Z=class extends te{constructor(A,z,V,G,q,se,le){super(void 0,A,z,V,G,q,se,le)}};Z=he([ae(0,h.IRequestService),ae(1,p.ILogService),ae(2,D.IEnvironmentService),ae(3,o.ITelemetryService),ae(4,m.IFileService),ae(5,a.IProductService),ae(6,C.IConfigurationService)],Z),i.ExtensionGalleryServiceWithNoStorageService=Z}),define(Y[122],Q([0,1,2,22,11,26,86,23,34,123,30,31,32,36]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(a,h,y){this._configurationService=h,this._productService=y,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=a.appenders,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(a,h){this._experimentProperties[a]=h}_updateTelemetryLevel(){this._telemetryLevel=(0,w.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const h=a.usage?3:a.error?2:0;this._telemetryLevel=Math.min(this._telemetryLevel,h)}}get telemetryLevel(){return this._telemetryLevel}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const a=await this._commonProperties;let h=a.sessionID,y=a["common.machineId"],S=a["common.firstSessionDate"],o=a["common.msftInternal"];return{sessionId:h,machineId:y,firstSessionDate:S,msftInternal:o}}dispose(){this._disposables.dispose()}_log(a,h,y,S){return this.telemetryLevel<h?Promise.resolve(void 0):this._commonProperties.then(o=>{y=(0,R.mixin)(y,o),y=(0,R.mixin)(y,this._experimentProperties),y=(0,R.cloneAndChange)(y,t=>{if(typeof t=="string")return this._cleanupInfo(t,S)}),this._appenders.forEach(t=>t.log(a,y))},o=>{console.error(o)})}publicLog(a,h,y){return this._log(a,3,h,y)}publicLog2(a,h,y){return this.publicLog(a,h,y)}publicLogError(a,h){return this._sendErrorTelemetry?this._log(a,2,h,!0):Promise.resolve(void 0)}publicLogError2(a,h){return this.publicLogError(a,h)}_anonymizeFilePaths(a){let h=a;const y=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(a);if(!e)break;y.push([e.index,r.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let t=0;for(h="";;){const r=o.exec(a);if(!r)break;!S.test(r[0])&&y.every(([e,n])=>r.index<e||r.index>=n)&&(h+=a.substring(t,r.index)+"<REDACTED: user-file-path>",t=o.lastIndex)}return t<a.length&&(h+=a.substr(t)),h}_removePropertiesWithPossibleUserInfo(a){if(!a)return a;const h=a.toLowerCase(),y=/@[a-zA-Z0-9-.]+/,S=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,o=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return S.test(h)?"<REDACTED: secret>":y.test(h)?"<REDACTED: email>":o.test(h)?"<REDACTED: token>":a}_cleanupInfo(a,h){let y=a;h&&(y=this._anonymizeFilePaths(y));for(let S of this._cleanupPatterns)y=y.replace(S,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([ae(1,b.IConfigurationService),ae(2,C.IProductService)],E),i.TelemetryService=E;function m(){const p=(0,O.localize)(0,null,g.default.nameLong),a=g.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=P.isWeb?"":(0,O.localize)(3,null),y=(0,O.localize)(4,null),S=(0,O.localize)(5,null),o=(0,O.localize)(6,null),t=(0,O.localize)(7,null),r=`
|       | ${y} | ${S} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,e=(0,O.localize)(8,null);return`
${p} ${a} ${h}

&nbsp;

${t}
${r}

&nbsp;

${e}
`}D.Registry.as(c.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),D.Registry.as(c.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,O.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,O.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[124],Q([0,1,6,22,36]),function(x,i,L,R,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function I(b){const c=await new Promise((C,D)=>{x(["applicationinsights"],C,D)});let g;return c.defaultClient?(g=new c.TelemetryClient(b),g.channel.setUseDiskRetryCaching(!0)):(c.setup(b).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=c.defaultClient),b.indexOf("AIF-")===0&&(g.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),g}class O{constructor(c,g,C){this._eventPrefix=c,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient)),this._asyncAIClient.then(g=>{c(g)},g=>{(0,L.onUnexpectedError)(g),console.error(g)})}}log(c,g){if(!!this._aiClient){g=(0,R.mixin)(g,this._defaultData),g=(0,P.validateTelemetryData)(g);try{this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+c,properties:g.properties,measurements:g.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(g=>{try{g.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=O}),define(Y[125],Q([0,1,10,15]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(I,O){const b=Object.create(null),c=(C,D)=>{const v=JSON.parse(C);b[D]=v};if(O){const C=[],D=await R.Promises.readdir(O);for(const w of D)try{(await R.Promises.stat((0,L.join)(O,w))).isDirectory()&&C.push(w)}catch{}const v=[];for(const w of C)(await R.Promises.readdir((0,L.join)(O,w))).filter(m=>m==="telemetry.json").length===1&&v.push(w);for(const w of v){const E=(await R.Promises.readFile((0,L.join)(O,w,"telemetry.json"))).toString();c(E,w)}}let g=(await R.Promises.readFile((0,L.join)(I,"telemetry-core.json"))).toString();return c(g,"vscode-core"),g=(await R.Promises.readFile((0,L.join)(I,"telemetry-extensions.json"))).toString(),c(g,"vscode-extensions"),JSON.stringify(b,null,4)}i.buildTelemetryMessage=P}),define(Y[37],Q([0,1,13]),function(x,i,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(Y[126],Q([0,1,7,2,9,20,24,16,14,37]),function(x,i,L,R,P,I,O,b,c,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let C=class extends R.Disposable{constructor(v,w,E,m,p){super();this.extensionsManagementService=v,this.logService=m,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(h=>{this.installedExtensions=h.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(h=>this.onInstallExtension(h))),this._register(v.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(v.onDidUninstallExtension(h=>this.onDidUninstallExtension(h)));const a=P.URI.file(E.extensionsPath);this._register(w.watch(a)),this._register(L.Event.filter(w.onDidFilesChange,h=>h.rawChanges.some(y=>this.doesChangeAffects(y,a)))(()=>this.onDidChange()))}doesChangeAffects(v,w){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),w)?this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!(v.type!==1&&v.type!==2||this.uriIdentityService.extUri.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const w of v)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(w=>!(0,O.areSameExtensions)(w,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,O.areSameExtensions)(w,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),w=v.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,O.areSameExtensions)(p,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),E=this.installedExtensions.filter(m=>this.installingExtensions.some(p=>(0,O.areSameExtensions)(p,m))?!1:v.every(p=>!(0,O.areSameExtensions)(p.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=v.map(m=>m.identifier),(w.length||E.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:E})}}};C=he([ae(1,b.IFileService),ae(2,I.INativeEnvironmentService),ae(3,c.ILogService),ae(4,g.IUriIdentityService)],C),i.ExtensionsWatcher=C}),define(Y[127],Q([0,1,37,92,16,19,58,7,2]),function(x,i,L,R,P,I,O,b,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class g{constructor(v){this.uri=v,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let C=class{constructor(v){this._fileService=v,this._dispooables=new c.DisposableStore,this._limit=2**16;const w=new Map,E=m=>{let p=w.get(m.scheme);return p===void 0&&(p=v.hasProvider(m)&&!this._fileService.hasCapability(m,1024),w.set(m.scheme,p)),p};this._dispooables.add(b.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(m=>{w.delete(m.scheme)})),this.extUri=new I.ExtUri(E),this._canonicalUris=new O.SkipList((m,p)=>this.extUri.compare(m,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,I.normalizePath)(v));let w=this._canonicalUris.get(v);return w?w.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new g(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((E,m)=>E[1].touch<m[1].touch?1:E[1].touch>m[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let E=0;E<w;E++)this._canonicalUris.set(v[E][0],v[E][1].touch())}};C=he([ae(0,P.IFileService)],C),i.UriIdentityService=C,(0,R.registerSingleton)(L.IUriIdentityService,C,!0)}),define(Y[43],Q([0,1,103,3,10,8,15,72,139,140]),function(x,i,L,R,P,I,O,b,c,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class C extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=C;function D(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function v(o){if(o instanceof C)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new C(t,o)}function w(o,t,r,e,n,s){const l=P.dirname(t),u=P.join(e,l);if(!u.startsWith(e))return Promise.reject(new Error(b.localize(0,null,t)));const f=P.join(e,t);let d;return s.onCancellationRequested(()=>{d&&d.destroy()}),Promise.resolve(O.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,M)=>{if(!s.isCancellationRequested)try{d=(0,L.createWriteStream)(f,{mode:r}),d.once("close",()=>T()),d.once("error",M),o.once("error",M),o.pipe(d)}catch(H){M(H)}}))}function E(o,t,r,e){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((l,u)=>{const f=new R.Sequencer,d=T=>{T.isCancellationRequested||(s++,o.readEntry())};o.once("error",u),o.once("close",()=>n.then(()=>{e.isCancellationRequested||o.entryCount===s?l():u(new C("Incomplete",new Error(b.localize(1,null,s,o.entryCount))))},u)),o.readEntry(),o.on("entry",T=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){d(e);return}const M=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const ee=P.join(t,M);n=(0,R.createCancelablePromise)(ie=>O.Promises.mkdir(ee,{recursive:!0}).then(()=>d(ie)).then(void 0,u));return}const H=p(o,T),X=D(T);n=(0,R.createCancelablePromise)(ee=>f.queue(()=>H.then(ie=>w(ie,M,X,t,r,ee).then(()=>d(ee)))).then(null,u))})})}function m(o,t=!1){return new Promise((r,e)=>{(0,c.open)(o,t?{lazyEntries:!0}:void 0,(n,s)=>{n?e(v(n)):r((0,I.assertIsDefined)(s))})})}function p(o,t){return new Promise((r,e)=>{o.openReadStream(t,(n,s)=>{n?e(v(n)):r((0,I.assertIsDefined)(s))})})}function a(o,t){return new Promise((r,e)=>{const n=new g.ZipFile;t.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const s=(0,L.createWriteStream)(o);n.outputStream.pipe(s),n.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(o))})}i.zip=a;function h(o,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=m(o,!0);return r.overwrite&&(s=s.then(l=>O.Promises.rm(t).then(()=>l))),s.then(l=>E(l,t,{sourcePathRegex:n},e))}i.extract=h;function y(o,t){return m(o).then(r=>new Promise((e,n)=>{r.on("entry",s=>{s.fileName===t&&p(r,s).then(l=>e(l),l=>n(l))}),r.once("close",()=>n(new Error(b.localize(2,null,t))))}))}function S(o,t){return y(o,t).then(r=>new Promise((e,n)=>{const s=[];r.once("error",n),r.on("data",l=>s.push(l)),r.on("end",()=>e(Buffer.concat(s)))}))}i.buffer=S}),define(Y[128],Q([0,1,43,78]),function(x,i,L,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(I){return(0,L.buffer)(I,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=P}),define(Y[129],Q([0,1,18,3,6,2,12,10,11,19,41,9,27,15,43,79,20,21,24,90,35,16,14,30]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m,p,a,h,y,S,o,t,r){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let e=class extends I.Disposable{constructor(s,l,u,f,d,T){super();this.beforeRemovingExtension=s,this.targetPlatform=l,this.fileService=u,this.logService=f,this.environmentService=d,this.productService=T,this._devSystemExtensionsLocation=null,this.systemExtensionsLocation=D.URI.file(d.builtinExtensionsPath),this.userExtensionsLocation=D.URI.file(d.extensionsPath),this.uninstalledPath=(0,g.joinPath)(this.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const l=[];s===null||s===0?(l.push(this.scanDefaultSystemExtensions()),l.push(this.environmentService.isBuilt?Promise.resolve([]):this.scanDevSystemExtensions())):(l.push(Promise.resolve([])),l.push(Promise.resolve([]))),l.push(this.scanUserExtensions(!1));try{const[u,f,d]=await Promise.all(l),T=this.dedupExtensions([...u,...f,...d],await this.targetPlatform);return s!==null?T.filter(M=>M.type===s):T}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[l,u]=await Promise.all([this.getUninstalledExtensions(),this.scanFromUserExtensionsLocation()]);return u=u.filter(f=>!l[h.ExtensionKey.create(f).toString()]),u=s?this.dedupExtensions(u,await this.targetPlatform):u,this.logService.trace("Scanned user extensions:",u.length),u}async extractUserExtension(s,l,u,f){const d=s.toString(),T=b.join(this.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),M=b.join(this.userExtensionsLocation.fsPath,d);try{await w.Promises.rm(M)}catch{throw new a.ExtensionManagementError((0,m.localize)(0,null,M,s.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(s,l,T,f);let H=await this.scanExtension(D.URI.file(T),1);if(!H)throw new Error((0,m.localize)(1,null,T));await this.storeMetadata(H,{...u,installedTimestamp:Date.now()});try{await this.rename(s,T,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(X){try{await w.Promises.rm(T)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",s.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(X)}. Deleted from extracted location`,T),X}try{H=await this.scanExtension(D.URI.file(M),1)}catch{}if(H)return H;throw new Error((0,m.localize)(2,null,this.userExtensionsLocation.fsPath))}async saveMetadataForLocalExtension(s,l){return this.setMetadata(s,l),await this.storeMetadata(s,{...l,installedTimestamp:s.installedTimestamp}),s}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...s){const l=s.map(u=>h.ExtensionKey.create(u));await this.withUninstalledExtensions(u=>{l.forEach(f=>u[f.toString()]=!0)})}async setInstalled(s){await this.withUninstalledExtensions(f=>delete f[s.toString()]);const u=(await this.scanUserExtensions(!0)).find(f=>h.ExtensionKey.create(f).equals(s))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,u.type)):null}async removeExtension(s,l){this.logService.trace(`Deleting ${l} extension from disk`,s.identifier.id,s.location.fsPath),await w.Promises.rm(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(l=>delete l[h.ExtensionKey.create(s).toString()])}async storeMetadata(s,l){l.isMachineScoped=l.isMachineScoped||void 0,l.isBuiltin=l.isBuiltin||void 0,l.installedTimestamp=l.installedTimestamp||void 0;const u=b.join(s.location.fsPath,"package.json"),f=await w.Promises.readFile(u,"utf8"),{manifest:d}=await this.parseManifest(f);return d.__metadata=l,await w.Promises.writeFile(u,JSON.stringify(d,null,"	")),s}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let l;try{l=await w.Promises.readFile(this.uninstalledPath,"utf8")}catch(f){if(f.code!=="ENOENT")throw f}let u={};if(l)try{u=JSON.parse(l)}catch{}return s&&(s(u),Object.keys(u).length?await w.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await w.Promises.rm(this.uninstalledPath)),u})}async extractAtLocation(s,l,u,f){this.logService.trace(`Started extracting the extension from ${l} to ${u}`);try{await w.Promises.rm(u)}catch(d){throw new a.ExtensionManagementError(this.joinErrors(d).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(l,u,{sourcePath:"extension",overwrite:!0},f),this.logService.info(`Extracted extension to ${u}:`,s.id)}catch(d){try{await w.Promises.rm(u)}catch{}let T=a.ExtensionManagementErrorCode.Extract;throw d instanceof E.ExtractError&&(d.type==="CorruptZip"?T=a.ExtensionManagementErrorCode.CorruptZip:d.type==="Incomplete"&&(T=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(d.message,T)}}async rename(s,l,u,f){try{await w.Promises.rename(l,u)}catch(d){if(c.isWindows&&d&&d.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${l} to ${u} with 'EPERM' error. Trying again...`,s.id),this.rename(s,l,u,f);throw new a.ExtensionManagementError(d.message||(0,m.localize)(3,null,l,u),d.code||a.ExtensionManagementErrorCode.Rename)}}async scanExtensionsInLocation(s,l){const u=new R.Limiter(10),f=await this.fileService.resolve(s);return f.children?(await Promise.all(f.children.filter(T=>T.isDirectory).map(T=>u.queue(async()=>(0,g.isEqualOrParent)(T.resource,this.userExtensionsLocation)&&(0,g.basename)(T.resource).indexOf(".")===0?null:this.scanExtension(T.resource,l))))).filter(T=>T&&T.identifier):[]}async scanExtension(s,l){try{const u=await this.fileService.resolve(s);if(u.children){const{manifest:f,metadata:d}=await this.readManifest(s.fsPath),T=u.children.find(({name:ie})=>/^readme(\.txt|\.md|)$/i.test(ie))?.resource,M=u.children.find(({name:ie})=>/^changelog(\.txt|\.md|)$/i.test(ie))?.resource,H={id:(0,h.getGalleryExtensionId)(f.publisher,f.name)},X=d?.isSystem?0:l,ee={type:X,identifier:H,manifest:f,location:s,readmeUrl:T,changelogUrl:M,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:X===0};return this.setMetadata(ee,d),ee}}catch(u){l!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=await this.scanExtensionsInLocation(this.systemExtensionsLocation,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){this.logService.trace("Started scanning dev system extensions");const s=this.getDevSystemExtensionsList();if(s.length){const l=await this.scanExtensionsInLocation(this.devSystemExtensionsLocation,0);return this.logService.trace("Scanned dev system extensions:",l.length),l.filter(u=>s.some(f=>(0,h.areSameExtensions)(u.identifier,{id:f})))}else return[]}async scanFromUserExtensionsLocation(){return this.scanExtensionsInLocation(this.userExtensionsLocation,1)}dedupExtensions(s,l){const u=new Map;for(const f of s){const d=S.ExtensionIdentifier.toKey(f.identifier.id),T=u.get(d);if(T){if(C.gt(T.manifest.version,f.manifest.version)){this.logService.debug(`Skipping extension ${f.location.fsPath} with lower version ${f.manifest.version}.`);continue}if(C.eq(T.manifest.version,f.manifest.version)&&T.targetPlatform===l){this.logService.debug(`Skipping extension ${f.location.fsPath} from different target platform ${f.targetPlatform}`);continue}T.type===0?this.logService.debug(`Overwriting system extension ${T.location.fsPath} with ${f.location.fsPath}.`):this.logService.warn(`Overwriting user extension ${T.location.fsPath} with ${f.location.fsPath}.`)}u.set(d,f)}return[...u.values()]}setMetadata(s,l){s.publisherDisplayName=l?.publisherDisplayName||null,s.publisherId=l?.publisherId||null,s.identifier.uuid=l?.id,s.isMachineScoped=!!l?.isMachineScoped,s.isPreReleaseVersion=!!l?.isPreReleaseVersion,s.preRelease=!!l?.preRelease,s.isBuiltin=s.type===0||!!l?.isBuiltin,s.installedTimestamp=l?.installedTimestamp,s.targetPlatform=l?.targetPlatform??"undefined",s.updated=!!l?.updated}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),l=await this.scanFromUserExtensionsLocation(),u=new Set;for(const T of l)s[h.ExtensionKey.create(T).toString()]||u.add(T.identifier.id.toLowerCase());const f=(0,h.groupByExtension)(l,T=>T.identifier);await R.Promises.settled(f.map(async T=>{const M=T.sort((H,X)=>C.rcompare(H.manifest.version,X.manifest.version))[0];u.has(M.identifier.id.toLowerCase())||await this.beforeRemovingExtension(M)}));const d=l.filter(T=>s[h.ExtensionKey.create(T).toString()]);await R.Promises.settled(d.map(T=>this.removeUninstalledExtension(T)))}async removeOutdatedExtensions(){const s=await this.scanFromUserExtensionsLocation(),l=[],u=await this.targetPlatform,f=(0,h.groupByExtension)(s,d=>d.identifier);l.push(...(0,L.flatten)(f.map(d=>d.sort((T,M)=>{const H=C.rcompare(T.manifest.version,M.manifest.version);return H!==0?H:T.targetPlatform===u?-1:1}).slice(1)))),await R.Promises.settled(l.map(d=>this.removeExtension(d,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const l=Array.isArray(s)?s:[s];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((u,f)=>new Error(`${u.message}${u.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}get devSystemExtensionsLocation(){return this._devSystemExtensionsLocation||(this._devSystemExtensionsLocation=D.URI.file(b.normalize(b.join(O.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions")))),this._devSystemExtensionsLocation}async readManifest(s){const l=[w.Promises.readFile(b.join(s,"package.json"),"utf8").then(T=>this.parseManifest(T)),w.Promises.readFile(b.join(s,"package.nls.json"),"utf8").then(void 0,T=>T.code!=="ENOENT"?Promise.reject(T):"{}").then(T=>JSON.parse(T))],[{manifest:u,metadata:f},d]=await Promise.all(l);return{manifest:(0,y.localizeManifest)(u,d),metadata:f}}parseManifest(s){return new Promise((l,u)=>{try{const f=JSON.parse(s);f.publisher||(f.publisher=S.UNDEFINED_PUBLISHER);const d=f.__metadata||null;l({manifest:f,metadata:d})}catch{u(new Error((0,m.localize)(4,null)))}})}};e=he([ae(2,o.IFileService),ae(3,t.ILogService),ae(4,p.INativeEnvironmentService),ae(5,r.IProductService)],e),i.ExtensionsScanner=e}),define(Y[130],Q([0,1,28,6,12,10,11,19,41,8,9,27,15,43,77,49,20,119,21,24,110,98,128,111,129,126,48,16,13,14,30,32,37]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m,p,a,h,y,S,o,t,r,e,n,s,l,u,f,d,T,M){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let H=class extends a.AbstractExtensionManagementService{constructor(B,_,re,U,N,W,K,te,J){super(B,_,re,te);this.environmentService=U,this.downloadService=N,this.fileService=K;const Z=this._register(W.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(e.ExtensionsScanner,A=>Z.postUninstall(A),this.getTargetPlatform())),this.manifestCache=this._register(new r.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(W.createInstance(S.ExtensionsDownloader));const k=this._register(new n.ExtensionsWatcher(this,K,U,re,J));this._register(k.onDidChangeExtensionsByAnotherSource(({added:A,removed:z})=>{A.length&&this._onDidInstallExtensions.fire(A.map(V=>({identifier:V.identifier,operation:1,local:V}))),z.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,y.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const _=await this.collectFiles(B),re=await(0,w.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)()).fsPath,_);return C.URI.file(re)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const _=await this.downloadVsix(B),re=I.resolve(_.fsPath);return(0,t.getManifest)(re)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,_={}){this.logService.trace("ExtensionManagementService#install",B.toString());const re=await this.downloadVsix(B),U=await(0,t.getManifest)(I.resolve(re.fsPath));if(U.engines&&U.engines.vscode&&!(0,s.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,y.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return this.installExtension(U,re,_)}async updateMetadata(B,_){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const re={...B.manifest.__metadata||{},..._};return _.isPreReleaseVersion&&(re.preRelease=!0),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,re),this.manifestCache.invalidate(),B}async updateExtensionScope(B,_){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:_}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===P.Schemas.file)return B;const _=(0,b.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)());return await this.downloadService.download(B,_),_}createInstallExtensionTask(B,_,re){return C.URI.isUri(_)?new ie(B,_,re,this.galleryService,this.extensionsScanner,this.logService):new ee(_,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,_){return new ne(B,_,this.extensionsScanner)}async collectFiles(B){const _=async U=>{let N=await v.Promises.readdir(U);N=N.map(te=>I.join(U,te));const W=await Promise.all(N.map(te=>v.Promises.stat(te)));let K=Promise.resolve([]);return W.forEach((te,J)=>{const Z=N[J];te.isFile()&&(K=K.then(k=>[...k,Z])),te.isDirectory()&&(K=K.then(k=>_(Z).then(A=>[...k,...A])))}),K};return(await _(B.location.fsPath)).map(U=>({path:`extension/${I.relative(B.location.fsPath,U)}`,localPath:U}))}};H=he([ae(0,h.IExtensionGalleryService),ae(1,T.ITelemetryService),ae(2,f.ILogService),ae(3,p.INativeEnvironmentService),ae(4,m.IDownloadService),ae(5,u.IInstantiationService),ae(6,l.IFileService),ae(7,d.IProductService),ae(8,M.IUriIdentityService)],H),i.ExtensionManagementService=H;class X extends a.AbstractExtensionTask{constructor(B,_,re,U,N){super();this.identifier=B,this.source=_,this.options=re,this.extensionsScanner=U,this.logService=N,this._operation=2}get operation(){return(0,g.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(B,_){try{const re=await this.unsetUninstalledAndGetLocal(B.key);if(re)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,{...re.manifest.__metadata||{},...B.metadata}):re}catch{throw O.isMacintosh?new h.ExtensionManagementError(E.localize(1,null),h.ExtensionManagementErrorCode.Internal):new h.ExtensionManagementError(E.localize(2,null),h.ExtensionManagementErrorCode.Internal)}return this.extract(B,_)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const re=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),re}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}async extract({zipPath:B,key:_,metadata:re},U){let N=await this.extensionsScanner.extractUserExtension(_,B,re,U);return this.logService.info("Extracting completed.",_.id),N}}class ee extends X{constructor(B,_,re,U,N){super(B.identifier,B,_,U,N);this.gallery=B,this.extensionsDownloader=re}async doRun(B){const re=(await this.extensionsScanner.scanExtensions(null)).find(N=>(0,y.areSameExtensions)(N.identifier,this.gallery.identifier));re&&(this._operation=3);const U=await this.downloadInstallableExtension(this.gallery,this._operation);U.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,U.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin,U.metadata.isSystem=re?.type===0?!0:void 0,U.metadata.updated=!!re,U.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,U.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,g.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:re?.preRelease);try{const N=await this.installExtension(U,B);return re&&(re.targetPlatform!==N.targetPlatform||c.neq(re.manifest.version,N.manifest.version))&&await this.extensionsScanner.setUninstalled(re),N}catch(N){throw await this.deleteDownloadedVSIX(U.zipPath),N}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(C.URI.file(B))}catch(_){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,R.getErrorMessage)(_))}}async downloadInstallableExtension(B,_){const re={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName,targetPlatform:B.properties.targetPlatform};let U;try{this.logService.trace("Started downloading extension:",B.identifier.id),U=(await this.extensionsDownloader.downloadExtension(B,_)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,U)}catch(N){throw new h.ExtensionManagementError((0,a.joinErrors)(N).message,h.ExtensionManagementErrorCode.Download)}try{return await(0,t.getManifest)(U),{zipPath:U,key:y.ExtensionKey.create(B),metadata:re}}catch(N){throw await this.deleteDownloadedVSIX(U),new h.ExtensionManagementError((0,a.joinErrors)(N).message,h.ExtensionManagementErrorCode.Invalid)}}}class ie extends X{constructor(B,_,re,U,N,W){super({id:(0,y.getGalleryExtensionId)(B.publisher,B.name)},_,re,N,W);this.manifest=B,this.location=_,this.galleryService=U}async doRun(B){const _=new y.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,y.areSameExtensions)(this.identifier,W.identifier)),N=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(N.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,N.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=3,_.equals(new y.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(E.localize(3,null,this.manifest.displayName||this.manifest.name))}else c.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const W=await this.unsetUninstalledAndGetLocal(_);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(E.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),key:_,metadata:N},B)}async getMetadata(B,_,re){try{let[U]=await this.galleryService.getExtensions([{id:B,version:_}],re);if(U||([U]=await this.galleryService.getExtensions([{id:B}],re)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class ne extends a.AbstractExtensionTask{constructor(B,_,re){super();this.extension=B,this.options=_,this.extensionsScanner=re}async doRun(B){const _=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=y.ExtensionKey.create(this.extension);_.push(...re.filter(N=>U.equals(y.ExtensionKey.create(N))))}else _.push(...re.filter(U=>(0,y.areSameExtensions)(U.identifier,this.extension.identifier)));if(!_.length)throw new Error(E.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(..._),this.options.remove)for(const U of _)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(N){throw new Error(E.localize(6,null,(0,L.toErrorMessage)(N)))}}}}),define(Y[131],Q([0,1,115,3,17,6,2,8,23,20,116,14,114,141]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let E=class extends O.Disposable{constructor(p,a,h){super();this.environmentService=a,this.logService=h,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,a){this.logService.trace("RequestService#request",p.url);const{proxyUrl:h,strictSSL:y}=this;let S;try{S=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...S},t=p.agent?p.agent:await(0,v.getProxyAgent)(p.url||"",o,{proxyUrl:h,strictSSL:y});return p.agent=t,p.strictSSL=y,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization}),this._request(p,a)}async getNodeRequest(p){return((0,L.parse)(p.url).protocol==="https:"?await new Promise((y,S)=>{x(["https"],y,S)}):await new Promise((y,S)=>{x(["http"],y,S)})).request}_request(p,a){return R.Promises.withAsyncBody(async(h,y)=>{let S;const o=(0,L.parse)(p.url),t=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,b.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(r.auth=p.user+":"+p.password),S=t(r,e=>{const n=(0,b.isNumber)(p.followRedirects)?p.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...p,url:e.headers.location,followRedirects:n-1},a).then(h,y);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,w.createGunzip)())),h({res:e,stream:(0,P.streamToBufferReadableStream)(s)})}}),S.on("error",y),p.timeout&&S.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&S.write(p.data),S.end(),a.onCancellationRequested(()=>{S.abort(),y((0,I.canceled)())})})}async resolveProxy(p){}};E=he([ae(0,c.IConfigurationService),ae(1,g.INativeEnvironmentService),ae(2,D.ILogService)],E),i.RequestService=E}),define(Y[142],Q([0,1,33,3,17,28,6,2,12,10,29,9,15,23,107,49,113,20,89,121,21,109,130,16,100,102,40,97,52,53,112,14,104,123,30,42,131,118,32,122,36,124,125,37,127]),function(x,i,L,R,P,I,O,b,c,g,C,D,v,w,E,m,p,a,h,y,S,o,t,r,e,n,s,l,u,f,d,T,M,H,X,ee,ie,ne,fe,B,_,re,U,N,W){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class K extends b.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,k]=await this.initServices();return Z.invokeFunction(async A=>{const z=A.get(T.ILogService),V=A.get(r.IFileService),G=A.get(a.INativeEnvironmentService),q=A.get(S.IExtensionManagementCLIService);z.info("CLI main",this.argv),this.registerErrorHandler(z),await this.doRun(G,q,V),await Promise.all(k.map(se=>{(0,R.raceTimeout)(se.flush(),1e3)}))})}async initServices(){const Z=new u.ServiceCollection,k={_serviceBrand:void 0,...H.default};Z.set(X.IProductService,k);const A=new h.NativeEnvironmentService(this.argv,k);Z.set(a.INativeEnvironmentService,A),await Promise.all([A.appSettingsHome.fsPath,A.extensionsPath].map(me=>me?v.Promises.mkdir(me,{recursive:!0}):void 0));const z=(0,T.getLogLevel)(A),V=[];V.push(new M.SpdLogLogger("cli",(0,g.join)(A.logsPath,"cli.log"),!0,!1,z)),z===T.LogLevel.Trace&&V.push(new T.ConsoleLogger(z));const G=this._register(new T.MultiplexLogService(V));Z.set(T.ILogService,G);const q=this._register(new e.FileService(G));Z.set(r.IFileService,q);const se=this._register(new n.DiskFileSystemProvider(G));q.registerProvider(c.Schemas.file,se);const le=this._register(new E.ConfigurationService(A.settingsResource,q));Z.set(w.IConfigurationService,le),await le.initialize(),Z.set(N.IUriIdentityService,new W.UriIdentityService(q)),Z.set(ee.IRequestService,new s.SyncDescriptor(ie.RequestService)),Z.set(m.IDownloadService,new s.SyncDescriptor(p.DownloadService)),Z.set(S.IExtensionManagementService,new s.SyncDescriptor(t.ExtensionManagementService)),Z.set(S.IExtensionGalleryService,new s.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService)),Z.set(S.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(f.ILocalizationsService,new s.SyncDescriptor(d.LocalizationsService));const ge=[];if((0,_.supportsTelemetry)(k,A)){k.aiConfig&&k.aiConfig.asimovKey&&ge.push(new re.AppInsightsAppender("monacoworkbench",null,k.aiConfig.asimovKey));const{installSourcePath:me}=A,oe={appenders:ge,sendErrorTelemetry:!1,commonProperties:(async()=>{let ue;try{const we=await v.Promises.readFile((0,g.join)(A.userDataPath,"storage.json"));ue=JSON.parse(we.toString())[fe.machineIdKey]}catch(we){we.code!=="ENOENT"&&G.error(we)}return(0,ne.resolveCommonProperties)(q,(0,L.release)(),(0,L.hostname)(),process.arch,k.commit,k.version,ue,k.msftInternalDomains,me)})(),piiPaths:(0,_.getPiiPathsFromEnvironment)(A)};Z.set(fe.ITelemetryService,new s.SyncDescriptor(B.TelemetryService,[oe]))}else Z.set(fe.ITelemetryService,_.NullTelemetryService);return[new l.InstantiationService(Z),ge]}registerErrorHandler(Z){(0,O.setUnexpectedErrorHandler)(k=>{const A=(0,I.toErrorMessage)(k,!0);!A||Z.error(`[uncaught exception in CLI]: ${A}`)}),process.on("uncaughtException",k=>(0,O.onUnexpectedError)(k)),process.on("unhandledRejection",k=>(0,O.onUnexpectedError)(k))}async doRun(Z,k,A){if(this.argv["install-source"])return this.setInstallSource(Z,A,this.argv["install-source"]);if(this.argv["list-extensions"])return k.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const z={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return k.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],z,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return k.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return k.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(k=>/\.vsix$/i.test(k)?D.URI.file((0,g.isAbsolute)(k)?k:(0,g.join)((0,C.cwd)(),k)):k)}async setInstallSource(Z,k,A){await k.writeFile(D.URI.file(Z.installSourcePath),P.VSBuffer.fromString(A.slice(0,30)))}}async function te(J){const Z=new K(J);try{await Z.run()}finally{Z.dispose()}}i.main=te})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/node/cliProcessMain.js.map
