/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/platform","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/base/common/glob","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/shared/dataTransfer","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(J){for(var e=[],f=0,t=J.length;f<t;f++)e[f]=be[J[f]];return e};define(be[55],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(be[73],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(D){return D?D.replace(/\$\((.*?)\)/g,(k,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=f;class t{constructor(k,y,A){this.id=k,this.definition=y,this.description=A,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(D,k){const y=["codicon","codicon-"+D];return k&&y.push("codicon-modifier-"+k),y}e.getClassNamesArray=I;var T;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function y(R){if(R instanceof t)return["codicon","codicon-"+R.id];const b=k.exec(R.id);if(!b)return y(t.error);let[,C,g]=b;const u=["codicon","codicon-"+C];return g&&u.push("codicon-modifier-"+g.substr(1)),u}D.asClassNameArray=y;function A(R){return y(R).join(" ")}D.asClassName=A;function N(R){return"."+y(R).join(".")}D.asCSSSelector=N})(T=e.CSSIcon||(e.CSSIcon={}))}),define(be[74],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function t(N){const R=[];for(let b in N)f.call(N,b)&&R.push(N[b]);return R}e.values=t;function I(N,R){for(let b in N)if(f.call(N,b)&&R({key:b,value:N[b]},function(){delete N[b]})===!1)return}e.forEach=I;function T(N,R){const b=Object.create(null);for(const C of N){const g=R(C);let u=b[g];u||(u=b[g]=[]),u.push(C)}return b}e.groupBy=T;function D(N){const R=Object.create(null);return N&&N.forEach((b,C)=>{R[C]=b}),R}e.fromMap=D;function k(N,R){const b=[],C=[];for(let g of N)R.has(g)||b.push(g);for(let g of R)N.has(g)||C.push(g);return{removed:b,added:C}}e.diffSets=k;function y(N,R){const b=[],C=[];for(let[g,u]of N)R.has(g)||b.push(u);for(let[g,u]of R)N.has(g)||C.push(u);return{removed:b,added:C}}e.diffMaps=y;class A{constructor(){this.map=new Map}add(R,b){let C=this.map.get(R);C||(C=new Set,this.map.set(R,C)),C.add(b)}delete(R,b){const C=this.map.get(R);!C||(C.delete(b),C.size===0&&this.map.delete(R))}forEach(R,b){const C=this.map.get(R);!C||C.forEach(b)}}e.SetMap=A}),define(be[56],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(D){return(k,y,A)=>{let N=null,R=null;if(typeof A.value=="function"?(N="value",R=A.value):typeof A.get=="function"&&(N="get",R=A.get),!R)throw new Error("not supported");A[N]=D(R,y)}}e.createDecorator=f;function t(D,k,y){let A=null,N=null;if(typeof y.value=="function"?(A="value",N=y.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(A="get",N=y.get),!N)throw new Error("not supported");const R=`$memoize$${k}`;y[A]=function(...b){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,b)}),this[R]}}e.memoize=t;function I(D,k,y){return f((A,N)=>{const R=`$debounce$${N}`,b=`$debounce$result$${N}`;return function(...C){this[b]||(this[b]=y?y():void 0),clearTimeout(this[R]),k&&(this[b]=k(this[b],...C),C=[this[b]]),this[R]=setTimeout(()=>{A.apply(this,C),this[b]=y?y():void 0},D)}})}e.debounce=I;function T(D,k,y){return f((A,N)=>{const R=`$throttle$timer$${N}`,b=`$throttle$result$${N}`,C=`$throttle$lastRun$${N}`,g=`$throttle$pending$${N}`;return function(...u){if(this[b]||(this[b]=y?y():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),k&&(this[b]=k(this[b],...u)),this[g])return;const v=this[C]+D;v<=Date.now()?(this[C]=Date.now(),A.apply(this,[this[b]]),this[b]=y?y():void 0):(this[g]=!0,this[R]=setTimeout(()=>{this[g]=!1,this[C]=Date.now(),A.apply(this,[this[b]]),this[b]=y?y():void 0},v-Date.now()))}})}e.throttle=T}),define(be[12],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(m){setTimeout(()=>{throw m.stack?new Error(m.message+`

`+m.stack):m},0)}}addListener(m){return this.listeners.push(m),()=>{this._removeListener(m)}}emit(m){this.listeners.forEach(a=>{a(m)})}_removeListener(m){this.listeners.splice(this.listeners.indexOf(m),1)}setUnexpectedErrorHandler(m){this.unexpectedErrorHandler=m}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(m){this.unexpectedErrorHandler(m),this.emit(m)}onUnexpectedExternalError(m){this.unexpectedErrorHandler(m)}}e.ErrorHandler=f,e.errorHandler=new f;function t(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=t;function I(d){y(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=I;function T(d){y(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=T;function D(d){if(d instanceof Error){let{name:m,message:a}=d;const S=d.stacktrace||d.stack;return{$isError:!0,name:m,message:a,stack:S}}return d}e.transformErrorForSerialization=D;const k="Canceled";function y(d){return d instanceof A?!0:d instanceof Error&&d.name===k&&d.message===k}e.isCancellationError=y;class A extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=A;function N(){const d=new Error(k);return d.name=d.message,d}e.canceled=N;function R(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=R;function b(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=b;function C(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function g(d){const m=new Error(`${d} has been disposed`);return m.name="DISPOSED",m}e.disposed=g;function u(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=u;class v extends Error{constructor(m){super("NotImplemented");m&&(this.message=m)}}e.NotImplementedError=v;class _ extends Error{constructor(m){super("NotSupported");m&&(this.message=m)}}e.NotSupportedError=_;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;class l extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(m){if(m&&m instanceof Error){const a=new l;return a.name=m.name,a.message=m.message,a.stack=m.stack,a}return new l(m)}}e.ErrorNoTelemetry=l}),define(be[18],Ee([1,0,12]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(ee,fe=0){return ee[ee.length-(1+fe)]}e.tail=t;function I(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}e.tail2=I;function T(ee,fe,ge=(ye,Ne)=>ye===Ne){if(ee===fe)return!0;if(!ee||!fe||ee.length!==fe.length)return!1;for(let ye=0,Ne=ee.length;ye<Ne;ye++)if(!ge(ee[ye],fe[ye]))return!1;return!0}e.equals=T;function D(ee,fe,ge){let ye=0,Ne=ee.length-1;for(;ye<=Ne;){const Se=(ye+Ne)/2|0,_e=ge(ee[Se],fe);if(_e<0)ye=Se+1;else if(_e>0)Ne=Se-1;else return Se}return-(ye+1)}e.binarySearch=D;function k(ee,fe){let ge=0,ye=ee.length;if(ye===0)return 0;for(;ge<ye;){const Ne=Math.floor((ge+ye)/2);fe(ee[Ne])?ye=Ne:ge=Ne+1}return ge}e.findFirstInSorted=k;function y(ee,fe,ge){if(ee=ee|0,ee>=fe.length)throw new TypeError("invalid index");let ye=fe[Math.floor(fe.length*Math.random())],Ne=[],Se=[],_e=[];for(let Ie of fe){const de=ge(Ie,ye);de<0?Ne.push(Ie):de>0?Se.push(Ie):_e.push(Ie)}return ee<Ne.length?y(ee,Ne,ge):ee<Ne.length+_e.length?_e[0]:y(ee-(Ne.length+_e.length),Se,ge)}e.quickSelect=y;function A(ee,fe){const ge=[];let ye;for(const Ne of ee.slice(0).sort(fe))!ye||fe(ye[0],Ne)!==0?(ye=[Ne],ge.push(ye)):ye.push(Ne);return ge}e.groupBy=A;function N(ee,fe,ge){const ye=[];function Ne(Ie,de,Q){if(de===0&&Q.length===0)return;const ne=ye[ye.length-1];ne&&ne.start+ne.deleteCount===Ie?(ne.deleteCount+=de,ne.toInsert.push(...Q)):ye.push({start:Ie,deleteCount:de,toInsert:Q})}let Se=0,_e=0;for(;;){if(Se===ee.length){Ne(Se,0,fe.slice(_e));break}if(_e===fe.length){Ne(Se,ee.length-Se,[]);break}const Ie=ee[Se],de=fe[_e],Q=ge(Ie,de);Q===0?(Se+=1,_e+=1):Q<0?(Ne(Se,1,[]),Se+=1):Q>0&&(Ne(Se,0,[de]),_e+=1)}return ye}e.sortedDiff=N;function R(ee,fe,ge){const ye=N(ee,fe,ge),Ne=[],Se=[];for(const _e of ye)Ne.push(...ee.slice(_e.start,_e.start+_e.deleteCount)),Se.push(..._e.toInsert);return{removed:Ne,added:Se}}e.delta=R;function b(ee,fe,ge){if(ge===0)return[];const ye=ee.slice(0,ge).sort(fe);return g(ee,fe,ye,ge,ee.length),ye}e.top=b;function C(ee,fe,ge,ye,Ne){return ge===0?Promise.resolve([]):new Promise((Se,_e)=>{(async()=>{const Ie=ee.length,de=ee.slice(0,ge).sort(fe);for(let Q=ge,ne=Math.min(ge+ye,Ie);Q<Ie;Q=ne,ne=Math.min(ne+ye,Ie)){if(Q>ge&&await new Promise(O=>setTimeout(O)),Ne&&Ne.isCancellationRequested)throw(0,f.canceled)();g(ee,fe,de,Q,ne)}return de})().then(Se,_e)})}e.topAsync=C;function g(ee,fe,ge,ye,Ne){for(const Se=ge.length;ye<Ne;ye++){const _e=ee[ye];if(fe(_e,ge[Se-1])<0){ge.pop();const Ie=k(ge,de=>fe(_e,de)<0);ge.splice(Ie,0,_e)}}}function u(ee){return ee.filter(fe=>!!fe)}e.coalesce=u;function v(ee){let fe=0;for(let ge=0;ge<ee.length;ge++)ee[ge]&&(ee[fe]=ee[ge],fe+=1);ee.length=fe}e.coalesceInPlace=v;function _(ee,fe,ge){ee.splice(ge,0,ee.splice(fe,1)[0])}e.move=_;function E(ee){return!Array.isArray(ee)||ee.length===0}e.isFalsyOrEmpty=E;function l(ee){return Array.isArray(ee)&&ee.length>0}e.isNonEmptyArray=l;function d(ee,fe=ge=>ge){const ge=new Set;return ee.filter(ye=>{const Ne=fe(ye);return ge.has(Ne)?!1:(ge.add(Ne),!0)})}e.distinct=d;function m(ee){const fe=new Set;return ge=>{const ye=ee(ge);return fe.has(ye)?!1:(fe.add(ye),!0)}}e.uniqueFilter=m;function a(ee,fe){const ge=S(ee,fe);if(ge!==-1)return ee[ge]}e.findLast=a;function S(ee,fe){for(let ge=ee.length-1;ge>=0;ge--){const ye=ee[ge];if(fe(ye))return ge}return-1}e.lastIndex=S;function o(ee,fe){return ee.length>0?ee[0]:fe}e.firstOrDefault=o;function i(ee,fe){return ee.length>0?ee[ee.length-1]:fe}e.lastOrDefault=i;function s(ee,fe,ge=(ye,Ne)=>ye===Ne){let ye=0;for(let Ne=0,Se=Math.min(ee.length,fe.length);Ne<Se&&ge(ee[Ne],fe[Ne]);Ne++)ye++;return ye}e.commonPrefixLength=s;function n(ee){return[].concat(...ee)}e.flatten=n;function r(ee,fe){let ge=typeof fe=="number"?ee:0;typeof fe=="number"?ge=ee:(ge=0,fe=ee);const ye=[];if(ge<=fe)for(let Ne=ge;Ne<fe;Ne++)ye.push(Ne);else for(let Ne=ge;Ne>fe;Ne--)ye.push(Ne);return ye}e.range=r;function h(ee,fe,ge){return ee.reduce((ye,Ne)=>(ye[fe(Ne)]=ge?ge(Ne):Ne,ye),Object.create(null))}e.index=h;function c(ee,fe){return ee.push(fe),()=>w(ee,fe)}e.insert=c;function w(ee,fe){const ge=ee.indexOf(fe);if(ge>-1)return ee.splice(ge,1),fe}e.remove=w;function P(ee,fe,ge){const ye=ee.slice(0,fe),Ne=ee.slice(fe);return ye.concat(ge,Ne)}e.arrayInsert=P;function L(ee,fe){let ge;if(typeof fe=="number"){let ye=fe;ge=()=>{const Ne=Math.sin(ye++)*179426549;return Ne-Math.floor(Ne)}}else ge=Math.random;for(let ye=ee.length-1;ye>0;ye-=1){const Ne=Math.floor(ge()*(ye+1)),Se=ee[ye];ee[ye]=ee[Ne],ee[Ne]=Se}}e.shuffle=L;function M(ee,fe){const ge=ee.indexOf(fe);ge>-1&&(ee.splice(ge,1),ee.unshift(fe))}e.pushToStart=M;function p(ee,fe){const ge=ee.indexOf(fe);ge>-1&&(ee.splice(ge,1),ee.push(fe))}e.pushToEnd=p;function U(ee,fe){for(const ge of fe)ee.push(ge)}e.pushMany=U;function B(ee,fe){return Array.isArray(ee)?ee.map(fe):fe(ee)}e.mapArrayOrNot=B;function H(ee){return Array.isArray(ee)?ee:[ee]}e.asArray=H;function re(ee){return ee[Math.floor(Math.random()*ee.length)]}e.getRandomElement=re;function W(ee,fe){for(const ge of ee){const ye=fe(ge);if(ye!==void 0)return ye}}e.mapFind=W;function F(ee,fe,ge){const ye=G(ee,fe),Ne=ee.length,Se=ge.length;ee.length=Ne+Se;for(let _e=Ne-1;_e>=ye;_e--)ee[_e+Se]=ee[_e];for(let _e=0;_e<Se;_e++)ee[_e+ye]=ge[_e]}e.insertInto=F;function q(ee,fe,ge,ye){const Ne=G(ee,fe),Se=ee.splice(Ne,ge);return F(ee,Ne,ye),Se}e.splice=q;function G(ee,fe){return fe<0?Math.max(fe+ee.length,0):Math.min(fe,ee.length)}function $(ee,fe){return(ge,ye)=>fe(ee(ge),ee(ye))}e.compareBy=$;const X=(ee,fe)=>ee-fe;e.numberComparator=X;function ie(ee,fe){if(ee.length===0)return;let ge=ee[0];for(let ye=1;ye<ee.length;ye++){const Ne=ee[ye];fe(Ne,ge)>0&&(ge=Ne)}return ge}e.findMaxBy=ie;function ae(ee,fe){if(ee.length===0)return;let ge=ee[0];for(let ye=1;ye<ee.length;ye++){const Ne=ee[ye];fe(Ne,ge)>=0&&(ge=Ne)}return ge}e.findLastMaxBy=ae;function le(ee,fe){return ie(ee,(ge,ye)=>-fe(ge,ye))}e.findMinBy=le;class se{constructor(fe){this.items=fe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(fe){let ge=this.firstIdx;for(;ge<this.items.length&&fe(this.items[ge]);)ge++;const ye=ge===this.firstIdx?null:this.items.slice(this.firstIdx,ge);return this.firstIdx=ge,ye}takeFromEndWhile(fe){let ge=this.lastIdx;for(;ge>=0&&fe(this.items[ge]);)ge--;const ye=ge===this.lastIdx?null:this.items.slice(ge+1,this.lastIdx+1);return this.lastIdx=ge,ye}peek(){return this.items[this.firstIdx]}dequeue(){const fe=this.items[this.firstIdx];return this.firstIdx++,fe}takeCount(fe){const ge=this.items.slice(this.firstIdx,this.firstIdx+fe);return this.firstIdx+=fe,ge}}e.ArrayQueue=se}),define(be[75],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(t){const I=this;let T=!1,D;return function(){return T||(T=!0,D=t.apply(I,arguments)),D}}e.once=f}),define(be[76],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(be[77],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function I(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}t.is=I;const T=Object.freeze([]);function D(){return T}t.empty=D;function*k(m){yield m}t.single=k;function y(m){return m||T}t.from=y;function A(m){return!m||m[Symbol.iterator]().next().done===!0}t.isEmpty=A;function N(m){return m[Symbol.iterator]().next().value}t.first=N;function R(m,a){for(const S of m)if(a(S))return!0;return!1}t.some=R;function b(m,a){for(const S of m)if(a(S))return S}t.find=b;function*C(m,a){for(const S of m)a(S)&&(yield S)}t.filter=C;function*g(m,a){let S=0;for(const o of m)yield a(o,S++)}t.map=g;function*u(...m){for(const a of m)for(const S of a)yield S}t.concat=u;function*v(m){for(const a of m)for(const S of a)yield S}t.concatNested=v;function _(m,a,S){let o=S;for(const i of m)o=a(o,i);return o}t.reduce=_;function*E(m,a,S=m.length){for(a<0&&(a+=m.length),S<0?S+=m.length:S>m.length&&(S=m.length);a<S;a++)yield m[a]}t.slice=E;function l(m,a=Number.POSITIVE_INFINITY){const S=[];if(a===0)return[S,m];const o=m[Symbol.iterator]();for(let i=0;i<a;i++){const s=o.next();if(s.done)return[S,t.empty()];S.push(s.value)}return[S,{[Symbol.iterator](){return o}}]}t.consume=l;function d(m,a,S=(o,i)=>o===i){const o=m[Symbol.iterator](),i=a[Symbol.iterator]();for(;;){const s=o.next(),n=i.next();if(s.done!==n.done)return!1;if(s.done)return!0;if(!S(s.value,n.value))return!1}}t.equals=d})(f=e.Iterable||(e.Iterable={}))}),define(be[142],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var t;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(a){a.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function D(a,S=!1){let o=0,i=a.length,s="",n=0,r=16,h=0;function c(B){let H=0,re=0;for(;H<B;){const W=a.charCodeAt(o);if(W>=48&&W<=57)re=re*16+W-48;else if(W>=65&&W<=70)re=re*16+W-65+10;else if(W>=97&&W<=102)re=re*16+W-97+10;else break;o++,H++}return H<B&&(re=-1),re}function w(B){o=B,s="",n=0,r=16,h=0}function P(){const B=o;if(a.charCodeAt(o)===48)o++;else for(o++;o<a.length&&A(a.charCodeAt(o));)o++;if(o<a.length&&a.charCodeAt(o)===46)if(o++,o<a.length&&A(a.charCodeAt(o)))for(o++;o<a.length&&A(a.charCodeAt(o));)o++;else return h=3,a.substring(B,o);let H=o;if(o<a.length&&(a.charCodeAt(o)===69||a.charCodeAt(o)===101))if(o++,(o<a.length&&a.charCodeAt(o)===43||a.charCodeAt(o)===45)&&o++,o<a.length&&A(a.charCodeAt(o))){for(o++;o<a.length&&A(a.charCodeAt(o));)o++;H=o}else h=3;return a.substring(B,H)}function L(){let B="",H=o;for(;;){if(o>=i){B+=a.substring(H,o),h=2;break}const re=a.charCodeAt(o);if(re===34){B+=a.substring(H,o),o++;break}if(re===92){if(B+=a.substring(H,o),o++,o>=i){h=2;break}switch(a.charCodeAt(o++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const F=c(4);F>=0?B+=String.fromCharCode(F):h=4;break}default:h=5}H=o;continue}if(re>=0&&re<=31)if(y(re)){B+=a.substring(H,o),h=2;break}else h=6;o++}return B}function M(){if(s="",h=0,n=o,o>=i)return n=i,r=17;let B=a.charCodeAt(o);if(k(B)){do o++,s+=String.fromCharCode(B),B=a.charCodeAt(o);while(k(B));return r=15}if(y(B))return o++,s+=String.fromCharCode(B),B===13&&a.charCodeAt(o)===10&&(o++,s+=`
`),r=14;switch(B){case 123:return o++,r=1;case 125:return o++,r=2;case 91:return o++,r=3;case 93:return o++,r=4;case 58:return o++,r=6;case 44:return o++,r=5;case 34:return o++,s=L(),r=10;case 47:{const H=o-1;if(a.charCodeAt(o+1)===47){for(o+=2;o<i&&!y(a.charCodeAt(o));)o++;return s=a.substring(H,o),r=12}if(a.charCodeAt(o+1)===42){o+=2;const re=i-1;let W=!1;for(;o<re;){if(a.charCodeAt(o)===42&&a.charCodeAt(o+1)===47){o+=2,W=!0;break}o++}return W||(o++,h=1),s=a.substring(H,o),r=13}return s+=String.fromCharCode(B),o++,r=16}case 45:if(s+=String.fromCharCode(B),o++,o===i||!A(a.charCodeAt(o)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),r=11;default:for(;o<i&&p(B);)o++,B=a.charCodeAt(o);if(n!==o){switch(s=a.substring(n,o),s){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return s+=String.fromCharCode(B),o++,r=16}}function p(B){if(k(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=M();while(B>=12&&B<=15);return B}return{setPosition:w,getPosition:()=>o,scan:S?U:M,getToken:()=>r,getTokenValue:()=>s,getTokenOffset:()=>n,getTokenLength:()=>o-n,getTokenError:()=>h}}e.createScanner=D;function k(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function y(a){return a===10||a===13||a===8232||a===8233}function A(a){return a>=48&&a<=57}var N;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(N||(N={}));function R(a,S){const o=[],i=new Object;let s;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function h(c,w,P,L){n.value=c,n.offset=w,n.length=P,n.type=L,n.colonOffset=void 0,s=n}try{l(a,{onObjectBegin:(c,w)=>{if(S<=c)throw i;s=void 0,r=S>c,o.push("")},onObjectProperty:(c,w,P)=>{if(S<w||(h(c,w,P,"property"),o[o.length-1]=c,S<=w+P))throw i},onObjectEnd:(c,w)=>{if(S<=c)throw i;s=void 0,o.pop()},onArrayBegin:(c,w)=>{if(S<=c)throw i;s=void 0,o.push(0)},onArrayEnd:(c,w)=>{if(S<=c)throw i;s=void 0,o.pop()},onLiteralValue:(c,w,P)=>{if(S<w||(h(c,w,P,m(c)),S<=w+P))throw i},onSeparator:(c,w,P)=>{if(S<=w)throw i;if(c===":"&&s&&s.type==="property")s.colonOffset=w,r=!1,s=void 0;else if(c===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(r=!0,o[o.length-1]=""),s=void 0}}})}catch(c){if(c!==i)throw c}return{path:o,previousNode:s,isAtPropertyKey:r,matches:c=>{let w=0;for(let P=0;w<c.length&&P<o.length;P++)if(c[w]===o[P]||c[w]==="*")w++;else if(c[w]!=="**")return!1;return w===c.length}}}e.getLocation=R;function b(a,S=[],o=T.DEFAULT){let i=null,s=[];const n=[];function r(c){Array.isArray(s)?s.push(c):i!==null&&(s[i]=c)}return l(a,{onObjectBegin:()=>{const c={};r(c),n.push(s),s=c,i=null},onObjectProperty:c=>{i=c},onObjectEnd:()=>{s=n.pop()},onArrayBegin:()=>{const c=[];r(c),n.push(s),s=c,i=null},onArrayEnd:()=>{s=n.pop()},onLiteralValue:r,onError:(c,w,P)=>{S.push({error:c,offset:w,length:P})}},o),s[0]}e.parse=b;function C(a,S=[],o=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(c){i.type==="property"&&(i.length=c-i.offset,i=i.parent)}function n(c){return i.children.push(c),c}l(a,{onObjectBegin:c=>{i=n({type:"object",offset:c,length:-1,parent:i,children:[]})},onObjectProperty:(c,w,P)=>{i=n({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:c,offset:w,length:P,parent:i})},onObjectEnd:(c,w)=>{i.length=c+w-i.offset,i=i.parent,s(c+w)},onArrayBegin:(c,w)=>{i=n({type:"array",offset:c,length:-1,parent:i,children:[]})},onArrayEnd:(c,w)=>{i.length=c+w-i.offset,i=i.parent,s(c+w)},onLiteralValue:(c,w,P)=>{n({type:m(c),offset:w,length:P,parent:i,value:c}),s(w+P)},onSeparator:(c,w,P)=>{i.type==="property"&&(c===":"?i.colonOffset=w:c===","&&s(w))},onError:(c,w,P)=>{S.push({error:c,offset:w,length:P})}},o);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=C;function g(a,S){if(!a)return;let o=a;for(let i of S)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const n of o.children)if(Array.isArray(n.children)&&n.children[0].value===i){o=n.children[1],s=!0;break}if(!s)return}else{const s=i;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}e.findNodeAtLocation=g;function u(a){if(!a.parent||!a.parent.children)return[];const S=u(a.parent);if(a.parent.type==="property"){const o=a.parent.children[0].value;S.push(o)}else if(a.parent.type==="array"){const o=a.parent.children.indexOf(a);o!==-1&&S.push(o)}return S}e.getNodePath=u;function v(a){switch(a.type){case"array":return a.children.map(v);case"object":{const S=Object.create(null);for(let o of a.children){const i=o.children[1];i&&(S[o.children[0].value]=v(i))}return S}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=v;function _(a,S,o=!1){return S>=a.offset&&S<a.offset+a.length||o&&S===a.offset+a.length}e.contains=_;function E(a,S,o=!1){if(_(a,S,o)){const i=a.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=S;s++){const n=E(i[s],S,o);if(n)return n}return a}}e.findNodeAtOffset=E;function l(a,S,o=T.DEFAULT){const i=D(a,!1);function s(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function n(ae){return ae?le=>ae(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const r=s(S.onObjectBegin),h=n(S.onObjectProperty),c=s(S.onObjectEnd),w=s(S.onArrayBegin),P=s(S.onArrayEnd),L=n(S.onLiteralValue),M=n(S.onSeparator),p=s(S.onComment),U=n(S.onError),B=o&&o.disallowComments,H=o&&o.allowTrailingComma;function re(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:B||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ae){case 12:case 13:B?W(10):p();break;case 16:W(1);break;case 15:case 14:break;default:return ae}}}function W(ae,le=[],se=[]){if(U(ae),le.length+se.length>0){let ee=i.getToken();for(;ee!==17;){if(le.indexOf(ee)!==-1){re();break}else if(se.indexOf(ee)!==-1)break;ee=re()}}}function F(ae){const le=i.getTokenValue();return ae?L(le):h(le),re(),!0}function q(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&(W(2),ae=0)}catch{W(2)}L(ae);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return re(),!0}function G(){return i.getToken()!==10?(W(3,[],[2,5]),!1):(F(!1),i.getToken()===6?(M(":"),re(),ie()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function $(){r(),re();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||W(4,[],[]),M(","),re(),i.getToken()===2&&H)break}else ae&&W(6,[],[]);G()||W(4,[],[2,5]),ae=!0}return c(),i.getToken()!==2?W(7,[2],[]):re(),!0}function X(){w(),re();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||W(4,[],[]),M(","),re(),i.getToken()===4&&H)break}else ae&&W(6,[],[]);ie()||W(4,[],[4,5]),ae=!0}return P(),i.getToken()!==4?W(8,[4],[]):re(),!0}function ie(){switch(i.getToken()){case 3:return X();case 1:return $();case 10:return F(!0);default:return q()}}return re(),i.getToken()===17?o.allowEmptyContent?!0:(W(4,[],[]),!1):ie()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=l;function d(a,S){let o=D(a),i=[],s,n=0,r;do switch(r=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:n!==r&&i.push(a.substring(n,r)),S!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,S)),n=o.getPosition();break}while(s!==17);return i.join("")}e.stripComments=d;function m(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(be[90],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(be[6],Ee([1,0,75,77]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let T=null;function D(s){T=s}if(e.setDisposableTracker=D,I){const s="__is_disposable_tracked__";D(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[s]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==E.None)try{n[s]=!0}catch{}}markAsDisposed(n){if(n&&n!==E.None)try{n[s]=!0}catch{}}markAsSingleton(n){}})}function k(s){return T?.trackDisposable(s),s}function y(s){T?.markAsDisposed(s)}function A(s,n){T?.setParent(s,n)}function N(s,n){if(!!T)for(const r of s)T.setParent(r,n)}function R(s){return T?.markAsSingleton(s),s}e.markAsSingleton=R;class b extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=b;function C(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=C;function g(s){if(t.Iterable.is(s)){let n=[];for(const r of s)if(r)try{r.dispose()}catch(h){n.push(h)}if(n.length===1)throw n[0];if(n.length>1)throw new b(n);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=g;function u(...s){const n=v(()=>g(s));return N(s,n),n}e.combinedDisposable=u;function v(s){const n=k({dispose:(0,f.once)(()=>{y(n),s()})});return n}e.toDisposable=v;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new _,k(this),A(this._store,this)}dispose(){y(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=l;class d{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,y(this))},this}}e.SafeDisposable=m;class a{constructor(){this.references=new Map}acquire(n,...r){let h=this.references.get(n);h||(h={counter:0,object:this.createReferencedObject(n,...r)},this.references.set(n,h));const{object:c}=h,w=(0,f.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(n,h.object),this.references.delete(n))});return h.counter++,{object:c,dispose:w}}}e.ReferenceCollection=a;class S{constructor(n){this.referenceCollection=n}async acquire(n,...r){const h=this.referenceCollection.acquire(n,...r);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(c){throw h.dispose(),c}}}e.AsyncReferenceCollection=S;class o{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=o;function i(s){const n=new _;try{s(n)}finally{n.dispose()}}e.disposeOnReturn=i}),define(be[91],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(T){this.element=T,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let T=this._first;for(;T!==f.Undefined;){const D=T.next;T.prev=f.Undefined,T.next=f.Undefined,T=D}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,D){const k=new f(T);if(this._first===f.Undefined)this._first=k,this._last=k;else if(D){const A=this._last;this._last=k,k.prev=A,A.next=k}else{const A=this._first;this._first=k,k.next=A,A.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==f.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==f.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==f.Undefined&&T.next!==f.Undefined){const D=T.prev;D.next=T.next,T.next.prev=D}else T.prev===f.Undefined&&T.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):T.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):T.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==f.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(be[143],Ee([0]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(Se,_e){for(var Ie=0;Ie<_e.length;Ie++){var de=_e[Ie];de.enumerable=de.enumerable||!1,de.configurable=!0,"value"in de&&(de.writable=!0),Object.defineProperty(Se,de.key,de)}}function f(Se,_e,Ie){return _e&&e(Se.prototype,_e),Ie&&e(Se,Ie),Object.defineProperty(Se,"prototype",{writable:!1}),Se}function t(Se,_e){if(!!Se){if(typeof Se=="string")return I(Se,_e);var Ie=Object.prototype.toString.call(Se).slice(8,-1);if(Ie==="Object"&&Se.constructor&&(Ie=Se.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Se);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return I(Se,_e)}}function I(Se,_e){(_e==null||_e>Se.length)&&(_e=Se.length);for(var Ie=0,de=new Array(_e);Ie<_e;Ie++)de[Ie]=Se[Ie];return de}function T(Se,_e){var Ie=typeof Symbol!="undefined"&&Se[Symbol.iterator]||Se["@@iterator"];if(Ie)return(Ie=Ie.call(Se)).next.bind(Ie);if(Array.isArray(Se)||(Ie=t(Se))||_e&&Se&&typeof Se.length=="number"){Ie&&(Se=Ie);var de=0;return function(){return de>=Se.length?{done:!0}:{done:!1,value:Se[de++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=D();function k(Se){J.defaults=Se}var y=/[&<>"']/,A=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(_e){return b[_e]};function g(Se,_e){if(_e){if(y.test(Se))return Se.replace(A,C)}else if(N.test(Se))return Se.replace(R,C);return Se}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Se){return Se.replace(u,function(_e,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var _=/(^|[^\[])\^/g;function E(Se,_e){Se=Se.source||Se,_e=_e||"";var Ie={replace:function(Q,ne){return ne=ne.source||ne,ne=ne.replace(_,"$1"),Se=Se.replace(Q,ne),Ie},getRegex:function(){return new RegExp(Se,_e)}};return Ie}var l=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Se,_e,Ie){if(Se){var de;try{de=decodeURIComponent(v(Ie)).replace(l,"").toLowerCase()}catch{return null}if(de.indexOf("javascript:")===0||de.indexOf("vbscript:")===0||de.indexOf("data:")===0)return null}_e&&!d.test(Ie)&&(Ie=s(_e,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var a={},S=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Se,_e){a[" "+Se]||(S.test(Se)?a[" "+Se]=Se+"/":a[" "+Se]=c(Se,"/",!0)),Se=a[" "+Se];var Ie=Se.indexOf(":")===-1;return _e.substring(0,2)==="//"?Ie?_e:Se.replace(o,"$1")+_e:_e.charAt(0)==="/"?Ie?_e:Se.replace(i,"$1")+_e:Se+_e}var n={exec:function(){}};function r(Se){for(var _e=1,Ie,de;_e<arguments.length;_e++){Ie=arguments[_e];for(de in Ie)Object.prototype.hasOwnProperty.call(Ie,de)&&(Se[de]=Ie[de])}return Se}function h(Se,_e){var Ie=Se.replace(/\|/g,function(ne,O,x){for(var j=!1,Y=O;--Y>=0&&x[Y]==="\\";)j=!j;return j?"|":" |"}),de=Ie.split(/ \|/),Q=0;if(de[0].trim()||de.shift(),de[de.length-1].trim()||de.pop(),de.length>_e)de.splice(_e);else for(;de.length<_e;)de.push("");for(;Q<de.length;Q++)de[Q]=de[Q].trim().replace(/\\\|/g,"|");return de}function c(Se,_e,Ie){var de=Se.length;if(de===0)return"";for(var Q=0;Q<de;){var ne=Se.charAt(de-Q-1);if(ne===_e&&!Ie)Q++;else if(ne!==_e&&Ie)Q++;else break}return Se.substr(0,de-Q)}function w(Se,_e){if(Se.indexOf(_e[1])===-1)return-1;for(var Ie=Se.length,de=0,Q=0;Q<Ie;Q++)if(Se[Q]==="\\")Q++;else if(Se[Q]===_e[0])de++;else if(Se[Q]===_e[1]&&(de--,de<0))return Q;return-1}function P(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Se,_e){if(_e<1)return"";for(var Ie="";_e>1;)_e&1&&(Ie+=Se),_e>>=1,Se+=Se;return Ie+Se}function M(Se,_e,Ie,de){var Q=_e.href,ne=_e.title?g(_e.title):null,O=Se[1].replace(/\\([\[\]])/g,"$1");if(Se[0].charAt(0)!=="!"){de.state.inLink=!0;var x={type:"link",raw:Ie,href:Q,title:ne,text:O,tokens:de.inlineTokens(O,[])};return de.state.inLink=!1,x}else return{type:"image",raw:Ie,href:Q,title:ne,text:g(O)}}function p(Se,_e){var Ie=Se.match(/^(\s+)(?:```)/);if(Ie===null)return _e;var de=Ie[1];return _e.split(`
`).map(function(Q){var ne=Q.match(/^\s+/);if(ne===null)return Q;var O=ne[0];return O.length>=de.length?Q.slice(de.length):Q}).join(`
`)}var U=function(){function Se(Ie){this.options=Ie||J.defaults}var _e=Se.prototype;return _e.space=function(de){var Q=this.rules.block.newline.exec(de);if(Q&&Q[0].length>0)return{type:"space",raw:Q[0]}},_e.code=function(de){var Q=this.rules.block.code.exec(de);if(Q){var ne=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:c(ne,`
`)}}},_e.fences=function(de){var Q=this.rules.block.fences.exec(de);if(Q){var ne=Q[0],O=p(ne,Q[3]||"");return{type:"code",raw:ne,lang:Q[2]?Q[2].trim():Q[2],text:O}}},_e.heading=function(de){var Q=this.rules.block.heading.exec(de);if(Q){var ne=Q[2].trim();if(/#$/.test(ne)){var O=c(ne,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ne=O.trim())}var x={type:"heading",raw:Q[0],depth:Q[1].length,text:ne,tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},_e.hr=function(de){var Q=this.rules.block.hr.exec(de);if(Q)return{type:"hr",raw:Q[0]}},_e.blockquote=function(de){var Q=this.rules.block.blockquote.exec(de);if(Q){var ne=Q[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Q[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},_e.list=function(de){var Q=this.rules.block.list.exec(de);if(Q){var ne,O,x,j,Y,ue,pe,De,Ue,ze,He,Ke,et=Q[1].trim(),Oe=et.length>1,Xe={type:"list",raw:"",ordered:Oe,start:Oe?+et.slice(0,-1):"",loose:!1,items:[]};et=Oe?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Oe?et:"[*+-]");for(var te=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");de&&(Ke=!1,!(!(Q=te.exec(de))||this.rules.block.hr.test(de)));){if(ne=Q[0],de=de.substring(ne.length),De=Q[2].split(`
`,1)[0],Ue=de.split(`
`,1)[0],this.options.pedantic?(j=2,He=De.trimLeft()):(j=Q[2].search(/[^ ]/),j=j>4?1:j,He=De.slice(j),j+=Q[1].length),ue=!1,!De&&/^ *$/.test(Ue)&&(ne+=Ue+`
`,de=de.substring(Ue.length+1),Ke=!0),!Ke)for(var oe=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])");de&&(ze=de.split(`
`,1)[0],De=ze,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!oe.test(De));){if(De.search(/[^ ]/)>=j||!De.trim())He+=`
`+De.slice(j);else if(!ue)He+=`
`+De;else break;!ue&&!De.trim()&&(ue=!0),ne+=ze+`
`,de=de.substring(ze.length+1)}Xe.loose||(pe?Xe.loose=!0:/\n *\n *$/.test(ne)&&(pe=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(He),O&&(x=O[0]!=="[ ] ",He=He.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:ne,task:!!O,checked:x,loose:!1,text:He}),Xe.raw+=ne}Xe.items[Xe.items.length-1].raw=ne.trimRight(),Xe.items[Xe.items.length-1].text=He.trimRight(),Xe.raw=Xe.raw.trimRight();var K=Xe.items.length;for(Y=0;Y<K;Y++){this.lexer.state.top=!1,Xe.items[Y].tokens=this.lexer.blockTokens(Xe.items[Y].text,[]);var we=Xe.items[Y].tokens.filter(function(We){return We.type==="space"}),ke=we.every(function(We){for(var xe=We.raw.split(""),Je=0,st=T(xe),mt;!(mt=st()).done;){var vt=mt.value;if(vt===`
`&&(Je+=1),Je>1)return!0}return!1});!Xe.loose&&we.length&&ke&&(Xe.loose=!0,Xe.items[Y].loose=!0)}return Xe}},_e.html=function(de){var Q=this.rules.block.html.exec(de);if(Q){var ne={type:"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:Q[0]};return this.options.sanitize&&(ne.type="paragraph",ne.text=this.options.sanitizer?this.options.sanitizer(Q[0]):g(Q[0]),ne.tokens=[],this.lexer.inline(ne.text,ne.tokens)),ne}},_e.def=function(de){var Q=this.rules.block.def.exec(de);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var ne=Q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:Q[0],href:Q[2],title:Q[3]}}},_e.table=function(de){var Q=this.rules.block.table.exec(de);if(Q){var ne={type:"table",header:h(Q[1]).map(function(pe){return{text:pe}}),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Q[3]?Q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=Q[0];var O=ne.align.length,x,j,Y,ue;for(x=0;x<O;x++)/^ *-+: *$/.test(ne.align[x])?ne.align[x]="right":/^ *:-+: *$/.test(ne.align[x])?ne.align[x]="center":/^ *:-+ *$/.test(ne.align[x])?ne.align[x]="left":ne.align[x]=null;for(O=ne.rows.length,x=0;x<O;x++)ne.rows[x]=h(ne.rows[x],ne.header.length).map(function(pe){return{text:pe}});for(O=ne.header.length,j=0;j<O;j++)ne.header[j].tokens=[],this.lexer.inlineTokens(ne.header[j].text,ne.header[j].tokens);for(O=ne.rows.length,j=0;j<O;j++)for(ue=ne.rows[j],Y=0;Y<ue.length;Y++)ue[Y].tokens=[],this.lexer.inlineTokens(ue[Y].text,ue[Y].tokens);return ne}}},_e.lheading=function(de){var Q=this.rules.block.lheading.exec(de);if(Q){var ne={type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1],tokens:[]};return this.lexer.inline(ne.text,ne.tokens),ne}},_e.paragraph=function(de){var Q=this.rules.block.paragraph.exec(de);if(Q){var ne={type:"paragraph",raw:Q[0],text:Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1],tokens:[]};return this.lexer.inline(ne.text,ne.tokens),ne}},_e.text=function(de){var Q=this.rules.block.text.exec(de);if(Q){var ne={type:"text",raw:Q[0],text:Q[0],tokens:[]};return this.lexer.inline(ne.text,ne.tokens),ne}},_e.escape=function(de){var Q=this.rules.inline.escape.exec(de);if(Q)return{type:"escape",raw:Q[0],text:g(Q[1])}},_e.tag=function(de){var Q=this.rules.inline.tag.exec(de);if(Q)return!this.lexer.state.inLink&&/^<a /i.test(Q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):g(Q[0]):Q[0]}},_e.link=function(de){var Q=this.rules.inline.link.exec(de);if(Q){var ne=Q[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var O=c(ne.slice(0,-1),"\\");if((ne.length-O.length)%2==0)return}else{var x=w(Q[2],"()");if(x>-1){var j=Q[0].indexOf("!")===0?5:4,Y=j+Q[1].length+x;Q[2]=Q[2].substring(0,x),Q[0]=Q[0].substring(0,Y).trim(),Q[3]=""}}var ue=Q[2],pe="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ue);De&&(ue=De[1],pe=De[3])}else pe=Q[3]?Q[3].slice(1,-1):"";return ue=ue.trim(),/^</.test(ue)&&(this.options.pedantic&&!/>$/.test(ne)?ue=ue.slice(1):ue=ue.slice(1,-1)),M(Q,{href:ue&&ue.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},Q[0],this.lexer)}},_e.reflink=function(de,Q){var ne;if((ne=this.rules.inline.reflink.exec(de))||(ne=this.rules.inline.nolink.exec(de))){var O=(ne[2]||ne[1]).replace(/\s+/g," ");if(O=Q[O.toLowerCase()],!O||!O.href){var x=ne[0].charAt(0);return{type:"text",raw:x,text:x}}return M(ne,O,ne[0],this.lexer)}},_e.emStrong=function(de,Q,ne){ne===void 0&&(ne="");var O=this.rules.inline.emStrong.lDelim.exec(de);if(!!O&&!(O[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=O[1]||O[2]||"";if(!x||x&&(ne===""||this.rules.inline.punctuation.exec(ne))){var j=O[0].length-1,Y,ue,pe=j,De=0,Ue=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ue.lastIndex=0,Q=Q.slice(-1*de.length+j);(O=Ue.exec(Q))!=null;)if(Y=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Y){if(ue=Y.length,O[3]||O[4]){pe+=ue;continue}else if((O[5]||O[6])&&j%3&&!((j+ue)%3)){De+=ue;continue}if(pe-=ue,!(pe>0)){if(ue=Math.min(ue,ue+pe+De),Math.min(j,ue)%2){var ze=de.slice(1,j+O.index+ue);return{type:"em",raw:de.slice(0,j+O.index+ue+1),text:ze,tokens:this.lexer.inlineTokens(ze,[])}}var He=de.slice(2,j+O.index+ue-1);return{type:"strong",raw:de.slice(0,j+O.index+ue+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}}}}},_e.codespan=function(de){var Q=this.rules.inline.code.exec(de);if(Q){var ne=Q[2].replace(/\n/g," "),O=/[^ ]/.test(ne),x=/^ /.test(ne)&&/ $/.test(ne);return O&&x&&(ne=ne.substring(1,ne.length-1)),ne=g(ne,!0),{type:"codespan",raw:Q[0],text:ne}}},_e.br=function(de){var Q=this.rules.inline.br.exec(de);if(Q)return{type:"br",raw:Q[0]}},_e.del=function(de){var Q=this.rules.inline.del.exec(de);if(Q)return{type:"del",raw:Q[0],text:Q[2],tokens:this.lexer.inlineTokens(Q[2],[])}},_e.autolink=function(de,Q){var ne=this.rules.inline.autolink.exec(de);if(ne){var O,x;return ne[2]==="@"?(O=g(this.options.mangle?Q(ne[1]):ne[1]),x="mailto:"+O):(O=g(ne[1]),x=O),{type:"link",raw:ne[0],text:O,href:x,tokens:[{type:"text",raw:O,text:O}]}}},_e.url=function(de,Q){var ne;if(ne=this.rules.inline.url.exec(de)){var O,x;if(ne[2]==="@")O=g(this.options.mangle?Q(ne[0]):ne[0]),x="mailto:"+O;else{var j;do j=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(j!==ne[0]);O=g(ne[0]),ne[1]==="www."?x="http://"+O:x=O}return{type:"link",raw:ne[0],text:O,href:x,tokens:[{type:"text",raw:O,text:O}]}}},_e.inlineText=function(de,Q){var ne=this.rules.inline.text.exec(de);if(ne){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):g(ne[0]):ne[0]:O=g(this.options.smartypants?Q(ne[0]):ne[0]),{type:"text",raw:ne[0],text:O}}},Se}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=E(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=E(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=E(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=E(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=E(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=E(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=r({},B),B.gfm=r({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=E(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=E(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=r({},B.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:E(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var H={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};H._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",H.punctuation=E(H.punctuation).replace(/punctuation/g,H._punctuation).getRegex(),H.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,H.escapedEmSt=/\\\*|\\_/g,H._comment=E(B._comment).replace("(?:-->|$)","-->").getRegex(),H.emStrong.lDelim=E(H.emStrong.lDelim).replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimAst=E(H.emStrong.rDelimAst,"g").replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimUnd=E(H.emStrong.rDelimUnd,"g").replace(/punct/g,H._punctuation).getRegex(),H._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,H._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,H._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,H.autolink=E(H.autolink).replace("scheme",H._scheme).replace("email",H._email).getRegex(),H._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,H.tag=E(H.tag).replace("comment",H._comment).replace("attribute",H._attribute).getRegex(),H._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,H._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,H._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,H.link=E(H.link).replace("label",H._label).replace("href",H._href).replace("title",H._title).getRegex(),H.reflink=E(H.reflink).replace("label",H._label).replace("ref",B._label).getRegex(),H.nolink=E(H.nolink).replace("ref",B._label).getRegex(),H.reflinkSearch=E(H.reflinkSearch,"g").replace("reflink",H.reflink).replace("nolink",H.nolink).getRegex(),H.normal=r({},H),H.pedantic=r({},H.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",H._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",H._label).getRegex()}),H.gfm=r({},H.normal,{escape:E(H.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),H.gfm.url=E(H.gfm.url,"i").replace("email",H.gfm._extended_email).getRegex(),H.breaks=r({},H.gfm,{br:E(H.br).replace("{2,}","*").getRegex(),text:E(H.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function re(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Se){var _e="",Ie,de,Q=Se.length;for(Ie=0;Ie<Q;Ie++)de=Se.charCodeAt(Ie),Math.random()>.5&&(de="x"+de.toString(16)),_e+="&#"+de+";";return _e}var F=function(){function Se(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||J.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var de={block:B.normal,inline:H.normal};this.options.pedantic?(de.block=B.pedantic,de.inline=H.pedantic):this.options.gfm&&(de.block=B.gfm,this.options.breaks?de.inline=H.breaks:de.inline=H.gfm),this.tokenizer.rules=de}Se.lex=function(de,Q){var ne=new Se(Q);return ne.lex(de)},Se.lexInline=function(de,Q){var ne=new Se(Q);return ne.inlineTokens(de)};var _e=Se.prototype;return _e.lex=function(de){de=de.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(de,this.tokens);for(var Q;Q=this.inlineQueue.shift();)this.inlineTokens(Q.src,Q.tokens);return this.tokens},_e.blockTokens=function(de,Q){var ne=this;Q===void 0&&(Q=[]),this.options.pedantic&&(de=de.replace(/^ +$/gm,""));for(var O,x,j,Y;de;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(O=pe.call({lexer:ne},de,Q))?(de=de.substring(O.raw.length),Q.push(O),!0):!1}))){if(O=this.tokenizer.space(de)){de=de.substring(O.raw.length),O.raw.length===1&&Q.length>0?Q[Q.length-1].raw+=`
`:Q.push(O);continue}if(O=this.tokenizer.code(de)){de=de.substring(O.raw.length),x=Q[Q.length-1],x&&(x.type==="paragraph"||x.type==="text")?(x.raw+=`
`+O.raw,x.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=x.text):Q.push(O);continue}if(O=this.tokenizer.fences(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.heading(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.hr(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.blockquote(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.list(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.html(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.def(de)){de=de.substring(O.raw.length),x=Q[Q.length-1],x&&(x.type==="paragraph"||x.type==="text")?(x.raw+=`
`+O.raw,x.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=x.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.lheading(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(j=de,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,De=de.slice(1),Ue=void 0;ne.options.extensions.startBlock.forEach(function(ze){Ue=ze.call({lexer:this},De),typeof Ue=="number"&&Ue>=0&&(pe=Math.min(pe,Ue))}),pe<1/0&&pe>=0&&(j=de.substring(0,pe+1))}(),this.state.top&&(O=this.tokenizer.paragraph(j))){x=Q[Q.length-1],Y&&x.type==="paragraph"?(x.raw+=`
`+O.raw,x.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=x.text):Q.push(O),Y=j.length!==de.length,de=de.substring(O.raw.length);continue}if(O=this.tokenizer.text(de)){de=de.substring(O.raw.length),x=Q[Q.length-1],x&&x.type==="text"?(x.raw+=`
`+O.raw,x.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=x.text):Q.push(O);continue}if(de){var ue="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return this.state.top=!0,Q},_e.inline=function(de,Q){this.inlineQueue.push({src:de,tokens:Q})},_e.inlineTokens=function(de,Q){var ne=this;Q===void 0&&(Q=[]);var O,x,j,Y=de,ue,pe,De;if(this.tokens.links){var Ue=Object.keys(this.tokens.links);if(Ue.length>0)for(;(ue=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)Ue.includes(ue[0].slice(ue[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,ue.index)+"["+L("a",ue[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ue=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,ue.index)+"["+L("a",ue[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ue=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,ue.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;de;)if(pe||(De=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(He){return(O=He.call({lexer:ne},de,Q))?(de=de.substring(O.raw.length),Q.push(O),!0):!1}))){if(O=this.tokenizer.escape(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.tag(de)){de=de.substring(O.raw.length),x=Q[Q.length-1],x&&O.type==="text"&&x.type==="text"?(x.raw+=O.raw,x.text+=O.text):Q.push(O);continue}if(O=this.tokenizer.link(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.reflink(de,this.tokens.links)){de=de.substring(O.raw.length),x=Q[Q.length-1],x&&O.type==="text"&&x.type==="text"?(x.raw+=O.raw,x.text+=O.text):Q.push(O);continue}if(O=this.tokenizer.emStrong(de,Y,De)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.codespan(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.br(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.del(de)){de=de.substring(O.raw.length),Q.push(O);continue}if(O=this.tokenizer.autolink(de,W)){de=de.substring(O.raw.length),Q.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(de,W))){de=de.substring(O.raw.length),Q.push(O);continue}if(j=de,this.options.extensions&&this.options.extensions.startInline&&function(){var He=1/0,Ke=de.slice(1),et=void 0;ne.options.extensions.startInline.forEach(function(Oe){et=Oe.call({lexer:this},Ke),typeof et=="number"&&et>=0&&(He=Math.min(He,et))}),He<1/0&&He>=0&&(j=de.substring(0,He+1))}(),O=this.tokenizer.inlineText(j,re)){de=de.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(De=O.raw.slice(-1)),pe=!0,x=Q[Q.length-1],x&&x.type==="text"?(x.raw+=O.raw,x.text+=O.text):Q.push(O);continue}if(de){var ze="Infinite loop on byte: "+de.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return Q},f(Se,null,[{key:"rules",get:function(){return{block:B,inline:H}}}]),Se}(),q=function(){function Se(Ie){this.options=Ie||J.defaults}var _e=Se.prototype;return _e.code=function(de,Q,ne){var O=(Q||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(de,O);x!=null&&x!==de&&(ne=!0,de=x)}return de=de.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+g(O,!0)+'">'+(ne?de:g(de,!0))+`</code></pre>
`:"<pre><code>"+(ne?de:g(de,!0))+`</code></pre>
`},_e.blockquote=function(de){return`<blockquote>
`+de+`</blockquote>
`},_e.html=function(de){return de},_e.heading=function(de,Q,ne,O){return this.options.headerIds?"<h"+Q+' id="'+this.options.headerPrefix+O.slug(ne)+'">'+de+"</h"+Q+`>
`:"<h"+Q+">"+de+"</h"+Q+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(de,Q,ne){var O=Q?"ol":"ul",x=Q&&ne!==1?' start="'+ne+'"':"";return"<"+O+x+`>
`+de+"</"+O+`>
`},_e.listitem=function(de){return"<li>"+de+`</li>
`},_e.checkbox=function(de){return"<input "+(de?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(de){return"<p>"+de+`</p>
`},_e.table=function(de,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+de+`</thead>
`+Q+`</table>
`},_e.tablerow=function(de){return`<tr>
`+de+`</tr>
`},_e.tablecell=function(de,Q){var ne=Q.header?"th":"td",O=Q.align?"<"+ne+' align="'+Q.align+'">':"<"+ne+">";return O+de+"</"+ne+`>
`},_e.strong=function(de){return"<strong>"+de+"</strong>"},_e.em=function(de){return"<em>"+de+"</em>"},_e.codespan=function(de){return"<code>"+de+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(de){return"<del>"+de+"</del>"},_e.link=function(de,Q,ne){if(de=m(this.options.sanitize,this.options.baseUrl,de),de===null)return ne;var O='<a href="'+g(de)+'"';return Q&&(O+=' title="'+Q+'"'),O+=">"+ne+"</a>",O},_e.image=function(de,Q,ne){if(de=m(this.options.sanitize,this.options.baseUrl,de),de===null)return ne;var O='<img src="'+de+'" alt="'+ne+'"';return Q&&(O+=' title="'+Q+'"'),O+=this.options.xhtml?"/>":">",O},_e.text=function(de){return de},Se}(),G=function(){function Se(){}var _e=Se.prototype;return _e.strong=function(de){return de},_e.em=function(de){return de},_e.codespan=function(de){return de},_e.del=function(de){return de},_e.html=function(de){return de},_e.text=function(de){return de},_e.link=function(de,Q,ne){return""+ne},_e.image=function(de,Q,ne){return""+ne},_e.br=function(){return""},Se}(),$=function(){function Se(){this.seen={}}var _e=Se.prototype;return _e.serialize=function(de){return de.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(de,Q){var ne=de,O=0;if(this.seen.hasOwnProperty(ne)){O=this.seen[de];do O++,ne=de+"-"+O;while(this.seen.hasOwnProperty(ne))}return Q||(this.seen[de]=O,this.seen[ne]=0),ne},_e.slug=function(de,Q){Q===void 0&&(Q={});var ne=this.serialize(de);return this.getNextSafeSlug(ne,Q.dryrun)},Se}(),X=function(){function Se(Ie){this.options=Ie||J.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new $}Se.parse=function(de,Q){var ne=new Se(Q);return ne.parse(de)},Se.parseInline=function(de,Q){var ne=new Se(Q);return ne.parseInline(de)};var _e=Se.prototype;return _e.parse=function(de,Q){Q===void 0&&(Q=!0);var ne="",O,x,j,Y,ue,pe,De,Ue,ze,He,Ke,et,Oe,Xe,te,oe,K,we,ke,We=de.length;for(O=0;O<We;O++){if(He=de[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[He.type]&&(ke=this.options.extensions.renderers[He.type].call({parser:this},He),ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(He.type))){ne+=ke||"";continue}switch(He.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(He.tokens),He.depth,v(this.parseInline(He.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(He.text,He.lang,He.escaped);continue}case"table":{for(Ue="",De="",Y=He.header.length,x=0;x<Y;x++)De+=this.renderer.tablecell(this.parseInline(He.header[x].tokens),{header:!0,align:He.align[x]});for(Ue+=this.renderer.tablerow(De),ze="",Y=He.rows.length,x=0;x<Y;x++){for(pe=He.rows[x],De="",ue=pe.length,j=0;j<ue;j++)De+=this.renderer.tablecell(this.parseInline(pe[j].tokens),{header:!1,align:He.align[j]});ze+=this.renderer.tablerow(De)}ne+=this.renderer.table(Ue,ze);continue}case"blockquote":{ze=this.parse(He.tokens),ne+=this.renderer.blockquote(ze);continue}case"list":{for(Ke=He.ordered,et=He.start,Oe=He.loose,Y=He.items.length,ze="",x=0;x<Y;x++)te=He.items[x],oe=te.checked,K=te.task,Xe="",te.task&&(we=this.renderer.checkbox(oe),Oe?te.tokens.length>0&&te.tokens[0].type==="paragraph"?(te.tokens[0].text=we+" "+te.tokens[0].text,te.tokens[0].tokens&&te.tokens[0].tokens.length>0&&te.tokens[0].tokens[0].type==="text"&&(te.tokens[0].tokens[0].text=we+" "+te.tokens[0].tokens[0].text)):te.tokens.unshift({type:"text",text:we}):Xe+=we),Xe+=this.parse(te.tokens,Oe),ze+=this.renderer.listitem(Xe,K,oe);ne+=this.renderer.list(ze,Ke,et);continue}case"html":{ne+=this.renderer.html(He.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(He.tokens));continue}case"text":{for(ze=He.tokens?this.parseInline(He.tokens):He.text;O+1<We&&de[O+1].type==="text";)He=de[++O],ze+=`
`+(He.tokens?this.parseInline(He.tokens):He.text);ne+=Q?this.renderer.paragraph(ze):ze;continue}default:{var xe='Token with "'+He.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}}return ne},_e.parseInline=function(de,Q){Q=Q||this.renderer;var ne="",O,x,j,Y=de.length;for(O=0;O<Y;O++){if(x=de[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(j=this.options.extensions.renderers[x.type].call({parser:this},x),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(x.type))){ne+=j||"";continue}switch(x.type){case"escape":{ne+=Q.text(x.text);break}case"html":{ne+=Q.html(x.text);break}case"link":{ne+=Q.link(x.href,x.title,this.parseInline(x.tokens,Q));break}case"image":{ne+=Q.image(x.href,x.title,x.text);break}case"strong":{ne+=Q.strong(this.parseInline(x.tokens,Q));break}case"em":{ne+=Q.em(this.parseInline(x.tokens,Q));break}case"codespan":{ne+=Q.codespan(x.text);break}case"br":{ne+=Q.br();break}case"del":{ne+=Q.del(this.parseInline(x.tokens,Q));break}case"text":{ne+=Q.text(x.text);break}default:{var ue='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return ne},Se}();function ie(Se,_e,Ie){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof _e=="function"&&(Ie=_e,_e=null),_e=r({},ie.defaults,_e||{}),P(_e),Ie){var de=_e.highlight,Q;try{Q=F.lex(Se,_e)}catch(j){return Ie(j)}var ne=function(Y){var ue;if(!Y)try{_e.walkTokens&&ie.walkTokens(Q,_e.walkTokens),ue=X.parse(Q,_e)}catch(pe){Y=pe}return _e.highlight=de,Y?Ie(Y):Ie(null,ue)};if(!de||de.length<3||(delete _e.highlight,!Q.length))return ne();var O=0;ie.walkTokens(Q,function(j){j.type==="code"&&(O++,setTimeout(function(){de(j.text,j.lang,function(Y,ue){if(Y)return ne(Y);ue!=null&&ue!==j.text&&(j.text=ue,j.escaped=!0),O--,O===0&&ne()})},0))}),O===0&&ne();return}try{var x=F.lex(Se,_e);return _e.walkTokens&&ie.walkTokens(x,_e.walkTokens),X.parse(x,_e)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+g(j.message+"",!0)+"</pre>";throw j}}ie.options=ie.setOptions=function(Se){return r(ie.defaults,Se),k(ie.defaults),ie},ie.getDefaults=D,ie.defaults=J.defaults,ie.use=function(){for(var Se=arguments.length,_e=new Array(Se),Ie=0;Ie<Se;Ie++)_e[Ie]=arguments[Ie];var de=r.apply(void 0,[{}].concat(_e)),Q=ie.defaults.extensions||{renderers:{},childTokens:{}},ne;_e.forEach(function(O){if(O.extensions&&(ne=!0,O.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var Y=Q.renderers?Q.renderers[j.name]:null;Y?Q.renderers[j.name]=function(){for(var ue=arguments.length,pe=new Array(ue),De=0;De<ue;De++)pe[De]=arguments[De];var Ue=j.renderer.apply(this,pe);return Ue===!1&&(Ue=Y.apply(this,pe)),Ue}:Q.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[j.level]?Q[j.level].unshift(j.tokenizer):Q[j.level]=[j.tokenizer],j.start&&(j.level==="block"?Q.startBlock?Q.startBlock.push(j.start):Q.startBlock=[j.start]:j.level==="inline"&&(Q.startInline?Q.startInline.push(j.start):Q.startInline=[j.start]))}j.childTokens&&(Q.childTokens[j.name]=j.childTokens)})),O.renderer&&function(){var j=ie.defaults.renderer||new q,Y=function(De){var Ue=j[De];j[De]=function(){for(var ze=arguments.length,He=new Array(ze),Ke=0;Ke<ze;Ke++)He[Ke]=arguments[Ke];var et=O.renderer[De].apply(j,He);return et===!1&&(et=Ue.apply(j,He)),et}};for(var ue in O.renderer)Y(ue);de.renderer=j}(),O.tokenizer&&function(){var j=ie.defaults.tokenizer||new U,Y=function(De){var Ue=j[De];j[De]=function(){for(var ze=arguments.length,He=new Array(ze),Ke=0;Ke<ze;Ke++)He[Ke]=arguments[Ke];var et=O.tokenizer[De].apply(j,He);return et===!1&&(et=Ue.apply(j,He)),et}};for(var ue in O.tokenizer)Y(ue);de.tokenizer=j}(),O.walkTokens){var x=ie.defaults.walkTokens;de.walkTokens=function(j){O.walkTokens.call(this,j),x&&x.call(this,j)}}ne&&(de.extensions=Q),ie.setOptions(de)})},ie.walkTokens=function(Se,_e){for(var Ie=function(){var O=Q.value;switch(_e.call(ie,O),O.type){case"table":{for(var x=T(O.header),j;!(j=x()).done;){var Y=j.value;ie.walkTokens(Y.tokens,_e)}for(var ue=T(O.rows),pe;!(pe=ue()).done;)for(var De=pe.value,Ue=T(De),ze;!(ze=Ue()).done;){var He=ze.value;ie.walkTokens(He.tokens,_e)}break}case"list":{ie.walkTokens(O.items,_e);break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[O.type]?ie.defaults.extensions.childTokens[O.type].forEach(function(Ke){ie.walkTokens(O[Ke],_e)}):O.tokens&&ie.walkTokens(O.tokens,_e)}},de=T(Se),Q;!(Q=de()).done;)Ie()},ie.parseInline=function(Se,_e){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");_e=r({},ie.defaults,_e||{}),P(_e);try{var Ie=F.lexInline(Se,_e);return _e.walkTokens&&ie.walkTokens(Ie,_e.walkTokens),X.parseInline(Ie,_e)}catch(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+g(de.message+"",!0)+"</pre>";throw de}},ie.Parser=X,ie.parser=X.parse,ie.Renderer=q,ie.TextRenderer=G,ie.Lexer=F,ie.lexer=F.lex,ie.Tokenizer=U,ie.Slugger=$,ie.parse=ie;var ae=ie.options,le=ie.setOptions,se=ie.use,ee=ie.walkTokens,fe=ie.parseInline,ge=ie,ye=X.parse,Ne=F.lex;J.Lexer=F,J.Parser=X,J.Renderer=q,J.Slugger=$,J.TextRenderer=G,J.Tokenizer=U,J.getDefaults=D,J.lexer=Ne,J.marked=ie,J.options=ae,J.parse=ge,J.parseInline=fe,J.parser=ye,J.setOptions=le,J.use=se,J.walkTokens=ee,Object.defineProperty(J,"__esModule",{value:!0})}),define(be[92],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(k,y,A){return Math.min(Math.max(k,y),A)}e.clamp=f;function t(k,y){return(y+k%y)%y}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class T{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class D{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const A=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function J(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function D(y){T.push(y,Date.now())}function k(){const y=[];for(let A=0;A<T.length;A+=2)y.push({name:T[A],startTime:T[A+1]});return y}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const D of performance.getEntriesByType("mark"))T.push({name:D.name,startTime:Math.round(I+D.startTime)});return T}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=f(t))}(),define(be[13],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let t=!1,I=!1,T=!1,D=!1,k=!1,y=!1,A=!1,N=!1,R=!1,b,C=f,g,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const _=typeof v?.versions?.electron=="string",E=_&&v?.type==="renderer";if(e.isElectronSandboxed=E&&v?.sandboxed,typeof navigator=="object"&&!E)u=navigator.userAgent,t=u.indexOf("Windows")>=0,I=u.indexOf("Macintosh")>=0,N=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=u.indexOf("Linux")>=0,y=!0,b=navigator.language,C=b;else if(typeof v=="object"){t=v.platform==="win32",I=v.platform==="darwin",T=v.platform==="linux",D=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,A=_,R=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=f,C=f;const n=v.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),h=r.availableLanguages["*"];b=r.locale,C=h||f,g=r._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var l;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function d(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let m=0;I?m=1:t?m=3:T&&(m=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=T,e.isLinuxSnap=D,e.isNative=k,e.isElectron=A,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=N,e.isCI=R,e.platform=m,e.userAgent=u,e.language=C;var a;(function(n){function r(){return e.language}n.value=r;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=h;function c(){return e.language==="en"}n.isDefault=c})(a=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let c=0,w=n.length;c<w;c++){const P=n[c];if(P.id===h.data.vscodeScheduleAsyncWork){n.splice(c,1),P.callback();return}}});let r=0;return h=>{const c=++r;n.push({id:c,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:c},"*")}}return n=>setTimeout(n)})();var S;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(S=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||N?2:t?1:3;let o=!0,i=!1;function s(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,o=new Uint16Array(n.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(be[38],Ee([1,0,13]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(be[9],Ee([1,0,38]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,T=90,D=122,k=46,y=47,A=92,N=58,R=63;class b extends Error{constructor(d,m,a){let S;typeof m=="string"&&m.indexOf("not ")===0?(S="must not be",m=m.replace(/^not /,"")):S="must be";const o=d.indexOf(".")!==-1?"property":"argument";let i=`The "${d}" ${o} ${S} of type ${m}`;i+=`. Received type ${typeof a}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function C(l,d){if(typeof l!="string")throw new b(d,"string",l)}function g(l){return l===y||l===A}function u(l){return l===y}function v(l){return l>=t&&l<=T||l>=I&&l<=D}function _(l,d,m,a){let S="",o=0,i=-1,s=0,n=0;for(let r=0;r<=l.length;++r){if(r<l.length)n=l.charCodeAt(r);else{if(a(n))break;n=y}if(a(n)){if(!(i===r-1||s===1))if(s===2){if(S.length<2||o!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const h=S.lastIndexOf(m);h===-1?(S="",o=0):(S=S.slice(0,h),o=S.length-1-S.lastIndexOf(m)),i=r,s=0;continue}else if(S.length!==0){S="",o=0,i=r,s=0;continue}}d&&(S+=S.length>0?`${m}..`:"..",o=2)}else S.length>0?S+=`${m}${l.slice(i+1,r)}`:S=l.slice(i+1,r),o=r-i-1;i=r,s=0}else n===k&&s!==-1?++s:s=-1}return S}function E(l,d){if(d===null||typeof d!="object")throw new b("pathObject","Object",d);const m=d.dir||d.root,a=d.base||`${d.name||""}${d.ext||""}`;return m?m===d.root?`${m}${a}`:`${m}${l}${a}`:a}e.win32={resolve(...l){let d="",m="",a=!1;for(let S=l.length-1;S>=-1;S--){let o;if(S>=0){if(o=l[S],C(o,"path"),o.length===0)continue}else d.length===0?o=f.cwd():(o=f.env[`=${d}`]||f.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==d.toLowerCase()&&o.charCodeAt(2)===A)&&(o=`${d}\\`));const i=o.length;let s=0,n="",r=!1;const h=o.charCodeAt(0);if(i===1)g(h)&&(s=1,r=!0);else if(g(h))if(r=!0,g(o.charCodeAt(1))){let c=2,w=c;for(;c<i&&!g(o.charCodeAt(c));)c++;if(c<i&&c!==w){const P=o.slice(w,c);for(w=c;c<i&&g(o.charCodeAt(c));)c++;if(c<i&&c!==w){for(w=c;c<i&&!g(o.charCodeAt(c));)c++;(c===i||c!==w)&&(n=`\\\\${P}\\${o.slice(w,c)}`,s=c)}}}else s=1;else v(h)&&o.charCodeAt(1)===N&&(n=o.slice(0,2),s=2,i>2&&g(o.charCodeAt(2))&&(r=!0,s=3));if(n.length>0)if(d.length>0){if(n.toLowerCase()!==d.toLowerCase())continue}else d=n;if(a){if(d.length>0)break}else if(m=`${o.slice(s)}\\${m}`,a=r,r&&d.length>0)break}return m=_(m,!a,"\\",g),a?`${d}\\${m}`:`${d}${m}`||"."},normalize(l){C(l,"path");const d=l.length;if(d===0)return".";let m=0,a,S=!1;const o=l.charCodeAt(0);if(d===1)return u(o)?"\\":l;if(g(o))if(S=!0,g(l.charCodeAt(1))){let s=2,n=s;for(;s<d&&!g(l.charCodeAt(s));)s++;if(s<d&&s!==n){const r=l.slice(n,s);for(n=s;s<d&&g(l.charCodeAt(s));)s++;if(s<d&&s!==n){for(n=s;s<d&&!g(l.charCodeAt(s));)s++;if(s===d)return`\\\\${r}\\${l.slice(n)}\\`;s!==n&&(a=`\\\\${r}\\${l.slice(n,s)}`,m=s)}}}else m=1;else v(o)&&l.charCodeAt(1)===N&&(a=l.slice(0,2),m=2,d>2&&g(l.charCodeAt(2))&&(S=!0,m=3));let i=m<d?_(l.slice(m),!S,"\\",g):"";return i.length===0&&!S&&(i="."),i.length>0&&g(l.charCodeAt(d-1))&&(i+="\\"),a===void 0?S?`\\${i}`:i:S?`${a}\\${i}`:`${a}${i}`},isAbsolute(l){C(l,"path");const d=l.length;if(d===0)return!1;const m=l.charCodeAt(0);return g(m)||d>2&&v(m)&&l.charCodeAt(1)===N&&g(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let d,m;for(let o=0;o<l.length;++o){const i=l[o];C(i,"path"),i.length>0&&(d===void 0?d=m=i:d+=`\\${i}`)}if(d===void 0)return".";let a=!0,S=0;if(typeof m=="string"&&g(m.charCodeAt(0))){++S;const o=m.length;o>1&&g(m.charCodeAt(1))&&(++S,o>2&&(g(m.charCodeAt(2))?++S:a=!1))}if(a){for(;S<d.length&&g(d.charCodeAt(S));)S++;S>=2&&(d=`\\${d.slice(S)}`)}return e.win32.normalize(d)},relative(l,d){if(C(l,"from"),C(d,"to"),l===d)return"";const m=e.win32.resolve(l),a=e.win32.resolve(d);if(m===a||(l=m.toLowerCase(),d=a.toLowerCase(),l===d))return"";let S=0;for(;S<l.length&&l.charCodeAt(S)===A;)S++;let o=l.length;for(;o-1>S&&l.charCodeAt(o-1)===A;)o--;const i=o-S;let s=0;for(;s<d.length&&d.charCodeAt(s)===A;)s++;let n=d.length;for(;n-1>s&&d.charCodeAt(n-1)===A;)n--;const r=n-s,h=i<r?i:r;let c=-1,w=0;for(;w<h;w++){const L=l.charCodeAt(S+w);if(L!==d.charCodeAt(s+w))break;L===A&&(c=w)}if(w!==h){if(c===-1)return a}else{if(r>h){if(d.charCodeAt(s+w)===A)return a.slice(s+w+1);if(w===2)return a.slice(s+w)}i>h&&(l.charCodeAt(S+w)===A?c=w:w===2&&(c=3)),c===-1&&(c=0)}let P="";for(w=S+c+1;w<=o;++w)(w===o||l.charCodeAt(w)===A)&&(P+=P.length===0?"..":"\\..");return s+=c,P.length>0?`${P}${a.slice(s,n)}`:(a.charCodeAt(s)===A&&++s,a.slice(s,n))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const d=e.win32.resolve(l);if(d.length<=2)return l;if(d.charCodeAt(0)===A){if(d.charCodeAt(1)===A){const m=d.charCodeAt(2);if(m!==R&&m!==k)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(v(d.charCodeAt(0))&&d.charCodeAt(1)===N&&d.charCodeAt(2)===A)return`\\\\?\\${d}`;return l},dirname(l){C(l,"path");const d=l.length;if(d===0)return".";let m=-1,a=0;const S=l.charCodeAt(0);if(d===1)return g(S)?l:".";if(g(S)){if(m=a=1,g(l.charCodeAt(1))){let s=2,n=s;for(;s<d&&!g(l.charCodeAt(s));)s++;if(s<d&&s!==n){for(n=s;s<d&&g(l.charCodeAt(s));)s++;if(s<d&&s!==n){for(n=s;s<d&&!g(l.charCodeAt(s));)s++;if(s===d)return l;s!==n&&(m=a=s+1)}}}}else v(S)&&l.charCodeAt(1)===N&&(m=d>2&&g(l.charCodeAt(2))?3:2,a=m);let o=-1,i=!0;for(let s=d-1;s>=a;--s)if(g(l.charCodeAt(s))){if(!i){o=s;break}}else i=!1;if(o===-1){if(m===-1)return".";o=m}return l.slice(0,o)},basename(l,d){d!==void 0&&C(d,"ext"),C(l,"path");let m=0,a=-1,S=!0,o;if(l.length>=2&&v(l.charCodeAt(0))&&l.charCodeAt(1)===N&&(m=2),d!==void 0&&d.length>0&&d.length<=l.length){if(d===l)return"";let i=d.length-1,s=-1;for(o=l.length-1;o>=m;--o){const n=l.charCodeAt(o);if(g(n)){if(!S){m=o+1;break}}else s===-1&&(S=!1,s=o+1),i>=0&&(n===d.charCodeAt(i)?--i==-1&&(a=o):(i=-1,a=s))}return m===a?a=s:a===-1&&(a=l.length),l.slice(m,a)}for(o=l.length-1;o>=m;--o)if(g(l.charCodeAt(o))){if(!S){m=o+1;break}}else a===-1&&(S=!1,a=o+1);return a===-1?"":l.slice(m,a)},extname(l){C(l,"path");let d=0,m=-1,a=0,S=-1,o=!0,i=0;l.length>=2&&l.charCodeAt(1)===N&&v(l.charCodeAt(0))&&(d=a=2);for(let s=l.length-1;s>=d;--s){const n=l.charCodeAt(s);if(g(n)){if(!o){a=s+1;break}continue}S===-1&&(o=!1,S=s+1),n===k?m===-1?m=s:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||S===-1||i===0||i===1&&m===S-1&&m===a+1?"":l.slice(m,S)},format:E.bind(null,"\\"),parse(l){C(l,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return d;const m=l.length;let a=0,S=l.charCodeAt(0);if(m===1)return g(S)?(d.root=d.dir=l,d):(d.base=d.name=l,d);if(g(S)){if(a=1,g(l.charCodeAt(1))){let c=2,w=c;for(;c<m&&!g(l.charCodeAt(c));)c++;if(c<m&&c!==w){for(w=c;c<m&&g(l.charCodeAt(c));)c++;if(c<m&&c!==w){for(w=c;c<m&&!g(l.charCodeAt(c));)c++;c===m?a=c:c!==w&&(a=c+1)}}}}else if(v(S)&&l.charCodeAt(1)===N){if(m<=2)return d.root=d.dir=l,d;if(a=2,g(l.charCodeAt(2))){if(m===3)return d.root=d.dir=l,d;a=3}}a>0&&(d.root=l.slice(0,a));let o=-1,i=a,s=-1,n=!0,r=l.length-1,h=0;for(;r>=a;--r){if(S=l.charCodeAt(r),g(S)){if(!n){i=r+1;break}continue}s===-1&&(n=!1,s=r+1),S===k?o===-1?o=r:h!==1&&(h=1):o!==-1&&(h=-1)}return s!==-1&&(o===-1||h===0||h===1&&o===s-1&&o===i+1?d.base=d.name=l.slice(i,s):(d.name=l.slice(i,o),d.base=l.slice(i,s),d.ext=l.slice(o,s))),i>0&&i!==a?d.dir=l.slice(0,i-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let d="",m=!1;for(let a=l.length-1;a>=-1&&!m;a--){const S=a>=0?l[a]:f.cwd();C(S,"path"),S.length!==0&&(d=`${S}/${d}`,m=S.charCodeAt(0)===y)}return d=_(d,!m,"/",u),m?`/${d}`:d.length>0?d:"."},normalize(l){if(C(l,"path"),l.length===0)return".";const d=l.charCodeAt(0)===y,m=l.charCodeAt(l.length-1)===y;return l=_(l,!d,"/",u),l.length===0?d?"/":m?"./":".":(m&&(l+="/"),d?`/${l}`:l)},isAbsolute(l){return C(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let d;for(let m=0;m<l.length;++m){const a=l[m];C(a,"path"),a.length>0&&(d===void 0?d=a:d+=`/${a}`)}return d===void 0?".":e.posix.normalize(d)},relative(l,d){if(C(l,"from"),C(d,"to"),l===d||(l=e.posix.resolve(l),d=e.posix.resolve(d),l===d))return"";const m=1,a=l.length,S=a-m,o=1,i=d.length-o,s=S<i?S:i;let n=-1,r=0;for(;r<s;r++){const c=l.charCodeAt(m+r);if(c!==d.charCodeAt(o+r))break;c===y&&(n=r)}if(r===s)if(i>s){if(d.charCodeAt(o+r)===y)return d.slice(o+r+1);if(r===0)return d.slice(o+r)}else S>s&&(l.charCodeAt(m+r)===y?n=r:r===0&&(n=0));let h="";for(r=m+n+1;r<=a;++r)(r===a||l.charCodeAt(r)===y)&&(h+=h.length===0?"..":"/..");return`${h}${d.slice(o+n)}`},toNamespacedPath(l){return l},dirname(l){if(C(l,"path"),l.length===0)return".";const d=l.charCodeAt(0)===y;let m=-1,a=!0;for(let S=l.length-1;S>=1;--S)if(l.charCodeAt(S)===y){if(!a){m=S;break}}else a=!1;return m===-1?d?"/":".":d&&m===1?"//":l.slice(0,m)},basename(l,d){d!==void 0&&C(d,"ext"),C(l,"path");let m=0,a=-1,S=!0,o;if(d!==void 0&&d.length>0&&d.length<=l.length){if(d===l)return"";let i=d.length-1,s=-1;for(o=l.length-1;o>=0;--o){const n=l.charCodeAt(o);if(n===y){if(!S){m=o+1;break}}else s===-1&&(S=!1,s=o+1),i>=0&&(n===d.charCodeAt(i)?--i==-1&&(a=o):(i=-1,a=s))}return m===a?a=s:a===-1&&(a=l.length),l.slice(m,a)}for(o=l.length-1;o>=0;--o)if(l.charCodeAt(o)===y){if(!S){m=o+1;break}}else a===-1&&(S=!1,a=o+1);return a===-1?"":l.slice(m,a)},extname(l){C(l,"path");let d=-1,m=0,a=-1,S=!0,o=0;for(let i=l.length-1;i>=0;--i){const s=l.charCodeAt(i);if(s===y){if(!S){m=i+1;break}continue}a===-1&&(S=!1,a=i+1),s===k?d===-1?d=i:o!==1&&(o=1):d!==-1&&(o=-1)}return d===-1||a===-1||o===0||o===1&&d===a-1&&d===m+1?"":l.slice(d,a)},format:E.bind(null,"/"),parse(l){C(l,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return d;const m=l.charCodeAt(0)===y;let a;m?(d.root="/",a=1):a=0;let S=-1,o=0,i=-1,s=!0,n=l.length-1,r=0;for(;n>=a;--n){const h=l.charCodeAt(n);if(h===y){if(!s){o=n+1;break}continue}i===-1&&(s=!1,i=n+1),h===k?S===-1?S=n:r!==1&&(r=1):S!==-1&&(r=-1)}if(i!==-1){const h=o===0&&m?1:o;S===-1||r===0||r===1&&S===i-1&&S===o+1?d.base=d.name=l.slice(h,i):(d.name=l.slice(h,S),d.base=l.slice(h,i),d.ext=l.slice(S,i))}return o>0?d.dir=l.slice(0,o-1):m&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[93],Ee([1,0,9]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(R){R.text="text/plain",R.binary="application/octet-stream",R.unknown="application/unknown",R.markdown="text/markdown",R.latex="text/latex",R.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(R){const b=(0,f.extname)(R),C=I[b.toLowerCase()];return C!==void 0?C:k(R)}e.getMediaOrTextMime=D;function k(R){const b=(0,f.extname)(R);return T[b.toLowerCase()]}e.getMediaMime=k;function y(R){for(const b in T)if(T[b]===R)return b}e.getExtensionForMimeType=y;const A=/^(.+)\/(.+?)(;.+)?$/;function N(R,b){const C=A.exec(R);return C?`${C[1].toLowerCase()}/${C[2].toLowerCase()}${C[3]??""}`:b?void 0:R}e.normalizeMimeType=N}),define(be[94],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var t;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(T,...D){const k=D.reduce((N,R)=>(N[R]=!0,N),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(N=>!k[N]).forEach(N=>{for(let R=0;R<y.length;R++)if(N.search(y[R])!==-1){delete T[N];break}})}e.sanitizeProcessEnvironment=I}),define(be[46],Ee([1,0,13]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new I(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(be[3],Ee([1,0,12,75,6,91,46]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let k=!1,y=!1;var A;(function(o){o.None=()=>I.Disposable.None;function i(X){if(y){const{onListenerDidAdd:ie}=X,ae=g.create();let le=0;X.onListenerDidAdd=()=>{++le==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),ie?.()}}}function s(X){return(ie,ae=null,le)=>{let se=!1,ee;return ee=X(fe=>{if(!se)return ee?ee.dispose():se=!0,ie.call(ae,fe)},null,le),se&&ee.dispose(),ee}}o.once=s;function n(X,ie,ae){return L((le,se=null,ee)=>X(fe=>le.call(se,ie(fe)),null,ee),ae)}o.map=n;function r(X,ie,ae){return L((le,se=null,ee)=>X(fe=>{ie(fe),le.call(se,fe)},null,ee),ae)}o.forEach=r;function h(X,ie,ae){return L((le,se=null,ee)=>X(fe=>ie(fe)&&le.call(se,fe),null,ee),ae)}o.filter=h;function c(X){return X}o.signal=c;function w(...X){return(ie,ae=null,le)=>(0,I.combinedDisposable)(...X.map(se=>se(ee=>ie.call(ae,ee),null,le)))}o.any=w;function P(X,ie,ae,le){let se=ae;return n(X,ee=>(se=ie(se,ee),se),le)}o.reduce=P;function L(X,ie){let ae;const le={onFirstListenerAdd(){ae=X(se.fire,se)},onLastListenerRemove(){ae.dispose()}};ie||i(le);const se=new v(le);return ie&&ie.add(se),se.event}function M(X,ie,ae=100,le=!1,se,ee){let fe,ge,ye,Ne=0;const Se={leakWarningThreshold:se,onFirstListenerAdd(){fe=X(Ie=>{Ne++,ge=ie(ge,Ie),le&&!ye&&(_e.fire(ge),ge=void 0),clearTimeout(ye),ye=setTimeout(()=>{const de=ge;ge=void 0,ye=void 0,(!le||Ne>1)&&_e.fire(de),Ne=0},ae)})},onLastListenerRemove(){fe.dispose()}};ee||i(Se);const _e=new v(Se);return ee&&ee.add(_e),_e.event}o.debounce=M;function p(X,ie=(le,se)=>le===se,ae){let le=!0,se;return h(X,ee=>{const fe=le||!ie(ee,se);return le=!1,se=ee,fe},ae)}o.latch=p;function U(X,ie,ae){return[o.filter(X,ie,ae),o.filter(X,le=>!ie(le),ae)]}o.split=U;function B(X,ie=!1,ae=[]){let le=ae.slice(),se=X(ge=>{le?le.push(ge):fe.fire(ge)});const ee=()=>{le&&le.forEach(ge=>fe.fire(ge)),le=null},fe=new v({onFirstListenerAdd(){se||(se=X(ge=>fe.fire(ge)))},onFirstListenerDidAdd(){le&&(ie?setTimeout(ee):ee())},onLastListenerRemove(){se&&se.dispose(),se=null}});return fe.event}o.buffer=B;class H{constructor(ie){this.event=ie}map(ie){return new H(n(this.event,ie))}forEach(ie){return new H(r(this.event,ie))}filter(ie){return new H(h(this.event,ie))}reduce(ie,ae){return new H(P(this.event,ie,ae))}latch(){return new H(p(this.event))}debounce(ie,ae=100,le=!1,se){return new H(M(this.event,ie,ae,le,se))}on(ie,ae,le){return this.event(ie,ae,le)}once(ie,ae,le){return s(this.event)(ie,ae,le)}}function re(X){return new H(X)}o.chain=re;function W(X,ie,ae=le=>le){const le=(...ge)=>fe.fire(ae(...ge)),se=()=>X.on(ie,le),ee=()=>X.removeListener(ie,le),fe=new v({onFirstListenerAdd:se,onLastListenerRemove:ee});return fe.event}o.fromNodeEventEmitter=W;function F(X,ie,ae=le=>le){const le=(...ge)=>fe.fire(ae(...ge)),se=()=>X.addEventListener(ie,le),ee=()=>X.removeEventListener(ie,le),fe=new v({onFirstListenerAdd:se,onLastListenerRemove:ee});return fe.event}o.fromDOMEventEmitter=F;function q(X){return new Promise(ie=>s(X)(ie))}o.toPromise=q;function G(X,ie){return ie(void 0),X(ae=>ie(ae))}o.runAndSubscribe=G;function $(X,ie){let ae=null;function le(ee){ae?.dispose(),ae=new I.DisposableStore,ie(ee,ae)}le(void 0);const se=X(ee=>le(ee));return(0,I.toDisposable)(()=>{se.dispose(),ae?.dispose()})}o.runAndSubscribeWithStore=$})(A=e.Event||(e.Event={}));class N{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${N._idPool++}`}start(i){this._stopWatch=new D.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}N._idPool=0;let R=-1;function b(o){const i=R;return R=o,{dispose(){R=i}}}e.setGlobalLeakWarningThreshold=b;class C{constructor(i,s=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,s){let n=R;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||s<n)return;this._stacks||(this._stacks=new Map);const r=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let h,c=0;for(const[w,P]of this._stacks)(!h||c<P)&&(h=w,c=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${c}):`),console.warn(h)}return()=>{const h=this._stacks.get(i.value)||0;this._stacks.set(i.value,h-1)}}}class g{constructor(i){this.value=i}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(i,s,n){this.callback=i,this.callbackThis=s,this.stack=n,this.subscription=new I.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class v{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=R>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new N(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const s of i)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,s,n)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let h,c;this._leakageMon&&this._listeners.size>=30&&(c=g.create(),h=this._leakageMon.check(c,this._listeners.size+1)),k&&(c=c??g.create());const w=new u(i,s,c),P=this._listeners.push(w);r&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,s);const L=w.subscription.set(()=>{h&&h(),this._disposed||(P(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return n instanceof I.DisposableStore?n.add(L):Array.isArray(n)&&n.push(L),L}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,n]=this._deliveryQueue.shift();try{s.invoke(n)}catch(r){(0,f.onUnexpectedError)(r)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class _ extends v{async fireAsync(i,s,n){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,i]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[r,h]=this._asyncDeliveryQueue.shift(),c=[],w={...h,token:s,waitUntil:P=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");n&&(P=n(P,r.callback)),c.push(P)}};try{r.invoke(w)}catch(P){(0,f.onUnexpectedError)(P);continue}Object.freeze(c),await Promise.allSettled(c).then(P=>{for(const L of P)L.status==="rejected"&&(0,f.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=_;class E extends v{constructor(i){super(i);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=E;class l extends E{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=l;class d extends v{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const s={event:i,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const n=()=>{this.hasListeners&&this.unhook(s);const r=this.events.indexOf(s);this.events.splice(r,1)};return(0,I.toDisposable)((0,t.once)(n))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(s=>this.emitter.fire(s))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class a{constructor(){this.buffers=[]}wrapEvent(i){return(s,n,r)=>i(h=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>s.call(n,h)):s.call(n,h)},void 0,r)}bufferEvents(i){const s=[];this.buffers.push(s);const n=i();return this.buffers.pop(),s.forEach(r=>r()),n}}e.EventBufferer=a;class S{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=I.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(be[21],Ee([1,0,3]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,y){const A=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(A)}}});var I;(function(k){function y(A){return A===k.None||A===k.Cancelled||A instanceof T?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=I.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=D}),define(be[144],Ee([1,0,21]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new f.CancellationTokenSource,k=this.task(D.token);return this.result={promise:k,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=t;class I{constructor(D){this.computeFn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const k=JSON.stringify(D);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(D)),this.lastCache}}e.LRUCachedComputed=I}),define(be[95],Ee([1,0,12,6]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(d){const m=d;return m?typeof m.read=="function":!1}e.isReadable=I;function T(d){const m=d;return m?[m.on,m.pause,m.resume,m.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=T;function D(d){const m=d;return m?T(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=D;function k(d,m){return new y(d,m)}e.newWriteableStream=k;class y{constructor(m,a){this.reducer=m,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(a=>a(m))}emitError(m){this.listeners.error.length===0?(0,f.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(a=>a(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,a){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(m,a){if(this.state.destroyed)return;let S;switch(m){case"data":S=this.listeners.data;break;case"end":S=this.listeners.end;break;case"error":S=this.listeners.error;break}if(S){const o=S.indexOf(a);o>=0&&S.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(S=>S())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function A(d,m){const a=[];let S;for(;(S=d.read())!==null;)a.push(S);return m(a)}e.consumeReadable=A;function N(d,m,a){const S=[];let o;for(;(o=d.read())!==null&&S.length<a;)S.push(o);return o===null&&S.length>0?m(S):{read:()=>{if(S.length>0)return S.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return d.read()}}}e.peekReadable=N;function R(d,m){return new Promise((a,S)=>{const o=[];b(d,{onData:i=>{m&&o.push(i)},onError:i=>{m?S(i):a(void 0)},onEnd:()=>{a(m?m(o):void 0)}})})}e.consumeStream=R;function b(d,m){let a=!1;return d.on("error",S=>{a||m.onError(S)}),d.on("end",()=>{a||m.onEnd()}),d.on("data",S=>{a||m.onData(S)}),(0,t.toDisposable)(()=>a=!0)}e.listenStream=b;function C(d,m){return new Promise((a,S)=>{const o=new t.DisposableStore,i=[],s=h=>{if(i.push(h),i.length>m)return o.dispose(),d.pause(),a({stream:d,buffer:i,ended:!1})},n=h=>S(h),r=()=>a({stream:d,buffer:i,ended:!0});o.add((0,t.toDisposable)(()=>d.removeListener("error",n))),d.on("error",n),o.add((0,t.toDisposable)(()=>d.removeListener("end",r))),d.on("end",r),o.add((0,t.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=C;function g(d,m){const a=k(m);return a.end(d),a}e.toStream=g;function u(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=u;function v(d){let m=!1;return{read:()=>m?null:(m=!0,d)}}e.toReadable=v;function _(d,m,a){const S=k(a);return b(d,{onData:o=>S.write(m.data(o)),onError:o=>S.error(m.error?m.error(o):o),onEnd:()=>S.end()}),S}e.transform=_;function E(d,m,a){let S=!1;return{read:()=>{const o=m.read();return S?o:(S=!0,o!==null?a([d,o]):d)}}}e.prefixedReadable=E;function l(d,m,a){let S=!1;const o=k(a);return b(m,{onData:i=>S?o.write(i):(S=!0,o.write(a([d,i]))),onError:i=>o.error(i),onEnd:()=>{S||(S=!0,o.write(d)),o.end()}}),o}e.prefixedStream=l}),define(be[22],Ee([1,0,95]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,T;class D{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,c){return!(c?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(h)):(I||(I=new TextEncoder),new D(I.encode(h)))}static fromByteArray(h){const c=D.alloc(h.length);for(let w=0,P=h.length;w<P;w++)c.buffer[w]=h[w];return c}static concat(h,c){if(typeof c=="undefined"){c=0;for(let L=0,M=h.length;L<M;L++)c+=h[L].byteLength}const w=D.alloc(c);let P=0;for(let L=0,M=h.length;L<M;L++){const p=h[L];w.set(p,P),P+=p.byteLength}return w}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,c){return new D(this.buffer.subarray(h,c))}set(h,c){if(h instanceof D)this.buffer.set(h.buffer,c);else if(h instanceof Uint8Array)this.buffer.set(h,c);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),c);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),c);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return A(this.buffer,h)}writeUInt32BE(h,c){N(this.buffer,h,c)}readUInt32LE(h){return R(this.buffer,h)}writeUInt32LE(h,c){b(this.buffer,h,c)}readUInt8(h){return C(this.buffer,h)}writeUInt8(h,c){g(this.buffer,h,c)}}e.VSBuffer=D;function k(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0}e.readUInt16LE=k;function y(r,h,c){r[c+0]=h&255,h=h>>>8,r[c+1]=h&255}e.writeUInt16LE=y;function A(r,h){return r[h]*2**24+r[h+1]*2**16+r[h+2]*2**8+r[h+3]}e.readUInt32BE=A;function N(r,h,c){r[c+3]=h,h=h>>>8,r[c+2]=h,h=h>>>8,r[c+1]=h,h=h>>>8,r[c]=h}e.writeUInt32BE=N;function R(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0|r[h+2]<<16>>>0|r[h+3]<<24>>>0}e.readUInt32LE=R;function b(r,h,c){r[c+0]=h&255,h=h>>>8,r[c+1]=h&255,h=h>>>8,r[c+2]=h&255,h=h>>>8,r[c+3]=h&255}e.writeUInt32LE=b;function C(r,h){return r[h]}e.readUInt8=C;function g(r,h,c){r[c]=h}e.writeUInt8=g;function u(r){return f.consumeReadable(r,h=>D.concat(h))}e.readableToBuffer=u;function v(r){return f.toReadable(r)}e.bufferToReadable=v;function _(r){return f.consumeStream(r,h=>D.concat(h))}e.streamToBuffer=_;async function E(r){return r.ended?D.concat(r.buffer):D.concat([...r.buffer,await _(r.stream)])}e.bufferedStreamToBuffer=E;function l(r){return f.toStream(r,h=>D.concat(h))}e.bufferToStream=l;function d(r){return f.transform(r,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.streamToBufferReadableStream=d;function m(r){return f.newWriteableStream(h=>D.concat(h),r)}e.newWriteableBufferStream=m;function a(r,h){return f.prefixedReadable(r,h,c=>D.concat(c))}e.prefixedBufferReadable=a;function S(r,h){return f.prefixedStream(r,h,c=>D.concat(c))}e.prefixedBufferStream=S;function o(r){let h=0,c=0,w=0;const P=new Uint8Array(Math.floor(r.length/4*3)),L=p=>{switch(c){case 3:P[w++]=h|p,c=0;break;case 2:P[w++]=h|p>>>2,h=p<<6,c=3;break;case 1:P[w++]=h|p>>>4,h=p<<4,c=2;break;default:h=p<<2,c=1}};for(let p=0;p<r.length;p++){const U=r.charCodeAt(p);if(U>=65&&U<=90)L(U-65);else if(U>=97&&U<=122)L(U-97+26);else if(U>=48&&U<=57)L(U-48+52);else if(U===43||U===45)L(62);else if(U===47||U===95)L(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${r[p]}`)}}const M=w;for(;c>0;)L(0);return D.wrap(P).slice(0,M)}e.decodeBase64=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:r},h=!0,c=!1){const w=c?s:i;let P="";const L=r.byteLength%3;let M=0;for(;M<r.byteLength-L;M+=3){const p=r[M+0],U=r[M+1],B=r[M+2];P+=w[p>>>2],P+=w[(p<<4|U>>>4)&63],P+=w[(U<<2|B>>>6)&63],P+=w[B&63]}if(L===1){const p=r[M+0];P+=w[p>>>2],P+=w[p<<4&63],h&&(P+="==")}else if(L===2){const p=r[M+0],U=r[M+1];P+=w[p>>>2],P+=w[(p<<4|U>>>4)&63],P+=w[U<<2&63],h&&(P+="=")}return P}e.encodeBase64=n}),define(be[8],Ee([1,0,144,90]),function(J,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=T;const D=/{(\d+)}/g;function k(K,...we){return we.length===0?K:K.replace(D,function(ke,We){const xe=parseInt(We,10);return isNaN(xe)||xe<0||xe>=we.length?ke:we[xe]})}e.format=k;const y=/{([^}]+)}/g;function A(K,we){return K.replace(y,(ke,We)=>we[We]??ke)}e.format2=A;function N(K){return K.replace(/[<>&]/g,function(we){switch(we){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return we}})}e.escape=N;function R(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function b(K,we){let ke=0;const We=we.charCodeAt(0);for(let xe=K.length-1;xe>=0;xe--)K.charCodeAt(xe)===We&&ke++;return ke}e.count=b;function C(K,we,ke="\u2026"){return K.length<=we?K:`${K.substr(0,we)}${ke}`}e.truncate=C;function g(K,we=" "){const ke=u(K,we);return v(ke,we)}e.trim=g;function u(K,we){if(!K||!we)return K;const ke=we.length;if(ke===0||K.length===0)return K;let We=0;for(;K.indexOf(we,We)===We;)We=We+ke;return K.substring(We)}e.ltrim=u;function v(K,we){if(!K||!we)return K;const ke=we.length,We=K.length;if(ke===0||We===0)return K;let xe=We,Je=-1;for(;Je=K.lastIndexOf(we,xe-1),!(Je===-1||Je+ke!==xe);){if(Je===0)return"";xe=Je}return K.substring(0,xe)}e.rtrim=v;function _(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=_;function E(K){return K.replace(/\*/g,"")}e.stripWildcards=E;function l(K,we,ke={}){if(!K)throw new Error("Cannot create regex from empty string");we||(K=R(K)),ke.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let We="";return ke.global&&(We+="g"),ke.matchCase||(We+="i"),ke.multiline&&(We+="m"),ke.unicode&&(We+="u"),new RegExp(K,We)}e.createRegExp=l;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function m(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function a(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=a;function S(K){return K.split(/\r\n|\r|\n/)}e.splitLines=S;function o(K){for(let we=0,ke=K.length;we<ke;we++){const We=K.charCodeAt(we);if(We!==32&&We!==9)return we}return-1}e.firstNonWhitespaceIndex=o;function i(K,we=0,ke=K.length){for(let We=we;We<ke;We++){const xe=K.charCodeAt(We);if(xe!==32&&xe!==9)return K.substring(we,We)}return K.substring(we,ke)}e.getLeadingWhitespace=i;function s(K,we=K.length-1){for(let ke=we;ke>=0;ke--){const We=K.charCodeAt(ke);if(We!==32&&We!==9)return ke}return-1}e.lastNonWhitespaceIndex=s;function n(K,we){return K<we?-1:K>we?1:0}e.compare=n;function r(K,we,ke=0,We=K.length,xe=0,Je=we.length){for(;ke<We&&xe<Je;ke++,xe++){let vt=K.charCodeAt(ke),qe=we.charCodeAt(xe);if(vt<qe)return-1;if(vt>qe)return 1}const st=We-ke,mt=Je-xe;return st<mt?-1:st>mt?1:0}e.compareSubstring=r;function h(K,we){return c(K,we,0,K.length,0,we.length)}e.compareIgnoreCase=h;function c(K,we,ke=0,We=K.length,xe=0,Je=we.length){for(;ke<We&&xe<Je;ke++,xe++){let vt=K.charCodeAt(ke),qe=we.charCodeAt(xe);if(vt===qe)continue;if(vt>=128||qe>=128)return r(K.toLowerCase(),we.toLowerCase(),ke,We,xe,Je);w(vt)&&(vt-=32),w(qe)&&(qe-=32);const at=vt-qe;if(at!==0)return at}const st=We-ke,mt=Je-xe;return st<mt?-1:st>mt?1:0}e.compareSubstringIgnoreCase=c;function w(K){return K>=97&&K<=122}e.isLowerAsciiLetter=w;function P(K){return K>=65&&K<=90}e.isUpperAsciiLetter=P;function L(K,we){return K.length===we.length&&c(K,we)===0}e.equalsIgnoreCase=L;function M(K,we){const ke=we.length;return we.length>K.length?!1:c(K,we,0,ke)===0}e.startsWithIgnoreCase=M;function p(K,we){let ke,We=Math.min(K.length,we.length);for(ke=0;ke<We;ke++)if(K.charCodeAt(ke)!==we.charCodeAt(ke))return ke;return We}e.commonPrefixLength=p;function U(K,we){let ke,We=Math.min(K.length,we.length);const xe=K.length-1,Je=we.length-1;for(ke=0;ke<We;ke++)if(K.charCodeAt(xe-ke)!==we.charCodeAt(Je-ke))return ke;return We}e.commonSuffixLength=U;function B(K){return 55296<=K&&K<=56319}e.isHighSurrogate=B;function H(K){return 56320<=K&&K<=57343}e.isLowSurrogate=H;function re(K,we){return(K-55296<<10)+(we-56320)+65536}e.computeCodePoint=re;function W(K,we,ke){const We=K.charCodeAt(ke);if(B(We)&&ke+1<we){const xe=K.charCodeAt(ke+1);if(H(xe))return re(We,xe)}return We}e.getNextCodePoint=W;function F(K,we){const ke=K.charCodeAt(we-1);if(H(ke)&&we>1){const We=K.charCodeAt(we-2);if(B(We))return re(We,ke)}return ke}class q{constructor(we,ke=0){this._str=we,this._len=we.length,this._offset=ke}get offset(){return this._offset}setOffset(we){this._offset=we}prevCodePoint(){const we=F(this._str,this._offset);return this._offset-=we>=65536?2:1,we}nextCodePoint(){const we=W(this._str,this._len,this._offset);return this._offset+=we>=65536?2:1,we}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class G{constructor(we,ke=0){this._iterator=new q(we,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const we=ze.getInstance(),ke=this._iterator,We=ke.offset;let xe=we.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Je=ke.offset,st=we.getGraphemeBreakType(ke.nextCodePoint());if(De(xe,st)){ke.setOffset(Je);break}xe=st}return ke.offset-We}prevGraphemeLength(){const we=ze.getInstance(),ke=this._iterator,We=ke.offset;let xe=we.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Je=ke.offset,st=we.getGraphemeBreakType(ke.prevCodePoint());if(De(st,xe)){ke.setOffset(Je);break}xe=st}return We-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function $(K,we){return new G(K,we).nextGraphemeLength()}e.nextCharLength=$;function X(K,we){return new G(K,we).prevGraphemeLength()}e.prevCharLength=X;function ie(K,we){we>0&&H(K.charCodeAt(we))&&we--;const ke=we+$(K,we);return[ke-X(K,ke),ke]}e.getCharContainingOffset=ie;const ae=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function le(K){return ae.test(K)}e.containsRTL=le;const se=/^[\t\n\r\x20-\x7E]*$/;function ee(K){return se.test(K)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=fe;function ge(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=ge;function ye(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ye;function Ne(K,we){if(K.length<we)return K;const ke=/\b/g;let We=0;for(;ke.test(K)&&!(K.length-ke.lastIndex<we);)We=ke.lastIndex,ke.lastIndex+=1;return K.substring(We).replace(/^\s/,"")}e.lcut=Ne;const Se=/\x1B\x5B[12]?K/g,_e=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function de(K){return K&&(K=K.replace(Se,""),K=K.replace(_e,""),K=K.replace(Ie,"")),K}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function ne(K){return Q(K)?K.substr(1):K}e.stripUTF8BOM=ne;function O(K,we){if(!K||!we||K.length<we.length)return!1;const ke=we.length,We=K.toLowerCase();let xe=0,Je=-1;for(;xe<ke;){const st=We.indexOf(we[xe],Je+1);if(st<0)return!1;Je=st,xe++}return!0}e.fuzzyContains=O;function x(K,we=!1){return K?(we&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=x;function j(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=j;function Y(K,we=1){if(we===0)return"";let ke=-1;do ke=K.indexOf(`
`,ke+1),we--;while(we>0&&ke>=0);return ke===-1?K:(K[ke-1]==="\r"&&ke--,K.substr(0,ke))}e.getNLines=Y;function ue(K){const we=90-65+1;return K=K%(2*we),K<we?String.fromCharCode(97+K):String.fromCharCode(65+K-we)}e.singleLetterHash=ue;function pe(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=pe;function De(K,we){return K===0?we!==5&&we!==7:K===2&&we===3?!1:K===4||K===2||K===3||we===4||we===2||we===3?!0:!(K===8&&(we===8||we===9||we===11||we===12)||(K===11||K===9)&&(we===9||we===10)||(K===12||K===10)&&we===10||we===5||we===13||we===7||K===1||K===13&&we===14||K===6&&we===6)}var Ue;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=He()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(we){if(we<32)return we===10?3:we===13?2:4;if(we<127)return 0;const ke=this._data,We=ke.length/3;let xe=1;for(;xe<=We;)if(we<ke[3*xe])xe=2*xe;else if(we>ke[3*xe+1])xe=2*xe+1;else return ke[3*xe+2];return 0}}ze._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(K,we){if(K===0)return 0;const ke=et(K,we);if(ke!==void 0)return ke;const We=new q(we,K);return We.prevCodePoint(),We.offset}e.getLeftDeleteOffset=Ke;function et(K,we){const ke=new q(we,K);let We=ke.prevCodePoint();for(;Oe(We)||We===65039||We===8419;){if(ke.offset===0)return;We=ke.prevCodePoint()}if(!ye(We))return;let xe=ke.offset;return xe>0&&ke.prevCodePoint()===8205&&(xe=ke.offset),xe}function Oe(K){return 127995<=K&&K<=127999}var Xe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class te{constructor(we){this.confusableDictionary=we}static getInstance(we){return te.cache.get(Array.from(we))}static getLocales(){return te._locales.getValue()}isAmbiguous(we){return this.confusableDictionary.has(we)}getPrimaryConfusable(we){return this.confusableDictionary.get(we)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=te,I=te,te.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),te.cache=new f.LRUCachedComputed(K=>{function we(qe){const at=new Map;for(let wt=0;wt<qe.length;wt+=2)at.set(qe[wt],qe[wt+1]);return at}function ke(qe,at){const wt=new Map(qe);for(const[it,dt]of at)wt.set(it,dt);return wt}function We(qe,at){if(!qe)return at;const wt=new Map;for(const[it,dt]of qe)at.has(it)&&wt.set(it,dt);return wt}const xe=I.ambiguousCharacterData.getValue();let Je=K.filter(qe=>!qe.startsWith("_")&&qe in xe);Je.length===0&&(Je=["_default"]);let st;for(const qe of Je){const at=we(xe[qe]);st=We(st,at)}const mt=we(xe._common),vt=ke(mt,st);return new te(vt)}),te._locales=new t.Lazy(()=>Object.keys(te.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(oe.getRawData())),this._data}static isInvisibleCharacter(we){return oe.getData().has(we)}static get codePoints(){return oe.getData()}}e.InvisibleCharacters=oe,oe._data=void 0}),define(be[57],Ee([1,0,8]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(_){return I(_,0)}e.hash=t;function I(_,E){switch(typeof _){case"object":return _===null?T(349,E):Array.isArray(_)?y(_,E):A(_,E);case"string":return k(_,E);case"boolean":return D(_,E);case"number":return T(_,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=I;function T(_,E){return(E<<5)-E+_|0}e.numberHash=T;function D(_,E){return T(_?433:863,E)}function k(_,E){E=T(149417,E);for(let l=0,d=_.length;l<d;l++)E=T(_.charCodeAt(l),E);return E}e.stringHash=k;function y(_,E){return E=T(104579,E),_.reduce((l,d)=>I(d,l),E)}function A(_,E){return E=T(181387,E),Object.keys(_).sort().reduce((l,d)=>(l=k(d,l),I(_[d],l)),E)}class N{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=I(E,this._value),this._value}}e.Hasher=N;var R;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function b(_,E,l=32){const d=l-E,m=~((1<<d)-1);return(_<<E|(m&_)>>>d)>>>0}function C(_,E=0,l=_.byteLength,d=0){for(let m=0;m<l;m++)_[E+m]=d}function g(_,E,l="0"){for(;_.length<E;)_=l+_;return _}function u(_,E=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(l=>l.toString(16).padStart(2,"0")).join(""):g((_>>>0).toString(16),E/4)}e.toHexString=u;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const l=E.length;if(l===0)return;const d=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,S,o;for(a!==0?(S=a,o=-1,a=0):(S=E.charCodeAt(0),o=0);;){let i=S;if(f.isHighSurrogate(S))if(o+1<l){const s=E.charCodeAt(o+1);f.isLowSurrogate(s)?(o++,i=f.computeCodePoint(S,s)):i=65533}else{a=S;break}else f.isLowSurrogate(S)&&(i=65533);if(m=this._push(d,m,i),o++,o<l)S=E.charCodeAt(o);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(E,l,d){return d<128?E[l++]=d:d<2048?(E[l++]=192|(d&1984)>>>6,E[l++]=128|(d&63)>>>0):d<65536?(E[l++]=224|(d&61440)>>>12,E[l++]=128|(d&4032)>>>6,E[l++]=128|(d&63)>>>0):(E[l++]=240|(d&1835008)>>>18,E[l++]=128|(d&258048)>>>12,E[l++]=128|(d&4032)>>>6,E[l++]=128|(d&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,C(this._buff,this._buffLen),this._buffLen>56&&(this._step(),C(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=v._bigBlock32,l=this._buffDV;for(let r=0;r<64;r+=4)E.setUint32(r,l.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)E.setUint32(r,b(E.getUint32(r-12,!1)^E.getUint32(r-32,!1)^E.getUint32(r-56,!1)^E.getUint32(r-64,!1),1),!1);let d=this._h0,m=this._h1,a=this._h2,S=this._h3,o=this._h4,i,s,n;for(let r=0;r<80;r++)r<20?(i=m&a|~m&S,s=1518500249):r<40?(i=m^a^S,s=1859775393):r<60?(i=m&a|m&S|a&S,s=2400959708):(i=m^a^S,s=3395469782),n=b(d,5)+i+o+s+E.getUint32(r*4,!1)&4294967295,o=S,S=a,a=b(m,30),m=d,d=n;this._h0=this._h0+d&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[24],Ee([1,0,18,8]),function(J,e,f,t){"use strict";var I,T,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(o,i,s){let n=o.get(i);return n===void 0&&(n=s,o.set(i,n)),n}e.getOrSet=k;function y(o){const i=[];return o.forEach((s,n)=>{i.push(`${n} => ${s}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=y;function A(o){const i=[];return o.forEach(s=>{i.push(s)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=A;class N{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=N;class R{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class b{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const n=this._value.charCodeAt(s);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var C;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(C||(C={}));class g{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(v||(v={}));class _{constructor(i){this._iter=i}static forUris(i=()=>!1){return new _(new g(i))}static forPaths(i=!1){return new _(new b(void 0,!i))}static forStrings(){return new _(new N)}static forConfigKeys(){return new _(new R)}clear(){this._root=void 0}fill(i,s){if(s){const n=s.slice(0);(0,f.shuffle)(n);for(let r of n)this.set(r,i)}else{const n=i.slice(0);(0,f.shuffle)(n);for(let r of n)this.set(r[0],r[1])}}set(i,s){const n=this._iter.reset(i);let r;this._root||(this._root=new u,this._root.segment=n.value());const h=[];for(r=this._root;;){const w=n.cmp(r.segment);if(w>0)r.left||(r.left=new u,r.left.segment=n.value()),h.push([-1,r]),r=r.left;else if(w<0)r.right||(r.right=new u,r.right.segment=n.value()),h.push([1,r]),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new u,r.mid.segment=n.value()),h.push([0,r]),r=r.mid;else break}const c=r.value;r.value=s,r.key=i;for(let w=h.length-1;w>=0;w--){const P=h[w][1];P.updateHeight();const L=P.balanceFactor();if(L<-1||L>1){const M=h[w][0],p=h[w+1][0];if(M===1&&p===1)h[w][1]=P.rotateLeft();else if(M===-1&&p===-1)h[w][1]=P.rotateRight();else if(M===1&&p===-1)P.right=h[w+1][1]=h[w+1][1].rotateRight(),h[w][1]=P.rotateLeft();else if(M===-1&&p===1)P.left=h[w+1][1]=h[w+1][1].rotateLeft(),h[w][1]=P.rotateRight();else throw new Error;if(w>0)switch(h[w-1][0]){case-1:h[w-1][1].left=h[w][1];break;case 1:h[w-1][1].right=h[w][1];break;case 0:h[w-1][1].mid=h[w][1];break}else this._root=h[0][1]}}return c}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const r=s.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const n=this._iter.reset(i),r=[];let h=this._root;for(;h;){const c=n.cmp(h.segment);if(c>0)r.push([-1,h]),h=h.left;else if(c<0)r.push([1,h]),h=h.right;else if(n.hasNext())n.next(),r.push([0,h]),h=h.mid;else break}if(!!h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const c=this._min(h.right),{key:w,value:P,segment:L}=c;this._delete(c.key,!1),h.key=w,h.value=P,h.segment=L}else{const c=h.left??h.right;if(r.length>0){const[w,P]=r[r.length-1];switch(w){case-1:P.left=c;break;case 0:P.mid=c;break;case 1:P.right=c;break}}else this._root=c}for(let c=r.length-1;c>=0;c--){const w=r[c][1];w.updateHeight();const P=w.balanceFactor();if(P>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),r[c][1]=w.rotateLeft()):P<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),r[c][1]=w.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this._root=r[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let n=this._root,r;for(;n;){const h=s.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(s.hasNext())s.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const r=s.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[s,n]of this)i(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const n=s.balanceFactor();return n<-1||n>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=_;class E{constructor(i,s){this.uri=i,this.value=s}}class l{constructor(i,s){this[I]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=s??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new E(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[n,r]of this.map)i(r.value,r.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=o=>o.toString();var d;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class m{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const n=this._map.get(i);if(!!n)return s!==0&&this.touch(n,s),n.value}set(i,s,n=0){let r=this._map.get(i);if(r)r.value=s,n!==0&&this.touch(r,n);else{switch(r={key:i,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const n=this._state;let r=this._head;for(;r;){if(s?i.bind(s)(r.value,r.key,this):i(r.value,r.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,s=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.key,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return r}values(){const i=this,s=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.value,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return r}entries(){const i=this,s=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:[n.key,n.value],done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return r}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>i;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,n=i.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const n=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(n.previous=r,r.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const n=i.next,r=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=r,r.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,n)=>{i.push([n,s])}),i}fromJSON(i){this.clear();for(const[s,n]of i)this.set(s,n)}}e.LinkedMap=m;class a extends m{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class S{constructor(i){D.set(this,void 0),Ye(this,D,i,"f")}get size(){return Le(this,D,"f").size}forEach(i,s){Le(this,D,"f").forEach(i,s)}get(i){return Le(this,D,"f").get(i)}has(i){return Le(this,D,"f").has(i)}entries(){return Le(this,D,"f").entries()}keys(){return Le(this,D,"f").keys()}values(){return Le(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Le(this,D,"f").entries()}}e.ReadonlyMapView=S}),define(be[96],Ee([1,0,24,8]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...Q){return function(ne,O){for(let x=0,j=Q.length;x<j;x++){const Y=Q[x](ne,O);if(Y)return Y}return null}}e.or=I,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(Q,ne,O){if(!O||O.length<ne.length)return null;let x;return Q?x=t.startsWithIgnoreCase(O,ne):x=O.indexOf(ne)===0,x?ne.length>0?[{start:0,end:ne.length}]:[]:null}function D(Q,ne){const O=ne.toLowerCase().indexOf(Q.toLowerCase());return O===-1?null:[{start:O,end:O+Q.length}]}e.matchesContiguousSubString=D;function k(Q,ne){return y(Q.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=k;function y(Q,ne,O,x){if(O===Q.length)return[];if(x===ne.length)return null;if(Q[O]===ne[x]){let j=null;return(j=y(Q,ne,O+1,x+1))?_({start:x,end:x+1},j):null}return y(Q,ne,O,x+1)}function A(Q){return 97<=Q&&Q<=122}function N(Q){return 65<=Q&&Q<=90}e.isUpper=N;function R(Q){return 48<=Q&&Q<=57}function b(Q){return Q===32||Q===9||Q===10||Q===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Q=>C.add(Q.charCodeAt(0)));function g(Q){return b(Q)||C.has(Q)}function u(Q,ne){return Q===ne||g(Q)&&g(ne)}function v(Q){return A(Q)||N(Q)||R(Q)}function _(Q,ne){return ne.length===0?ne=[Q]:Q.end===ne[0].start?ne[0].start=Q.start:ne.unshift(Q),ne}function E(Q,ne){for(let O=ne;O<Q.length;O++){const x=Q.charCodeAt(O);if(N(x)||R(x)||O>0&&!v(Q.charCodeAt(O-1)))return O}return Q.length}function l(Q,ne,O,x){if(O===Q.length)return[];if(x===ne.length)return null;if(Q[O]!==ne[x].toLowerCase())return null;{let j=null,Y=x+1;for(j=l(Q,ne,O+1,x+1);!j&&(Y=E(ne,Y))<ne.length;)j=l(Q,ne,O+1,Y),Y++;return j===null?null:_({start:x,end:x+1},j)}}function d(Q){let ne=0,O=0,x=0,j=0,Y=0;for(let ze=0;ze<Q.length;ze++)Y=Q.charCodeAt(ze),N(Y)&&ne++,A(Y)&&O++,v(Y)&&x++,R(Y)&&j++;const ue=ne/Q.length,pe=O/Q.length,De=x/Q.length,Ue=j/Q.length;return{upperPercent:ue,lowerPercent:pe,alphaPercent:De,numericPercent:Ue}}function m(Q){const{upperPercent:ne,lowerPercent:O}=Q;return O===0&&ne>.6}function a(Q){const{upperPercent:ne,lowerPercent:O,alphaPercent:x,numericPercent:j}=Q;return O>.2&&ne<.8&&x>.6&&j<.2}function S(Q){let ne=0,O=0,x=0,j=0;for(let Y=0;Y<Q.length;Y++)x=Q.charCodeAt(Y),N(x)&&ne++,A(x)&&O++,b(x)&&j++;return(ne===0||O===0)&&j===0?Q.length<=30:ne<=5}function o(Q,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!S(Q)||ne.length>60)return null;const O=d(ne);if(!a(O)){if(!m(O))return null;ne=ne.toLowerCase()}let x=null,j=0;for(Q=Q.toLowerCase();j<ne.length&&(x=l(Q,ne,0,j))===null;)j=E(ne,j+1);return x}e.matchesCamelCase=o;function i(Q,ne,O=!1){if(!ne||ne.length===0)return null;let x=null,j=0;for(Q=Q.toLowerCase(),ne=ne.toLowerCase();j<ne.length&&(x=s(Q,ne,0,j,O))===null;)j=n(ne,j+1);return x}e.matchesWords=i;function s(Q,ne,O,x,j){if(O===Q.length)return[];if(x===ne.length)return null;if(u(Q.charCodeAt(O),ne.charCodeAt(x))){let Y=null,ue=x+1;if(Y=s(Q,ne,O+1,x+1,j),!j)for(;!Y&&(ue=n(ne,ue))<ne.length;)Y=s(Q,ne,O+1,ue,j),ue++;return Y===null?null:_({start:x,end:x+1},Y)}else return null}function n(Q,ne){for(let O=ne;O<Q.length;O++)if(g(Q.charCodeAt(O))||O>0&&g(Q.charCodeAt(O-1)))return O;return Q.length}const r=I(e.matchesPrefix,o,D),h=I(e.matchesPrefix,o,k),c=new f.LRUCache(1e4);function w(Q,ne,O=!1){if(typeof Q!="string"||typeof ne!="string")return null;let x=c.get(Q);x||(x=new RegExp(t.convertSimple2RegExpPattern(Q),"i"),c.set(Q,x));const j=x.exec(ne);return j?[{start:j.index,end:j.index+j[0].length}]:O?h(Q,ne):r(Q,ne)}e.matchesFuzzy=w;function P(Q,ne){const O=ge(Q,Q.toLowerCase(),0,ne,ne.toLowerCase(),0,!0);return O?M(O):null}e.matchesFuzzy2=P;function L(Q,ne,O,x,j,Y){const ue=Math.min(13,Q.length);for(;O<ue;O++){const pe=ge(Q,ne,O,x,j,Y,!1);if(pe)return pe}return[0,Y]}e.anyScore=L;function M(Q){if(typeof Q=="undefined")return[];const ne=[],O=Q[1];for(let x=Q.length-1;x>1;x--){const j=Q[x]+O,Y=ne[ne.length-1];Y&&Y.end===j?Y.end=j+1:ne.push({start:j,end:j+1})}return ne}e.createMatches=M;const p=128;function U(){const Q=[],ne=[];for(let O=0;O<=p;O++)ne[O]=0;for(let O=0;O<=p;O++)Q.push(ne.slice(0));return Q}function B(Q){const ne=[];for(let O=0;O<=Q;O++)ne[O]=0;return ne}const H=B(2*p),re=B(2*p),W=U(),F=U(),q=U(),G=!1;function $(Q,ne,O,x,j){function Y(pe,De,Ue=" "){for(;pe.length<De;)pe=Ue+pe;return pe}let ue=` |   |${x.split("").map(pe=>Y(pe,3)).join("|")}
`;for(let pe=0;pe<=O;pe++)pe===0?ue+=" |":ue+=`${ne[pe-1]}|`,ue+=Q[pe].slice(0,j+1).map(De=>Y(De.toString(),3)).join("|")+`
`;return ue}function X(Q,ne,O,x){Q=Q.substr(ne),O=O.substr(x),console.log($(F,Q,Q.length,O,O.length)),console.log($(q,Q,Q.length,O,O.length)),console.log($(W,Q,Q.length,O,O.length))}function ie(Q,ne){if(ne<0||ne>=Q.length)return!1;const O=Q.codePointAt(ne);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function ae(Q,ne){if(ne<0||ne>=Q.length)return!1;switch(Q.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function le(Q,ne,O){return ne[Q]!==O[Q]}function se(Q,ne,O,x,j,Y,ue=!1){for(;ne<O&&j<Y;)Q[ne]===x[j]&&(ue&&(H[ne]=j),ne+=1),j+=1;return ne===O}e.isPatternInWord=se;var ee;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var fe;(function(Q){Q.Default=[-100,0];function ne(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}Q.isDefault=ne})(fe=e.FuzzyScore||(e.FuzzyScore={}));function ge(Q,ne,O,x,j,Y,ue){const pe=Q.length>p?p:Q.length,De=x.length>p?p:x.length;if(O>=pe||Y>=De||pe-O>De-Y||!se(ne,O,pe,j,Y,De,!0))return;ye(pe,De,O,Y,ne,j);let Ue=1,ze=1,He=O,Ke=Y;const et=[!1];for(Ue=1,He=O;He<pe;Ue++,He++){const K=H[He],we=re[He],ke=He+1<pe?re[He+1]:De;for(ze=K-Y+1,Ke=K;Ke<ke;ze++,Ke++){let We=Number.MIN_SAFE_INTEGER,xe=!1;Ke<=we&&(We=Ne(Q,ne,He,O,x,j,Ke,De,Y,W[Ue-1][ze-1]===0,et));let Je=0;We!==Number.MAX_SAFE_INTEGER&&(xe=!0,Je=We+F[Ue-1][ze-1]);const st=Ke>K,mt=st?F[Ue][ze-1]+(W[Ue][ze-1]>0?-5:0):0,vt=Ke>K+1&&W[Ue][ze-1]>0,qe=vt?F[Ue][ze-2]+(W[Ue][ze-2]>0?-5:0):0;if(vt&&(!st||qe>=mt)&&(!xe||qe>=Je))F[Ue][ze]=qe,q[Ue][ze]=3,W[Ue][ze]=0;else if(st&&(!xe||mt>=Je))F[Ue][ze]=mt,q[Ue][ze]=2,W[Ue][ze]=0;else if(xe)F[Ue][ze]=Je,q[Ue][ze]=1,W[Ue][ze]=W[Ue-1][ze-1]+1;else throw new Error("not possible")}}if(G&&X(Q,O,x,Y),!et[0]&&!ue)return;Ue--,ze--;const Oe=[F[Ue][ze],Y];let Xe=0,te=0;for(;Ue>=1;){let K=ze;do{const we=q[Ue][K];if(we===3)K=K-2;else if(we===2)K=K-1;else break}while(K>=1);Xe>1&&ne[O+Ue-1]===j[Y+ze-1]&&!le(K+Y-1,x,j)&&Xe+1>W[Ue][K]&&(K=ze),K===ze?Xe++:Xe=1,te||(te=K),Ue--,ze=K-1,Oe.push(ze)}De===pe&&(Oe[0]+=2);const oe=te-pe;return Oe[0]-=oe,Oe}e.fuzzyScore=ge;function ye(Q,ne,O,x,j,Y){let ue=Q-1,pe=ne-1;for(;ue>=O&&pe>=x;)j[ue]===Y[pe]&&(re[ue]=pe,ue--),pe--}function Ne(Q,ne,O,x,j,Y,ue,pe,De,Ue,ze){if(ne[O]!==Y[ue])return Number.MIN_SAFE_INTEGER;let He=1,Ke=!1;return ue===O-x?He=Q[O]===j[ue]?7:5:le(ue,j,Y)&&(ue===0||!le(ue-1,j,Y))?(He=Q[O]===j[ue]?7:5,Ke=!0):ie(Y,ue)&&(ue===0||!ie(Y,ue-1))?He=5:(ie(Y,ue-1)||ae(Y,ue-1))&&(He=5,Ke=!0),He>1&&O===x&&(ze[0]=!0),Ke||(Ke=le(ue,j,Y)||ie(Y,ue-1)||ae(Y,ue-1)),O===x?ue>De&&(He-=Ke?3:5):Ue?He+=Ke?2:0:He+=Ke?0:1,ue+1===pe&&(He-=Ke?3:5),He}function Se(Q,ne,O,x,j,Y,ue){return Ie(Q,ne,O,x,j,Y,!0,ue)}e.fuzzyScoreGracefulAggressive=Se;function _e(Q,ne,O,x,j,Y,ue){return Ie(Q,ne,O,x,j,Y,!1,ue)}e.fuzzyScoreGraceful=_e;function Ie(Q,ne,O,x,j,Y,ue,pe){let De=ge(Q,ne,O,x,j,Y,pe);if(De&&!ue)return De;if(Q.length>=3){const Ue=Math.min(7,Q.length-1);for(let ze=O+1;ze<Ue;ze++){const He=de(Q,ze);if(He){const Ke=ge(He,He.toLowerCase(),O,x,j,Y,pe);Ke&&(Ke[0]-=3,(!De||Ke[0]>De[0])&&(De=Ke))}}}return De}function de(Q,ne){if(ne+1>=Q.length)return;const O=Q[ne],x=Q[ne+1];if(O!==x)return Q.slice(0,ne)+x+O+Q.slice(ne+2)}}),define(be[145],Ee([1,0,73,96,8]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(f.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${T.source}`,"g");function y(v){return v.replace(k,(_,E)=>E?_:`\\${_}`)}e.escapeIcons=y;const A=new RegExp(`\\\\${T.source}`,"g");function N(v){return v.replace(A,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=N;const R=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function b(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(R,(_,E,l,d)=>l?_:E||d||"")}e.stripIcons=b;function C(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:g(v,_)}e.parseLabelWithIcons=C;function g(v,_){const E=[];let l="";function d(r){if(r){l+=r;for(const h of r)E.push(S)}}let m=-1,a="",S=0,o,i,s=_;const n=v.length;for(d(v.substr(0,_));s<n;)o=v[s],i=v[s+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=s,d(a),a=e.iconStartMarker,s++):o===")"&&m!==-1?(S+=s-m+1,m=-1,a=""):m!==-1?D.test(o)?a+=o:(d(a),m=-1,a=""):d(o),s++;return d(a),{text:l,iconOffsets:E}}function u(v,_,E=!1){const{text:l,iconOffsets:d}=_;if(!d||d.length===0)return(0,t.matchesFuzzy)(v,l,E);const m=(0,I.ltrim)(l," "),a=l.length-m.length,S=(0,t.matchesFuzzy)(v,m,E);if(S)for(const o of S){const i=d[o.start+a]+a;o.start+=i,o.end+=i}return S}e.matchesFuzzyIconAware=u}),define(be[78],Ee([1,0,24]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new f.LRUCache(1e4);function I(A){return y(A,"NFC",t)}e.normalizeNFC=I;const T=new f.LRUCache(1e4);function D(A){return y(A,"NFD",T)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function y(A,N,R){if(!A)return A;const b=R.get(A);if(b)return b;let C;return k.test(A)?C=A.normalize(N):C=A,R.set(A,C),C}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(N){return D(N).replace(A,"")}}()}),define(be[47],Ee([1,0,8]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const T="error",D="warning",k="warn",y="info",A="ignore";function N(b){return b?f.equalsIgnoreCase(T,b)?I.Error:f.equalsIgnoreCase(D,b)||f.equalsIgnoreCase(k,b)?I.Warning:f.equalsIgnoreCase(y,b)?I.Info:I.Ignore:I.Ignore}I.fromValue=N;function R(b){switch(b){case I.Error:return T;case I.Warning:return D;case I.Info:return y;default:return A}}I.toString=R}(t||(t={})),e.default=t}),define(be[14],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(r){return Array.isArray(r)}e.isArray=f;function t(r){return typeof r=="string"}e.isString=t;function I(r){return Array.isArray(r)&&r.every(h=>t(h))}e.isStringArray=I;function T(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=T;function D(r){return typeof r=="object"&&(r instanceof Uint8Array||r instanceof Uint16Array||r instanceof Uint32Array||r instanceof Float32Array||r instanceof Float64Array||r instanceof Int8Array||r instanceof Int16Array||r instanceof Int32Array||r instanceof BigInt64Array||r instanceof BigUint64Array||r instanceof Uint8ClampedArray)}e.isTypedArray=D;function k(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=k;function y(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=y;function A(r){return r===!0||r===!1}e.isBoolean=A;function N(r){return typeof r=="undefined"}e.isUndefined=N;function R(r){return!b(r)}e.isDefined=R;function b(r){return N(r)||r===null}e.isUndefinedOrNull=b;function C(r,h){if(!r)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=C;function g(r){if(b(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function u(...r){const h=[];for(let c=0;c<r.length;c++){const w=r[c];if(b(w))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);h.push(w)}return h}e.assertAllDefined=u;const v=Object.prototype.hasOwnProperty;function _(r){if(!T(r))return!1;for(let h in r)if(v.call(r,h))return!1;return!0}e.isEmptyObject=_;function E(r){return typeof r=="function"}e.isFunction=E;function l(...r){return r.length>0&&r.every(E)}e.areFunctions=l;function d(r,h){const c=Math.min(r.length,h.length);for(let w=0;w<c;w++)m(r[w],h[w])}e.validateConstraints=d;function m(r,h){if(t(h)){if(typeof r!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(E(h)){try{if(r instanceof h)return}catch{}if(!b(r)&&r.constructor===h||h.length===1&&h.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function a(r){let h=[],c=Object.getPrototypeOf(r);for(;Object.prototype!==c;)h=h.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return h}e.getAllPropertyNames=a;function S(r){const h=[];for(const c of a(r))typeof r[c]=="function"&&h.push(c);return h}e.getAllMethodNames=S;function o(r,h){const c=P=>function(){const L=Array.prototype.slice.call(arguments,0);return h(P,L)};let w={};for(const P of r)w[P]=c(P);return w}e.createProxyObject=o;function i(r){return r===null?void 0:r}e.withNullAsUndefined=i;function s(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=s;function n(r,h="Unreachable"){throw new Error(h)}e.assertNever=n}),define(be[30],Ee([1,0,9,13,8,14]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function k(s){return s.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=k;function y(s){return s.indexOf("/")===-1&&(s=k(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function A(s,n=f.posix.sep){if(!s)return"";const r=s.length,h=s.charCodeAt(0);if(D(h)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let w=3;const P=w;for(;w<r&&!D(s.charCodeAt(w));w++);if(P!==w&&!D(s.charCodeAt(w+1))){for(w+=1;w<r;w++)if(D(s.charCodeAt(w)))return s.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(_(h)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let c=s.indexOf("://");if(c!==-1){for(c+=3;c<r;c++)if(D(s.charCodeAt(c)))return s.slice(0,c+1)}return""}e.getRoot=A;function N(s){if(!t.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let r=2;const h=r;for(;r<s.length&&(n=s.charCodeAt(r),n!==92);r++);return!(h===r||(n=s.charCodeAt(r+1),isNaN(n)||n===92))}e.isUNC=N;const R=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(s,n=t.isWindows){const r=n?R:b;return!(!s||s.length===0||/^\s+$/.test(s)||(r.lastIndex=0,r.test(s))||n&&C.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=g;function u(s,n,r){const h=s===n;return!r||h?h:!s||!n?!1:(0,I.equalsIgnoreCase)(s,n)}e.isEqual=u;function v(s,n,r,h=f.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(r){if(!(0,I.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let w=n.length;return n.charAt(n.length-1)===h&&w--,s.charAt(w)===h}return n.charAt(n.length-1)!==h&&(n+=h),s.indexOf(n)===0}e.isEqualOrParent=v;function _(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=_;function E(s,n){return t.isWindows&&s.endsWith(":")&&(s+=f.sep),(0,f.isAbsolute)(s)||(s=(0,f.join)(n,s)),s=(0,f.normalize)(s),t.isWindows?(s=(0,I.rtrim)(s,f.sep),s.endsWith(":")&&(s+=f.sep)):(s=(0,I.rtrim)(s,f.sep),s||(s=f.sep)),s}e.sanitizeFilePath=E;function l(s){const n=(0,f.normalize)(s);return t.isWindows?s.length>3?!1:d(n)&&(s.length===2||n.charCodeAt(2)===92):n===f.posix.sep}e.isRootOrDriveLetter=l;function d(s,n){return(n!==void 0?n:t.isWindows)?_(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function m(s){return d(s)?s[0]:void 0}e.getDriveLetter=m;function a(s,n,r){return n.length>s.length?-1:s===n?0:(r&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=a;function S(s){const n=s.split(":");let r,h,c;for(const w of n){const P=Number(w);(0,T.isNumber)(P)?h===void 0?h=P:c===void 0&&(c=P):r=r?[r,w].join(":"):w}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:h!==void 0?h:void 0,column:c!==void 0?c:h!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,n,r=8){let h="";for(let w=0;w<r;w++)h+=o.charAt(Math.floor(Math.random()*o.length));let c;return n?c=`${n}-${h}`:c=h,s?(0,f.join)(s,c):c}e.randomPath=i}),define(be[25],Ee([1,0,14]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.keys(u).forEach(_=>{u[_]&&typeof u[_]=="object"?v[_]=t(u[_]):v[_]=u[_]}),v}e.deepClone=t;function I(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const _=v.shift();Object.freeze(_);for(const E in _)if(T.call(_,E)){const l=_[E];typeof l=="object"&&!Object.isFrozen(l)&&!(0,f.isTypedArray)(l)&&v.push(l)}}return u}e.deepFreeze=I;const T=Object.prototype.hasOwnProperty;function D(u,v){return k(u,v,new Set)}e.cloneAndChange=D;function k(u,v,_){if((0,f.isUndefinedOrNull)(u))return u;const E=v(u);if(typeof E!="undefined")return E;if((0,f.isArray)(u)){const l=[];for(const d of u)l.push(k(d,v,_));return l}if((0,f.isObject)(u)){if(_.has(u))throw new Error("Cannot clone recursive data-structure");_.add(u);const l={};for(let d in u)T.call(u,d)&&(l[d]=k(u[d],v,_));return _.delete(u),l}return u}function y(u,v,_=!0){return(0,f.isObject)(u)?((0,f.isObject)(v)&&Object.keys(v).forEach(E=>{E in u?_&&((0,f.isObject)(u[E])&&(0,f.isObject)(v[E])?y(u[E],v[E],_):u[E]=v[E]):u[E]=v[E]}),u):v}e.mixin=y;function A(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let _,E;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(_=0;_<u.length;_++)if(!A(u[_],v[_]))return!1}else{const l=[];for(E in u)l.push(E);l.sort();const d=[];for(E in v)d.push(E);if(d.sort(),!A(l,d))return!1;for(_=0;_<l.length;_++)if(!A(u[l[_]],v[l[_]]))return!1}return!0}e.equals=A;function N(u){const v=new Set;return JSON.stringify(u,(_,E)=>{if((0,f.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}e.safeStringify=N;function R(u,v,_){const E=v(u);return typeof E=="undefined"?_:E}e.getOrDefault=R;function b(u,v){const _=Object.create(null);return!u||!v||Object.keys(v).forEach(l=>{const d=u[l],m=v[l];A(d,m)||(_[l]=m)}),_}e.distinct=b;function C(u,v){const _=v.toLowerCase(),E=Object.keys(u).find(l=>l.toLowerCase()===_);return E?u[E]:u[v]}e.getCaseInsensitive=C;function g(u,v){const _=Object.create(null);for(const[E,l]of Object.entries(u))v(E,l)&&(_[E]=l);return _}e.filter=g}),define(be[97],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function t(T){return T<0?0:T>255?255:T|0}e.toUint8=t;function I(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=I}),define(be[2],Ee([1,0,9,13]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,T=/^\//,D=/^\/\//;function k(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!I.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!T.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,i){return!o&&!i?"file":o}function A(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==R&&(i=R+i):i=R;break}return i}const N="",R="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(i,s,n,r,h,c=!1){typeof i=="object"?(this.scheme=i.scheme||N,this.authority=i.authority||N,this.path=i.path||N,this.query=i.query||N,this.fragment=i.fragment||N):(this.scheme=y(i,c),this.authority=s||N,this.path=A(this.scheme,n||N),this.query=r||N,this.fragment=h||N,k(this,c))}static isUri(i){return i instanceof C?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:n,path:r,query:h,fragment:c}=i;return s===void 0?s=this.scheme:s===null&&(s=N),n===void 0?n=this.authority:n===null&&(n=N),r===void 0?r=this.path:r===null&&(r=N),h===void 0?h=this.query:h===null&&(h=N),c===void 0?c=this.fragment:c===null&&(c=N),s===this.scheme&&n===this.authority&&r===this.path&&h===this.query&&c===this.fragment?this:new u(s,n,r,h,c)}static parse(i,s=!1){const n=b.exec(i);return n?new u(n[2]||N,S(n[4]||N),S(n[5]||N),S(n[7]||N),S(n[9]||N),s):new u(N,N,N,N,N)}static file(i){let s=N;if(t.isWindows&&(i=i.replace(/\\/g,R)),i[0]===R&&i[1]===R){const n=i.indexOf(R,2);n===-1?(s=i.substring(2),i=R):(s=i.substring(2,n),i=i.substring(n)||R)}return new u("file",s,i,N,N)}static from(i){const s=new u(i.scheme,i.authority,i.path,i.query,i.fragment);return k(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return t.isWindows&&i.scheme==="file"?n=C.file(f.win32.join(l(i,!0),...s)).path:n=f.posix.join(i.path,...s),i.with({path:n})}toString(i=!1){return d(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof C)return i;{const s=new u(i);return s._formatted=i.external,s._fsPath=i._sep===g?i.fsPath:null,s}}else return i}}e.URI=C;const g=t.isWindows?1:void 0;class u extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=g),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(o,i){let s,n=-1;for(let r=0;r<o.length;r++){const h=o.charCodeAt(r);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)n!==-1&&(s+=encodeURIComponent(o.substring(n,r)),n=-1),s!==void 0&&(s+=o.charAt(r));else{s===void 0&&(s=o.substr(0,r));const c=v[h];c!==void 0?(n!==-1&&(s+=encodeURIComponent(o.substring(n,r)),n=-1),s+=c):n===-1&&(n=r)}}return n!==-1&&(s+=encodeURIComponent(o.substring(n))),s!==void 0?s:o}function E(o){let i;for(let s=0;s<o.length;s++){const n=o.charCodeAt(s);n===35||n===63?(i===void 0&&(i=o.substr(0,s)),i+=v[n]):i!==void 0&&(i+=o[s])}return i!==void 0?i:o}function l(o,i){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=l;function d(o,i){const s=i?E:_;let n="",{scheme:r,authority:h,path:c,query:w,fragment:P}=o;if(r&&(n+=r,n+=":"),(h||r==="file")&&(n+=R,n+=R),h){let L=h.indexOf("@");if(L!==-1){const M=h.substr(0,L);h=h.substr(L+1),L=M.indexOf(":"),L===-1?n+=s(M,!1):(n+=s(M.substr(0,L),!1),n+=":",n+=s(M.substr(L+1),!1)),n+="@"}h=h.toLowerCase(),L=h.indexOf(":"),L===-1?n+=s(h,!1):(n+=s(h.substr(0,L),!1),n+=h.substr(L))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const L=c.charCodeAt(1);L>=65&&L<=90&&(c=`/${String.fromCharCode(L+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const L=c.charCodeAt(0);L>=65&&L<=90&&(c=`${String.fromCharCode(L+32)}:${c.substr(2)}`)}n+=s(c,!0)}return w&&(n+="?",n+=s(w,!1)),P&&(n+="#",n+=i?P:_(P,!1)),n}function m(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+m(o.substr(3)):o}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(o){return o.match(a)?o.replace(a,i=>m(i)):o}}),define(be[58],Ee([1,0,22,8,2]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(A){return JSON.stringify(A,k)}e.stringify=T;function D(A){let N=JSON.parse(A);return N=y(N),N}e.parse=D;function k(A,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,t.regExpFlags)(N)}:N}function y(A,N=0){if(!A||N>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return I.URI.revive(A);case 2:return new RegExp(A.source,A.flags);case 14:return new Date(A.source)}if(A instanceof f.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let R=0;R<A.length;++R)A[R]=y(A[R],N+1);else for(const R in A)Object.hasOwnProperty.call(A,R)&&(A[R]=y(A[R],N+1))}return A}e.revive=y}),define(be[10],Ee([1,0,13,2]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,A,N){this._hosts[y]=A,this._ports[y]=N}setConnectionToken(y,A){this._connectionTokens[y]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const A=y.authority;let N=this._hosts[A];N&&N.indexOf(":")!==-1&&(N=`[${N}]`);const R=this._ports[A],b=this._connectionTokens[A];let C=`path=${encodeURIComponent(y.path)}`;return typeof b=="string"&&(C+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),t.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${N}:${R}`,path:"/vscode-remote-resource",query:C})}}e.RemoteAuthorities=new T;class D{asBrowserUri(y,A){const N=this.toUri(y,A);return N.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===I.file&&(f.isNative||f.isWebWorker&&f.globals.origin===`${I.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?N.with({scheme:I.vscodeFileResource,authority:N.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(y,A){const N=this.toUri(y,A);return N.scheme===I.vscodeFileResource?N.with({scheme:I.file,authority:N.authority!==D.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(y,A){return t.URI.isUri(y)?y:t.URI.parse(A.toUrl(y))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(be[23],Ee([1,0,30,10,9,13,8,2]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(C){return(0,k.uriToFsPath)(C,!0)}e.originalFSPath=y;class A{constructor(g){this._ignorePathCasing=g}compare(g,u,v=!1){return g===u?0:(0,D.compare)(this.getComparisonKey(g,v),this.getComparisonKey(u,v))}isEqual(g,u,v=!1){return g===u?!0:!g||!u?!1:this.getComparisonKey(g,v)===this.getComparisonKey(u,v)}getComparisonKey(g,u=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,u,v=!1){if(g.scheme===u.scheme){if(g.scheme===t.Schemas.file)return f.isEqualOrParent(y(g),y(u),this._ignorePathCasing(g))&&g.query===u.query&&(v||g.fragment===u.fragment);if((0,e.isEqualAuthority)(g.authority,u.authority))return f.isEqualOrParent(g.path,u.path,this._ignorePathCasing(g),"/")&&g.query===u.query&&(v||g.fragment===u.fragment)}return!1}joinPath(g,...u){return k.URI.joinPath(g,...u)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return I.posix.basename(g.path)}extname(g){return I.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let u;return g.scheme===t.Schemas.file?u=k.URI.file(I.dirname(y(g))).path:(u=I.posix.dirname(g.path),g.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),u="/")),g.with({path:u})}normalizePath(g){if(!g.path.length)return g;let u;return g.scheme===t.Schemas.file?u=k.URI.file(I.normalize(y(g))).path:u=I.posix.normalize(g.path),g.with({path:u})}relativePath(g,u){if(g.scheme!==u.scheme||!(0,e.isEqualAuthority)(g.authority,u.authority))return;if(g.scheme===t.Schemas.file){const E=I.relative(y(g),y(u));return T.isWindows?f.toSlashes(E):E}let v=g.path||"/",_=u.path||"/";if(this._ignorePathCasing(g)){let E=0;for(const l=Math.min(v.length,_.length);E<l&&!(v.charCodeAt(E)!==_.charCodeAt(E)&&v.charAt(E).toLowerCase()!==_.charAt(E).toLowerCase());E++);v=_.substr(0,E)+v.substr(E)}return I.posix.relative(v,_)}resolvePath(g,u){if(g.scheme===t.Schemas.file){const v=k.URI.file(I.resolve(y(g),u));return g.with({authority:v.authority,path:v.path})}return u=f.toPosixPath(u),g.with({path:I.posix.resolve(g.path,u)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,u){return g===u||g!==void 0&&u!==void 0&&(0,D.equalsIgnoreCase)(g,u)}hasTrailingPathSeparator(g,u=I.sep){if(g.scheme===t.Schemas.file){const v=y(g);return v.length>f.getRoot(v).length&&v[v.length-1]===u}else{const v=g.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,u=I.sep){return(0,e.hasTrailingPathSeparator)(g,u)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,u=I.sep){let v=!1;if(g.scheme===t.Schemas.file){const _=y(g);v=_!==void 0&&_.length===f.getRoot(_).length&&_[_.length-1]===u}else{u="/";const _=g.path;v=_.length===1&&_.charCodeAt(_.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(g,u)?g.with({path:g.path+"/"}):g}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(C=>C.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new A(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(C,g){const u=[];for(let v=0;v<C.length;v++){const _=g(C[v]);C.some((E,l)=>l===v?!1:(0,e.isEqualOrParent)(_,g(E)))||u.push(C[v])}return u}e.distinctParents=N;var R;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function g(u){const v=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(l=>{const[d,m]=l.split(":");d&&m&&v.set(d,m)});const E=u.path.substring(0,u.path.indexOf(";"));return E&&v.set(C.META_DATA_MIME,E),v}C.parseMetaData=g})(R=e.DataUri||(e.DataUri={}));function b(C,g,u){if(g){let v=C.path;return v&&v[0]!==I.posix.sep&&(v=I.posix.sep+v),C.with({scheme:u,authority:g,path:v})}return C.with({scheme:u})}e.toLocalResource=b}),define(be[15],Ee([1,0,21,12,3,6,23,13]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(le){return!!le&&typeof le.then=="function"}e.isThenable=y;function A(le){const se=new f.CancellationTokenSource,ee=le(se.token),fe=new Promise((ge,ye)=>{const Ne=se.token.onCancellationRequested(()=>{Ne.dispose(),se.dispose(),ye(new t.CancellationError)});Promise.resolve(ee).then(Se=>{Ne.dispose(),se.dispose(),ge(Se)},Se=>{Ne.dispose(),se.dispose(),ye(Se)})});return new class{cancel(){se.cancel()}then(ge,ye){return fe.then(ge,ye)}catch(ge){return this.then(void 0,ge)}finally(ge){return fe.finally(ge)}}}e.createCancelablePromise=A;function N(le,se,ee){return new Promise((fe,ge)=>{const ye=se.onCancellationRequested(()=>{ye.dispose(),fe(ee)});le.then(fe,ge).finally(()=>ye.dispose())})}e.raceCancellation=N;function R(le,se){return new Promise((ee,fe)=>{const ge=se.onCancellationRequested(()=>{ge.dispose(),fe(new t.CancellationError)});le.then(ee,fe).finally(()=>ge.dispose())})}e.raceCancellationError=R;async function b(le){let se=-1;const ee=le.map((ge,ye)=>ge.then(Ne=>(se=ye,Ne))),fe=await Promise.race(ee);return le.forEach((ge,ye)=>{ye!==se&&ge.cancel()}),fe}e.raceCancellablePromises=b;function C(le,se,ee){let fe;const ge=setTimeout(()=>{fe?.(void 0),ee?.()},se);return Promise.race([le.finally(()=>clearTimeout(ge)),new Promise(ye=>fe=ye)])}e.raceTimeout=C;function g(le){return new Promise((se,ee)=>{const fe=le();y(fe)?fe.then(se,ee):se(fe)})}e.asPromise=g;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(se){if(this.activePromise){if(this.queuedPromiseFactory=se,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(ee,ee).then(fe)})}return new Promise((ee,fe)=>{this.queuedPromise.then(ee,fe)})}return this.activePromise=se(),new Promise((ee,fe)=>{this.activePromise.then(ge=>{this.activePromise=null,ee(ge)},ge=>{this.activePromise=null,fe(ge)})})}}e.Throttler=u;class v{constructor(){this.current=Promise.resolve(null)}queue(se){return this.current=this.current.then(()=>se(),()=>se())}}e.Sequencer=v;class _{constructor(){this.promiseMap=new Map}queue(se,ee){const ge=(this.promiseMap.get(se)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(se)===ge&&this.promiseMap.delete(se)});return this.promiseMap.set(se,ge),ge}}e.SequencerByKey=_;const E=(le,se)=>{let ee=!0;const fe=setTimeout(()=>{ee=!1,se()},le);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(fe),ee=!1}}},l=le=>{let se=!0;return queueMicrotask(()=>{se&&(se=!1,le())}),{isTriggered:()=>se,dispose:()=>{se=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(se){this.defaultDelay=se,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(se,ee=this.defaultDelay){this.task=se,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,ye)=>{this.doResolve=ge,this.doReject=ye}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===e.MicrotaskDelay?l(fe):E(ee,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class m{constructor(se){this.delayer=new d(se),this.throttler=new u}trigger(se,ee){return this.delayer.trigger(()=>this.throttler.queue(se),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class a{constructor(){this._isOpen=!1,this._promise=new Promise((se,ee)=>{this._completePromise=se})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class S extends a{constructor(se){super();this._timeout=setTimeout(()=>this.open(),se)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function o(le,se){return se?new Promise((ee,fe)=>{const ge=setTimeout(()=>{ye.dispose(),ee()},le),ye=se.onCancellationRequested(()=>{clearTimeout(ge),ye.dispose(),fe(new t.CancellationError)})}):A(ee=>o(le,ee))}e.timeout=o;function i(le,se=0){const ee=setTimeout(le,se);return(0,T.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=i;function s(le){const se=[];let ee=0;const fe=le.length;function ge(){return ee<fe?le[ee++]():null}function ye(Ne){Ne!=null&&se.push(Ne);const Se=ge();return Se?Se.then(ye):Promise.resolve(se)}return Promise.resolve(null).then(ye)}e.sequence=s;function n(le,se=fe=>!!fe,ee=null){let fe=0;const ge=le.length,ye=()=>{if(fe>=ge)return Promise.resolve(ee);const Ne=le[fe++];return Promise.resolve(Ne()).then(_e=>se(_e)?Promise.resolve(_e):ye())};return ye()}e.first=n;function r(le,se=fe=>!!fe,ee=null){if(le.length===0)return Promise.resolve(ee);let fe=le.length;const ge=()=>{fe=-1;for(const ye of le)ye.cancel?.()};return new Promise((ye,Ne)=>{for(const Se of le)Se.then(_e=>{--fe>=0&&se(_e)?(ge(),ye(_e)):fe===0&&ye(ee)}).catch(_e=>{--fe>=0&&(ge(),Ne(_e))})})}e.firstParallel=r;class h{constructor(se){this._size=0,this.maxDegreeOfParalellism=se,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(se){return this._size++,new Promise((ee,fe)=>{this.outstandingPromises.push({factory:se,c:ee,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const se=this.outstandingPromises.shift();this.runningPromises++;const ee=se.factory();ee.then(se.c,se.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class c extends h{constructor(){super(1)}}e.Queue=c;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const se=new q;return this.drainers.add(se),se.p}isDrained(){for(const[,se]of this.queues)if(se.size>0)return!1;return!0}queueFor(se,ee=D.extUri){const fe=ee.getComparisonKey(se);let ge=this.queues.get(fe);return ge||(ge=new c,I.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.queues.delete(fe),this.onDidQueueDrain()}),this.queues.set(fe,ge)),ge}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const se of this.drainers)se.complete();this.drainers.clear()}dispose(){for(const[,se]of this.queues)se.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class P{constructor(se,ee){this._token=-1,typeof se=="function"&&typeof ee=="number"&&this.setIfNotSet(se,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(se,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,se()},ee)}setIfNotSet(se,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,se()},ee))}}e.TimeoutTimer=P;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(se,ee){this.cancel(),this._token=setInterval(()=>{se()},ee)}}e.IntervalTimer=L;class M{constructor(se,ee){this.timeoutToken=-1,this.runner=se,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(se=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,se)}get delay(){return this.timeout}set delay(se){this.timeout=se}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class p{constructor(se,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=se,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(se=this.timeout){se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(se/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class U extends M{constructor(se,ee){super(se,ee);this.units=[]}work(se){this.units.push(se),this.isScheduled()||this.schedule()}doRun(){const se=this.units;this.units=[],this.runner&&this.runner(se)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class B extends T.Disposable{constructor(se,ee){super();this.options=se,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(se){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+se.length>this.options.maxBufferedWork)return!1}else if(this.pending+se.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...se),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,k.setTimeout0)(()=>{if(se)return;const ee=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.runWhenIdle=(le,se)=>{const ee=requestIdleCallback(le,typeof se=="number"?{timeout:se}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(ee))}}}}();class H{constructor(se){this._didRun=!1,this._executor=()=>{try{this._value=se()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function re(le,se,ee){let fe;for(let ge=0;ge<ee;ge++)try{return await le()}catch(ye){fe=ye,await o(se)}throw fe}e.retry=re;class W{hasPending(se){return this._pending?typeof se=="number"?this._pending.taskId===se:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(se,ee,fe){return this._pending={taskId:se,cancel:()=>fe?.(),promise:ee},ee.then(()=>this.donePending(se),()=>this.donePending(se)),ee}donePending(se){this._pending&&se===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const se=this._next;this._next=void 0,se.run().then(se.promiseResolve,se.promiseReject)}}setNext(se){if(this._next)this._next.run=se;else{let ee,fe;const ge=new Promise((ye,Ne)=>{ee=ye,fe=Ne});this._next={run:se,promise:ge,promiseResolve:ee,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=W;class F{constructor(se,ee=()=>Date.now()){this.interval=se,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const se=this.nowFn();return se-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=se,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((se,ee)=>{this.completeCallback=se,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(se){return new Promise(ee=>{this.completeCallback(se),this.resolved=!0,ee()})}error(se){return new Promise(ee=>{this.errorCallback(se),this.rejected=!0,ee()})}cancel(){new Promise(se=>{this.errorCallback(new t.CancellationError),this.rejected=!0,se()})}}e.DeferredPromise=q;var G;(function(le){async function se(fe){let ge;const ye=await Promise.all(fe.map(Ne=>Ne.then(Se=>Se,Se=>{ge||(ge=Se)})));if(typeof ge!="undefined")throw ge;return ye}le.settled=se;function ee(fe){return new Promise(async(ge,ye)=>{try{await fe(ge,ye)}catch(Ne){ye(Ne)}})}le.withAsyncBody=ee})(G=e.Promises||(e.Promises={}));var $;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})($||($={}));class X{constructor(se){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const ee={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(se(ee)),this.resolve()}catch(fe){this.reject(fe)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}static fromArray(se){return new X(ee=>{ee.emitMany(se)})}static fromPromise(se){return new X(async ee=>{ee.emitMany(await se)})}static fromPromises(se){return new X(async ee=>{await Promise.all(se.map(async fe=>ee.emitOne(await fe)))})}static merge(se){return new X(async ee=>{await Promise.all(se.map(async fe=>{for await(const ge of fe)ee.emitOne(ge)}))})}[Symbol.asyncIterator](){let se=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(se<this._results.length)return{done:!1,value:this._results[se++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(se,ee){return new X(async fe=>{for await(const ge of se)fe.emitOne(ee(ge))})}map(se){return X.map(this,se)}static filter(se,ee){return new X(async fe=>{for await(const ge of se)ee(ge)&&fe.emitOne(ge)})}filter(se){return X.filter(this,se)}static coalesce(se){return X.filter(se,ee=>!!ee)}coalesce(){return X.coalesce(this)}static async toPromise(se){const ee=[];for await(const fe of se)ee.push(fe);return ee}toPromise(){return X.toPromise(this)}emitOne(se){this._state===0&&(this._results.push(se),this._onStateChanged.fire())}emitMany(se){this._state===0&&(this._results=this._results.concat(se),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(se){this._state===0&&(this._state=2,this._error=se,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ie extends X{constructor(se,ee){super(ee);this._source=se}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function ae(le){const se=new f.CancellationTokenSource,ee=le(se.token);return new ie(se,async fe=>{const ge=se.token.onCancellationRequested(()=>{ge.dispose(),se.dispose(),fe.reject(new t.CancellationError)});try{for await(const ye of ee){if(se.token.isCancellationRequested)return;fe.emitOne(ye)}ge.dispose(),se.dispose()}catch(ye){ge.dispose(),se.dispose(),fe.reject(ye)}})}e.createCancelableAsyncIterable=ae}),define(be[98],Ee([1,0,15,9]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),T=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(c,w,P=!1){const L=c||"",M=w||"",p=I.value.collator.compare(L,M);return I.value.collatorIsNumeric&&p===0&&L!==M?L<M?-1:1:p}e.compareFileNames=k;function y(c,w){const P=T.value.collator;return c=c||"",w=w||"",m(P,c,w)}e.compareFileNamesDefault=y;function A(c,w){const P=T.value.collator;return c=c||"",w=w||"",i(c,w)||m(P,c,w)}e.compareFileNamesUpper=A;function N(c,w){const P=T.value.collator;return c=c||"",w=w||"",o(c,w)||m(P,c,w)}e.compareFileNamesLower=N;function R(c,w){return c=c||"",w=w||"",c===w?0:c<w?-1:1}e.compareFileNamesUnicode=R;function b(c,w,P=!1){P||(c=c&&c.toLowerCase(),w=w&&w.toLowerCase());const[L,M]=l(c),[p,U]=l(w);return L!==p?L<p?-1:1:M===U?0:M<U?-1:1}e.noIntlCompareFileNames=b;function C(c,w){const[P,L]=l(c),[M,p]=l(w);let U=I.value.collator.compare(L,p);if(U===0){if(I.value.collatorIsNumeric&&L!==p)return L<p?-1:1;if(U=I.value.collator.compare(P,M),I.value.collatorIsNumeric&&U===0&&P!==M)return P<M?-1:1}return U}e.compareFileExtensions=C;function g(c,w){c=c||"",w=w||"";const P=d(c),L=d(w),M=T.value.collator,p=D.value.collator;return m(p,P,L)||m(M,c,w)}e.compareFileExtensionsDefault=g;function u(c,w){c=c||"",w=w||"";const P=d(c),L=d(w),M=T.value.collator,p=D.value.collator;return m(p,P,L)||i(c,w)||m(M,c,w)}e.compareFileExtensionsUpper=u;function v(c,w){c=c||"",w=w||"";const P=d(c),L=d(w),M=T.value.collator,p=D.value.collator;return m(p,P,L)||o(c,w)||m(M,c,w)}e.compareFileExtensionsLower=v;function _(c,w){c=c||"",w=w||"";const P=d(c).toLowerCase(),L=d(w).toLowerCase();return P!==L?P<L?-1:1:c!==w?c<w?-1:1:0}e.compareFileExtensionsUnicode=_;const E=/^(.*?)(\.([^.]*))?$/;function l(c,w=!1){const P=c?E.exec(c):[];let L=[P&&P[1]||"",P&&P[3]||""];return w&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function d(c){const w=c?E.exec(c):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function m(c,w,P){let L=c.compare(w,P);return L!==0?L:w.length!==P.length?w.length<P.length?-1:1:0}function a(c){const w=c.charAt(0);return w.toLocaleUpperCase()!==w}function S(c){const w=c.charAt(0);return w.toLocaleLowerCase()!==w}function o(c,w){return a(c)&&S(w)?-1:S(c)&&a(w)?1:0}function i(c,w){return S(c)&&a(w)?-1:a(c)&&S(w)?1:0}function s(c,w,P=!1){return P||(c=c&&c.toLowerCase(),w=w&&w.toLowerCase()),c===w?0:c<w?-1:1}function n(c,w,P=!1){const L=c.split(t.sep),M=w.split(t.sep),p=L.length-1,U=M.length-1;let B,H;for(let re=0;;re++){if(B=p===re,H=U===re,B&&H)return k(L[re],M[re],P);if(B)return-1;if(H)return 1;const W=s(L[re],M[re],P);if(W!==0)return W}}e.comparePaths=n;function r(c,w,P){const L=c.toLowerCase(),M=w.toLowerCase(),p=h(c,w,P);if(p)return p;const U=L.endsWith(P),B=M.endsWith(P);if(U!==B)return U?-1:1;const H=k(L,M);return H!==0?H:L.localeCompare(M)}e.compareAnything=r;function h(c,w,P){const L=c.toLowerCase(),M=w.toLowerCase(),p=L.startsWith(P),U=M.startsWith(P);if(p!==U)return p?-1:1;if(p&&U){if(L.length<M.length)return-1;if(L.length>M.length)return 1}return 0}e.compareByPrefix=h}),define(be[99],Ee([1,0,98,96,57,9,13,8]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,A=[y,[]];function N(W,F,q,G){if(!W||!F)return A;const $=W.length,X=F.length;if($<X)return A;const ie=W.toLowerCase();return R(F,q,X,W,ie,$,G)}e.scoreFuzzy=N;function R(W,F,q,G,$,X,ie){const ae=[],le=[];for(let ge=0;ge<q;ge++){const ye=ge*X,Ne=ye-X,Se=ge>0,_e=W[ge],Ie=F[ge];for(let de=0;de<X;de++){const Q=de>0,ne=ye+de,O=ne-1,x=Ne+de-1,j=Q?ae[O]:0,Y=Se&&Q?ae[x]:0,ue=Se&&Q?le[x]:0;let pe;!Y&&Se?pe=0:pe=b(_e,Ie,G,$,de,ue),pe&&Y+pe>=j&&(ie||Se||$.startsWith(F,de))?(le[ne]=ue+1,ae[ne]=Y+pe):(le[ne]=y,ae[ne]=j)}}const se=[];let ee=q-1,fe=X-1;for(;ee>=0&&fe>=0;){const ge=ee*X+fe;le[ge]===y||(se.push(fe),ee--),fe--}return[ae[q*X-1],se.reverse()]}function b(W,F,q,G,$,X){let ie=0;if(!C(F,G[$]))return ie;if(ie+=1,X>0&&(ie+=X*5),W===q[$]&&(ie+=1),$===0)ie+=8;else{const ae=g(q.charCodeAt($-1));ae?ie+=ae:(0,t.isUpper)(q.charCodeAt($))&&X===0&&(ie+=2)}return ie}function C(W,F){return W===F?!0:W==="/"||W==="\\"?F==="/"||F==="\\":!1}function g(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function v(W,F,q=0,G=0){const $=F;return $.values&&$.values.length>1?_(W,$.values,q,G):E(W,F,q,G)}e.scoreFuzzy2=v;function _(W,F,q,G){let $=0;const X=[];for(const ie of F){const[ae,le]=E(W,ie,q,G);if(typeof ae!="number")return u;$+=ae,X.push(...le)}return[$,h(X)]}function E(W,F,q,G){const $=(0,t.fuzzyScore)(F.original,F.originalLowercase,q,W,W.toLowerCase(),G,!0);return $?[$[0],(0,t.createMatches)($)]:u}const l=Object.freeze({score:0}),d=1<<18,m=1<<17,a=1<<16;function S(W,F,q,G){const $=G.values?G.values:[G];return(0,I.hash)({[G.normalized]:{values:$.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:W,description:F,allowNonContiguousMatches:q}})}function o(W,F,q,G,$){if(!W||!F.normalized)return l;const X=G.getItemLabel(W);if(!X)return l;const ie=G.getItemDescription(W),ae=S(X,ie,q,F),le=$[ae];if(le)return le;const se=i(X,ie,G.getItemPath(W),F,q);return $[ae]=se,se}e.scoreItemFuzzy=o;function i(W,F,q,G,$){const X=!q||!G.containsPathSeparator;return q&&(D.isLinux?G.pathNormalized===q:(0,k.equalsIgnoreCase)(G.pathNormalized,q))?{score:d,labelMatch:[{start:0,end:W.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:G.values&&G.values.length>1?s(W,F,q,G.values,X,$):n(W,F,q,G,X,$)}function s(W,F,q,G,$,X){let ie=0;const ae=[],le=[];for(const se of G){const{score:ee,labelMatch:fe,descriptionMatch:ge}=n(W,F,q,se,$,X);if(ee===y)return l;ie+=ee,fe&&ae.push(...fe),ge&&le.push(...ge)}return{score:ie,labelMatch:h(ae),descriptionMatch:h(le)}}function n(W,F,q,G,$,X){if($||!F){const[ie,ae]=N(W,G.normalized,G.normalizedLowercase,X&&!G.expectContiguousMatch);if(ie){const le=(0,t.matchesPrefix)(G.normalized,W);let se;return le?(se=m,se+=Math.round(G.normalized.length/W.length*100)):se=a,{score:se+ie,labelMatch:le||r(ae)}}}if(F){let ie=F;q&&(ie=`${F}${T.sep}`);const ae=ie.length,le=`${ie}${W}`,[se,ee]=N(le,G.normalized,G.normalizedLowercase,X&&!G.expectContiguousMatch);if(se){const fe=r(ee),ge=[],ye=[];return fe.forEach(Ne=>{Ne.start<ae&&Ne.end>ae?(ge.push({start:0,end:Ne.end-ae}),ye.push({start:Ne.start,end:ae})):Ne.start>=ae?ge.push({start:Ne.start-ae,end:Ne.end-ae}):ye.push(Ne)}),{score:se,labelMatch:ge,descriptionMatch:ye}}}return l}function r(W){const F=[];if(!W)return F;let q;for(const G of W)q&&q.end===G?q.end+=1:(q={start:G,end:G+1},F.push(q));return F}function h(W){const F=W.sort(($,X)=>$.start-X.start),q=[];let G;for(const $ of F)!G||!c(G,$)?(G=$,q.push($)):(G.start=Math.min(G.start,$.start),G.end=Math.max(G.end,$.end));return q}function c(W,F){return!(W.end<F.start||F.end<W.start)}function w(W,F,q,G,$,X){const ie=o(W,q,G,$,X),ae=o(F,q,G,$,X),le=ie.score,se=ae.score;if((le===d||se===d)&&le!==se)return le===d?-1:1;if(le>a||se>a){if(le!==se)return le>se?-1:1;if(le<m&&se<m){const _e=L(ie.labelMatch,ae.labelMatch);if(_e!==0)return _e}const Ne=$.getItemLabel(W)||"",Se=$.getItemLabel(F)||"";if(Ne.length!==Se.length)return Ne.length-Se.length}if(le!==se)return le>se?-1:1;const ee=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,fe=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0;if(ee&&!fe)return-1;if(fe&&!ee)return 1;const ge=P(W,ie,$),ye=P(F,ae,$);return ge&&ye&&ge!==ye?ye>ge?-1:1:M(W,F,q,$)}e.compareItemsByFuzzyScore=w;function P(W,F,q){let G=-1,$=-1;if(F.descriptionMatch&&F.descriptionMatch.length?G=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&(G=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if($=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const X=q.getItemDescription(W);X&&($+=X.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&($=F.descriptionMatch[F.descriptionMatch.length-1].end);return $-G}function L(W,F){if(!W&&!F||(!W||!W.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!W||!W.length)return 1;const q=W[0].start,$=W[W.length-1].end-q,X=F[0].start,ae=F[F.length-1].end-X;return $===ae?0:ae<$?1:-1}function M(W,F,q,G){const $=G.getItemLabel(W)||"",X=G.getItemLabel(F)||"",ie=G.getItemDescription(W),ae=G.getItemDescription(F),le=$.length+(ie?ie.length:0),se=X.length+(ae?ae.length:0);if(le!==se)return le-se;const ee=G.getItemPath(W),fe=G.getItemPath(F);return ee&&fe&&ee.length!==fe.length?ee.length-fe.length:$!==X?(0,f.compareAnything)($,X,q.normalized):ie&&ae&&ie!==ae?(0,f.compareAnything)(ie,ae,q.normalized):ee&&fe&&ee!==fe?(0,f.compareAnything)(ee,fe,q.normalized):0}function p(W){return W.startsWith('"')&&W.endsWith('"')}const U=" ";function B(W){typeof W!="string"&&(W="");const F=W.toLowerCase(),{pathNormalized:q,normalized:G,normalizedLowercase:$}=H(W),X=q.indexOf(T.sep)>=0,ie=p(W);let ae;const le=W.split(U);if(le.length>1)for(const se of le){const ee=p(se),{pathNormalized:fe,normalized:ge,normalizedLowercase:ye}=H(se);ge&&(ae||(ae=[]),ae.push({original:se,originalLowercase:se.toLowerCase(),pathNormalized:fe,normalized:ge,normalizedLowercase:ye,expectContiguousMatch:ee}))}return{original:W,originalLowercase:F,pathNormalized:q,normalized:G,normalizedLowercase:$,values:ae,containsPathSeparator:X,expectContiguousMatch:ie}}e.prepareQuery=B;function H(W){let F;D.isWindows?F=W.replace(/\//g,T.sep):F=W.replace(/\\/g,T.sep);const q=(0,k.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:q,normalizedLowercase:q.toLowerCase()}}function re(W){return Array.isArray(W)?B(W.map(F=>F.original).join(U)):B(W.original)}e.pieceToQuery=re}),define(be[34],Ee([1,0,15,30,24,9,13,8]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",N="[^/\\\\]",R=/\//g;function b(W,F){switch(W){case 0:return"";case 1:return`${N}*?`;default:return`(?:${A}|${N}+${A}${F?`|${A}${N}+`:""})*?`}}function C(W,F){if(!W)return[];const q=[];let G=!1,$=!1,X="";for(const ie of W){switch(ie){case F:if(!G&&!$){q.push(X),X="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":$=!0;break;case"]":$=!1;break}X+=ie}return X&&q.push(X),q}e.splitGlobAware=C;function g(W){if(!W)return"";let F="";const q=C(W,e.GLOB_SPLIT);if(q.every(G=>G===e.GLOBSTAR))F=".*";else{let G=!1;q.forEach(($,X)=>{if($===e.GLOBSTAR){if(G)return;F+=b(2,X===q.length-1)}else{let ie=!1,ae="",le=!1,se="";for(const ee of $){if(ee!=="}"&&ie){ae+=ee;continue}if(le&&(ee!=="]"||!se)){let fe;ee==="-"?fe=ee:(ee==="^"||ee==="!")&&!se?fe="^":ee===e.GLOB_SPLIT?fe="":fe=(0,k.escapeRegExpCharacters)(ee),se+=fe;continue}switch(ee){case"{":ie=!0;continue;case"[":le=!0;continue;case"}":{F+=`(?:${C(ae,",").map(ye=>g(ye)).join("|")})`,ie=!1,ae="";break}case"]":{F+="["+se+"]",le=!1,se="";break}case"?":F+=N;continue;case"*":F+=b(1);continue;default:F+=(0,k.escapeRegExpCharacters)(ee)}}X<q.length-1&&(q[X+1]!==e.GLOBSTAR||X+2<q.length)&&(F+=A)}G=$===e.GLOBSTAR})}return F}const u=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,m=new I.LRUCache(1e4),a=function(){return!1},S=function(){return null};function o(W,F){if(!W)return S;let q;typeof W!="string"?q=W.pattern:q=W,q=q.trim();const G=`${q}_${!!F.trimForExclusions}`;let $=m.get(G);if($)return i($,W);let X;return u.test(q)?$=n(q.substr(4),q):(X=v.exec(s(q,F)))?$=r(X[1],q):(F.trimForExclusions?E:_).test(q)?$=h(q,F):(X=l.exec(s(q,F)))?$=c(X[1].substr(1),q,!0):(X=d.exec(s(q,F)))?$=c(X[1],q,!1):$=w(q),m.set(G,$),i($,W)}function i(W,F){return typeof F=="string"?W:function(q,G){return(0,t.isEqualOrParent)(q,F.base,!D.isLinux)?W(q.substr(F.base.length+1),G):null}}function s(W,F){return F.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function n(W,F){return function(q,G){return typeof q=="string"&&q.endsWith(W)?F:null}}function r(W,F){const q=`/${W}`,G=`\\${W}`,$=function(ie,ae){return typeof ie!="string"?null:ae?ae===W?F:null:ie===W||ie.endsWith(q)||ie.endsWith(G)?F:null},X=[W];return $.basenames=X,$.patterns=[F],$.allBasenames=X,$}function h(W,F){const q=re(W.slice(1,-1).split(",").map(ae=>o(ae,F)).filter(ae=>ae!==S),W),G=q.length;if(!G)return S;if(G===1)return q[0];const $=function(ae,le){for(let se=0,ee=q.length;se<ee;se++)if(q[se](ae,le))return W;return null},X=q.find(ae=>!!ae.allBasenames);X&&($.allBasenames=X.allBasenames);const ie=q.reduce((ae,le)=>le.allPaths?ae.concat(le.allPaths):ae,[]);return ie.length&&($.allPaths=ie),$}function c(W,F,q){const G=T.sep===T.posix.sep,$=G?W:W.replace(R,T.sep),X=T.sep+$,ie=T.posix.sep+W;let ae;return q?ae=function(le,se){return typeof le=="string"&&(le===$||le.endsWith(X)||!G&&(le===W||le.endsWith(ie)))?F:null}:ae=function(le,se){return typeof le=="string"&&(le===$||!G&&le===W)?F:null},ae.allPaths=[(q?"*/":"./")+W],ae}function w(W){try{const F=new RegExp(`^${g(W)}$`);return function(q){return F.lastIndex=0,typeof q=="string"&&F.test(q)?W:null}}catch{return S}}function P(W,F,q){return!W||typeof F!="string"?!1:L(W)(F,void 0,q)}e.match=P;function L(W,F={}){if(!W)return a;if(typeof W=="string"||M(W)){const q=o(W,F);if(q===S)return a;const G=function($,X){return!!q($,X)};return q.allBasenames&&(G.allBasenames=q.allBasenames),q.allPaths&&(G.allPaths=q.allPaths),G}return B(W,F)}e.parse=L;function M(W){const F=W;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=M;function p(W){return W.allBasenames||[]}e.getBasenameTerms=p;function U(W){return W.allPaths||[]}e.getPathTerms=U;function B(W,F){const q=re(Object.getOwnPropertyNames(W).map(ae=>H(ae,W[ae],F)).filter(ae=>ae!==S)),G=q.length;if(!G)return S;if(!q.some(ae=>!!ae.requiresSiblings)){if(G===1)return q[0];const ae=function(ee,fe){for(let ge=0,ye=q.length;ge<ye;ge++){const Ne=q[ge](ee,fe);if(Ne)return Ne}return null},le=q.find(ee=>!!ee.allBasenames);le&&(ae.allBasenames=le.allBasenames);const se=q.reduce((ee,fe)=>fe.allPaths?ee.concat(fe.allPaths):ee,[]);return se.length&&(ae.allPaths=se),ae}const $=function(ae,le,se){let ee;for(let fe=0,ge=q.length;fe<ge;fe++){const ye=q[fe];ye.requiresSiblings&&se&&(le||(le=(0,T.basename)(ae)),ee||(ee=le.substr(0,le.length-(0,T.extname)(ae).length)));const Ne=ye(ae,le,ee,se);if(Ne)return Ne}return null},X=q.find(ae=>!!ae.allBasenames);X&&($.allBasenames=X.allBasenames);const ie=q.reduce((ae,le)=>le.allPaths?ae.concat(le.allPaths):ae,[]);return ie.length&&($.allPaths=ie),$}function H(W,F,q){if(F===!1)return S;const G=o(W,q);if(G===S)return S;if(typeof F=="boolean")return G;if(F){const $=F.when;if(typeof $=="string"){const X=(ie,ae,le,se)=>{if(!se||!G(ie,ae))return null;const ee=$.replace("$(basename)",le),fe=se(ee);return(0,f.isThenable)(fe)?fe.then(ge=>ge?W:null):fe?W:null};return X.requiresSiblings=!0,X}}return G}function re(W,F){const q=W.filter(ae=>!!ae.basenames);if(q.length<2)return W;const G=q.reduce((ae,le)=>{const se=le.basenames;return se?ae.concat(se):ae},[]);let $;if(F){$=[];for(let ae=0,le=G.length;ae<le;ae++)$.push(F)}else $=q.reduce((ae,le)=>{const se=le.patterns;return se?ae.concat(se):ae},[]);const X=function(ae,le){if(typeof ae!="string")return null;if(!le){let ee;for(ee=ae.length;ee>0;ee--){const fe=ae.charCodeAt(ee-1);if(fe===47||fe===92)break}le=ae.substr(ee)}const se=G.indexOf(le);return se!==-1?$[se]:null};X.basenames=G,X.patterns=$,X.allBasenames=G;const ie=W.filter(ae=>!ae.basenames);return ie.push(X),ie}}),define(be[100],Ee([1,0,12,145,23,8,2]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(v="",_=!1){if(this.value=v,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=_.isTrusted??void 0,this.supportThemeIcons=_.supportThemeIcons??!1,this.supportHtml=_.supportHtml??!1)}appendText(v,_=0){return this.value+=b(this.supportThemeIcons?(0,t.escapeIcons)(v):v).replace(/([ \t]+)/g,(E,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,_){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}appendLink(v,_,E){return this.value+="[",this.value+=this._escape(_,"]"),this.value+="](",this.value+=this._escape(String(v),")"),E&&(this.value+=` "${this._escape(this._escape(E,'"'),")")}"`),this.value+=")",this}_escape(v,_){const E=new RegExp((0,T.escapeRegExpCharacters)(_),"g");return v.replace(E,(l,d)=>v.charAt(d-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=y;function A(u){return N(u)?!u.value:Array.isArray(u)?u.every(A):!0}e.isEmptyMarkdownString=A;function N(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function R(u,v){return u===v?!0:!u||!v?!1:u.value===v.value&&u.isTrusted===v.isTrusted&&u.supportThemeIcons===v.supportThemeIcons&&u.supportHtml===v.supportHtml&&(u.baseUri===v.baseUri||!!u.baseUri&&!!v.baseUri&&(0,I.isEqual)(D.URI.from(u.baseUri),D.URI.from(v.baseUri)))}e.markdownStringEqual=R;function b(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function C(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=C;function g(u){const v=[],_=u.split("|").map(l=>l.trim());u=_[0];const E=_[1];if(E){const l=/height=(\d+)/.exec(E),d=/width=(\d+)/.exec(E),m=l?l[1]:"",a=d?d[1]:"",S=isFinite(parseInt(a)),o=isFinite(parseInt(m));S&&v.push(`width="${a}"`),o&&v.push(`height="${m}"`)}return{href:u,dimensions:v}}e.parseHrefAndDimensions=g}),define(be[101],Ee([1,0,30,10,9,13,23,8,2]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(i,s,n){if(typeof i=="string"&&(i=y.URI.file(i)),n){const h=n.getWorkspaceFolder(i);if(h){const c=n.getWorkspace().folders.length>1;let w;if((0,D.isEqual)(h.uri,i)?w="":w=(0,D.relativePath)(h.uri,i),c){const P=h.name?h.name:(0,D.basename)(h.uri);w=w?P+" \u2022 "+w:P}return w}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,I.normalize)(R(i.fsPath));let r=(0,I.normalize)(i.fsPath);return!T.isWindows&&s?.userHome&&(r=C(r,s.userHome.fsPath)),r}e.getPathLabel=A;function N(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const s=(0,D.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,f.isRootOrDriveLetter)(s)?R(s):s}e.getBaseLabel=N;function R(i,s){return(0,f.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=R;let b=Object.create(null);function C(i,s){if(T.isWindows||!i||!s)return i;let n=b.original===s?b.normalized:void 0;return n||(n=`${(0,k.rtrim)(s,I.posix.sep)}${I.posix.sep}`,b={original:s,normalized:n}),(T.isLinux?i.startsWith(n):(0,k.startsWithIgnoreCase)(i,n))&&(i=`~/${i.substr(n.length)}`),i}e.tildify=C;function g(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=g;const u="\u2026",v="\\\\",_="~";function E(i,s=I.sep){const n=new Array(i.length);let r=!1;for(let h=0;h<i.length;h++){let c=i[h];if(c===""){n[h]=`.${s}`;continue}if(!c){n[h]=c;continue}r=!0;let w="";c.indexOf(v)===0?(w=c.substr(0,c.indexOf(v)+v.length),c=c.substr(c.indexOf(v)+v.length)):c.indexOf(s)===0?(w=c.substr(0,c.indexOf(s)+s.length),c=c.substr(c.indexOf(s)+s.length)):c.indexOf(_)===0&&(w=c.substr(0,c.indexOf(_)+_.length),c=c.substr(c.indexOf(_)+_.length));const P=c.split(s);for(let L=1;r&&L<=P.length;L++)for(let M=P.length-L;r&&M>=0;M--){r=!1;let p=P.slice(M,M+L).join(s);for(let U=0;!r&&U<i.length;U++)if(U!==h&&i[U]&&i[U].indexOf(p)>-1){const B=M+L===P.length,H=M>0&&i[U].indexOf(s)>-1?s+p:p,re=i[U].endsWith(H);r=!B||re}if(!r){let U="";(P[0].endsWith(":")||w!=="")&&(M===1&&(M=0,L++,p=P[0]+s+p),M>0&&(U=P[0]+s),U=w+U),M>0&&(U=U+u+s),U=U+p,M+L<P.length&&(U=U+s+u),n[h]=U}}r&&(n[h]=c)}return n}e.shorten=E;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function d(i,s=Object.create(null)){const n=[];let r=!1,h="";for(const c of i)if(c==="$"||r&&c==="{")h&&n.push({value:h,type:l.TEXT}),h="",r=!0;else if(c==="}"&&r){const w=s[h];if(typeof w=="string")w.length&&n.push({value:w,type:l.VARIABLE});else if(w){const P=n[n.length-1];(!P||P.type!==l.SEPARATOR)&&n.push({value:w.label,type:l.SEPARATOR})}h="",r=!1}else h+=c;return h&&!r&&n.push({value:h,type:l.TEXT}),n.filter((c,w)=>{if(c.type===l.SEPARATOR){const P=n[w-1],L=n[w+1];return[P,L].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=d;function m(i,s){return T.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function a(i,s){return T.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,n=>n==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function o(i){const s=i.indexOf("/")!==-1?I.posix:I.win32,n=s.basename(i),r=s.dirname(i);return n.length?{name:n,parentPath:r}:{name:r,parentPath:""}}e.splitName=o}),define(be[102],Ee([1,0,2]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(N){return N.toJSON()}class I{constructor(R){this._uriTransformer=R}transformIncoming(R){const b=this._uriTransformer.transformIncoming(R);return b===R?R:t(f.URI.from(b))}transformOutgoing(R){const b=this._uriTransformer.transformOutgoing(R);return b===R?R:t(f.URI.from(b))}transformOutgoingURI(R){const b=this._uriTransformer.transformOutgoing(R);return b===R?R:f.URI.from(b)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function T(N,R,b){if(!N||b>200)return null;if(typeof N=="object"){if(N instanceof f.URI)return R.transformOutgoing(N);for(let C in N)if(Object.hasOwnProperty.call(N,C)){const g=T(N[C],R,b+1);g!==null&&(N[C]=g)}}return null}function D(N,R){const b=T(N,R,0);return b===null?N:b}e.transformOutgoingURIs=D;function k(N,R,b,C){if(!N||C>200)return null;if(typeof N=="object"){if(N.$mid===1)return b?f.URI.revive(R.transformIncoming(N)):R.transformIncoming(N);for(let g in N)if(Object.hasOwnProperty.call(N,g)){const u=k(N[g],R,b,C+1);u!==null&&(N[g]=u)}}return null}function y(N,R){const b=k(N,R,!1,0);return b===null?N:b}e.transformIncomingURIs=y;function A(N,R){const b=k(N,R,!0,0);return b===null?N:b}e.transformAndReviveIncomingURIs=A}),define(be[32],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(y){return f.test(y)}e.isUUID=t;const I=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let A=0;A<y.length;A++)y[A]=Math.floor(Math.random()*256);return y};function k(){D(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let y=0,A="";return A+=T[I[y++]],A+=T[I[y++]],A+=T[I[y++]],A+=T[I[y++]],A+="-",A+=T[I[y++]],A+=T[I[y++]],A+="-",A+=T[I[y++]],A+=T[I[y++]],A+="-",A+=T[I[y++]],A+=T[I[y++]],A+="-",A+=T[I[y++]],A+=T[I[y++]],A+=T[I[y++]],A+=T[I[y++]],A+=T[I[y++]],A+=T[I[y++]],A}e.generateUuid=k}),define(be[146],Ee([1,0,103]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new f.StringDecoder(T),this.remaining=null}write(T){const D=[],k=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(k.length<1)return D;let y=0,A,N=y;for(;N<k.length;)if(A=k.charCodeAt(N),A===13||A===10){if(D.push(k.substring(y,N)),N++,N<k.length){const R=A;A=k.charCodeAt(N),(R===13&&A===10||R===10&&A===13)&&N++}y=N}else N++;return this.remaining=y<k.length?k.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=t}),define(be[29],Ee([1,0,59,60,291,15,30,78,9,13,23,2]),function(J,e,f,t,I,T,D,k,y,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function C(B,H=b.UNLINK){if((0,D.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return H===b.UNLINK?u(B):g(B)}async function g(B){try{const H=(0,D.randomPath)((0,t.tmpdir)());try{await f.promises.rename(B,H)}catch{return u(B)}u(H).catch(re=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function u(B){return(0,I.promisify)(f.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function v(B){if((0,D.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function _(B,H){return d(await(H?E(B):(0,I.promisify)(f.readdir)(B)))}async function E(B){try{return await(0,I.promisify)(f.readdir)(B,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const H=[],re=await _(B);for(const W of re){let F=!1,q=!1,G=!1;try{const $=await e.Promises.lstat((0,y.join)(B,W));F=$.isFile(),q=$.isDirectory(),G=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}H.push({name:W,isFile:()=>F,isDirectory:()=>q,isSymbolicLink:()=>G})}return H}function l(B){return d(f.readdirSync(B))}e.readdirSync=l;function d(B){return B.map(H=>typeof H=="string"?A.isMacintosh?(0,k.normalizeNFC)(H):H:(H.name=A.isMacintosh?(0,k.normalizeNFC)(H.name):H.name,H))}async function m(B){const H=await _(B),re=[];for(const W of H)await S.existsDirectory((0,y.join)(B,W))&&re.push(W);return re}function a(B,H=1e3){return new Promise(re=>{let W=!1;const F=setInterval(()=>{W||(W=!0,f.access(B,q=>{W=!1,q&&(clearInterval(F),re(void 0))}))},H)})}e.whenDeleted=a;var S;(function(B){async function H(F){let q;try{if(q=await e.Promises.lstat(F),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(A.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw $}throw G}}B.stat=H;async function re(F){try{const{stat:q,symbolicLink:G}=await B.stat(F);return q.isFile()&&G?.dangling!==!0}catch{}return!1}B.existsFile=re;async function W(F){try{const{stat:q,symbolicLink:G}=await B.stat(F);return q.isDirectory()&&G?.dangling!==!0}catch{}return!1}B.existsDirectory=W})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new T.ResourceQueue;function i(B,H,re){return o.queueFor(R.URI.file(B),N.extUriBiasedIgnorePathCase).queue(()=>{const W=h(re);return new Promise((F,q)=>n(B,H,W,G=>G?q(G):F()))})}let s=!0;function n(B,H,re,W){if(!s)return f.writeFile(B,H,{mode:re.mode,flag:re.flag},W);f.open(B,re.flag,re.mode,(F,q)=>{if(F)return W(F);f.writeFile(q,H,G=>{if(G)return f.close(q,()=>W(G));f.fdatasync(q,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),s=!1),f.close(q,X=>W(X))))})})}function r(B,H,re){const W=h(re);if(!s)return f.writeFileSync(B,H,{mode:W.mode,flag:W.flag});const F=f.openSync(B,W.flag,W.mode);try{f.writeFileSync(F,H);try{f.fdatasyncSync(F)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),s=!1}}finally{f.closeSync(F)}}e.writeFileSync=r;function h(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function c(B,H){if(B!==H)try{await e.Promises.rename(B,H)}catch(re){if(B.toLowerCase()!==H.toLowerCase()&&re.code==="EXDEV"||B.endsWith("."))await w(B,H,{preserveSymlinks:!1}),await C(B,b.MOVE);else throw re}}async function w(B,H,re){return L(B,H,{root:{source:B,target:H},options:re,handledSourcePaths:new Set})}const P=511;async function L(B,H,re){if(re.handledSourcePaths.has(B))return;re.handledSourcePaths.add(B);const{stat:W,symbolicLink:F}=await S.stat(B);if(F){if(re.options.preserveSymlinks)try{return await U(B,H,re)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(F.dangling)return}return W.isDirectory()?M(B,H,W.mode&P,re):p(B,H,W.mode&P)}async function M(B,H,re,W){await e.Promises.mkdir(H,{recursive:!0,mode:re});const F=await _(B);for(const q of F)await L((0,y.join)(B,q),(0,y.join)(H,q),W)}async function p(B,H,re){await e.Promises.copyFile(B,H),await e.Promises.chmod(H,re)}async function U(B,H,re){let W=await e.Promises.readlink(B);(0,D.isEqualOrParent)(W,re.root.source,!A.isLinux)&&(W=(0,y.join)(re.root.target,W.substr(re.root.source.length+1))),await e.Promises.symlink(W,H)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(B,H,re,W,F)=>new Promise((q,G)=>{f.read(B,H,re,W,F,($,X,ie)=>$?G($):q({bytesRead:X,buffer:ie}))})}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(B,H,re,W,F)=>new Promise((q,G)=>{f.write(B,H,re,W,F,($,X,ie)=>$?G($):q({bytesWritten:X,buffer:ie}))})}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return _}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return C}get move(){return c}get copy(){return w}}}),define(be[104],Ee([1,0,59,9,13,8,29]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(b){if(I.isLinux)return b;const C=(0,t.dirname)(b);if(b===C)return b;const g=((0,t.basename)(b)||b).toLowerCase();try{const v=(0,D.readdirSync)(C).filter(_=>_.toLowerCase()===g);if(v.length===1){const _=k(C);if(_)return(0,t.join)(_,v[0])}else if(v.length>1){const _=v.indexOf(g);if(_>=0){const E=k(C);if(E)return(0,t.join)(E,v[_])}}}catch{}return null}e.realcaseSync=k;async function y(b){if(I.isLinux)return b;const C=(0,t.dirname)(b);if(b===C)return b;const g=((0,t.basename)(b)||b).toLowerCase();try{const v=(await D.Promises.readdir(C)).filter(_=>_.toLowerCase()===g);if(v.length===1){const _=await y(C);if(_)return(0,t.join)(_,v[0])}else if(v.length>1){const _=v.indexOf(g);if(_>=0){const E=await y(C);if(E)return(0,t.join)(E,v[_])}}}catch{}return null}e.realcase=y;async function A(b){try{return await D.Promises.realpath(b)}catch{const g=R(b);return await D.Promises.access(g,f.constants.R_OK),g}}e.realpath=A;function N(b){try{return f.realpathSync(b)}catch{const g=R(b);return f.accessSync(g,f.constants.R_OK),g}}e.realpathSync=N;function R(b){return(0,T.rtrim)((0,t.normalize)(b),t.sep)}});var $e=this&&this.__decorate||function(J,e,f,t){var I=arguments.length,T=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,f):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,f,t);else for(var k=J.length-1;k>=0;k--)(D=J[k])&&(T=(I<3?D(T):I>3?D(e,f,T):D(e,f))||T);return I>3&&T&&Object.defineProperty(e,f,T),T};define(be[105],Ee([1,0,18,15,22,21,56,12,3,6,58,8,14]),function(J,e,f,t,I,T,D,k,y,A,N,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var C;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(C=e.RequestType||(e.RequestType={}));function g(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function v(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var _;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(_||(_={}));class E{constructor(G){this.buffer=G,this.pos=0}read(G){const $=this.buffer.slice(this.pos,this.pos+G);return this.pos+=$.byteLength,$}}class l{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(G){this.buffers.push(G)}}var d;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(d||(d={}));function m(q){const G=I.VSBuffer.alloc(4);return G.writeUInt32BE(q,0),G}function a(q){return q.read(4).readUInt32BE(0)}function S(q){const G=I.VSBuffer.alloc(1);return G.writeUInt8(q,0),G}const o={Undefined:S(d.Undefined),String:S(d.String),Buffer:S(d.Buffer),VSBuffer:S(d.VSBuffer),Array:S(d.Array),Object:S(d.Object)},i=typeof Buffer!="undefined";function s(q,G){if(typeof G=="undefined")q.write(o.Undefined);else if(typeof G=="string"){const $=I.VSBuffer.fromString(G);q.write(o.String),q.write(m($.byteLength)),q.write($)}else if(i&&Buffer.isBuffer(G)){const $=I.VSBuffer.wrap(G);q.write(o.Buffer),q.write(m($.byteLength)),q.write($)}else if(G instanceof I.VSBuffer)q.write(o.VSBuffer),q.write(m(G.byteLength)),q.write(G);else if(Array.isArray(G)){q.write(o.Array),q.write(m(G.length));for(const $ of G)s(q,$)}else{const $=I.VSBuffer.fromString(JSON.stringify(G));q.write(o.Object),q.write(m($.byteLength)),q.write($)}}function n(q){switch(q.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return q.read(a(q)).toString();case d.Buffer:return q.read(a(q)).buffer;case d.VSBuffer:return q.read(a(q));case d.Array:{const $=a(q),X=[];for(let ie=0;ie<$;ie++)X.push(n(q));return X}case d.Object:return JSON.parse(q.read(a(q)).toString())}}class r{constructor(G,$,X=null,ie=1e3){this.protocol=G,this.ctx=$,this.logger=X,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(G,$){this.channels.set(G,$),setTimeout(()=>this.flushPendingRequests(G),0)}sendResponse(G){switch(G.type){case 200:{const $=this.send([G.type]);this.logger?.logOutgoing($,0,1,v(G.type));return}case 201:case 202:case 204:case 203:{const $=this.send([G.type,G.id],G.data);this.logger?.logOutgoing($,G.id,1,v(G.type),G.data);return}}}send(G,$=void 0){const X=new l;return s(X,G),s(X,$),this.sendBuffer(X.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onRawMessage(G){const $=new E(G),X=n($),ie=n($),ae=X[0];switch(ae){case 100:return this.logger?.logIncoming(G.byteLength,X[1],1,`${g(ae)}: ${X[2]}.${X[3]}`,ie),this.onPromise({type:ae,id:X[1],channelName:X[2],name:X[3],arg:ie});case 102:return this.logger?.logIncoming(G.byteLength,X[1],1,`${g(ae)}: ${X[2]}.${X[3]}`,ie),this.onEventListen({type:ae,id:X[1],channelName:X[2],name:X[3],arg:ie});case 101:return this.logger?.logIncoming(G.byteLength,X[1],1,`${g(ae)}`),this.disposeActiveRequest({type:ae,id:X[1]});case 103:return this.logger?.logIncoming(G.byteLength,X[1],1,`${g(ae)}`),this.disposeActiveRequest({type:ae,id:X[1]})}}onPromise(G){const $=this.channels.get(G.channelName);if(!$){this.collectPendingRequest(G);return}const X=new T.CancellationTokenSource;let ie;try{ie=$.call(this.ctx,G.name,G.arg,X.token)}catch(se){ie=Promise.reject(se)}const ae=G.id;ie.then(se=>{this.sendResponse({id:ae,data:se,type:201}),this.activeRequests.delete(G.id)},se=>{se instanceof Error?this.sendResponse({id:ae,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split?se.stack.split(`
`):se.stack:void 0},type:202}):this.sendResponse({id:ae,data:se,type:203}),this.activeRequests.delete(G.id)});const le=(0,A.toDisposable)(()=>X.cancel());this.activeRequests.set(G.id,le)}onEventListen(G){const $=this.channels.get(G.channelName);if(!$){this.collectPendingRequest(G);return}const X=G.id,ae=$.listen(this.ctx,G.name,G.arg)(le=>this.sendResponse({id:X,data:le,type:204}));this.activeRequests.set(G.id,ae)}disposeActiveRequest(G){const $=this.activeRequests.get(G.id);$&&($.dispose(),this.activeRequests.delete(G.id))}collectPendingRequest(G){let $=this.pendingRequests.get(G.channelName);$||($=[],this.pendingRequests.set(G.channelName,$));const X=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.sendResponse({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:G,timeoutTimer:X})}flushPendingRequests(G){const $=this.pendingRequests.get(G);if($){for(const X of $)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(G)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,A.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=r;var h;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class c{constructor(G,$=null){this.protocol=G,this.isDisposed=!1,this.state=_.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=$}getChannel(G){const $=this;return{call(X,ie,ae){return $.isDisposed?Promise.reject(k.canceled()):$.requestPromise(G,X,ie,ae)},listen(X,ie){return $.isDisposed?y.Event.None:$.requestEvent(G,X,ie)}}}requestPromise(G,$,X,ie=T.CancellationToken.None){const ae=this.lastRequestId++,se={id:ae,type:100,channelName:G,name:$,arg:X};if(ie.isCancellationRequested)return Promise.reject(k.canceled());let ee;return new Promise((ge,ye)=>{if(ie.isCancellationRequested)return ye(k.canceled());const Ne=()=>{const de=Q=>{switch(Q.type){case 201:this.handlers.delete(ae),ge(Q.data);break;case 202:{this.handlers.delete(ae);const ne=new Error(Q.data.message);ne.stack=Q.data.stack,ne.name=Q.data.name,ye(ne);break}case 203:this.handlers.delete(ae),ye(Q.data);break}};this.handlers.set(ae,de),this.sendRequest(se)};let Se=null;this.state===_.Idle?Ne():(Se=(0,t.createCancelablePromise)(de=>this.whenInitialized()),Se.then(()=>{Se=null,Ne()}));const _e=()=>{Se?(Se.cancel(),Se=null):this.sendRequest({id:ae,type:101}),ye(k.canceled())},Ie=ie.onCancellationRequested(_e);ee=(0,A.combinedDisposable)((0,A.toDisposable)(_e),Ie),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(G,$,X){const ie=this.lastRequestId++,le={id:ie,type:102,channelName:G,name:$,arg:X};let se=null;const ee=new y.Emitter({onFirstListenerAdd:()=>{se=(0,t.createCancelablePromise)(ge=>this.whenInitialized()),se.then(()=>{se=null,this.activeRequests.add(ee),this.sendRequest(le)})},onLastListenerRemove:()=>{se?(se.cancel(),se=null):(this.activeRequests.delete(ee),this.sendRequest({id:ie,type:103}))}}),fe=ge=>ee.fire(ge.data);return this.handlers.set(ie,fe),ee.event}sendRequest(G){switch(G.type){case 100:case 102:{const $=this.send([G.type,G.id,G.channelName,G.name],G.arg);this.logger&&this.logger.logOutgoing($,G.id,0,`${g(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const $=this.send([G.type,G.id]);this.logger&&this.logger.logOutgoing($,G.id,0,g(G.type));return}}}send(G,$=void 0){const X=new l;return s(X,G),s(X,$),this.sendBuffer(X.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onBuffer(G){const $=new E(G),X=n($),ie=n($),ae=X[0];switch(ae){case 200:return this.logger&&this.logger.logIncoming(G.byteLength,0,0,v(ae)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(G.byteLength,X[1],0,v(ae),ie),this.onResponse({type:X[0],id:X[1],data:ie})}}onResponse(G){if(G.type===200){this.state=_.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(G.id);$&&$(G)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===_.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,A.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}$e([D.memoize],c.prototype,"onDidInitializePromise",null),e.ChannelClient=c;class w{constructor(G){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,G(({protocol:$,onDidClientDisconnect:X})=>{y.Event.once($.onMessage)(ae=>{const le=new E(ae),se=n(le),ee=new r($,se),fe=new c($);this.channels.forEach((ye,Ne)=>ee.registerChannel(Ne,ye));const ge={channelServer:ee,channelClient:fe,ctx:se};this._connections.add(ge),this._onDidAddConnection.fire(ge),X(()=>{ee.dispose(),fe.dispose(),this._connections.delete(ge),this._onDidRemoveConnection.fire(ge)})})})}get connections(){const G=[];return this._connections.forEach($=>G.push($)),G}getChannel(G,$){const X=this;return{call(ie,ae,le){let se;if((0,b.isFunction)($)){let fe=(0,f.getRandomElement)(X.connections.filter($));se=fe?Promise.resolve(fe):y.Event.toPromise(y.Event.filter(X.onDidAddConnection,$))}else se=$.routeCall(X,ie,ae);const ee=se.then(fe=>fe.channelClient.getChannel(G));return L(ee).call(ie,ae,le)},listen(ie,ae){if((0,b.isFunction)($))return X.getMulticastEvent(G,$,ie,ae);const le=$.routeEvent(X,ie,ae).then(se=>se.channelClient.getChannel(G));return L(le).listen(ie,ae)}}}getMulticastEvent(G,$,X,ie){const ae=this;let le=new A.DisposableStore;const se=new y.Emitter({onFirstListenerAdd:()=>{le=new A.DisposableStore;const ee=new y.EventMultiplexer,fe=new Map,ge=Ne=>{const _e=Ne.channelClient.getChannel(G).listen(X,ie),Ie=ee.add(_e);fe.set(Ne,Ie)},ye=Ne=>{const Se=fe.get(Ne);!Se||(Se.dispose(),fe.delete(Ne))};ae.connections.filter($).forEach(ge),y.Event.filter(ae.onDidAddConnection,$)(ge,void 0,le),ae.onDidRemoveConnection(ye,void 0,le),ee.event(se.fire,se,le),le.add(ee)},onLastListenerRemove:()=>{le.dispose()}});return se.event}registerChannel(G,$){this.channels.set(G,$),this._connections.forEach(X=>{X.channelServer.registerChannel(G,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class P{constructor(G,$,X=null){const ie=new l;s(ie,$),G.send(ie.buffer),this.channelClient=new c(G,X),this.channelServer=new r(G,$,X)}getChannel(G){return this.channelClient.getChannel(G)}registerChannel(G,$){this.channelServer.registerChannel(G,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function L(q){return{call(G,$,X){return q.then(ie=>ie.call(G,$,X))},listen(G,$){const X=new y.Relay;return q.then(ie=>X.input=ie.listen(G,$)),X.event}}}e.getDelayedChannel=L;function M(q){let G=!1;return{call($,X,ie){return G?q.call($,X,ie):(0,t.timeout)(0).then(()=>G=!0).then(()=>q.call($,X,ie))},listen($,X){if(G)return q.listen($,X);const ie=new y.Relay;return(0,t.timeout)(0).then(()=>G=!0).then(()=>ie.input=q.listen($,X)),ie.event}}}e.getNextTickChannel=M;class p{constructor(G){this.fn=G}routeCall(G){return this.route(G)}routeEvent(G){return this.route(G)}async route(G){for(const $ of G.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await y.Event.toPromise(G.onDidAddConnection),await this.route(G)}}e.StaticRouter=p;var U;(function(q){function G(ae,le){const se=ae,ee=le&&le.disableMarshalling,fe=new Map;for(const ge in se)X(ge)&&fe.set(ge,y.Event.buffer(se[ge],!0));return new class{listen(ge,ye,Ne){const Se=fe.get(ye);if(Se)return Se;if(ie(ye)){const _e=se[ye];if(typeof _e=="function")return _e.call(se,Ne)}throw new Error(`Event not found: ${ye}`)}call(ge,ye,Ne){const Se=se[ye];if(typeof Se=="function"){if(!ee&&Array.isArray(Ne))for(let _e=0;_e<Ne.length;_e++)Ne[_e]=(0,N.revive)(Ne[_e]);return Se.apply(se,Ne)}throw new Error(`Method not found: ${ye}`)}}}q.fromService=G;function $(ae,le){const se=le&&le.disableMarshalling;return new Proxy({},{get(ee,fe){if(typeof fe=="string")return le?.properties?.has(fe)?le.properties.get(fe):ie(fe)?function(ge){return ae.listen(fe,ge)}:X(fe)?ae.listen(fe):async function(...ge){let ye;le&&!(0,b.isUndefinedOrNull)(le.context)?ye=[le.context,...ge]:ye=ge;const Ne=await ae.call(fe,ye);return se?Ne:(0,N.revive)(Ne)};throw new Error(`Property not found: ${String(fe)}`)}})}q.toService=$;function X(ae){return ae[0]==="o"&&ae[1]==="n"&&R.isUpperAsciiLetter(ae.charCodeAt(2))}function ie(ae){return/^onDynamic/.test(ae)&&R.isUpperAsciiLetter(ae.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let G=q.toString();if(G!=="[object Object]")return G}return q}function re(q){return Array.isArray(q)?q.map(H):H(q)}function W(q,G,$,X,ie,ae,le){le=re(le);const se=B[ie],ee=se[X%se.length];let fe=[`%c[${q}]%c[${String(G).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(ae)?(fe=fe.concat(le),fe.push(")")):fe.push(le),console.log.apply(console,fe)}e.logWithColors=W;class F{constructor(G,$){this._outgoingPrefix=G,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(G,$,X,ie,ae){this._totalOutgoing+=G,W(this._outgoingPrefix,this._totalOutgoing,G,$,X,ie,ae)}logIncoming(G,$,X,ie,ae){this._totalIncoming+=G,W(this._incomingPrefix,this._totalIncoming,G,$,X,ie,ae)}}e.IPCLogger=F}),define(be[106],Ee([1,0,22,3,6,105]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let n=0;function r(c,w){if(!s.has(c)){const P=String(++n);s.set(c,P)}return s.get(c)}function h(c,w,P,L){if(!i.enableDiagnostics)return;const M=r(c,w);if(L instanceof f.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const p=f.VSBuffer.alloc(L.byteLength);p.set(L),i.records.push({timestamp:Date.now(),id:M,label:w,type:P,buff:p})}else i.records.push({timestamp:Date.now(),id:M,label:w,type:P,data:L})}i.traceSocketEvent=h})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function N(){return A||(A=f.VSBuffer.alloc(0)),A}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,n){if(s===0)return N();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const w=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=s),w}if(this._chunks[0].byteLength>s){const w=this._chunks[0].slice(0,s);return n&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),w}let r=f.VSBuffer.alloc(s),h=0,c=0;for(;s>0;){const w=this._chunks[c];if(w.byteLength>s){const P=w.slice(0,s);r.set(P,h),h+=s,n&&(this._chunks[c]=w.slice(s),this._totalLength-=s),s-=s}else r.set(w,h),h+=w.byteLength,n?(this._chunks.shift(),this._totalLength-=w.byteLength):c++,s-=w.byteLength}return r}}e.ChunkStream=R;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(b||(b={}));function C(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(s,n,r,h){this.type=s,this.id=n,this.ack=r,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends I.Disposable{constructor(s){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const r=this._state.messageType,h=this._state.id,c=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new u(r,h,c,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=f.VSBuffer.alloc(13);n.writeUInt8(s.type,0),n.writeUInt32BE(s.id,1),n.writeUInt32BE(s.ack,5),n.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(n,s.data)}_bufferAdd(s,n){const r=this._totalLength===0;return this._data.push(s,n),this._totalLength+=s.byteLength+n.byteLength,r}_bufferTake(){const s=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,n){this._bufferAdd(s,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class E extends I.Disposable{constructor(s){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new u(1,0,0,s))}}e.Protocol=E;class l extends T.IPCClient{constructor(s,n,r=null){super(s,n,r);this.protocol=s}static fromSocket(s,n){return new l(new E(s),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=l;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class m{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],n=0,r=this._first;for(;r;)s[n++]=r.data,r=r.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const n=new m(s);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class S{constructor(){this.lastRuns=[];const s=Date.now();for(let n=0;n<S._HISTORY_LENGTH;n++)this.lastRuns[n]=s-1e3*n;setInterval(()=>{for(let n=S._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const s=Date.now(),n=(1+S._HISTORY_LENGTH)*1e3;let r=0;for(let h=0;h<S._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=n&&r++;return 1-r/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class o{constructor(s,n=null,r=S.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=r,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),n&&this._socketReader.acceptChunk(n)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new u(5,0,0,N());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new u(7,0,0,N());this._socketWriter.write(s)}sendResume(){const s=new u(8,0,0,N());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,n){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.push(this._socket.onClose(r=>this._onSocketClose.fire(r))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new u(3,0,this._incomingAckId,N());this._socketWriter.write(s);const n=this._outgoingUnackMsg.toArray();for(let r=0,h=n.length;r<h;r++)this._socketWriter.write(n[r]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new u(6,0,0,N())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let r=0,h=n.length;r<h;r++)this._socketWriter.write(n[r]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const r=new u(1,n,this._incomingAckId,s);this._outgoingUnackMsg.push(r),this._isReconnecting||(this._socketWriter.write(r),this._recvAckCheck())}sendControl(s){const n=new u(2,0,0,s);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),n=Date.now()-s.writtenTime,r=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&r>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const c=Math.max(2e4-n,2e4-r,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},c)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new u(3,0,this._incomingAckId,N());this._socketWriter.write(s)}}e.PersistentProtocol=o}),define(be[107],Ee([1,0,97]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const y=(0,f.toUint8)(k);this._defaultValue=y,this._asciiMap=t._createAsciiMap(y),this._map=new Map}static _createAsciiMap(k){const y=new Uint8Array(256);for(let A=0;A<256;A++)y[A]=k;return y}set(k,y){const A=(0,f.toUint8)(y);k>=0&&k<256?this._asciiMap[k]=A:this._map.set(k,A)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(I||(I={}));class T{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(be[48],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,T){this.lineNumber=I,this.column=T}with(I=this.lineNumber,T=this.column){return I===this.lineNumber&&T===this.column?this:new f(I,T)}delta(I=0,T=0){return this.with(this.lineNumber+I,this.column+T)}equals(I){return f.equals(this,I)}static equals(I,T){return!I&&!T?!0:!!I&&!!T&&I.lineNumber===T.lineNumber&&I.column===T.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<T.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<=T.column}static compare(I,T){const D=I.lineNumber|0,k=T.lineNumber|0;if(D===k){const y=I.column|0,A=T.column|0;return y-A}return D-k}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(be[35],Ee([1,0,48]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(T,D,k,y){T>k||T===k&&D>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=T,this.endColumn=D):(this.startLineNumber=T,this.startColumn=D,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return t.containsPosition(this,T)}static containsPosition(T,D){return!(D.lineNumber<T.startLineNumber||D.lineNumber>T.endLineNumber||D.lineNumber===T.startLineNumber&&D.column<T.startColumn||D.lineNumber===T.endLineNumber&&D.column>T.endColumn)}static strictContainsPosition(T,D){return!(D.lineNumber<T.startLineNumber||D.lineNumber>T.endLineNumber||D.lineNumber===T.startLineNumber&&D.column<=T.startColumn||D.lineNumber===T.endLineNumber&&D.column>=T.endColumn)}containsRange(T){return t.containsRange(this,T)}static containsRange(T,D){return!(D.startLineNumber<T.startLineNumber||D.endLineNumber<T.startLineNumber||D.startLineNumber>T.endLineNumber||D.endLineNumber>T.endLineNumber||D.startLineNumber===T.startLineNumber&&D.startColumn<T.startColumn||D.endLineNumber===T.endLineNumber&&D.endColumn>T.endColumn)}strictContainsRange(T){return t.strictContainsRange(this,T)}static strictContainsRange(T,D){return!(D.startLineNumber<T.startLineNumber||D.endLineNumber<T.startLineNumber||D.startLineNumber>T.endLineNumber||D.endLineNumber>T.endLineNumber||D.startLineNumber===T.startLineNumber&&D.startColumn<=T.startColumn||D.endLineNumber===T.endLineNumber&&D.endColumn>=T.endColumn)}plusRange(T){return t.plusRange(this,T)}static plusRange(T,D){let k,y,A,N;return D.startLineNumber<T.startLineNumber?(k=D.startLineNumber,y=D.startColumn):D.startLineNumber===T.startLineNumber?(k=D.startLineNumber,y=Math.min(D.startColumn,T.startColumn)):(k=T.startLineNumber,y=T.startColumn),D.endLineNumber>T.endLineNumber?(A=D.endLineNumber,N=D.endColumn):D.endLineNumber===T.endLineNumber?(A=D.endLineNumber,N=Math.max(D.endColumn,T.endColumn)):(A=T.endLineNumber,N=T.endColumn),new t(k,y,A,N)}intersectRanges(T){return t.intersectRanges(this,T)}static intersectRanges(T,D){let k=T.startLineNumber,y=T.startColumn,A=T.endLineNumber,N=T.endColumn,R=D.startLineNumber,b=D.startColumn,C=D.endLineNumber,g=D.endColumn;return k<R?(k=R,y=b):k===R&&(y=Math.max(y,b)),A>C?(A=C,N=g):A===C&&(N=Math.min(N,g)),k>A||k===A&&y>N?null:new t(k,y,A,N)}equalsRange(T){return t.equalsRange(this,T)}static equalsRange(T,D){return!!T&&!!D&&T.startLineNumber===D.startLineNumber&&T.startColumn===D.startColumn&&T.endLineNumber===D.endLineNumber&&T.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(T){return new f.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(T){return new f.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,D){return new t(this.startLineNumber,this.startColumn,T,D)}setStartPosition(T,D){return new t(T,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(T){return new t(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,D=T){return new t(T.lineNumber,T.column,D.lineNumber,D.column)}static lift(T){return T?new t(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,D){return!(T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<D.startColumn||D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<T.startColumn)}static areIntersecting(T,D){return!(T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<=D.startColumn||D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,D){if(T&&D){const A=T.startLineNumber|0,N=D.startLineNumber|0;if(A===N){const R=T.startColumn|0,b=D.startColumn|0;if(R===b){const C=T.endLineNumber|0,g=D.endLineNumber|0;if(C===g){const u=T.endColumn|0,v=D.endColumn|0;return u-v}return C-g}return R-b}return A-N}return(T?1:0)-(D?1:0)}static compareRangesUsingEnds(T,D){return T.endLineNumber===D.endLineNumber?T.endColumn===D.endColumn?T.startLineNumber===D.startLineNumber?T.startColumn-D.startColumn:T.startLineNumber-D.startLineNumber:T.endColumn-D.endColumn:T.endLineNumber-D.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.Range=t}),define(be[147],Ee([1,0,48,35]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class T extends t.Range{constructor(k,y,A,N){super(k,y,A,N);this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=A,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,y):new T(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,y){return this.getDirection()===0?new T(k,y,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new T(k.lineNumber,k.column,y.lineNumber,y.column)}static fromRange(k,y){return y===0?new T(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new T(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let A=0,N=k.length;A<N;A++)if(!this.selectionsEqual(k[A],y[A]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,A,N,R){return R===0?new T(k,y,A,N):new T(A,N,k,y)}}e.Selection=T}),define(be[148],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1,independentColorPoolPerBracketType:!1}}}),define(be[149],Ee([1,0,107]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(k){super(0);for(let y=0,A=k.length;y<A;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function T(D){const k={};return y=>(k.hasOwnProperty(y)||(k[y]=D(y)),k[y])}e.getMapForWordSeparators=T(D=>new I(D))}),define(be[108],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(k=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)k.indexOf(A)>=0||(y+="\\"+A);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=f();function t(k){let y=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)y=k;else{let A="g";k.ignoreCase&&(A+="i"),k.multiline&&(A+="m"),k.unicode&&(A+="u"),y=new RegExp(k.source,A)}return y.lastIndex=0,y}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,y,A,N,R=I){if(A.length>R.maxLen){let v=k-R.maxLen/2;return v<0?v=0:N+=v,A=A.substring(v,k+R.maxLen/2),T(k,y,A,N,R)}const b=Date.now(),C=k-1-N;let g=-1,u=null;for(let v=1;!(Date.now()-b>=R.timeBudget);v++){const _=C-R.windowSize*v;y.lastIndex=Math.max(0,_);const E=D(y,A,C,g);if(!E&&u||(u=E,_<=0))break;g=_}if(u){const v={word:u[0],startColumn:N+1+u.index,endColumn:N+1+u.index+u[0].length};return y.lastIndex=0,v}return null}e.getWordAtText=T;function D(k,y,A,N){let R;for(;R=k.exec(y);){const b=R.index||0;if(b<=A&&k.lastIndex>=A)return R;if(N>0&&b>N)return null}return null}}),define(be[109],Ee([1,0,34,9]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(T,D,k,y,A){if(Array.isArray(T)){let N=0;for(const R of T){const b=I(R,D,k,y,A);if(b===10)return b;b>N&&(N=b)}return N}else{if(typeof T=="string")return y?T==="*"?5:T===k?10:0:0;if(T){const{language:N,pattern:R,scheme:b,hasAccessToAllModels:C,notebookType:g}=T;if(!y&&!C)return 0;let u=0;if(b)if(b===D.scheme)u=10;else if(b==="*")u=5;else return 0;if(N)if(N===k)u=10;else if(N==="*")u=Math.max(u,5);else return 0;if(g)if(g===A)u=10;else if(g==="*")u=Math.max(u,5);else return 0;if(R){let v;if(typeof R=="string"?v=R:v={...R,base:(0,t.normalize)(R.base)},v===D.fsPath||(0,f.match)(v,D.fsPath))u=10;else return 0}return u}else return 0}}e.score=I}),define(be[150],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let y=0,A=k.notIn.length;y<A;y++)switch(k.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,y){if(k.getTokenCount()===0)return!0;const A=k.findTokenIndexAtOffset(y-2),N=k.getStandardTokenType(A);return this.isOK(N)}_findNeutralCharacterInRange(k,y){for(let A=k;A<=y;A++){const N=String.fromCharCode(A);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)T(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),T(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),T(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),T(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&T(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function T(D,k,y){D.has(k)?D.get(k).push(y):D.set(k,[y])}}),define(be[151],Ee([1,0,107]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(g,u,v){const _=new Uint8Array(g*u);for(let E=0,l=g*u;E<l;E++)_[E]=v;this._data=_,this.rows=g,this.cols=u}get(g,u){return this._data[g*this.cols+u]}set(g,u,v){this._data[g*this.cols+u]=v}}e.Uint8Matrix=I;class T{constructor(g){let u=0,v=0;for(let E=0,l=g.length;E<l;E++){const[d,m,a]=g[E];m>u&&(u=m),d>v&&(v=d),a>v&&(v=a)}u++,v++;const _=new I(v,u,0);for(let E=0,l=g.length;E<l;E++){const[d,m,a]=g[E];_.set(d,m,a)}this._states=_,this._maxCharCode=u}nextState(g,u){return u<0||u>=this._maxCharCode?0:this._states.get(g,u)}}e.StateMachine=T;let D=null;function k(){return D===null&&(D=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let A=null;function N(){if(A===null){A=new f.CharacterClassifier(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<C.length;u++)A.set(C.charCodeAt(u),1);const g=".,;";for(let u=0;u<g.length;u++)A.set(g.charCodeAt(u),2)}return A}class R{static _createLink(g,u,v,_,E){let l=E-1;do{const d=u.charCodeAt(l);if(g.get(d)!==2)break;l--}while(l>_);if(_>0){const d=u.charCodeAt(_-1),m=u.charCodeAt(l);(d===40&&m===41||d===91&&m===93||d===123&&m===125)&&l--}return{range:{startLineNumber:v,startColumn:_+1,endLineNumber:v,endColumn:l+2},url:u.substring(_,l+1)}}static computeLinks(g,u=k()){const v=N(),_=[];for(let E=1,l=g.getLineCount();E<=l;E++){const d=g.getLineContent(E),m=d.length;let a=0,S=0,o=0,i=1,s=!1,n=!1,r=!1,h=!1;for(;a<m;){let c=!1;const w=d.charCodeAt(a);if(i===13){let P;switch(w){case 40:s=!0,P=0;break;case 41:P=s?0:1;break;case 91:r=!0,n=!0,P=0;break;case 93:r=!1,P=n?0:1;break;case 123:h=!0,P=0;break;case 125:P=h?0:1;break;case 39:P=o===34||o===96?0:1;break;case 34:P=o===39||o===96?0:1;break;case 96:P=o===39||o===34?0:1;break;case 42:P=o===42?1:0;break;case 124:P=o===124?1:0;break;case 32:P=r?0:1;break;default:P=v.get(w)}P===1&&(_.push(R._createLink(v,d,E,S,a)),c=!0)}else if(i===12){let P;w===91?(n=!0,P=0):P=v.get(w),P===1?c=!0:i=13}else i=u.nextState(i,w),i===0&&(c=!0);c&&(i=1,s=!1,n=!1,h=!1,S=a+1,o=w),a++}i===13&&_.push(R._createLink(v,d,E,S,m))}return _}}e.LinkComputer=R;function b(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:R.computeLinks(C)}e.computeLinks=b}),define(be[110],Ee([1,0,25]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(T=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class N{constructor(l,d){this._findMatchBrand=void 0,this.range=l,this.matches=d}}e.FindMatch=N;var R;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var b;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None"})(b=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class g{constructor(l,d,m,a,S,o){this.identifier=l,this.range=d,this.text=m,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=S,this._isTracked=o}}e.ValidAnnotatedEditOperation=g;class u{constructor(l,d,m){this.regex=l,this.wordSeparators=d,this.simpleSearch=m}}e.SearchData=u;class v{constructor(l,d,m){this.reverseEdits=l,this.changes=d,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=v;function _(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=_}),define(be[111],Ee([1,0,18,97]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,A){y=(0,t.toUint32)(y);const N=this.values,R=this.prefixSum,b=A.length;return b===0?!1:(this.values=new Uint32Array(N.length+b),this.values.set(N.subarray(0,y),0),this.values.set(N.subarray(y),y+b),this.values.set(A,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(R.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(y,A){return y=(0,t.toUint32)(y),A=(0,t.toUint32)(A),this.values[y]===A?!1:(this.values[y]=A,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,A){y=(0,t.toUint32)(y),A=(0,t.toUint32)(A);const N=this.values,R=this.prefixSum;if(y>=N.length)return!1;const b=N.length-y;return A>=b&&(A=b),A===0?!1:(this.values=new Uint32Array(N.length-A),this.values.set(N.subarray(0,y),0),this.values.set(N.subarray(y+A),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(R.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this._getPrefixSum(y))}_getPrefixSum(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),y>=this.values.length&&(y=this.values.length-1);for(let N=A;N<=y;N++)this.prefixSum[N]=this.prefixSum[N-1]+this.values[N];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let A=0,N=this.values.length-1,R=0,b=0,C=0;for(;A<=N;)if(R=A+(N-A)/2|0,b=this.prefixSum[R],C=b-this.values[R],y<C)N=R-1;else if(y>=b)A=R+1;else break;return new D(R,y-C)}}e.PrefixSumComputer=I;class T{constructor(y){this._values=y,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(y){return this._ensureValid(),y===0?0:this._prefixSum[y-1]}getIndexOf(y){this._ensureValid();const A=this._indexBySum[y],N=A>0?this._prefixSum[A-1]:0;return new D(A,y-N)}removeValues(y,A){this._values.splice(y,A),this._invalidate(y)}insertValues(y,A){this._values=(0,f.arrayInsert)(this._values,y,A),this._invalidate(y)}_invalidate(y){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,y-1)}_ensureValid(){if(!this._isValid){for(let y=this._validEndIndex+1,A=this._values.length;y<A;y++){const N=this._values[y],R=y>0?this._prefixSum[y-1]:0;this._prefixSum[y]=R+N;for(let b=0;b<N;b++)this._indexBySum[R+b]=y}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(y,A){this._values[y]!==A&&(this._values[y]=A,this._invalidate(y))}}e.ConstantTimePrefixSumComputer=T;class D{constructor(y,A){this.index=y,this.remainder=A,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=A}}e.PrefixSumIndexOfResult=D}),define(be[152],Ee([1,0,8,48,111]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,y,A,N){this._uri=k,this._lines=y,this._eol=A,this._versionId=N,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const y=k.changes;for(const A of y)this._acceptDeleteRange(A.range),this._acceptInsertText(new t.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,y=this._lines.length,A=new Uint32Array(y);for(let N=0;N<y;N++)A[N]=this._lines[N].length+k;this._lineStarts=new I.PrefixSumComputer(A)}}_setLineText(k,y){this._lines[k]=y,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,y){if(y.length===0)return;const A=(0,f.splitLines)(y);if(A.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+A[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}A[A.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+A[0]);const N=new Uint32Array(A.length-1);for(let R=1;R<A.length;R++)this._lines.splice(k.lineNumber+R-1,0,A[R]),N[R-1]=A[R].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,N)}}e.MirrorTextModel=T}),define(be[153],Ee([1,0,8,149,48,35,110]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(E,l,d,m){this.searchString=E,this.isRegex=l,this.matchCase=d,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=A(this.searchString):E=this.searchString.indexOf(`
`)>=0;let l=null;try{l=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!l)return null;let d=!this.isRegex&&!E;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new D.SearchData(l,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}e.SearchParams=y;function A(_){if(!_||_.length===0)return!1;for(let E=0,l=_.length;E<l;E++)if(_.charCodeAt(E)===92){if(E++,E>=l)break;const m=_.charCodeAt(E);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=A;function N(_,E,l){if(!l)return new D.FindMatch(_,null);const d=[];for(let m=0,a=E.length;m<a;m++)d[m]=E[m];return new D.FindMatch(_,d)}e.createFindMatch=N;class R{constructor(E){const l=[];let d=0;for(let m=0,a=E.length;m<a;m++)E.charCodeAt(m)===10&&(l[d++]=m);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(E){const l=this._lineFeedsOffsets;let d=0,m=l.length-1;if(m===-1||E<=l[0])return 0;for(;d<m;){const a=d+((m-d)/2>>0);l[a]>=E?m=a-1:l[a+1]>=E?(d=a,m=a):d=a+1}return d+1}}class b{static findMatches(E,l,d,m,a){const S=l.parseSearchRequest();return S?S.regex.multiline?this._doFindMatchesMultiline(E,d,new v(S.wordSeparators,S.regex),m,a):this._doFindMatchesLineByLine(E,d,S,m,a):[]}static _getMultilineMatchRange(E,l,d,m,a,S){let o,i=0;m?(i=m.findLineFeedCountBeforeOffset(a),o=l+a+i):o=l+a;let s;if(m){const c=m.findLineFeedCountBeforeOffset(a+S.length)-i;s=o+S.length+c}else s=o+S.length;const n=E.getPositionAt(o),r=E.getPositionAt(s);return new T.Range(n.lineNumber,n.column,r.lineNumber,r.column)}static _doFindMatchesMultiline(E,l,d,m,a){const S=E.getOffsetAt(l.getStartPosition()),o=E.getValueInRange(l,1),i=E.getEOL()===`\r
`?new R(o):null,s=[];let n=0,r;for(d.reset(0);r=d.next(o);)if(s[n++]=N(this._getMultilineMatchRange(E,S,o,i,r.index,r[0]),r,m),n>=a)return s;return s}static _doFindMatchesLineByLine(E,l,d,m,a){const S=[];let o=0;if(l.startLineNumber===l.endLineNumber){const s=E.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return o=this._findMatchesInLine(d,s,l.startLineNumber,l.startColumn-1,o,S,m,a),S}const i=E.getLineContent(l.startLineNumber).substring(l.startColumn-1);o=this._findMatchesInLine(d,i,l.startLineNumber,l.startColumn-1,o,S,m,a);for(let s=l.startLineNumber+1;s<l.endLineNumber&&o<a;s++)o=this._findMatchesInLine(d,E.getLineContent(s),s,0,o,S,m,a);if(o<a){const s=E.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);o=this._findMatchesInLine(d,s,l.endLineNumber,0,o,S,m,a)}return S}static _findMatchesInLine(E,l,d,m,a,S,o,i){const s=E.wordSeparators;if(!o&&E.simpleSearch){const h=E.simpleSearch,c=h.length,w=l.length;let P=-c;for(;(P=l.indexOf(h,P+c))!==-1;)if((!s||u(s,l,w,P,c))&&(S[a++]=new D.FindMatch(new T.Range(d,P+1+m,d,P+1+c+m),null),a>=i))return a;return a}const n=new v(E.wordSeparators,E.regex);let r;n.reset(0);do if(r=n.next(l),r&&(S[a++]=N(new T.Range(d,r.index+1+m,d,r.index+1+r[0].length+m),r,o),a>=i))return a;while(r);return a}static findNextMatch(E,l,d,m){const a=l.parseSearchRequest();if(!a)return null;const S=new v(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(E,d,S,m):this._doFindNextMatchLineByLine(E,d,S,m)}static _doFindNextMatchMultiline(E,l,d,m){const a=new I.Position(l.lineNumber,1),S=E.getOffsetAt(a),o=E.getLineCount(),i=E.getValueInRange(new T.Range(a.lineNumber,a.column,o,E.getLineMaxColumn(o)),1),s=E.getEOL()===`\r
`?new R(i):null;d.reset(l.column-1);let n=d.next(i);return n?N(this._getMultilineMatchRange(E,S,i,s,n.index,n[0]),n,m):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(E,new I.Position(1,1),d,m):null}static _doFindNextMatchLineByLine(E,l,d,m){const a=E.getLineCount(),S=l.lineNumber,o=E.getLineContent(S),i=this._findFirstMatchInLine(d,o,S,l.column,m);if(i)return i;for(let s=1;s<=a;s++){const n=(S+s-1)%a,r=E.getLineContent(n+1),h=this._findFirstMatchInLine(d,r,n+1,1,m);if(h)return h}return null}static _findFirstMatchInLine(E,l,d,m,a){E.reset(m-1);const S=E.next(l);return S?N(new T.Range(d,S.index+1,d,S.index+1+S[0].length),S,a):null}static findPreviousMatch(E,l,d,m){const a=l.parseSearchRequest();if(!a)return null;const S=new v(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(E,d,S,m):this._doFindPreviousMatchLineByLine(E,d,S,m)}static _doFindPreviousMatchMultiline(E,l,d,m){const a=this._doFindMatchesMultiline(E,new T.Range(1,1,l.lineNumber,l.column),d,m,10*k);if(a.length>0)return a[a.length-1];const S=E.getLineCount();return l.lineNumber!==S||l.column!==E.getLineMaxColumn(S)?this._doFindPreviousMatchMultiline(E,new I.Position(S,E.getLineMaxColumn(S)),d,m):null}static _doFindPreviousMatchLineByLine(E,l,d,m){const a=E.getLineCount(),S=l.lineNumber,o=E.getLineContent(S).substring(0,l.column-1),i=this._findLastMatchInLine(d,o,S,m);if(i)return i;for(let s=1;s<=a;s++){const n=(a+S-s-1)%a,r=E.getLineContent(n+1),h=this._findLastMatchInLine(d,r,n+1,m);if(h)return h}return null}static _findLastMatchInLine(E,l,d,m){let a=null,S;for(E.reset(0);S=E.next(l);)a=N(new T.Range(d,S.index+1,d,S.index+1+S[0].length),S,m);return a}}e.TextModelSearch=b;function C(_,E,l,d,m){if(d===0)return!0;const a=E.charCodeAt(d-1);if(_.get(a)!==0||a===13||a===10)return!0;if(m>0){const S=E.charCodeAt(d);if(_.get(S)!==0)return!0}return!1}function g(_,E,l,d,m){if(d+m===l)return!0;const a=E.charCodeAt(d+m);if(_.get(a)!==0||a===13||a===10)return!0;if(m>0){const S=E.charCodeAt(d+m-1);if(_.get(S)!==0)return!0}return!1}function u(_,E,l,d,m){return C(_,E,l,d,m)&&g(_,E,l,d,m)}e.isValidMatch=u;class v{constructor(E,l){this._wordSeparators=E,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(E){this._searchRegex.lastIndex=E,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(E){const l=E.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(d=this._searchRegex.exec(E),!d))return null;const m=d.index,a=d[0].length;if(m===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){f.getNextCodePoint(E,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=a,!this._wordSeparators||u(this._wordSeparators,E,l,m,a))return d}while(d);return null}}e.Searcher=v}),define(be[112],Ee([1,0,22,13]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(R){R[R.Full=1]="Full",R[R.Delta=2]="Delta"})(I||(I={}));function T(R){for(let b=0,C=R.length;b<C;b+=4){const g=R[b+0],u=R[b+1],v=R[b+2],_=R[b+3];R[b+0]=_,R[b+1]=v,R[b+2]=u,R[b+3]=g}}function D(R){const b=new Uint8Array(R.buffer,R.byteOffset,R.length*4);return t.isLittleEndian()||T(b),f.VSBuffer.wrap(b)}function k(R){const b=R.buffer;if(t.isLittleEndian()||T(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const C=new Uint8Array(b.byteLength);return C.set(b),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function y(R){const b=new Uint32Array(A(R));let C=0;if(b[C++]=R.id,R.type==="full")b[C++]=1,b[C++]=R.data.length,b.set(R.data,C),C+=R.data.length;else{b[C++]=2,b[C++]=R.deltas.length;for(const g of R.deltas)b[C++]=g.start,b[C++]=g.deleteCount,g.data?(b[C++]=g.data.length,b.set(g.data,C),C+=g.data.length):b[C++]=0}return D(b)}e.encodeSemanticTokensDto=y;function A(R){let b=0;if(b+=1+1,R.type==="full")b+=1+R.data.length;else{b+=1,b+=(1+1+1)*R.deltas.length;for(const C of R.deltas)C.data&&(b+=C.data.length)}return b}function N(R){const b=k(R);let C=0;const g=b[C++];if(b[C++]===1){const E=b[C++],l=b.subarray(C,C+E);return C+=E,{id:g,type:"full",data:l}}const v=b[C++],_=[];for(let E=0;E<v;E++){const l=b[C++],d=b[C++],m=b[C++];let a;m>0&&(a=b.subarray(C,C+m),C+=m),_[E]={start:l,deleteCount:d,data:a}}return{id:g,type:"delta",deltas:_}}e.decodeSemanticTokensDto=N}),define(be[154],Ee([1,0,3,6]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this._map.set(k,y),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===y&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,y){this._factories.get(k)?.dispose();const A=new T(this,k,y);return this._factories.set(k,A),(0,t.toDisposable)(()=>{const N=this._factories.get(k);!N||N!==A||(this._factories.delete(k),N.dispose())})}async getOrCreate(k){const y=this.get(k);if(y)return y;const A=this._factories.get(k);return!A||A.isResolved?null:(await A.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const A=this._factories.get(k);return!!(!A||A.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class T extends t.Disposable{constructor(k,y,A){super();this._registry=k,this._languageId=y,this._factory=A,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(be[61],Ee([1,0,2,35,154,73]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var D;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));var k;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(k=e.FontStyle||(e.FontStyle={}));var y;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(y=e.ColorId||(e.ColorId={}));var A;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var N;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=1024]="ITALIC_MASK",p[p.BOLD_MASK=2048]="BOLD_MASK",p[p.UNDERLINE_MASK=4096]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(N=e.MetadataConsts||(e.MetadataConsts={}));class R{static getLanguageId(U){return(U&255)>>>0}static getTokenType(U){return(U&768)>>>8}static getFontStyle(U){return(U&15360)>>>10}static getForeground(U){return(U&8372224)>>>14}static getBackground(U){return(U&4286578688)>>>23}static getClassNameFromMetadata(U){const B=this.getForeground(U);let H="mtk"+B;const re=this.getFontStyle(U);return re&1&&(H+=" mtki"),re&2&&(H+=" mtkb"),re&4&&(H+=" mtku"),re&8&&(H+=" mtks"),H}static getInlineStyleFromMetadata(U,B){const H=this.getForeground(U),re=this.getFontStyle(U);let W=`color: ${B[H]};`;re&1&&(W+="font-style: italic;"),re&2&&(W+="font-weight: bold;");let F="";return re&4&&(F+=" underline"),re&8&&(F+=" line-through"),F&&(W+=`text-decoration:${F};`),W}static getPresentationFromMetadata(U){const B=this.getForeground(U),H=this.getFontStyle(U);return{foreground:B,italic:Boolean(H&1),bold:Boolean(H&2),underline:Boolean(H&4),strikethrough:Boolean(H&8)}}}e.TokenMetadata=R;class b{constructor(U,B,H){this._tokenBrand=void 0,this.offset=U,this.type=B,this.language=H}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=b;class C{constructor(U,B){this._tokenizationResultBrand=void 0,this.tokens=U,this.endState=B}}e.TokenizationResult=C;class g{constructor(U,B){this._encodedTokenizationResultBrand=void 0,this.tokens=U,this.endState=B}}e.EncodedTokenizationResult=g;var u;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(p){const U=new Map;U.set(0,T.Codicon.symbolMethod),U.set(1,T.Codicon.symbolFunction),U.set(2,T.Codicon.symbolConstructor),U.set(3,T.Codicon.symbolField),U.set(4,T.Codicon.symbolVariable),U.set(5,T.Codicon.symbolClass),U.set(6,T.Codicon.symbolStruct),U.set(7,T.Codicon.symbolInterface),U.set(8,T.Codicon.symbolModule),U.set(9,T.Codicon.symbolProperty),U.set(10,T.Codicon.symbolEvent),U.set(11,T.Codicon.symbolOperator),U.set(12,T.Codicon.symbolUnit),U.set(13,T.Codicon.symbolValue),U.set(15,T.Codicon.symbolEnum),U.set(14,T.Codicon.symbolConstant),U.set(15,T.Codicon.symbolEnum),U.set(16,T.Codicon.symbolEnumMember),U.set(17,T.Codicon.symbolKeyword),U.set(27,T.Codicon.symbolSnippet),U.set(18,T.Codicon.symbolText),U.set(19,T.Codicon.symbolColor),U.set(20,T.Codicon.symbolFile),U.set(21,T.Codicon.symbolReference),U.set(22,T.Codicon.symbolCustomColor),U.set(23,T.Codicon.symbolFolder),U.set(24,T.Codicon.symbolTypeParameter),U.set(25,T.Codicon.account),U.set(26,T.Codicon.issues);function B(W){let F=U.get(W);return F||(console.info("No codicon found for CompletionItemKind "+W),F=T.Codicon.symbolProperty),F}p.toIcon=B;const H=new Map;H.set("method",0),H.set("function",1),H.set("constructor",2),H.set("field",3),H.set("variable",4),H.set("class",5),H.set("struct",6),H.set("interface",7),H.set("module",8),H.set("property",9),H.set("event",10),H.set("operator",11),H.set("unit",12),H.set("value",13),H.set("constant",14),H.set("enum",15),H.set("enum-member",16),H.set("enumMember",16),H.set("keyword",17),H.set("snippet",27),H.set("text",18),H.set("color",19),H.set("file",20),H.set("reference",21),H.set("customcolor",22),H.set("folder",23),H.set("type-parameter",24),H.set("typeParameter",24),H.set("account",25),H.set("issue",26);function re(W,F){let q=H.get(W);return typeof q=="undefined"&&!F&&(q=9),q}p.fromString=re})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var _;(function(p){p[p.Deprecated=1]="Deprecated"})(_=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var l;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var d;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(d=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var S;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(S=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(p){return p&&f.URI.isUri(p.uri)&&t.Range.isIRange(p.range)&&(t.Range.isIRange(p.originSelectionRange)||t.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=o;var i;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(p){const U=new Map;U.set(0,T.Codicon.symbolFile),U.set(1,T.Codicon.symbolModule),U.set(2,T.Codicon.symbolNamespace),U.set(3,T.Codicon.symbolPackage),U.set(4,T.Codicon.symbolClass),U.set(5,T.Codicon.symbolMethod),U.set(6,T.Codicon.symbolProperty),U.set(7,T.Codicon.symbolField),U.set(8,T.Codicon.symbolConstructor),U.set(9,T.Codicon.symbolEnum),U.set(10,T.Codicon.symbolInterface),U.set(11,T.Codicon.symbolFunction),U.set(12,T.Codicon.symbolVariable),U.set(13,T.Codicon.symbolConstant),U.set(14,T.Codicon.symbolString),U.set(15,T.Codicon.symbolNumber),U.set(16,T.Codicon.symbolBoolean),U.set(17,T.Codicon.symbolArray),U.set(18,T.Codicon.symbolObject),U.set(19,T.Codicon.symbolKey),U.set(20,T.Codicon.symbolNull),U.set(21,T.Codicon.symbolEnumMember),U.set(22,T.Codicon.symbolStruct),U.set(23,T.Codicon.symbolEvent),U.set(24,T.Codicon.symbolOperator),U.set(25,T.Codicon.symbolTypeParameter);function B(H){let re=U.get(H);return re||(console.info("No codicon found for SymbolKind "+H),re=T.Codicon.symbolProperty),re}p.toIcon=B})(n=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(U){this.value=U}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var h;(function(p){function U(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}p.is=U})(h=e.Command||(e.Command={}));var c;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(p){p[p.Unresolved=0]="Unresolved",p[p.Resolved=1]="Resolved"})(w=e.CommentThreadState||(e.CommentThreadState={}));var P;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(P=e.CommentMode||(e.CommentMode={}));var L;(function(p){p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(L=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var M;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(M=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[155],Ee([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(be[156],Ee([1,0,155]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,T=I*24,D=T*7,k=T*30,y=T*365;function A(R,b,C){typeof R!="number"&&(R=R.getTime());const g=Math.round((new Date().getTime()-R)/1e3);if(g<-30)return(0,f.localize)(0,null,A(new Date().getTime()+g*1e3,!1));if(g<30)return(0,f.localize)(1,null);let u;return g<t?(u=g,b?u===1?C?(0,f.localize)(2,null,u):(0,f.localize)(3,null,u):C?(0,f.localize)(4,null,u):(0,f.localize)(5,null,u):u===1?C?(0,f.localize)(6,null,u):(0,f.localize)(7,null,u):C?(0,f.localize)(8,null,u):(0,f.localize)(9,null,u)):g<I?(u=Math.floor(g/t),b?u===1?C?(0,f.localize)(10,null,u):(0,f.localize)(11,null,u):C?(0,f.localize)(12,null,u):(0,f.localize)(13,null,u):u===1?C?(0,f.localize)(14,null,u):(0,f.localize)(15,null,u):C?(0,f.localize)(16,null,u):(0,f.localize)(17,null,u)):g<T?(u=Math.floor(g/I),b?u===1?C?(0,f.localize)(18,null,u):(0,f.localize)(19,null,u):C?(0,f.localize)(20,null,u):(0,f.localize)(21,null,u):u===1?C?(0,f.localize)(22,null,u):(0,f.localize)(23,null,u):C?(0,f.localize)(24,null,u):(0,f.localize)(25,null,u)):g<D?(u=Math.floor(g/T),b?u===1?(0,f.localize)(26,null,u):(0,f.localize)(27,null,u):u===1?(0,f.localize)(28,null,u):(0,f.localize)(29,null,u)):g<k?(u=Math.floor(g/D),b?u===1?C?(0,f.localize)(30,null,u):(0,f.localize)(31,null,u):C?(0,f.localize)(32,null,u):(0,f.localize)(33,null,u):u===1?C?(0,f.localize)(34,null,u):(0,f.localize)(35,null,u):C?(0,f.localize)(36,null,u):(0,f.localize)(37,null,u)):g<y?(u=Math.floor(g/k),b?u===1?C?(0,f.localize)(38,null,u):(0,f.localize)(39,null,u):C?(0,f.localize)(40,null,u):(0,f.localize)(41,null,u):u===1?C?(0,f.localize)(42,null,u):(0,f.localize)(43,null,u):C?(0,f.localize)(44,null,u):(0,f.localize)(45,null,u)):(u=Math.floor(g/y),b?u===1?C?(0,f.localize)(46,null,u):(0,f.localize)(47,null,u):C?(0,f.localize)(48,null,u):(0,f.localize)(49,null,u):u===1?C?(0,f.localize)(50,null,u):(0,f.localize)(51,null,u):C?(0,f.localize)(52,null,u):(0,f.localize)(53,null,u))}e.fromNow=A;function N(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(be[157],Ee([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(be[49],Ee([1,0,18,14,157]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(R,b){return b&&(R.stack||R.stacktrace)?I.localize(0,null,k(R),D(R.stack)||D(R.stacktrace)):k(R)}function D(R){return Array.isArray(R)?R.join(`
`):R}function k(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?I.localize(1,null,R.message):R.message||I.localize(2,null)}function y(R=null,b=!1){if(!R)return I.localize(3,null);if(Array.isArray(R)){const C=f.coalesce(R),g=y(C[0],b);return C.length>1?I.localize(4,null,g,C.length):g}if(t.isString(R))return R;if(R.detail){const C=R.detail;if(C.error)return T(C.error,b);if(C.exception)return T(C.exception,b)}return R.stack?T(R,b):R.message?R.message:I.localize(5,null)}e.toErrorMessage=y;function A(R){const b=R;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=A;function N(R,b=Object.create(null)){const C=new Error(R);return b.actions&&(C.actions=b.actions),C}e.createErrorWithActions=N}),define(be[158],Ee([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(be[113],Ee([1,0,39,30,10,25,9,13,38,94,14,146,29,158]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function g(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(a,S){if(k.isWindows)try{const o={stdio:["pipe","pipe","ignore"]};S&&(o.cwd=S);const i=f.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],o);return new Promise(s=>{i.once("error",n=>{s({success:!1,error:n})}),i.once("exit",(n,r)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(o){return Promise.resolve({success:!1,error:o,code:o.status?g(o.status):1})}else if(k.isLinux||k.isMacintosh)try{const o=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(i=>{f.execFile(o,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,n,r)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(o){return Promise.resolve({success:!1,error:o})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function v(a){!a||(delete a.DEBUG,k.isMacintosh&&delete a.DYLD_LIBRARY_PATH,k.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function _(a=y.env){return a.comspec||"cmd.exe"}e.getWindowsShell=_;class E{constructor(S,o,i,s){if(o!==void 0&&i!==void 0&&s!==void 0)this.cmd=S,this.args=o,this.shell=i,this.options=s;else{const n=S;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(y.env).forEach(r=>{n[r]=y.env[r]}),Object.keys(this.options.env).forEach(r=>{n[r]=this.options.env[r]}),this.options.env=n}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const o=S.lastIndexOf(D.sep);return o!==-1&&(S=S.substring(o+1)),E.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(y.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(o=>{let i,s;const n=new Promise((r,h)=>{i=r,s=h});if(o){let r=this.cmd;this.args&&(r=r+" "+this.args.join(" ")),this.childProcess=f.exec(r,this.options,(h,c,w)=>{this.childProcess=null;const P=h;P&&P.killed?s({killed:this.terminateRequested,stdout:c.toString(),stderr:w.toString()}):this.handleExec(i,S,h,c,w)})}else{let r=null;const h=c=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(c,i,S,s);const w={terminated:this.terminateRequested};N.isNumber(c)&&(w.cmdCode=c),i(w)};if(this.shell&&k.isWindows){const c=T.deepClone(this.options);c.windowsVerbatimArguments=!0,c.detached=!1;let w=!1,P=!1;const L=[];let M=this.ensureQuotes(this.cmd);L.push(M.value),w=M.quoted,this.args&&this.args.forEach(U=>{M=this.ensureQuotes(U),L.push(M.value),P=P&&M.quoted});const p=["/s","/c"];w?P?p.push('"'+L.join(" ")+'"'):L.length>1?p.push('"'+L[0]+'" '+L.slice(1).join(" ")):p.push('"'+L[0]+'"'):p.push(L.join(" ")),r=f.spawn(_(),p,c)}else this.cmd&&(r=f.spawn(this.cmd,this.args,this.options));r&&(this.childProcess=r,this.childProcessPromise=Promise.resolve(r),this.pidResolve&&(this.pidResolve(N.isNumber(r.pid)?r.pid:-1),this.pidResolve=void 0),r.on("error",c=>{this.childProcess=null,s({terminated:this.terminateRequested,error:c})}),r.pid&&(this.childProcess.on("close",h),this.handleSpawn(r,i,S,s,!0)))}return n})}handleClose(S,o,i,s){}ensureQuotes(S){return E.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,u(S,this.options.cwd).then(o=>(o.success&&(this.childProcess=null),o))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const o=f.spawn(_(),["/s","/c"]);o.on("error",i=>S(!0)),o.on("exit",i=>S(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class l extends E{constructor(S,o,i,s){super(S,o,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,o,i,s,n){[s,n].forEach((r,h)=>{const c=new R.LineDecoder;c.write(r).forEach(L=>{o({line:L,source:h===0?0:1})});const P=c.end();P&&o({line:P,source:h===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,o,i,s,n){const r=new R.LineDecoder,h=new R.LineDecoder;S.stdout.on("data",c=>{r.write(c).forEach(P=>i({line:P,source:0}))}),S.stderr.on("data",c=>{h.write(c).forEach(P=>i({line:P,source:1}))}),this.stdoutLineDecoder=r,this.stderrLineDecoder=h}handleClose(S,o,i,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const r=this.stderrLineDecoder?this.stderrLineDecoder.end():null;r&&i({line:r,source:1})}}e.LineProcess=l;function d(a){let S=[],o=!1;const i=function(s){if(o){S.push(s);return}(!a.send(s,r=>{if(r&&console.error(r),o=!1,S.length>0){const h=S.slice(0);S=[],h.forEach(c=>i(c))}})||k.isWindows)&&(o=!0)};return{send:i}}e.createQueuedSender=d;var m;(function(a){async function S(o,i,s){if(D.isAbsolute(o))return o;if(i===void 0&&(i=y.cwd()),D.dirname(o)!=="."||(s===void 0&&N.isString(y.env.PATH)&&(s=y.env.PATH.split(D.delimiter)),s===void 0||s.length===0))return D.join(i,o);async function r(h){if(await b.Promises.exists(h)){let c;try{c=await b.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(c=await b.Promises.lstat(h))}return c?!c.isDirectory():!1}return!1}for(let h of s){let c;if(D.isAbsolute(h)?c=D.join(h,o):c=D.join(i,h,o),await r(c))return c;let w=c+".com";if(await r(w)||(w=c+".exe",await r(w)))return w}return D.join(i,o)}a.findExecutable=S})(m=e.win32||(e.win32={}))}),define(be[159],Ee([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(be[114],Ee([1,0,159,13,108,18,25,148]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=A;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class R{constructor(oe,K,we,ke){this.id=oe,this.name=K,this.defaultValue=we,this.schema=ke}applyUpdate(oe,K){return C(oe,K)}compute(oe,K,we){return we}}class b{constructor(oe,K){this.newValue=oe,this.didChange=K}}e.ApplyUpdateResult=b;function C(te,oe){if(typeof te!="object"||typeof oe!="object"||!te||!oe)return new b(oe,te!==oe);if(Array.isArray(te)||Array.isArray(oe)){const we=Array.isArray(te)&&Array.isArray(oe)&&T.equals(te,oe);return new b(oe,we)}let K=!1;for(const we in oe)if(oe.hasOwnProperty(we)){const ke=C(te[we],oe[we]);ke.didChange&&(te[we]=ke.newValue,K=!0)}return new b(te,K)}class g{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,K){return C(oe,K)}validate(oe){return this.defaultValue}}class u{constructor(oe,K,we,ke){this.id=oe,this.name=K,this.defaultValue=we,this.schema=ke}applyUpdate(oe,K){return C(oe,K)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,K,we){return we}}function v(te,oe){return typeof te=="undefined"?oe:te==="false"?!1:Boolean(te)}e.boolean=v;class _ extends u{constructor(oe,K,we,ke=void 0){typeof ke!="undefined"&&(ke.type="boolean",ke.default=we);super(oe,K,we,ke)}validate(oe){return v(oe,this.defaultValue)}}function E(te,oe,K,we){if(typeof te=="undefined")return oe;let ke=parseInt(te,10);return isNaN(ke)?oe:(ke=Math.max(K,ke),ke=Math.min(we,ke),ke|0)}e.clampedInt=E;class l extends u{constructor(oe,K,we,ke,We,xe=void 0){typeof xe!="undefined"&&(xe.type="integer",xe.default=we,xe.minimum=ke,xe.maximum=We);super(oe,K,we,xe);this.minimum=ke,this.maximum=We}static clampedInt(oe,K,we,ke){return E(oe,K,we,ke)}validate(oe){return l.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class d extends u{constructor(oe,K,we,ke,We){typeof We!="undefined"&&(We.type="number",We.default=we);super(oe,K,we,We);this.validationFn=ke}static clamp(oe,K,we){return oe<K?K:oe>we?we:oe}static float(oe,K){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return K;const we=parseFloat(oe);return isNaN(we)?K:we}validate(oe){return this.validationFn(d.float(oe,this.defaultValue))}}class m extends u{static string(oe,K){return typeof oe!="string"?K:oe}constructor(oe,K,we,ke=void 0){typeof ke!="undefined"&&(ke.type="string",ke.default=we);super(oe,K,we,ke)}validate(oe){return m.string(oe,this.defaultValue)}}function a(te,oe,K){return typeof te!="string"||K.indexOf(te)===-1?oe:te}e.stringSet=a;class S extends u{constructor(oe,K,we,ke,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=ke,We.default=we);super(oe,K,we,We);this._allowedValues=ke}validate(oe){return a(oe,this.defaultValue,this._allowedValues)}}class o extends R{constructor(oe,K,we,ke,We,xe,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=We,Je.default=ke);super(oe,K,we,Je);this._allowedValues=We,this._convert=xe}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function i(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,K,we){return we===0?oe.accessibilitySupport:we}}class n extends R{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:f.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{insertSpace:v(K.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(K.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(te){switch(te){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function P(te){switch(te){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class L extends g{constructor(){super(128)}compute(oe,K,we){const ke=["monaco-editor"];return K.get(33)&&ke.push(K.get(33)),oe.extraEditorClassName&&ke.push(oe.extraEditorClassName),K.get(66)==="default"?ke.push("mouse-default"):K.get(66)==="copy"&&ke.push("mouse-copy"),K.get(100)&&ke.push("showUnused"),K.get(126)&&ke.push("showDeprecated"),ke.join(" ")}}class M extends _{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(oe,K,we){return we&&oe.emptySelectionClipboard}}class p extends R{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:f.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:f.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{cursorMoveOnType:v(K.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":a(K.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":a(K.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(K.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(K.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(K.loop,this.defaultValue.loop)}}}class U extends R{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?U.OFF:oe==="true"?U.ON:oe:Boolean(oe)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class B extends g{constructor(){super(44)}compute(oe,K,we){return oe.fontInfo}}class H extends u{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(oe){const K=d.float(oe,this.defaultValue);return K===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(K,6,100)}compute(oe,K,we){return oe.fontInfo.fontSize}}class re extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.MINIMUM_VALUE,maximum:re.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(l.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,re.MINIMUM_VALUE,re.MAXIMUM_VALUE))}}re.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],re.MINIMUM_VALUE=1,re.MAXIMUM_VALUE=1e3;class W extends R{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},K={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},we=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...K},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...K},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...K},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...K},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...K},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:we,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:we,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:we,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:we,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:we,description:f.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{multiple:a(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:K.multipleDefinitions??a(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:K.multipleTypeDefinitions??a(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:K.multipleDeclarations??a(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:K.multipleImplementations??a(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:K.multipleReferences??a(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends R{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:f.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{enabled:v(K.enabled,this.defaultValue.enabled),delay:l.clampedInt(K.delay,this.defaultValue.delay,0,1e4),sticky:v(K.sticky,this.defaultValue.sticky),above:v(K.above,this.defaultValue.above)}}}var q;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class G extends g{constructor(){super(131)}compute(oe,K,we){return G.computeLayout(K,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const K=oe.height/oe.lineHeight,we=oe.scrollBeyondLastLine?K-1:0,ke=(oe.viewLineCount+we)/(oe.pixelRatio*oe.height),We=Math.floor(oe.viewLineCount/ke);return{typicalViewportLineCount:K,extraLinesBeyondLastLine:we,desiredRatio:ke,minimapLineCount:We}}static _computeMinimapLayout(oe,K){const we=oe.outerWidth,ke=oe.outerHeight,We=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ke};const xe=K.stableMinimapLayoutInput,Je=xe&&oe.outerHeight===xe.outerHeight&&oe.lineHeight===xe.lineHeight&&oe.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&oe.pixelRatio===xe.pixelRatio&&oe.scrollBeyondLastLine===xe.scrollBeyondLastLine&&oe.minimap.enabled===xe.minimap.enabled&&oe.minimap.side===xe.minimap.side&&oe.minimap.size===xe.minimap.size&&oe.minimap.showSlider===xe.minimap.showSlider&&oe.minimap.renderCharacters===xe.minimap.renderCharacters&&oe.minimap.maxColumn===xe.minimap.maxColumn&&oe.minimap.scale===xe.minimap.scale&&oe.verticalScrollbarWidth===xe.verticalScrollbarWidth&&oe.isViewportWrapping===xe.isViewportWrapping,st=oe.lineHeight,mt=oe.typicalHalfwidthCharacterWidth,vt=oe.scrollBeyondLastLine,qe=oe.minimap.renderCharacters;let at=We>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const wt=oe.minimap.maxColumn,it=oe.minimap.size,dt=oe.minimap.side,Ut=oe.verticalScrollbarWidth,At=oe.viewLineCount,Ct=oe.remainingWidth,ht=oe.isViewportWrapping,Rt=qe?2:3;let Ft=Math.floor(We*ke);const Nt=Ft/We;let Ve=!1,Ce=!1,Te=Rt*at,ve=at/We,Z=1;if(it==="fill"||it==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:ot,desiredRatio:ft,minimapLineCount:ct}=G.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:vt,height:ke,lineHeight:st,pixelRatio:We});if(At/ct>1)Ve=!0,Ce=!0,at=1,Te=1,ve=at/We;else{let _t=!1,Tt=at+1;if(it==="fit"){const It=Math.ceil((At+ot)*Te);ht&&Je&&Ct<=K.stableFitRemainingWidth?(_t=!0,Tt=K.stableFitMaxMinimapScale):_t=It>Ft}if(it==="fill"||_t){Ve=!0;const It=at;Te=Math.min(st*We,Math.max(1,Math.floor(1/ft))),ht&&Je&&Ct<=K.stableFitRemainingWidth&&(Tt=K.stableFitMaxMinimapScale),at=Math.min(Tt,Math.max(1,Math.floor(Te/Rt))),at>It&&(Z=Math.min(2,at/It)),ve=at/We/Z,Ft=Math.ceil(Math.max(Et,At+ot)*Te),ht?(K.stableMinimapLayoutInput=oe,K.stableFitRemainingWidth=Ct,K.stableFitMaxMinimapScale=at):(K.stableMinimapLayoutInput=null,K.stableFitRemainingWidth=0)}}}const Ae=Math.floor(wt*ve),Fe=Math.min(Ae,Math.max(0,Math.floor((Ct-Ut-2)*ve/(mt+ve)))+e.MINIMAP_GUTTER_WIDTH);let je=Math.floor(We*Fe);const Qe=je/We;je=Math.floor(je*Z);const gt=qe?1:2,bt=dt==="left"?0:we-Fe-Ut;return{renderMinimap:gt,minimapLeft:bt,minimapWidth:Fe,minimapHeightIsEditorHeight:Ve,minimapIsSampling:Ce,minimapScale:at,minimapLineHeight:Te,minimapCanvasInnerWidth:je,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Nt}}static computeLayout(oe,K){const we=K.outerWidth|0,ke=K.outerHeight|0,We=K.lineHeight|0,xe=K.lineNumbersDigitCount|0,Je=K.typicalHalfwidthCharacterWidth,st=K.maxDigitWidth,mt=K.pixelRatio,vt=K.viewLineCount,qe=oe.get(123),at=qe==="inherit"?oe.get(122):qe,wt=at==="inherit"?oe.get(118):at,it=oe.get(121),dt=oe.get(2),Ut=K.isDominatedByLongLines,At=oe.get(50),Ct=oe.get(60).renderType!==0,ht=oe.get(61),Rt=oe.get(94),Ft=oe.get(65),Nt=oe.get(92),Ve=Nt.verticalScrollbarSize,Ce=Nt.verticalHasArrows,Te=Nt.arrowSize,ve=Nt.horizontalScrollbarSize,Z=oe.get(58),Ae=oe.get(37);let Fe;if(typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)){const Ht=parseFloat(Z.substr(0,Z.length-2));Fe=l.clampedInt(Ht*Je,0,0,1e3)}else Fe=l.clampedInt(Z,0,0,1e3);Ae&&(Fe+=16);let je=0;if(Ct){const Ht=Math.max(xe,ht);je=Math.round(Ht*st)}let Qe=0;At&&(Qe=We);let gt=0,bt=gt+Qe,Et=bt+je,ot=Et+Fe;const ft=we-Qe-je-Fe;let ct=!1,Mt=!1,_t=-1;dt!==2&&(at==="inherit"&&Ut?(ct=!0,Mt=!0):wt==="on"||wt==="bounded"?Mt=!0:wt==="wordWrapColumn"&&(_t=it));const Tt=G._computeMinimapLayout({outerWidth:we,outerHeight:ke,lineHeight:We,typicalHalfwidthCharacterWidth:Je,pixelRatio:mt,scrollBeyondLastLine:Rt,minimap:Ft,verticalScrollbarWidth:Ve,viewLineCount:vt,remainingWidth:ft,isViewportWrapping:Mt},K.memory||new N);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(gt+=Tt.minimapWidth,bt+=Tt.minimapWidth,Et+=Tt.minimapWidth,ot+=Tt.minimapWidth);const It=ft-Tt.minimapWidth,yt=Math.max(1,Math.floor((It-Ve-2)/Je)),Jt=Ce?Te:0;return Mt&&(_t=Math.max(1,yt),wt==="bounded"&&(_t=Math.min(_t,it))),{width:we,height:ke,glyphMarginLeft:gt,glyphMarginWidth:Qe,lineNumbersLeft:bt,lineNumbersWidth:je,decorationsLeft:Et,decorationsWidth:Fe,contentLeft:ot,contentWidth:It,minimap:Tt,viewportColumn:yt,isWordWrapMinified:ct,isViewportWrapping:Mt,wrappingColumn:_t,verticalScrollbarWidth:Ve,horizontalScrollbarHeight:ve,overviewRuler:{top:Jt,width:Ve,height:ke-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=G;class $ extends R{constructor(){const oe={enabled:!0};super(57,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:f.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:v(oe.enabled,this.defaultValue.enabled)}}}class X extends R{constructor(){const oe={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"boolean",default:oe.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:f.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{enabled:v(K.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(K.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(K.fontFamily,this.defaultValue.fontFamily)}}}class ie extends d{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>d.clamp(oe,0,150),{markdownDescription:f.localize(47,null)})}compute(oe,K,we){return oe.fontInfo.lineHeight}}class ae extends R{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:oe.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:f.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{enabled:v(K.enabled,this.defaultValue.enabled),size:a(K.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(K.side,this.defaultValue.side,["right","left"]),showSlider:a(K.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(K.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(K.scale,1,1,3),maxColumn:l.clampedInt(K.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(te){return te==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class se extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{top:l.clampedInt(K.top,0,0,1e3),bottom:l.clampedInt(K.bottom,0,0,1e3)}}}class ee extends R{constructor(){const oe={enabled:!0,cycle:!1};super(76,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:f.localize(61,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{enabled:v(K.enabled,this.defaultValue.enabled),cycle:v(K.cycle,this.defaultValue.cycle)}}}class fe extends g{constructor(){super(129)}compute(oe,K,we){return oe.pixelRatio}}class ge extends R{constructor(){const oe={other:"on",comments:"off",strings:"off"},K=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[f.localize(62,null),f.localize(63,null),f.localize(64,null)]}];super(79,"quickSuggestions",oe,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{anyOf:K,default:oe.strings,description:f.localize(65,null)},comments:{anyOf:K,default:oe.comments,description:f.localize(66,null)},other:{anyOf:K,default:oe.other,description:f.localize(67,null)}}}],default:oe,markdownDescription:f.localize(68,null)});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const mt=oe?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:K,comments:we,strings:ke}=oe,We=["on","inline","off"];let xe,Je,st;return typeof K=="boolean"?xe=K?"on":"off":xe=a(K,this.defaultValue.other,We),typeof we=="boolean"?Je=we?"on":"off":Je=a(we,this.defaultValue.comments,We),typeof ke=="boolean"?st=ke?"on":"off":st=a(ke,this.defaultValue.strings,We),{other:xe,comments:Je,strings:st}}}var ye;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(69,null),f.localize(70,null),f.localize(71,null),f.localize(72,null)],default:"on",description:f.localize(73,null)})}validate(oe){let K=this.defaultValue.renderType,we=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(K=4,we=oe):oe==="interval"?K=3:oe==="relative"?K=2:oe==="on"?K=1:K=0),{renderType:K,renderFn:we}}}function Se(te){const oe=te.get(87);return oe==="editable"?te.get(81):oe!=="on"}e.filterValidationDecorations=Se;class _e extends R{constructor(){const oe=[],K={type:"number",description:f.localize(74,null)};super(91,"rulers",oe,{type:"array",items:{anyOf:[K,{type:["object"],properties:{column:K,color:{type:"string",description:f.localize(75,null),format:"color-hex"}}}]},default:oe,description:f.localize(76,null)})}validate(oe){if(Array.isArray(oe)){const K=[];for(let we of oe)if(typeof we=="number")K.push({column:l.clampedInt(we,0,0,1e4),color:null});else if(we&&typeof we=="object"){const ke=we;K.push({column:l.clampedInt(ke.column,0,0,1e4),color:ke.color})}return K.sort((we,ke)=>we.column-ke.column),K}return this.defaultValue}}function Ie(te,oe){if(typeof te!="string")return oe;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class de extends R{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(77,null),f.localize(78,null),f.localize(79,null)],default:"auto",description:f.localize(80,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(81,null),f.localize(82,null),f.localize(83,null)],default:"auto",description:f.localize(84,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:f.localize(85,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:f.localize(86,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:f.localize(87,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe,we=l.clampedInt(K.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ke=l.clampedInt(K.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(K.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(K.vertical,this.defaultValue.vertical),horizontal:Ie(K.horizontal,this.defaultValue.horizontal),useShadows:v(K.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(K.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(K.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(K.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(K.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:we,horizontalSliderSize:l.clampedInt(K.horizontalSliderSize,we,0,1e3),verticalScrollbarSize:ke,verticalSliderSize:l.clampedInt(K.verticalSliderSize,ke,0,1e3),scrollByPage:v(K.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends R{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:f.localize(90,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:f.localize(91,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:f.localize(92,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:f.localize(93,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:f.localize(94,null)}})}applyUpdate(oe,K){let we=!1;K.allowedCharacters&&(D.equals(oe.allowedCharacters,K.allowedCharacters)||(oe={...oe,allowedCharacters:K.allowedCharacters},we=!0)),K.allowedLocales&&(D.equals(oe.allowedLocales,K.allowedLocales)||(oe={...oe,allowedLocales:K.allowedLocales},we=!0));const ke=super.applyUpdate(oe,K);return we?new b(ke.newValue,!0):ke}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{nonBasicASCII:j(K.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(K.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(K.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:j(K.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:j(K.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,K){if(typeof oe!="object"||!oe)return K;const we={};for(const[ke,We]of Object.entries(oe))We===!0&&(we[ke]=!0);return we}}class ne extends R{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:f.localize(95,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{enabled:v(K.enabled,this.defaultValue.enabled),mode:a(K.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends R{constructor(){const oe={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:f.localize(96,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:f.localize(97,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{enabled:v(K.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(K.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class x extends R{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:oe.bracketPairs,description:f.localize(101,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(102,null),f.localize(103,null),f.localize(104,null)],default:oe.bracketPairsHorizontal,description:f.localize(105,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:f.localize(106,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:f.localize(107,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:oe.highlightActiveIndentation,description:f.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{bracketPairs:j(K.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:j(K.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(K.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(K.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(K.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function j(te,oe,K){const we=K.indexOf(te);return we===-1?oe:K[we]}class Y extends R{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(109,null),f.localize(110,null)],default:oe.insertMode,description:f.localize(111,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:f.localize(112,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:f.localize(113,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:f.localize(114,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:f.localize(115,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:f.localize(116,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:f.localize(117,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:f.localize(118,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:f.localize(119,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(120,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(121,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(147,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(148,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(149,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(150,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const K=oe;return{insertMode:a(K.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(K.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(K.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(K.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(K.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(K.showIcons,this.defaultValue.showIcons),showStatusBar:v(K.showStatusBar,this.defaultValue.showStatusBar),preview:v(K.preview,this.defaultValue.preview),previewMode:a(K.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(K.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(K.showMethods,this.defaultValue.showMethods),showFunctions:v(K.showFunctions,this.defaultValue.showFunctions),showConstructors:v(K.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(K.showDeprecated,this.defaultValue.showDeprecated),showFields:v(K.showFields,this.defaultValue.showFields),showVariables:v(K.showVariables,this.defaultValue.showVariables),showClasses:v(K.showClasses,this.defaultValue.showClasses),showStructs:v(K.showStructs,this.defaultValue.showStructs),showInterfaces:v(K.showInterfaces,this.defaultValue.showInterfaces),showModules:v(K.showModules,this.defaultValue.showModules),showProperties:v(K.showProperties,this.defaultValue.showProperties),showEvents:v(K.showEvents,this.defaultValue.showEvents),showOperators:v(K.showOperators,this.defaultValue.showOperators),showUnits:v(K.showUnits,this.defaultValue.showUnits),showValues:v(K.showValues,this.defaultValue.showValues),showConstants:v(K.showConstants,this.defaultValue.showConstants),showEnums:v(K.showEnums,this.defaultValue.showEnums),showEnumMembers:v(K.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(K.showKeywords,this.defaultValue.showKeywords),showWords:v(K.showWords,this.defaultValue.showWords),showColors:v(K.showColors,this.defaultValue.showColors),showFiles:v(K.showFiles,this.defaultValue.showFiles),showReferences:v(K.showReferences,this.defaultValue.showReferences),showFolders:v(K.showFolders,this.defaultValue.showFolders),showTypeParameters:v(K.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(K.showSnippets,this.defaultValue.showSnippets),showUsers:v(K.showUsers,this.defaultValue.showUsers),showIssues:v(K.showIssues,this.defaultValue.showIssues)}}}class ue extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(151,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends g{constructor(){super(130)}compute(oe,K,we){return K.get(81)?!0:oe.tabFocusMode}}var De;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Ue(te){switch(te){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ze extends g{constructor(){super(132)}compute(oe,K,we){const ke=K.get(131);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:ke.isWordWrapMinified,isViewportWrapping:ke.isViewportWrapping,wrappingColumn:ke.wrappingColumn}}}const He="Consolas, 'Courier New', monospace",Ke="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ke:t.isLinux?et:He,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(te){return e.editorOptionsRegistry[te.id]=te,te}var Xe;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.autoClosingBrackets=5]="autoClosingBrackets",te[te.autoClosingDelete=6]="autoClosingDelete",te[te.autoClosingOvertype=7]="autoClosingOvertype",te[te.autoClosingQuotes=8]="autoClosingQuotes",te[te.autoIndent=9]="autoIndent",te[te.automaticLayout=10]="automaticLayout",te[te.autoSurround=11]="autoSurround",te[te.bracketPairColorization=12]="bracketPairColorization",te[te.guides=13]="guides",te[te.codeLens=14]="codeLens",te[te.codeLensFontFamily=15]="codeLensFontFamily",te[te.codeLensFontSize=16]="codeLensFontSize",te[te.colorDecorators=17]="colorDecorators",te[te.columnSelection=18]="columnSelection",te[te.comments=19]="comments",te[te.contextmenu=20]="contextmenu",te[te.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",te[te.cursorBlinking=22]="cursorBlinking",te[te.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",te[te.cursorStyle=24]="cursorStyle",te[te.cursorSurroundingLines=25]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",te[te.cursorWidth=27]="cursorWidth",te[te.disableLayerHinting=28]="disableLayerHinting",te[te.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",te[te.domReadOnly=30]="domReadOnly",te[te.dragAndDrop=31]="dragAndDrop",te[te.emptySelectionClipboard=32]="emptySelectionClipboard",te[te.extraEditorClassName=33]="extraEditorClassName",te[te.fastScrollSensitivity=34]="fastScrollSensitivity",te[te.find=35]="find",te[te.fixedOverflowWidgets=36]="fixedOverflowWidgets",te[te.folding=37]="folding",te[te.foldingStrategy=38]="foldingStrategy",te[te.foldingHighlight=39]="foldingHighlight",te[te.foldingImportsByDefault=40]="foldingImportsByDefault",te[te.foldingMaximumRegions=41]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=43]="fontFamily",te[te.fontInfo=44]="fontInfo",te[te.fontLigatures=45]="fontLigatures",te[te.fontSize=46]="fontSize",te[te.fontWeight=47]="fontWeight",te[te.formatOnPaste=48]="formatOnPaste",te[te.formatOnType=49]="formatOnType",te[te.glyphMargin=50]="glyphMargin",te[te.gotoLocation=51]="gotoLocation",te[te.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",te[te.hover=53]="hover",te[te.inDiffEditor=54]="inDiffEditor",te[te.inlineSuggest=55]="inlineSuggest",te[te.letterSpacing=56]="letterSpacing",te[te.lightbulb=57]="lightbulb",te[te.lineDecorationsWidth=58]="lineDecorationsWidth",te[te.lineHeight=59]="lineHeight",te[te.lineNumbers=60]="lineNumbers",te[te.lineNumbersMinChars=61]="lineNumbersMinChars",te[te.linkedEditing=62]="linkedEditing",te[te.links=63]="links",te[te.matchBrackets=64]="matchBrackets",te[te.minimap=65]="minimap",te[te.mouseStyle=66]="mouseStyle",te[te.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=68]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",te[te.multiCursorModifier=70]="multiCursorModifier",te[te.multiCursorPaste=71]="multiCursorPaste",te[te.occurrencesHighlight=72]="occurrencesHighlight",te[te.overviewRulerBorder=73]="overviewRulerBorder",te[te.overviewRulerLanes=74]="overviewRulerLanes",te[te.padding=75]="padding",te[te.parameterHints=76]="parameterHints",te[te.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",te[te.quickSuggestions=79]="quickSuggestions",te[te.quickSuggestionsDelay=80]="quickSuggestionsDelay",te[te.readOnly=81]="readOnly",te[te.renameOnType=82]="renameOnType",te[te.renderControlCharacters=83]="renderControlCharacters",te[te.renderFinalNewline=84]="renderFinalNewline",te[te.renderLineHighlight=85]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=87]="renderValidationDecorations",te[te.renderWhitespace=88]="renderWhitespace",te[te.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",te[te.roundedSelection=90]="roundedSelection",te[te.rulers=91]="rulers",te[te.scrollbar=92]="scrollbar",te[te.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=94]="scrollBeyondLastLine",te[te.scrollPredominantAxis=95]="scrollPredominantAxis",te[te.selectionClipboard=96]="selectionClipboard",te[te.selectionHighlight=97]="selectionHighlight",te[te.selectOnLineNumbers=98]="selectOnLineNumbers",te[te.showFoldingControls=99]="showFoldingControls",te[te.showUnused=100]="showUnused",te[te.snippetSuggestions=101]="snippetSuggestions",te[te.smartSelect=102]="smartSelect",te[te.smoothScrolling=103]="smoothScrolling",te[te.stickyTabStops=104]="stickyTabStops",te[te.stopRenderingLineAfter=105]="stopRenderingLineAfter",te[te.suggest=106]="suggest",te[te.suggestFontSize=107]="suggestFontSize",te[te.suggestLineHeight=108]="suggestLineHeight",te[te.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",te[te.suggestSelection=110]="suggestSelection",te[te.tabCompletion=111]="tabCompletion",te[te.tabIndex=112]="tabIndex",te[te.unicodeHighlighting=113]="unicodeHighlighting",te[te.unusualLineTerminators=114]="unusualLineTerminators",te[te.useShadowDOM=115]="useShadowDOM",te[te.useTabStops=116]="useTabStops",te[te.wordSeparators=117]="wordSeparators",te[te.wordWrap=118]="wordWrap",te[te.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=121]="wordWrapColumn",te[te.wordWrapOverride1=122]="wordWrapOverride1",te[te.wordWrapOverride2=123]="wordWrapOverride2",te[te.wrappingIndent=124]="wrappingIndent",te[te.wrappingStrategy=125]="wrappingStrategy",te[te.showDeprecated=126]="showDeprecated",te[te.inlayHints=127]="inlayHints",te[te.editorClassName=128]="editorClassName",te[te.pixelRatio=129]="pixelRatio",te[te.tabFocusMode=130]="tabFocusMode",te[te.layoutInfo=131]="layoutInfo",te[te.wrappingInfo=132]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new _(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(152,null)})),acceptSuggestionOnEnter:Oe(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(153,null),""],markdownDescription:f.localize(154,null)})),accessibilitySupport:Oe(new s),accessibilityPageSize:Oe(new l(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(155,null)})),ariaLabel:Oe(new m(4,"ariaLabel",f.localize(156,null))),autoClosingBrackets:Oe(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(157,null),f.localize(158,null),""],description:f.localize(159,null)})),autoClosingDelete:Oe(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(160,null),""],description:f.localize(161,null)})),autoClosingOvertype:Oe(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(162,null),""],description:f.localize(163,null)})),autoClosingQuotes:Oe(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(164,null),f.localize(165,null),""],description:f.localize(166,null)})),autoIndent:Oe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[f.localize(167,null),f.localize(168,null),f.localize(169,null),f.localize(170,null),f.localize(171,null)],description:f.localize(172,null)})),automaticLayout:Oe(new _(10,"automaticLayout",!1)),autoSurround:Oe(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(173,null),f.localize(174,null),f.localize(175,null),""],description:f.localize(176,null)})),bracketPairColorization:Oe(new O),bracketPairGuides:Oe(new x),stickyTabStops:Oe(new _(104,"stickyTabStops",!1,{description:f.localize(177,null)})),codeLens:Oe(new _(14,"codeLens",!0,{description:f.localize(178,null)})),codeLensFontFamily:Oe(new m(15,"codeLensFontFamily","",{description:f.localize(179,null)})),codeLensFontSize:Oe(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(180,null)})),colorDecorators:Oe(new _(17,"colorDecorators",!0,{description:f.localize(181,null)})),columnSelection:Oe(new _(18,"columnSelection",!1,{description:f.localize(182,null)})),comments:Oe(new n),contextmenu:Oe(new _(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new _(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(183,null)})),cursorBlinking:Oe(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:f.localize(184,null)})),cursorSmoothCaretAnimation:Oe(new _(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(185,null)})),cursorStyle:Oe(new o(24,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:f.localize(186,null)})),cursorSurroundingLines:Oe(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(187,null)})),cursorSurroundingLinesStyle:Oe(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(188,null),f.localize(189,null)],description:f.localize(190,null)})),cursorWidth:Oe(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(191,null)})),disableLayerHinting:Oe(new _(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new _(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new _(30,"domReadOnly",!1)),dragAndDrop:Oe(new _(31,"dragAndDrop",!0,{description:f.localize(192,null)})),emptySelectionClipboard:Oe(new M),extraEditorClassName:Oe(new m(33,"extraEditorClassName","")),fastScrollSensitivity:Oe(new d(34,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:f.localize(193,null)})),find:Oe(new p),fixedOverflowWidgets:Oe(new _(36,"fixedOverflowWidgets",!1)),folding:Oe(new _(37,"folding",!0,{description:f.localize(194,null)})),foldingStrategy:Oe(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(195,null),f.localize(196,null)],description:f.localize(197,null)})),foldingHighlight:Oe(new _(39,"foldingHighlight",!0,{description:f.localize(198,null)})),foldingImportsByDefault:Oe(new _(40,"foldingImportsByDefault",!1,{description:f.localize(199,null)})),foldingMaximumRegions:Oe(new l(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(200,null)})),unfoldOnClickAfterEndOfLine:Oe(new _(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(201,null)})),fontFamily:Oe(new m(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(202,null)})),fontInfo:Oe(new B),fontLigatures2:Oe(new U),fontSize:Oe(new H),fontWeight:Oe(new re),formatOnPaste:Oe(new _(48,"formatOnPaste",!1,{description:f.localize(203,null)})),formatOnType:Oe(new _(49,"formatOnType",!1,{description:f.localize(204,null)})),glyphMargin:Oe(new _(50,"glyphMargin",!0,{description:f.localize(205,null)})),gotoLocation:Oe(new W),hideCursorInOverviewRuler:Oe(new _(52,"hideCursorInOverviewRuler",!1,{description:f.localize(206,null)})),hover:Oe(new F),inDiffEditor:Oe(new _(54,"inDiffEditor",!1)),letterSpacing:Oe(new d(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>d.clamp(te,-5,20),{description:f.localize(207,null)})),lightbulb:Oe(new $),lineDecorationsWidth:Oe(new u(58,"lineDecorationsWidth",10)),lineHeight:Oe(new ie),lineNumbers:Oe(new Ne),lineNumbersMinChars:Oe(new l(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new _(62,"linkedEditing",!1,{description:f.localize(208,null)})),links:Oe(new _(63,"links",!0,{description:f.localize(209,null)})),matchBrackets:Oe(new S(64,"matchBrackets","always",["always","near","never"],{description:f.localize(210,null)})),minimap:Oe(new ae),mouseStyle:Oe(new S(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new d(67,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:f.localize(211,null)})),mouseWheelZoom:Oe(new _(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(212,null)})),multiCursorMergeOverlapping:Oe(new _(69,"multiCursorMergeOverlapping",!0,{description:f.localize(213,null)})),multiCursorModifier:Oe(new o(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[f.localize(214,null),f.localize(215,null)],markdownDescription:f.localize(216,null)})),multiCursorPaste:Oe(new S(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(217,null),f.localize(218,null)],markdownDescription:f.localize(219,null)})),occurrencesHighlight:Oe(new _(72,"occurrencesHighlight",!0,{description:f.localize(220,null)})),overviewRulerBorder:Oe(new _(73,"overviewRulerBorder",!0,{description:f.localize(221,null)})),overviewRulerLanes:Oe(new l(74,"overviewRulerLanes",3,0,3)),padding:Oe(new se),parameterHints:Oe(new ee),peekWidgetDefaultFocus:Oe(new S(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(222,null),f.localize(223,null)],description:f.localize(224,null)})),definitionLinkOpensInPeek:Oe(new _(78,"definitionLinkOpensInPeek",!1,{description:f.localize(225,null)})),quickSuggestions:Oe(new ge),quickSuggestionsDelay:Oe(new l(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(226,null)})),readOnly:Oe(new _(81,"readOnly",!1)),renameOnType:Oe(new _(82,"renameOnType",!1,{description:f.localize(227,null),markdownDeprecationMessage:f.localize(228,null)})),renderControlCharacters:Oe(new _(83,"renderControlCharacters",!0,{description:f.localize(229,null),restricted:!0})),renderFinalNewline:Oe(new _(84,"renderFinalNewline",!0,{description:f.localize(230,null)})),renderLineHighlight:Oe(new S(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(231,null)],description:f.localize(232,null)})),renderLineHighlightOnlyWhenFocus:Oe(new _(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(233,null)})),renderValidationDecorations:Oe(new S(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new S(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(234,null),f.localize(235,null),f.localize(236,null),""],description:f.localize(237,null)})),revealHorizontalRightPadding:Oe(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new _(90,"roundedSelection",!0,{description:f.localize(238,null)})),rulers:Oe(new _e),scrollbar:Oe(new de),scrollBeyondLastColumn:Oe(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(239,null)})),scrollBeyondLastLine:Oe(new _(94,"scrollBeyondLastLine",!0,{description:f.localize(240,null)})),scrollPredominantAxis:Oe(new _(95,"scrollPredominantAxis",!0,{description:f.localize(241,null)})),selectionClipboard:Oe(new _(96,"selectionClipboard",!0,{description:f.localize(242,null),included:t.isLinux})),selectionHighlight:Oe(new _(97,"selectionHighlight",!0,{description:f.localize(243,null)})),selectOnLineNumbers:Oe(new _(98,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new S(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(244,null),f.localize(245,null)],description:f.localize(246,null)})),showUnused:Oe(new _(100,"showUnused",!0,{description:f.localize(247,null)})),showDeprecated:Oe(new _(126,"showDeprecated",!0,{description:f.localize(248,null)})),inlayHints:Oe(new X),snippetSuggestions:Oe(new S(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(249,null),f.localize(250,null),f.localize(251,null),f.localize(252,null)],description:f.localize(253,null)})),smartSelect:Oe(new ue),smoothScrolling:Oe(new _(103,"smoothScrolling",!1,{description:f.localize(254,null)})),stopRenderingLineAfter:Oe(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Y),inlineSuggest:Oe(new ne),suggestFontSize:Oe(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(255,null)})),suggestLineHeight:Oe(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(256,null)})),suggestOnTriggerCharacters:Oe(new _(109,"suggestOnTriggerCharacters",!0,{description:f.localize(257,null)})),suggestSelection:Oe(new S(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabCompletion:Oe(new S(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),tabIndex:Oe(new l(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new Q),unusualLineTerminators:Oe(new S(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(266,null),f.localize(267,null),f.localize(268,null)],description:f.localize(269,null)})),useShadowDOM:Oe(new _(115,"useShadowDOM",!0)),useTabStops:Oe(new _(116,"useTabStops",!0,{description:f.localize(270,null)})),wordSeparators:Oe(new m(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(271,null)})),wordWrap:Oe(new S(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(272,null),f.localize(273,null),f.localize(274,null),f.localize(275,null)],description:f.localize(276,null)})),wordWrapBreakAfterCharacters:Oe(new m(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new m(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new l(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(277,null)})),wordWrapOverride1:Oe(new S(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new S(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new o(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ue,{enumDescriptions:[f.localize(278,null),f.localize(279,null),f.localize(280,null),f.localize(281,null)],description:f.localize(282,null)})),wrappingStrategy:Oe(new S(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(283,null),f.localize(284,null)],description:f.localize(285,null)})),editorClassName:Oe(new L),pixelRatio:Oe(new fe),tabFocusMode:Oe(new pe),layoutInfo:Oe(new G),wrappingInfo:Oe(new ze)}}),define(be[160],Ee([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[161],Ee([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[162],Ee([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[163],Ee([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(be[164],Ee([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(be[165],Ee([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(be[166],Ee([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(be[167],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[168],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[169],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(be[170],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[171],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[172],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[173],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[174],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(be[175],Ee([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(be[176],Ee([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(be[177],Ee([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[178],Ee([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(be[179],Ee([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(be[180],Ee([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[181],Ee([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[182],Ee([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(be[183],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var f;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(I=e.EditorOpenSource||(e.EditorOpenSource={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(be[184],Ee([1,0,162]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function T(b){return b=b.trim(),b==="*"||t.test(b)}e.isValidVersionStr=T;function D(b){if(!T(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let C=b.match(t);return C?{hasCaret:C[1]==="^",hasGreaterEquals:C[1]===">=",majorBase:C[2]==="x"?0:parseInt(C[2],10),majorMustEqual:C[2]!=="x",minorBase:C[4]==="x"?0:parseInt(C[4],10),minorMustEqual:C[4]!=="x",patchBase:C[6]==="x"?0:parseInt(C[6],10),patchMustEqual:C[6]!=="x",preRelease:C[8]||null}:null}e.parseVersion=D;function k(b){if(!b)return null;let C=b.majorBase,g=b.majorMustEqual,u=b.minorBase,v=b.minorMustEqual,_=b.patchBase,E=b.patchMustEqual;b.hasCaret&&(C===0||(v=!1),E=!1);let l=0;if(b.preRelease){const d=I.exec(b.preRelease);if(d){const[,m,a,S]=d;l=Date.UTC(Number(m),Number(a)-1,Number(S))}}return{majorBase:C,majorMustEqual:g,minorBase:u,minorMustEqual:v,patchBase:_,patchMustEqual:E,isMinimum:b.hasGreaterEquals,notBefore:l}}e.normalizeVersion=k;function y(b,C,g){let u;typeof b=="string"?u=k(D(b)):u=b;let v;C instanceof Date?v=C.getTime():typeof C=="string"&&(v=new Date(C).getTime());let _;if(typeof g=="string"?_=k(D(g)):_=g,!u||!_)return!1;let E=u.majorBase,l=u.minorBase,d=u.patchBase,m=_.majorBase,a=_.minorBase,S=_.patchBase,o=_.notBefore,i=_.majorMustEqual,s=_.minorMustEqual,n=_.patchMustEqual;return _.isMinimum?E>m?!0:E<m?!1:l>a?!0:l<a||v&&v<o?!1:d>=S:(E===1&&m===0&&(!i||!s||!n)&&(m=1,a=0,S=0,i=!0,s=!1,n=!1),E<m?!1:E>m?!i:l<a?!1:l>a?!s:d<S?!1:d>S?!n:!(v&&v<o))}e.isValidVersion=y;function A(b,C,g,u,v){return u||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:R(b,C,g.engines.vscode,v)}e.isValidExtensionVersion=A;function N(b,C,g){return b==="*"||R(C,g,b)}e.isEngineValid=N;function R(b,C,g,u=[]){let v=k(D(g));if(!v)return u.push(f.localize(0,null,g)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return u.push(f.localize(1,null,g)),!1}else if(!v.majorMustEqual)return u.push(f.localize(2,null,g)),!1;return y(b,C,v)?!0:(u.push(f.localize(3,null,b,g)),!1)}}),define(be[115],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,T=[],D=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=f}),define(be[79],Ee([1,0,115]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(D,k,y){k instanceof f.SyncDescriptor||(k=new f.SyncDescriptor(k,[],y)),t.push([D,k])}e.registerSingleton=I;function T(){return t}e.getSingletonServiceDescriptors=T}),define(be[185],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=f;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let D of this._nodes.values())D.outgoing.size===0&&T.push(D);return T}insertEdge(T,D){const k=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(D);k.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(T),k)}removeNode(T){const D=this._hashFn(T);this._nodes.delete(D);for(let k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(T){const D=this._hashFn(T);let k=this._nodes.get(D);return k||(k=new f(T),this._nodes.set(D,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[D,k]of this._nodes)T.push(`${D}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,D]of this._nodes){const k=new Set([T]),y=this._findCycle(D,k);if(y)return y}}_findCycle(T,D){for(let[k,y]of T.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const A=this._findCycle(y,D);if(A)return A;D.delete(k)}}}e.Graph=t}),define(be[4],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(D,k,y){k[f.DI_TARGET]===k?k[f.DI_DEPENDENCIES].push({id:D,index:y}):(k[f.DI_DEPENDENCIES]=[{id:D,index:y}],k[f.DI_TARGET]=k)}function I(D){if(f.serviceIds.has(D))return f.serviceIds.get(D);const k=function(y,A,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,y,N)};return k.toString=()=>D,f.serviceIds.set(D,k),k}e.createDecorator=I;function T(D){return D}e.refineServiceDecorator=T}),define(be[80],Ee([1,0,14,2,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function T(_){return _&&typeof _=="object"&&(!_.overrideIdentifier||typeof _.overrideIdentifier=="string")&&(!_.resource||_.resource instanceof t.URI)}e.isConfigurationOverrides=T;function D(_){return _&&typeof _=="object"&&(!_.overrideIdentifiers||f.isArray(_.overrideIdentifiers))&&!_.overrideIdentifier&&(!_.resource||_.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var k;(function(_){_[_.USER=1]="USER",_[_.USER_LOCAL=2]="USER_LOCAL",_[_.USER_REMOTE=3]="USER_REMOTE",_[_.WORKSPACE=4]="WORKSPACE",_[_.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",_[_.DEFAULT=6]="DEFAULT",_[_.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(_){switch(_){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function A(_,E){const l=Object.create(null);for(let d in _)N(l,d,_[d],E);return l}e.toValuesTree=A;function N(_,E,l,d){const m=E.split("."),a=m.pop();let S=_;for(let o=0;o<m.length;o++){let i=m[o],s=S[i];switch(typeof s){case"undefined":s=S[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${E} as ${m.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}S=s}if(typeof S=="object"&&S!==null)try{S[a]=l}catch{d(`Ignoring ${E} as ${m.join(".")} is ${JSON.stringify(S)}`)}else d(`Ignoring ${E} as ${m.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=N;function R(_,E){const l=E.split(".");b(_,l)}e.removeFromValueTree=R;function b(_,E){const l=E.shift();if(E.length===0){delete _[l];return}if(Object.keys(_).indexOf(l)!==-1){const d=_[l];typeof d=="object"&&!Array.isArray(d)&&(b(d,E),Object.keys(d).length===0&&delete _[l])}}function C(_,E,l){function d(S,o){let i=S;for(const s of o){if(typeof i!="object"||i===null)return;i=i[s]}return i}const m=E.split("."),a=d(_,m);return typeof a=="undefined"?l:a}e.getConfigurationValue=C;function g(_,E,l){Object.keys(E).forEach(d=>{d!=="__proto__"&&(d in _?f.isObject(_[d])&&f.isObject(E[d])?g(_[d],E[d],l):l&&(_[d]=E[d]):_[d]=E[d])})}e.merge=g;function u(_,E,l){const d=_.inspect(E),m=_.inspect(l);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:d.defaultValue}e.getMigratedSettingValue=u;function v(_){return _.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(be[62],Ee([1,0,13,8,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",f.isMacintosh),T.set("isLinux",f.isLinux),T.set("isWindows",f.isWindows),T.set("isWeb",f.isWeb),T.set("isMacNative",f.isMacintosh&&!f.isWeb),T.set("isEdge",f.isEdge),T.set("isFirefox",f.isFirefox),T.set("isChrome",f.isChrome),T.set("isSafari",f.isSafari);const D=Object.prototype.hasOwnProperty;var k;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return R.INSTANCE}static true(){return b.INSTANCE}static has(p){return C.create(p)}static equals(p,U){return g.create(p,U)}static notEquals(p,U){return _.create(p,U)}static regex(p,U){return o.create(p,U)}static in(p,U){return u.create(p,U)}static not(p){return E.create(p)}static and(...p){return n.create(p,null)}static or(...p){return r.create(p,null,!0)}static greater(p,U){return d.create(p,U)}static greaterEquals(p,U){return m.create(p,U)}static smaller(p,U){return a.create(p,U)}static smallerEquals(p,U){return S.create(p,U)}static deserialize(p,U=!1){if(!!p)return this._deserializeOrExpression(p,U)}static _deserializeOrExpression(p,U){let B=p.split("||");return r.create(B.map(H=>this._deserializeAndExpression(H,U)),null,!0)}static _deserializeAndExpression(p,U){let B=p.split("&&");return n.create(B.map(H=>this._deserializeOne(H,U)),null)}static _deserializeOne(p,U){if(p=p.trim(),p.indexOf("!=")>=0){let B=p.split("!=");return _.create(B[0].trim(),this._deserializeValue(B[1],U))}if(p.indexOf("==")>=0){let B=p.split("==");return g.create(B[0].trim(),this._deserializeValue(B[1],U))}if(p.indexOf("=~")>=0){let B=p.split("=~");return o.create(B[0].trim(),this._deserializeRegexValue(B[1],U))}if(p.indexOf(" in ")>=0){let B=p.split(" in ");return u.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const B=p.split(">=");return m.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const B=p.split(">");return d.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const B=p.split("<=");return S.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const B=p.split("<");return a.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(p)?E.create(p.substr(1).trim()):C.create(p)}static _deserializeValue(p,U){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let B=/^'([^']*)'$/.exec(p);return B?B[1].trim():p}static _deserializeRegexValue(p,U){if((0,t.isFalsyOrWhitespace)(p)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=p.indexOf("/"),H=p.lastIndexOf("/");if(B===H||B<0){if(U)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let re=p.slice(B+1,H),W=p[H+1]==="i"?"i":"";try{return new RegExp(re,W)}catch(F){if(U)throw new Error(`bad regexp-value '${p}', parse error: ${F}`);return console.warn(`bad regexp-value '${p}', parse error: ${F}`),null}}}e.ContextKeyExpr=y;function A(M,p){const U=M?M.substituteConstants():void 0,B=p?p.substituteConstants():void 0;return!U&&!B?!0:!U||!B?!1:U.equals(B)}e.expressionsAreEqualWithConstantSubstitution=A;function N(M,p){return M.cmp(p)}class R{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class b{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}substituteConstants(){return this}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class C{constructor(p,U){this.key=p,this.negated=U,this.type=2}static create(p,U=null){const B=T.get(p);return typeof B=="boolean"?B?b.INSTANCE:R.INSTANCE:new C(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:c(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=T.get(this.key);return typeof p=="boolean"?p?b.INSTANCE:R.INSTANCE:this}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class g{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=4}static create(p,U,B=null){if(typeof U=="boolean")return U?C.create(p,B):E.create(p,B);const H=T.get(p);return typeof H=="boolean"?U===(H?"true":"false")?b.INSTANCE:R.INSTANCE:new g(p,U,B)}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=T.get(this.key);if(typeof p=="boolean"){const U=p?"true":"false";return this.value===U?b.INSTANCE:R.INSTANCE}return this}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class u{constructor(p,U){this.key=p,this.valueKey=U,this.type=10,this.negated=null}static create(p,U){return new u(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}substituteConstants(){return this}evaluate(p){const U=p.getValue(this.valueKey),B=p.getValue(this.key);return Array.isArray(U)?U.indexOf(B)>=0:typeof B=="string"&&typeof U=="object"&&U!==null?D.call(U,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=u;class v{constructor(p){this._actual=p,this.type=11}static create(p){return new v(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new v(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class _{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=5}static create(p,U,B=null){if(typeof U=="boolean")return U?E.create(p,B):C.create(p,B);const H=T.get(p);return typeof H=="boolean"?U===(H?"true":"false")?R.INSTANCE:b.INSTANCE:new _(p,U,B)}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){const p=T.get(this.key);if(typeof p=="boolean"){const U=p?"true":"false";return this.value===U?R.INSTANCE:b.INSTANCE}return this}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class E{constructor(p,U){this.key=p,this.negated=U,this.type=3}static create(p,U=null){const B=T.get(p);return typeof B=="boolean"?B?R.INSTANCE:b.INSTANCE:new E(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:c(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}substituteConstants(){const p=T.get(this.key);return typeof p=="boolean"?p?R.INSTANCE:b.INSTANCE:this}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;function l(M,p){if(typeof M=="string"){const U=parseFloat(M);isNaN(U)||(M=U)}return typeof M=="string"||typeof M=="number"?p(M):R.INSTANCE}class d{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=12}static create(p,U,B=null){return l(U,H=>new d(p,H,B))}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class m{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=13}static create(p,U,B=null){return l(U,H=>new m(p,H,B))}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class a{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=14}static create(p,U,B=null){return l(U,H=>new a(p,H,B))}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class S{constructor(p,U,B){this.key=p,this.value=U,this.negated=B,this.type=15}static create(p,U,B=null){return l(U,H=>new S(p,H,B))}cmp(p){return p.type!==this.type?this.type-p.type:w(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}substituteConstants(){return this}evaluate(p){return typeof this.value=="string"?!1:parseFloat(p.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=S;class o{constructor(p,U){this.key=p,this.regexp=U,this.type=7,this.negated=null}static create(p,U){return new o(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const U=this.regexp?this.regexp.source:"",B=p.regexp?p.regexp.source:"";return U<B?-1:U>B?1:0}equals(p){if(p.type===this.type){const U=this.regexp?this.regexp.source:"",B=p.regexp?p.regexp.source:"";return this.key===p.key&&U===B}return!1}substituteConstants(){return this}evaluate(p){let U=p.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class i{constructor(p){this._actual=p,this.type=8}static create(p){return new i(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}substituteConstants(){return this}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new i(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(M){let p=null;for(let U=0,B=M.length;U<B;U++){const H=M[U].substituteConstants();if(M[U]!==H&&p===null){p=[];for(let re=0;re<U;re++)p[re]=M[re]}p!==null&&(p[U]=H)}return p===null?M:p}class n{constructor(p,U){this.expr=p,this.negated=U,this.type=6}static create(p,U){return n._normalizeArr(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const H=N(this.expr[U],p.expr[U]);if(H!==0)return H}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}substituteConstants(){const p=s(this.expr);return p===this.expr?this:n.create(p,this.negated)}evaluate(p){for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].evaluate(p))return!1;return!0}static _normalizeArr(p,U){const B=[];let H=!1;for(const re of p)if(!!re){if(re.type===1){H=!0;continue}if(re.type===0)return R.INSTANCE;if(re.type===6){B.push(...re.expr);continue}B.push(re)}if(B.length===0&&H)return b.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(N);for(let re=1;re<B.length;re++)B[re-1].equals(B[re])&&(B.splice(re,1),re--);if(B.length===1)return B[0];for(;B.length>1;){const re=B[B.length-1];if(re.type!==9)break;B.pop();const W=B.pop(),F=B.length===0,q=r.create(re.expr.map(G=>n.create([G,W],null)),null,F);q&&(B.push(q),B.sort(N))}return B.length===1?B[0]:new n(B,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new n(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){const p=[];for(let U of this.expr)p.push(U.negate());this.negated=r.create(p,this,!0)}return this.negated}}class r{constructor(p,U){this.expr=p,this.negated=U,this.type=9}static create(p,U,B){return r._normalizeArr(p,U,B)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const H=N(this.expr[U],p.expr[U]);if(H!==0)return H}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}substituteConstants(){const p=s(this.expr);return p===this.expr?this:r.create(p,this.negated,!1)}evaluate(p){for(let U=0,B=this.expr.length;U<B;U++)if(this.expr[U].evaluate(p))return!0;return!1}static _normalizeArr(p,U,B){let H=[],re=!1;if(p){for(let W=0,F=p.length;W<F;W++){const q=p[W];if(!!q){if(q.type===0){re=!0;continue}if(q.type===1)return b.INSTANCE;if(q.type===9){H=H.concat(q.expr);continue}H.push(q)}}if(H.length===0&&re)return R.INSTANCE;H.sort(N)}if(H.length!==0){if(H.length===1)return H[0];for(let W=1;W<H.length;W++)H[W-1].equals(H[W])&&(H.splice(W,1),W--);if(H.length===1)return H[0];if(B){for(let W=0;W<H.length;W++)for(let F=W+1;F<H.length;F++)P(H[W],H[F])&&(H.splice(F,1),F--);if(H.length===1)return H[0]}return new r(H,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new r(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){let p=[];for(let U of this.expr)p.push(U.negate());for(;p.length>1;){const U=p.shift(),B=p.shift(),H=[];for(const W of L(U))for(const F of L(B))H.push(n.create([W,F],null));const re=p.length===0;p.unshift(r.create(H,null,re))}this.negated=p[0]}return this.negated}}class h extends C{constructor(p,U,B){super(p,null);this._defaultValue=U,typeof B=="object"?h._info.push({...B,key:p}):B!==!0&&h._info.push({key:p,description:B,type:U!=null?typeof U:void 0})}static all(){return h._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return g.create(this.key,p)}notEqualsTo(p){return _.create(this.key,p)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function c(M,p){return M<p?-1:M>p?1:0}function w(M,p,U,B){return M<U?-1:M>U?1:p<B?-1:p>B?1:0}function P(M,p){if(p.type===6&&M.type!==9&&M.type!==6){for(const H of p.expr)if(M.equals(H))return!0}const U=M.negate(),B=L(U).concat(L(p));B.sort(N);for(let H=0;H<B.length;H++){const W=B[H].negate();for(let F=H+1;F<B.length;F++){const q=B[F];if(W.equals(q))return!0}}return!1}e.implies=P;function L(M){return M.type===9?M.expr:[M]}}),define(be[186],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(be[116],Ee([1,0,161,4]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(_){switch(_){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function T(_){switch(_){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function D(_,E){switch(_){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function k(_,E){return E==="web"&&!_.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function y(_,E,l){return k(E,l)?!1:_==="undefined"||_==="universal"?!0:_==="unknown"?!1:_===l?!0:A(l).includes(_)}e.isTargetPlatformCompatible=y;function A(_){switch(_){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function N(_){return _&&typeof _=="object"&&typeof _.id=="string"&&(!_.uuid||typeof _.uuid=="string")}e.isIExtensionIdentifier=N;var R;(function(_){_[_.NoneOrRelevance=0]="NoneOrRelevance",_[_.LastUpdatedDate=1]="LastUpdatedDate",_[_.Title=2]="Title",_[_.PublisherName=3]="PublisherName",_[_.InstallCount=4]="InstallCount",_[_.PublishedDate=10]="PublishedDate",_[_.AverageRating=6]="AverageRating",_[_.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var b;(function(_){_[_.Default=0]="Default",_[_.Ascending=1]="Ascending",_[_.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var C;(function(_){_.Install="install",_.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var g;(function(_){_[_.None=1]="None",_[_.Install=2]="Install",_[_.Update=3]="Update",_[_.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var u;(function(_){_.Unsupported="Unsupported",_.UnsupportedPreRelease="UnsupportedPreRelease",_.Malicious="Malicious",_.Incompatible="Incompatible",_.IncompatiblePreRelease="IncompatiblePreRelease",_.IncompatibleTargetPlatform="IncompatibleTargetPlatform",_.ReleaseVersionNotFound="ReleaseVersionNotFound",_.Invalid="Invalid",_.Download="Download",_.Extract="Extract",_.Delete="Delete",_.Rename="Rename",_.CorruptZip="CorruptZip",_.IncompleteZip="IncompleteZip",_.Internal="Internal"})(u=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(E,l){super(E);this.code=l,this.name=l}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,f.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,f.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(be[187],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(be[188],Ee([1,0,39,10,9,13,94,29,113,163,187]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const R=A.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await u.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends b{openTerminal(d,m){return this.spawnTerminal(f,d,y.getWindowsShell(),m)}spawnTerminal(d,m,a,S){const o=m.windowsExec||C.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return d.spawn(o,S?[S]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return o.indexOf(" ")>=0&&s.push('""'),s.push(o),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((n,r)=>{const h=v(process),c=d.spawn(a,s,{cwd:S,env:h});c.on("error",r),c.on("exit",()=>n())})}runInTerminal(d,m,a,S,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:C.getDefaultTerminalWindows();return new Promise((s,n)=>{const r=`"${m} - ${R}"`,h=`""${a.join('" "')}" & pause"`,c=["/c","start",r,"/wait",i,"/c",h],w=Object.assign({},v(process),S);Object.keys(w).filter(M=>w[M]===null).forEach(M=>delete w[M]);const P={cwd:m,env:w,windowsVerbatimArguments:!0};f.spawn(C.CMD,c,P).on("error",M=>{n(_(M))}),s(void 0)})}static getDefaultTerminalWindows(){if(!C._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return C._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=C,C.CMD="cmd.exe";class g extends b{openTerminal(d,m){return this.spawnTerminal(f,d,m)}runInTerminal(d,m,a,S,o){const i=o.osxExec||N.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{if(i===N.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const r=i===N.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",c=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`,J).fsPath,"-t",d||R,"-w",m];for(let L of a)c.push("-a"),c.push(L);if(S){const L=Object.assign({},v(process),S);for(let M in L){const p=L[M];p===null?(c.push("-u"),c.push(M)):(c.push("-e"),c.push(`${M}=${p}`))}}let w="";const P=f.spawn(g.OSASCRIPT,c);P.on("error",L=>{n(_(L))}),P.stderr.on("data",L=>{w+=L.toString()}),P.on("exit",L=>{if(L===0)s(void 0);else if(w){const M=w.split(`
`,1);n(new Error(M[0]))}else n(new Error(A.localize(1,null,r,L)))})}else n(new Error(A.localize(2,null,i)))})}spawnTerminal(d,m,a){const S=m.osxExec||N.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const s=["-a",S];a&&s.push(a);const n=v(process),r=d.spawn("/usr/bin/open",s,{cwd:a,env:n});r.on("error",i),r.on("exit",()=>o())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class u extends b{openTerminal(d,m){return this.spawnTerminal(f,d,m)}runInTerminal(d,m,a,S,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{let r=[];i.then(h=>{h.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const c=`${E(a)}; echo; read -p "${u.WAIT_MESSAGE}" -n1;`;r.push(`''${c}''`);const w=Object.assign({},v(process),S);Object.keys(w).filter(p=>w[p]===null).forEach(p=>delete w[p]);const P={cwd:m,env:w};let L="";const M=f.spawn(h,r,P);M.on("error",p=>{n(_(p))}),M.stderr.on("data",p=>{L+=p.toString()}),M.on("exit",p=>{if(p===0)s(void 0);else if(L){const U=L.split(`
`,1);n(new Error(U[0]))}else n(new Error(A.localize(4,null,h,p)))})})})}static async getDefaultTerminalLinuxReady(){if(!u._DEFAULT_TERMINAL_LINUX_READY)if(!T.isLinux)u._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const d=await k.Promises.exists("/etc/debian_version");u._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{d?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return u._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,m,a){const S=m.linuxExec?Promise.resolve(m.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{S.then(s=>{const n=v(process),r=d.spawn(s,[],{cwd:a,env:n});r.on("error",i),r.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=u,u.WAIT_MESSAGE=A.localize(3,null);function v(l){const d={...l.env};return(0,D.sanitizeProcessEnvironment)(d),d}function _(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(A.localize(5,null,l.path)):l}function E(l){let d="";for(let m of l)m.indexOf(" ")>=0?d+='"'+m+'"':d+=m,d+=" ";return d}}),define(be[42],Ee([1,0,12,24,9,8,14,2,164,4]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function N(F){return F.create===!0}e.isFileOpenForWriteOptions=N;var R;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var b;(function(F){F[F.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var C;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=g;function u(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=u;function v(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=v;function _(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=_;function E(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=E;function l(F){return g(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=l;var d;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(q,G){super(q);this.code=G}}e.FileSystemProviderError=m;function a(F,q){const G=new m(F.toString(),q);return o(G,q),G}e.createFileSystemProviderError=a;function S(F){return F||a((0,y.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=S;function o(F,q){return F.name=q?`${q} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=o;function i(F){if(!F)return d.Unknown;if(F instanceof m)return F.code;const q=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!q)return d.Unknown;switch(q[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=i;function s(F){if(F instanceof P)return F.fileOperationResult;switch(i(F)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(q,G,$){this.resource=q,this.operation=G,this.target=$}isOperation(q){return this.operation===q}}e.FileOperationEvent=r;var h;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class c{constructor(q,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=q;const $=new Map;for(const X of q){const ie=$.get(X.type);switch(ie?ie.push([X.resource,X]):$.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,ie]of $)switch(X){case 1:this.added=t.TernarySearchTree.forUris(()=>G),this.added.fill(ie);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>G),this.updated.fill(ie);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>G),this.deleted.fill(ie);break}}contains(q,...G){return this.doContains(q,{includeChildren:!1},...G)}affects(q,...G){return this.doContains(q,{includeChildren:!0},...G)}doContains(q,G,...$){if(!q)return!1;const X=$.length>0;return!!((!X||$.includes(1))&&(this.added?.get(q)||G.includeChildren&&this.added?.findSuperstr(q))||(!X||$.includes(0))&&(this.updated?.get(q)||G.includeChildren&&this.updated?.findSuperstr(q))||(!X||$.includes(2))&&(this.deleted?.findSubstr(q)||G.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function w(F,q,G){return!F||!q||F===q||q.length>F.length?!1:(q.charAt(q.length-1)!==I.sep&&(q+=I.sep),G?(0,T.startsWithIgnoreCase)(F,q):F.indexOf(q)===0)}e.isParent=w;class P extends f.ErrorNoTelemetry{constructor(q,G,$){super(q);this.fileOperationResult=G,this.options=$}}e.FileOperationError=P;class L extends P{constructor(q,G,$){super(q,2,$);this.stat=G}}e.NotModifiedSinceFileOperationError=L;var M;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=U;async function B(F,q){if(!q.hasProvider(k.URI.from({scheme:F.scheme})))return new Promise(G=>{const $=q.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===F.scheme&&X.added&&($.dispose(),G())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(q){return(0,D.isNumber)(q)||(q=0),q<H.KB?(0,y.localize)(1,null,q.toFixed(0)):q<H.MB?(0,y.localize)(2,null,(q/H.KB).toFixed(2)):q<H.GB?(0,y.localize)(3,null,(q/H.MB).toFixed(2)):q<H.TB?(0,y.localize)(4,null,(q/H.GB).toFixed(2)):(0,y.localize)(5,null,(q/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var re;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function W(F){return{maxFileSize:F===0?300*H.MB:16*H.GB,maxHeapSize:F===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=W}),define(be[81],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[T,D]of I)this.set(T,D)}set(I,T){const D=this._entries.get(I);return this._entries.set(I,T),D}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(be[189],Ee([1,0,15,12,115,185,4,81]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class A extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class N{constructor(g=new k.ServiceCollection,u=!1,v){this._activeInstantiations=new Set,this._services=g,this._strict=u,this._parent=v,this._services.set(D.IInstantiationService,this)}createChild(g){return new N(g,this._strict,this)}invokeFunction(g,...u){let v=b.traceInvocation(g),_=!1;try{return g({get:l=>{if(_)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(l,v);if(!d)throw new Error(`[invokeFunction] unknown service '${l}'`);return d}},...u)}finally{_=!0,v.stop()}}createInstance(g,...u){let v,_;return g instanceof I.SyncDescriptor?(v=b.traceCreation(g.ctor),_=this._createInstance(g.ctor,g.staticArguments.concat(u),v)):(v=b.traceCreation(g),_=this._createInstance(g,u,v)),v.stop(),_}_createInstance(g,u=[],v){let _=D._util.getServiceDependencies(g).sort((d,m)=>d.index-m.index),E=[];for(const d of _){let m=this._getOrCreateServiceInstance(d.id,v);m||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${d.id}.`,!1),E.push(m)}let l=_.length>0?_[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${g.name} at position ${l+1} conflicts with ${u.length} static arguments`);let d=l-u.length;d>0?u=u.concat(new Array(d)):u=u.slice(0,l)}return new g(...[...u,...E])}_setServiceInstance(g,u){if(this._services.get(g)instanceof I.SyncDescriptor)this._services.set(g,u);else if(this._parent)this._parent._setServiceInstance(g,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let u=this._services.get(g);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):u}_getOrCreateServiceInstance(g,u){let v=this._getServiceInstanceOrDescriptor(g);return v instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,u.branch(g,!0)):(u.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,u,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,u,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,u,v){const _=new T.Graph(d=>d.id.toString());let E=0;const l=[{id:g,desc:u,_trace:v}];for(;l.length;){const d=l.pop();if(_.lookupOrInsertNode(d),E++>1e3)throw new A(_);for(let m of D._util.getServiceDependencies(d.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(m.id);if(a||this._throwIfStrict(`[createInstance] ${g} depends on ${m.id} which is NOT registered.`,!0),a instanceof I.SyncDescriptor){const S={id:m.id,desc:a,_trace:d._trace.branch(m.id,!0)};_.insertEdge(d,S),l.push(S)}}}for(;;){const d=_.roots();if(d.length===0){if(!_.isEmpty())throw new A(_);break}for(const{data:m}of d){if(this._getServiceInstanceOrDescriptor(m.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,S)}_.removeNode(m)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,u,v=[],_,E){if(this._services.get(g)instanceof I.SyncDescriptor)return this._createServiceInstance(u,v,_,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,u,v,_,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(g,u=[],v,_){if(v){const E=new f.IdleValue(()=>this._createInstance(g,u,_));return new Proxy(Object.create(null),{get(l,d){if(d in l)return l[d];let m=E.value,a=m[d];return typeof a!="function"||(a=a.bind(m),l[d]=a),a},set(l,d,m){return E.value[d]=m,!0}})}else return this._createInstance(g,u,_)}_throwIfStrict(g,u){if(u&&console.warn(u),this._strict)throw new Error(g)}}e.InstantiationService=N;var R;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(R||(R={}));class b{constructor(g,u){this.type=g,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return y?new b(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(g){return y?new b(0,g.name):b._None}branch(g,u){let v=new b(2,g.toString());return this._dep.push([g,u,v]),v}stop(){let g=Date.now()-this._start;b._totals+=g;let u=!1;function v(E,l){let d=[],m=new Array(E+1).join("	");for(const[a,S,o]of l._dep)if(S&&o){u=!0,d.push(`${m}CREATES -> ${a}`);let i=v(E+1,o);i&&d.push(i)}else d.push(`${m}uses -> ${a}`);return d.join(`
`)}let _=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(g>2||u)&&console.log(_.join(`
`))}}e.Trace=b,b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(be[11],Ee([1,0,49,3,6,13,4]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function A(S,o,i){switch(o){case y.Trace:S.trace(i);break;case y.Debug:S.debug(i);break;case y.Info:S.info(i);break;case y.Warning:S.warn(i);break;case y.Error:S.error(i);break;case y.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=A;function N(S){let o="";for(let i=0;i<S.length;i++){let s=S[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}o+=(i>0?" ":"")+s}return o}e.format=N;class R extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class b extends R{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,N([o,...i]))}debug(o,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,N([o,...i]))}info(o,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,N([o,...i]))}warn(o,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,N([o,...i]))}error(o,...i){if(this.checkLogLevel(y.Error))if(o instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=o.stack,this.log(y.Error,N(s))}else this.log(y.Error,N([o,...i]))}critical(o,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,N([o,...i]))}flush(){}}e.AbstractMessageLogger=b;class C extends R{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...i):console.log(`[main ${k()}]`,o,...i))}debug(o,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...i):console.log(`[main ${k()}]`,o,...i))}info(o,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,o,...i):console.log(`[main ${k()}]`,o,...i))}warn(o,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,o,...i):console.warn(`[main ${k()}]`,o,...i))}error(o,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,o,...i):console.error(`[main ${k()}]`,o,...i))}critical(o,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,o,...i):console.error(`[main ${k()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends R{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class u extends R{constructor(o,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,f.toErrorMessage)(o,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class v extends R{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const s of this.logServices)s.trace(o,...i)}debug(o,...i){for(const s of this.logServices)s.debug(o,...i)}info(o,...i){for(const s of this.logServices)s.info(o,...i)}warn(o,...i){for(const s of this.logServices)s.warn(o,...i)}error(o,...i){for(const s of this.logServices)s.error(o,...i)}critical(o,...i){for(const s of this.logServices)s.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=v;class _ extends I.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=_;class E extends I.Disposable{constructor(o,i){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let s=this.loggers.get(o.toString());return s||(s=this.doCreateLogger(o,i?.always?y.Trace:this.logLevel,i),this.loggers.set(o.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=l;function d(S){if(S.verbose)return y.Trace;if(typeof S.logLevel=="string"){const o=m(S.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function m(S){switch(S){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=m;function a(S){switch(S){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=a}),define(be[190],Ee([1,0,42,11]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,y,A,N,R){try{const b=await new Promise((g,u)=>{J(["spdlog"],g,u)});b.setFlushOn(t.LogLevel.Trace);const C=await b.createAsyncRotatingLogger(k,y,A,N);return R&&C.clearFormatters(),C}catch(b){console.error(b)}return null}function T(k,y,A){switch(y){case t.LogLevel.Trace:k.trace(A);break;case t.LogLevel.Debug:k.debug(A);break;case t.LogLevel.Info:k.info(A);break;case t.LogLevel.Warning:k.warn(A);break;case t.LogLevel.Error:k.error(A);break;case t.LogLevel.Critical:k.critical(A);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(y,A,N,R,b){super();this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(y,A,N,R),this._register(this.onDidChangeLogLevel(C=>{this._logger&&this._logger.setLevel(C)}))}async _createSpdLogLogger(y,A,N,R){const b=N?6:1,C=30/b*f.ByteSize.MB,g=await I(y,A,C,b,R);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:u,message:v}of this.buffer)T(this._logger,u,v);this.buffer=[]}}log(y,A){this._logger?T(this._logger,y,A):this.getLevel()<=y&&this.buffer.push({level:y,message:A})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(be[117],Ee([1,0,47,165,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function A(g,u){return u-g}y.compare=A;const N=Object.create(null);N[y.Error]=(0,t.localize)(0,null),N[y.Warning]=(0,t.localize)(1,null),N[y.Info]=(0,t.localize)(2,null);function R(g){return N[g]||""}y.toString=R;function b(g){switch(g){case f.default.Error:return y.Error;case f.default.Warning:return y.Warning;case f.default.Info:return y.Info;case f.default.Ignore:return y.Hint}}y.fromSeverity=b;function C(g){switch(g){case y.Error:return f.default.Error;case y.Warning:return f.default.Warning;case y.Info:return f.default.Info;case y.Hint:return f.default.Ignore}}y.toSeverity=C}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const A="";function N(b){return R(b,!0)}y.makeKey=N;function R(b,C){let g=[A];return b.source?g.push(b.source.replace("\xA6","\\\xA6")):g.push(A),b.code?typeof b.code=="string"?g.push(b.code.replace("\xA6","\\\xA6")):g.push(b.code.value.replace("\xA6","\\\xA6")):g.push(A),b.severity!==void 0&&b.severity!==null?g.push(D.toString(b.severity)):g.push(A),b.message&&C?g.push(b.message.replace("\xA6","\\\xA6")):g.push(A),b.startLineNumber!==void 0&&b.startLineNumber!==null?g.push(b.startLineNumber.toString()):g.push(A),b.startColumn!==void 0&&b.startColumn!==null?g.push(b.startColumn.toString()):g.push(A),b.endLineNumber!==void 0&&b.endLineNumber!==null?g.push(b.endLineNumber.toString()):g.push(A),b.endColumn!==void 0&&b.endColumn!==null?g.push(b.endColumn.toString()):g.push(A),g.push(A),g.join("\xA6")}y.makeKeyOptionalMessage=R})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(be[191],Ee([1,0,3,47,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=y}),define(be[118],Ee([1,0,6,8,2,4]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(N){return{resolved:N,dispose(){}}}});function D(N,R){return I.URI.isUri(N)?(0,t.equalsIgnoreCase)(N.scheme,R):(0,t.startsWithIgnoreCase)(N,R+":")}e.matchesScheme=D;function k(N,...R){return R.some(b=>D(N,b))}e.matchesSomeScheme=k;function y(N,R){return N.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=y;function A(N){let R;const b=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(N.fragment);return b&&(R={startLineNumber:parseInt(b[1]),startColumn:b[2]?parseInt(b[2]):1,endLineNumber:b[4]?parseInt(b[4]):void 0,endColumn:b[4]?b[5]?parseInt(b[5]):1:void 0},N=N.with({fragment:""})),{selection:R,uri:N}}e.extractSelection=A}),define(be[192],Ee([1,0,10,13,38,23]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const k=t.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const k=(0,T.dirname)(f.FileAccess.asFileUri("",J));D=J.__$__nodeRequire((0,T.joinPath)(k,"product.json").fsPath);const y=J.__$__nodeRequire((0,T.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D});var Be=this&&this.__param||function(J,e){return function(f,t){e(f,t,J)}};define(be[119],Ee([1,0,15,21,6,4]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var D;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(R){this.callback=R}get value(){return this._value}report(R){this._value=R,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let y=class extends I.Disposable{constructor(R,b){super();this.deferred=new f.DeferredPromise,b.withProgress(R,C=>(this.reporter=C,this.lastStep&&C.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(R){this.reporter?this.reporter.report(R):this.lastStep=R}};y=$e([Be(1,e.IProgressService)],y),e.UnmanagedProgress=y;class A extends I.Disposable{constructor(R){super();this.progressIndicator=R,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(R){this.stop();const b=++this.currentOperationId,C=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},R),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>C.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:C.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(R){this.currentOperationId===R&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(be[50],Ee([1,0,55,14]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(D,k){f.ok(t.isString(D)),f.ok(t.isObject(k)),f.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new I}),define(be[193],Ee([1,0,3,50]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,A){this.schemasById[I(y)]=A,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new T;t.Registry.add(e.Extensions.JSONContribution,D)}),define(be[120],Ee([1,0,18,3,14,160,80,193,50]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var A;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(A=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=y.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,S=!0){this.registerConfigurations([a],S)}registerConfigurations(a,S=!0){const o=this.doRegisterConfigurations(a,S);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(a){const S=this.doDeregisterConfigurations(a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}updateConfigurations({add:a,remove:S}){const o=[];o.push(...this.doDeregisterConfigurations(S)),o.push(...this.doRegisterConfigurations(a,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(o)})}registerDefaultConfigurations(a){const S=[],o=[];for(const{overrides:i,source:s}of a)for(const n in i)if(S.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const r={...this.configurationDefaultsOverrides.get(n)?.value||{},...i[n]};this.configurationDefaultsOverrides.set(n,{source:s,value:r});const h=(0,D.getLanguageTagSettingPlainKey)(n),c={type:"object",default:r,description:T.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:r,source:I.isString(s)?void 0:s};o.push(...u(n)),this.configurationProperties[n]=c,this.defaultLanguageConfigurationOverridesNode.properties[n]=c}else{this.configurationDefaultsOverrides.set(n,{value:i[n],source:s});const r=this.configurationProperties[n];r&&(this.updatePropertyDefaultValue(n,r),this.updateSchema(n,r))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const S=[];for(const{overrides:o,source:i}of a)for(const s in o){const n=this.configurationDefaultsOverrides.get(s),r=I.isString(i)?i:i?.id,h=I.isString(n?.source)?n?.source:n?.source?.id;if(r===h)if(S.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const c=this.configurationProperties[s];c&&(this.updatePropertyDefaultValue(s,c),this.updateSchema(s,c))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const S of a)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,S){const o=[];return a.forEach(i=>{o.push(...this.validateAndRegisterProperties(i,S,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),o}doDeregisterConfigurations(a){const S=[],o=i=>{if(i.properties)for(const s in i.properties)S.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s]);i.allOf&&i.allOf.forEach(s=>o(s))};for(const i of a){o(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return S}validateAndRegisterProperties(a,S=!0,o,i,s=3){s=I.isUndefinedOrNull(a.scope)?s:a.scope;let n=[],r=a.properties;if(r)for(let c in r){if(S&&l(c)){delete r[c];continue}const w=r[c];if(w.source=o,w.defaultDefaultValue=r[c].default,this.updatePropertyDefaultValue(c,w),e.OVERRIDE_PROPERTY_REGEX.test(c)?w.scope=void 0:(w.scope=I.isUndefinedOrNull(w.scope)?s:w.scope,w.restricted=I.isUndefinedOrNull(w.restricted)?!!i?.includes(c):w.restricted),r[c].hasOwnProperty("included")&&!r[c].included){this.excludedConfigurationProperties[c]=r[c],delete r[c];continue}else this.configurationProperties[c]=r[c];!r[c].deprecationMessage&&r[c].markdownDeprecationMessage&&(r[c].deprecationMessage=r[c].markdownDeprecationMessage),n.push(c)}let h=a.allOf;if(h)for(let c of h)n.push(...this.validateAndRegisterProperties(c,S,o,i,s));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const S=o=>{let i=o.properties;if(i)for(const n in i)this.updateSchema(n,i[n]);let s=o.allOf;s&&s.forEach(S)};S(a)}updateSchema(a,S){switch(e.allSettings.properties[a]=S,S.scope){case 1:e.applicationSettings.properties[a]=S;break;case 2:e.machineSettings.properties[a]=S;break;case 6:e.machineOverridableSettings.properties[a]=S;break;case 3:e.windowSettings.properties[a]=S;break;case 4:e.resourceSettings.properties[a]=S;break;case 5:e.resourceSettings.properties[a]=S,this.resourceLanguageSettingsSchema.properties[a]=S;break}}removeFromSchema(a,S){switch(delete e.allSettings.properties[a],S.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const S=`[${a}]`,o={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,o),e.allSettings.properties[S]=o,e.applicationSettings.properties[S]=o,e.machineSettings.properties[S]=o,e.machineOverridableSettings.properties[S]=o,e.windowSettings.properties[S]=o,e.resourceSettings.properties[S]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,S){const o=this.configurationDefaultsOverrides.get(a);let i=o?.value,s=o?.source;I.isUndefined(i)&&(i=S.defaultDefaultValue,s=void 0),I.isUndefined(i)&&(i=_(S.type)),S.default=i,S.defaultValueSource=s}}const C="\\[([^\\]]+)\\]",g=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(m){const a=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let S=g.exec(m);for(;S?.length;){const o=S[1].trim();o&&a.push(o),S=g.exec(m)}}return(0,f.distinct)(a)}e.overrideIdentifiersFromKey=u;function v(m){return m.reduce((a,S)=>`${a}[${S}]`,"")}e.keyFromOverrideIdentifiers=v;function _(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const E=new b;y.Registry.add(e.Extensions.Configuration,E);function l(m){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?T.localize(7,null,m):E.getConfigurationProperties()[m]!==void 0?T.localize(8,null,m):null:T.localize(6,null)}e.validateProperty=l;function d(){const m=[],a=E.getConfigurationProperties();for(const S of Object.keys(a))m.push([S,a[S].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=d}),define(be[194],Ee([1,0,18,3,142,6,24,25,14,2,80,120,50]),function(J,e,f,t,I,T,D,k,y,A,N,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class C{constructor(o={},i=[],s=[]){this._contents=o,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,N.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,i){const s=this.getContentsForOverrideIdentifer(i);return s?o?(0,N.getConfigurationValue)(s,o):s:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const s of this.overrides)s.identifiers.includes(o)&&i.push(...s.keys);return f.distinct(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return f.distinct(o)}override(o){let i=this.overrideConfigurations.get(o);return i||(i=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,i)),i}merge(...o){const i=k.deepClone(this.contents),s=k.deepClone(this.overrides),n=[...this.keys];for(const r of o){this.mergeContents(i,r.contents);for(const h of r.overrides){const[c]=s.filter(w=>f.equals(w.identifiers,h.identifiers));c?(this.mergeContents(c.contents,h.contents),c.keys.push(...h.keys),c.keys=f.distinct(c.keys)):s.push(k.deepClone(h))}for(const h of r.keys)n.indexOf(h)===-1&&n.push(h)}return new C(i,n,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const i=this.getContentsForOverrideIdentifer(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const n of f.distinct([...Object.keys(this.contents),...Object.keys(i)])){let r=this.contents[n],h=i[n];h&&(typeof r=="object"&&typeof h=="object"?(r=k.deepClone(r),this.mergeContents(r,h)):r=h),s[n]=r}return new C(s,this.keys,this.overrides)}mergeContents(o,i){for(const s of Object.keys(i)){if(s in o&&y.isObject(o[s])&&y.isObject(i[s])){this.mergeContents(o[s],i[s]);continue}o[s]=k.deepClone(i[s])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?k.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let i=null,s=null;const n=r=>{r&&(s?this.mergeContents(s,r):s=k.deepClone(r))};for(const r of this.overrides)f.equals(r.identifiers,[o])?i=r.contents:r.identifiers.includes(o)&&n(r.contents);return n(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,i){this.addKey(o),(0,N.addToValueTree)(this.contents,o,i,s=>{throw new Error(s)})}removeValue(o){this.removeKey(o)&&(0,N.removeFromValueTree)(this.contents,o)}addKey(o){let i=this.keys.length;for(let s=0;s<i;s++)o.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,o)}removeKey(o){let i=this.keys.indexOf(o);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=C;class g extends C{constructor(o={}){const i=b.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),n=Object.create(null),r=[];for(const h in i){const c=o[h],w=c!==void 0?c:i[h].default;(0,N.addToValueTree)(n,h,w,P=>console.error(`Conflict in default settings: ${P}`))}for(const h of Object.keys(n))R.OVERRIDE_PROPERTY_REGEX.test(h)&&r.push({identifiers:(0,R.overrideIdentifiersFromKey)(h),keys:Object.keys(n[h]),contents:(0,N.toValuesTree)(n[h],c=>console.error(`Conflict in default settings file: ${c}`))});super(n,s,r)}}e.DefaultConfigurationModel=g;class u{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,i){if(!y.isUndefinedOrNull(o)){const s=this.doParseContent(o);this.parseRaw(s,i)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,i){this._raw=o;const{contents:s,keys:n,overrides:r,restricted:h}=this.doParseRaw(o,i);this._configurationModel=new C(s,n,r),this._restrictedConfigurations=h||[]}doParseContent(o){let i={},s=null,n=[],r=[],h=[];function c(P){Array.isArray(n)?n.push(P):s!==null&&(n[s]=P)}let w={onObjectBegin:()=>{let P={};c(P),r.push(n),n=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{let P=[];c(P),r.push(n),n=P,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(P,L,M)=>{h.push({error:P,offset:L,length:M})}};if(o)try{I.visit(o,w),i=n[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(o,i){const s=b.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),n=this.filter(o,s,!0,i);o=n.raw;const r=(0,N.toValuesTree)(o,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),h=Object.keys(o),c=this.toOverrides(o,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:r,keys:h,overrides:c,restricted:n.restricted}}filter(o,i,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:o,restricted:[]};const r={},h=[];for(let c in o)if(R.OVERRIDE_PROPERTY_REGEX.test(c)&&s){const w=this.filter(o[c],i,!1,n);r[c]=w.raw,h.push(...w.restricted)}else{const w=i[c],P=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&h.push(c),(P===void 0||n.scopes===void 0||n.scopes.includes(P))&&(n.skipRestricted&&w?.restricted||(r[c]=o[c]))}return{raw:r,restricted:h}}toOverrides(o,i){const s=[];for(const n of Object.keys(o))if(R.OVERRIDE_PROPERTY_REGEX.test(n)){const r={};for(const h in o[n])r[h]=o[n][h];s.push({identifiers:(0,R.overrideIdentifiersFromKey)(n),keys:Object.keys(r),contents:(0,N.toValuesTree)(r,i)})}return s}}e.ConfigurationModelParser=u;class v extends T.Disposable{constructor(o,i,s,n){super();this.userSettingsResource=o,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class _{constructor(o,i,s=new C,n=new C,r=new D.ResourceMap,h=new C,c=new D.ResourceMap,w=!0){this._defaultConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=r,this._memoryConfiguration=h,this._memoryConfigurationByResource=c,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(o,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(o)}updateValue(o,i,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new C,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(o):n.setValue(o,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,i,s){const n=this.getConsolidateConfigurationModel(i,s),r=this.getFolderConfigurationModelForResource(i.resource,s),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,c=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),L=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),M=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,p=r?i.overrideIdentifier?r.freeze().override(i.overrideIdentifier).getValue(o):r.freeze().getValue(o):void 0,U=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(o):h.getValue(o),B=n.getValue(o),H=f.distinct(f.flatten(n.overrides.map(re=>re.identifiers))).filter(re=>n.getOverrideValue(o,re)!==void 0);return{defaultValue:c,userValue:w,userLocalValue:P,userRemoteValue:L,workspaceValue:M,workspaceFolderValue:p,memoryValue:U,value:B,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:r?.freeze().getValue(o),override:i.overrideIdentifier?r?.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:h.getValue(o),override:i.overrideIdentifier?h.getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(o){const i=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,i){this._folderConfigurations.set(o,i),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const s=[];if(!i){const{added:n,updated:r,removed:h}=m(this._defaultConfiguration,o);i=[...n,...r,...h]}for(const n of i)for(const r of(0,R.overrideIdentifiersFromKey)(n)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(r),c=o.getKeysForOverrideIdentifier(r),w=[...c.filter(P=>h.indexOf(P)===-1),...h.filter(P=>c.indexOf(P)===-1),...h.filter(P=>!k.equals(this._defaultConfiguration.override(r).getValue(P),o.override(r).getValue(P)))];s.push([r,w])}return this.updateDefaultConfiguration(o),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:s,removed:n,overrides:r}=m(this.localUserConfiguration,o),h=[...i,...s,...n];return h.length&&this.updateLocalUserConfiguration(o),{keys:h,overrides:r}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:s,removed:n,overrides:r}=m(this.remoteUserConfiguration,o);let h=[...i,...s,...n];return h.length&&this.updateRemoteUserConfiguration(o),{keys:h,overrides:r}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:s,removed:n,overrides:r}=m(this.workspaceConfiguration,o);let h=[...i,...s,...n];return h.length&&this.updateWorkspaceConfiguration(o),{keys:h,overrides:r}}compareAndUpdateFolderConfiguration(o,i){const s=this.folderConfigurations.get(o),{added:n,updated:r,removed:h,overrides:c}=m(s,i);let w=[...n,...r,...h];return(w.length||!s)&&this.updateFolderConfiguration(o,i),{keys:w,overrides:c}}compareAndDeleteFolderConfiguration(o){const i=this.folderConfigurations.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:s,updated:n,removed:r,overrides:h}=m(i,void 0);return{keys:[...s,...n,...r],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,i){let s=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier?s.override(o.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:o},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&o){const n=i.getFolder(o);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const r=this._memoryConfigurationByResource.get(o);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let i=this._foldersConsolidatedConfigurations.get(o);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(o);n?(i=s.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(o,i)):i=s}return i}getFolderConfigurationModelForResource(o,i){if(i&&o){const s=i.getFolder(o);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,i)=>{const{contents:s,overrides:n,keys:r}=this._folderConfigurations.get(i);return o.push([i,{contents:s,overrides:n,keys:r}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>o.add(i)),this.userConfiguration.freeze().keys.forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>o.add(s))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>o.add(s))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n))),[...i.values()]}static parse(o){const i=this.parseConfigurationModel(o.defaults),s=this.parseConfigurationModel(o.user),n=this.parseConfigurationModel(o.workspace),r=o.folders.reduce((h,c)=>(h.set(A.URI.revive(c[0]),this.parseConfigurationModel(c[1])),h),new D.ResourceMap);return new _(i,s,new C,n,r,new C,new D.ResourceMap,!1)}static parseConfigurationModel(o){return new C(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=_;function E(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const o=new Set,i=new Map;for(const n of S)n.keys.forEach(r=>o.add(r)),n.overrides.forEach(([r,h])=>{const c=(0,D.getOrSet)(i,r,new Set);h.forEach(w=>c.add(w))});const s=[];return i.forEach((n,r)=>s.push([r,[...n.values()]])),{keys:[...o.values()],overrides:s}}e.mergeChanges=E;class l{constructor(o,i,s,n){this.change=o,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const r=new Set;o.keys.forEach(c=>r.add(c)),o.overrides.forEach(([,c])=>c.forEach(w=>r.add(w))),this.affectedKeys=[...r.values()];const h=new C;this.affectedKeys.forEach(c=>h.setValue(c,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=_.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(o,i,this.currentWorkspace);return!k.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(o,i){let s=(0,N.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(o=o[n],!o)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=l;class d extends l{constructor(o,i,s,n){super({keys:o.allKeys(),overrides:[]},void 0,o,i);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=d;function m(S,o){const{added:i,removed:s,updated:n}=a(o,S),r=[],h=S?.getAllOverrideIdentifiers()||[],c=o?.getAllOverrideIdentifiers()||[];if(o){const w=c.filter(P=>!h.includes(P));for(const P of w)r.push([P,o.getKeysForOverrideIdentifier(P)])}if(S){const w=h.filter(P=>!c.includes(P));for(const P of w)r.push([P,S.getKeysForOverrideIdentifier(P)])}if(o&&S){for(const w of h)if(c.includes(w)){const P=a({contents:S.getOverrideValue(void 0,w)||{},keys:S.getKeysForOverrideIdentifier(w)},{contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)});r.push([w,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:s,updated:n,overrides:r}}function a(S,o){const i=S?o?S.keys.filter(r=>o.keys.indexOf(r)===-1):[...S.keys]:[],s=o?S?o.keys.filter(r=>S.keys.indexOf(r)===-1):[...o.keys]:[],n=[];if(S&&o){for(const r of o.keys)if(S.keys.indexOf(r)!==-1){const h=(0,N.getConfigurationValue)(o.contents,r),c=(0,N.getConfigurationValue)(S.contents,r);k.equals(h,c)||n.push(r)}}return{added:i,removed:s,updated:n}}}),define(be[121],Ee([1,0,12,4]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends f.ErrorNoTelemetry{constructor(k,y=I.Unknown,A){super(k);this._message=k,this._code=y,this._detail=A,this.isHandled=y===I.NotAvailable&&A===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(k){return k instanceof T&&k._code===I.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof T&&k._code===I.NoResolverFound}static isHandled(k){return k instanceof T&&k.isHandled}}e.RemoteAuthorityResolverError=T}),define(be[122],Ee([1,0,10]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===f.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function I(T){if(!T)return;const D=T.indexOf("+");return D<0?T:T.substr(0,D)}e.getRemoteName=I}),define(be[28],Ee([1,0,8,4,122]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}e.getWorkspaceSupportTypeMessage=T;function D(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var y;(function(C){C.WIN32_X64="win32-x64",C.WIN32_IA32="win32-ia32",C.WIN32_ARM64="win32-arm64",C.LINUX_X64="linux-x64",C.LINUX_ARM64="linux-arm64",C.LINUX_ARMHF="linux-armhf",C.ALPINE_X64="alpine-x64",C.ALPINE_ARM64="alpine-arm64",C.DARWIN_X64="darwin-x64",C.DARWIN_ARM64="darwin-arm64",C.WEB="web",C.UNIVERSAL="universal",C.UNKNOWN="unknown",C.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class A{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,u){if(typeof g=="undefined"||g===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof g=="string"||typeof u=="string"){let v=typeof g=="string"?g:g.value,_=typeof u=="string"?u:u.value;return f.equalsIgnoreCase(v,_)}return g._lower===u._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=A;function N(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=N;function R(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function b(C,g){if(g){const u=`onResolveRemoteAuthority:${(0,I.getRemoteName)(g)}`;return C.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[195],Ee([1,0,8,116,28,13,2,12,38]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,f.compareIgnoreCase)(o.id,i.id)===0}e.areSameExtensions=A;const N=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(i,s,n="undefined"){this.version=s,this.targetPlatform=n,this.id=i.id}static create(i){const s=i.manifest?i.manifest.version:i.version,n=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new R(i.identifier,s,n)}static parse(i){const s=N.exec(i);return s&&s[1]&&s[2]?new R({id:s[1]},s[2],s[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof R?A(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=R;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(o){const i=b.exec(o);return i&&i[1]?[u(i[1]),i[2]]:[u(o),void 0]}e.getIdAndVersion=C;function g(o,i){return`${o}.${i}`}e.getExtensionId=g;function u(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function v(o,i){return u(g(o,i))}e.getGalleryExtensionId=v;function _(o,i){const s=[],n=r=>{for(const h of s)if(h.some(c=>A(i(c),i(r))))return h;return null};for(const r of o){const h=n(r);h?h.push(r):s.push([r])}return s}e.groupByExtension=_;function E(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function l(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=l,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(o){const i=new Set;if(o.malicious)for(const s of o.malicious)i.add(s.id);return i}e.getMaliciousExtensionsSet=d;function m(o,i){const s=[],n=i.manifest.extensionDependencies?.slice(0)??[];for(;n.length;){const r=n.shift();if(r&&s.every(h=>!A(h.identifier,{id:r}))){const h=o.filter(c=>A(c.identifier,{id:r}));h.length===1&&(s.push(h[0]),n.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=m;async function a(o,i){if(!T.isLinux)return!1;let s;try{s=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){i.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(r))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function S(o,i){const s=await a(o,i),n=(0,t.getTargetPlatform)(s?"alpine":T.platform,y.arch);return i.debug("ComputeTargetPlatform:",n),n}e.computeTargetPlatform=S}),define(be[196],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((I,T)=>J(["vsda"],I,T))}async createNewMessage(I){try{const T=await this.vsda(),D=new T.validator;if(D){const k=String(f._nextId++);return this.validators.set(k,D),{id:k,data:D.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,T){if(!I.id)return!0;const D=this.validators.get(I.id);if(!D)return!1;this.validators.delete(I.id);try{return D.validate(T)==="ok"}catch{return!1}}async sign(I){try{const T=await this.vsda(),D=new T.signer;if(D)return D.sign(I)}catch{}return I}}e.SignService=f,f._nextId=1}),define(be[197],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,T,D=5){let k;return k=T(y=>{const A=typeof y=="string"?y:y.data;let N=this._terminalBufferMap.get(I);if(N){N.data.push(A);return}const R=setTimeout(()=>this.flushBuffer(I),D);N={data:[A],timeoutId:R,dispose:()=>{clearTimeout(R),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,N)}),k}stopBuffering(I){const T=this._terminalBufferMap.get(I);T&&T.dispose()}flushBuffer(I){const T=this._terminalBufferMap.get(I);T&&(this._terminalBufferMap.delete(I),this._callback(I,T.data.join("")))}}e.TerminalDataBufferer=f}),define(be[198],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var f;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST_DARK="hcDark",I.HIGH_CONTRAST_LIGHT="hcLight"})(f=e.ColorScheme||(e.ColorScheme={}));function t(I){return I===f.HIGH_CONTRAST_DARK||I===f.HIGH_CONTRAST_LIGHT}e.isHighContrast=t}),define(be[82],Ee([1,0,73,3,6,4,50,198]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var y;(function(v){function _(E){return E&&typeof E=="object"&&typeof E.id=="string"}v.isThemeColor=_})(y=e.ThemeColor||(e.ThemeColor={}));function A(v){return{id:v}}e.themeColorFromId=A;var N;(function(v){function _(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}v.isThemeIcon=_;const E=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const s=E.exec(i);if(!s)return;let[,n]=s;return{id:n}}v.fromString=l;function d(i){return{id:i}}v.fromId=d;function m(i,s){let n=i.id;const r=n.lastIndexOf("~");return r!==-1&&(n=n.substring(0,r)),s&&(n=`${n}~${s}`),{id:n}}v.modify=m;function a(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}v.getModifier=a;function S(i,s){return i.id===s.id&&i.color?.id===s.color?.id}v.isEqual=S;function o(i,s){return{id:i.id,color:s?A(s):void 0}}v.asThemeIcon=o,v.asClassNameArray=f.CSSIcon.asClassNameArray,v.asClassName=f.CSSIcon.asClassName,v.asCSSSelector=f.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function R(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(_){return this.themingParticipants.push(_),this.onThemingParticipantAddedEmitter.fire(_),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(_);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let C=new b;D.Registry.add(e.Extensions.ThemingContribution,C);function g(v){return C.onColorThemeChange(v)}e.registerThemingParticipant=g;class u extends I.Disposable{constructor(_){super();this.themeService=_,this.theme=_.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(_){this.theme=_,this.updateStyles()}updateStyles(){}getColor(_,E){let l=this.theme.getColor(_);return l&&E&&(l=E(l,this.theme)),l?l.toString():null}}e.Themable=u}),define(be[123],Ee([1,0,3,13,4,11]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var D;(function(g){g.Http="http",g.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function R(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=R;function b(g,u){return u?u!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=b;let C=class{constructor(u){this.logService=u,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],v=Array.from(this._tunnels.values());for(let _ of v){const E=Array.from(_.values());for(let l of E){const d=await l.value;d&&u.push(d)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:v}of u.values())await v.then(_=>_?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,v,_,E,l=!1,d=k.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${E}.`),!u)return;v||(v="localhost");const a=this.retainOrCreateTunnel(u,v,_,E,l,d,m);return a?a.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(S);return(S.tunnelRemoteHost!==v||S.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const v=this._tunnels.get(u.tunnelRemoteHost);if(v){const _=v.get(u.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,_))}}}}async tryDisposeTunnel(u,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${v}.`);const E=_.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(v),E}}async closeTunnel(u,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${v} `);const _=this._tunnels.get(u);if(_&&_.has(v)){const E=_.get(v);E.refcount=0,await this.tryDisposeTunnel(u,v,E)}}addTunnelToMap(u,v,_){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(u,v){const _=this._tunnels.get(u);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,v){let _=[u];N(u)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):R(u)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const E=_.map(l=>this._tunnels.get(l));for(const l of E){const d=l?.get(v);if(d)return d}}canTunnel(u){return!!A(u)}createWithProvider(u,v,_,E,l,d,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${E}.`);const S={elevationRequired:l?b(E===void 0?_:E):!1},o={remoteAddress:{host:v,port:_},localAddressPort:E,privacy:d,public:d!==k.Private,protocol:m},i=u.forwardPort(o,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(v,_,i),i}};C=$e([Be(0,T.ILogService)],C),e.AbstractTunnelService=C}),define(be[199],Ee([1,0,10]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(y){return y.scheme!==f.Schemas.file&&y.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=t;function I(y){if(y.folders.length)return y.folders.every(A=>t(A.uri))?y.folders[0].uri:void 0;if(y.configuration&&t(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function T(y){return I(y)?.scheme}e.getVirtualWorkspaceScheme=T;function D(y){return I(y)?.authority}e.getVirtualWorkspaceAuthority=D;function k(y){return I(y)!==void 0}e.isVirtualWorkspace=k}),define(be[43],Ee([1,0,166,9,24,23,2,4,10]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function A(o){const i=o;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=A;function N(o){if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=N;function R(o){const i=o;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=R;function b(o){const i=o;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const s=o;if(s?.configPath)return{id:s.id,configPath:D.URI.revive(s.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=b;var C;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function g(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=g;function u(o){const i=o;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=u;class v{constructor(i,s,n,r,h){this._id=i,this._transient=n,this._configuration=r,this._ignorePathCasing=h,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class _{constructor(i,s){this.raw=s,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,T.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=_;function E(o){return new _({uri:o,index:0,name:(0,T.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace";const l=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,f.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(o,i){return T.extUriBiasedIgnorePathCase.isEqualOrParent(o,i.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function m(o){let i;return D.URI.isUri(o)?i=o:i=o.configuration,i?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=m;function a(o,i){return!d(o,i)&&!m(o)}e.isSavedWorkspace=a;function S(o){return(typeof o=="string"?(0,t.extname)(o):(0,T.extname)(o))===l}e.hasWorkspaceFileExtension=S}),define(be[83],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const T=this._idPool++;return this._data.set(T,I),this.logDebugInfo(),T}get(I,T){return this._data.has(I)?this._data.get(I)[T]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(be[44],Ee([1,0,10,23,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const y=this._providerInfo.get(k.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(k,y){y===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,y)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(be[26],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(be[200],Ee([1,0,15]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,k,y){this._deferredPromises=new Map,this._id=D,this._shared=k,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of A.values())N.complete()}catch(N){for(const R of A.values())R.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,k){let y=this._value[D];return typeof y=="undefined"&&(y=k),y}update(D,k){this._value[D]=k;let y=this._deferredPromises.get(D);if(y!==void 0)return y.p;const A=new f.DeferredPromise;return this._deferredPromises.set(D,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(D,k){super(D.identifier.value,!0,k);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=I}),define(be[201],Ee([1,0,3,2,11]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(k,y){this._logService=k,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new f.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(k,y,A,N){const b=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(y.value,A,N);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(k,y){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(y)}$acceptModelSaved(k){const y=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(k,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,y);const A=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));A.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};T=$e([Be(0,I.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(be[17],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[202],Ee([1,0,28,3]),function(J,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,y){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(k.identifier),Ye(this,I,y,"f"),Le(this,I,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(k){return Le(this,I,"f").get(this._id,k)}store(k,y){return Le(this,I,"f").store(this._id,k,y)}delete(k){return Le(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=T,I=new WeakMap}),define(be[124],Ee([1,0,4,3]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(D,k){this._level=D,this._productConfig=k||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(be[63],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(E,l)=>{const d={controllerId:l};return t.set(E,d),d};e.createPrivateApiFor=I;const T=E=>t.get(E);e.getPrivateApiFor=T;const D=(E,l,d,m)=>{let a=d;return{enumerable:!0,configurable:!1,get(){return a},set(S){if(!m(a,S)){const o=a;a=S,E.listener?.({op:3,key:l,value:S,previous:o})}}}},k=(E,l)=>E===l,y={range:(E,l)=>E===l?!0:!E||!l?!1:E.isEqual(l),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(E,l)=>!(E.length!==l.length||E.some(d=>!l.find(m=>d.id===m.id)))},A=Object.keys(y),N=(E,l)=>({range:D(E,"range",void 0,y.range),label:D(E,"label",l,y.label),description:D(E,"description",void 0,y.description),sortText:D(E,"sortText",void 0,y.sortText),canResolveChildren:D(E,"canResolveChildren",!1,y.canResolveChildren),busy:D(E,"busy",!1,y.busy),error:D(E,"error",void 0,y.error),tags:D(E,"tags",[],y.tags)}),R=(E,l)=>{const d=new Map;for(const m of A)y[m](E[m],l[m])||d.set(m,l[m]);return d};e.diffTestItems=R;class b extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=b;class C extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=C;class g extends Error{constructor(l,d,m){super(`TestItem with ID "${l}" is from controller "${d}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=g;const u=E=>{const l=(0,e.getPrivateApiFor)(E);let d=new Map;return{get size(){return d.size},forEach(m,a){for(const S of d.values())m.call(a,S,this)},replace(m){const a=new Map,S=new Set(d.keys()),o={op:4,ops:[]};for(const i of m){if(!(i instanceof v))throw new C(i.id);const s=(0,e.getPrivateApiFor)(i).controllerId;if(s!==l.controllerId)throw new g(i.id,s,l.controllerId);if(a.has(i.id))throw new b(i.id);a.set(i.id,i),S.delete(i.id),o.ops.push({op:0,item:i})}for(const i of S.keys())o.ops.push({op:1,id:i});l.listener?.(o),d=a},add(m){if(!(m instanceof v))throw new C(m.id);d.set(m.id,m),l.listener?.({op:0,item:m})},delete(m){d.delete(m)&&l.listener?.({op:1,id:m})},get(m){return d.get(m)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class v{constructor(l,d,m,a){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const S=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof _?void 0:S.parent}},children:{value:u(this),enumerable:!0,writable:!1},...N(S,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class _ extends v{constructor(l,d){super(l,l,d,void 0)}}e.TestItemRootImpl=_}),define(be[51],Ee([1,0,4,123,3,17]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(y){function A(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public,privacy:R.privacy??(R.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:R.protocol}}y.fromApiTunnel=A;function N(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.privacy!==t.TunnelPrivacyId.ConstantPrivate&&R.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:R.privacy,protocol:R.protocol}}y.fromServiceTunnel=N})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let k=class{constructor(A){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,N){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,N){return{dispose:()=>{}}}async $providePortAttributes(A,N,R,b,C){return[]}async $forwardPort(A,N){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([Be(0,T.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[7],Ee([1,0,18,12,100,24,93,8,14,2,32,42,121]),function(J,e,f,t,I,T,D,k,y,A,N,R,b){"use strict";var C,g,u,v,_,E,l,d,m,a,S,o,i,s,n,r,h,c,w,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(V){function z(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(z,V),Object.setPrototypeOf(z.prototype,V.prototype),z}let M=_=class{constructor(z){C.set(this,void 0),Ye(this,C,z,"f")}static from(...z){let he=z;return new _(function(){if(he){for(const Pe of he)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();he=void 0}})}dispose(){typeof Le(this,C,"f")=="function"&&(Le(this,C,"f").call(this),Ye(this,C,void 0,"f"))}};C=new WeakMap,M=_=$e([L],M),e.Disposable=M;let p=E=class{constructor(z,he){if(z<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=z,this._character=he}static Min(...z){if(z.length===0)throw new TypeError;let he=z[0];for(let Pe=1;Pe<z.length;Pe++){const Ge=z[Pe];Ge.isBefore(he)&&(he=Ge)}return he}static Max(...z){if(z.length===0)throw new TypeError;let he=z[0];for(let Pe=1;Pe<z.length;Pe++){const Ge=z[Pe];Ge.isAfter(he)&&(he=Ge)}return he}static isPosition(z){if(!z)return!1;if(z instanceof E)return!0;let{line:he,character:Pe}=z;return typeof he=="number"&&typeof Pe=="number"}static of(z){if(z instanceof E)return z;if(this.isPosition(z))return new E(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,he=0){if(z===null||he===null)throw(0,t.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=0:typeof z=="number"?Pe=z:(Pe=typeof z.lineDelta=="number"?z.lineDelta:0,he=typeof z.characterDelta=="number"?z.characterDelta:0),Pe===0&&he===0?this:new E(this.line+Pe,this.character+he)}with(z,he=this.character){if(z===null||he===null)throw(0,t.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=this.line:typeof z=="number"?Pe=z:(Pe=typeof z.line=="number"?z.line:this.line,he=typeof z.character=="number"?z.character:this.character),Pe===this.line&&he===this.character?this:new E(Pe,he)}toJSON(){return{line:this.line,character:this.character}}};p=E=$e([L],p),e.Position=p;let U=l=class{constructor(z,he,Pe,Ge){let Ze,tt;if(typeof z=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Ze=new p(z,he),tt=new p(Pe,Ge)):p.isPosition(z)&&p.isPosition(he)&&(Ze=p.of(z),tt=p.of(he)),!Ze||!tt)throw new Error("Invalid arguments");Ze.isBefore(tt)?(this._start=Ze,this._end=tt):(this._start=tt,this._end=Ze)}static isRange(z){return z instanceof l?!0:z?p.isPosition(z.start)&&p.isPosition(z.end):!1}static of(z){if(z instanceof l)return z;if(this.isRange(z))return new l(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(z){return l.isRange(z)?this.contains(z.start)&&this.contains(z.end):p.isPosition(z)?!(p.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const he=p.Max(z.start,this._start),Pe=p.Min(z.end,this._end);if(!he.isAfter(Pe))return new l(he,Pe)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const he=p.Min(z.start,this._start),Pe=p.Max(z.end,this.end);return new l(he,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,he=this.end){if(z===null||he===null)throw(0,t.illegalArgument)();let Pe;return z?p.isPosition(z)?Pe=z:(Pe=z.start||this.start,he=z.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&he.isEqual(this.end)?this:new l(Pe,he)}toJSON(){return[this.start,this.end]}};U=l=$e([L],U),e.Range=U;let B=d=class extends U{constructor(z,he,Pe,Ge){let Ze,tt;if(typeof z=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Ze=new p(z,he),tt=new p(Pe,Ge)):p.isPosition(z)&&p.isPosition(he)&&(Ze=p.of(z),tt=p.of(he)),!Ze||!tt)throw new Error("Invalid arguments");super(Ze,tt);this._anchor=Ze,this._active=tt}static isSelection(z){return z instanceof d?!0:z?U.isRange(z)&&p.isPosition(z.anchor)&&p.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=d=$e([L],B),e.Selection=B;class H{constructor(z,he,Pe){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(he),this.connectionToken=Pe}}e.ResolvedAuthority=H;class re extends Error{constructor(z,he=b.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(z);this._message=z,this._code=he,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(z,he){return new re(z,b.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(z){return new re(z,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var W;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var F;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=m=class{constructor(z,he){this._range=z,this._newText=he}static isTextEdit(z){return z instanceof m?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,he){return new m(z,he)}static insert(z,he){return m.replace(new U(z,z),he)}static delete(z){return m.replace(z,"")}static setEndOfLine(z){const he=new m(new U(new p(0,0),new p(0,0)),"");return he.newEol=z,he}get range(){return this._range}set range(z){if(z&&!U.isRange(z))throw(0,t.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,t.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,t.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=m=$e([L],q),e.TextEdit=q;var G;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(G=e.FileEditType||(e.FileEditType={}));let $=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,he,Pe,Ge){this._edits.push({_type:1,from:z,to:he,options:Pe,metadata:Ge})}createFile(z,he,Pe){this._edits.push({_type:1,from:void 0,to:z,options:he,metadata:Pe})}deleteFile(z,he,Pe){this._edits.push({_type:1,from:z,to:void 0,options:he,metadata:Pe})}replaceNotebookMetadata(z,he,Pe){this._edits.push({_type:3,metadata:Pe,uri:z,edit:{editType:5,metadata:he},notebookMetadata:he})}replaceNotebookCells(z,he,Pe,Ge,Ze){let tt,nt,Dt=[],Lt;if(ut.isNotebookRange(he)&&Vt.isNotebookCellDataArray(Pe)&&!Vt.isNotebookCellDataArray(Ge)?(tt=he.start,nt=he.end,Dt=Pe,Lt=Ge):typeof he=="number"&&typeof Pe=="number"&&Vt.isNotebookCellDataArray(Ge)&&(tt=he,nt=Pe,Dt=Ge,Lt=Ze),tt===void 0||nt===void 0)throw new Error("Invalid arguments");(tt!==nt||Dt.length>0)&&this._edits.push({_type:5,uri:z,index:tt,count:nt-tt,cells:Dt,metadata:Lt})}replaceNotebookCellMetadata(z,he,Pe,Ge){this._edits.push({_type:3,metadata:Ge,uri:z,edit:{editType:8,index:he,metadata:Pe}})}replace(z,he,Pe,Ge){this._edits.push({_type:2,uri:z,edit:new q(he,Pe),metadata:Ge})}insert(z,he,Pe,Ge){this.replace(z,new U(he,he),Pe,Ge)}delete(z,he,Pe){this.replace(z,he,"",Pe)}has(z){return this._edits.some(he=>he._type===2&&he.uri.toString()===z.toString())}set(z,he){if(he)for(const Pe of he)Pe&&this._edits.push({_type:2,uri:z,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ge=this._edits[Pe];Ge._type===2&&Ge.uri.toString()===z.toString()&&(this._edits[Pe]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(z){const he=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===z.toString()&&he.push(Pe.edit);return he}entries(){const z=new T.ResourceMap;for(let he of this._edits)if(he._type===2){let Pe=z.get(he.uri);Pe||(Pe=[he.uri,[]],z.set(he.uri,Pe)),Pe[1].push(he.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};$=$e([L],$),e.WorkspaceEdit=$;let X=a=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof a?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=a._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,he=this._tabstop++){if(typeof z=="function"){const Pe=new a;Pe._tabstop=this._tabstop,z(Pe),this._tabstop=Pe._tabstop,z=Pe.value}else z=a._escape(z);return this.value+="${",this.value+=he,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,he=this._tabstop++){const Pe=z.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(z,he){if(typeof he=="function"){const Pe=new a;Pe._tabstop=this._tabstop,he(Pe),this._tabstop=Pe._tabstop,he=Pe.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,he&&(this.value+=":",this.value+=he),this.value+="}",this}};X=a=$e([L],X),e.SnippetString=X;var ie;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(ie=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let le=S=class{constructor(z,he){if(this.uri=z,he)if(U.isRange(he))this.range=U.of(he);else if(p.isPosition(he))this.range=new U(he,he);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof S?!0:z?U.isRange(z.range)&&A.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};le=S=$e([L],le),e.Location=le;let se=class{constructor(z,he){this.location=z,this.message=he}static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&A.URI.isUri(z.location.uri):!1}static isEqual(z,he){return z===he?!0:!z||!he?!1:z.message===he.message&&z.location.range.isEqual(he.location.range)&&z.location.uri.toString()===he.location.uri.toString()}};se=$e([L],se),e.DiagnosticRelatedInformation=se;let ee=class{constructor(z,he,Pe=ae.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=z,this.message=he,this.severity=Pe}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,he){return z===he?!0:!z||!he?!1:z.message===he.message&&z.severity===he.severity&&z.code===he.code&&z.severity===he.severity&&z.source===he.source&&z.range.isEqual(he.range)&&(0,f.equals)(z.tags,he.tags)&&(0,f.equals)(z.relatedInformation,he.relatedInformation,se.isEqual)}};ee=$e([L],ee),e.Diagnostic=ee;let fe=class{constructor(z,he){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=he}};fe=$e([L],fe),e.Hover=fe;var ge;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ye=class{constructor(z,he=ge.Text){this.range=z,this.kind=he}toJSON(){return{range:this.range,kind:ge[this.kind]}}};ye=$e([L],ye),e.DocumentHighlight=ye;var Ne;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var Se;(function(V){V[V.Deprecated=1]="Deprecated"})(Se=e.SymbolTag||(e.SymbolTag={}));let _e=o=class{constructor(z,he,Pe,Ge,Ze){this.name=z,this.kind=he,this.containerName=Ze,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof le?this.location=Ge:Pe instanceof U&&(this.location=new le(Ge,Pe)),o.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};_e=o=$e([L],_e),e.SymbolInformation=_e;let Ie=i=class{constructor(z,he,Pe,Ge,Ze){this.name=z,this.detail=he,this.kind=Pe,this.range=Ge,this.selectionRange=Ze,this.children=[],i.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(i.validate)}};Ie=i=$e([L],Ie),e.DocumentSymbol=Ie;var de;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(de=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Q=class{constructor(z,he){this.title=z,this.kind=he}};Q=$e([L],Q),e.CodeAction=Q;let ne=s=class{constructor(z){this.value=z}append(z){return new s(this.value?this.value+s.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+s.sep)}};ne.sep=".",ne=s=$e([L],ne),e.CodeActionKind=ne,ne.Empty=new ne(""),ne.QuickFix=ne.Empty.append("quickfix"),ne.Refactor=ne.Empty.append("refactor"),ne.RefactorExtract=ne.Refactor.append("extract"),ne.RefactorInline=ne.Refactor.append("inline"),ne.RefactorRewrite=ne.Refactor.append("rewrite"),ne.Source=ne.Empty.append("source"),ne.SourceOrganizeImports=ne.Source.append("organizeImports"),ne.SourceFixAll=ne.Source.append("fixAll");let O=class{constructor(z,he){if(this.range=z,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};O=$e([L],O),e.SelectionRange=O;class x{constructor(z,he,Pe,Ge,Ze,tt){this.kind=z,this.name=he,this.detail=Pe,this.uri=Ge,this.range=Ze,this.selectionRange=tt}}e.CallHierarchyItem=x;class j{constructor(z,he){this.fromRanges=he,this.from=z}}e.CallHierarchyIncomingCall=j;class Y{constructor(z,he){this.fromRanges=he,this.to=z}}e.CallHierarchyOutgoingCall=Y;var ue;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(ue=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let pe=class{constructor(z,he){this.range=z,this.command=he}get isResolved(){return!!this.command}};pe=$e([L],pe),e.CodeLens=pe;let De=n=class{constructor(z,he=!1){g.set(this,void 0),Ye(this,g,new I.MarkdownString(z,{supportThemeIcons:he}),"f")}static isMarkdownString(z){return z instanceof n?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Le(this,g,"f").value}set value(z){Le(this,g,"f").value=z}get isTrusted(){return Le(this,g,"f").isTrusted}set isTrusted(z){Le(this,g,"f").isTrusted=z}get supportThemeIcons(){return Le(this,g,"f").supportThemeIcons}set supportThemeIcons(z){Le(this,g,"f").supportThemeIcons=z}get supportHtml(){return Le(this,g,"f").supportHtml}set supportHtml(z){Le(this,g,"f").supportHtml=z}get baseUri(){return Le(this,g,"f").baseUri}set baseUri(z){Le(this,g,"f").baseUri=z}appendText(z){return Le(this,g,"f").appendText(z),this}appendMarkdown(z){return Le(this,g,"f").appendMarkdown(z),this}appendCodeblock(z,he){return Le(this,g,"f").appendCodeblock(he??"",z),this}};g=new WeakMap,De=n=$e([L],De),e.MarkdownString=De;let Ue=class{constructor(z,he){this.label=z,this.documentation=he}};Ue=$e([L],Ue),e.ParameterInformation=Ue;let ze=class{constructor(z,he){this.label=z,this.documentation=he,this.parameters=[]}};ze=$e([L],ze),e.SignatureInformation=ze;let He=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};He=$e([L],He),e.SignatureHelp=He;var Ke;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Oe=class{constructor(z){this.value=z}};Oe=$e([L],Oe),e.InlayHintLabelPart=Oe;let Xe=class{constructor(z,he,Pe){this.position=z,this.label=he,this.kind=Pe}};Xe=$e([L],Xe),e.InlayHint=Xe;var te;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(V){V[V.Deprecated=1]="Deprecated"})(K=e.CompletionItemTag||(e.CompletionItemTag={}));let we=class{constructor(z,he){this.label=z,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};we=$e([L],we),e.CompletionItem=we;let ke=class{constructor(z=[],he=!1){this.items=z,this.isIncomplete=he}};ke=$e([L],ke),e.CompletionList=ke;let We=class{constructor(z,he,Pe){this.insertText=z,this.range=he,this.command=Pe}};We=$e([L],We),e.InlineSuggestion=We;let xe=class{constructor(z){this.items=z}};xe=$e([L],xe),e.InlineSuggestions=xe;let Je=class{constructor(z,he,Pe){this.insertText=z,this.range=he,this.command=Pe}};Je=$e([L],Je),e.InlineSuggestionNew=Je;let st=class{constructor(z){this.items=z}};st=$e([L],st),e.InlineSuggestionsNew=st;var mt;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(mt=e.ViewColumn||(e.ViewColumn={}));var vt;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(vt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var qe;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var at;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(at=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var wt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(wt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var it;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(it=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var dt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function z(he){switch(he){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=z}(it=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let At=class{constructor(z,he){if(he&&!A.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!U.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.target=he}};At=$e([L],At),e.DocumentLink=At;let Ct=class{constructor(z,he,Pe,Ge){this.red=z,this.green=he,this.blue=Pe,this.alpha=Ge}};Ct=$e([L],Ct),e.Color=Ct;let ht=class{constructor(z,he){if(he&&!(he instanceof Ct))throw(0,t.illegalArgument)("color");if(!U.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.color=he}};ht=$e([L],ht),e.ColorInformation=ht;let Rt=class{constructor(z){if(!z||typeof z!="string")throw(0,t.illegalArgument)("label");this.label=z}};Rt=$e([L],Rt),e.ColorPresentation=Rt;var Ft;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Ft=e.ColorFormat||(e.ColorFormat={}));var Nt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Nt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ve{constructor(z,he,Pe){if(this.startIndex=z,this.length=he,this.tooltip=Pe,typeof z!="number"||z<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ve;var Ce;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Ce=e.TerminalLocation||(e.TerminalLocation={}));class Te{constructor(z){this.options=z,typeof z!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=Te;var ve;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(ve=e.TaskRevealKind||(e.TaskRevealKind={}));var Z;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Z=e.TaskPanelKind||(e.TaskPanelKind={}));let Ae=r=class{constructor(z,he){if(this.label=he,typeof z!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return r.Clean;case"build":return r.Build;case"rebuild":return r.Rebuild;case"test":return r.Test;default:return}}get id(){return this._id}};Ae.Clean=new r("clean","Clean"),Ae.Build=new r("build","Build"),Ae.Rebuild=new r("rebuild","Rebuild"),Ae.Test=new r("test","Test"),Ae=r=$e([L],Ae),e.TaskGroup=Ae;function Fe(V){let z="";for(let he=0;he<V.length;he++)z+=V[he].replace(/,/g,",,")+",";return z}let je=class{constructor(z,he,Pe){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=z,he!==void 0&&(Array.isArray(he)?(this._args=he,this._options=Pe):this._options=he)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let he of this._args)z.push(he);return Fe(z)}};je=$e([L],je),e.ProcessExecution=je;let Qe=class{constructor(z,he,Pe){if(this._args=[],Array.isArray(he)){if(!z)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z,this._args=he,this._options=Pe}else{if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z,this._options=he}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let he of this._args)z.push(typeof he=="string"?he:he.value);return Fe(z)}};Qe=$e([L],Qe),e.ShellExecution=Qe;var gt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Et{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=Et;let ot=h=class{constructor(z,he,Pe,Ge,Ze,tt){this.__deprecated=!1,this._definition=this.definition=z;let nt;typeof he=="string"?(this._name=this.name=he,this._source=this.source=Pe,this.execution=Ge,nt=Ze,this.__deprecated=!0):he===bt.Global||he===bt.Workspace?(this.target=he,this._name=this.name=Pe,this._source=this.source=Ge,this.execution=Ze,nt=tt):(this.target=he,this._name=this.name=Pe,this._source=this.source=Ge,this.execution=Ze,nt=tt),typeof nt=="string"?(this._problemMatchers=[nt],this._hasDefinedMatchers=!0):Array.isArray(nt)?(this._problemMatchers=nt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof je?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const he=this._definition.type;(h.EmptyType===he||h.ProcessType===he||h.ShellType===he||h.ExtensionCallbackType===he)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};ot.ExtensionCallbackType="customExecution",ot.ProcessType="process",ot.ShellType="shell",ot.EmptyType="$empty",ot=h=$e([L],ot),e.Task=ot;var ft;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(z,he=Mt.None){this.collapsibleState=he,A.URI.isUri(z)?this.resourceUri=z:this.label=z}};ct=$e([L],ct),e.TreeItem=ct;var Mt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Mt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(z){this.value=z}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};_t=$e([L],_t),e.DataTransferItem=_t;let Tt=class{constructor(){this._items=new Map}get(z){return this._items.get(z)}set(z,he){this._items.set(z,he)}forEach(z){this._items.forEach(z)}};Tt=$e([L],Tt),e.DataTransfer=Tt;let It=class{constructor(z,he){this.id=z,this.color=he}};It=$e([L],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let yt=class{constructor(z){this.id=z}};yt=$e([L],yt),e.ThemeColor=yt;var Jt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ht=class{constructor(z,he){if(typeof z!="string"&&(!z||!A.URI.isUri(z)&&!A.URI.isUri(z.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof z=="string"?this.baseUri=A.URI.file(z):A.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=he}get base(){return this._base}set base(z){this._base=z,this._baseUri=A.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ht=$e([L],Ht),e.RelativePattern=Ht;let pt=class{constructor(z,he,Pe,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof he=="string"&&(this.condition=he),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,N.generateUuid)()),this._id}};pt=$e([L],pt),e.Breakpoint=pt;let Gt=class extends pt{constructor(z,he,Pe,Ge,Ze){super(he,Pe,Ge,Ze);if(z===null)throw(0,t.illegalArgument)("location");this.location=z}};Gt=$e([L],Gt),e.SourceBreakpoint=Gt;let Xt=class extends pt{constructor(z,he,Pe,Ge,Ze){super(he,Pe,Ge,Ze);this.functionName=z}};Xt=$e([L],Xt),e.FunctionBreakpoint=Xt;let Zt=class extends pt{constructor(z,he,Pe,Ge,Ze,tt,nt){super(Ge,Ze,tt,nt);if(!he)throw(0,t.illegalArgument)("dataId");this.label=z,this.dataId=he,this.canPersist=Pe}};Zt=$e([L],Zt),e.DataBreakpoint=Zt;let li=class{constructor(z,he,Pe){this.command=z,this.args=he||[],this.options=Pe}};li=$e([L],li),e.DebugAdapterExecutable=li;let Pt=class{constructor(z,he){this.port=z,this.host=he}};Pt=$e([L],Pt),e.DebugAdapterServer=Pt;let ei=class{constructor(z){this.path=z}};ei=$e([L],ei),e.DebugAdapterNamedPipeServer=ei;let ci=class{constructor(z){this.implementation=z}};ci=$e([L],ci),e.DebugAdapterInlineImplementation=ci;let Kt=class{constructor(z,he){this.range=z,this.expression=he}};Kt=$e([L],Kt),e.EvaluatableExpression=Kt;var ti;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(ti=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var lt;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(lt=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let ui=class{constructor(z,he){this.range=z,this.text=he}};ui=$e([L],ui),e.InlineValueText=ui;let Bt=class{constructor(z,he,Pe=!0){this.range=z,this.variableName=he,this.caseSensitiveLookup=Pe}};Bt=$e([L],Bt),e.InlineValueVariableLookup=Bt;let $t=class{constructor(z,he){this.range=z,this.expression=he}};$t=$e([L],$t),e.InlineValueEvaluatableExpression=$t;let ii=class{constructor(z,he){this.frameId=z,this.stoppedLocation=he}};ii=$e([L],ii),e.InlineValueContext=ii;var Di;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Di=e.FileChangeType||(e.FileChangeType={}));let ni=c=class extends Error{constructor(z,he=R.FileSystemProviderErrorCode.Unknown,Pe){super(A.URI.isUri(z)?z.toString(!0):z);this.code=Pe?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,he),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(z){return new c(z,R.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(z){return new c(z,R.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(z){return new c(z,R.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(z){return new c(z,R.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(z){return new c(z,R.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(z){return new c(z,R.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}};ni=c=$e([L],ni),e.FileSystemError=ni;let di=class{constructor(z,he,Pe){this.start=z,this.end=he,this.kind=Pe}};di=$e([L],di),e.FoldingRange=di;var bi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ri;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(ri=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ii;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Ii=e.CommentMode||(e.CommentMode={}));var hi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(hi=e.CommentThreadState||(e.CommentThreadState={}));class fi{constructor(z,he=[]){this.tokenTypes=z,this.tokenModifiers=he}}e.SemanticTokensLegend=fi;function ki(V){return typeof V=="undefined"||(0,y.isStringArray)(V)}class mi{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let he=0,Pe=z.tokenTypes.length;he<Pe;he++)this._tokenTypeStrToInt.set(z.tokenTypes[he],he);for(let he=0,Pe=z.tokenModifiers.length;he<Pe;he++)this._tokenModifierStrToInt.set(z.tokenModifiers[he],he)}}push(z,he,Pe,Ge,Ze){if(typeof z=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze=="undefined"))return typeof Ze=="undefined"&&(Ze=0),this._pushEncoded(z,he,Pe,Ge,Ze);if(U.isRange(z)&&typeof he=="string"&&ki(Pe))return this._push(z,he,Pe);throw(0,t.illegalArgument)()}_push(z,he,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(he))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,Ze=z.start.character,tt=z.end.character-z.start.character,nt=this._tokenTypeStrToInt.get(he);let Dt=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Lt);Dt|=1<<Wt>>>0}this._pushEncoded(Ge,Ze,tt,nt,Dt)}_pushEncoded(z,he,Pe,Ge,Ze){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&he<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Lt=0,Wt=0;for(let zt=0;zt<Dt;zt++){let jt=this._data[5*zt],vi=this._data[5*zt+1];jt===0?(jt=Lt,vi+=Wt):jt+=Lt,this._data[5*zt]=jt,this._data[5*zt+1]=vi,Lt=jt,Wt=vi}}let tt=z,nt=he;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(tt-=this._prevLine,tt===0&&(nt-=this._prevChar)),this._data[this._dataLen++]=tt,this._data[this._dataLen++]=nt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ze,this._prevLine=z,this._prevChar=he}static _sortAndDeltaEncode(z){let he=[];const Pe=z.length/5|0;for(let nt=0;nt<Pe;nt++)he[nt]=nt;he.sort((nt,Dt)=>{const Lt=z[5*nt],Wt=z[5*Dt];if(Lt===Wt){const zt=z[5*nt+1],jt=z[5*Dt+1];return zt-jt}return Lt-Wt});const Ge=new Uint32Array(z.length);let Ze=0,tt=0;for(let nt=0;nt<Pe;nt++){const Dt=5*he[nt],Lt=z[Dt+0],Wt=z[Dt+1],zt=z[Dt+2],jt=z[Dt+3],vi=z[Dt+4],Gi=Lt-Ze,un=Gi===0?Wt-tt:Wt,wi=5*nt;Ge[wi+0]=Gi,Ge[wi+1]=un,Ge[wi+2]=zt,Ge[wi+3]=jt,Ge[wi+4]=vi,Ze=Lt,tt=Wt}return Ge}build(z){return this._dataIsSortedAndDeltaEncoded?new xt(new Uint32Array(this._data),z):new xt(mi._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=mi;class xt{constructor(z,he){this.resultId=he,this.data=z}}e.SemanticTokens=xt;class Ti{constructor(z,he,Pe){this.start=z,this.deleteCount=he,this.data=Pe}}e.SemanticTokensEdit=Ti;class Pi{constructor(z,he){this.resultId=he,this.edits=z}}e.SemanticTokensEdits=Pi;var Ai;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Ai=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new It("arrow-left")},si=$e([L],si),e.QuickInputButtons=si;var gi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(gi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ei;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(Ei=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var _i;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(_i=e.ExtensionKind||(e.ExtensionKind={}));class Me{constructor(z,he,Pe){this.badge=z,this.tooltip=he,this.color=Pe}static validate(z){if(z.badge){let he=(0,k.nextCharLength)(z.badge,0);if(he<z.badge.length&&(he+=(0,k.nextCharLength)(z.badge,he)),z.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Me;let Qt=class{constructor(z){this.kind=z}};Qt=$e([L],Qt),e.ColorTheme=Qt;var Si;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Si=e.ColorThemeKind||(e.ColorThemeKind={}));class ut{constructor(z,he){if(z<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");z<=he?(this._start=z,this._end=he):(this._start=he,this._end=z)}static isNotebookRange(z){return z instanceof ut?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let he=this._start,Pe=this._end;return z.start!==void 0&&(he=z.start),z.end!==void 0&&(Pe=z.end),he===this._start&&Pe===this._end?this:new ut(he,Pe)}}e.NotebookRange=ut;class Vt{constructor(z,he,Pe,Ge,Ze,tt,nt){this.kind=z,this.value=he,this.languageId=Pe,this.mime=Ge,this.outputs=Ze??[],this.metadata=tt,this.executionSummary=nt,Vt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(he=>Vt.isNotebookCellData(he))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Vt;class Ri{constructor(z){this.cells=z}}e.NotebookData=Ri;class Ot{constructor(z,he){this.data=z,this.mime=he;const Pe=(0,D.normalizeMimeType)(he,!0);if(!Pe)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(z){return z instanceof Ot?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const he={name:z.name,message:z.message,stack:z.stack};return Ot.json(he,"application/vnd.code.notebook.error")}static stdout(z){return Ot.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Ot.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,he="application/octet-stream"){return new Ot(z,he)}static text(z,he=D.Mimes.text){const Pe=Le(Ot,u,"f",v).encode(String(z));return new Ot(Pe,he)}static json(z,he="text/x-json"){const Pe=JSON.stringify(z,void 0,"	");return Ot.text(Pe,he)}}e.NotebookCellOutputItem=Ot,u=Ot,v={value:new TextEncoder};class Yt{constructor(z,he,Pe){this.items=Yt.ensureUniqueMimeTypes(z,!0),typeof he=="string"?(this.id=he,this.metadata=Pe):(this.id=(0,N.generateUuid)(),this.metadata=he??Pe)}static isNotebookCellOutput(z){return z instanceof Yt?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,y.isArray)(z.items)}static ensureUniqueMimeTypes(z,he=!1){const Pe=new Set,Ge=new Set;for(let Ze=0;Ze<z.length;Ze++){const tt=z[Ze],nt=(0,D.normalizeMimeType)(tt.mime);if(!Pe.has(nt)){Pe.add(nt);continue}Ge.add(Ze),he&&console.warn(`DUPLICATED mime type '${tt.mime}' will be dropped`)}return Ge.size===0?z:z.filter((Ze,tt)=>!Ge.has(tt))}}e.NotebookCellOutput=Yt;var Li;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Li=e.NotebookCellKind||(e.NotebookCellKind={}));var Oi;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Oi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ni;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Ni=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Fi;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Fi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ci{constructor(z,he){this.text=z,this.alignment=he}}e.NotebookCellStatusBarItem=Ci;var Mi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ui{constructor(z,he=[]){this.uri=z,this.provides=(0,f.asArray)(he)}}e.NotebookRendererScript=Ui;let pi=class{constructor(z,he){this.label=z,this.timestamp=he}};pi=$e([L],pi),e.TimelineItem=pi;var Bi;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Bi=e.ExtensionMode||(e.ExtensionMode={}));var Wi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Wi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ce;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(ce=e.StandardTokenType||(e.StandardTokenType={}));class me{constructor(z,he){this.ranges=z,this.wordPattern=he}}e.LinkedEditingRanges=me;class Re{constructor(z,he){this._port=z,this._autoForwardAction=he}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Re;var rt;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(rt=e.TestResultState||(e.TestResultState={}));var St;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(St=e.TestRunProfileKind||(e.TestRunProfileKind={}));let kt=class{constructor(z=void 0,he=void 0,Pe=void 0){this.include=z,this.exclude=he,this.profile=Pe}};kt=$e([L],kt),e.TestRunRequest=kt;let zi=w=class{constructor(z){this.message=z}static diff(z,he,Pe){const Ge=new w(z);return Ge.expectedOutput=he,Ge.actualOutput=Pe,Ge}};zi=w=$e([L],zi),e.TestMessage=zi;let Hi=class{constructor(z){this.id=z}};Hi=$e([L],Hi),e.TestTag=Hi;let oi=class{constructor(z,he){this.covered=z,this.total=he}};oi=$e([L],oi),e.CoveredCount=oi;let $i=P=class{constructor(z,he,Pe,Ge){this.uri=z,this.statementCoverage=he,this.branchCoverage=Pe,this.functionCoverage=Ge}static fromDetails(z,he){const Pe=new oi(0,0),Ge=new oi(0,0),Ze=new oi(0,0);for(const nt of he)if("branches"in nt){Pe.total+=1,Pe.covered+=nt.executionCount>0?1:0;for(const Dt of nt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=nt.executionCount>0?1:0;const tt=new P(z,Pe,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return tt.detailedCoverage=he,tt}};$i=P=$e([L],$i),e.FileCoverage=$i;let xi=class{constructor(z,he,Pe=[]){this.executionCount=z,this.location=he,this.branches=Pe}};xi=$e([L],xi),e.StatementCoverage=xi;let Vi=class{constructor(z,he){this.executionCount=z,this.location=he}};Vi=$e([L],Vi),e.BranchCoverage=Vi;let ji=class{constructor(z,he){this.executionCount=z,this.location=he}};ji=$e([L],ji),e.FunctionCoverage=ji;var Ji;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Ji=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Zi;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var en;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(en=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class tn{constructor(z,he,Pe,Ge,Ze,tt){this.kind=z,this.name=he,this.detail=Pe,this.uri=Ge,this.range=Ze,this.selectionRange=tt}}e.TypeHierarchyItem=tn;class nn{constructor(z){this.uri=z}}e.TextTabInput=nn;class rn{constructor(z,he){this.original=z,this.modified=he}}e.TextDiffTabInput=rn;class sn{constructor(z,he){this.uri=z,this.viewType=he}}e.CustomEditorTabInput=sn;class on{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=on;class an{constructor(z,he){this.uri=z,this.notebookType=he}}e.NotebookEditorTabInput=an;class ln{constructor(z,he,Pe){this.original=z,this.modified=he,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=ln;class cn{constructor(){}}e.TerminalEditorTabInput=cn}),define(be[125],Ee([1,0,55,10,8,152,108,7,18]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function N(g,u){u?A.set(g,u):A.delete(g)}e.setWordDefinitionFor=N;function R(g){return A.get(g)}e.getWordDefinitionFor=R;class b extends T.MirrorTextModel{constructor(u,v,_,E,l,d,m,a){super(v,_,E,l);this._proxy=u,this._languageId=d,this._isDirty=m,this._notebook=a,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,y.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===t.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(v){return v?u._getTextInRange(v):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(v){return u._lineAt(v)},offsetAt(v){return u._offsetAt(v)},positionAt(v){return u._positionAt(v)},validateRange(v){return u._validateRange(v)},validatePosition(v){return u._validatePosition(v)},getWordRangeAtPosition(v,_){return u._getWordRangeAtPosition(v,_)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,f.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,f.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const v=this._validateRange(u);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const _=this._eol,E=v.start.line,l=v.end.line,d=[];d.push(this._lines[E].substring(v.start.character));for(let m=E+1;m<l;m++)d.push(this._lines[m]);return d.push(this._lines[l].substring(0,v.end.character)),d.join(_)}_lineAt(u){let v;if(u instanceof k.Position?v=u.line:typeof u=="number"&&(v=u),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new C(v,this._lines[v],v===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(u),_=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,_))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(u.start),_=this._validatePosition(u.end);return v===u.start&&_===u.end?u:new k.Range(v.line,v.character,_.line,_.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:v,character:_}=u,E=!1;if(v<0)v=0,_=0,E=!0;else if(v>=this._lines.length)v=this._lines.length-1,_=this._lines[v].length,E=!0;else{const l=this._lines[v].length;_<0?(_=0,E=!0):_>l&&(_=l,E=!0)}return E?new k.Position(v,_):u}_getWordRangeAtPosition(u,v){const _=this._validatePosition(u);if(!v)v=R(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const E=(0,D.getWordAtText)(_.character+1,(0,D.ensureValidWordDefinition)(v),this._lines[_.line],0);if(E)return new k.Range(_.line,E.startColumn-1,_.line,E.endColumn-1)}}e.ExtHostDocumentData=b;class C{constructor(u,v,_){this._line=u,this._text=v,this._isLastLine=_}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(be[203],Ee([1,0,7,3,111,6,109,24,2,32]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class N{constructor(b,C,g,u){this._notebook=g,this._selector=u,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(C.onDidChangeDocument(_=>{const E=this._cellUris.get(_.document.uri);E!==void 0&&(this._cellLengths.setValue(E,this._cells[E].document.getText().length+1),this._cellLines.setValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=_=>{_===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(_=>v(_.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const b=[],C=[];for(const g of this._notebook.getCells())g.kind===f.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,g.document.uri,g.document.languageId,!0,void 0))&&(this._cellUris.set(g.document.uri,this._cells.length),this._cells.push(g),b.push(g.document.getText().length+1),C.push(g.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(C))}get version(){return this._versionId}getText(b){if(!b){let E="";for(const l of this._cells)E+=l.document.getText()+`
`;return E=E.slice(0,-1),E}if(b.isEmpty)return"";const C=this.locationAt(b.start),g=this.locationAt(b.end),u=this._cellUris.get(C.uri),v=this._cellUris.get(g.uri);if(u===void 0||v===void 0)return"";if(u===v)return this._cells[u].document.getText(new f.Range(C.range.start,g.range.end));const _=[this._cells[u].document.getText(new f.Range(C.range.start,new f.Position(this._cells[u].document.lineCount,0)))];for(let E=u+1;E<v;E++)_.push(this._cells[E].document.getText());return _.push(this._cells[v].document.getText(new f.Range(new f.Position(0,0),g.range.end))),_.join(`
`)}offsetAt(b){const C=this._cellLines.getIndexOf(b.line),g=this._cellLengths.getPrefixSum(C.index-1),u=this._cells[C.index].document.offsetAt(b.with(C.remainder));return g+u}positionAt(b){if(typeof b=="number"){const g=this._cellLengths.getIndexOf(b),u=this._cellLines.getPrefixSum(g.index-1);return this._cells[g.index].document.positionAt(g.remainder).translate(u)}const C=this._cellUris.get(b.uri);if(C!==void 0){const g=this._cellLines.getPrefixSum(C-1);return new f.Position(g+b.range.start.line,b.range.start.character)}return new f.Position(0,0)}locationAt(b){f.Range.isRange(b)||(b=new f.Range(b,b));const C=this._cellLines.getIndexOf(b.start.line);let g=C;b.isEmpty||(g=this._cellLines.getIndexOf(b.end.line));const u=new f.Position(C.remainder,b.start.character),v=new f.Position(g.remainder,b.end.character),_=new f.Range(u,v),E=this._cells[C.index];return new f.Location(E.document.uri,E.document.validateRange(_))}contains(b){return this._cellUris.has(b)}validateRange(b){const C=this.validatePosition(b.start),g=this.validatePosition(b.end);return b.with(C,g)}validatePosition(b){const C=this._cellLines.getIndexOf(b.line),g=new f.Position(C.remainder,b.character),u=this._cells[C.index].document.validatePosition(g),v=this._cellLines.getPrefixSum(C.index-1);return new f.Position(v+u.line,u.character)}}e.ExtHostNotebookConcatDocument=N}),define(be[204],Ee([1,0,7,17,3]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y;switch(k){case"light":y=f.ColorThemeKind.Light;break;case"hcDark":y=f.ColorThemeKind.HighContrast;break;case"hcLight":y=f.ColorThemeKind.HighContrastLight;break;default:y=f.ColorThemeKind.Dark}this._actual=new f.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=$e([Be(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[64],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(be[205],Ee([1,0,22]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let A=this.buffers.indexOf(y);return A<0&&(A=this.buffers.length,this.buffers.push(y)),A}}function I(k,y){if(y.serializeBuffersForPostMessage){const A=new t,N=(C,g)=>{if(g instanceof ArrayBuffer){const u=A.add(g);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(g)){const u=T(g);if(u){const v=A.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:u,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},R=JSON.stringify(k,N),b=A.buffers.map(C=>{const g=new Uint8Array(C);return f.VSBuffer.wrap(g)});return{message:R,buffers:b}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function T(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(k,y){const A=y.map(b=>{const C=new ArrayBuffer(b.byteLength);return new Uint8Array(C).set(b.buffer),C}),N=y.length?(b,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const g=C,{index:u}=g,v=A[u];if(g.view)switch(g.view.type){case 1:return new Int8Array(v,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return C}:void 0;return{message:JSON.parse(k,N),arrayBuffers:A}}e.deserializeWebviewMessage=D}),define(be[126],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransferConverter=void 0;var f;(function(t){function I(D){const k=new Map;return D.types.forEach((y,A)=>{k.set(y,{asString:async()=>D.items[A].asString,value:void 0})}),k}t.toDataTransfer=I;async function T(D){const k={types:[],items:[]},y=Array.from(D.entries());for(const A of y)k.types.push(A[0]),k.items.push({asString:await A[1].asString()});return k}t.toDataTransferDTO=T})(f=e.DataTransferConverter||(e.DataTransferConverter={}))}),define(be[206],Ee([1,0,102]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(T){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:T,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function I(T){return new f.URITransformer(t(T))}e.createURITransformer=I}),define(be[207],Ee([1,0,176,14,2,6,4,50,42,18,10]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(W){W[W.PROGRAMMATIC=1]="PROGRAMMATIC",W[W.USER=2]="USER",W[W.EDIT=3]="EDIT",W[W.NAVIGATION=4]="NAVIGATION",W[W.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var b;(function(W){W[W.IDENTICAL=1]="IDENTICAL",W[W.SIMILAR=2]="SIMILAR",W[W.DIFFERENT=3]="DIFFERENT"})(b=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function C(W){const F=W;return!!F&&typeof F.getSelection=="function"&&!!F.onDidChangeSelection}e.isEditorPaneWithSelection=C;function g(W,F,q){for(const G of q.visibleEditorPanes)if(G.group.id===F&&W.matches(G.input))return G.getViewState()}e.findViewStateForEditor=g;function u(W){if(o(W))return!1;const F=W;return I.URI.isUri(F?.resource)}e.isResourceEditorInput=u;function v(W){if(o(W))return!1;const F=W;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=v;function _(W){if(o(W)||v(W))return!1;const F=W;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=_;function E(W){if(o(W))return!1;const F=W;return F?F.resource===void 0||F.resource.scheme===N.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var l;(function(W){W[W.SHORT=0]="SHORT",W[W.MEDIUM=1]="MEDIUM",W[W.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var d;(function(W){W[W.EXPLICIT=1]="EXPLICIT",W[W.AUTO=2]="AUTO",W[W.FOCUS_CHANGE=3]="FOCUS_CHANGE",W[W.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d=e.SaveReason||(e.SaveReason={}));class m{constructor(){this.mapIdToSaveSource=new Map}registerSource(F,q){let G=this.mapIdToSaveSource.get(F);return G||(G={source:F,label:q},this.mapIdToSaveSource.set(F,G)),G.source}getSourceLabel(F){return this.mapIdToSaveSource.get(F)?.label??F}}e.SaveSourceRegistry=new m;var a;(function(W){W[W.None=0]="None",W[W.Readonly=2]="Readonly",W[W.Untitled=4]="Untitled",W[W.Singleton=8]="Singleton",W[W.RequiresTrust=16]="RequiresTrust",W[W.CanSplitInGroup=32]="CanSplitInGroup",W[W.ForceDescription=64]="ForceDescription"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class S extends T.Disposable{}e.AbstractEditorInput=S;function o(W){return W instanceof S}e.isEditorInput=o;function i(W){const F=W;return I.URI.isUri(F?.preferredResource)}function s(W){const F=W;return o(F?.primary)&&o(F?.secondary)}e.isSideBySideEditorInput=s;function n(W){const F=W;return o(F?.modified)&&o(F?.original)}e.isDiffEditorInput=n;function r(W){return o(W?.editor)}e.isEditorInputWithOptions=r;function h(W){const F=W;return r(W)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function c(W){const F=W;return typeof F?.groupId=="number"&&o(F.editor)}e.isEditorIdentifier=c;var w;(function(W){W[W.UNKNOWN=0]="UNKNOWN",W[W.REPLACE=1]="REPLACE",W[W.MOVE=2]="MOVE",W[W.UNPIN=3]="UNPIN"})(w=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(W){W[W.GROUP_ACTIVE=0]="GROUP_ACTIVE",W[W.GROUP_INDEX=1]="GROUP_INDEX",W[W.GROUP_LOCKED=2]="GROUP_LOCKED",W[W.EDITOR_OPEN=3]="EDITOR_OPEN",W[W.EDITOR_CLOSE=4]="EDITOR_CLOSE",W[W.EDITOR_MOVE=5]="EDITOR_MOVE",W[W.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",W[W.EDITOR_LABEL=7]="EDITOR_LABEL",W[W.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",W[W.EDITOR_PIN=9]="EDITOR_PIN",W[W.EDITOR_STICKY=10]="EDITOR_STICKY",W[W.EDITOR_DIRTY=11]="EDITOR_DIRTY",W[W.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var L;(function(W){W[W.PRIMARY=1]="PRIMARY",W[W.SECONDARY=2]="SECONDARY",W[W.BOTH=3]="BOTH",W[W.ANY=4]="ANY"})(L=e.SideBySideEditor||(e.SideBySideEditor={}));class M{getOriginalUri(F,q){if(!F)return;if(q?.supportSideBySide){const{primary:$,secondary:X}=this.getSideEditors(F);if($&&X){if(q?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(X,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===L.ANY)return this.getOriginalUri($,{filterByScheme:q.filterByScheme})??this.getOriginalUri(X,{filterByScheme:q.filterByScheme});F=q.supportSideBySide===L.PRIMARY?$:X}}if(v(F)||_(F))return;const G=i(F)?F.preferredResource:F.resource;return!G||!q||!q.filterByScheme?G:this.filterUri(G,q.filterByScheme)}getSideEditors(F){return s(F)||_(F)?{primary:F.primary,secondary:F.secondary}:n(F)||v(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,q){if(!F)return;if(q?.supportSideBySide){const{primary:$,secondary:X}=this.getSideEditors(F);if($&&X){if(q?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(X,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===L.ANY)return this.getCanonicalUri($,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(X,{filterByScheme:q.filterByScheme});F=q.supportSideBySide===L.PRIMARY?$:X}}if(v(F)||_(F))return;const G=F.resource;return!G||!q||!q.filterByScheme?G:this.filterUri(G,q.filterByScheme)}filterUri(F,q){if(Array.isArray(q)){if(q.some(G=>F.scheme===G))return F}else if(q===F.scheme)return F}}e.EditorResourceAccessor=new M;var p;(function(W){W[W.LEFT=0]="LEFT",W[W.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const q=this.instantiationService=F.get(D.IInstantiationService);for(const[G,$]of this.editorSerializerConstructors)this.createEditorSerializer(G,$,q);this.editorSerializerConstructors.clear()}createEditorSerializer(F,q,G){const $=G.createInstance(q);this.editorSerializerInstances.set(F,$)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,q){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,q,this.instantiationService):this.editorSerializerConstructors.set(F,q),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new U);async function B(W,F){if(!W||!W.length)return[];const q=await Promise.all(W.map(async G=>{const $=I.URI.revive(G.fileUri);if(!$||!await F.canHandleResource($))return;let ie=G.exists,ae=G.type;if(typeof ie!="boolean"||typeof ae!="number")try{ae=(await F.stat($)).isDirectory?y.FileType.Directory:y.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&G.openOnlyIfExists||ae===y.FileType.Directory)return;const le={selection:ie?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let se;return ie?se={resource:$,options:le}:se={resource:$,options:le,forceUntitled:!0},se}));return(0,A.coalesce)(q)}e.pathsToEditors=B;var H;(function(W){W[W.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",W[W.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function re(W){const F=W;if(!F)return!1;const q=F;if(q.modified)return re(q.modified);const G=F;return!!(G.contributionsState&&G.viewState&&Array.isArray(G.cursorState))}e.isTextEditorViewState=re}),define(be[84],Ee([1,0,10,2]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,y){return k.scheme===f.Schemas.http||k.scheme===f.Schemas.https?k:(y&&y.authority&&y.isRemote&&k.scheme===f.Schemas.file&&(k=t.URI.from({scheme:f.Schemas.vscodeRemote,authority:y.authority,path:k.path})),t.URI.from({scheme:f.Schemas.https,authority:`${k.scheme}+${T(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function T(k){return k.replace(/./g,y=>{const A=y.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?y:"-"+A.toString(16).padStart(4,"0")})}function D(k){return k.replace(/-([0-9a-f]{4})/g,(y,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=D}),define(be[208],Ee([1,0,3,6,84]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(k,y,A){this._proxy=k,this._editors=y,this._remoteInfo=A,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const N=y.getVisibleTextEditors();for(const R of this._insets.values())N.indexOf(R.editor)<0&&R.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,y,A,N,R){let b;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===k){b=l;break}if(!b)throw new Error("not a visible editor");const C=this,g=this._handlePool++,u=new f.Emitter,v=new f.Emitter,_=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,I.asWebviewUri)(l,C._remoteInfo)}get cspSource(){return I.webviewGenericCspSource}set options(l){this._options=l,C._proxy.$setOptions(g,l)}get options(){return this._options}set html(l){this._html=l,C._proxy.$setHtml(g,l)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(l){return C._proxy.$postMessage(g,l)}},E=new class{constructor(){this.editor=k,this.line=y,this.height=A,this.webview=_,this.onDidDispose=v.event}dispose(){C._insets.has(g)&&(C._insets.delete(g),C._proxy.$disposeEditorInset(g),v.fire(),v.dispose(),u.dispose())}};return this._proxy.$createEditorInset(g,b.id,b.value.document.uri,y+1,A,N||{},R.identifier,R.extensionLocation),this._insets.set(g,{editor:k,inset:E,onDidReceiveMessage:u}),E}$onDidDispose(k){const y=this._insets.get(k);y&&y.inset.dispose()}$onDidReceiveMessage(k,y){const A=this._insets.get(k);A&&A.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=T}),define(be[127],Ee([1,0,3,15,177]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,A,N){const R={command:k};if(y&&Object.keys(y).length>0&&(R.arguments=y),this.internalSend("request",R),typeof N=="number"){const b=setTimeout(()=>{clearTimeout(b);const C=this.pendingRequests.get(R.seq);if(C){this.pendingRequests.delete(R.seq);const g={type:"response",seq:0,request_seq:R.seq,success:!1,command:k,message:(0,I.localize)(0,null,N,k)};C(g)}},N)}return A&&this.pendingRequests.set(R.seq,A),R.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const y=k,A=this.pendingRequests.get(y.request_seq);A&&(this.pendingRequests.delete(y.request_seq),A(y));break}}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,A)=>k.set(A,y)),await(0,t.timeout)(500),k.forEach((y,A)=>{y({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[209],Ee([1,0,178,62,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:f.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:f.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:f.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:f.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:f.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:f.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:f.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:f.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:f.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:f.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:f.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:f.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:f.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:f.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:f.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:f.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:f.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:f.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:f.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:f.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:f.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:f.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:f.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:f.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:f.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:f.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:f.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:f.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:f.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:f.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:f.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:f.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:f.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:f.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:f.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:f.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:f.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:f.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:f.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:f.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:f.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:f.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:f.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:f.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:f.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:f.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:f.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:f.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:f.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:f.localize(49,null)});const T=R=>f.localize(50,null,R);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:f.localize(51,null)};var D;(function(R){R[R.Inactive=0]="Inactive",R[R.Initializing=1]="Initializing",R[R.Stopped=2]="Stopped",R[R.Running=3]="Running"})(D=e.State||(e.State={}));function k(R){switch(R){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var y;(function(R){R[R.Valid=0]="Valid",R[R.Unreadable=1]="Unreadable",R[R.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(R){R[R.Initial=1]="Initial",R[R.Dynamic=2]="Dynamic"})(A=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var N;(function(R){R[R.CONDITION=0]="CONDITION",R[R.HIT_COUNT=1]="HIT_COUNT",R[R.LOG_MESSAGE=2]="LOG_MESSAGE"})(N=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(be[210],Ee([1,0,8,2,9,25,10]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function y(o,i,s){return o.replace(k,function(n,r){return i&&r.length>0&&r[0]!=="_"?n:s&&s.hasOwnProperty(r)?s[r]:n})}e.formatPII=y;function A(o){const i={};for(const s of Object.keys(o))s.startsWith("!")||(i[s]=o[s]);return i}e.filterExceptionsFromTelemetry=A;function N(o){return o.configuration.request==="attach"&&!R(o)&&(!o.parentSession||N(o.parentSession))}e.isSessionAttach=N;function R(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(i,"extensionhost")||(0,f.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?R(o.parentSession):void 0}e.getExtensionHostDebugSession=R;function b(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=b;function C(o,i,s){let n,r=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let c=null;for(;c=h.exec(o);){const w=c.index+1,P=w+c[0].length;if(w<=i&&P>=s){n=c[0],r=w;break}}if(n){const w=/\w+/g;let P=null;for(;(P=w.exec(n))&&!(P.index+1+r+P[0].length>=s););P&&(n=n.substring(0,w.lastIndex))}return n?{start:r,end:r+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=C;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(o){return!!(o&&o.match(g))}e.isUri=u;function v(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(u(o.path))return t.URI.parse(o.path);if((0,I.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function _(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return o.path}function E(o,i){const s=i?v:_,n=(0,T.deepClone)(o);return d(n,(r,h)=>{r&&h&&(h.path=s(h))}),n}e.convertToDAPaths=E;function l(o,i){const s=i?v:_,n=(0,T.deepClone)(o);return d(n,(r,h)=>{!r&&h&&(h.path=s(h))}),n}e.convertToVSCPaths=l;function d(o,i){switch(o.type){case"event":{const s=o;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=o;switch(s.command){case"setBreakpoints":i(!0,s.arguments.source);break;case"breakpointLocations":i(!0,s.arguments.source);break;case"source":i(!0,s.arguments.source);break;case"gotoTargets":i(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(n=>i(!1,n));break;default:break}break}case"response":{const s=o;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(n=>i(!1,n.source));break;case"loadedSources":s.body.sources.forEach(n=>i(!1,n));break;case"scopes":s.body.scopes.forEach(n=>i(!1,n.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(n=>i(!1,n.source));break;case"setBreakpoints":s.body.breakpoints.forEach(n=>i(!1,n.source));break;case"disassemble":{const n=s;n.body&&n.body.instructions.forEach(r=>i(!1,r.location))}break;default:break}break}}}function m(o){return o.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):a(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:a(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=m;function a(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function S(o,i){const s=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const n=i.activeEditorPane;n&&n.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:n.input,groupId:n.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(be[211],Ee([1,0,29,39,179,128,9,8,25,13,116,127]),function(J,e,f,t,I,T,D,k,y,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class b extends R.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",d=>this.handleData(d))}sendMessage(E){if(this.outputStream){const l=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${b.TWO_CRLF}${l}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+l))}continue}}else{const l=this.rawData.indexOf(b.TWO_CRLF);if(l!==-1){const m=this.rawData.toString("utf8",0,l).split(b.HEADER_LINESEPARATOR);for(const a of m){const S=a.split(b.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(l+b.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=b,b.TWO_CRLF=`\r
\r
`,b.HEADER_LINESEPARATOR=/\r?\n/,b.HEADER_FIELDSEPARATOR=/: */;class C extends b{startSession(){return new Promise((E,l)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",m=>{d?this._onError.fire(m):l(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=C;class g extends C{constructor(E){super();this.adapterServer=E}createConnection(E){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=g;class u extends C{constructor(E){super();this.adapterServer=E}createConnection(E){return T.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=u;class v extends b{constructor(E,l,d){super();this.adapterExecutable=E,this.debugType=l,this.outputService=d}async startSession(){const E=this.adapterExecutable.command,l=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(E)if(D.isAbsolute(E)){if(!await f.Promises.exists(E))throw new Error(I.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let m=process.env;if(d.env&&Object.keys(d.env).length>0&&(m=y.mixin(y.deepClone(process.env),d.env)),E==="node")if(Array.isArray(l)&&l.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:m,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(o.cwd=d.cwd);const i=t.fork(l[0],l.slice(1),o);if(!i.pid)throw new Error(I.localize(2,null,l[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:m};d.cwd&&(S.cwd=d.cwd),this.serverProcess=t.spawn(E,l,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,o)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const a=this.outputService;if(a){const S=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const i=a.getChannel(N.ExtensionsChannelId);i&&i.append(S(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((E,l)=>{const d=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,a,S){if(m)return l(m)});d.on("exit",E),d.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,l){if(!E)return;const d=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?d.runtime=D.join(l,E.runtime):d.runtime=E.runtime),E.runtimeArgs&&(d.runtimeArgs=E.runtimeArgs),E.program&&(D.isAbsolute(E.program)?d.program=E.program:d.program=D.join(l,E.program)),E.args&&(d.args=E.args);const m=E;return m.win&&(d.win=v.extract(m.win,l)),m.winx86&&(d.winx86=v.extract(m.winx86,l)),m.windows&&(d.windows=v.extract(m.windows,l)),m.osx&&(d.osx=v.extract(m.osx,l)),m.linux&&(d.linux=v.extract(m.linux,l)),d}static platformAdapterExecutable(E,l){let d=Object.create(null);l=l.toLowerCase();for(const s of E)if(s.contributes){const n=s.contributes.debuggers;n&&n.length>0&&n.filter(r=>typeof r.type=="string"&&k.equalsIgnoreCase(r.type,l)).forEach(r=>{const h=v.extract(r,s.extensionLocation.fsPath);d=y.mixin(d,h,s.isBuiltin)})}let m;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=d.winx86||d.win||d.windows:A.isWindows?m=d.win||d.windows:A.isMacintosh?m=d.osx:A.isLinux&&(m=d.linux),m=m||d;const a=m.program||d.program,S=m.args||d.args,o=m.runtime||d.runtime,i=m.runtimeArgs||d.runtimeArgs;if(o)return{type:"executable",command:o,args:(i||[]).concat(typeof a=="string"?[a]:[]).concat(S||[])};if(a)return{type:"executable",command:a,args:S||[]}}}e.ExecutableDebugAdapter=v}),define(be[212],Ee([1,0,39,30,13]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function T(A,N){return new Promise((R,b)=>{let C="";const g=f.spawn(A,N);g.pid&&g.stdout.on("data",u=>{C+=u.toString()}),g.on("error",u=>{b(u)}),g.on("close",u=>{R(C)})})}async function D(A){if(A)if(I.isWindows){const N=await new Promise((R,b)=>{J(["windows-process-tree"],R,b)});return new Promise(R=>{N.getProcessTree(A,b=>{R(b.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(A)]).then(N=>{const R=N.trim();return!(R.length===0||R.indexOf(" tmux")>=0)},N=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var k;(function(A){A[A.cmd=0]="cmd",A[A.powershell=1]="powershell",A[A.bash=2]="bash"})(k||(k={}));function y(A,N,R,b){A=A.trim().toLowerCase();let C;A.indexOf("powershell")>=0||A.indexOf("pwsh")>=0?C=1:A.indexOf("cmd.exe")>=0?C=0:A.indexOf("bash")>=0?C=2:I.isWindows?C=0:C=2;let g,u=" ";switch(C){case 1:if(g=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),R){const v=(0,t.getDriveLetter)(R);v&&(u+=`${v}:; `),u+=`cd ${g(R)}; `}if(b)for(const v in b){const _=b[v];_===null?u+=`Remove-Item env:${v}; `:u+=`\${env:${v}}='${_}'; `}if(N.length>0){const v=g(N.shift());u+=v[0]==="'"?`& ${v} `:`${v} `;for(const _ of N)u+=`${g(_)} `}break;case 0:if(g=v=>(v=v.replace(/\"/g,'""'),v.indexOf(" ")>=0||v.indexOf('"')>=0||v.length===0?`"${v}"`:v),R){const v=(0,t.getDriveLetter)(R);v&&(u+=`${v}: && `),u+=`cd ${g(R)} && `}if(b){u+='cmd /C "';for(const v in b){let _=b[v];_===null?u+=`set "${v}=" && `:(_=_.replace(/[\^\&\|\<\>]/g,E=>`^${E}`),u+=`set "${v}=${_}" && `)}}for(const v of N)u+=`${g(v)} `;b&&(u+='"');break;case 2:{g=_=>(_=_.replace(/(["'\\\$])/g,"\\$1"),_.indexOf(" ")>=0||_.indexOf(";")>=0||_.length===0?`"${_}"`:_);const v=_=>/[^\w@%\/+=,.:^-]/.test(_)?`'${_.replace(/'/g,"'\\''")}'`:_;if(R&&(u+=`cd ${g(R)} ; `),b){u+="/usr/bin/env";for(const _ in b){const E=b[_];E===null?u+=` -u ${v(_)}`:u+=` ${v(`${_}=${E}`)}`}u+=" "}for(const _ of N)u+=`${g(_)} `;break}}return u}e.prepareCommand=y}),define(be[129],Ee([1,0,34,77,93,10,9,13,62]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var N;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(N=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(C=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeLanguage=5]="ChangeLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(n){n.scheme=T.Schemas.vscodeNotebookCell;const r=/^ch(\d{7,})/;function h(p,U){return p.with({scheme:n.scheme,fragment:`ch${U.toString().padStart(7,"0")}${p.scheme!==T.Schemas.file?p.scheme:""}`})}n.generate=h;function c(p){if(p.scheme!==n.scheme)return;const U=r.exec(p.fragment);return U?{handle:Number(U[1]),notebook:p.with({scheme:p.fragment.substring(U[0].length)||T.Schemas.file,fragment:null})}:void 0}n.parse=c;function w(p,U){return p.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${U??""},${p.scheme!==T.Schemas.file?p.scheme:""}`})}n.generateCellOutputUri=w;function P(p){if(p.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const U=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(p.fragment);if(!U)return;const B=U[1]&&U[1]!==""?U[1]:void 0,H=U[2];return{outputId:B,notebook:p.with({scheme:H||T.Schemas.file,fragment:null})}}n.parseCellOutputUri=P;function L(p,U,B){return p.with({scheme:B,fragment:`ch${U.toString().padStart(7,"0")}${p.scheme!==T.Schemas.file?p.scheme:""}`})}n.generateCellUri=L;function M(p,U){if(p.scheme!==U)return;const B=r.exec(p.fragment);return B?{handle:Number(B[1]),notebook:p.with({scheme:p.fragment.substring(B[0].length)||T.Schemas.file,fragment:null})}:void 0}n.parseCellUri=M})(_=e.CellUri||(e.CellUri={}));const E=n=>k.isWindows?n.replace(/\//g,"\\"):n;class l{constructor(r=[],h=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=h,this.order=[...new Set(r)].map(c=>({pattern:c,matches:f.parse(E(c))}))}sort(r){const h=new Map(t.Iterable.map(r,w=>[w,E(w)]));let c=[];for(const{matches:w}of this.order)for(const[P,L]of h)if(w(L)){c.push(P),h.delete(P);break}return h.size&&(c=c.concat([...h.keys()].sort((w,P)=>this.defaultOrder.indexOf(w)-this.defaultOrder.indexOf(P)))),c}prioritize(r,h){const c=this.findIndex(r);if(c===-1){this.order.unshift({pattern:r,matches:f.parse(E(r))});return}const w=new Set(h.map(L=>this.findIndex(L,c)));w.delete(-1);const P=Array.from(w).sort();this.order.splice(c+1,0,...P.map(L=>this.order[L]));for(let L=P.length-1;L>=0;L--)this.order.splice(P[L],1)}toArray(){return this.order.map(r=>r.pattern)}findIndex(r,h=this.order.length){const c=E(r);for(let w=0;w<h;w++)if(this.order[w].matches(c))return w;return-1}}e.MimeTypeDisplayOrder=l;function d(n,r,h,c=(w,P)=>w===P){const w=[];function P(p,U,B){if(U===0&&B.length===0)return;const H=w[w.length-1];H&&H.start+H.deleteCount===p?(H.deleteCount+=U,H.toInsert.push(...B)):w.push({start:p,deleteCount:U,toInsert:B})}let L=0,M=0;for(;;){if(L===n.length){P(L,0,r.slice(M));break}if(M===r.length){P(L,n.length-L,[]);break}const p=n[L],U=r[M];if(c(p,U)){L+=1,M+=1;continue}h(U)?(P(L,1,[]),L+=1):(P(L,0,[U]),M+=1)}return w}e.diff=d,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(n){n.default="default",n.option="option"})(m=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(n){const r=n;return!!((typeof r.include=="string"||f.isRelativePattern(r.include))&&(typeof r.exclude=="string"||f.isRelativePattern(r.exclude)))}e.isDocumentExcludePattern=a;function S(n,r,h){if(Array.isArray(n.viewType)&&n.viewType.indexOf(r)>=0||n.viewType===r)return!0;if(n.filenamePattern){const c=a(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,w=a(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(f.match(c,(0,D.basename)(h.fsPath).toLowerCase()))return!(w&&f.match(w,(0,D.basename)(h.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=S;class o{constructor(r){this.textModel=r}getElements(){const r=new Int32Array(this.textModel.cells.length);for(let h=0;h<this.textModel.cells.length;h++)r[h]=this.textModel.cells[h].getHashValue();return r}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(r){return`${s._prefix}${r}`}static parse(r){if(r.startsWith(s._prefix))return r.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(be[213],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(be[214],Ee([1,0,4,62]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(be[215],Ee([1,0,180,4,62]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[216],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(be[85],Ee([1,0,2,35]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var T;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(T=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(s){s.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),s.deserialize=n=>({range:t.Range.lift(n.range),uri:f.URI.revive(n.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var k;(function(s){s[s.Error=0]="Error",s[s.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var y;(function(s){s.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&D.serialize(n.location)}),s.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&D.deserialize(n.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));var A;(function(s){s.serialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&D.serialize(n.location)}),s.deserialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&D.deserialize(n.location)})})(A=e.ITestOutputMessage||(e.ITestOutputMessage={}));var N;(function(s){s.serialize=n=>n.type===0?y.serialize(n):A.serialize(n),s.deserialize=n=>n.type===0?y.deserialize(n):A.deserialize(n)})(N=e.ITestMessage||(e.ITestMessage={}));var R;(function(s){s.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(N.serialize)}),s.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(N.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const b="\0",C=(s,n)=>s+b+n;e.namespaceTestTag=C;const g=s=>{const n=s.indexOf(b);return{ctrlId:s.slice(0,n),tagId:s.slice(n+1)}};e.denamespaceTestTag=g;var u;(function(s){s.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),s.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?f.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(u=e.ITestItem||(e.ITestItem={}));var v;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var _;(function(s){s.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:u.serialize(n.item)}),s.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:u.deserialize(n.item)})})(_=e.InternalTestItem||(e.InternalTestItem={}));var E;(function(s){s.serialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.uri!==void 0&&(r.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(r.range=n.item.range?.toJSON()),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}},s.deserialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.range!==void 0&&(r.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}}})(E=e.ITestItemUpdate||(e.ITestItemUpdate={}));const l=(s,n)=>{n.expand!==void 0&&(s.expand=n.expand),n.item!==void 0&&(s.item=s.item?Object.assign(s.item,n.item):n.item)};e.applyTestItemUpdate=l;var d;(function(s){s.serialize=(n,r)=>({..._.serialize(n),children:r,ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(R.serialize)})})(d=e.TestResultItem||(e.TestResultItem={}));var m;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var a;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var S;(function(s){s.deserialize=n=>n.op===0?{op:n.op,item:_.deserialize(n.item)}:n.op===1?{op:n.op,item:E.deserialize(n.item)}:n,s.serialize=n=>n.op===0?{op:n.op,item:_.serialize(n.item)}:n.op===1?{op:n.op,item:E.serialize(n.item)}:n})(S=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(n){}update(n){}remove(n,r){}complete(){}}e.IncrementalChangeCollector=o;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const r=this.createChangeCollector();for(const h of n)switch(h.op){case 0:{const c=_.deserialize(h.item);if(c.parent){if(this.items.has(c.parent)){const w=this.items.get(c.parent);w.children.add(c.item.extId);const P=this.createItem(c,w);this.items.set(c.item.extId,P),r.add(P)}}else{const w=this.createItem(c);this.roots.add(w),this.items.set(c.item.extId,w),r.add(w)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=E.deserialize(h.item),w=this.items.get(c.extId);if(!w)break;c.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,c),r.update(w);break}case 2:{const c=this.items.get(h.itemId);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const w=[[h.itemId]];for(;w.length;)for(const P of w.pop()){const L=this.items.get(P);L&&(w.push(L.children),this.items.delete(P),r.remove(L,L!==c),L.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h.itemId);break;case 3:this.updatePendingRoots(h.amount);break;case 5:this._tags.set(h.tag.id,h.tag);break;case 6:this._tags.delete(h.id);break}r.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=i}),define(be[86],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(T){T.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(D,k=D.length){if(this.path=D,this.viewEnd=k,D.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,k,y=D.parent){if(D.id===k)return new I([k]);let A=[D.id];for(let N=y;N&&N.id!==k;N=N.parent)A.push(N.id);return A.push(k),new I(A.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const k=D.indexOf("\0");return k===-1?D:D.slice(0,k)}static fromString(D){return new I(D.split("\0"))}static join(D,k){return new I([...D.path,k])}static joinToString(D,k){return D.toString()+"\0"+k}static compare(D,k){return D===k?0:k.startsWith(D+"\0")?2:D.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new I(this.path,D)}compare(D){if(typeof D=="string")return I.compare(this.toString(),D);for(let k=0;k<D.viewEnd&&k<this.viewEnd;k++)if(D.path[k]!==this.path[k])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=I}),define(be[217],Ee([1,0,9,38,14,25,13,101,181]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(R,b,C,g){this._contributedVariables=new Map,this._context=R,this._labelService=b,this._userHomePromise=C,g&&(this._envVariablesPromise=g.then(u=>this.prepareEnv(u)))}prepareEnv(R){if(D.isWindows){const b=Object.create(null);return Object.keys(R).forEach(C=>{b[C.toLowerCase()]=R[C]}),b}return R}resolveWithEnvironment(R,b,C){return this.recursiveResolve({env:this.prepareEnv(R),userHome:void 0},b?b.uri:void 0,C)}async resolveAsync(R,b){const C={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(C,R?R.uri:void 0,b)}async resolveAnyBase(R,b,C,g){const u=T.deepClone(b);D.isWindows&&u.windows?Object.keys(u.windows).forEach(_=>u[_]=u.windows[_]):D.isMacintosh&&u.osx?Object.keys(u.osx).forEach(_=>u[_]=u.osx[_]):D.isLinux&&u.linux&&Object.keys(u.linux).forEach(_=>u[_]=u.linux[_]),delete u.windows,delete u.osx,delete u.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,R?R.uri:void 0,u,C,g)}async resolveAnyAsync(R,b,C){return this.resolveAnyBase(R,b,C)}async resolveAnyMap(R,b,C){const g=new Map;return{newConfig:await this.resolveAnyBase(R,b,C,g),resolvedVariables:g}}resolveWithInteractionReplace(R,b,C,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(R,b,C,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(R,b){if(this._contributedVariables.has(R))throw new Error("Variable "+R+" is contributed twice.");this._contributedVariables.set(R,b)}recursiveResolve(R,b,C,g,u){if(I.isString(C))return this.resolveString(R,b,C,g,u);if(I.isArray(C))return C.map(v=>this.recursiveResolve(R,b,v,g,u));if(I.isObject(C)){let v=Object.create(null);return Object.keys(C).forEach(_=>{const E=this.resolveString(R,b,_,g,u);v[E]=this.recursiveResolve(R,b,C[_],g,u)}),v}return C}resolveString(R,b,C,g,u){return C.replace(A.VARIABLE_REGEXP,(_,E)=>{if(E.includes(A.VARIABLE_LHS))return _;let l=this.evaluateSingleVariable(R,_,E,b,g);return u&&u.set(E,l),l!==_&&I.isString(l)&&l.match(A.VARIABLE_REGEXP)&&(l=this.resolveString(R,b,l,g,u)),l})}fsPath(R){return this._labelService?this._labelService.getUriLabel(R,{noPrefix:!0}):R.fsPath}evaluateSingleVariable(R,b,C,g,u){let v;const _=C.split(":");_.length>1&&(C=_[0],v=_[1]);const E=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,y.localize)(0,null,b))},l=()=>{const m=E();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,y.localize)(1,null,b,f.basename(m)))},d=()=>{if(v){const m=this._context.getFolderUri(v);if(m)return m;throw new Error((0,y.localize)(2,null,b,v))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,b)):new Error((0,y.localize)(4,null,b))};switch(C){case"env":if(v){if(R.env){const m=R.env[D.isWindows?v.toLowerCase():v];if(I.isString(m))return m}return""}throw new Error((0,y.localize)(5,null,b));case"config":if(v){const m=this._context.getConfigurationValue(g,v);if(I.isUndefinedOrNull(m))throw new Error((0,y.localize)(6,null,b,v));if(I.isObject(m))throw new Error((0,y.localize)(7,null,b,v));return m}throw new Error((0,y.localize)(8,null,b));case"command":return this.resolveFromMap(b,v,u,"command");case"input":return this.resolveFromMap(b,v,u,"input");default:switch(C){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return g||v?(0,k.normalizeDriveLetter)(this.fsPath(d())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(d()));case"userHome":{if(R.userHome)return R.userHome;throw new Error((0,y.localize)(9,null,b))}case"lineNumber":{const m=this._context.getLineNumber();if(m)return m;throw new Error((0,y.localize)(10,null,b))}case"selectedText":{const m=this._context.getSelectedText();if(m)return m;throw new Error((0,y.localize)(11,null,b))}case"file":return E();case"fileWorkspaceFolder":return l();case"relativeFile":return g||v?f.relative(this.fsPath(d()),E()):E();case"relativeFileDirname":{const m=f.dirname(E());if(g||v){const a=f.relative(this.fsPath(d()),m);return a.length===0?".":a}return m}case"fileDirname":return f.dirname(E());case"fileExtname":return f.extname(E());case"fileBasename":return f.basename(E());case"fileBasenameNoExtension":{const m=f.basename(E());return m.slice(0,m.length-f.extname(m).length)}case"fileDirnameBasename":return f.basename(f.dirname(E()));case"execPath":{const m=this._context.getExecPath();return m||b}case"execInstallFolder":{const m=this._context.getAppRoot();return m||b}case"pathSeparator":return f.sep;default:try{const m=v?`${C}:${v}`:C;return this.resolveFromMap(b,m,u,void 0)}catch{return b}}}}resolveFromMap(R,b,C,g){if(b&&C){const u=g===void 0?C[b]:C[g+":"+b];if(typeof u=="string")return u;throw new Error((0,y.localize)(12,null,R))}return R}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[130],Ee([1,0,4,207]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function A(g){const u=g;return(0,t.isEditorInput)(u?.editor)&&(0,t.isEditorInput)(u?.replacement)}e.isEditorReplacement=A;var N;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function b(g){const u=g;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=b;function C(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(be[218],Ee([1,0,4,130]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(T){const D=T;return typeof T=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=I}),define(be[16],Ee([1,0,18,22,100,143,58,25,14,2,35,61,183,117,63,129,85,86,218,7]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ce){function Te(Z){const{selectionStartLineNumber:Ae,selectionStartColumn:Fe,positionLineNumber:je,positionColumn:Qe}=Z,gt=new l.Position(Ae-1,Fe-1),bt=new l.Position(je-1,Qe-1);return new l.Selection(gt,bt)}Ce.to=Te;function ve(Z){const{anchor:Ae,active:Fe}=Z;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Ce.from=ve})(d=e.Selection||(e.Selection={}));var m;(function(Ce){function Te(Z){if(!Z)return;const{start:Ae,end:Fe}=Z;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Ce.from=Te;function ve(Z){if(!Z)return;const{startLineNumber:Ae,startColumn:Fe,endLineNumber:je,endColumn:Qe}=Z;return new l.Range(Ae-1,Fe-1,je-1,Qe-1)}Ce.to=ve})(m=e.Range||(e.Range={}));var a;(function(Ce){function Te(ve){switch(ve){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ce.to=Te})(a=e.TokenType||(e.TokenType={}));var S;(function(Ce){function Te(Z){return new l.Position(Z.lineNumber-1,Z.column-1)}Ce.to=Te;function ve(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Ce.from=ve})(S=e.Position||(e.Position={}));var o;(function(Ce){function Te(Ae,Fe){return(0,f.coalesce)((0,f.asArray)(Ae).map(je=>ve(je,Fe)))}Ce.from=Te;function ve(Ae,Fe){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:Z(Ae.scheme,Fe),pattern:K.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function Z(Ae,Fe){return Fe&&typeof Ae=="string"?Fe.transformOutgoingScheme(Ae):Ae}})(o=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Ce){function Te(Z){switch(Z){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ce.from=Te;function ve(Z){switch(Z){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ce.to=ve})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Ce){function Te(Z){let Ae;return Z.code&&((0,y.isString)(Z.code)||(0,y.isNumber)(Z.code)?Ae=String(Z.code):Ae={value:String(Z.code.value),target:Z.code.target}),{...m.from(Z.range),message:Z.message,source:Z.source,code:Ae,severity:r.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(n.from),tags:Array.isArray(Z.tags)?(0,f.coalesce)(Z.tags.map(i.from)):void 0}}Ce.from=Te;function ve(Z){const Ae=new l.Diagnostic(m.to(Z),Z.message,r.to(Z.severity));return Ae.source=Z.source,Ae.code=(0,y.isString)(Z.code)?Z.code:Z.code?.value,Ae.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(n.to),Ae.tags=Z.tags&&(0,f.coalesce)(Z.tags.map(i.to)),Ae}Ce.to=ve})(s=e.Diagnostic||(e.Diagnostic={}));var n;(function(Ce){function Te(Z){return{...m.from(Z.location.range),message:Z.message,resource:Z.location.uri}}Ce.from=Te;function ve(Z){return new l.DiagnosticRelatedInformation(new l.Location(Z.resource,m.to(Z)),Z.message)}Ce.to=ve})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(Ce){function Te(Z){switch(Z){case l.DiagnosticSeverity.Error:return C.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return C.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return C.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return C.MarkerSeverity.Hint}return C.MarkerSeverity.Error}Ce.from=Te;function ve(Z){switch(Z){case C.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case C.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case C.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case C.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ce.to=ve})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(Ce){function Te(Z){return typeof Z=="number"&&Z>=l.ViewColumn.One?Z-1:Z===l.ViewColumn.Beside?E.SIDE_GROUP:E.ACTIVE_GROUP}Ce.from=Te;function ve(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ve})(h=e.ViewColumn||(e.ViewColumn={}));function c(Ce){return typeof Ce.range!="undefined"}function w(Ce){return Ce.length===0?!0:!!c(Ce[0])}e.isDecorationOptionsArr=w;var P;(function(Ce){function Te(Qe){return Qe.map(Ce.from)}Ce.fromMany=Te;function ve(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Z(Qe){let gt;if(ve(Qe)){const{language:ft,value:ct}=Qe;gt={value:"```"+ft+`
`+ct+"\n```\n"}}else l.MarkdownString.isMarkdownString(Qe)?gt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?gt={value:Qe}:gt={value:""};const bt=Object.create(null);gt.uris=bt;const Et=ft=>{try{let ct=A.URI.parse(ft,!0);ct=ct.with({query:Ae(ct.query,bt)}),bt[ft]=ct}catch{}return""},ot=new T.marked.Renderer;return ot.link=Et,ot.image=ft=>typeof ft=="string"?Et(I.parseHrefAndDimensions(ft).href):"",(0,T.marked)(gt.value,{renderer:ot}),gt}Ce.from=Z;function Ae(Qe,gt){if(!Qe)return Qe;let bt;try{bt=(0,D.parse)(Qe)}catch{}if(!bt)return Qe;let Et=!1;return bt=(0,k.cloneAndChange)(bt,ot=>{if(A.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[ft]=ot,Et=!0,ft}else return}),Et?JSON.stringify(bt):Qe}function Fe(Qe){const gt=new l.MarkdownString(Qe.value,Qe.supportThemeIcons);return gt.isTrusted=Qe.isTrusted,gt.supportHtml=Qe.supportHtml,gt.baseUri=Qe.baseUri?A.URI.from(Qe.baseUri):void 0,gt}Ce.to=Fe;function je(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Ce.from(Qe)}Ce.fromStrict=je})(P=e.MarkdownString||(e.MarkdownString={}));function L(Ce){return w(Ce)?Ce.map(Te=>({range:m.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?P.fromMany(Te.hoverMessage):Te.hoverMessage?P.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Ce.map(Te=>({range:m.from(Te)}))}e.fromRangeOrRangeWithMessage=L;function M(Ce){return typeof Ce=="undefined"?Ce:typeof Ce=="string"?A.URI.file(Ce):Ce}e.pathOrURIToURI=M;var p;(function(Ce){function Te(ve){return typeof ve=="undefined"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?M(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ce.from=Te})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ce){function Te(ve){return typeof ve=="undefined"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?M(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?p.from(ve.before):void 0,after:ve.after?p.from(ve.after):void 0}}Ce.from=Te})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ce){function Te(ve){if(typeof ve=="undefined")return ve;switch(ve){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Te})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var H;(function(Ce){function Te(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?B.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?U.from(ve.light):void 0,dark:ve.dark?U.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?M(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?p.from(ve.before):void 0,after:ve.after?p.from(ve.after):void 0}}Ce.from=Te})(H=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var re;(function(Ce){function Te(Z){return{text:Z.newText,eol:Z.newEol&&et.from(Z.newEol),range:m.from(Z.range)}}Ce.from=Te;function ve(Z){const Ae=new l.TextEdit(m.to(Z.range),Z.text);return Ae.newEol=typeof Z.eol=="undefined"?void 0:et.to(Z.eol),Ae}Ce.to=ve})(re=e.TextEdit||(e.TextEdit={}));var W;(function(Ce){function Te(Z,Ae){const Fe={edits:[]};if(Z instanceof l.WorkspaceEdit)for(let je of Z._allEntries())je._type===1?Fe.edits.push({_type:1,oldUri:je.from,newUri:je.to,options:je.options,metadata:je.metadata}):je._type===2?Fe.edits.push({_type:2,resource:je.uri,edit:re.from(je.edit),modelVersionId:Ae?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Fe.edits.push({_type:3,metadata:je.metadata,resource:je.uri,edit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Fe.edits.push({_type:3,metadata:je.metadata,resource:je.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(je.uri),edit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(mt.from)}});return Fe}Ce.from=Te;function ve(Z){const Ae=new l.WorkspaceEdit;for(const Fe of Z.edits)Fe.edit?Ae.replace(A.URI.revive(Fe.resource),m.to(Fe.edit.range),Fe.edit.text):Ae.renameFile(A.URI.revive(Fe.oldUri),A.URI.revive(Fe.newUri),Fe.options);return Ae}Ce.to=ve})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var F;(function(Ce){const Te=Object.create(null);Te[l.SymbolKind.File]=0,Te[l.SymbolKind.Module]=1,Te[l.SymbolKind.Namespace]=2,Te[l.SymbolKind.Package]=3,Te[l.SymbolKind.Class]=4,Te[l.SymbolKind.Method]=5,Te[l.SymbolKind.Property]=6,Te[l.SymbolKind.Field]=7,Te[l.SymbolKind.Constructor]=8,Te[l.SymbolKind.Enum]=9,Te[l.SymbolKind.Interface]=10,Te[l.SymbolKind.Function]=11,Te[l.SymbolKind.Variable]=12,Te[l.SymbolKind.Constant]=13,Te[l.SymbolKind.String]=14,Te[l.SymbolKind.Number]=15,Te[l.SymbolKind.Boolean]=16,Te[l.SymbolKind.Array]=17,Te[l.SymbolKind.Object]=18,Te[l.SymbolKind.Key]=19,Te[l.SymbolKind.Null]=20,Te[l.SymbolKind.EnumMember]=21,Te[l.SymbolKind.Struct]=22,Te[l.SymbolKind.Event]=23,Te[l.SymbolKind.Operator]=24,Te[l.SymbolKind.TypeParameter]=25;function ve(Ae){return typeof Te[Ae]=="number"?Te[Ae]:6}Ce.from=ve;function Z(Ae){for(const Fe in Te)if(Te[Fe]===Ae)return Number(Fe);return l.SymbolKind.Property}Ce.to=Z})(F=e.SymbolKind||(e.SymbolKind={}));var q;(function(Ce){function Te(Z){switch(Z){case l.SymbolTag.Deprecated:return 1}}Ce.from=Te;function ve(Z){switch(Z){case 1:return l.SymbolTag.Deprecated}}Ce.to=ve})(q=e.SymbolTag||(e.SymbolTag={}));var G;(function(Ce){function Te(Z){return{name:Z.name,kind:F.from(Z.kind),tags:Z.tags&&Z.tags.map(q.from),containerName:Z.containerName,location:le.from(Z.location)}}Ce.from=Te;function ve(Z){const Ae=new l.SymbolInformation(Z.name,F.to(Z.kind),Z.containerName,le.to(Z.location));return Ae.tags=Z.tags&&Z.tags.map(q.to),Ae}Ce.to=ve})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(Ce){function Te(Z){const Ae={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:m.from(Z.range),selectionRange:m.from(Z.selectionRange),kind:F.from(Z.kind),tags:Z.tags?.map(q.from)??[]};return Z.children&&(Ae.children=Z.children.map(Te)),Ae}Ce.from=Te;function ve(Z){const Ae=new l.DocumentSymbol(Z.name,Z.detail,F.to(Z.kind),m.to(Z.range),m.to(Z.selectionRange));return(0,f.isNonEmptyArray)(Z.tags)&&(Ae.tags=Z.tags.map(q.to)),Z.children&&(Ae.children=Z.children.map(ve)),Ae}Ce.to=ve})($=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(Ce){function Te(Z){const Ae=new l.CallHierarchyItem(F.to(Z.kind),Z.name,Z.detail||"",A.URI.revive(Z.uri),m.to(Z.range),m.to(Z.selectionRange));return Ae._sessionId=Z._sessionId,Ae._itemId=Z._itemId,Ae}Ce.to=Te;function ve(Z,Ae,Fe){if(Ae=Ae??Z._sessionId,Fe=Fe??Z._itemId,Ae===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Fe,name:Z.name,detail:Z.detail,kind:F.from(Z.kind),uri:Z.uri,range:m.from(Z.range),selectionRange:m.from(Z.selectionRange),tags:Z.tags?.map(q.from)}}Ce.from=ve})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Ce){function Te(ve){return new l.CallHierarchyIncomingCall(X.to(ve.from),ve.fromRanges.map(Z=>m.to(Z)))}Ce.to=Te})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ae;(function(Ce){function Te(ve){return new l.CallHierarchyOutgoingCall(X.to(ve.to),ve.fromRanges.map(Z=>m.to(Z)))}Ce.to=Te})(ae=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(Ce){function Te(Z){return{range:Z.range&&m.from(Z.range),uri:Z.uri}}Ce.from=Te;function ve(Z){return new l.Location(A.URI.revive(Z.uri),m.to(Z.range))}Ce.to=ve})(le=e.location||(e.location={}));var se;(function(Ce){function Te(Z){const Ae=Z,Fe=Z;return{originSelectionRange:Ae.originSelectionRange?m.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Fe.uri,range:m.from(Ae.targetRange?Ae.targetRange:Fe.range),targetSelectionRange:Ae.targetSelectionRange?m.from(Ae.targetSelectionRange):void 0}}Ce.from=Te;function ve(Z){return{targetUri:A.URI.revive(Z.uri),targetRange:m.to(Z.range),targetSelectionRange:Z.targetSelectionRange?m.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?m.to(Z.originSelectionRange):void 0}}Ce.to=ve})(se=e.DefinitionLink||(e.DefinitionLink={}));var ee;(function(Ce){function Te(Z){return{range:m.from(Z.range),contents:P.fromMany(Z.contents)}}Ce.from=Te;function ve(Z){return new l.Hover(Z.contents.map(P.to),m.to(Z.range))}Ce.to=ve})(ee=e.Hover||(e.Hover={}));var fe;(function(Ce){function Te(Z){return{range:m.from(Z.range),expression:Z.expression}}Ce.from=Te;function ve(Z){return new l.EvaluatableExpression(m.to(Z.range),Z.expression)}Ce.to=ve})(fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(Ce){function Te(Z){if(Z instanceof l.InlineValueText)return{type:"text",range:m.from(Z.range),text:Z.text};if(Z instanceof l.InlineValueVariableLookup)return{type:"variable",range:m.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Te;function ve(Z){switch(Z.type){case"text":return{range:m.to(Z.range),text:Z.text};case"variable":return{range:m.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:m.to(Z.range),expression:Z.expression}}}Ce.to=ve})(ge=e.InlineValue||(e.InlineValue={}));var ye;(function(Ce){function Te(Z){return{frameId:Z.frameId,stoppedLocation:m.from(Z.stoppedLocation)}}Ce.from=Te;function ve(Z){return new l.InlineValueContext(Z.frameId,m.to(Z.stoppedLocation))}Ce.to=ve})(ye=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(Ce){function Te(Z){return{range:m.from(Z.range),kind:Z.kind}}Ce.from=Te;function ve(Z){return new l.DocumentHighlight(m.to(Z.range),Z.kind)}Ce.to=ve})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var Se;(function(Ce){function Te(ve){switch(ve){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ce.to=Te})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _e;(function(Ce){function Te(ve){return{triggerKind:Se.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ce.to=Te})(_e=e.CompletionContext||(e.CompletionContext={}));var Ie;(function(Ce){function Te(Z){switch(Z){case l.CompletionItemTag.Deprecated:return 1}}Ce.from=Te;function ve(Z){switch(Z){case 1:return l.CompletionItemTag.Deprecated}}Ce.to=ve})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));var de;(function(Ce){const Te=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function ve(Fe){return Te.get(Fe)??9}Ce.from=ve;const Z=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Fe){return Z.get(Fe)??l.CompletionItemKind.Property}Ce.to=Ae})(de=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Ce){function Te(ve,Z){const Ae=new l.CompletionItem(ve.label);return Ae.insertText=ve.insertText,Ae.kind=de.to(ve.kind),Ae.tags=ve.tags?.map(Ie.to),Ae.detail=ve.detail,Ae.documentation=I.isMarkdownString(ve.documentation)?P.to(ve.documentation):ve.documentation,Ae.sortText=ve.sortText,Ae.filterText=ve.filterText,Ae.preselect=ve.preselect,Ae.commitCharacters=ve.commitCharacters,N.Range.isIRange(ve.range)?Ae.range=m.to(ve.range):typeof ve.range=="object"&&(Ae.range={inserting:m.to(ve.range.insert),replacing:m.to(ve.range.replace)}),Ae.keepWhitespace=typeof ve.insertTextRules=="undefined"?!1:Boolean(ve.insertTextRules&1),typeof ve.insertTextRules!="undefined"&&ve.insertTextRules&4?Ae.insertText=new l.SnippetString(ve.insertText):(Ae.insertText=ve.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ve.additionalTextEdits.map(Fe=>re.to(Fe))),Ae.command=Z&&ve.command?Z.fromInternal(ve.command):void 0,Ae}Ce.to=Te})(Q=e.CompletionItem||(e.CompletionItem={}));var ne;(function(Ce){function Te(Z){return{label:Z.label,documentation:P.fromStrict(Z.documentation)}}Ce.from=Te;function ve(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?P.to(Z.documentation):Z.documentation}}Ce.to=ve})(ne=e.ParameterInformation||(e.ParameterInformation={}));var O;(function(Ce){function Te(Z){return{label:Z.label,documentation:P.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(ne.from):[],activeParameter:Z.activeParameter}}Ce.from=Te;function ve(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?P.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(ne.to):[],activeParameter:Z.activeParameter}}Ce.to=ve})(O=e.SignatureInformation||(e.SignatureInformation={}));var x;(function(Ce){function Te(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(O.from):[]}}Ce.from=Te;function ve(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(O.to):[]}}Ce.to=ve})(x=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(Ce){function Te(ve,Z){const Ae=new l.InlayHint(S.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(Y.to.bind(void 0,ve)),Z.kind&&ue.to(Z.kind));return Ae.textEdits=Z.textEdits&&Z.textEdits.map(re.to),Ae.tooltip=I.isMarkdownString(Z.tooltip)?P.to(Z.tooltip):Z.tooltip,Ae.paddingLeft=Z.paddingLeft,Ae.paddingRight=Z.paddingRight,Ae}Ce.to=Te})(j=e.InlayHint||(e.InlayHint={}));var Y;(function(Ce){function Te(ve,Z){const Ae=new l.InlayHintLabelPart(Z.label);return Ae.tooltip=I.isMarkdownString(Z.tooltip)?P.to(Z.tooltip):Z.tooltip,R.Command.is(Z.command)&&(Ae.command=ve.fromInternal(Z.command)),Z.location&&(Ae.location=le.to(Z.location)),Ae}Ce.to=Te})(Y=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ue;(function(Ce){function Te(Z){return Z}Ce.from=Te;function ve(Z){return Z}Ce.to=ve})(ue=e.InlayHintKind||(e.InlayHintKind={}));var pe;(function(Ce){function Te(Z){return{range:m.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Ce.from=Te;function ve(Z){let Ae;if(Z.url)try{Ae=typeof Z.url=="string"?A.URI.parse(Z.url,!0):A.URI.revive(Z.url)}catch{}return new l.DocumentLink(m.to(Z.range),Ae)}Ce.to=ve})(pe=e.DocumentLink||(e.DocumentLink={}));var De;(function(Ce){function Te(Z){const Ae=new l.ColorPresentation(Z.label);return Z.textEdit&&(Ae.textEdit=re.to(Z.textEdit)),Z.additionalTextEdits&&(Ae.additionalTextEdits=Z.additionalTextEdits.map(Fe=>re.to(Fe))),Ae}Ce.to=Te;function ve(Z){return{label:Z.label,textEdit:Z.textEdit?re.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Ae=>re.from(Ae)):void 0}}Ce.from=ve})(De=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(Ce){function Te(Z){return new l.Color(Z[0],Z[1],Z[2],Z[3])}Ce.to=Te;function ve(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Ce.from=ve})(Ue=e.Color||(e.Color={}));var ze;(function(Ce){function Te(Z){return{range:m.from(Z.range)}}Ce.from=Te;function ve(Z){return new l.SelectionRange(m.to(Z.range))}Ce.to=ve})(ze=e.SelectionRange||(e.SelectionRange={}));var He;(function(Ce){function Te(ve){switch(ve){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ce.to=Te})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(Ce){function Te(Z){switch(Z){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Te;function ve(Z){switch(Z){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ce.to=ve})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(Ce){function Te(Z){if(Z===l.EndOfLine.CRLF)return 1;if(Z===l.EndOfLine.LF)return 0}Ce.from=Te;function ve(Z){if(Z===1)return l.EndOfLine.CRLF;if(Z===0)return l.EndOfLine.LF}Ce.to=ve})(et=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(Ce){function Te(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Te})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var Xe;(function(Ce){function Te(ve){const Z={start:ve.start+1,end:ve.end+1};return ve.kind&&(Z.kind=te.from(ve.kind)),Z}Ce.from=Te})(Xe=e.FoldingRange||(e.FoldingRange={}));var te;(function(Ce){function Te(ve){if(ve)switch(ve){case l.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}Ce.from=Te})(te=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Ce){function Te(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?m.from(ve.selection):void 0,override:typeof ve.override=="boolean"?b.EditorResolution.DISABLED:void 0}}Ce.from=Te})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var K;(function(Ce){function Te(Fe){return Fe instanceof l.RelativePattern?Fe.toJSON():typeof Fe=="string"?Fe:ve(Fe)||Z(Fe)?new l.RelativePattern(Fe.baseUri??Fe.base,Fe.pattern).toJSON():Fe}Ce.from=Te;function ve(Fe){const je=Fe;return je?A.URI.isUri(je.baseUri)&&typeof je.pattern=="string":!1}function Z(Fe){const je=Fe;return je?typeof je.base=="string"&&typeof je.pattern=="string":!1}function Ae(Fe){return typeof Fe=="string"?Fe:new l.RelativePattern(A.URI.revive(Fe.baseUri),Fe.pattern)}Ce.to=Ae})(K=e.GlobPattern||(e.GlobPattern={}));var we;(function(Ce){function Te(ve){if(ve){if(Array.isArray(ve))return ve.map(Te);if(typeof ve=="string")return ve;{const Z=ve;return{language:Z.language,scheme:Z.scheme,pattern:K.from(Z.pattern),exclusive:Z.exclusive}}}else return}Ce.from=Te})(we=e.LanguageSelector||(e.LanguageSelector={}));var ke;(function(Ce){function Te(Z){return{start:Z.start,end:Z.end}}Ce.from=Te;function ve(Z){return new l.NotebookRange(Z.start,Z.end)}Ce.to=ve})(ke=e.NotebookRange||(e.NotebookRange={}));var We;(function(Ce){function Te(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Ce.to=Te;function ve(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}Ce.from=ve})(We=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var xe;(function(Ce){function Te(ve){if(ve===u.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(ve===u.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(ve===u.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ve}`)}Ce.to=Te})(xe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(Ce){function Te(Z){switch(Z){case l.NotebookCellKind.Markup:return u.CellKind.Markup;case l.NotebookCellKind.Code:default:return u.CellKind.Code}}Ce.from=Te;function ve(Z){switch(Z){case u.CellKind.Markup:return l.NotebookCellKind.Markup;case u.CellKind.Code:default:return l.NotebookCellKind.Code}}Ce.to=ve})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(Ce){function Te(Z){const Ae={metadata:Z.metadata??Object.create(null),cells:[]};for(let Fe of Z.cells)l.NotebookCellData.validate(Fe),Ae.cells.push(mt.from(Fe));return Ae}Ce.from=Te;function ve(Z){const Ae=new l.NotebookData(Z.cells.map(mt.to));return(0,y.isEmptyObject)(Z.metadata)||(Ae.metadata=Z.metadata),Ae}Ce.to=ve})(st=e.NotebookData||(e.NotebookData={}));var mt;(function(Ce){function Te(Z){return{cellKind:Je.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:We.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(qe.from):[]}}Ce.from=Te;function ve(Z){return new l.NotebookCellData(Je.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(qe.to):void 0,Z.metadata,Z.internalMetadata?We.to(Z.internalMetadata):void 0)}Ce.to=ve})(mt=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(Ce){function Te(Z){return{mime:Z.mime,valueBytes:t.VSBuffer.wrap(Z.data)}}Ce.from=Te;function ve(Z){return new l.NotebookCellOutputItem(Z.valueBytes.buffer,Z.mime)}Ce.to=ve})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(Ce){function Te(Z){return{outputId:Z.id,items:Z.items.map(vt.from),metadata:Z.metadata}}Ce.from=Te;function ve(Z){const Ae=Z.items.map(vt.to);return new l.NotebookCellOutput(Ae,Z.outputId,Z.metadata)}Ce.to=ve})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(Ce){function Te(Ae){return Z(Ae)?{include:(0,y.withNullAsUndefined)(K.from(Ae.include)),exclude:(0,y.withNullAsUndefined)(K.from(Ae.exclude))}:(0,y.withNullAsUndefined)(K.from(Ae))}Ce.from=Te;function ve(Ae){return Z(Ae)?{include:K.to(Ae.include),exclude:K.to(Ae.exclude)}:K.to(Ae)}Ce.to=ve;function Z(Ae){const Fe=Ae;return Fe?!!Fe.include&&!!Fe.exclude:!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var wt;(function(Ce){function Te(ve){return{backgroundColor:ve.backgroundColor,borderColor:ve.borderColor,top:ve.top?p.from(ve.top):void 0}}Ce.from=Te})(wt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var it;(function(Ce){function Te(ve,Z,Ae){const Fe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Fe,Ae),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ce.from=Te})(it=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var dt;(function(Ce){function Te(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{}}}Ce.from=Te})(dt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ut;(function(Ce){function Te(Z){return{uri:Z.uri,provides:Z.provides}}Ce.from=Te;function ve(Z){return new l.NotebookRendererScript(A.URI.revive(Z.uri),Z.provides)}Ce.to=ve})(Ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(Ce){function Te(Z){return{message:P.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,location:Z.location&&{range:m.from(Z.location.range),uri:Z.location.uri}}}Ce.from=Te;function ve(Z){const Ae=new l.TestMessage(typeof Z.message=="string"?Z.message:P.to(Z.message));return Ae.actualOutput=Z.actual,Ae.expectedOutput=Z.expected,Ae.location=Z.location?le.to(Z.location):void 0,Ae}Ce.to=ve})(At=e.TestMessage||(e.TestMessage={}));var Ct;(function(Ce){Ce.namespace=v.namespaceTestTag,Ce.denamespace=v.denamespaceTestTag})(Ct=e.TestTag||(e.TestTag={}));var ht;(function(Ce){function Te(Fe){const je=(0,g.getPrivateApiFor)(Fe).controllerId;return{extId:_.TestId.fromExtHostTestItem(Fe,je).toString(),label:Fe.label,uri:A.URI.revive(Fe.uri),busy:!1,tags:Fe.tags.map(Qe=>Ct.namespace(je,Qe.id)),range:N.Range.lift(m.from(Fe.range)),description:Fe.description||null,sortText:Fe.sortText||null,error:Fe.error&&P.fromStrict(Fe.error)||null}}Ce.from=Te;function ve(Fe){return{parent:void 0,error:void 0,id:_.TestId.fromString(Fe.extId).localId,label:Fe.label,uri:A.URI.revive(Fe.uri),tags:(Fe.tags||[]).map(je=>{const{tagId:Qe}=Ct.denamespace(je);return new l.TestTag(Qe)}),range:m.to(Fe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Fe.description||void 0,sortText:Fe.sortText||void 0}}Ce.toPlain=ve;function Z(Fe){const je=_.TestId.fromString(Fe.extId),Qe=new g.TestItemImpl(je.controllerId,je.localId,Fe.label,A.URI.revive(Fe.uri)||void 0);return Qe.range=m.to(Fe.range||void 0),Qe.description=Fe.description||void 0,Qe.sortText=Fe.sortText||void 0,Qe}function Ae(Fe){let je;for(const Qe of Fe.tests){const gt=Z(Qe.item);(0,g.getPrivateApiFor)(gt).parent=je,je=gt}return je}Ce.toItemFromContext=Ae})(ht=e.TestItem||(e.TestItem={})),function(Ce){function Te(Z){return{id:Z.id}}Ce.from=Te;function ve(Z){return new l.TestTag(Z.id)}Ce.to=ve}(Ct=e.TestTag||(e.TestTag={}));var Rt;(function(Ce){const Te=(Z,Ae)=>{const Fe={...ht.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(Qe=>Qe.type===0).map(At.to)})),children:Z.children.map(je=>Ae.get(je)).filter(y.isDefined).map(je=>Te(je,Ae))};for(const je of Fe.children)je.parent=Fe;return Fe};function ve(Z){const Ae=[],Fe=new Map;for(const je of Z.items)Fe.set(je.item.extId,je),Z.request.targets.some(Qe=>Qe.controllerId===je.controllerId&&Qe.testIds.includes(je.item.extId))&&Ae.push(je);return{completedAt:Z.completedAt,results:Ae.map(je=>Te(je,Fe))}}Ce.to=ve})(Rt=e.TestResults||(e.TestResults={}));var Ft;(function(Ce){function Te(Fe){return{covered:Fe.covered,total:Fe.covered}}function ve(Fe){return"line"in Fe?S.from(Fe):m.from(Fe)}function Z(Fe){return"branches"in Fe?{count:Fe.executionCount,location:ve(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(je=>({count:je.executionCount,location:je.location&&ve(je.location)})):void 0}:{type:0,count:Fe.executionCount,location:ve(Fe.location)}}Ce.fromDetailed=Z;function Ae(Fe){return{uri:Fe.uri,statement:Te(Fe.statementCoverage),branch:Fe.branchCoverage&&Te(Fe.branchCoverage),function:Fe.functionCoverage&&Te(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Z)}}Ce.fromFile=Ae})(Ft=e.TestCoverage||(e.TestCoverage={}));var Nt;(function(Ce){function Te(ve){switch(ve){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ce.to=Te})(Nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ve;(function(Ce){function Te(Z){const Ae=new l.TypeHierarchyItem(F.to(Z.kind),Z.name,Z.detail||"",A.URI.revive(Z.uri),m.to(Z.range),m.to(Z.selectionRange));return Ae._sessionId=Z._sessionId,Ae._itemId=Z._itemId,Ae}Ce.to=Te;function ve(Z,Ae,Fe){if(Ae=Ae??Z._sessionId,Fe=Fe??Z._itemId,Ae===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Fe,kind:F.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:m.from(Z.range),selectionRange:m.from(Z.selectionRange),tags:Z.tags?.map(q.from)}}Ce.from=ve})(Ve=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[219],Ee([1,0,2,12,7,16,91]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(A,N,R,b={timeout:1500,errors:3}){this._logService=A,this._documents=N,this._mainThreadBulkEdits=R,this._thresholds=b,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(N,R,b)=>{const g={dispose:this._callbacks.push([N,R,A])};return Array.isArray(b)&&b.push(g),g}}async $participateInSave(A,N){const R=f.URI.revive(A);let b=!1;const C=setTimeout(()=>b=!0,this._thresholds.timeout),g=[];try{for(let u of[...this._callbacks]){if(b)break;const v=this._documents.getDocument(R),_=await this._deliverEventAsyncAndBlameBadListeners(u,{document:v,reason:T.TextDocumentSaveReason.to(N)});g.push(_)}}finally{clearTimeout(C)}return g}_deliverEventAsyncAndBlameBadListeners([A,N,R],b){const C=this._badListeners.get(A);return typeof C=="number"&&C>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(R,A,N,b).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const u=this._badListeners.get(A);this._badListeners.set(A,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,N,R,b){const C=[],g=Date.now(),{document:u,reason:v}=b,{version:_}=u,E=Object.freeze({document:u,reason:v,waitUntil(l){if(Object.isFrozen(C))throw(0,t.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(l))}});try{N.apply(R,[E])}catch(l){return Promise.reject(l)}return Object.freeze(C),new Promise((l,d)=>{const m=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(C).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(m),l(a)}).catch(a=>{clearTimeout(m),d(a)})}).then(l=>{const d={edits:[]};for(const m of l)if(Array.isArray(m)&&m.every(a=>a instanceof I.TextEdit))for(const{newText:a,newEol:S,range:o}of m)d.edits.push({_type:2,resource:u.uri,edit:{range:o&&T.Range.from(o),text:a,eol:S&&T.EndOfLine.from(S)}});if(d.edits.length!==0)return _===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(be[220],Ee([1,0,10,25,2,16,7,129]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(b,C,g,u){this.start=b,this.deletedCount=C,this.deletedItems=g,this.items=u}asApiEvent(){return{range:new D.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}static asApiEvents(b){return b.map(C=>({start:C.start,deletedCount:C.deletedCount,deletedItems:C.deletedItems,items:C.items.map(g=>g.apiCell)}))}}class A{constructor(b,C,g){this.notebook=b,this._extHostDocument=C,this._cellData=g,this.handle=g.handle,this.uri=I.URI.revive(g.uri),this.cellKind=g.cellKind,this._outputs=g.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=g.internalMetadata??{},this._metadata=Object.freeze(g.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(g.internalMetadata??{}))}static asModelAddData(b,C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,C=this._extHostDocument.getDocument(this.uri);if(!C)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const g={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:C.document,get mime(){return b._mime},set mime(u){b._mime=u},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(g)}return this._apiCell}setOutputs(b){this._outputs=b.map(T.NotebookCellOutput.to)}setOutputItems(b,C,g){const u=g.map(T.NotebookCellOutputItem.to),v=this._outputs.find(_=>_.id===b);v&&(C||(v.items.length=0),v.items.push(...u))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=A;class N{constructor(b,C,g,u,v,_){this._proxy=b,this._textDocumentsAndEditors=C,this._textDocuments=g,this._emitter=u,this.uri=v,this.handle=N._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=_.viewType,this._metadata=Object.freeze(_.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,_.cells]],!0,void 0),this._versionId=_.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,C={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===f.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(g){return g=b._validateIndex(g),b._cells[g].apiCell},getCells(g){return(g?b._getCells(g):b._cells).map(v=>v.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(C)}return this._notebook}updateBackup(b){this._backup?.delete(),this._backup=b}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,C,g){this._versionId=b.versionId,this._isDirty=C,this.acceptDocumentPropertiesChanged({metadata:g});const u={notebook:this.apiNotebook,metadata:g,cellChanges:[],contentChanges:[]},v=[];for(const E of b.rawEvents)E.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(E.changes,!1,u.contentChanges):E.kind===k.NotebookCellsChangeType.Move?this._moveCell(E.index,E.newIdx,u.contentChanges):E.kind===k.NotebookCellsChangeType.Output?(this._setCellOutputs(E.index,E.outputs),v.push({cell:this._cells[E.index].apiCell,outputs:this._cells[E.index].apiCell.outputs})):E.kind===k.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(E.index,E.outputId,E.append,E.outputItems),v.push({cell:this._cells[E.index].apiCell,outputs:this._cells[E.index].apiCell.outputs})):E.kind===k.NotebookCellsChangeType.ChangeLanguage?(this._changeCellLanguage(E.index,E.language),v.push({cell:this._cells[E.index].apiCell,document:this._cells[E.index].apiCell.document})):E.kind===k.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this._cells[E.index].apiCell,document:this._cells[E.index].apiCell.document}):E.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(E.index,E.mime):E.kind===k.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(E.index,E.metadata),v.push({cell:this._cells[E.index].apiCell,metadata:this._cells[E.index].apiCell.metadata})):E.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(E.index,E.internalMetadata),v.push({cell:this._cells[E.index].apiCell,executionSummary:this._cells[E.index].apiCell.executionSummary}));const _=new Map;for(let E=0;E<v.length;E++){const l=v[E],d=_.get(l.cell);if(d===void 0){const m=u.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});_.set(l.cell,m-1)}else u.cellChanges[d]={...u.cellChanges[d],...l}}return Object.freeze(u),Object.freeze(u.cellChanges),Object.freeze(u.contentChanges),u}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let C=b.start|0,g=b.end|0;return C<0&&(C=0),g>this._cells.length&&(g=this._cells.length),b.with({start:C,end:g})}_getCells(b){b=this._validateRange(b);const C=[];for(let g=b.start;g<b.end;g++)C.push(this._cells[g]);return C}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,C,g){if(this._disposed)return;const u=[],v=[],_=[];if(b.reverse().forEach(E=>{const d=E[2].map(S=>{const o=new A(this,this._textDocumentsAndEditors,S);return C||v.push(A.asModelAddData(this.apiNotebook,S)),o}),m=new y(E[0],E[1],[],d),a=this._cells.splice(E[0],E[1],...d);for(const S of a)_.push(S.uri),m.deletedItems.push(S.apiCell);u.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),g)for(let E of u)g.push(E.asApiEvent());C||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(u)}))}_moveCell(b,C,g){const u=this._cells.splice(b,1);this._cells.splice(C,0,...u);const v=[new y(b,1,u.map(_=>_.apiCell),[]),new y(C,0,[],u)];for(const _ of v)g.push(_.asApiEvent());this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(v)}))}_setCellOutputs(b,C){const g=this._cells[b];g.setOutputs(C),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_setCellOutputItems(b,C,g,u){const v=this._cells[b];v.setOutputItems(C,g,u),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(b,C){const g=this._cells[b];g.apiCell.document.languageId!==C&&this._textDocuments.$acceptModelLanguageChanged(g.uri,C)}_changeCellMime(b,C){const g=this._cells[b];g.apiCell.mime=C}_changeCellMetadata(b,C){const g=this._cells[b],u=g.apiCell.metadata;g.setMetadata(C);const v=g.apiCell.metadata;(0,t.equals)(u,v)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:g.apiCell}))}_changeCellInternalMetadata(b,C){this._cells[b].setInternalMetadata(C)}getCellFromApiCell(b){return this._cells.find(C=>C.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(C=>C.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=N,N._handlePool=0}),define(be[131],Ee([1,0,7,16,12]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:A})}replaceCells(y,A,N){this._throwIfFinalized(),!(y===A&&N.length===0)&&this._collectedEdits.push({editType:1,index:y,count:A-y,cells:N.map(t.NotebookCellData.from)})}}class D{constructor(y,A,N,R,b,C){this.id=y,this._proxy=A,this.notebookData=N,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._visibleRanges=R,this._viewColumn=C}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(A){if(!Array.isArray(A)||!A.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");y._selections=A,y._trySetSelections(A)},get visibleRanges(){return y._visibleRanges},revealRange(A,N){y._proxy.$tryRevealRange(y.id,t.NotebookRange.from(A),N??f.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(A){const N=new T(this.document.version);return A(N),y._applyEdit(N.finalize())},setDecorations(A,N){return y.setDecorations(A,N)}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(t.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const A=[];let N=-1;for(let R=0;R<y.cellEdits.length;R++){if(N<0){A.push(y.cellEdits[R]),N++;continue}const C=A[N],g=y.cellEdits[R];if(C.editType===1&&g.editType===1&&C.index===g.index){C.cells.push(...y.cellEdits[R].cells),C.count+=y.cellEdits[R].count;continue}A.push(y.cellEdits[R]),N++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,A)}setDecorations(y,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return A.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(A),y.key)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(be[221],Ee([1,0,16,119,169,21,56,12]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}async withProgress(b,C,g){const u=this._handles++,{title:v,location:_,cancellable:E}=C,l={label:(0,I.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(u,{location:f.ProgressLocation.from(_),title:v,source:l,cancellable:E},b.isUnderDevelopment?void 0:b.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(u,g,!!E)}_withProgress(b,C,g){let u;g&&(u=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,u));const v=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),u&&u.dispose()};let _;try{_=C(new N(this._proxy,b),g&&u?u.token:T.CancellationToken.None)}catch(E){throw v(b),E}return _.then(E=>v(b),E=>v(b)),_}$acceptProgressCanceled(b){const C=this._mapHandleToCancellationSource.get(b);C&&(C.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=y;function A(R,b){return R.message=b.message,typeof b.increment=="number"&&(typeof R.increment=="number"?R.increment+=b.increment:R.increment=b.increment),R}class N extends t.Progress{constructor(b,C){super(g=>this.throttledReport(g));this._proxy=b,this._handle=C}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}$e([(0,D.throttle)(100,(R,b)=>A(R,b),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(be[132],Ee([1,0,55,12,76,16,7]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(b,C,g){const u=k._Keys.nextId();b.$registerTextEditorDecorationType(C.identifier,u,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:u,dispose(){b.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class y{constructor(b,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,C){this._throwIfFinalized();let g=null;if(b instanceof D.Position)g=new D.Range(b,b);else if(b instanceof D.Range)g=b;else throw new Error("Unrecognized location");this._pushEdit(g,C,!1)}insert(b,C){this._throwIfFinalized(),this._pushEdit(new D.Range(b,b),C,!0)}delete(b){this._throwIfFinalized();let C=null;if(b instanceof D.Range)C=b;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(b,C,g){const u=this._document.validateRange(b);this._collectedEdits.push({range:u,text:C,forceMoveMarkers:g})}setEndOfLine(b){if(this._throwIfFinalized(),b!==D.EndOfLine.LF&&b!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=y;class A{constructor(b,C,g,u){this._proxy=b,this._id=C,this._accept(g),this._logService=u;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(_){v._setTabSize(_)},get insertSpaces(){return v._insertSpaces},set insertSpaces(_){v._setInsertSpaces(_)},get cursorStyle(){return v._cursorStyle},set cursorStyle(_){v._setCursorStyle(_)},get lineNumbers(){return v._lineNumbers},set lineNumbers(_){v._setLineNumbers(_)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const C=Math.floor(b);return C>0?C:null}if(typeof b=="string"){const C=parseInt(b,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(b){const C=this._validateTabSize(b);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const C=this._validateInsertSpaces(b);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(b)})))}assign(b){const C={};let g=!1;if(typeof b.tabSize!="undefined"){const u=this._validateTabSize(b.tabSize);u==="auto"?(g=!0,C.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,g=!0,C.tabSize=u)}if(typeof b.insertSpaces!="undefined"){const u=this._validateInsertSpaces(b.insertSpaces);u==="auto"?(g=!0,C.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,g=!0,C.insertSpaces=u)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,g=!0,C.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,g=!0,C.lineNumbers=T.TextEditorLineNumbersStyle.from(b.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(b,C){C.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=A;class N{constructor(b,C,g,u,v,_,E,l){this.id=b,this._proxy=C,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new A(this._proxy,this.id,_,g),this._visibleRanges=E,this._viewColumn=l;const d=this;this.value=Object.freeze({get document(){return u.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(m){if(!(m instanceof D.Selection))throw(0,t.illegalArgument)("selection");d._selections=[m],d._trySetSelection()},get selections(){return d._selections},set selections(m){if(!Array.isArray(m)||m.some(a=>!(a instanceof D.Selection)))throw(0,t.illegalArgument)("selections");d._selections=m,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return d._options.value},set options(m){d._disposed||d._options.assign(m)},get viewColumn(){return d._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,a={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new y(u.getValue(),a);return m(S),d._applyEdit(S)},insertSnippet(m,a,S={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!a||Array.isArray(a)&&a.length===0)o=d._selections.map(i=>T.Range.from(i));else if(a instanceof D.Position){const{lineNumber:i,column:s}=T.Position.from(a);o=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(a instanceof D.Range)o=[T.Range.from(a)];else{o=[];for(const i of a)if(i instanceof D.Range)o.push(T.Range.from(i));else{const{lineNumber:s,column:n}=T.Position.from(i);o.push({startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n})}}return C.$tryInsertSnippet(b,m.value,o,S)},setDecorations(m,a){const S=a.length===0;S&&!d._hasDecorationsForKey.has(m.key)||(S?d._hasDecorationsForKey.delete(m.key):d._hasDecorationsForKey.add(m.key),d._runOnProxy(()=>{if(T.isDecorationOptionsArr(a))return C.$trySetDecorations(b,m.key,T.fromRangeOrRangeWithMessage(a));{const o=new Array(4*a.length);for(let i=0,s=a.length;i<s;i++){const n=a[i];o[4*i]=n.start.line+1,o[4*i+1]=n.start.character+1,o[4*i+2]=n.end.line+1,o[4*i+3]=n.end.character+1}return C.$trySetDecorationsFast(b,m.key,o)}}))},revealRange(m,a){d._runOnProxy(()=>C.$tryRevealRange(b,T.Range.from(m),a||D.TextEditorRevealType.Default))},show(m){C.$tryShowEditor(b,T.ViewColumn.from(m))},hide(){C.$tryHideEditor(b)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,f.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,f.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,f.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,f.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const C=b.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const g=C.edits.map(v=>v.range);g.sort((v,_)=>v.end.line===_.end.line?v.end.character===_.end.character?v.start.line===_.start.line?v.start.character-_.start.character:v.start.line-_.start.line:v.end.character-_.end.character:v.end.line-_.end.line);for(let v=0,_=g.length-1;v<_;v++){const E=g[v].end;if(g[v+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=C.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,u,{setEndOfLine:typeof C.setEndOfLine=="number"?T.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=N}),define(be[222],Ee([1,0,15,3,6,14,63,16,85,86,35]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends I.Disposable{constructor(C){super();this.controllerId=C,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new D.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(C){this._resolveHandler=C;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const C=this.diff;return this.diff=[],C}pushDiff(C){const g=this.diff[this.diff.length-1];if(g&&C.op===1){if(g.op===1&&g.item.extId===C.item.extId){(0,y.applyTestItemUpdate)(g.item,C.item);return}if(g.op===0&&g.item.item.extId===C.item.extId){(0,y.applyTestItemUpdate)(g.item,C.item);return}}this.diff.push(C),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(C,g){const u=this.tree.get(C);if(!!u){if((u.expandLevels===void 0||g>u.expandLevels)&&(u.expandLevels=g),u.expand===1){const v=this.resolveChildren(u);return v.isOpen()?this.expandChildren(u,g-1):v.wait().then(()=>this.expandChildren(u,g-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,g-1)):this.expandChildren(u,g-1)}}dispose(){for(const C of this.tree.values())(0,D.getPrivateApiFor)(C.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(C,g){switch(g.op){case 2:this.pushDiff({op:4,itemId:C.fullId.toString()});break;case 1:this.removeItem(A.TestId.joinToString(C.fullId,g.id));break;case 0:this.upsertItem(g.item,C);break;case 4:for(const u of g.ops)this.onTestItemEvent(C,u);break;case 3:{const{key:u,value:v,previous:_}=g,E=C.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(C);break;case"tags":this.diffTagRefs(v,_,E);break;case"range":this.pushDiff({op:1,item:{extId:E,item:{range:N.Range.lift(k.Range.from(v))}}});break;case"error":this.pushDiff({op:1,item:{extId:E,item:{error:k.MarkdownString.fromStrict(v)||null}}});break;default:this.pushDiff({op:1,item:{extId:E,item:{[u]:v??null}}});break}break}default:(0,T.assertNever)(g)}}upsertItem(C,g){if(!(C instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${C.id} did not`);const u=A.TestId.fromExtHostTestItem(C,this.root.id,g?.actual),v=(0,D.getPrivateApiFor)(C);v.parent&&v.parent!==g?.actual&&v.parent.children.delete(C.id);let _=this.tree.get(u.toString());if(!_){_={fullId:u,actual:C,parent:g?u.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},C.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(C,g),this.pushDiff({op:0,item:{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(C)}}),this.connectItemAndChildren(C,_,g);return}if(_.actual===C){this.connectItem(C,_,g);return}const E=_.actual.children,l=_.actual,d=(0,D.diffTestItems)(l,C);(0,D.getPrivateApiFor)(l).listener=void 0,_.actual=C,_.expand=0;for(const[m,a]of d)this.onTestItemEvent(_,{op:3,key:m,value:a,previous:l[m]});this.connectItemAndChildren(C,_,g);for(const m of E)C.children.get(m.id)||this.removeItem(A.TestId.joinToString(u,m.id))}diffTagRefs(C,g,u){const v=new Set(g.map(_=>_.id));for(const _ of C)v.delete(_.id)||this.incrementTagRefs(_);this.pushDiff({op:1,item:{extId:u,item:{tags:C.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}}),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(C){const g=this.tags.get(C.id);g?g.refCount++:(this.tags.set(C.id,{refCount:1}),this.pushDiff({op:5,tag:{id:k.TestTag.namespace(this.controllerId,C.id),ctrlLabel:this.root.label}}))}decrementTagRefs(C){const g=this.tags.get(C);g&&!--g.refCount&&(this.tags.delete(C),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.controllerId,C)}))}setItemParent(C,g){(0,D.getPrivateApiFor)(C).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(C,g,u){this.setItemParent(C,u);const v=(0,D.getPrivateApiFor)(C);v.parent=u?.actual,v.listener=_=>this.onTestItemEvent(g,_),this.updateExpandability(g)}connectItemAndChildren(C,g,u){this.connectItem(C,g,u);for(const v of C.children)this.upsertItem(v,g)}updateExpandability(C){let g;this._resolveHandler?C.resolveBarrier?g=C.resolveBarrier.isOpen()?3:2:g=C.actual.canResolveChildren?1:0:g=0,g!==C.expand&&(C.expand=g,this.pushDiff({op:1,item:{extId:C.fullId.toString(),expand:g}}),g===1&&C.expandLevels!==void 0&&this.resolveChildren(C))}expandChildren(C,g){if(g<0)return;const u=[];for(const v of C.actual.children){const _=this.expand(A.TestId.joinToString(C.fullId,v.id),g);(0,f.isThenable)(_)&&u.push(_)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(C){if(C.resolveBarrier)return C.resolveBarrier;if(!this._resolveHandler){const _=new f.Barrier;return _.open(),_}C.expand=2,this.pushExpandStateUpdate(C);const g=C.resolveBarrier=new f.Barrier,u=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),C.actual!==this.root&&(C.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(C.actual===this.root?void 0:C.actual)}catch(_){u(_)}return(0,f.isThenable)(v)?v.catch(u).then(()=>{g.open(),this.updateExpandability(C)}):(g.open(),this.updateExpandability(C)),C.resolveBarrier}pushExpandStateUpdate(C){this.pushDiff({op:1,item:{extId:C.fullId.toString(),expand:C.expand}})}removeItem(C){const g=this.tree.get(C);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:C});const u=[g];for(;u.length;){const v=u.pop();if(!!v){(0,D.getPrivateApiFor)(v.actual).listener=void 0;for(const _ of v.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)u.push(this.tree.get(A.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const C=this.collectDiff();C.length&&this.diffOpEmitter.fire(C)}}e.SingleUseTestCollection=R}),define(be[223],Ee([1,0,4,186]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(t.IEnvironmentService)}),define(be[224],Ee([1,0,28,3,9]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(N){this.removedDueToLooping=N}}e.DeltaExtensionsResult=T;class D{constructor(N){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=N,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const N of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(N.identifier))){console.error("Extension `"+N.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(N.identifier),N),this._extensionsArr.push(N),Array.isArray(N.activationEvents))for(let R of N.activationEvents)R==="onUri"&&(R=`onUri:${f.ExtensionIdentifier.toKey(N.identifier)}`),this._activationMap.has(R)||this._activationMap.set(R,[]),this._activationMap.get(R).push(N)}}keepOnly(N){const R=new Set;N.forEach(b=>R.add(f.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>R.has(f.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(N,R){N.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(N));const b=D._findLoopingExtensions(this._extensionDescriptions);if(R=R.concat(b.map(C=>C.identifier)),R.length>0){const C=new Set;R.forEach(g=>C.add(f.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>!C.has(f.ExtensionIdentifier.toKey(g.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(b)}static _findLoopingExtensions(N){const R=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,_){this.addNode(v),this.addNode(_),this._arcs.has(v)?this._arcs.get(v).push(_):this._arcs.set(v,[_])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,_){const E=R.getArcs(v);for(let l=0;l<E.length;l++)if(!_.has(E[l]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let v of N){const _=f.ExtensionIdentifier.toKey(v.identifier);if(b.set(_,v),v.extensionDependencies)for(let E of v.extensionDependencies){const l=f.ExtensionIdentifier.toKey(E);R.addArc(_,l)}}let C=new Set;R.getNodes().filter(v=>R.getArcs(v).length===0).forEach(v=>C.add(v));let g=R.getNodes().filter(v=>!C.has(v)),u;do{u=!1;for(let v=0;v<g.length;v++){const _=g[v];R.hasOnlyGoodArcs(_,C)&&(g.splice(v,1),v--,C.add(_),u=!0)}}while(u);return g.map(v=>b.get(v))}containsActivationEvent(N){return this._activationMap.has(N)}containsExtension(N){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(N))}getExtensionDescriptionsForActivationEvent(N){const R=this._activationMap.get(N);return R?R.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(N){const R=this._extensionsMap.get(f.ExtensionIdentifier.toKey(N));return R||void 0}}e.ExtensionDescriptionRegistry=D;var k;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(k||(k={}));function y(A,N){const R=A.isBuiltin?0:A.isUnderDevelopment?2:1,b=N.isBuiltin?0:N.isUnderDevelopment?2:1;if(R!==b)return R-b;const C=I.posix.basename(A.extensionLocation.path),g=I.posix.basename(N.extensionLocation.path);return C<g?-1:C>g?1:0}}),define(be[133],Ee([1,0,22]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function D(y){const A=f.VSBuffer.alloc(1);switch(y){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=D;function k(y,A){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=k}),define(be[27],Ee([1,0,3,2,4,28,195]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class k{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=k;class y{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=y;class A{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class N{constructor(a){this.dependency=a}}e.MissingExtensionDependency=N;var R;(function(m){m[m.LocalProcess=1]="LocalProcess",m[m.LocalWebWorker=2]="LocalWebWorker",m[m.Remote=3]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(m){if(m===null)return"None";switch(m){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;function C(m,a){return m.enabledApiProposals?m.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=C;function g(m,a){if(!C(m,a))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.checkProposedApiEnabled=g;class u{constructor(a,S,o,i){this.codeLoadingTime=a,this.activateCallTime=S,this.activateResolvedTime=o,this.activationReason=i}}e.ActivationTimes=u;class v{constructor(a,S){this.description=a,this.value=S}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var _;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(_=e.ActivationKind||(e.ActivationKind={}));function E(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform}}e.toExtension=E;function l(m,a){return{identifier:new T.ExtensionIdentifier((0,D.getExtensionId)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!a,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.toExtensionDescription=l;class d{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,S){return Promise.resolve(0)}getInspectPorts(a,S){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,S){return Promise.resolve()}}e.NullExtensionService=d}),define(be[225],Ee([1,0,12,28,27,11,15]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class k{constructor(v,_,E,l){this.startup=v,this.codeLoadingTime=_,this.activateCallTime=E,this.activateResolvedTime=l}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,_){return v===-1||_===-1?-1:_-v}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class A{constructor(v,_,E,l,d,m){this.activationFailed=v,this.activationFailedError=_,this.activationTimes=E,this.module=l,this.exports=d,this.subscriptions=m}}e.ActivatedExtension=A;class N extends A{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class R extends A{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=R;class b extends A{constructor(v){super(!0,v,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let C=class{constructor(v,_,E,l,d){this._logService=d,this._registry=v,this._resolvedExtensionsSet=new Set,_.forEach(m=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,E.forEach(m=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(m),m)),this._host=l,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,_]of this._operations)_.dispose()}isActivated(v){const _=this._operations.get(t.ExtensionIdentifier.toKey(v));return Boolean(_&&_.value)}getActivatedExtension(v){const _=this._operations.get(t.ExtensionIdentifier.toKey(v));if(!_||!_.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return _.value}async activateByEvent(v,_){if(this._alreadyActivatedEvents[v])return;const E=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(E.map(l=>({id:l.identifier,reason:{startup:_,extensionId:l.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,_){const E=this._registry.getExtensionDescription(v);if(!E)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:E.identifier,reason:_}])}async _activateExtensions(v){const _=v.filter(E=>!this.isActivated(E.id)).map(E=>this._handleActivationRequest(E));await Promise.all(_.map(E=>E.wait()))}_handleActivationRequest(v){if(this._operations.has(t.ExtensionIdentifier.toKey(v.id)))return this._operations.get(t.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const _=this._registry.getExtensionDescription(v.id);if(!_){const d=new Error(`Cannot activate unknown extension '${v.id.value}'`),m=this._createAndSaveOperation(v,null,[],new b(d));return this._host.onExtensionActivationError(v.id,d,new I.MissingExtensionDependency(v.id.value)),m}const E=[],l=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;for(const d of l){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(d)))continue;const m=this._operations.get(t.ExtensionIdentifier.toKey(d));if(m){E.push(m);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(d))){E.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(d)),reason:v.reason}));continue}const a=this._registry.getExtensionDescription(d);if(a){if(!a.main&&!a.browser)continue;E.push(this._handleActivationRequest({id:a.identifier,reason:v.reason}));continue}const S=_.displayName||_.identifier.value,o=new Error(`Cannot activate the '${S}' extension because it depends on unknown extension '${d}'`),i=this._createAndSaveOperation(v,_.displayName,[],new b(o));return this._host.onExtensionActivationError(_.identifier,o,new I.MissingExtensionDependency(d)),i}return this._createAndSaveOperation(v,_.displayName,E,null)}_createAndSaveOperation(v,_,E,l){const d=new g(v.id,_,v.reason,E,l,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(v.id),d),d}};C=$e([Be(4,T.ILogService)],C),e.ExtensionsActivator=C;let g=class{constructor(v,_,E,l,d,m,a){this._id=v,this._displayName=_,this._reason=E,this._deps=l,this._value=d,this._host=m,this._logService=a,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const _=this._deps[v];if(_.value&&!_.value.activationFailed){this._deps.splice(v,1),v--;continue}if(_.value&&_.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${_.friendlyName}' failed to activate`);E.detail=_.value.activationFailedError,this._value=new b(E),this._host.onExtensionActivationError(this._id,E,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const _=new Error;if(v&&v.name&&(_.name=v.name),v&&v.message?_.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:_.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(_.stack=v.stack),this._value=new b(_),this._isDisposed&&f.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,_,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};g=$e([Be(6,T.ILogService)],g)}),define(be[226],Ee([1,0,11,26,27]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends f.LogService{constructor(k,y){super(k.createLogger(y.logFile,{name:I.ExtensionHostLogFileName}))}};T=$e([Be(0,f.ILoggerService),Be(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(be[227],Ee([1,0,12]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,D)=>{this._actualOk=T,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,f.onUnexpectedError)(T))}then(T,D){return this._ensureActual().then(T,D)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(be[52],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const t=[];function I(k){const y=new f(k);return t[y.nid]=y,y}e.createProxyIdentifier=I;function T(k){return t[k].sid}e.getStringIdentifierForProxy=T;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(be[5],Ee([1,0,58,2,52]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.NotebookInput=3]="NotebookInput",E[E.NotebookDiffInput=4]="NotebookDiffInput",E[E.CustomEditorInput=5]="CustomEditorInput",E[E.WebviewEditorInput=6]="WebviewEditorInput",E[E.TerminalEditorInput=7]="TerminalEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var k;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var N;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(N=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(l){return l._id=b._n++,l}}e.IdObject=b,b._n=0;var C;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.command="m",E.kindModifier="n"})(C=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var u;(function(E){E[E.File=1]="File",E[E.Text=2]="Text",E[E.Cell=3]="Cell"})(u=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(E){if(E&&E.edits)for(const l of E.edits)typeof l.resource=="object"?l.resource=t.URI.revive(l.resource):(l.newUri=t.URI.revive(l.newUri),l.oldUri=t.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,f.revive)(l.metadata));return E}e.reviveWorkspaceEditDto=v;var _;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(be[87],Ee([1,0,5,3,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,A){return this._proxy.$setPassword(k,y,A)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(be[65],Ee([1,0,4,11,5,17]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,A,N){const R=this.getUsageKey(y,A);this._reportedUsages.has(R)||(this._reportedUsages.add(R),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:y}))}getUsageKey(y,A){return`${y}-${A.identifier.value}`}};D=$e([Be(0,T.IExtHostRpcService),Be(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,A){}})}),define(be[228],Ee([1,0,3,5,7,28]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,A,N,R={}){const b=T.ExtensionIdentifier.toKey(y.identifier),C=this._inFlightRequests.get(b)||[],g=[...N].sort().join(" ");let u=C.find(v=>v.scopes===g);if(u)return u.result;{const v=this._getSession(y,b,A,N,R);u={scopes:g,result:v},C.push(u),this._inFlightRequests.set(b,C);try{await v}finally{const _=C.findIndex(E=>E.scopes===g);_>-1&&(C.splice(_),this._inFlightRequests.set(b,C))}return v}}async _getSession(y,A,N,R,b={}){await this._proxy.$ensureProvider(N);const C=y.displayName||y.name;return this._proxy.$getSession(N,R,A,C,b)}async removeSession(y,A){const N=this._authenticationProviders.get(y);return N?N.provider.removeSession(A):this._proxy.$removeSession(y,A)}registerAuthenticationProvider(y,A,N,R){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:A,provider:N,options:R??{supportsMultipleAccounts:!1}}),this._providers.find(C=>C.id===y)||this._providers.push({id:y,label:A});const b=N.onDidChangeSessions(C=>{this._proxy.$sendDidChangeSessions(y,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,A,R?.supportsMultipleAccounts??!1),new I.Disposable(()=>{b.dispose(),this._authenticationProviders.delete(y);const C=this._providers.findIndex(g=>g.id===y);C>-1&&this._providers.splice(C),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,A){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this._onDidChangeSessions.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(be[229],Ee([1,0,5,17,16]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,y){this._proxy=k.getProxy(f.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:A=>y.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k){const y=I.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(y)}};T=$e([Be(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[230],Ee([1,0,5]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const D=T.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(k){return D.$writeText(k)}})}}e.ExtHostClipboard=t});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[40],Ee([1,0,14,7,16,25,5,18,11,58,35,48,2,6,4,17,63,22,52,49]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(n,r){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ye(this,d,n.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=r,this.converter=new a(this,h=>{const c=this._apiCommands.get(h);return c?.result===o.Void?c:void 0},r),this._argumentProcessors=[{processArgument(h){return(0,A.revive)(h)}},{processArgument(h){return(0,T.cloneAndChange)(h,function(c){if(N.Range.isIRange(c))return I.Range.to(c);if(R.Position.isIPosition(c))return I.Position.to(c);if(N.Range.isIRange(c.range)&&b.URI.isUri(c.uri))return I.location.to(c);if(c instanceof _.VSBuffer)return c.buffer.buffer;if(!Array.isArray(c))return c})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const r=this.registerCommand(!1,n.id,async(...h)=>{const c=n.args.map((P,L)=>{if(!P.validate(h[L]))throw new Error(`Invalid argument '${P.name}' when running '${n.id}', received: ${h[L]}`);return P.convert(h[L])}),w=await this.executeCommand(n.internalId,...c);return n.result.convert(w,h,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{r.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,r,h,c,w,P){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:h,thisArg:c,description:w,extension:P}),n&&Le(this,d,"f").$registerCommand(r),new t.Disposable(()=>{this._commands.delete(r)&&n&&Le(this,d,"f").$unregisterCommand(r)})}executeCommand(n,...r){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,r,!0)}async _doExecuteCommand(n,r,h){if(this._commands.has(n))return this._executeContributedCommand(n,r,!1);{let c=!1;const w=(0,T.cloneAndChange)(r,function(P){if(P instanceof t.Position)return I.Position.from(P);if(P instanceof t.Range)return I.Range.from(P);if(P instanceof t.Location)return I.location.from(P);if(t.NotebookRange.isNotebookRange(P))return I.NotebookRange.from(P);if(P instanceof ArrayBuffer)return c=!0,_.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return c=!0,_.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await Le(this,d,"f").$executeCommand(n,c?new E.SerializableObjectWithBuffers(w):w,h);return(0,A.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(n,r,!1);throw P}}}async _executeContributedCommand(n,r,h){const c=this._commands.get(n);if(!c)throw new Error("Unknown command");let{callback:w,thisArg:P,description:L}=c;if(L)for(let M=0;M<L.args.length;M++)try{(0,f.validateConstraint)(r[M],L.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${L.args[M].name}' - ${L.args[M].description}`)}try{return await w.apply(P,r)}catch(M){if(n===this.converter.delegatingCommandId){const p=this.converter.getActualCommand(...r);p&&(n=p.command)}throw this._logService.error(M,n,c.extension?.identifier),h?new class extends Error{constructor(){super((0,l.toErrorMessage)(M));this.id=n,this.source=c.extension?.displayName??c.extension?.name}}:M}}$executeContributedCommand(n,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(r=r.map(h=>this._argumentProcessors.reduce((c,w)=>w.processArgument(c),h)),this._executeContributedCommand(n,r,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Le(this,d,"f").$getCommands().then(r=>(n&&(r=r.filter(h=>h[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(let[r,h]of this._commands){let{description:c}=h;c&&(n[r]=c)}return Promise.resolve(n)}};d=new WeakMap,m=$e([Be(0,u.IExtHostRpcService),Be(1,y.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class a{constructor(n,r,h){this._commands=n,this._lookupApiCommand=r,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,r){if(!n)return;const h={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return h;const c=this._lookupApiCommand(n.command);if(c)h.id=c.internalId,h.arguments=c.args.map((w,P)=>w.convert(n.arguments&&n.arguments[P]));else if((0,k.isNonEmptyArray)(n.arguments)){const w=++this._cachIdPool;this._cache.set(w,n),r.add((0,C.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),h.$ident=w,h.id=this.delegatingCommandId,h.arguments=[w],this._logService.trace("CommandsConverter#CREATE",n.command,w)}return h}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const r=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class S{constructor(n,r,h,c){this.name=n,this.description=r,this.validate=h,this.convert=c}optional(){return new S(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,r){return new S(n??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",s=>b.URI.isUri(s),s=>s),S.Position=new S("position","A position in a text document",s=>t.Position.isPosition(s),I.Position.from),S.Range=new S("range","A range in a text document",s=>t.Range.isRange(s),I.Range.from),S.Selection=new S("selection","A selection in a text document",s=>t.Selection.isSelection(s),I.Selection.from),S.Number=new S("number","",s=>typeof s=="number",s=>s),S.String=new S("string","",s=>typeof s=="string",s=>s),S.CallHierarchyItem=new S("item","A call hierarchy item",s=>s instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",s=>s instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",s=>s instanceof v.TestItemImpl,I.TestItem.from);class o{constructor(n,r){this.description=n,this.convert=r}}e.ApiCommandResult=o,o.Void=new o("no result",s=>s);class i{constructor(n,r,h,c,w){this.id=n,this.internalId=r,this.description=h,this.args=c,this.result=w}}e.ApiCommand=i}),define(be[231],Ee([1,0,2,16,7,61,40,18,112,118,10]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,v)=>{if((0,k.isFalsyOrEmpty)(u))return;class _ extends I.SymbolInformation{static to(l){const d=new _(l.name,t.SymbolKind.to(l.kind),l.containerName||"",new I.Location(v[0],t.Range.to(l.range)));return d.detail=l.detail,d.range=d.location.range,d.selectionRange=t.Range.to(l.selectionRange),d.children=l.children?l.children.map(_.to):[],d}}return u.map(_.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new D.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(v=>I.Position.isPosition(v)),u=>u.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(v=>{let _;for(const E of v.reverse())_=new I.SelectionRange(t.Range.to(E),_);return _}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:t.Range.to(u.range),placeholder:u.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return t.WorkspaceEdit.to(u)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new I.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const v=(0,y.decodeSemanticTokensDto)(u);if(v.type==="full")return new I.SemanticTokens(v.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new I.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const v=(0,y.decodeSemanticTokensDto)(u);if(v.type==="full")return new I.SemanticTokens(v.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,v,_)=>{if(!u)return new I.CompletionList([]);const E=u.suggestions.map(l=>t.CompletionItem.to(l,_));return new I.CompletionList(E,u.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return t.SignatureHelp.to(u)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,v,_)=>C(E=>new I.CodeLens(t.Range.to(E.range),E.command&&_.fromInternal(E.command)))(u))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>I.Range.isRange(u),u=>I.Selection.isSelection(u)?t.Selection.from(u):t.Range.from(u)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,v,_)=>C(E=>{if(E._isSynthetic){if(!E.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(E.command)}else{const l=new I.CodeAction(E.title,E.kind?new I.CodeActionKind(E.kind):void 0);return E.edit&&(l.edit=t.WorkspaceEdit.to(E.edit)),E.command&&(l.command=_.fromInternal(E.command)),l.isPreferred=E.isPreferred,l}})(u))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(v=>new I.ColorInformation(t.Range.to(v.range),t.Color.to(v.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",u=>u instanceof I.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:t.Range.from(u.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,v,_)=>u.map(t.InlayHint.to.bind(void 0,_)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(v=>t.NotebookExclusiveDocumentPattern.to(v))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,A.matchesSomeScheme)(u,N.Schemas.http,N.Schemas.https),u=>u),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[t.ViewColumn.from(u),void 0]:[t.ViewColumn.from(u.viewColumn),t.TextEditorOpenOptions.from(u)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[t.ViewColumn.from(u),void 0]:[t.ViewColumn.from(u.viewColumn),t.TextEditorOpenOptions.from(u)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[t.ViewColumn.from(u.viewColumn),t.TextEditorOpenOptions.from(u)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class b{static register(v){R.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=b;function C(u){return v=>{if(Array.isArray(v))return v.map(u)}}function g(u){if(!Array.isArray(u))return;const v=[];for(const _ of u)T.isLocationLink(_)?v.push(t.DefinitionLink.to(_)):v.push(t.location.to(_));return v}}),define(be[232],Ee([1,0,15,56,3,6,2,61,28,16,7,27,5]),function(J,e,f,t,I,T,D,k,y,A,N,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(g,u,v){const _=g.getProxy(b.MainContext.MainThreadComments);class E{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const r=this._commentControllers.get(n.handle);return r?r.value:n}else if(n&&n.$mid===7){const r=this._commentControllers.get(n.commentControlHandle);if(!r)return n;const h=r.getCommentThread(n.commentThreadHandle);return h?h.value:n}else if(n&&n.$mid===8){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const h=r.getCommentThread(n.thread.commentThreadHandle);return h?{thread:h.value,text:n.text}:n}else if(n&&n.$mid===9){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const h=r.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;let c=n.commentUniqueId,w=h.getCommentByUniqueId(c);return w||n}else if(n&&n.$mid===10){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const h=r.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;let c=n.text,w=n.commentUniqueId,P=h.getCommentByUniqueId(w);return P?(P.body=c,P):n}return n}})}createCommentController(n,r,h){const c=E.handlePool++,w=new d(n,c,r,h);this._commentControllers.set(w.handle,w);const P=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(n.identifier))||[];return P.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(n.identifier),P),w.value}$createCommentThreadTemplate(n,r,h){const c=this._commentControllers.get(n);!c||c.$createCommentThreadTemplate(r,h)}async $updateCommentThreadTemplate(n,r,h){const c=this._commentControllers.get(n);!c||c.$updateCommentThreadTemplate(r,h)}$deleteCommentThread(n,r){const h=this._commentControllers.get(n);h&&h.$deleteCommentThread(r)}$provideCommentingRanges(n,r,h){const c=this._commentControllers.get(n);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(D.URI.revive(r));return(0,f.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(w,h)).then(P=>P?P.map(L=>A.Range.from(L)):void 0)}$toggleReaction(n,r,h,c,w){const P=this._commentControllers.get(n);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const L=P.getCommentThread(r);if(L){const M=L.getCommentByUniqueId(c.uniqueIdInThread);if(P!==void 0&&M&&P.reactionHandler)return P.reactionHandler(M,S(w))}return Promise.resolve(void 0)})}dispose(){}}E.handlePool=0;class l{constructor(n,r,h,c,w,P,L){this._commentControllerHandle=r,this._id=h,this._uri=c,this._range=w,this._comments=P,this.extensionDescription=L,this.handle=l._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),_.$createCommentThread(r,this.handle,this._id,this._uri,A.Range.from(this._range),L.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(r,this.handle)}});const M=this;this.value={get uri(){return M.uri},get range(){return M.range},set range(p){M.range=p},get comments(){return M.comments},set comments(p){M.comments=p},get collapsibleState(){return M.collapsibleState},set collapsibleState(p){M.collapsibleState=p},get canReply(){return M.canReply},set canReply(p){M.canReply=p},get contextValue(){return M.contextValue},set contextValue(p){M.contextValue=p},get label(){return M.label},set label(p){M.label=p},get state(){return M.state},set state(p){M.state=p},dispose:()=>{M.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get state(){return(0,R.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(n){(0,R.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=n,this.modifications.state=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const n=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),r={};n("range")&&(r.range=A.Range.from(this._range)),n("label")&&(r.label=this.label),n("contextValue")&&(r.contextValue=this.contextValue??null),n("comments")&&(r.comments=this._comments.map(h=>m(this,h,this._commentsMap))),n("collapsibleState")&&(r.collapseState=o(this._collapseState)),n("canReply")&&(r.canReply=this.canReply),n("state")&&(r.state=i(this._state)),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(n){for(let r of this._commentsMap){let h=r[0],c=r[1];if(n===c)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}l._handlePool=0,$e([(0,t.debounce)(100)],l.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(n,r,h,c){this._extension=n,this._handle=r,this._id=h,this._label=c,this._threads=new Map,_.$registerCommentController(this.handle,h,c);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(P){w.options=P},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(P){w.commentingRangeProvider=P},get reactionHandler(){return w.reactionHandler},set reactionHandler(P){w.reactionHandler=P},createCommentThread(P,L,M){return w.createCommentThread(P,L,M).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,_.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,r,h,c){if(typeof n=="string"){const w=new l(this.id,this.handle,n,r,h,c,this._extension);return this._threads.set(w.handle,w),w}else{const w=new l(this.id,this.handle,void 0,n,r,h,this._extension);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(n,r){const h=new l(this.id,this.handle,void 0,D.URI.revive(n),A.Range.to(r),[],this._extension);return h.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(n,r){let h=this._threads.get(n);h&&(h.range=A.Range.to(r))}$deleteCommentThread(n){let r=this._threads.get(n);r&&r.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function m(s,n,r){let h=r.get(n);h||(h=++s.commentHandle,r.set(n,h));const c=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:h,body:typeof n.body=="string"?n.body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:c,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>a(w)):void 0,timestamp:n.timestamp?.toJSON()}}function a(s){return{label:s.label,iconPath:s.iconPath?A.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function S(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?D.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function o(s){if(s!==void 0)switch(s){case N.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function i(s){if(s!==void 0)switch(s){case N.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new E}e.createExtHostComments=C}),define(be[134],Ee([1,0,2,5,7,4,17,11,18,8,9]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let R=class yi{constructor(C,g){this._logService=g,this._provider=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,g){const u=yi._handlePool++;this._provider.set(u,{provider:C,extensionId:g}),this._proxy.$registerDecorationProvider(u,g.value);const v=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(_=>{if(!_){this._proxy.$onDidChange(u,null);return}let E=(0,y.asArray)(_);if(E.length<=yi._maxEventSize){this._proxy.$onDidChange(u,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,E.length);const l=E.map(a=>({uri:a,rank:(0,A.count)(a.path,"/")})),d=(0,y.groupBy)(l,(a,S)=>a.rank-S.rank||(0,A.compare)(a.uri.path,S.uri.path));let m=[];e:for(let a of d){let S;for(let o of a){let i=(0,N.dirname)(o.uri.path);if(S!==i&&(S=i,m.push(o.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(u,m)});return new I.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(C,g,u){if(!this._provider.has(C))return Object.create(null);const v=Object.create(null),{provider:_,extensionId:E}=this._provider.get(C);return await Promise.all(g.map(async l=>{try{const{uri:d,id:m}=l,a=await Promise.resolve(_.provideFileDecoration(f.URI.revive(d),u));if(!a)return;try{I.FileDecoration.validate(a),v[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${E.value}': ${S}`)}}catch(d){this._logService.error(d)}})),v}};R._handlePool=0,R._maxEventSize=250,R=$e([Be(0,D.IExtHostRpcService),Be(1,k.ILogService)],R),e.ExtHostDecorations=R,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[233],Ee([1,0,167,117,2,5,7,16,3,11,24,44]),function(J,e,f,t,I,T,D,k,y,A,N,R){"use strict";var b,C,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(E,l,d,m,a,S){this._name=E,this._owner=l,this._maxDiagnosticsPerFile=d,b.set(this,void 0),C.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Ye(this,g,new N.ResourceMap(o=>m.getComparisonKey(o)),"f"),Ye(this,b,a,"f"),Ye(this,C,S,"f")}dispose(){this._isDisposed||(Le(this,C,"f").fire([...Le(this,g,"f").keys()]),Le(this,b,"f")&&Le(this,b,"f").$clear(this._owner),Le(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(E,l){if(!E){this.clear();return}this._checkDisposed();let d=[];if(I.URI.isUri(E)){if(!l){this.delete(E);return}Le(this,g,"f").set(E,l.slice()),d=[E]}else if(Array.isArray(E)){d=[];let a;E=[...E].sort(u._compareIndexedTuplesByUri);for(const S of E){const[o,i]=S;if((!a||o.toString()!==a.toString())&&(a&&Le(this,g,"f").get(a).length===0&&Le(this,g,"f").delete(a),a=o,d.push(o),Le(this,g,"f").set(o,[])),i){const s=Le(this,g,"f").get(o);s&&s.push(...i)}else{const s=Le(this,g,"f").get(o);s&&(s.length=0)}}}if(Le(this,C,"f").fire(d),!Le(this,b,"f"))return;const m=[];for(let a of d){let S=[];const o=Le(this,g,"f").get(a);if(o)if(o.length>this._maxDiagnosticsPerFile){S=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let n of o)if(n.severity===i[s]&&S.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,f.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=o.map(i=>k.Diagnostic.from(i));m.push([a,S])}Le(this,b,"f").$changeMany(this._owner,m)}delete(E){this._checkDisposed(),Le(this,C,"f").fire([E]),Le(this,g,"f").delete(E),Le(this,b,"f")&&Le(this,b,"f").$changeMany(this._owner,[[E,void 0]])}clear(){this._checkDisposed(),Le(this,C,"f").fire([...Le(this,g,"f").keys()]),Le(this,g,"f").clear(),Le(this,b,"f")&&Le(this,b,"f").$clear(this._owner)}forEach(E,l){this._checkDisposed();for(let d of Le(this,g,"f").keys())E.apply(l,[d,this.get(d),this])}get(E){this._checkDisposed();const l=Le(this,g,"f").get(E);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(E){return this._checkDisposed(),Array.isArray(Le(this,g,"f").get(E))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(E,l){return E[0].toString()<l[0].toString()?-1:E[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=u,b=new WeakMap,C=new WeakMap,g=new WeakMap;let v=class ai{constructor(E,l,d){this._logService=l,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,ai._mapper),this._proxy=E.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(E){const l=new N.ResourceMap;for(const d of E)l.set(d,d);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(E,l){const{_collections:d,_proxy:m,_onDidChangeDiagnostics:a,_logService:S,_fileSystemInfoService:o}=this,i=new class{$changeMany(r,h){m.$changeMany(r,h),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,r,h.length===0?"CLEARING":h)}$clear(r){m.$clear(r),S.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,r)}dispose(){m.dispose()}};let s;if(!l)l="_generated_diagnostic_collection_name_#"+ai._idPool++,s=l;else if(!d.has(l))s=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do s=l+ai._idPool++;while(d.has(s))}return new class extends u{constructor(){super(l,s,ai._maxDiagnosticsPerFile,o.extUri,i,a);d.set(s,this)}dispose(){super.dispose(),d.delete(s)}}}getDiagnostics(E){if(E)return this._getDiagnostics(E);{const l=new Map,d=[];for(const m of this._collections.values())m.forEach((a,S)=>{let o=l.get(a.toString());typeof o=="undefined"&&(o=d.length,l.set(a.toString(),o),d.push([a,[]])),d[o][1]=d[o][1].concat(...S)});return d}}_getDiagnostics(E){let l=[];for(let d of this._collections.values())d.has(E)&&(l=l.concat(d.get(E)));return l}$acceptMarkersChange(E){if(!this._mirrorCollection){const l="_generated_mirror",d=new u(l,l,ai._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,d),this._mirrorCollection=d}for(const[l,d]of E)this._mirrorCollection.set(I.URI.revive(l),d.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=$e([Be(1,A.ILogService),Be(2,R.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(be[234],Ee([1,0,2,5]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(D){this._proxy=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(k=>k?k.map(y=>f.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(k=>k?f.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(be[235],Ee([1,0,12,2,7,5,10,21,8]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(R,b,C){this._documentsAndEditors=b,this._logService=C,this._documentContentProviders=new Map,this._proxy=R.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(R,b){if(Object.keys(D.Schemas).indexOf(R)>=0)throw new Error(`scheme '${R}' already registered`);const C=A._handlePool++;this._documentContentProviders.set(C,b),this._proxy.$registerTextContentProvider(C,R);let g;return typeof b.onDidChange=="function"&&(g=b.onDidChange(u=>{if(u.scheme!==R){this._logService.warn(`Provider for scheme '${R}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(C,u).then(v=>{if(!v&&typeof v!="string")return;const _=this._documentsAndEditors.getDocument(u);if(!_)return;const E=(0,y.splitLines)(v);if(!_.equalLines(E))return this._proxy.$onVirtualDocumentChange(u,v)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(R,b){const C=this._documentContentProviders.get(R);return C?Promise.resolve(C.provideTextDocumentContent(t.URI.revive(b),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(be[236],Ee([1,0,3,6,2,5,125,16,14,25,7]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(C,g){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const v of u)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const v of u)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const g=this._documentsAndEditors.getDocument(C);if(g)return g}getDocument(C){const g=this.getDocumentData(C);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return g.document}ensureDocumentData(C){const g=this._documentsAndEditors.getDocument(C);if(g)return Promise.resolve(g);let u=this._documentLoader.get(C.toString());return u||(u=this._proxy.$tryOpenDocument(C).then(v=>{this._documentLoader.delete(C.toString());const _=I.URI.revive(v);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(_))},v=>(this._documentLoader.delete(C.toString()),Promise.reject(v))),this._documentLoader.set(C.toString(),u)),u}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(C,g){const u=I.URI.revive(C),v=this._documentsAndEditors.getDocument(u);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(g),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(C){const g=I.URI.revive(C),u=this._documentsAndEditors.getDocument(g);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(C,g){const u=I.URI.revive(C),v=this._documentsAndEditors.getDocument(u);if(!v)throw new Error("unknown document");v._acceptIsDirty(g),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,g,u){const v=I.URI.revive(C),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(u),_.onEvents(g);let E;g.isUndoing?E=N.TextDocumentChangeReason.Undo:g.isRedoing&&(E=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:_.document,contentChanges:g.changes.map(l=>({range:k.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:E}))}setWordDefinitionFor(C,g){(0,D.setWordDefinitionFor)(C,g)}}e.ExtHostDocuments=R}),define(be[45],Ee([1,0,55,3,6,2,4,5,125,17,132,16,11,24,10,77,90]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class _{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(d,m){this._extHostRpc=d,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const m=[],a=[],S=[];if(d.removedDocuments)for(const o of d.removedDocuments){const i=T.URI.revive(o),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),m.push(s.value))}if(d.addedDocuments)for(const o of d.addedDocuments){const i=T.URI.revive(o.uri);let s=this._documents.get(i);if(s&&i.scheme!==g.Schemas.vscodeNotebookCell&&i.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new _(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,s),a.push(s.value)),s.ref()}if(d.removedEditors)for(const o of d.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&S.push(i)}if(d.addedEditors)for(const o of d.addedEditors){const i=T.URI.revive(o.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(i).value,n=new N.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>s.document),o.selections.map(R.Selection.to),o.options,o.visibleRanges.map(r=>R.Range.to(r)),typeof o.editorPosition=="number"?R.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,n)}d.newActiveEditor!==void 0&&(f.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,I.dispose)(m),(0,I.dispose)(S),d.removedDocuments&&this._onDidRemoveDocuments.fire(m),d.addedDocuments&&this._onDidAddDocuments.fire(a),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return d?m:m?.value}allEditors(){return[...this._editors.values()]}};E=$e([Be(0,A.IExtHostRpcService),Be(1,b.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[53],Ee([1,0,16,5,2,3,4,7,17,14]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class N{constructor(g,u,v){this._activeTabIdGetter=v,this._parentGroup=u,this.acceptDtoUpdate(g)}get apiObject(){const g=this;if(!this._apiObject){const u={get isActive(){return g._dto.id===g._activeTabIdGetter()},get label(){return g._dto.label},get kind(){return g._input},get isDirty(){return g._dto.isDirty},get isPinned(){return g._dto.isPinned},get isPreview(){return g._dto.isPreview},get group(){return g._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(g){this._dto=g,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new k.TextTabInput(I.URI.revive(this._dto.input.uri));case 2:return new k.TextDiffTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified));case 5:return new k.CustomEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new k.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new k.NotebookEditorTabInput(I.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new k.NotebookDiffEditorTabInput(I.URI.revive(this._dto.input.original),I.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new k.TerminalEditorTabInput;default:return}}}class R{constructor(g,u,v){this._tabs=[],this._activeTabId="",this._dto=g,this._activeGroupIdGetter=v;for(const _ of g.tabs)_.isActive&&(this._activeTabId=_.id),this._tabs.push(new N(_,this,()=>this.activeTabId()))}get apiObject(){const g=this;if(!this._apiObject){const u={get isActive(){return g._dto.groupId===g._activeGroupIdGetter()},get viewColumn(){return f.ViewColumn.to(g._dto.viewColumn)},get activeTab(){return g._tabs.find(v=>v.tabId===g._activeTabId)?.apiObject},get tabs(){return Object.freeze(g._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(g){this._dto=g}acceptTabDtoUpdate(g){const u=this._tabs.find(v=>v.tabId===g.id);if(!u)throw new Error("INVALID tab");return g.isActive&&(this._activeTabId=g.id),u.acceptDtoUpdate(g),u}activeTabId(){return this._activeTabId}}let b=class{constructor(g){this._onDidChangeTab=new T.Emitter,this._onDidChangeTabGroup=new T.Emitter,this._onDidChangeActiveTabGroup=new T.Emitter,this._extHostTabGroups=[],this._proxy=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const g=this,u={onDidChangeTabGroup:g._onDidChangeTabGroup.event,onDidChangeActiveTabGroup:g._onDidChangeActiveTabGroup.event,onDidChangeTab:g._onDidChangeTab.event,get groups(){return Object.freeze(g._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=g._activeGroupId;return(0,A.assertIsDefined)(g._extHostTabGroups.find(E=>E.groupId===v)?.apiObject)},close:async(v,_)=>{const E=Array.isArray(v)?v:[v],l=[];for(const d of E){const m=this._findExtHostTabFromApi(d);if(!m)throw new Error("Tab close: Invalid tab not found!");l.push(m.tabId)}this._proxy.$closeTab(l,_)},move:async(v,_,E,l)=>{const d=this._findExtHostTabFromApi(v);if(!d)throw new Error("Invalid tab");this._proxy.$moveTab(d.tabId,E,f.ViewColumn.from(_),l)}};this._apiObject=Object.freeze(u)}return this._apiObject}_findExtHostTabFromApi(g){for(const u of this._extHostTabGroups)for(const v of u.tabs)if(v.apiObject===g)return v}$acceptEditorTabModel(g){this._extHostTabGroups=g.map(v=>new R(v,this._proxy,()=>this._activeGroupId));const u=(0,A.assertIsDefined)(g.find(v=>v.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u,this._onDidChangeActiveTabGroup.fire(this.tabGroups.activeTabGroup)),this._onDidChangeTabGroup.fire()}$acceptTabGroupUpdate(g){const u=this._extHostTabGroups.find(v=>v.groupId===g.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");if(u.acceptGroupDtoUpdate(g),g.isActive){const v=this._activeGroupId;this._activeGroupId=g.groupId,v!==this._activeGroupId&&this._onDidChangeActiveTabGroup.fire(u.apiObject)}this._onDidChangeTabGroup.fire()}$acceptTabUpdate(g,u){const v=this._extHostTabGroups.find(E=>E.groupId===g);if(!v)throw new Error("Update Tabs IPC call received before group creation.");const _=v.acceptTabDtoUpdate(u);this._onDidChangeTab.fire(_.apiObject)}};b=$e([Be(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b}),define(be[237],Ee([1,0,2,5,6,7,16,151,8,22,27]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const u=this._schemes.indexOf(g);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),u=[];let v,_,E=14,l=14;for(const d of g){let m=v?(0,y.commonPrefixLength)(v,d):0;for(m===0?_=1:_=l;m<d.length;m++)m+1===d.length?(E=l,l=9):l+=1,u.push([_,d.toUpperCase().charCodeAt(m),l]),u.push([_,d.toLowerCase().charCodeAt(m),l]),_=l;v=d,l=E}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new k.StateMachine(u)}}provideDocumentLinks(g){this._initStateMachine();const u=[],v=k.LinkComputer.computeLinks({getLineContent(_){return g.lineAt(_-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const _ of v){const E=D.DocumentLink.to(_);E.target&&u.push(E)}return u}}class b{constructor(g,u){this._extHostLanguageFeatures=u,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,u,v,_={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const E=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(E,v);let l=2;_.isCaseSensitive&&(l+=1024),_.isReadonly&&(l+=2048),typeof v.copy=="function"&&(l+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,N.checkProposedApiEnabled)(g,"fsChunks"),l+=4),this._proxy.$registerFileSystemProvider(E,u,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${u}`),console.error(m)});const d=v.onDidChangeFile(m=>{const a=[];for(const S of m){let{uri:o,type:i}=S;if(o.scheme!==u)continue;let s;switch(i){case T.FileChangeType.Changed:s=0;break;case T.FileChangeType.Created:s=1;break;case T.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:o,type:s})}this._proxy.$onFileSystemChange(E,a)});return(0,I.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g){const{type:u,ctime:v,mtime:_,size:E,permissions:l}=g;return{type:u,ctime:v,mtime:_,size:E,permissions:l}}$stat(g,u){return Promise.resolve(this._getFsProvider(g).stat(f.URI.revive(u))).then(v=>b._asIStat(v))}$readdir(g,u){return Promise.resolve(this._getFsProvider(g).readDirectory(f.URI.revive(u)))}$readFile(g,u){return Promise.resolve(this._getFsProvider(g).readFile(f.URI.revive(u))).then(v=>A.VSBuffer.wrap(v))}$writeFile(g,u,v,_){return Promise.resolve(this._getFsProvider(g).writeFile(f.URI.revive(u),v.buffer,_))}$delete(g,u,v){return Promise.resolve(this._getFsProvider(g).delete(f.URI.revive(u),v))}$rename(g,u,v,_){return Promise.resolve(this._getFsProvider(g).rename(f.URI.revive(u),f.URI.revive(v),_))}$copy(g,u,v,_){const E=this._getFsProvider(g);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(f.URI.revive(u),f.URI.revive(v),_))}$mkdir(g,u){return Promise.resolve(this._getFsProvider(g).createDirectory(f.URI.revive(u)))}$watch(g,u,v,_){const E=this._getFsProvider(g).watch(f.URI.revive(v),_);this._watches.set(u,E)}$unwatch(g,u){const v=this._watches.get(u);v&&(v.dispose(),this._watches.delete(u))}$open(g,u,v){const _=this._getFsProvider(g);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(f.URI.revive(u),v))}$close(g,u){const v=this._getFsProvider(g);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(u))}$read(g,u,v,_){const E=this._getFsProvider(g);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const l=A.VSBuffer.alloc(_);return Promise.resolve(E.read(u,v,l.buffer,0,_)).then(d=>l.slice(0,d))}$write(g,u,v,_){const E=this._getFsProvider(g);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(u,v,_.buffer,0,_.byteLength))}_getFsProvider(g){const u=this._fsProvider.get(g);if(!u){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return u}}e.ExtHostFileSystem=b}),define(be[66],Ee([1,0,5,42,7,22,4,17,44,6]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class qt{constructor(b,C){this._fileSystemProvider=new Map,this._proxy=b.getProxy(f.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(u){try{const v=g._fileSystemProvider.get(u.scheme);if(!v)return await g._proxy.$stat(u);await g._proxy.$ensureActivation(u.scheme);const _=await v.stat(u);return{type:_.type,ctime:_.ctime,mtime:_.mtime,size:_.size,permissions:_.permissions}}catch(v){qt._handleError(v)}},async readDirectory(u){try{const v=g._fileSystemProvider.get(u.scheme);return v?(await g._proxy.$ensureActivation(u.scheme),(await v.readDirectory(u)).slice()):await g._proxy.$readdir(u)}catch(v){return qt._handleError(v)}},async createDirectory(u){try{return await g._proxy.$mkdir(u)}catch(v){return qt._handleError(v)}},async readFile(u){try{const v=g._fileSystemProvider.get(u.scheme);return v?(await g._proxy.$ensureActivation(u.scheme),(await v.readFile(u)).slice()):(await g._proxy.$readFile(u)).buffer}catch(v){return qt._handleError(v)}},async writeFile(u,v){try{return await g._proxy.$writeFile(u,T.VSBuffer.wrap(v))}catch(_){return qt._handleError(_)}},async delete(u,v){try{const _=g._fileSystemProvider.get(u.scheme);return _?(await g._proxy.$ensureActivation(u.scheme),await _.delete(u,{recursive:!1,...v})):await g._proxy.$delete(u,{recursive:!1,useTrash:!1,...v})}catch(_){return qt._handleError(_)}},async rename(u,v,_){try{return await g._proxy.$rename(u,v,{overwrite:!1,..._})}catch(E){return qt._handleError(E)}},async copy(u,v,_){try{return await g._proxy.$copy(u,v,{overwrite:!1,..._})}catch(E){return qt._handleError(E)}},isWritableFileSystem(u){const v=C.getCapabilities(u);if(typeof v=="number")return!(v&2048)}})}static _handleError(b){if(b instanceof I.FileSystemError)throw b;if(!(b instanceof Error))throw new I.FileSystemError(String(b));if(b.name==="ENOPRO")throw I.FileSystemError.Unavailable(b.message);switch(b.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(b.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(b.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(b.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(b.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(b.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(b.message);default:throw new I.FileSystemError(b.message,b.name)}}addFileSystemProvider(b,C){return this._fileSystemProvider.set(b,C),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(b))}};N=$e([Be(0,k.IExtHostRpcService),Be(1,y.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(be[238],Ee([1,0,3,34,2,5,16,7]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(R,b,C,g,u,v,_,E){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const l=this.ensureWatching(R,C,u);this._config=0,v&&(this._config+=1),_&&(this._config+=2),E&&(this._config+=4);const d=(0,t.parse)(u),m=typeof u=="string",a=g(S=>{if(!v)for(let o of S.created){const i=I.URI.revive(o);d(i.fsPath)&&(!m||b.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!_)for(let o of S.changed){const i=I.URI.revive(o);d(i.fsPath)&&(!m||b.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!E)for(let o of S.deleted){const i=I.URI.revive(o);d(i.fsPath)&&(!m||b.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(R,b,C){let g=k.Disposable.from();if(typeof C=="string")return g;const u=R.getProxy(T.MainContext.MainThreadFileSystem);let v=!1;(C.pattern.includes(t.GLOBSTAR)||C.pattern.includes(t.GLOB_SPLIT))&&(v=!0);const _=Math.random();return u.$watch(b.identifier.value,_,C.baseUri,{recursive:v,excludes:[]}),k.Disposable.from({dispose:()=>u.$unwatch(_)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(R,b,C){this._mainContext=R,this._logService=b,this._extHostDocumentsAndEditors=C,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,b,C,g,u,v){return new y(this._mainContext,R,b,this._onFileSystemEvent.event,D.GlobPattern.from(C),g,u,v)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,b){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(C=>({oldUri:I.URI.revive(C.source),newUri:I.URI.revive(C.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(C=>I.URI.revive(C.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:b.map(C=>I.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,b){return(C,g,u)=>{const v=function(E){C.call(g,E)};return v.extension=R,b.event(v,void 0,u)}}async $onWillRunFileOperation(R,b,C,g){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(u=>({oldUri:I.URI.revive(u.source),newUri:I.URI.revive(u.target)}))},C,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(u=>I.URI.revive(u.target))},C,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(u=>I.URI.revive(u.target))},C,g)}}async _fireWillEvent(R,b,C,g){const u=new Set,v=[];if(await R.fireAsync(b,g,async(E,l)=>{const d=Date.now(),m=await Promise.resolve(E);m instanceof k.WorkspaceEdit&&(v.push(m),u.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-d>C&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),g.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let E of v){let{edits:l}=D.WorkspaceEdit.from(E,{getTextDocumentVersion:d=>this._extHostDocumentsAndEditors.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}});_.edits=_.edits.concat(l)}return{edit:_,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=A}),define(be[239],Ee([1,0,2,40]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(D,k,y,A){this._extHostNotebooks=k,this._textDocumentsAndEditors=y,this._commands=A;const N=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",R=>!0,R=>R),new t.ApiCommandArgument("resource","Interactive resource Uri",R=>!0,R=>R),new t.ApiCommandArgument("controllerId","Notebook controller Id",R=>!0,R=>R),new t.ApiCommandArgument("title","Interactive editor title",R=>!0,R=>R)],new t.ApiCommandResult("Notebook and input URI",R=>{if(R.notebookEditorId!==void 0){const b=this._extHostNotebooks.getEditorById(R.notebookEditorId);return{notebookUri:f.URI.revive(R.notebookUri),inputUri:f.URI.revive(R.inputUri),notebookEditor:b.apiEditor}}return{notebookUri:f.URI.revive(R.notebookUri),inputUri:f.URI.revive(R.inputUri)}}));this._commands.registerApiCommand(N)}$willAddInteractiveDocument(D,k,y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:y,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=I}),define(be[240],Ee([1,0,6,5]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(D){this._handlePool=0,this._proxy=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,D),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(be[241],Ee([1,0,2,25,16,7,61,5,8,35,18,14,147,21,6,112,76,83,46,12,3,15,27]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class S{constructor(O,x){this._documents=O,this._provider=x}async provideDocumentSymbols(O,x){const j=this._documents.getDocument(O),Y=await this._provider.provideDocumentSymbols(j,x);if(!(0,N.isFalsyOrEmpty)(Y))return Y[0]instanceof T.DocumentSymbol?Y.map(I.DocumentSymbol.from):S._asDocumentSymbolTree(Y)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((Y,ue)=>{let pe=Y.location.range.start.compareTo(ue.location.range.start);return pe===0&&(pe=ue.location.range.end.compareTo(Y.location.range.end)),pe});const x=[],j=[];for(const Y of O){const ue={name:Y.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Y.kind),tags:Y.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:I.Range.from(Y.location.range),selectionRange:I.Range.from(Y.location.range),children:[]};for(;;){if(j.length===0){j.push(ue),x.push(ue);break}const pe=j[j.length-1];if(A.Range.containsRange(pe.range,ue.range)&&!A.Range.equalsRange(pe.range,ue.range)){pe.children&&pe.children.push(ue),j.push(ue);break}j.pop()}}return x}}class o{constructor(O,x,j){this._documents=O,this._commands=x,this._provider=j,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,x){const j=this._documents.getDocument(O),Y=await this._provider.provideCodeLenses(j,x);if(!Y||x.isCancellationRequested)return;const ue=this._cache.add(Y),pe=new g.DisposableStore;this._disposables.set(ue,pe);const De={cacheId:ue,lenses:[]};for(let Ue=0;Ue<Y.length;Ue++)De.lenses.push({cacheId:[ue,Ue],range:I.Range.from(Y[Ue].range),command:this._commands.toInternal(Y[Ue].command,pe)});return De}async resolveCodeLens(O,x){const j=O.cacheId&&this._cache.get(...O.cacheId);if(!j)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||j.isResolved?Y=j:Y=await this._provider.resolveCodeLens(j,x),Y||(Y=j),x.isCancellationRequested)return;const ue=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!ue)return O.command=this._commands.toInternal(Y.command??o._badCmd,ue),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(ne){return Array.isArray(ne)?ne.map(I.DefinitionLink.from):ne?[I.DefinitionLink.from(ne)]:[]}class s{constructor(O,x){this._documents=O,this._provider=x}async provideDefinition(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideDefinition(Y,ue,j);return i(pe)}}class n{constructor(O,x){this._documents=O,this._provider=x}async provideDeclaration(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideDeclaration(Y,ue,j);return i(pe)}}class r{constructor(O,x){this._documents=O,this._provider=x}async provideImplementation(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideImplementation(Y,ue,j);return i(pe)}}class h{constructor(O,x){this._documents=O,this._provider=x}async provideTypeDefinition(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideTypeDefinition(Y,ue,j);return i(pe)}}class c{constructor(O,x){this._documents=O,this._provider=x}async provideHover(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideHover(Y,ue,j);if(!(!pe||(0,N.isFalsyOrEmpty)(pe.contents)))return pe.range||(pe.range=Y.getWordRangeAtPosition(ue)),pe.range||(pe.range=new T.Range(ue,ue)),I.Hover.from(pe)}}class w{constructor(O,x){this._documents=O,this._provider=x}async provideEvaluatableExpression(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideEvaluatableExpression(Y,ue,j);if(pe)return I.EvaluatableExpression.from(pe)}}class P{constructor(O,x){this._documents=O,this._provider=x}async provideInlineValues(O,x,j,Y){const ue=this._documents.getDocument(O),pe=await this._provider.provideInlineValues(ue,I.Range.to(x),I.InlineValueContext.to(j),Y);if(Array.isArray(pe))return pe.map(De=>I.InlineValue.from(De))}}class L{constructor(O,x){this._documents=O,this._provider=x}async provideDocumentHighlights(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideDocumentHighlights(Y,ue,j);if(Array.isArray(pe))return pe.map(I.DocumentHighlight.from)}}class M{constructor(O,x){this._documents=O,this._provider=x}async provideLinkedEditingRanges(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.provideLinkedEditingRanges(Y,ue,j);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,N.coalesce)(pe.ranges.map(I.Range.from)),wordPattern:pe.wordPattern}}}class p{constructor(O,x){this._documents=O,this._provider=x}async provideReferences(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Position.to(x),De=await this._provider.provideReferences(ue,pe,j,Y);if(Array.isArray(De))return De.map(I.location.from)}}class U{constructor(O,x,j,Y,ue,pe,De){this._documents=O,this._commands=x,this._diagnostics=j,this._provider=Y,this._logService=ue,this._extension=pe,this._apiDeprecation=De,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,x,j,Y){const ue=this._documents.getDocument(O),pe=b.Selection.isISelection(x)?I.Selection.to(x):I.Range.to(x),De=[];for(const Oe of this._diagnostics.getDiagnostics(O))if(pe.intersection(Oe.range)&&De.push(Oe)>U._maxCodeActionsPerFile)break;const Ue={diagnostics:De,only:j.only?new T.CodeActionKind(j.only):void 0,triggerKind:I.CodeActionTriggerKind.to(j.trigger)},ze=await this._provider.provideCodeActions(ue,pe,Ue,Y);if(!(0,N.isNonEmptyArray)(ze)||Y.isCancellationRequested)return;const He=this._cache.add(ze),Ke=new g.DisposableStore;this._disposables.set(He,Ke);const et=[];for(let Oe=0;Oe<ze.length;Oe++){const Xe=ze[Oe];!Xe||(U._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Ke)})):(Ue.only&&(Xe.kind?Ue.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,Oe],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Ke),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(I.Diagnostic.from),edit:Xe.edit&&I.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction(O,x){const[j,Y]=O,ue=this._cache.get(j,Y);if(!ue||U._isCommand(ue)||!this._provider.resolveCodeAction)return;const pe=await this._provider.resolveCodeAction(ue,x)??ue;return pe?.edit?I.WorkspaceEdit.from(pe.edit):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}U._maxCodeActionsPerFile=1e3;class B{constructor(O,x){this._documents=O,this._provider=x}async provideDocumentFormattingEdits(O,x,j){const Y=this._documents.getDocument(O),ue=await this._provider.provideDocumentFormattingEdits(Y,x,j);if(Array.isArray(ue))return ue.map(I.TextEdit.from)}}class H{constructor(O,x){this._documents=O,this._provider=x}async provideDocumentRangeFormattingEdits(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Range.to(x),De=await this._provider.provideDocumentRangeFormattingEdits(ue,pe,j,Y);if(Array.isArray(De))return De.map(I.TextEdit.from)}}class re{constructor(O,x){this._documents=O,this._provider=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,x,j,Y,ue){const pe=this._documents.getDocument(O),De=I.Position.to(x),Ue=await this._provider.provideOnTypeFormattingEdits(pe,De,j,Y,ue);if(Array.isArray(Ue))return Ue.map(I.TextEdit.from)}}class W{constructor(O,x){this._provider=O,this._logService=x,this._cache=new _.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,x){const j=await this._provider.provideWorkspaceSymbols(O,x);if(!(0,N.isNonEmptyArray)(j))return{symbols:[]};const Y=this._cache.add(j),ue={cacheId:Y,symbols:[]};for(let pe=0;pe<j.length;pe++){const De=j[pe];if(!De||!De.name){this._logService.warn("INVALID SymbolInformation",De);continue}ue.symbols.push({...I.WorkspaceSymbol.from(De),cacheId:[Y,pe]})}return ue}async resolveWorkspaceSymbol(O,x){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const j=this._cache.get(...O.cacheId);if(j){const Y=await this._provider.resolveWorkspaceSymbol(j,x);return Y&&(0,t.mixin)(O,I.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class F{constructor(O,x,j){this._documents=O,this._provider=x,this._logService=j}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Position.to(x);try{const De=await this._provider.provideRenameEdits(ue,pe,j,Y);return De?I.WorkspaceEdit.from(De):void 0}catch(De){const Ue=F._asMessage(De);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(De)}}async resolveRenameLocation(O,x,j){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Y=this._documents.getDocument(O),ue=I.Position.to(x);try{const pe=await this._provider.prepareRename(Y,ue,j);let De,Ue;if(T.Range.isRange(pe)?(De=pe,Ue=Y.getText(pe)):(0,R.isObject)(pe)&&(De=pe.range,Ue=pe.placeholder),!De||!Ue)return;if(De.start.line>ue.line||De.end.line<ue.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(De),text:Ue}}catch(pe){const De=F._asMessage(pe);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(pe)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class q{constructor(O,x){this.resultId=O,this.tokens=x}}class G{constructor(O,x){this._documents=O,this._provider=x,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,x,j){const Y=this._documents.getDocument(O),ue=x!==0?this._previousResults.get(x):null;let pe=typeof ue?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Y,ue.resultId,j):await this._provider.provideDocumentSemanticTokens(Y,j);return ue&&this._previousResults.delete(x),pe?(pe=G._fixProvidedSemanticTokens(pe),this._send(G._convertToEdits(ue,pe),pe)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return G._isSemanticTokens(O)?G._isCorrectSemanticTokens(O)?O:new T.SemanticTokens(new Uint32Array(O.data),O.resultId):G._isSemanticTokensEdits(O)?G._isCorrectSemanticTokensEdits(O)?O:new T.SemanticTokensEdits(O.edits.map(x=>new T.SemanticTokensEdit(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const x of O.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,x){if(!G._isSemanticTokens(x)||!O||!O.tokens)return x;const j=O.tokens,Y=j.length,ue=x.data,pe=ue.length;let De=0;const Ue=Math.min(Y,pe);for(;De<Ue&&j[De]===ue[De];)De++;if(De===Y&&De===pe)return new T.SemanticTokensEdits([],x.resultId);let ze=0;const He=Ue-De;for(;ze<He&&j[Y-ze-1]===ue[pe-ze-1];)ze++;return new T.SemanticTokensEdits([{start:De,deleteCount:Y-De-ze,data:ue.subarray(De,pe-ze)}],x.resultId)}_send(O,x){if(G._isSemanticTokens(O)){const j=this._nextResultId++;return this._previousResults.set(j,new q(O.resultId,O.data)),(0,u.encodeSemanticTokensDto)({id:j,type:"full",data:O.data})}if(G._isSemanticTokensEdits(O)){const j=this._nextResultId++;return G._isSemanticTokens(x)?this._previousResults.set(j,new q(x.resultId,x.data)):this._previousResults.set(j,new q(O.resultId)),(0,u.encodeSemanticTokensDto)({id:j,type:"delta",deltas:(O.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}e.DocumentSemanticTokensAdapter=G;class ${constructor(O,x){this._documents=O,this._provider=x}async provideDocumentRangeSemanticTokens(O,x,j){const Y=this._documents.getDocument(O),ue=await this._provider.provideDocumentRangeSemanticTokens(Y,I.Range.to(x),j);return ue?this._send(ue):null}_send(O){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=$;class X{constructor(O,x,j,Y,ue){this._documents=O,this._commands=x,this._provider=j,this._apiDeprecation=Y,this._extension=ue,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Position.to(x),De=ue.getWordRangeAtPosition(pe)||new T.Range(pe,pe),Ue=De.with({end:pe}),ze=new E.StopWatch(!0),He=await this._provider.provideCompletionItems(ue,pe,Y,I.CompletionContext.to(j));if(!He||Y.isCancellationRequested)return;const Ke=Array.isArray(He)?new T.CompletionList(He):He,et=X.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),Oe=new g.DisposableStore;this._disposables.set(et,Oe);const Xe=[],te={x:et,b:Xe,a:{replace:I.Range.from(De),insert:I.Range.from(Ue)},c:Ke.isIncomplete||void 0,d:ze.elapsed()};for(let oe=0;oe<Ke.items.length;oe++){const K=Ke.items[oe],we=this._convertCompletionItem(K,[et,oe],Ue,De);Xe.push(we)}return te}async resolveCompletionItem(O,x){if(typeof this._provider.resolveCompletionItem!="function")return;const j=this._cache.get(...O);if(!j)return;const Y=await this._provider.resolveCompletionItem(j,x);if(!!Y)return this._convertCompletionItem(Y,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,x,j,Y){const ue=this._disposables.get(x[0]);if(!ue)throw Error("DisposableStore is missing...");const pe={x,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(O.command,ue)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),pe.h=O.textEdit.newText):typeof O.insertText=="string"?pe.h=O.insertText:O.insertText instanceof T.SnippetString&&(pe.h=O.insertText.value,pe.i|=4);let De;return O.textEdit?De=O.textEdit.range:O.range&&(De=O.range),T.Range.isRange(De)?pe.j=I.Range.from(De):De&&(!j?.isEqual(De.inserting)||!Y?.isEqual(De.replacing))&&(pe.j={insert:I.Range.from(De.inserting),replace:I.Range.from(De.replacing)}),pe}}class ie{async provideInlineCompletions(O,x,j,Y){}}class ae extends ie{constructor(O,x,j){super();this._documents=O,this._provider=x,this._commands=j,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Position.to(x),De=await this._provider.provideInlineCompletionItems(ue,pe,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:I.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text,isSnippetText:j.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(j.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:j.triggerKind},Y);if(!De||Y.isCancellationRequested)return;const Ue=(0,R.isArray)(De)?De:De.items,ze=this._cache.add(Ue);let He;return{pid:ze,items:Ue.map((Ke,et)=>{let Oe;Ke.command&&(He||(He=new g.DisposableStore,this._disposables.set(ze,He)),Oe=this._commands.toInternal(Ke.command,He));const Xe=Ke.insertText??Ke.text;if(Xe===void 0)throw new Error("text or insertText must be defined");return{insertText:typeof Xe=="string"?Xe:{snippet:Xe.value},range:Ke.range?I.Range.from(Ke.range):void 0,command:Oe,idx:et,completeBracketPairs:Ke.completeBracketPairs}})}}disposeCompletions(O){this._cache.delete(O);const x=this._disposables.get(O);x&&x.clear(),this._disposables.delete(O)}handleDidShowCompletionItem(O,x){const j=this._cache.get(O,x);j&&se.get(this._provider).fireOnDidShowCompletionItem({completionItem:j})}}class le extends ie{constructor(O,x,j,Y){super();this.extension=O,this._documents=x,this._provider=j,this._commands=Y,this._cache=new _.Cache("InlineCompletionItemNew"),this._disposables=new Map,this.isAdditionProposedApiEnabled=(0,a.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKindNew.Automatic,[D.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Position.to(x),De=await this._provider.provideInlineCompletionItems(ue,pe,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:I.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[j.triggerKind]},Y);if(!De||Y.isCancellationRequested)return;const Ue=(0,R.isArray)(De)?De:De.items,ze=this._cache.add(Ue);let He;return{pid:ze,items:Ue.map((Ke,et)=>{let Oe;Ke.command&&(He||(He=new g.DisposableStore,this._disposables.set(ze,He)),Oe=this._commands.toInternal(Ke.command,He));const Xe=Ke.insertText;return{insertText:typeof Xe=="string"?Xe:{snippet:Xe.value},filterText:Ke.filterText,range:Ke.range?I.Range.from(Ke.range):void 0,command:Oe,idx:et,completeBracketPairs:this.isAdditionProposedApiEnabled?Ke.completeBracketPairs:!1}})}}disposeCompletions(O){this._cache.delete(O);const x=this._disposables.get(O);x&&x.clear(),this._disposables.delete(O)}handleDidShowCompletionItem(O,x){const j=this._cache.get(O,x);j&&this._provider.handleDidShowCompletionItem&&(0,a.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions")&&this._provider.handleDidShowCompletionItem(j)}}class se{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(O){let x=se.map.get(O);return x||(x=new se,se.map.set(O,x)),x}fireOnDidShowCompletionItem(O){this._onDidShowCompletionItemEmitter.fire(O)}}e.InlineCompletionController=se,se.map=new WeakMap;class ee{constructor(O,x){this._documents=O,this._provider=x,this._cache=new _.Cache("SignatureHelp")}async provideSignatureHelp(O,x,j,Y){const ue=this._documents.getDocument(O),pe=I.Position.to(x),De=this.reviveContext(j),Ue=await this._provider.provideSignatureHelp(ue,pe,Y,De);if(Ue){const ze=this._cache.add([Ue]);return{...I.SignatureHelp.from(Ue),id:ze}}}reviveContext(O){let x;if(O.activeSignatureHelp){const j=I.SignatureHelp.to(O.activeSignatureHelp),Y=this._cache.get(O.activeSignatureHelp.id,0);Y?(x=Y,x.activeSignature=j.activeSignature,x.activeParameter=j.activeParameter):x=j}return{...O,activeSignatureHelp:x}}releaseSignatureHelp(O){this._cache.delete(O)}}class fe{constructor(O,x,j,Y,ue){this._documents=O,this._commands=x,this._provider=j,this._logService=Y,this._extension=ue,this._cache=new _.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,x,j){const Y=this._documents.getDocument(O),ue=I.Range.to(x),pe=await this._provider.provideInlayHints(Y,ue,j);if(!Array.isArray(pe)||pe.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${x}`);return}if(j.isCancellationRequested)return;const De=this._cache.add(pe);this._disposables.set(De,new g.DisposableStore);const Ue={hints:[],cacheId:De};for(let ze=0;ze<pe.length;ze++)this._isValidInlayHint(pe[ze],ue)&&Ue.hints.push(this._convertInlayHint(pe[ze],[De,ze]));return this._logService.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this._extension.identifier.value}' for ${x}`),Ue}async resolveInlayHint(O,x){if(typeof this._provider.resolveInlayHint!="function")return;const j=this._cache.get(...O);if(!j)return;const Y=await this._provider.resolveInlayHint(j,x);if(!!Y&&!!this._isValidInlayHint(Y))return this._convertInlayHint(Y,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,x){return O.label.length===0||Array.isArray(O.label)&&O.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(x&&!x.contains(O.position))}_convertInlayHint(O,x){const j=this._disposables.get(x[0]);if(!j)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:x,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Y.label=O.label:Y.label=O.label.map(ue=>{let pe={label:ue.value};return pe.tooltip=I.MarkdownString.fromStrict(ue.tooltip),T.Location.isLocation(ue.location)&&(pe.location=I.location.from(ue.location)),ue.command&&(pe.command=this._commands.toInternal(ue.command,j)),pe}),Y}}class ge{constructor(O,x){this._documents=O,this._provider=x,this._cache=new _.Cache("DocumentLink")}async provideLinks(O,x){const j=this._documents.getDocument(O),Y=await this._provider.provideDocumentLinks(j,x);if(!(!Array.isArray(Y)||Y.length===0)&&!x.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Y.filter(ge._validateLink).map(I.DocumentLink.from)};{const ue=this._cache.add(Y),pe={links:[],cacheId:ue};for(let De=0;De<Y.length;De++){if(!ge._validateLink(Y[De]))continue;const Ue=I.DocumentLink.from(Y[De]);Ue.cacheId=[ue,De],pe.links.push(Ue)}return pe}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,x){if(typeof this._provider.resolveDocumentLink!="function")return;const j=this._cache.get(...O);if(!j)return;const Y=await this._provider.resolveDocumentLink(j,x);if(!(!Y||!ge._validateLink(Y)))return I.DocumentLink.from(Y)}releaseLinks(O){this._cache.delete(O)}}class ye{constructor(O,x){this._documents=O,this._provider=x}async provideColors(O,x){const j=this._documents.getDocument(O),Y=await this._provider.provideDocumentColors(j,x);return Array.isArray(Y)?Y.map(pe=>({color:I.Color.from(pe.color),range:I.Range.from(pe.range)})):[]}async provideColorPresentations(O,x,j){const Y=this._documents.getDocument(O),ue=I.Range.to(x.range),pe=I.Color.to(x.color),De=await this._provider.provideColorPresentations(pe,{document:Y,range:ue},j);if(!!Array.isArray(De))return De.map(I.ColorPresentation.from)}}class Ne{constructor(O,x){this._documents=O,this._provider=x}async provideFoldingRanges(O,x,j){const Y=this._documents.getDocument(O),ue=await this._provider.provideFoldingRanges(Y,x,j);if(!!Array.isArray(ue))return ue.map(I.FoldingRange.from)}}class Se{constructor(O,x,j){this._documents=O,this._provider=x,this._logService=j}async provideSelectionRanges(O,x,j){const Y=this._documents.getDocument(O),ue=x.map(I.Position.to),pe=await this._provider.provideSelectionRanges(Y,ue,j);if(!(0,N.isNonEmptyArray)(pe))return[];if(pe.length!==ue.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let Ue=0;Ue<ue.length;Ue++){const ze=[];De.push(ze);let He=ue[Ue],Ke=pe[Ue];for(;;){if(!Ke.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(I.SelectionRange.from(Ke)),!Ke.parent)break;He=Ke.range,Ke=Ke.parent}}return De}}class _e{constructor(O,x){this._documents=O,this._provider=x,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.prepareCallHierarchy(Y,ue,j);if(!pe)return;const De=this._idPool.nextId();return this._cache.set(De,new Map),Array.isArray(pe)?pe.map(Ue=>this._cacheAndConvertItem(De,Ue)):[this._cacheAndConvertItem(De,pe)]}async provideCallsTo(O,x,j){const Y=this._itemFromCache(O,x);if(!Y)throw new Error("missing call hierarchy item");const ue=await this._provider.provideCallHierarchyIncomingCalls(Y,j);if(!!ue)return ue.map(pe=>({from:this._cacheAndConvertItem(O,pe.from),fromRanges:pe.fromRanges.map(De=>I.Range.from(De))}))}async provideCallsFrom(O,x,j){const Y=this._itemFromCache(O,x);if(!Y)throw new Error("missing call hierarchy item");const ue=await this._provider.provideCallHierarchyOutgoingCalls(Y,j);if(!!ue)return ue.map(pe=>({to:this._cacheAndConvertItem(O,pe.to),fromRanges:pe.fromRanges.map(De=>I.Range.from(De))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,x){const j=this._cache.get(O),Y=I.CallHierarchyItem.from(x,O,j.size.toString(36));return j.set(Y._itemId,x),Y}_itemFromCache(O,x){return this._cache.get(O)?.get(x)}}class Ie{constructor(O,x){this._documents=O,this._provider=x,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(O,x,j){const Y=this._documents.getDocument(O),ue=I.Position.to(x),pe=await this._provider.prepareTypeHierarchy(Y,ue,j);if(!pe)return;const De=this._idPool.nextId();return this._cache.set(De,new Map),Array.isArray(pe)?pe.map(Ue=>this._cacheAndConvertItem(De,Ue)):[this._cacheAndConvertItem(De,pe)]}async provideSupertypes(O,x,j){const Y=this._itemFromCache(O,x);if(!Y)throw new Error("missing type hierarchy item");const ue=await this._provider.provideTypeHierarchySupertypes(Y,j);if(!!ue)return ue.map(pe=>this._cacheAndConvertItem(O,pe))}async provideSubtypes(O,x,j){const Y=this._itemFromCache(O,x);if(!Y)throw new Error("missing type hierarchy item");const ue=await this._provider.provideTypeHierarchySubtypes(Y,j);if(!!ue)return ue.map(pe=>this._cacheAndConvertItem(O,pe))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,x){const j=this._cache.get(O),Y=I.TypeHierarchyItem.from(x,O,j.size.toString(36));return j.set(Y._itemId,x),Y}_itemFromCache(O,x){return this._cache.get(O)?.get(x)}}class de{constructor(O,x){this.adapter=O,this.extension=x}}class Q{constructor(O,x,j,Y,ue,pe,De){this._adapter=new Map,this._uriTransformer=x,this._proxy=O.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=j,this._commands=Y,this._diagnostics=ue,this._logService=pe,this._apiDeprecation=De}_transformDocumentSelector(O){return I.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new T.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return Q._handlePool++}async _withAdapter(O,x,j,Y,ue,pe=!1){const De=this._adapter.get(O);if(!De||!(De.adapter instanceof x))return Y;const Ue=Date.now();pe||this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const ze=j(De.adapter,De.extension);return Promise.resolve(ze).catch(He=>{(0,l.isCancellationError)(He)||(this._logService.error(`[${De.extension.identifier.value}] provider FAILED`),this._logService.error(He))}).finally(()=>{pe||this._logService.trace(`[${De.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),C.CancellationToken.isCancellationToken(ue)?(0,m.raceCancellationError)(ze,ue):ze}_addNewAdapter(O,x){const j=this._nextHandle();return this._adapter.set(j,new de(O,x)),j}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,x,j,Y){const ue=this._addNewAdapter(new S(this._documents,j),O),pe=Y&&Y.label||Q._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(ue,this._transformDocumentSelector(x),pe),this._createDisposable(ue)}$provideDocumentSymbols(O,x,j){return this._withAdapter(O,S,Y=>Y.provideDocumentSymbols(f.URI.revive(x),j),void 0,j)}registerCodeLensProvider(O,x,j){const Y=this._nextHandle(),ue=typeof j.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Y,new de(new o(this._documents,this._commands.converter,j),O)),this._proxy.$registerCodeLensSupport(Y,this._transformDocumentSelector(x),ue);let pe=this._createDisposable(Y);if(ue!==void 0){const De=j.onDidChangeCodeLenses(Ue=>this._proxy.$emitCodeLensEvent(ue));pe=T.Disposable.from(pe,De)}return pe}$provideCodeLenses(O,x,j){return this._withAdapter(O,o,Y=>Y.provideCodeLenses(f.URI.revive(x),j),void 0,j)}$resolveCodeLens(O,x,j){return this._withAdapter(O,o,Y=>Y.resolveCodeLens(x,j),void 0,void 0)}$releaseCodeLenses(O,x){this._withAdapter(O,o,j=>Promise.resolve(j.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(O,x,j){const Y=this._addNewAdapter(new s(this._documents,j),O);return this._proxy.$registerDefinitionSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideDefinition(O,x,j,Y){return this._withAdapter(O,s,ue=>ue.provideDefinition(f.URI.revive(x),j,Y),[],Y)}registerDeclarationProvider(O,x,j){const Y=this._addNewAdapter(new n(this._documents,j),O);return this._proxy.$registerDeclarationSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideDeclaration(O,x,j,Y){return this._withAdapter(O,n,ue=>ue.provideDeclaration(f.URI.revive(x),j,Y),[],Y)}registerImplementationProvider(O,x,j){const Y=this._addNewAdapter(new r(this._documents,j),O);return this._proxy.$registerImplementationSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideImplementation(O,x,j,Y){return this._withAdapter(O,r,ue=>ue.provideImplementation(f.URI.revive(x),j,Y),[],Y)}registerTypeDefinitionProvider(O,x,j){const Y=this._addNewAdapter(new h(this._documents,j),O);return this._proxy.$registerTypeDefinitionSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideTypeDefinition(O,x,j,Y){return this._withAdapter(O,h,ue=>ue.provideTypeDefinition(f.URI.revive(x),j,Y),[],Y)}registerHoverProvider(O,x,j,Y){const ue=this._addNewAdapter(new c(this._documents,j),O);return this._proxy.$registerHoverProvider(ue,this._transformDocumentSelector(x)),this._createDisposable(ue)}$provideHover(O,x,j,Y){return this._withAdapter(O,c,ue=>ue.provideHover(f.URI.revive(x),j,Y),void 0,Y)}registerEvaluatableExpressionProvider(O,x,j,Y){const ue=this._addNewAdapter(new w(this._documents,j),O);return this._proxy.$registerEvaluatableExpressionProvider(ue,this._transformDocumentSelector(x)),this._createDisposable(ue)}$provideEvaluatableExpression(O,x,j,Y){return this._withAdapter(O,w,ue=>ue.provideEvaluatableExpression(f.URI.revive(x),j,Y),void 0,Y)}registerInlineValuesProvider(O,x,j,Y){const ue=typeof j.onDidChangeInlineValues=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new P(this._documents,j),O);this._proxy.$registerInlineValuesProvider(pe,this._transformDocumentSelector(x),ue);let De=this._createDisposable(pe);if(ue!==void 0){const Ue=j.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(ue));De=T.Disposable.from(De,Ue)}return De}$provideInlineValues(O,x,j,Y,ue){return this._withAdapter(O,P,pe=>pe.provideInlineValues(f.URI.revive(x),j,Y,ue),void 0,ue)}registerDocumentHighlightProvider(O,x,j){const Y=this._addNewAdapter(new L(this._documents,j),O);return this._proxy.$registerDocumentHighlightProvider(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideDocumentHighlights(O,x,j,Y){return this._withAdapter(O,L,ue=>ue.provideDocumentHighlights(f.URI.revive(x),j,Y),void 0,Y)}registerLinkedEditingRangeProvider(O,x,j){const Y=this._addNewAdapter(new M(this._documents,j),O);return this._proxy.$registerLinkedEditingRangeProvider(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideLinkedEditingRanges(O,x,j,Y){return this._withAdapter(O,M,async ue=>{const pe=await ue.provideLinkedEditingRanges(f.URI.revive(x),j,Y);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Q._serializeRegExp(pe.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(O,x,j){const Y=this._addNewAdapter(new p(this._documents,j),O);return this._proxy.$registerReferenceSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideReferences(O,x,j,Y,ue){return this._withAdapter(O,p,pe=>pe.provideReferences(f.URI.revive(x),j,Y,ue),void 0,ue)}registerCodeActionProvider(O,x,j,Y){const ue=new g.DisposableStore,pe=this._addNewAdapter(new U(this._documents,this._commands.converter,this._diagnostics,j,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(x),{providedKinds:Y?.providedCodeActionKinds?.map(De=>De.value),documentation:Y?.documentation?.map(De=>({kind:De.kind.value,command:this._commands.converter.toInternal(De.command,ue)}))},Q._extLabel(O),Boolean(j.resolveCodeAction)),ue.add(this._createDisposable(pe)),ue}$provideCodeActions(O,x,j,Y,ue){return this._withAdapter(O,U,pe=>pe.provideCodeActions(f.URI.revive(x),j,Y,ue),void 0,ue)}$resolveCodeAction(O,x,j){return this._withAdapter(O,U,Y=>Y.resolveCodeAction(x,j),void 0,void 0)}$releaseCodeActions(O,x){this._withAdapter(O,U,j=>Promise.resolve(j.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(O,x,j){const Y=this._addNewAdapter(new B(this._documents,j),O);return this._proxy.$registerDocumentFormattingSupport(Y,this._transformDocumentSelector(x),O.identifier,O.displayName||O.name),this._createDisposable(Y)}$provideDocumentFormattingEdits(O,x,j,Y){return this._withAdapter(O,B,ue=>ue.provideDocumentFormattingEdits(f.URI.revive(x),j,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(O,x,j){const Y=this._addNewAdapter(new H(this._documents,j),O);return this._proxy.$registerRangeFormattingSupport(Y,this._transformDocumentSelector(x),O.identifier,O.displayName||O.name),this._createDisposable(Y)}$provideDocumentRangeFormattingEdits(O,x,j,Y,ue){return this._withAdapter(O,H,pe=>pe.provideDocumentRangeFormattingEdits(f.URI.revive(x),j,Y,ue),void 0,ue)}registerOnTypeFormattingEditProvider(O,x,j,Y){const ue=this._addNewAdapter(new re(this._documents,j),O);return this._proxy.$registerOnTypeFormattingSupport(ue,this._transformDocumentSelector(x),Y,O.identifier),this._createDisposable(ue)}$provideOnTypeFormattingEdits(O,x,j,Y,ue,pe){return this._withAdapter(O,re,De=>De.provideOnTypeFormattingEdits(f.URI.revive(x),j,Y,ue,pe),void 0,pe)}registerWorkspaceSymbolProvider(O,x){const j=this._addNewAdapter(new W(x,this._logService),O);return this._proxy.$registerNavigateTypeSupport(j,typeof x.resolveWorkspaceSymbol=="function"),this._createDisposable(j)}$provideWorkspaceSymbols(O,x,j){return this._withAdapter(O,W,Y=>Y.provideWorkspaceSymbols(x,j),{symbols:[]},j)}$resolveWorkspaceSymbol(O,x,j){return this._withAdapter(O,W,Y=>Y.resolveWorkspaceSymbol(x,j),void 0,void 0)}$releaseWorkspaceSymbols(O,x){this._withAdapter(O,W,j=>j.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(O,x,j){const Y=this._addNewAdapter(new F(this._documents,j,this._logService),O);return this._proxy.$registerRenameSupport(Y,this._transformDocumentSelector(x),F.supportsResolving(j)),this._createDisposable(Y)}$provideRenameEdits(O,x,j,Y,ue){return this._withAdapter(O,F,pe=>pe.provideRenameEdits(f.URI.revive(x),j,Y,ue),void 0,ue)}$resolveRenameLocation(O,x,j,Y){return this._withAdapter(O,F,ue=>ue.resolveRenameLocation(f.URI.revive(x),j,Y),void 0,Y)}registerDocumentSemanticTokensProvider(O,x,j,Y){const ue=this._addNewAdapter(new G(this._documents,j),O),pe=typeof j.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ue,this._transformDocumentSelector(x),Y,pe);let De=this._createDisposable(ue);if(pe){const Ue=j.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(pe));De=T.Disposable.from(De,Ue)}return De}$provideDocumentSemanticTokens(O,x,j,Y){return this._withAdapter(O,G,ue=>ue.provideDocumentSemanticTokens(f.URI.revive(x),j,Y),null,Y)}$releaseDocumentSemanticTokens(O,x){this._withAdapter(O,G,j=>j.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,x,j,Y){const ue=this._addNewAdapter(new $(this._documents,j),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ue,this._transformDocumentSelector(x),Y),this._createDisposable(ue)}$provideDocumentRangeSemanticTokens(O,x,j,Y){return this._withAdapter(O,$,ue=>ue.provideDocumentRangeSemanticTokens(f.URI.revive(x),j,Y),null,Y)}registerCompletionItemProvider(O,x,j,Y){const ue=this._addNewAdapter(new X(this._documents,this._commands.converter,j,this._apiDeprecation,O),O);return this._proxy.$registerSuggestSupport(ue,this._transformDocumentSelector(x),Y,X.supportsResolving(j),`${O.identifier.value}(${Y.join("")})`),this._createDisposable(ue)}$provideCompletionItems(O,x,j,Y,ue){return this._withAdapter(O,X,pe=>pe.provideCompletionItems(f.URI.revive(x),j,Y,ue),void 0,ue)}$resolveCompletionItem(O,x,j){return this._withAdapter(O,X,Y=>Y.resolveCompletionItem(x,j),void 0,j)}$releaseCompletionItems(O,x){this._withAdapter(O,X,j=>j.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(O,x,j){const Y=this._addNewAdapter(new ae(this._documents,j,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}registerInlineCompletionsProviderNew(O,x,j){const Y=this._addNewAdapter(new le(O,this._documents,j,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideInlineCompletions(O,x,j,Y,ue){return this._withAdapter(O,ie,pe=>pe.provideInlineCompletions(f.URI.revive(x),j,Y,ue),void 0,ue)}$handleInlineCompletionDidShow(O,x,j){this._withAdapter(O,ae,async Y=>{Y.handleDidShowCompletionItem(x,j)},void 0,void 0)}$freeInlineCompletionsList(O,x){this._withAdapter(O,ae,async j=>{j.disposeCompletions(x)},void 0,void 0)}registerSignatureHelpProvider(O,x,j,Y){const ue=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,pe=this._addNewAdapter(new ee(this._documents,j),O);return this._proxy.$registerSignatureHelpProvider(pe,this._transformDocumentSelector(x),ue),this._createDisposable(pe)}$provideSignatureHelp(O,x,j,Y,ue){return this._withAdapter(O,ee,pe=>pe.provideSignatureHelp(f.URI.revive(x),j,Y,ue),void 0,ue)}$releaseSignatureHelp(O,x){this._withAdapter(O,ee,j=>j.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(O,x,j){const Y=typeof j.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new fe(this._documents,this._commands.converter,j,this._logService,O),O);this._proxy.$registerInlayHintsProvider(ue,this._transformDocumentSelector(x),typeof j.resolveInlayHint=="function",Y,Q._extLabel(O));let pe=this._createDisposable(ue);if(Y!==void 0){const De=j.onDidChangeInlayHints(Ue=>this._proxy.$emitInlayHintsEvent(Y));pe=T.Disposable.from(pe,De)}return pe}$provideInlayHints(O,x,j,Y){return this._withAdapter(O,fe,ue=>ue.provideInlayHints(f.URI.revive(x),j,Y),void 0,Y)}$resolveInlayHint(O,x,j){return this._withAdapter(O,fe,Y=>Y.resolveInlayHint(x,j),void 0,j)}$releaseInlayHints(O,x){this._withAdapter(O,fe,j=>j.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(O,x,j){const Y=this._addNewAdapter(new ge(this._documents,j),O);return this._proxy.$registerDocumentLinkProvider(Y,this._transformDocumentSelector(x),typeof j.resolveDocumentLink=="function"),this._createDisposable(Y)}$provideDocumentLinks(O,x,j){return this._withAdapter(O,ge,Y=>Y.provideLinks(f.URI.revive(x),j),void 0,j,x.scheme==="output")}$resolveDocumentLink(O,x,j){return this._withAdapter(O,ge,Y=>Y.resolveLink(x,j),void 0,void 0,!0)}$releaseDocumentLinks(O,x){this._withAdapter(O,ge,j=>j.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(O,x,j){const Y=this._addNewAdapter(new ye(this._documents,j),O);return this._proxy.$registerDocumentColorProvider(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideDocumentColors(O,x,j){return this._withAdapter(O,ye,Y=>Y.provideColors(f.URI.revive(x),j),[],j)}$provideColorPresentations(O,x,j,Y){return this._withAdapter(O,ye,ue=>ue.provideColorPresentations(f.URI.revive(x),j,Y),void 0,Y)}registerFoldingRangeProvider(O,x,j){const Y=this._nextHandle(),ue=typeof j.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Y,new de(new Ne(this._documents,j),O)),this._proxy.$registerFoldingRangeProvider(Y,this._transformDocumentSelector(x),ue);let pe=this._createDisposable(Y);if(ue!==void 0){const De=j.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ue));pe=T.Disposable.from(pe,De)}return pe}$provideFoldingRanges(O,x,j,Y){return this._withAdapter(O,Ne,ue=>ue.provideFoldingRanges(f.URI.revive(x),j,Y),void 0,Y)}registerSelectionRangeProvider(O,x,j){const Y=this._addNewAdapter(new Se(this._documents,j,this._logService),O);return this._proxy.$registerSelectionRangeProvider(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$provideSelectionRanges(O,x,j,Y){return this._withAdapter(O,Se,ue=>ue.provideSelectionRanges(f.URI.revive(x),j,Y),[],Y)}registerCallHierarchyProvider(O,x,j){const Y=this._addNewAdapter(new _e(this._documents,j),O);return this._proxy.$registerCallHierarchyProvider(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$prepareCallHierarchy(O,x,j,Y){return this._withAdapter(O,_e,ue=>Promise.resolve(ue.prepareSession(f.URI.revive(x),j,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(O,x,j,Y){return this._withAdapter(O,_e,ue=>ue.provideCallsTo(x,j,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(O,x,j,Y){return this._withAdapter(O,_e,ue=>ue.provideCallsFrom(x,j,Y),void 0,Y)}$releaseCallHierarchy(O,x){this._withAdapter(O,_e,j=>Promise.resolve(j.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(O,x,j){const Y=this._addNewAdapter(new Ie(this._documents,j),O);return this._proxy.$registerTypeHierarchyProvider(Y,this._transformDocumentSelector(x)),this._createDisposable(Y)}$prepareTypeHierarchy(O,x,j,Y){return this._withAdapter(O,Ie,ue=>Promise.resolve(ue.prepareSession(f.URI.revive(x),j,Y)),void 0,Y)}$provideTypeHierarchySupertypes(O,x,j,Y){return this._withAdapter(O,Ie,ue=>ue.provideSupertypes(x,j,Y),void 0,Y)}$provideTypeHierarchySubtypes(O,x,j,Y){return this._withAdapter(O,Ie,ue=>ue.provideSubtypes(x,j,Y),void 0,Y)}$releaseTypeHierarchy(O,x){this._withAdapter(O,Ie,j=>Promise.resolve(j.releaseSession(x)),void 0,void 0)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:Q._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:Q._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Q._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Q._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:Q._serializeRegExp(O.beforeText),afterText:O.afterText?Q._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?Q._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(Q._serializeOnEnterRule)}setLanguageConfiguration(O,x,j){let{wordPattern:Y}=j;if(Y&&(0,y.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this._documents.setWordDefinitionFor(x,Y):this._documents.setWordDefinitionFor(x,void 0),j.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),j.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const ue=this._nextHandle(),pe={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?Q._serializeRegExp(j.wordPattern):void 0,indentationRules:j.indentationRules?Q._serializeIndentationRule(j.indentationRules):void 0,onEnterRules:j.onEnterRules?Q._serializeOnEnterRules(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ue,x,pe),this._createDisposable(ue)}$setWordDefinitions(O){for(const x of O)this._documents.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.ExtHostLanguageFeatures=Q,Q._handlePool=0}),define(be[242],Ee([1,0,5,16,7,47,15,6]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(N,R,b,C){this._documents=R,this._commands=b,this._uriTransformer=C,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,R){await this._proxy.$changeLanguage(N,R);const b=this._documents.getDocumentData(N);if(!b)throw new Error(`document '${N.toString()}' NOT found`);return b.document}async tokenAtPosition(N,R){const b=N.version,C=t.Position.from(R),g=await this._proxy.$tokensAtPosition(N.uri,C),u={type:I.StandardTokenType.Other,range:N.getWordRangeAtPosition(R)??new I.Range(R.line,R.character,R.line,R.character)};if(!g)return u;const v={range:t.Range.to(g.range),type:t.TokenType.to(g.type)};return!v.range.contains(R)||b!==N.version?u:v}createLanguageStatusItem(N,R,b){const C=this._handlePool++,g=this._proxy,u=this._ids,v=`${N.identifier.value}/${R}`;if(u.has(v))throw new Error(`LanguageStatusItem with id '${R}' ALREADY exists`);u.add(v);const _={selector:b,id:R,name:N.displayName??N.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let E,l=new k.DisposableStore;const d=()=>{E?.dispose(),E=(0,D.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(C,{id:v,name:_.name??N.displayName??N.name,source:N.displayName??N.name,selector:t.DocumentSelector.from(_.selector,this._uriTransformer),label:_.text,detail:_.detail??"",severity:_.severity===I.LanguageStatusSeverity.Error?T.default.Error:_.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:_.command&&this._commands.toInternal(_.command,l),accessibilityInfo:_.accessibilityInformation,busy:_.busy})},0)},m={dispose(){l.dispose(),E?.dispose(),g.$removeLanguageStatus(C),u.delete(v)},get id(){return _.id},get name(){return _.name},set name(a){_.name=a,d()},get selector(){return _.selector},set selector(a){_.selector=a,d()},get text(){return _.text},set text(a){_.text=a,d()},get detail(){return _.detail},set detail(a){_.detail=a,d()},get severity(){return _.severity},set severity(a){_.severity=a,d()},get accessibilityInformation(){return _.accessibilityInformation},set accessibilityInformation(a){_.accessibilityInformation=a,d()},get command(){return _.command},set command(a){_.command=a,d()},get busy(){return _.busy},set busy(a){_.busy=a,d()}};return d(),m}}e.ExtHostLanguages=y}),define(be[135],Ee([1,0,11,5,26,17,3]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends f.AbstractLoggerService{constructor(N,R){const b=new D.Emitter;super(R.logLevel,b.event);this._proxy=N.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(b)}$setLevel(N){this._onDidChangeLogLevel.fire(N)}doCreateLogger(N,R,b){return new y(this._proxy,N,R,b)}};k=$e([Be(0,T.IExtHostRpcService),Be(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class y extends f.AbstractMessageLogger{constructor(N,R,b,C){super(C?.always);this.proxy=N,this.file=R,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(b),this.proxy.$createLogger(R,C).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(N,R){const b=[[N,R]];this.isLoggerCreated?this.doLog(b):this.buffer.push(...b)}doLog(N){this.proxy.$log(this.file,N)}}}),define(be[243],Ee([1,0,5,11,27]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let D=class{constructor(y,A){this._logService=A,this._proxy=y.getProxy(f.MainContext.MainThreadMessageService)}showMessage(y,A,N,R,b){const C={source:{identifier:y.identifier,label:y.displayName||y.name}};let g;typeof R=="string"||T(R)?g=[R,...b]:(C.modal=R?.modal,C.useCustom=R?.useCustom,C.detail=R?.detail,g=b),C.useCustom&&(0,I.checkProposedApiEnabled)(y,"resolvers");const u=[];for(let v=0;v<g.length;v++){const _=g[v];if(typeof _=="string")u.push({title:_,handle:v,isCloseAffordance:!1});else if(typeof _=="object"){let{title:E,isCloseAffordance:l}=_;u.push({title:E,isCloseAffordance:!!l,handle:v})}else this._logService.warn("Invalid message item:",_)}return this._proxy.$showMessage(A,N,C,u).then(v=>{if(typeof v=="number")return g[v]})}};D=$e([Be(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(be[244],Ee([1,0,22,3,57,6,24,8,14,2,83,5,16,7,52,220,131]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(l,d,m,a,S){this._textDocumentsAndEditors=m,this._textDocuments=a,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new N.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,s=o.cell.handle,r=this._documents.get(i)?.getCell(s);if(r)return r.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const d=this._editors.get(l);if(!d)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(l){for(const[d,m]of this._editors)if(m.apiEditor===l)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,d){const m=this._documents.get(l);if(!m&&!d)throw new Error(`NO notebook document for '${l}'`);return m}_getProviderData(l){const d=this._notebookContentProviders.get(l);if(!d)throw new Error(`NO provider for '${l}'`);return d}registerNotebookContentProvider(l,d,m,a,S){if((0,k.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:l,provider:m});let o;return m.onDidChangeNotebookContentOptions&&(o=m.onDidChangeNotebookContentOptions(()=>{const i=b.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(d,i)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},d,b.NotebookDocumentContentOptions.from(a),_._convertNotebookRegistrationData(l,S)),new C.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(l,d){if(!d)return;const m=d.filenamePattern.map(a=>b.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(d.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:d.displayName,filenamePattern:m,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,d,m){const a=_._notebookStatusBarItemProviderHandlePool++,S=typeof m.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,S,d);let o;return S!==void 0&&(o=m.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new C.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,S),o&&o.dispose()})}async createNotebookDocument(l){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&b.NotebookData.from(l.content)});return A.URI.revive(d)}async openNotebookDocument(l){const d=this._documents.get(l);if(d)return d.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(l),a=this._documents.get(A.URI.revive(m));return(0,y.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(l,d){A.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let m;typeof d=="object"?m={position:b.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(b.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:m={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,m),S=a&&this._editors.get(a)?.apiEditor;if(S)return S;throw a?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,d,m,a){const S=this._notebookStatusBarItemProviders.get(l),o=A.URI.revive(d),i=this._documents.get(o);if(!i||!S)return;const s=i.getCellFromIndex(m);if(!s)return;const n=await S.provideCellStatusBarItems(s.apiCell,a);if(!n)return;const r=new T.DisposableStore,h=this._statusBarCache.add([r]),w=(Array.isArray(n)?n:[n]).map(P=>b.NotebookStatusBarItem.from(P,this._commandsConverter,r));return{cacheId:h,items:w}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,d,m,a,S){if((0,k.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,m),this._notebookProxy.$registerNotebookSerializer(o,{id:l.identifier,location:l.extensionLocation},d,b.NotebookDocumentContentOptions.from(a),_._convertNotebookRegistrationData(l,S)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(l,d,m){const a=this._notebookSerializer.get(l);if(!a)throw new Error("NO serializer found");const S=await a.deserializeNotebook(d.buffer,m);return new g.SerializableObjectWithBuffers(b.NotebookData.from(S))}async $notebookToData(l,d,m){const a=this._notebookSerializer.get(l);if(!a)throw new Error("NO serializer found");const S=await a.serializeNotebook(b.NotebookData.to(d.value),m);return f.VSBuffer.wrap(S)}async $openNotebook(l,d,m,a,S){const{provider:o}=this._getProviderData(l),i=await o.openNotebook(A.URI.revive(d),{backupId:m,untitledDocumentData:a?.buffer},S);return new g.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(b.NotebookCellData.from)})}async $saveNotebook(l,d,m){const a=this.getNotebookDocument(A.URI.revive(d)),{provider:S}=this._getProviderData(l);return await S.saveNotebook(a.apiNotebook,m),!0}async $saveNotebookAs(l,d,m,a){const S=this.getNotebookDocument(A.URI.revive(d)),{provider:o}=this._getProviderData(l);return await o.saveNotebookAs(A.URI.revive(m),S.apiNotebook,a),!0}async $backupNotebook(l,d,m){const a=this.getNotebookDocument(A.URI.revive(d)),S=this._getProviderData(l),o=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([a.uri.toString(),this._backupIdPool++])),s=A.URI.joinPath(o,i),n=await S.provider.backupNotebook(a.apiNotebook,{destination:s},m);return a.updateBackup(n),n.id}_createExtHostEditor(l,d,m){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const a=new v.ExtHostNotebookEditor(d,this._notebookEditorsProxy,l,m.visibleRanges.map(b.NotebookRange.to),m.selections.map(b.NotebookRange.to),typeof m.viewColumn=="number"?b.ViewColumn.to(m.viewColumn):void 0);this._editors.set(d,a)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const m of l.value.removedDocuments){const a=A.URI.revive(m),S=this._documents.get(a);S&&(S.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===a.toString()&&this._editors.delete(o.id)}if(l.value.addedDocuments){const m=[];for(const a of l.value.addedDocuments){const S=A.URI.revive(a.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const o=this,i=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){o._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){o._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){o._onDidChangeCellMetadata.fire(s)}},S,a);m.push(...a.cells.map(s=>u.ExtHostCell.asModelAddData(i.apiNotebook,s))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const m of l.value.addedEditors){if(this._editors.has(m.id))return;const a=A.URI.revive(m.documentUri),S=this._documents.get(a);S&&this._createExtHostEditor(S,m.id,m)}const d=[];if(l.value.removedEditors)for(const m of l.value.removedEditors){const a=this._editors.get(m);a&&(this._editors.delete(m),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),d.push(a))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const m=new Set;this._visibleNotebookEditors.forEach(a=>m.add(a.id));for(const a of this._editors.values()){const S=m.has(a.id);a._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(be[245],Ee([1,0,3,76,11,5,17,16]),function(J,e,f,t,I,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(R,b){const C=y._Keys.nextId();R.$registerNotebookEditorDecorationType(C,k.NotebookDecorationRenderOptions.from(b)),this.value={key:C,dispose(){R.$removeNotebookEditorDecorationType(C)}}}}y._Keys=new t.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(R,b,C){this._logService=R,this._extHostRpc=b,this._notebooksAndEditors=C,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(R){return new y(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),R).value}$acceptEditorPropertiesChanged(R,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,b);const C=this._notebooksAndEditors.getEditorById(R);b.visibleRanges&&C._acceptVisibleRanges(b.visibleRanges.ranges.map(k.NotebookRange.to)),b.selections&&C._acceptSelections(b.selections.selections.map(k.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const b in R)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(k.ViewColumn.to(R[b]))}};A=$e([Be(0,I.ILogService),Be(1,D.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(be[246],Ee([1,0,18,15,21,3,6,24,2,28,11,5,40,16,7,84,213,27,52]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(i,s,n,r,h){this._initData=s,this._extHostNotebook=n,this._commands=r,this._logService=h,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(R.MainContext.MainThreadNotebookKernels);const c=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const P=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:P}}else if(w&&"notebookEditor"in w){const P=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return w})],b.ApiCommandResult.Void);this._commands.registerApiCommand(c)}createNotebookController(i,s,n,r,h,c){for(const X of this._kernelData.values())if(X.controller.id===s&&A.ExtensionIdentifier.equals(i.identifier,X.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const w=this._handlePool++,P=this;this._logService.trace(`NotebookController[${w}], CREATED by ${i.identifier.value}, ${s}`);const L=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${i.identifier}'`);let M=!1;const p=new D.DisposableStore,U=new T.Emitter,B=new T.Emitter,H={id:S(i,s),notebookType:n,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:r||i.identifier.value,preloads:c?c.map(C.NotebookRendererScript.from):[]};let re=h??L,W;this._proxy.$addKernel(w,H).catch(X=>{console.log(X),M=!0});let F=0;const q=()=>{if(M)return;const X=++F;Promise.resolve().then(()=>{X===F&&this._proxy.$updateKernel(w,H)})},G=new k.ResourceMap,$={get id(){return s},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return H.label},set label(X){H.label=X??i.displayName??i.name,q()},get detail(){return H.detail??""},set detail(X){H.detail=X,q()},get description(){return H.description??""},set description(X){H.description=X,q()},get kind(){return(0,_.checkProposedApiEnabled)(i,"notebookControllerKind"),H.kind??""},set kind(X){(0,_.checkProposedApiEnabled)(i,"notebookControllerKind"),H.kind=X,q()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(X){H.supportedLanguages=X,q()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(X){H.supportsExecutionOrder=X,q()},get rendererScripts(){return H.preloads?H.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(X){re=X??L},get interruptHandler(){return W},set interruptHandler(X){W=X,H.supportsInterrupt=Boolean(X),q()},createNotebookCellExecution(X){if(M)throw new Error("notebook controller is DISPOSED");if(!G.has(X.notebook.uri))throw P._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.notebook.uri.toString()}`);return P._createNotebookCellExecution(X,S(i,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${w}], DISPOSED`),M=!0,this._kernelData.delete(w),p.dispose(),U.dispose(),B.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(X,ie){P._proxy.$updateNotebookPriority(w,X.uri,ie)},onDidReceiveMessage:B.event,postMessage(X,ie){return(0,_.checkProposedApiEnabled)(i,"notebookMessaging"),P._proxy.$postMessage(w,ie&&P._extHostNotebook.getIdByEditor(ie),X)},asWebviewUri(X){return(0,_.checkProposedApiEnabled)(i,"notebookMessaging"),(0,u.asWebviewUri)(X,P._initData.remote)}};return this._kernelData.set(w,{extensionId:i.identifier,controller:$,onDidReceiveMessage:B,onDidChangeSelection:U,associatedNotebooks:G}),$}$acceptNotebookAssociation(i,s,n){const r=this._kernelData.get(i);if(r){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));n?r.associatedNotebooks.set(h.uri,!0):r.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,h.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:h.apiNotebook})}}async $executeCells(i,s,n){const r=this._kernelData.get(i);if(!r)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(s)),c=[];for(const w of n){const P=h.getCell(w);P&&c.push(P.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,h.uri.toString(),c.length),await r.controller.executeHandler.call(r.controller,c,h.apiNotebook,r.controller)}catch(w){this._logService.error(`NotebookController[${i}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(i,s,n){const r=this._kernelData.get(i);if(!r)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,h.apiNotebook);else for(const c of n){const w=h.getCell(c);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,s,n){const r=this._kernelData.get(i);if(!r)return;const h=this._extHostNotebook.getEditorById(s);r.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:n}))}$cellExecutionChanged(i,s,n){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(s);h&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:n?C.NotebookCellExecutionState.to(n):g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,s){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const h=new m(s,r,this._proxy);this._activeExecutions.set(r.uri,h);const c=h.onDidChangeState(()=>{h.state===d.Resolved&&(h.dispose(),c.dispose(),this._activeExecutions.delete(r.uri))});return h.asApiObject()}};l=$e([Be(4,N.ILogService)],l),e.ExtHostNotebookKernels=l;var d;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(d||(d={}));class m extends D.Disposable{constructor(i,s,n){super();this._cell=s,this._proxy=n,this._handle=m.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new a(10,r=>this.update(r)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const s=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new E.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(s=>{const n=g.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return n===s.items?C.NotebookCellOutput.from(s):C.NotebookCellOutput.from({items:n,id:s.id,metadata:s.metadata})})}async updateOutputs(i,s,n){const r=this.validateAndConvertOutputs((0,f.asArray)(i));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:n,outputs:r})}async updateOutputItems(i,s,n){return i=g.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(i),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:i.map(C.NotebookCellOutputItem.from),outputId:s.id,append:n})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(n){i._executionOrder=n,i.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(n){if(i._state===d.Resolved||i._state===d.Started)throw new Error("Cannot call start again");i._state=d.Started,i._onDidChangeState.fire(),i.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(i._state===d.Resolved)throw new Error("Cannot call resolve twice");i._state=d.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new E.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return i.verifyStateForOutput(),i.updateOutputs([],n,!1)},appendOutput(n,r){return i.verifyStateForOutput(),i.updateOutputs(n,r,!0)},replaceOutput(n,r){return i.verifyStateForOutput(),i.updateOutputs(n,r,!1)},appendOutputItems(n,r){return i.verifyStateForOutput(),i.updateOutputItems(n,r,!0)},replaceOutputItems(n,r){return i.verifyStateForOutput(),i.updateOutputItems(n,r,!1)}})}}m.HANDLE=0;class a{constructor(i,s){this.delay=i,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>i.complete())}}function S(o,i){return`${o.identifier.value}/${i}`}}),define(be[247],Ee([1,0,3,5,131,27]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class D{constructor(y,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,A,N){const R=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(A)?.fire({editor:R.apiEditor,message:N})}createRendererMessaging(y,A){if(!y.contributes?.notebookRenderer?.some(C=>C.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const N=(0,T.isProposedApiEnabled)(y,"notebookEditor"),R=new WeakMap;return{onDidReceiveMessage:(C,g,u)=>{const v=N?C:_=>{const E={};R.set(E,_.editor),C({editor:E,message:_.message})};return this.getOrCreateEmitterFor(A).event(v,g,u)},postMessage:(C,g)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(C)&&([C,g]=[g,C]);const u=N?g:R.get(g),v=u&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(v?.id,A,C)}}}getOrCreateEmitterFor(y){let A=this._rendererMessageEmitters.get(y);return A||(A=new f.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,A),A)}}e.ExtHostNotebookRenderers=D}),define(be[136],Ee([1,0,5,6,4,17,11,214,66,26,44,156,22,14]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends t.Disposable{constructor(_,E,l,d){super();this.id=_,this.name=E,this.logger=l,this.proxy=d,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,_)}replace(_){const E=this.offset;this.write(_),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,E),this.visible&&this.logger.flush()}show(_,E){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:E))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=b.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let u=class{constructor(_,E,l,d,m){this.extHostFileSystem=l,this.extHostFileSystemInfo=d,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(E.logsLocation,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[E,l]of this.channels)l.visible=E===this.visibleChannelId}createOutputChannel(_,E,l){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");if((0,C.isString)(E)&&!E.trim())throw new Error("illegal argument `languageId`. must not be empty");const d=this.doCreateOutputChannel(_,E,l);return d.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,d)}async doCreateOutputChannel(_,E,l){const d=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(d,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),S=await this.proxy.$register(_,!1,m,E,l.identifier.value);return new g(S,_,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,E){let l=!1;const d=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return _},append(m){d(),E.then(a=>a.append(m))},appendLine(m){d(),E.then(a=>a.appendLine(m))},clear(){d(),E.then(m=>m.clear())},replace(m){d(),E.then(a=>a.replace(m))},show(m,a){d(),E.then(S=>S.show(m,a))},hide(){d(),E.then(m=>m.hide())},dispose(){l=!0,E.then(m=>m.dispose())}}}};u=$e([Be(0,T.IExtHostRpcService),Be(1,A.IExtHostInitDataService),Be(2,y.IExtHostConsumerFileSystem),Be(3,N.IExtHostFileSystemInfo),Be(4,D.ILoggerService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(be[248],Ee([1,0,15,21,3,6,5,2,7,12,18,47,82,27]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(u,v,_){const E=u.getProxy(D.MainContext.MainThreadQuickOpen);class l{constructor(r,h){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=h}showQuickPick(r,h,c=t.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(r),P=++this._instances,L=E.$show(P,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},c),M={},p=L.then(()=>M);return Promise.race([p,w]).then(U=>{if(U!==M)return w.then(B=>{const H=[];for(let re=0;re<B.length;re++){const W=B[re];typeof W=="string"?H.push({label:W,handle:re}):W.kind===y.QuickPickItemKind.Separator?H.push({type:"separator",label:W.label}):H.push({label:W.label,description:W.description,detail:W.detail,picked:W.picked,alwaysShow:W.alwaysShow,handle:re})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=re=>{h.onDidSelectItem(B[re])}),E.$setItems(P,H),L.then(re=>{if(typeof re=="number")return B[re];if(Array.isArray(re))return re.map(W=>B[W])})})}).then(void 0,U=>{if(!(0,A.isCancellationError)(U))return E.$setError(P,U),Promise.reject(U)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,h=t.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",h).then(void 0,c=>{if(!(0,A.isCancellationError)(c))return Promise.reject(c)})}$validateInput(r){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,h=t.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!c)return;const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(P=>P.uri.toString()===c.uri.toString())}createQuickPick(r){const h=new i(r,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(r){const h=new s(r,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(r,h){const c=this._sessions.get(r);c&&c._fireDidChangeValue(h)}$onDidAccept(r){const h=this._sessions.get(r);h&&h._fireDidAccept()}$onDidChangeActive(r,h){const c=this._sessions.get(r);c instanceof i&&c._fireDidChangeActive(h)}$onDidChangeSelection(r,h){const c=this._sessions.get(r);c instanceof i&&c._fireDidChangeSelection(h)}$onDidTriggerButton(r,h){const c=this._sessions.get(r);c&&c._fireDidTriggerButton(h)}$onDidTriggerItemButton(r,h,c){const w=this._sessions.get(r);w instanceof i&&w._fireDidTriggerItemButton(h,c)}$onDidHide(r){const h=this._sessions.get(r);h&&h._fireDidHide()}}class d{constructor(r,h){this._extensionId=r,this._onDidDispose=h,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((h,c)=>{const w=h===y.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(w,h)}),this.update({buttons:r.map((h,c)=>({...o(h),tooltip:h.tooltip,handle:h===y.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const h=this._handlesToButtons.get(r);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const h of Object.keys(r)){const c=r[h];this._pendingUpdate[h]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}d._nextId=1;function m(n){if(n instanceof y.ThemeIcon)return{id:n.id};const r=S(n),h=a(n);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof h=="string"?k.URI.file(h):h}}function a(n){return typeof n=="object"&&"light"in n?n.light:n}function S(n){return typeof n=="object"&&"dark"in n?n.dark:n}function o(n){const r=m(n.iconPath);let h,c;return"id"in r?c=b.ThemeIcon.asClassName(r):h=r,{iconPath:h,iconClass:c}}class i extends d{constructor(r,h){super(r.identifier,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,w)=>{this._handlesToItems.set(w,c),this._itemsToHandles.set(c,w)});const h=[];for(let c=0;c<r.length;c++){const w=r[c];w.kind===y.QuickPickItemKind.Separator?h.push({type:"separator",label:w.label}):h.push({handle:c,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons?.map((P,L)=>({...o(P),tooltip:P.tooltip,handle:L}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(r){const h=(0,N.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(r){const h=(0,N.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(r,h){const c=this._handlesToItems.get(r);if(!c||!c.buttons||!c.buttons.length)return;const w=c.buttons[h];w&&this._onDidTriggerItemButtonEmitter.fire({button:w,item:c})}}class s extends d{constructor(r,h){super(r.identifier,h);this.extension=r,this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?R.default.Error:R.default.Ignore})}get validationMessage2(){return this._validationMessage2}set validationMessage2(r){(0,C.checkProposedApiEnabled)(this.extension,"inputBoxSeverity"),this._validationMessage2=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.content,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new l(v,_)}e.createExtHostQuickOpen=g});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[249],Ee([1,0,2,3,56,6,15,5,18,98,11,28,82,16,27]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g){"use strict";var u,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function _(h){if(h)return typeof h.iconPath=="string"?f.URI.file(h.iconPath):f.URI.isUri(h.iconPath)||b.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function E(h,c){if(!h.iconPath&&!c.iconPath)return 0;if(h.iconPath){if(!c.iconPath)return 1}else return-1;const w=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,P=typeof c.iconPath=="string"?c.iconPath:f.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,A.comparePaths)(w,P)}function l(h,c){let w=0;if(h.strikeThrough!==c.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==c.faded)return h.faded?1:-1;if(h.tooltip!==c.tooltip)return(h.tooltip||"").localeCompare(c.tooltip||"");if(w=E(h,c),w!==0)return w;if(h.light&&c.light)w=E(h.light,c.light);else{if(h.light)return 1;if(c.light)return-1}if(w!==0)return w;if(h.dark&&c.dark)w=E(h.dark,c.dark);else{if(h.dark)return 1;if(c.dark)return-1}return w}function d(h,c){if(h.command!==c.command)return h.command<c.command?-1:1;if(h.title!==c.title)return h.title<c.title?-1:1;if(h.tooltip!==c.tooltip){if(h.tooltip!==void 0&&c.tooltip!==void 0)return h.tooltip<c.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(h.arguments===c.arguments)return 0;if(h.arguments)if(c.arguments){if(h.arguments.length!==c.arguments.length)return h.arguments.length-c.arguments.length}else return 1;else return-1;for(let w=0;w<h.arguments.length;w++){const P=h.arguments[w],L=c.arguments[w];if(P!==L)return P<L?-1:1}return 0}function m(h,c){let w=(0,A.comparePaths)(h.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(w!==0)return w;if(h.command&&c.command)w=d(h.command,c.command);else{if(h.command)return 1;if(c.command)return-1}if(w!==0)return w;if(h.decorations&&c.decorations)w=l(h.decorations,c.decorations);else{if(h.decorations)return 1;if(c.decorations)return-1}return w}function a(h,c){for(let w=0;w<h.length;w++)if(h[w]!==c[w])return!1;return!0}function S(h,c){return h.command===c.command&&h.title===c.title&&h.tooltip===c.tooltip&&(h.arguments&&c.arguments?a(h.arguments,c.arguments):h.arguments===c.arguments)}function o(h,c){return(0,y.equals)(h,c,S)}class i{constructor(c,w,P){this._extension=c,this._sourceControlHandle=P,u.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Ye(this,u,w,"f")}get value(){return this._value}set value(c){c=c??"",Le(this,u,"f").$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){Le(this,u,"f").$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(c){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,Le(this,u,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,Le(this,u,"f").$setInputBoxVisibility(this._sourceControlHandle,c))}showValidationMessage(c,w){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,u,"f").$showValidationMessage(this._sourceControlHandle,c,w)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=i,u=new WeakMap;class s{constructor(c,w,P,L,M){this._proxy=c,this._commands=w,this._sourceControlHandle=P,this._id=L,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,w){const P=this._resourceStatesCommandsMap.get(c);return P?(0,D.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(m),P=(0,y.sortedDiff)(this._resourceSnapshot,c,m).map(p=>{const U=p.toInsert.map(B=>{const H=this._resourceHandlePool++;this._resourceStatesMap.set(H,B);const re=B.resourceUri;let W;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ee=new T.DisposableStore;W=this._commands.converter.toInternal(B.command,ee),this._resourceStatesDisposablesMap.set(H,ee)}else this._resourceStatesCommandsMap.set(H,B.command);const F=_(B.decorations),q=B.decorations&&_(B.decorations.light)||F,G=B.decorations&&_(B.decorations.dark)||F,$=[q,G],X=B.decorations&&B.decorations.tooltip||"",ie=B.decorations&&!!B.decorations.strikeThrough,ae=B.decorations&&!!B.decorations.faded,le=B.contextValue||"";return{rawResource:[H,re,$,X,ie,ae,le,W],handle:H}});return{start:p.start,deleteCount:p.deleteCount,toInsert:U}}),L=P.map(({start:p,deleteCount:U,toInsert:B})=>[p,U,B.map(H=>H.rawResource)]),M=P.reverse();for(const{start:p,deleteCount:U,toInsert:B}of M){const H=B.map(W=>W.handle),re=this._handlesSnapshot.splice(p,U,...H);for(const W of re)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=c,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class n{constructor(c,w,P,L,M,p){this._extension=c,this._commands=P,this._id=L,this._label=M,this._rootUri=p,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,v,w,"f"),this._inputBox=new i(c,Le(this,v,"f"),this.handle),Le(this,v,"f").$registerSourceControl(this.handle,L,M,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,Le(this,v,"f").$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,Le(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,Le(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=c;const w=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);Le(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(c){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=c;const w=c!==void 0?{command:this._commands.converter.toInternal(c.command,this._actionButtonDisposables.value),description:c.description}:void 0;Le(this,v,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&o(this._statusBarCommands,c))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=c;const w=(c||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));Le(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(c,w){const P=new s(Le(this,v,"f"),this._commands,this.handle,c,w),L=t.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,L),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const c=[],w=[];for(const[P,L]of this.createdResourceGroups){L.dispose();const M=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});t.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),M.dispose(),this._groups.delete(P.handle),Le(this,v,"f").$unregisterGroup(this.handle,P.handle)}),c.push([P.handle,P.id,P.label,P.features]);const p=P._takeResourceStateSnapshot();p.length>0&&w.push([P.handle,p]),this._groups.set(P.handle,P)}Le(this,v,"f").$registerGroups(this.handle,c,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(w=>{const P=w._takeResourceStateSnapshot();P.length!==0&&c.push([w.handle,P])}),c.length>0&&Le(this,v,"f").$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),Le(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,n._handlePool=0,$e([(0,I.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),$e([(0,I.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let r=class Ki{constructor(c,w,P){this._commands=w,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=c.getProxy(k.MainContext.MainThreadSCM),this._telemetry=c.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const M=this._sourceControls.get(L.sourceControlHandle);if(!M)return L;const p=M.getResourceGroup(L.groupHandle);return p?p.getResourceState(L.handle):L}else if(L&&L.$mid===4){const M=this._sourceControls.get(L.sourceControlHandle);return M?M.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const M=this._sourceControls.get(L.handle);return M||L}return L}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,w,P,L){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,w,P,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const M=Ki._handlePool++,p=new n(c,this._proxy,this._commands,w,P,L);this._sourceControls.set(M,p);const U=this._sourceControlsByExtension.get(R.ExtensionIdentifier.toKey(c.identifier))||[];return U.push(p),this._sourceControlsByExtension.set(R.ExtensionIdentifier.toKey(c.identifier),U),p}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const w=this._sourceControlsByExtension.get(R.ExtensionIdentifier.toKey(c.identifier)),P=w&&w[w.length-1];return P&&P.inputBox}$provideOriginalResource(c,w,P){const L=f.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,L.toString());const M=this._sourceControls.get(c);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(L,P)).then(p=>p||null)}$onInputBoxValueChange(c,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const P=this._sourceControls.get(c);return P&&P.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(c,w,P,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,w,P);const M=this._sourceControls.get(c);if(!M)return Promise.resolve(void 0);const p=M.getResourceGroup(w);return p?p.$executeResourceCommand(P,L):Promise.resolve(void 0)}$validateInput(c,w,P){this.logService.trace("ExtHostSCM#$validateInput",c);const L=this._sourceControls.get(c);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>L.inputBox.validateInput(w,P)).then(M=>{if(!M)return Promise.resolve(void 0);const p=C.MarkdownString.fromStrict(M.message);return p?Promise.resolve([p,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};r._handlePool=0,r=$e([Be(2,N.ILogService)],r),e.ExtHostSCM=r});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[250],Ee([1,0,7,5,170,6,16,14]),function(J,e,f,t,I,T,D,k){"use strict";var y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(g,u,v,_,E=f.StatusBarAlignment.Left,l){y.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ye(this,y,g,"f"),Ye(this,A,u,"f"),this._entryId=N.ID_GEN++,this._extension=v,this._id=_,this._alignment=E,this._priority=this.validatePriority(l)}validatePriority(g){if(!!(0,k.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!N.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Le(this,A,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Le(this,A,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let u;this._name?u=this._name:u=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=D.MarkdownString.fromStrict(this._tooltip);Le(this,y,"f").$setEntry(this._entryId,g,u,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=N,y=new WeakMap,A=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class R{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const u={message:g};return this._messages.unshift(u),this._update(),new f.Disposable(()=>{const v=this._messages.indexOf(u);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class b{constructor(g,u){this._proxy=g.getProxy(t.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new R(this)}createStatusBarEntry(g,u,v,_){return new N(this._proxy,this._commands,g,u,v,_)}setStatusBarMessage(g,u){const v=this._statusMessage.setMessage(g);let _;return typeof u=="number"?_=setTimeout(()=>v.dispose(),u):typeof u!="undefined"&&u.then(()=>v.dispose(),()=>v.dispose()),new f.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=b}),define(be[88],Ee([1,0,5,3,4]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}initializeExtensionStorage(k,y,A){return this._proxy.$initializeExtensionStorage(k,y).then(N=>N||A)}setValue(k,y,A){return this._proxy.$setValue(k,y,A)}$acceptValue(k,y,A){this._onDidChangeStorage.fire({shared:k,key:y,value:A})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(be[67],Ee([1,0,4,26,11,66,2]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let k=class{constructor(A,N,R){this._logService=N,this._extHostFileSystem=R,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(b=>this._value=b)}async _getWorkspaceStorageURI(A){return D.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,N=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(R){this._logService.error("[ExtHostStorage]",R);return}}workspaceValue(A){if(this._value)return D.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return D.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([Be(0,t.IExtHostInitDataService),Be(1,I.ILogService),Be(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(be[33],Ee([1,0,3,5,4,2,17,6,7,171,12,216,21,32,197,82,14,15]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class E{constructor(n,r,h,c){this._proxy=n,this._id=r,this._creationOptions=h,this._name=c,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(P,L=!0){w._checkDisposed(),w._proxy.$sendText(w._id,P,L)},show(P){w._checkDisposed(),w._proxy.$show(w._id,P)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,v.withNullAsUndefined)(n.shellPath),shellArgs:(0,v.withNullAsUndefined)(n.shellArgs),cwd:(0,v.withNullAsUndefined)(n.cwd),env:(0,v.withNullAsUndefined)(n.env),icon:(0,v.withNullAsUndefined)(o(n.iconPath)),color:u.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,v.withNullAsUndefined)(n.message),strictEnv:(0,v.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this._serializeParentTerminal(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,h,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:u.ThemeColor.isThemeColor(c)?c.id:void 0,location:this._serializeParentTerminal(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,r){return n===this._cols&&r===this._rows||n===0||r===0?!1:(this._cols=n,this._rows=r,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=E;class l{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,r){this._pty.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose?.((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions?.(r=>{r&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this._pty.onDidChangeName?.(r=>{this._onDidChangeProperty.fire({type:"title",value:r})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let d=1,m=class extends k.Disposable{constructor(n,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=r.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[h,c]of this._terminalProcesses)c.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,r){const h=new E(this._proxy,(0,C.generateUuid)(),n,n.name),c=new l(n.pty);return h.createExtensionTerminal(n.location,this._serializeParentTerminal(n,r).resolvedExtHostIdentifier,o(n.iconPath),i(n.color)).then(w=>{const P=this._setupExtHostProcessListeners(w,c);this._terminalProcessDisposables[w]=P}),this._terminals.push(h),h.value}_serializeParentTerminal(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const h=n.location.parentTerminal;if(h){const c=this._terminals.find(w=>w.value===h);c&&(r.resolvedExtHostIdentifier=c._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const c=new l(r),w=this._setupExtHostProcessListeners(n,c);this._terminalProcessDisposables[n]=w}async $acceptActiveTerminalChanged(n){const r=this._activeTerminal;if(n===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(n);h&&(this._activeTerminal=h,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,r){const h=this._getTerminalById(n);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:r})}async $acceptTerminalDimensions(n,r,h){const c=this._getTerminalById(n);c&&c.setDimensions(r,h)&&this._onDidChangeTerminalDimensions.fire({terminal:c.value,dimensions:c.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,h){this._terminalProcesses.get(n)?.resize(r,h)}async $acceptTerminalTitleChange(n,r){const h=this._getTerminalById(n);h&&(h.name=r)}async $acceptTerminalClosed(n,r){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){const c=this._terminals.splice(h,1)[0];c.setExitCode(r),this._onDidCloseTerminal.fire(c.value)}}$acceptTerminalOpened(n,r,h,c){if(r){const L=this._getTerminalObjectIndexById(this._terminals,r);if(L!==null){this._terminals[L]._id=n,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const w={name:c.name,shellPath:c.executable,shellArgs:c.args,cwd:typeof c.cwd=="string"?c.cwd:T.URI.revive(c.cwd),env:c.env,hideFromUser:c.hideFromUser},P=new E(this._proxy,n,w,h);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(n,r){const h=this._getTerminalById(n);h&&h._setProcessId(r)}async $startExtensionTerminal(n,r){const h=this._getTerminalById(n);if(!h)return{message:(0,A.localize)(0,null,n)};h.isOpen||await new Promise(w=>{const P=this.onDidOpenTerminal(async L=>{L===h.value&&(P.dispose(),w())})});const c=this._terminalProcesses.get(n);c?c.startSendingEvents(r):this._extensionTerminalAwaitingStart[n]={initialDimensions:r}}_setupExtHostProcessListeners(n,r){const h=new k.DisposableStore;h.add(r.onProcessReady(w=>this._proxy.$sendProcessReady(n,w.pid,w.cwd))),h.add(r.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(n,w))),this._bufferer.startBuffering(n,r.onProcessData),h.add(r.onProcessExit(w=>this._onProcessExit(n,w))),this._terminalProcesses.set(n,r);const c=this._extensionTerminalAwaitingStart[n];return c&&r instanceof l&&(r.startSendingEvents(c.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),h}$acceptProcessAckDataEvent(n,r){this._terminalProcesses.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this._terminalProcesses.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this._getTerminalById(n);r?.setInteractedWith()&&this._onDidChangeTerminalState.fire(r.value)}$acceptProcessResize(n,r,h){try{this._terminalProcesses.get(n)?.resize(r,h)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(n,r){this._terminalProcesses.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(r=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(r=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,r,h){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,h),this._proxy.$registerProfileProvider(r,n.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(n,r){const h=new b.CancellationTokenSource().token;let c=await this._profileProviders.get(n)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(c&&!("options"in c)&&(c={options:c}),!c||!("options"in c))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in c.options){this.createExtensionTerminal(c.options,r);return}this.createTerminalFromOptions(c.options,r)}}async $provideLinks(n,r){const h=this._getTerminalById(n);if(!h)return[];this._terminalLinkCache.delete(n);const c=this._terminalLinkCancellationSource.get(n);c&&c.dispose(!0);const w=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,w);const P=[],L={terminal:h.value,line:r},M=[];for(const B of this._linkProviders)M.push(_.Promises.withAsyncBody(async H=>{w.token.onCancellationRequested(()=>H({provider:B,links:[]}));const re=await B.provideTerminalLinks(L,w.token)||[];w.token.isCancellationRequested||H({provider:B,links:re})}));const p=await Promise.all(M);if(w.token.isCancellationRequested)return[];const U=new Map;for(const B of p)B&&B.links.length>0&&P.push(...B.links.map(H=>{const re={id:d++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return U.set(re.id,{provider:B.provider,link:H}),re}));return this._terminalLinkCache.set(n,U),P}$activateLink(n,r){const h=this._terminalLinkCache.get(n)?.get(r);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(n,r){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const h=this._terminalProcessDisposables[n];h&&(h.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,r)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,r){const h=this._getTerminalObjectIndexById(n,r);return h!==null?n[h]:null}_getTerminalObjectIndexById(n,r){let h=null;return n.some((c,w)=>c._id===r?(h=w,!0):!1),h}getEnvironmentVariableCollection(n){let r=this._environmentVariableCollections.get(n.identifier.value);return r||(r=new a,this._setEnvironmentVariableCollection(n.identifier.value,r)),r}_syncEnvironmentVariableCollection(n,r){const h=(0,R.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(n,r.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const h=r[0],c=new a(r[1]);this._setEnvironmentVariableCollection(h,c)})}$acceptDefaultProfile(n,r){this._defaultProfile=n,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(n,r){this._environmentVariableCollections.set(n,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,r)})}};m=$e([Be(1,D.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class a{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,r){this._setIfDiffers(n,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(n,r){this._setIfDiffers(n,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,r){this._setIfDiffers(n,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,r){const h=this.map.get(n);(!h||h.value!==r.value||h.type!==r.type)&&(this.map.set(n,r),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((h,c)=>n.call(r,c,h,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let S=class extends m{constructor(n){super(!1,n)}createTerminal(n,r,h){throw new N.NotSupportedError}createTerminalFromOptions(n,r){throw new N.NotSupportedError}};S=$e([Be(0,D.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function o(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function i(s){return u.ThemeColor.isThemeColor(s)?s:void 0}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[251],Ee([1,0,18,22,21,3,75,57,6,25,14,32,5,17,63,16,7,222,85,86]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l){"use strict";var d,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(M,p){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(b.MainContext.MainThreadTesting),this.observer=new c(this.proxy),this.runTracker=new o(this.proxy),p.registerArgumentProcessor({processArgument:U=>U?.$mid===13?u.TestItem.toItemFromContext(U):U})}createTestController(M,p,U){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const B=new y.DisposableStore,H=B.add(new _.SingleUseTestCollection(M));H.root.label=p;const re=new Map,W=this.proxy,F={items:H.root.children,get label(){return p},set label(G){p=G,H.root.label=G,W.$updateController(M,{label:p})},get refreshHandler(){return U},set refreshHandler(G){U=G,W.$updateController(M,{canRefresh:!!G})},get id(){return M},createRunProfile:(G,$,X,ie,ae)=>{let le=(0,k.hash)(G);for(;re.has(le);)le++;return new w(this.proxy,re,M,le,G,$,X,ie,ae)},createTestItem(G,$,X){return new g.TestItemImpl(M,G,$,X)},createTestRun:(G,$,X=!0)=>this.runTracker.createTestRun(M,H,G,$,X),set resolveHandler(G){H.resolveHandler=G},get resolveHandler(){return H.resolveHandler},dispose:()=>{B.dispose()}};W.$registerTestController(M,p,!!U),B.add((0,y.toDisposable)(()=>W.$unregisterTestController(M)));const q={controller:F,collection:H,profiles:re};return this.controllers.set(M,q),B.add((0,y.toDisposable)(()=>this.controllers.delete(M))),B.add(H.onDidGenerateDiff(G=>W.$publishDiff(M,G.map(E.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(M,p=I.CancellationToken.None){const U=i(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(U.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(H=>l.TestId.fromExtHostTestItem(H,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:P[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(H=>H.id)},p)}$provideFileCoverage(M,p,U){return(0,f.mapFind)(this.runTracker.trackers,H=>H.id===M?H.getCoverage(p):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,p,U,B){return(0,f.mapFind)(this.runTracker.trackers,re=>re.id===M?re.getCoverage(p):void 0)?.resolveFileCoverage(U,B)??Promise.resolve([])}$configureRunProfile(M,p){this.controllers.get(M)?.profiles.get(p)?.configureHandler?.()}async $refreshTests(M,p){await this.controllers.get(M)?.controller.refreshHandler?.(p)}$publishTestResults(M){this.results=Object.freeze(M.map(p=>(0,A.deepFreeze)(u.TestResults.to(p))).concat(this.results).sort((p,U)=>U.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,p){const U=this.controllers.get(l.TestId.fromString(M).controllerId)?.collection;U&&(await U.expand(M,p<0?1/0:p),U.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(E.TestsDiffOp.deserialize))}async $runControllerTests(M,p){const U=this.controllers.get(M.controllerId);if(!U)return;const{collection:B,profiles:H}=U,re=H.get(M.profileId);if(!re)return;const W=M.testIds.map($=>B.tree.get($)).filter(N.isDefined),F=M.excludeExtIds.map($=>U.collection.tree.get($)).filter(N.isDefined).filter($=>W.some(X=>X.fullId.compare($.fullId)===2));if(!W.length)return;const q=new v.TestRunRequest(W.some($=>$.actual instanceof g.TestItemRootImpl)?void 0:W.map($=>$.actual),F.map($=>$.actual),re),G=this.runTracker.prepareForMainThreadTestRun(q,s.fromInternal(M,U.collection),p);try{await re.runHandler(q,p)}finally{G.isRunning&&!p.isCancellationRequested&&await T.Event.toPromise(G.onEnd),G.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};a=$e([Be(0,C.IExtHostRpcService)],a),e.ExtHostTesting=a;class S extends y.Disposable{constructor(M,p,U){super();this.dto=M,this.proxy=p,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const p=this.dto.id,U=this.dto.controllerId,B=(0,R.generateUuid)(),H=new n(this.proxy,p,B),re=G=>($,...X)=>{if(F){console.warn(`Setting the state of test "${$.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded($)||(this.ensureTestIsKnown($),G($,...X))},W=(G,$)=>{const X=$ instanceof Array?$.map(u.TestMessage.from):[u.TestMessage.from($)];if(G.uri&&G.range){const ie={range:u.Range.from(G.range),uri:G.uri};for(const ae of X)ae.location=ae.location||ie}this.proxy.$appendTestMessagesInRun(p,B,l.TestId.fromExtHostTestItem(G,U).toString(),X)};let F=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return H.coverageProvider},set coverageProvider(G){H.coverageProvider=G},enqueued:re(G=>{this.proxy.$updateTestStateInRun(p,B,l.TestId.fromExtHostTestItem(G,U).toString(),1)}),skipped:re(G=>{this.proxy.$updateTestStateInRun(p,B,l.TestId.fromExtHostTestItem(G,U).toString(),5)}),started:re(G=>{this.proxy.$updateTestStateInRun(p,B,l.TestId.fromExtHostTestItem(G,U).toString(),2)}),errored:re((G,$,X)=>{W(G,$),this.proxy.$updateTestStateInRun(p,B,l.TestId.fromExtHostTestItem(G,U).toString(),6,X)}),failed:re((G,$,X)=>{W(G,$),this.proxy.$updateTestStateInRun(p,B,l.TestId.fromExtHostTestItem(G,U).toString(),4,X)}),passed:re((G,$)=>{this.proxy.$updateTestStateInRun(p,B,l.TestId.fromExtHostTestItem(G,this.dto.controllerId).toString(),3,$)}),appendOutput:(G,$,X)=>{F||(X&&(this.dto.isIncluded(X)?this.ensureTestIsKnown(X):X=void 0),this.proxy.$appendOutputToRun(p,B,t.VSBuffer.fromString(G),$&&u.location.from($),X&&l.TestId.fromExtHostTestItem(X,U).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(p,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:q,coverage:H}),this.proxy.$startedTestRunTask(p,{id:B,name:M,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof g.TestItemImpl))throw new g.InvalidTestItemError(M.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const p=[],U=this.dto.colllection.root;for(;;){const B=u.TestItem.from(M);if(p.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),M===U))break;M=M.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,p)}}class o{constructor(M){this.proxy=M,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(M,p,U){return this.getTracker(M,p,U)}cancelRunById(M){for(const p of this.tracked.values())if(p.id===M){p.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,p,U,B,H){const re=this.tracked.get(U);if(re)return re.createRun(B);const W=s.fromPublic(M,p,U,H),F=i(U);this.proxy.$startedExtensionTestRun({controllerId:M,profile:F&&{group:P[F.kind],id:F.profileId},exclude:U.exclude?.map(G=>l.TestId.fromExtHostTestItem(G,p.root.id).toString())??[],id:W.id,include:U.include?.map(G=>l.TestId.fromExtHostTestItem(G,p.root.id).toString())??[p.root.id],persist:H});const q=this.getTracker(U,W);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),q.createRun(B)}getTracker(M,p,U){const B=new S(p,this.proxy,U);return this.tracked.set(M,B),B.onEnd(()=>this.tracked.delete(M)),B}}e.TestRunCoordinator=o;const i=L=>{if(!!L.profile){if(!(L.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return L.profile}};class s{constructor(M,p,U,B,H,re){this.controllerId=M,this.id=p,this.isPersisted=H,this.colllection=re,this.includePrefix=U.map(W=>W+"\0"),this.excludePrefix=B.map(W=>W+"\0")}static fromPublic(M,p,U,B){return new s(M,(0,R.generateUuid)(),U.include?.map(H=>l.TestId.fromExtHostTestItem(H,M).toString())??[M],U.exclude?.map(H=>l.TestId.fromExtHostTestItem(H,M).toString())??[],B,p)}static fromInternal(M,p){return new s(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,p)}isIncluded(M){const p=l.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(p===U||p.startsWith(U))return!1;for(const U of this.includePrefix)if(p===U||p.startsWith(U))return!0;return!1}}e.TestRunDto=s;class n{constructor(M,p,U){this.proxy=M,this.runId=p,this.taskId=U}set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(p){throw this.fileCoverage=void 0,p}}async resolveFileCoverage(M,p){const U=await this.fileCoverage;let B=U?.[M];return!this._coverageProvider||!U||!B?[]:(B.detailedCoverage||(B=U[M]=await this._coverageProvider.resolveFileCoverage?.(B,p)??B),B.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class r extends E.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:p,removed:U}=this;return{get added(){return[...M].map(B=>B.revived)},get updated(){return[...p].map(B=>B.revived)},get removed(){return[...U].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,p){return{...M,revived:u.TestItem.toPlain(M.item),depth:p?p.depth+1:0,children:new Set}}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=h;class c{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(p=>p.revived)},dispose:(0,D.once)(()=>{--M.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class w{constructor(M,p,U,B,H,re,W,F=!1,q=void 0){this.controllerId=U,this.profileId=B,this._label=H,this.kind=re,this.runHandler=W,this._isDefault=F,this._tag=q,d.set(this,void 0),m.set(this,void 0),Ye(this,d,M,"f"),Ye(this,m,p,"f"),p.set(B,this);const G=P[re];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);Le(this,d,"f").$publishTestRunProfile({profileId:B,controllerId:U,tag:q?u.TestTag.namespace(this.controllerId,q.id):null,label:H,group:G,isDefault:F,hasConfigurationHandler:!1})}get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Le(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Le(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Le(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Le(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}dispose(){Le(this,m,"f")?.delete(this.profileId)&&(Ye(this,m,void 0,"f"),Le(this,d,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=w,d=new WeakMap,m=new WeakMap;const P={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[252],Ee([1,0,3,18,5,132,16,7,126,21]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class N{constructor(b,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this._onWillDropOnTextEditor=new f.AsyncEmitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onWillDropOnTextEditor=this._onWillDropOnTextEditor.event,this._proxy=b.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(b){const C=this._extHostDocumentsAndEditors.allEditors();return b?C:C.map(g=>g.value)}async showTextDocument(b,C,g){let u;typeof C=="number"?u={position:D.ViewColumn.from(C),preserveFocus:g}:typeof C=="object"?u={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:u={preserveFocus:!1};const v=await this._proxy.$tryShowTextDocument(b.uri,u),_=v&&this._extHostDocumentsAndEditors.getEditor(v);if(_)return _.value;throw v?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}createTextEditorDecorationType(b,C){return new T.TextEditorDecorationType(this._proxy,b,C).value}$acceptEditorPropertiesChanged(b,C){const g=this._extHostDocumentsAndEditors.getEditor(b);if(!g)throw new Error("unknown text editor");if(C.options&&g._acceptOptions(C.options),C.selections){const u=C.selections.selections.map(D.Selection.to);g._acceptSelections(u)}if(C.visibleRanges){const u=t.coalesce(C.visibleRanges.map(D.Range.to));g._acceptVisibleRanges(u)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...C.options,lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const u=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),v=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:v,kind:u})}if(C.visibleRanges){const u=t.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:u})}}$acceptEditorPositionData(b){for(const C in b){const g=this._extHostDocumentsAndEditors.getEditor(C);if(!g)throw new Error("Unknown text editor");const u=D.ViewColumn.to(b[C]);g.value.viewColumn!==u&&(g._acceptViewColumn(u),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:u}))}}getDiffInformation(b){return Promise.resolve(this._proxy.$getDiffInformation(b))}async $textEditorHandleDrop(b,C,g){const u=this._extHostDocumentsAndEditors.getEditor(b);if(!u)throw new Error("Unknown text editor");const v=D.Position.to(C),_=y.DataTransferConverter.toDataTransfer(g),E=Object.freeze({editor:u.value,position:v,dataTransfer:_});await this._onWillDropOnTextEditor.fireAsync(E,A.CancellationToken.None)}}e.ExtHostEditors=N}),define(be[253],Ee([1,0,2,4,5,6,7,16,14]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class A{constructor(b,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=b.getProxy(I.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const u=g.uri===void 0?void 0:f.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(N(u))?.get(g.handle)}return g}})}async $getTimeline(b,C,g,u,v){return this._providers.get(b)?.provideTimeline(f.URI.revive(C),g,u,v)}registerTimelineProvider(b,C,g,u){const v=new T.DisposableStore,_=this.convertTimelineItem(C.id,u,v).bind(this);let E;C.onDidChange&&(E=C.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:C.id}),this));const l=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:b,onDidChange:void 0,async provideTimeline(d,m,a,S){S?.resetCache&&(v.clear(),l.get(C.id)?.clear());const o=await C.provideTimeline(d,m,a);if(o==null)return;const i=_(d,S);return{...o,source:C.id,items:o.items.map(i)}},dispose(){for(const d of l.values())d.get(C.id)?.clear();E?.dispose(),v.dispose()}})}convertTimelineItem(b,C,g){return(u,v)=>{let _;if(v?.cacheResults){let E=this._itemsBySourceAndUriMap.get(b);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(b,E));const l=N(u);_=E.get(l),_===void 0&&(_=new Map,E.set(l,_))}return E=>{const{iconPath:l,...d}=E,m=`${b}|${E.id??E.timestamp}`;_?.set(m,E);let a,S,o;E.iconPath&&(l instanceof D.ThemeIcon?o={id:l.id,color:l.color}:f.URI.isUri(l)?(a=l,S=l):{light:a,dark:S}=l);let i;return D.MarkdownString.isMarkdownString(d.tooltip)?i=k.MarkdownString.from(d.tooltip):(0,y.isString)(d.tooltip)?i=d.tooltip:D.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=k.MarkdownString.from(d.detail)):(0,y.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=d.detail),{...d,id:d.id??void 0,handle:m,source:b,command:E.command?C.toInternal(E.command,g):void 0,icon:a,iconDark:S,themeIcon:o,tooltip:i,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(b){if(this._providers.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this._proxy.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this._providers.set(b.id,b),(0,T.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(b.id)?.clear();this._providers.delete(b.id),this._proxy.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=A;function N(R){return R?.toString()}}),define(be[254],Ee([1,0,6,10,2,5]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,A,N,R){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const b=R.schemes.find(C=>!D.supportedSchemes.has(C));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,N),this._proxy.$registerUriOpener(A,R.schemes,y,R.label),(0,f.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(y,A,N){const R=this._openers.get(y);if(!R)throw new Error(`Unknown opener with id: ${y}`);const b=I.URI.revive(A);return R.canOpenExternalUri(b,N)}async $openUri(y,A,N){const R=this._openers.get(y);if(!R)throw new Error(`Unknown opener id: '${y}'`);return R.openExternalUri(I.URI.revive(A.resolvedUri),{sourceUri:I.URI.revive(A.sourceUri)},N)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(be[255],Ee([1,0,5,2,6,12,28]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(A,N){if(this.handles.has(D.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const R=k.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(A)),this.handlers.set(R,N),this._proxy.$registerUriHandler(R,A),(0,I.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(A)),this.handlers.delete(R),this._proxy.$unregisterUriHandler(R)})}$handleExternalUri(A,N){const R=this.handlers.get(A);if(!R)return Promise.resolve(void 0);try{R.handleUri(t.URI.revive(N))}catch(b){(0,T.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(A){return t.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=k,k.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[68],Ee([1,0,3,10,2,184,205,84,5]),function(J,e,f,t,I,T,D,k,y){"use strict";var A,N,R,b,C,g,u,v,_,E,l,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(h,c,w,P,L,M,p){A.set(this,void 0),N.set(this,void 0),R.set(this,void 0),b.set(this,void 0),C.set(this,void 0),g.set(this,void 0),u.set(this,""),v.set(this,void 0),_.set(this,!1),E.set(this,!1),l.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new f.Emitter),this._onDidDispose=Le(this,d,"f").event,Ye(this,A,h,"f"),Ye(this,N,c,"f"),Ye(this,v,w,"f"),Ye(this,b,P,"f"),Ye(this,C,L,"f"),Ye(this,g,M,"f"),Ye(this,l,a(M),"f"),Ye(this,R,p,"f")}dispose(){Ye(this,_,!0,"f"),Le(this,d,"f").fire(),Le(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return Ye(this,E,!0,"f"),(0,k.asWebviewUri)(h,Le(this,b,"f"))}get cspSource(){const h=Le(this,g,"f").extensionLocation;if(h.scheme===t.Schemas.https||h.scheme===t.Schemas.http){let c=h.toString();return c.endsWith("/")||(c+="/"),c+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,u,"f")}set html(h){this.assertNotDisposed(),Le(this,u,"f")!==h&&(Ye(this,u,h,"f"),!Le(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(Ye(this,E,!0,"f"),Le(this,R,"f").report("Webview vscode-resource: uris",Le(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,N,"f").$setHtml(Le(this,A,"f"),h))}get options(){return this.assertNotDisposed(),Le(this,v,"f")}set options(h){this.assertNotDisposed(),Le(this,N,"f").$setOptions(Le(this,A,"f"),i(Le(this,g,"f"),Le(this,C,"f"),h)),Ye(this,v,h,"f")}async postMessage(h){if(Le(this,_,"f"))return!1;const c=(0,D.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Le(this,l,"f")});return Le(this,N,"f").$postMessage(Le(this,A,"f"),c.message,...c.buffers)}assertNotDisposed(){if(Le(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,A=new WeakMap,N=new WeakMap,R=new WeakMap,b=new WeakMap,C=new WeakMap,g=new WeakMap,u=new WeakMap,v=new WeakMap,_=new WeakMap,E=new WeakMap,l=new WeakMap,d=new WeakMap;function a(r){try{const h=(0,T.normalizeVersion)((0,T.parseVersion)(r.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class S{constructor(h,c,w,P,L){this.remoteInfo=c,this.workspace=w,this._logService=P,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=h.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(h,c,w){const P=this.getWebview(h);if(P){const{message:L}=(0,D.deserializeWebviewMessage)(c,w.value);P._onMessageEmitter.fire(L)}}$onMissingCsp(h,c){this._logService.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,c,w){const P=new m(h,this._webviewProxy,s(c),this.remoteInfo,this.workspace,w,this._deprecationService);return this._webviews.set(h,P),P._onDidDispose(()=>{this._webviews.delete(h)}),P}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=S;function o(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=o;function i(r,h,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||n(r,h)}}e.serializeWebviewOptions=i;function s(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(h=>I.URI.from(h))}}e.reviveOptions=s;function n(r,h){return[...(h?.getWorkspaceFolders()||[]).map(c=>c.uri),r.extensionLocation]}}),define(be[256],Ee([1,0,21,57,6,10,23,2,16,68,83,5,7]),function(J,e,f,t,I,T,D,k,y,A,N,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(a,S){this.document=a,this._storagePath=S,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,S){await this.getEdit(a).undo(),S||this.disposeBackup()}async redo(a,S){await this.getEdit(a).redo(),S||this.disposeBackup()}disposeEdits(a){for(const S of a)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=d(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const S=this._edits.get(a,0);if(!S)throw new Error("No edit found");return S}}class g{constructor(){this._documents=new Map}get(a,S){return this._documents.get(this.key(a,S))}add(a,S,o){const i=this.key(a,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${a} resource:${S.uri}`);const s=new C(S,o);return this._documents.set(i,s),s}delete(a,S){const o=this.key(a,S.uri);this._documents.delete(o)}key(a,S){return`${a}@@@${S}`}}var u;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(u||(u={}));class v{constructor(){this._providers=new Map}addTextProvider(a,S,o){return this.add(0,a,S,o)}addCustomProvider(a,S,o){return this.add(1,a,S,o)}get(a){return this._providers.get(a)}add(a,S,o,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:a,extension:o,provider:i}),new b.Disposable(()=>this._providers.delete(S))}}class _{constructor(a,S,o,i,s){this._extHostDocuments=S,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new v,this._documents=new g,this._proxy=a.getProxy(R.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,S,o,i){const s=new I.DisposableStore;return E(o)?(s.add(this._editorProviders.addTextProvider(S,a,o)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(a),S,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(a))):(s.add(this._editorProviders.addCustomProvider(S,a,o)),this.supportEditing(o)&&s.add(o.onDidChangeCustomDocument(n=>{const r=this.getCustomDocumentEntry(S,n.document.uri);if(l(n)){const h=r.addEdit(n);this._proxy.$onDidEdit(n.document.uri,S,h,n.label)}else this._proxy.$onContentChange(n.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(a),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(a))),b.Disposable.from(s,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(a,S,o,i,s){const n=this._editorProviders.get(S);if(!n)throw new Error(`No provider found for '${S}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${S}'`);const r=k.URI.revive(a),h=await n.provider.openCustomDocument(r,{backupId:o,untitledDocumentData:i?.buffer},s);let c;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(c=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(S,h,c),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(a,S){const o=this._editorProviders.get(S);if(!o)throw new Error(`No provider found for '${S}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=k.URI.revive(a),{document:s}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,s),s.dispose()}async $resolveWebviewEditor(a,S,o,i,s,n){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);const h=y.ViewColumn.to(s),c=this._extHostWebview.createNewWebview(S,i.webviewOptions,r.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(S,o,i.title,h,i.panelOptions,c),P=k.URI.revive(a);switch(r.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,P);return r.provider.resolveCustomEditor(L,w,n)}case 0:{const L=this._extHostDocuments.getDocument(P);return r.provider.resolveCustomTextEditor(L,w,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,S,o){this.getCustomDocumentEntry(S,a).disposeEdits(o)}async $onMoveCustomEditor(a,S,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const s=this._extHostWebviewPanels.getWebviewPanel(a);if(!s)throw new Error("No webview found");const n=k.URI.revive(S),r=this._extHostDocuments.getDocument(n);await i.provider.moveCustomTextEditor(r,s,f.CancellationToken.None)}async $undo(a,S,o,i){return this.getCustomDocumentEntry(S,a).undo(o,i)}async $redo(a,S,o,i){return this.getCustomDocumentEntry(S,a).redo(o,i)}async $revert(a,S,o){const i=this.getCustomDocumentEntry(S,a);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(a,S,o){const i=this.getCustomDocumentEntry(S,a);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(a,S,o,i){const s=this.getCustomDocumentEntry(S,a);return this.getCustomEditorProvider(S).saveCustomDocumentAs(s.document,k.URI.revive(o),i)}async $backup(a,S,o){const i=this.getCustomDocumentEntry(S,a),n=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(n),n.id}getCustomDocumentEntry(a,S){const o=this._documents.get(a,k.URI.revive(S));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(a){const o=this._editorProviders.get(a)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=_;function E(m){return typeof m.resolveCustomTextEditor=="function"}function l(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function d(m){const a=m.scheme===T.Schemas.file||m.scheme===T.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(a)+""}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[257],Ee([1,0,3,6,2,32,16,68,5,7]),function(J,e,f,t,I,T,D,k,y,A){"use strict";var N,R,b,C,g,u,v,_,E,l,d,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(n,r,h,c,w,P,L){super();N.set(this,void 0),R.set(this,void 0),b.set(this,void 0),C.set(this,void 0),g.set(this,void 0),u.set(this,void 0),v.set(this,void 0),_.set(this,void 0),E.set(this,!0),l.set(this,!0),d.set(this,!1),m.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,m,"f").event,a.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Le(this,a,"f").event,Ye(this,N,n,"f"),Ye(this,R,r,"f"),Ye(this,b,h,"f"),Ye(this,g,P,"f"),Ye(this,_,w,"f"),Ye(this,u,c,"f"),Ye(this,C,L,"f")}dispose(){Le(this,d,"f")||(Ye(this,d,!0,"f"),Le(this,m,"f").fire(),Le(this,R,"f").$disposeWebview(Le(this,N,"f")),Le(this,C,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,C,"f")}get viewType(){return this.assertNotDisposed(),Le(this,b,"f")}get title(){return this.assertNotDisposed(),Le(this,u,"f")}set title(n){this.assertNotDisposed(),Le(this,u,"f")!==n&&(Ye(this,u,n,"f"),Le(this,R,"f").$setTitle(Le(this,N,"f"),n))}get iconPath(){return this.assertNotDisposed(),Le(this,v,"f")}set iconPath(n){this.assertNotDisposed(),Le(this,v,"f")!==n&&(Ye(this,v,n,"f"),Le(this,R,"f").$setIconPath(Le(this,N,"f"),I.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Le(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,_,"f")=="number"&&Le(this,_,"f")<0))return Le(this,_,"f")}get active(){return this.assertNotDisposed(),Le(this,l,"f")}get visible(){return this.assertNotDisposed(),Le(this,E,"f")}_updateViewState(n){Le(this,d,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(Ye(this,l,n.active,"f"),Ye(this,E,n.visible,"f"),Ye(this,_,n.viewColumn,"f"),Le(this,a,"f").fire({webviewPanel:this}))}reveal(n,r){this.assertNotDisposed(),Le(this,R,"f").$reveal(Le(this,N,"f"),{viewColumn:typeof n=="undefined"?void 0:D.ViewColumn.from(n),preserveFocus:!!r})}assertNotDisposed(){if(Le(this,d,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,R=new WeakMap,b=new WeakMap,C=new WeakMap,g=new WeakMap,u=new WeakMap,v=new WeakMap,_=new WeakMap,E=new WeakMap,l=new WeakMap,d=new WeakMap,m=new WeakMap,a=new WeakMap;class o{constructor(n,r,h){this.webviews=r,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(n,r,h,c,w={}){const P=typeof c=="object"?c.viewColumn:c,L={viewColumn:D.ViewColumn.from(P),preserveFocus:typeof c=="object"&&!!c.preserveFocus},M=(0,k.shouldSerializeBuffersForPostMessage)(n),p=o.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(n),p,r,{title:h,panelOptions:i(w),webviewOptions:(0,k.serializeWebviewOptions)(n,this.workspace,w),serializeBuffersForPostMessage:M},L);const U=this.webviews.createNewWebview(p,w,n);return this.createNewWebviewPanel(p,r,h,P,w,U)}$onDidChangeWebviewPanelViewStates(n){const r=Object.keys(n);r.sort((h,c)=>{const w=n[h],P=n[c];return w.active?1:P.active?-1:+w.visible-+P.visible});for(const h of r){const c=this.getWebviewPanel(h);if(!c)continue;const w=n[h];c._updateViewState({active:w.active,visible:w.visible,viewColumn:D.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,r,h){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:h,extension:n}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(n)}),new A.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(n,r,h,c){const w=this._serializers.get(r);if(!w)throw new Error(`No serializer found for '${r}'`);const{serializer:P,extension:L}=w,M=this.webviews.createNewWebview(n,h.webviewOptions,L),p=this.createNewWebviewPanel(n,r,h.title,c,h.panelOptions,M);await P.deserializeWebviewPanel(p,h.state)}createNewWebviewPanel(n,r,h,c,w,P){const L=new S(n,this._proxy,r,h,c,w,P);return this._webviewPanels.set(n,L),L}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=o;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[258],Ee([1,0,3,6,68,5,7]),function(J,e,f,t,I,T,D){"use strict";var k,y,A,N,R,b,C,g,u,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends t.Disposable{constructor(d,m,a,S,o,i){super();k.set(this,void 0),y.set(this,void 0),A.set(this,void 0),N.set(this,void 0),R.set(this,!1),b.set(this,void 0),C.set(this,void 0),g.set(this,void 0),u.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Le(this,u,"f").event,v.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,v,"f").event,Ye(this,A,a,"f"),Ye(this,C,S,"f"),Ye(this,k,d,"f"),Ye(this,y,m,"f"),Ye(this,N,o,"f"),Ye(this,b,i,"f")}dispose(){Le(this,R,"f")||(Ye(this,R,!0,"f"),Le(this,v,"f").fire(),Le(this,N,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,C,"f")}set title(d){this.assertNotDisposed(),Le(this,C,"f")!==d&&(Ye(this,C,d,"f"),Le(this,y,"f").$setWebviewViewTitle(Le(this,k,"f"),d))}get description(){return this.assertNotDisposed(),Le(this,g,"f")}set description(d){this.assertNotDisposed(),Le(this,g,"f")!==d&&(Ye(this,g,d,"f"),Le(this,y,"f").$setWebviewViewDescription(Le(this,k,"f"),d))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,N,"f")}get viewType(){return Le(this,A,"f")}_setVisible(d){d===Le(this,b,"f")||Le(this,R,"f")||(Ye(this,b,d,"f"),Le(this,u,"f").fire())}show(d){this.assertNotDisposed(),Le(this,y,"f").$show(Le(this,k,"f"),!!d)}assertNotDisposed(){if(Le(this,R,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,y=new WeakMap,A=new WeakMap,N=new WeakMap,R=new WeakMap,b=new WeakMap,C=new WeakMap,g=new WeakMap,u=new WeakMap,v=new WeakMap;class E{constructor(d,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,m,a,S){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:a,extension:d}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(d),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(d,m,a,S,o){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:n}=i,r=this._extHostWebview.createNewWebview(d,{},n),h=new _(d,this._proxy,m,a,r,!0);this._webviewViews.set(d,h),await s.resolveWebviewView(h,{state:S},o)}async $onDidChangeWebviewViewVisibility(d,m){this.getWebviewView(d)._setVisible(m)}async $disposeWebviewView(d){const m=this.getWebviewView(d);this._webviewViews.delete(d),m.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const m=this._webviewViews.get(d);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=E}),define(be[137],Ee([1,0,3,5,2,10,8,4,17]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Xi{constructor(R){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Xi.InitialState,this._proxy=R.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(R){R!==this._state.focused&&(this._state={...this._state,focused:R},this._onDidChangeWindowState.fire(this._state))}openUri(R,b){let C;if(typeof R=="string"){C=R;try{R=I.URI.parse(R)}catch{return Promise.reject(`Invalid uri - '${R}'`)}}return(0,D.isFalsyOrWhitespace)(R.scheme)?Promise.reject("Invalid scheme - cannot be empty"):R.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${R.scheme}'`):this._proxy.$openUri(R,C,b)}async asExternalUri(R,b){if((0,D.isFalsyOrWhitespace)(R.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this._proxy.$asExternalUri(R,b);return I.URI.from(C)}};A.InitialState={focused:!0},A=$e([Be(0,y.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(be[259],Ee([1,0,9,60,32,40,6,5,2,17]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let N=class extends D.Disposable{constructor(b,C){super();const g=b.getProxy(k.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async u=>{const v=y.URI.file((0,f.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await g.$download(u,v),v})}};N=$e([Be(0,A.IExtHostRpcService),Be(1,T.IExtHostCommands)],N),e.ExtHostDownloadService=N}),define(be[260],Ee([1,0,135,10,190,32]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends f.ExtHostLoggerService{doCreateLogger(y,A,N){return y.scheme===t.Schemas.file?new I.SpdLogLogger(N?.name||(0,T.generateUuid)(),y.fsPath,!N?.donotRotate,!!N?.donotUseFormatters,A):super.doCreateLogger(y,A,N)}}e.ExtHostLoggerService=D}),define(be[261],Ee([1,0,59,9,2,67,6,10,15,29]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class N extends T.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const S=await super._getWorkspaceStorageURI(a);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const o=S.fsPath;let i=0;do{let s;i===0?s=o:s=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await R(s);const n=t.join(s,"vscode.lock"),r=await u(this._logService,n,!1);if(r)return this._workspaceStorageLock=r,process.on("exit",()=>{r.dispose()}),I.URI.file(s);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=N;async function R(m){try{await A.Promises.stat(m);return}catch{}try{await A.Promises.mkdir(m,{recursive:!0})}catch{}}const b=1e3,C=10*60*1e3;class g extends D.Disposable{constructor(a,S){super();this.logService=a,this.filename=S,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await v(a,S);(!o||o.pid!==process.pid)&&(a.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await A.Promises.utimes(S,new Date,new Date)}catch(i){a.error(i),a.info(`Lock '${S}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+a};await A.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function u(m,a,S){try{const i={pid:process.pid,willReleaseAt:0};await A.Promises.writeFile(a,JSON.stringify(i),{flag:"wx"})}catch(i){m.error(i)}const o=await v(m,a);return!o||o.pid!==process.pid?S?(m.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),l(m,a)):(m.info(`Lock '${a}': Lock acquired.`),new g(m,a))}async function v(m,a){let S;try{S=await A.Promises.readFile(a)}catch(o){return m.error(o),null}try{return JSON.parse(String(S))}catch(o){return m.error(o),null}}async function _(m,a){let S;try{S=await A.Promises.stat(a)}catch(o){return m.error(o),0}return S.mtime.getTime()}function E(m){try{return process.kill(m,0),!0}catch{return!1}}async function l(m,a){const S=await v(m,a);if(!S)return m.info(`Lock '${a}': Could not read pid of lock holder.`),d(m,a);if(S.willReleaseAt){let r=S.willReleaseAt-Date.now();if(r<5e3){for(r>0?m.info(`Lock '${a}': The lockfile is scheduled to be released in ${r} ms.`):m.info(`Lock '${a}': The lockfile is scheduled to have been released.`);r>0;){if(await(0,y.timeout)(Math.min(100,r)),await _(m,a)===0)return d(m,a);r=S.willReleaseAt-Date.now()}return d(m,a)}}if(!E(S.pid))return m.info(`Lock '${a}': The pid ${S.pid} appears to be gone.`),d(m,a);const o=await _(m,a),i=Date.now()-o;if(i<=C)return m.info(`Lock '${a}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;m.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const s=await _(m,a),n=Date.now()-s;return n<=C?(m.info(`Lock '${a}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(m.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),d(m,a))}async function d(m,a){m.info(`Lock '${a}': Deleting a stale lock.`);try{await A.Promises.unlink(a)}catch{}return u(m,a,!0)}}),define(be[262],Ee([1,0,32,17,33]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,y,A){return this.createTerminalFromOptions({name:k,shellPath:y,shellArgs:A})}createTerminalFromOptions(k,y){const A=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),k,k.name);return this._terminals.push(A),A.create(k,this._serializeParentTerminal(k,y)),A.value}};T=$e([Be(0,t.IExtHostRpcService)],T),e.ExtHostTerminalService=T}),define(be[263],Ee([1,0,5,17,175,6,26,2,39,23,29,7,13,51,3,123,92,11]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(h,c,w){this.remoteAddress=h,this.localAddress=c,this._dispose=w,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function l(r){const h=r.trim().split(`
`),c=[];return h.forEach(P=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(P);L&&L.length>=3&&c.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),c.reduce((P,L)=>(P[L.socket]=L,P),{})}e.getSockets=l;function d(...r){const h=[].concat(...r.map(a));return[...new Map(h.filter(c=>c.st==="0A").map(c=>{const w=c.local_address.split(":");return{socket:parseInt(c.inode,10),ip:m(w[0]),port:parseInt(w[1],16)}}).map(c=>[c.ip+":"+c.port,c])).values()]}e.loadListeningPorts=d;function m(r){let h="";if(r.length===8)for(let c=r.length-2;c>=0;c-=2)h+=parseInt(r.substr(c,2),16),c!==0&&(h+=".");else for(let c=r.length-4;c>=0;c-=4)h+=parseInt(r.substr(c,4),16).toString(16),c!==0&&(h+=":");return h}e.parseIpAddress=m;function a(r){const h=r.trim().split(`
`),c=h.shift().trim().split(/\s+/).filter(P=>P!=="rx_queue"&&P!=="tm->when");return h.map(P=>P.trim().split(/\s+/).reduce((L,M,p)=>(L[c[p]||p]=M,L),{}))}e.loadConnectionTable=a;function S(r){return!!r.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||r.indexOf("out/server-main.js")!==-1||r.indexOf("_productName=VSCode")!==-1}function o(r){const h=r.trim().split(`
`),c=[];return h.forEach(w=>{const P=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);P&&P.length>=4&&c.push({pid:parseInt(P[1],10),ppid:parseInt(P[2]),cmd:P[3]})}),c}e.getRootProcesses=o;async function i(r,h,c){const w=c.reduce((L,M)=>(L[M.pid]=M,L),{}),P=[];return r.forEach(({socket:L,ip:M,port:p})=>{const U=h[L]?h[L].pid:void 0,B=U?w[U]?.cmd:void 0;U&&B&&!S(B)&&P.push({host:M,port:p,detail:B,pid:U})}),P}e.findPorts=i;function s(r,h,c){const w=new Map,P=o(h);for(const L of r){const M=c.get(L.port);if(M){w.set(L.port,M);continue}const p=P.find(U=>U.cmd.includes(`${L.port}`));if(p){let U=p,B;do B=P.find(H=>H.ppid===U.pid),B&&(U=B);while(B);w.set(L.port,{host:L.ip,port:L.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else w.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=s;let n=class extends T.Disposable{constructor(h,c,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(f.MainContext.MainThreadTunnelService),b.isLinux&&c.remote.isRemote&&c.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,c){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(c,h.displayName);if(w){const P=new E(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(P),P}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,c){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:h,provider:c}),this._proxy.$registerPortsAttributesProvider(h,w),new R.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(h,c,w,P,L){const M=[];for(const U of h){const B=this._portAttributesProviders.get(U);if(!B)return[];M.push(...await Promise.all(c.map(async H=>B.provider.providePortAttributes(H,w,P,L))))}const p=M.filter(U=>!!U);return p.length>0?p.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let c=new v.MovingAverage,w;for(;this._candidateFindingEnabled;){const P=new Date().getTime(),L=(await this.findCandidatePorts()).filter(p=>(0,u.isLocalhost)(p.host)||(0,u.isAllInterfaces)(p.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(p=>p.port).join(", ")}`);const M=new Date().getTime()-P;c.update(M),(!w||JSON.stringify(w)!==JSON.stringify(L))&&(w=L,await this._proxy.$onFoundNewCandidates(w)),await new Promise(p=>setTimeout(()=>p(),this.calculateDelay(c.value)))}}async setTunnelFactory(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let c=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const w=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:c}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,c){if(this._extensionTunnels.has(h.host)){const w=this._extensionTunnels.get(h.host);w.has(h.port)&&(c&&w.get(h.port).disposeListener.dispose(),await w.get(h.port).tunnel.dispose(),w.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,c){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(h,c);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const P=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const L=this._register(P.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(P.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:P,disposeListener:L}),C.TunnelDtoConverter.fromApiTunnel(P)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const c=await Promise.all(h.map(P=>this._showCandidatePort(P.host,P.port,P.detail??""))),w=h.filter((P,L)=>c[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(P=>P.port).join(", ")} to ${w.map(P=>P.port).join(", ")}`),w}async findCandidatePorts(){let h="",c="";try{h=await N.Promises.readFile("/proc/net/tcp","utf8"),c=await N.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=d(h,c),P=await new Promise(W=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,q,G)=>{W(q)})}),L=l(P),M=await N.Promises.readdir("/proc"),p=[];for(let W of M)try{const F=Number(W),q=A.joinPath(k.URI.file("/proc"),W);if((await N.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(F)){const $=await N.Promises.readlink(A.joinPath(q,"cwd").fsPath),X=await N.Promises.readFile(A.joinPath(q,"cmdline").fsPath,"utf8");p.push({pid:F,cwd:$,cmd:X})}}catch{}const U=[],B=w.filter(W=>{const F=L[W.socket];return F||U.push(W),F}),H=i(B,L,p);let re;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const W=await new Promise(F=>{(0,y.exec)("ps -F -A -l | grep root",(q,G,$)=>{F(G)})});this._foundRootPorts=s(U,W,this._foundRootPorts),re=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${re.join(", ")}`)}return H.then(W=>re?W.concat(re):W)}};n=$e([Be(0,t.IExtHostRpcService),Be(1,D.IExtHostInitDataService),Be(2,_.ILogService)],n),e.ExtHostTunnelService=n}),define(be[264],Ee([1,0,15,22,21,12,3,6,102,227,52]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function b(w,P){try{return JSON.stringify(w,P)}catch{return"null"}}const C="$$ref$$",g={[C]:-1};class u{constructor(P,L){this.jsonString=P,this.referencedBuffers=L}}function v(w,P=null,L=!1){const M=[];return{jsonString:(L?b:JSON.stringify)(w,(U,B)=>{if(typeof B=="undefined")return g;if(typeof B=="object"){if(B instanceof t.VSBuffer){const H=M.push(B)-1;return{[C]:H}}if(P)return P(U,B)}return B}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=v;function _(w,P,L){return JSON.parse(w,(M,p)=>{if(p){const U=p[C];if(typeof U=="number")return P[U];if(L&&p.$mid===1)return L.transformIncoming(p)}return p})}e.parseJsonAndRestoreBufferRefs=_;function E(w,P){return JSON.stringify(w,P)}function l(w){return w?(P,L)=>L&&L.$mid===1?w.transformOutgoing(L):L:null}var d;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},S=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(P,L=null,M=null){super();this[R]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=L,this._uriTransformer=M,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let p=0,U=N.ProxyIdentifier.count;p<U;p++)this._locals[p]=null,this._proxies[p]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(p=>this._receiveOneMessage(p))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:L,sid:M}=P;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,M)),this._proxies[L]}_createProxy(P,L){let M={get:(p,U)=>(typeof U=="string"&&!p[U]&&U.charCodeAt(0)===36&&(p[U]=(...B)=>this._remoteCall(P,U,B)),U===o?L:p[U])};return new Proxy(Object.create(null),M)}set(P,L){return this._locals[P.nid]=L,L}assertRegistered(P){for(let L=0,M=P.length;L<M;L++){const p=P[L];if(!this._locals[p.nid])throw new Error(`Missing proxy instance ${p.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const L=P.byteLength,M=s.read(P,0),p=M.readUInt8(),U=M.readUInt32();switch(p){case 1:case 2:{let{rpcId:B,method:H,args:re}=r.deserializeRequestJSONArgs(M);this._uriTransformer&&(re=(0,y.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(L,U,B,H,re,p===2);break}case 3:case 4:{let{rpcId:B,method:H,args:re}=r.deserializeRequestMixedArgs(M);this._uriTransformer&&(re=(0,y.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(L,U,B,H,re,p===4);break}case 5:{this._logger&&this._logger.logIncoming(L,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(L,U);break}case 7:{this._receiveReply(L,U,void 0);break}case 9:{let B=r.deserializeReplyOKJSON(M);this._uriTransformer&&(B=(0,y.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(L,U,B);break}case 10:{const B=r.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(L,U,B);break}case 8:{let B=r.deserializeReplyOKVSBuffer(M);this._receiveReply(L,U,B);break}case 11:{let B=r.deserializeReplyErrError(M);this._uriTransformer&&(B=(0,y.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(L,U,B);break}case 12:{this._receiveReplyErr(L,U,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,L,M,p,U,B){this._logger&&this._logger.logIncoming(P,L,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(M)}.${p}(`,U);const H=String(L);let re,W;if(B){const q=new I.CancellationTokenSource;U.push(q.token),re=this._invokeHandler(M,p,U),W=()=>q.cancel()}else re=this._invokeHandler(M,p,U),W=a;this._cancelInvokedHandlers[H]=W;const F=r.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(F.byteLength,L,1,"ack"),this._protocol.send(F),re.then(q=>{delete this._cancelInvokedHandlers[H];const G=r.serializeReplyOK(L,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,L,1,"reply:",q),this._protocol.send(G)},q=>{delete this._cancelInvokedHandlers[H];const G=r.serializeReplyErr(L,q);this._logger&&this._logger.logOutgoing(G.byteLength,L,1,"replyErr:",q),this._protocol.send(G)})}_receiveCancel(P,L){this._logger&&this._logger.logIncoming(P,L,1,"receiveCancel");const M=String(L);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(P,L,M){this._logger&&this._logger.logIncoming(P,L,0,"receiveReply:",M);const p=String(L);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const U=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p],U.resolveOk(M)}_receiveReplyErr(P,L,M){this._logger&&this._logger.logIncoming(P,L,0,"receiveReplyErr:",M);const p=String(L);if(!this._pendingRPCReplies.hasOwnProperty(p))return;const U=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p];let B;M&&(M.$isError?(B=new Error,B.name=M.name,B.message=M.message,B.stack=M.stack):B=M),U.resolveErr(B)}_invokeHandler(P,L,M){try{return Promise.resolve(this._doInvokeHandler(P,L,M))}catch(p){return Promise.reject(p)}}_doInvokeHandler(P,L,M){const p=this._locals[P];if(!p)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(P));let U=p[L];if(typeof U!="function")throw new Error("Unknown method "+L+" on actor "+(0,N.getStringIdentifierForProxy)(P));return U.apply(p,M)}_remoteCall(P,L,M){if(this._isDisposed)return Promise.reject(T.canceled());let p=null;if(M.length>0&&I.CancellationToken.isCancellationToken(M[M.length-1])&&(p=M.pop()),p&&p.isCancellationRequested)return Promise.reject(T.canceled());const U=r.serializeRequestArguments(M,this._uriReplacer),B=++this._lastMessageId,H=String(B),re=new A.LazyPromise;p&&p.onCancellationRequested(()=>{const F=r.serializeCancel(B);this._logger&&this._logger.logOutgoing(F.byteLength,B,0,"cancel"),this._protocol.send(r.serializeCancel(B))}),this._pendingRPCReplies[H]=re,this._onWillSendRequest(B);const W=r.serializeRequest(B,P,L,U,!!p);return this._logger&&this._logger.logOutgoing(W.byteLength,B,0,`request: ${(0,N.getStringIdentifierForProxy)(P)}.${L}(`,M),this._protocol.send(W),re}}e.RPCProtocol=i,R=S,i.UNRESPONSIVE_TIME=3*1e3;class s{constructor(P,L){this._buff=P,this._offset=L}static alloc(P,L,M){let p=new s(t.VSBuffer.alloc(M+1+4),0);return p.writeUInt8(P),p.writeUInt32(L),p}static read(P,L){return new s(P,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,M}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,M}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,L}static sizeMixedArray(P){let L=0;L+=1;for(let M=0,p=P.length;M<p;M++){const U=P[M];switch(L+=1,U.type){case 1:L+=this.sizeLongString(U.value);break;case 2:L+=this.sizeVSBuffer(U.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(U.value);for(let B=0;B<U.buffers.length;++B)L+=this.sizeVSBuffer(U.buffers[B]);break;case 4:break}}return L}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let L=0,M=P.length;L<M;L++){const p=P[L];switch(p.type){case 1:this.writeUInt8(1),this.writeLongString(p.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p.value);break;case 3:this.writeUInt8(3),this.writeUInt32(p.buffers.length),this.writeLongString(p.value);for(let U=0;U<p.buffers.length;++U)this.writeBuffer(p.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(P);for(let M=0;M<P;M++)switch(this.readUInt8()){case 1:L[M]=this.readLongString();break;case 2:L[M]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),B=this.readLongString(),H=[];for(let re=0;re<U;++re)H.push(this.readVSBuffer());L[M]=new N.SerializableObjectWithBuffers(_(B,H,null));break}case 4:L[M]=void 0;break}return L}}s.sizeUInt32=4;var n;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(n||(n={}));class r{static _useMixedArgSerialization(P){for(let L=0,M=P.length;L<M;L++)if(P[L]instanceof t.VSBuffer||P[L]instanceof N.SerializableObjectWithBuffers||typeof P[L]=="undefined")return!0;return!1}static serializeRequestArguments(P,L){if(this._useMixedArgSerialization(P)){const M=[];for(let p=0,U=P.length;p<U;p++){const B=P[p];if(B instanceof t.VSBuffer)M[p]={type:2,value:B};else if(typeof B=="undefined")M[p]={type:4};else if(B instanceof N.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:re}=v(B.value,L);M[p]={type:3,value:t.VSBuffer.fromString(H),buffers:re}}else M[p]={type:1,value:t.VSBuffer.fromString(E(B,L))}}return{type:1,args:M}}return{type:0,args:E(P,L)}}static serializeRequest(P,L,M,p,U){switch(p.type){case 0:return this._requestJSONArgs(P,L,M,p.args,U);case 1:return this._requestMixedArgs(P,L,M,p.args,U)}}static _requestJSONArgs(P,L,M,p,U){const B=t.VSBuffer.fromString(M),H=t.VSBuffer.fromString(p);let re=0;re+=s.sizeUInt8(),re+=s.sizeShortString(B),re+=s.sizeLongString(H);let W=s.alloc(U?2:1,P,re);return W.writeUInt8(L),W.writeShortString(B),W.writeLongString(H),W.buffer}static deserializeRequestJSONArgs(P){const L=P.readUInt8(),M=P.readShortString(),p=P.readLongString();return{rpcId:L,method:M,args:JSON.parse(p)}}static _requestMixedArgs(P,L,M,p,U){const B=t.VSBuffer.fromString(M);let H=0;H+=s.sizeUInt8(),H+=s.sizeShortString(B),H+=s.sizeMixedArray(p);let re=s.alloc(U?4:3,P,H);return re.writeUInt8(L),re.writeShortString(B),re.writeMixedArray(p),re.buffer}static deserializeRequestMixedArgs(P){const L=P.readUInt8(),M=P.readShortString(),p=P.readMixedArray(),U=new Array(p.length);for(let B=0,H=p.length;B<H;B++){const re=p[B];typeof re=="string"?U[B]=JSON.parse(re):U[B]=re}return{rpcId:L,method:M,args:U}}static serializeAcknowledged(P){return s.alloc(5,P,0).buffer}static serializeCancel(P){return s.alloc(6,P,0).buffer}static serializeReplyOK(P,L,M){if(typeof L=="undefined")return this._serializeReplyOKEmpty(P);if(L instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(P,L);if(L instanceof N.SerializableObjectWithBuffers){const{jsonString:p,referencedBuffers:U}=v(L.value,M,!0);return this._serializeReplyOKJSONWithBuffers(P,p,U)}else return this._serializeReplyOKJSON(P,b(L,M))}static _serializeReplyOKEmpty(P){return s.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,L){let M=0;M+=s.sizeVSBuffer(L);let p=s.alloc(8,P,M);return p.writeVSBuffer(L),p.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,L){const M=t.VSBuffer.fromString(L);let p=0;p+=s.sizeLongString(M);let U=s.alloc(9,P,p);return U.writeLongString(M),U.buffer}static _serializeReplyOKJSONWithBuffers(P,L,M){const p=t.VSBuffer.fromString(L);let U=0;U+=s.sizeUInt32,U+=s.sizeLongString(p);for(const H of M)U+=s.sizeVSBuffer(H);let B=s.alloc(10,P,U);B.writeUInt32(M.length),B.writeLongString(p);for(const H of M)B.writeBuffer(H);return B.buffer}static deserializeReplyOKJSON(P){const L=P.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(P,L){const M=P.readUInt32(),p=P.readLongString(),U=[];for(let B=0;B<M;++B)U.push(P.readVSBuffer());return new N.SerializableObjectWithBuffers(_(p,U,L))}static serializeReplyErr(P,L){const M=L?b(T.transformErrorForSerialization(L),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(P);const p=t.VSBuffer.fromString(M);let U=0;U+=s.sizeLongString(p);let B=s.alloc(11,P,U);return B.writeLongString(p),B.buffer}static deserializeReplyErrError(P){const L=P.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(P){return s.alloc(12,P,0).buffer}}var h;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var c;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(c||(c={}))}),define(be[265],Ee([1,0,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(be[266],Ee([1,0,30,10,9,13,23,2,4,199,43,223,265]),function(J,e,f,t,I,T,D,k,y,A,N,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let C=class Qi{constructor(u,v,_,E){this.localUserHome=u,this.remoteAgentService=v,this.environmentService=_,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const l=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=l?.userHome||u})()}hasValidBasename(u,v,_){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(E=>this.doHasValidBasename(u,E,v)):this.doHasValidBasename(u,v,_)}doHasValidBasename(u,v,_){return u.scheme===t.Schemas.file||u.scheme===t.Schemas.vscodeRemote?(0,f.isValidBasename)(_??(0,D.basename)(u),v===1):!0}get defaultUriScheme(){return Qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,v){if(u.remoteAuthority)return t.Schemas.vscodeRemote;const _=(0,A.getVirtualWorkspaceScheme)(v.getWorkspace());if(_)return _;const E=v.getWorkspace().folders[0];if(E)return E.uri.scheme;const l=v.getWorkspace().configuration;return l?l.scheme:t.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?I.win32:I.posix)}async fileURI(u){let v="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const E=u.indexOf("/",2);E===-1?(v=u.substring(2),u="/"):(v=u.substring(2,E),u=u.substring(E)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:v,path:u,query:"",fragment:""})}};C=$e([Be(1,b.IRemoteAgentService),Be(2,R.IWorkbenchEnvironmentService),Be(3,N.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(be[69],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(D,k){this.line=D,this.character=k}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,k){return new f(0,0)}with(D){return new f(0,0)}}e.Position=f;class t{constructor(D,k,y,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(D,k),this.end=new f(y,A)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[31],Ee([1,0,18,34,25,30,8,4,9,12,69,15]),function(J,e,f,t,I,T,D,k,y,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const b="\u27EA ",C=" characters skipped \u27EB",g=(b.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var u;(function($){$[$.file=0]="file",$[$.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var v;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function _($){return!!$.preview}e.resultIsMatch=_;function E($){return!!$.resource}e.isFileMatch=E;function l($){return!!$.message}e.isProgressMessage=l;var d;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(X){this.resource=X,this.results=[]}}e.FileMatch=m;class a{constructor(X,ie,ae){this.ranges=ie;const le=Array.isArray(ie)?ie:[ie];if(ae&&ae.matchLines===1&&S(le)){X=(0,D.getNLines)(X,ae.matchLines);let se="",ee=0,fe=0;const ge=Math.floor(ae.charsPerLine/5),ye=[];for(const Ne of le){const Se=Math.max(Ne.startColumn-ge,0),_e=Ne.startColumn+ae.charsPerLine;if(Se>fe+ge+g){const Ie=b+(Se-fe)+C;se+=Ie+X.slice(Se,_e),ee+=Se-(fe+Ie.length)}else se+=X.slice(fe,_e);ye.push(new i(0,Ne.startColumn-ee,Ne.endColumn-ee)),fe=_e}this.preview={text:se,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const se=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:X,matches:(0,f.mapArrayOrNot)(ie,ee=>new o(ee.startLineNumber-se,ee.startColumn,ee.endLineNumber-se,ee.endColumn))}}}}e.TextSearchMatch=a;function S($){const X=$[0].startLineNumber;for(const ie of $)if(ie.startLineNumber!==X||ie.endLineNumber!==X)return!1;return!0}class o{constructor(X,ie,ae,le){this.startLineNumber=X,this.startColumn=ie,this.endLineNumber=ae,this.endColumn=le}}e.SearchRange=o;class i extends o{constructor(X,ie,ae){super(X,ie,X,ae)}}e.OneLineRange=i;var s;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function n($,X=!0){const ie=$&&$.files&&$.files.exclude,ae=X&&$&&$.search&&$.search.exclude;if(!ie&&!ae)return;if(!ie||!ae)return ie||ae;let le=Object.create(null);return le=I.mixin(le,I.deepClone(ie)),le=I.mixin(le,I.deepClone(ae),!0),le}e.getExcludes=n;function r($,X){return $.excludePattern&&t.match($.excludePattern,X)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&t.match($.includePattern,X)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(ie=>{const ae=ie.folder.fsPath;if(T.isEqualOrParent(X,ae)){const le=y.relative(ae,X);return!ie.includePattern||!!t.match(ie.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var h;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class c extends Error{constructor(X,ie){super(X);this.code=ie}}e.SearchError=c;function w($){const X=$.message;if((0,A.isCancellationError)($))return new c(X,h.canceled);try{const ie=JSON.parse(X);return new c(ie.message,ie.code)}catch{return new c(X,h.other)}}e.deserializeSearchError=w;function P($){const X={message:$.message,code:$.code};return new Error(JSON.stringify(X))}e.serializeSearchError=P;function L($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=L;function M($){return $.type==="success"}e.isSerializedSearchSuccess=M;function p($){return!!$.path}e.isSerializedFileMatch=p;function U($,X){const ie=$.searchPath?$.searchPath:$.relativePath;return(0,D.fuzzyContains)(ie,X)}e.isFilePatternMatch=U;class B{constructor(X){this.path=X,this.results=[]}addMatch(X){this.results.push(X)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function H($,X){const ie={...$||{},...X||{}};return Object.keys(ie).filter(ae=>{const le=ie[ae];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=H;class re{constructor(X,ie){this._parsedIncludeExpression=null,this._excludeExpression={...X.excludePattern||{},...ie.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let ae=X.includePattern;ie.includePattern&&(ae?ae={...ae,...ie.includePattern}:ae=ie.includePattern),ae&&(this._parsedIncludeExpression=t.parse(ae))}matchesExcludesSync(X,ie,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,ie,ae))}includedInQuerySync(X,ie,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,ie,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(X,ie,ae))}includedInQuery(X,ie,ae){const le=this._parsedExcludeExpression(X,ie,ae),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(X,ie,ae):!0;return(0,R.isThenable)(le)?le.then(ee=>ee?!1:se()):se()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=re;function W($){for(const X in $)if(typeof $[X]!="boolean")return!0;return!1}function F($){if(!$)return;let X;return ie=>(X||(X=($()||Promise.resolve([])).then(ae=>ae?G(ae):{})),X.then(ae=>!!ae[ie]))}e.hasSiblingPromiseFn=F;function q($){if(!$)return;let X;return ie=>{if(!X){const ae=$();X=ae?G(ae):{}}return!!X[ie]}}e.hasSiblingFn=q;function G($){const X={};for(const ie of $)X[ie]=!0;return X}}),define(be[36],Ee([1,0,18,15,21,3,24,10,92,23,8,14,2,173,4,11,191,43,44,26,17,16,7,31,5]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d,m,a,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,M,p){return new A.ExtUri(U=>h(U,p)).isEqual(L,M)}function s(L,M,p){return i(L.uri,M.uri,p)?0:(0,N.compare)(L.uri.toString(),M.uri.toString())}function n(L,M,p){return L.index!==M.index?L.index<M.index?-1:1:i(L.uri,M.uri,p)?(0,N.compare)(L.name,M.name):(0,N.compare)(L.uri.toString(),M.uri.toString())}function r(L,M,p,U){const B=L.slice(0).sort((re,W)=>p(re,W,U)),H=M.slice(0).sort((re,W)=>p(re,W,U));return(0,f.delta)(B,H,(re,W)=>p(re,W,U))}function h(L,M){const p=M.getCapabilities(L.scheme);return!(p&&p&1024)}class c extends _.Workspace{constructor(M,p,U,B,H,re,W){super(M,U.map(F=>new _.WorkspaceFolder(F)),B,H,W);this._name=p,this._isUntitled=re,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(W),U.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(M,p,U,B){if(!M)return{workspace:null,added:[],removed:[]};const{id:H,name:re,folders:W,configuration:F,transient:q,isUntitled:G}=M,$=[],X=p;p?W.forEach((se,ee)=>{const fe=b.URI.revive(se.uri),ge=c._findFolder(U||p,fe,B);ge?(ge.name=se.name,ge.index=se.index,$.push(ge)):$.push({uri:fe,name:se.name,index:ee})}):$.push(...W.map(({uri:se,name:ee,index:fe})=>({uri:b.URI.revive(se),name:ee,index:fe}))),$.sort((se,ee)=>se.index<ee.index?-1:1);const ie=new c(H,re,$,!!q,F?b.URI.revive(F):null,!!G,se=>h(se,B)),{added:ae,removed:le}=r(X?X.workspaceFolders:[],ie.workspaceFolders,s,B);return{workspace:ie,added:ae,removed:le}}static _findFolder(M,p,U){for(let B=0;B<M.folders.length;B++){const H=M.workspaceFolders[B];if(i(H.uri,p,U))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,p){return p&&this._structure.get(M)&&(M=(0,A.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let w=class{constructor(M,p,U,B){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=B,this._extHostFileSystemInfo=U,this._requestIdProvider=new y.Counter,this._barrier=new t.Barrier,this._proxy=M.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(o.MainContext.MainThreadMessageService);const H=p.workspace;this._confirmedWorkspace=H?new c(H.id,H.name,[],!!H.transient,H.configuration?b.URI.revive(H.configuration):null,!!H.isUntitled,re=>h(re,U)):void 0}$initializeWorkspace(M,p){this._trusted=p,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:k.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,p,U,...B){const H=[];if(Array.isArray(B)&&B.forEach(G=>{b.URI.isUri(G.uri)&&!H.some($=>i($.uri,G.uri,this._extHostFileSystemInfo))&&H.push({uri:G.uri,name:G.name||(0,A.basenameOrAuthority)(G.uri)})}),this._unconfirmedWorkspace||[p,U].some(G=>typeof G!="number"||G<0)||U===0&&H.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(p+U>re.length)return!1;const W=re.slice(0);W.splice(p,U,...H.map(G=>({uri:G.uri,name:G.name||(0,A.basenameOrAuthority)(G.uri),index:void 0})));for(let G=0;G<W.length;G++){const $=W[G];if(W.some((X,ie)=>ie!==G&&i($.uri,X.uri,this._extHostFileSystemInfo)))return!1}W.forEach((G,$)=>G.index=$);const{added:F,removed:q}=r(re,W,n,this._extHostFileSystemInfo);if(F.length===0&&q.length===0)return!1;if(this._proxy){const G=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(G,p,U,H).then(void 0,$=>{this._unconfirmedWorkspace=void 0;const X={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(v.Severity.Error,(0,C.localize)(0,null,G,$.toString()),X,[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(M,p){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,p)}async getWorkspaceFolder2(M,p){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,p)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,p){let U,B="";if(typeof M=="string"?(U=b.URI.file(M),B=M):typeof M!="undefined"&&(U=M,B=M.fsPath),!U)return B;const H=this.getWorkspaceFolder(U,!0);if(!H)return B;typeof p=="undefined"&&this._actualWorkspace&&(p=this._actualWorkspace.folders.length>1);let re=(0,A.relativePath)(H.uri,U);return p&&H.name&&(re=`${H.name}/${re}`),re}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=c.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:p,added:U,removed:B}=c.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=p||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:B}))}findFiles(M,p,U,B,H=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let re;if(p===null?re=!1:p&&(typeof p=="string"?re=p:re=p.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:F}=P(m.GlobPattern.from(M));return this._proxy.$startFileSearch((0,R.withUndefinedAsNull)(W),(0,R.withUndefinedAsNull)(F),(0,R.withUndefinedAsNull)(re),(0,R.withUndefinedAsNull)(U),H).then(q=>Array.isArray(q)?q.map(G=>b.URI.revive(G)):[])}async findTextInFiles(M,p,U,B,H=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),W=typeof p.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:p.previewOptions,{includePattern:F,folder:q}=P(m.GlobPattern.from(p.include)),G=typeof p.exclude=="string"?p.exclude:p.exclude?p.exclude.pattern:void 0,$={ignoreSymlinks:typeof p.followSymlinks=="boolean"?!p.followSymlinks:void 0,disregardIgnoreFiles:typeof p.useIgnoreFiles=="boolean"?!p.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof p.useGlobalIgnoreFiles=="boolean"?!p.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof p.useParentIgnoreFiles=="boolean"?!p.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof p.useDefaultExcludes=="boolean"?!p.useDefaultExcludes:!0,fileEncoding:p.encoding,maxResults:p.maxResults,previewOptions:W,afterContext:p.afterContext,beforeContext:p.beforeContext,includePattern:F,excludePattern:G},X=!1;if(this._activeSearchCallbacks[re]=ie=>{if(X)return;const ae=b.URI.revive(ie.resource);ie.results.forEach(le=>{(0,S.resultIsMatch)(le)?U({uri:ae,preview:{text:le.preview.text,matches:(0,f.mapArrayOrNot)(le.preview.matches,se=>new a.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,f.mapArrayOrNot)(le.ranges,se=>new a.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):U({uri:ae,text:le.text,lineNumber:le.lineNumber})})},H.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(M,(0,R.withUndefinedAsNull)(q),$,re,H);return delete this._activeSearchCallbacks[re],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[re],ie}}$handleTextSearchResult(M,p){this._activeSearchCallbacks[p]&&this._activeSearchCallbacks[p](M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=$e([Be(0,d.IExtHostRpcService),Be(1,l.IExtHostInitDataService),Be(2,E.IExtHostFileSystemInfo),Be(3,u.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function P(L){let M,p;return L&&(typeof L=="string"?M=L:(M=L.pattern,p=b.URI.revive(L.baseUri))),{includePattern:M,folder:p}}}),define(be[37],Ee([1,0,25,3,36,5,7,194,120,14,15,4,17,11,2]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(S,o){if(o){const i=o.split(".");let s=S;for(let n=0;s&&n<i.length;n++)s=s[i[n]];return s}}function v(S){return S instanceof g.URI}function _(S){return S&&S.uri instanceof g.URI&&S.languageId&&typeof S.languageId=="string"}function E(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function l(S){return S&&S.uri instanceof g.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function d(S){if(v(S))return{resource:S};if(_(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(E(S))return{overrideIdentifier:S.languageId};if(l(S))return{resource:S.uri};if(S===null)return{resource:null}}let m=class{constructor(o,i,s){this._proxy=o.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new a(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,i))}};m=$e([Be(0,b.IExtHostRpcService),Be(1,I.IExtHostWorkspace),Be(2,C.ILogService)],m),e.ExtHostConfiguration=m;class a{constructor(o,i,s,n){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=n,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(o,i,s){const n=d(i)||{},r=this._toReadonlyValue(o?u(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,n,s?.identifier);function h(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const c={has(w){return typeof u(r,w)!="undefined"},get:(w,P)=>{this._validateConfigurationAccess(o?`${o}.${w}`:w,n,s?.identifier);let L=u(r,w);if(typeof L=="undefined")L=P;else{let M;const p=(U,B)=>{let H;const re=()=>{M=M||(0,f.deepClone)(r),H=H||u(M,B)};return(0,A.isObject)(U)?new Proxy(U,{get:(W,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return re(),()=>H;if(M)return H=H||u(M,B),H[F];const q=W[F];return typeof F=="string"?p(q,`${B}.${F}`):q},set:(W,F,q)=>(re(),H&&(H[F]=q),!0),deleteProperty:(W,F)=>(re(),H&&delete H[F],!0),defineProperty:(W,F,q)=>(re(),H&&Object.defineProperty(H,F,q),!0)}):U};L=p(L,w)}return L},update:(w,P,L,M)=>{w=o?`${o}.${w}`:w;const p=h(L);return P!==void 0?this._proxy.$updateConfigurationOption(p,w,P,n,M):this._proxy.$removeConfigurationOption(p,w,n,M)},inspect:w=>{w=o?`${o}.${w}`:w;const P=(0,f.deepClone)(this._configuration.inspect(w,n,this._extHostWorkspace.workspace));if(P)return{key:w,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof r=="object"&&(0,f.mixin)(c,r,!1),Object.freeze(c)}_toReadonlyValue(o){const i=s=>(0,A.isObject)(s)?new Proxy(s,{get:(n,r)=>i(n[r]),set:(n,r,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(n,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(n,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(o)}_validateConfigurationAccess(o,i,s){const n=y.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),r=s?`[${s.value}] `:"";if(n===4){typeof i?.resource=="undefined"&&this._logService.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){i?.resource&&this._logService.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const s=new k.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,r)=>s.affectsConfiguration(n,d(r))})}_toMap(o){return o.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,R.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[70],Ee([1,0,2,15,3,5,7,36,45,37,21,33,17,26,4,10,13,11,65,215,12]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(B){function H(W){if(W!=null)return W}B.from=H;function re(W){if(W!=null)return W}B.to=re})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(B){function H(W){if(W!=null)return W}B.from=H;function re(W){if(W!=null)return W}B.to=re})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(B){function H(W){if(W!=null)return W}B.from=H;function re(W){if(W!=null)return W}B.to=re})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(B){function H(F){if(F){const q=F;return q&&!!q.process}else return!1}B.is=H;function re(F){if(F==null)return;const q={process:F.process,args:F.args};return F.options&&(q.options=o.from(F.options)),q}B.from=re;function W(F){if(F!=null)return new D.ProcessExecution(F.process,F.args,F.options)}B.to=W})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(B){function H(W){if(W!=null)return W}B.from=H;function re(W){if(W!=null)return W}B.to=re})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function(B){function H(F){if(F){const q=F;return q&&(!!q.commandLine||!!q.command)}else return!1}B.is=H;function re(F){if(F==null)return;const q={};return F.commandLine!==void 0?q.commandLine=F.commandLine:(q.command=F.command,q.args=F.args),F.options&&(q.options=s.from(F.options)),q}B.from=re;function W(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new D.ShellExecution(F.commandLine,F.options):new D.ShellExecution(F.command,F.args?F.args:[],F.options)}B.to=W})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var r;(function(B){function H(F){if(F){let q=F;return q&&q.customExecution==="customExecution"}else return!1}B.is=H;function re(F){return{customExecution:"customExecution"}}B.from=re;function W(F,q){return q.get(F)}B.to=W})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(B){function H(re,W){let F;return re.scope!==void 0&&typeof re.scope!="number"?F=re.scope.uri:re.scope!==void 0&&typeof re.scope=="number"&&(re.scope===D.TaskScope.Workspace&&W&&W.workspaceFile?F=W.workspaceFile:F=l.USER_TASKS_GROUP_KEY),{id:re._id,workspaceFolder:F}}B.from=H})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(B){function H(re){if(re!=null)return{_id:re.id,isDefault:re.isDefault}}B.from=H})(c=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(B){function H(F,q){if(F==null)return[];const G=[];for(let $ of F){const X=re($,q);X&&G.push(X)}return G}B.fromMany=H;function re(F,q){if(F==null)return;let G;F.execution instanceof D.ProcessExecution?G=i.from(F.execution):F.execution instanceof D.ShellExecution?G=n.from(F.execution):F.execution&&F.execution instanceof D.CustomExecution&&(G=r.from(F.execution));const $=a.from(F.definition);let X;return F.scope?typeof F.scope=="number"?X=F.scope:X=F.scope.uri:X=D.TaskScope.Workspace,!$||!X?void 0:{_id:F._id,definition:$,name:F.name,source:{extensionId:q.identifier.value,label:F.source,scope:X},execution:G,isBackground:F.isBackground,group:c.from(F.group),presentationOptions:S.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}B.from=re;async function W(F,q,G){if(F==null)return;let $;i.is(F.execution)?$=i.to(F.execution):n.is(F.execution)?$=n.to(F.execution):r.is(F.execution)&&($=r.to(F._id,G));const X=a.to(F.definition);let ie;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ie=F.source.scope:ie=await q.resolveWorkspaceFolder(f.URI.revive(F.source.scope)):ie=D.TaskScope.Workspace),!X||!ie)return;const ae=new D.Task(X,ie,F.name,F.source.label,$,F.problemMatchers);return F.isBackground!==void 0&&(ae.isBackground=F.isBackground),F.group!==void 0&&(ae.group=D.TaskGroup.from(F.group._id),ae.group&&F.group.isDefault&&(ae.group=new D.TaskGroup(ae.group.id,ae.group.label),F.group.isDefault&&(ae.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ae.presentationOptions=S.to(F.presentationOptions)),F._id&&(ae._id=F._id),F.detail&&(ae.detail=F.detail),ae}B.to=W})(w=e.TaskDTO||(e.TaskDTO={}));var P;(function(B){function H(W){return W}B.from=H;function re(W){if(!!W)return Object.assign(Object.create(null),W)}B.to=re})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(H,re,W){this._id=re,this._task=W,m.set(this,void 0),Ye(this,m,H,"f")}get task(){return this._task}terminate(){Le(this,m,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}m=new WeakMap;var M;(function(B){function H(re){return{id:re._id,task:void 0}}B.from=H})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let p=class{constructor(H,re,W,F,q,G,$,X){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=H.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=F,this._configurationService=q,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=X,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,re,W){if(!W)return new D.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:re,provider:W,extension:H}),this._proxy.$registerTaskProvider(F,re),new D.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(H,re){this._proxy.$registerTaskSystem(H,re)}fetchTasks(H){return this._proxy.$fetchTasks(P.from(H)).then(async re=>{const W=[];for(let F of re){const q=await w.to(F,this._workspaceProvider,this._providedCustomExecutions2);q&&W.push(q)}return W})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(re=>H.push(re)),H}terminateTask(H){if(!(H instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,re,W){const F=this._providedCustomExecutions2.get(H.id);F&&(this._activeCustomExecutions2.set(H.id,F),this._terminalService.attachPtyToTerminal(re,await F.callback(W))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const re=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:re})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const re=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:re,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const re=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:re,exitCode:H.exitCode})}$provideTasks(H,re){const W=this._handlers.get(H);if(!W)return Promise.reject(new Error("no handler found"));const F=[],q=(0,t.asPromise)(()=>W.provider.provideTasks(N.CancellationToken.None)).then(G=>this.provideTasksInternal(re,F,W,G));return new Promise(G=>{q.then($=>{Promise.all(F).then(()=>{G($)})})})}async $resolveTask(H,re){const W=this._handlers.get(H);if(!W)return Promise.reject(new Error("no handler found"));if(re.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${re.definition.type}] cannot be resolved by provider of type [${W.type}].`);const F=await w.to(re,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const q=await W.provider.resolveTask(F,N.CancellationToken.None);if(!q)return;this.checkDeprecation(q,W);const G=w.from(q,W.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(G.execution)&&await this.addCustomExecution(G,q,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,re,W){const F=await this._proxy.$createTaskId(H);!W&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,re.execution)),this._providedCustomExecutions2.set(F,re.execution)}async getTaskExecution(H,re){if(typeof H=="string"){const q=this._taskExecutionPromises.get(H);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let W=this._taskExecutionPromises.get(H.id);if(W)return W;const F=new Promise((q,G)=>{function $(X,ie,ae){ae?q(new L(X,ie.id,ae)):G("Unexpected: Task does not exist.")}re?$(this,H,re):w.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(X=>$(this,H,X))});return this._taskExecutionPromises.set(H.id,F),F.then(q=>(this._taskExecutions.set(H.id,q),q),q=>Promise.reject(q))}checkDeprecation(H,re){H._deprecated&&this._deprecationService.report("Task.constructor",re.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let W=this._notProvidedCustomExecutions.values(),F=W.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=W.next()}};p=$e([Be(0,b.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,A.IExtHostConfiguration),Be(5,R.IExtHostTerminalService),Be(6,_.ILogService),Be(7,E.IExtHostApiDeprecationService)],p),e.ExtHostTaskBase=p;let U=class extends p{constructor(H,re,W,F,q,G,$,X){super(H,re,W,F,q,G,$,X);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(H,re){if(!re.execution)throw new Error("Tasks to execute must include an execution");const W=w.from(re,H);if(W===void 0)throw new Error("Task is not valid");if(r.is(W.execution))await this.addCustomExecution(W,re,!1);else throw new d.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),re);return this._proxy.$executeTask(W).catch(q=>{throw new Error(q)}),F}provideTasksInternal(H,re,W,F){const q=[];if(F)for(let G of F){this.checkDeprecation(G,W),(!G.definition||!H[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const $=w.from(G,W.extension);$&&r.is($.execution)?(q.push($),re.push(this.addCustomExecution($,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:W.extension}}async resolveTaskInternal(H){if(r.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,re){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,re,W){}};U=$e([Be(0,b.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,A.IExtHostConfiguration),Be(5,R.IExtHostTerminalService),Be(6,_.ILogService),Be(7,E.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(be[267],Ee([1,0,9,21,49,34,23,46,31]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(b,C,g){this.config=b,this.provider=C,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=b.filePattern,this.includePattern=b.includePattern&&T.parse(b.includePattern),this.maxResults=b.maxResults||void 0,this.exists=b.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=b.excludePattern&&T.parse(b.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(b=>b.cancel()),this.activeCancellationTokens=new Set}search(b){const C=this.config.folderQueries||[];return new Promise((g,u)=>{const v=_=>{this.resultCount++,b(_)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(_=>{const E=_.toString(),l=f.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,l)||this.matchFile(v,{base:_,basename:l})}),Promise.all(C.map(_=>this.searchInFolder(_,v))).then(_=>{g({limitHit:this.isLimitHit,stats:_[0]||void 0})},_=>{u(new Error((0,I.toErrorMessage)(_)))})})}async searchInFolder(b,C){const g=new t.CancellationTokenSource,u=this.getSearchOptionsForFolder(b),v=this.initDirectoryTree(),_=new y.QueryGlobTester(this.config,b),E=!_.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(g),l=k.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,g.token),m=l.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(S=>{const o=f.posix.relative(b.folder.path,S.path);if(E){const i=f.basename(S.path);this.matchFile(C,{base:b.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(v,b.folder,o,C)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,_,C),{providerTime:m,postProcessTime:a.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(b){const C=(0,y.resolvePatternsForProvider)(this.config.includePattern,b.includePattern),g=(0,y.resolvePatternsForProvider)(this.config.excludePattern,b.excludePattern);return{folder:b.folder,excludes:g,includes:C,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}addDirectoryEntries({pathToEntries:b},C,g,u){if(g===this.filePattern){const _=f.basename(this.filePattern);this.matchFile(u,{base:C,relativePath:this.filePattern,basename:_})}function v(_){const E=f.basename(_),l=f.dirname(_);let d=b[l];d||(d=b[l]=[],v(l)),d.push({base:C,relativePath:_,basename:E})}v(g)}matchDirectoryTree({rootEntries:b,pathToEntries:C},g,u){const v=this,_=this.filePattern;function E(l){const d=(0,y.hasSiblingFn)(()=>l.map(m=>m.basename));for(let m=0,a=l.length;m<a;m++){const S=l[m],{relativePath:o,basename:i}=S;if(g.matchesExcludesSync(o,i,_!==i?d:void 0))continue;const s=C[o];if(s)E(s);else{if(o===_)continue;v.matchFile(u,S)}if(v.isLimitHit)break}}E(b)}matchFile(b,C){(!this.includePattern||C.relativePath&&this.includePattern(C.relativePath,C.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||b(C))}}class N{constructor(){this.sessions=new Map}fileSearch(b,C,g,u){const v=this.getSessionTokenSource(b.cacheKey),_=new A(b,C,v&&v.token);let E=0;const l=d=>{E+=d.length,g(d.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(_,N.BATCH_SIZE,l,u).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:d.stats}}))}clearCache(b){const C=this.getSessionTokenSource(b);C&&C.cancel()}getSessionTokenSource(b){if(!!b)return this.sessions.has(b)||this.sessions.set(b,new t.CancellationTokenSource),this.sessions.get(b)}rawMatchToSearchItem(b){return b.relativePath?{resource:D.joinPath(b.base,b.relativePath)}:{resource:b.base}}doSearch(b,C,g,u){u.onCancellationRequested(()=>{b.cancel()});const v=E=>{E&&(_.push(E),C>0&&_.length>=C&&(g(_),_=[]))};let _=[];return b.search(v).then(E=>(_.length&&g(_),E),E=>(_.length&&g(_),Promise.reject(E)))}}e.FileSearchManager=N,N.BATCH_SIZE=512}),define(be[268],Ee([1,0,18,74,34,101,24,10,9,23,8,14,2,153,182,80,11,43,130,266,31]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(c,w,P,L,M){this.configurationService=c,this.workspaceContextService=w,this.editorGroupsService=P,this.logService=L,this.pathService=M}text(c,w,P={}){c=this.getContentPattern(c,P);const L=this.configurationService.getValue(),M=w&&w.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(w?.map(_.toWorkspaceFolder),P),type:2,contentPattern:c,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:L.search.usePCRE2||M||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(c,w){const P=this.configurationService.getValue();c.isRegExp&&(c.pattern=c.pattern.replace(/\r?\n/g,"\\n"));const L={...c,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(c,w)&&(L.isCaseSensitive=!0),this.isMultiline(c)&&(L.isMultiline=!0),L}file(c,w={}){return{...this.commonQuery(c,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(c,w){return c?(c=Array.isArray(c)?c.map(s):s(c),w?this.parseSearchPaths(c):{pattern:S(...Array.isArray(c)?c:[c])}):{}}commonQuery(c=[],w={}){const P=this.handleIncludeExclude(w.includePattern,w.expandPatterns),L=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),M=c.length>1,p=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,w,L)):c.map(H=>this.getFolderQueryForRoot(H,w,L,M))).filter(H=>!!H),U={_reason:w._reason,folderQueries:p,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:L.pattern,includePattern:P.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const H=f.coalesce(f.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(q=>q.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(H));const re=H.filter(F=>(0,d.pathIncludedInQuery)(U,F.fsPath)),W=this.commonQueryFromFileList(re);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...U,...W}}const B=w.extraFileResources&&w.extraFileResources.filter(H=>(0,d.pathIncludedInQuery)(U,H.fsPath));return U.extraFileResources=B&&B.length?B:void 0,U}commonQueryFromFileList(c){const w=[],P=new D.ResourceMap,L={};let M=!1;return c.forEach(p=>{if(p.scheme===k.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(p)){const B=this.workspaceContextService.getWorkspaceFolder(p)?.uri??p.with({path:y.dirname(p.fsPath)});let H=P.get(B);H||(M=!0,H={folder:B,includePattern:{}},w.push(H),P.set(B,H));const re=y.relative(B.fsPath,p.fsPath);(0,R.assertIsDefined)(H.includePattern)[re.replace(/\\/g,"/")]=!0}else p.fsPath&&(M=!0,L[p.fsPath]=!0)}),{folderQueries:w,includePattern:L,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(c,w){if(w.isSmartCase){if(c.isRegExp){if(N.containsUppercaseCharacter(c.pattern,!0))return!0}else if(N.containsUppercaseCharacter(c.pattern))return!0}return!!c.isCaseSensitive}isMultiline(c){return c.isMultiline||c.isRegExp&&(0,C.isMultilineRegexSource)(c.pattern)||c.pattern.indexOf(`
`)>=0?!0:!!c.isMultiline}parseSearchPaths(c){const w=W=>y.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),L=(Array.isArray(c)?c:o(c)).map(W=>{const F=this.pathService.resolvedUserHome;return F?(0,T.untildify)(W,F.scheme===k.Schemas.file?F.fsPath:F.path):W}),M=t.groupBy(L,W=>w(W)?"searchPaths":"exprSegments"),p=(M.exprSegments||[]).map(W=>N.rtrim(W,"/")).map(W=>N.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),i(W))),U={},B=this.expandSearchPathPatterns(M.searchPaths||[]);B&&B.length&&(U.searchPaths=B);const H=f.flatten(p),re=S(...H);return re&&(U.pattern=re),U}getExcludesForFolder(c,w){return w.disregardExcludeSettings?void 0:(0,d.getExcludes)(c,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(c){if(!c||!c.length)return[];const w=f.flatten(c.map(L=>{let{pathPortion:M,globPortion:p}=a(L);p&&(p=n(p));const U=this.expandOneSearchPath(M);return f.flatten(U.map(B=>this.resolveOneSearchPathPattern(B,p)))})),P=new Map;return w.forEach(L=>{const M=L.searchPath.toString(),p=P.get(M);p?L.pattern&&(p.pattern=p.pattern||{},p.pattern[L.pattern]=!0):P.set(M,{searchPath:L.searchPath,pattern:L.pattern?S(L.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(c){if(y.isAbsolute(c)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==k.Schemas.file?[{searchPath:w[0].uri.with({path:c})}]:[{searchPath:b.URI.file(y.normalize(c))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(c=s(c),c.startsWith("../")||c===".."){const L=y.posix.resolve(w.path,c);return[{searchPath:w.with({path:L})}]}const P=n(c);return[{searchPath:w,pattern:P}]}else{if(c==="./"||c===".\\")return[];{const w=c.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(M=>{const p=w.match(new RegExp(`^${N.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return p?{match:p,folder:M}:null}).filter(R.isDefined);if(L.length)return L.map(M=>{const p=M.match[1];return{searchPath:M.folder.uri,pattern:p&&n(p)}});{const M=c.match(/\.[\/\\](.+)[\/\\]?/),p=M?M[1]:c,U=g.localize(0,null,p);throw new Error(U)}}}}resolveOneSearchPathPattern(c,w){const P=c.pattern&&w?`${c.pattern}/${w}`:c.pattern||w,L=[{searchPath:c.searchPath,pattern:P}];return P&&!P.endsWith("**")&&L.push({searchPath:c.searchPath,pattern:P+"/**"}),L}getFolderQueryForSearchPath(c,w,P){const L=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(c.searchPath),w,P,!1);return L?{...L,includePattern:c.pattern}:null}getFolderQueryForRoot(c,w,P,L){let M;const p=b.URI.isUri(c)?c:c.uri;if(P.searchPaths){const W=P.searchPaths.filter(F=>(0,A.isEqual)(F.searchPath,p))[0];if(W&&!W.pattern)return null;W&&(M=W.pattern)}const U=this.configurationService.getValue({resource:p}),H={...this.getExcludesForFolder(U,w)||{},...M||{}},re=b.URI.isUri(c)?(0,A.basename)(c):c.name;return{folder:p,folderName:L?re:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!U.search.followSymlinks}}};m=$e([Be(0,u.IConfigurationService),Be(1,_.IWorkspaceContextService),Be(2,E.IEditorGroupsService),Be(3,v.ILogService),Be(4,l.IPathService)],m),e.QueryBuilder=m;function a(h){const c=h.match(/[\*\{\}\(\)\[\]\?]/);if(c){const w=c.index,P=h.substr(0,w).match(/[/|\\][^/\\]*$/);if(P){let L=h.substr(0,P.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:h.substr((P.index||0)+1)}}}return{pathPortion:h}}function S(...h){return h.length?h.reduce((c,w)=>(c[w]=!0,c),Object.create(null)):void 0}function o(h){return I.splitGlobAware(h,",").map(c=>c.trim()).filter(c=>!!c.length)}function i(h){return[`**/${h}/**`,`**/${h}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function s(h){return h.replace(/\\/g,"/")}function n(h){return s(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(h,c){h=f.distinct(h,L=>L.toString());const w=[],P=c.getWorkspace();return h&&h.forEach(L=>{let M;if(c.getWorkbenchState()===2)M=(0,A.relativePath)(P.folders[0].uri,L),M&&M!=="."&&(M="./"+M);else{const p=c.getWorkspaceFolder(L);if(p){const U=p.name;if(P.folders.filter(H=>H.name===U).length===1){const H=(0,A.relativePath)(p.uri,L);H===""?M=`./${p.name}`:M=`./${p.name}/${H}`}else M=L.fsPath}}M&&w.push(M)}),w}e.resolveResourcesForSearchIncludes=r}),define(be[269],Ee([1,0,23,2,21,12,4,268,31,43]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function R(u,v){const _=v.activationEvents;if(!_)return Promise.resolve(void 0);const E=[],l=[];for(const i of _)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||u.forceUsingSearch?l.push(s):E.push(s)}if(E.length===0&&l.length===0)return Promise.resolve(void 0);let d;const m=new Promise((i,s)=>{d=i}),a=i=>d({activationEvent:i}),S=Promise.all(E.map(i=>b(u,i,a))).then(()=>{}),o=C(u,v.identifier,l,a);return Promise.all([S,o]).then(()=>{d(void 0)}),m}e.checkActivateWorkspaceContainsExtension=R;async function b(u,v,_){for(const E of u.folders)if(await u.exists(f.joinPath(t.URI.revive(E),v))){_(`workspaceContains:${v}`);return}}async function C(u,v,_,E){if(_.length===0)return Promise.resolve(void 0);const l=new I.CancellationTokenSource,d=u.checkExists(u.folders,_,l.token),m=setTimeout(async()=>{l.cancel(),u.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${_.join(",")}`)},N);let a=!1;try{a=await d}catch(S){T.isCancellationError(S)||T.onUnexpectedError(S)}l.dispose(),clearTimeout(m),a&&E(`workspaceContains:${_.join(",")}`)}function g(u,v,_,E){const l=u.get(D.IInstantiationService),d=u.get(y.ISearchService),a=l.createInstance(k.QueryBuilder).file(v.map(S=>(0,A.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:_,exists:!0});return d.fileSearch(a,E).then(S=>!!S.limitHit,S=>T.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=g});var Ye=this&&this.__classPrivateFieldSet||function(J,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},Le=this&&this.__classPrivateFieldGet||function(J,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(J):t?t.value:e.get(J)};define(be[41],Ee([1,0,168,9,71,23,15,6,24,2,11,5,37,225,88,36,27,224,12,28,22,200,7,121,4,26,67,17,81,51,33,3,269,87,202,10]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d,m,a,S,o,i,s,n,r,h,c,w,P,L,M,p){"use strict";var U,B,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let re=class Yi extends k.Disposable{constructor($,X,ie,ae,le,se,ee,fe,ge,ye){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=X,this._extHostContext=ie,this._initData=ee,this._extHostWorkspace=ae,this._extHostConfiguration=le,this._logService=se,this._extHostTunnelService=ge,this._extHostTerminalService=ye,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(R.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(R.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(R.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new _.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=$.createChild(new r.ServiceCollection([g.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(Se=>Ne.add(l.ExtensionIdentifier.toKey(Se))),this._activator=this._register(new C.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Se,_e,Ie)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Se,E.transformErrorForSerialization(_e),Ie)},actualActivateExtension:async(Se,_e)=>{if(Ne.has(l.ExtensionIdentifier.toKey(Se)))return await this._mainThreadExtensionsProxy.$activateExtension(Se,_e),new C.HostExtension;const Ie=this._registry.getExtensionDescription(Se);return this._activateExtension(Ie,_e)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){E.onUnexpectedError($)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let $=[];try{$=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch{}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,X){return this._activator.activateByEvent($,X)}_activateById($,X){return this._activator.activateById($,X)}activateByIdWithErrors($,X){return this._activateById($,X).then(()=>{const ie=this._activator.getActivatedExtension($);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}async _realPathExtensionUri($){if($.scheme!==p.Schemas.file)return $;const X=await this._hostUtils.realpath($.fsPath);return A.URI.file(X)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const $=y.TernarySearchTree.forUris(X=>T.extUriBiasedIgnorePathCase.ignorePathCasing(X));for(const X of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(X)){const ie=await this._realPathExtensionUri(X.extensionLocation);$.set(ie,X)}return $})()),this._extensionPathIndex}_deactivate($){let X=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return X;const ie=this._activator.getActivatedExtension($);if(!ie)return X;try{typeof ie.module.deactivate=="function"&&(X=Promise.resolve(ie.module.deactivate()).then(void 0,ae=>(this._logService.error(ae),Promise.resolve(void 0))))}catch(ae){this._logService.error(`An error occurred when deactivating the extension '${$.value}':`),this._logService.error(ae)}try{(0,k.dispose)(ie.subscriptions)}catch(ae){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${$.value}':`),this._logService.error(ae)}return X}async _activateExtension($,X){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,X).then(ie=>{const ae=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,X),this._logExtensionActivationTimes($,X,"success",ae),ie},ie=>{throw this._logExtensionActivationTimes($,X,"failure"),ie})}_logExtensionActivationTimes($,X,ie,ae){const le=W($,X);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...ae||{},outcome:ie})}_doActivateExtension($,X){const ie=W($,X);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const ae=this._getEntryPoint($);if(!ae)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${$.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this._logService.flush();const le=new C.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,T.joinPath)($.extensionLocation,ae),le),this._loadExtensionContext($)]).then(se=>(I.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),Yi._callActivate(this._logService,$.identifier,se[0],se[1],le))).then(se=>(I.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),se))}_loadExtensionContext($){const X=new m.ExtensionGlobalMemento($,this._storage),ie=new m.ExtensionMemento($.identifier.value,!1,this._storage),ae=new M.ExtensionSecrets($,this._secretState),le=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,se=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([X.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const ee=this;let fe,ge;const ye=(0,v.isProposedApiEnabled)($,"ipc")?this._initData.messagePorts?.get(l.ExtensionIdentifier.toKey($.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:ie,secrets:ae,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(Ne){return t.join($.extensionLocation.fsPath,Ne)},get storagePath(){return ee._storagePath.workspaceValue($)?.fsPath},get globalStoragePath(){return ee._storagePath.globalValue($).fsPath},get logPath(){return t.join(ee._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return A.URI.joinPath(ee._initData.logsLocation,$.identifier.value)},get storageUri(){return ee._storagePath.workspaceValue($)},get globalStorageUri(){return ee._storagePath.globalValue($)},get extensionMode(){return le},get extension(){return fe===void 0&&(fe=new F(ee,$.identifier,$,se)),fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)($,"extensionRuntime"),ee.extensionRuntime},get environmentVariableCollection(){return ee._extHostTerminalService.getEnvironmentVariableCollection($)},get messagePassingProtocol(){if(!ge){if(!ye)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(ye,"message",Se=>Se.data));ye.start(),ge={onDidReceiveMessage:Ne,postMessage:ye.postMessage.bind(ye)}}return ge}})})}static _callActivate($,X,ie,ae,le){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional($,X,ie,ae,le).then(se=>new C.ActivatedExtension(!1,null,le.build(),ie,se,ae.subscriptions))}static _callActivateOptional($,X,ie,ae,le){if(typeof ie.activate=="function")try{le.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${X.value}`);const se=typeof global=="object"?global:self,ee=ie.activate.apply(se,[ae]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ee).then(fe=>(le.activateResolveStop(),fe))}catch(se){return Promise.reject(se)}else return Promise.resolve(ie)}_activateOneStartupFinished($,X){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:X}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const X of $.activationEvents)X==="onStartupFinished"&&this._activateOneStartupFinished($,X)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._register(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const X=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(X),ae=Promise.all([$,ie]).then(()=>{});return Promise.race([ae,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ae}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(X=>this._handleWorkspaceContainsEagerExtension($,X))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,X){if(this.isActivated(X.identifier))return;const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ae={logService:this._logService,folders:$.map(se=>se.uri),forceUsingSearch:ie,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ee,fe)=>this._mainThreadWorkspaceProxy.$checkExists(se,ee,fe)},le=await(0,P.checkActivateWorkspaceContainsExtension)(ae,X);if(!!le)return this._activateById(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:le.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:X}=this._initData.environment;if(!$||!X)throw new Error(f.localize(0,null));const ie=await this._loadCommonJSModule(null,X,new C.ExtensionActivationTimesBuilder(!1));if(!ie||typeof ie.run!="function")throw new Error(f.localize(1,null,X.toString()));return new Promise((ae,le)=>{const se=(ge,ye)=>{ge?le(ge):ae(typeof ye=="number"&&ye>0?1:0)},ee=(0,T.originalFSPath)(X),fe=ie.run(ee,se);fe&&fe.then&&fe.then(()=>{ae(0)}).catch(ge=>{le(ge instanceof Error&&ge.stack?ge.stack:String(ge))})})}async $extensionTestsExit($){this._logService.info(`Extension host terminating: test runner requested exit with code ${$}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver($,X){return this._resolvers[$]=X,(0,k.toDisposable)(()=>{delete this._resolvers[$]})}async _activateAndGetResolver($){const X=$.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const ie=$.substr(0,X);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this._resolvers[ie]}}async $resolveAuthority($,X){this._logService.info(`$resolveAuthority invoked for authority (${q($)})`);const{authorityPrefix:ie,resolver:ae}=await this._activateAndGetResolver($);if(!ae)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ie}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ae)),I.mark(`code/extHost/willResolveAuthority/${ie}`);const le=await ae.resolve($,{resolveAttempt:X});I.mark(`code/extHost/didResolveAuthorityOK/${ie}`);const se={authority:$,host:le.host,port:le.port,connectionToken:le.connectionToken},ee={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted,authenticationSession:le.authenticationSessionForInitializingExtensions?{id:le.authenticationSessionForInitializingExtensions.id,providerId:le.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:ee,tunnelInformation:{environmentTunnels:le.environmentTunnels,features:le.tunnelFeatures}}}}catch(le){if(I.mark(`code/extHost/didResolveAuthorityError/${ie}`),le instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI($,X){this._logService.info(`$getCanonicalURI invoked for authority (${q($)})`);const{resolver:ie}=await this._activateAndGetResolver($);if(!ie)return null;const ae=A.URI.revive(X);if(typeof ie.getCanonicalURI=="undefined")return ae;const le=await(0,D.asPromise)(()=>ie.getCanonicalURI(ae));return le||ae}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,X){return X===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent($,!1))}async $activate($,X){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,X),!0):!1}async $deltaExtensions($,X){$.forEach(ae=>ae.extensionLocation=A.URI.revive(ae.extensionLocation));const ie=await this.getExtensionPathIndex();return await Promise.all(X.map(async ae=>{const le=this._registry.getExtensionDescription(ae);le&&ie.delete(await this._realPathExtensionUri(le.extensionLocation))})),await Promise.all($.map(async ae=>{const le=await this._realPathExtensionUri(ae.extensionLocation);ie.set(le,ae)})),this._registry.deltaExtensions($,X),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let X=d.VSBuffer.alloc($),ie=Math.random()%256;for(let ae=0;ae<$;ae++)X.writeUInt8(ie,ae);return X}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};re=$e([Be(0,o.IInstantiationService),Be(1,e.IHostUtils),Be(2,n.IExtHostRpcService),Be(3,u.IExtHostWorkspace),Be(4,b.IExtHostConfiguration),Be(5,N.ILogService),Be(6,i.IExtHostInitDataService),Be(7,s.IExtensionStoragePaths),Be(8,h.IExtHostTunnelService),Be(9,c.IExtHostTerminalService)],re),e.AbstractExtHostExtensionService=re;function W(G,$){return{id:G.identifier.value,name:G.name,extensionVersion:G.version,publisherDisplayName:G.publisher,activationEvents:G.activationEvents?G.activationEvents.join(","):null,isBuiltin:G.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class F{constructor($,X,ie,ae){U.set(this,void 0),B.set(this,void 0),H.set(this,void 0),Ye(this,U,$,"f"),Ye(this,B,X,"f"),Ye(this,H,ie.identifier,"f"),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=ae}get isActive(){return Le(this,U,"f").isActivated(Le(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,U,"f").getExtensionExports(Le(this,H,"f"))}activate(){return Le(this,U,"f").activateByIdWithErrors(Le(this,H,"f"),{startup:!1,extensionId:Le(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,U=new WeakMap,B=new WeakMap,H=new WeakMap;function q(G){const $=G.indexOf("+");return $===-1?G:G.substring(0,$)}}),define(be[54],Ee([1,0,9,2,3,15,5,7,127,36,41,45,217,37,210,17,4,14,38,53]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let d=class{constructor(r,h,c,w,P,L){this._workspaceService=h,this._extensionService=c,this._editorsService=w,this._configurationService=P,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=r.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(p=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,h){const c=r;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let w=`debug:${encodeURIComponent(c.path||"")}`,P="?";return h&&(w+=`${P}session=${encodeURIComponent(h.id)}`,P="&"),w+=`${P}ref=${c.sourceReference}`,t.URI.parse(w)}else{if(c.path)return t.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const h=[];for(const c of r.getAllExtensionDescriptions())if(c.contributes){const w=c.contributes.debuggers;if(w&&w.length>0)for(const P of w)(0,g.isDebuggerMainContribution)(P)&&h.push(P.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(h=>r.push(h)),r}addBreakpoints(r){this.startBreakpoints();const h=r.filter(P=>{const L=P.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,P),!0)});this.fireBreakpointChanges(h,[],[]);const c=[],w=new Map;for(const P of h)if(P instanceof k.SourceBreakpoint){let L=w.get(P.location.uri.toString());L||(L={type:"sourceMulti",uri:P.location.uri,lines:[]},w.set(P.location.uri.toString(),L),c.push(L)),L.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof k.FunctionBreakpoint&&c.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(c)}removeBreakpoints(r){this.startBreakpoints();const h=r.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],h,[]);const c=h.filter(L=>L instanceof k.SourceBreakpoint).map(L=>L.id),w=h.filter(L=>L instanceof k.FunctionBreakpoint).map(L=>L.id),P=h.filter(L=>L instanceof k.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(c,w,P)}startDebugging(r,h,c){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,h,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,debugUI:c.debugUI,suppressSaveBeforeStart:c.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,h,c){if(!h)return new k.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:w,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,c,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,w),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(r,h,c){if(!c)return new k.Disposable(()=>{});if(!this.definesDebugType(r,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:w,factory:c}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,w),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==c),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(r,h){if(!h)return new k.Disposable(()=>{});const c=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:c,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==h)})}async $runInTerminal(r,h){return Promise.resolve(void 0)}async $substituteVariables(r,h){if(!this._variableResolver){const[P,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,L)}let c;const w=await this.getFolder(r);return w&&(c={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(c,h)}createDebugAdapter(r,h){if(r.type==="implementation")return new i(r.implementation)}createSignService(){}async $startDASession(r,h){const c=this,w=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const L=this.convertToDto(P),M=this.createDebugAdapter(L,w);if(!M)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const p=M;return this._debugAdapters.set(r,p),this.getDebugAdapterTrackers(w).then(U=>(U&&this._debugAdaptersTrackers.set(r,U),p.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const H=B,re={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(H.arguments.value);re.body={signature:W},p.sendResponse(re)}else throw new Error("no signer")}catch(W){re.success=!1,re.message=W.message,p.sendResponse(re)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(B),B=(0,g.convertToVSCPaths)(B,!0),c._debugServiceProxy.$acceptDAMessage(r,B)}),p.onError(B=>{U&&U.onError&&U.onError(B),this._debugServiceProxy.$acceptDAError(r,B.name,B.message,B.stack)}),p.onExit(B=>{U&&U.onExit&&U.onExit((0,_.withNullAsUndefined)(B),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,_.withNullAsUndefined)(B),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),p.startSession()))})}$sendDAMessage(r,h){h=(0,g.convertToDAPaths)(h,!1);const c=this._debugAdaptersTrackers.get(r);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(h);const w=this._debugAdapters.get(r);w&&w.sendMessage(h)}$stopDASession(r){const h=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),h&&h.onWillStopSession&&h.onWillStopSession();const c=this._debugAdapters.get(r);return this._debugAdapters.delete(r),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const h=[],c=[],w=[];if(r.added)for(const P of r.added){const L=P.id;if(L&&!this._breakpoints.has(L)){let M;if(P.type==="function")M=new k.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")M=new k.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const p=t.URI.revive(P.uri);M=new k.SourceBreakpoint(new k.Location(p,new k.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}M._id=L,this._breakpoints.set(L,M),h.push(M)}}if(r.removed)for(const P of r.removed){const L=this._breakpoints.get(P);L&&(this._breakpoints.delete(P),c.push(L))}if(r.changed){for(const P of r.changed)if(P.id){const L=this._breakpoints.get(P.id);if(L){if(L instanceof k.FunctionBreakpoint&&P.type==="function"){const M=L;M.enabled=P.enabled,M.condition=P.condition,M.hitCondition=P.hitCondition,M.logMessage=P.logMessage,M.functionName=P.functionName}else if(L instanceof k.SourceBreakpoint&&P.type==="source"){const M=L;M.enabled=P.enabled,M.condition=P.condition,M.hitCondition=P.hitCondition,M.logMessage=P.logMessage,M.location=new k.Location(t.URI.revive(P.uri),new k.Position(P.line,P.character))}w.push(L)}}}this.fireBreakpointChanges(h,c,w)}$provideDebugConfigurations(r,h,c){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(r);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(h);return w.provideDebugConfigurations(P,c)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(r,h,c,w){return(0,T.asPromise)(async()=>{const P=this.getConfigProviderByHandle(r);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(h);return P.resolveDebugConfiguration(L,c,w)})}$resolveDebugConfigurationWithSubstitutedVariables(r,h,c,w){return(0,T.asPromise)(async()=>{const P=this.getConfigProviderByHandle(r);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(h);return P.resolveDebugConfigurationWithSubstitutedVariables(L,c,w)})}async $provideDebugAdapter(r,h){const c=this.getAdapterDescriptorFactoryByHandle(r);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(h);return this.getAdapterDescriptor(c,w).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(r){const h=await this.getSession(r);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(r){const h=await this.getSession(r);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,h){const c=await this.getSession(r);c&&c._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(r,h){const w={session:await this.getSession(r),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const h=this._adapterFactories.filter(c=>c.type===r);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(r){const h=this._adapterFactories.filter(c=>c.handle===r);if(h.length>0)return h[0].factory}getConfigProviderByHandle(r){const h=this._configProviders.filter(c=>c.handle===r);if(h.length>0)return h[0].provider}definesDebugType(r,h){if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0){for(const w of c)if(w.label&&w.type&&w.type===h)return!0}}return!1}getDebugAdapterTrackers(r){const c=r.configuration.type,w=this._trackerFactories.filter(P=>P.type===c||P.type==="*").map(P=>(0,T.asPromise)(()=>P.factory.createDebugAdapterTracker(r)).then(L=>L,L=>null));return Promise.race([Promise.all(w).then(P=>{const L=P.filter(M=>!!M);if(L.length>0)return new o(L)}),new Promise((P,L)=>{const M=setTimeout(()=>{clearTimeout(M),L(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(r,h){const c=h.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new k.DebugAdapterServer(c));if(r){const P=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>r.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,P))).then(L=>{if(L)return L})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,w))}daExecutableFromPackage(r,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,h,c){(r.length>0||h.length>0||c.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:h,changed:c}))}async getSession(r){if(r)if(typeof r=="string"){const h=this._debugSessions.get(r);if(h)return h}else{let h=this._debugSessions.get(r.id);if(!h){const c=await this.getFolder(r.folderUri),w=r.parent?this._debugSessions.get(r.parent):void 0;h=new m(this._debugServiceProxy,r.id,r.type,r.name,c,r.configuration,w),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(r){if(r){const h=t.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};d=$e([Be(0,u.IExtHostRpcService),Be(1,A.IExtHostWorkspace),Be(2,N.IExtHostExtensionService),Be(3,R.IExtHostDocumentsAndEditors),Be(4,C.IExtHostConfiguration),Be(5,l.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class m{constructor(r,h,c,w,P,L,M){this._debugServiceProxy=r,this._id=h,this._type=c,this._name=w,this._workspaceFolder=P,this._configuration=L,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,h)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=m;class a{constructor(r){this.value=Object.freeze({append(h){r.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=a;class S extends b.AbstractVariableResolverService{constructor(r,h,c,w,P,L){function M(){if(h){const p=h.activeEditor();if(p)return p.document.uri;const U=w.tabGroups.groups.find(B=>B.isActive)?.activeTab;if(U!==void 0){if(U.kind instanceof k.TextDiffTabInput||U.kind instanceof k.NotebookDiffEditorTabInput)return U.kind.modified;if(U.kind instanceof k.TextTabInput||U.kind instanceof k.NotebookEditorTabInput||U.kind instanceof k.CustomEditorTabInput)return U.kind.uri}}}super({getFolderUri:p=>{const U=r.filter(B=>B.name===p);if(U&&U.length>0)return U[0].uri},getWorkspaceFolderCount:()=>r.length,getConfigurationValue:(p,U)=>c.getConfiguration(void 0,p).get(U),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=M();if(p)return f.normalize(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const p=M();if(p){const U=P.getWorkspaceFolder(p);if(U)return f.normalize(U.uri.fsPath)}}},getSelectedText:()=>{if(h){const p=h.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(h){const p=h.activeEditor();if(p)return String(p.selection.end.line+1)}}},void 0,L?Promise.resolve(L):void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=S;class o{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(h=>h.onError?h.onError(r):void 0)}onExit(r,h){this.trackers.forEach(c=>c.onExit?c.onExit(r,h):void 0)}}class i extends y.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends d{constructor(r,h,c,w,P,L){super(r,h,c,w,P,L)}createVariableResolver(r,h,c){return new S(r,h,c,this._editorTabs)}};s=$e([Be(0,u.IExtHostRpcService),Be(1,A.IExtHostWorkspace),Be(2,N.IExtHostExtensionService),Be(3,R.IExtHostDocumentsAndEditors),Be(4,C.IExtHostConfiguration),Be(5,l.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(be[270],Ee([1,0,71,2,5,37,27,28,17,26,4,41,38,11,8]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(m,a,S,o,i,s,n){this._apiFactory=m,this._extensionRegistry=a,this._instaService=S,this._extHostConfiguration=o,this._extHostExtensionService=i,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new _(this._apiFactory,a,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(E,a)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(l,a,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(let a of m.nodeModuleName)this._factories.set(a,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(a=>m.alternativeModuleName(a))}};u=$e([Be(2,N.IInstantiationService),Be(3,T.IExtHostConfiguration),Be(4,R.IExtHostExtensionService),Be(5,A.IExtHostInitDataService),Be(6,C.ILogService)],u),e.RequireInterceptor=u;let v=class qi{constructor(m){if(m.environment.appRoot&&qi.aliased.size){const a=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),S="[a-z0-9_.-]",o=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${i}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(m));if(!a)return;const[,S,o,i]=a,s=qi.aliased.get(o);if(s!==void 0)return console.warn(`${o} as been renamed to ${s}, please update your imports`),S+s+i}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=$e([Be(0,A.IExtHostInitDataService)],v);class _{constructor(m,a,S,o,i){this._apiFactory=m,this._extensionPaths=a,this._extensionRegistry=S,this._configProvider=o,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,a){const S=this._extensionPaths.findSubstr(a);if(S){let o=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return o||(o=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((i,s)=>o+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(m,a,S){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(I.MainContext.MainThreadTelemetry);const{environment:o}=S,i=a.getProxy(I.MainContext.MainThreadKeytar);if(o.appRoot){let s=o.appRoot.fsPath;b.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,n)=>i.$getPassword(s,n),setPassword:(s,n,r)=>i.$setPassword(s,n,r),deletePassword:(s,n)=>i.$deletePassword(s,n),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(m,a){const S=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const a=m.length;if(a<=7||!this.alternativeNames)return;const S=a-7;if((m.charAt(S)==="/"||m.charAt(S)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};E=$e([Be(1,y.IExtHostRpcService),Be(2,A.IExtHostInitDataService)],E);let l=class{constructor(m,a,S){this._extensionPaths=m,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const o=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,s)=>{const n=t.URI.parse(i);return s?this.callOriginal(i,s):n.scheme==="http"||n.scheme==="https"?o.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?o.$openUri(n,i,{}):this.callOriginal(i,s)}}load(m,a,S){const o=this._extensionPaths.findSubstr(a);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=S(m),this._impl}callOriginal(m,a){return this.sendNoForwardTelemetry(),this._original(m,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};l=$e([Be(2,y.IExtHostRpcService)],l)}),define(be[271],Ee([1,0,15,12,71,6,2,5,264,11,79,81,26,189,17,64,41,33]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(d,m,a,S,o){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new y.RPCProtocol(d,null,S),m=E._transform(m,this._rpcProtocol);const i=new R.ServiceCollection(...(0,N.getSingletonServiceDescriptors)());i.set(b.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:o}),i.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),i.set(u.IURITransformerService,new u.URITransformerService(S)),i.set(v.IHostUtils,a);const s=new C.InstantiationService(i,!0);this._disposables.add(s.invokeFunction(c=>c.get(_.IExtHostTerminalService))),this._disposables.add(s.invokeFunction(c=>c.get(v.IExtHostExtensionService))),this._logService=s.invokeFunction(c=>c.get(A.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=s.invokeFunction(c=>c.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(c=>{Error.prepareStackTrace=(w,P)=>{let L="",M,p;for(const U of P)L+=`
	at ${U.toString()}`,p=U.getFileName(),!M&&p&&(M=c.findSubstr(D.URI.file(p)));return n.set(w,M),`${w.name||"Error"}: ${w.message||""}${L}`}});const r=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(c=>{const w=t.transformErrorForSerialization(c),P=n.get(c);P?r.$onExtensionRuntimeError(P.identifier,w):h.$onUnexpectedError(w)})}async asBrowserUri(d){const m=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService);return D.URI.revive(await m.$asBrowserUri(d))}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(d,m){d.extensions.forEach(S=>S.extensionLocation=D.URI.revive(m.transformIncomingURIs(S.extensionLocation))),d.environment.appRoot=D.URI.revive(m.transformIncomingURIs(d.environment.appRoot));const a=d.environment.extensionDevelopmentLocationURI;return a&&(d.environment.extensionDevelopmentLocationURI=a.map(S=>D.URI.revive(m.transformIncomingURIs(S)))),d.environment.extensionTestsLocationURI=D.URI.revive(m.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=D.URI.revive(m.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=D.URI.revive(m.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=D.URI.revive(m.transformIncomingURIs(d.logsLocation)),d.logFile=D.URI.revive(m.transformIncomingURIs(d.logFile)),d.workspace=m.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=E}),define(be[272],Ee([1,0,174,60,13,7,211,36,41,45,37,33,17,54,196,15,212,53,188]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let l=class extends C.ExtHostDebugServiceBase{constructor(o,i,s,n,r,h,c){super(o,i,s,n,r,c);this._terminalService=h,this._integratedTerminalInstances=new a}createDebugAdapter(o,i){switch(o.type){case"server":return new D.SocketDebugAdapter(o);case"pipeServer":return new D.NamedPipeDebugAdapter(o);case"executable":return new D.ExecutableDebugAdapter(o,i.type)}return super.createDebugAdapter(o,i)}daExecutableFromPackage(o,i){const s=D.ExecutableDebugAdapter.platformAdapterExecutable(i.getAllExtensionDescriptions(),o.type);if(s)return new T.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new g.SignService}async $runInTerminal(o,i){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(B=>{this._integratedTerminalInstances.onTerminalClosed(B)}));const s=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),h=o.title||f.localize(0,null),c=JSON.stringify({shell:n,shellArgs:r});let w=await this._integratedTerminalInstances.checkout(c,h),P,L=!1;if(w)P=o.cwd;else{const B={shellPath:n,shellArgs:r,cwd:o.cwd,name:h,iconPath:new T.ThemeIcon("debug")};L=!0,w=this._terminalService.createTerminalFromOptions(B,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(w,c)}w.show(!0);const M=await w.processId;L?await new Promise(B=>setTimeout(B,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?w.sendText("cls"):n.indexOf("bash")>=0?w.sendText("clear"):I.isWindows?w.sendText("cls"):w.sendText("clear"));const p=(0,v.prepareCommand)(n,o.args,P,o.env);w.sendText(p);const U=this.onDidTerminateDebugSession(B=>{B.id===i&&(this._integratedTerminalInstances.free(w),U.dispose())});return M}else if(o.kind==="external")return m(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,i)}createVariableResolver(o,i,s){return new C.ExtHostVariableResolverService(o,i,s,this._editorTabs,this._workspaceService,(0,t.homedir)())}};l=$e([Be(0,b.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,y.IExtHostExtensionService),Be(3,A.IExtHostDocumentsAndEditors),Be(4,N.IExtHostConfiguration),Be(5,R.IExtHostTerminalService),Be(6,_.IExtHostEditorTabs)],l),e.ExtHostDebugService=l;let d;function m(S,o){if(!d)if(I.isWindows)d=new E.WindowsExternalTerminalService;else if(I.isMacintosh)d=new E.MacExternalTerminalService;else if(I.isLinux)d=new E.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const i=o.getConfiguration("terminal");return d.runInTerminal(S.title,S.cwd,S.args,S.env||{},i.external||{})}e.runInExternalTerminal=m;class a{constructor(){this._terminalInstances=new Map}async checkout(o,i){const n=[...this._terminalInstances.entries()].map(([r,h])=>(0,u.createCancelablePromise)(async c=>{if(r.name!==i||h.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await r.processId))return null;const w=Date.now();return h.lastUsedAt+a.minUseDelay>w||c.isCancellationRequested||h.config!==o?null:(h.lastUsedAt=w,r)}));return await(0,u.firstParallel)(n,r=>!!r)}insert(o,i){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:i})}free(o){const i=this._terminalInstances.get(o);i&&(i.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}a.minUseDelay=1e3}),define(be[273],Ee([1,0,9,2,113,36,54,45,37,43,33,17,26,70,10,11,65,53,23,60]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let d=class extends C.ExtHostTaskBase{constructor(a,S,o,i,s,n,r,h,c){super(a,S,o,i,s,n,r,h);this.workspaceService=o,this.editorTabs=c,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,S){const o=S;if(!S.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const i=C.TaskHandleDTO.from(o,this.workspaceService),s=await this._proxy.$getTaskExecution(i);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(s,S);return this._proxy.$executeTask(i).catch(()=>{}),n}else{const i=C.TaskDTO.from(S,a);if(i===void 0)return Promise.reject(new Error("Task is not valid"));C.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),s}}provideTasksInternal(a,S,o,i){const s=[];if(i)for(let n of i){this.checkDeprecation(n,o),(!n.definition||!a[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const r=C.TaskDTO.from(n,o.extension);r&&(s.push(r),C.CustomExecutionDTO.is(r.execution)&&S.push(this.addCustomExecution(r,n,!0)))}return{tasks:s,extension:o.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(a,this._editorService,S,this.editorTabs,this.workspaceService,(0,l.homedir)())}return this._variableResolver}async getAFolder(a){let S=a&&a.length>0?a[0]:void 0;if(!S){const o=t.URI.file((0,l.homedir)());S=new A.WorkspaceFolder({uri:o,name:E.basename(o),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,S){const o=t.URI.revive(a),i={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(o),n=await this._workspaceProvider.getWorkspaceFolders2()??[],r=await this.getVariableResolver(n),h=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(n);for(let c of S.variables)i.variables[c]=await r.resolveAsync(h,c);if(S.process!==void 0){let c;if(S.process.path!==void 0){c=S.process.path.split(f.delimiter);for(let w=0;w<c.length;w++)c[w]=await r.resolveAsync(h,c[w])}i.process=await I.win32.findExecutable(await r.resolveAsync(h,S.process.name),S.process.cwd!==void 0?await r.resolveAsync(h,S.process.cwd):void 0,c)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(a,S,o){return I.win32.findExecutable(a,S,o)}};d=$e([Be(0,R.IExtHostRpcService),Be(1,b.IExtHostInitDataService),Be(2,T.IExtHostWorkspace),Be(3,k.IExtHostDocumentsAndEditors),Be(4,y.IExtHostConfiguration),Be(5,N.IExtHostTerminalService),Be(6,u.ILogService),Be(7,v.IExtHostApiDeprecationService),Be(8,_.IExtHostEditorTabs)],d),e.ExtHostTask=d}),define(be[138],Ee([1,0,18,15,21,49,10,9,23,14,2,31]),function(J,e,f,t,I,T,D,k,y,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(l,d,m,a){this.query=l,this.provider=d,this.fileUtils=m,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,d){const m=this.query.folderQueries||[],a=new I.CancellationTokenSource;return d.onCancellationRequested(()=>a.cancel()),new Promise((S,o)=>{this.collector=new g(l);let i=!1;const s=(n,r)=>{if(!i&&!this.isLimitHit){const h=this.resultSize(n);v(n)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,i=!0,a.cancel(),n=this.trimResultToSize(n,this.query.maxResults-this.resultCount));const c=this.resultSize(n);this.resultCount+=c,(c>0||!v(n))&&this.collector.add(n,r)}};Promise.all(m.map((n,r)=>this.searchInFolder(n,h=>s(h,r),a.token))).then(n=>{a.dispose(),this.collector.flush();const r=n.some(h=>!!h&&!!h.limitHit);S({limitHit:this.isLimitHit||r,messages:(0,f.flatten)(n.map(h=>h?.message?(0,A.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},n=>{a.dispose();const r=(0,T.toErrorMessage)(n);o(new Error(r))})})}resultSize(l){return v(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,d){const m=Array.isArray(l.ranges)?l.ranges:[l.ranges],a=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:m.slice(0,d),preview:{matches:a.slice(0,d),text:l.preview.text},uri:l.uri}}async searchInFolder(l,d,m){const a=new R.QueryGlobTester(this.query,l),S=[],o={report:n=>{if(!this.validateProviderResult(n))return;const r=l.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(n.uri))):void 0,h=y.relativePath(l.folder,n.uri);if(h){const c=a.includedInQuery(h,k.basename(h),r);(0,t.isThenable)(c)?S.push(c.then(w=>{w&&d(n)})):c&&d(n)}}},i=this.getSearchOptionsForFolder(l),s=await this.provider.provideTextSearchResults(C(this.query.contentPattern),i,o,m);return S.length&&await Promise.all(S),s}validateProviderResult(l){if(v(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const d=(0,R.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),m=(0,R.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),a={folder:N.URI.from(l.folder),excludes:m,includes:d,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=b;function C(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class g{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,d=>this.sendItems(d))}add(l,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!y.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(u(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=g;function u(E){return v(E)?{preview:{matches:(0,f.mapArrayOrNot)(E.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:E.preview.text},ranges:(0,f.mapArrayOrNot)(E.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function v(E){return!!E.preview}e.extensionResultIsMatch=v;class _{constructor(l,d){this.maxBatchSize=l,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,d){!l||this.addItemToBatch(l,d)}addItems(l,d){!l||this.addItemsToBatch(l,d)}addItemToBatch(l,d){this.batch.push(l),this.batchSize+=d,this.onUpdate()}addItemsToBatch(l,d){this.batch=this.batch.concat(l),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(be[72],Ee([1,0,6,5,4,267,17,64,11,2,138]),function(J,e,f,t,I,T,D,k,y,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let R=class{constructor(u,v,_){this.extHostRpc=u,this._uriTransformer=v,this._logService=_,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,v){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const _=this._handlePool++;return this._textSearchProvider.set(_,v),this._proxy.$registerTextSearchProvider(_,this._transformScheme(u)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}registerFileSearchProvider(u,v){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const _=this._handlePool++;return this._fileSearchProvider.set(_,v),this._proxy.$registerFileSearchProvider(_,this._transformScheme(u)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}$provideFileSearchResults(u,v,_,E){const l=b(_),d=this._fileSearchProvider.get(u);if(d)return this._fileSearchManager.fileSearch(l,d,m=>{this._proxy.$handleFileMatch(u,v,m.map(a=>a.resource))},E);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,v,_,E){const l=this._textSearchProvider.get(u);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const d=b(_);return this.createTextSearchManager(d,l).search(a=>this._proxy.$handleTextMatch(u,v,a),E)}$enableExtensionHostSearch(){}createTextSearchManager(u,v){return new N.TextSearchManager(u,v,{readdir:_=>Promise.resolve([]),toCanonicalName:_=>_},"textSearchProvider")}};R=$e([Be(0,D.IExtHostRpcService),Be(1,k.IURITransformerService),Be(2,y.ILogService)],R),e.ExtHostSearch=R;function b(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(C),extraFileResources:g.extraFileResources&&g.extraFileResources.map(u=>A.URI.revive(u))}}e.reviveQuery=b;function C(g){return{...g,folder:A.URI.revive(g.folder)}}}),define(be[274],Ee([1,0,79,136,36,134,37,40,45,33,70,54,72,88,51,65,137,66,44,87,124,53,135,11,226]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d,m,a,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(S.ILoggerService,a.ExtHostLoggerService),(0,f.registerSingleton)(S.ILogService,o.ExtHostLogService),(0,f.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,f.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,f.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,f.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,f.registerSingleton)(R.IExtHostDebugService,R.WorkerExtHostDebugService),(0,f.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,f.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,f.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,f.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,f.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage),(0,f.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask),(0,f.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,f.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,f.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,f.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(be[89],Ee([1,0,18,11,31,69]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(R){return R.startsWith("**")||R.startsWith("/")?R:`/${R}`}e.anchorGlob=D;function k(R,b,C,g){const u=(0,f.mapArrayOrNot)(C,y),v=new I.TextSearchMatch(b,u,g),_=v.preview.matches;return{ranges:(0,f.mapArrayOrNot)(u,A),uri:R,preview:{text:v.preview.text,matches:(0,f.mapArrayOrNot)(_,A)}}}e.createTextSearchResult=k;function y(R){return new I.SearchRange(R.start.line,R.start.character,R.end.line,R.end.character)}function A(R){return new T.Range(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn)}let N=class{constructor(b,C){this.prefix=b,this.logService=C}appendLine(b){this.logService.debug(`${this.prefix}#search`,b)}};N=$e([Be(1,t.ILogService)],N),e.OutputChannel=N}),define(be[275],Ee([1,0,39,9,78,30,13,8,89,276]),function(J,e,f,t,I,T,D,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const N=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function R(l,d,m,a){const S=b(l,d,m,a),o=d.folder.fsPath;return{cmd:f.spawn(N,S.args,{cwd:o}),rgDiskPath:N,siblingClauses:S.siblingClauses,rgArgs:S,cwd:o}}e.spawnRipgrepCmd=R;function b(l,d,m,a){const S=["--files","--hidden","--case-sensitive"];g([d],m,!1).forEach(i=>{const s=(0,y.anchorGlob)(i);if(S.push("-g",s),D.isMacintosh){const n=(0,I.normalizeNFD)(s);n!==s&&S.push("-g",n)}});const o=C([d],a,void 0,!1);return o.globArgs.forEach(i=>{const s=`!${(0,y.anchorGlob)(i)}`;if(S.push("-g",s),D.isMacintosh){const n=(0,I.normalizeNFD)(s);n!==s&&S.push("-g",n)}}),d.disregardIgnoreFiles!==!1?S.push("--no-ignore"):d.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),d.ignoreSymlinks||S.push("--follow"),l.exists&&S.push("--quiet"),S.push("--no-config"),d.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:o.siblingClauses}}function C(l,d,m,a=!0){const S=[];let o={};return l.forEach(i=>{const s=Object.assign({},i.excludePattern||{},d||{}),n=u(s,a?i.folder.fsPath:void 0,m);S.push(...n.globArgs),n.siblingClauses&&(o=Object.assign(o,n.siblingClauses))}),{globArgs:S,siblingClauses:o}}e.foldersToRgExcludeGlobs=C;function g(l,d,m=!0){const a=[];return l.forEach(S=>{const o=Object.assign({},d||{},S.includePattern||{}),i=u(o,m?S.folder.fsPath:void 0);a.push(...i.globArgs)}),a}e.foldersToIncludeGlobs=g;function u(l,d,m){const a=[],S={};return Object.keys(l).forEach(o=>{if(m&&m.has(o)||!o)return;const i=l[o];o=_(d?v(d,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),a.push(E(o))):i&&i.when&&(S[o]=i)}),{globArgs:a,siblingClauses:S}}function v(l,d){return t.isAbsolute(d)?d:t.join(l,d)}e.getAbsoluteGlob=v;function _(l){return l=k.rtrim(l,"\\"),k.rtrim(l,"/")}function E(l){return T.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=E}),define(be[277],Ee([1,0,39,59,9,103,18,49,34,78,30,13,46,8,14,29,31,275,99]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(o=>o())});class d{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(s=>{const n=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),r=s.folder.fsPath;i.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==r).forEach(h=>{(0,N.isEqualOrParent)(h,r)&&(n[I.relative(r,h)]=!0)}),this.folderExcludePatterns.set(r,new a(n,r))})}cancel(){this.isCanceled=!0,l.forEach(i=>i())}walk(i,s,n,r,h){if(this.fileWalkSW=b.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);s.forEach(c=>{const w=I.basename(c.fsPath);this.globalExcludePattern&&this.globalExcludePattern(c.fsPath,w)||this.matchFile(n,{relativePath:c.fsPath,searchPath:void 0})}),this.cmdSW=b.StopWatch.create(!1),this.parallel(i,(c,w)=>{this.call(this.cmdTraversal,this,c,n,r,P=>{if(P){const L=(0,k.toErrorMessage)(P);console.error(L),this.errors.push(L),w(P,void 0)}else w(null,void 0)})},(c,w)=>{this.fileWalkSW.stop();const P=c?D.coalesce(c)[0]:null;h(P,this.isLimitHit)})}parallel(i,s,n){const r=new Array(i.length),h=new Array(i.length);let c=!1,w=0;if(i.length===0)return n(null,[]);i.forEach((P,L)=>{s(P,(M,p)=>{if(M?(c=!0,r[L]=null,h[L]=M):(r[L]=p,h[L]=null),++w===i.length)return n(c?h:null,r)})})}call(i,s,...n){try{i.apply(s,n)}catch(r){n[n.length-1](r)}}cmdTraversal(i,s,n,r){const h=i.folder.fsPath,c=R.isMacintosh;let w;const P=()=>w&&w.kill();l.add(P);let L=W=>{l.delete(P),L=()=>{},r(W)},M="";const p=this.initDirectoryTree();let U;const B=(0,_.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=B.cmd,U=!Object.keys(B.siblingClauses).length;const H=B.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let re=`${B.rgDiskPath} ${H}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(re+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),n({message:re}),this.cmdResultCount=0,this.collectStdout(w,"utf8",n,(W,F,q)=>{if(W){L(W);return}if(this.isLimitHit){L();return}const $=(M+(c?A.normalizeNFC(F||""):F)).split(`
`);if(q){const X=$.length;$[X-1]=$[X-1].trim(),$[X-1]||$.pop()}else M=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,U){for(const X of $)if(this.matchFile(s,{base:h,relativePath:X,searchPath:this.getSearchPath(i,X)}),this.isLimitHit){P();break}(q||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,p,h,$,s),q&&(this.matchDirectoryTree(p,h,s),L())})}spawnFindCmd(i){const s=this.folderExcludePatterns.get(i.folder.fsPath),n=s.getBasenameTerms(),r=s.getPathTerms(),h=["-L","."];if(n.length||r.length){h.push("-not","(","(");for(const c of n)h.push("-name",c),h.push("-o");for(const c of r)h.push("-path",c),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),f.spawn("find",h,{cwd:i.folder.fsPath})}readStdout(i,s,n){let r="";this.collectStdout(i,s,()=>{},(h,c,w)=>{if(h){n(h);return}r+=c,w&&n(null,r)})}collectStdout(i,s,n,r){let h=(P,L,M)=>{(P||M)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),r(P,L,M)},c=!1;i.stdout?(this.forwardData(i.stdout,s,h),i.stdout.once("data",()=>c=!0)):n({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):n({message:"stderr is null"}),i.on("error",P=>{h(P)}),i.on("close",P=>{let L;!c&&(L=this.decodeData(w,s))&&S(L)?h(new Error(`command failed with error code ${P}: ${this.decodeData(w,s)}`)):(this.exists&&P===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(i,s,n){const r=new T.StringDecoder(s);return i.on("data",h=>{n(null,r.write(h))}),r}collectData(i){const s=[];return i.on("data",n=>{s.push(n)}),s}decodeData(i,s){const n=new T.StringDecoder(s);return i.map(r=>n.write(r)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:s},n,r,h){r.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const c=w=>{const P=I.basename(w),L=I.dirname(w);let M=s[L];M||(M=s[L]=[],c(L)),M.push({base:n,relativePath:w,basename:P,searchPath:this.getSearchPath(i,w)})};r.forEach(c)}matchDirectoryTree({rootEntries:i,pathToEntries:s},n,r){const h=this,c=this.folderExcludePatterns.get(n),w=this.filePattern;function P(L){h.directoriesWalked++;const M=(0,v.hasSiblingFn)(()=>L.map(p=>p.basename));for(let p=0,U=L.length;p<U;p++){const B=L[p],{relativePath:H,basename:re}=B;if(c.test(H,re,w!==re?M:void 0))continue;const W=s[H];if(W)P(W);else{if(h.filesWalked++,H===w)continue;h.matchFile(r,B)}if(h.isLimitHit)break}}P(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,s,n,r,h){const c=i.folder,w=(0,v.hasSiblingFn)(()=>n);this.parallel(n,(P,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const M=s?[s,P].join(I.sep):P;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,P,this.config.filePattern!==P?w:void 0))return L(null);const p=[c.fsPath,M].join(I.sep);t.lstat(p,(U,B)=>{if(U||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(p,B,(H,re)=>H||this.isCanceled||this.isLimitHit?L(null):re.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(p,B,(W,F)=>W||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?L(null):(this.walkedPaths[F]=!0,u.Promises.readdir(p).then(q=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,M,q,r,G=>L(G||null))},q=>{L(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&g.isNumber(re.size)&&re.size>this.maxFilesize||this.matchFile(r,{base:c.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),L(null,void 0)))})},P=>{const L=P&&D.coalesce(P);return h(L&&L.length>0?L[0]:void 0)})}matchFile(i,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,I.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(s))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,s,n){return s.isSymbolicLink()?t.stat(i,n):n(null,s)}realPathIfNeeded(i,s,n){return s.isSymbolicLink()?t.realpath(i,(r,h)=>r?n(r):n(null,h)):n(null,i)}getSearchPath(i,s){return i.folderName?I.join(i.folderName,s):s}}e.FileWalker=d;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new d(i)}search(i,s,n){this.walker.walk(this.folderQueries,this.extraFiles,i,s,(r,h)=>{n(r,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class a{constructor(i,s){this.expression=i,this.root=s,this.init(i)}init(i){let s,n;Object.keys(i).filter(r=>i[r]).forEach(r=>{I.isAbsolute(r)?(s=s||y.getEmptyExpression(),s[r]=i[r]):(n=n||y.getEmptyExpression(),n[r]=i[r])}),this.absoluteParsedExpr=s&&y.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=n&&y.parse(n,{trimForExclusions:!0})}test(i,s,n){return this.relativeParsedExpr&&this.relativeParsedExpr(i,s,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),s,n)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function S(o){const i=o.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return C.uppercaseFirstLetter(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=S}),define(be[278],Ee([1,0,95,22]),function(J,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===o)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,D=512,k=512*8,y=512*128;var A;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(A=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class N extends Error{constructor(i,s){super(i);this.decodeStreamErrorKind=s}}e.DecodeStreamError=N;class R{constructor(i){this.iconvLiteDecoder=i}static async create(i){let s;if(i!==e.UTF8)s=(await new Promise((r,h)=>{J(["@vscode/iconv-lite-umd"],r,h)})).getDecoder(u(i));else{const n=new TextDecoder;s={write(r){return n.decode(r,{stream:!0})},end(){return n.decode()}}}return new R(s)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function b(o,i){const s=i.minBytesRequiredForDetection??i.guessEncoding?k:D;return new Promise((n,r)=>{const h=(0,f.newWriteableStream)(p=>p.join("")),c=[];let w=0,P,L;const M=async()=>{try{const p=await S({buffer:t.VSBuffer.concat(c),bytesRead:w},i.guessEncoding);if(p.seemsBinary&&i.acceptTextOnly)throw new N("Stream is binary but only text is accepted for decoding",1);p.encoding=await i.overwriteEncoding(p.encoding),P=await R.create(p.encoding);const U=P.write(t.VSBuffer.concat(c).buffer);h.write(U),c.length=0,w=0,n({stream:h,detected:p})}catch(p){L?.dispose(),h.destroy(),r(p)}};L=(0,f.listenStream)(o,{onData:async p=>{P?h.write(P.write(p.buffer)):(c.push(p),w+=p.byteLength,w>=s&&(o.pause(),await M(),setTimeout(()=>o.resume())))},onError:p=>h.error(p),onEnd:async()=>{P||await M(),h.end(P?.end())}})})}e.toDecodeStream=b;async function C(o,i,s){const r=(await new Promise((w,P)=>{J(["@vscode/iconv-lite-umd"],w,P)})).getEncoder(u(i),s);let h=!1,c=!1;return{read(){if(c)return null;const w=o.read();if(typeof w!="string"){if(c=!0,!h&&s?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const P=r.end();return P&&P.length>0?(h=!0,t.VSBuffer.wrap(P)):null}return h=!0,t.VSBuffer.wrap(r.write(w))}}}e.toEncodeReadable=C;async function g(o){return(await new Promise((s,n)=>{J(["@vscode/iconv-lite-umd"],s,n)})).encodingExists(u(o))}e.encodingExists=g;function u(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=u;function v(o,i){if(!o||i<e.UTF16be_BOM.length)return null;const s=o.readUInt8(0),n=o.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const r=o.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&r===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const _=["ascii","utf-16","utf-32"];async function E(o){const i=await new Promise((c,w)=>{J(["jschardet"],c,w)}),s=o.slice(0,y),n=m(s.buffer),r=i.detect(n);if(!r||!r.encoding)return null;const h=r.encoding.toLowerCase();return 0<=_.indexOf(h)?null:d(r.encoding)}const l={ibm866:"cp866",big5:"cp950"};function d(o){const i=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return l[i]||i}function m(o){let i="";for(let s=0;s<o.length;s++)i+=String.fromCharCode(o[s]);return i}function a(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=o.match(/windows(\d+)/);return i?"windows-"+i[1]:o}}}e.toCanonicalName=a;function S({buffer:o,bytesRead:i},s){let n=v(o,i),r=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&o){let h=!0,c=!0,w=!1;for(let P=0;P<i&&P<T;P++){const L=P%2==1,M=o.readUInt8(P)===0;if(M&&(w=!0),h&&(L&&!M||!L&&M)&&(h=!1),c&&(L&&M||!L&&!M)&&(c=!1),M&&!h&&!c)break}w&&(h?n=e.UTF16le:c?n=e.UTF16be:r=!0)}return s&&!r&&!n&&o?E(o.slice(0,i)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:r,encoding:n}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(be[139],Ee([1,0,278,29,138]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends I.TextSearchManager{constructor(k,y,A=t,N="searchProcess"){super(k,y,{readdir:R=>A.Promises.readdir(R.fsPath),toCanonicalName:R=>(0,f.toCanonicalName)(R)},N)}}e.NativeTextSearchManager=T}),define(be[279],Ee([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class f{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const T=this._dragOperations.get(I);return this._dragOperations.delete(I),T}}addDragOperationTransfer(I,T){this._dragOperations.set(I,T)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,T){this._renderedElements.set(I,T)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=f}),define(be[280],Ee([1,0,172,23,2,3,6,15,7,14,18,16,21,126,279]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(E,l){if((0,A.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let d;return Array.isArray(E.highlights)&&(d=E.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),d=d.length?d:void 0),{label:E.label,highlights:d}}}class v{constructor(l,d,m){this._proxy=l,this.commands=d,this.logService=m,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function a(S){return S&&S.$treeViewId&&S.$treeItemHandle}d.registerArgumentProcessor({processArgument:S=>a(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(o=>a(o)?this.convertArgument(o):o):S})}registerTreeDataProvider(l,d,m){const a=this.createTreeView(l,{treeDataProvider:d},m);return{dispose:()=>a.dispose()}}createTreeView(l,d,m){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=d.dragAndDropController?.dropMimeTypes??[],S=d.dragAndDropController?.dragMimeTypes??[],o=!!d.dragAndDropController?.handleDrag,i=!!d.dragAndDropController?.handleDrop,s=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,dropMimeTypes:a,dragMimeTypes:S,hasHandleDrag:o,hasHandleDrop:i}),n=this.createExtHostTreeView(l,d,m);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(r){n.message=r},get title(){return n.title},set title(r){n.title=r},get description(){return n.description},set description(r){n.description=r},reveal:(r,h)=>n.reveal(r,h),dispose:async()=>{await s,this.treeViews.delete(l),n.dispose()}}}$getChildren(l,d){const m=this.treeViews.get(l);return m?m.getChildren(d):Promise.reject(new Error((0,f.localize)(0,null,l)))}async $handleDrop(l,d,m,a,S,o,i){const s=this.treeViews.get(l);if(!s)return Promise.reject(new Error((0,f.localize)(1,null,l)));const n=C.DataTransferConverter.toDataTransfer(d);return o===l&&i&&await this.addAdditionalTransferItems(n,s,i,a,S),s.onDrop(n,m,a)}async addAdditionalTransferItems(l,d,m,a,S){const o=this.treeDragAndDropService.removeDragOperationTransfer(S);if(o)(await o)?.forEach((i,s)=>{i&&l.set(s,i)});else if(S&&d.handleDrag){const i=d.handleDrag(m,l,a);this.treeDragAndDropService.addDragOperationTransfer(S,i),await i}return l}async $handleDrag(l,d,m,a){const S=this.treeViews.get(l);if(!S)return Promise.reject(new Error((0,f.localize)(2,null,l)));const o=await this.addAdditionalTransferItems(new Map,S,d,a,m);if(!!o)return C.DataTransferConverter.toDataTransferDTO(o)}async $hasResolve(l){const d=this.treeViews.get(l);if(!d)throw new Error((0,f.localize)(3,null,l));return d.hasResolve}$resolve(l,d,m){const a=this.treeViews.get(l);if(!a)throw new Error((0,f.localize)(4,null,l));return a.resolveTreeItem(d,m)}$setExpanded(l,d,m){const a=this.treeViews.get(l);if(!a)throw new Error((0,f.localize)(5,null,l));a.setExpanded(d,m)}$setSelection(l,d){const m=this.treeViews.get(l);if(!m)throw new Error((0,f.localize)(6,null,l));m.setSelection(d)}$setVisible(l,d){const m=this.treeViews.get(l);if(!m)throw new Error((0,f.localize)(7,null,l));m.setVisible(d)}createExtHostTreeView(l,d,m){const a=new _(l,d,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(l,a),a}convertArgument(l){const d=this.treeViews.get(l.$treeViewId);return d?d.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=v;class _ extends D.Disposable{constructor(l,d,m,a,S,o){super();if(this.viewId=l,this.proxy=m,this.commands=a,this.logService=S,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,o.contributes&&o.contributes.views)for(const n in o.contributes.views)for(const r of o.contributes.views[n])r.id===l&&(this._title=r.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,s;this._register(T.Event.debounce(this._onDidChangeData.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(i||(i=new Promise(h=>s=h),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=s;return i=null,this.refresh(r).then(()=>h())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.isUndefinedOrNull)(l))}async getChildren(l){const d=l?this.getExtensionElement(l):void 0;if(l&&!d)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(l);return m||(m=await this.fetchChildrenNodes(d)),m?m.map(a=>a.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,d){d=d||{select:!0,focus:!1};const m=(0,A.isUndefinedOrNull)(d.select)?!0:d.select,a=(0,A.isUndefinedOrNull)(d.focus)?!1:d.focus,S=(0,A.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(o=>this.resolveTreeNode(l,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(s=>s.item)},{select:m,focus:a,expand:S})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:a,expand:S})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,d){const m=this.getExtensionElement(l);m&&(d?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(l){(0,N.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,d,m){const a=[];for(const S of l){const o=this.getExtensionElement(S);o&&a.push(o)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,d,m),d}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,d,m){const a=d?this.getExtensionElement(d):void 0;if(!(!a&&d||!this.dndController?.handleDrop))return(0,k.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(a,l,m):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,d){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(l);if(m){const a=this.nodes.get(m);if(a){const S=await this.dataProvider.resolveTreeItem(a.extensionItem,m,d)??a.extensionItem;return a.item.tooltip=this.getTooltip(S.tooltip),a.item.command=this.getCommand(a.disposableStore,S.command),a.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(d=>d?this.resolveUnknownParentChain(d).then(m=>this.resolveTreeNode(d,m[m.length-1]).then(a=>(m.push(a),m))):Promise.resolve([]))}resolveParent(l){const d=this.nodes.get(l);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,d){const m=this.nodes.get(l);return m?Promise.resolve(m):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(a=>this.createHandle(l,a,d,!0)).then(a=>this.getChildren(d?d.item.handle:void 0).then(()=>{const S=this.getExtensionElement(a);if(S){const o=this.nodes.get(S);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(l){if(l){let d;if(typeof l=="string"){const m=this.getExtensionElement(l);d=m?this.nodes.get(m):void 0}else d=l;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const d=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=l?this.nodes.get(l):void 0,a=await this.dataProvider.getChildren(l);if(d.token.isCancellationRequested)return;const S=await Promise.all((0,N.coalesce)(a||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,m):null}));return d.token.isCancellationRequested?void 0:(0,N.coalesce)(S)}finally{d.dispose()}}refresh(l){if(l.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(l);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const d=new Set,m=l.map(S=>this.nodes.get(S));for(const S of m)if(S&&!d.has(S.item.handle)){let o=S;for(;o&&o.parent&&m.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&d.add(S.item.handle)}const a=[];return d.forEach(S=>{const o=this.elements.get(S);if(o){const i=this.nodes.get(o);i&&(!i.parent||!d.has(i.parent.item.handle))&&a.push(S)}}),a}refreshHandles(l){const d={};return Promise.all(l.map(m=>this.refreshNode(m).then(a=>{a&&(d[m]=a.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(l){const d=this.getExtensionElement(l);if(d){const m=this.nodes.get(d);if(m)return this.clearChildren(d),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(a=>{if(a){const S=this.createTreeNode(d,a,m.parent);return this.updateNodeCache(d,S,m,m.parent),m.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,d,m){const a=this.createTreeNode(l,d,m);if(d.id&&this.elements.has(a.item.handle))throw new Error((0,f.localize)(8,null,d.id));return this.addNodeToCache(l,a),this.addNodeToParentCache(a,m),a}getTooltip(l){return y.MarkdownString.isMarkdownString(l)?R.MarkdownString.from(l):l}getCommand(l,d){return d?this.commands.toInternal(d,l):void 0}createTreeNode(l,d,m){const a=new D.DisposableStore,S=this.createHandle(l,d,m),o=this.getLightIconPath(d);return{item:{handle:S,parentHandle:m?m.item.handle:void 0,label:u(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(a,d.command),contextValue:d.contextValue,icon:o,iconDark:this.getDarkIconPath(d)||o,themeIcon:this.getThemeIcon(d),collapsibleState:(0,A.isUndefinedOrNull)(d.collapsibleState)?y.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:m,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(l){return l.iconPath instanceof y.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:d,label:m,resourceUri:a},S,o){if(d)return`${_.ID_HANDLE_PREFIX}/${d}`;const i=u(m,this.extension),s=S?S.item.handle:_.LABEL_HANDLE_PREFIX;let n=i?i.label:a?(0,t.basename)(a):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,h=this.getChildrenNodes(S)||[];let c,w=0;do{if(c=`${s}/${w}:${n}`,o||!this.elements.has(c)||r===c)break;w++}while(w<=h.length);return c}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof y.ThemeIcon))return typeof l.iconPath=="string"||I.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof y.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return I.URI.isUri(l)?l:I.URI.file(l)}addNodeToCache(l,d){this.elements.set(d.item.handle,l),this.nodes.set(l,d)}updateNodeCache(l,d,m,a){this.elements.delete(d.item.handle),this.nodes.delete(l),d.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(l,d);const S=this.getChildrenNodes(a)||[],o=S.filter(i=>i.item.handle===m.item.handle)[0];o&&S.splice(S.indexOf(o),1,d)}addNodeToParentCache(l,d){d?(d.children||(d.children=[]),d.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const d=this.nodes.get(l);if(d){if(d.children)for(const m of d.children){const a=this.elements.get(m.item.handle);a&&this.clear(a)}d.children=void 0}}else this.clearAll()}clear(l){const d=this.nodes.get(l);if(d){if(d.children)for(const m of d.children){const a=this.elements.get(m.item.handle);a&&this.clear(a)}this.nodes.delete(l),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}_.LABEL_HANDLE_PREFIX="0",_.ID_HANDLE_PREFIX="1"}),define(be[281],Ee([1,0,21,12,3,47,2,114,110,150,109,42,5,133,231,230,40,232,37,233,234,235,219,236,45,41,237,238,241,242,243,136,221,248,249,250,88,33,252,280,16,7,255,68,137,36,74,208,240,122,134,70,54,72,11,64,17,26,244,204,51,65,228,253,203,67,66,258,256,257,229,44,251,254,87,53,124,246,69,247,10,118,245,201,239,6,27,209]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E,l,d,m,a,S,o,i,s,n,r,h,c,w,P,L,M,p,U,B,H,re,W,F,q,G,$,X,ie,ae,le,se,ee,fe,ge,ye,Ne,Se,_e,Ie,de,Q,ne,O,x,j,Y,ue,pe,De,Ue,ze,He,Ke,et,Oe,Xe,te,oe,K,we,ke,We,xe,Je,st,mt,vt,qe,at){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function wt(it){const dt=it.get(Ie.IExtHostInitDataService),Ut=it.get(Ke.IExtHostFileSystemInfo),At=it.get(pe.IExtHostConsumerFileSystem),Ct=it.get(i.IExtHostExtensionService),ht=it.get(X.IExtHostWorkspace),Rt=it.get(oe.IExtHostTelemetry),Ft=it.get(E.IExtHostConfiguration),Nt=it.get(Se.IURITransformerService),Ve=it.get(_e.IExtHostRpcService),Ce=it.get(U.IExtHostStorage),Te=it.get(ue.IExtensionStoragePaths),ve=it.get(Ne.ILoggerService),Z=it.get(Ne.ILogService),Ae=it.get(ne.IExtHostTunnelService),Fe=it.get(O.IExtHostApiDeprecationService),je=it.get($.IExtHostWindow),Qe=it.get(Xe.IExtHostSecretState),gt=it.get(te.IExtHostEditorTabs);Ve.set(b.ExtHostContext.ExtHostFileSystemInfo,Ut),Ve.set(b.ExtHostContext.ExtHostLogLevelServiceShape,ve),Ve.set(b.ExtHostContext.ExtHostWorkspace,ht),Ve.set(b.ExtHostContext.ExtHostConfiguration,Ft),Ve.set(b.ExtHostContext.ExtHostExtensionService,Ct),Ve.set(b.ExtHostContext.ExtHostStorage,Ce),Ve.set(b.ExtHostContext.ExtHostTunnelService,Ae),Ve.set(b.ExtHostContext.ExtHostWindow,je),Ve.set(b.ExtHostContext.ExtHostSecretState,Qe),Ve.set(b.ExtHostContext.ExtHostTelemetry,Rt),Ve.set(b.ExtHostContext.ExtHostEditorTabs,gt);const bt=Ve.set(b.ExtHostContext.ExtHostDecorations,it.get(ee.IExtHostDecorations)),Et=Ve.set(b.ExtHostContext.ExtHostDocumentsAndEditors,it.get(o.IExtHostDocumentsAndEditors)),ot=Ve.set(b.ExtHostContext.ExtHostCommands,it.get(v.IExtHostCommands)),ft=Ve.set(b.ExtHostContext.ExtHostTerminalService,it.get(B.IExtHostTerminalService)),ct=Ve.set(b.ExtHostContext.ExtHostDebugService,it.get(ge.IExtHostDebugService)),Mt=Ve.set(b.ExtHostContext.ExtHostSearch,it.get(ye.IExtHostSearch)),_t=Ve.set(b.ExtHostContext.ExtHostTask,it.get(fe.IExtHostTask)),Tt=Ve.set(b.ExtHostContext.ExtHostOutputService,it.get(w.IExtHostOutputService)),It=Ve.set(b.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Ve)),yt=Ve.set(b.ExtHostContext.ExtHostDocuments,new S.ExtHostDocuments(Ve,Et)),Jt=Ve.set(b.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Ve,Et,Z)),Ht=Ve.set(b.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(Z,yt,Ve.getProxy(b.MainContext.MainThreadBulkEdits))),pt=Ve.set(b.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(Ve,ot,Et,yt,Te)),Gt=Ve.set(b.ExtHostContext.ExtHostNotebookDocuments,new st.ExtHostNotebookDocuments(Z,pt)),Xt=Ve.set(b.ExtHostContext.ExtHostNotebookEditors,new Je.ExtHostNotebookEditors(Z,Ve,pt)),Zt=Ve.set(b.ExtHostContext.ExtHostNotebookKernels,new K.ExtHostNotebookKernels(Ve,dt,pt,ot,Z)),li=Ve.set(b.ExtHostContext.ExtHostNotebookRenderers,new ke.ExtHostNotebookRenderers(Ve,pt)),Pt=Ve.set(b.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(Ve,Et)),ei=Ve.set(b.ExtHostContext.ExtHostTreeViews,new re.ExtHostTreeViews(Ve.getProxy(b.MainContext.MainThreadTreeViews),ot,Z)),ci=Ve.set(b.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(Ve.getProxy(b.MainContext.MainThreadEditorInsets),Pt,dt.remote)),Kt=Ve.set(b.ExtHostContext.ExtHostDiagnostics,new l.ExtHostDiagnostics(Ve,Z,Ut)),ti=Ve.set(b.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ve,yt,ot.converter,Nt)),lt=Ve.set(b.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(Ve,Nt,yt,ot,Kt,Z,Fe)),ui=Ve.set(b.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ve,lt)),Bt=Ve.set(b.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(Ve,Z,Et)),$t=Ve.set(b.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(Ve,ht,ot)),ii=Ve.set(b.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ve,ot,Z)),Di=Ve.set(b.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(Ve,ot,yt)),ni=Ve.set(b.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(Ve.getProxy(b.MainContext.MainThreadProgress))),di=Ve.set(b.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ve)),bi=Ve.set(b.ExtHostContext.ExtHostTheming,new Q.ExtHostTheming(Ve)),ri=Ve.set(b.ExtHostContext.ExtHostAuthentication,new x.ExtHostAuthentication(Ve)),Ii=Ve.set(b.ExtHostContext.ExtHostTimeline,new j.ExtHostTimeline(Ve,ot)),hi=Ve.set(b.ExtHostContext.ExtHostWebviews,new G.ExtHostWebviews(Ve,dt.remote,ht,Z,Fe)),fi=Ve.set(b.ExtHostContext.ExtHostWebviewPanels,new ze.ExtHostWebviewPanels(Ve,hi,ht)),ki=Ve.set(b.ExtHostContext.ExtHostCustomEditors,new Ue.ExtHostCustomEditors(Ve,yt,Te,hi,fi)),mi=Ve.set(b.ExtHostContext.ExtHostWebviewViews,new De.ExtHostWebviewViews(Ve,hi)),xt=Ve.set(b.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(Ve,ot)),Ti=Ve.set(b.ExtHostContext.ExtHostUriOpeners,new Oe.ExtHostUriOpeners(Ve));Ve.set(b.ExtHostContext.ExtHostInteractive,new mt.ExtHostInteractive(Ve,pt,Et,ot));const Pi=(0,ie.values)(b.ExtHostContext);Ve.assertRegistered(Pi);const Ai=new He.ExtHostBulkEdits(Ve,Et),si=new u.ExtHostClipboard(Ve),gi=new c.ExtHostMessageService(Ve,Z),Ei=new d.ExtHostDialogs(Ve),_i=new p.ExtHostStatusBar(Ve,ot.converter);return g.ExtHostApiCommands.register(ot),function(Me,Qt,Si){const ut=function(){let ce=!Me.isUnderDevelopment;function me(){ce||(Z.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ce=!0)}return function Re(rt){if(Array.isArray(rt))rt.forEach(Re);else if(typeof rt=="string")me();else{const St=rt;typeof St.scheme=="undefined"&&me(),typeof St.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return rt}}(),Vt={getSession(ce,me,Re){return ri.getSession(Me,ce,me,Re)},async hasSession(ce,me){return(0,qe.checkProposedApiEnabled)(Me,"authSession"),!!await ri.getSession(Me,ce,me,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(ce,me,Re,rt){return ri.registerAuthenticationProvider(ce,me,Re,rt)}},Ri={registerCommand(ce,me,Re){return ot.registerCommand(!0,ce,me,Re,void 0,Me)},registerTextEditorCommand(ce,me,Re){return ot.registerCommand(!0,ce,(...rt)=>{const St=Pt.getActiveTextEditor();if(!St){Z.warn("Cannot execute "+ce+" because there is no active text editor.");return}return St.edit(kt=>{me.apply(Re,[St,kt,...rt])}).then(kt=>{kt||Z.warn("Edits from command "+ce+" were not applied.")},kt=>{Z.warn("An error occurred while running command "+ce,kt)})},void 0,void 0,Me)},registerDiffInformationCommand:(ce,me,Re)=>((0,qe.checkProposedApiEnabled)(Me,"diffCommand"),ot.registerCommand(!0,ce,async(...rt)=>{const St=Et.activeEditor(!0);if(!St){Z.warn("Cannot execute "+ce+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(St.id);me.apply(Re,[kt,...rt])},void 0,void 0,Me)),executeCommand(ce,...me){return ot.executeCommand(ce,...me)},getCommands(ce=!1){return ot.getCommands(ce)}},Ot={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return si.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Me,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Me,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ce=Date.now()-new Date(dt.telemetryInfo.firstSessionDate).getTime();return isNaN(ce)?!1:ce<1e3*60*60*24},openExternal(ce,me){return je.openUri(ce,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(ce){if(ce.scheme===dt.environment.appUriScheme)return It.createAppUri(ce);try{return await je.asExternalUri(ce,{allowTunneling:!!dt.remote.authority})}catch(me){if((0,xe.matchesScheme)(ce,We.Schemas.http)||(0,xe.matchesScheme)(ce,We.Schemas.https))return ce;throw me}},get remoteName(){return(0,se.getRemoteName)(dt.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Me,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind}};dt.environment.extensionTestsLocationURI||Object.freeze(Ot);const Yt=dt.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Li={createTestController(ce,me,Re){return xt.createTestController(ce,me,Re)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),xt.createTestObserver()},runTests(ce){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),xt.runTests(ce)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),xt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Me,"testObserver"),xt.results}},Oi={getExtension(ce){const me=Qt.getExtensionDescription(ce);if(me)return new i.Extension(Ct,Me.identifier,me,Yt)},get all(){return Qt.getAllExtensionDescriptions().map(ce=>new i.Extension(Ct,Me.identifier,ce,Yt))},get onDidChange(){return Qt.onDidChange}},Ni={createDiagnosticCollection(ce){return Kt.createDiagnosticCollection(Me.identifier,ce)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:ce=>Kt.getDiagnostics(ce),getLanguages(){return ti.getLanguages()},setTextDocumentLanguage(ce,me){return ti.changeLanguage(ce.uri,me)},match(ce,me){return(0,N.score)(W.LanguageSelector.from(ce),me.uri,me.languageId,!0,me.notebook?.notebookType)},registerCodeActionsProvider(ce,me,Re){return lt.registerCodeActionProvider(Me,ut(ce),me,Re)},registerCodeLensProvider(ce,me){return lt.registerCodeLensProvider(Me,ut(ce),me)},registerDefinitionProvider(ce,me){return lt.registerDefinitionProvider(Me,ut(ce),me)},registerDeclarationProvider(ce,me){return lt.registerDeclarationProvider(Me,ut(ce),me)},registerImplementationProvider(ce,me){return lt.registerImplementationProvider(Me,ut(ce),me)},registerTypeDefinitionProvider(ce,me){return lt.registerTypeDefinitionProvider(Me,ut(ce),me)},registerHoverProvider(ce,me){return lt.registerHoverProvider(Me,ut(ce),me,Me.identifier)},registerEvaluatableExpressionProvider(ce,me){return lt.registerEvaluatableExpressionProvider(Me,ut(ce),me,Me.identifier)},registerInlineValuesProvider(ce,me){return lt.registerInlineValuesProvider(Me,ut(ce),me,Me.identifier)},registerDocumentHighlightProvider(ce,me){return lt.registerDocumentHighlightProvider(Me,ut(ce),me)},registerLinkedEditingRangeProvider(ce,me){return lt.registerLinkedEditingRangeProvider(Me,ut(ce),me)},registerReferenceProvider(ce,me){return lt.registerReferenceProvider(Me,ut(ce),me)},registerRenameProvider(ce,me){return lt.registerRenameProvider(Me,ut(ce),me)},registerDocumentSymbolProvider(ce,me,Re){return lt.registerDocumentSymbolProvider(Me,ut(ce),me,Re)},registerWorkspaceSymbolProvider(ce){return lt.registerWorkspaceSymbolProvider(Me,ce)},registerDocumentFormattingEditProvider(ce,me){return lt.registerDocumentFormattingEditProvider(Me,ut(ce),me)},registerDocumentRangeFormattingEditProvider(ce,me){return lt.registerDocumentRangeFormattingEditProvider(Me,ut(ce),me)},registerOnTypeFormattingEditProvider(ce,me,Re,...rt){return lt.registerOnTypeFormattingEditProvider(Me,ut(ce),me,[Re].concat(rt))},registerDocumentSemanticTokensProvider(ce,me,Re){return lt.registerDocumentSemanticTokensProvider(Me,ut(ce),me,Re)},registerDocumentRangeSemanticTokensProvider(ce,me,Re){return lt.registerDocumentRangeSemanticTokensProvider(Me,ut(ce),me,Re)},registerSignatureHelpProvider(ce,me,Re,...rt){return typeof Re=="object"?lt.registerSignatureHelpProvider(Me,ut(ce),me,Re):lt.registerSignatureHelpProvider(Me,ut(ce),me,typeof Re=="undefined"?[]:[Re,...rt])},registerCompletionItemProvider(ce,me,...Re){return lt.registerCompletionItemProvider(Me,ut(ce),me,Re)},registerInlineCompletionItemProvider(ce,me){return(0,qe.checkProposedApiEnabled)(Me,"inlineCompletions"),lt.registerInlineCompletionsProvider(Me,ut(ce),me)},registerInlineCompletionItemProviderNew(ce,me){if((0,qe.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),me.handleDidShowCompletionItem&&!(0,qe.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return lt.registerInlineCompletionsProviderNew(Me,ut(ce),me)},registerDocumentLinkProvider(ce,me){return lt.registerDocumentLinkProvider(Me,ut(ce),me)},registerColorProvider(ce,me){return lt.registerColorProvider(Me,ut(ce),me)},registerFoldingRangeProvider(ce,me){return lt.registerFoldingRangeProvider(Me,ut(ce),me)},registerSelectionRangeProvider(ce,me){return lt.registerSelectionRangeProvider(Me,ce,me)},registerCallHierarchyProvider(ce,me){return lt.registerCallHierarchyProvider(Me,ce,me)},registerTypeHierarchyProvider(ce,me){return lt.registerTypeHierarchyProvider(Me,ce,me)},setLanguageConfiguration:(ce,me)=>lt.setLanguageConfiguration(Me,ce,me),getTokenInformationAtPosition(ce,me){return(0,qe.checkProposedApiEnabled)(Me,"tokenInformation"),ti.tokenAtPosition(ce,me)},registerInlayHintsProvider(ce,me){return lt.registerInlayHintsProvider(Me,ce,me)},createLanguageStatusItem(ce,me){return ti.createLanguageStatusItem(Me,ce,me)}},Fi={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ce,me,Re){const rt=await(D.URI.isUri(ce)?Promise.resolve(Ci.openTextDocument(ce)):Promise.resolve(ce));return Pt.showTextDocument(rt,me,Re)},createTextEditorDecorationType(ce){return Pt.createTextEditorDecorationType(Me,ce)},onDidChangeActiveTextEditor(ce,me,Re){return Pt.onDidChangeActiveTextEditor(ce,me,Re)},onDidChangeVisibleTextEditors(ce,me,Re){return Pt.onDidChangeVisibleTextEditors(ce,me,Re)},onDidChangeTextEditorSelection(ce,me,Re){return Pt.onDidChangeTextEditorSelection(ce,me,Re)},onDidChangeTextEditorOptions(ce,me,Re){return Pt.onDidChangeTextEditorOptions(ce,me,Re)},onDidChangeTextEditorVisibleRanges(ce,me,Re){return Pt.onDidChangeTextEditorVisibleRanges(ce,me,Re)},onDidChangeTextEditorViewColumn(ce,me,Re){return Pt.onDidChangeTextEditorViewColumn(ce,me,Re)},onDidCloseTerminal(ce,me,Re){return ft.onDidCloseTerminal(ce,me,Re)},onDidOpenTerminal(ce,me,Re){return ft.onDidOpenTerminal(ce,me,Re)},onDidChangeActiveTerminal(ce,me,Re){return ft.onDidChangeActiveTerminal(ce,me,Re)},onDidChangeTerminalDimensions(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"terminalDimensions"),ft.onDidChangeTerminalDimensions(ce,me,Re)},onDidChangeTerminalState(ce,me,Re){return ft.onDidChangeTerminalState(ce,me,Re)},onDidWriteTerminalData(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(ce,me,Re)},get state(){return je.state},onDidChangeWindowState(ce,me,Re){return je.onDidChangeWindowState(ce,me,Re)},showInformationMessage(ce,...me){return gi.showMessage(Me,T.default.Info,ce,me[0],me.slice(1))},showWarningMessage(ce,...me){return gi.showMessage(Me,T.default.Warning,ce,me[0],me.slice(1))},showErrorMessage(ce,...me){return gi.showMessage(Me,T.default.Error,ce,me[0],me.slice(1))},showQuickPick(ce,me,Re){return $t.showQuickPick(ce,me,Re)},showWorkspaceFolderPick(ce){return $t.showWorkspaceFolderPick(ce)},showInputBox(ce,me){return ce?.validateInput2&&((0,qe.checkProposedApiEnabled)(Me,"inputBoxSeverity"),ce.validateInput=ce.validateInput2),$t.showInput(ce,me)},showOpenDialog(ce){return Ei.showOpenDialog(ce)},showSaveDialog(ce){return Ei.showSaveDialog(ce)},createStatusBarItem(ce,me,Re){let rt,St,kt;return typeof ce=="string"?(rt=ce,St=me,kt=Re):(St=ce,kt=me),_i.createStatusBarEntry(Me,rt,St,kt)},setStatusBarMessage(ce,me){return _i.setStatusBarMessage(ce,me)},withScmProgress(ce){return Fe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ni.withProgress(Me,{location:F.ProgressLocation.SourceControl},(me,Re)=>ce({report(rt){}}))},withProgress(ce,me){return ni.withProgress(Me,ce,me)},createOutputChannel(ce,me){return Tt.createOutputChannel(ce,me,Me)},createWebviewPanel(ce,me,Re,rt){return fi.createWebviewPanel(Me,ce,me,Re,rt)},createWebviewTextEditorInset(ce,me,Re,rt){return(0,qe.checkProposedApiEnabled)(Me,"editorInsets"),ci.createWebviewEditorInset(ce,me,Re,rt,Me)},createTerminal(ce,me,Re){return typeof ce=="object"?"pty"in ce?ft.createExtensionTerminal(ce):ft.createTerminalFromOptions(ce):ft.createTerminal(ce,me,Re)},registerTerminalLinkProvider(ce){return ft.registerLinkProvider(ce)},registerTerminalProfileProvider(ce,me){return ft.registerProfileProvider(Me,ce,me)},registerTreeDataProvider(ce,me){return ei.registerTreeDataProvider(ce,me,Me)},createTreeView(ce,me){return ei.createTreeView(ce,me,Me)},registerWebviewPanelSerializer:(ce,me)=>fi.registerWebviewPanelSerializer(Me,ce,me),registerCustomEditorProvider:(ce,me,Re={})=>ki.registerCustomEditorProvider(Me,ce,me,Re),registerFileDecorationProvider(ce){return bt.registerFileDecorationProvider(ce,Me.identifier)},registerUriHandler(ce){return It.registerUriHandler(Me.identifier,ce)},createQuickPick(){return $t.createQuickPick(Me)},createInputBox(){return $t.createInputBox(Me)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(ce,me,Re){return bi.onDidChangeActiveColorTheme(ce,me,Re)},registerWebviewViewProvider(ce,me,Re){return mi.registerWebviewViewProvider(Me,ce,me,Re?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.onDidChangeActiveNotebookEditor(ce,me,Re)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(ce,me,Re)},onDidChangeNotebookEditorVisibleRanges(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(ce,me,Re)},showNotebookDocument(ce,me){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.showNotebookDocument(ce,me)},registerExternalUriOpener(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"externalUriOpener"),Ti.registerExternalUriOpener(Me.identifier,ce,me,Re)},get tabGroups(){return(0,qe.checkProposedApiEnabled)(Me,"tabs"),gt.tabGroups},getInlineCompletionItemController(ce){return(0,qe.checkProposedApiEnabled)(Me,"inlineCompletions"),r.InlineCompletionController.get(ce)}},Ci={get rootPath(){return Fe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ce){throw t.readonly()},getWorkspaceFolder(ce){return ht.getWorkspaceFolder(ce)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ce){throw t.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ce){throw t.readonly()},updateWorkspaceFolders:(ce,me,...Re)=>ht.updateWorkspaceFolders(Me,ce,me||0,...Re),onDidChangeWorkspaceFolders:function(ce,me,Re){return ht.onDidChangeWorkspace(ce,me,Re)},asRelativePath:(ce,me)=>ht.getRelativePath(ce,me),findFiles:(ce,me,Re,rt)=>ht.findFiles(ce,me,Re,Me.identifier,rt),findTextInFiles:(ce,me,Re,rt)=>{(0,qe.checkProposedApiEnabled)(Me,"findTextInFiles");let St,kt;return typeof me=="object"?(St=me,kt=Re):(St={},kt=me,rt=Re),ht.findTextInFiles(ce,St||{},kt,Me.identifier,rt)},saveAll:ce=>ht.saveAll(ce),applyEdit(ce){return Ai.applyWorkspaceEdit(ce)},createFileSystemWatcher:(ce,me,Re,rt)=>Bt.createFileSystemWatcher(ht,Me,ce,me,Re,rt),get textDocuments(){return yt.getAllDocumentData().map(ce=>ce.document)},set textDocuments(ce){throw t.readonly()},openTextDocument(ce){let me;const Re=ce;if(typeof ce=="string")me=Promise.resolve(D.URI.file(ce));else if(D.URI.isUri(ce))me=Promise.resolve(ce);else if(!Re||typeof Re=="object")me=yt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(rt=>yt.ensureDocumentData(rt).then(St=>St.document))},onDidOpenTextDocument:(ce,me,Re)=>yt.onDidAddDocument(ce,me,Re),onDidCloseTextDocument:(ce,me,Re)=>yt.onDidRemoveDocument(ce,me,Re),onDidChangeTextDocument:(ce,me,Re)=>yt.onDidChangeDocument(ce,me,Re),onDidSaveTextDocument:(ce,me,Re)=>yt.onDidSaveDocument(ce,me,Re),onWillSaveTextDocument:(ce,me,Re)=>Ht.getOnWillSaveTextDocumentEvent(Me)(ce,me,Re),onWillDropOnTextEditor:(ce,me,Re)=>((0,qe.checkProposedApiEnabled)(Me,"textEditorDrop"),Pt.onWillDropOnTextEditor(ce,me,Re)),get notebookDocuments(){return pt.notebookDocuments.map(ce=>ce.apiNotebook)},async openNotebookDocument(ce,me){let Re;if(D.URI.isUri(ce))Re=ce,await pt.openNotebookDocument(ce);else if(typeof ce=="string")Re=D.URI.revive(await pt.createNotebookDocument({viewType:ce,content:me}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookDocumentEvents"),Gt.onDidSaveNotebookDocument(ce,me,Re)},onDidChangeNotebookDocument(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookDocumentEvents"),Gt.onDidChangeNotebookDocument(ce,me,Re)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ce,me,Re,rt){return pt.registerNotebookSerializer(Me,ce,me,Re,(0,qe.isProposedApiEnabled)(Me,"notebookLiveShare")?rt:void 0)},registerNotebookContentProvider:(ce,me,Re,rt)=>((0,qe.checkProposedApiEnabled)(Me,"notebookContentProvider"),pt.registerNotebookContentProvider(Me,ce,me,Re,(0,qe.isProposedApiEnabled)(Me,"notebookLiveShare")?rt:void 0)),onDidChangeConfiguration:(ce,me,Re)=>Si.onDidChangeConfiguration(ce,me,Re),getConfiguration(ce,me){return me=arguments.length===1?void 0:me,Si.getConfiguration(ce,me,Me)},registerTextDocumentContentProvider(ce,me){return Jt.registerTextDocumentContentProvider(ce,me)},registerTaskProvider:(ce,me)=>(Fe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Me,ce,me)),registerFileSystemProvider(ce,me,Re){return(0,vt.combinedDisposable)(ui.registerFileSystemProvider(Me,ce,me,Re),At.addFileSystemProvider(ce,me))},get fs(){return At.value},registerFileSearchProvider:(ce,me)=>((0,qe.checkProposedApiEnabled)(Me,"fileSearchProvider"),Mt.registerFileSearchProvider(ce,me)),registerTextSearchProvider:(ce,me)=>((0,qe.checkProposedApiEnabled)(Me,"textSearchProvider"),Mt.registerTextSearchProvider(ce,me)),registerRemoteAuthorityResolver:(ce,me)=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),Ct.registerRemoteAuthorityResolver(ce,me)),registerResourceLabelFormatter:ce=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),di.$registerResourceLabelFormatter(ce)),onDidCreateFiles:(ce,me,Re)=>Bt.onDidCreateFile(ce,me,Re),onDidDeleteFiles:(ce,me,Re)=>Bt.onDidDeleteFile(ce,me,Re),onDidRenameFiles:(ce,me,Re)=>Bt.onDidRenameFile(ce,me,Re),onWillCreateFiles:(ce,me,Re)=>Bt.getOnWillCreateFileEvent(Me)(ce,me,Re),onWillDeleteFiles:(ce,me,Re)=>Bt.getOnWillDeleteFileEvent(Me)(ce,me,Re),onWillRenameFiles:(ce,me,Re)=>Bt.getOnWillRenameFileEvent(Me)(ce,me,Re),openTunnel:ce=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),Ae.openTunnel(Me,ce).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Me,"resolvers"),Ae.getTunnels()},onDidChangeTunnels:(ce,me,Re)=>((0,qe.checkProposedApiEnabled)(Me,"resolvers"),Ae.onDidChangeTunnels(ce,me,Re)),registerPortAttributesProvider:(ce,me)=>((0,qe.checkProposedApiEnabled)(Me,"portsAttributes"),Ae.registerPortsAttributesProvider(ce,me)),registerTimelineProvider:(ce,me)=>((0,qe.checkProposedApiEnabled)(Me,"timeline"),Ii.registerTimelineProvider(ce,me,Me.identifier,ot.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ce=>((0,qe.checkProposedApiEnabled)(Me,"workspaceTrust"),ht.requestWorkspaceTrust(ce)),onDidGrantWorkspaceTrust:(ce,me,Re)=>ht.onDidGrantWorkspaceTrust(ce,me,Re)},Mi={get inputBox(){return Fe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ii.getLastInputBox(Me)},createSourceControl(ce,me,Re){return ii.createSourceControl(Me,ce,me,Re)}},Ui={createCommentController(ce,me){return Di.createCommentController(Me,ce,me)}},pi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ce,me,Re){return ct.onDidStartDebugSession(ce,me,Re)},onDidTerminateDebugSession(ce,me,Re){return ct.onDidTerminateDebugSession(ce,me,Re)},onDidChangeActiveDebugSession(ce,me,Re){return ct.onDidChangeActiveDebugSession(ce,me,Re)},onDidReceiveDebugSessionCustomEvent(ce,me,Re){return ct.onDidReceiveDebugSessionCustomEvent(ce,me,Re)},onDidChangeBreakpoints(ce,me,Re){return ct.onDidChangeBreakpoints(ce,me,Re)},registerDebugConfigurationProvider(ce,me,Re){return ct.registerDebugConfigurationProvider(ce,me,Re||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ce,me){return ct.registerDebugAdapterDescriptorFactory(Me,ce,me)},registerDebugAdapterTrackerFactory(ce,me){return ct.registerDebugAdapterTrackerFactory(ce,me)},startDebugging(ce,me,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(ce,me,{parentSession:Re}):ct.startDebugging(ce,me,Re||{})},stopDebugging(ce){return ct.stopDebugging(ce)},addBreakpoints(ce){return ct.addBreakpoints(ce)},removeBreakpoints(ce){return ct.removeBreakpoints(ce)},asDebugSourceUri(ce,me){return ct.asDebugSourceUri(ce,me)}},Bi={registerTaskProvider:(ce,me)=>_t.registerTaskProvider(Me,ce,me),fetchTasks:ce=>_t.fetchTasks(ce),executeTask:ce=>_t.executeTask(Me,ce),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(ce,me,Re)=>_t.onDidStartTask(ce,me,Re),onDidEndTask:(ce,me,Re)=>_t.onDidEndTask(ce,me,Re),onDidStartTaskProcess:(ce,me,Re)=>_t.onDidStartTaskProcess(ce,me,Re),onDidEndTaskProcess:(ce,me,Re)=>_t.onDidEndTaskProcess(ce,me,Re)},Wi={createNotebookController(ce,me,Re,rt,St){return Zt.createNotebookController(Me,ce,me,Re,rt,(0,qe.isProposedApiEnabled)(Me,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ce,me)=>pt.registerNotebookCellStatusBarItemProvider(Me,ce,me),get onDidSaveNotebookDocument(){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),Gt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ce){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(ce)},createRendererMessaging(ce){return li.createRendererMessaging(Me,ce)},onDidChangeNotebookDocumentMetadata(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),Gt.onDidChangeNotebookDocumentMetadata(ce,me,Re)},onDidChangeNotebookCells(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.onDidChangeNotebookCells(ce,me,Re)},onDidChangeNotebookCellExecutionState(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ce,me,Re)},onDidChangeCellOutputs(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.onDidChangeCellOutputs(ce,me,Re)},onDidChangeCellMetadata(ce,me,Re){return(0,qe.checkProposedApiEnabled)(Me,"notebookEditor"),pt.onDidChangeCellMetadata(ce,me,Re)},createConcatTextDocument(ce,me){return(0,qe.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new Y.ExtHostNotebookConcatDocument(pt,yt,ce,me)}};return{version:dt.version,authentication:Vt,commands:Ri,comments:Ui,debug:pi,env:Ot,extensions:Oi,languages:Ni,notebooks:Wi,scm:Mi,tasks:Bi,tests:Li,window:Fi,workspace:Ci,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:b.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:I.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:R.FileType,FilePermission:R.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestions,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:A.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:C.UIKind,Uri:D.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:we.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabKindText:F.TextTabInput,TabKindTextDiff:F.TextDiffTabInput,TabKindCustom:F.CustomEditorTabInput,TabKindNotebook:F.NotebookEditorTabInput,TabKindNotebookDiff:F.NotebookDiffEditorTabInput,TabKindWebview:F.WebviewEditorTabInput,TabKindTerminal:F.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=wt}),define(be[282],Ee([1,0,283,292,293,2,294]),function(J,e,f,t,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(R,b,C,g,u,v){const _=v.environment.useHostProxy,E=typeof _=="boolean"?_:!v.remote.isRemote,l=(0,D.createProxyResolver)({resolveProxy:m=>R.resolveProxy(m),getHttpProxySetting:()=>b.getConfiguration("http").get("proxy"),log:(m,a,...S)=>{switch(m){case D.LogLevel.Trace:g.trace(a,...S);break;case D.LogLevel.Debug:g.debug(a,...S);break;case D.LogLevel.Info:g.info(a,...S);break;case D.LogLevel.Warning:g.warn(a,...S);break;case D.LogLevel.Error:g.error(a,...S);break;case D.LogLevel.Critical:g.critical(a,...S);break;case D.LogLevel.Off:break;default:o(m,a,S);break}function o(i,s,...n){g.error("Unknown log level",i),g.error(s,...n)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:E,env:process.env}),d=y(b,l);return N(C,d)}e.connectProxyResolver=k;function y(R,b){const C={config:R.getConfiguration("http").get("proxySupport")||"off"};R.onDidChangeConfiguration(u=>{C.config=R.getConfiguration("http").get("proxySupport")||"off"});const g={config:!!R.getConfiguration("http").get("systemCertificates")};return R.onDidChangeConfiguration(u=>{g.config=!!R.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,D.createHttpPatch)(f,b,{config:"off"},g,!0)),on:Object.assign({},f,(0,D.createHttpPatch)(f,b,{config:"on"},g,!0)),override:Object.assign({},f,(0,D.createHttpPatch)(f,b,{config:"override"},g,!0)),onRequest:Object.assign({},f,(0,D.createHttpPatch)(f,b,C,g,!0)),default:Object.assign(f,(0,D.createHttpPatch)(f,b,C,g,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,b,{config:"off"},g,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,b,{config:"on"},g,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,b,{config:"override"},g,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,b,C,g,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,b,C,g,!1))},tls:Object.assign(I,(0,D.createTlsPatch)(I))}}const A=new Map;function N(R,b){return R.getExtensionPathIndex().then(C=>{const g=J.__$__nodeRequire("module"),u=g._load;g._load=function(_,E,l){if(_==="tls")return b.tls;if(_!=="http"&&_!=="https")return u.apply(this,arguments);const d=b[_],m=C.findSubstr(T.URI.file(E.filename));let a=A.get(m);if(a||A.set(m,a={}),!a[_]){let S=d.default;a[_]={...S}}return a[_]}})}}),define(be[140],Ee([1,0,39,295,103,18,74,34,9,8,2,31,69,296,276,89]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class _{constructor(c){this.outputChannel=c}provideTextSearchResults(c,w,P,L){return this.outputChannel.appendLine(`provideTextSearchResults ${c.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((M,p)=>{L.onCancellationRequested(()=>G());const U=S(c,w),B=w.folder.fsPath,H=U.map(le=>le.match(/^-/)?le:`'${le}'`).join(" ");this.outputChannel.appendLine(`${v} ${H}
 - cwd: ${B}`);let re=f.spawn(v,U,{cwd:B});re.on("error",le=>{console.error(le),this.outputChannel.appendLine("Error: "+(le&&le.message)),p((0,R.serializeSearchError)(new R.SearchError(le&&le.message,R.SearchErrorCode.rgProcessError)))});let W=!1;const F=new d(w.maxResults,B,w.previewOptions);F.on("result",le=>{W=!0,X="",P.report(le)});let q=!1;const G=()=>{q=!0,re&&re.kill(),F&&F.cancel()};let $=!1;F.on("hitLimit",()=>{$=!0,G()});let X="";re.stdout.on("data",le=>{F.handleData(le),W||(X+=le)});let ie=!1;re.stdout.once("data",()=>ie=!0);let ae="";re.stderr.on("data",le=>{const se=le.toString();this.outputChannel.appendLine(se),ae+=se}),re.on("close",()=>{if(this.outputChannel.appendLine(ie?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(W?"Got result from parser":"No result from parser"),X&&this.outputChannel.appendLine(`Got data without result: ${X}`),this.outputChannel.appendLine(""),q)M({limitHit:$});else{F.flush(),re=null;let le;ae&&!ie&&(le=E(ae))?p((0,R.serializeSearchError)(new R.SearchError(le.message,le.code))):M({limitHit:$})}})})}}e.RipgrepTextSearchEngine=_;function E(h){const c=h.split(`
`),w=c[0].trim();if(c.some(L=>L.startsWith("regex parse error")))return new R.SearchError(l(c),R.SearchErrorCode.regexParseError);const P=w.match(/grep config error: unknown encoding: (.*)/);if(P)return new R.SearchError(`Unknown encoding: ${P[1]}`,R.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new R.SearchError(w.charAt(0).toUpperCase()+w.substr(1),R.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new R.SearchError(w.charAt(0).toUpperCase()+w.substr(1),R.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new R.SearchError(w,R.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function l(h){const c=["Regex parse error"],w=h.filter(P=>P.startsWith("PCRE2:"));if(w.length>=1){const P=w[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const L=P.split(":")[1];c.push(":"+L)}}return c.join("")}e.buildRegexParseError=l;class d extends t.EventEmitter{constructor(c,w,P){super();this.maxResults=c,this.rootFolder=w,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(c,w){return super.on(c,w),this}handleData(c){if(this.isDone)return;const w=typeof c=="string"?c:this.stringDecoder.write(c);this.handleDecodedData(w)}handleDecodedData(c){let w=c.indexOf(`
`);const P=this.remainder+c;if(w>=0)w+=this.remainder.length;else{this.remainder=P;return}let L=0;for(;w>=0;)this.handleLine(P.substring(L,w).trim()),L=w+1,w=P.indexOf(`
`,L);this.remainder=P.substring(L)}handleLine(c){if(this.isDone||!c)return;let w;try{w=JSON.parse(c)}catch{throw new Error(`malformed line from rg: ${c}`)}if(w.type==="match"){const P=m(w.data.path),L=N.URI.file(y.join(this.rootFolder,P)),M=this.createTextSearchMatch(w.data,L);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const P=m(w.data.path),L=N.URI.file(y.join(this.rootFolder,P));this.createTextSearchContext(w.data,L).forEach(p=>this.onResult(p))}}createTextSearchMatch(c,w){const P=c.line_number-1,L=m(c.lines),M=Buffer.from(L);let p=0,U=0,B=P;c.submatches.length===0&&c.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const H=(0,T.coalesce)(c.submatches.map((re,W)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=m(re.match),q=M.slice(p,re.start).toString().length,G=U+q,$=a(F),X=B,ie=$.numLines+X,ae=$.numLines>0?$.lastLineLength:$.lastLineLength+G;return p=re.end,U=ae,B=ie,new b.Range(X,G,ie,ae)}));return(0,u.createTextSearchResult)(w,L,H,this.previewOptions)}createTextSearchContext(c,w){const P=m(c.lines),L=c.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((M,p)=>({text:M,uri:w,lineNumber:L+p}))}onResult(c){this.emit("result",c)}}e.RipgrepParser=d;function m(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function a(h){const c=/\n/g;let w=0,P=-1,L;for(;L=c.exec(h);)w++,P=L.index;const M=P>=0?h.length-P-1:h.length;return{numLines:w,lastLineLength:M}}function S(h,c){const w=["--hidden"];w.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:L}=(0,D.groupBy)(c.includes,p=>p.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const p=new Set;L.forEach(U=>{p.add(U)}),w.push("-g","!*"),p.forEach(U=>{o(U).map(u.anchorGlob).forEach(B=>{w.push("-g",B)})})}P&&P.length&&P.forEach(p=>{w.push("-g",p)}),c.excludes.map(u.anchorGlob).forEach(p=>w.push("-g",`!${p}`)),c.maxFileSize&&w.push("--max-filesize",c.maxFileSize+""),c.useIgnoreFiles?c.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),c.followSymlinks&&w.push("--follow"),c.encoding&&c.encoding!=="utf8"&&w.push("--encoding",c.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,A.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),c.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),w.push("--engine","auto"));let M;if(h.isWordMatch){const U=(0,A.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",U)}else if(h.isRegExp){let p=n(h.pattern);p=r(p),w.push("--regexp",p)}else M=h.pattern,w.push("--fixed-strings");return w.push("--no-config"),c.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),h.isMultiline&&w.push("--multiline"),c.beforeContext&&w.push("--before-context",c.beforeContext+""),c.afterContext&&w.push("--after-context",c.afterContext+""),w.push("--"),M&&w.push(M),w.push("."),w}function o(h){const c=(0,k.splitGlobAware)(h,"/");return c.map((w,P)=>c.slice(0,P+1).join("/"))}e.spreadGlobComponents=o;function i(h){const c=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(c);)h=h.replace(c,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(w);)h=h.replace(w,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=i;const s=h=>h.type==="Assertion"&&h.kind==="lookbehind";function n(h){let c;try{c=new C.RegExpParser().parsePattern(h)}catch{return h}let w="",P=0;const L=(U,B,H)=>{w+=h.slice(P,U)+H,P=B},M=[];return new C.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const B=M[0];if(!B)L(U.start,U.end,"\\r?\\n");else if(!M.some(s))if(B.type==="CharacterClass")if(B.negate){const H=h.slice(B.start+2,U.start)+h.slice(U.end,B.end-1);B.parent?.type==="Quantifier"?L(B.start,B.end,H?`[^${H}]`:"."):L(B.start,B.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=h.slice(B.start+1,U.start)+h.slice(U.end,B.end-1);L(B.start,B.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else B.type==="Quantifier"&&L(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){M.unshift(U)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(U){M.unshift(U)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(U){M.unshift(U)},onCharacterClassLeave(){M.shift()},onAssertionEnter(U){s(U)&&M.push(U)},onAssertionLeave(U){M[0]===U&&M.shift()}}).visit(c),w+=h.slice(P),w}e.fixRegexNewline=n;function r(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=r}),define(be[284],Ee([1,0,21,140,119,10]),function(J,e,f,t,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,N,R,b){const C=new t.RipgrepTextSearchEngine(this.outputChannel);if(N.folder.scheme===T.Schemas.vscodeUserData){const g={...N,folder:N.folder.with({scheme:T.Schemas.file})},u=new I.Progress(v=>R.report({...v,uri:v.uri.with({scheme:N.folder.scheme})}));return this.withToken(b,v=>C.provideTextSearchResults(A,g,u,v))}else return this.withToken(b,g=>C.provideTextSearchResults(A,N,R,g))}async withToken(A,N){const R=k(A);this.inProgress.add(R);const b=await N(R.token);return this.inProgress.delete(R),b}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=D;function k(y){const A=new f.CancellationTokenSource;return y.onCancellationRequested(()=>A.cancel()),A}}),define(be[285],Ee([1,0,29,140,139]),function(J,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(y){this.query=y}search(y,A,N){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const R={appendLine(C){N({message:C})}},b=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(R),f);return new Promise((C,g)=>b.search(u=>{A(u.map(D))},y).then(u=>C({limitHit:u.limitHit,type:"success",stats:u.stats}),g))}}e.TextSearchEngineAdapter=T;function D(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,A)=>{if(A.ranges){const N=A;return y+(Array.isArray(N.ranges)?N.ranges.length:1)}else return y+1},0)}}}),define(be[286],Ee([1,0,18,15,12,3,99,9,46,2,42,31,277,285]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class g{constructor(d="searchProcess"){this.processType=d,this.caches=Object.create(null)}fileSearch(d){let m;const a=_(d),S=new T.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(b.Engine,a,i=>S.fire(i),o)),m.then(o=>S.fire(o),o=>S.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return S.event}textSearch(d){let m;const a=_(d),S=new T.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(a,i=>S.fire(i),o)),m.then(o=>S.fire(o),o=>S.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return S.event}ripgrepTextSearch(d,m,a){return d.maxFileSize=(0,N.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(d).search(a,m,m)}doFileSearch(d,m,a){return this.doFileSearchWithEngine(b.Engine,d,m,a)}doFileSearchWithEngine(d,m,a,S,o=g.BATCH_SIZE){let i=0;const s=r=>{Array.isArray(r)?(i+=r.length,a(r.map(h=>this.rawMatchToSearchItem(h)))):r.relativePath?(i++,a(this.rawMatchToSearchItem(r))):a(r)};if(m.sortByScore){let r=this.trySortedSearchFromCache(m,s,S);if(!r){const h=m.maxResults?Object.assign({},m,{maxResults:null}):m,c=new d(h);r=this.doSortedSearch(c,m,a,s,S)}return new Promise((h,c)=>{r.then(([w,P])=>{const L=P.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(L,a,o),h(w)},c)})}const n=new d(m);return this.doSearch(n,s,o,S).then(r=>({limitHit:r.limitHit,type:"success",stats:{detailStats:r.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(d){return{path:d.base?(0,k.join)(d.base,d.relativePath):d.relativePath}}doSortedSearch(d,m,a,S,o){const i=new T.Emitter;let s=(0,t.createCancelablePromise)(r=>{let h=[];const c=w=>{Array.isArray(w)?h=w:(S(w),i.fire(w))};return this.doSearch(d,c,-1,r).then(w=>[w,h])}),n;if(m.cacheKey){n=this.getOrCreateCache(m.cacheKey);const r={promise:s,event:i.event,resolved:!1};n.resultsToSearchCache[m.filePattern||""]=r,s.then(()=>{r.resolved=!0},h=>{delete n.resultsToSearchCache[m.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([r,h])=>{const c=n?n.scorerCache:Object.create(null),w=(typeof m.maxResults!="number"||m.maxResults>0)&&y.StopWatch.create(!1);return this.sortResults(m,h,c,o).then(P=>{const L=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:r.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:P.length},messages:r.messages,limitHit:r.limitHit||typeof m.maxResults=="number"&&h.length>m.maxResults},P]})})}getOrCreateCache(d){const m=this.caches[d];return m||(this.caches[d]=new u)}trySortedSearchFromCache(d,m,a){const S=d.cacheKey&&this.caches[d.cacheKey];if(!S)return;const o=this.getResultsFromCache(S,d.filePattern||"",m,a);if(o)return o.then(([i,s,n])=>{const r=y.StopWatch.create(!1);return this.sortResults(d,s,S.scorerCache,a).then(h=>{const c=r.elapsed(),w={fromCache:!0,detailStats:n,type:this.processType,resultCount:s.length,sortingTime:c};return[{type:"success",limitHit:i.limitHit||typeof d.maxResults=="number"&&s.length>d.maxResults,stats:w},h]})})}sortResults(d,m,a,S){const o=(0,D.prepareQuery)(d.filePattern||""),i=(n,r)=>(0,D.compareItemsByFuzzyScore)(n,r,o,!0,v,a),s=typeof d.maxResults=="number"?d.maxResults:Number.MAX_VALUE;return f.topAsync(m,i,s,1e4,S)}sendProgress(d,m,a){if(a&&a>0)for(let S=0;S<d.length;S+=a)m(d.slice(S,S+a));else m(d)}getResultsFromCache(d,m,a,S){const o=y.StopWatch.create(!1),i=m.indexOf(k.sep)>=0;let s;for(const c in d.resultsToSearchCache)if(m.startsWith(c)){if(i&&c.indexOf(k.sep)<0&&c!=="")continue;const w=d.resultsToSearchCache[c];s={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!s)return null;const n=o.elapsed(),r=y.StopWatch.create(!1),h=s.event(a);return S&&S.onCancellationRequested(()=>{h.dispose()}),s.promise.then(([c,w])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const P=[],L=(0,D.prepareQuery)(m).normalizedLowercase;for(const M of w)!(0,R.isFilePatternMatch)(M,L)||P.push(M);return[c,P,{cacheWasResolved:s.resolved,cacheLookupTime:n,cacheFilterTime:r.elapsed(),cacheEntryCount:w.length}]})}doSearch(d,m,a,S){return new Promise((o,i)=>{let s=[];S&&S.onCancellationRequested(()=>d.cancel()),d.search(n=>{n&&(a?(s.push(n),a>0&&s.length>=a&&(m(s),s=[])):m(n))},n=>{m(n)},(n,r)=>{s.length&&m(s),n?i(n):o(r)})})}clearCache(d){return delete this.caches[d],Promise.resolve(void 0)}preventCancellation(d){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,a){return d.then(m,a)}catch(m){return this.then(void 0,m)}finally(m){return d.finally(m)}}}}e.SearchService=g,g.BATCH_SIZE=512;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(l){return(0,k.basename)(l.relativePath)}getItemDescription(l){return(0,k.dirname)(l.relativePath)}getItemPath(l){return l.relativePath}};function _(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(E),extraFileResources:l.extraFileResources&&l.extraFileResources.map(d=>A.URI.revive(d))}}function E(l){return{...l,folder:A.URI.revive(l.folder)}}}),define(be[287],Ee([1,0,6,10,2,29,11,26,17,72,64,31,286,284,89,139]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends A.ExtHostSearch{constructor(E,l,d,m){super(E,d,m);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new g.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new C.RipgrepSearchProvider(a)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new g.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new C.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(t.Schemas.file,new b.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,l){const d=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(E)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(E,l,d,m){const a=(0,A.reviveQuery)(d);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,l,a,m):super.$provideFileSearchResults(E,l,d,m)}doInternalFileSearch(E,l,d,m){const a=S=>{if((0,R.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(E,l,S.map(o=>I.URI.file(o.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,a,m)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,l){return new u.NativeTextSearchManager(E,l,void 0,"textSearchProvider")}};v=$e([Be(0,y.IExtHostRpcService),Be(1,k.IExtHostInitDataService),Be(2,N.IURITransformerService),Be(3,D.ILogService)],v),e.NativeExtHostSearch=v}),define(be[141],Ee([1,0,297,128,60,22,12,3,6,9,13,32,105,106,298]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(w,P=""){this.debugLabel=P,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,D.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,P){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const P=L=>{this.traceSocketEvent("read",L),w(T.VSBuffer.wrap(L))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(w){const P=L=>{this.traceSocketEvent("close",{hadError:L}),w({type:0,hadError:L,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(w){const P=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,D.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,D.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=u;var v;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var _;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(_||(_={}));class E extends y.Disposable{constructor(w,P,L,M){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:L?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new l(this,P,L,M,this._onData,(p,U)=>this._write(p,U))),this._register(this._flowManager.onError(p=>{console.error(p),(0,D.onUnexpectedError)(p),this._onClose.fire({type:0,hadError:!0,error:p})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(p=>this._acceptChunk(p))),this._register(this.socket.onClose(p=>this._onClose.fire(p)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,P){this.socket.traceSocketEvent(w,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let L=2;w.byteLength<126?L+=0:w.byteLength<2**16?L+=2:L+=8;const M=T.VSBuffer.alloc(L);if(P?M.writeUInt8(194,0):M.writeUInt8(130,0),w.byteLength<126)M.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){M.writeUInt8(126,1);let p=1;M.writeUInt8(w.byteLength>>>8&255,++p),M.writeUInt8(w.byteLength>>>0&255,++p)}else{M.writeUInt8(127,1);let p=1;M.writeUInt8(0,++p),M.writeUInt8(0,++p),M.writeUInt8(0,++p),M.writeUInt8(0,++p),M.writeUInt8(w.byteLength>>>24&255,++p),M.writeUInt8(w.byteLength>>>16&255,++p),M.writeUInt8(w.byteLength>>>8&255,++p),M.writeUInt8(w.byteLength>>>0&255,++p)}this.socket.write(T.VSBuffer.concat([M,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),L=P.readUInt8(0),M=(L&128)>>>7,p=(L&64)>>>6,U=P.readUInt8(1),B=(U&128)>>>7,H=U&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(p)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),L=P.readUInt8(1),M=(L&128)>>>7;let p=L&127,U=1;p===126?p=P.readUInt8(++U)*2**8+P.readUInt8(++U):p===127&&(p=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let B=0;M&&(B=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=p,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),a(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class l extends y.Disposable{constructor(w,P,L,M,p,U){super();this._tracer=w,this._onData=p,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new d(this._tracer,M,L,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(P,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,P){return new Promise((L,M)=>{w.write(P),w.flush(p=>L(p))})}acceptFrame(w,P,L){this._readQueue.push({data:w,isCompressed:P,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,P,L){return new Promise((M,p)=>{w.write(P),L&&w.write(T.VSBuffer.fromByteArray([0,0,255,255])),w.flush(U=>M(U))})}}class d extends y.Disposable{constructor(w,P,L,M){super();this._tracer=w,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(M),this._zlibInflate.on("error",p=>{this._tracer.traceSocketEvent("zlibInflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibInflate.on("data",p=>{this._tracer.traceSocketEvent("zlibInflateData",p),this._pendingInflateData.push(T.VSBuffer.wrap(p))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(P)})}}class m extends y.Disposable{constructor(w,P){super();this._tracer=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(T.VSBuffer.wrap(L))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),w(P)})}}function a(c,w){if(w===0)return;let P=c.byteLength>>>2;for(let H=0;H<P;H++){const re=c.readUInt32BE(H*4);c.writeUInt32BE(re^w,H*4)}let L=P*4,M=c.byteLength-L;const p=w>>>24&255,U=w>>>16&255,B=w>>>8&255;M>=1&&c.writeUInt8(c.readUInt8(L)^p,L),M>=2&&c.writeUInt8(c.readUInt8(L+1)^U,L+1),M>=3&&c.writeUInt8(c.readUInt8(L+2)^B,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function o(){const c=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):w=(0,A.join)((0,I.tmpdir)(),`vscode-ipc-${c}.sock`),s(w),w}e.createRandomIPCHandle=o;function i(c,w,P){const L=(0,f.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${P}-${w}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${P}-${w}.sock`):M=(0,A.join)(c,`${P}-${w}.sock`),s(M),M}e.createStaticIPCHandle=i;function s(c){const w=S[N.platform];typeof w=="number"&&c.length>=w&&console.warn(`WARNING: IPC handle "${c}" is longer than ${w} chars, try a shorter --user-data-dir`)}class n extends b.IPCServer{constructor(w){super(n.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const P=k.Event.fromNodeEventEmitter(w,"connection");return k.Event.map(P,L=>({protocol:new C.Protocol(new u(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(c){return new Promise((w,P)=>{const L=(0,t.createServer)();L.on("error",P),L.listen(c,()=>{L.removeListener("error",P),w(new n(L))})})}e.serve=r;function h(c,w){return new Promise((P,L)=>{const M=(0,t.createConnection)(c,()=>{M.removeListener("error",L),P(C.Client.fromSocket(new u(M,`ipc-client${w}`),w))});M.once("error",L)})}e.connect=h}),define(be[288],Ee([1,0,141,283,59,40,2,11,43]),function(J,e,f,t,I,T,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(b,C,g){this._commands=b,this.logService=C,this._ipcHandlePath=g,this._server=t.createServer((u,v)=>this.onRequest(u,v)),this.setup().catch(u=>(C.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",b=>this.logService.error(b))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(b,C){const g=(v,_)=>{C.writeHead(v,{"content-type":"application/json"}),C.end(JSON.stringify(_||null),E=>E&&this.logService.error(E))},u=[];b.setEncoding("utf8"),b.on("data",v=>u.push(v)),b.on("end",async()=>{try{const v=JSON.parse(u.join(""));let _;switch(v.type){case"open":_=await this.open(v);break;case"openExternal":_=await this.openExternal(v);break;case"status":_=await this.getStatus(v);break;case"extensionManagement":_=await this.manageExtensions(v);break;default:g(404,`Unknown message type: ${v.type}`);break}g(200,_)}catch(v){const _=v instanceof Error?v.message:JSON.stringify(v);g(500,_),this.logService.error("Error while processing pipe request",v)}})}async open(b){const{fileURIs:C,folderURIs:g,forceNewWindow:u,diffMode:v,addMode:_,forceReuseWindow:E,gotoLineMode:l,waitMarkerFilePath:d,remoteAuthority:m}=b,a=[];if(Array.isArray(g))for(const s of g)try{a.push({folderUri:D.URI.parse(s)})}catch{}if(Array.isArray(C))for(const s of C)try{(0,y.hasWorkspaceFileExtension)(s)?a.push({workspaceUri:D.URI.parse(s)}):a.push({fileUri:D.URI.parse(s)})}catch{}const S=d?D.URI.file(d):void 0,i={forceNewWindow:u,diffMode:v,addMode:_,gotoLineMode:l,forceReuseWindow:E,preferNewWindow:!E&&!S&&!_,waitMarkerFileURI:S,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",a,i),""}async openExternal(b){for(const C of b.uris){const g=D.URI.parse(C),u=g.scheme==="file"?g:C;await this._commands.executeCommand("_remoteCLI.openExternal",u)}}async manageExtensions(b){const C=u=>u?.map(v=>/\.vsix$/i.test(v)?D.URI.parse(v):v),g={list:b.list,install:C(b.install),uninstall:C(b.uninstall),force:b.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",g)}async getStatus(b){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let N=class extends A{constructor(b,C){super(b,C,(0,f.createRandomIPCHandle)())}};N=$e([Be(0,T.IExtHostCommands),Be(1,k.ILogService)],N),e.CLIServer=N}),define(be[289],Ee([1,0,71,281,270,5,282,41,259,2,10,7,288,104]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends I.RequireInterceptor{_installInterceptor(){const _=this,E=J.__$__nodeRequire("module"),l=E._load;E._load=function(S,o,i){return S=m(S),_._factories.has(S)?_._factories.get(S).load(S,A.URI.file((0,C.realpathSync)(o.filename)),s=>l.apply(this,[s,o,i])):l.apply(this,arguments)};const d=E._resolveLookupPaths;E._resolveLookupPaths=(a,S)=>d.call(this,m(a),S);const m=a=>{for(let S of _._alternatives){let o=S(a);if(o){a=o;break}}return a}}}class u extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const _=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(b.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(g,_,this._registry).install(),f.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const d=process.send,m=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?d.apply(process,a):(m.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(_){return _.main}_loadCommonJSModule(_,E,l){if(E.scheme!==N.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let d=null;l.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{_&&f.mark(`code/extHost/willLoadExtensionCode/${_.value}`),d=J.__$__nodeRequire(E.fsPath)}catch(m){return Promise.reject(m)}finally{_&&f.mark(`code/extHost/didLoadExtensionCode/${_.value}`),l.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(_){if(!!this._initData.remote.isRemote)for(const E in _){const l=_[E];l===null?delete process.env[E]:process.env[E]=l}}}e.ExtHostExtensionService=u}),define(be[290],Ee([1,0,79,262,273,272,287,289,263,54,41,72,70,33,51,67,261,260,11]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v,_,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(N.IExtHostExtensionService,k.ExtHostExtensionService),(0,f.registerSingleton)(E.ILoggerService,_.ExtHostLoggerService),(0,f.registerSingleton)(u.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,f.registerSingleton)(A.IExtHostDebugService,T.ExtHostDebugService),(0,f.registerSingleton)(R.IExtHostSearch,D.NativeExtHostSearch),(0,f.registerSingleton)(b.IExtHostTask,I.ExtHostTask),(0,f.registerSingleton)(C.IExtHostTerminalService,t.ExtHostTerminalService),(0,f.registerSingleton)(g.IExtHostTunnelService,y.ExtHostTunnelService)}),define(be[299],Ee([1,0,128,300,71,12,106,141,192,133,271,22,29,104,15,114,206,274,290]),function(J,e,f,t,I,T,D,k,y,A,N,R,b,C,g,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const _=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=J.__$__nodeRequire("module"),s=i._load;i._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return s.apply(this,arguments)}})();const E=process.exit.bind(process);function l(i){process.exit=function(s){if(i)E(s);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let d=function(i){E()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,s)=>{let n=null,r=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,c=3e5,w=new g.ProcessTimeRunOnceScheduler(()=>d("renderer disconnected for too long (1)"),h),P=new g.ProcessTimeRunOnceScheduler(()=>d("renderer disconnected for too long (2)"),c);process.on("message",(M,p)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){p.setNoDelay(!0);const U=R.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let B;if(M.skipWebSocketFrames)B=new k.NodeSocket(p,"extHost-socket");else{const H=R.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));B=new k.WebSocketNodeSocket(new k.NodeSocket(p,"extHost-socket"),M.permessageDeflate,H,!1)}n?(w.cancel(),P.cancel(),n.beginAcceptReconnection(B,U),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(r),n=new D.PersistentProtocol(B,U),n.sendResume(),n.onDidDispose(()=>d("renderer disconnected")),i(n),n.onSocketClose(()=>{w.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(P.isScheduled())return;w.isScheduled()&&P.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,n)=>{const r=f.createConnection(i,()=>{r.removeListener("error",n),s(new D.PersistentProtocol(new k.NodeSocket(r,"extHost-renderer")))});r.once("error",n),r.on("close",()=>{d("renderer closed the socket")})})}}async function a(){const i=await m();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(s=>{(0,A.isMessageOfType)(s,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||i.send(s)}drain(){return i.drain()}}}function S(i){return new Promise(s=>{const n=i.onMessage(r=>{n.dispose();const h=JSON.parse(r.toString()),c=h.commit,w=y.default.commit;c&&w&&c!==w&&E(55);let P=0;setInterval(function(){try{process.kill(h.parentPid,0),P=0}catch(M){M&&M.code==="EPERM"?(P++,P>=3&&d(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):d(`parent process ${h.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let L;try{L=J.__$__nodeRequire("native-watchdog"),L.start(h.parentPid)}catch(M){(0,T.onUnexpectedError)(M)}i.send((0,A.createMessageOfType)(0)),s({protocol:i,initData:h})});i.send((0,A.createMessageOfType)(1))})}async function o(){const i=[];process.on("unhandledRejection",(P,L)=>{i.push(L),setTimeout(()=>{const M=i.indexOf(L);M>=0&&L.catch(p=>{i.splice(M,1),(0,T.isCancellationError)(p)||(console.warn(`rejected promise not handled within 1 second: ${p}`),p&&p.stack&&console.warn(`stack trace: ${p.stack}`),P&&(0,T.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const L=i.indexOf(P);L>=0&&i.splice(L,1)}),process.on("uncaughtException",function(P){(0,T.onUnexpectedError)(P)}),I.mark("code/extHost/willConnectToRenderer");const s=await a();I.mark("code/extHost/didConnectToRenderer");const n=await S(s);I.mark("code/extHost/didWaitForInitData");const{initData:r}=n;l(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,u.boolean)(_.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(L){E(L)}exists(L){return b.Promises.exists(L)}realpath(L){return(0,C.realpath)(L)}};let c=null;r.remote.authority&&_.transformURIs&&(c=(0,v.createURITransformer)(r.remote.authority));const w=new N.ExtensionHostMain(n.protocol,r,h,c);d=P=>w.terminate(P)}e.startExtensionHostProcess=o,o().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/node/extensionHostProcess.js.map
