/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/shared/dataTransfer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Se=function(J){for(var e=[],l=0,T=J.length;l<T;l++)e[l]=be[J[l]];return e};define(be[42],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function l(T,b){if(!T)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=l}),define(be[73],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const l=Object.prototype.hasOwnProperty;function T(L){const C=[];for(let u in L)l.call(L,u)&&C.push(L[u]);return C}e.values=T;function b(L,C){for(let u in L)if(l.call(L,u)&&C({key:u,value:L[u]},function(){delete L[u]})===!1)return}e.forEach=b;function M(L,C){const u=Object.create(null);for(const g of L){const o=C(g);let r=u[o];r||(r=u[o]=[]),r.push(g)}return u}e.groupBy=M;function I(L){const C=Object.create(null);return L&&L.forEach((u,g)=>{C[g]=u}),C}e.fromMap=I;function A(L,C){const u=[],g=[];for(let o of L)C.has(o)||u.push(o);for(let o of C)L.has(o)||g.push(o);return{removed:u,added:g}}e.diffSets=A;function y(L,C){const u=[],g=[];for(let[o,r]of L)C.has(o)||u.push(r);for(let[o,r]of C)L.has(o)||g.push(r);return{removed:u,added:g}}e.diffMaps=y;class O{constructor(){this.map=new Map}add(C,u){let g=this.map.get(C);g||(g=new Set,this.map.set(C,g)),g.add(u)}delete(C,u){const g=this.map.get(C);!g||(g.delete(u),g.size===0&&this.map.delete(C))}forEach(C,u){const g=this.map.get(C);!g||g.forEach(u)}}e.SetMap=O}),define(be[52],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(I){return(A,y,O)=>{let L=null,C=null;if(typeof O.value=="function"?(L="value",C=O.value):typeof O.get=="function"&&(L="get",C=O.get),!C)throw new Error("not supported");O[L]=I(C,y)}}e.createDecorator=l;function T(I,A,y){let O=null,L=null;if(typeof y.value=="function"?(O="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(O="get",L=y.get),!L)throw new Error("not supported");const C=`$memoize$${A}`;y[O]=function(...u){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,u)}),this[C]}}e.memoize=T;function b(I,A,y){return l((O,L)=>{const C=`$debounce$${L}`,u=`$debounce$result$${L}`;return function(...g){this[u]||(this[u]=y?y():void 0),clearTimeout(this[C]),A&&(this[u]=A(this[u],...g),g=[this[u]]),this[C]=setTimeout(()=>{O.apply(this,g),this[u]=y?y():void 0},I)}})}e.debounce=b;function M(I,A,y){return l((O,L)=>{const C=`$throttle$timer$${L}`,u=`$throttle$result$${L}`,g=`$throttle$lastRun$${L}`,o=`$throttle$pending$${L}`;return function(...r){if(this[u]||(this[u]=y?y():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),A&&(this[u]=A(this[u],...r)),this[o])return;const f=this[g]+I;f<=Date.now()?(this[g]=Date.now(),O.apply(this,[this[u]]),this[u]=y?y():void 0):(this[o]=!0,this[C]=setTimeout(()=>{this[o]=!1,this[g]=Date.now(),O.apply(this,[this[u]]),this[u]=y?y():void 0},f-Date.now()))}})}e.throttle=M}),define(be[53],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(be[101],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var T;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(a){a.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function I(a,k=!1){let s=0,i=a.length,c="",t=0,n=16,m=0;function d(W){let V=0,re=0;for(;V<W;){const H=a.charCodeAt(s);if(H>=48&&H<=57)re=re*16+H-48;else if(H>=65&&H<=70)re=re*16+H-65+10;else if(H>=97&&H<=102)re=re*16+H-97+10;else break;s++,V++}return V<W&&(re=-1),re}function S(W){s=W,c="",t=0,n=16,m=0}function P(){const W=s;if(a.charCodeAt(s)===48)s++;else for(s++;s<a.length&&O(a.charCodeAt(s));)s++;if(s<a.length&&a.charCodeAt(s)===46)if(s++,s<a.length&&O(a.charCodeAt(s)))for(s++;s<a.length&&O(a.charCodeAt(s));)s++;else return m=3,a.substring(W,s);let V=s;if(s<a.length&&(a.charCodeAt(s)===69||a.charCodeAt(s)===101))if(s++,(s<a.length&&a.charCodeAt(s)===43||a.charCodeAt(s)===45)&&s++,s<a.length&&O(a.charCodeAt(s))){for(s++;s<a.length&&O(a.charCodeAt(s));)s++;V=s}else m=3;return a.substring(W,V)}function B(){let W="",V=s;for(;;){if(s>=i){W+=a.substring(V,s),m=2;break}const re=a.charCodeAt(s);if(re===34){W+=a.substring(V,s),s++;break}if(re===92){if(W+=a.substring(V,s),s++,s>=i){m=2;break}switch(a.charCodeAt(s++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const R=d(4);R>=0?W+=String.fromCharCode(R):m=4;break}default:m=5}V=s;continue}if(re>=0&&re<=31)if(y(re)){W+=a.substring(V,s),m=2;break}else m=6;s++}return W}function F(){if(c="",m=0,t=s,s>=i)return t=i,n=17;let W=a.charCodeAt(s);if(A(W)){do s++,c+=String.fromCharCode(W),W=a.charCodeAt(s);while(A(W));return n=15}if(y(W))return s++,c+=String.fromCharCode(W),W===13&&a.charCodeAt(s)===10&&(s++,c+=`
`),n=14;switch(W){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,c=B(),n=10;case 47:{const V=s-1;if(a.charCodeAt(s+1)===47){for(s+=2;s<i&&!y(a.charCodeAt(s));)s++;return c=a.substring(V,s),n=12}if(a.charCodeAt(s+1)===42){s+=2;const re=i-1;let H=!1;for(;s<re;){if(a.charCodeAt(s)===42&&a.charCodeAt(s+1)===47){s+=2,H=!0;break}s++}return H||(s++,m=1),c=a.substring(V,s),n=13}return c+=String.fromCharCode(W),s++,n=16}case 45:if(c+=String.fromCharCode(W),s++,s===i||!O(a.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=P(),n=11;default:for(;s<i&&v(W);)s++,W=a.charCodeAt(s);if(t!==s){switch(c=a.substring(t,s),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(W),s++,n=16}}function v(W){if(A(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let W;do W=F();while(W>=12&&W<=15);return W}return{setPosition:S,getPosition:()=>s,scan:k?x:F,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>t,getTokenLength:()=>s-t,getTokenError:()=>m}}e.createScanner=I;function A(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function y(a){return a===10||a===13||a===8232||a===8233}function O(a){return a>=48&&a<=57}var L;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(L||(L={}));function C(a,k){const s=[],i=new Object;let c;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function m(d,S,P,B){t.value=d,t.offset=S,t.length=P,t.type=B,t.colonOffset=void 0,c=t}try{h(a,{onObjectBegin:(d,S)=>{if(k<=d)throw i;c=void 0,n=k>d,s.push("")},onObjectProperty:(d,S,P)=>{if(k<S||(m(d,S,P,"property"),s[s.length-1]=d,k<=S+P))throw i},onObjectEnd:(d,S)=>{if(k<=d)throw i;c=void 0,s.pop()},onArrayBegin:(d,S)=>{if(k<=d)throw i;c=void 0,s.push(0)},onArrayEnd:(d,S)=>{if(k<=d)throw i;c=void 0,s.pop()},onLiteralValue:(d,S,P)=>{if(k<S||(m(d,S,P,E(d)),k<=S+P))throw i},onSeparator:(d,S,P)=>{if(k<=S)throw i;if(d===":"&&c&&c.type==="property")c.colonOffset=S,n=!1,c=void 0;else if(d===","){const B=s[s.length-1];typeof B=="number"?s[s.length-1]=B+1:(n=!0,s[s.length-1]=""),c=void 0}}})}catch(d){if(d!==i)throw d}return{path:s,previousNode:c,isAtPropertyKey:n,matches:d=>{let S=0;for(let P=0;S<d.length&&P<s.length;P++)if(d[S]===s[P]||d[S]==="*")S++;else if(d[S]!=="**")return!1;return S===d.length}}}e.getLocation=C;function u(a,k=[],s=M.DEFAULT){let i=null,c=[];const t=[];function n(d){Array.isArray(c)?c.push(d):i!==null&&(c[i]=d)}return h(a,{onObjectBegin:()=>{const d={};n(d),t.push(c),c=d,i=null},onObjectProperty:d=>{i=d},onObjectEnd:()=>{c=t.pop()},onArrayBegin:()=>{const d=[];n(d),t.push(c),c=d,i=null},onArrayEnd:()=>{c=t.pop()},onLiteralValue:n,onError:(d,S,P)=>{k.push({error:d,offset:S,length:P})}},s),c[0]}e.parse=u;function g(a,k=[],s=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(d){i.type==="property"&&(i.length=d-i.offset,i=i.parent)}function t(d){return i.children.push(d),d}h(a,{onObjectBegin:d=>{i=t({type:"object",offset:d,length:-1,parent:i,children:[]})},onObjectProperty:(d,S,P)=>{i=t({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:d,offset:S,length:P,parent:i})},onObjectEnd:(d,S)=>{i.length=d+S-i.offset,i=i.parent,c(d+S)},onArrayBegin:(d,S)=>{i=t({type:"array",offset:d,length:-1,parent:i,children:[]})},onArrayEnd:(d,S)=>{i.length=d+S-i.offset,i=i.parent,c(d+S)},onLiteralValue:(d,S,P)=>{t({type:E(d),offset:S,length:P,parent:i,value:d}),c(S+P)},onSeparator:(d,S,P)=>{i.type==="property"&&(d===":"?i.colonOffset=S:d===","&&c(S))},onError:(d,S,P)=>{k.push({error:d,offset:S,length:P})}},s);const m=i.children[0];return m&&delete m.parent,m}e.parseTree=g;function o(a,k){if(!a)return;let s=a;for(let i of k)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const t of s.children)if(Array.isArray(t.children)&&t.children[0].value===i){s=t.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=o;function r(a){if(!a.parent||!a.parent.children)return[];const k=r(a.parent);if(a.parent.type==="property"){const s=a.parent.children[0].value;k.push(s)}else if(a.parent.type==="array"){const s=a.parent.children.indexOf(a);s!==-1&&k.push(s)}return k}e.getNodePath=r;function f(a){switch(a.type){case"array":return a.children.map(f);case"object":{const k=Object.create(null);for(let s of a.children){const i=s.children[1];i&&(k[s.children[0].value]=f(i))}return k}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=f;function p(a,k,s=!1){return k>=a.offset&&k<a.offset+a.length||s&&k===a.offset+a.length}e.contains=p;function D(a,k,s=!1){if(p(a,k,s)){const i=a.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=k;c++){const t=D(i[c],k,s);if(t)return t}return a}}e.findNodeAtOffset=D;function h(a,k,s=M.DEFAULT){const i=I(a,!1);function c(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(me){return me?fe=>me(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const n=c(k.onObjectBegin),m=t(k.onObjectProperty),d=c(k.onObjectEnd),S=c(k.onArrayBegin),P=c(k.onArrayEnd),B=t(k.onLiteralValue),F=t(k.onSeparator),v=c(k.onComment),x=t(k.onError),W=s&&s.disallowComments,V=s&&s.allowTrailingComma;function re(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:W||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(me){case 12:case 13:W?H(10):v();break;case 16:H(1);break;case 15:case 14:break;default:return me}}}function H(me,fe=[],ae=[]){if(x(me),fe.length+ae.length>0){let pe=i.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){re();break}else if(ae.indexOf(pe)!==-1)break;pe=re()}}}function R(me){const fe=i.getTokenValue();return me?B(fe):m(fe),re(),!0}function se(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(H(2),me=0)}catch{H(2)}B(me);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return re(),!0}function de(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(R(!1),i.getToken()===6?(F(":"),re(),he()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function X(){n(),re();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||H(4,[],[]),F(","),re(),i.getToken()===2&&V)break}else me&&H(6,[],[]);de()||H(4,[],[2,5]),me=!0}return d(),i.getToken()!==2?H(7,[2],[]):re(),!0}function ie(){S(),re();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||H(4,[],[]),F(","),re(),i.getToken()===4&&V)break}else me&&H(6,[],[]);he()||H(4,[],[4,5]),me=!0}return P(),i.getToken()!==4?H(8,[4],[]):re(),!0}function he(){switch(i.getToken()){case 3:return ie();case 1:return X();case 10:return R(!0);default:return se()}}return re(),i.getToken()===17?s.allowEmptyContent?!0:(H(4,[],[]),!1):he()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=h;function _(a,k){let s=I(a),i=[],c,t=0,n;do switch(n=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:t!==n&&i.push(a.substring(t,n)),k!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,k)),t=s.getPosition();break}while(c!==17);return i.join("")}e.stripComments=_;function E(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(be[102],Se([0]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(Ce,Ee){for(var De=0;De<Ee.length;De++){var ne=Ee[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Ce,ne.key,ne)}}function l(Ce,Ee,De){return Ee&&e(Ce.prototype,Ee),De&&e(Ce,De),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,Ee){if(!!Ce){if(typeof Ce=="string")return b(Ce,Ee);var De=Object.prototype.toString.call(Ce).slice(8,-1);if(De==="Object"&&Ce.constructor&&(De=Ce.constructor.name),De==="Map"||De==="Set")return Array.from(Ce);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return b(Ce,Ee)}}function b(Ce,Ee){(Ee==null||Ee>Ce.length)&&(Ee=Ce.length);for(var De=0,ne=new Array(Ee);De<Ee;De++)ne[De]=Ce[De];return ne}function M(Ce,Ee){var De=typeof Symbol!="undefined"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(De)return(De=De.call(Ce)).next.bind(De);if(Array.isArray(Ce)||(De=T(Ce))||Ee&&Ce&&typeof Ce.length=="number"){De&&(Ce=De);var ne=0;return function(){return ne>=Ce.length?{done:!0}:{done:!1,value:Ce[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=I();function A(Ce){J.defaults=Ce}var y=/[&<>"']/,O=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(Ee){return u[Ee]};function o(Ce,Ee){if(Ee){if(y.test(Ce))return Ce.replace(O,g)}else if(L.test(Ce))return Ce.replace(C,g);return Ce}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(Ce){return Ce.replace(r,function(Ee,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var p=/(^|[^\[])\^/g;function D(Ce,Ee){Ce=Ce.source||Ce,Ee=Ee||"";var De={replace:function(q,Q){return Q=Q.source||Q,Q=Q.replace(p,"$1"),Ce=Ce.replace(q,Q),De},getRegex:function(){return new RegExp(Ce,Ee)}};return De}var h=/[^\w:]/g,_=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(Ce,Ee,De){if(Ce){var ne;try{ne=decodeURIComponent(f(De)).replace(h,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Ee&&!_.test(De)&&(De=c(Ee,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var a={},k=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Ce,Ee){a[" "+Ce]||(k.test(Ce)?a[" "+Ce]=Ce+"/":a[" "+Ce]=d(Ce,"/",!0)),Ce=a[" "+Ce];var De=Ce.indexOf(":")===-1;return Ee.substring(0,2)==="//"?De?Ee:Ce.replace(s,"$1")+Ee:Ee.charAt(0)==="/"?De?Ee:Ce.replace(i,"$1")+Ee:Ce+Ee}var t={exec:function(){}};function n(Ce){for(var Ee=1,De,ne;Ee<arguments.length;Ee++){De=arguments[Ee];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&(Ce[ne]=De[ne])}return Ce}function m(Ce,Ee){var De=Ce.replace(/\|/g,function(Q,w,U){for(var z=!1,j=w;--j>=0&&U[j]==="\\";)z=!z;return z?"|":" |"}),ne=De.split(/ \|/),q=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>Ee)ne.splice(Ee);else for(;ne.length<Ee;)ne.push("");for(;q<ne.length;q++)ne[q]=ne[q].trim().replace(/\\\|/g,"|");return ne}function d(Ce,Ee,De){var ne=Ce.length;if(ne===0)return"";for(var q=0;q<ne;){var Q=Ce.charAt(ne-q-1);if(Q===Ee&&!De)q++;else if(Q!==Ee&&De)q++;else break}return Ce.substr(0,ne-q)}function S(Ce,Ee){if(Ce.indexOf(Ee[1])===-1)return-1;for(var De=Ce.length,ne=0,q=0;q<De;q++)if(Ce[q]==="\\")q++;else if(Ce[q]===Ee[0])ne++;else if(Ce[q]===Ee[1]&&(ne--,ne<0))return q;return-1}function P(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(Ce,Ee){if(Ee<1)return"";for(var De="";Ee>1;)Ee&1&&(De+=Ce),Ee>>=1,Ce+=Ce;return De+Ce}function F(Ce,Ee,De,ne){var q=Ee.href,Q=Ee.title?o(Ee.title):null,w=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){ne.state.inLink=!0;var U={type:"link",raw:De,href:q,title:Q,text:w,tokens:ne.inlineTokens(w,[])};return ne.state.inLink=!1,U}else return{type:"image",raw:De,href:q,title:Q,text:o(w)}}function v(Ce,Ee){var De=Ce.match(/^(\s+)(?:```)/);if(De===null)return Ee;var ne=De[1];return Ee.split(`
`).map(function(q){var Q=q.match(/^\s+/);if(Q===null)return q;var w=Q[0];return w.length>=ne.length?q.slice(ne.length):q}).join(`
`)}var x=function(){function Ce(De){this.options=De||J.defaults}var Ee=Ce.prototype;return Ee.space=function(ne){var q=this.rules.block.newline.exec(ne);if(q&&q[0].length>0)return{type:"space",raw:q[0]}},Ee.code=function(ne){var q=this.rules.block.code.exec(ne);if(q){var Q=q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:q[0],codeBlockStyle:"indented",text:this.options.pedantic?Q:d(Q,`
`)}}},Ee.fences=function(ne){var q=this.rules.block.fences.exec(ne);if(q){var Q=q[0],w=v(Q,q[3]||"");return{type:"code",raw:Q,lang:q[2]?q[2].trim():q[2],text:w}}},Ee.heading=function(ne){var q=this.rules.block.heading.exec(ne);if(q){var Q=q[2].trim();if(/#$/.test(Q)){var w=d(Q,"#");(this.options.pedantic||!w||/ $/.test(w))&&(Q=w.trim())}var U={type:"heading",raw:q[0],depth:q[1].length,text:Q,tokens:[]};return this.lexer.inline(U.text,U.tokens),U}},Ee.hr=function(ne){var q=this.rules.block.hr.exec(ne);if(q)return{type:"hr",raw:q[0]}},Ee.blockquote=function(ne){var q=this.rules.block.blockquote.exec(ne);if(q){var Q=q[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:q[0],tokens:this.lexer.blockTokens(Q,[]),text:Q}}},Ee.list=function(ne){var q=this.rules.block.list.exec(ne);if(q){var Q,w,U,z,j,ee,ce,ve,Oe,Le,Ne,Ve,Je=q[1].trim(),ke=Je.length>1,je={type:"list",raw:"",ordered:ke,start:ke?+Je.slice(0,-1):"",loose:!1,items:[]};Je=ke?"\\d{1,9}\\"+Je.slice(-1):"\\"+Je,this.options.pedantic&&(Je=ke?Je:"[*+-]");for(var G=new RegExp("^( {0,3}"+Je+")((?: [^\\n]*)?(?:\\n|$))");ne&&(Ve=!1,!(!(q=G.exec(ne))||this.rules.block.hr.test(ne)));){if(Q=q[0],ne=ne.substring(Q.length),ve=q[2].split(`
`,1)[0],Oe=ne.split(`
`,1)[0],this.options.pedantic?(z=2,Ne=ve.trimLeft()):(z=q[2].search(/[^ ]/),z=z>4?1:z,Ne=ve.slice(z),z+=q[1].length),ee=!1,!ve&&/^ *$/.test(Oe)&&(Q+=Oe+`
`,ne=ne.substring(Oe.length+1),Ve=!0),!Ve)for(var Y=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])");ne&&(Le=ne.split(`
`,1)[0],ve=Le,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Y.test(ve));){if(ve.search(/[^ ]/)>=z||!ve.trim())Ne+=`
`+ve.slice(z);else if(!ee)Ne+=`
`+ve;else break;!ee&&!ve.trim()&&(ee=!0),Q+=Le+`
`,ne=ne.substring(Le.length+1)}je.loose||(ce?je.loose=!0:/\n *\n *$/.test(Q)&&(ce=!0)),this.options.gfm&&(w=/^\[[ xX]\] /.exec(Ne),w&&(U=w[0]!=="[ ] ",Ne=Ne.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:Q,task:!!w,checked:U,loose:!1,text:Ne}),je.raw+=Q}je.items[je.items.length-1].raw=Q.trimRight(),je.items[je.items.length-1].text=Ne.trimRight(),je.raw=je.raw.trimRight();var ue=je.items.length;for(j=0;j<ue;j++){this.lexer.state.top=!1,je.items[j].tokens=this.lexer.blockTokens(je.items[j].text,[]);var Me=je.items[j].tokens.filter(function(Xe){return Xe.type==="space"}),We=Me.every(function(Xe){for(var Ze=Xe.raw.split(""),ot=0,wt=M(Ze),mt;!(mt=wt()).done;){var kt=mt.value;if(kt===`
`&&(ot+=1),ot>1)return!0}return!1});!je.loose&&Me.length&&We&&(je.loose=!0,je.items[j].loose=!0)}return je}},Ee.html=function(ne){var q=this.rules.block.html.exec(ne);if(q){var Q={type:"html",raw:q[0],pre:!this.options.sanitizer&&(q[1]==="pre"||q[1]==="script"||q[1]==="style"),text:q[0]};return this.options.sanitize&&(Q.type="paragraph",Q.text=this.options.sanitizer?this.options.sanitizer(q[0]):o(q[0]),Q.tokens=[],this.lexer.inline(Q.text,Q.tokens)),Q}},Ee.def=function(ne){var q=this.rules.block.def.exec(ne);if(q){q[3]&&(q[3]=q[3].substring(1,q[3].length-1));var Q=q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Q,raw:q[0],href:q[2],title:q[3]}}},Ee.table=function(ne){var q=this.rules.block.table.exec(ne);if(q){var Q={type:"table",header:m(q[1]).map(function(ce){return{text:ce}}),align:q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:q[3]?q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Q.header.length===Q.align.length){Q.raw=q[0];var w=Q.align.length,U,z,j,ee;for(U=0;U<w;U++)/^ *-+: *$/.test(Q.align[U])?Q.align[U]="right":/^ *:-+: *$/.test(Q.align[U])?Q.align[U]="center":/^ *:-+ *$/.test(Q.align[U])?Q.align[U]="left":Q.align[U]=null;for(w=Q.rows.length,U=0;U<w;U++)Q.rows[U]=m(Q.rows[U],Q.header.length).map(function(ce){return{text:ce}});for(w=Q.header.length,z=0;z<w;z++)Q.header[z].tokens=[],this.lexer.inlineTokens(Q.header[z].text,Q.header[z].tokens);for(w=Q.rows.length,z=0;z<w;z++)for(ee=Q.rows[z],j=0;j<ee.length;j++)ee[j].tokens=[],this.lexer.inlineTokens(ee[j].text,ee[j].tokens);return Q}}},Ee.lheading=function(ne){var q=this.rules.block.lheading.exec(ne);if(q){var Q={type:"heading",raw:q[0],depth:q[2].charAt(0)==="="?1:2,text:q[1],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},Ee.paragraph=function(ne){var q=this.rules.block.paragraph.exec(ne);if(q){var Q={type:"paragraph",raw:q[0],text:q[1].charAt(q[1].length-1)===`
`?q[1].slice(0,-1):q[1],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},Ee.text=function(ne){var q=this.rules.block.text.exec(ne);if(q){var Q={type:"text",raw:q[0],text:q[0],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},Ee.escape=function(ne){var q=this.rules.inline.escape.exec(ne);if(q)return{type:"escape",raw:q[0],text:o(q[1])}},Ee.tag=function(ne){var q=this.rules.inline.tag.exec(ne);if(q)return!this.lexer.state.inLink&&/^<a /i.test(q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):o(q[0]):q[0]}},Ee.link=function(ne){var q=this.rules.inline.link.exec(ne);if(q){var Q=q[2].trim();if(!this.options.pedantic&&/^</.test(Q)){if(!/>$/.test(Q))return;var w=d(Q.slice(0,-1),"\\");if((Q.length-w.length)%2==0)return}else{var U=S(q[2],"()");if(U>-1){var z=q[0].indexOf("!")===0?5:4,j=z+q[1].length+U;q[2]=q[2].substring(0,U),q[0]=q[0].substring(0,j).trim(),q[3]=""}}var ee=q[2],ce="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);ve&&(ee=ve[1],ce=ve[3])}else ce=q[3]?q[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(Q)?ee=ee.slice(1):ee=ee.slice(1,-1)),F(q,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},q[0],this.lexer)}},Ee.reflink=function(ne,q){var Q;if((Q=this.rules.inline.reflink.exec(ne))||(Q=this.rules.inline.nolink.exec(ne))){var w=(Q[2]||Q[1]).replace(/\s+/g," ");if(w=q[w.toLowerCase()],!w||!w.href){var U=Q[0].charAt(0);return{type:"text",raw:U,text:U}}return F(Q,w,Q[0],this.lexer)}},Ee.emStrong=function(ne,q,Q){Q===void 0&&(Q="");var w=this.rules.inline.emStrong.lDelim.exec(ne);if(!!w&&!(w[3]&&Q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=w[1]||w[2]||"";if(!U||U&&(Q===""||this.rules.inline.punctuation.exec(Q))){var z=w[0].length-1,j,ee,ce=z,ve=0,Oe=w[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Oe.lastIndex=0,q=q.slice(-1*ne.length+z);(w=Oe.exec(q))!=null;)if(j=w[1]||w[2]||w[3]||w[4]||w[5]||w[6],!!j){if(ee=j.length,w[3]||w[4]){ce+=ee;continue}else if((w[5]||w[6])&&z%3&&!((z+ee)%3)){ve+=ee;continue}if(ce-=ee,!(ce>0)){if(ee=Math.min(ee,ee+ce+ve),Math.min(z,ee)%2){var Le=ne.slice(1,z+w.index+ee);return{type:"em",raw:ne.slice(0,z+w.index+ee+1),text:Le,tokens:this.lexer.inlineTokens(Le,[])}}var Ne=ne.slice(2,z+w.index+ee-1);return{type:"strong",raw:ne.slice(0,z+w.index+ee+1),text:Ne,tokens:this.lexer.inlineTokens(Ne,[])}}}}}},Ee.codespan=function(ne){var q=this.rules.inline.code.exec(ne);if(q){var Q=q[2].replace(/\n/g," "),w=/[^ ]/.test(Q),U=/^ /.test(Q)&&/ $/.test(Q);return w&&U&&(Q=Q.substring(1,Q.length-1)),Q=o(Q,!0),{type:"codespan",raw:q[0],text:Q}}},Ee.br=function(ne){var q=this.rules.inline.br.exec(ne);if(q)return{type:"br",raw:q[0]}},Ee.del=function(ne){var q=this.rules.inline.del.exec(ne);if(q)return{type:"del",raw:q[0],text:q[2],tokens:this.lexer.inlineTokens(q[2],[])}},Ee.autolink=function(ne,q){var Q=this.rules.inline.autolink.exec(ne);if(Q){var w,U;return Q[2]==="@"?(w=o(this.options.mangle?q(Q[1]):Q[1]),U="mailto:"+w):(w=o(Q[1]),U=w),{type:"link",raw:Q[0],text:w,href:U,tokens:[{type:"text",raw:w,text:w}]}}},Ee.url=function(ne,q){var Q;if(Q=this.rules.inline.url.exec(ne)){var w,U;if(Q[2]==="@")w=o(this.options.mangle?q(Q[0]):Q[0]),U="mailto:"+w;else{var z;do z=Q[0],Q[0]=this.rules.inline._backpedal.exec(Q[0])[0];while(z!==Q[0]);w=o(Q[0]),Q[1]==="www."?U="http://"+w:U=w}return{type:"link",raw:Q[0],text:w,href:U,tokens:[{type:"text",raw:w,text:w}]}}},Ee.inlineText=function(ne,q){var Q=this.rules.inline.text.exec(ne);if(Q){var w;return this.lexer.state.inRawBlock?w=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):o(Q[0]):Q[0]:w=o(this.options.smartypants?q(Q[0]):Q[0]),{type:"text",raw:Q[0],text:w}}},Ce}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=D(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=D(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=D(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=D(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=D(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=D(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=n({},W),W.gfm=n({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=D(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=D(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=n({},W.normal,{html:D(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:D(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=D(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=D(W._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=D(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=D(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=D(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=D(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=D(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=D(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=D(V.reflink).replace("label",V._label).replace("ref",W._label).getRegex(),V.nolink=D(V.nolink).replace("ref",W._label).getRegex(),V.reflinkSearch=D(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=n({},V),V.pedantic=n({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:D(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:D(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=n({},V.normal,{escape:D(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=D(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=n({},V.gfm,{br:D(V.br).replace("{2,}","*").getRegex(),text:D(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function re(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ce){var Ee="",De,ne,q=Ce.length;for(De=0;De<q;De++)ne=Ce.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),Ee+="&#"+ne+";";return Ee}var R=function(){function Ce(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||J.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:W.normal,inline:V.normal};this.options.pedantic?(ne.block=W.pedantic,ne.inline=V.pedantic):this.options.gfm&&(ne.block=W.gfm,this.options.breaks?ne.inline=V.breaks:ne.inline=V.gfm),this.tokenizer.rules=ne}Ce.lex=function(ne,q){var Q=new Ce(q);return Q.lex(ne)},Ce.lexInline=function(ne,q){var Q=new Ce(q);return Q.inlineTokens(ne)};var Ee=Ce.prototype;return Ee.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var q;q=this.inlineQueue.shift();)this.inlineTokens(q.src,q.tokens);return this.tokens},Ee.blockTokens=function(ne,q){var Q=this;q===void 0&&(q=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var w,U,z,j;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(w=ce.call({lexer:Q},ne,q))?(ne=ne.substring(w.raw.length),q.push(w),!0):!1}))){if(w=this.tokenizer.space(ne)){ne=ne.substring(w.raw.length),w.raw.length===1&&q.length>0?q[q.length-1].raw+=`
`:q.push(w);continue}if(w=this.tokenizer.code(ne)){ne=ne.substring(w.raw.length),U=q[q.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+w.raw,U.text+=`
`+w.text,this.inlineQueue[this.inlineQueue.length-1].src=U.text):q.push(w);continue}if(w=this.tokenizer.fences(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.heading(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.hr(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.blockquote(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.list(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.html(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.def(ne)){ne=ne.substring(w.raw.length),U=q[q.length-1],U&&(U.type==="paragraph"||U.type==="text")?(U.raw+=`
`+w.raw,U.text+=`
`+w.raw,this.inlineQueue[this.inlineQueue.length-1].src=U.text):this.tokens.links[w.tag]||(this.tokens.links[w.tag]={href:w.href,title:w.title});continue}if(w=this.tokenizer.table(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.lheading(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(z=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,ve=ne.slice(1),Oe=void 0;Q.options.extensions.startBlock.forEach(function(Le){Oe=Le.call({lexer:this},ve),typeof Oe=="number"&&Oe>=0&&(ce=Math.min(ce,Oe))}),ce<1/0&&ce>=0&&(z=ne.substring(0,ce+1))}(),this.state.top&&(w=this.tokenizer.paragraph(z))){U=q[q.length-1],j&&U.type==="paragraph"?(U.raw+=`
`+w.raw,U.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):q.push(w),j=z.length!==ne.length,ne=ne.substring(w.raw.length);continue}if(w=this.tokenizer.text(ne)){ne=ne.substring(w.raw.length),U=q[q.length-1],U&&U.type==="text"?(U.raw+=`
`+w.raw,U.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=U.text):q.push(w);continue}if(ne){var ee="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,q},Ee.inline=function(ne,q){this.inlineQueue.push({src:ne,tokens:q})},Ee.inlineTokens=function(ne,q){var Q=this;q===void 0&&(q=[]);var w,U,z,j=ne,ee,ce,ve;if(this.tokens.links){var Oe=Object.keys(this.tokens.links);if(Oe.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)Oe.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,ee.index)+"["+B("a",ee[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,ee.index)+"["+B("a",ee[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,ee.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(ce||(ve=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ne){return(w=Ne.call({lexer:Q},ne,q))?(ne=ne.substring(w.raw.length),q.push(w),!0):!1}))){if(w=this.tokenizer.escape(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.tag(ne)){ne=ne.substring(w.raw.length),U=q[q.length-1],U&&w.type==="text"&&U.type==="text"?(U.raw+=w.raw,U.text+=w.text):q.push(w);continue}if(w=this.tokenizer.link(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(w.raw.length),U=q[q.length-1],U&&w.type==="text"&&U.type==="text"?(U.raw+=w.raw,U.text+=w.text):q.push(w);continue}if(w=this.tokenizer.emStrong(ne,j,ve)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.codespan(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.br(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.del(ne)){ne=ne.substring(w.raw.length),q.push(w);continue}if(w=this.tokenizer.autolink(ne,H)){ne=ne.substring(w.raw.length),q.push(w);continue}if(!this.state.inLink&&(w=this.tokenizer.url(ne,H))){ne=ne.substring(w.raw.length),q.push(w);continue}if(z=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var Ne=1/0,Ve=ne.slice(1),Je=void 0;Q.options.extensions.startInline.forEach(function(ke){Je=ke.call({lexer:this},Ve),typeof Je=="number"&&Je>=0&&(Ne=Math.min(Ne,Je))}),Ne<1/0&&Ne>=0&&(z=ne.substring(0,Ne+1))}(),w=this.tokenizer.inlineText(z,re)){ne=ne.substring(w.raw.length),w.raw.slice(-1)!=="_"&&(ve=w.raw.slice(-1)),ce=!0,U=q[q.length-1],U&&U.type==="text"?(U.raw+=w.raw,U.text+=w.text):q.push(w);continue}if(ne){var Le="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return q},l(Ce,null,[{key:"rules",get:function(){return{block:W,inline:V}}}]),Ce}(),se=function(){function Ce(De){this.options=De||J.defaults}var Ee=Ce.prototype;return Ee.code=function(ne,q,Q){var w=(q||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(ne,w);U!=null&&U!==ne&&(Q=!0,ne=U)}return ne=ne.replace(/\n$/,"")+`
`,w?'<pre><code class="'+this.options.langPrefix+o(w,!0)+'">'+(Q?ne:o(ne,!0))+`</code></pre>
`:"<pre><code>"+(Q?ne:o(ne,!0))+`</code></pre>
`},Ee.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Ee.html=function(ne){return ne},Ee.heading=function(ne,q,Q,w){return this.options.headerIds?"<h"+q+' id="'+this.options.headerPrefix+w.slug(Q)+'">'+ne+"</h"+q+`>
`:"<h"+q+">"+ne+"</h"+q+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(ne,q,Q){var w=q?"ol":"ul",U=q&&Q!==1?' start="'+Q+'"':"";return"<"+w+U+`>
`+ne+"</"+w+`>
`},Ee.listitem=function(ne){return"<li>"+ne+`</li>
`},Ee.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(ne){return"<p>"+ne+`</p>
`},Ee.table=function(ne,q){return q&&(q="<tbody>"+q+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+q+`</table>
`},Ee.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Ee.tablecell=function(ne,q){var Q=q.header?"th":"td",w=q.align?"<"+Q+' align="'+q.align+'">':"<"+Q+">";return w+ne+"</"+Q+`>
`},Ee.strong=function(ne){return"<strong>"+ne+"</strong>"},Ee.em=function(ne){return"<em>"+ne+"</em>"},Ee.codespan=function(ne){return"<code>"+ne+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(ne){return"<del>"+ne+"</del>"},Ee.link=function(ne,q,Q){if(ne=E(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Q;var w='<a href="'+o(ne)+'"';return q&&(w+=' title="'+q+'"'),w+=">"+Q+"</a>",w},Ee.image=function(ne,q,Q){if(ne=E(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Q;var w='<img src="'+ne+'" alt="'+Q+'"';return q&&(w+=' title="'+q+'"'),w+=this.options.xhtml?"/>":">",w},Ee.text=function(ne){return ne},Ce}(),de=function(){function Ce(){}var Ee=Ce.prototype;return Ee.strong=function(ne){return ne},Ee.em=function(ne){return ne},Ee.codespan=function(ne){return ne},Ee.del=function(ne){return ne},Ee.html=function(ne){return ne},Ee.text=function(ne){return ne},Ee.link=function(ne,q,Q){return""+Q},Ee.image=function(ne,q,Q){return""+Q},Ee.br=function(){return""},Ce}(),X=function(){function Ce(){this.seen={}}var Ee=Ce.prototype;return Ee.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(ne,q){var Q=ne,w=0;if(this.seen.hasOwnProperty(Q)){w=this.seen[ne];do w++,Q=ne+"-"+w;while(this.seen.hasOwnProperty(Q))}return q||(this.seen[ne]=w,this.seen[Q]=0),Q},Ee.slug=function(ne,q){q===void 0&&(q={});var Q=this.serialize(ne);return this.getNextSafeSlug(Q,q.dryrun)},Ce}(),ie=function(){function Ce(De){this.options=De||J.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new X}Ce.parse=function(ne,q){var Q=new Ce(q);return Q.parse(ne)},Ce.parseInline=function(ne,q){var Q=new Ce(q);return Q.parseInline(ne)};var Ee=Ce.prototype;return Ee.parse=function(ne,q){q===void 0&&(q=!0);var Q="",w,U,z,j,ee,ce,ve,Oe,Le,Ne,Ve,Je,ke,je,G,Y,ue,Me,We,Xe=ne.length;for(w=0;w<Xe;w++){if(Ne=ne[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(We=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),We!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ne.type))){Q+=We||"";continue}switch(Ne.type){case"space":continue;case"hr":{Q+=this.renderer.hr();continue}case"heading":{Q+=this.renderer.heading(this.parseInline(Ne.tokens),Ne.depth,f(this.parseInline(Ne.tokens,this.textRenderer)),this.slugger);continue}case"code":{Q+=this.renderer.code(Ne.text,Ne.lang,Ne.escaped);continue}case"table":{for(Oe="",ve="",j=Ne.header.length,U=0;U<j;U++)ve+=this.renderer.tablecell(this.parseInline(Ne.header[U].tokens),{header:!0,align:Ne.align[U]});for(Oe+=this.renderer.tablerow(ve),Le="",j=Ne.rows.length,U=0;U<j;U++){for(ce=Ne.rows[U],ve="",ee=ce.length,z=0;z<ee;z++)ve+=this.renderer.tablecell(this.parseInline(ce[z].tokens),{header:!1,align:Ne.align[z]});Le+=this.renderer.tablerow(ve)}Q+=this.renderer.table(Oe,Le);continue}case"blockquote":{Le=this.parse(Ne.tokens),Q+=this.renderer.blockquote(Le);continue}case"list":{for(Ve=Ne.ordered,Je=Ne.start,ke=Ne.loose,j=Ne.items.length,Le="",U=0;U<j;U++)G=Ne.items[U],Y=G.checked,ue=G.task,je="",G.task&&(Me=this.renderer.checkbox(Y),ke?G.tokens.length>0&&G.tokens[0].type==="paragraph"?(G.tokens[0].text=Me+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Me+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Me}):je+=Me),je+=this.parse(G.tokens,ke),Le+=this.renderer.listitem(je,ue,Y);Q+=this.renderer.list(Le,Ve,Je);continue}case"html":{Q+=this.renderer.html(Ne.text);continue}case"paragraph":{Q+=this.renderer.paragraph(this.parseInline(Ne.tokens));continue}case"text":{for(Le=Ne.tokens?this.parseInline(Ne.tokens):Ne.text;w+1<Xe&&ne[w+1].type==="text";)Ne=ne[++w],Le+=`
`+(Ne.tokens?this.parseInline(Ne.tokens):Ne.text);Q+=q?this.renderer.paragraph(Le):Le;continue}default:{var Ze='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return Q},Ee.parseInline=function(ne,q){q=q||this.renderer;var Q="",w,U,z,j=ne.length;for(w=0;w<j;w++){if(U=ne[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(z=this.options.extensions.renderers[U.type].call({parser:this},U),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(U.type))){Q+=z||"";continue}switch(U.type){case"escape":{Q+=q.text(U.text);break}case"html":{Q+=q.html(U.text);break}case"link":{Q+=q.link(U.href,U.title,this.parseInline(U.tokens,q));break}case"image":{Q+=q.image(U.href,U.title,U.text);break}case"strong":{Q+=q.strong(this.parseInline(U.tokens,q));break}case"em":{Q+=q.em(this.parseInline(U.tokens,q));break}case"codespan":{Q+=q.codespan(U.text);break}case"br":{Q+=q.br();break}case"del":{Q+=q.del(this.parseInline(U.tokens,q));break}case"text":{Q+=q.text(U.text);break}default:{var ee='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return Q},Ce}();function he(Ce,Ee,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof Ee=="function"&&(De=Ee,Ee=null),Ee=n({},he.defaults,Ee||{}),P(Ee),De){var ne=Ee.highlight,q;try{q=R.lex(Ce,Ee)}catch(z){return De(z)}var Q=function(j){var ee;if(!j)try{Ee.walkTokens&&he.walkTokens(q,Ee.walkTokens),ee=ie.parse(q,Ee)}catch(ce){j=ce}return Ee.highlight=ne,j?De(j):De(null,ee)};if(!ne||ne.length<3||(delete Ee.highlight,!q.length))return Q();var w=0;he.walkTokens(q,function(z){z.type==="code"&&(w++,setTimeout(function(){ne(z.text,z.lang,function(j,ee){if(j)return Q(j);ee!=null&&ee!==z.text&&(z.text=ee,z.escaped=!0),w--,w===0&&Q()})},0))}),w===0&&Q();return}try{var U=R.lex(Ce,Ee);return Ee.walkTokens&&he.walkTokens(U,Ee.walkTokens),ie.parse(U,Ee)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+o(z.message+"",!0)+"</pre>";throw z}}he.options=he.setOptions=function(Ce){return n(he.defaults,Ce),A(he.defaults),he},he.getDefaults=I,he.defaults=J.defaults,he.use=function(){for(var Ce=arguments.length,Ee=new Array(Ce),De=0;De<Ce;De++)Ee[De]=arguments[De];var ne=n.apply(void 0,[{}].concat(Ee)),q=he.defaults.extensions||{renderers:{},childTokens:{}},Q;Ee.forEach(function(w){if(w.extensions&&(Q=!0,w.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var j=q.renderers?q.renderers[z.name]:null;j?q.renderers[z.name]=function(){for(var ee=arguments.length,ce=new Array(ee),ve=0;ve<ee;ve++)ce[ve]=arguments[ve];var Oe=z.renderer.apply(this,ce);return Oe===!1&&(Oe=j.apply(this,ce)),Oe}:q.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");q[z.level]?q[z.level].unshift(z.tokenizer):q[z.level]=[z.tokenizer],z.start&&(z.level==="block"?q.startBlock?q.startBlock.push(z.start):q.startBlock=[z.start]:z.level==="inline"&&(q.startInline?q.startInline.push(z.start):q.startInline=[z.start]))}z.childTokens&&(q.childTokens[z.name]=z.childTokens)})),w.renderer&&function(){var z=he.defaults.renderer||new se,j=function(ve){var Oe=z[ve];z[ve]=function(){for(var Le=arguments.length,Ne=new Array(Le),Ve=0;Ve<Le;Ve++)Ne[Ve]=arguments[Ve];var Je=w.renderer[ve].apply(z,Ne);return Je===!1&&(Je=Oe.apply(z,Ne)),Je}};for(var ee in w.renderer)j(ee);ne.renderer=z}(),w.tokenizer&&function(){var z=he.defaults.tokenizer||new x,j=function(ve){var Oe=z[ve];z[ve]=function(){for(var Le=arguments.length,Ne=new Array(Le),Ve=0;Ve<Le;Ve++)Ne[Ve]=arguments[Ve];var Je=w.tokenizer[ve].apply(z,Ne);return Je===!1&&(Je=Oe.apply(z,Ne)),Je}};for(var ee in w.tokenizer)j(ee);ne.tokenizer=z}(),w.walkTokens){var U=he.defaults.walkTokens;ne.walkTokens=function(z){w.walkTokens.call(this,z),U&&U.call(this,z)}}Q&&(ne.extensions=q),he.setOptions(ne)})},he.walkTokens=function(Ce,Ee){for(var De=function(){var w=q.value;switch(Ee.call(he,w),w.type){case"table":{for(var U=M(w.header),z;!(z=U()).done;){var j=z.value;he.walkTokens(j.tokens,Ee)}for(var ee=M(w.rows),ce;!(ce=ee()).done;)for(var ve=ce.value,Oe=M(ve),Le;!(Le=Oe()).done;){var Ne=Le.value;he.walkTokens(Ne.tokens,Ee)}break}case"list":{he.walkTokens(w.items,Ee);break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[w.type]?he.defaults.extensions.childTokens[w.type].forEach(function(Ve){he.walkTokens(w[Ve],Ee)}):w.tokens&&he.walkTokens(w.tokens,Ee)}},ne=M(Ce),q;!(q=ne()).done;)De()},he.parseInline=function(Ce,Ee){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");Ee=n({},he.defaults,Ee||{}),P(Ee);try{var De=R.lexInline(Ce,Ee);return Ee.walkTokens&&he.walkTokens(De,Ee.walkTokens),ie.parseInline(De,Ee)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+o(ne.message+"",!0)+"</pre>";throw ne}},he.Parser=ie,he.parser=ie.parse,he.Renderer=se,he.TextRenderer=de,he.Lexer=R,he.lexer=R.lex,he.Tokenizer=x,he.Slugger=X,he.parse=he;var me=he.options,fe=he.setOptions,ae=he.use,pe=he.walkTokens,Ae=he.parseInline,Fe=he,He=ie.parse,Ye=R.lex;J.Lexer=R,J.Parser=ie,J.Renderer=se,J.Slugger=X,J.TextRenderer=de,J.Tokenizer=x,J.getDefaults=I,J.lexer=Ye,J.marked=he,J.options=me,J.parse=Fe,J.parseInline=Ae,J.parser=He,J.setOptions=fe,J.use=ae,J.walkTokens=pe,Object.defineProperty(J,"__esModule",{value:!0})}),define(be[103],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(A,y,O){return Math.min(Math.max(A,y),O)}e.clamp=l;function T(A,y){return(y+A%y)%y}e.rot=T;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class M{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class I{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const O=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=O,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function J(b){const M=[];typeof b=="number"&&M.push("code/timeOrigin",b);function I(y){M.push(y,Date.now())}function A(){const y=[];for(let O=0;O<M.length;O+=2)y.push({name:M[O],startTime:M[O+1]});return y}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const I of performance.getEntriesByType("mark"))M.push({name:I.name,startTime:Math.round(b+I.startTime)});return M}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=l(T))}(),define(be[74],Se([1,0,17]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var T;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex",C.uriList="text/uri-list"})(T=e.Mimes||(e.Mimes={}));const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(C){const u=(0,l.extname)(C),g=b[u.toLowerCase()];return g!==void 0?g:A(C)}e.getMediaOrTextMime=I;function A(C){const u=(0,l.extname)(C);return M[u.toLowerCase()]}e.getMediaMime=A;function y(C){for(const u in M)if(M[u]===C)return u}e.getExtensionForMimeType=y;const O=/^(.+)\/(.+?)(;.+)?$/;function L(C,u){const g=O.exec(C);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:u?void 0:C}e.normalizeMimeType=L}),define(be[104],Se([1,0,14,7]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(_){const E=_;return E?typeof E.read=="function":!1}e.isReadable=b;function M(_){const E=_;return E?[E.on,E.pause,E.resume,E.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=M;function I(_){const E=_;return E?M(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(_,E){return new y(_,E)}e.newWriteableStream=A;class y{constructor(E,a){this.reducer=E,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E!="undefined"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(a=>a(E))}emitError(E){this.listeners.error.length===0?(0,l.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(a=>a(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,a){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(E,a){if(this.state.destroyed)return;let k;switch(E){case"data":k=this.listeners.data;break;case"end":k=this.listeners.end;break;case"error":k=this.listeners.error;break}if(k){const s=k.indexOf(a);s>=0&&k.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(k=>k())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function O(_,E){const a=[];let k;for(;(k=_.read())!==null;)a.push(k);return E(a)}e.consumeReadable=O;function L(_,E,a){const k=[];let s;for(;(s=_.read())!==null&&k.length<a;)k.push(s);return s===null&&k.length>0?E(k):{read:()=>{if(k.length>0)return k.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return _.read()}}}e.peekReadable=L;function C(_,E){return new Promise((a,k)=>{const s=[];u(_,{onData:i=>{E&&s.push(i)},onError:i=>{E?k(i):a(void 0)},onEnd:()=>{a(E?E(s):void 0)}})})}e.consumeStream=C;function u(_,E){let a=!1;return _.on("error",k=>{a||E.onError(k)}),_.on("end",()=>{a||E.onEnd()}),_.on("data",k=>{a||E.onData(k)}),(0,T.toDisposable)(()=>a=!0)}e.listenStream=u;function g(_,E){return new Promise((a,k)=>{const s=new T.DisposableStore,i=[],c=m=>{if(i.push(m),i.length>E)return s.dispose(),_.pause(),a({stream:_,buffer:i,ended:!1})},t=m=>k(m),n=()=>a({stream:_,buffer:i,ended:!0});s.add((0,T.toDisposable)(()=>_.removeListener("error",t))),_.on("error",t),s.add((0,T.toDisposable)(()=>_.removeListener("end",n))),_.on("end",n),s.add((0,T.toDisposable)(()=>_.removeListener("data",c))),_.on("data",c)})}e.peekStream=g;function o(_,E){const a=A(E);return a.end(_),a}e.toStream=o;function r(){const _=A(()=>{throw new Error("not supported")});return _.end(),_}e.emptyStream=r;function f(_){let E=!1;return{read:()=>E?null:(E=!0,_)}}e.toReadable=f;function p(_,E,a){const k=A(a);return u(_,{onData:s=>k.write(E.data(s)),onError:s=>k.error(E.error?E.error(s):s),onEnd:()=>k.end()}),k}e.transform=p;function D(_,E,a){let k=!1;return{read:()=>{const s=E.read();return k?s:(k=!0,s!==null?a([_,s]):_)}}}e.prefixedReadable=D;function h(_,E,a){let k=!1;const s=A(a);return u(E,{onData:i=>k?s.write(i):(k=!0,s.write(a([_,i]))),onError:i=>s.error(i),onEnd:()=>{k||(k=!0,s.write(_)),s.end()}}),s}e.prefixedStream=h}),define(be[22],Se([1,0,104]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let b,M;class I{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return T?new I(Buffer.allocUnsafe(m)):new I(new Uint8Array(m))}static wrap(m){return T&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new I(m)}static fromString(m,d){return!(d?.dontUseNodeBuffer||!1)&&T?new I(Buffer.from(m)):(b||(b=new TextEncoder),new I(b.encode(m)))}static fromByteArray(m){const d=I.alloc(m.length);for(let S=0,P=m.length;S<P;S++)d.buffer[S]=m[S];return d}static concat(m,d){if(typeof d=="undefined"){d=0;for(let B=0,F=m.length;B<F;B++)d+=m[B].byteLength}const S=I.alloc(d);let P=0;for(let B=0,F=m.length;B<F;B++){const v=m[B];S.set(v,P),P+=v.byteLength}return S}clone(){const m=I.alloc(this.byteLength);return m.set(this),m}toString(){return T?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(m,d){return new I(this.buffer.subarray(m,d))}set(m,d){if(m instanceof I)this.buffer.set(m.buffer,d);else if(m instanceof Uint8Array)this.buffer.set(m,d);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),d);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return O(this.buffer,m)}writeUInt32BE(m,d){L(this.buffer,m,d)}readUInt32LE(m){return C(this.buffer,m)}writeUInt32LE(m,d){u(this.buffer,m,d)}readUInt8(m){return g(this.buffer,m)}writeUInt8(m,d){o(this.buffer,m,d)}}e.VSBuffer=I;function A(n,m){return n[m+0]<<0>>>0|n[m+1]<<8>>>0}e.readUInt16LE=A;function y(n,m,d){n[d+0]=m&255,m=m>>>8,n[d+1]=m&255}e.writeUInt16LE=y;function O(n,m){return n[m]*2**24+n[m+1]*2**16+n[m+2]*2**8+n[m+3]}e.readUInt32BE=O;function L(n,m,d){n[d+3]=m,m=m>>>8,n[d+2]=m,m=m>>>8,n[d+1]=m,m=m>>>8,n[d]=m}e.writeUInt32BE=L;function C(n,m){return n[m+0]<<0>>>0|n[m+1]<<8>>>0|n[m+2]<<16>>>0|n[m+3]<<24>>>0}e.readUInt32LE=C;function u(n,m,d){n[d+0]=m&255,m=m>>>8,n[d+1]=m&255,m=m>>>8,n[d+2]=m&255,m=m>>>8,n[d+3]=m&255}e.writeUInt32LE=u;function g(n,m){return n[m]}e.readUInt8=g;function o(n,m,d){n[d]=m}e.writeUInt8=o;function r(n){return l.consumeReadable(n,m=>I.concat(m))}e.readableToBuffer=r;function f(n){return l.toReadable(n)}e.bufferToReadable=f;function p(n){return l.consumeStream(n,m=>I.concat(m))}e.streamToBuffer=p;async function D(n){return n.ended?I.concat(n.buffer):I.concat([...n.buffer,await p(n.stream)])}e.bufferedStreamToBuffer=D;function h(n){return l.toStream(n,m=>I.concat(m))}e.bufferToStream=h;function _(n){return l.transform(n,{data:m=>typeof m=="string"?I.fromString(m):I.wrap(m)},m=>I.concat(m))}e.streamToBufferReadableStream=_;function E(n){return l.newWriteableStream(m=>I.concat(m),n)}e.newWriteableBufferStream=E;function a(n,m){return l.prefixedReadable(n,m,d=>I.concat(d))}e.prefixedBufferReadable=a;function k(n,m){return l.prefixedStream(n,m,d=>I.concat(d))}e.prefixedBufferStream=k;function s(n){let m=0,d=0,S=0;const P=new Uint8Array(Math.floor(n.length/4*3)),B=v=>{switch(d){case 3:P[S++]=m|v,d=0;break;case 2:P[S++]=m|v>>>2,m=v<<6,d=3;break;case 1:P[S++]=m|v>>>4,m=v<<4,d=2;break;default:m=v<<2,d=1}};for(let v=0;v<n.length;v++){const x=n.charCodeAt(v);if(x>=65&&x<=90)B(x-65);else if(x>=97&&x<=122)B(x-97+26);else if(x>=48&&x<=57)B(x-48+52);else if(x===43||x===45)B(62);else if(x===47||x===95)B(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${n[v]}`)}}const F=S;for(;d>0;)B(0);return I.wrap(P).slice(0,F)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:n},m=!0,d=!1){const S=d?c:i;let P="";const B=n.byteLength%3;let F=0;for(;F<n.byteLength-B;F+=3){const v=n[F+0],x=n[F+1],W=n[F+2];P+=S[v>>>2],P+=S[(v<<4|x>>>4)&63],P+=S[(x<<2|W>>>6)&63],P+=S[W&63]}if(B===1){const v=n[F+0];P+=S[v>>>2],P+=S[v<<4&63],m&&(P+="==")}else if(B===2){const v=n[F+0],x=n[F+1];P+=S[v>>>2],P+=S[(v<<4|x>>>4)&63],P+=S[x<<2&63],m&&(P+="=")}return P}e.encodeBase64=t});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[23],Se([1,0,16,9]),function(J,e,l,T){"use strict";var b,M,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(s,i,c){let t=s.get(i);return t===void 0&&(t=c,s.set(i,t)),t}e.getOrSet=A;function y(s){const i=[];return s.forEach((c,t)=>{i.push(`${t} => ${c}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=y;function O(s){const i=[];return s.forEach(c=>{i.push(c)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=O;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const c=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return c-t}value(){return this._value[this._pos]}}e.StringIterator=L;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,T.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class u{constructor(i=!0,c=!0){this._splitOnBackslash=i,this._caseSensitive=c}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let c=i.length-1;c>=0;c--,this._valueLen--){const t=this._value.charCodeAt(c);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,T.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var g;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(g||(g={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,T.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(f||(f={}));class p{constructor(i){this._iter=i}static forUris(i=()=>!1){return new p(new o(i))}static forPaths(i=!1){return new p(new u(void 0,!i))}static forStrings(){return new p(new L)}static forConfigKeys(){return new p(new C)}clear(){this._root=void 0}fill(i,c){if(c){const t=c.slice(0);(0,l.shuffle)(t);for(let n of t)this.set(n,i)}else{const t=i.slice(0);(0,l.shuffle)(t);for(let n of t)this.set(n[0],n[1])}}set(i,c){const t=this._iter.reset(i);let n;this._root||(this._root=new r,this._root.segment=t.value());const m=[];for(n=this._root;;){const S=t.cmp(n.segment);if(S>0)n.left||(n.left=new r,n.left.segment=t.value()),m.push([-1,n]),n=n.left;else if(S<0)n.right||(n.right=new r,n.right.segment=t.value()),m.push([1,n]),n=n.right;else if(t.hasNext())t.next(),n.mid||(n.mid=new r,n.mid.segment=t.value()),m.push([0,n]),n=n.mid;else break}const d=n.value;n.value=c,n.key=i;for(let S=m.length-1;S>=0;S--){const P=m[S][1];P.updateHeight();const B=P.balanceFactor();if(B<-1||B>1){const F=m[S][0],v=m[S+1][0];if(F===1&&v===1)m[S][1]=P.rotateLeft();else if(F===-1&&v===-1)m[S][1]=P.rotateRight();else if(F===1&&v===-1)P.right=m[S+1][1]=m[S+1][1].rotateRight(),m[S][1]=P.rotateLeft();else if(F===-1&&v===1)P.left=m[S+1][1]=m[S+1][1].rotateLeft(),m[S][1]=P.rotateRight();else throw new Error;if(S>0)switch(m[S-1][0]){case-1:m[S-1][1].left=m[S][1];break;case 1:m[S-1][1].right=m[S][1];break;case 0:m[S-1][1].mid=m[S][1];break}else this._root=m[0][1]}}return d}get(i){return this._getNode(i)?.value}_getNode(i){const c=this._iter.reset(i);let t=this._root;for(;t;){const n=c.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(c.hasNext())c.next(),t=t.mid;else break}return t}has(i){const c=this._getNode(i);return!(c?.value===void 0&&c?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,c){const t=this._iter.reset(i),n=[];let m=this._root;for(;m;){const d=t.cmp(m.segment);if(d>0)n.push([-1,m]),m=m.left;else if(d<0)n.push([1,m]),m=m.right;else if(t.hasNext())t.next(),n.push([0,m]),m=m.mid;else break}if(!!m){if(c?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const d=this._min(m.right),{key:S,value:P,segment:B}=d;this._delete(d.key,!1),m.key=S,m.value=P,m.segment=B}else{const d=m.left??m.right;if(n.length>0){const[S,P]=n[n.length-1];switch(S){case-1:P.left=d;break;case 0:P.mid=d;break;case 1:P.right=d;break}}else this._root=d}for(let d=n.length-1;d>=0;d--){const S=n[d][1];S.updateHeight();const P=S.balanceFactor();if(P>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),n[d][1]=S.rotateLeft()):P<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),n[d][1]=S.rotateRight()),d>0)switch(n[d-1][0]){case-1:n[d-1][1].left=n[d][1];break;case 1:n[d-1][1].right=n[d][1];break;case 0:n[d-1][1].mid=n[d][1];break}else this._root=n[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const c=this._iter.reset(i);let t=this._root,n;for(;t;){const m=c.cmp(t.segment);if(m>0)t=t.left;else if(m<0)t=t.right;else if(c.hasNext())c.next(),n=t.value||n,t=t.mid;else break}return t&&t.value||n}findSuperstr(i){const c=this._iter.reset(i);let t=this._root;for(;t;){const n=c.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(c.hasNext())c.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[c,t]of this)i(t,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=c=>{if(!c)return!0;const t=c.balanceFactor();return t<-1||t>1?!1:i(c.left)&&i(c.right)};return i(this._root)}}e.TernarySearchTree=p;class D{constructor(i,c){this.uri=i,this.value=c}}class h{constructor(i,c){this[b]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=c??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,c){return this.map.set(this.toKey(i),new D(i,c)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,c){typeof c!="undefined"&&(i=i.bind(c));for(let[t,n]of this.map)i(n.value,n.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=s=>s.toString();var _;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class E{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,c=0){const t=this._map.get(i);if(!!t)return c!==0&&this.touch(t,c),t.value}set(i,c,t=0){let n=this._map.get(i);if(n)n.value=c,t!==0&&this.touch(n,t);else{switch(n={key:i,value:c,next:void 0,previous:void 0},t){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(i,n),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this._map.get(i);if(!!c)return this._map.delete(i),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,c){const t=this._state;let n=this._head;for(;n;){if(c?i.bind(c)(n.value,n.key,this):i(n.value,n.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const i=this,c=this._state;let t=this._head;const n={[Symbol.iterator](){return n},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const m={value:t.key,done:!1};return t=t.next,m}else return{value:void 0,done:!0}}};return n}values(){const i=this,c=this._state;let t=this._head;const n={[Symbol.iterator](){return n},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const m={value:t.value,done:!1};return t=t.next,m}else return{value:void 0,done:!0}}};return n}entries(){const i=this,c=this._state;let t=this._head;const n={[Symbol.iterator](){return n},next(){if(i._state!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const m={value:[t.key,t.value],done:!1};return t=t.next,m}else return{value:void 0,done:!0}}};return n}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this._head,t=this.size;for(;c&&t>i;)this._map.delete(c.key),c=c.next,t--;this._head=c,this._size=t,c&&(c.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const c=i.next,t=i.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}i.next=void 0,i.previous=void 0,this._state++}touch(i,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this._head)return;const t=i.next,n=i.previous;i===this._tail?(n.next=void 0,this._tail=n):(t.previous=n,n.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(c===2){if(i===this._tail)return;const t=i.next,n=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=n,n.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((c,t)=>{i.push([t,c])}),i}fromJSON(i){this.clear();for(const[c,t]of i)this.set(c,t)}}e.LinkedMap=E;class a extends E{constructor(i,c=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class k{constructor(i){I.set(this,void 0),Ge(this,I,i,"f")}get size(){return Te(this,I,"f").size}forEach(i,c){Te(this,I,"f").forEach(i,c)}get(i){return Te(this,I,"f").get(i)}has(i){return Te(this,I,"f").has(i)}entries(){return Te(this,I,"f").entries()}keys(){return Te(this,I,"f").keys()}values(){return Te(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Te(this,I,"f").entries()}}e.ReadonlyMapView=k}),define(be[105],Se([1,0,23,9]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...q){return function(Q,w){for(let U=0,z=q.length;U<z;U++){const j=q[U](Q,w);if(j)return j}return null}}e.or=b,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(q,Q,w){if(!w||w.length<Q.length)return null;let U;return q?U=T.startsWithIgnoreCase(w,Q):U=w.indexOf(Q)===0,U?Q.length>0?[{start:0,end:Q.length}]:[]:null}function I(q,Q){const w=Q.toLowerCase().indexOf(q.toLowerCase());return w===-1?null:[{start:w,end:w+q.length}]}e.matchesContiguousSubString=I;function A(q,Q){return y(q.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=A;function y(q,Q,w,U){if(w===q.length)return[];if(U===Q.length)return null;if(q[w]===Q[U]){let z=null;return(z=y(q,Q,w+1,U+1))?p({start:U,end:U+1},z):null}return y(q,Q,w,U+1)}function O(q){return 97<=q&&q<=122}function L(q){return 65<=q&&q<=90}e.isUpper=L;function C(q){return 48<=q&&q<=57}function u(q){return q===32||q===9||q===10||q===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>g.add(q.charCodeAt(0)));function o(q){return u(q)||g.has(q)}function r(q,Q){return q===Q||o(q)&&o(Q)}function f(q){return O(q)||L(q)||C(q)}function p(q,Q){return Q.length===0?Q=[q]:q.end===Q[0].start?Q[0].start=q.start:Q.unshift(q),Q}function D(q,Q){for(let w=Q;w<q.length;w++){const U=q.charCodeAt(w);if(L(U)||C(U)||w>0&&!f(q.charCodeAt(w-1)))return w}return q.length}function h(q,Q,w,U){if(w===q.length)return[];if(U===Q.length)return null;if(q[w]!==Q[U].toLowerCase())return null;{let z=null,j=U+1;for(z=h(q,Q,w+1,U+1);!z&&(j=D(Q,j))<Q.length;)z=h(q,Q,w+1,j),j++;return z===null?null:p({start:U,end:U+1},z)}}function _(q){let Q=0,w=0,U=0,z=0,j=0;for(let Le=0;Le<q.length;Le++)j=q.charCodeAt(Le),L(j)&&Q++,O(j)&&w++,f(j)&&U++,C(j)&&z++;const ee=Q/q.length,ce=w/q.length,ve=U/q.length,Oe=z/q.length;return{upperPercent:ee,lowerPercent:ce,alphaPercent:ve,numericPercent:Oe}}function E(q){const{upperPercent:Q,lowerPercent:w}=q;return w===0&&Q>.6}function a(q){const{upperPercent:Q,lowerPercent:w,alphaPercent:U,numericPercent:z}=q;return w>.2&&Q<.8&&U>.6&&z<.2}function k(q){let Q=0,w=0,U=0,z=0;for(let j=0;j<q.length;j++)U=q.charCodeAt(j),L(U)&&Q++,O(U)&&w++,u(U)&&z++;return(Q===0||w===0)&&z===0?q.length<=30:Q<=5}function s(q,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!k(q)||Q.length>60)return null;const w=_(Q);if(!a(w)){if(!E(w))return null;Q=Q.toLowerCase()}let U=null,z=0;for(q=q.toLowerCase();z<Q.length&&(U=h(q,Q,0,z))===null;)z=D(Q,z+1);return U}e.matchesCamelCase=s;function i(q,Q,w=!1){if(!Q||Q.length===0)return null;let U=null,z=0;for(q=q.toLowerCase(),Q=Q.toLowerCase();z<Q.length&&(U=c(q,Q,0,z,w))===null;)z=t(Q,z+1);return U}e.matchesWords=i;function c(q,Q,w,U,z){if(w===q.length)return[];if(U===Q.length)return null;if(r(q.charCodeAt(w),Q.charCodeAt(U))){let j=null,ee=U+1;if(j=c(q,Q,w+1,U+1,z),!z)for(;!j&&(ee=t(Q,ee))<Q.length;)j=c(q,Q,w+1,ee,z),ee++;return j===null?null:p({start:U,end:U+1},j)}else return null}function t(q,Q){for(let w=Q;w<q.length;w++)if(o(q.charCodeAt(w))||w>0&&o(q.charCodeAt(w-1)))return w;return q.length}const n=b(e.matchesPrefix,s,I),m=b(e.matchesPrefix,s,A),d=new l.LRUCache(1e4);function S(q,Q,w=!1){if(typeof q!="string"||typeof Q!="string")return null;let U=d.get(q);U||(U=new RegExp(T.convertSimple2RegExpPattern(q),"i"),d.set(q,U));const z=U.exec(Q);return z?[{start:z.index,end:z.index+z[0].length}]:w?m(q,Q):n(q,Q)}e.matchesFuzzy=S;function P(q,Q){const w=Fe(q,q.toLowerCase(),0,Q,Q.toLowerCase(),0,!0);return w?F(w):null}e.matchesFuzzy2=P;function B(q,Q,w,U,z,j){const ee=Math.min(13,q.length);for(;w<ee;w++){const ce=Fe(q,Q,w,U,z,j,!1);if(ce)return ce}return[0,j]}e.anyScore=B;function F(q){if(typeof q=="undefined")return[];const Q=[],w=q[1];for(let U=q.length-1;U>1;U--){const z=q[U]+w,j=Q[Q.length-1];j&&j.end===z?j.end=z+1:Q.push({start:z,end:z+1})}return Q}e.createMatches=F;const v=128;function x(){const q=[],Q=[];for(let w=0;w<=v;w++)Q[w]=0;for(let w=0;w<=v;w++)q.push(Q.slice(0));return q}function W(q){const Q=[];for(let w=0;w<=q;w++)Q[w]=0;return Q}const V=W(2*v),re=W(2*v),H=x(),R=x(),se=x(),de=!1;function X(q,Q,w,U,z){function j(ce,ve,Oe=" "){for(;ce.length<ve;)ce=Oe+ce;return ce}let ee=` |   |${U.split("").map(ce=>j(ce,3)).join("|")}
`;for(let ce=0;ce<=w;ce++)ce===0?ee+=" |":ee+=`${Q[ce-1]}|`,ee+=q[ce].slice(0,z+1).map(ve=>j(ve.toString(),3)).join("|")+`
`;return ee}function ie(q,Q,w,U){q=q.substr(Q),w=w.substr(U),console.log(X(R,q,q.length,w,w.length)),console.log(X(se,q,q.length,w,w.length)),console.log(X(H,q,q.length,w,w.length))}function he(q,Q){if(Q<0||Q>=q.length)return!1;const w=q.codePointAt(Q);switch(w){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(w)}}function me(q,Q){if(Q<0||Q>=q.length)return!1;switch(q.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function fe(q,Q,w){return Q[q]!==w[q]}function ae(q,Q,w,U,z,j,ee=!1){for(;Q<w&&z<j;)q[Q]===U[z]&&(ee&&(V[Q]=z),Q+=1),z+=1;return Q===w}e.isPatternInWord=ae;var pe;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Ae;(function(q){q.Default=[-100,0];function Q(w){return!w||w.length===2&&w[0]===-100&&w[1]===0}q.isDefault=Q})(Ae=e.FuzzyScore||(e.FuzzyScore={}));function Fe(q,Q,w,U,z,j,ee){const ce=q.length>v?v:q.length,ve=U.length>v?v:U.length;if(w>=ce||j>=ve||ce-w>ve-j||!ae(Q,w,ce,z,j,ve,!0))return;He(ce,ve,w,j,Q,z);let Oe=1,Le=1,Ne=w,Ve=j;const Je=[!1];for(Oe=1,Ne=w;Ne<ce;Oe++,Ne++){const ue=V[Ne],Me=re[Ne],We=Ne+1<ce?re[Ne+1]:ve;for(Le=ue-j+1,Ve=ue;Ve<We;Le++,Ve++){let Xe=Number.MIN_SAFE_INTEGER,Ze=!1;Ve<=Me&&(Xe=Ye(q,Q,Ne,w,U,z,Ve,ve,j,H[Oe-1][Le-1]===0,Je));let ot=0;Xe!==Number.MAX_SAFE_INTEGER&&(Ze=!0,ot=Xe+R[Oe-1][Le-1]);const wt=Ve>ue,mt=wt?R[Oe][Le-1]+(H[Oe][Le-1]>0?-5:0):0,kt=Ve>ue+1&&H[Oe][Le-1]>0,qe=kt?R[Oe][Le-2]+(H[Oe][Le-2]>0?-5:0):0;if(kt&&(!wt||qe>=mt)&&(!Ze||qe>=ot))R[Oe][Le]=qe,se[Oe][Le]=3,H[Oe][Le]=0;else if(wt&&(!Ze||mt>=ot))R[Oe][Le]=mt,se[Oe][Le]=2,H[Oe][Le]=0;else if(Ze)R[Oe][Le]=ot,se[Oe][Le]=1,H[Oe][Le]=H[Oe-1][Le-1]+1;else throw new Error("not possible")}}if(de&&ie(q,w,U,j),!Je[0]&&!ee)return;Oe--,Le--;const ke=[R[Oe][Le],j];let je=0,G=0;for(;Oe>=1;){let ue=Le;do{const Me=se[Oe][ue];if(Me===3)ue=ue-2;else if(Me===2)ue=ue-1;else break}while(ue>=1);je>1&&Q[w+Oe-1]===z[j+Le-1]&&!fe(ue+j-1,U,z)&&je+1>H[Oe][ue]&&(ue=Le),ue===Le?je++:je=1,G||(G=ue),Oe--,Le=ue-1,ke.push(Le)}ve===ce&&(ke[0]+=2);const Y=G-ce;return ke[0]-=Y,ke}e.fuzzyScore=Fe;function He(q,Q,w,U,z,j){let ee=q-1,ce=Q-1;for(;ee>=w&&ce>=U;)z[ee]===j[ce]&&(re[ee]=ce,ee--),ce--}function Ye(q,Q,w,U,z,j,ee,ce,ve,Oe,Le){if(Q[w]!==j[ee])return Number.MIN_SAFE_INTEGER;let Ne=1,Ve=!1;return ee===w-U?Ne=q[w]===z[ee]?7:5:fe(ee,z,j)&&(ee===0||!fe(ee-1,z,j))?(Ne=q[w]===z[ee]?7:5,Ve=!0):he(j,ee)&&(ee===0||!he(j,ee-1))?Ne=5:(he(j,ee-1)||me(j,ee-1))&&(Ne=5,Ve=!0),Ne>1&&w===U&&(Le[0]=!0),Ve||(Ve=fe(ee,z,j)||he(j,ee-1)||me(j,ee-1)),w===U?ee>ve&&(Ne-=Ve?3:5):Oe?Ne+=Ve?2:0:Ne+=Ve?0:1,ee+1===ce&&(Ne-=Ve?3:5),Ne}function Ce(q,Q,w,U,z,j,ee){return De(q,Q,w,U,z,j,!0,ee)}e.fuzzyScoreGracefulAggressive=Ce;function Ee(q,Q,w,U,z,j,ee){return De(q,Q,w,U,z,j,!1,ee)}e.fuzzyScoreGraceful=Ee;function De(q,Q,w,U,z,j,ee,ce){let ve=Fe(q,Q,w,U,z,j,ce);if(ve&&!ee)return ve;if(q.length>=3){const Oe=Math.min(7,q.length-1);for(let Le=w+1;Le<Oe;Le++){const Ne=ne(q,Le);if(Ne){const Ve=Fe(Ne,Ne.toLowerCase(),w,U,z,j,ce);Ve&&(Ve[0]-=3,(!ve||Ve[0]>ve[0])&&(ve=Ve))}}}return ve}function ne(q,Q){if(Q+1>=q.length)return;const w=q[Q],U=q[Q+1];if(w!==U)return q.slice(0,Q)+U+w+q.slice(Q+2)}}),define(be[106],Se([1,0,107,105,9]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(l.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${M.source}`,"g");function y(f){return f.replace(A,(p,D)=>D?p:`\\${p}`)}e.escapeIcons=y;const O=new RegExp(`\\\\${M.source}`,"g");function L(f){return f.replace(O,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=L;const C=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(C,(p,D,h,_)=>h?p:D||_||"")}e.stripIcons=u;function g(f){const p=f.indexOf(e.iconStartMarker);return p===-1?{text:f}:o(f,p)}e.parseLabelWithIcons=g;function o(f,p){const D=[];let h="";function _(n){if(n){h+=n;for(const m of n)D.push(k)}}let E=-1,a="",k=0,s,i,c=p;const t=f.length;for(_(f.substr(0,p));c<t;)s=f[c],i=f[c+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(E=c,_(a),a=e.iconStartMarker,c++):s===")"&&E!==-1?(k+=c-E+1,E=-1,a=""):E!==-1?I.test(s)?a+=s:(_(a),E=-1,a=""):_(s),c++;return _(a),{text:h,iconOffsets:D}}function r(f,p,D=!1){const{text:h,iconOffsets:_}=p;if(!_||_.length===0)return(0,T.matchesFuzzy)(f,h,D);const E=(0,b.ltrim)(h," "),a=h.length-E.length,k=(0,T.matchesFuzzy)(f,E,D);if(k)for(const s of k){const i=_[s.start+a]+a;s.start+=i,s.end+=i}return k}e.matchesFuzzyIconAware=r}),define(be[34],Se([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(T||(T={})),function(b){const M="error",I="warning",A="warn",y="info",O="ignore";function L(u){return u?l.equalsIgnoreCase(M,u)?b.Error:l.equalsIgnoreCase(I,u)||l.equalsIgnoreCase(A,u)?b.Warning:l.equalsIgnoreCase(y,u)?b.Info:b.Ignore:b.Ignore}b.fromValue=L;function C(u){switch(u){case b.Error:return M;case b.Warning:return I;case b.Info:return y;default:return O}}b.toString=C}(T||(T={})),e.default=T}),define(be[35],Se([1,0,17,21,9,10]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(c){return c===47||c===92}e.isPathSeparator=I;function A(c){return c.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=A;function y(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function O(c,t=l.posix.sep){if(!c)return"";const n=c.length,m=c.charCodeAt(0);if(I(m)){if(I(c.charCodeAt(1))&&!I(c.charCodeAt(2))){let S=3;const P=S;for(;S<n&&!I(c.charCodeAt(S));S++);if(P!==S&&!I(c.charCodeAt(S+1))){for(S+=1;S<n;S++)if(I(c.charCodeAt(S)))return c.slice(0,S+1).replace(/[\\/]/g,t)}}return t}else if(p(m)&&c.charCodeAt(1)===58)return I(c.charCodeAt(2))?c.slice(0,2)+t:c.slice(0,2);let d=c.indexOf("://");if(d!==-1){for(d+=3;d<n;d++)if(I(c.charCodeAt(d)))return c.slice(0,d+1)}return""}e.getRoot=O;function L(c){if(!T.isWindows||!c||c.length<5)return!1;let t=c.charCodeAt(0);if(t!==92||(t=c.charCodeAt(1),t!==92))return!1;let n=2;const m=n;for(;n<c.length&&(t=c.charCodeAt(n),t!==92);n++);return!(m===n||(t=c.charCodeAt(n+1),isNaN(t)||t===92))}e.isUNC=L;const C=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(c,t=T.isWindows){const n=t?C:u;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||t&&g.test(c)||c==="."||c===".."||t&&c[c.length-1]==="."||t&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=o;function r(c,t,n){const m=c===t;return!n||m?m:!c||!t?!1:(0,b.equalsIgnoreCase)(c,t)}e.isEqual=r;function f(c,t,n,m=l.sep){if(c===t)return!0;if(!c||!t||t.length>c.length)return!1;if(n){if(!(0,b.startsWithIgnoreCase)(c,t))return!1;if(t.length===c.length)return!0;let S=t.length;return t.charAt(t.length-1)===m&&S--,c.charAt(S)===m}return t.charAt(t.length-1)!==m&&(t+=m),c.indexOf(t)===0}e.isEqualOrParent=f;function p(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=p;function D(c,t){return T.isWindows&&c.endsWith(":")&&(c+=l.sep),(0,l.isAbsolute)(c)||(c=(0,l.join)(t,c)),c=(0,l.normalize)(c),T.isWindows?(c=(0,b.rtrim)(c,l.sep),c.endsWith(":")&&(c+=l.sep)):(c=(0,b.rtrim)(c,l.sep),c||(c=l.sep)),c}e.sanitizeFilePath=D;function h(c){const t=(0,l.normalize)(c);return T.isWindows?c.length>3?!1:_(t)&&(c.length===2||t.charCodeAt(2)===92):t===l.posix.sep}e.isRootOrDriveLetter=h;function _(c,t){return(t!==void 0?t:T.isWindows)?p(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=_;function E(c){return _(c)?c[0]:void 0}e.getDriveLetter=E;function a(c,t,n){return t.length>c.length?-1:c===t?0:(n&&(c=c.toLowerCase(),t=t.toLowerCase()),c.indexOf(t))}e.indexOfPath=a;function k(c){const t=c.split(":");let n,m,d;for(const S of t){const P=Number(S);(0,M.isNumber)(P)?m===void 0?m=P:d===void 0&&(d=P):n=n?[n,S].join(":"):S}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:m!==void 0?m:void 0,column:d!==void 0?d:m!==void 0?1:void 0}}e.parseLineAndColumnAware=k;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(c,t,n=8){let m="";for(let S=0;S<n;S++)m+=s.charAt(Math.floor(Math.random()*s.length));let d;return t?d=`${t}-${m}`:d=m,c?(0,l.join)(c,d):d}e.randomPath=i}),define(be[54],Se([1,0,22,9,2]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(O){return JSON.stringify(O,A)}e.stringify=M;function I(O){let L=JSON.parse(O);return L=y(L),L}e.parse=I;function A(O,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,T.regExpFlags)(L)}:L}function y(O,L=0){if(!O||L>200)return O;if(typeof O=="object"){switch(O.$mid){case 1:return b.URI.revive(O);case 2:return new RegExp(O.source,O.flags);case 14:return new Date(O.source)}if(O instanceof l.VSBuffer||O instanceof Uint8Array)return O;if(Array.isArray(O))for(let C=0;C<O.length;++C)O[C]=y(O[C],L+1);else for(const C in O)Object.hasOwnProperty.call(O,C)&&(O[C]=y(O[C],L+1))}return O}e.revive=y}),define(be[11],Se([1,0,21,2]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.vscodeUserData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,O,L){this._hosts[y]=O,this._ports[y]=L}setConnectionToken(y,O){this._connectionTokens[y]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)return this._delegate(y);const O=y.authority;let L=this._hosts[O];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const C=this._ports[O],u=this._connectionTokens[O];let g=`path=${encodeURIComponent(y.path)}`;return typeof u=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),T.URI.from({scheme:l.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${L}:${C}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new M;class I{asBrowserUri(y,O){const L=this.toUri(y,O);return L.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===b.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${b.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?L.with({scheme:b.vscodeFileResource,authority:L.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(y,O){const L=this.toUri(y,O);return L.scheme===b.vscodeFileResource?L.with({scheme:b.file,authority:L.authority!==I.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,O){return T.URI.isUri(y)?y:T.URI.parse(O.toUrl(y))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(be[24],Se([1,0,35,11,17,21,9,2]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(g){return(0,A.uriToFsPath)(g,!0)}e.originalFSPath=y;class O{constructor(o){this._ignorePathCasing=o}compare(o,r,f=!1){return o===r?0:(0,I.compare)(this.getComparisonKey(o,f),this.getComparisonKey(r,f))}isEqual(o,r,f=!1){return o===r?!0:!o||!r?!1:this.getComparisonKey(o,f)===this.getComparisonKey(r,f)}getComparisonKey(o,r=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,r,f=!1){if(o.scheme===r.scheme){if(o.scheme===T.Schemas.file)return l.isEqualOrParent(y(o),y(r),this._ignorePathCasing(o))&&o.query===r.query&&(f||o.fragment===r.fragment);if((0,e.isEqualAuthority)(o.authority,r.authority))return l.isEqualOrParent(o.path,r.path,this._ignorePathCasing(o),"/")&&o.query===r.query&&(f||o.fragment===r.fragment)}return!1}joinPath(o,...r){return A.URI.joinPath(o,...r)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return b.posix.basename(o.path)}extname(o){return b.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let r;return o.scheme===T.Schemas.file?r=A.URI.file(b.dirname(y(o))).path:(r=b.posix.dirname(o.path),o.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),r="/")),o.with({path:r})}normalizePath(o){if(!o.path.length)return o;let r;return o.scheme===T.Schemas.file?r=A.URI.file(b.normalize(y(o))).path:r=b.posix.normalize(o.path),o.with({path:r})}relativePath(o,r){if(o.scheme!==r.scheme||!(0,e.isEqualAuthority)(o.authority,r.authority))return;if(o.scheme===T.Schemas.file){const D=b.relative(y(o),y(r));return M.isWindows?l.toSlashes(D):D}let f=o.path||"/",p=r.path||"/";if(this._ignorePathCasing(o)){let D=0;for(const h=Math.min(f.length,p.length);D<h&&!(f.charCodeAt(D)!==p.charCodeAt(D)&&f.charAt(D).toLowerCase()!==p.charAt(D).toLowerCase());D++);f=p.substr(0,D)+f.substr(D)}return b.posix.relative(f,p)}resolvePath(o,r){if(o.scheme===T.Schemas.file){const f=A.URI.file(b.resolve(y(o),r));return o.with({authority:f.authority,path:f.path})}return r=l.toPosixPath(r),o.with({path:b.posix.resolve(o.path,r)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,r){return o===r||o!==void 0&&r!==void 0&&(0,I.equalsIgnoreCase)(o,r)}hasTrailingPathSeparator(o,r=b.sep){if(o.scheme===T.Schemas.file){const f=y(o);return f.length>l.getRoot(f).length&&f[f.length-1]===r}else{const f=o.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,r=b.sep){return(0,e.hasTrailingPathSeparator)(o,r)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,r=b.sep){let f=!1;if(o.scheme===T.Schemas.file){const p=y(o);f=p!==void 0&&p.length===l.getRoot(p).length&&p[p.length-1]===r}else{r="/";const p=o.path;f=p.length===1&&p.charCodeAt(p.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(o,r)?o.with({path:o.path+"/"}):o}}e.ExtUri=O,e.extUri=new O(()=>!1),e.extUriBiasedIgnorePathCase=new O(g=>g.scheme===T.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new O(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(g,o){const r=[];for(let f=0;f<g.length;f++){const p=o(g[f]);g.some((D,h)=>h===f?!1:(0,e.isEqualOrParent)(p,o(D)))||r.push(g[f])}return r}e.distinctParents=L;var C;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function o(r){const f=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(h=>{const[_,E]=h.split(":");_&&E&&f.set(_,E)});const D=r.path.substring(0,r.path.indexOf(";"));return D&&f.set(g.META_DATA_MIME,D),f}g.parseMetaData=o})(C=e.DataUri||(e.DataUri={}));function u(g,o,r){if(o){let f=g.path;return f&&f[0]!==b.posix.sep&&(f=b.posix.sep+f),g.with({scheme:r,authority:o,path:f})}return g.with({scheme:r})}e.toLocalResource=u}),define(be[12],Se([1,0,20,14,5,7,24,21]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=y;function O(fe){const ae=new l.CancellationTokenSource,pe=fe(ae.token),Ae=new Promise((Fe,He)=>{const Ye=ae.token.onCancellationRequested(()=>{Ye.dispose(),ae.dispose(),He(new T.CancellationError)});Promise.resolve(pe).then(Ce=>{Ye.dispose(),ae.dispose(),Fe(Ce)},Ce=>{Ye.dispose(),ae.dispose(),He(Ce)})});return new class{cancel(){ae.cancel()}then(Fe,He){return Ae.then(Fe,He)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ae.finally(Fe)}}}e.createCancelablePromise=O;function L(fe,ae,pe){return new Promise((Ae,Fe)=>{const He=ae.onCancellationRequested(()=>{He.dispose(),Ae(pe)});fe.then(Ae,Fe).finally(()=>He.dispose())})}e.raceCancellation=L;function C(fe,ae){return new Promise((pe,Ae)=>{const Fe=ae.onCancellationRequested(()=>{Fe.dispose(),Ae(new T.CancellationError)});fe.then(pe,Ae).finally(()=>Fe.dispose())})}e.raceCancellationError=C;async function u(fe){let ae=-1;const pe=fe.map((Fe,He)=>Fe.then(Ye=>(ae=He,Ye))),Ae=await Promise.race(pe);return fe.forEach((Fe,He)=>{He!==ae&&Fe.cancel()}),Ae}e.raceCancellablePromises=u;function g(fe,ae,pe){let Ae;const Fe=setTimeout(()=>{Ae?.(void 0),pe?.()},ae);return Promise.race([fe.finally(()=>clearTimeout(Fe)),new Promise(He=>Ae=He)])}e.raceTimeout=g;function o(fe){return new Promise((ae,pe)=>{const Ae=fe();y(Ae)?Ae.then(ae,pe):ae(Ae)})}e.asPromise=o;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ae){if(this.activePromise){if(this.queuedPromiseFactory=ae,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ae};this.queuedPromise=new Promise(Ae=>{this.activePromise.then(pe,pe).then(Ae)})}return new Promise((pe,Ae)=>{this.queuedPromise.then(pe,Ae)})}return this.activePromise=ae(),new Promise((pe,Ae)=>{this.activePromise.then(Fe=>{this.activePromise=null,pe(Fe)},Fe=>{this.activePromise=null,Ae(Fe)})})}}e.Throttler=r;class f{constructor(){this.current=Promise.resolve(null)}queue(ae){return this.current=this.current.then(()=>ae(),()=>ae())}}e.Sequencer=f;class p{constructor(){this.promiseMap=new Map}queue(ae,pe){const Fe=(this.promiseMap.get(ae)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(ae)===Fe&&this.promiseMap.delete(ae)});return this.promiseMap.set(ae,Fe),Fe}}e.SequencerByKey=p;const D=(fe,ae)=>{let pe=!0;const Ae=setTimeout(()=>{pe=!1,ae()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Ae),pe=!1}}},h=fe=>{let ae=!0;return queueMicrotask(()=>{ae&&(ae=!1,fe())}),{isTriggered:()=>ae,dispose:()=>{ae=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class _{constructor(ae){this.defaultDelay=ae,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ae,pe=this.defaultDelay){this.task=ae,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,He)=>{this.doResolve=Fe,this.doReject=He}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?h(Ae):D(pe,Ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new T.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=_;class E{constructor(ae){this.delayer=new _(ae),this.throttler=new r}trigger(ae,pe){return this.delayer.trigger(()=>this.throttler.queue(ae),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class a{constructor(){this._isOpen=!1,this._promise=new Promise((ae,pe)=>{this._completePromise=ae})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class k extends a{constructor(ae){super();this._timeout=setTimeout(()=>this.open(),ae)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=k;function s(fe,ae){return ae?new Promise((pe,Ae)=>{const Fe=setTimeout(()=>{He.dispose(),pe()},fe),He=ae.onCancellationRequested(()=>{clearTimeout(Fe),He.dispose(),Ae(new T.CancellationError)})}):O(pe=>s(fe,pe))}e.timeout=s;function i(fe,ae=0){const pe=setTimeout(fe,ae);return(0,M.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=i;function c(fe){const ae=[];let pe=0;const Ae=fe.length;function Fe(){return pe<Ae?fe[pe++]():null}function He(Ye){Ye!=null&&ae.push(Ye);const Ce=Fe();return Ce?Ce.then(He):Promise.resolve(ae)}return Promise.resolve(null).then(He)}e.sequence=c;function t(fe,ae=Ae=>!!Ae,pe=null){let Ae=0;const Fe=fe.length,He=()=>{if(Ae>=Fe)return Promise.resolve(pe);const Ye=fe[Ae++];return Promise.resolve(Ye()).then(Ee=>ae(Ee)?Promise.resolve(Ee):He())};return He()}e.first=t;function n(fe,ae=Ae=>!!Ae,pe=null){if(fe.length===0)return Promise.resolve(pe);let Ae=fe.length;const Fe=()=>{Ae=-1;for(const He of fe)He.cancel?.()};return new Promise((He,Ye)=>{for(const Ce of fe)Ce.then(Ee=>{--Ae>=0&&ae(Ee)?(Fe(),He(Ee)):Ae===0&&He(pe)}).catch(Ee=>{--Ae>=0&&(Fe(),Ye(Ee))})})}e.firstParallel=n;class m{constructor(ae){this._size=0,this.maxDegreeOfParalellism=ae,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ae){return this._size++,new Promise((pe,Ae)=>{this.outstandingPromises.push({factory:ae,c:pe,e:Ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ae=this.outstandingPromises.shift();this.runningPromises++;const pe=ae.factory();pe.then(ae.c,ae.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class d extends m{constructor(){super(1)}}e.Queue=d;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ae=new se;return this.drainers.add(ae),ae.p}isDrained(){for(const[,ae]of this.queues)if(ae.size>0)return!1;return!0}queueFor(ae,pe=I.extUri){const Ae=pe.getComparisonKey(ae);let Fe=this.queues.get(Ae);return Fe||(Fe=new d,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Ae),this.onDidQueueDrain()}),this.queues.set(Ae,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ae of this.drainers)ae.complete();this.drainers.clear()}dispose(){for(const[,ae]of this.queues)ae.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class P{constructor(ae,pe){this._token=-1,typeof ae=="function"&&typeof pe=="number"&&this.setIfNotSet(ae,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ae,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ae()},pe)}setIfNotSet(ae,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ae()},pe))}}e.TimeoutTimer=P;class B{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ae,pe){this.cancel(),this._token=setInterval(()=>{ae()},pe)}}e.IntervalTimer=B;class F{constructor(ae,pe){this.timeoutToken=-1,this.runner=ae,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ae=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ae)}get delay(){return this.timeout}set delay(ae){this.timeout=ae}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class v{constructor(ae,pe){pe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=ae,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ae=this.timeout){ae%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ae/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=v;class x extends F{constructor(ae,pe){super(ae,pe);this.units=[]}work(ae){this.units.push(ae),this.isScheduled()||this.schedule()}doRun(){const ae=this.units;this.units=[],this.runner&&this.runner(ae)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class W extends M.Disposable{constructor(ae,pe){super();this.options=ae,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ae){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ae.length>this.options.maxBufferedWork)return!1}else if(this.pending+ae.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ae),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(ae)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.runWhenIdle=(fe,ae)=>{const pe=requestIdleCallback(fe,typeof ae=="number"?{timeout:ae}:void 0);let Ae=!1;return{dispose(){Ae||(Ae=!0,cancelIdleCallback(pe))}}}}();class V{constructor(ae){this._didRun=!1,this._executor=()=>{try{this._value=ae()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function re(fe,ae,pe){let Ae;for(let Fe=0;Fe<pe;Fe++)try{return await fe()}catch(He){Ae=He,await s(ae)}throw Ae}e.retry=re;class H{hasPending(ae){return this._pending?typeof ae=="number"?this._pending.taskId===ae:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ae,pe,Ae){return this._pending={taskId:ae,cancel:()=>Ae?.(),promise:pe},pe.then(()=>this.donePending(ae),()=>this.donePending(ae)),pe}donePending(ae){this._pending&&ae===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ae=this._next;this._next=void 0,ae.run().then(ae.promiseResolve,ae.promiseReject)}}setNext(ae){if(this._next)this._next.run=ae;else{let pe,Ae;const Fe=new Promise((He,Ye)=>{pe=He,Ae=Ye});this._next={run:ae,promise:Fe,promiseResolve:pe,promiseReject:Ae}}return this._next.promise}}e.TaskSequentializer=H;class R{constructor(ae,pe=()=>Date.now()){this.interval=ae,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const ae=this.nowFn();return ae-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ae,this.value=0),this.value++,this.value}}e.IntervalCounter=R;class se{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ae,pe)=>{this.completeCallback=ae,this.errorCallback=pe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ae){return new Promise(pe=>{this.completeCallback(ae),this.resolved=!0,pe()})}error(ae){return new Promise(pe=>{this.errorCallback(ae),this.rejected=!0,pe()})}cancel(){new Promise(ae=>{this.errorCallback(new T.CancellationError),this.rejected=!0,ae()})}}e.DeferredPromise=se;var de;(function(fe){async function ae(Ae){let Fe;const He=await Promise.all(Ae.map(Ye=>Ye.then(Ce=>Ce,Ce=>{Fe||(Fe=Ce)})));if(typeof Fe!="undefined")throw Fe;return He}fe.settled=ae;function pe(Ae){return new Promise(async(Fe,He)=>{try{await Ae(Fe,He)}catch(Ye){He(Ye)}})}fe.withAsyncBody=pe})(de=e.Promises||(e.Promises={}));var X;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(X||(X={}));class ie{constructor(ae){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const pe={emitOne:Ae=>this.emitOne(Ae),emitMany:Ae=>this.emitMany(Ae),reject:Ae=>this.reject(Ae)};try{await Promise.resolve(ae(pe)),this.resolve()}catch(Ae){this.reject(Ae)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}static fromArray(ae){return new ie(pe=>{pe.emitMany(ae)})}static fromPromise(ae){return new ie(async pe=>{pe.emitMany(await ae)})}static fromPromises(ae){return new ie(async pe=>{await Promise.all(ae.map(async Ae=>pe.emitOne(await Ae)))})}static merge(ae){return new ie(async pe=>{await Promise.all(ae.map(async Ae=>{for await(const Fe of Ae)pe.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ae=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ae<this._results.length)return{done:!1,value:this._results[ae++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ae,pe){return new ie(async Ae=>{for await(const Fe of ae)Ae.emitOne(pe(Fe))})}map(ae){return ie.map(this,ae)}static filter(ae,pe){return new ie(async Ae=>{for await(const Fe of ae)pe(Fe)&&Ae.emitOne(Fe)})}filter(ae){return ie.filter(this,ae)}static coalesce(ae){return ie.filter(ae,pe=>!!pe)}coalesce(){return ie.coalesce(this)}static async toPromise(ae){const pe=[];for await(const Ae of ae)pe.push(Ae);return pe}toPromise(){return ie.toPromise(this)}emitOne(ae){this._state===0&&(this._results.push(ae),this._onStateChanged.fire())}emitMany(ae){this._state===0&&(this._results=this._results.concat(ae),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ae){this._state===0&&(this._state=2,this._error=ae,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class he extends ie{constructor(ae,pe){super(pe);this._source=ae}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=he;function me(fe){const ae=new l.CancellationTokenSource,pe=fe(ae.token);return new he(ae,async Ae=>{const Fe=ae.token.onCancellationRequested(()=>{Fe.dispose(),ae.dispose(),Ae.reject(new T.CancellationError)});try{for await(const He of pe){if(ae.token.isCancellationRequested)return;Ae.emitOne(He)}Fe.dispose(),ae.dispose()}catch(He){Fe.dispose(),ae.dispose(),Ae.reject(He)}})}e.createCancelableAsyncIterable=me}),define(be[108],Se([1,0,12,17]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new l.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),M=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(d,S,P=!1){const B=d||"",F=S||"",v=b.value.collator.compare(B,F);return b.value.collatorIsNumeric&&v===0&&B!==F?B<F?-1:1:v}e.compareFileNames=A;function y(d,S){const P=M.value.collator;return d=d||"",S=S||"",E(P,d,S)}e.compareFileNamesDefault=y;function O(d,S){const P=M.value.collator;return d=d||"",S=S||"",i(d,S)||E(P,d,S)}e.compareFileNamesUpper=O;function L(d,S){const P=M.value.collator;return d=d||"",S=S||"",s(d,S)||E(P,d,S)}e.compareFileNamesLower=L;function C(d,S){return d=d||"",S=S||"",d===S?0:d<S?-1:1}e.compareFileNamesUnicode=C;function u(d,S,P=!1){P||(d=d&&d.toLowerCase(),S=S&&S.toLowerCase());const[B,F]=h(d),[v,x]=h(S);return B!==v?B<v?-1:1:F===x?0:F<x?-1:1}e.noIntlCompareFileNames=u;function g(d,S){const[P,B]=h(d),[F,v]=h(S);let x=b.value.collator.compare(B,v);if(x===0){if(b.value.collatorIsNumeric&&B!==v)return B<v?-1:1;if(x=b.value.collator.compare(P,F),b.value.collatorIsNumeric&&x===0&&P!==F)return P<F?-1:1}return x}e.compareFileExtensions=g;function o(d,S){d=d||"",S=S||"";const P=_(d),B=_(S),F=M.value.collator,v=I.value.collator;return E(v,P,B)||E(F,d,S)}e.compareFileExtensionsDefault=o;function r(d,S){d=d||"",S=S||"";const P=_(d),B=_(S),F=M.value.collator,v=I.value.collator;return E(v,P,B)||i(d,S)||E(F,d,S)}e.compareFileExtensionsUpper=r;function f(d,S){d=d||"",S=S||"";const P=_(d),B=_(S),F=M.value.collator,v=I.value.collator;return E(v,P,B)||s(d,S)||E(F,d,S)}e.compareFileExtensionsLower=f;function p(d,S){d=d||"",S=S||"";const P=_(d).toLowerCase(),B=_(S).toLowerCase();return P!==B?P<B?-1:1:d!==S?d<S?-1:1:0}e.compareFileExtensionsUnicode=p;const D=/^(.*?)(\.([^.]*))?$/;function h(d,S=!1){const P=d?D.exec(d):[];let B=[P&&P[1]||"",P&&P[3]||""];return S&&(!B[0]&&B[1]||B[0]&&B[0].charAt(0)===".")&&(B=[B[0]+"."+B[1],""]),B}function _(d){const S=d?D.exec(d):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function E(d,S,P){let B=d.compare(S,P);return B!==0?B:S.length!==P.length?S.length<P.length?-1:1:0}function a(d){const S=d.charAt(0);return S.toLocaleUpperCase()!==S}function k(d){const S=d.charAt(0);return S.toLocaleLowerCase()!==S}function s(d,S){return a(d)&&k(S)?-1:k(d)&&a(S)?1:0}function i(d,S){return k(d)&&a(S)?-1:a(d)&&k(S)?1:0}function c(d,S,P=!1){return P||(d=d&&d.toLowerCase(),S=S&&S.toLowerCase()),d===S?0:d<S?-1:1}function t(d,S,P=!1){const B=d.split(T.sep),F=S.split(T.sep),v=B.length-1,x=F.length-1;let W,V;for(let re=0;;re++){if(W=v===re,V=x===re,W&&V)return A(B[re],F[re],P);if(W)return-1;if(V)return 1;const H=c(B[re],F[re],P);if(H!==0)return H}}e.comparePaths=t;function n(d,S,P){const B=d.toLowerCase(),F=S.toLowerCase(),v=m(d,S,P);if(v)return v;const x=B.endsWith(P),W=F.endsWith(P);if(x!==W)return x?-1:1;const V=A(B,F);return V!==0?V:B.localeCompare(F)}e.compareAnything=n;function m(d,S,P){const B=d.toLowerCase(),F=S.toLowerCase(),v=B.startsWith(P),x=F.startsWith(P);if(v!==x)return v?-1:1;if(v&&x){if(B.length<F.length)return-1;if(B.length>F.length)return 1}return 0}e.compareByPrefix=m}),define(be[29],Se([1,0,12,35,23,17,21,9]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",L="[^/\\\\]",C=/\//g;function u(H,R){switch(H){case 0:return"";case 1:return`${L}*?`;default:return`(?:${O}|${L}+${O}${R?`|${O}${L}+`:""})*?`}}function g(H,R){if(!H)return[];const se=[];let de=!1,X=!1,ie="";for(const he of H){switch(he){case R:if(!de&&!X){se.push(ie),ie="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":X=!0;break;case"]":X=!1;break}ie+=he}return ie&&se.push(ie),se}e.splitGlobAware=g;function o(H){if(!H)return"";let R="";const se=g(H,e.GLOB_SPLIT);if(se.every(de=>de===e.GLOBSTAR))R=".*";else{let de=!1;se.forEach((X,ie)=>{if(X===e.GLOBSTAR){if(de)return;R+=u(2,ie===se.length-1)}else{let he=!1,me="",fe=!1,ae="";for(const pe of X){if(pe!=="}"&&he){me+=pe;continue}if(fe&&(pe!=="]"||!ae)){let Ae;pe==="-"?Ae=pe:(pe==="^"||pe==="!")&&!ae?Ae="^":pe===e.GLOB_SPLIT?Ae="":Ae=(0,A.escapeRegExpCharacters)(pe),ae+=Ae;continue}switch(pe){case"{":he=!0;continue;case"[":fe=!0;continue;case"}":{R+=`(?:${g(me,",").map(He=>o(He)).join("|")})`,he=!1,me="";break}case"]":{R+="["+ae+"]",fe=!1,ae="";break}case"?":R+=L;continue;case"*":R+=u(1);continue;default:R+=(0,A.escapeRegExpCharacters)(pe)}}ie<se.length-1&&(se[ie+1]!==e.GLOBSTAR||ie+2<se.length)&&(R+=O)}de=X===e.GLOBSTAR})}return R}const r=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,D=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,E=new b.LRUCache(1e4),a=function(){return!1},k=function(){return null};function s(H,R){if(!H)return k;let se;typeof H!="string"?se=H.pattern:se=H,se=se.trim();const de=`${se}_${!!R.trimForExclusions}`;let X=E.get(de);if(X)return i(X,H);let ie;return r.test(se)?X=t(se.substr(4),se):(ie=f.exec(c(se,R)))?X=n(ie[1],se):(R.trimForExclusions?D:p).test(se)?X=m(se,R):(ie=h.exec(c(se,R)))?X=d(ie[1].substr(1),se,!0):(ie=_.exec(c(se,R)))?X=d(ie[1],se,!1):X=S(se),E.set(de,X),i(X,H)}function i(H,R){return typeof R=="string"?H:function(se,de){return(0,T.isEqualOrParent)(se,R.base,!I.isLinux)?H(se.substr(R.base.length+1),de):null}}function c(H,R){return R.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function t(H,R){return function(se,de){return typeof se=="string"&&se.endsWith(H)?R:null}}function n(H,R){const se=`/${H}`,de=`\\${H}`,X=function(he,me){return typeof he!="string"?null:me?me===H?R:null:he===H||he.endsWith(se)||he.endsWith(de)?R:null},ie=[H];return X.basenames=ie,X.patterns=[R],X.allBasenames=ie,X}function m(H,R){const se=re(H.slice(1,-1).split(",").map(me=>s(me,R)).filter(me=>me!==k),H),de=se.length;if(!de)return k;if(de===1)return se[0];const X=function(me,fe){for(let ae=0,pe=se.length;ae<pe;ae++)if(se[ae](me,fe))return H;return null},ie=se.find(me=>!!me.allBasenames);ie&&(X.allBasenames=ie.allBasenames);const he=se.reduce((me,fe)=>fe.allPaths?me.concat(fe.allPaths):me,[]);return he.length&&(X.allPaths=he),X}function d(H,R,se){const de=M.sep===M.posix.sep,X=de?H:H.replace(C,M.sep),ie=M.sep+X,he=M.posix.sep+H;let me;return se?me=function(fe,ae){return typeof fe=="string"&&(fe===X||fe.endsWith(ie)||!de&&(fe===H||fe.endsWith(he)))?R:null}:me=function(fe,ae){return typeof fe=="string"&&(fe===X||!de&&fe===H)?R:null},me.allPaths=[(se?"*/":"./")+H],me}function S(H){try{const R=new RegExp(`^${o(H)}$`);return function(se){return R.lastIndex=0,typeof se=="string"&&R.test(se)?H:null}}catch{return k}}function P(H,R,se){return!H||typeof R!="string"?!1:B(H)(R,void 0,se)}e.match=P;function B(H,R={}){if(!H)return a;if(typeof H=="string"||F(H)){const se=s(H,R);if(se===k)return a;const de=function(X,ie){return!!se(X,ie)};return se.allBasenames&&(de.allBasenames=se.allBasenames),se.allPaths&&(de.allPaths=se.allPaths),de}return W(H,R)}e.parse=B;function F(H){const R=H;return R?typeof R.base=="string"&&typeof R.pattern=="string":!1}e.isRelativePattern=F;function v(H){return H.allBasenames||[]}e.getBasenameTerms=v;function x(H){return H.allPaths||[]}e.getPathTerms=x;function W(H,R){const se=re(Object.getOwnPropertyNames(H).map(me=>V(me,H[me],R)).filter(me=>me!==k)),de=se.length;if(!de)return k;if(!se.some(me=>!!me.requiresSiblings)){if(de===1)return se[0];const me=function(pe,Ae){for(let Fe=0,He=se.length;Fe<He;Fe++){const Ye=se[Fe](pe,Ae);if(Ye)return Ye}return null},fe=se.find(pe=>!!pe.allBasenames);fe&&(me.allBasenames=fe.allBasenames);const ae=se.reduce((pe,Ae)=>Ae.allPaths?pe.concat(Ae.allPaths):pe,[]);return ae.length&&(me.allPaths=ae),me}const X=function(me,fe,ae){let pe;for(let Ae=0,Fe=se.length;Ae<Fe;Ae++){const He=se[Ae];He.requiresSiblings&&ae&&(fe||(fe=(0,M.basename)(me)),pe||(pe=fe.substr(0,fe.length-(0,M.extname)(me).length)));const Ye=He(me,fe,pe,ae);if(Ye)return Ye}return null},ie=se.find(me=>!!me.allBasenames);ie&&(X.allBasenames=ie.allBasenames);const he=se.reduce((me,fe)=>fe.allPaths?me.concat(fe.allPaths):me,[]);return he.length&&(X.allPaths=he),X}function V(H,R,se){if(R===!1)return k;const de=s(H,se);if(de===k)return k;if(typeof R=="boolean")return de;if(R){const X=R.when;if(typeof X=="string"){const ie=(he,me,fe,ae)=>{if(!ae||!de(he,me))return null;const pe=X.replace("$(basename)",fe),Ae=ae(pe);return(0,l.isThenable)(Ae)?Ae.then(Fe=>Fe?H:null):Ae?H:null};return ie.requiresSiblings=!0,ie}}return de}function re(H,R){const se=H.filter(me=>!!me.basenames);if(se.length<2)return H;const de=se.reduce((me,fe)=>{const ae=fe.basenames;return ae?me.concat(ae):me},[]);let X;if(R){X=[];for(let me=0,fe=de.length;me<fe;me++)X.push(R)}else X=se.reduce((me,fe)=>{const ae=fe.patterns;return ae?me.concat(ae):me},[]);const ie=function(me,fe){if(typeof me!="string")return null;if(!fe){let pe;for(pe=me.length;pe>0;pe--){const Ae=me.charCodeAt(pe-1);if(Ae===47||Ae===92)break}fe=me.substr(pe)}const ae=de.indexOf(fe);return ae!==-1?X[ae]:null};ie.basenames=de,ie.patterns=X,ie.allBasenames=de;const he=H.filter(me=>!me.basenames);return he.push(ie),he}}),define(be[75],Se([1,0,14,106,24,9,2]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=u(this.supportThemeIcons?(0,T.escapeIcons)(f):f).replace(/([ \t]+)/g,(D,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,D){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(f),")"),D&&(this.value+=` "${this._escape(this._escape(D,'"'),")")}"`),this.value+=")",this}_escape(f,p){const D=new RegExp((0,M.escapeRegExpCharacters)(p),"g");return f.replace(D,(h,_)=>f.charAt(_-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=y;function O(r){return L(r)?!r.value:Array.isArray(r)?r.every(O):!0}e.isEmptyMarkdownString=O;function L(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function C(r,f){return r===f?!0:!r||!f?!1:r.value===f.value&&r.isTrusted===f.isTrusted&&r.supportThemeIcons===f.supportThemeIcons&&r.supportHtml===f.supportHtml&&(r.baseUri===f.baseUri||!!r.baseUri&&!!f.baseUri&&(0,b.isEqual)(I.URI.from(r.baseUri),I.URI.from(f.baseUri)))}e.markdownStringEqual=C;function u(r){return r.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=u;function g(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function o(r){const f=[],p=r.split("|").map(h=>h.trim());r=p[0];const D=p[1];if(D){const h=/height=(\d+)/.exec(D),_=/width=(\d+)/.exec(D),E=h?h[1]:"",a=_?_[1]:"",k=isFinite(parseInt(a)),s=isFinite(parseInt(E));k&&f.push(`width="${a}"`),s&&f.push(`height="${E}"`)}return{href:r,dimensions:f}}e.parseHrefAndDimensions=o}),define(be[76],Se([1,0,35,11,17,21,24,9,2]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function O(i,c,t){if(typeof i=="string"&&(i=y.URI.file(i)),t){const m=t.getWorkspaceFolder(i);if(m){const d=t.getWorkspace().folders.length>1;let S;if((0,I.isEqual)(m.uri,i)?S="":S=(0,I.relativePath)(m.uri,i),d){const P=m.name?m.name:(0,I.basename)(m.uri);S=S?P+" \u2022 "+S:P}return S}}if(i.scheme!==T.Schemas.file&&i.scheme!==T.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,l.hasDriveLetter)(i.fsPath))return(0,b.normalize)(C(i.fsPath));let n=(0,b.normalize)(i.fsPath);return!M.isWindows&&c?.userHome&&(n=g(n,c.userHome.fsPath)),n}e.getPathLabel=O;function L(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const c=(0,I.basename)(i)||(i.scheme===T.Schemas.file?i.fsPath:i.path);return M.isWindows&&(0,l.isRootOrDriveLetter)(c)?C(c):c}e.getBaseLabel=L;function C(i,c){return(0,l.hasDriveLetter)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let u=Object.create(null);function g(i,c){if(M.isWindows||!i||!c)return i;let t=u.original===c?u.normalized:void 0;return t||(t=`${(0,A.rtrim)(c,b.posix.sep)}${b.posix.sep}`,u={original:c,normalized:t}),(M.isLinux?i.startsWith(t):(0,A.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=g;function o(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=o;const r="\u2026",f="\\\\",p="~";function D(i,c=b.sep){const t=new Array(i.length);let n=!1;for(let m=0;m<i.length;m++){let d=i[m];if(d===""){t[m]=`.${c}`;continue}if(!d){t[m]=d;continue}n=!0;let S="";d.indexOf(f)===0?(S=d.substr(0,d.indexOf(f)+f.length),d=d.substr(d.indexOf(f)+f.length)):d.indexOf(c)===0?(S=d.substr(0,d.indexOf(c)+c.length),d=d.substr(d.indexOf(c)+c.length)):d.indexOf(p)===0&&(S=d.substr(0,d.indexOf(p)+p.length),d=d.substr(d.indexOf(p)+p.length));const P=d.split(c);for(let B=1;n&&B<=P.length;B++)for(let F=P.length-B;n&&F>=0;F--){n=!1;let v=P.slice(F,F+B).join(c);for(let x=0;!n&&x<i.length;x++)if(x!==m&&i[x]&&i[x].indexOf(v)>-1){const W=F+B===P.length,V=F>0&&i[x].indexOf(c)>-1?c+v:v,re=i[x].endsWith(V);n=!W||re}if(!n){let x="";(P[0].endsWith(":")||S!=="")&&(F===1&&(F=0,B++,v=P[0]+c+v),F>0&&(x=P[0]+c),x=S+x),F>0&&(x=x+r+c),x=x+v,F+B<P.length&&(x=x+c+r),t[m]=x}}n&&(t[m]=d)}return t}e.shorten=D;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function _(i,c=Object.create(null)){const t=[];let n=!1,m="";for(const d of i)if(d==="$"||n&&d==="{")m&&t.push({value:m,type:h.TEXT}),m="",n=!0;else if(d==="}"&&n){const S=c[m];if(typeof S=="string")S.length&&t.push({value:S,type:h.VARIABLE});else if(S){const P=t[t.length-1];(!P||P.type!==h.SEPARATOR)&&t.push({value:S.label,type:h.SEPARATOR})}m="",n=!1}else m+=d;return m&&!n&&t.push({value:m,type:h.TEXT}),t.filter((d,S)=>{if(d.type===h.SEPARATOR){const P=t[S-1],B=t[S+1];return[P,B].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=_;function E(i,c){return M.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function a(i,c){return M.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function k(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=k;function s(i){const c=i.indexOf("/")!==-1?b.posix:b.win32,t=c.basename(i),n=c.dirname(i);return t.length?{name:t,parentPath:n}:{name:n,parentPath:""}}e.splitName=s}),define(be[109],Se([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(L){return L.toJSON()}class b{constructor(C){this._uriTransformer=C}transformIncoming(C){const u=this._uriTransformer.transformIncoming(C);return u===C?C:T(l.URI.from(u))}transformOutgoing(C){const u=this._uriTransformer.transformOutgoing(C);return u===C?C:T(l.URI.from(u))}transformOutgoingURI(C){const u=this._uriTransformer.transformOutgoing(C);return u===C?C:l.URI.from(u)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function M(L,C,u){if(!L||u>200)return null;if(typeof L=="object"){if(L instanceof l.URI)return C.transformOutgoing(L);for(let g in L)if(Object.hasOwnProperty.call(L,g)){const o=M(L[g],C,u+1);o!==null&&(L[g]=o)}}return null}function I(L,C){const u=M(L,C,0);return u===null?L:u}e.transformOutgoingURIs=I;function A(L,C,u,g){if(!L||g>200)return null;if(typeof L=="object"){if(L.$mid===1)return u?l.URI.revive(C.transformIncoming(L)):C.transformIncoming(L);for(let o in L)if(Object.hasOwnProperty.call(L,o)){const r=A(L[o],C,u,g+1);r!==null&&(L[o]=r)}}return null}function y(L,C){const u=A(L,C,!1,0);return u===null?L:u}e.transformIncomingURIs=y;function O(L,C){const u=A(L,C,!0,0);return u===null?L:u}e.transformAndReviveIncomingURIs=O}),define(be[36],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return l.test(y)}e.isUUID=T;const b=new Uint8Array(16),M=[];for(let y=0;y<256;y++)M.push(y.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(y){for(let O=0;O<y.length;O++)y[O]=Math.floor(Math.random()*256);return y};function A(){I(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let y=0,O="";return O+=M[b[y++]],O+=M[b[y++]],O+=M[b[y++]],O+=M[b[y++]],O+="-",O+=M[b[y++]],O+=M[b[y++]],O+="-",O+=M[b[y++]],O+=M[b[y++]],O+="-",O+=M[b[y++]],O+=M[b[y++]],O+="-",O+=M[b[y++]],O+=M[b[y++]],O+=M[b[y++]],O+=M[b[y++]],O+=M[b[y++]],O+=M[b[y++]],O}e.generateUuid=A}),define(be[110],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1,independentColorPoolPerBracketType:!1}}}),define(be[77],Se([1,0,29,17]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(M,I,A,y,O){if(Array.isArray(M)){let L=0;for(const C of M){const u=b(C,I,A,y,O);if(u===10)return u;u>L&&(L=u)}return L}else{if(typeof M=="string")return y?M==="*"?5:M===A?10:0:0;if(M){const{language:L,pattern:C,scheme:u,hasAccessToAllModels:g,notebookType:o}=M;if(!y&&!g)return 0;let r=0;if(u)if(u===I.scheme)r=10;else if(u==="*")r=5;else return 0;if(L)if(L===A)r=10;else if(L==="*")r=Math.max(r,5);else return 0;if(o)if(o===O)r=10;else if(o==="*")r=Math.max(r,5);else return 0;if(C){let f;if(typeof C=="string"?f=C:f={...C,base:(0,T.normalize)(C.base)},f===I.fsPath||(0,l.match)(f,I.fsPath))r=10;else return 0}return r}else return 0}}e.score=b}),define(be[111],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class T{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,O=A.notIn.length;y<O;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const O=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(O);return this.isOK(L)}_findNeutralCharacterInRange(A,y){for(let O=A;O<=y;O++){const L=String.fromCharCode(O);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=T;class b{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=b;function M(I,A,y){I.has(A)?I.get(A).push(y):I.set(A,[y])}}),define(be[78],Se([1,0,22,21]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(b||(b={}));function M(C){for(let u=0,g=C.length;u<g;u+=4){const o=C[u+0],r=C[u+1],f=C[u+2],p=C[u+3];C[u+0]=p,C[u+1]=f,C[u+2]=r,C[u+3]=o}}function I(C){const u=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return T.isLittleEndian()||M(u),l.VSBuffer.wrap(u)}function A(C){const u=C.buffer;if(T.isLittleEndian()||M(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const g=new Uint8Array(u.byteLength);return g.set(u),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function y(C){const u=new Uint32Array(O(C));let g=0;if(u[g++]=C.id,C.type==="full")u[g++]=1,u[g++]=C.data.length,u.set(C.data,g),g+=C.data.length;else{u[g++]=2,u[g++]=C.deltas.length;for(const o of C.deltas)u[g++]=o.start,u[g++]=o.deleteCount,o.data?(u[g++]=o.data.length,u.set(o.data,g),g+=o.data.length):u[g++]=0}return I(u)}e.encodeSemanticTokensDto=y;function O(C){let u=0;if(u+=1+1,C.type==="full")u+=1+C.data.length;else{u+=1,u+=(1+1+1)*C.deltas.length;for(const g of C.deltas)g.data&&(u+=g.data.length)}return u}function L(C){const u=A(C);let g=0;const o=u[g++];if(u[g++]===1){const D=u[g++],h=u.subarray(g,g+D);return g+=D,{id:o,type:"full",data:h}}const f=u[g++],p=[];for(let D=0;D<f;D++){const h=u[g++],_=u[g++],E=u[g++];let a;E>0&&(a=u.subarray(g,g+E),g+=E),p[D]={start:h,deleteCount:_,data:a}}return{id:o,type:"delta",deltas:p}}e.decodeSemanticTokensDto=L}),define(be[112],Se([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(be[113],Se([1,0,112]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,b=T*60,M=b*24,I=M*7,A=M*30,y=M*365;function O(C,u,g){typeof C!="number"&&(C=C.getTime());const o=Math.round((new Date().getTime()-C)/1e3);if(o<-30)return(0,l.localize)(0,null,O(new Date().getTime()+o*1e3,!1));if(o<30)return(0,l.localize)(1,null);let r;return o<T?(r=o,u?r===1?g?(0,l.localize)(2,null,r):(0,l.localize)(3,null,r):g?(0,l.localize)(4,null,r):(0,l.localize)(5,null,r):r===1?g?(0,l.localize)(6,null,r):(0,l.localize)(7,null,r):g?(0,l.localize)(8,null,r):(0,l.localize)(9,null,r)):o<b?(r=Math.floor(o/T),u?r===1?g?(0,l.localize)(10,null,r):(0,l.localize)(11,null,r):g?(0,l.localize)(12,null,r):(0,l.localize)(13,null,r):r===1?g?(0,l.localize)(14,null,r):(0,l.localize)(15,null,r):g?(0,l.localize)(16,null,r):(0,l.localize)(17,null,r)):o<M?(r=Math.floor(o/b),u?r===1?g?(0,l.localize)(18,null,r):(0,l.localize)(19,null,r):g?(0,l.localize)(20,null,r):(0,l.localize)(21,null,r):r===1?g?(0,l.localize)(22,null,r):(0,l.localize)(23,null,r):g?(0,l.localize)(24,null,r):(0,l.localize)(25,null,r)):o<I?(r=Math.floor(o/M),u?r===1?(0,l.localize)(26,null,r):(0,l.localize)(27,null,r):r===1?(0,l.localize)(28,null,r):(0,l.localize)(29,null,r)):o<A?(r=Math.floor(o/I),u?r===1?g?(0,l.localize)(30,null,r):(0,l.localize)(31,null,r):g?(0,l.localize)(32,null,r):(0,l.localize)(33,null,r):r===1?g?(0,l.localize)(34,null,r):(0,l.localize)(35,null,r):g?(0,l.localize)(36,null,r):(0,l.localize)(37,null,r)):o<y?(r=Math.floor(o/A),u?r===1?g?(0,l.localize)(38,null,r):(0,l.localize)(39,null,r):g?(0,l.localize)(40,null,r):(0,l.localize)(41,null,r):r===1?g?(0,l.localize)(42,null,r):(0,l.localize)(43,null,r):g?(0,l.localize)(44,null,r):(0,l.localize)(45,null,r)):(r=Math.floor(o/y),u?r===1?g?(0,l.localize)(46,null,r):(0,l.localize)(47,null,r):g?(0,l.localize)(48,null,r):(0,l.localize)(49,null,r):r===1?g?(0,l.localize)(50,null,r):(0,l.localize)(51,null,r):g?(0,l.localize)(52,null,r):(0,l.localize)(53,null,r))}e.fromNow=O;function L(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(be[114],Se([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(be[43],Se([1,0,16,10,114]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(C,u){return u&&(C.stack||C.stacktrace)?b.localize(0,null,A(C),I(C.stack)||I(C.stacktrace)):A(C)}function I(C){return Array.isArray(C)?C.join(`
`):C}function A(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?b.localize(1,null,C.message):C.message||b.localize(2,null)}function y(C=null,u=!1){if(!C)return b.localize(3,null);if(Array.isArray(C)){const g=l.coalesce(C),o=y(g[0],u);return g.length>1?b.localize(4,null,o,g.length):o}if(T.isString(C))return C;if(C.detail){const g=C.detail;if(g.error)return M(g.error,u);if(g.exception)return M(g.exception,u)}return C.stack?M(C,u):C.message?C.message:b.localize(5,null)}e.toErrorMessage=y;function O(C){const u=C;return u instanceof Error&&Array.isArray(u.actions)}e.isErrorWithActions=O;function L(C,u=Object.create(null)){const g=new Error(C);return u.actions&&(g.actions=u.actions),g}e.createErrorWithActions=L}),define(be[115],Se([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(be[116],Se([1,0,115,21,117,16,27,110]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class O{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=O;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(Y,ue,Me,We){this.id=Y,this.name=ue,this.defaultValue=Me,this.schema=We}applyUpdate(Y,ue){return g(Y,ue)}compute(Y,ue,Me){return Me}}class u{constructor(Y,ue){this.newValue=Y,this.didChange=ue}}e.ApplyUpdateResult=u;function g(G,Y){if(typeof G!="object"||typeof Y!="object"||!G||!Y)return new u(Y,G!==Y);if(Array.isArray(G)||Array.isArray(Y)){const Me=Array.isArray(G)&&Array.isArray(Y)&&M.equals(G,Y);return new u(Y,Me)}let ue=!1;for(const Me in Y)if(Y.hasOwnProperty(Me)){const We=g(G[Me],Y[Me]);We.didChange&&(G[Me]=We.newValue,ue=!0)}return new u(G,ue)}class o{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ue){return g(Y,ue)}validate(Y){return this.defaultValue}}class r{constructor(Y,ue,Me,We){this.id=Y,this.name=ue,this.defaultValue=Me,this.schema=We}applyUpdate(Y,ue){return g(Y,ue)}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,ue,Me){return Me}}function f(G,Y){return typeof G=="undefined"?Y:G==="false"?!1:Boolean(G)}e.boolean=f;class p extends r{constructor(Y,ue,Me,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Me);super(Y,ue,Me,We)}validate(Y){return f(Y,this.defaultValue)}}function D(G,Y,ue,Me){if(typeof G=="undefined")return Y;let We=parseInt(G,10);return isNaN(We)?Y:(We=Math.max(ue,We),We=Math.min(Me,We),We|0)}e.clampedInt=D;class h extends r{constructor(Y,ue,Me,We,Xe,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Me,Ze.minimum=We,Ze.maximum=Xe);super(Y,ue,Me,Ze);this.minimum=We,this.maximum=Xe}static clampedInt(Y,ue,Me,We){return D(Y,ue,Me,We)}validate(Y){return h.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class _ extends r{constructor(Y,ue,Me,We,Xe){typeof Xe!="undefined"&&(Xe.type="number",Xe.default=Me);super(Y,ue,Me,Xe);this.validationFn=We}static clamp(Y,ue,Me){return Y<ue?ue:Y>Me?Me:Y}static float(Y,ue){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return ue;const Me=parseFloat(Y);return isNaN(Me)?ue:Me}validate(Y){return this.validationFn(_.float(Y,this.defaultValue))}}class E extends r{static string(Y,ue){return typeof Y!="string"?ue:Y}constructor(Y,ue,Me,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Me);super(Y,ue,Me,We)}validate(Y){return E.string(Y,this.defaultValue)}}function a(G,Y,ue){return typeof G!="string"||ue.indexOf(G)===-1?Y:G}e.stringSet=a;class k extends r{constructor(Y,ue,Me,We,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=We,Xe.default=Me);super(Y,ue,Me,Xe);this._allowedValues=We}validate(Y){return a(Y,this.defaultValue,this._allowedValues)}}class s extends C{constructor(Y,ue,Me,We,Xe,Ze,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=Xe,ot.default=We);super(Y,ue,Me,ot);this._allowedValues=Xe,this._convert=Ze}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function i(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ue,Me){return Me===0?Y.accessibilitySupport:Me}}class t extends C{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{insertSpace:f(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(G){switch(G){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function P(G){switch(G){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class B extends o{constructor(){super(128)}compute(Y,ue,Me){const We=["monaco-editor"];return ue.get(33)&&We.push(ue.get(33)),Y.extraEditorClassName&&We.push(Y.extraEditorClassName),ue.get(66)==="default"?We.push("mouse-default"):ue.get(66)==="copy"&&We.push("mouse-copy"),ue.get(100)&&We.push("showUnused"),ue.get(126)&&We.push("showDeprecated"),We.join(" ")}}class F extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Y,ue,Me){return Me&&Y.emptySelectionClipboard}}class v extends C{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:l.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:l.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{cursorMoveOnType:f(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":a(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":a(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(ue.loop,this.defaultValue.loop)}}}class x extends C{constructor(){super(45,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?x.OFF:Y==="true"?x.ON:Y:Boolean(Y)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class W extends o{constructor(){super(44)}compute(Y,ue,Me){return Y.fontInfo}}class V extends r{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(Y){const ue=_.float(Y,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(ue,6,100)}compute(Y,ue,Me){return Y.fontInfo.fontSize}}class re extends C{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.MINIMUM_VALUE,maximum:re.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(h.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,re.MINIMUM_VALUE,re.MAXIMUM_VALUE))}}re.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],re.MINIMUM_VALUE=1,re.MAXIMUM_VALUE=1e3;class H extends C{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...ue},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...ue},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Me,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Me,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Me,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Me,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Me,description:l.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{multiple:a(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??a(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??a(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??a(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??a(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??a(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class R extends C{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:l.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{enabled:f(ue.enabled,this.defaultValue.enabled),delay:h.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:f(ue.sticky,this.defaultValue.sticky),above:f(ue.above,this.defaultValue.above)}}}var se;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(se=e.RenderMinimap||(e.RenderMinimap={}));class de extends o{constructor(){super(131)}compute(Y,ue,Me){return de.computeLayout(ue,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const ue=Y.height/Y.lineHeight,Me=Y.scrollBeyondLastLine?ue-1:0,We=(Y.viewLineCount+Me)/(Y.pixelRatio*Y.height),Xe=Math.floor(Y.viewLineCount/We);return{typicalViewportLineCount:ue,extraLinesBeyondLastLine:Me,desiredRatio:We,minimapLineCount:Xe}}static _computeMinimapLayout(Y,ue){const Me=Y.outerWidth,We=Y.outerHeight,Xe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ze=ue.stableMinimapLayoutInput,ot=Ze&&Y.outerHeight===Ze.outerHeight&&Y.lineHeight===Ze.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ze.pixelRatio&&Y.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Y.minimap.enabled===Ze.minimap.enabled&&Y.minimap.side===Ze.minimap.side&&Y.minimap.size===Ze.minimap.size&&Y.minimap.showSlider===Ze.minimap.showSlider&&Y.minimap.renderCharacters===Ze.minimap.renderCharacters&&Y.minimap.maxColumn===Ze.minimap.maxColumn&&Y.minimap.scale===Ze.minimap.scale&&Y.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Y.isViewportWrapping===Ze.isViewportWrapping,wt=Y.lineHeight,mt=Y.typicalHalfwidthCharacterWidth,kt=Y.scrollBeyondLastLine,qe=Y.minimap.renderCharacters;let gt=Xe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Nt=Y.minimap.maxColumn,rt=Y.minimap.size,ft=Y.minimap.side,Ut=Y.verticalScrollbarWidth,Pt=Y.viewLineCount,_t=Y.remainingWidth,ct=Y.isViewportWrapping,At=qe?2:3;let Mt=Math.floor(Xe*We);const Ft=Mt/Xe;let xe=!1,ge=!1,we=At*gt,le=gt/Xe,K=1;if(rt==="fill"||rt==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:nt,desiredRatio:ut,minimapLineCount:at}=de.computeContainedMinimapLineCount({viewLineCount:Pt,scrollBeyondLastLine:kt,height:We,lineHeight:wt,pixelRatio:Xe});if(Pt/at>1)xe=!0,ge=!0,gt=1,we=1,le=gt/Xe;else{let Et=!1,It=gt+1;if(rt==="fit"){const yt=Math.ceil((Pt+nt)*we);ct&&ot&&_t<=ue.stableFitRemainingWidth?(Et=!0,It=ue.stableFitMaxMinimapScale):Et=yt>Mt}if(rt==="fill"||Et){xe=!0;const yt=gt;we=Math.min(wt*Xe,Math.max(1,Math.floor(1/ut))),ct&&ot&&_t<=ue.stableFitRemainingWidth&&(It=ue.stableFitMaxMinimapScale),gt=Math.min(It,Math.max(1,Math.floor(we/At))),gt>yt&&(K=Math.min(2,gt/yt)),le=gt/Xe/K,Mt=Math.ceil(Math.max(vt,Pt+nt)*we),ct?(ue.stableMinimapLayoutInput=Y,ue.stableFitRemainingWidth=_t,ue.stableFitMaxMinimapScale=gt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const ye=Math.floor(Nt*le),Pe=Math.min(ye,Math.max(0,Math.floor((_t-Ut-2)*le/(mt+le)))+e.MINIMAP_GUTTER_WIDTH);let $e=Math.floor(Xe*Pe);const Ke=$e/Xe;$e=Math.floor($e*K);const dt=qe?1:2,pt=ft==="left"?0:Me-Pe-Ut;return{renderMinimap:dt,minimapLeft:pt,minimapWidth:Pe,minimapHeightIsEditorHeight:xe,minimapIsSampling:ge,minimapScale:gt,minimapLineHeight:we,minimapCanvasInnerWidth:$e,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:Ft}}static computeLayout(Y,ue){const Me=ue.outerWidth|0,We=ue.outerHeight|0,Xe=ue.lineHeight|0,Ze=ue.lineNumbersDigitCount|0,ot=ue.typicalHalfwidthCharacterWidth,wt=ue.maxDigitWidth,mt=ue.pixelRatio,kt=ue.viewLineCount,qe=Y.get(123),gt=qe==="inherit"?Y.get(122):qe,Nt=gt==="inherit"?Y.get(118):gt,rt=Y.get(121),ft=Y.get(2),Ut=ue.isDominatedByLongLines,Pt=Y.get(50),_t=Y.get(60).renderType!==0,ct=Y.get(61),At=Y.get(94),Mt=Y.get(65),Ft=Y.get(92),xe=Ft.verticalScrollbarSize,ge=Ft.verticalHasArrows,we=Ft.arrowSize,le=Ft.horizontalScrollbarSize,K=Y.get(58),ye=Y.get(37);let Pe;if(typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)){const Wt=parseFloat(K.substr(0,K.length-2));Pe=h.clampedInt(Wt*ot,0,0,1e3)}else Pe=h.clampedInt(K,0,0,1e3);ye&&(Pe+=16);let $e=0;if(_t){const Wt=Math.max(Ze,ct);$e=Math.round(Wt*wt)}let Ke=0;Pt&&(Ke=Xe);let dt=0,pt=dt+Ke,vt=pt+$e,nt=vt+Pe;const ut=Me-Ke-$e-Pe;let at=!1,Lt=!1,Et=-1;ft!==2&&(gt==="inherit"&&Ut?(at=!0,Lt=!0):Nt==="on"||Nt==="bounded"?Lt=!0:Nt==="wordWrapColumn"&&(Et=rt));const It=de._computeMinimapLayout({outerWidth:Me,outerHeight:We,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:mt,scrollBeyondLastLine:At,minimap:Mt,verticalScrollbarWidth:xe,viewLineCount:kt,remainingWidth:ut,isViewportWrapping:Lt},ue.memory||new L);It.renderMinimap!==0&&It.minimapLeft===0&&(dt+=It.minimapWidth,pt+=It.minimapWidth,vt+=It.minimapWidth,nt+=It.minimapWidth);const yt=ut-It.minimapWidth,St=Math.max(1,Math.floor((yt-xe-2)/ot)),Jt=ge?we:0;return Lt&&(Et=Math.max(1,St),Nt==="bounded"&&(Et=Math.min(Et,rt))),{width:Me,height:We,glyphMarginLeft:dt,glyphMarginWidth:Ke,lineNumbersLeft:pt,lineNumbersWidth:$e,decorationsLeft:vt,decorationsWidth:Pe,contentLeft:nt,contentWidth:yt,minimap:It,viewportColumn:St,isWordWrapMinified:at,isViewportWrapping:Lt,wrappingColumn:Et,verticalScrollbarWidth:xe,horizontalScrollbarHeight:le,overviewRuler:{top:Jt,width:xe,height:We-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=de;class X extends C{constructor(){const Y={enabled:!0};super(57,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:l.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:f(Y.enabled,this.defaultValue.enabled)}}}class ie extends C{constructor(){const Y={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"boolean",default:Y.enabled,description:l.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:l.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:l.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{enabled:f(ue.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(ue.fontFamily,this.defaultValue.fontFamily)}}}class he extends _{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>_.clamp(Y,0,150),{markdownDescription:l.localize(47,null)})}compute(Y,ue,Me){return Y.fontInfo.lineHeight}}class me extends C{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:l.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(49,null),l.localize(50,null),l.localize(51,null)],default:Y.size,description:l.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:l.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:l.localize(54,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:l.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:l.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{enabled:f(ue.enabled,this.defaultValue.enabled),size:a(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ue.side,this.defaultValue.side,["right","left"]),showSlider:a(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(ue.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(ue.scale,1,1,3),maxColumn:h.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(G){return G==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ae extends C{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{top:h.clampedInt(ue.top,0,0,1e3),bottom:h.clampedInt(ue.bottom,0,0,1e3)}}}class pe extends C{constructor(){const Y={enabled:!0,cycle:!1};super(76,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:l.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:l.localize(61,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{enabled:f(ue.enabled,this.defaultValue.enabled),cycle:f(ue.cycle,this.defaultValue.cycle)}}}class Ae extends o{constructor(){super(129)}compute(Y,ue,Me){return Y.pixelRatio}}class Fe extends C{constructor(){const Y={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(62,null),l.localize(63,null),l.localize(64,null)]}];super(79,"quickSuggestions",Y,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{anyOf:ue,default:Y.strings,description:l.localize(65,null)},comments:{anyOf:ue,default:Y.comments,description:l.localize(66,null)},other:{anyOf:ue,default:Y.other,description:l.localize(67,null)}}}],default:Y,markdownDescription:l.localize(68,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const mt=Y?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ue,comments:Me,strings:We}=Y,Xe=["on","inline","off"];let Ze,ot,wt;return typeof ue=="boolean"?Ze=ue?"on":"off":Ze=a(ue,this.defaultValue.other,Xe),typeof Me=="boolean"?ot=Me?"on":"off":ot=a(Me,this.defaultValue.comments,Xe),typeof We=="boolean"?wt=We?"on":"off":wt=a(We,this.defaultValue.strings,Xe),{other:Ze,comments:ot,strings:wt}}}var He;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(He=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ye extends C{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null),l.localize(72,null)],default:"on",description:l.localize(73,null)})}validate(Y){let ue=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(ue=4,Me=Y):Y==="interval"?ue=3:Y==="relative"?ue=2:Y==="on"?ue=1:ue=0),{renderType:ue,renderFn:Me}}}function Ce(G){const Y=G.get(87);return Y==="editable"?G.get(81):Y!=="on"}e.filterValidationDecorations=Ce;class Ee extends C{constructor(){const Y=[],ue={type:"number",description:l.localize(74,null)};super(91,"rulers",Y,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:l.localize(75,null),format:"color-hex"}}}]},default:Y,description:l.localize(76,null)})}validate(Y){if(Array.isArray(Y)){const ue=[];for(let Me of Y)if(typeof Me=="number")ue.push({column:h.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const We=Me;ue.push({column:h.clampedInt(We.column,0,0,1e4),color:We.color})}return ue.sort((Me,We)=>Me.column-We.column),ue}return this.defaultValue}}function De(G,Y){if(typeof G!="string")return Y;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ne extends C{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null)],default:"auto",description:l.localize(80,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(81,null),l.localize(82,null),l.localize(83,null)],default:"auto",description:l.localize(84,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:l.localize(85,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:l.localize(86,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:l.localize(87,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y,Me=h.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=h.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(ue.vertical,this.defaultValue.vertical),horizontal:De(ue.horizontal,this.defaultValue.horizontal),useShadows:f(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:h.clampedInt(ue.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:We,verticalSliderSize:h.clampedInt(ue.verticalSliderSize,We,0,1e3),scrollByPage:f(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends C{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:l.localize(88,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:l.localize(89,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:l.localize(90,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:l.localize(91,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:l.localize(92,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:l.localize(93,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:l.localize(94,null)}})}applyUpdate(Y,ue){let Me=!1;ue.allowedCharacters&&(I.equals(Y.allowedCharacters,ue.allowedCharacters)||(Y={...Y,allowedCharacters:ue.allowedCharacters},Me=!0)),ue.allowedLocales&&(I.equals(Y.allowedLocales,ue.allowedLocales)||(Y={...Y,allowedLocales:ue.allowedLocales},Me=!0));const We=super.applyUpdate(Y,ue);return Me?new u(We.newValue,!0):We}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{nonBasicASCII:z(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:z(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:z(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,ue){if(typeof Y!="object"||!Y)return ue;const Me={};for(const[We,Xe]of Object.entries(Y))Xe===!0&&(Me[We]=!0);return Me}}class Q extends C{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:l.localize(95,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{enabled:f(ue.enabled,this.defaultValue.enabled),mode:a(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class w extends C{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:l.localize(96,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:l.localize(97,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{enabled:f(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class U extends C{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:Y.bracketPairs,description:l.localize(101,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(102,null),l.localize(103,null),l.localize(104,null)],default:Y.bracketPairsHorizontal,description:l.localize(105,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:l.localize(106,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:l.localize(107,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Y.highlightActiveIndentation,description:l.localize(108,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{bracketPairs:z(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:z(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:f(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function z(G,Y,ue){const Me=ue.indexOf(G);return Me===-1?Y:ue[Me]}class j extends C{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(109,null),l.localize(110,null)],default:Y.insertMode,description:l.localize(111,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:l.localize(112,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:l.localize(113,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:l.localize(114,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:l.localize(115,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:l.localize(116,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:l.localize(117,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:l.localize(118,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:l.localize(119,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(120,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(121,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(122,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(123,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(124,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(125,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(126,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(127,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(128,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(129,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(130,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(131,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(132,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ue=Y;return{insertMode:a(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(ue.showIcons,this.defaultValue.showIcons),showStatusBar:f(ue.showStatusBar,this.defaultValue.showStatusBar),preview:f(ue.preview,this.defaultValue.preview),previewMode:a(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(ue.showMethods,this.defaultValue.showMethods),showFunctions:f(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:f(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(ue.showDeprecated,this.defaultValue.showDeprecated),showFields:f(ue.showFields,this.defaultValue.showFields),showVariables:f(ue.showVariables,this.defaultValue.showVariables),showClasses:f(ue.showClasses,this.defaultValue.showClasses),showStructs:f(ue.showStructs,this.defaultValue.showStructs),showInterfaces:f(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:f(ue.showModules,this.defaultValue.showModules),showProperties:f(ue.showProperties,this.defaultValue.showProperties),showEvents:f(ue.showEvents,this.defaultValue.showEvents),showOperators:f(ue.showOperators,this.defaultValue.showOperators),showUnits:f(ue.showUnits,this.defaultValue.showUnits),showValues:f(ue.showValues,this.defaultValue.showValues),showConstants:f(ue.showConstants,this.defaultValue.showConstants),showEnums:f(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:f(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(ue.showKeywords,this.defaultValue.showKeywords),showWords:f(ue.showWords,this.defaultValue.showWords),showColors:f(ue.showColors,this.defaultValue.showColors),showFiles:f(ue.showFiles,this.defaultValue.showFiles),showReferences:f(ue.showReferences,this.defaultValue.showReferences),showFolders:f(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:f(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(ue.showSnippets,this.defaultValue.showSnippets),showUsers:f(ue.showUsers,this.defaultValue.showUsers),showIssues:f(ue.showIssues,this.defaultValue.showIssues)}}}class ee extends C{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(151,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends o{constructor(){super(130)}compute(Y,ue,Me){return ue.get(81)?!0:Y.tabFocusMode}}var ve;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(ve=e.WrappingIndent||(e.WrappingIndent={}));function Oe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Le extends o{constructor(){super(132)}compute(Y,ue,Me){const We=ue.get(131);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const Ne="Consolas, 'Courier New', monospace",Ve="Menlo, Monaco, 'Courier New', monospace",Je="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Ve:T.isLinux?Je:Ne,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var je;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(152,null)})),acceptSuggestionOnEnter:ke(new k(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(153,null),""],markdownDescription:l.localize(154,null)})),accessibilitySupport:ke(new c),accessibilityPageSize:ke(new h(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(155,null)})),ariaLabel:ke(new E(4,"ariaLabel",l.localize(156,null))),autoClosingBrackets:ke(new k(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(157,null),l.localize(158,null),""],description:l.localize(159,null)})),autoClosingDelete:ke(new k(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(160,null),""],description:l.localize(161,null)})),autoClosingOvertype:ke(new k(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(162,null),""],description:l.localize(163,null)})),autoClosingQuotes:ke(new k(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(164,null),l.localize(165,null),""],description:l.localize(166,null)})),autoIndent:ke(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[l.localize(167,null),l.localize(168,null),l.localize(169,null),l.localize(170,null),l.localize(171,null)],description:l.localize(172,null)})),automaticLayout:ke(new p(10,"automaticLayout",!1)),autoSurround:ke(new k(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(173,null),l.localize(174,null),l.localize(175,null),""],description:l.localize(176,null)})),bracketPairColorization:ke(new w),bracketPairGuides:ke(new U),stickyTabStops:ke(new p(104,"stickyTabStops",!1,{description:l.localize(177,null)})),codeLens:ke(new p(14,"codeLens",!0,{description:l.localize(178,null)})),codeLensFontFamily:ke(new E(15,"codeLensFontFamily","",{description:l.localize(179,null)})),codeLensFontSize:ke(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(180,null)})),colorDecorators:ke(new p(17,"colorDecorators",!0,{description:l.localize(181,null)})),columnSelection:ke(new p(18,"columnSelection",!1,{description:l.localize(182,null)})),comments:ke(new t),contextmenu:ke(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new p(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(183,null)})),cursorBlinking:ke(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:l.localize(184,null)})),cursorSmoothCaretAnimation:ke(new p(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(185,null)})),cursorStyle:ke(new s(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(186,null)})),cursorSurroundingLines:ke(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(187,null)})),cursorSurroundingLinesStyle:ke(new k(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(188,null),l.localize(189,null)],description:l.localize(190,null)})),cursorWidth:ke(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(191,null)})),disableLayerHinting:ke(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new p(30,"domReadOnly",!1)),dragAndDrop:ke(new p(31,"dragAndDrop",!0,{description:l.localize(192,null)})),emptySelectionClipboard:ke(new F),extraEditorClassName:ke(new E(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new _(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:l.localize(193,null)})),find:ke(new v),fixedOverflowWidgets:ke(new p(36,"fixedOverflowWidgets",!1)),folding:ke(new p(37,"folding",!0,{description:l.localize(194,null)})),foldingStrategy:ke(new k(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(195,null),l.localize(196,null)],description:l.localize(197,null)})),foldingHighlight:ke(new p(39,"foldingHighlight",!0,{description:l.localize(198,null)})),foldingImportsByDefault:ke(new p(40,"foldingImportsByDefault",!1,{description:l.localize(199,null)})),foldingMaximumRegions:ke(new h(41,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(200,null)})),unfoldOnClickAfterEndOfLine:ke(new p(42,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(201,null)})),fontFamily:ke(new E(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(202,null)})),fontInfo:ke(new W),fontLigatures2:ke(new x),fontSize:ke(new V),fontWeight:ke(new re),formatOnPaste:ke(new p(48,"formatOnPaste",!1,{description:l.localize(203,null)})),formatOnType:ke(new p(49,"formatOnType",!1,{description:l.localize(204,null)})),glyphMargin:ke(new p(50,"glyphMargin",!0,{description:l.localize(205,null)})),gotoLocation:ke(new H),hideCursorInOverviewRuler:ke(new p(52,"hideCursorInOverviewRuler",!1,{description:l.localize(206,null)})),hover:ke(new R),inDiffEditor:ke(new p(54,"inDiffEditor",!1)),letterSpacing:ke(new _(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>_.clamp(G,-5,20),{description:l.localize(207,null)})),lightbulb:ke(new X),lineDecorationsWidth:ke(new r(58,"lineDecorationsWidth",10)),lineHeight:ke(new he),lineNumbers:ke(new Ye),lineNumbersMinChars:ke(new h(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new p(62,"linkedEditing",!1,{description:l.localize(208,null)})),links:ke(new p(63,"links",!0,{description:l.localize(209,null)})),matchBrackets:ke(new k(64,"matchBrackets","always",["always","near","never"],{description:l.localize(210,null)})),minimap:ke(new me),mouseStyle:ke(new k(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new _(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:l.localize(211,null)})),mouseWheelZoom:ke(new p(68,"mouseWheelZoom",!1,{markdownDescription:l.localize(212,null)})),multiCursorMergeOverlapping:ke(new p(69,"multiCursorMergeOverlapping",!0,{description:l.localize(213,null)})),multiCursorModifier:ke(new s(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[l.localize(214,null),l.localize(215,null)],markdownDescription:l.localize(216,null)})),multiCursorPaste:ke(new k(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(217,null),l.localize(218,null)],markdownDescription:l.localize(219,null)})),occurrencesHighlight:ke(new p(72,"occurrencesHighlight",!0,{description:l.localize(220,null)})),overviewRulerBorder:ke(new p(73,"overviewRulerBorder",!0,{description:l.localize(221,null)})),overviewRulerLanes:ke(new h(74,"overviewRulerLanes",3,0,3)),padding:ke(new ae),parameterHints:ke(new pe),peekWidgetDefaultFocus:ke(new k(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(222,null),l.localize(223,null)],description:l.localize(224,null)})),definitionLinkOpensInPeek:ke(new p(78,"definitionLinkOpensInPeek",!1,{description:l.localize(225,null)})),quickSuggestions:ke(new Fe),quickSuggestionsDelay:ke(new h(80,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(226,null)})),readOnly:ke(new p(81,"readOnly",!1)),renameOnType:ke(new p(82,"renameOnType",!1,{description:l.localize(227,null),markdownDeprecationMessage:l.localize(228,null)})),renderControlCharacters:ke(new p(83,"renderControlCharacters",!0,{description:l.localize(229,null),restricted:!0})),renderFinalNewline:ke(new p(84,"renderFinalNewline",!0,{description:l.localize(230,null)})),renderLineHighlight:ke(new k(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(231,null)],description:l.localize(232,null)})),renderLineHighlightOnlyWhenFocus:ke(new p(86,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(233,null)})),renderValidationDecorations:ke(new k(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new k(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(234,null),l.localize(235,null),l.localize(236,null),""],description:l.localize(237,null)})),revealHorizontalRightPadding:ke(new h(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new p(90,"roundedSelection",!0,{description:l.localize(238,null)})),rulers:ke(new Ee),scrollbar:ke(new ne),scrollBeyondLastColumn:ke(new h(93,"scrollBeyondLastColumn",5,0,1073741824,{description:l.localize(239,null)})),scrollBeyondLastLine:ke(new p(94,"scrollBeyondLastLine",!0,{description:l.localize(240,null)})),scrollPredominantAxis:ke(new p(95,"scrollPredominantAxis",!0,{description:l.localize(241,null)})),selectionClipboard:ke(new p(96,"selectionClipboard",!0,{description:l.localize(242,null),included:T.isLinux})),selectionHighlight:ke(new p(97,"selectionHighlight",!0,{description:l.localize(243,null)})),selectOnLineNumbers:ke(new p(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new k(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],description:l.localize(246,null)})),showUnused:ke(new p(100,"showUnused",!0,{description:l.localize(247,null)})),showDeprecated:ke(new p(126,"showDeprecated",!0,{description:l.localize(248,null)})),inlayHints:ke(new ie),snippetSuggestions:ke(new k(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null),l.localize(252,null)],description:l.localize(253,null)})),smartSelect:ke(new ee),smoothScrolling:ke(new p(103,"smoothScrolling",!1,{description:l.localize(254,null)})),stopRenderingLineAfter:ke(new h(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new j),inlineSuggest:ke(new Q),suggestFontSize:ke(new h(107,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(255,null)})),suggestLineHeight:ke(new h(108,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(256,null)})),suggestOnTriggerCharacters:ke(new p(109,"suggestOnTriggerCharacters",!0,{description:l.localize(257,null)})),suggestSelection:ke(new k(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(258,null),l.localize(259,null),l.localize(260,null)],description:l.localize(261,null)})),tabCompletion:ke(new k(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(262,null),l.localize(263,null),l.localize(264,null)],description:l.localize(265,null)})),tabIndex:ke(new h(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new q),unusualLineTerminators:ke(new k(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(266,null),l.localize(267,null),l.localize(268,null)],description:l.localize(269,null)})),useShadowDOM:ke(new p(115,"useShadowDOM",!0)),useTabStops:ke(new p(116,"useTabStops",!0,{description:l.localize(270,null)})),wordSeparators:ke(new E(117,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:l.localize(271,null)})),wordWrap:ke(new k(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),wordWrapBreakAfterCharacters:ke(new E(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new E(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new h(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(277,null)})),wordWrapOverride1:ke(new k(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new k(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new s(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[l.localize(278,null),l.localize(279,null),l.localize(280,null),l.localize(281,null)],description:l.localize(282,null)})),wrappingStrategy:ke(new k(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),editorClassName:ke(new B),pixelRatio:ke(new Ae),tabFocusMode:ke(new ce),layoutInfo:ke(new de),wrappingInfo:ke(new Le)}}),define(be[118],Se([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[119],Se([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[120],Se([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Se([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(be[122],Se([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(be[123],Se([18,19]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(be[124],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Se([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Se([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(be[132],Se([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[133],Se([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(be[134],Se([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[135],Se([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[136],Se([18,19]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(be[137],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var l;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(l=e.EditorActivation||(e.EditorActivation={}));var T;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(T=e.EditorResolution||(e.EditorResolution={}));var b;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var M;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(M=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var I;(function(A){A.PROGRAMMATIC="api",A.NAVIGATION="code.navigation",A.JUMP="code.jump"})(I=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(be[138],Se([1,0,120]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function M(u){return u=u.trim(),u==="*"||T.test(u)}e.isValidVersionStr=M;function I(u){if(!M(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=u.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function A(u){if(!u)return null;let g=u.majorBase,o=u.majorMustEqual,r=u.minorBase,f=u.minorMustEqual,p=u.patchBase,D=u.patchMustEqual;u.hasCaret&&(g===0||(f=!1),D=!1);let h=0;if(u.preRelease){const _=b.exec(u.preRelease);if(_){const[,E,a,k]=_;h=Date.UTC(Number(E),Number(a)-1,Number(k))}}return{majorBase:g,majorMustEqual:o,minorBase:r,minorMustEqual:f,patchBase:p,patchMustEqual:D,isMinimum:u.hasGreaterEquals,notBefore:h}}e.normalizeVersion=A;function y(u,g,o){let r;typeof u=="string"?r=A(I(u)):r=u;let f;g instanceof Date?f=g.getTime():typeof g=="string"&&(f=new Date(g).getTime());let p;if(typeof o=="string"?p=A(I(o)):p=o,!r||!p)return!1;let D=r.majorBase,h=r.minorBase,_=r.patchBase,E=p.majorBase,a=p.minorBase,k=p.patchBase,s=p.notBefore,i=p.majorMustEqual,c=p.minorMustEqual,t=p.patchMustEqual;return p.isMinimum?D>E?!0:D<E?!1:h>a?!0:h<a||f&&f<s?!1:_>=k:(D===1&&E===0&&(!i||!c||!t)&&(E=1,a=0,k=0,i=!0,c=!1,t=!1),D<E?!1:D>E?!i:h<a?!1:h>a?!c:_<k?!1:_>k?!t:!(f&&f<s))}e.isValidVersion=y;function O(u,g,o,r,f){return r||typeof o.main=="undefined"&&typeof o.browser=="undefined"?!0:C(u,g,o.engines.vscode,f)}e.isValidExtensionVersion=O;function L(u,g,o){return u==="*"||C(g,o,u)}e.isEngineValid=L;function C(u,g,o,r=[]){let f=A(I(o));if(!f)return r.push(l.localize(0,null,o)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return r.push(l.localize(1,null,o)),!1}else if(!f.majorMustEqual)return r.push(l.localize(2,null,o)),!1;return y(u,g,f)?!0:(r.push(l.localize(3,null,u,o)),!1)}}),define(be[79],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(b,M=[],I=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=l}),define(be[55],Se([1,0,79]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function b(I,A,y){A instanceof l.SyncDescriptor||(A=new l.SyncDescriptor(A,[],y)),T.push([I,A])}e.registerSingleton=b;function M(){return T}e.getSingletonServiceDescriptors=M}),define(be[139],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=l;class T{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let I of this._nodes.values())I.outgoing.size===0&&M.push(I);return M}insertEdge(M,I){const A=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(I);A.outgoing.set(this._hashFn(I),y),y.incoming.set(this._hashFn(M),A)}removeNode(M){const I=this._hashFn(M);this._nodes.delete(I);for(let A of this._nodes.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(M){const I=this._hashFn(M);let A=this._nodes.get(I);return A||(A=new l(M),this._nodes.set(I,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[I,A]of this._nodes)M.push(`${I}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,I]of this._nodes){const A=new Set([M]),y=this._findCycle(I,A);if(y)return y}}_findCycle(M,I){for(let[A,y]of M.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const O=this._findCycle(y,I);if(O)return O;I.delete(A)}}}e.Graph=T}),define(be[3],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(l=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function T(I,A,y){A[l.DI_TARGET]===A?A[l.DI_DEPENDENCIES].push({id:I,index:y}):(A[l.DI_DEPENDENCIES]=[{id:I,index:y}],A[l.DI_TARGET]=A)}function b(I){if(l.serviceIds.has(I))return l.serviceIds.get(I);const A=function(y,O,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,y,L)};return A.toString=()=>I,l.serviceIds.set(I,A),A}e.createDecorator=b;function M(I){return I}e.refineServiceDecorator=M}),define(be[56],Se([1,0,10,2,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function M(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof T.URI)}e.isConfigurationOverrides=M;function I(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||l.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function O(p,D){const h=Object.create(null);for(let _ in p)L(h,_,p[_],D);return h}e.toValuesTree=O;function L(p,D,h,_){const E=D.split("."),a=E.pop();let k=p;for(let s=0;s<E.length;s++){let i=E[s],c=k[i];switch(typeof c){case"undefined":c=k[i]=Object.create(null);break;case"object":break;default:_(`Ignoring ${D} as ${E.slice(0,s+1).join(".")} is ${JSON.stringify(c)}`);return}k=c}if(typeof k=="object"&&k!==null)try{k[a]=h}catch{_(`Ignoring ${D} as ${E.join(".")} is ${JSON.stringify(k)}`)}else _(`Ignoring ${D} as ${E.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=L;function C(p,D){const h=D.split(".");u(p,h)}e.removeFromValueTree=C;function u(p,D){const h=D.shift();if(D.length===0){delete p[h];return}if(Object.keys(p).indexOf(h)!==-1){const _=p[h];typeof _=="object"&&!Array.isArray(_)&&(u(_,D),Object.keys(_).length===0&&delete p[h])}}function g(p,D,h){function _(k,s){let i=k;for(const c of s){if(typeof i!="object"||i===null)return;i=i[c]}return i}const E=D.split("."),a=_(p,E);return typeof a=="undefined"?h:a}e.getConfigurationValue=g;function o(p,D,h){Object.keys(D).forEach(_=>{_!=="__proto__"&&(_ in p?l.isObject(p[_])&&l.isObject(D[_])?o(p[_],D[_],h):h&&(p[_]=D[_]):p[_]=D[_])})}e.merge=o;function r(p,D,h){const _=p.inspect(D),E=p.inspect(h);return typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:_.defaultValue}e.getMigratedSettingValue=r;function f(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(be[44],Se([1,0,21,9,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",l.isMacintosh),M.set("isLinux",l.isLinux),M.set("isWindows",l.isWindows),M.set("isWeb",l.isWeb),M.set("isMacNative",l.isMacintosh&&!l.isWeb),M.set("isEdge",l.isEdge),M.set("isFirefox",l.isFirefox),M.set("isChrome",l.isChrome),M.set("isSafari",l.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return C.INSTANCE}static true(){return u.INSTANCE}static has(v){return g.create(v)}static equals(v,x){return o.create(v,x)}static notEquals(v,x){return p.create(v,x)}static regex(v,x){return s.create(v,x)}static in(v,x){return r.create(v,x)}static not(v){return D.create(v)}static and(...v){return t.create(v,null)}static or(...v){return n.create(v,null,!0)}static greater(v,x){return _.create(v,x)}static greaterEquals(v,x){return E.create(v,x)}static smaller(v,x){return a.create(v,x)}static smallerEquals(v,x){return k.create(v,x)}static deserialize(v,x=!1){if(!!v)return this._deserializeOrExpression(v,x)}static _deserializeOrExpression(v,x){let W=v.split("||");return n.create(W.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(v,x){let W=v.split("&&");return t.create(W.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(v,x){if(v=v.trim(),v.indexOf("!=")>=0){let W=v.split("!=");return p.create(W[0].trim(),this._deserializeValue(W[1],x))}if(v.indexOf("==")>=0){let W=v.split("==");return o.create(W[0].trim(),this._deserializeValue(W[1],x))}if(v.indexOf("=~")>=0){let W=v.split("=~");return s.create(W[0].trim(),this._deserializeRegexValue(W[1],x))}if(v.indexOf(" in ")>=0){let W=v.split(" in ");return r.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const W=v.split(">=");return E.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const W=v.split(">");return _.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const W=v.split("<=");return k.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const W=v.split("<");return a.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(v)?D.create(v.substr(1).trim()):g.create(v)}static _deserializeValue(v,x){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let W=/^'([^']*)'$/.exec(v);return W?W[1].trim():v}static _deserializeRegexValue(v,x){if((0,T.isFalsyOrWhitespace)(v)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=v.indexOf("/"),V=v.lastIndexOf("/");if(W===V||W<0){if(x)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let re=v.slice(W+1,V),H=v[V+1]==="i"?"i":"";try{return new RegExp(re,H)}catch(R){if(x)throw new Error(`bad regexp-value '${v}', parse error: ${R}`);return console.warn(`bad regexp-value '${v}', parse error: ${R}`),null}}}e.ContextKeyExpr=y;function O(F,v){const x=F?F.substituteConstants():void 0,W=v?v.substituteConstants():void 0;return!x&&!W?!0:!x||!W?!1:x.equals(W)}e.expressionsAreEqualWithConstantSubstitution=O;function L(F,v){return F.cmp(v)}class C{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class u{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class g{constructor(v,x){this.key=v,this.negated=x,this.type=2}static create(v,x=null){const W=M.get(v);return typeof W=="boolean"?W?u.INSTANCE:C.INSTANCE:new g(v,x)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=M.get(this.key);return typeof v=="boolean"?v?u.INSTANCE:C.INSTANCE:this}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class o{constructor(v,x,W){this.key=v,this.value=x,this.negated=W,this.type=4}static create(v,x,W=null){if(typeof x=="boolean")return x?g.create(v,W):D.create(v,W);const V=M.get(v);return typeof V=="boolean"?x===(V?"true":"false")?u.INSTANCE:C.INSTANCE:new o(v,x,W)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=M.get(this.key);if(typeof v=="boolean"){const x=v?"true":"false";return this.value===x?u.INSTANCE:C.INSTANCE}return this}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=o;class r{constructor(v,x){this.key=v,this.valueKey=x,this.type=10,this.negated=null}static create(v,x){return new r(v,x)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}substituteConstants(){return this}evaluate(v){const x=v.getValue(this.valueKey),W=v.getValue(this.key);return Array.isArray(x)?x.indexOf(W)>=0:typeof W=="string"&&typeof x=="object"&&x!==null?I.call(x,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=r;class f{constructor(v){this._actual=v,this.type=11}static create(v){return new f(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new f(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class p{constructor(v,x,W){this.key=v,this.value=x,this.negated=W,this.type=5}static create(v,x,W=null){if(typeof x=="boolean")return x?D.create(v,W):g.create(v,W);const V=M.get(v);return typeof V=="boolean"?x===(V?"true":"false")?C.INSTANCE:u.INSTANCE:new p(v,x,W)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=M.get(this.key);if(typeof v=="boolean"){const x=v?"true":"false";return this.value===x?C.INSTANCE:u.INSTANCE}return this}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class D{constructor(v,x){this.key=v,this.negated=x,this.type=3}static create(v,x=null){const W=M.get(v);return typeof W=="boolean"?W?C.INSTANCE:u.INSTANCE:new D(v,x)}cmp(v){return v.type!==this.type?this.type-v.type:d(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=M.get(this.key);return typeof v=="boolean"?v?C.INSTANCE:u.INSTANCE:this}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function h(F,v){if(typeof F=="string"){const x=parseFloat(F);isNaN(x)||(F=x)}return typeof F=="string"||typeof F=="number"?v(F):C.INSTANCE}class _{constructor(v,x,W){this.key=v,this.value=x,this.negated=W,this.type=12}static create(v,x,W=null){return h(x,V=>new _(v,V,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=_;class E{constructor(v,x,W){this.key=v,this.value=x,this.negated=W,this.type=13}static create(v,x,W=null){return h(x,V=>new E(v,V,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=E;class a{constructor(v,x,W){this.key=v,this.value=x,this.negated=W,this.type=14}static create(v,x,W=null){return h(x,V=>new a(v,V,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class k{constructor(v,x,W){this.key=v,this.value=x,this.negated=W,this.type=15}static create(v,x,W=null){return h(x,V=>new k(v,V,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=k;class s{constructor(v,x){this.key=v,this.regexp=x,this.type=7,this.negated=null}static create(v,x){return new s(v,x)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const x=this.regexp?this.regexp.source:"",W=v.regexp?v.regexp.source:"";return x<W?-1:x>W?1:0}equals(v){if(v.type===this.type){const x=this.regexp?this.regexp.source:"",W=v.regexp?v.regexp.source:"";return this.key===v.key&&x===W}return!1}substituteConstants(){return this}evaluate(v){let x=v.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class i{constructor(v){this._actual=v,this.type=8}static create(v){return new i(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new i(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function c(F){let v=null;for(let x=0,W=F.length;x<W;x++){const V=F[x].substituteConstants();if(F[x]!==V&&v===null){v=[];for(let re=0;re<x;re++)v[re]=F[re]}v!==null&&(v[x]=V)}return v===null?F:v}class t{constructor(v,x){this.expr=v,this.negated=x,this.type=6}static create(v,x){return t._normalizeArr(v,x)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let x=0,W=this.expr.length;x<W;x++){const V=L(this.expr[x],v.expr[x]);if(V!==0)return V}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].equals(v.expr[x]))return!1;return!0}return!1}substituteConstants(){const v=c(this.expr);return v===this.expr?this:t.create(v,this.negated)}evaluate(v){for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].evaluate(v))return!1;return!0}static _normalizeArr(v,x){const W=[];let V=!1;for(const re of v)if(!!re){if(re.type===1){V=!0;continue}if(re.type===0)return C.INSTANCE;if(re.type===6){W.push(...re.expr);continue}W.push(re)}if(W.length===0&&V)return u.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(L);for(let re=1;re<W.length;re++)W[re-1].equals(W[re])&&(W.splice(re,1),re--);if(W.length===1)return W[0];for(;W.length>1;){const re=W[W.length-1];if(re.type!==9)break;W.pop();const H=W.pop(),R=W.length===0,se=n.create(re.expr.map(de=>t.create([de,H],null)),null,R);se&&(W.push(se),W.sort(L))}return W.length===1?W[0]:new t(W,x)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let x of this.expr)v.push(...x.keys());return v}map(v){return new t(this.expr.map(x=>x.map(v)),null)}negate(){if(!this.negated){const v=[];for(let x of this.expr)v.push(x.negate());this.negated=n.create(v,this,!0)}return this.negated}}class n{constructor(v,x){this.expr=v,this.negated=x,this.type=9}static create(v,x,W){return n._normalizeArr(v,x,W)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let x=0,W=this.expr.length;x<W;x++){const V=L(this.expr[x],v.expr[x]);if(V!==0)return V}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].equals(v.expr[x]))return!1;return!0}return!1}substituteConstants(){const v=c(this.expr);return v===this.expr?this:n.create(v,this.negated,!1)}evaluate(v){for(let x=0,W=this.expr.length;x<W;x++)if(this.expr[x].evaluate(v))return!0;return!1}static _normalizeArr(v,x,W){let V=[],re=!1;if(v){for(let H=0,R=v.length;H<R;H++){const se=v[H];if(!!se){if(se.type===0){re=!0;continue}if(se.type===1)return u.INSTANCE;if(se.type===9){V=V.concat(se.expr);continue}V.push(se)}}if(V.length===0&&re)return C.INSTANCE;V.sort(L)}if(V.length!==0){if(V.length===1)return V[0];for(let H=1;H<V.length;H++)V[H-1].equals(V[H])&&(V.splice(H,1),H--);if(V.length===1)return V[0];if(W){for(let H=0;H<V.length;H++)for(let R=H+1;R<V.length;R++)P(V[H],V[R])&&(V.splice(R,1),R--);if(V.length===1)return V[0]}return new n(V,x)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let x of this.expr)v.push(...x.keys());return v}map(v){return new n(this.expr.map(x=>x.map(v)),null)}negate(){if(!this.negated){let v=[];for(let x of this.expr)v.push(x.negate());for(;v.length>1;){const x=v.shift(),W=v.shift(),V=[];for(const H of B(x))for(const R of B(W))V.push(t.create([H,R],null));const re=v.length===0;v.unshift(n.create(V,null,re))}this.negated=v[0]}return this.negated}}class m extends g{constructor(v,x,W){super(v,null);this._defaultValue=x,typeof W=="object"?m._info.push({...W,key:v}):W!==!0&&m._info.push({key:v,description:W,type:x!=null?typeof x:void 0})}static all(){return m._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return o.create(this.key,v)}notEqualsTo(v){return p.create(this.key,v)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(F,v){return F<v?-1:F>v?1:0}function S(F,v,x,W){return F<x?-1:F>x?1:v<W?-1:v>W?1:0}function P(F,v){if(v.type===6&&F.type!==9&&F.type!==6){for(const V of v.expr)if(F.equals(V))return!0}const x=F.negate(),W=B(x).concat(B(v));W.sort(L);for(let V=0;V<W.length;V++){const H=W[V].negate();for(let R=V+1;R<W.length;R++){const se=W[R];if(H.equals(se))return!0}}return!1}e.implies=P;function B(F){return F.type===9?F.expr:[F]}}),define(be[140],Se([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(be[141],Se([1,0,119,3]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function M(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function I(p,D){switch(p){case 3:return D==="x64"?"win32-x64":D==="ia32"?"win32-ia32":D==="arm64"?"win32-arm64":"unknown";case 2:return D==="x64"?"linux-x64":D==="arm64"?"linux-arm64":D==="arm"?"linux-armhf":"unknown";case"alpine":return D==="x64"?"alpine-x64":D==="arm64"?"alpine-arm64":"unknown";case 1:return D==="x64"?"darwin-x64":D==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(p,D){return D==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(p,D,h){return A(D,h)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===h?!0:O(h).includes(p)}e.isTargetPlatformCompatible=y;function O(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=O;function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=L;var C;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var u;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var g;(function(p){p.Install="install",p.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var o;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(o=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var r;(function(p){p.Unsupported="Unsupported",p.UnsupportedPreRelease="UnsupportedPreRelease",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(r=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(D,h){super(D);this.code=h,this.name=h}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(be[45],Se([1,0,14,23,17,9,10,2,121,3]),function(J,e,l,T,b,M,I,A,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,O.createDecorator)("fileService");function L(R){return R.create===!0}e.isFileOpenForWriteOptions=L;var C;(function(R){R[R.Unknown=0]="Unknown",R[R.File=1]="File",R[R.Directory=2]="Directory",R[R.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var u;(function(R){R[R.Readonly=1]="Readonly"})(u=e.FilePermission||(e.FilePermission={}));var g;(function(R){R[R.FileReadWrite=2]="FileReadWrite",R[R.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",R[R.FileReadStream=16]="FileReadStream",R[R.FileFolderCopy=8]="FileFolderCopy",R[R.PathCaseSensitive=1024]="PathCaseSensitive",R[R.Readonly=2048]="Readonly",R[R.Trash=4096]="Trash",R[R.FileWriteUnlock=8192]="FileWriteUnlock",R[R.FileAtomicRead=16384]="FileAtomicRead",R[R.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function o(R){return!!(R.capabilities&2)}e.hasReadWriteCapability=o;function r(R){return!!(R.capabilities&8)}e.hasFileFolderCopyCapability=r;function f(R){return!!(R.capabilities&32768)}e.hasFileCloneCapability=f;function p(R){return!!(R.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function D(R){return!!(R.capabilities&16)}e.hasFileReadStreamCapability=D;function h(R){return o(R)?!!(R.capabilities&16384):!1}e.hasFileAtomicReadCapability=h;var _;(function(R){R.FileExists="EntryExists",R.FileNotFound="EntryNotFound",R.FileNotADirectory="EntryNotADirectory",R.FileIsADirectory="EntryIsADirectory",R.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",R.FileTooLarge="EntryTooLarge",R.FileWriteLocked="EntryWriteLocked",R.NoPermissions="NoPermissions",R.Unavailable="Unavailable",R.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(se,de){super(se);this.code=de}}e.FileSystemProviderError=E;function a(R,se){const de=new E(R.toString(),se);return s(de,se),de}e.createFileSystemProviderError=a;function k(R){return R||a((0,y.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=k;function s(R,se){return R.name=se?`${se} (FileSystemError)`:"FileSystemError",R}e.markAsFileSystemProviderError=s;function i(R){if(!R)return _.Unknown;if(R instanceof E)return R.code;const se=/^(.+) \(FileSystemError\)$/.exec(R.name);if(!se)return _.Unknown;switch(se[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=i;function c(R){if(R instanceof P)return R.fileOperationResult;switch(i(R)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var t;(function(R){R[R.CREATE=0]="CREATE",R[R.DELETE=1]="DELETE",R[R.MOVE=2]="MOVE",R[R.COPY=3]="COPY",R[R.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class n{constructor(se,de,X){this.resource=se,this.operation=de,this.target=X}isOperation(se){return this.operation===se}}e.FileOperationEvent=n;var m;(function(R){R[R.UPDATED=0]="UPDATED",R[R.ADDED=1]="ADDED",R[R.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class d{constructor(se,de){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=se;const X=new Map;for(const ie of se){const he=X.get(ie.type);switch(he?he.push([ie.resource,ie]):X.set(ie.type,[[ie.resource,ie]]),ie.type){case 1:this.rawAdded.push(ie.resource);break;case 0:this.rawUpdated.push(ie.resource);break;case 2:this.rawDeleted.push(ie.resource);break}}for(const[ie,he]of X)switch(ie){case 1:this.added=T.TernarySearchTree.forUris(()=>de),this.added.fill(he);break;case 0:this.updated=T.TernarySearchTree.forUris(()=>de),this.updated.fill(he);break;case 2:this.deleted=T.TernarySearchTree.forUris(()=>de),this.deleted.fill(he);break}}contains(se,...de){return this.doContains(se,{includeChildren:!1},...de)}affects(se,...de){return this.doContains(se,{includeChildren:!0},...de)}doContains(se,de,...X){if(!se)return!1;const ie=X.length>0;return!!((!ie||X.includes(1))&&(this.added?.get(se)||de.includeChildren&&this.added?.findSuperstr(se))||(!ie||X.includes(0))&&(this.updated?.get(se)||de.includeChildren&&this.updated?.findSuperstr(se))||(!ie||X.includes(2))&&(this.deleted?.findSubstr(se)||de.includeChildren&&this.deleted?.findSuperstr(se)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function S(R,se,de){return!R||!se||R===se||se.length>R.length?!1:(se.charAt(se.length-1)!==b.sep&&(se+=b.sep),de?(0,M.startsWithIgnoreCase)(R,se):R.indexOf(se)===0)}e.isParent=S;class P extends l.ErrorNoTelemetry{constructor(se,de,X){super(se);this.fileOperationResult=de,this.options=X}}e.FileOperationError=P;class B extends P{constructor(se,de,X){super(se,2,X);this.stat=de}}e.NotModifiedSinceFileOperationError=B;var F;(function(R){R[R.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",R[R.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",R[R.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",R[R.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",R[R.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",R[R.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",R[R.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",R[R.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",R[R.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",R[R.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",R[R.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",R[R.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(R){R[R.FILE=0]="FILE",R[R.FOLDER=1]="FOLDER",R[R.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(R){if(!(typeof R.size!="number"||typeof R.mtime!="number"))return R.mtime.toString(29)+R.size.toString(31)}e.etag=x;async function W(R,se){if(!se.hasProvider(A.URI.from({scheme:R.scheme})))return new Promise(de=>{const X=se.onDidChangeFileSystemProviderRegistrations(ie=>{ie.scheme===R.scheme&&ie.added&&(X.dispose(),de())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(se){return(0,I.isNumber)(se)||(se=0),se<V.KB?(0,y.localize)(1,null,se.toFixed(0)):se<V.MB?(0,y.localize)(2,null,(se/V.KB).toFixed(2)):se<V.GB?(0,y.localize)(3,null,(se/V.MB).toFixed(2)):se<V.TB?(0,y.localize)(4,null,(se/V.GB).toFixed(2)):(0,y.localize)(5,null,(se/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var re;(function(R){R[R.IA32=0]="IA32",R[R.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function H(R){return{maxFileSize:R===0?300*V.MB:16*V.GB,maxHeapSize:R===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=H}),define(be[57],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...b){this._entries=new Map;for(let[M,I]of b)this.set(M,I)}set(b,M){const I=this._entries.get(b);return this._entries.set(b,M),I}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=l}),define(be[142],Se([1,0,12,14,79,139,3,57]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class O extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class L{constructor(o=new A.ServiceCollection,r=!1,f){this._activeInstantiations=new Set,this._services=o,this._strict=r,this._parent=f,this._services.set(I.IInstantiationService,this)}createChild(o){return new L(o,this._strict,this)}invokeFunction(o,...r){let f=u.traceInvocation(o),p=!1;try{return o({get:h=>{if(p)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const _=this._getOrCreateServiceInstance(h,f);if(!_)throw new Error(`[invokeFunction] unknown service '${h}'`);return _}},...r)}finally{p=!0,f.stop()}}createInstance(o,...r){let f,p;return o instanceof b.SyncDescriptor?(f=u.traceCreation(o.ctor),p=this._createInstance(o.ctor,o.staticArguments.concat(r),f)):(f=u.traceCreation(o),p=this._createInstance(o,r,f)),f.stop(),p}_createInstance(o,r=[],f){let p=I._util.getServiceDependencies(o).sort((_,E)=>_.index-E.index),D=[];for(const _ of p){let E=this._getOrCreateServiceInstance(_.id,f);E||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${_.id}.`,!1),D.push(E)}let h=p.length>0?p[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${r.length} static arguments`);let _=h-r.length;_>0?r=r.concat(new Array(_)):r=r.slice(0,h)}return new o(...[...r,...D])}_setServiceInstance(o,r){if(this._services.get(o)instanceof b.SyncDescriptor)this._services.set(o,r);else if(this._parent)this._parent._setServiceInstance(o,r);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let r=this._services.get(o);return!r&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):r}_getOrCreateServiceInstance(o,r){let f=this._getServiceInstanceOrDescriptor(o);return f instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,f,r.branch(o,!0)):(r.branch(o,!1),f)}_safeCreateAndCacheServiceInstance(o,r,f){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,r,f)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,r,f){const p=new M.Graph(_=>_.id.toString());let D=0;const h=[{id:o,desc:r,_trace:f}];for(;h.length;){const _=h.pop();if(p.lookupOrInsertNode(_),D++>1e3)throw new O(p);for(let E of I._util.getServiceDependencies(_.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(E.id);if(a||this._throwIfStrict(`[createInstance] ${o} depends on ${E.id} which is NOT registered.`,!0),a instanceof b.SyncDescriptor){const k={id:E.id,desc:a,_trace:_._trace.branch(E.id,!0)};p.insertEdge(_,k),h.push(k)}}}for(;;){const _=p.roots();if(_.length===0){if(!p.isEmpty())throw new O(p);break}for(const{data:E}of _){if(this._getServiceInstanceOrDescriptor(E.id)instanceof b.SyncDescriptor){const k=this._createServiceInstanceWithOwner(E.id,E.desc.ctor,E.desc.staticArguments,E.desc.supportsDelayedInstantiation,E._trace);this._setServiceInstance(E.id,k)}p.removeNode(E)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,r,f=[],p,D){if(this._services.get(o)instanceof b.SyncDescriptor)return this._createServiceInstance(r,f,p,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,r,f,p,D);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}_createServiceInstance(o,r=[],f,p){if(f){const D=new l.IdleValue(()=>this._createInstance(o,r,p));return new Proxy(Object.create(null),{get(h,_){if(_ in h)return h[_];let E=D.value,a=E[_];return typeof a!="function"||(a=a.bind(E),h[_]=a),a},set(h,_,E){return D.value[_]=E,!0}})}else return this._createInstance(o,r,p)}_throwIfStrict(o,r){if(r&&console.warn(r),this._strict)throw new Error(o)}}e.InstantiationService=L;var C;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(C||(C={}));class u{constructor(o,r){this.type=o,this.name=r,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return y?new u(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(o){return y?new u(0,o.name):u._None}branch(o,r){let f=new u(2,o.toString());return this._dep.push([o,r,f]),f}stop(){let o=Date.now()-this._start;u._totals+=o;let r=!1;function f(D,h){let _=[],E=new Array(D+1).join("	");for(const[a,k,s]of h._dep)if(k&&s){r=!0,_.push(`${E}CREATES -> ${a}`);let i=f(D+1,s);i&&_.push(i)}else _.push(`${E}uses -> ${a}`);return _.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(o>2||r)&&console.log(p.join(`
`))}}e.Trace=u,u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(be[13],Se([1,0,43,5,7,21,3]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function A(){return new Date().toISOString()}var y;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function O(k,s,i){switch(s){case y.Trace:k.trace(i);break;case y.Debug:k.debug(i);break;case y.Info:k.info(i);break;case y.Warning:k.warn(i);break;case y.Error:k.error(i);break;case y.Critical:k.critical(i);break;default:throw new Error("Invalid log level")}}e.log=O;function L(k){let s="";for(let i=0;i<k.length;i++){let c=k[i];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}s+=(i>0?" ":"")+c}return s}e.format=L;class C extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class u extends C{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,L([s,...i]))}debug(s,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,L([s,...i]))}info(s,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,L([s,...i]))}warn(s,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,L([s,...i]))}error(s,...i){if(this.checkLogLevel(y.Error))if(s instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=s.stack,this.log(y.Error,L(c))}else this.log(y.Error,L([s,...i]))}critical(s,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,L([s,...i]))}flush(){}}e.AbstractMessageLogger=u;class g extends C{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!M.isWindows}trace(s,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,s,...i):console.log(`[main ${A()}]`,s,...i))}debug(s,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,s,...i):console.log(`[main ${A()}]`,s,...i))}info(s,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,s,...i):console.log(`[main ${A()}]`,s,...i))}warn(s,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,s,...i):console.warn(`[main ${A()}]`,s,...i))}error(s,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,s,...i):console.error(`[main ${A()}]`,s,...i))}critical(s,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,s,...i):console.error(`[main ${A()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class o extends C{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class r extends C{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,l.toErrorMessage)(s,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=r;class f extends C{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const c of this.logServices)c.trace(s,...i)}debug(s,...i){for(const c of this.logServices)c.debug(s,...i)}info(s,...i){for(const c of this.logServices)c.info(s,...i)}warn(s,...i){for(const c of this.logServices)c.warn(s,...i)}error(s,...i){for(const c of this.logServices)c.error(s,...i)}critical(s,...i){for(const c of this.logServices)c.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=f;class p extends b.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=p;class D extends b.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(c))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let c=this.loggers.get(s.toString());return c||(c=this.doCreateLogger(s,i?.always?y.Trace:this.logLevel,i),this.loggers.set(s.toString(),c),i?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class h{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(s){}getLevel(){return y.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=h;function _(k){if(k.verbose)return y.Trace;if(typeof k.logLevel=="string"){const s=E(k.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function E(k){switch(k){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=E;function a(k){switch(k){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=a}),define(be[80],Se([1,0,34,122,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function O(o,r){return r-o}y.compare=O;const L=Object.create(null);L[y.Error]=(0,T.localize)(0,null),L[y.Warning]=(0,T.localize)(1,null),L[y.Info]=(0,T.localize)(2,null);function C(o){return L[o]||""}y.toString=C;function u(o){switch(o){case l.default.Error:return y.Error;case l.default.Warning:return y.Warning;case l.default.Info:return y.Info;case l.default.Ignore:return y.Hint}}y.fromSeverity=u;function g(o){switch(o){case y.Error:return l.default.Error;case y.Warning:return l.default.Warning;case y.Info:return l.default.Info;case y.Hint:return l.default.Ignore}}y.toSeverity=g}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const O="";function L(u){return C(u,!0)}y.makeKey=L;function C(u,g){let o=[O];return u.source?o.push(u.source.replace("\xA6","\\\xA6")):o.push(O),u.code?typeof u.code=="string"?o.push(u.code.replace("\xA6","\\\xA6")):o.push(u.code.value.replace("\xA6","\\\xA6")):o.push(O),u.severity!==void 0&&u.severity!==null?o.push(I.toString(u.severity)):o.push(O),u.message&&g?o.push(u.message.replace("\xA6","\\\xA6")):o.push(O),u.startLineNumber!==void 0&&u.startLineNumber!==null?o.push(u.startLineNumber.toString()):o.push(O),u.startColumn!==void 0&&u.startColumn!==null?o.push(u.startColumn.toString()):o.push(O),u.endLineNumber!==void 0&&u.endLineNumber!==null?o.push(u.endLineNumber.toString()):o.push(O),u.endColumn!==void 0&&u.endColumn!==null?o.push(u.endColumn.toString()):o.push(O),o.push(O),o.join("\xA6")}y.makeKeyOptionalMessage=C})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(be[143],Se([1,0,5,34,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,b.createDecorator)("notificationService");var M;(function(O){O[O.WORKSPACE=0]="WORKSPACE",O[O.GLOBAL=1]="GLOBAL"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(O){O[O.OFF=0]="OFF",O[O.SILENT=1]="SILENT",O[O.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(be[81],Se([1,0,7,9,2,3]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function I(L,C){return b.URI.isUri(L)?(0,T.equalsIgnoreCase)(L.scheme,C):(0,T.startsWithIgnoreCase)(L,C+":")}e.matchesScheme=I;function A(L,...C){return C.some(u=>I(L,u))}e.matchesSomeScheme=A;function y(L,C){return L.with({fragment:`${C.startLineNumber},${C.startColumn}${C.endLineNumber?`-${C.endLineNumber}${C.endColumn?`,${C.endColumn}`:""}`:""}`})}e.withSelection=y;function O(L){let C;const u=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return u&&(C={startLineNumber:parseInt(u[1]),startColumn:u[2]?parseInt(u[2]):1,endLineNumber:u[4]?parseInt(u[4]):void 0,endColumn:u[4]?u[5]?parseInt(u[5]):1:void 0},L=L.with({fragment:""})),{selection:C,uri:L}}e.extractSelection=O});var Ue=this&&this.__decorate||function(J,e,l,T){var b=arguments.length,M=b<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,l):T,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,e,l,T);else for(var A=J.length-1;A>=0;A--)(I=J[A])&&(M=(b<3?I(M):b>3?I(e,l,M):I(e,l))||M);return b>3&&M&&Object.defineProperty(e,l,M),M},Be=this&&this.__param||function(J,e){return function(l,T){e(l,T,J)}};define(be[144],Se([1,0,12,20,7,3]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var I;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends b.Disposable{constructor(C,u){super();this.deferred=new l.DeferredPromise,u.withProgress(C,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=Ue([Be(1,e.IProgressService)],y),e.UnmanagedProgress=y;class O extends b.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(C){this.stop();const u=++this.currentOperationId,g=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:g.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=O,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(be[37],Se([1,0,42,10]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(I,A){l.ok(T.isString(I)),l.ok(T.isObject(A)),l.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,A)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new b}),define(be[145],Se([1,0,5,37]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,O){this.schemasById[b(y)]=O,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new M;T.Registry.add(e.Extensions.JSONContribution,I)}),define(be[82],Se([1,0,16,5,10,118,56,145,37]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var O;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(O=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=y.Registry.as(A.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,k=!0){this.registerConfigurations([a],k)}registerConfigurations(a,k=!0){const s=this.doRegisterConfigurations(a,k);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(a){const k=this.doDeregisterConfigurations(a);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:k})}updateConfigurations({add:a,remove:k}){const s=[];s.push(...this.doDeregisterConfigurations(k)),s.push(...this.doRegisterConfigurations(a,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(s)})}registerDefaultConfigurations(a){const k=[],s=[];for(const{overrides:i,source:c}of a)for(const t in i)if(k.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const n={...this.configurationDefaultsOverrides.get(t)?.value||{},...i[t]};this.configurationDefaultsOverrides.set(t,{source:c,value:n});const m=(0,I.getLanguageTagSettingPlainKey)(t),d={type:"object",default:n,description:M.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:n,source:b.isString(c)?void 0:c};s.push(...r(t)),this.configurationProperties[t]=d,this.defaultLanguageConfigurationOverridesNode.properties[t]=d}else{this.configurationDefaultsOverrides.set(t,{value:i[t],source:c});const n=this.configurationProperties[t];n&&(this.updatePropertyDefaultValue(t,n),this.updateSchema(t,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:k,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const k=[];for(const{overrides:s,source:i}of a)for(const c in s){const t=this.configurationDefaultsOverrides.get(c),n=b.isString(i)?i:i?.id,m=b.isString(t?.source)?t?.source:t?.source?.id;if(n===m)if(k.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const d=this.configurationProperties[c];d&&(this.updatePropertyDefaultValue(c,d),this.updateSchema(c,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:k,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const k of a)this.overrideIdentifiers.add(k);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,k){const s=[];return a.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,k,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(a){const k=[],s=i=>{if(i.properties)for(const c in i.properties)k.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,i.properties[c]);i.allOf&&i.allOf.forEach(c=>s(c))};for(const i of a){s(i);const c=this.configurationContributors.indexOf(i);c!==-1&&this.configurationContributors.splice(c,1)}return k}validateAndRegisterProperties(a,k=!0,s,i,c=3){c=b.isUndefinedOrNull(a.scope)?c:a.scope;let t=[],n=a.properties;if(n)for(let d in n){if(k&&h(d)){delete n[d];continue}const S=n[d];if(S.source=s,S.defaultDefaultValue=n[d].default,this.updatePropertyDefaultValue(d,S),e.OVERRIDE_PROPERTY_REGEX.test(d)?S.scope=void 0:(S.scope=b.isUndefinedOrNull(S.scope)?c:S.scope,S.restricted=b.isUndefinedOrNull(S.restricted)?!!i?.includes(d):S.restricted),n[d].hasOwnProperty("included")&&!n[d].included){this.excludedConfigurationProperties[d]=n[d],delete n[d];continue}else this.configurationProperties[d]=n[d];!n[d].deprecationMessage&&n[d].markdownDeprecationMessage&&(n[d].deprecationMessage=n[d].markdownDeprecationMessage),t.push(d)}let m=a.allOf;if(m)for(let d of m)t.push(...this.validateAndRegisterProperties(d,k,s,i,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const k=s=>{let i=s.properties;if(i)for(const t in i)this.updateSchema(t,i[t]);let c=s.allOf;c&&c.forEach(k)};k(a)}updateSchema(a,k){switch(e.allSettings.properties[a]=k,k.scope){case 1:e.applicationSettings.properties[a]=k;break;case 2:e.machineSettings.properties[a]=k;break;case 6:e.machineOverridableSettings.properties[a]=k;break;case 3:e.windowSettings.properties[a]=k;break;case 4:e.resourceSettings.properties[a]=k;break;case 5:e.resourceSettings.properties[a]=k,this.resourceLanguageSettingsSchema.properties[a]=k;break}}removeFromSchema(a,k){switch(delete e.allSettings.properties[a],k.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const k=`[${a}]`,s={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(k,s),e.allSettings.properties[k]=s,e.applicationSettings.properties[k]=s,e.machineSettings.properties[k]=s,e.machineOverridableSettings.properties[k]=s,e.windowSettings.properties[k]=s,e.resourceSettings.properties[k]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,k){const s=this.configurationDefaultsOverrides.get(a);let i=s?.value,c=s?.source;b.isUndefined(i)&&(i=k.defaultDefaultValue,c=void 0),b.isUndefined(i)&&(i=p(k.type)),k.default=i,k.defaultValueSource=c}}const g="\\[([^\\]]+)\\]",o=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(E){const a=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let k=o.exec(E);for(;k?.length;){const s=k[1].trim();s&&a.push(s),k=o.exec(E)}}return(0,l.distinct)(a)}e.overrideIdentifiersFromKey=r;function f(E){return E.reduce((a,k)=>`${a}[${k}]`,"")}e.keyFromOverrideIdentifiers=f;function p(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const D=new u;y.Registry.add(e.Extensions.Configuration,D);function h(E){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?M.localize(7,null,E):D.getConfigurationProperties()[E]!==void 0?M.localize(8,null,E):null:M.localize(6,null)}e.validateProperty=h;function _(){const E=[],a=D.getConfigurationProperties();for(const k of Object.keys(a))E.push([k,a[k].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=_}),define(be[146],Se([1,0,16,5,101,7,23,27,10,2,56,82,37]),function(J,e,l,T,b,M,I,A,y,O,L,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(s={},i=[],c=[]){this._contents=s,this._keys=i,this._overrides=c,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const c=this.getContentsForOverrideIdentifer(i);return c?s?(0,L.getConfigurationValue)(c,s):c:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const c of this.overrides)c.identifiers.includes(s)&&i.push(...c.keys);return l.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return l.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=A.deepClone(this.contents),c=A.deepClone(this.overrides),t=[...this.keys];for(const n of s){this.mergeContents(i,n.contents);for(const m of n.overrides){const[d]=c.filter(S=>l.equals(S.identifiers,m.identifiers));d?(this.mergeContents(d.contents,m.contents),d.keys.push(...m.keys),d.keys=l.distinct(d.keys)):c.push(A.deepClone(m))}for(const m of n.keys)t.indexOf(m)===-1&&t.push(m)}return new g(i,t,c)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let c={};for(const t of l.distinct([...Object.keys(this.contents),...Object.keys(i)])){let n=this.contents[t],m=i[t];m&&(typeof n=="object"&&typeof m=="object"?(n=A.deepClone(n),this.mergeContents(n,m)):n=m),c[t]=n}return new g(c,this.keys,this.overrides)}mergeContents(s,i){for(const c of Object.keys(i)){if(c in s&&y.isObject(s[c])&&y.isObject(i[c])){this.mergeContents(s[c],i[c]);continue}s[c]=A.deepClone(i[c])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?A.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,c=null;const t=n=>{n&&(c?this.mergeContents(c,n):c=A.deepClone(n))};for(const n of this.overrides)l.equals(n.identifiers,[s])?i=n.contents:n.identifiers.includes(s)&&t(n.contents);return t(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,L.addToValueTree)(this.contents,s,i,c=>{throw new Error(c)})}removeValue(s){this.removeKey(s)&&(0,L.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let c=0;c<i;c++)s.indexOf(this.keys[c])===0&&(i=c);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class o extends g{constructor(s={}){const i=u.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(i),t=Object.create(null),n=[];for(const m in i){const d=s[m],S=d!==void 0?d:i[m].default;(0,L.addToValueTree)(t,m,S,P=>console.error(`Conflict in default settings: ${P}`))}for(const m of Object.keys(t))C.OVERRIDE_PROPERTY_REGEX.test(m)&&n.push({identifiers:(0,C.overrideIdentifiersFromKey)(m),keys:Object.keys(t[m]),contents:(0,L.toValuesTree)(t[m],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,c,n)}}e.DefaultConfigurationModel=o;class r{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!y.isUndefinedOrNull(s)){const c=this.doParseContent(s);this.parseRaw(c,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:c,keys:t,overrides:n,restricted:m}=this.doParseRaw(s,i);this._configurationModel=new g(c,t,n),this._restrictedConfigurations=m||[]}doParseContent(s){let i={},c=null,t=[],n=[],m=[];function d(P){Array.isArray(t)?t.push(P):c!==null&&(t[c]=P)}let S={onObjectBegin:()=>{let P={};d(P),n.push(t),t=P,c=null},onObjectProperty:P=>{c=P},onObjectEnd:()=>{t=n.pop()},onArrayBegin:()=>{let P=[];d(P),n.push(t),t=P,c=null},onArrayEnd:()=>{t=n.pop()},onLiteralValue:d,onError:(P,B,F)=>{m.push({error:P,offset:B,length:F})}};if(s)try{b.visit(s,S),i=t[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(s,i){const c=u.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),t=this.filter(s,c,!0,i);s=t.raw;const n=(0,L.toValuesTree)(s,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),m=Object.keys(s),d=this.toOverrides(s,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:n,keys:m,overrides:d,restricted:t.restricted}}filter(s,i,c,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:s,restricted:[]};const n={},m=[];for(let d in s)if(C.OVERRIDE_PROPERTY_REGEX.test(d)&&c){const S=this.filter(s[d],i,!1,t);n[d]=S.raw,m.push(...S.restricted)}else{const S=i[d],P=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&m.push(d),(P===void 0||t.scopes===void 0||t.scopes.includes(P))&&(t.skipRestricted&&S?.restricted||(n[d]=s[d]))}return{raw:n,restricted:m}}toOverrides(s,i){const c=[];for(const t of Object.keys(s))if(C.OVERRIDE_PROPERTY_REGEX.test(t)){const n={};for(const m in s[t])n[m]=s[t][m];c.push({identifiers:(0,C.overrideIdentifiersFromKey)(t),keys:Object.keys(n),contents:(0,L.toValuesTree)(n,i)})}return c}}e.ConfigurationModelParser=r;class f extends M.Disposable{constructor(s,i,c,t){super();this.userSettingsResource=s,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new r(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.any(T.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource)),T.Event.filter(this.fileService.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&c.isEqual(n.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class p{constructor(s,i,c=new g,t=new g,n=new I.ResourceMap,m=new g,d=new I.ResourceMap,S=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=c,this._workspaceConfiguration=t,this._folderConfigurations=n,this._memoryConfiguration=m,this._memoryConfigurationByResource=d,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(s,i,c){return this.getConsolidateConfigurationModel(i,c).getValue(s)}updateValue(s,i,c={}){let t;c.resource?(t=this._memoryConfigurationByResource.get(c.resource),t||(t=new g,this._memoryConfigurationByResource.set(c.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(s):t.setValue(s,i),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,c){const t=this.getConsolidateConfigurationModel(i,c),n=this.getFolderConfigurationModelForResource(i.resource,c),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,d=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),S=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),B=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),F=c?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,v=n?i.overrideIdentifier?n.freeze().override(i.overrideIdentifier).getValue(s):n.freeze().getValue(s):void 0,x=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(s):m.getValue(s),W=t.getValue(s),V=l.distinct(l.flatten(t.overrides.map(re=>re.identifiers))).filter(re=>t.getOverrideValue(s,re)!==void 0);return{defaultValue:d,userValue:S,userLocalValue:P,userRemoteValue:B,workspaceValue:F,workspaceFolderValue:v,memoryValue:x,value:W,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:B!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:v!==void 0?{value:n?.freeze().getValue(s),override:i.overrideIdentifier?n?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:m.getValue(s),override:i.overrideIdentifier?m.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const c=[];if(!i){const{added:t,updated:n,removed:m}=E(this._defaultConfiguration,s);i=[...t,...n,...m]}for(const t of i)for(const n of(0,C.overrideIdentifiersFromKey)(t)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(n),d=s.getKeysForOverrideIdentifier(n),S=[...d.filter(P=>m.indexOf(P)===-1),...m.filter(P=>d.indexOf(P)===-1),...m.filter(P=>!A.equals(this._defaultConfiguration.override(n).getValue(P),s.override(n).getValue(P)))];c.push([n,S])}return this.updateDefaultConfiguration(s),{keys:i,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:c,removed:t,overrides:n}=E(this.localUserConfiguration,s),m=[...i,...c,...t];return m.length&&this.updateLocalUserConfiguration(s),{keys:m,overrides:n}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:c,removed:t,overrides:n}=E(this.remoteUserConfiguration,s);let m=[...i,...c,...t];return m.length&&this.updateRemoteUserConfiguration(s),{keys:m,overrides:n}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:c,removed:t,overrides:n}=E(this.workspaceConfiguration,s);let m=[...i,...c,...t];return m.length&&this.updateWorkspaceConfiguration(s),{keys:m,overrides:n}}compareAndUpdateFolderConfiguration(s,i){const c=this.folderConfigurations.get(s),{added:t,updated:n,removed:m,overrides:d}=E(c,i);let S=[...t,...n,...m];return(S.length||!c)&&this.updateFolderConfiguration(s,i),{keys:S,overrides:d}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:c,updated:t,removed:n,overrides:m}=E(i,void 0);return{keys:[...c,...t,...n],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let c=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?c.override(s.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:s},i){let c=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const t=i.getFolder(s);t&&(c=this.getFolderConsolidatedConfiguration(t.uri)||c);const n=this._memoryConfigurationByResource.get(s);n&&(c=c.merge(n))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const c=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(s);t?(i=c.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=c}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const c=i.getFolder(s);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:c,overrides:t,keys:n}=this._folderConfigurations.get(i);return s.push([i,{contents:c,overrides:t,keys:n}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(c=>s.add(c))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(c=>s.add(c))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(c=>i.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(s).forEach(t=>i.add(t))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),c=this.parseConfigurationModel(s.user),t=this.parseConfigurationModel(s.workspace),n=s.folders.reduce((m,d)=>(m.set(O.URI.revive(d[0]),this.parseConfigurationModel(d[1])),m),new I.ResourceMap);return new p(i,c,new g,t,n,new g,new I.ResourceMap,!1)}static parseConfigurationModel(s){return new g(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=p;function D(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const s=new Set,i=new Map;for(const t of k)t.keys.forEach(n=>s.add(n)),t.overrides.forEach(([n,m])=>{const d=(0,I.getOrSet)(i,n,new Set);m.forEach(S=>d.add(S))});const c=[];return i.forEach((t,n)=>c.push([n,[...t.values()]])),{keys:[...s.values()],overrides:c}}e.mergeChanges=D;class h{constructor(s,i,c,t){this.change=s,this.previous=i,this.currentConfiguraiton=c,this.currentWorkspace=t,this._previousConfiguration=void 0;const n=new Set;s.keys.forEach(d=>n.add(d)),s.overrides.forEach(([,d])=>d.forEach(S=>n.add(S))),this.affectedKeys=[...n.values()];const m=new g;this.affectedKeys.forEach(d=>m.setValue(d,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const c=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!A.equals(c,t)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let c=(0,L.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof c=="object"&&(t=Object.keys(c)[0]);){if(s=s[t],!s)return!1;c=c[t]}return!0}}e.ConfigurationChangeEvent=h;class _ extends h{constructor(s,i,c,t){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=c,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=_;function E(k,s){const{added:i,removed:c,updated:t}=a(s,k),n=[],m=k?.getAllOverrideIdentifiers()||[],d=s?.getAllOverrideIdentifiers()||[];if(s){const S=d.filter(P=>!m.includes(P));for(const P of S)n.push([P,s.getKeysForOverrideIdentifier(P)])}if(k){const S=m.filter(P=>!d.includes(P));for(const P of S)n.push([P,k.getKeysForOverrideIdentifier(P)])}if(s&&k){for(const S of m)if(d.includes(S)){const P=a({contents:k.getOverrideValue(void 0,S)||{},keys:k.getKeysForOverrideIdentifier(S)},{contents:s.getOverrideValue(void 0,S)||{},keys:s.getKeysForOverrideIdentifier(S)});n.push([S,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:c,updated:t,overrides:n}}function a(k,s){const i=k?s?k.keys.filter(n=>s.keys.indexOf(n)===-1):[...k.keys]:[],c=s?k?s.keys.filter(n=>k.keys.indexOf(n)===-1):[...s.keys]:[],t=[];if(k&&s){for(const n of s.keys)if(k.keys.indexOf(n)!==-1){const m=(0,L.getConfigurationValue)(s.contents,n),d=(0,L.getConfigurationValue)(k.contents,n);A.equals(m,d)||t.push(n)}}return{added:i,removed:c,updated:t}}}),define(be[83],Se([1,0,14,3]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var b;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends l.ErrorNoTelemetry{constructor(A,y=b.Unknown,O){super(A);this._message=A,this._code=y,this._detail=O,this.isHandled=y===b.NotAvailable&&O===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===b.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===b.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}}e.RemoteAuthorityResolverError=M}),define(be[84],Se([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function T(M){return M.scheme===l.Schemas.vscodeRemote?M.authority:void 0}e.getRemoteAuthority=T;function b(M){if(!M)return;const I=M.indexOf("+");return I<0?M:M.substr(0,I)}e.getRemoteName=b}),define(be[26],Se([1,0,9,3,84]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=M;function I(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class O{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,r){if(typeof o=="undefined"||o===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof o=="string"||typeof r=="string"){let f=typeof o=="string"?o:o.value,p=typeof r=="string"?r:r.value;return l.equalsIgnoreCase(f,p)}return o._lower===r._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=O;function L(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function C(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function u(g,o){if(o){const r=`onResolveRemoteAuthority:${(0,b.getRemoteName)(o)}`;return g.activationEvents?.indexOf(r)!==-1}return!1}e.isResolverExtension=u,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[147],Se([1,0,9,141,26,21,2,14,58]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,l.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=O;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{constructor(i,c,t="undefined"){this.version=c,this.targetPlatform=t,this.id=i.id}static create(i){const c=i.manifest?i.manifest.version:i.version,t=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new C(i.identifier,c,t)}static parse(i){const c=L.exec(i);return c&&c[1]&&c[2]?new C({id:c[1]},c[2],c[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof C?O(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=C;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const i=u.exec(s);return i&&i[1]?[r(i[1]),i[2]]:[r(s),void 0]}e.getIdAndVersion=g;function o(s,i){return`${s}.${i}`}e.getExtensionId=o;function r(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function f(s,i){return r(o(s,i))}e.getGalleryExtensionId=f;function p(s,i){const c=[],t=n=>{for(const m of c)if(m.some(d=>O(i(d),i(n))))return m;return null};for(const n of s){const m=t(n);m?m.push(n):c.push([n])}return c}e.groupByExtension=p;function D(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function h(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function _(s){const i=new Set;if(s.malicious)for(const c of s.malicious)i.add(c.id);return i}e.getMaliciousExtensionsSet=_;function E(s,i){const c=[],t=i.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const n=t.shift();if(n&&c.every(m=>!O(m.identifier,{id:n}))){const m=s.filter(d=>O(d.identifier,{id:n}));m.length===1&&(c.push(m[0]),t.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=E;async function a(s,i){if(!M.isLinux)return!1;let c;try{c=(await s.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await s.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function k(s,i){const c=await a(s,i),t=(0,T.getTargetPlatform)(c?"alpine":M.platform,y.arch);return i.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=k}),define(be[148],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,M,I=5){let A;return A=M(y=>{const O=typeof y=="string"?y:y.data;let L=this._terminalBufferMap.get(b);if(L){L.data.push(O);return}const C=setTimeout(()=>this.flushBuffer(b),I);L={data:[O],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(b),A.dispose()}},this._terminalBufferMap.set(b,L)}),A}stopBuffering(b){const M=this._terminalBufferMap.get(b);M&&M.dispose()}flushBuffer(b){const M=this._terminalBufferMap.get(b);M&&(this._terminalBufferMap.delete(b),this._callback(b,M.data.join("")))}}e.TerminalDataBufferer=l}),define(be[149],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var l;(function(b){b.DARK="dark",b.LIGHT="light",b.HIGH_CONTRAST_DARK="hcDark",b.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function T(b){return b===l.HIGH_CONTRAST_DARK||b===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=T}),define(be[59],Se([1,0,107,5,7,3,37,149]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var y;(function(f){function p(D){return D&&typeof D=="object"&&typeof D.id=="string"}f.isThemeColor=p})(y=e.ThemeColor||(e.ThemeColor={}));function O(f){return{id:f}}e.themeColorFromId=O;var L;(function(f){function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}f.isThemeIcon=p;const D=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const c=D.exec(i);if(!c)return;let[,t]=c;return{id:t}}f.fromString=h;function _(i){return{id:i}}f.fromId=_;function E(i,c){let t=i.id;const n=t.lastIndexOf("~");return n!==-1&&(t=t.substring(0,n)),c&&(t=`${t}~${c}`),{id:t}}f.modify=E;function a(i){const c=i.id.lastIndexOf("~");if(c!==-1)return i.id.substring(c+1)}f.getModifier=a;function k(i,c){return i.id===c.id&&i.color?.id===c.color?.id}f.isEqual=k;function s(i,c){return{id:i.id,color:c?O(c):void 0}}f.asThemeIcon=s,f.asClassNameArray=l.CSSIcon.asClassNameArray,f.asClassName=l.CSSIcon.asClassName,f.asCSSSelector=l.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function C(f){switch(f){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,b.toDisposable)(()=>{const D=this.themingParticipants.indexOf(p);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new u;I.Registry.add(e.Extensions.ThemingContribution,g);function o(f){return g.onColorThemeChange(f)}e.registerThemingParticipant=o;class r extends b.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,D){let h=this.theme.getColor(p);return h&&D&&(h=D(h,this.theme)),h?h.toString():null}}e.Themable=r}),define(be[150],Se([1,0,5,21,3,13]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var I;(function(o){o.Http="http",o.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function O(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=O,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=C;function u(o,r){return r?r!==1&&o<1024:!T.isWindows&&o<1024}e.isPortPrivileged=u;let g=class{constructor(r){this.logService=r,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(r){return this._tunnelProvider=r,r?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this._canElevate=r.elevation,this._privacyOptions=r.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const r=[],f=Array.from(this._tunnels.values());for(let p of f){const D=Array.from(p.values());for(let h of D){const _=await h.value;_&&r.push(_)}}return r}async dispose(){for(const r of this._tunnels.values()){for(const{value:f}of r.values())await f.then(p=>p?.dispose());r.clear()}this._tunnels.clear()}openTunnel(r,f,p,D,h=!1,_=A.Private,E){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${D}.`),!r)return;f||(f="localhost");const a=this.retainOrCreateTunnel(r,f,p,D,h,_,E);return a?a.then(k=>{if(!k){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(k);return(k.tunnelRemoteHost!==f||k.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const f=this._tunnels.get(r.tunnelRemoteHost);if(f){const p=f.get(r.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(r.tunnelRemoteHost,r.tunnelRemotePort,p))}}}}async tryDisposeTunnel(r,f,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${f}.`);const D=p.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(r)&&this._tunnels.get(r).delete(f),D}}async closeTunnel(r,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${f} `);const p=this._tunnels.get(r);if(p&&p.has(f)){const D=p.get(f);D.refcount=0,await this.tryDisposeTunnel(r,f,D)}}addTunnelToMap(r,f,p){this._tunnels.has(r)||this._tunnels.set(r,new Map),this._tunnels.get(r).set(f,{refcount:1,value:p})}async removeEmptyTunnelFromMap(r,f){const p=this._tunnels.get(r);p&&(await p.get(f)||p.delete(f),p.size===0&&this._tunnels.delete(r))}getTunnelFromMap(r,f){let p=[r];L(r)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):C(r)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const D=p.map(h=>this._tunnels.get(h));for(const h of D){const _=h?.get(f);if(_)return _}}canTunnel(r){return!!O(r)}createWithProvider(r,f,p,D,h,_,E){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${D}.`);const k={elevationRequired:h?u(D===void 0?p:D):!1},s={remoteAddress:{host:f,port:p},localAddressPort:D,privacy:_,public:_!==A.Private,protocol:E},i=r.forwardPort(s,k);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(f,p,i),i}};g=Ue([Be(0,M.ILogService)],g),e.AbstractTunnelService=g}),define(be[151],Se([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(y){return y.scheme!==l.Schemas.file&&y.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=T;function b(y){if(y.folders.length)return y.folders.every(O=>T(O.uri))?y.folders[0].uri:void 0;if(y.configuration&&T(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=b;function M(y){return b(y)?.scheme}e.getVirtualWorkspaceScheme=M;function I(y){return b(y)?.authority}e.getVirtualWorkspaceAuthority=I;function A(y){return b(y)!==void 0}e.isVirtualWorkspace=A}),define(be[46],Se([1,0,123,17,23,24,2,3,11]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function O(s){const i=s;return typeof i?.id=="string"&&I.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=O;function L(s){if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=L;function C(s){const i=s;return typeof i?.id=="string"&&I.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=C;function u(s){const i=s;if(i?.uri)return{id:i.id,uri:I.URI.revive(i.uri)};const c=s;if(c?.configPath)return{id:c.id,configPath:I.URI.revive(c.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=u;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function o(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=o;function r(s){const i=s;return!!(i&&typeof i=="object"&&I.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=r;class f{constructor(i,c,t,n,m){this._id=i,this._transient=t,this._configuration=n,this._ignorePathCasing=m,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(i,c){this.raw=c,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function D(s){return new p({uri:s,index:0,name:(0,M.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=D,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(s,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}e.isUntitledWorkspace=_;function E(s){let i;return I.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=E;function a(s,i){return!_(s,i)&&!E(s)}e.isSavedWorkspace=a;function k(s){return(typeof s=="string"?(0,T.extname)(s):(0,M.extname)(s))===h}e.hasWorkspaceFileExtension=k}),define(be[60],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const M=this._idPool++;return this._data.set(M,b),this.logDebugInfo(),M}get(b,M){return this._data.has(b)?this._data.get(b)[M]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(be[30],Se([1,0,11,24,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new T.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(be[28],Se([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(be[152],Se([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(I,A,y){this._deferredPromises=new Map,this._id=I,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(O=>(this._value=O,this)),this._storageListener=this._storage.onDidChangeStorage(O=>{O.shared===this._shared&&O.key===this._id&&(this._value=O.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const O=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of O.values())L.complete()}catch(L){for(const C of O.values())C.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,A){let y=this._value[I];return typeof y=="undefined"&&(y=A),y}update(I,A){this._value[I]=A;let y=this._deferredPromises.get(I);if(y!==void 0)return y.p;const O=new l.DeferredPromise;return this._deferredPromises.set(I,O),this._scheduler.isScheduled()||this._scheduler.schedule(),O.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class b extends T{constructor(I,A){super(I.identifier.value,!0,A);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=b}),define(be[153],Se([1,0,5,2,13]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let M=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new l.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,y,O,L){const u=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(y.value,O,L);this._onDidChangeNotebookDocument.fire(u)}$acceptDirtyStateChanged(A,y){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A)).acceptDirty(y)}$acceptModelSaved(A){const y=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,y);const O=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(A));O.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:O.apiNotebook})}};M=Ue([Be(0,b.ILogService)],M),e.ExtHostNotebookDocuments=M}),define(be[15],Se([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=T});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[154],Se([1,0,26,5]),function(J,e,l,T){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,y){b.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(A.identifier),Ge(this,b,y,"f"),Te(this,b,"f").onDidChangePassword(O=>{O.extensionId===this._id&&this._onDidChange.fire({key:O.key})})}get(A){return Te(this,b,"f").get(this._id,A)}store(A,y){return Te(this,b,"f").store(this._id,A,y)}delete(A){return Te(this,b,"f").delete(this._id,A)}}e.ExtensionSecrets=M,b=new WeakMap}),define(be[85],Se([1,0,3,5]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new T.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(I,A){this._level=I,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(I){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=I,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(be[47],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var l;(function(D){D[D.Upsert=0]="Upsert",D[D.RemoveChild=1]="RemoveChild",D[D.Invalidated=2]="Invalidated",D[D.SetProp=3]="SetProp",D[D.Bulk=4]="Bulk"})(l=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const T=new WeakMap,b=(D,h)=>{const _={controllerId:h};return T.set(D,_),_};e.createPrivateApiFor=b;const M=D=>T.get(D);e.getPrivateApiFor=M;const I=(D,h,_,E)=>{let a=_;return{enumerable:!0,configurable:!1,get(){return a},set(k){if(!E(a,k)){const s=a;a=k,D.listener?.({op:3,key:h,value:k,previous:s})}}}},A=(D,h)=>D===h,y={range:(D,h)=>D===h?!0:!D||!h?!1:D.isEqual(h),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(D,h)=>!(D.length!==h.length||D.some(_=>!h.find(E=>_.id===E.id)))},O=Object.keys(y),L=(D,h)=>({range:I(D,"range",void 0,y.range),label:I(D,"label",h,y.label),description:I(D,"description",void 0,y.description),sortText:I(D,"sortText",void 0,y.sortText),canResolveChildren:I(D,"canResolveChildren",!1,y.canResolveChildren),busy:I(D,"busy",!1,y.busy),error:I(D,"error",void 0,y.error),tags:I(D,"tags",[],y.tags)}),C=(D,h)=>{const _=new Map;for(const E of O)y[E](D[E],h[E])||_.set(E,h[E]);return _};e.diffTestItems=C;class u extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=u;class g extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class o extends Error{constructor(h,_,E){super(`TestItem with ID "${h}" is from controller "${_}" and cannot be added as a child of an item from controller "${E}".`)}}e.MixedTestItemController=o;const r=D=>{const h=(0,e.getPrivateApiFor)(D);let _=new Map;return{get size(){return _.size},forEach(E,a){for(const k of _.values())E.call(a,k,this)},replace(E){const a=new Map,k=new Set(_.keys()),s={op:4,ops:[]};for(const i of E){if(!(i instanceof f))throw new g(i.id);const c=(0,e.getPrivateApiFor)(i).controllerId;if(c!==h.controllerId)throw new o(i.id,c,h.controllerId);if(a.has(i.id))throw new u(i.id);a.set(i.id,i),k.delete(i.id),s.ops.push({op:0,item:i})}for(const i of k.keys())s.ops.push({op:1,id:i});h.listener?.(s),_=a},add(E){if(!(E instanceof f))throw new g(E.id);_.set(E.id,E),h.listener?.({op:0,item:E})},delete(E){_.delete(E)&&h.listener?.({op:1,id:E})},get(E){return _.get(E)},toJSON(){return Array.from(_.values())},[Symbol.iterator](){return _.values()}}};class f{constructor(h,_,E,a){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const k=(0,e.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return k.parent instanceof p?void 0:k.parent}},children:{value:r(this),enumerable:!0,writable:!1},...L(k,E)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=f;class p extends f{constructor(h,_){super(h,h,_,void 0)}}e.TestItemRootImpl=p}),define(be[61],Se([1,0,3,150,5,15]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function O(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public,privacy:C.privacy??(C.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:C.protocol}}y.fromApiTunnel=O;function L(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.privacy!==T.TunnelPrivacyId.ConstantPrivate&&C.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:C.privacy,protocol:C.protocol}}y.fromServiceTunnel=L})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let A=class{constructor(O){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(O){return O}async openTunnel(O,L){}async getTunnels(){return[]}async setTunnelFactory(O){return{dispose:()=>{}}}registerPortsAttributesProvider(O,L){return{dispose:()=>{}}}async $providePortAttributes(O,L,C,u,g){return[]}async $forwardPort(O,L){}async $closeTunnel(O){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ue([Be(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[6],Se([1,0,16,14,75,23,74,9,10,2,36,45,83]),function(J,e,l,T,b,M,I,A,y,O,L,C,u){"use strict";var g,o,r,f,p,D,h,_,E,a,k,s,i,c,t,n,m,d,S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B($){function N(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(N,$),Object.setPrototypeOf(N.prototype,$.prototype),N}let F=p=class{constructor(N){g.set(this,void 0),Ge(this,g,N,"f")}static from(...N){let te=N;return new p(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Te(this,g,"f")=="function"&&(Te(this,g,"f").call(this),Ge(this,g,void 0,"f"))}};g=new WeakMap,F=p=Ue([B],F),e.Disposable=F;let v=D=class{constructor(N,te){if(N<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=N,this._character=te}static Min(...N){if(N.length===0)throw new TypeError;let te=N[0];for(let _e=1;_e<N.length;_e++){const ze=N[_e];ze.isBefore(te)&&(te=ze)}return te}static Max(...N){if(N.length===0)throw new TypeError;let te=N[0];for(let _e=1;_e<N.length;_e++){const ze=N[_e];ze.isAfter(te)&&(te=ze)}return te}static isPosition(N){if(!N)return!1;if(N instanceof D)return!0;let{line:te,character:_e}=N;return typeof te=="number"&&typeof _e=="number"}static of(N){if(N instanceof D)return N;if(this.isPosition(N))return new D(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,te=0){if(N===null||te===null)throw(0,T.illegalArgument)();let _e;return typeof N=="undefined"?_e=0:typeof N=="number"?_e=N:(_e=typeof N.lineDelta=="number"?N.lineDelta:0,te=typeof N.characterDelta=="number"?N.characterDelta:0),_e===0&&te===0?this:new D(this.line+_e,this.character+te)}with(N,te=this.character){if(N===null||te===null)throw(0,T.illegalArgument)();let _e;return typeof N=="undefined"?_e=this.line:typeof N=="number"?_e=N:(_e=typeof N.line=="number"?N.line:this.line,te=typeof N.character=="number"?N.character:this.character),_e===this.line&&te===this.character?this:new D(_e,te)}toJSON(){return{line:this.line,character:this.character}}};v=D=Ue([B],v),e.Position=v;let x=h=class{constructor(N,te,_e,ze){let Qe,et;if(typeof N=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof ze=="number"?(Qe=new v(N,te),et=new v(_e,ze)):v.isPosition(N)&&v.isPosition(te)&&(Qe=v.of(N),et=v.of(te)),!Qe||!et)throw new Error("Invalid arguments");Qe.isBefore(et)?(this._start=Qe,this._end=et):(this._start=et,this._end=Qe)}static isRange(N){return N instanceof h?!0:N?v.isPosition(N.start)&&v.isPosition(N.end):!1}static of(N){if(N instanceof h)return N;if(this.isRange(N))return new h(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return h.isRange(N)?this.contains(N.start)&&this.contains(N.end):v.isPosition(N)?!(v.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const te=v.Max(N.start,this._start),_e=v.Min(N.end,this._end);if(!te.isAfter(_e))return new h(te,_e)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const te=v.Min(N.start,this._start),_e=v.Max(N.end,this.end);return new h(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,te=this.end){if(N===null||te===null)throw(0,T.illegalArgument)();let _e;return N?v.isPosition(N)?_e=N:(_e=N.start||this.start,te=N.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new h(_e,te)}toJSON(){return[this.start,this.end]}};x=h=Ue([B],x),e.Range=x;let W=_=class extends x{constructor(N,te,_e,ze){let Qe,et;if(typeof N=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof ze=="number"?(Qe=new v(N,te),et=new v(_e,ze)):v.isPosition(N)&&v.isPosition(te)&&(Qe=v.of(N),et=v.of(te)),!Qe||!et)throw new Error("Invalid arguments");super(Qe,et);this._anchor=Qe,this._active=et}static isSelection(N){return N instanceof _?!0:N?x.isRange(N)&&v.isPosition(N.anchor)&&v.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=_=Ue([B],W),e.Selection=W;class V{constructor(N,te,_e){if(typeof N!="string"||N.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,T.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=V;class re extends Error{constructor(N,te=u.RemoteAuthorityResolverErrorCode.Unknown,_e){super(N);this._message=N,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,re.prototype)}static NotAvailable(N,te){return new re(N,u.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(N){return new re(N,u.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=re;var H;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var R;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(R=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let se=E=class{constructor(N,te){this._range=N,this._newText=te}static isTextEdit(N){return N instanceof E?!0:N?x.isRange(N)&&typeof N.newText=="string":!1}static replace(N,te){return new E(N,te)}static insert(N,te){return E.replace(new x(N,N),te)}static delete(N){return E.replace(N,"")}static setEndOfLine(N){const te=new E(new x(new v(0,0),new v(0,0)),"");return te.newEol=N,te}get range(){return this._range}set range(N){if(N&&!x.isRange(N))throw(0,T.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,T.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,T.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};se=E=Ue([B],se),e.TextEdit=se;var de;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace"})(de=e.FileEditType||(e.FileEditType={}));let X=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,te,_e,ze){this._edits.push({_type:1,from:N,to:te,options:_e,metadata:ze})}createFile(N,te,_e){this._edits.push({_type:1,from:void 0,to:N,options:te,metadata:_e})}deleteFile(N,te,_e){this._edits.push({_type:1,from:N,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(N,te,_e){this._edits.push({_type:3,metadata:_e,uri:N,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(N,te,_e,ze,Qe){let et,tt,Dt=[],Rt;if(lt.isNotebookRange(te)&&Vt.isNotebookCellDataArray(_e)&&!Vt.isNotebookCellDataArray(ze)?(et=te.start,tt=te.end,Dt=_e,Rt=ze):typeof te=="number"&&typeof _e=="number"&&Vt.isNotebookCellDataArray(ze)&&(et=te,tt=_e,Dt=ze,Rt=Qe),et===void 0||tt===void 0)throw new Error("Invalid arguments");(et!==tt||Dt.length>0)&&this._edits.push({_type:5,uri:N,index:et,count:tt-et,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(N,te,_e,ze){this._edits.push({_type:3,metadata:ze,uri:N,edit:{editType:8,index:te,metadata:_e}})}replace(N,te,_e,ze){this._edits.push({_type:2,uri:N,edit:new se(te,_e),metadata:ze})}insert(N,te,_e,ze){this.replace(N,new x(te,te),_e,ze)}delete(N,te,_e){this.replace(N,te,"",_e)}has(N){return this._edits.some(te=>te._type===2&&te.uri.toString()===N.toString())}set(N,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:N,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const ze=this._edits[_e];ze._type===2&&ze.uri.toString()===N.toString()&&(this._edits[_e]=void 0)}(0,l.coalesceInPlace)(this._edits)}}get(N){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===N.toString()&&te.push(_e.edit);return te}entries(){const N=new M.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=N.get(te.uri);_e||(_e=[te.uri,[]],N.set(te.uri,_e)),_e[1].push(te.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};X=Ue([B],X),e.WorkspaceEdit=X;let ie=a=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof a?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=a._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,te=this._tabstop++){if(typeof N=="function"){const _e=new a;_e._tabstop=this._tabstop,N(_e),this._tabstop=_e._tabstop,N=_e.value}else N=a._escape(N);return this.value+="${",this.value+=te,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,te=this._tabstop++){const _e=N.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(N,te){if(typeof te=="function"){const _e=new a;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ie=a=Ue([B],ie),e.SnippetString=ie;var he;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(he=e.DiagnosticTag||(e.DiagnosticTag={}));var me;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(me=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=k=class{constructor(N,te){if(this.uri=N,te)if(x.isRange(te))this.range=x.of(te);else if(v.isPosition(te))this.range=new x(te,te);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof k?!0:N?x.isRange(N.range)&&O.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=k=Ue([B],fe),e.Location=fe;let ae=class{constructor(N,te){this.location=N,this.message=te}static is(N){return N?typeof N.message=="string"&&N.location&&x.isRange(N.location.range)&&O.URI.isUri(N.location.uri):!1}static isEqual(N,te){return N===te?!0:!N||!te?!1:N.message===te.message&&N.location.range.isEqual(te.location.range)&&N.location.uri.toString()===te.location.uri.toString()}};ae=Ue([B],ae),e.DiagnosticRelatedInformation=ae;let pe=class{constructor(N,te,_e=me.Error){if(!x.isRange(N))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=N,this.message=te,this.severity=_e}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,te){return N===te?!0:!N||!te?!1:N.message===te.message&&N.severity===te.severity&&N.code===te.code&&N.severity===te.severity&&N.source===te.source&&N.range.isEqual(te.range)&&(0,l.equals)(N.tags,te.tags)&&(0,l.equals)(N.relatedInformation,te.relatedInformation,ae.isEqual)}};pe=Ue([B],pe),e.Diagnostic=pe;let Ae=class{constructor(N,te){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=te}};Ae=Ue([B],Ae),e.Hover=Ae;var Fe;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let He=class{constructor(N,te=Fe.Text){this.range=N,this.kind=te}toJSON(){return{range:this.range,kind:Fe[this.kind]}}};He=Ue([B],He),e.DocumentHighlight=He;var Ye;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Ye=e.SymbolKind||(e.SymbolKind={}));var Ce;(function($){$[$.Deprecated=1]="Deprecated"})(Ce=e.SymbolTag||(e.SymbolTag={}));let Ee=s=class{constructor(N,te,_e,ze,Qe){this.name=N,this.kind=te,this.containerName=Qe,typeof _e=="string"&&(this.containerName=_e),ze instanceof fe?this.location=ze:_e instanceof x&&(this.location=new fe(ze,_e)),s.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ye[this.kind],location:this.location,containerName:this.containerName}}};Ee=s=Ue([B],Ee),e.SymbolInformation=Ee;let De=i=class{constructor(N,te,_e,ze,Qe){this.name=N,this.detail=te,this.kind=_e,this.range=ze,this.selectionRange=Qe,this.children=[],i.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(i.validate)}};De=i=Ue([B],De),e.DocumentSymbol=De;var ne;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(N,te){this.title=N,this.kind=te}};q=Ue([B],q),e.CodeAction=q;let Q=c=class{constructor(N){this.value=N}append(N){return new c(this.value?this.value+c.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+c.sep)}};Q.sep=".",Q=c=Ue([B],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let w=class{constructor(N,te){if(this.range=N,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};w=Ue([B],w),e.SelectionRange=w;class U{constructor(N,te,_e,ze,Qe,et){this.kind=N,this.name=te,this.detail=_e,this.uri=ze,this.range=Qe,this.selectionRange=et}}e.CallHierarchyItem=U;class z{constructor(N,te){this.fromRanges=te,this.from=N}}e.CallHierarchyIncomingCall=z;class j{constructor(N,te){this.fromRanges=te,this.to=N}}e.CallHierarchyOutgoingCall=j;var ee;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(ee=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ce=class{constructor(N,te){this.range=N,this.command=te}get isResolved(){return!!this.command}};ce=Ue([B],ce),e.CodeLens=ce;let ve=t=class{constructor(N,te=!1){o.set(this,void 0),Ge(this,o,new b.MarkdownString(N,{supportThemeIcons:te}),"f")}static isMarkdownString(N){return N instanceof t?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Te(this,o,"f").value}set value(N){Te(this,o,"f").value=N}get isTrusted(){return Te(this,o,"f").isTrusted}set isTrusted(N){Te(this,o,"f").isTrusted=N}get supportThemeIcons(){return Te(this,o,"f").supportThemeIcons}set supportThemeIcons(N){Te(this,o,"f").supportThemeIcons=N}get supportHtml(){return Te(this,o,"f").supportHtml}set supportHtml(N){Te(this,o,"f").supportHtml=N}get baseUri(){return Te(this,o,"f").baseUri}set baseUri(N){Te(this,o,"f").baseUri=N}appendText(N){return Te(this,o,"f").appendText(N),this}appendMarkdown(N){return Te(this,o,"f").appendMarkdown(N),this}appendCodeblock(N,te){return Te(this,o,"f").appendCodeblock(te??"",N),this}};o=new WeakMap,ve=t=Ue([B],ve),e.MarkdownString=ve;let Oe=class{constructor(N,te){this.label=N,this.documentation=te}};Oe=Ue([B],Oe),e.ParameterInformation=Oe;let Le=class{constructor(N,te){this.label=N,this.documentation=te,this.parameters=[]}};Le=Ue([B],Le),e.SignatureInformation=Le;let Ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ne=Ue([B],Ne),e.SignatureHelp=Ne;var Ve;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(Ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Je;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(Je=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor(N){this.value=N}};ke=Ue([B],ke),e.InlayHintLabelPart=ke;let je=class{constructor(N,te,_e){this.position=N,this.label=te,this.kind=_e}};je=Ue([B],je),e.InlayHint=je;var G;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function($){$[$.Deprecated=1]="Deprecated"})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));let Me=class{constructor(N,te){this.label=N,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Me=Ue([B],Me),e.CompletionItem=Me;let We=class{constructor(N=[],te=!1){this.items=N,this.isIncomplete=te}};We=Ue([B],We),e.CompletionList=We;let Xe=class{constructor(N,te,_e){this.insertText=N,this.range=te,this.command=_e}};Xe=Ue([B],Xe),e.InlineSuggestion=Xe;let Ze=class{constructor(N){this.items=N}};Ze=Ue([B],Ze),e.InlineSuggestions=Ze;let ot=class{constructor(N,te,_e){this.insertText=N,this.range=te,this.command=_e}};ot=Ue([B],ot),e.InlineSuggestionNew=ot;let wt=class{constructor(N){this.items=N}};wt=Ue([B],wt),e.InlineSuggestionsNew=wt;var mt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(mt=e.ViewColumn||(e.ViewColumn={}));var kt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(kt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var qe;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(gt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var rt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function N(te){switch(te){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=N}(rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Pt=class{constructor(N,te){if(te&&!O.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!x.isRange(N)||N.isEmpty)throw(0,T.illegalArgument)("range");this.range=N,this.target=te}};Pt=Ue([B],Pt),e.DocumentLink=Pt;let _t=class{constructor(N,te,_e,ze){this.red=N,this.green=te,this.blue=_e,this.alpha=ze}};_t=Ue([B],_t),e.Color=_t;let ct=class{constructor(N,te){if(te&&!(te instanceof _t))throw(0,T.illegalArgument)("color");if(!x.isRange(N)||N.isEmpty)throw(0,T.illegalArgument)("range");this.range=N,this.color=te}};ct=Ue([B],ct),e.ColorInformation=ct;let At=class{constructor(N){if(!N||typeof N!="string")throw(0,T.illegalArgument)("label");this.label=N}};At=Ue([B],At),e.ColorPresentation=At;var Mt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(N,te,_e){if(this.startIndex=N,this.length=te,this.tooltip=_e,typeof N!="number"||N<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class we{constructor(N){this.options=N,typeof N!="object"&&(0,T.illegalArgument)("options")}}e.TerminalProfile=we;var le;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(le=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let ye=n=class{constructor(N,te){if(this.label=te,typeof N!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return n.Clean;case"build":return n.Build;case"rebuild":return n.Rebuild;case"test":return n.Test;default:return}}get id(){return this._id}};ye.Clean=new n("clean","Clean"),ye.Build=new n("build","Build"),ye.Rebuild=new n("rebuild","Rebuild"),ye.Test=new n("test","Test"),ye=n=Ue([B],ye),e.TaskGroup=ye;function Pe($){let N="";for(let te=0;te<$.length;te++)N+=$[te].replace(/,/g,",,")+",";return N}let $e=class{constructor(N,te,_e){if(typeof N!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=N,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,T.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let te of this._args)N.push(te);return Pe(N)}};$e=Ue([B],$e),e.ProcessExecution=$e;let Ke=class{constructor(N,te,_e){if(this._args=[],Array.isArray(te)){if(!N)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,T.illegalArgument)("command");this._command=N,this._args=te,this._options=_e}else{if(typeof N!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=N,this._options=te}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,T.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)N.push(typeof te=="string"?te:te.value);return Pe(N)}};Ke=Ue([B],Ke),e.ShellExecution=Ke;var dt;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class vt{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=vt;let nt=m=class{constructor(N,te,_e,ze,Qe,et){this.__deprecated=!1,this._definition=this.definition=N;let tt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=ze,tt=Qe,this.__deprecated=!0):te===pt.Global||te===pt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=ze,this.execution=Qe,tt=et):(this.target=te,this._name=this.name=_e,this._source=this.source=ze,this.execution=Qe,tt=et),typeof tt=="string"?(this._problemMatchers=[tt],this._hasDefinedMatchers=!0):Array.isArray(tt)?(this._problemMatchers=tt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof $e?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ke?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=m=Ue([B],nt),e.Task=nt;var ut;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(N,te=Lt.None){this.collapsibleState=te,O.URI.isUri(N)?this.resourceUri=N:this.label=N}};at=Ue([B],at),e.TreeItem=at;var Lt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(Lt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Et=class{constructor(N){this.value=N}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};Et=Ue([B],Et),e.DataTransferItem=Et;let It=class{constructor(){this._items=new Map}get(N){return this._items.get(N)}set(N,te){this._items.set(N,te)}forEach(N){this._items.forEach(N)}};It=Ue([B],It),e.DataTransfer=It;let yt=class{constructor(N,te){this.id=N,this.color=te}};yt=Ue([B],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let St=class{constructor(N){this.id=N}};St=Ue([B],St),e.ThemeColor=St;var Jt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Wt=class{constructor(N,te){if(typeof N!="string"&&(!N||!O.URI.isUri(N)&&!O.URI.isUri(N.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof N=="string"?this.baseUri=O.URI.file(N):O.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=te}get base(){return this._base}set base(N){this._base=N,this._baseUri=O.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Wt=Ue([B],Wt),e.RelativePattern=Wt;let ht=class{constructor(N,te,_e,ze){this.enabled=typeof N=="boolean"?N:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};ht=Ue([B],ht),e.Breakpoint=ht;let Kt=class extends ht{constructor(N,te,_e,ze,Qe){super(te,_e,ze,Qe);if(N===null)throw(0,T.illegalArgument)("location");this.location=N}};Kt=Ue([B],Kt),e.SourceBreakpoint=Kt;let Xt=class extends ht{constructor(N,te,_e,ze,Qe){super(te,_e,ze,Qe);this.functionName=N}};Xt=Ue([B],Xt),e.FunctionBreakpoint=Xt;let Zt=class extends ht{constructor(N,te,_e,ze,Qe,et,tt){super(ze,Qe,et,tt);if(!te)throw(0,T.illegalArgument)("dataId");this.label=N,this.dataId=te,this.canPersist=_e}};Zt=Ue([B],Zt),e.DataBreakpoint=Zt;let li=class{constructor(N,te,_e){this.command=N,this.args=te||[],this.options=_e}};li=Ue([B],li),e.DebugAdapterExecutable=li;let Tt=class{constructor(N,te){this.port=N,this.host=te}};Tt=Ue([B],Tt),e.DebugAdapterServer=Tt;let ei=class{constructor(N){this.path=N}};ei=Ue([B],ei),e.DebugAdapterNamedPipeServer=ei;let ci=class{constructor(N){this.implementation=N}};ci=Ue([B],ci),e.DebugAdapterInlineImplementation=ci;let Gt=class{constructor(N,te){this.range=N,this.expression=te}};Gt=Ue([B],Gt),e.EvaluatableExpression=Gt;var ti;(function($){$[$.Automatic=0]="Automatic",$[$.Explicit=1]="Explicit"})(ti=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var st;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(st=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let ui=class{constructor(N,te){this.range=N,this.text=te}};ui=Ue([B],ui),e.InlineValueText=ui;let Bt=class{constructor(N,te,_e=!0){this.range=N,this.variableName=te,this.caseSensitiveLookup=_e}};Bt=Ue([B],Bt),e.InlineValueVariableLookup=Bt;let zt=class{constructor(N,te){this.range=N,this.expression=te}};zt=Ue([B],zt),e.InlineValueEvaluatableExpression=zt;let ii=class{constructor(N,te){this.frameId=N,this.stoppedLocation=te}};ii=Ue([B],ii),e.InlineValueContext=ii;var Ci;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ci=e.FileChangeType||(e.FileChangeType={}));let ni=d=class extends Error{constructor(N,te=C.FileSystemProviderErrorCode.Unknown,_e){super(O.URI.isUri(N)?N.toString(!0):N);this.code=_e?.name??"Unknown",(0,C.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(N){return new d(N,C.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(N){return new d(N,C.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(N){return new d(N,C.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(N){return new d(N,C.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(N){return new d(N,C.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(N){return new d(N,C.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};ni=d=Ue([B],ni),e.FileSystemError=ni;let di=class{constructor(N,te,_e){this.start=N,this.end=te,this.kind=_e}};di=Ue([B],di),e.FoldingRange=di;var bi;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ri;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(ri=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ii;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Ii=e.CommentMode||(e.CommentMode={}));var hi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(hi=e.CommentThreadState||(e.CommentThreadState={}));class fi{constructor(N,te=[]){this.tokenTypes=N,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function Ti($){return typeof $=="undefined"||(0,y.isStringArray)($)}class mi{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let te=0,_e=N.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(N.tokenTypes[te],te);for(let te=0,_e=N.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(N.tokenModifiers[te],te)}}push(N,te,_e,ze,Qe){if(typeof N=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof ze=="number"&&(typeof Qe=="number"||typeof Qe=="undefined"))return typeof Qe=="undefined"&&(Qe=0),this._pushEncoded(N,te,_e,ze,Qe);if(x.isRange(N)&&typeof te=="string"&&Ti(_e))return this._push(N,te,_e);throw(0,T.illegalArgument)()}_push(N,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const ze=N.start.line,Qe=N.start.character,et=N.end.character-N.start.character,tt=this._tokenTypeStrToInt.get(te);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<xt>>>0}this._pushEncoded(ze,Qe,et,tt,Dt)}_pushEncoded(N,te,_e,ze,Qe){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,xt=0;for(let $t=0;$t<Dt;$t++){let jt=this._data[5*$t],vi=this._data[5*$t+1];jt===0?(jt=Rt,vi+=xt):jt+=Rt,this._data[5*$t]=jt,this._data[5*$t+1]=vi,Rt=jt,xt=vi}}let et=N,tt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(et-=this._prevLine,et===0&&(tt-=this._prevChar)),this._data[this._dataLen++]=et,this._data[this._dataLen++]=tt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Qe,this._prevLine=N,this._prevChar=te}static _sortAndDeltaEncode(N){let te=[];const _e=N.length/5|0;for(let tt=0;tt<_e;tt++)te[tt]=tt;te.sort((tt,Dt)=>{const Rt=N[5*tt],xt=N[5*Dt];if(Rt===xt){const $t=N[5*tt+1],jt=N[5*Dt+1];return $t-jt}return Rt-xt});const ze=new Uint32Array(N.length);let Qe=0,et=0;for(let tt=0;tt<_e;tt++){const Dt=5*te[tt],Rt=N[Dt+0],xt=N[Dt+1],$t=N[Dt+2],jt=N[Dt+3],vi=N[Dt+4],Ki=Rt-Qe,un=Ki===0?xt-et:xt,Ei=5*tt;ze[Ei+0]=Ki,ze[Ei+1]=un,ze[Ei+2]=$t,ze[Ei+3]=jt,ze[Ei+4]=vi,Qe=Rt,et=xt}return ze}build(N){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),N):new Ht(mi._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=mi;class Ht{constructor(N,te){this.resultId=te,this.data=N}}e.SemanticTokens=Ht;class ki{constructor(N,te,_e){this.start=N,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=ki;class Pi{constructor(N,te){this.resultId=te,this.edits=N}}e.SemanticTokensEdits=Pi;var Ai;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Ai=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new yt("arrow-left")},si=Ue([B],si),e.QuickInputButtons=si;var gi;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(gi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var wi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(wi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var _i;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(_i=e.ExtensionKind||(e.ExtensionKind={}));class Re{constructor(N,te,_e){this.badge=N,this.tooltip=te,this.color=_e}static validate(N){if(N.badge){let te=(0,A.nextCharLength)(N.badge,0);if(te<N.badge.length&&(te+=(0,A.nextCharLength)(N.badge,te)),N.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Re;let Qt=class{constructor(N){this.kind=N}};Qt=Ue([B],Qt),e.ColorTheme=Qt;var Si;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Si=e.ColorThemeKind||(e.ColorThemeKind={}));class lt{constructor(N,te){if(N<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");N<=te?(this._start=N,this._end=te):(this._start=te,this._end=N)}static isNotebookRange(N){return N instanceof lt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let te=this._start,_e=this._end;return N.start!==void 0&&(te=N.start),N.end!==void 0&&(_e=N.end),te===this._start&&_e===this._end?this:new lt(te,_e)}}e.NotebookRange=lt;class Vt{constructor(N,te,_e,ze,Qe,et,tt){this.kind=N,this.value=te,this.languageId=_e,this.mime=ze,this.outputs=Qe??[],this.metadata=et,this.executionSummary=tt,Vt.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(te=>Vt.isNotebookCellData(te))}static isNotebookCellData(N){return!0}}e.NotebookCellData=Vt;class Ri{constructor(N){this.cells=N}}e.NotebookData=Ri;class Ot{constructor(N,te){this.data=N,this.mime=te;const _e=(0,I.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(N){return N instanceof Ot?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const te={name:N.name,message:N.message,stack:N.stack};return Ot.json(te,"application/vnd.code.notebook.error")}static stdout(N){return Ot.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Ot.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,te="application/octet-stream"){return new Ot(N,te)}static text(N,te=I.Mimes.text){const _e=Te(Ot,r,"f",f).encode(String(N));return new Ot(_e,te)}static json(N,te="text/x-json"){const _e=JSON.stringify(N,void 0,"	");return Ot.text(_e,te)}}e.NotebookCellOutputItem=Ot,r=Ot,f={value:new TextEncoder};class Yt{constructor(N,te,_e){this.items=Yt.ensureUniqueMimeTypes(N,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,L.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(N){return N instanceof Yt?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&(0,y.isArray)(N.items)}static ensureUniqueMimeTypes(N,te=!1){const _e=new Set,ze=new Set;for(let Qe=0;Qe<N.length;Qe++){const et=N[Qe],tt=(0,I.normalizeMimeType)(et.mime);if(!_e.has(tt)){_e.add(tt);continue}ze.add(Qe),te&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return ze.size===0?N:N.filter((Qe,et)=>!ze.has(et))}}e.NotebookCellOutput=Yt;var Oi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(Oi=e.NotebookCellKind||(e.NotebookCellKind={}));var Fi;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Fi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ni;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ni=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Mi;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Di{constructor(N,te){this.text=N,this.alignment=te}}e.NotebookCellStatusBarItem=Di;var Li;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Li=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ui{constructor(N,te=[]){this.uri=N,this.provides=(0,l.asArray)(te)}}e.NotebookRendererScript=Ui;let pi=class{constructor(N,te){this.label=N,this.timestamp=te}};pi=Ue([B],pi),e.TimelineItem=pi;var Bi;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(Bi=e.ExtensionMode||(e.ExtensionMode={}));var xi;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(xi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Z;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(Z=e.StandardTokenType||(e.StandardTokenType={}));class oe{constructor(N,te){this.ranges=N,this.wordPattern=te}}e.LinkedEditingRanges=oe;class Ie{constructor(N,te){this._port=N,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ie;var it;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(it=e.TestResultState||(e.TestResultState={}));var bt;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(bt=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ct=class{constructor(N=void 0,te=void 0,_e=void 0){this.include=N,this.exclude=te,this.profile=_e}};Ct=Ue([B],Ct),e.TestRunRequest=Ct;let $i=S=class{constructor(N){this.message=N}static diff(N,te,_e){const ze=new S(N);return ze.expectedOutput=te,ze.actualOutput=_e,ze}};$i=S=Ue([B],$i),e.TestMessage=$i;let Wi=class{constructor(N){this.id=N}};Wi=Ue([B],Wi),e.TestTag=Wi;let oi=class{constructor(N,te){this.covered=N,this.total=te}};oi=Ue([B],oi),e.CoveredCount=oi;let zi=P=class{constructor(N,te,_e,ze){this.uri=N,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=ze}static fromDetails(N,te){const _e=new oi(0,0),ze=new oi(0,0),Qe=new oi(0,0);for(const tt of te)if("branches"in tt){_e.total+=1,_e.covered+=tt.executionCount>0?1:0;for(const Dt of tt.branches)ze.total+=1,ze.covered+=Dt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=tt.executionCount>0?1:0;const et=new P(N,_e,ze.total>0?ze:void 0,Qe.total>0?Qe:void 0);return et.detailedCoverage=te,et}};zi=P=Ue([B],zi),e.FileCoverage=zi;let Hi=class{constructor(N,te,_e=[]){this.executionCount=N,this.location=te,this.branches=_e}};Hi=Ue([B],Hi),e.StatementCoverage=Hi;let Vi=class{constructor(N,te){this.executionCount=N,this.location=te}};Vi=Ue([B],Vi),e.BranchCoverage=Vi;let ji=class{constructor(N,te){this.executionCount=N,this.location=te}};ji=Ue([B],ji),e.FunctionCoverage=ji;var Ji;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(Ji=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Zi;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(Zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var en;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(en=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class tn{constructor(N,te,_e,ze,Qe,et){this.kind=N,this.name=te,this.detail=_e,this.uri=ze,this.range=Qe,this.selectionRange=et}}e.TypeHierarchyItem=tn;class nn{constructor(N){this.uri=N}}e.TextTabInput=nn;class rn{constructor(N,te){this.original=N,this.modified=te}}e.TextDiffTabInput=rn;class sn{constructor(N,te){this.uri=N,this.viewType=te}}e.CustomEditorTabInput=sn;class on{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=on;class an{constructor(N,te){this.uri=N,this.notebookType=te}}e.NotebookEditorTabInput=an;class ln{constructor(N,te,_e){this.original=N,this.modified=te,this.notebookType=_e}}e.NotebookDiffEditorTabInput=ln;class cn{constructor(){}}e.TerminalEditorTabInput=cn}),define(be[86],Se([1,0,42,11,9,228,117,6,16]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const O=new Map;function L(o,r){r?O.set(o,r):O.delete(o)}e.setWordDefinitionFor=L;function C(o){return O.get(o)}e.getWordDefinitionFor=C;class u extends M.MirrorTextModel{constructor(r,f,p,D,h,_,E,a){super(f,p,D,h);this._proxy=r,this._languageId=_,this._isDirty=E,this._notebook=a,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(r){return(0,y.equals)(this._lines,r)}get document(){if(!this._document){const r=this;this._document={get uri(){return r._uri},get fileName(){return r._uri.fsPath},get isUntitled(){return r._uri.scheme===T.Schemas.untitled},get languageId(){return r._languageId},get version(){return r._versionId},get isClosed(){return r._isDisposed},get isDirty(){return r._isDirty},get notebook(){return r._notebook},save(){return r._save()},getText(f){return f?r._getTextInRange(f):r.getText()},get eol(){return r._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return r._lines.length},lineAt(f){return r._lineAt(f)},offsetAt(f){return r._offsetAt(f)},positionAt(f){return r._positionAt(f)},validateRange(f){return r._validateRange(f)},validatePosition(f){return r._validatePosition(f)},getWordRangeAtPosition(f,p){return r._getWordRangeAtPosition(f,p)}}}return Object.freeze(this._document)}_acceptLanguageId(r){(0,l.ok)(!this._isDisposed),this._languageId=r}_acceptIsDirty(r){(0,l.ok)(!this._isDisposed),this._isDirty=r}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(r){const f=this._validateRange(r);if(f.isEmpty)return"";if(f.isSingleLine)return this._lines[f.start.line].substring(f.start.character,f.end.character);const p=this._eol,D=f.start.line,h=f.end.line,_=[];_.push(this._lines[D].substring(f.start.character));for(let E=D+1;E<h;E++)_.push(this._lines[E]);return _.push(this._lines[h].substring(0,f.end.character)),_.join(p)}_lineAt(r){let f;if(r instanceof A.Position?f=r.line:typeof r=="number"&&(f=r),typeof f!="number"||f<0||f>=this._lines.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new g(f,this._lines[f],f===this._lines.length-1)}_offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.line-1)+r.character}_positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(r),p=this._lines[f.index].length;return new A.Position(f.index,Math.min(f.remainder,p))}_validateRange(r){if(!(r instanceof A.Range))throw new Error("Invalid argument");const f=this._validatePosition(r.start),p=this._validatePosition(r.end);return f===r.start&&p===r.end?r:new A.Range(f.line,f.character,p.line,p.character)}_validatePosition(r){if(!(r instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return r.with(0,0);let{line:f,character:p}=r,D=!1;if(f<0)f=0,p=0,D=!0;else if(f>=this._lines.length)f=this._lines.length-1,p=this._lines[f].length,D=!0;else{const h=this._lines[f].length;p<0?(p=0,D=!0):p>h&&(p=h,D=!0)}return D?new A.Position(f,p):r}_getWordRangeAtPosition(r,f){const p=this._validatePosition(r);if(!f)f=C(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const D=(0,I.getWordAtText)(p.character+1,(0,I.ensureValidWordDefinition)(f),this._lines[p.line],0);if(D)return new A.Range(p.line,D.startColumn-1,p.line,D.endColumn-1)}}e.ExtHostDocumentData=u;class g{constructor(r,f,p){this._line=r,this._text=f,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(be[155],Se([1,0,6,5,229,7,77,23,2,36]),function(J,e,l,T,b,M,I,A,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(u,g,o,r){this._notebook=o,this._selector=r,this._disposables=new M.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,O.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(p=>{const D=this._cellUris.get(p.document.uri);D!==void 0&&(this._cellLengths.setValue(D,this._cells[D].document.getText().length+1),this._cellLines.setValue(D,this._cells[D].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const f=p=>{p===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(p=>f(p.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const u=[],g=[];for(const o of this._notebook.getCells())o.kind===l.NotebookCellKind.Code&&(!this._selector||(0,I.score)(this._selector,o.document.uri,o.document.languageId,!0,void 0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),u.push(o.document.getText().length+1),g.push(o.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(u){if(!u){let D="";for(const h of this._cells)D+=h.document.getText()+`
`;return D=D.slice(0,-1),D}if(u.isEmpty)return"";const g=this.locationAt(u.start),o=this.locationAt(u.end),r=this._cellUris.get(g.uri),f=this._cellUris.get(o.uri);if(r===void 0||f===void 0)return"";if(r===f)return this._cells[r].document.getText(new l.Range(g.range.start,o.range.end));const p=[this._cells[r].document.getText(new l.Range(g.range.start,new l.Position(this._cells[r].document.lineCount,0)))];for(let D=r+1;D<f;D++)p.push(this._cells[D].document.getText());return p.push(this._cells[f].document.getText(new l.Range(new l.Position(0,0),o.range.end))),p.join(`
`)}offsetAt(u){const g=this._cellLines.getIndexOf(u.line),o=this._cellLengths.getPrefixSum(g.index-1),r=this._cells[g.index].document.offsetAt(u.with(g.remainder));return o+r}positionAt(u){if(typeof u=="number"){const o=this._cellLengths.getIndexOf(u),r=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(r)}const g=this._cellUris.get(u.uri);if(g!==void 0){const o=this._cellLines.getPrefixSum(g-1);return new l.Position(o+u.range.start.line,u.range.start.character)}return new l.Position(0,0)}locationAt(u){l.Range.isRange(u)||(u=new l.Range(u,u));const g=this._cellLines.getIndexOf(u.start.line);let o=g;u.isEmpty||(o=this._cellLines.getIndexOf(u.end.line));const r=new l.Position(g.remainder,u.start.character),f=new l.Position(o.remainder,u.end.character),p=new l.Range(r,f),D=this._cells[g.index];return new l.Location(D.document.uri,D.document.validateRange(p))}contains(u){return this._cellUris.has(u)}validateRange(u){const g=this.validatePosition(u.start),o=this.validatePosition(u.end);return u.with(g,o)}validatePosition(u){const g=this._cellLines.getIndexOf(u.line),o=new l.Position(g.remainder,u.character),r=this._cells[g.index].document.validatePosition(o),f=this._cellLines.getPrefixSum(g.index-1);return new l.Position(f+r.line,r.character)}}e.ExtHostNotebookConcatDocument=L}),define(be[156],Se([1,0,6,15,5]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=l.ColorThemeKind.Light;break;case"hcDark":y=l.ColorThemeKind.HighContrast;break;case"hcLight":y=l.ColorThemeKind.HighContrastLight;break;default:y=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=Ue([Be(0,T.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(be[62],Se([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=T}),define(be[157],Se([1,0,22]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(y){let O=this.buffers.indexOf(y);return O<0&&(O=this.buffers.length,this.buffers.push(y)),O}}function b(A,y){if(y.serializeBuffersForPostMessage){const O=new T,L=(g,o)=>{if(o instanceof ArrayBuffer){const r=O.add(o);return{$$vscode_array_buffer_reference$$:!0,index:r}}else if(ArrayBuffer.isView(o)){const r=M(o);if(r){const f=O.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:f,view:{type:r,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},C=JSON.stringify(A,L),u=O.buffers.map(g=>{const o=new Uint8Array(g);return l.VSBuffer.wrap(o)});return{message:C,buffers:u}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=b;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,y){const O=y.map(u=>{const g=new ArrayBuffer(u.byteLength);return new Uint8Array(g).set(u.buffer),g}),L=y.length?(u,g)=>{if(g&&typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const o=g,{index:r}=o,f=O[r];if(o.view)switch(o.view.type){case 1:return new Int8Array(f,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return g}:void 0;return{message:JSON.parse(A,L),arrayBuffers:O}}e.deserializeWebviewMessage=I}),define(be[87],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransferConverter=void 0;var l;(function(T){function b(I){const A=new Map;return I.types.forEach((y,O)=>{A.set(y,{asString:async()=>I.items[O].asString,value:void 0})}),A}T.toDataTransfer=b;async function M(I){const A={types:[],items:[]},y=Array.from(I.entries());for(const O of y)A.types.push(O[0]),A.items.push({asString:await O[1].asString()});return A}T.toDataTransferDTO=M})(l=e.DataTransferConverter||(e.DataTransferConverter={}))}),define(be[158],Se([1,0,131,10,2,7,3,37,45,16,11]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(C=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var u;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(u=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(H){const R=H;return!!R&&typeof R.getSelection=="function"&&!!R.onDidChangeSelection}e.isEditorPaneWithSelection=g;function o(H,R,se){for(const de of se.visibleEditorPanes)if(de.group.id===R&&H.matches(de.input))return de.getViewState()}e.findViewStateForEditor=o;function r(H){if(s(H))return!1;const R=H;return b.URI.isUri(R?.resource)}e.isResourceEditorInput=r;function f(H){if(s(H))return!1;const R=H;return R?.original!==void 0&&R.modified!==void 0}e.isResourceDiffEditorInput=f;function p(H){if(s(H)||f(H))return!1;const R=H;return R?.primary!==void 0&&R.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function D(H){if(s(H))return!1;const R=H;return R?R.resource===void 0||R.resource.scheme===L.Schemas.untitled||R.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;var h;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var _;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));class E{constructor(){this.mapIdToSaveSource=new Map}registerSource(R,se){let de=this.mapIdToSaveSource.get(R);return de||(de={source:R,label:se},this.mapIdToSaveSource.set(R,de)),de.source}getSourceLabel(R){return this.mapIdToSaveSource.get(R)?.label??R}}e.SaveSourceRegistry=new E;var a;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class k extends M.Disposable{}e.AbstractEditorInput=k;function s(H){return H instanceof k}e.isEditorInput=s;function i(H){const R=H;return b.URI.isUri(R?.preferredResource)}function c(H){const R=H;return s(R?.primary)&&s(R?.secondary)}e.isSideBySideEditorInput=c;function t(H){const R=H;return s(R?.modified)&&s(R?.original)}e.isDiffEditorInput=t;function n(H){return s(H?.editor)}e.isEditorInputWithOptions=n;function m(H){const R=H;return n(H)&&R?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function d(H){const R=H;return typeof R?.groupId=="number"&&s(R.editor)}e.isEditorIdentifier=d;var S;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(S=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(R,se){if(!R)return;if(se?.supportSideBySide){const{primary:X,secondary:ie}=this.getSideEditors(R);if(X&&ie){if(se?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getOriginalUri(X,{filterByScheme:se.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:se.filterByScheme});R=se.supportSideBySide===B.PRIMARY?X:ie}}if(f(R)||p(R))return;const de=i(R)?R.preferredResource:R.resource;return!de||!se||!se.filterByScheme?de:this.filterUri(de,se.filterByScheme)}getSideEditors(R){return c(R)||p(R)?{primary:R.primary,secondary:R.secondary}:t(R)||f(R)?{primary:R.modified,secondary:R.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(R,se){if(!R)return;if(se?.supportSideBySide){const{primary:X,secondary:ie}=this.getSideEditors(R);if(X&&ie){if(se?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getCanonicalUri(X,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme});R=se.supportSideBySide===B.PRIMARY?X:ie}}if(f(R)||p(R))return;const de=R.resource;return!de||!se||!se.filterByScheme?de:this.filterUri(de,se.filterByScheme)}filterUri(R,se){if(Array.isArray(se)){if(se.some(de=>R.scheme===de))return R}else if(se===R.scheme)return R}}e.EditorResourceAccessor=new F;var v;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class x{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(R){const se=this.instantiationService=R.get(I.IInstantiationService);for(const[de,X]of this.editorSerializerConstructors)this.createEditorSerializer(de,X,se);this.editorSerializerConstructors.clear()}createEditorSerializer(R,se,de){const X=de.createInstance(se);this.editorSerializerInstances.set(R,X)}registerFileEditorFactory(R){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=R}getFileEditorFactory(){return(0,T.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(R,se){if(this.editorSerializerConstructors.has(R)||this.editorSerializerInstances.has(R))throw new Error(`A editor serializer with type ID '${R}' was already registered.`);return this.instantiationService?this.createEditorSerializer(R,se,this.instantiationService):this.editorSerializerConstructors.set(R,se),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(R),this.editorSerializerInstances.delete(R)})}getEditorSerializer(R){return this.editorSerializerInstances.get(typeof R=="string"?R:R.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new x);async function W(H,R){if(!H||!H.length)return[];const se=await Promise.all(H.map(async de=>{const X=b.URI.revive(de.fileUri);if(!X||!await R.canHandleResource(X))return;let he=de.exists,me=de.type;if(typeof he!="boolean"||typeof me!="number")try{me=(await R.stat(X)).isDirectory?y.FileType.Directory:y.FileType.Unknown,he=!0}catch{he=!1}if(!he&&de.openOnlyIfExists||me===y.FileType.Directory)return;const fe={selection:he?de.selection:void 0,pinned:!0,override:de.editorOverrideId};let ae;return he?ae={resource:X,options:fe}:ae={resource:X,options:fe,forceUntitled:!0},ae}));return(0,O.coalesce)(se)}e.pathsToEditors=W;var V;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(V=e.EditorsOrder||(e.EditorsOrder={}));function re(H){const R=H;if(!R)return!1;const se=R;if(se.modified)return re(se.modified);const de=R;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=re}),define(be[63],Se([1,0,11,2]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(A,y){return A.scheme===l.Schemas.http||A.scheme===l.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===l.Schemas.file&&(A=T.URI.from({scheme:l.Schemas.vscodeRemote,authority:y.authority,path:A.path})),T.URI.from({scheme:l.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=b;function M(A){return A.replace(/./g,y=>{const O=y.charCodeAt(0);return O>=97&&O<=122||O>=65&&O<=90||O>=48&&O<=57?y:"-"+O.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(y,O)=>String.fromCharCode(parseInt(O,16)))}e.decodeAuthority=I}),define(be[159],Se([1,0,5,7,63]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,y,O){this._proxy=A,this._editors=y,this._remoteInfo=O,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const C of this._insets.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,O,L,C){let u;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===A){u=h;break}if(!u)throw new Error("not a visible editor");const g=this,o=this._handlePool++,r=new l.Emitter,f=new l.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,b.asWebviewUri)(h,g._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(h){this._options=h,g._proxy.$setOptions(o,h)}get options(){return this._options}set html(h){this._html=h,g._proxy.$setHtml(o,h)}get html(){return this._html}get onDidReceiveMessage(){return r.event}postMessage(h){return g._proxy.$postMessage(o,h)}},D=new class{constructor(){this.editor=A,this.line=y,this.height=O,this.webview=p,this.onDidDispose=f.event}dispose(){g._insets.has(o)&&(g._insets.delete(o),g._proxy.$disposeEditorInset(o),f.fire(),f.dispose(),r.dispose())}};return this._proxy.$createEditorInset(o,u.id,u.value.document.uri,y+1,O,L||{},C.identifier,C.extensionLocation),this._insets.set(o,{editor:A,inset:D,onDidReceiveMessage:r}),D}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){const O=this._insets.get(A);O&&O.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(be[160],Se([1,0,5,12,132]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,O,L){const C={command:A};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof L=="number"){const u=setTimeout(()=>{clearTimeout(u);const g=this.pendingRequests.get(C.seq);if(g){this.pendingRequests.delete(C.seq);const o={type:"response",seq:0,request_seq:C.seq,success:!1,command:A,message:(0,b.localize)(0,null,L,A)};g(o)}},L)}return O&&this.pendingRequests.set(C.seq,O),C.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,T.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":{const y=A,O=this.pendingRequests.get(y.request_seq);O&&(this.pendingRequests.delete(y.request_seq),O(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,O)=>A.set(O,y)),await(0,T.timeout)(500),A.forEach((y,O)=>{y({type:"response",seq:0,request_seq:O,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(O)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(be[161],Se([1,0,133,44,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new T.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(49,null)});const M=C=>l.localize(50,null,C);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(51,null)};var I;(function(C){C[C.Inactive=0]="Inactive",C[C.Initializing=1]="Initializing",C[C.Stopped=2]="Stopped",C[C.Running=3]="Running"})(I=e.State||(e.State={}));function A(C){switch(C){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(C){C[C.Valid=0]="Valid",C[C.Unreadable=1]="Unreadable",C[C.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var O;(function(C){C[C.Initial=1]="Initial",C[C.Dynamic=2]="Dynamic"})(O=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var L;(function(C){C[C.CONDITION=0]="CONDITION",C[C.HIT_COUNT=1]="HIT_COUNT",C[C.LOG_MESSAGE=2]="LOG_MESSAGE"})(L=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(be[162],Se([1,0,9,2,17,27,11]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(s,i,c){return s.replace(A,function(t,n){return i&&n.length>0&&n[0]!=="_"?t:c&&c.hasOwnProperty(n)?c[n]:t})}e.formatPII=y;function O(s){const i={};for(const c of Object.keys(s))c.startsWith("!")||(i[c]=s[c]);return i}e.filterExceptionsFromTelemetry=O;function L(s){return s.configuration.request==="attach"&&!C(s)&&(!s.parentSession||L(s.parentSession))}e.isSessionAttach=L;function C(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(i,"extensionhost")||(0,l.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?C(s.parentSession):void 0}e.getExtensionHostDebugSession=C;function u(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=u;function g(s,i,c){let t,n=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=m.exec(s);){const S=d.index+1,P=S+d[0].length;if(S<=i&&P>=c){t=d[0],n=S;break}}if(t){const S=/\w+/g;let P=null;for(;(P=S.exec(t))&&!(P.index+1+n+P[0].length>=c););P&&(t=t.substring(0,S.lastIndex))}return t?{start:n,end:n+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(s){return!!(s&&s.match(o))}e.isUri=r;function f(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(r(s.path))return T.URI.parse(s.path);if((0,b.isAbsolute)(s.path))return T.URI.file(s.path)}return s.path}function p(s){if(typeof s.path=="object"){const i=T.URI.revive(s.path);if(i)return i.scheme===I.Schemas.file?i.fsPath:i.toString()}return s.path}function D(s,i){const c=i?f:p,t=(0,M.deepClone)(s);return _(t,(n,m)=>{n&&m&&(m.path=c(m))}),t}e.convertToDAPaths=D;function h(s,i){const c=i?f:p,t=(0,M.deepClone)(s);return _(t,(n,m)=>{!n&&m&&(m.path=c(m))}),t}e.convertToVSCPaths=h;function _(s,i){switch(s.type){case"event":{const c=s;switch(c.event){case"output":i(!1,c.body.source);break;case"loadedSource":i(!1,c.body.source);break;case"breakpoint":i(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=s;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const c=s;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":c.body.sources.forEach(t=>i(!1,t));break;case"scopes":c.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":c.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=c;t.body&&t.body.instructions.forEach(n=>i(!1,n.location))}break;default:break}break}}}function E(s){return s.filter(i=>!i.presentation?.hidden).sort((i,c)=>i.presentation?c.presentation?i.presentation.group?c.presentation.group?i.presentation.group!==c.presentation.group?i.presentation.group.localeCompare(c.presentation.group):a(i.presentation.order,c.presentation.order):-1:c.presentation.group?1:a(i.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=E;function a(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function k(s,i){const c=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(c!=="none"&&(await i.saveAll(),c==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===I.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=k}),define(be[88],Se([1,0,29,163,74,11,17,21,44]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",b.Mimes.latex,b.Mimes.markdown,"image/png","image/jpeg",b.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[b.Mimes.latex,b.Mimes.markdown,"application/json",b.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var u;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(u=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeLanguage=5]="ChangeLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var r;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(r=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var p;(function(t){t.scheme=M.Schemas.vscodeNotebookCell;const n=/^ch(\d{7,})/;function m(v,x){return v.with({scheme:t.scheme,fragment:`ch${x.toString().padStart(7,"0")}${v.scheme!==M.Schemas.file?v.scheme:""}`})}t.generate=m;function d(v){if(v.scheme!==t.scheme)return;const x=n.exec(v.fragment);return x?{handle:Number(x[1]),notebook:v.with({scheme:v.fragment.substring(x[0].length)||M.Schemas.file,fragment:null})}:void 0}t.parse=d;function S(v,x){return v.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${v.scheme!==M.Schemas.file?v.scheme:""}`})}t.generateCellOutputUri=S;function P(v){if(v.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(v.fragment);if(!x)return;const W=x[1]&&x[1]!==""?x[1]:void 0,V=x[2];return{outputId:W,notebook:v.with({scheme:V||M.Schemas.file,fragment:null})}}t.parseCellOutputUri=P;function B(v,x,W){return v.with({scheme:W,fragment:`ch${x.toString().padStart(7,"0")}${v.scheme!==M.Schemas.file?v.scheme:""}`})}t.generateCellUri=B;function F(v,x){if(v.scheme!==x)return;const W=n.exec(v.fragment);return W?{handle:Number(W[1]),notebook:v.with({scheme:v.fragment.substring(W[0].length)||M.Schemas.file,fragment:null})}:void 0}t.parseCellUri=F})(p=e.CellUri||(e.CellUri={}));const D=t=>A.isWindows?t.replace(/\//g,"\\"):t;class h{constructor(n=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(n)].map(d=>({pattern:d,matches:l.parse(D(d))}))}sort(n){const m=new Map(T.Iterable.map(n,S=>[S,D(S)]));let d=[];for(const{matches:S}of this.order)for(const[P,B]of m)if(S(B)){d.push(P),m.delete(P);break}return m.size&&(d=d.concat([...m.keys()].sort((S,P)=>this.defaultOrder.indexOf(S)-this.defaultOrder.indexOf(P)))),d}prioritize(n,m){const d=this.findIndex(n);if(d===-1){this.order.unshift({pattern:n,matches:l.parse(D(n))});return}const S=new Set(m.map(B=>this.findIndex(B,d)));S.delete(-1);const P=Array.from(S).sort();this.order.splice(d+1,0,...P.map(B=>this.order[B]));for(let B=P.length-1;B>=0;B--)this.order.splice(P[B],1)}toArray(){return this.order.map(n=>n.pattern)}findIndex(n,m=this.order.length){const d=D(n);for(let S=0;S<m;S++)if(this.order[S].matches(d))return S;return-1}}e.MimeTypeDisplayOrder=h;function _(t,n,m,d=(S,P)=>S===P){const S=[];function P(v,x,W){if(x===0&&W.length===0)return;const V=S[S.length-1];V&&V.start+V.deleteCount===v?(V.deleteCount+=x,V.toInsert.push(...W)):S.push({start:v,deleteCount:x,toInsert:W})}let B=0,F=0;for(;;){if(B===t.length){P(B,0,n.slice(F));break}if(F===n.length){P(B,t.length-B,[]);break}const v=t[B],x=n[F];if(d(v,x)){B+=1,F+=1;continue}m(x)?(P(B,1,[]),B+=1):(P(B,0,[x]),F+=1)}return S}e.diff=_,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var E;(function(t){t.default="default",t.option="option"})(E=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(t){const n=t;return!!((typeof n.include=="string"||l.isRelativePattern(n.include))&&(typeof n.exclude=="string"||l.isRelativePattern(n.exclude)))}e.isDocumentExcludePattern=a;function k(t,n,m){if(Array.isArray(t.viewType)&&t.viewType.indexOf(n)>=0||t.viewType===n)return!0;if(t.filenamePattern){const d=a(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,S=a(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(l.match(d,(0,I.basename)(m.fsPath).toLowerCase()))return!(S&&l.match(S,(0,I.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=k;class s{constructor(n){this.textModel=n}getElements(){const n=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)n[m]=this.textModel.cells[m].getHashValue();return n}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(n){return`${c._prefix}${n}`}static parse(n){if(n.startsWith(c._prefix))return n.substring(c._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c._prefix="notebook/"}),define(be[164],Se([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(be[165],Se([1,0,3,44]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,l.createDecorator)(e.OUTPUT_SERVICE_ID);var b;(function(M){M[M.Append=1]="Append",M[M.Replace=2]="Replace",M[M.Clear=3]="Clear"})(b=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(be[166],Se([1,0,134,3,44]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,l.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,l.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,l.localize(2,null)),e.ITaskService=(0,T.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=l;function T(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=T}),define(be[64],Se([1,0,2,48]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var M;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(c){c.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),c.deserialize=t=>({range:T.Range.lift(t.range),uri:l.URI.revive(t.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var A;(function(c){c[c.Error=0]="Error",c[c.Info=1]="Info"})(A=e.TestMessageType||(e.TestMessageType={}));var y;(function(c){c.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.serialize(t.location)}),c.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&I.deserialize(t.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));var O;(function(c){c.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.serialize(t.location)}),c.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&I.deserialize(t.location)})})(O=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(c){c.serialize=t=>t.type===0?y.serialize(t):O.serialize(t),c.deserialize=t=>t.type===0?y.deserialize(t):O.deserialize(t)})(L=e.ITestMessage||(e.ITestMessage={}));var C;(function(c){c.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),c.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const u="\0",g=(c,t)=>c+u+t;e.namespaceTestTag=g;const o=c=>{const t=c.indexOf(u);return{ctrlId:c.slice(0,t),tagId:c.slice(t+1)}};e.denamespaceTestTag=o;var r;(function(c){c.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),c.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?l.URI.revive(t.uri):void 0,range:t.range?T.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(r=e.ITestItem||(e.ITestItem={}));var f;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var p;(function(c){c.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:r.serialize(t.item)}),c.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:r.deserialize(t.item)})})(p=e.InternalTestItem||(e.InternalTestItem={}));var D;(function(c){c.serialize=t=>{let n;return t.item&&(n={},t.item.label!==void 0&&(n.label=t.item.label),t.item.tags!==void 0&&(n.tags=t.item.tags),t.item.busy!==void 0&&(n.busy=t.item.busy),t.item.uri!==void 0&&(n.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(n.range=t.item.range?.toJSON()),t.item.description!==void 0&&(n.description=t.item.description),t.item.error!==void 0&&(n.error=t.item.error),t.item.sortText!==void 0&&(n.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:n}},c.deserialize=t=>{let n;return t.item&&(n={},t.item.label!==void 0&&(n.label=t.item.label),t.item.tags!==void 0&&(n.tags=t.item.tags),t.item.busy!==void 0&&(n.busy=t.item.busy),t.item.range!==void 0&&(n.range=t.item.range?T.Range.lift(t.item.range):null),t.item.description!==void 0&&(n.description=t.item.description),t.item.error!==void 0&&(n.error=t.item.error),t.item.sortText!==void 0&&(n.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:n}}})(D=e.ITestItemUpdate||(e.ITestItemUpdate={}));const h=(c,t)=>{t.expand!==void 0&&(c.expand=t.expand),t.item!==void 0&&(c.item=c.item?Object.assign(c.item,t.item):t.item)};e.applyTestItemUpdate=h;var _;(function(c){c.serialize=(t,n)=>({...p.serialize(t),children:n,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(C.serialize)})})(_=e.TestResultItem||(e.TestResultItem={}));var E;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var a;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.Remove=2]="Remove",c[c.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",c[c.Retire=4]="Retire",c[c.AddTag=5]="AddTag",c[c.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var k;(function(c){c.deserialize=t=>t.op===0?{op:t.op,item:p.deserialize(t.item)}:t.op===1?{op:t.op,item:D.deserialize(t.item)}:t,c.serialize=t=>t.op===0?{op:t.op,item:p.serialize(t.item)}:t.op===1?{op:t.op,item:D.serialize(t.item)}:t})(k=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(t){}update(t){}remove(t,n){}complete(){}}e.IncrementalChangeCollector=s;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const n=this.createChangeCollector();for(const m of t)switch(m.op){case 0:{const d=p.deserialize(m.item);if(d.parent){if(this.items.has(d.parent)){const S=this.items.get(d.parent);S.children.add(d.item.extId);const P=this.createItem(d,S);this.items.set(d.item.extId,P),n.add(P)}}else{const S=this.createItem(d);this.roots.add(S),this.items.set(d.item.extId,S),n.add(S)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=D.deserialize(m.item),S=this.items.get(d.extId);if(!S)break;d.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,d),n.update(S);break}case 2:{const d=this.items.get(m.itemId);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const S=[[m.itemId]];for(;S.length;)for(const P of S.pop()){const B=this.items.get(P);B&&(S.push(B.children),this.items.delete(P),n.remove(B,B!==d),B.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}n.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=i}),define(be[65],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(M){M.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class b{constructor(I,A=I.length){if(this.path=I,this.viewEnd=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,A,y=I.parent){if(I.id===A)return new b([A]);let O=[I.id];for(let L=y;L&&L.id!==A;L=L.parent)O.push(L.id);return O.push(A),new b(O.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new b(I.split("\0"))}static join(I,A){return new b([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new b(this.path,I)}compare(I){if(typeof I=="string")return b.compare(this.toString(),I);for(let A=0;A<I.viewEnd&&A<this.viewEnd;A++)if(I.path[A]!==this.path[A])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=b}),define(be[168],Se([1,0,17,58,10,27,21,76,135]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class O{constructor(C,u,g,o){this._contributedVariables=new Map,this._context=C,this._labelService=u,this._userHomePromise=g,o&&(this._envVariablesPromise=o.then(r=>this.prepareEnv(r)))}prepareEnv(C){if(I.isWindows){const u=Object.create(null);return Object.keys(C).forEach(g=>{u[g.toLowerCase()]=C[g]}),u}return C}resolveWithEnvironment(C,u,g){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},u?u.uri:void 0,g)}async resolveAsync(C,u){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,C?C.uri:void 0,u)}async resolveAnyBase(C,u,g,o){const r=M.deepClone(u);I.isWindows&&r.windows?Object.keys(r.windows).forEach(p=>r[p]=r.windows[p]):I.isMacintosh&&r.osx?Object.keys(r.osx).forEach(p=>r[p]=r.osx[p]):I.isLinux&&r.linux&&Object.keys(r.linux).forEach(p=>r[p]=r.linux[p]),delete r.windows,delete r.osx,delete r.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,C?C.uri:void 0,r,g,o)}async resolveAnyAsync(C,u,g){return this.resolveAnyBase(C,u,g)}async resolveAnyMap(C,u,g){const o=new Map;return{newConfig:await this.resolveAnyBase(C,u,g,o),resolvedVariables:o}}resolveWithInteractionReplace(C,u,g,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,u,g,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,u){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,u)}recursiveResolve(C,u,g,o,r){if(b.isString(g))return this.resolveString(C,u,g,o,r);if(b.isArray(g))return g.map(f=>this.recursiveResolve(C,u,f,o,r));if(b.isObject(g)){let f=Object.create(null);return Object.keys(g).forEach(p=>{const D=this.resolveString(C,u,p,o,r);f[D]=this.recursiveResolve(C,u,g[p],o,r)}),f}return g}resolveString(C,u,g,o,r){return g.replace(O.VARIABLE_REGEXP,(p,D)=>{if(D.includes(O.VARIABLE_LHS))return p;let h=this.evaluateSingleVariable(C,p,D,u,o);return r&&r.set(D,h),h!==p&&b.isString(h)&&h.match(O.VARIABLE_REGEXP)&&(h=this.resolveString(C,u,h,o,r)),h})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,u,g,o,r){let f;const p=g.split(":");p.length>1&&(g=p[0],f=p[1]);const D=()=>{const E=this._context.getFilePath();if(E)return E;throw new Error((0,y.localize)(0,null,u))},h=()=>{const E=D();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,y.localize)(1,null,u,l.basename(E)))},_=()=>{if(f){const E=this._context.getFolderUri(f);if(E)return E;throw new Error((0,y.localize)(2,null,u,f))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,u)):new Error((0,y.localize)(4,null,u))};switch(g){case"env":if(f){if(C.env){const E=C.env[I.isWindows?f.toLowerCase():f];if(b.isString(E))return E}return""}throw new Error((0,y.localize)(5,null,u));case"config":if(f){const E=this._context.getConfigurationValue(o,f);if(b.isUndefinedOrNull(E))throw new Error((0,y.localize)(6,null,u,f));if(b.isObject(E))throw new Error((0,y.localize)(7,null,u,f));return E}throw new Error((0,y.localize)(8,null,u));case"command":return this.resolveFromMap(u,f,r,"command");case"input":return this.resolveFromMap(u,f,r,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(_()));case"cwd":return o||f?(0,A.normalizeDriveLetter)(this.fsPath(_())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(_()));case"userHome":{if(C.userHome)return C.userHome;throw new Error((0,y.localize)(9,null,u))}case"lineNumber":{const E=this._context.getLineNumber();if(E)return E;throw new Error((0,y.localize)(10,null,u))}case"selectedText":{const E=this._context.getSelectedText();if(E)return E;throw new Error((0,y.localize)(11,null,u))}case"file":return D();case"fileWorkspaceFolder":return h();case"relativeFile":return o||f?l.relative(this.fsPath(_()),D()):D();case"relativeFileDirname":{const E=l.dirname(D());if(o||f){const a=l.relative(this.fsPath(_()),E);return a.length===0?".":a}return E}case"fileDirname":return l.dirname(D());case"fileExtname":return l.extname(D());case"fileBasename":return l.basename(D());case"fileBasenameNoExtension":{const E=l.basename(D());return E.slice(0,E.length-l.extname(E).length)}case"fileDirnameBasename":return l.basename(l.dirname(D()));case"execPath":{const E=this._context.getExecPath();return E||u}case"execInstallFolder":{const E=this._context.getAppRoot();return E||u}case"pathSeparator":return l.sep;default:try{const E=f?`${g}:${f}`:g;return this.resolveFromMap(u,E,r,void 0)}catch{return u}}}}resolveFromMap(C,u,g,o){if(u&&g){const r=o===void 0?g[u]:g[o+":"+u];if(typeof r=="string")return r;throw new Error((0,y.localize)(12,null,C))}return C}}e.AbstractVariableResolverService=O,O.VARIABLE_LHS="${",O.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[89],Se([1,0,3,158]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var b;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var M;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function O(o){const r=o;return(0,T.isEditorInput)(r?.editor)&&(0,T.isEditorInput)(r?.replacement)}e.isEditorReplacement=O;var L;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function u(o){const r=o;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.isEditorGroup=u;function g(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=g}),define(be[169],Se([1,0,3,89]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(M){const I=M;return typeof M=="number"||(0,T.isEditorGroup)(I)}e.isPreferredGroup=b}),define(be[8],Se([1,0,16,22,75,102,54,27,10,2,48,66,137,80,47,88,64,65,169,6]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(ge){function we(K){const{selectionStartLineNumber:ye,selectionStartColumn:Pe,positionLineNumber:$e,positionColumn:Ke}=K,dt=new h.Position(ye-1,Pe-1),pt=new h.Position($e-1,Ke-1);return new h.Selection(dt,pt)}ge.to=we;function le(K){const{anchor:ye,active:Pe}=K;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ge.from=le})(_=e.Selection||(e.Selection={}));var E;(function(ge){function we(K){if(!K)return;const{start:ye,end:Pe}=K;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ge.from=we;function le(K){if(!K)return;const{startLineNumber:ye,startColumn:Pe,endLineNumber:$e,endColumn:Ke}=K;return new h.Range(ye-1,Pe-1,$e-1,Ke-1)}ge.to=le})(E=e.Range||(e.Range={}));var a;(function(ge){function we(le){switch(le){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}ge.to=we})(a=e.TokenType||(e.TokenType={}));var k;(function(ge){function we(K){return new h.Position(K.lineNumber-1,K.column-1)}ge.to=we;function le(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=le})(k=e.Position||(e.Position={}));var s;(function(ge){function we(ye,Pe){return(0,l.coalesce)((0,l.asArray)(ye).map($e=>le($e,Pe)))}ge.from=we;function le(ye,Pe){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:K(ye.scheme,Pe),pattern:ue.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType}}function K(ye,Pe){return Pe&&typeof ye=="string"?Pe.transformOutgoingScheme(ye):ye}})(s=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(ge){function we(K){switch(K){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}ge.from=we;function le(K){switch(K){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}ge.to=le})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(ge){function we(K){let ye;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?ye=String(K.code):ye={value:String(K.code.value),target:K.code.target}),{...E.from(K.range),message:K.message,source:K.source,code:ye,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,l.coalesce)(K.tags.map(i.from)):void 0}}ge.from=we;function le(K){const ye=new h.Diagnostic(E.to(K),K.message,n.to(K.severity));return ye.source=K.source,ye.code=(0,y.isString)(K.code)?K.code:K.code?.value,ye.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),ye.tags=K.tags&&(0,l.coalesce)(K.tags.map(i.to)),ye}ge.to=le})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(ge){function we(K){return{...E.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=we;function le(K){return new h.DiagnosticRelatedInformation(new h.Location(K.resource,E.to(K)),K.message)}ge.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ge){function we(K){switch(K){case h.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ge.from=we;function le(K){switch(K){case g.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}ge.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(ge){function we(K){return typeof K=="number"&&K>=h.ViewColumn.One?K-1:K===h.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}ge.from=we;function le(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=le})(m=e.ViewColumn||(e.ViewColumn={}));function d(ge){return typeof ge.range!="undefined"}function S(ge){return ge.length===0?!0:!!d(ge[0])}e.isDecorationOptionsArr=S;var P;(function(ge){function we(Ke){return Ke.map(ge.from)}ge.fromMany=we;function le(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function K(Ke){let dt;if(le(Ke)){const{language:ut,value:at}=Ke;dt={value:"```"+ut+`
`+at+"\n```\n"}}else h.MarkdownString.isMarkdownString(Ke)?dt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?dt={value:Ke}:dt={value:""};const pt=Object.create(null);dt.uris=pt;const vt=ut=>{try{let at=O.URI.parse(ut,!0);at=at.with({query:ye(at.query,pt)}),pt[ut]=at}catch{}return""},nt=new M.marked.Renderer;return nt.link=vt,nt.image=ut=>typeof ut=="string"?vt(b.parseHrefAndDimensions(ut).href):"",(0,M.marked)(dt.value,{renderer:nt}),dt}ge.from=K;function ye(Ke,dt){if(!Ke)return Ke;let pt;try{pt=(0,I.parse)(Ke)}catch{}if(!pt)return Ke;let vt=!1;return pt=(0,A.cloneAndChange)(pt,nt=>{if(O.URI.isUri(nt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ut]=nt,vt=!0,ut}else return}),vt?JSON.stringify(pt):Ke}function Pe(Ke){const dt=new h.MarkdownString(Ke.value,Ke.supportThemeIcons);return dt.isTrusted=Ke.isTrusted,dt.supportHtml=Ke.supportHtml,dt.baseUri=Ke.baseUri?O.URI.from(Ke.baseUri):void 0,dt}ge.to=Pe;function $e(Ke){if(!!Ke)return typeof Ke=="string"?Ke:ge.from(Ke)}ge.fromStrict=$e})(P=e.MarkdownString||(e.MarkdownString={}));function B(ge){return S(ge)?ge.map(we=>({range:E.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?P.fromMany(we.hoverMessage):we.hoverMessage?P.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):ge.map(we=>({range:E.from(we)}))}e.fromRangeOrRangeWithMessage=B;function F(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?O.URI.file(ge):ge}e.pathOrURIToURI=F;var v;(function(ge){function we(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?F(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ge.from=we})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(ge){function we(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?F(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?v.from(le.before):void 0,after:le.after?v.from(le.after):void 0}}ge.from=we})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(ge){function we(le){if(typeof le=="undefined")return le;switch(le){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=we})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ge){function we(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?W.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?x.from(le.light):void 0,dark:le.dark?x.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?F(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?v.from(le.before):void 0,after:le.after?v.from(le.after):void 0}}ge.from=we})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var re;(function(ge){function we(K){return{text:K.newText,eol:K.newEol&&Je.from(K.newEol),range:E.from(K.range)}}ge.from=we;function le(K){const ye=new h.TextEdit(E.to(K.range),K.text);return ye.newEol=typeof K.eol=="undefined"?void 0:Je.to(K.eol),ye}ge.to=le})(re=e.TextEdit||(e.TextEdit={}));var H;(function(ge){function we(K,ye){const Pe={edits:[]};if(K instanceof h.WorkspaceEdit)for(let $e of K._allEntries())$e._type===1?Pe.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata}):$e._type===2?Pe.edits.push({_type:2,resource:$e.uri,edit:re.from($e.edit),modelVersionId:ye?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Pe.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Pe.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:ye?.getNotebookDocumentVersion($e.uri),edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(mt.from)}});return Pe}ge.from=we;function le(K){const ye=new h.WorkspaceEdit;for(const Pe of K.edits)Pe.edit?ye.replace(O.URI.revive(Pe.resource),E.to(Pe.edit.range),Pe.edit.text):ye.renameFile(O.URI.revive(Pe.oldUri),O.URI.revive(Pe.newUri),Pe.options);return ye}ge.to=le})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var R;(function(ge){const we=Object.create(null);we[h.SymbolKind.File]=0,we[h.SymbolKind.Module]=1,we[h.SymbolKind.Namespace]=2,we[h.SymbolKind.Package]=3,we[h.SymbolKind.Class]=4,we[h.SymbolKind.Method]=5,we[h.SymbolKind.Property]=6,we[h.SymbolKind.Field]=7,we[h.SymbolKind.Constructor]=8,we[h.SymbolKind.Enum]=9,we[h.SymbolKind.Interface]=10,we[h.SymbolKind.Function]=11,we[h.SymbolKind.Variable]=12,we[h.SymbolKind.Constant]=13,we[h.SymbolKind.String]=14,we[h.SymbolKind.Number]=15,we[h.SymbolKind.Boolean]=16,we[h.SymbolKind.Array]=17,we[h.SymbolKind.Object]=18,we[h.SymbolKind.Key]=19,we[h.SymbolKind.Null]=20,we[h.SymbolKind.EnumMember]=21,we[h.SymbolKind.Struct]=22,we[h.SymbolKind.Event]=23,we[h.SymbolKind.Operator]=24,we[h.SymbolKind.TypeParameter]=25;function le(ye){return typeof we[ye]=="number"?we[ye]:6}ge.from=le;function K(ye){for(const Pe in we)if(we[Pe]===ye)return Number(Pe);return h.SymbolKind.Property}ge.to=K})(R=e.SymbolKind||(e.SymbolKind={}));var se;(function(ge){function we(K){switch(K){case h.SymbolTag.Deprecated:return 1}}ge.from=we;function le(K){switch(K){case 1:return h.SymbolTag.Deprecated}}ge.to=le})(se=e.SymbolTag||(e.SymbolTag={}));var de;(function(ge){function we(K){return{name:K.name,kind:R.from(K.kind),tags:K.tags&&K.tags.map(se.from),containerName:K.containerName,location:fe.from(K.location)}}ge.from=we;function le(K){const ye=new h.SymbolInformation(K.name,R.to(K.kind),K.containerName,fe.to(K.location));return ye.tags=K.tags&&K.tags.map(se.to),ye}ge.to=le})(de=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(ge){function we(K){const ye={name:K.name||"!!MISSING: name!!",detail:K.detail,range:E.from(K.range),selectionRange:E.from(K.selectionRange),kind:R.from(K.kind),tags:K.tags?.map(se.from)??[]};return K.children&&(ye.children=K.children.map(we)),ye}ge.from=we;function le(K){const ye=new h.DocumentSymbol(K.name,K.detail,R.to(K.kind),E.to(K.range),E.to(K.selectionRange));return(0,l.isNonEmptyArray)(K.tags)&&(ye.tags=K.tags.map(se.to)),K.children&&(ye.children=K.children.map(le)),ye}ge.to=le})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(ge){function we(K){const ye=new h.CallHierarchyItem(R.to(K.kind),K.name,K.detail||"",O.URI.revive(K.uri),E.to(K.range),E.to(K.selectionRange));return ye._sessionId=K._sessionId,ye._itemId=K._itemId,ye}ge.to=we;function le(K,ye,Pe){if(ye=ye??K._sessionId,Pe=Pe??K._itemId,ye===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Pe,name:K.name,detail:K.detail,kind:R.from(K.kind),uri:K.uri,range:E.from(K.range),selectionRange:E.from(K.selectionRange),tags:K.tags?.map(se.from)}}ge.from=le})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(ge){function we(le){return new h.CallHierarchyIncomingCall(ie.to(le.from),le.fromRanges.map(K=>E.to(K)))}ge.to=we})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(ge){function we(le){return new h.CallHierarchyOutgoingCall(ie.to(le.to),le.fromRanges.map(K=>E.to(K)))}ge.to=we})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var fe;(function(ge){function we(K){return{range:K.range&&E.from(K.range),uri:K.uri}}ge.from=we;function le(K){return new h.Location(O.URI.revive(K.uri),E.to(K.range))}ge.to=le})(fe=e.location||(e.location={}));var ae;(function(ge){function we(K){const ye=K,Pe=K;return{originSelectionRange:ye.originSelectionRange?E.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Pe.uri,range:E.from(ye.targetRange?ye.targetRange:Pe.range),targetSelectionRange:ye.targetSelectionRange?E.from(ye.targetSelectionRange):void 0}}ge.from=we;function le(K){return{targetUri:O.URI.revive(K.uri),targetRange:E.to(K.range),targetSelectionRange:K.targetSelectionRange?E.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?E.to(K.originSelectionRange):void 0}}ge.to=le})(ae=e.DefinitionLink||(e.DefinitionLink={}));var pe;(function(ge){function we(K){return{range:E.from(K.range),contents:P.fromMany(K.contents)}}ge.from=we;function le(K){return new h.Hover(K.contents.map(P.to),E.to(K.range))}ge.to=le})(pe=e.Hover||(e.Hover={}));var Ae;(function(ge){function we(K){return{range:E.from(K.range),expression:K.expression}}ge.from=we;function le(K){return new h.EvaluatableExpression(E.to(K.range),K.expression)}ge.to=le})(Ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(ge){function we(K){if(K instanceof h.InlineValueText)return{type:"text",range:E.from(K.range),text:K.text};if(K instanceof h.InlineValueVariableLookup)return{type:"variable",range:E.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:E.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=we;function le(K){switch(K.type){case"text":return{range:E.to(K.range),text:K.text};case"variable":return{range:E.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:E.to(K.range),expression:K.expression}}}ge.to=le})(Fe=e.InlineValue||(e.InlineValue={}));var He;(function(ge){function we(K){return{frameId:K.frameId,stoppedLocation:E.from(K.stoppedLocation)}}ge.from=we;function le(K){return new h.InlineValueContext(K.frameId,E.to(K.stoppedLocation))}ge.to=le})(He=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(ge){function we(K){return{range:E.from(K.range),kind:K.kind}}ge.from=we;function le(K){return new h.DocumentHighlight(E.to(K.range),K.kind)}ge.to=le})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(ge){function we(le){switch(le){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}ge.to=we})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(ge){function we(le){return{triggerKind:Ce.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ge.to=we})(Ee=e.CompletionContext||(e.CompletionContext={}));var De;(function(ge){function we(K){switch(K){case h.CompletionItemTag.Deprecated:return 1}}ge.from=we;function le(K){switch(K){case 1:return h.CompletionItemTag.Deprecated}}ge.to=le})(De=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(ge){const we=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function le(Pe){return we.get(Pe)??9}ge.from=le;const K=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function ye(Pe){return K.get(Pe)??h.CompletionItemKind.Property}ge.to=ye})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var q;(function(ge){function we(le,K){const ye=new h.CompletionItem(le.label);return ye.insertText=le.insertText,ye.kind=ne.to(le.kind),ye.tags=le.tags?.map(De.to),ye.detail=le.detail,ye.documentation=b.isMarkdownString(le.documentation)?P.to(le.documentation):le.documentation,ye.sortText=le.sortText,ye.filterText=le.filterText,ye.preselect=le.preselect,ye.commitCharacters=le.commitCharacters,L.Range.isIRange(le.range)?ye.range=E.to(le.range):typeof le.range=="object"&&(ye.range={inserting:E.to(le.range.insert),replacing:E.to(le.range.replace)}),ye.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?ye.insertText=new h.SnippetString(le.insertText):(ye.insertText=le.insertText,ye.textEdit=ye.range instanceof h.Range?new h.TextEdit(ye.range,ye.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(ye.additionalTextEdits=le.additionalTextEdits.map(Pe=>re.to(Pe))),ye.command=K&&le.command?K.fromInternal(le.command):void 0,ye}ge.to=we})(q=e.CompletionItem||(e.CompletionItem={}));var Q;(function(ge){function we(K){return{label:K.label,documentation:P.fromStrict(K.documentation)}}ge.from=we;function le(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?P.to(K.documentation):K.documentation}}ge.to=le})(Q=e.ParameterInformation||(e.ParameterInformation={}));var w;(function(ge){function we(K){return{label:K.label,documentation:P.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(Q.from):[],activeParameter:K.activeParameter}}ge.from=we;function le(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?P.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Q.to):[],activeParameter:K.activeParameter}}ge.to=le})(w=e.SignatureInformation||(e.SignatureInformation={}));var U;(function(ge){function we(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(w.from):[]}}ge.from=we;function le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(w.to):[]}}ge.to=le})(U=e.SignatureHelp||(e.SignatureHelp={}));var z;(function(ge){function we(le,K){const ye=new h.InlayHint(k.to(K.position),typeof K.label=="string"?K.label:K.label.map(j.to.bind(void 0,le)),K.kind&&ee.to(K.kind));return ye.textEdits=K.textEdits&&K.textEdits.map(re.to),ye.tooltip=b.isMarkdownString(K.tooltip)?P.to(K.tooltip):K.tooltip,ye.paddingLeft=K.paddingLeft,ye.paddingRight=K.paddingRight,ye}ge.to=we})(z=e.InlayHint||(e.InlayHint={}));var j;(function(ge){function we(le,K){const ye=new h.InlayHintLabelPart(K.label);return ye.tooltip=b.isMarkdownString(K.tooltip)?P.to(K.tooltip):K.tooltip,C.Command.is(K.command)&&(ye.command=le.fromInternal(K.command)),K.location&&(ye.location=fe.to(K.location)),ye}ge.to=we})(j=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ee;(function(ge){function we(K){return K}ge.from=we;function le(K){return K}ge.to=le})(ee=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(ge){function we(K){return{range:E.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=we;function le(K){let ye;if(K.url)try{ye=typeof K.url=="string"?O.URI.parse(K.url,!0):O.URI.revive(K.url)}catch{}return new h.DocumentLink(E.to(K.range),ye)}ge.to=le})(ce=e.DocumentLink||(e.DocumentLink={}));var ve;(function(ge){function we(K){const ye=new h.ColorPresentation(K.label);return K.textEdit&&(ye.textEdit=re.to(K.textEdit)),K.additionalTextEdits&&(ye.additionalTextEdits=K.additionalTextEdits.map(Pe=>re.to(Pe))),ye}ge.to=we;function le(K){return{label:K.label,textEdit:K.textEdit?re.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(ye=>re.from(ye)):void 0}}ge.from=le})(ve=e.ColorPresentation||(e.ColorPresentation={}));var Oe;(function(ge){function we(K){return new h.Color(K[0],K[1],K[2],K[3])}ge.to=we;function le(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=le})(Oe=e.Color||(e.Color={}));var Le;(function(ge){function we(K){return{range:E.from(K.range)}}ge.from=we;function le(K){return new h.SelectionRange(E.to(K.range))}ge.to=le})(Le=e.SelectionRange||(e.SelectionRange={}));var Ne;(function(ge){function we(le){switch(le){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}ge.to=we})(Ne=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ve;(function(ge){function we(K){switch(K){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=we;function le(K){switch(K){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}ge.to=le})(Ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Je;(function(ge){function we(K){if(K===h.EndOfLine.CRLF)return 1;if(K===h.EndOfLine.LF)return 0}ge.from=we;function le(K){if(K===1)return h.EndOfLine.CRLF;if(K===0)return h.EndOfLine.LF}ge.to=le})(Je=e.EndOfLine||(e.EndOfLine={}));var ke;(function(ge){function we(le){if(typeof le=="object")return le.viewId;switch(le){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=we})(ke=e.ProgressLocation||(e.ProgressLocation={}));var je;(function(ge){function we(le){const K={start:le.start+1,end:le.end+1};return le.kind&&(K.kind=G.from(le.kind)),K}ge.from=we})(je=e.FoldingRange||(e.FoldingRange={}));var G;(function(ge){function we(le){if(le)switch(le){case h.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}ge.from=we})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(ge){function we(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?E.from(le.selection):void 0,override:typeof le.override=="boolean"?u.EditorResolution.DISABLED:void 0}}ge.from=we})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ue;(function(ge){function we(Pe){return Pe instanceof h.RelativePattern?Pe.toJSON():typeof Pe=="string"?Pe:le(Pe)||K(Pe)?new h.RelativePattern(Pe.baseUri??Pe.base,Pe.pattern).toJSON():Pe}ge.from=we;function le(Pe){const $e=Pe;return $e?O.URI.isUri($e.baseUri)&&typeof $e.pattern=="string":!1}function K(Pe){const $e=Pe;return $e?typeof $e.base=="string"&&typeof $e.pattern=="string":!1}function ye(Pe){return typeof Pe=="string"?Pe:new h.RelativePattern(O.URI.revive(Pe.baseUri),Pe.pattern)}ge.to=ye})(ue=e.GlobPattern||(e.GlobPattern={}));var Me;(function(ge){function we(le){if(le){if(Array.isArray(le))return le.map(we);if(typeof le=="string")return le;{const K=le;return{language:K.language,scheme:K.scheme,pattern:ue.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=we})(Me=e.LanguageSelector||(e.LanguageSelector={}));var We;(function(ge){function we(K){return{start:K.start,end:K.end}}ge.from=we;function le(K){return new h.NotebookRange(K.start,K.end)}ge.to=le})(We=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function we(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=we;function le(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=le})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ze;(function(ge){function we(le){if(le===r.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;if(le===r.NotebookCellExecutionState.Pending)return h.NotebookCellExecutionState.Pending;if(le===r.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${le}`)}ge.to=we})(Ze=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ot;(function(ge){function we(K){switch(K){case h.NotebookCellKind.Markup:return r.CellKind.Markup;case h.NotebookCellKind.Code:default:return r.CellKind.Code}}ge.from=we;function le(K){switch(K){case r.CellKind.Markup:return h.NotebookCellKind.Markup;case r.CellKind.Code:default:return h.NotebookCellKind.Code}}ge.to=le})(ot=e.NotebookCellKind||(e.NotebookCellKind={}));var wt;(function(ge){function we(K){const ye={metadata:K.metadata??Object.create(null),cells:[]};for(let Pe of K.cells)h.NotebookCellData.validate(Pe),ye.cells.push(mt.from(Pe));return ye}ge.from=we;function le(K){const ye=new h.NotebookData(K.cells.map(mt.to));return(0,y.isEmptyObject)(K.metadata)||(ye.metadata=K.metadata),ye}ge.to=le})(wt=e.NotebookData||(e.NotebookData={}));var mt;(function(ge){function we(K){return{cellKind:ot.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(qe.from):[]}}ge.from=we;function le(K){return new h.NotebookCellData(ot.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(qe.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=le})(mt=e.NotebookCellData||(e.NotebookCellData={}));var kt;(function(ge){function we(K){return{mime:K.mime,valueBytes:T.VSBuffer.wrap(K.data)}}ge.from=we;function le(K){return new h.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=le})(kt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(ge){function we(K){return{outputId:K.id,items:K.items.map(kt.from),metadata:K.metadata}}ge.from=we;function le(K){const ye=K.items.map(kt.to);return new h.NotebookCellOutput(ye,K.outputId,K.metadata)}ge.to=le})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var gt;(function(ge){function we(ye){return K(ye)?{include:(0,y.withNullAsUndefined)(ue.from(ye.include)),exclude:(0,y.withNullAsUndefined)(ue.from(ye.exclude))}:(0,y.withNullAsUndefined)(ue.from(ye))}ge.from=we;function le(ye){return K(ye)?{include:ue.to(ye.include),exclude:ue.to(ye.exclude)}:ue.to(ye)}ge.to=le;function K(ye){const Pe=ye;return Pe?!!Pe.include&&!!Pe.exclude:!1}})(gt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Nt;(function(ge){function we(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?v.from(le.top):void 0}}ge.from=we})(Nt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var rt;(function(ge){function we(le,K,ye){const Pe=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Pe,ye),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ge.from=we})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(ge){function we(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}ge.from=we})(ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ut;(function(ge){function we(K){return{uri:K.uri,provides:K.provides}}ge.from=we;function le(K){return new h.NotebookRendererScript(O.URI.revive(K.uri),K.provides)}ge.to=le})(Ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(ge){function we(K){return{message:P.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:E.from(K.location.range),uri:K.location.uri}}}ge.from=we;function le(K){const ye=new h.TestMessage(typeof K.message=="string"?K.message:P.to(K.message));return ye.actualOutput=K.actual,ye.expectedOutput=K.expected,ye.location=K.location?fe.to(K.location):void 0,ye}ge.to=le})(Pt=e.TestMessage||(e.TestMessage={}));var _t;(function(ge){ge.namespace=f.namespaceTestTag,ge.denamespace=f.denamespaceTestTag})(_t=e.TestTag||(e.TestTag={}));var ct;(function(ge){function we(Pe){const $e=(0,o.getPrivateApiFor)(Pe).controllerId;return{extId:p.TestId.fromExtHostTestItem(Pe,$e).toString(),label:Pe.label,uri:O.URI.revive(Pe.uri),busy:!1,tags:Pe.tags.map(Ke=>_t.namespace($e,Ke.id)),range:L.Range.lift(E.from(Pe.range)),description:Pe.description||null,sortText:Pe.sortText||null,error:Pe.error&&P.fromStrict(Pe.error)||null}}ge.from=we;function le(Pe){return{parent:void 0,error:void 0,id:p.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:O.URI.revive(Pe.uri),tags:(Pe.tags||[]).map($e=>{const{tagId:Ke}=_t.denamespace($e);return new h.TestTag(Ke)}),range:E.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0,sortText:Pe.sortText||void 0}}ge.toPlain=le;function K(Pe){const $e=p.TestId.fromString(Pe.extId),Ke=new o.TestItemImpl($e.controllerId,$e.localId,Pe.label,O.URI.revive(Pe.uri)||void 0);return Ke.range=E.to(Pe.range||void 0),Ke.description=Pe.description||void 0,Ke.sortText=Pe.sortText||void 0,Ke}function ye(Pe){let $e;for(const Ke of Pe.tests){const dt=K(Ke.item);(0,o.getPrivateApiFor)(dt).parent=$e,$e=dt}return $e}ge.toItemFromContext=ye})(ct=e.TestItem||(e.TestItem={})),function(ge){function we(K){return{id:K.id}}ge.from=we;function le(K){return new h.TestTag(K.id)}ge.to=le}(_t=e.TestTag||(e.TestTag={}));var At;(function(ge){const we=(K,ye)=>{const Pe={...ct.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Ke=>Ke.type===0).map(Pt.to)})),children:K.children.map($e=>ye.get($e)).filter(y.isDefined).map($e=>we($e,ye))};for(const $e of Pe.children)$e.parent=Pe;return Pe};function le(K){const ye=[],Pe=new Map;for(const $e of K.items)Pe.set($e.item.extId,$e),K.request.targets.some(Ke=>Ke.controllerId===$e.controllerId&&Ke.testIds.includes($e.item.extId))&&ye.push($e);return{completedAt:K.completedAt,results:ye.map($e=>we($e,Pe))}}ge.to=le})(At=e.TestResults||(e.TestResults={}));var Mt;(function(ge){function we(Pe){return{covered:Pe.covered,total:Pe.covered}}function le(Pe){return"line"in Pe?k.from(Pe):E.from(Pe)}function K(Pe){return"branches"in Pe?{count:Pe.executionCount,location:le(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map($e=>({count:$e.executionCount,location:$e.location&&le($e.location)})):void 0}:{type:0,count:Pe.executionCount,location:le(Pe.location)}}ge.fromDetailed=K;function ye(Pe){return{uri:Pe.uri,statement:we(Pe.statementCoverage),branch:Pe.branchCoverage&&we(Pe.branchCoverage),function:Pe.functionCoverage&&we(Pe.functionCoverage),details:Pe.detailedCoverage?.map(K)}}ge.fromFile=ye})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(ge){function we(le){switch(le){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}ge.to=we})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function we(K){const ye=new h.TypeHierarchyItem(R.to(K.kind),K.name,K.detail||"",O.URI.revive(K.uri),E.to(K.range),E.to(K.selectionRange));return ye._sessionId=K._sessionId,ye._itemId=K._itemId,ye}ge.to=we;function le(K,ye,Pe){if(ye=ye??K._sessionId,Pe=Pe??K._itemId,ye===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Pe,kind:R.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:E.from(K.range),selectionRange:E.from(K.selectionRange),tags:K.tags?.map(se.from)}}ge.from=le})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Se([1,0,2,14,6,8,230]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(O,L,C,u={timeout:1500,errors:3}){this._logService=O,this._documents=L,this._mainThreadBulkEdits=C,this._thresholds=u,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(O){return(L,C,u)=>{const o={dispose:this._callbacks.push([L,C,O])};return Array.isArray(u)&&u.push(o),o}}async $participateInSave(O,L){const C=l.URI.revive(O);let u=!1;const g=setTimeout(()=>u=!0,this._thresholds.timeout),o=[];try{for(let r of[...this._callbacks]){if(u)break;const f=this._documents.getDocument(C),p=await this._deliverEventAsyncAndBlameBadListeners(r,{document:f,reason:M.TextDocumentSaveReason.to(L)});o.push(p)}}finally{clearTimeout(g)}return o}_deliverEventAsyncAndBlameBadListeners([O,L,C],u){const g=this._badListeners.get(O);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,O,L,u).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const r=this._badListeners.get(O);this._badListeners.set(O,r?r+1:1),typeof r=="number"&&r>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(O,L,C,u){const g=[],o=Date.now(),{document:r,reason:f}=u,{version:p}=r,D=Object.freeze({document:r,reason:f,waitUntil(h){if(Object.isFrozen(g))throw(0,T.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(h))}});try{L.apply(C,[D])}catch(h){return Promise.reject(h)}return Object.freeze(g),new Promise((h,_)=>{const E=setTimeout(()=>_(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${O.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(E),h(a)}).catch(a=>{clearTimeout(E),_(a)})}).then(h=>{const _={edits:[]};for(const E of h)if(Array.isArray(E)&&E.every(a=>a instanceof b.TextEdit))for(const{newText:a,newEol:k,range:s}of E)_.edits.push({_type:2,resource:r.uri,edit:{range:s&&M.Range.from(s),text:a,eol:k&&M.EndOfLine.from(k)}});if(_.edits.length!==0)return p===r.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(_):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(be[171],Se([1,0,11,27,2,8,6,88]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(u,g,o,r){this.start=u,this.deletedCount=g,this.deletedItems=o,this.items=r}asApiEvent(){return{range:new I.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(u=>u.apiCell),removedCells:this.deletedItems}}static asApiEvents(u){return u.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(o=>o.apiCell)}))}}class O{constructor(u,g,o){this.notebook=u,this._extHostDocument=g,this._cellData=o,this.handle=o.handle,this.uri=b.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(M.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(M.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(u,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const o={get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:M.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return u._mime},set mime(r){u._mime=r},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}};this._apiCell=Object.freeze(o)}return this._apiCell}setOutputs(u){this._outputs=u.map(M.NotebookCellOutput.to)}setOutputItems(u,g,o){const r=o.map(M.NotebookCellOutputItem.to),f=this._outputs.find(p=>p.id===u);f&&(g||(f.items.length=0),f.items.push(...r))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(M.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=O;class L{constructor(u,g,o,r,f,p){this._proxy=u,this._textDocumentsAndEditors=g,this._textDocuments=o,this._emitter=r,this.uri=f,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0,void 0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this,g={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===l.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(o){return o=u._validateIndex(o),u._cells[o].apiCell},getCells(o){return(o?u._getCells(o):u._cells).map(f=>f.apiCell)},save(){return u._save()}};this._notebook=Object.freeze(g)}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,g,o){this._versionId=u.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:o});const r={notebook:this.apiNotebook,metadata:o,cellChanges:[],contentChanges:[]},f=[];for(const D of u.rawEvents)D.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(D.changes,!1,r.contentChanges):D.kind===A.NotebookCellsChangeType.Move?this._moveCell(D.index,D.newIdx,r.contentChanges):D.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(D.index,D.outputs),f.push({cell:this._cells[D.index].apiCell,outputs:this._cells[D.index].apiCell.outputs})):D.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(D.index,D.outputId,D.append,D.outputItems),f.push({cell:this._cells[D.index].apiCell,outputs:this._cells[D.index].apiCell.outputs})):D.kind===A.NotebookCellsChangeType.ChangeLanguage?(this._changeCellLanguage(D.index,D.language),f.push({cell:this._cells[D.index].apiCell,document:this._cells[D.index].apiCell.document})):D.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this._cells[D.index].apiCell,document:this._cells[D.index].apiCell.document}):D.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(D.index,D.mime):D.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(D.index,D.metadata),f.push({cell:this._cells[D.index].apiCell,metadata:this._cells[D.index].apiCell.metadata})):D.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(D.index,D.internalMetadata),f.push({cell:this._cells[D.index].apiCell,executionSummary:this._cells[D.index].apiCell.executionSummary}));const p=new Map;for(let D=0;D<f.length;D++){const h=f[D],_=p.get(h.cell);if(_===void 0){const E=r.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});p.set(h.cell,E-1)}else r.cellChanges[_]={...r.cellChanges[_],...h}}return Object.freeze(r),Object.freeze(r.cellChanges),Object.freeze(r.contentChanges),r}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let g=u.start|0,o=u.end|0;return g<0&&(g=0),o>this._cells.length&&(o=this._cells.length),u.with({start:g,end:o})}_getCells(u){u=this._validateRange(u);const g=[];for(let o=u.start;o<u.end;o++)g.push(this._cells[o]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,g,o){if(this._disposed)return;const r=[],f=[],p=[];if(u.reverse().forEach(D=>{const _=D[2].map(k=>{const s=new O(this,this._textDocumentsAndEditors,k);return g||f.push(O.asModelAddData(this.apiNotebook,k)),s}),E=new y(D[0],D[1],[],_),a=this._cells.splice(D[0],D[1],..._);for(const k of a)p.push(k.uri),E.deletedItems.push(k.apiCell);r.push(E)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:p}),o)for(let D of r)o.push(D.asApiEvent());g||this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(r)}))}_moveCell(u,g,o){const r=this._cells.splice(u,1);this._cells.splice(g,0,...r);const f=[new y(u,1,r.map(p=>p.apiCell),[]),new y(g,0,[],r)];for(const p of f)o.push(p.asApiEvent());this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(f)}))}_setCellOutputs(u,g){const o=this._cells[u];o.setOutputs(g),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(u,g,o,r){const f=this._cells[u];f.setOutputItems(g,o,r),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_changeCellLanguage(u,g){const o=this._cells[u];o.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(o.uri,g)}_changeCellMime(u,g){const o=this._cells[u];o.apiCell.mime=g}_changeCellMetadata(u,g){const o=this._cells[u],r=o.apiCell.metadata;o.setMetadata(g);const f=o.apiCell.metadata;(0,T.equals)(r,f)||this._emitter.emitCellMetadataChange((0,T.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(u,g){this._cells[u].setInternalMetadata(g)}getCellFromApiCell(u){return this._cells.find(g=>g.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(g=>g.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(be[90],Se([1,0,6,8,14]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,O){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:O})}replaceCells(y,O,L){this._throwIfFinalized(),!(y===O&&L.length===0)&&this._collectedEdits.push({editType:1,index:y,count:O-y,cells:L.map(T.NotebookCellData.from)})}}class I{constructor(y,O,L,C,u,g){this.id=y,this._proxy=O,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=C,this._viewColumn=g}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(O){if(!Array.isArray(O)||!O.every(l.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");y._selections=O,y._trySetSelections(O)},get visibleRanges(){return y._visibleRanges},revealRange(O,L){y._proxy.$tryRevealRange(y.id,T.NotebookRange.from(O),L??l.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(O){const L=new M(this.document.version);return O(L),y._applyEdit(L.finalize())},setDecorations(O,L){return y.setDecorations(O,L)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(T.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const O=[];let L=-1;for(let C=0;C<y.cellEdits.length;C++){if(L<0){O.push(y.cellEdits[C]),L++;continue}const g=O[L],o=y.cellEdits[C];if(g.editType===1&&o.editType===1&&g.index===o.index){g.cells.push(...y.cellEdits[C].cells),g.count+=y.cellEdits[C].count;continue}O.push(y.cellEdits[C]),L++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,O)}setDecorations(y,O){if(!(O.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return O.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(O),y.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(be[172],Se([1,0,8,144,126,20,52,14]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(u){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=u}async withProgress(u,g,o){const r=this._handles++,{title:f,location:p,cancellable:D}=g,h={label:(0,b.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this._proxy.$startProgress(r,{location:l.ProgressLocation.from(p),title:f,source:h,cancellable:D},u.isUnderDevelopment?void 0:u.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(r,o,!!D)}_withProgress(u,g,o){let r;o&&(r=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(u,r));const f=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),r&&r.dispose()};let p;try{p=g(new L(this._proxy,u),o&&r?r.token:M.CancellationToken.None)}catch(D){throw f(u),D}return p.then(D=>f(u),D=>f(u)),p}$acceptProgressCanceled(u){const g=this._mapHandleToCancellationSource.get(u);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(u))}}e.ExtHostProgress=y;function O(C,u){return C.message=u.message,typeof u.increment=="number"&&(typeof C.increment=="number"?C.increment+=u.increment:C.increment=u.increment),C}class L extends T.Progress{constructor(u,g){super(o=>this.throttledReport(o));this._proxy=u,this._handle=g}throttledReport(u){this._proxy.$progressReport(this._handle,u)}}Ue([(0,I.throttle)(100,(C,u)=>O(C,u),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(be[91],Se([1,0,42,14,53,8,6]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(u,g,o){const r=A._Keys.nextId();u.$registerTextEditorDecorationType(g.identifier,r,M.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=A,A._Keys=new b.IdGenerator("TextEditorDecorationType");class y{constructor(u,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,g){this._throwIfFinalized();let o=null;if(u instanceof I.Position)o=new I.Range(u,u);else if(u instanceof I.Range)o=u;else throw new Error("Unrecognized location");this._pushEdit(o,g,!1)}insert(u,g){this._throwIfFinalized(),this._pushEdit(new I.Range(u,u),g,!0)}delete(u){this._throwIfFinalized();let g=null;if(u instanceof I.Range)g=u;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(u,g,o){const r=this._document.validateRange(u);this._collectedEdits.push({range:r,text:g,forceMoveMarkers:o})}setEndOfLine(u){if(this._throwIfFinalized(),u!==I.EndOfLine.LF&&u!==I.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=y;class O{constructor(u,g,o,r){this._proxy=u,this._id=g,this._accept(o),this._logService=r;const f=this;this.value={get tabSize(){return f._tabSize},set tabSize(p){f._setTabSize(p)},get insertSpaces(){return f._insertSpaces},set insertSpaces(p){f._setInsertSpaces(p)},get cursorStyle(){return f._cursorStyle},set cursorStyle(p){f._setCursorStyle(p)},get lineNumbers(){return f._lineNumbers},set lineNumbers(p){f._setLineNumbers(p)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const g=Math.floor(u);return g>0?g:null}if(typeof u=="string"){const g=parseInt(u,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(u){const g=this._validateTabSize(u);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const g=this._validateInsertSpaces(u);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const g={};let o=!1;if(typeof u.tabSize!="undefined"){const r=this._validateTabSize(u.tabSize);r==="auto"?(o=!0,g.tabSize=r):typeof r=="number"&&this._tabSize!==r&&(this._tabSize=r,o=!0,g.tabSize=r)}if(typeof u.insertSpaces!="undefined"){const r=this._validateInsertSpaces(u.insertSpaces);r==="auto"?(o=!0,g.insertSpaces=r):this._insertSpaces!==r&&(this._insertSpaces=r,o=!0,g.insertSpaces=r)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,o=!0,g.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,o=!0,g.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,g))}_warnOnError(u,g){g.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=O;class L{constructor(u,g,o,r,f,p,D,h){this.id=u,this._proxy=g,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._options=new O(this._proxy,this.id,p,o),this._visibleRanges=D,this._viewColumn=h;const _=this;this.value=Object.freeze({get document(){return r.getValue()},set document(E){throw(0,T.readonly)("document")},get selection(){return _._selections&&_._selections[0]},set selection(E){if(!(E instanceof I.Selection))throw(0,T.illegalArgument)("selection");_._selections=[E],_._trySetSelection()},get selections(){return _._selections},set selections(E){if(!Array.isArray(E)||E.some(a=>!(a instanceof I.Selection)))throw(0,T.illegalArgument)("selections");_._selections=E,_._trySetSelection()},get visibleRanges(){return _._visibleRanges},set visibleRanges(E){throw(0,T.readonly)("visibleRanges")},get options(){return _._options.value},set options(E){_._disposed||_._options.assign(E)},get viewColumn(){return _._viewColumn},set viewColumn(E){throw(0,T.readonly)("viewColumn")},edit(E,a={undoStopBefore:!0,undoStopAfter:!0}){if(_._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const k=new y(r.getValue(),a);return E(k),_._applyEdit(k)},insertSnippet(E,a,k={undoStopBefore:!0,undoStopAfter:!0}){if(_._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!a||Array.isArray(a)&&a.length===0)s=_._selections.map(i=>M.Range.from(i));else if(a instanceof I.Position){const{lineNumber:i,column:c}=M.Position.from(a);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(a instanceof I.Range)s=[M.Range.from(a)];else{s=[];for(const i of a)if(i instanceof I.Range)s.push(M.Range.from(i));else{const{lineNumber:c,column:t}=M.Position.from(i);s.push({startLineNumber:c,startColumn:t,endLineNumber:c,endColumn:t})}}return g.$tryInsertSnippet(u,E.value,s,k)},setDecorations(E,a){const k=a.length===0;k&&!_._hasDecorationsForKey.has(E.key)||(k?_._hasDecorationsForKey.delete(E.key):_._hasDecorationsForKey.add(E.key),_._runOnProxy(()=>{if(M.isDecorationOptionsArr(a))return g.$trySetDecorations(u,E.key,M.fromRangeOrRangeWithMessage(a));{const s=new Array(4*a.length);for(let i=0,c=a.length;i<c;i++){const t=a[i];s[4*i]=t.start.line+1,s[4*i+1]=t.start.character+1,s[4*i+2]=t.end.line+1,s[4*i+3]=t.end.character+1}return g.$trySetDecorationsFast(u,E.key,s)}}))},revealRange(E,a){_._runOnProxy(()=>g.$tryRevealRange(u,M.Range.from(E),a||I.TextEditorRevealType.Default))},show(E){g.$tryShowEditor(u,M.ViewColumn.from(E))},hide(){g.$tryHideEditor(u)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,l.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,l.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,l.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,l.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const g=u.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const o=g.edits.map(f=>f.range);o.sort((f,p)=>f.end.line===p.end.line?f.end.character===p.end.character?f.start.line===p.start.line?f.start.character-p.start.character:f.start.line-p.start.line:f.end.character-p.end.character:f.end.line-p.end.line);for(let f=0,p=o.length-1;f<p;f++){const D=o[f].end;if(o[f+1].start.isBefore(D))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=g.edits.map(f=>({range:M.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,r,{setEndOfLine:typeof g.setEndOfLine=="number"?M.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=L}),define(be[173],Se([1,0,12,5,7,10,47,8,64,65,48]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class C extends b.Disposable{constructor(g){super();this.controllerId=g,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new T.Emitter),this.root=new I.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const o of this.tree.values())this.updateExpandability(o)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const o=this.diff[this.diff.length-1];if(o&&g.op===1){if(o.op===1&&o.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(o.item,g.item);return}if(o.op===0&&o.item.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(o.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,o){const r=this.tree.get(g);if(!!r){if((r.expandLevels===void 0||o>r.expandLevels)&&(r.expandLevels=o),r.expand===1){const f=this.resolveChildren(r);return f.isOpen()?this.expandChildren(r,o-1):f.wait().then(()=>this.expandChildren(r,o-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,o-1)):this.expandChildren(r,o-1)}}dispose(){for(const g of this.tree.values())(0,I.getPrivateApiFor)(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,o){switch(o.op){case 2:this.pushDiff({op:4,itemId:g.fullId.toString()});break;case 1:this.removeItem(O.TestId.joinToString(g.fullId,o.id));break;case 0:this.upsertItem(o.item,g);break;case 4:for(const r of o.ops)this.onTestItemEvent(g,r);break;case 3:{const{key:r,value:f,previous:p}=o,D=g.fullId.toString();switch(r){case"canResolveChildren":this.updateExpandability(g);break;case"tags":this.diffTagRefs(f,p,D);break;case"range":this.pushDiff({op:1,item:{extId:D,item:{range:L.Range.lift(A.Range.from(f))}}});break;case"error":this.pushDiff({op:1,item:{extId:D,item:{error:A.MarkdownString.fromStrict(f)||null}}});break;default:this.pushDiff({op:1,item:{extId:D,item:{[r]:f??null}}});break}break}default:(0,M.assertNever)(o)}}upsertItem(g,o){if(!(g instanceof I.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);const r=O.TestId.fromExtHostTestItem(g,this.root.id,o?.actual),f=(0,I.getPrivateApiFor)(g);f.parent&&f.parent!==o?.actual&&f.parent.children.delete(g.id);let p=this.tree.get(r.toString());if(!p){p={fullId:r,actual:g,parent:o?r.parentId:null,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(g,o),this.pushDiff({op:0,item:{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:A.TestItem.from(g)}}),this.connectItemAndChildren(g,p,o);return}if(p.actual===g){this.connectItem(g,p,o);return}const D=p.actual.children,h=p.actual,_=(0,I.diffTestItems)(h,g);(0,I.getPrivateApiFor)(h).listener=void 0,p.actual=g,p.expand=0;for(const[E,a]of _)this.onTestItemEvent(p,{op:3,key:E,value:a,previous:h[E]});this.connectItemAndChildren(g,p,o);for(const E of D)g.children.get(E.id)||this.removeItem(O.TestId.joinToString(r,E.id))}diffTagRefs(g,o,r){const f=new Set(o.map(p=>p.id));for(const p of g)f.delete(p.id)||this.incrementTagRefs(p);this.pushDiff({op:1,item:{extId:r,item:{tags:g.map(p=>A.TestTag.namespace(this.controllerId,p.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const o=this.tags.get(g.id);o?o.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:A.TestTag.namespace(this.controllerId,g.id),ctrlLabel:this.root.label}}))}decrementTagRefs(g){const o=this.tags.get(g);o&&!--o.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.controllerId,g)}))}setItemParent(g,o){(0,I.getPrivateApiFor)(g).parent=o&&o.actual!==this.root?o.actual:void 0}connectItem(g,o,r){this.setItemParent(g,r);const f=(0,I.getPrivateApiFor)(g);f.parent=r?.actual,f.listener=p=>this.onTestItemEvent(o,p),this.updateExpandability(o)}connectItemAndChildren(g,o,r){this.connectItem(g,o,r);for(const f of g.children)this.upsertItem(f,o)}updateExpandability(g){let o;this._resolveHandler?g.resolveBarrier?o=g.resolveBarrier.isOpen()?3:2:o=g.actual.canResolveChildren?1:0:o=0,o!==g.expand&&(g.expand=o,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:o}}),o===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,o){if(o<0)return;const r=[];for(const f of g.actual.children){const p=this.expand(O.TestId.joinToString(g.fullId,f.id),o);(0,l.isThenable)(p)&&r.push(p)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const p=new l.Barrier;return p.open(),p}g.expand=2,this.pushExpandStateUpdate(g);const o=g.resolveBarrier=new l.Barrier,r=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),g.actual!==this.root&&(g.actual.error=p.stack||p.message||String(p))};let f;try{f=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(p){r(p)}return(0,l.isThenable)(f)?f.catch(r).then(()=>{o.open(),this.updateExpandability(g)}):(o.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const o=this.tree.get(g);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const r=[o];for(;r.length;){const f=r.pop();if(!!f){(0,I.getPrivateApiFor)(f.actual).listener=void 0;for(const p of f.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(f.fullId.toString());for(const p of f.actual.children)r.push(this.tree.get(O.TestId.joinToString(f.fullId,p.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.SingleUseTestCollection=C}),define(be[174],Se([1,0,3,140]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(T.IEnvironmentService)}),define(be[175],Se([1,0,26,5,17]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=M;class I{constructor(L){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let C of L.activationEvents)C==="onUri"&&(C=`onUri:${l.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(L)}}keepOnly(L){const C=new Set;L.forEach(u=>C.add(l.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>C.has(l.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,C){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const u=I._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(u.map(g=>g.identifier)),C.length>0){const g=new Set;C.forEach(o=>g.add(l.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!g.has(l.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new M(u)}static _findLoopingExtensions(L){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,p){this.addNode(f),this.addNode(p),this._arcs.has(f)?this._arcs.get(f).push(p):this._arcs.set(f,[p])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,p){const D=C.getArcs(f);for(let h=0;h<D.length;h++)if(!p.has(D[h]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let f of L){const p=l.ExtensionIdentifier.toKey(f.identifier);if(u.set(p,f),f.extensionDependencies)for(let D of f.extensionDependencies){const h=l.ExtensionIdentifier.toKey(D);C.addArc(p,h)}}let g=new Set;C.getNodes().filter(f=>C.getArcs(f).length===0).forEach(f=>g.add(f));let o=C.getNodes().filter(f=>!g.has(f)),r;do{r=!1;for(let f=0;f<o.length;f++){const p=o[f];C.hasOnlyGoodArcs(p,g)&&(o.splice(f,1),f--,g.add(p),r=!0)}}while(r);return o.map(f=>u.get(f))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const C=this._activationMap.get(L);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const C=this._extensionsMap.get(l.ExtensionIdentifier.toKey(L));return C||void 0}}e.ExtensionDescriptionRegistry=I;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,L){const C=O.isBuiltin?0:O.isUnderDevelopment?2:1,u=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(C!==u)return C-u;const g=b.posix.basename(O.extensionLocation.path),o=b.posix.basename(L.extensionLocation.path);return g<o?-1:g>o?1:0}}),define(be[92],Se([1,0,22]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var b;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function I(y){const O=l.VSBuffer.alloc(1);switch(y){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=I;function A(y,O){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A}),define(be[25],Se([1,0,5,2,3,26,147]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class A{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=A;class y{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=y;class O{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class L{constructor(a){this.dependency=a}}e.MissingExtensionDependency=L;var C;(function(E){E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(C=e.ExtensionHostKind||(e.ExtensionHostKind={}));function u(E){if(E===null)return"None";switch(E){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=u;function g(E,a){return E.enabledApiProposals?E.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=g;function o(E,a){if(!g(E,a))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.checkProposedApiEnabled=o;class r{constructor(a,k,s,i){this.codeLoadingTime=a,this.activateCallTime=k,this.activateResolvedTime=s,this.activationReason=i}}e.ActivationTimes=r;class f{constructor(a,k){this.description=a,this.value=k}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var p;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(p=e.ActivationKind||(e.ActivationKind={}));function D(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform}}e.toExtension=D;function h(E,a){return{identifier:new M.ExtensionIdentifier((0,I.getExtensionId)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!a,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.toExtensionDescription=h;class _{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,k){return Promise.resolve(0)}getInspectPorts(a,k){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,k){return Promise.resolve()}}e.NullExtensionService=_}),define(be[176],Se([1,0,14,26,25,13,12]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(f,p,D,h){this.startup=f,this.codeLoadingTime=p,this.activateCallTime=D,this.activateResolvedTime=h}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(f){this._startup=f,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(f,p){return f===-1||p===-1?-1:p-f}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class O{constructor(f,p,D,h,_,E){this.activationFailed=f,this.activationFailedError=p,this.activationTimes=D,this.module=h,this.exports=_,this.subscriptions=E}}e.ActivatedExtension=O;class L extends O{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class C extends O{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class u extends O{constructor(f){super(!0,f,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=u;let g=class{constructor(f,p,D,h,_){this._logService=_,this._registry=f,this._resolvedExtensionsSet=new Set,p.forEach(E=>this._resolvedExtensionsSet.add(T.ExtensionIdentifier.toKey(E))),this._externalExtensionsMap=new Map,D.forEach(E=>this._externalExtensionsMap.set(T.ExtensionIdentifier.toKey(E),E)),this._host=h,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[f,p]of this._operations)p.dispose()}isActivated(f){const p=this._operations.get(T.ExtensionIdentifier.toKey(f));return Boolean(p&&p.value)}getActivatedExtension(f){const p=this._operations.get(T.ExtensionIdentifier.toKey(f));if(!p||!p.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return p.value}async activateByEvent(f,p){if(this._alreadyActivatedEvents[f])return;const D=this._registry.getExtensionDescriptionsForActivationEvent(f);await this._activateExtensions(D.map(h=>({id:h.identifier,reason:{startup:p,extensionId:h.identifier,activationEvent:f}}))),this._alreadyActivatedEvents[f]=!0}activateById(f,p){const D=this._registry.getExtensionDescription(f);if(!D)throw new Error(`Extension '${f}' is not known`);return this._activateExtensions([{id:D.identifier,reason:p}])}async _activateExtensions(f){const p=f.filter(D=>!this.isActivated(D.id)).map(D=>this._handleActivationRequest(D));await Promise.all(p.map(D=>D.wait()))}_handleActivationRequest(f){if(this._operations.has(T.ExtensionIdentifier.toKey(f.id)))return this._operations.get(T.ExtensionIdentifier.toKey(f.id));if(this._externalExtensionsMap.has(T.ExtensionIdentifier.toKey(f.id)))return this._createAndSaveOperation(f,null,[],null);const p=this._registry.getExtensionDescription(f.id);if(!p){const _=new Error(`Cannot activate unknown extension '${f.id.value}'`),E=this._createAndSaveOperation(f,null,[],new u(_));return this._host.onExtensionActivationError(f.id,_,new b.MissingExtensionDependency(f.id.value)),E}const D=[],h=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;for(const _ of h){if(this._resolvedExtensionsSet.has(T.ExtensionIdentifier.toKey(_)))continue;const E=this._operations.get(T.ExtensionIdentifier.toKey(_));if(E){D.push(E);continue}if(this._externalExtensionsMap.has(T.ExtensionIdentifier.toKey(_))){D.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(T.ExtensionIdentifier.toKey(_)),reason:f.reason}));continue}const a=this._registry.getExtensionDescription(_);if(a){if(!a.main&&!a.browser)continue;D.push(this._handleActivationRequest({id:a.identifier,reason:f.reason}));continue}const k=p.displayName||p.identifier.value,s=new Error(`Cannot activate the '${k}' extension because it depends on unknown extension '${_}'`),i=this._createAndSaveOperation(f,p.displayName,[],new u(s));return this._host.onExtensionActivationError(p.identifier,s,new b.MissingExtensionDependency(_)),i}return this._createAndSaveOperation(f,p.displayName,D,null)}_createAndSaveOperation(f,p,D,h){const _=new o(f.id,p,f.reason,D,h,this._host,this._logService);return this._operations.set(T.ExtensionIdentifier.toKey(f.id),_),_}};g=Ue([Be(4,M.ILogService)],g),e.ExtensionsActivator=g;let o=class{constructor(f,p,D,h,_,E,a){this._id=f,this._displayName=p,this._reason=D,this._deps=h,this._value=_,this._host=E,this._logService=a,this._barrier=new I.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let f=0;f<this._deps.length;f++){const p=this._deps[f];if(p.value&&!p.value.activationFailed){this._deps.splice(f,1),f--;continue}if(p.value&&p.value.activationFailed){const D=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);D.detail=p.value.activationFailedError,this._value=new u(D),this._host.onExtensionActivationError(this._id,D,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(f=>f.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(f){const p=new Error;if(f&&f.name&&(p.name=f.name),f&&f.message?p.message=`Activating extension '${this._id.value}' failed: ${f.message}.`:p.message=`Activating extension '${this._id.value}' failed: ${f}.`,f&&f.stack&&(p.stack=f.stack),this._value=new u(p),this._isDisposed&&l.isCancellationError(f))return;this._host.onExtensionActivationError(this._id,p,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(f)}}};o=Ue([Be(6,M.ILogService)],o)}),define(be[177],Se([1,0,13,28,25]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends l.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:b.ExtensionHostLogFileName}))}};M=Ue([Be(0,l.ILoggerService),Be(1,T.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(be[178],Se([1,0,14]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((M,I)=>{this._actualOk=M,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(M){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=M,this._actual&&this._actualOk(M))}resolveErr(M){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=M,this._actual?this._actualErr(M):(0,l.onUnexpectedError)(M))}then(M,I){return this._ensureActual().then(M,I)}catch(M){return this._ensureActual().then(void 0,M)}finally(M){return this._ensureActual().finally(M)}}e.LazyPromise=T}),define(be[38],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const T=[];function b(A){const y=new l(A);return T[y.nid]=y,y}e.createProxyIdentifier=b;function M(A){return T[A].sid}e.getStringIdentifierForProxy=M;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(be[4],Se([1,0,54,2,38]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(D){D[D.Default=0]="Default",D[D.InCenter=1]="InCenter",D[D.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",D[D.AtTop=3]="AtTop"})(M=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(D){D[D.UnknownInput=0]="UnknownInput",D[D.TextInput=1]="TextInput",D[D.TextDiffInput=2]="TextDiffInput",D[D.NotebookInput=3]="NotebookInput",D[D.NotebookDiffInput=4]="NotebookDiffInput",D[D.CustomEditorInput=5]="CustomEditorInput",D[D.WebviewEditorInput=6]="WebviewEditorInput",D[D.TerminalEditorInput=7]="TerminalEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var A;(function(D){D[D.Editable=0]="Editable",D[D.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(D){D[D.Int8Array=1]="Int8Array",D[D.Uint8Array=2]="Uint8Array",D[D.Uint8ClampedArray=3]="Uint8ClampedArray",D[D.Int16Array=4]="Int16Array",D[D.Uint16Array=5]="Uint16Array",D[D.Int32Array=6]="Int32Array",D[D.Uint32Array=7]="Uint32Array",D[D.Float32Array=8]="Float32Array",D[D.Float64Array=9]="Float64Array",D[D.BigInt64Array=10]="BigInt64Array",D[D.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var O;(function(D){D[D.Text=1]="Text",D[D.Error=2]="Error",D[D.Rich=3]="Rich"})(O=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(D){D[D.Default=0]="Default",D[D.InCenter=1]="InCenter",D[D.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",D[D.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(D){D[D.None=0]="None",D[D.Process=1]="Process",D[D.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));class u{static mixin(h){return h._id=u._n++,h}}e.IdObject=u,u._n=0;var g;(function(D){D.label="a",D.kind="b",D.detail="c",D.documentation="d",D.sortText="e",D.filterText="f",D.preselect="g",D.insertText="h",D.insertTextRules="i",D.range="j",D.commitCharacters="k",D.additionalTextEdits="l",D.command="m",D.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var o;(function(D){D.defaultRanges="a",D.completions="b",D.isIncomplete="c",D.duration="d"})(o=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var r;(function(D){D[D.File=1]="File",D[D.Text=2]="Text",D[D.Cell=3]="Cell"})(r=e.WorkspaceEditType||(e.WorkspaceEditType={}));function f(D){if(D&&D.edits)for(const h of D.edits)typeof h.resource=="object"?h.resource=T.URI.revive(h.resource):(h.newUri=T.URI.revive(h.newUri),h.oldUri=T.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,l.revive)(h.metadata));return D}e.reviveWorkspaceEditDto=f;var p;(function(D){D[D.Workspace=0]="Workspace",D[D.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createProxyIdentifier)("ExtHostTelemetry")}}),define(be[67],Se([1,0,4,5,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,O){return this._proxy.$setPassword(A,y,O)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(be[68],Se([1,0,3,13,4,15]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,O){this._extHostLogService=O,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(b.MainContext.MainThreadTelemetry)}report(y,O,L){const C=this.getUsageKey(y,O);this._reportedUsages.has(C)||(this._reportedUsages.add(C),O.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:O.identifier.value,apiId:y}))}getUsageKey(y,O){return`${y}-${O.identifier.value}`}};I=Ue([Be(0,M.IExtHostRpcService),Be(1,T.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,O){}})}),define(be[179],Se([1,0,5,4,6,26]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,O,L,C={}){const u=M.ExtensionIdentifier.toKey(y.identifier),g=this._inFlightRequests.get(u)||[],o=[...L].sort().join(" ");let r=g.find(f=>f.scopes===o);if(r)return r.result;{const f=this._getSession(y,u,O,L,C);r={scopes:o,result:f},g.push(r),this._inFlightRequests.set(u,g);try{await f}finally{const p=g.findIndex(D=>D.scopes===o);p>-1&&(g.splice(p),this._inFlightRequests.set(u,g))}return f}}async _getSession(y,O,L,C,u={}){await this._proxy.$ensureProvider(L);const g=y.displayName||y.name;return this._proxy.$getSession(L,C,O,g,u)}async removeSession(y,O){const L=this._authenticationProviders.get(y);return L?L.provider.removeSession(O):this._proxy.$removeSession(y,O)}registerAuthenticationProvider(y,O,L,C){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:O,provider:L,options:C??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===y)||this._providers.push({id:y,label:O});const u=L.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(y,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,O,C?.supportsMultipleAccounts??!1),new b.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(y);const g=this._providers.findIndex(o=>o.id===y);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,O){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.createSession(O));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,O){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.removeSession(O));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,O){const L=this._authenticationProviders.get(y);if(L)return Promise.resolve(L.provider.getSessions(O));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,O){return this._onDidChangeSessions.fire({provider:{id:y,label:O}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(be[180],Se([1,0,4,15,8]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,y){this._proxy=A.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:O=>y.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A){const y=b.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(y)}};M=Ue([Be(0,T.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(be[181],Se([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(M){const I=M.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=T});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[39],Se([1,0,10,6,8,27,4,16,13,54,48,231,2,7,3,15,47,22,38,43]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){_.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ge(this,_,t.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=n,this.converter=new a(this,m=>{const d=this._apiCommands.get(m);return d?.result===s.Void?d:void 0},n),this._argumentProcessors=[{processArgument(m){return(0,O.revive)(m)}},{processArgument(m){return(0,M.cloneAndChange)(m,function(d){if(L.Range.isIRange(d))return b.Range.to(d);if(C.Position.isIPosition(d))return b.Position.to(d);if(L.Range.isIRange(d.range)&&u.URI.isUri(d.uri))return b.location.to(d);if(d instanceof p.VSBuffer)return d.buffer.buffer;if(!Array.isArray(d))return d})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...m)=>{const d=t.args.map((P,B)=>{if(!P.validate(m[B]))throw new Error(`Invalid argument '${P.name}' when running '${t.id}', received: ${m[B]}`);return P.convert(m[B])}),S=await this.executeCommand(t.internalId,...d);return t.result.convert(S,m,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,m,d,S,P){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:m,thisArg:d,description:S,extension:P}),t&&Te(this,_,"f").$registerCommand(n),new T.Disposable(()=>{this._commands.delete(n)&&t&&Te(this,_,"f").$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,m){if(this._commands.has(t))return this._executeContributedCommand(t,n,!1);{let d=!1;const S=(0,M.cloneAndChange)(n,function(P){if(P instanceof T.Position)return b.Position.from(P);if(P instanceof T.Range)return b.Range.from(P);if(P instanceof T.Location)return b.location.from(P);if(T.NotebookRange.isNotebookRange(P))return b.NotebookRange.from(P);if(P instanceof ArrayBuffer)return d=!0,p.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return d=!0,p.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await Te(this,_,"f").$executeCommand(t,d?new D.SerializableObjectWithBuffers(S):S,m);return(0,O.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw P}}}async _executeContributedCommand(t,n,m){const d=this._commands.get(t);if(!d)throw new Error("Unknown command");let{callback:S,thisArg:P,description:B}=d;if(B)for(let F=0;F<B.args.length;F++)try{(0,l.validateConstraint)(n[F],B.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${B.args[F].name}' - ${B.args[F].description}`)}try{return await S.apply(P,n)}catch(F){if(t===this.converter.delegatingCommandId){const v=this.converter.getActualCommand(...n);v&&(t=v.command)}throw this._logService.error(F,t,d.extension?.identifier),m?new class extends Error{constructor(){super((0,h.toErrorMessage)(F));this.id=t,this.source=d.extension?.displayName??d.extension?.name}}:F}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(m=>this._argumentProcessors.reduce((d,S)=>S.processArgument(d),m)),this._executeContributedCommand(t,n,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),Te(this,_,"f").$getCommands().then(n=>(t&&(n=n.filter(m=>m[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,m]of this._commands){let{description:d}=m;d&&(t[n]=d)}return Promise.resolve(t)}};_=new WeakMap,E=Ue([Be(0,r.IExtHostRpcService),Be(1,y.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class a{constructor(t,n,m){this._commands=t,this._lookupApiCommand=n,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const m={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return m;const d=this._lookupApiCommand(t.command);if(d)m.id=d.internalId,m.arguments=d.args.map((S,P)=>S.convert(t.arguments&&t.arguments[P]));else if((0,A.isNonEmptyArray)(t.arguments)){const S=++this._cachIdPool;this._cache.set(S,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(S),this._logService.trace("CommandsConverter#DISPOSE",S)})),m.$ident=S,m.id=this.delegatingCommandId,m.arguments=[S],this._logService.trace("CommandsConverter#CREATE",t.command,S)}return m}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class k{constructor(t,n,m,d){this.name=t,this.description=n,this.validate=m,this.convert=d}optional(){return new k(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new k(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=k,k.Uri=new k("uri","Uri of a text document",c=>u.URI.isUri(c),c=>c),k.Position=new k("position","A position in a text document",c=>T.Position.isPosition(c),b.Position.from),k.Range=new k("range","A range in a text document",c=>T.Range.isRange(c),b.Range.from),k.Selection=new k("selection","A selection in a text document",c=>T.Selection.isSelection(c),b.Selection.from),k.Number=new k("number","",c=>typeof c=="number",c=>c),k.String=new k("string","",c=>typeof c=="string",c=>c),k.CallHierarchyItem=new k("item","A call hierarchy item",c=>c instanceof T.CallHierarchyItem,b.CallHierarchyItem.from),k.TypeHierarchyItem=new k("item","A type hierarchy item",c=>c instanceof T.TypeHierarchyItem,b.TypeHierarchyItem.from),k.TestItem=new k("testItem","A VS Code TestItem",c=>c instanceof f.TestItemImpl,b.TestItem.from);class s{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=s,s.Void=new s("no result",c=>c);class i{constructor(t,n,m,d,S){this.id=t,this.internalId=n,this.description=m,this.args=d,this.result=S}}e.ApiCommand=i}),define(be[182],Se([1,0,2,8,6,66,39,16,78,81,11]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(T.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,f)=>{if((0,A.isFalsyOrEmpty)(r))return;class p extends b.SymbolInformation{static to(h){const _=new p(h.name,T.SymbolKind.to(h.kind),h.containerName||"",new b.Location(f[0],T.Range.to(h.range)));return _.detail=h.detail,_.range=_.location.range,_.selectionRange=T.Range.to(h.selectionRange),_.children=h.children?h.children.map(p.to):[],_}}return r.map(p.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(T.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(T.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new I.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(T.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",o)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(T.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(T.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(f=>b.Position.isPosition(f)),r=>r.map(T.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(f=>{let p;for(const D of f.reverse())p=new b.SelectionRange(T.Range.to(D),p);return p}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(T.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(!!r)return{range:T.Range.to(r.range),placeholder:r.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return T.WorkspaceEdit.to(r)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(T.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new b.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const f=(0,y.decodeSemanticTokensDto)(r);if(f.type==="full")return new b.SemanticTokens(f.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new b.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const f=(0,y.decodeSemanticTokensDto)(r);if(f.type==="full")return new b.SemanticTokens(f.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,f,p)=>{if(!r)return new b.CompletionList([]);const D=r.suggestions.map(h=>T.CompletionItem.to(h,p));return new b.CompletionList(D,r.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return T.SignatureHelp.to(r)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,f,p)=>g(D=>new b.CodeLens(T.Range.to(D.range),D.command&&p.fromInternal(D.command)))(r))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>b.Range.isRange(r),r=>b.Selection.isSelection(r)?T.Selection.from(r):T.Range.from(r)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,f,p)=>g(D=>{if(D._isSynthetic){if(!D.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(D.command)}else{const h=new b.CodeAction(D.title,D.kind?new b.CodeActionKind(D.kind):void 0);return D.edit&&(h.edit=T.WorkspaceEdit.to(D.edit)),D.command&&(h.command=p.fromInternal(D.command)),h.isPreferred=D.isPreferred,h}})(r))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(f=>new b.ColorInformation(T.Range.to(f.range),T.Color.to(f.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",r=>r instanceof b.Color,T.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:T.Range.from(r.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(T.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,f,p)=>r.map(T.InlayHint.to.bind(void 0,p)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(f=>T.NotebookExclusiveDocumentPattern.to(f))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(T.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>l.URI.isUri(r)||typeof r=="string"&&(0,O.matchesSomeScheme)(r,L.Schemas.http,L.Schemas.https),r=>r),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[T.ViewColumn.from(r),void 0]:[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[T.ViewColumn.from(r),void 0]:[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(T.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(T.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(T.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class u{static register(f){C.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=u;function g(r){return f=>{if(Array.isArray(f))return f.map(r)}}function o(r){if(!Array.isArray(r))return;const f=[];for(const p of r)M.isLocationLink(p)?f.push(T.DefinitionLink.to(p)):f.push(T.location.to(p));return f}}),define(be[183],Se([1,0,12,52,5,7,2,66,26,8,6,25,4]),function(J,e,l,T,b,M,I,A,y,O,L,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function g(o,r,f){const p=o.getProxy(u.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,r.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const n=this._commentControllers.get(t.handle);return n?n.value:t}else if(t&&t.$mid===7){const n=this._commentControllers.get(t.commentControlHandle);if(!n)return t;const m=n.getCommentThread(t.commentThreadHandle);return m?m.value:t}else if(t&&t.$mid===8){const n=this._commentControllers.get(t.thread.commentControlHandle);if(!n)return t;const m=n.getCommentThread(t.thread.commentThreadHandle);return m?{thread:m.value,text:t.text}:t}else if(t&&t.$mid===9){const n=this._commentControllers.get(t.thread.commentControlHandle);if(!n)return t;const m=n.getCommentThread(t.thread.commentThreadHandle);if(!m)return t;let d=t.commentUniqueId,S=m.getCommentByUniqueId(d);return S||t}else if(t&&t.$mid===10){const n=this._commentControllers.get(t.thread.commentControlHandle);if(!n)return t;const m=n.getCommentThread(t.thread.commentThreadHandle);if(!m)return t;let d=t.text,S=t.commentUniqueId,P=m.getCommentByUniqueId(S);return P?(P.body=d,P):t}return t}})}createCommentController(t,n,m){const d=D.handlePool++,S=new _(t,d,n,m);this._commentControllers.set(S.handle,S);const P=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(t.identifier))||[];return P.push(S),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(t.identifier),P),S.value}$createCommentThreadTemplate(t,n,m){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(n,m)}async $updateCommentThreadTemplate(t,n,m){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(n,m)}$deleteCommentThread(t,n){const m=this._commentControllers.get(t);m&&m.$deleteCommentThread(n)}$provideCommentingRanges(t,n,m){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const S=f.getDocument(I.URI.revive(n));return(0,l.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(S,m)).then(P=>P?P.map(B=>O.Range.from(B)):void 0)}$toggleReaction(t,n,m,d,S){const P=this._commentControllers.get(t);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const B=P.getCommentThread(n);if(B){const F=B.getCommentByUniqueId(d.uniqueIdInThread);if(P!==void 0&&F&&P.reactionHandler)return P.reactionHandler(F,k(S))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class h{constructor(t,n,m,d,S,P,B){this._commentControllerHandle=n,this._id=m,this._uri=d,this._range=S,this._comments=P,this.extensionDescription=B,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),p.$createCommentThread(n,this.handle,this._id,this._uri,O.Range.from(this._range),B.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(n,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(v){F.range=v},get comments(){return F.comments},set comments(v){F.comments=v},get collapsibleState(){return F.collapsibleState},set collapsibleState(v){F.collapsibleState=v},get canReply(){return F.canReply},set canReply(v){F.canReply=v},get contextValue(){return F.contextValue},set contextValue(v){F.contextValue=v},get label(){return F.label},set label(v){F.label=v},get state(){return F.state},set state(v){F.state=v},dispose:()=>{F.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,C.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,C.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const t=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),n={};t("range")&&(n.range=O.Range.from(this._range)),t("label")&&(n.label=this.label),t("contextValue")&&(n.contextValue=this.contextValue??null),t("comments")&&(n.comments=this._comments.map(m=>E(this,m,this._commentsMap))),t("collapsibleState")&&(n.collapseState=s(this._collapseState)),t("canReply")&&(n.canReply=this.canReply),t("state")&&(n.state=i(this._state)),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(t){for(let n of this._commentsMap){let m=n[0],d=n[1];if(t===d)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}h._handlePool=0,Ue([(0,T.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class _{constructor(t,n,m,d){this._extension=t,this._handle=n,this._id=m,this._label=d,this._threads=new Map,p.$registerCommentController(this.handle,m,d);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(P){S.options=P},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(P){S.commentingRangeProvider=P},get reactionHandler(){return S.reactionHandler},set reactionHandler(P){S.reactionHandler=P},createCommentThread(P,B,F){return S.createCommentThread(P,B,F).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,n,m,d){if(typeof t=="string"){const S=new h(this.id,this.handle,t,n,m,d,this._extension);return this._threads.set(S.handle,S),S}else{const S=new h(this.id,this.handle,void 0,t,n,m,this._extension);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(t,n){const m=new h(this.id,this.handle,void 0,I.URI.revive(t),O.Range.to(n),[],this._extension);return m.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(t,n){let m=this._threads.get(t);m&&(m.range=O.Range.to(n))}$deleteCommentThread(t){let n=this._threads.get(t);n&&n.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function E(c,t,n){let m=n.get(t);m||(m=++c.commentHandle,n.set(t,m));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:m,body:typeof t.body=="string"?t.body:O.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(S=>a(S)):void 0,timestamp:t.timestamp?.toJSON()}}function a(c){return{label:c.label,iconPath:c.iconPath?O.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function k(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?I.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function s(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new D}e.createExtHostComments=g}),define(be[93],Se([1,0,2,4,6,3,15,13,16,9,17]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yi{constructor(g,o){this._logService=o,this._provider=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,o){const r=yi._handlePool++;this._provider.set(r,{provider:g,extensionId:o}),this._proxy.$registerDecorationProvider(r,o.value);const f=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(r,null);return}let D=(0,y.asArray)(p);if(D.length<=yi._maxEventSize){this._proxy.$onDidChange(r,D);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,D.length);const h=D.map(a=>({uri:a,rank:(0,O.count)(a.path,"/")})),_=(0,y.groupBy)(h,(a,k)=>a.rank-k.rank||(0,O.compare)(a.uri.path,k.uri.path));let E=[];e:for(let a of _){let k;for(let s of a){let i=(0,L.dirname)(s.uri.path);if(k!==i&&(k=i,E.push(s.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(r,E)});return new b.Disposable(()=>{f?.dispose(),this._proxy.$unregisterDecorationProvider(r),this._provider.delete(r)})}async $provideDecorations(g,o,r){if(!this._provider.has(g))return Object.create(null);const f=Object.create(null),{provider:p,extensionId:D}=this._provider.get(g);return await Promise.all(o.map(async h=>{try{const{uri:_,id:E}=h,a=await Promise.resolve(p.provideFileDecoration(l.URI.revive(_),r));if(!a)return;try{b.FileDecoration.validate(a),f[E]=[a.propagate,a.tooltip,a.badge,a.color]}catch(k){this._logService.warn(`INVALID decoration from extension '${D.value}': ${k}`)}}catch(_){this._logService.error(_)}})),f}};C._handlePool=0,C._maxEventSize=250,C=Ue([Be(0,I.IExtHostRpcService),Be(1,A.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[184],Se([1,0,124,80,2,4,6,8,5,13,23,30]),function(J,e,l,T,b,M,I,A,y,O,L,C){"use strict";var u,g,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class r{constructor(D,h,_,E,a,k){this._name=D,this._owner=h,this._maxDiagnosticsPerFile=_,u.set(this,void 0),g.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ge(this,o,new L.ResourceMap(s=>E.getComparisonKey(s)),"f"),Ge(this,u,a,"f"),Ge(this,g,k,"f")}dispose(){this._isDisposed||(Te(this,g,"f").fire([...Te(this,o,"f").keys()]),Te(this,u,"f")&&Te(this,u,"f").$clear(this._owner),Te(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(D,h){if(!D){this.clear();return}this._checkDisposed();let _=[];if(b.URI.isUri(D)){if(!h){this.delete(D);return}Te(this,o,"f").set(D,h.slice()),_=[D]}else if(Array.isArray(D)){_=[];let a;D=[...D].sort(r._compareIndexedTuplesByUri);for(const k of D){const[s,i]=k;if((!a||s.toString()!==a.toString())&&(a&&Te(this,o,"f").get(a).length===0&&Te(this,o,"f").delete(a),a=s,_.push(s),Te(this,o,"f").set(s,[])),i){const c=Te(this,o,"f").get(s);c&&c.push(...i)}else{const c=Te(this,o,"f").get(s);c&&(c.length=0)}}}if(Te(this,g,"f").fire(_),!Te(this,u,"f"))return;const E=[];for(let a of _){let k=[];const s=Te(this,o,"f").get(a);if(s)if(s.length>this._maxDiagnosticsPerFile){k=[];const i=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(let t of s)if(t.severity===i[c]&&k.push(A.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;k.push({severity:T.MarkerSeverity.Info,message:(0,l.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:k[k.length-1].startLineNumber,startColumn:k[k.length-1].startColumn,endLineNumber:k[k.length-1].endLineNumber,endColumn:k[k.length-1].endColumn})}else k=s.map(i=>A.Diagnostic.from(i));E.push([a,k])}Te(this,u,"f").$changeMany(this._owner,E)}delete(D){this._checkDisposed(),Te(this,g,"f").fire([D]),Te(this,o,"f").delete(D),Te(this,u,"f")&&Te(this,u,"f").$changeMany(this._owner,[[D,void 0]])}clear(){this._checkDisposed(),Te(this,g,"f").fire([...Te(this,o,"f").keys()]),Te(this,o,"f").clear(),Te(this,u,"f")&&Te(this,u,"f").$clear(this._owner)}forEach(D,h){this._checkDisposed();for(let _ of Te(this,o,"f").keys())D.apply(h,[_,this.get(_),this])}get(D){this._checkDisposed();const h=Te(this,o,"f").get(D);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(D){return this._checkDisposed(),Array.isArray(Te(this,o,"f").get(D))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(D,h){return D[0].toString()<h[0].toString()?-1:D[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=r,u=new WeakMap,g=new WeakMap,o=new WeakMap;let f=class ai{constructor(D,h,_){this._logService=h,this._fileSystemInfoService=_,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,ai._mapper),this._proxy=D.getProxy(M.MainContext.MainThreadDiagnostics)}static _mapper(D){const h=new L.ResourceMap;for(const _ of D)h.set(_,_);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(D,h){const{_collections:_,_proxy:E,_onDidChangeDiagnostics:a,_logService:k,_fileSystemInfoService:s}=this,i=new class{$changeMany(n,m){E.$changeMany(n,m),k.trace("[DiagnosticCollection] change many (extension, owner, uris)",D.value,n,m.length===0?"CLEARING":m)}$clear(n){E.$clear(n),k.trace("[DiagnosticCollection] remove all (extension, owner)",D.value,n)}dispose(){E.dispose()}};let c;if(!h)h="_generated_diagnostic_collection_name_#"+ai._idPool++,c=h;else if(!_.has(h))c=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do c=h+ai._idPool++;while(_.has(c))}return new class extends r{constructor(){super(h,c,ai._maxDiagnosticsPerFile,s.extUri,i,a);_.set(c,this)}dispose(){super.dispose(),_.delete(c)}}}getDiagnostics(D){if(D)return this._getDiagnostics(D);{const h=new Map,_=[];for(const E of this._collections.values())E.forEach((a,k)=>{let s=h.get(a.toString());typeof s=="undefined"&&(s=_.length,h.set(a.toString(),s),_.push([a,[]])),_[s][1]=_[s][1].concat(...k)});return _}}_getDiagnostics(D){let h=[];for(let _ of this._collections.values())_.has(D)&&(h=h.concat(_.get(D)));return h}$acceptMarkersChange(D){if(!this._mirrorCollection){const h="_generated_mirror",_=new r(h,h,ai._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,_),this._mirrorCollection=_}for(const[h,_]of D)this._mirrorCollection.set(b.URI.revive(h),_.map(A.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=Ue([Be(1,O.ILogService),Be(2,C.IExtHostFileSystemInfo)],f),e.ExtHostDiagnostics=f}),define(be[185],Se([1,0,2,4]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(I){this._proxy=I.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(A=>A?A.map(y=>l.URI.revive(y)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(A=>A?l.URI.revive(A):void 0)}}e.ExtHostDialogs=b}),define(be[186],Se([1,0,14,2,6,4,11,20,9]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class O{constructor(C,u,g){this._documentsAndEditors=u,this._logService=g,this._documentContentProviders=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,u){if(Object.keys(I.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const g=O._handlePool++;this._documentContentProviders.set(g,u),this._proxy.$registerTextContentProvider(g,C);let o;return typeof u.onDidChange=="function"&&(o=u.onDidChange(r=>{if(r.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${r.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(r)&&this.$provideTextDocumentContent(g,r).then(f=>{if(!f&&typeof f!="string")return;const p=this._documentsAndEditors.getDocument(r);if(!p)return;const D=(0,y.splitLines)(f);if(!p.equalLines(D))return this._proxy.$onVirtualDocumentChange(r,f)},l.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(C,u){const g=this._documentContentProviders.get(C);return g?Promise.resolve(g.provideTextDocumentContent(T.URI.revive(u),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=O,O._handlePool=0}),define(be[187],Se([1,0,5,7,2,4,86,8,10,27,6]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(g,o){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const f of r)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const f of r)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const o=this._documentsAndEditors.getDocument(g);if(o)return o}getDocument(g){const o=this.getDocumentData(g);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return o.document}ensureDocumentData(g){const o=this._documentsAndEditors.getDocument(g);if(o)return Promise.resolve(o);let r=this._documentLoader.get(g.toString());return r||(r=this._proxy.$tryOpenDocument(g).then(f=>{this._documentLoader.delete(g.toString());const p=b.URI.revive(f);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(p))},f=>(this._documentLoader.delete(g.toString()),Promise.reject(f))),this._documentLoader.set(g.toString(),r)),r}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(o=>b.URI.revive(o))}$acceptModelLanguageChanged(g,o){const r=b.URI.revive(g),f=this._documentsAndEditors.getDocument(r);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(o),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(g){const o=b.URI.revive(g),r=this._documentsAndEditors.getDocument(o);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(g,o){const r=b.URI.revive(g),f=this._documentsAndEditors.getDocument(r);if(!f)throw new Error("unknown document");f._acceptIsDirty(o),this._onDidChangeDocument.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,o,r){const f=b.URI.revive(g),p=this._documentsAndEditors.getDocument(f);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(o);let D;o.isUndoing?D=L.TextDocumentChangeReason.Undo:o.isRedoing&&(D=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,O.deepFreeze)({document:p.document,contentChanges:o.changes.map(h=>({range:A.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:D}))}setWordDefinitionFor(g,o){(0,I.setWordDefinitionFor)(g,o)}}e.ExtHostDocuments=C}),define(be[49],Se([1,0,42,5,7,2,3,4,86,15,91,8,13,23,11,163,232]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(_){this.value=_,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let D=class{constructor(_,E){this._extHostRpc=_,this._logService=E,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(_){this.acceptDocumentsAndEditorsDelta(_)}acceptDocumentsAndEditorsDelta(_){const E=[],a=[],k=[];if(_.removedDocuments)for(const s of _.removedDocuments){const i=M.URI.revive(s),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),E.push(c.value))}if(_.addedDocuments)for(const s of _.addedDocuments){const i=M.URI.revive(s.uri);let c=this._documents.get(i);if(c&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new p(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,c),a.push(c.value)),c.ref()}if(_.removedEditors)for(const s of _.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&k.push(i)}if(_.addedEditors)for(const s of _.addedEditors){const i=M.URI.revive(s.documentUri);l.ok(this._documents.has(i),`document '${i}' does not exist`),l.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(i).value,t=new L.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new f.Lazy(()=>c.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(n=>C.Range.to(n)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,t)}_.newActiveEditor!==void 0&&(l.ok(_.newActiveEditor===null||this._editors.has(_.newActiveEditor),`active editor '${_.newActiveEditor}' does not exist`),this._activeEditorId=_.newActiveEditor),(0,b.dispose)(E),(0,b.dispose)(k),_.removedDocuments&&this._onDidRemoveDocuments.fire(E),_.addedDocuments&&this._onDidAddDocuments.fire(a),(_.removedEditors||_.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),_.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(_){return this._documents.get(_)?.value}allDocuments(){return r.Iterable.map(this._documents.values(),_=>_.value)}getEditor(_){return this._editors.get(_)}activeEditor(_){if(!this._activeEditorId)return;const E=this._editors.get(this._activeEditorId);return _?E:E?.value}allEditors(){return[...this._editors.values()]}};D=Ue([Be(0,O.IExtHostRpcService),Be(1,u.ILogService)],D),e.ExtHostDocumentsAndEditors=D,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[69],Se([1,0,8,4,2,5,3,6,15,10]),function(J,e,l,T,b,M,I,A,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class L{constructor(o,r,f){this._activeTabIdGetter=f,this._parentGroup=r,this.acceptDtoUpdate(o)}get apiObject(){const o=this;if(!this._apiObject){const r={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get kind(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(r)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 5:return new A.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new A.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new A.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new A.TerminalEditorTabInput;default:return}}}class C{constructor(o,r,f){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=f;for(const p of o.tabs)p.isActive&&(this._activeTabId=p.id),this._tabs.push(new L(p,this,()=>this.activeTabId()))}get apiObject(){const o=this;if(!this._apiObject){const r={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(f=>f.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(f=>f.apiObject))}};this._apiObject=Object.freeze(r)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabDtoUpdate(o){const r=this._tabs.find(f=>f.tabId===o.id);if(!r)throw new Error("INVALID tab");return o.isActive&&(this._activeTabId=o.id),r.acceptDtoUpdate(o),r}activeTabId(){return this._activeTabId}}let u=class{constructor(o){this._onDidChangeTab=new M.Emitter,this._onDidChangeTabGroup=new M.Emitter,this._onDidChangeActiveTabGroup=new M.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,r={onDidChangeTabGroup:o._onDidChangeTabGroup.event,onDidChangeActiveTabGroup:o._onDidChangeActiveTabGroup.event,onDidChangeTab:o._onDidChangeTab.event,get groups(){return Object.freeze(o._extHostTabGroups.map(f=>f.apiObject))},get activeTabGroup(){const f=o._activeGroupId;return(0,O.assertIsDefined)(o._extHostTabGroups.find(D=>D.groupId===f)?.apiObject)},close:async(f,p)=>{const D=Array.isArray(f)?f:[f],h=[];for(const _ of D){const E=this._findExtHostTabFromApi(_);if(!E)throw new Error("Tab close: Invalid tab not found!");h.push(E.tabId)}this._proxy.$closeTab(h,p)},move:async(f,p,D,h)=>{const _=this._findExtHostTabFromApi(f);if(!_)throw new Error("Invalid tab");this._proxy.$moveTab(_.tabId,D,l.ViewColumn.from(p),h)}};this._apiObject=Object.freeze(r)}return this._apiObject}_findExtHostTabFromApi(o){for(const r of this._extHostTabGroups)for(const f of r.tabs)if(f.apiObject===o)return f}$acceptEditorTabModel(o){this._extHostTabGroups=o.map(f=>new C(f,this._proxy,()=>this._activeGroupId));const r=(0,O.assertIsDefined)(o.find(f=>f.isActive===!0)?.groupId);r!==void 0&&this._activeGroupId!==r&&(this._activeGroupId=r,this._onDidChangeActiveTabGroup.fire(this.tabGroups.activeTabGroup)),this._onDidChangeTabGroup.fire()}$acceptTabGroupUpdate(o){const r=this._extHostTabGroups.find(f=>f.groupId===o.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");if(r.acceptGroupDtoUpdate(o),o.isActive){const f=this._activeGroupId;this._activeGroupId=o.groupId,f!==this._activeGroupId&&this._onDidChangeActiveTabGroup.fire(r.apiObject)}this._onDidChangeTabGroup.fire()}$acceptTabUpdate(o,r){const f=this._extHostTabGroups.find(D=>D.groupId===o);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const p=f.acceptTabDtoUpdate(r);this._onDidChangeTab.fire(p.apiObject)}};u=Ue([Be(0,y.IExtHostRpcService)],u),e.ExtHostEditorTabs=u}),define(be[188],Se([1,0,2,4,7,6,8,233,9,22,25]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const r=this._schemes.indexOf(o);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),r=[];let f,p,D=14,h=14;for(const _ of o){let E=f?(0,y.commonPrefixLength)(f,_):0;for(E===0?p=1:p=h;E<_.length;E++)E+1===_.length?(D=h,h=9):h+=1,r.push([p,_.toUpperCase().charCodeAt(E),h]),r.push([p,_.toLowerCase().charCodeAt(E),h]),p=h;f=_,h=D}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new A.StateMachine(r)}}provideDocumentLinks(o){this._initStateMachine();const r=[],f=A.LinkComputer.computeLinks({getLineContent(p){return o.lineAt(p-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const p of f){const D=I.DocumentLink.to(p);D.target&&r.push(D)}return r}}class u{constructor(o,r){this._extHostLanguageFeatures=r,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(o,r,f,p={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(o,"*",this._linkProvider));const D=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(D,f);let h=2;p.isCaseSensitive&&(h+=1024),p.isReadonly&&(h+=2048),typeof f.copy=="function"&&(h+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&((0,L.checkProposedApiEnabled)(o,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(D,r,h).catch(E=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${r}`),console.error(E)});const _=f.onDidChangeFile(E=>{const a=[];for(const k of E){let{uri:s,type:i}=k;if(s.scheme!==r)continue;let c;switch(i){case M.FileChangeType.Changed:c=0;break;case M.FileChangeType.Created:c=1;break;case M.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:s,type:c})}this._proxy.$onFileSystemChange(D,a)});return(0,b.toDisposable)(()=>{_.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(o){const{type:r,ctime:f,mtime:p,size:D,permissions:h}=o;return{type:r,ctime:f,mtime:p,size:D,permissions:h}}$stat(o,r){return Promise.resolve(this._getFsProvider(o).stat(l.URI.revive(r))).then(f=>u._asIStat(f))}$readdir(o,r){return Promise.resolve(this._getFsProvider(o).readDirectory(l.URI.revive(r)))}$readFile(o,r){return Promise.resolve(this._getFsProvider(o).readFile(l.URI.revive(r))).then(f=>O.VSBuffer.wrap(f))}$writeFile(o,r,f,p){return Promise.resolve(this._getFsProvider(o).writeFile(l.URI.revive(r),f.buffer,p))}$delete(o,r,f){return Promise.resolve(this._getFsProvider(o).delete(l.URI.revive(r),f))}$rename(o,r,f,p){return Promise.resolve(this._getFsProvider(o).rename(l.URI.revive(r),l.URI.revive(f),p))}$copy(o,r,f,p){const D=this._getFsProvider(o);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(l.URI.revive(r),l.URI.revive(f),p))}$mkdir(o,r){return Promise.resolve(this._getFsProvider(o).createDirectory(l.URI.revive(r)))}$watch(o,r,f,p){const D=this._getFsProvider(o).watch(l.URI.revive(f),p);this._watches.set(r,D)}$unwatch(o,r){const f=this._watches.get(r);f&&(f.dispose(),this._watches.delete(r))}$open(o,r,f){const p=this._getFsProvider(o);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(l.URI.revive(r),f))}$close(o,r){const f=this._getFsProvider(o);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(r))}$read(o,r,f,p){const D=this._getFsProvider(o);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const h=O.VSBuffer.alloc(p);return Promise.resolve(D.read(r,f,h.buffer,0,p)).then(_=>h.slice(0,_))}$write(o,r,f,p){const D=this._getFsProvider(o);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(r,f,p.buffer,0,p.byteLength))}_getFsProvider(o){const r=this._fsProvider.get(o);if(!r){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return r}}e.ExtHostFileSystem=u}),define(be[50],Se([1,0,4,45,6,22,3,15,30,7]),function(J,e,l,T,b,M,I,A,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class qt{constructor(u,g){this._fileSystemProvider=new Map,this._proxy=u.getProxy(l.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(r){try{const f=o._fileSystemProvider.get(r.scheme);if(!f)return await o._proxy.$stat(r);await o._proxy.$ensureActivation(r.scheme);const p=await f.stat(r);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions}}catch(f){qt._handleError(f)}},async readDirectory(r){try{const f=o._fileSystemProvider.get(r.scheme);return f?(await o._proxy.$ensureActivation(r.scheme),(await f.readDirectory(r)).slice()):await o._proxy.$readdir(r)}catch(f){return qt._handleError(f)}},async createDirectory(r){try{return await o._proxy.$mkdir(r)}catch(f){return qt._handleError(f)}},async readFile(r){try{const f=o._fileSystemProvider.get(r.scheme);return f?(await o._proxy.$ensureActivation(r.scheme),(await f.readFile(r)).slice()):(await o._proxy.$readFile(r)).buffer}catch(f){return qt._handleError(f)}},async writeFile(r,f){try{return await o._proxy.$writeFile(r,M.VSBuffer.wrap(f))}catch(p){return qt._handleError(p)}},async delete(r,f){try{const p=o._fileSystemProvider.get(r.scheme);return p?(await o._proxy.$ensureActivation(r.scheme),await p.delete(r,{recursive:!1,...f})):await o._proxy.$delete(r,{recursive:!1,useTrash:!1,...f})}catch(p){return qt._handleError(p)}},async rename(r,f,p){try{return await o._proxy.$rename(r,f,{overwrite:!1,...p})}catch(D){return qt._handleError(D)}},async copy(r,f,p){try{return await o._proxy.$copy(r,f,{overwrite:!1,...p})}catch(D){return qt._handleError(D)}},isWritableFileSystem(r){const f=g.getCapabilities(r);if(typeof f=="number")return!(f&2048)}})}static _handleError(u){if(u instanceof b.FileSystemError)throw u;if(!(u instanceof Error))throw new b.FileSystemError(String(u));if(u.name==="ENOPRO")throw b.FileSystemError.Unavailable(u.message);switch(u.name){case T.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(u.message);default:throw new b.FileSystemError(u.message,u.name)}}addFileSystemProvider(u,g){return this._fileSystemProvider.set(u,g),(0,O.toDisposable)(()=>this._fileSystemProvider.delete(u))}};L=Ue([Be(0,A.IExtHostRpcService),Be(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(be[189],Se([1,0,5,29,2,4,8,6]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,u,g,o,r,f,p,D){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const h=this.ensureWatching(C,g,r);this._config=0,f&&(this._config+=1),p&&(this._config+=2),D&&(this._config+=4);const _=(0,T.parse)(r),E=typeof r=="string",a=o(k=>{if(!f)for(let s of k.created){const i=b.URI.revive(s);_(i.fsPath)&&(!E||u.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!p)for(let s of k.changed){const i=b.URI.revive(s);_(i.fsPath)&&(!E||u.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!D)for(let s of k.deleted){const i=b.URI.revive(s);_(i.fsPath)&&(!E||u.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=A.Disposable.from(h,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(C,u,g){let o=A.Disposable.from();if(typeof g=="string")return o;const r=C.getProxy(M.MainContext.MainThreadFileSystem);let f=!1;(g.pattern.includes(T.GLOBSTAR)||g.pattern.includes(T.GLOB_SPLIT))&&(f=!0);const p=Math.random();return r.$watch(u.identifier.value,p,g.baseUri,{recursive:f,excludes:[]}),A.Disposable.from({dispose:()=>r.$unwatch(p)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class O{constructor(C,u,g){this._mainContext=C,this._logService=u,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,u,g,o,r,f){return new y(this._mainContext,C,u,this._onFileSystemEvent.event,I.GlobPattern.from(g),o,r,f)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,u){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:u.map(g=>({oldUri:b.URI.revive(g.source),newUri:b.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:u.map(g=>b.URI.revive(g.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:u.map(g=>b.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,u){return(g,o,r)=>{const f=function(D){g.call(o,D)};return f.extension=C,u.event(f,void 0,r)}}async $onWillRunFileOperation(C,u,g,o){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:u.map(r=>({oldUri:b.URI.revive(r.source),newUri:b.URI.revive(r.target)}))},g,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:u.map(r=>b.URI.revive(r.target))},g,o);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:u.map(r=>b.URI.revive(r.target))},g,o)}}async _fireWillEvent(C,u,g,o){const r=new Set,f=[];if(await C.fireAsync(u,o,async(D,h)=>{const _=Date.now(),E=await Promise.resolve(D);E instanceof A.WorkspaceEdit&&(f.push(E),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-_>g&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||f.length===0)return;const p={edits:[]};for(let D of f){let{edits:h}=I.WorkspaceEdit.from(D,{getTextDocumentVersion:_=>this._extHostDocumentsAndEditors.getDocument(_)?.version,getNotebookDocumentVersion:()=>{}});p.edits=p.edits.concat(h)}return{edit:p,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=O}),define(be[190],Se([1,0,2,39]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(I,A,y,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=O;const L=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",C=>!0,C=>C),new T.ApiCommandArgument("resource","Interactive resource Uri",C=>!0,C=>C),new T.ApiCommandArgument("controllerId","Notebook controller Id",C=>!0,C=>C),new T.ApiCommandArgument("title","Interactive editor title",C=>!0,C=>C)],new T.ApiCommandResult("Notebook and input URI",C=>{if(C.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(C.notebookEditorId);return{notebookUri:l.URI.revive(C.notebookUri),inputUri:l.URI.revive(C.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:l.URI.revive(C.notebookUri),inputUri:l.URI.revive(C.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(I,A,y,O){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(O))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=b}),define(be[191],Se([1,0,7,4]),function(J,e,l,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(I){this._handlePool=0,this._proxy=I.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,I),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=b}),define(be[192],Se([1,0,2,27,8,6,66,4,9,48,16,10,234,20,7,78,53,60,193,14,5,12,25]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class k{constructor(w,U){this._documents=w,this._provider=U}async provideDocumentSymbols(w,U){const z=this._documents.getDocument(w),j=await this._provider.provideDocumentSymbols(z,U);if(!(0,L.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(b.DocumentSymbol.from):k._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(w){w=w.slice(0).sort((j,ee)=>{let ce=j.location.range.start.compareTo(ee.location.range.start);return ce===0&&(ce=ee.location.range.end.compareTo(j.location.range.end)),ce});const U=[],z=[];for(const j of w){const ee={name:j.name||"!!MISSING: name!!",kind:b.SymbolKind.from(j.kind),tags:j.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:b.Range.from(j.location.range),selectionRange:b.Range.from(j.location.range),children:[]};for(;;){if(z.length===0){z.push(ee),U.push(ee);break}const ce=z[z.length-1];if(O.Range.containsRange(ce.range,ee.range)&&!O.Range.equalsRange(ce.range,ee.range)){ce.children&&ce.children.push(ee),z.push(ee);break}z.pop()}}return U}}class s{constructor(w,U,z){this._documents=w,this._commands=U,this._provider=z,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(w,U){const z=this._documents.getDocument(w),j=await this._provider.provideCodeLenses(z,U);if(!j||U.isCancellationRequested)return;const ee=this._cache.add(j),ce=new o.DisposableStore;this._disposables.set(ee,ce);const ve={cacheId:ee,lenses:[]};for(let Oe=0;Oe<j.length;Oe++)ve.lenses.push({cacheId:[ee,Oe],range:b.Range.from(j[Oe].range),command:this._commands.toInternal(j[Oe].command,ce)});return ve}async resolveCodeLens(w,U){const z=w.cacheId&&this._cache.get(...w.cacheId);if(!z)return;let j;if(typeof this._provider.resolveCodeLens!="function"||z.isResolved?j=z:j=await this._provider.resolveCodeLens(z,U),j||(j=z),U.isCancellationRequested)return;const ee=w.cacheId&&this._disposables.get(w.cacheId[0]);if(!!ee)return w.command=this._commands.toInternal(j.command??s._badCmd,ee),w}releaseCodeLenses(w){this._disposables.get(w)?.dispose(),this._disposables.delete(w),this._cache.delete(w)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(Q){return Array.isArray(Q)?Q.map(b.DefinitionLink.from):Q?[b.DefinitionLink.from(Q)]:[]}class c{constructor(w,U){this._documents=w,this._provider=U}async provideDefinition(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideDefinition(j,ee,z);return i(ce)}}class t{constructor(w,U){this._documents=w,this._provider=U}async provideDeclaration(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideDeclaration(j,ee,z);return i(ce)}}class n{constructor(w,U){this._documents=w,this._provider=U}async provideImplementation(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideImplementation(j,ee,z);return i(ce)}}class m{constructor(w,U){this._documents=w,this._provider=U}async provideTypeDefinition(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideTypeDefinition(j,ee,z);return i(ce)}}class d{constructor(w,U){this._documents=w,this._provider=U}async provideHover(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideHover(j,ee,z);if(!(!ce||(0,L.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=j.getWordRangeAtPosition(ee)),ce.range||(ce.range=new M.Range(ee,ee)),b.Hover.from(ce)}}class S{constructor(w,U){this._documents=w,this._provider=U}async provideEvaluatableExpression(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideEvaluatableExpression(j,ee,z);if(ce)return b.EvaluatableExpression.from(ce)}}class P{constructor(w,U){this._documents=w,this._provider=U}async provideInlineValues(w,U,z,j){const ee=this._documents.getDocument(w),ce=await this._provider.provideInlineValues(ee,b.Range.to(U),b.InlineValueContext.to(z),j);if(Array.isArray(ce))return ce.map(ve=>b.InlineValue.from(ve))}}class B{constructor(w,U){this._documents=w,this._provider=U}async provideDocumentHighlights(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideDocumentHighlights(j,ee,z);if(Array.isArray(ce))return ce.map(b.DocumentHighlight.from)}}class F{constructor(w,U){this._documents=w,this._provider=U}async provideLinkedEditingRanges(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.provideLinkedEditingRanges(j,ee,z);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,L.coalesce)(ce.ranges.map(b.Range.from)),wordPattern:ce.wordPattern}}}class v{constructor(w,U){this._documents=w,this._provider=U}async provideReferences(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Position.to(U),ve=await this._provider.provideReferences(ee,ce,z,j);if(Array.isArray(ve))return ve.map(b.location.from)}}class x{constructor(w,U,z,j,ee,ce,ve){this._documents=w,this._commands=U,this._diagnostics=z,this._provider=j,this._logService=ee,this._extension=ce,this._apiDeprecation=ve,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(w,U,z,j){const ee=this._documents.getDocument(w),ce=u.Selection.isISelection(U)?b.Selection.to(U):b.Range.to(U),ve=[];for(const ke of this._diagnostics.getDiagnostics(w))if(ce.intersection(ke.range)&&ve.push(ke)>x._maxCodeActionsPerFile)break;const Oe={diagnostics:ve,only:z.only?new M.CodeActionKind(z.only):void 0,triggerKind:b.CodeActionTriggerKind.to(z.trigger)},Le=await this._provider.provideCodeActions(ee,ce,Oe,j);if(!(0,L.isNonEmptyArray)(Le)||j.isCancellationRequested)return;const Ne=this._cache.add(Le),Ve=new o.DisposableStore;this._disposables.set(Ne,Ve);const Je=[];for(let ke=0;ke<Le.length;ke++){const je=Le[ke];!je||(x._isCommand(je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:je.title,command:this._commands.toInternal(je,Ve)})):(Oe.only&&(je.kind?Oe.only.contains(je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,ke],title:je.title,command:je.command&&this._commands.toInternal(je.command,Ve),diagnostics:je.diagnostics&&je.diagnostics.map(b.Diagnostic.from),edit:je.edit&&b.WorkspaceEdit.from(je.edit),kind:je.kind&&je.kind.value,isPreferred:je.isPreferred,disabled:je.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(w,U){const[z,j]=w,ee=this._cache.get(z,j);if(!ee||x._isCommand(ee)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(ee,U)??ee;return ce?.edit?b.WorkspaceEdit.from(ce.edit):void 0}releaseCodeActions(w){this._disposables.get(w)?.dispose(),this._disposables.delete(w),this._cache.delete(w)}static _isCommand(w){return typeof w.command=="string"&&typeof w.title=="string"}}x._maxCodeActionsPerFile=1e3;class W{constructor(w,U){this._documents=w,this._provider=U}async provideDocumentFormattingEdits(w,U,z){const j=this._documents.getDocument(w),ee=await this._provider.provideDocumentFormattingEdits(j,U,z);if(Array.isArray(ee))return ee.map(b.TextEdit.from)}}class V{constructor(w,U){this._documents=w,this._provider=U}async provideDocumentRangeFormattingEdits(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Range.to(U),ve=await this._provider.provideDocumentRangeFormattingEdits(ee,ce,z,j);if(Array.isArray(ve))return ve.map(b.TextEdit.from)}}class re{constructor(w,U){this._documents=w,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(w,U,z,j,ee){const ce=this._documents.getDocument(w),ve=b.Position.to(U),Oe=await this._provider.provideOnTypeFormattingEdits(ce,ve,z,j,ee);if(Array.isArray(Oe))return Oe.map(b.TextEdit.from)}}class H{constructor(w,U){this._provider=w,this._logService=U,this._cache=new p.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(w,U){const z=await this._provider.provideWorkspaceSymbols(w,U);if(!(0,L.isNonEmptyArray)(z))return{symbols:[]};const j=this._cache.add(z),ee={cacheId:j,symbols:[]};for(let ce=0;ce<z.length;ce++){const ve=z[ce];if(!ve||!ve.name){this._logService.warn("INVALID SymbolInformation",ve);continue}ee.symbols.push({...b.WorkspaceSymbol.from(ve),cacheId:[j,ce]})}return ee}async resolveWorkspaceSymbol(w,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!w.cacheId)return w;const z=this._cache.get(...w.cacheId);if(z){const j=await this._provider.resolveWorkspaceSymbol(z,U);return j&&(0,T.mixin)(w,b.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(w){this._cache.delete(w)}}class R{constructor(w,U,z){this._documents=w,this._provider=U,this._logService=z}static supportsResolving(w){return typeof w.prepareRename=="function"}async provideRenameEdits(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Position.to(U);try{const ve=await this._provider.provideRenameEdits(ee,ce,z,j);return ve?b.WorkspaceEdit.from(ve):void 0}catch(ve){const Oe=R._asMessage(ve);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(w,U,z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(w),ee=b.Position.to(U);try{const ce=await this._provider.prepareRename(j,ee,z);let ve,Oe;if(M.Range.isRange(ce)?(ve=ce,Oe=j.getText(ce)):(0,C.isObject)(ce)&&(ve=ce.range,Oe=ce.placeholder),!ve||!Oe)return;if(ve.start.line>ee.line||ve.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(ve),text:Oe}}catch(ce){const ve=R._asMessage(ce);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(w){return typeof w=="string"?w:w instanceof Error&&typeof w.message=="string"?w.message:void 0}}class se{constructor(w,U){this.resultId=w,this.tokens=U}}class de{constructor(w,U){this._documents=w,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(w,U,z){const j=this._documents.getDocument(w),ee=U!==0?this._previousResults.get(U):null;let ce=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,ee.resultId,z):await this._provider.provideDocumentSemanticTokens(j,z);return ee&&this._previousResults.delete(U),ce?(ce=de._fixProvidedSemanticTokens(ce),this._send(de._convertToEdits(ee,ce),ce)):null}async releaseDocumentSemanticColoring(w){this._previousResults.delete(w)}static _fixProvidedSemanticTokens(w){return de._isSemanticTokens(w)?de._isCorrectSemanticTokens(w)?w:new M.SemanticTokens(new Uint32Array(w.data),w.resultId):de._isSemanticTokensEdits(w)?de._isCorrectSemanticTokensEdits(w)?w:new M.SemanticTokensEdits(w.edits.map(U=>new M.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),w.resultId):w}static _isSemanticTokens(w){return w&&!!w.data}static _isCorrectSemanticTokens(w){return w.data instanceof Uint32Array}static _isSemanticTokensEdits(w){return w&&Array.isArray(w.edits)}static _isCorrectSemanticTokensEdits(w){for(const U of w.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(w,U){if(!de._isSemanticTokens(U)||!w||!w.tokens)return U;const z=w.tokens,j=z.length,ee=U.data,ce=ee.length;let ve=0;const Oe=Math.min(j,ce);for(;ve<Oe&&z[ve]===ee[ve];)ve++;if(ve===j&&ve===ce)return new M.SemanticTokensEdits([],U.resultId);let Le=0;const Ne=Oe-ve;for(;Le<Ne&&z[j-Le-1]===ee[ce-Le-1];)Le++;return new M.SemanticTokensEdits([{start:ve,deleteCount:j-ve-Le,data:ee.subarray(ve,ce-Le)}],U.resultId)}_send(w,U){if(de._isSemanticTokens(w)){const z=this._nextResultId++;return this._previousResults.set(z,new se(w.resultId,w.data)),(0,r.encodeSemanticTokensDto)({id:z,type:"full",data:w.data})}if(de._isSemanticTokensEdits(w)){const z=this._nextResultId++;return de._isSemanticTokens(U)?this._previousResults.set(z,new se(U.resultId,U.data)):this._previousResults.set(z,new se(w.resultId)),(0,r.encodeSemanticTokensDto)({id:z,type:"delta",deltas:(w.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=de;class X{constructor(w,U){this._documents=w,this._provider=U}async provideDocumentRangeSemanticTokens(w,U,z){const j=this._documents.getDocument(w),ee=await this._provider.provideDocumentRangeSemanticTokens(j,b.Range.to(U),z);return ee?this._send(ee):null}_send(w){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:w.data})}}e.DocumentRangeSemanticTokensAdapter=X;class ie{constructor(w,U,z,j,ee){this._documents=w,this._commands=U,this._provider=z,this._apiDeprecation=j,this._extension=ee,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(w){return typeof w.resolveCompletionItem=="function"}async provideCompletionItems(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Position.to(U),ve=ee.getWordRangeAtPosition(ce)||new M.Range(ce,ce),Oe=ve.with({end:ce}),Le=new D.StopWatch(!0),Ne=await this._provider.provideCompletionItems(ee,ce,j,b.CompletionContext.to(z));if(!Ne||j.isCancellationRequested)return;const Ve=Array.isArray(Ne)?new M.CompletionList(Ne):Ne,Je=ie.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),ke=new o.DisposableStore;this._disposables.set(Je,ke);const je=[],G={x:Je,b:je,a:{replace:b.Range.from(ve),insert:b.Range.from(Oe)},c:Ve.isIncomplete||void 0,d:Le.elapsed()};for(let Y=0;Y<Ve.items.length;Y++){const ue=Ve.items[Y],Me=this._convertCompletionItem(ue,[Je,Y],Oe,ve);je.push(Me)}return G}async resolveCompletionItem(w,U){if(typeof this._provider.resolveCompletionItem!="function")return;const z=this._cache.get(...w);if(!z)return;const j=await this._provider.resolveCompletionItem(z,U);if(!!j)return this._convertCompletionItem(j,w)}releaseCompletionItems(w){this._disposables.get(w)?.dispose(),this._disposables.delete(w),this._cache.delete(w)}_convertCompletionItem(w,U,z,j){const ee=this._disposables.get(U[0]);if(!ee)throw Error("DisposableStore is missing...");const ce={x:U,a:w.label,b:w.kind!==void 0?b.CompletionItemKind.from(w.kind):void 0,n:w.tags&&w.tags.map(b.CompletionItemTag.from),c:w.detail,d:typeof w.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(w.documentation),e:w.sortText!==w.label?w.sortText:void 0,f:w.filterText!==w.label?w.filterText:void 0,g:w.preselect||void 0,i:w.keepWhitespace?1:0,k:w.commitCharacters,l:w.additionalTextEdits&&w.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(w.command,ee)};w.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=w.textEdit.newText):typeof w.insertText=="string"?ce.h=w.insertText:w.insertText instanceof M.SnippetString&&(ce.h=w.insertText.value,ce.i|=4);let ve;return w.textEdit?ve=w.textEdit.range:w.range&&(ve=w.range),M.Range.isRange(ve)?ce.j=b.Range.from(ve):ve&&(!z?.isEqual(ve.inserting)||!j?.isEqual(ve.replacing))&&(ce.j={insert:b.Range.from(ve.inserting),replace:b.Range.from(ve.replacing)}),ce}}class he{async provideInlineCompletions(w,U,z,j){}}class me extends he{constructor(w,U,z){super();this._documents=w,this._provider=U,this._commands=z,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Position.to(U),ve=await this._provider.provideInlineCompletionItems(ee,ce,{selectedCompletionInfo:z.selectedSuggestionInfo?{range:b.Range.to(z.selectedSuggestionInfo.range),text:z.selectedSuggestionInfo.text,isSnippetText:z.selectedSuggestionInfo.isSnippetText,completionKind:b.CompletionItemKind.to(z.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:z.triggerKind},j);if(!ve||j.isCancellationRequested)return;const Oe=(0,C.isArray)(ve)?ve:ve.items,Le=this._cache.add(Oe);let Ne;return{pid:Le,items:Oe.map((Ve,Je)=>{let ke;Ve.command&&(Ne||(Ne=new o.DisposableStore,this._disposables.set(Le,Ne)),ke=this._commands.toInternal(Ve.command,Ne));const je=Ve.insertText??Ve.text;if(je===void 0)throw new Error("text or insertText must be defined");return{insertText:typeof je=="string"?je:{snippet:je.value},range:Ve.range?b.Range.from(Ve.range):void 0,command:ke,idx:Je,completeBracketPairs:Ve.completeBracketPairs}})}}disposeCompletions(w){this._cache.delete(w);const U=this._disposables.get(w);U&&U.clear(),this._disposables.delete(w)}handleDidShowCompletionItem(w,U){const z=this._cache.get(w,U);z&&ae.get(this._provider).fireOnDidShowCompletionItem({completionItem:z})}}class fe extends he{constructor(w,U,z,j){super();this.extension=w,this._documents=U,this._provider=z,this._commands=j,this._cache=new p.Cache("InlineCompletionItemNew"),this._disposables=new Map,this.isAdditionProposedApiEnabled=(0,a.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[I.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[I.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Position.to(U),ve=await this._provider.provideInlineCompletionItems(ee,ce,{selectedCompletionInfo:z.selectedSuggestionInfo?{range:b.Range.to(z.selectedSuggestionInfo.range),text:z.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[z.triggerKind]},j);if(!ve||j.isCancellationRequested)return;const Oe=(0,C.isArray)(ve)?ve:ve.items,Le=this._cache.add(Oe);let Ne;return{pid:Le,items:Oe.map((Ve,Je)=>{let ke;Ve.command&&(Ne||(Ne=new o.DisposableStore,this._disposables.set(Le,Ne)),ke=this._commands.toInternal(Ve.command,Ne));const je=Ve.insertText;return{insertText:typeof je=="string"?je:{snippet:je.value},filterText:Ve.filterText,range:Ve.range?b.Range.from(Ve.range):void 0,command:ke,idx:Je,completeBracketPairs:this.isAdditionProposedApiEnabled?Ve.completeBracketPairs:!1}})}}disposeCompletions(w){this._cache.delete(w);const U=this._disposables.get(w);U&&U.clear(),this._disposables.delete(w)}handleDidShowCompletionItem(w,U){const z=this._cache.get(w,U);z&&this._provider.handleDidShowCompletionItem&&(0,a.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions")&&this._provider.handleDidShowCompletionItem(z)}}class ae{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(w){let U=ae.map.get(w);return U||(U=new ae,ae.map.set(w,U)),U}fireOnDidShowCompletionItem(w){this._onDidShowCompletionItemEmitter.fire(w)}}e.InlineCompletionController=ae,ae.map=new WeakMap;class pe{constructor(w,U){this._documents=w,this._provider=U,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(w,U,z,j){const ee=this._documents.getDocument(w),ce=b.Position.to(U),ve=this.reviveContext(z),Oe=await this._provider.provideSignatureHelp(ee,ce,j,ve);if(Oe){const Le=this._cache.add([Oe]);return{...b.SignatureHelp.from(Oe),id:Le}}}reviveContext(w){let U;if(w.activeSignatureHelp){const z=b.SignatureHelp.to(w.activeSignatureHelp),j=this._cache.get(w.activeSignatureHelp.id,0);j?(U=j,U.activeSignature=z.activeSignature,U.activeParameter=z.activeParameter):U=z}return{...w,activeSignatureHelp:U}}releaseSignatureHelp(w){this._cache.delete(w)}}class Ae{constructor(w,U,z,j,ee){this._documents=w,this._commands=U,this._provider=z,this._logService=j,this._extension=ee,this._cache=new p.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(w,U,z){const j=this._documents.getDocument(w),ee=b.Range.to(U),ce=await this._provider.provideInlayHints(j,ee,z);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${U}`);return}if(z.isCancellationRequested)return;const ve=this._cache.add(ce);this._disposables.set(ve,new o.DisposableStore);const Oe={hints:[],cacheId:ve};for(let Le=0;Le<ce.length;Le++)this._isValidInlayHint(ce[Le],ee)&&Oe.hints.push(this._convertInlayHint(ce[Le],[ve,Le]));return this._logService.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${U}`),Oe}async resolveInlayHint(w,U){if(typeof this._provider.resolveInlayHint!="function")return;const z=this._cache.get(...w);if(!z)return;const j=await this._provider.resolveInlayHint(z,U);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,w)}releaseHints(w){this._disposables.get(w)?.dispose(),this._disposables.delete(w),this._cache.delete(w)}_isValidInlayHint(w,U){return w.label.length===0||Array.isArray(w.label)&&w.label.every(z=>z.value.length===0)?(console.log("INVALID inlay hint, empty label",w),!1):!(U&&!U.contains(w.position))}_convertInlayHint(w,U){const z=this._disposables.get(U[0]);if(!z)throw Error("DisposableStore is missing...");const j={label:"",cacheId:U,tooltip:b.MarkdownString.fromStrict(w.tooltip),position:b.Position.from(w.position),textEdits:w.textEdits&&w.textEdits.map(b.TextEdit.from),kind:w.kind&&b.InlayHintKind.from(w.kind),paddingLeft:w.paddingLeft,paddingRight:w.paddingRight};return typeof w.label=="string"?j.label=w.label:j.label=w.label.map(ee=>{let ce={label:ee.value};return ce.tooltip=b.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(ce.location=b.location.from(ee.location)),ee.command&&(ce.command=this._commands.toInternal(ee.command,z)),ce}),j}}class Fe{constructor(w,U){this._documents=w,this._provider=U,this._cache=new p.Cache("DocumentLink")}async provideLinks(w,U){const z=this._documents.getDocument(w),j=await this._provider.provideDocumentLinks(z,U);if(!(!Array.isArray(j)||j.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(b.DocumentLink.from)};{const ee=this._cache.add(j),ce={links:[],cacheId:ee};for(let ve=0;ve<j.length;ve++){if(!Fe._validateLink(j[ve]))continue;const Oe=b.DocumentLink.from(j[ve]);Oe.cacheId=[ee,ve],ce.links.push(Oe)}return ce}}}static _validateLink(w){return w.target&&w.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(w,U){if(typeof this._provider.resolveDocumentLink!="function")return;const z=this._cache.get(...w);if(!z)return;const j=await this._provider.resolveDocumentLink(z,U);if(!(!j||!Fe._validateLink(j)))return b.DocumentLink.from(j)}releaseLinks(w){this._cache.delete(w)}}class He{constructor(w,U){this._documents=w,this._provider=U}async provideColors(w,U){const z=this._documents.getDocument(w),j=await this._provider.provideDocumentColors(z,U);return Array.isArray(j)?j.map(ce=>({color:b.Color.from(ce.color),range:b.Range.from(ce.range)})):[]}async provideColorPresentations(w,U,z){const j=this._documents.getDocument(w),ee=b.Range.to(U.range),ce=b.Color.to(U.color),ve=await this._provider.provideColorPresentations(ce,{document:j,range:ee},z);if(!!Array.isArray(ve))return ve.map(b.ColorPresentation.from)}}class Ye{constructor(w,U){this._documents=w,this._provider=U}async provideFoldingRanges(w,U,z){const j=this._documents.getDocument(w),ee=await this._provider.provideFoldingRanges(j,U,z);if(!!Array.isArray(ee))return ee.map(b.FoldingRange.from)}}class Ce{constructor(w,U,z){this._documents=w,this._provider=U,this._logService=z}async provideSelectionRanges(w,U,z){const j=this._documents.getDocument(w),ee=U.map(b.Position.to),ce=await this._provider.provideSelectionRanges(j,ee,z);if(!(0,L.isNonEmptyArray)(ce))return[];if(ce.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Oe=0;Oe<ee.length;Oe++){const Le=[];ve.push(Le);let Ne=ee[Oe],Ve=ce[Oe];for(;;){if(!Ve.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(Le.push(b.SelectionRange.from(Ve)),!Ve.parent)break;Ne=Ve.range,Ve=Ve.parent}}return ve}}class Ee{constructor(w,U){this._documents=w,this._provider=U,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.prepareCallHierarchy(j,ee,z);if(!ce)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ce)?ce.map(Oe=>this._cacheAndConvertItem(ve,Oe)):[this._cacheAndConvertItem(ve,ce)]}async provideCallsTo(w,U,z){const j=this._itemFromCache(w,U);if(!j)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(j,z);if(!!ee)return ee.map(ce=>({from:this._cacheAndConvertItem(w,ce.from),fromRanges:ce.fromRanges.map(ve=>b.Range.from(ve))}))}async provideCallsFrom(w,U,z){const j=this._itemFromCache(w,U);if(!j)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(j,z);if(!!ee)return ee.map(ce=>({to:this._cacheAndConvertItem(w,ce.to),fromRanges:ce.fromRanges.map(ve=>b.Range.from(ve))}))}releaseSession(w){this._cache.delete(w)}_cacheAndConvertItem(w,U){const z=this._cache.get(w),j=b.CallHierarchyItem.from(U,w,z.size.toString(36));return z.set(j._itemId,U),j}_itemFromCache(w,U){return this._cache.get(w)?.get(U)}}class De{constructor(w,U){this._documents=w,this._provider=U,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(w,U,z){const j=this._documents.getDocument(w),ee=b.Position.to(U),ce=await this._provider.prepareTypeHierarchy(j,ee,z);if(!ce)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ce)?ce.map(Oe=>this._cacheAndConvertItem(ve,Oe)):[this._cacheAndConvertItem(ve,ce)]}async provideSupertypes(w,U,z){const j=this._itemFromCache(w,U);if(!j)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(j,z);if(!!ee)return ee.map(ce=>this._cacheAndConvertItem(w,ce))}async provideSubtypes(w,U,z){const j=this._itemFromCache(w,U);if(!j)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(j,z);if(!!ee)return ee.map(ce=>this._cacheAndConvertItem(w,ce))}releaseSession(w){this._cache.delete(w)}_cacheAndConvertItem(w,U){const z=this._cache.get(w),j=b.TypeHierarchyItem.from(U,w,z.size.toString(36));return z.set(j._itemId,U),j}_itemFromCache(w,U){return this._cache.get(w)?.get(U)}}class ne{constructor(w,U){this.adapter=w,this.extension=U}}class q{constructor(w,U,z,j,ee,ce,ve){this._adapter=new Map,this._uriTransformer=U,this._proxy=w.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=z,this._commands=j,this._diagnostics=ee,this._logService=ce,this._apiDeprecation=ve}_transformDocumentSelector(w){return b.DocumentSelector.from(w,this._uriTransformer)}_createDisposable(w){return new M.Disposable(()=>{this._adapter.delete(w),this._proxy.$unregister(w)})}_nextHandle(){return q._handlePool++}async _withAdapter(w,U,z,j,ee,ce=!1){const ve=this._adapter.get(w);if(!ve||!(ve.adapter instanceof U))return j;const Oe=Date.now();ce||this._logService.trace(`[${ve.extension.identifier.value}] INVOKE provider '${z.toString().replace(/[\r\n]/g,"")}'`);const Le=z(ve.adapter,ve.extension);return Promise.resolve(Le).catch(Ne=>{(0,h.isCancellationError)(Ne)||(this._logService.error(`[${ve.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ce||this._logService.trace(`[${ve.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),g.CancellationToken.isCancellationToken(ee)?(0,E.raceCancellationError)(Le,ee):Le}_addNewAdapter(w,U){const z=this._nextHandle();return this._adapter.set(z,new ne(w,U)),z}static _extLabel(w){return w.displayName||w.name}registerDocumentSymbolProvider(w,U,z,j){const ee=this._addNewAdapter(new k(this._documents,z),w),ce=j&&j.label||q._extLabel(w);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(U),ce),this._createDisposable(ee)}$provideDocumentSymbols(w,U,z){return this._withAdapter(w,k,j=>j.provideDocumentSymbols(l.URI.revive(U),z),void 0,z)}registerCodeLensProvider(w,U,z){const j=this._nextHandle(),ee=typeof z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ne(new s(this._documents,this._commands.converter,z),w)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(U),ee);let ce=this._createDisposable(j);if(ee!==void 0){const ve=z.onDidChangeCodeLenses(Oe=>this._proxy.$emitCodeLensEvent(ee));ce=M.Disposable.from(ce,ve)}return ce}$provideCodeLenses(w,U,z){return this._withAdapter(w,s,j=>j.provideCodeLenses(l.URI.revive(U),z),void 0,z)}$resolveCodeLens(w,U,z){return this._withAdapter(w,s,j=>j.resolveCodeLens(U,z),void 0,void 0)}$releaseCodeLenses(w,U){this._withAdapter(w,s,z=>Promise.resolve(z.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(w,U,z){const j=this._addNewAdapter(new c(this._documents,z),w);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDefinition(w,U,z,j){return this._withAdapter(w,c,ee=>ee.provideDefinition(l.URI.revive(U),z,j),[],j)}registerDeclarationProvider(w,U,z){const j=this._addNewAdapter(new t(this._documents,z),w);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDeclaration(w,U,z,j){return this._withAdapter(w,t,ee=>ee.provideDeclaration(l.URI.revive(U),z,j),[],j)}registerImplementationProvider(w,U,z){const j=this._addNewAdapter(new n(this._documents,z),w);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideImplementation(w,U,z,j){return this._withAdapter(w,n,ee=>ee.provideImplementation(l.URI.revive(U),z,j),[],j)}registerTypeDefinitionProvider(w,U,z){const j=this._addNewAdapter(new m(this._documents,z),w);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideTypeDefinition(w,U,z,j){return this._withAdapter(w,m,ee=>ee.provideTypeDefinition(l.URI.revive(U),z,j),[],j)}registerHoverProvider(w,U,z,j){const ee=this._addNewAdapter(new d(this._documents,z),w);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(U)),this._createDisposable(ee)}$provideHover(w,U,z,j){return this._withAdapter(w,d,ee=>ee.provideHover(l.URI.revive(U),z,j),void 0,j)}registerEvaluatableExpressionProvider(w,U,z,j){const ee=this._addNewAdapter(new S(this._documents,z),w);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(U)),this._createDisposable(ee)}$provideEvaluatableExpression(w,U,z,j){return this._withAdapter(w,S,ee=>ee.provideEvaluatableExpression(l.URI.revive(U),z,j),void 0,j)}registerInlineValuesProvider(w,U,z,j){const ee=typeof z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new P(this._documents,z),w);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(U),ee);let ve=this._createDisposable(ce);if(ee!==void 0){const Oe=z.onDidChangeInlineValues(Le=>this._proxy.$emitInlineValuesEvent(ee));ve=M.Disposable.from(ve,Oe)}return ve}$provideInlineValues(w,U,z,j,ee){return this._withAdapter(w,P,ce=>ce.provideInlineValues(l.URI.revive(U),z,j,ee),void 0,ee)}registerDocumentHighlightProvider(w,U,z){const j=this._addNewAdapter(new B(this._documents,z),w);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDocumentHighlights(w,U,z,j){return this._withAdapter(w,B,ee=>ee.provideDocumentHighlights(l.URI.revive(U),z,j),void 0,j)}registerLinkedEditingRangeProvider(w,U,z){const j=this._addNewAdapter(new F(this._documents,z),w);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideLinkedEditingRanges(w,U,z,j){return this._withAdapter(w,F,async ee=>{const ce=await ee.provideLinkedEditingRanges(l.URI.revive(U),z,j);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?q._serializeRegExp(ce.wordPattern):void 0}},void 0,j)}registerReferenceProvider(w,U,z){const j=this._addNewAdapter(new v(this._documents,z),w);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideReferences(w,U,z,j,ee){return this._withAdapter(w,v,ce=>ce.provideReferences(l.URI.revive(U),z,j,ee),void 0,ee)}registerCodeActionProvider(w,U,z,j){const ee=new o.DisposableStore,ce=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,z,this._logService,w,this._apiDeprecation),w);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(U),{providedKinds:j?.providedCodeActionKinds?.map(ve=>ve.value),documentation:j?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,ee)}))},q._extLabel(w),Boolean(z.resolveCodeAction)),ee.add(this._createDisposable(ce)),ee}$provideCodeActions(w,U,z,j,ee){return this._withAdapter(w,x,ce=>ce.provideCodeActions(l.URI.revive(U),z,j,ee),void 0,ee)}$resolveCodeAction(w,U,z){return this._withAdapter(w,x,j=>j.resolveCodeAction(U,z),void 0,void 0)}$releaseCodeActions(w,U){this._withAdapter(w,x,z=>Promise.resolve(z.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(w,U,z){const j=this._addNewAdapter(new W(this._documents,z),w);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(U),w.identifier,w.displayName||w.name),this._createDisposable(j)}$provideDocumentFormattingEdits(w,U,z,j){return this._withAdapter(w,W,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(U),z,j),void 0,j)}registerDocumentRangeFormattingEditProvider(w,U,z){const j=this._addNewAdapter(new V(this._documents,z),w);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(U),w.identifier,w.displayName||w.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(w,U,z,j,ee){return this._withAdapter(w,V,ce=>ce.provideDocumentRangeFormattingEdits(l.URI.revive(U),z,j,ee),void 0,ee)}registerOnTypeFormattingEditProvider(w,U,z,j){const ee=this._addNewAdapter(new re(this._documents,z),w);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(U),j,w.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(w,U,z,j,ee,ce){return this._withAdapter(w,re,ve=>ve.provideOnTypeFormattingEdits(l.URI.revive(U),z,j,ee,ce),void 0,ce)}registerWorkspaceSymbolProvider(w,U){const z=this._addNewAdapter(new H(U,this._logService),w);return this._proxy.$registerNavigateTypeSupport(z,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable(z)}$provideWorkspaceSymbols(w,U,z){return this._withAdapter(w,H,j=>j.provideWorkspaceSymbols(U,z),{symbols:[]},z)}$resolveWorkspaceSymbol(w,U,z){return this._withAdapter(w,H,j=>j.resolveWorkspaceSymbol(U,z),void 0,void 0)}$releaseWorkspaceSymbols(w,U){this._withAdapter(w,H,z=>z.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(w,U,z){const j=this._addNewAdapter(new R(this._documents,z,this._logService),w);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(U),R.supportsResolving(z)),this._createDisposable(j)}$provideRenameEdits(w,U,z,j,ee){return this._withAdapter(w,R,ce=>ce.provideRenameEdits(l.URI.revive(U),z,j,ee),void 0,ee)}$resolveRenameLocation(w,U,z,j){return this._withAdapter(w,R,ee=>ee.resolveRenameLocation(l.URI.revive(U),z,j),void 0,j)}registerDocumentSemanticTokensProvider(w,U,z,j){const ee=this._addNewAdapter(new de(this._documents,z),w),ce=typeof z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(U),j,ce);let ve=this._createDisposable(ee);if(ce){const Oe=z.onDidChangeSemanticTokens(Le=>this._proxy.$emitDocumentSemanticTokensEvent(ce));ve=M.Disposable.from(ve,Oe)}return ve}$provideDocumentSemanticTokens(w,U,z,j){return this._withAdapter(w,de,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(U),z,j),null,j)}$releaseDocumentSemanticTokens(w,U){this._withAdapter(w,de,z=>z.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(w,U,z,j){const ee=this._addNewAdapter(new X(this._documents,z),w);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(U),j),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(w,U,z,j){return this._withAdapter(w,X,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(U),z,j),null,j)}registerCompletionItemProvider(w,U,z,j){const ee=this._addNewAdapter(new ie(this._documents,this._commands.converter,z,this._apiDeprecation,w),w);return this._proxy.$registerSuggestSupport(ee,this._transformDocumentSelector(U),j,ie.supportsResolving(z),`${w.identifier.value}(${j.join("")})`),this._createDisposable(ee)}$provideCompletionItems(w,U,z,j,ee){return this._withAdapter(w,ie,ce=>ce.provideCompletionItems(l.URI.revive(U),z,j,ee),void 0,ee)}$resolveCompletionItem(w,U,z){return this._withAdapter(w,ie,j=>j.resolveCompletionItem(U,z),void 0,z)}$releaseCompletionItems(w,U){this._withAdapter(w,ie,z=>z.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(w,U,z){const j=this._addNewAdapter(new me(this._documents,z,this._commands.converter),w);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}registerInlineCompletionsProviderNew(w,U,z){const j=this._addNewAdapter(new fe(w,this._documents,z,this._commands.converter),w);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideInlineCompletions(w,U,z,j,ee){return this._withAdapter(w,he,ce=>ce.provideInlineCompletions(l.URI.revive(U),z,j,ee),void 0,ee)}$handleInlineCompletionDidShow(w,U,z){this._withAdapter(w,me,async j=>{j.handleDidShowCompletionItem(U,z)},void 0,void 0)}$freeInlineCompletionsList(w,U){this._withAdapter(w,me,async z=>{z.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(w,U,z,j){const ee=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ce=this._addNewAdapter(new pe(this._documents,z),w);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(U),ee),this._createDisposable(ce)}$provideSignatureHelp(w,U,z,j,ee){return this._withAdapter(w,pe,ce=>ce.provideSignatureHelp(l.URI.revive(U),z,j,ee),void 0,ee)}$releaseSignatureHelp(w,U){this._withAdapter(w,pe,z=>z.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(w,U,z){const j=typeof z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new Ae(this._documents,this._commands.converter,z,this._logService,w),w);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(U),typeof z.resolveInlayHint=="function",j,q._extLabel(w));let ce=this._createDisposable(ee);if(j!==void 0){const ve=z.onDidChangeInlayHints(Oe=>this._proxy.$emitInlayHintsEvent(j));ce=M.Disposable.from(ce,ve)}return ce}$provideInlayHints(w,U,z,j){return this._withAdapter(w,Ae,ee=>ee.provideInlayHints(l.URI.revive(U),z,j),void 0,j)}$resolveInlayHint(w,U,z){return this._withAdapter(w,Ae,j=>j.resolveInlayHint(U,z),void 0,z)}$releaseInlayHints(w,U){this._withAdapter(w,Ae,z=>z.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(w,U,z){const j=this._addNewAdapter(new Fe(this._documents,z),w);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(U),typeof z.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(w,U,z){return this._withAdapter(w,Fe,j=>j.provideLinks(l.URI.revive(U),z),void 0,z,U.scheme==="output")}$resolveDocumentLink(w,U,z){return this._withAdapter(w,Fe,j=>j.resolveLink(U,z),void 0,void 0,!0)}$releaseDocumentLinks(w,U){this._withAdapter(w,Fe,z=>z.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(w,U,z){const j=this._addNewAdapter(new He(this._documents,z),w);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDocumentColors(w,U,z){return this._withAdapter(w,He,j=>j.provideColors(l.URI.revive(U),z),[],z)}$provideColorPresentations(w,U,z,j){return this._withAdapter(w,He,ee=>ee.provideColorPresentations(l.URI.revive(U),z,j),void 0,j)}registerFoldingRangeProvider(w,U,z){const j=this._nextHandle(),ee=typeof z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ne(new Ye(this._documents,z),w)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(U),ee);let ce=this._createDisposable(j);if(ee!==void 0){const ve=z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));ce=M.Disposable.from(ce,ve)}return ce}$provideFoldingRanges(w,U,z,j){return this._withAdapter(w,Ye,ee=>ee.provideFoldingRanges(l.URI.revive(U),z,j),void 0,j)}registerSelectionRangeProvider(w,U,z){const j=this._addNewAdapter(new Ce(this._documents,z,this._logService),w);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideSelectionRanges(w,U,z,j){return this._withAdapter(w,Ce,ee=>ee.provideSelectionRanges(l.URI.revive(U),z,j),[],j)}registerCallHierarchyProvider(w,U,z){const j=this._addNewAdapter(new Ee(this._documents,z),w);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$prepareCallHierarchy(w,U,z,j){return this._withAdapter(w,Ee,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(U),z,j)),void 0,j)}$provideCallHierarchyIncomingCalls(w,U,z,j){return this._withAdapter(w,Ee,ee=>ee.provideCallsTo(U,z,j),void 0,j)}$provideCallHierarchyOutgoingCalls(w,U,z,j){return this._withAdapter(w,Ee,ee=>ee.provideCallsFrom(U,z,j),void 0,j)}$releaseCallHierarchy(w,U){this._withAdapter(w,Ee,z=>Promise.resolve(z.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(w,U,z){const j=this._addNewAdapter(new De(this._documents,z),w);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$prepareTypeHierarchy(w,U,z,j){return this._withAdapter(w,De,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(U),z,j)),void 0,j)}$provideTypeHierarchySupertypes(w,U,z,j){return this._withAdapter(w,De,ee=>ee.provideSupertypes(U,z,j),void 0,j)}$provideTypeHierarchySubtypes(w,U,z,j){return this._withAdapter(w,De,ee=>ee.provideSubtypes(U,z,j),void 0,j)}$releaseTypeHierarchy(w,U){this._withAdapter(w,De,z=>Promise.resolve(z.releaseSession(U)),void 0,void 0)}static _serializeRegExp(w){return{pattern:w.source,flags:(0,y.regExpFlags)(w)}}static _serializeIndentationRule(w){return{decreaseIndentPattern:q._serializeRegExp(w.decreaseIndentPattern),increaseIndentPattern:q._serializeRegExp(w.increaseIndentPattern),indentNextLinePattern:w.indentNextLinePattern?q._serializeRegExp(w.indentNextLinePattern):void 0,unIndentedLinePattern:w.unIndentedLinePattern?q._serializeRegExp(w.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(w){return{beforeText:q._serializeRegExp(w.beforeText),afterText:w.afterText?q._serializeRegExp(w.afterText):void 0,previousLineText:w.previousLineText?q._serializeRegExp(w.previousLineText):void 0,action:w.action}}static _serializeOnEnterRules(w){return w.map(q._serializeOnEnterRule)}setLanguageConfiguration(w,U,z){let{wordPattern:j}=z;if(j&&(0,y.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(U,j):this._documents.setWordDefinitionFor(U,void 0),z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",w,"Do not use."),z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",w,"Do not use.");const ee=this._nextHandle(),ce={comments:z.comments,brackets:z.brackets,wordPattern:z.wordPattern?q._serializeRegExp(z.wordPattern):void 0,indentationRules:z.indentationRules?q._serializeIndentationRule(z.indentationRules):void 0,onEnterRules:z.onEnterRules?q._serializeOnEnterRules(z.onEnterRules):void 0,__electricCharacterSupport:z.__electricCharacterSupport,__characterPairSupport:z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ee,U,ce),this._createDisposable(ee)}$setWordDefinitions(w){for(const U of w)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=q,q._handlePool=0}),define(be[194],Se([1,0,4,8,6,34,12,7]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,C,u,g){this._documents=C,this._commands=u,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,C){await this._proxy.$changeLanguage(L,C);const u=this._documents.getDocumentData(L);if(!u)throw new Error(`document '${L.toString()}' NOT found`);return u.document}async tokenAtPosition(L,C){const u=L.version,g=T.Position.from(C),o=await this._proxy.$tokensAtPosition(L.uri,g),r={type:b.StandardTokenType.Other,range:L.getWordRangeAtPosition(C)??new b.Range(C.line,C.character,C.line,C.character)};if(!o)return r;const f={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!f.range.contains(C)||u!==L.version?r:f}createLanguageStatusItem(L,C,u){const g=this._handlePool++,o=this._proxy,r=this._ids,f=`${L.identifier.value}/${C}`;if(r.has(f))throw new Error(`LanguageStatusItem with id '${C}' ALREADY exists`);r.add(f);const p={selector:u,id:C,name:L.displayName??L.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let D,h=new A.DisposableStore;const _=()=>{D?.dispose(),D=(0,I.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(g,{id:f,name:p.name??L.displayName??L.name,source:L.displayName??L.name,selector:T.DocumentSelector.from(p.selector,this._uriTransformer),label:p.text,detail:p.detail??"",severity:p.severity===b.LanguageStatusSeverity.Error?M.default.Error:p.severity===b.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:p.command&&this._commands.toInternal(p.command,h),accessibilityInfo:p.accessibilityInformation,busy:p.busy})},0)},E={dispose(){h.dispose(),D?.dispose(),o.$removeLanguageStatus(g),r.delete(f)},get id(){return p.id},get name(){return p.name},set name(a){p.name=a,_()},get selector(){return p.selector},set selector(a){p.selector=a,_()},get text(){return p.text},set text(a){p.text=a,_()},get detail(){return p.detail},set detail(a){p.detail=a,_()},get severity(){return p.severity},set severity(a){p.severity=a,_()},get accessibilityInformation(){return p.accessibilityInformation},set accessibilityInformation(a){p.accessibilityInformation=a,_()},get command(){return p.command},set command(a){p.command=a,_()},get busy(){return p.busy},set busy(a){p.busy=a,_()}};return _(),E}}e.ExtHostLanguages=y}),define(be[195],Se([1,0,13,4,28,15,5]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends l.AbstractLoggerService{constructor(L,C){const u=new I.Emitter;super(C.logLevel,u.event);this._proxy=L.getProxy(T.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(u)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,C,u){return new y(this._proxy,L,C,u)}};A=Ue([Be(0,M.IExtHostRpcService),Be(1,b.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class y extends l.AbstractMessageLogger{constructor(L,C,u,g){super(g?.always);this.proxy=L,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.proxy.$createLogger(C,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,C){const u=[[L,C]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(L){this.proxy.$log(this.file,L)}}}),define(be[196],Se([1,0,4,13,25]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let I=class{constructor(y,O){this._logService=O,this._proxy=y.getProxy(l.MainContext.MainThreadMessageService)}showMessage(y,O,L,C,u){const g={source:{identifier:y.identifier,label:y.displayName||y.name}};let o;typeof C=="string"||M(C)?o=[C,...u]:(g.modal=C?.modal,g.useCustom=C?.useCustom,g.detail=C?.detail,o=u),g.useCustom&&(0,b.checkProposedApiEnabled)(y,"resolvers");const r=[];for(let f=0;f<o.length;f++){const p=o[f];if(typeof p=="string")r.push({title:p,handle:f,isCloseAffordance:!1});else if(typeof p=="object"){let{title:D,isCloseAffordance:h}=p;r.push({title:D,isCloseAffordance:!!h,handle:f})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(O,L,g,r).then(f=>{if(typeof f=="number")return o[f]})}};I=Ue([Be(1,T.ILogService)],I),e.ExtHostMessageService=I}),define(be[197],Se([1,0,22,5,94,7,23,9,10,2,60,4,8,6,38,171,90]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class p{constructor(h,_,E,a,k){this._textDocumentsAndEditors=E,this._textDocuments=a,this._extensionStoragePaths=k,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(C.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(C.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(C.MainContext.MainThreadNotebookEditors),this._commandsConverter=_.converter,_.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,c=s.cell.handle,n=this._documents.get(i)?.getCell(c);if(n)return n.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){const _=this._editors.get(h);if(!_)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return _}getIdByEditor(h){for(const[_,E]of this._editors)if(E.apiEditor===h)return _}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,_){const E=this._documents.get(h);if(!E&&!_)throw new Error(`NO notebook document for '${h}'`);return E}_getProviderData(h){const _=this._notebookContentProviders.get(h);if(!_)throw new Error(`NO provider for '${h}'`);return _}registerNotebookContentProvider(h,_,E,a,k){if((0,A.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(_))throw new Error(`Notebook provider for '${_}' already registered`);this._notebookContentProviders.set(_,{extension:h,provider:E});let s;return E.onDidChangeNotebookContentOptions&&(s=E.onDidChangeNotebookContentOptions(()=>{const i=u.NotebookDocumentContentOptions.from(E.options);this._notebookProxy.$updateNotebookProviderOptions(_,i)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},_,u.NotebookDocumentContentOptions.from(a),p._convertNotebookRegistrationData(h,k)),new g.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(_),this._notebookProxy.$unregisterNotebookProvider(_)})}static _convertNotebookRegistrationData(h,_){if(!_)return;const E=_.filenamePattern.map(a=>u.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(_.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${_.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:_.displayName,filenamePattern:E,exclusive:_.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,_,E){const a=p._notebookStatusBarItemProviderHandlePool++,k=typeof E.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,E),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,k,_);let s;return k!==void 0&&(s=E.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(k))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,k),s&&s.dispose()})}async createNotebookDocument(h){const _=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&u.NotebookData.from(h.content)});return O.URI.revive(_)}async openNotebookDocument(h){const _=this._documents.get(h);if(_)return _.apiNotebook;const E=await this._notebookDocumentsProxy.$tryOpenNotebook(h),a=this._documents.get(O.URI.revive(E));return(0,y.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(h,_){O.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let E;typeof _=="object"?E={position:u.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selections:_.selections&&_.selections.map(u.NotebookRange.from),pinned:typeof _.preview=="boolean"?!_.preview:void 0}:E={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,E),k=a&&this._editors.get(a)?.apiEditor;if(k)return k;throw a?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,_,E,a){const k=this._notebookStatusBarItemProviders.get(h),s=O.URI.revive(_),i=this._documents.get(s);if(!i||!k)return;const c=i.getCellFromIndex(E);if(!c)return;const t=await k.provideCellStatusBarItems(c.apiCell,a);if(!t)return;const n=new M.DisposableStore,m=this._statusBarCache.add([n]),S=(Array.isArray(t)?t:[t]).map(P=>u.NotebookStatusBarItem.from(P,this._commandsConverter,n));return{cacheId:m,items:S}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,_,E,a,k){if((0,A.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,E),this._notebookProxy.$registerNotebookSerializer(s,{id:h.identifier,location:h.extensionLocation},_,u.NotebookDocumentContentOptions.from(a),p._convertNotebookRegistrationData(h,k)),(0,M.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(h,_,E){const a=this._notebookSerializer.get(h);if(!a)throw new Error("NO serializer found");const k=await a.deserializeNotebook(_.buffer,E);return new o.SerializableObjectWithBuffers(u.NotebookData.from(k))}async $notebookToData(h,_,E){const a=this._notebookSerializer.get(h);if(!a)throw new Error("NO serializer found");const k=await a.serializeNotebook(u.NotebookData.to(_.value),E);return l.VSBuffer.wrap(k)}async $openNotebook(h,_,E,a,k){const{provider:s}=this._getProviderData(h),i=await s.openNotebook(O.URI.revive(_),{backupId:E,untitledDocumentData:a?.buffer},k);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(u.NotebookCellData.from)})}async $saveNotebook(h,_,E){const a=this.getNotebookDocument(O.URI.revive(_)),{provider:k}=this._getProviderData(h);return await k.saveNotebook(a.apiNotebook,E),!0}async $saveNotebookAs(h,_,E,a){const k=this.getNotebookDocument(O.URI.revive(_)),{provider:s}=this._getProviderData(h);return await s.saveNotebookAs(O.URI.revive(E),k.apiNotebook,a),!0}async $backupNotebook(h,_,E){const a=this.getNotebookDocument(O.URI.revive(_)),k=this._getProviderData(h),s=this._extensionStoragePaths.workspaceValue(k.extension)??this._extensionStoragePaths.globalValue(k.extension),i=String((0,b.hash)([a.uri.toString(),this._backupIdPool++])),c=O.URI.joinPath(s,i),t=await k.provider.backupNotebook(a.apiNotebook,{destination:c},E);return a.updateBackup(t),t.id}_createExtHostEditor(h,_,E){if(this._editors.has(_))throw new Error(`editor with id ALREADY EXSIST: ${_}`);const a=new f.ExtHostNotebookEditor(_,this._notebookEditorsProxy,h,E.visibleRanges.map(u.NotebookRange.to),E.selections.map(u.NotebookRange.to),typeof E.viewColumn=="number"?u.ViewColumn.to(E.viewColumn):void 0);this._editors.set(_,a)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const E of h.value.removedDocuments){const a=O.URI.revive(E),k=this._documents.get(a);k&&(k.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:k.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(k.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===a.toString()&&this._editors.delete(s.id)}if(h.value.addedDocuments){const E=[];for(const a of h.value.addedDocuments){const k=O.URI.revive(a.uri);if(this._documents.has(k))throw new Error(`adding EXISTING notebook ${k} `);const s=this,i=new r.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){s._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){s._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){s._onDidChangeCellMetadata.fire(c)}},k,a);E.push(...a.cells.map(c=>r.ExtHostCell.asModelAddData(i.apiNotebook,c))),this._documents.get(k)?.dispose(),this._documents.set(k,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(h.value.addedEditors)for(const E of h.value.addedEditors){if(this._editors.has(E.id))return;const a=O.URI.revive(E.documentUri),k=this._documents.get(a);k&&this._createExtHostEditor(k,E.id,E)}const _=[];if(h.value.removedEditors)for(const E of h.value.removedEditors){const a=this._editors.get(E);a&&(this._editors.delete(E),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),_.push(a))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const E=new Set;this._visibleNotebookEditors.forEach(a=>E.add(a.id));for(const a of this._editors.values()){const k=E.has(a.id);a._acceptVisibility(k)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=p,p._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Se([1,0,5,53,13,4,15,8]),function(J,e,l,T,b,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(C,u){const g=y._Keys.nextId();C.$registerNotebookEditorDecorationType(g,A.NotebookDecorationRenderOptions.from(u)),this.value={key:g,dispose(){C.$removeNotebookEditorDecorationType(g)}}}}y._Keys=new T.IdGenerator("NotebookEditorDecorationType");let O=class{constructor(C,u,g){this._logService=C,this._extHostRpc=u,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(C){return new y(this._extHostRpc.getProxy(M.MainContext.MainThreadNotebookEditors),C).value}$acceptEditorPropertiesChanged(C,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,u);const g=this._notebooksAndEditors.getEditorById(C);u.visibleRanges&&g._acceptVisibleRanges(u.visibleRanges.ranges.map(A.NotebookRange.to)),u.selections&&g._acceptSelections(u.selections.selections.map(A.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const u in C)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(A.ViewColumn.to(C[u]))}};O=Ue([Be(0,b.ILogService),Be(1,I.IExtHostRpcService)],O),e.ExtHostNotebookEditors=O}),define(be[199],Se([1,0,16,12,20,5,7,23,2,26,13,4,39,8,6,63,164,25,38]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(i,c,t,n,m){this._initData=c,this._extHostNotebook=t,this._commands=n,this._logService=m,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(C.MainContext.MainThreadNotebookKernels);const d=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const P=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:P}}else if(S&&"notebookEditor"in S){const P=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return S})],u.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(i,c,t,n,m,d){for(const ie of this._kernelData.values())if(ie.controller.id===c&&O.ExtensionIdentifier.equals(i.identifier,ie.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const S=this._handlePool++,P=this;this._logService.trace(`NotebookController[${S}], CREATED by ${i.identifier.value}, ${c}`);const B=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${i.identifier}'`);let F=!1;const v=new I.DisposableStore,x=new M.Emitter,W=new M.Emitter,V={id:k(i,c),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:n||i.identifier.value,preloads:d?d.map(g.NotebookRendererScript.from):[]};let re=m??B,H;this._proxy.$addKernel(S,V).catch(ie=>{console.log(ie),F=!0});let R=0;const se=()=>{if(F)return;const ie=++R;Promise.resolve().then(()=>{ie===R&&this._proxy.$updateKernel(S,V)})},de=new A.ResourceMap,X={get id(){return c},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return V.label},set label(ie){V.label=ie??i.displayName??i.name,se()},get detail(){return V.detail??""},set detail(ie){V.detail=ie,se()},get description(){return V.description??""},set description(ie){V.description=ie,se()},get kind(){return(0,p.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind??""},set kind(ie){(0,p.checkProposedApiEnabled)(i,"notebookControllerKind"),V.kind=ie,se()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(ie){V.supportedLanguages=ie,se()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){V.supportsExecutionOrder=ie,se()},get rendererScripts(){return V.preloads?V.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ie){re=ie??B},get interruptHandler(){return H},set interruptHandler(ie){H=ie,V.supportsInterrupt=Boolean(ie),se()},createNotebookCellExecution(ie){if(F)throw new Error("notebook controller is DISPOSED");if(!de.has(ie.notebook.uri))throw P._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(he=>he.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return P._createNotebookCellExecution(ie,k(i,this.id))},dispose:()=>{F||(this._logService.trace(`NotebookController[${S}], DISPOSED`),F=!0,this._kernelData.delete(S),v.dispose(),x.dispose(),W.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(ie,he){P._proxy.$updateNotebookPriority(S,ie.uri,he)},onDidReceiveMessage:W.event,postMessage(ie,he){return(0,p.checkProposedApiEnabled)(i,"notebookMessaging"),P._proxy.$postMessage(S,he&&P._extHostNotebook.getIdByEditor(he),ie)},asWebviewUri(ie){return(0,p.checkProposedApiEnabled)(i,"notebookMessaging"),(0,r.asWebviewUri)(ie,P._initData.remote)}};return this._kernelData.set(S,{extensionId:i.identifier,controller:X,onDidReceiveMessage:W,onDidChangeSelection:x,associatedNotebooks:de}),X}$acceptNotebookAssociation(i,c,t){const n=this._kernelData.get(i);if(n){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));t?n.associatedNotebooks.set(m.uri,!0):n.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,m.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:m.apiNotebook})}}async $executeCells(i,c,t){const n=this._kernelData.get(i);if(!n)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)),d=[];for(const S of t){const P=m.getCell(S);P&&d.push(P.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,m.uri.toString(),d.length),await n.controller.executeHandler.call(n.controller,d,m.apiNotebook,n.controller)}catch(S){this._logService.error(`NotebookController[${i}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(i,c,t){const n=this._kernelData.get(i);if(!n)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,m.apiNotebook);else for(const d of t){const S=m.getCell(d);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,c,t){const n=this._kernelData.get(i);if(!n)return;const m=this._extHostNotebook.getEditorById(c);n.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:t}))}$cellExecutionChanged(i,c,t){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(c);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:t?g.NotebookCellExecutionState.to(t):o.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,c){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const m=new E(c,n,this._proxy);this._activeExecutions.set(n.uri,m);const d=m.onDidChangeState(()=>{m.state===_.Resolved&&(m.dispose(),d.dispose(),this._activeExecutions.delete(n.uri))});return m.asApiObject()}};h=Ue([Be(4,L.ILogService)],h),e.ExtHostNotebookKernels=h;var _;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(_||(_={}));class E extends I.Disposable{constructor(i,c,t){super();this._cell=c,this._proxy=t,this._handle=E.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=_.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new a(10,n=>this.update(n)),this._executionOrder=c.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const c=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new D.SerializableObjectWithBuffers(c))}verifyStateForOutput(){if(this._state===_.Init)throw new Error("Must call start before modifying cell output");if(this._state===_.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(c=>{const t=o.NotebookCellOutput.ensureUniqueMimeTypes(c.items,!0);return t===c.items?g.NotebookCellOutput.from(c):g.NotebookCellOutput.from({items:t,id:c.id,metadata:c.metadata})})}async updateOutputs(i,c,t){const n=this.validateAndConvertOutputs((0,l.asArray)(i));return this.updateSoon({editType:f.CellExecutionUpdateType.Output,append:t,outputs:n})}async updateOutputItems(i,c,t){return i=o.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(i),!0),this.updateSoon({editType:f.CellExecutionUpdateType.OutputItems,items:i.map(g.NotebookCellOutputItem.from),outputId:c.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===_.Resolved||i._state===_.Started)throw new Error("Cannot call start again");i._state=_.Started,i._onDidChangeState.fire(),i.update({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,n){if(i._state===_.Resolved)throw new Error("Cannot call resolve twice");i._state=_.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new D.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,n){return i.verifyStateForOutput(),i.updateOutputs(t,n,!0)},replaceOutput(t,n){return i.verifyStateForOutput(),i.updateOutputs(t,n,!1)},appendOutputItems(t,n){return i.verifyStateForOutput(),i.updateOutputItems(t,n,!0)},replaceOutputItems(t,n){return i.verifyStateForOutput(),i.updateOutputItems(t,n,!1)}})}}E.HANDLE=0;class a{constructor(i,c){this.delay=i,this.callback=c,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new T.DeferredPromise,this.startedTimer=Date.now(),(0,T.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const c=this.batch;return this.batch=[],this.callback(c).finally(()=>i.complete())}}function k(s,i){return`${s.identifier.value}/${i}`}}),define(be[200],Se([1,0,5,4,90,25]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class I{constructor(y,O){this._extHostNotebook=O,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,O,L){const C=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(O)?.fire({editor:C.apiEditor,message:L})}createRendererMessaging(y,O){if(!y.contributes?.notebookRenderer?.some(g=>g.id===O))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${O})`);const L=(0,M.isProposedApiEnabled)(y,"notebookEditor"),C=new WeakMap;return{onDidReceiveMessage:(g,o,r)=>{const f=L?g:p=>{const D={};C.set(D,p.editor),g({editor:D,message:p.message})};return this.getOrCreateEmitterFor(O).event(f,o,r)},postMessage:(g,o)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(g)&&([g,o]=[o,g]);const r=L?o:C.get(o),f=r&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(r);return this.proxy.$postMessage(f?.id,O,g)}}}getOrCreateEmitterFor(y){let O=this._rendererMessageEmitters.get(y);return O||(O=new l.Emitter({onLastListenerRemove:()=>{O?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,O),O)}}e.ExtHostNotebookRenderers=I}),define(be[95],Se([1,0,4,7,3,15,13,165,50,28,30,113,22,10]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class o extends T.Disposable{constructor(p,D,h,_){super();this.id=p,this.name=D,this.logger=h,this.proxy=_,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(p){this.append(p+`
`)}append(p){this.write(p),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const D=this.offset;this.write(p),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(p,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:D))}hide(){this.proxy.$close(this.id)}write(p){this.offset+=u.VSBuffer.fromString(p).byteLength,this.logger.info(p)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=o;let r=class{constructor(p,D,h,_,E){this.extHostFileSystem=h,this.extHostFileSystemInfo=_,this.loggerService=E,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[D,h]of this.channels)h.visible=D===this.visibleChannelId}createOutputChannel(p,D,h){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");if((0,g.isString)(D)&&!D.trim())throw new Error("illegal argument `languageId`. must not be empty");const _=this.doCreateOutputChannel(p,D,h);return _.then(E=>{this.channels.set(E.id,E),E.visible=E.id===this.visibleChannelId}),this.createExtHostOutputChannel(p,_)}async doCreateOutputChannel(p,D,h){const _=await this.createOutputDirectory(),E=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(E,{always:!0,donotRotate:!0,donotUseFormatters:!0}),k=await this.proxy.$register(p,!1,E,D,h.identifier.value);return new o(k,p,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(p,D){let h=!1;const _=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return p},append(E){_(),D.then(a=>a.append(E))},appendLine(E){_(),D.then(a=>a.appendLine(E))},clear(){_(),D.then(E=>E.clear())},replace(E){_(),D.then(a=>a.replace(E))},show(E,a){_(),D.then(k=>k.show(E,a))},hide(){_(),D.then(E=>E.hide())},dispose(){h=!0,D.then(E=>E.dispose())}}}};r=Ue([Be(0,M.IExtHostRpcService),Be(1,O.IExtHostInitDataService),Be(2,y.IExtHostConsumerFileSystem),Be(3,L.IExtHostFileSystemInfo),Be(4,I.ILoggerService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(be[201],Se([1,0,12,20,5,7,4,2,6,14,16,34,59,25]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(r,f,p){const D=r.getProxy(I.MainContext.MainThreadQuickOpen);class h{constructor(n,m){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=m}showQuickPick(n,m,d=T.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(n),P=++this._instances,B=D.$show(P,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},d),F={},v=B.then(()=>F);return Promise.race([v,S]).then(x=>{if(x!==F)return S.then(W=>{const V=[];for(let re=0;re<W.length;re++){const H=W[re];typeof H=="string"?V.push({label:H,handle:re}):H.kind===y.QuickPickItemKind.Separator?V.push({type:"separator",label:H.label}):V.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:re})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=re=>{m.onDidSelectItem(W[re])}),D.$setItems(P,V),B.then(re=>{if(typeof re=="number")return W[re];if(Array.isArray(re))return re.map(H=>W[H])})})}).then(void 0,x=>{if(!(0,O.isCancellationError)(x))return D.$setError(P,x),Promise.reject(x)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,m=T.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,D.$input(n,typeof this._validateInput=="function",m).then(void 0,d=>{if(!(0,O.isCancellationError)(d))return Promise.reject(d)})}$validateInput(n){return this._validateInput?(0,l.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,m=T.CancellationToken.None){const d=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!d)return;const S=await this._workspace.getWorkspaceFolders2();if(!!S)return S.find(P=>P.uri.toString()===d.uri.toString())}createQuickPick(n){const m=new i(n,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(n){const m=new c(n,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(n,m){const d=this._sessions.get(n);d&&d._fireDidChangeValue(m)}$onDidAccept(n){const m=this._sessions.get(n);m&&m._fireDidAccept()}$onDidChangeActive(n,m){const d=this._sessions.get(n);d instanceof i&&d._fireDidChangeActive(m)}$onDidChangeSelection(n,m){const d=this._sessions.get(n);d instanceof i&&d._fireDidChangeSelection(m)}$onDidTriggerButton(n,m){const d=this._sessions.get(n);d&&d._fireDidTriggerButton(m)}$onDidTriggerItemButton(n,m,d){const S=this._sessions.get(n);S instanceof i&&S._fireDidTriggerItemButton(m,d)}$onDidHide(n){const m=this._sessions.get(n);m&&m._fireDidHide()}}class _{constructor(n,m){this._extensionId=n,this._onDidDispose=m,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((m,d)=>{const S=m===y.QuickInputButtons.Back?-1:d;this._handlesToButtons.set(S,m)}),this.update({buttons:n.map((m,d)=>({...s(m),tooltip:m.tooltip,handle:m===y.QuickInputButtons.Back?-1:d}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const m=this._handlesToButtons.get(n);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,M.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),D.$dispose(this._id))}update(n){if(!this._disposed){for(const m of Object.keys(n)){const d=n[m];this._pendingUpdate[m]=d===void 0?null:d}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){D.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function E(t){if(t instanceof y.ThemeIcon)return{id:t.id};const n=k(t),m=a(t);return{dark:typeof n=="string"?A.URI.file(n):n,light:typeof m=="string"?A.URI.file(m):m}}function a(t){return typeof t=="object"&&"light"in t?t.light:t}function k(t){return typeof t=="object"&&"dark"in t?t.dark:t}function s(t){const n=E(t.iconPath);let m,d;return"id"in n?d=u.ThemeIcon.asClassName(n):m=n,{iconPath:m,iconClass:d}}class i extends _{constructor(n,m){super(n.identifier,m);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((d,S)=>{this._handlesToItems.set(S,d),this._itemsToHandles.set(d,S)});const m=[];for(let d=0;d<n.length;d++){const S=n[d];S.kind===y.QuickPickItemKind.Separator?m.push({type:"separator",label:S.label}):m.push({handle:d,label:S.label,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,buttons:S.buttons?.map((P,B)=>({...s(P),tooltip:P.tooltip,handle:B}))})}this.update({items:m})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(n){const m=(0,L.coalesce)(n.map(d=>this._handlesToItems.get(d)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(n){const m=(0,L.coalesce)(n.map(d=>this._handlesToItems.get(d)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(n,m){const d=this._handlesToItems.get(n);if(!d||!d.buttons||!d.buttons.length)return;const S=d.buttons[m];S&&this._onDidTriggerItemButtonEmitter.fire({button:S,item:d})}}class c extends _{constructor(n,m){super(n.identifier,m);this.extension=n,this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?C.default.Error:C.default.Ignore})}get validationMessage2(){return this._validationMessage2}set validationMessage2(n){(0,g.checkProposedApiEnabled)(this.extension,"inputBoxSeverity"),this._validationMessage2=n,n?typeof n=="string"?this.update({validationMessage:n,severity:C.default.Error}):this.update({validationMessage:n.content,severity:n.severity??C.default.Error}):this.update({validationMessage:void 0,severity:C.default.Ignore})}}return new h(f,p)}e.createExtHostQuickOpen=o});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[202],Se([1,0,2,5,52,7,12,4,16,108,13,26,59,8,25]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o){"use strict";var r,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(m){if(m)return typeof m.iconPath=="string"?l.URI.file(m.iconPath):l.URI.isUri(m.iconPath)||u.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function D(m,d){if(!m.iconPath&&!d.iconPath)return 0;if(m.iconPath){if(!d.iconPath)return 1}else return-1;const S=typeof m.iconPath=="string"?m.iconPath:l.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,P=typeof d.iconPath=="string"?d.iconPath:l.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,O.comparePaths)(S,P)}function h(m,d){let S=0;if(m.strikeThrough!==d.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==d.faded)return m.faded?1:-1;if(m.tooltip!==d.tooltip)return(m.tooltip||"").localeCompare(d.tooltip||"");if(S=D(m,d),S!==0)return S;if(m.light&&d.light)S=D(m.light,d.light);else{if(m.light)return 1;if(d.light)return-1}if(S!==0)return S;if(m.dark&&d.dark)S=D(m.dark,d.dark);else{if(m.dark)return 1;if(d.dark)return-1}return S}function _(m,d){if(m.command!==d.command)return m.command<d.command?-1:1;if(m.title!==d.title)return m.title<d.title?-1:1;if(m.tooltip!==d.tooltip){if(m.tooltip!==void 0&&d.tooltip!==void 0)return m.tooltip<d.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(m.arguments===d.arguments)return 0;if(m.arguments)if(d.arguments){if(m.arguments.length!==d.arguments.length)return m.arguments.length-d.arguments.length}else return 1;else return-1;for(let S=0;S<m.arguments.length;S++){const P=m.arguments[S],B=d.arguments[S];if(P!==B)return P<B?-1:1}return 0}function E(m,d){let S=(0,O.comparePaths)(m.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(S!==0)return S;if(m.command&&d.command)S=_(m.command,d.command);else{if(m.command)return 1;if(d.command)return-1}if(S!==0)return S;if(m.decorations&&d.decorations)S=h(m.decorations,d.decorations);else{if(m.decorations)return 1;if(d.decorations)return-1}return S}function a(m,d){for(let S=0;S<m.length;S++)if(m[S]!==d[S])return!1;return!0}function k(m,d){return m.command===d.command&&m.title===d.title&&m.tooltip===d.tooltip&&(m.arguments&&d.arguments?a(m.arguments,d.arguments):m.arguments===d.arguments)}function s(m,d){return(0,y.equals)(m,d,k)}class i{constructor(d,S,P){this._extension=d,this._sourceControlHandle=P,r.set(this,void 0),this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0,Ge(this,r,S,"f")}get value(){return this._value}set value(d){d=d??"",Te(this,r,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Te(this,r,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Te(this,r,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Te(this,r,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,S){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),Te(this,r,"f").$showValidationMessage(this._sourceControlHandle,d,S)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=i,r=new WeakMap;class c{constructor(d,S,P,B,F){this._proxy=d,this._commands=S,this._sourceControlHandle=P,this._id=B,this._label=F,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=c._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,S){const P=this._resourceStatesCommandsMap.get(d);return P?(0,I.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(E),P=(0,y.sortedDiff)(this._resourceSnapshot,d,E).map(v=>{const x=v.toInsert.map(W=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,W);const re=W.resourceUri;let H;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const pe=new M.DisposableStore;H=this._commands.converter.toInternal(W.command,pe),this._resourceStatesDisposablesMap.set(V,pe)}else this._resourceStatesCommandsMap.set(V,W.command);const R=p(W.decorations),se=W.decorations&&p(W.decorations.light)||R,de=W.decorations&&p(W.decorations.dark)||R,X=[se,de],ie=W.decorations&&W.decorations.tooltip||"",he=W.decorations&&!!W.decorations.strikeThrough,me=W.decorations&&!!W.decorations.faded,fe=W.contextValue||"";return{rawResource:[V,re,X,ie,he,me,fe,H],handle:V}});return{start:v.start,deleteCount:v.deleteCount,toInsert:x}}),B=P.map(({start:v,deleteCount:x,toInsert:W})=>[v,x,W.map(V=>V.rawResource)]),F=P.reverse();for(const{start:v,deleteCount:x,toInsert:W}of F){const V=W.map(H=>H.handle),re=this._handlesSnapshot.splice(v,x,...V);for(const H of re)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=d,B}dispose(){this._disposed=!0,this._onDidDispose.fire()}}c._handlePool=0;class t{constructor(d,S,P,B,F,v){this._extension=d,this._commands=P,this._id=B,this._label=F,this._rootUri=v,f.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ge(this,f,S,"f"),this._inputBox=new i(d,Te(this,f,"f"),this.handle),Te(this,f,"f").$registerSourceControl(this.handle,B,F,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Te(this,f,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Te(this,f,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Te(this,f,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=d;const S=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Te(this,f,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=d;const S=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),description:d.description}:void 0;Te(this,f,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&s(this._statusBarCommands,d))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=d;const S=(d||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));Te(this,f,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(d,S){const P=new c(Te(this,f,"f"),this._commands,this.handle,d,S),B=T.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,B),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const d=[],S=[];for(const[P,B]of this.createdResourceGroups){B.dispose();const F=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});T.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),F.dispose(),this._groups.delete(P.handle),Te(this,f,"f").$unregisterGroup(this.handle,P.handle)}),d.push([P.handle,P.id,P.label,P.features]);const v=P._takeResourceStateSnapshot();v.length>0&&S.push([P.handle,v]),this._groups.set(P.handle,P)}Te(this,f,"f").$registerGroups(this.handle,d,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(S=>{const P=S._takeResourceStateSnapshot();P.length!==0&&d.push([S.handle,P])}),d.length>0&&Te(this,f,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Te(this,f,"f").$unregisterSourceControl(this.handle)}}f=new WeakMap,t._handlePool=0,Ue([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ue([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let n=class Gi{constructor(d,S,P){this._commands=S,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=d.getProxy(A.MainContext.MainThreadSCM),this._telemetry=d.getProxy(A.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const F=this._sourceControls.get(B.sourceControlHandle);if(!F)return B;const v=F.getResourceGroup(B.groupHandle);return v?v.getResourceState(B.handle):B}else if(B&&B.$mid===4){const F=this._sourceControls.get(B.sourceControlHandle);return F?F.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const F=this._sourceControls.get(B.handle);return F||B}return B}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,S,P,B){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,S,P,B),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const F=Gi._handlePool++,v=new t(d,this._proxy,this._commands,S,P,B);this._sourceControls.set(F,v);const x=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier))||[];return x.push(v),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(d.identifier),x),v}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const S=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(d.identifier)),P=S&&S[S.length-1];return P&&P.inputBox}$provideOriginalResource(d,S,P){const B=l.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,B.toString());const F=this._sourceControls.get(d);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>F.quickDiffProvider.provideOriginalResource(B,P)).then(v=>v||null)}$onInputBoxValueChange(d,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const P=this._sourceControls.get(d);return P&&P.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(d,S,P,B){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,S,P);const F=this._sourceControls.get(d);if(!F)return Promise.resolve(void 0);const v=F.getResourceGroup(S);return v?v.$executeResourceCommand(P,B):Promise.resolve(void 0)}$validateInput(d,S,P){this.logService.trace("ExtHostSCM#$validateInput",d);const B=this._sourceControls.get(d);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>B.inputBox.validateInput(S,P)).then(F=>{if(!F)return Promise.resolve(void 0);const v=g.MarkdownString.fromStrict(F.message);return v?Promise.resolve([v,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};n._handlePool=0,n=Ue([Be(2,L.ILogService)],n),e.ExtHostSCM=n});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[203],Se([1,0,6,4,127,7,8,10]),function(J,e,l,T,b,M,I,A){"use strict";var y,O;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(o,r,f,p,D=l.StatusBarAlignment.Left,h){y.set(this,void 0),O.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Ge(this,y,o,"f"),Ge(this,O,r,"f"),this._entryId=L.ID_GEN++,this._extension=f,this._id=p,this._alignment=D,this._priority=this.validatePriority(h)}validatePriority(o){if(!!(0,A.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!L.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Te(this,O,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Te(this,O,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let r;this._name?r=this._name:r=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let f=this._color;this._backgroundColor&&(f=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const p=I.MarkdownString.fromStrict(this._tooltip);Te(this,y,"f").$setEntry(this._entryId,o,r,this._text,p,this._command?.internal,f,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,O=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class C{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const r={message:o};return this._messages.unshift(r),this._update(),new l.Disposable(()=>{const f=this._messages.indexOf(r);f>=0&&(this._messages.splice(f,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class u{constructor(o,r){this._proxy=o.getProxy(T.MainContext.MainThreadStatusBar),this._commands=r,this._statusMessage=new C(this)}createStatusBarEntry(o,r,f,p){return new L(this._proxy,this._commands,o,r,f,p)}setStatusBarMessage(o,r){const f=this._statusMessage.setMessage(o);let p;return typeof r=="number"?p=setTimeout(()=>f.dispose(),r):typeof r!="undefined"&&r.then(()=>f.dispose(),()=>f.dispose()),new l.Disposable(()=>{f.dispose(),clearTimeout(p)})}}e.ExtHostStatusBar=u}),define(be[70],Se([1,0,4,5,3]),function(J,e,l,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,O){return this._proxy.$initializeExtensionStorage(A,y).then(L=>L||O)}setValue(A,y,O){return this._proxy.$setValue(A,y,O)}$acceptValue(A,y,O){this._onDidChangeStorage.fire({shared:A,key:y,value:O})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(be[71],Se([1,0,3,28,13,50,2]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let A=class{constructor(O,L,C){this._logService=L,this._extHostFileSystem=C,this._workspace=O.workspace??void 0,this._environment=O.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(O){return I.URI.joinPath(this._environment.workspaceStorageHome,O)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const O=this._workspace.id,L=await this._getWorkspaceStorageURI(O);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(O){if(this._value)return I.URI.joinPath(this._value,O.identifier.value)}globalValue(O){return I.URI.joinPath(this._environment.globalStorageHome,O.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Ue([Be(0,T.IExtHostInitDataService),Be(1,b.ILogService),Be(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(be[40],Se([1,0,5,4,3,2,15,7,6,128,14,167,20,36,148,59,10,12]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class D{constructor(t,n,m,d){this._proxy=t,this._id=n,this._creationOptions=m,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(P,B=!0){S._checkDisposed(),S._proxy.$sendText(S._id,P,B)},show(P){S._checkDisposed(),S._proxy.$show(S._id,P)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(t,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,f.withNullAsUndefined)(t.shellPath),shellArgs:(0,f.withNullAsUndefined)(t.shellArgs),cwd:(0,f.withNullAsUndefined)(t.cwd),env:(0,f.withNullAsUndefined)(t.env),icon:(0,f.withNullAsUndefined)(s(t.iconPath)),color:r.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,f.withNullAsUndefined)(t.message),strictEnv:(0,f.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,f.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,f.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,f.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this._serializeParentTerminal(t.location,n?.resolvedExtHostIdentifier),isTransient:(0,f.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,n,m,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:r.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(t,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,n){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=D;class h{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${n}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,n){this._pty.setDimensions?.({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose?.((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions?.(n=>{n&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this._pty.onDidChangeName?.(n=>{this._onDidChangeProperty.fire({type:"title",value:n})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let _=1,E=class extends A.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=n.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[m,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,n){const m=new D(this._proxy,(0,g.generateUuid)(),t,t.name),d=new h(t.pty);return m.createExtensionTerminal(t.location,this._serializeParentTerminal(t,n).resolvedExtHostIdentifier,s(t.iconPath),i(t.color)).then(S=>{const P=this._setupExtHostProcessListeners(S,d);this._terminalProcessDisposables[S]=P}),this._terminals.push(m),m.value}_serializeParentTerminal(t,n){if(n=n||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const m=t.location.parentTerminal;if(m){const d=this._terminals.find(S=>S.value===m);d&&(n.resolvedExtHostIdentifier=d._id)}}else t.location&&typeof t.location!="object"?n.location=t.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const d=new h(n),S=this._setupExtHostProcessListeners(t,d);this._terminalProcessDisposables[t]=S}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(t);m&&(this._activeTerminal=m,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const m=this._getTerminalById(t);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:n})}async $acceptTerminalDimensions(t,n,m){const d=this._getTerminalById(t);d&&d.setDimensions(n,m)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,m){this._terminalProcesses.get(t)?.resize(n,m)}async $acceptTerminalTitleChange(t,n){const m=this._getTerminalById(t);m&&(m.name=n)}async $acceptTerminalClosed(t,n){const m=this._getTerminalObjectIndexById(this._terminals,t);if(m!==null){const d=this._terminals.splice(m,1)[0];d.setExitCode(n),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(t,n,m,d){if(n){const B=this._getTerminalObjectIndexById(this._terminals,n);if(B!==null){this._terminals[B]._id=t,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const S={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:M.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},P=new D(this._proxy,t,S,m);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(t,n){const m=this._getTerminalById(t);m&&m._setProcessId(n)}async $startExtensionTerminal(t,n){const m=this._getTerminalById(t);if(!m)return{message:(0,O.localize)(0,null,t)};m.isOpen||await new Promise(S=>{const P=this.onDidOpenTerminal(async B=>{B===m.value&&(P.dispose(),S())})});const d=this._terminalProcesses.get(t);d?d.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const m=new A.DisposableStore;m.add(n.onProcessReady(S=>this._proxy.$sendProcessReady(t,S.pid,S.cwd))),m.add(n.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(t,S))),this._bufferer.startBuffering(t,n.onProcessData),m.add(n.onProcessExit(S=>this._onProcessExit(t,S))),this._terminalProcesses.set(t,n);const d=this._extensionTerminalAwaitingStart[t];return d&&n instanceof h&&(n.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),m}$acceptProcessAckDataEvent(t,n){this._terminalProcesses.get(t)?.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){this._terminalProcesses.get(t)?.input(n)}$acceptTerminalInteraction(t){const n=this._getTerminalById(t);n?.setInteractedWith()&&this._onDidChangeTerminalState.fire(n.value)}$acceptProcessResize(t,n,m){try{this._terminalProcesses.get(t)?.resize(n,m)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(t,n){this._terminalProcesses.get(t)?.shutdown(n)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(n=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(n=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:n}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,n,m){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,m),this._proxy.$registerProfileProvider(n,t.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(t,n){const m=new u.CancellationTokenSource().token;let d=await this._profileProviders.get(t)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,n);return}this.createTerminalFromOptions(d.options,n)}}async $provideLinks(t,n){const m=this._getTerminalById(t);if(!m)return[];this._terminalLinkCache.delete(t);const d=this._terminalLinkCancellationSource.get(t);d&&d.dispose(!0);const S=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,S);const P=[],B={terminal:m.value,line:n},F=[];for(const W of this._linkProviders)F.push(p.Promises.withAsyncBody(async V=>{S.token.onCancellationRequested(()=>V({provider:W,links:[]}));const re=await W.provideTerminalLinks(B,S.token)||[];S.token.isCancellationRequested||V({provider:W,links:re})}));const v=await Promise.all(F);if(S.token.isCancellationRequested)return[];const x=new Map;for(const W of v)W&&W.links.length>0&&P.push(...W.links.map(V=>{const re={id:_++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return x.set(re.id,{provider:W.provider,link:V}),re}));return this._terminalLinkCache.set(t,x),P}$activateLink(t,n){const m=this._terminalLinkCache.get(t)?.get(n);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const m=this._terminalProcessDisposables[t];m&&(m.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const m=this._getTerminalObjectIndexById(t,n);return m!==null?t[m]:null}_getTerminalObjectIndexById(t,n){let m=null;return t.some((d,S)=>d._id===n?(m=S,!0):!1),m}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new a,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const m=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const m=n[0],d=new a(n[1]);this._setEnvironmentVariableCollection(m,d)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=Ue([Be(1,I.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class a{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const m=this.map.get(t);(!m||m.value!==n.value||m.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((m,d)=>t.call(n,d,m,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let k=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,m){throw new L.NotSupportedError}createTerminalFromOptions(t,n){throw new L.NotSupportedError}};k=Ue([Be(0,I.IExtHostRpcService)],k),e.WorkerExtHostTerminalService=k;function s(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function i(c){return r.ThemeColor.isThemeColor(c)?c:void 0}});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[204],Se([1,0,16,22,20,5,235,94,7,27,10,36,4,15,47,8,6,173,64,65]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h){"use strict";var _,E;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(F,v){this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(u.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new s(this.proxy),v.registerArgumentProcessor({processArgument:x=>x?.$mid===13?r.TestItem.toItemFromContext(x):x})}createTestController(F,v,x){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const W=new y.DisposableStore,V=W.add(new p.SingleUseTestCollection(F));V.root.label=v;const re=new Map,H=this.proxy,R={items:V.root.children,get label(){return v},set label(de){v=de,V.root.label=de,H.$updateController(F,{label:v})},get refreshHandler(){return x},set refreshHandler(de){x=de,H.$updateController(F,{canRefresh:!!de})},get id(){return F},createRunProfile:(de,X,ie,he,me)=>{let fe=(0,A.hash)(de);for(;re.has(fe);)fe++;return new S(this.proxy,re,F,fe,de,X,ie,he,me)},createTestItem(de,X,ie){return new o.TestItemImpl(F,de,X,ie)},createTestRun:(de,X,ie=!0)=>this.runTracker.createTestRun(F,V,de,X,ie),set resolveHandler(de){V.resolveHandler=de},get resolveHandler(){return V.resolveHandler},dispose:()=>{W.dispose()}};H.$registerTestController(F,v,!!x),W.add((0,y.toDisposable)(()=>H.$unregisterTestController(F)));const se={controller:R,collection:V,profiles:re};return this.controllers.set(F,se),W.add((0,y.toDisposable)(()=>this.controllers.delete(F))),W.add(V.onDidGenerateDiff(de=>H.$publishDiff(F,de.map(D.TestsDiffOp.serialize)))),R}createTestObserver(){return this.observer.checkout()}async runTests(F,v=b.CancellationToken.None){const x=i(F);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(x.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(V=>h.TestId.fromExtHostTestItem(V,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:P[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:F.exclude?.map(V=>V.id)},v)}$provideFileCoverage(F,v,x){return(0,l.mapFind)(this.runTracker.trackers,V=>V.id===F?V.getCoverage(v):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(F,v,x,W){return(0,l.mapFind)(this.runTracker.trackers,re=>re.id===F?re.getCoverage(v):void 0)?.resolveFileCoverage(x,W)??Promise.resolve([])}$configureRunProfile(F,v){this.controllers.get(F)?.profiles.get(v)?.configureHandler?.()}async $refreshTests(F,v){await this.controllers.get(F)?.controller.refreshHandler?.(v)}$publishTestResults(F){this.results=Object.freeze(F.map(v=>(0,O.deepFreeze)(r.TestResults.to(v))).concat(this.results).sort((v,x)=>x.completedAt-v.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,v){const x=this.controllers.get(h.TestId.fromString(F).controllerId)?.collection;x&&(await x.expand(F,v<0?1/0:v),x.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F.map(D.TestsDiffOp.deserialize))}async $runControllerTests(F,v){const x=this.controllers.get(F.controllerId);if(!x)return;const{collection:W,profiles:V}=x,re=V.get(F.profileId);if(!re)return;const H=F.testIds.map(X=>W.tree.get(X)).filter(L.isDefined),R=F.excludeExtIds.map(X=>x.collection.tree.get(X)).filter(L.isDefined).filter(X=>H.some(ie=>ie.fullId.compare(X.fullId)===2));if(!H.length)return;const se=new f.TestRunRequest(H.some(X=>X.actual instanceof o.TestItemRootImpl)?void 0:H.map(X=>X.actual),R.map(X=>X.actual),re),de=this.runTracker.prepareForMainThreadTestRun(se,c.fromInternal(F,x.collection),v);try{await re.runHandler(se,v)}finally{de.isRunning&&!v.isCancellationRequested&&await M.Event.toPromise(de.onEnd),de.dispose()}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};a=Ue([Be(0,g.IExtHostRpcService)],a),e.ExtHostTesting=a;class k extends y.Disposable{constructor(F,v,x){super();this.dto=F,this.proxy=v,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:W}of this.tasks.values())W.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const v=this.dto.id,x=this.dto.controllerId,W=(0,C.generateUuid)(),V=new t(this.proxy,v,W),re=de=>(X,...ie)=>{if(R){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(X)||(this.ensureTestIsKnown(X),de(X,...ie))},H=(de,X)=>{const ie=X instanceof Array?X.map(r.TestMessage.from):[r.TestMessage.from(X)];if(de.uri&&de.range){const he={range:r.Range.from(de.range),uri:de.uri};for(const me of ie)me.location=me.location||he}this.proxy.$appendTestMessagesInRun(v,W,h.TestId.fromExtHostTestItem(de,x).toString(),ie)};let R=!1;const se={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return V.coverageProvider},set coverageProvider(de){V.coverageProvider=de},enqueued:re(de=>{this.proxy.$updateTestStateInRun(v,W,h.TestId.fromExtHostTestItem(de,x).toString(),1)}),skipped:re(de=>{this.proxy.$updateTestStateInRun(v,W,h.TestId.fromExtHostTestItem(de,x).toString(),5)}),started:re(de=>{this.proxy.$updateTestStateInRun(v,W,h.TestId.fromExtHostTestItem(de,x).toString(),2)}),errored:re((de,X,ie)=>{H(de,X),this.proxy.$updateTestStateInRun(v,W,h.TestId.fromExtHostTestItem(de,x).toString(),6,ie)}),failed:re((de,X,ie)=>{H(de,X),this.proxy.$updateTestStateInRun(v,W,h.TestId.fromExtHostTestItem(de,x).toString(),4,ie)}),passed:re((de,X)=>{this.proxy.$updateTestStateInRun(v,W,h.TestId.fromExtHostTestItem(de,this.dto.controllerId).toString(),3,X)}),appendOutput:(de,X,ie)=>{R||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(v,W,T.VSBuffer.fromString(de),X&&r.location.from(X),ie&&h.TestId.fromExtHostTestItem(ie,x).toString()))},end:()=>{R||(R=!0,this.proxy.$finishedTestRunTask(v,W),this.tasks.delete(W),this.isRunning||this.dispose())}};return this.tasks.set(W,{run:se,coverage:V}),this.proxy.$startedTestRunTask(v,{id:W,name:F,running:!0}),se}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof o.TestItemImpl))throw new o.InvalidTestItemError(F.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const v=[],x=this.dto.colllection.root;for(;;){const W=r.TestItem.from(F);if(v.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),F===x))break;F=F.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,v)}}class s{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,v,x){return this.getTracker(F,v,x)}cancelRunById(F){for(const v of this.tracked.values())if(v.id===F){v.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,v,x,W,V){const re=this.tracked.get(x);if(re)return re.createRun(W);const H=c.fromPublic(F,v,x,V),R=i(x);this.proxy.$startedExtensionTestRun({controllerId:F,profile:R&&{group:P[R.kind],id:R.profileId},exclude:x.exclude?.map(de=>h.TestId.fromExtHostTestItem(de,v.root.id).toString())??[],id:H.id,include:x.include?.map(de=>h.TestId.fromExtHostTestItem(de,v.root.id).toString())??[v.root.id],persist:V});const se=this.getTracker(x,H);return se.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),se.createRun(W)}getTracker(F,v,x){const W=new k(v,this.proxy,x);return this.tracked.set(F,W),W.onEnd(()=>this.tracked.delete(F)),W}}e.TestRunCoordinator=s;const i=B=>{if(!!B.profile){if(!(B.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class c{constructor(F,v,x,W,V,re){this.controllerId=F,this.id=v,this.isPersisted=V,this.colllection=re,this.includePrefix=x.map(H=>H+"\0"),this.excludePrefix=W.map(H=>H+"\0")}static fromPublic(F,v,x,W){return new c(F,(0,C.generateUuid)(),x.include?.map(V=>h.TestId.fromExtHostTestItem(V,F).toString())??[F],x.exclude?.map(V=>h.TestId.fromExtHostTestItem(V,F).toString())??[],W,v)}static fromInternal(F,v){return new c(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,v)}isIncluded(F){const v=h.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(v===x||v.startsWith(x))return!1;for(const x of this.includePrefix)if(v===x||v.startsWith(x))return!0;return!1}}e.TestRunDto=c;class t{constructor(F,v,x){this.proxy=F,this.runId=v,this.taskId=x}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(r.TestCoverage.fromFile)??[]}catch(v){throw this.fileCoverage=void 0,v}}async resolveFileCoverage(F,v){const x=await this.fileCoverage;let W=x?.[F];return!this._coverageProvider||!x||!W?[]:(W.detailedCoverage||(W=x[F]=await this._coverageProvider.resolveFileCoverage?.(W,v)??W),W.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class n extends D.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,r.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:v,removed:x}=this;return{get added(){return[...F].map(W=>W.revived)},get updated(){return[...v].map(W=>W.revived)},get removed(){return[...x].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,v){return{...F,revived:r.TestItem.toPlain(F.item),depth:v?v.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=m;class d{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(v=>v.revived)},dispose:(0,I.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class S{constructor(F,v,x,W,V,re,H,R=!1,se=void 0){this.controllerId=x,this.profileId=W,this._label=V,this.kind=re,this.runHandler=H,this._isDefault=R,this._tag=se,_.set(this,void 0),E.set(this,void 0),Ge(this,_,F,"f"),Ge(this,E,v,"f"),v.set(W,this);const de=P[re];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);Te(this,_,"f").$publishTestRunProfile({profileId:W,controllerId:x,tag:se?r.TestTag.namespace(this.controllerId,se.id):null,label:V,group:de,isDefault:R,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Te(this,_,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Te(this,_,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Te(this,_,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?r.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Te(this,_,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Te(this,E,"f")?.delete(this.profileId)&&(Ge(this,E,void 0,"f"),Te(this,_,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,_=new WeakMap,E=new WeakMap;const P={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(be[205],Se([1,0,5,16,4,91,8,6,87,20]),function(J,e,l,T,b,M,I,A,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class L{constructor(u,g){this._extHostDocumentsAndEditors=g,this._onDidChangeTextEditorSelection=new l.Emitter,this._onDidChangeTextEditorOptions=new l.Emitter,this._onDidChangeTextEditorVisibleRanges=new l.Emitter,this._onDidChangeTextEditorViewColumn=new l.Emitter,this._onDidChangeActiveTextEditor=new l.Emitter,this._onDidChangeVisibleTextEditors=new l.Emitter,this._onWillDropOnTextEditor=new l.AsyncEmitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onWillDropOnTextEditor=this._onWillDropOnTextEditor.event,this._proxy=u.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(u){const g=this._extHostDocumentsAndEditors.allEditors();return u?g:g.map(o=>o.value)}async showTextDocument(u,g,o){let r;typeof g=="number"?r={position:I.ViewColumn.from(g),preserveFocus:o}:typeof g=="object"?r={position:I.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?I.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:r={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(u.uri,r),p=f&&this._extHostDocumentsAndEditors.getEditor(f);if(p)return p.value;throw f?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}createTextEditorDecorationType(u,g){return new M.TextEditorDecorationType(this._proxy,u,g).value}$acceptEditorPropertiesChanged(u,g){const o=this._extHostDocumentsAndEditors.getEditor(u);if(!o)throw new Error("unknown text editor");if(g.options&&o._acceptOptions(g.options),g.selections){const r=g.selections.selections.map(I.Selection.to);o._acceptSelections(r)}if(g.visibleRanges){const r=T.coalesce(g.visibleRanges.map(I.Range.to));o._acceptVisibleRanges(r)}if(g.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:{...g.options,lineNumbers:I.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const r=A.TextEditorSelectionChangeKind.fromValue(g.selections.source),f=g.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:f,kind:r})}if(g.visibleRanges){const r=T.coalesce(g.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:r})}}$acceptEditorPositionData(u){for(const g in u){const o=this._extHostDocumentsAndEditors.getEditor(g);if(!o)throw new Error("Unknown text editor");const r=I.ViewColumn.to(u[g]);o.value.viewColumn!==r&&(o._acceptViewColumn(r),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:r}))}}getDiffInformation(u){return Promise.resolve(this._proxy.$getDiffInformation(u))}async $textEditorHandleDrop(u,g,o){const r=this._extHostDocumentsAndEditors.getEditor(u);if(!r)throw new Error("Unknown text editor");const f=I.Position.to(g),p=y.DataTransferConverter.toDataTransfer(o),D=Object.freeze({editor:r.value,position:f,dataTransfer:p});await this._onWillDropOnTextEditor.fireAsync(D,O.CancellationToken.None)}}e.ExtHostEditors=L}),define(be[206],Se([1,0,2,3,4,7,6,8,10]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class O{constructor(u,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=u.getProxy(b.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===11){const r=o.uri===void 0?void 0:l.URI.revive(o.uri);return this._itemsBySourceAndUriMap.get(o.source)?.get(L(r))?.get(o.handle)}return o}})}async $getTimeline(u,g,o,r,f){return this._providers.get(u)?.provideTimeline(l.URI.revive(g),o,r,f)}registerTimelineProvider(u,g,o,r){const f=new M.DisposableStore,p=this.convertTimelineItem(g.id,r,f).bind(this);let D;g.onDidChange&&(D=g.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:g.id}),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:u,onDidChange:void 0,async provideTimeline(_,E,a,k){k?.resetCache&&(f.clear(),h.get(g.id)?.clear());const s=await g.provideTimeline(_,E,a);if(s==null)return;const i=p(_,k);return{...s,source:g.id,items:s.items.map(i)}},dispose(){for(const _ of h.values())_.get(g.id)?.clear();D?.dispose(),f.dispose()}})}convertTimelineItem(u,g,o){return(r,f)=>{let p;if(f?.cacheResults){let D=this._itemsBySourceAndUriMap.get(u);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(u,D));const h=L(r);p=D.get(h),p===void 0&&(p=new Map,D.set(h,p))}return D=>{const{iconPath:h,..._}=D,E=`${u}|${D.id??D.timestamp}`;p?.set(E,D);let a,k,s;D.iconPath&&(h instanceof I.ThemeIcon?s={id:h.id,color:h.color}:l.URI.isUri(h)?(a=h,k=h):{light:a,dark:k}=h);let i;return I.MarkdownString.isMarkdownString(_.tooltip)?i=A.MarkdownString.from(_.tooltip):(0,y.isString)(_.tooltip)?i=_.tooltip:I.MarkdownString.isMarkdownString(_.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=A.MarkdownString.from(_.detail)):(0,y.isString)(_.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=_.detail),{..._,id:_.id??void 0,handle:E,source:u,command:D.command?g.toInternal(D.command,o):void 0,icon:a,iconDark:k,themeIcon:s,tooltip:i,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(u){if(this._providers.get(u.id))throw new Error(`Timeline Provider ${u.id} already exists.`);return this._proxy.$registerTimelineProvider({id:u.id,label:u.label,scheme:u.scheme}),this._providers.set(u.id,u),(0,M.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(u.id)?.clear();this._providers.delete(u.id),this._proxy.$unregisterTimelineProvider(u.id),u.dispose()})}}e.ExtHostTimeline=O;function L(C){return C?.toString()}}),define(be[207],Se([1,0,7,11,2,4]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this._openers=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,O,L,C){if(this._openers.has(O))throw new Error(`Opener with id '${O}' already registered`);const u=C.schemes.find(g=>!I.supportedSchemes.has(g));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(O,L),this._proxy.$registerUriOpener(O,C.schemes,y,C.label),(0,l.toDisposable)(()=>{this._openers.delete(O),this._proxy.$unregisterUriOpener(O)})}async $canOpenUri(y,O,L){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const u=b.URI.revive(O);return C.canOpenExternalUri(u,L)}async $openUri(y,O,L){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(b.URI.revive(O.resolvedUri),{sourceUri:b.URI.revive(O.sourceUri)},L)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(be[208],Se([1,0,4,2,7,14,26]),function(J,e,l,T,b,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(O){this.handles=new Set,this.handlers=new Map,this._proxy=O.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(O,L){if(this.handles.has(I.ExtensionIdentifier.toKey(O)))throw new Error(`Protocol handler already registered for extension ${O}`);const C=A.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(O)),this.handlers.set(C,L),this._proxy.$registerUriHandler(C,O),(0,b.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(O)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(O,L){const C=this.handlers.get(O);if(!C)return Promise.resolve(void 0);try{C.handleUri(T.URI.revive(L))}catch(u){(0,M.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(O){return T.URI.revive(await this._proxy.$createAppUri(O))}}e.ExtHostUrls=A,A.HandlePool=0});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[51],Se([1,0,5,11,2,138,157,63,4]),function(J,e,l,T,b,M,I,A,y){"use strict";var O,L,C,u,g,o,r,f,p,D,h,_;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class E{constructor(m,d,S,P,B,F,v){O.set(this,void 0),L.set(this,void 0),C.set(this,void 0),u.set(this,void 0),g.set(this,void 0),o.set(this,void 0),r.set(this,""),f.set(this,void 0),p.set(this,!1),D.set(this,!1),h.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,_.set(this,new l.Emitter),this._onDidDispose=Te(this,_,"f").event,Ge(this,O,m,"f"),Ge(this,L,d,"f"),Ge(this,f,S,"f"),Ge(this,u,P,"f"),Ge(this,g,B,"f"),Ge(this,o,F,"f"),Ge(this,h,a(F),"f"),Ge(this,C,v,"f")}dispose(){Ge(this,p,!0,"f"),Te(this,_,"f").fire(),Te(this,_,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Ge(this,D,!0,"f"),(0,A.asWebviewUri)(m,Te(this,u,"f"))}get cspSource(){const m=Te(this,o,"f").extensionLocation;if(m.scheme===T.Schemas.https||m.scheme===T.Schemas.http){let d=m.toString();return d.endsWith("/")||(d+="/"),d+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,r,"f")}set html(m){this.assertNotDisposed(),Te(this,r,"f")!==m&&(Ge(this,r,m,"f"),!Te(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Ge(this,D,!0,"f"),Te(this,C,"f").report("Webview vscode-resource: uris",Te(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,L,"f").$setHtml(Te(this,O,"f"),m))}get options(){return this.assertNotDisposed(),Te(this,f,"f")}set options(m){this.assertNotDisposed(),Te(this,L,"f").$setOptions(Te(this,O,"f"),i(Te(this,o,"f"),Te(this,g,"f"),m)),Ge(this,f,m,"f")}async postMessage(m){if(Te(this,p,"f"))return!1;const d=(0,I.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Te(this,h,"f")});return Te(this,L,"f").$postMessage(Te(this,O,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Te(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=E,O=new WeakMap,L=new WeakMap,C=new WeakMap,u=new WeakMap,g=new WeakMap,o=new WeakMap,r=new WeakMap,f=new WeakMap,p=new WeakMap,D=new WeakMap,h=new WeakMap,_=new WeakMap;function a(n){try{const m=(0,M.normalizeVersion)((0,M.parseVersion)(n.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class k{constructor(m,d,S,P,B){this.remoteInfo=d,this.workspace=S,this._logService=P,this._deprecationService=B,this._webviews=new Map,this._webviewProxy=m.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(m,d,S){const P=this.getWebview(m);if(P){const{message:B}=(0,I.deserializeWebviewMessage)(d,S.value);P._onMessageEmitter.fire(B)}}$onMissingCsp(m,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,d,S){const P=new E(m,this._webviewProxy,c(d),this.remoteInfo,this.workspace,S,this._deprecationService);return this._webviews.set(m,P),P._onDidDispose(()=>{this._webviews.delete(m)}),P}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=k;function s(n){return{id:n.identifier,location:n.extensionLocation}}e.toExtensionData=s;function i(n,m,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||t(n,m)}}e.serializeWebviewOptions=i;function c(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(m=>b.URI.from(m))}}e.reviveOptions=c;function t(n,m){return[...(m?.getWorkspaceFolders()||[]).map(d=>d.uri),n.extensionLocation]}}),define(be[209],Se([1,0,20,94,7,11,24,2,8,51,60,4,6]),function(J,e,l,T,b,M,I,A,y,O,L,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(a,k){this.document=a,this._storagePath=k,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,k){await this.getEdit(a).undo(),k||this.disposeBackup()}async redo(a,k){await this.getEdit(a).redo(),k||this.disposeBackup()}disposeEdits(a){for(const k of a)this._edits.delete(k)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=_(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const k=this._edits.get(a,0);if(!k)throw new Error("No edit found");return k}}class o{constructor(){this._documents=new Map}get(a,k){return this._documents.get(this.key(a,k))}add(a,k,s){const i=this.key(a,k.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${a} resource:${k.uri}`);const c=new g(k,s);return this._documents.set(i,c),c}delete(a,k){const s=this.key(a,k.uri);this._documents.delete(s)}key(a,k){return`${a}@@@${k}`}}var r;(function(E){E[E.Text=0]="Text",E[E.Custom=1]="Custom"})(r||(r={}));class f{constructor(){this._providers=new Map}addTextProvider(a,k,s){return this.add(0,a,k,s)}addCustomProvider(a,k,s){return this.add(1,a,k,s)}get(a){return this._providers.get(a)}add(a,k,s,i){if(this._providers.has(k))throw new Error(`Provider for viewType:${k} already registered`);return this._providers.set(k,{type:a,extension:s,provider:i}),new u.Disposable(()=>this._providers.delete(k))}}class p{constructor(a,k,s,i,c){this._extHostDocuments=k,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new f,this._documents=new o,this._proxy=a.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,k,s,i){const c=new b.DisposableStore;return D(s)?(c.add(this._editorProviders.addTextProvider(k,a,s)),this._proxy.$registerTextEditorProvider((0,O.toExtensionData)(a),k,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,O.shouldSerializeBuffersForPostMessage)(a))):(c.add(this._editorProviders.addCustomProvider(k,a,s)),this.supportEditing(s)&&c.add(s.onDidChangeCustomDocument(t=>{const n=this.getCustomDocumentEntry(k,t.document.uri);if(h(t)){const m=n.addEdit(t);this._proxy.$onDidEdit(t.document.uri,k,m,t.label)}else this._proxy.$onContentChange(t.document.uri,k)})),this._proxy.$registerCustomEditorProvider((0,O.toExtensionData)(a),k,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,O.shouldSerializeBuffersForPostMessage)(a))),u.Disposable.from(c,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(k)}))}async $createCustomDocument(a,k,s,i,c){const t=this._editorProviders.get(k);if(!t)throw new Error(`No provider found for '${k}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${k}'`);const n=A.URI.revive(a),m=await t.provider.openCustomDocument(n,{backupId:s,untitledDocumentData:i?.buffer},c);let d;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(k,m,d),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(a,k){const s=this._editorProviders.get(k);if(!s)throw new Error(`No provider found for '${k}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${k}'`);const i=A.URI.revive(a),{document:c}=this.getCustomDocumentEntry(k,i);this._documents.delete(k,c),c.dispose()}async $resolveWebviewEditor(a,k,s,i,c,t){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);const m=y.ViewColumn.to(c),d=this._extHostWebview.createNewWebview(k,i.webviewOptions,n.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(k,s,i.title,m,i.panelOptions,d),P=A.URI.revive(a);switch(n.type){case 1:{const{document:B}=this.getCustomDocumentEntry(s,P);return n.provider.resolveCustomEditor(B,S,t)}case 0:{const B=this._extHostDocuments.getDocument(P);return n.provider.resolveCustomTextEditor(B,S,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,k,s){this.getCustomDocumentEntry(k,a).disposeEdits(s)}async $onMoveCustomEditor(a,k,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const c=this._extHostWebviewPanels.getWebviewPanel(a);if(!c)throw new Error("No webview found");const t=A.URI.revive(k),n=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(n,c,l.CancellationToken.None)}async $undo(a,k,s,i){return this.getCustomDocumentEntry(k,a).undo(s,i)}async $redo(a,k,s,i){return this.getCustomDocumentEntry(k,a).redo(s,i)}async $revert(a,k,s){const i=this.getCustomDocumentEntry(k,a);await this.getCustomEditorProvider(k).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(a,k,s){const i=this.getCustomDocumentEntry(k,a);await this.getCustomEditorProvider(k).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(a,k,s,i){const c=this.getCustomDocumentEntry(k,a);return this.getCustomEditorProvider(k).saveCustomDocumentAs(c.document,A.URI.revive(s),i)}async $backup(a,k,s){const i=this.getCustomDocumentEntry(k,a),t=await this.getCustomEditorProvider(k).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(t),t.id}getCustomDocumentEntry(a,k){const s=this._documents.get(a,A.URI.revive(k));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(a){const s=this._editorProviders.get(a)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function D(E){return typeof E.resolveCustomTextEditor=="function"}function h(E){return typeof E.undo=="function"&&typeof E.redo=="function"}function _(E){const a=E.scheme===M.Schemas.file||E.scheme===M.Schemas.untitled?E.fsPath:E.toString();return(0,T.hash)(a)+""}});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[210],Se([1,0,5,7,2,36,8,51,4,6]),function(J,e,l,T,b,M,I,A,y,O){"use strict";var L,C,u,g,o,r,f,p,D,h,_,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class k extends T.Disposable{constructor(t,n,m,d,S,P,B){super();L.set(this,void 0),C.set(this,void 0),u.set(this,void 0),g.set(this,void 0),o.set(this,void 0),r.set(this,void 0),f.set(this,void 0),p.set(this,void 0),D.set(this,!0),h.set(this,!0),_.set(this,!1),E.set(this,this._register(new l.Emitter)),this.onDidDispose=Te(this,E,"f").event,a.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Te(this,a,"f").event,Ge(this,L,t,"f"),Ge(this,C,n,"f"),Ge(this,u,m,"f"),Ge(this,o,P,"f"),Ge(this,p,S,"f"),Ge(this,r,d,"f"),Ge(this,g,B,"f")}dispose(){Te(this,_,"f")||(Ge(this,_,!0,"f"),Te(this,E,"f").fire(),Te(this,C,"f").$disposeWebview(Te(this,L,"f")),Te(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,g,"f")}get viewType(){return this.assertNotDisposed(),Te(this,u,"f")}get title(){return this.assertNotDisposed(),Te(this,r,"f")}set title(t){this.assertNotDisposed(),Te(this,r,"f")!==t&&(Ge(this,r,t,"f"),Te(this,C,"f").$setTitle(Te(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),Te(this,f,"f")}set iconPath(t){this.assertNotDisposed(),Te(this,f,"f")!==t&&(Ge(this,f,t,"f"),Te(this,C,"f").$setIconPath(Te(this,L,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Te(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,p,"f")=="number"&&Te(this,p,"f")<0))return Te(this,p,"f")}get active(){return this.assertNotDisposed(),Te(this,h,"f")}get visible(){return this.assertNotDisposed(),Te(this,D,"f")}_updateViewState(t){Te(this,_,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ge(this,h,t.active,"f"),Ge(this,D,t.visible,"f"),Ge(this,p,t.viewColumn,"f"),Te(this,a,"f").fire({webviewPanel:this}))}reveal(t,n){this.assertNotDisposed(),Te(this,C,"f").$reveal(Te(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:I.ViewColumn.from(t),preserveFocus:!!n})}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,C=new WeakMap,u=new WeakMap,g=new WeakMap,o=new WeakMap,r=new WeakMap,f=new WeakMap,p=new WeakMap,D=new WeakMap,h=new WeakMap,_=new WeakMap,E=new WeakMap,a=new WeakMap;class s{constructor(t,n,m){this.webviews=n,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,M.generateUuid)()}createWebviewPanel(t,n,m,d,S={}){const P=typeof d=="object"?d.viewColumn:d,B={viewColumn:I.ViewColumn.from(P),preserveFocus:typeof d=="object"&&!!d.preserveFocus},F=(0,A.shouldSerializeBuffersForPostMessage)(t),v=s.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(t),v,n,{title:m,panelOptions:i(S),webviewOptions:(0,A.serializeWebviewOptions)(t,this.workspace,S),serializeBuffersForPostMessage:F},B);const x=this.webviews.createNewWebview(v,S,t);return this.createNewWebviewPanel(v,n,m,P,S,x)}$onDidChangeWebviewPanelViewStates(t){const n=Object.keys(t);n.sort((m,d)=>{const S=t[m],P=t[d];return S.active?1:P.active?-1:+S.visible-+P.visible});for(const m of n){const d=this.getWebviewPanel(m);if(!d)continue;const S=t[m];d._updateViewState({active:S.active,visible:S.visible,viewColumn:I.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,n,m){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:m,extension:t}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(t)}),new O.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(t,n,m,d){const S=this._serializers.get(n);if(!S)throw new Error(`No serializer found for '${n}'`);const{serializer:P,extension:B}=S,F=this.webviews.createNewWebview(t,m.webviewOptions,B),v=this.createNewWebviewPanel(t,n,m.title,d,m.panelOptions,F);await P.deserializeWebviewPanel(v,m.state)}createNewWebviewPanel(t,n,m,d,S,P){const B=new k(t,this._proxy,n,m,d,S,P);return this._webviewPanels.set(t,B),B}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=s;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[211],Se([1,0,5,7,51,4,6]),function(J,e,l,T,b,M,I){"use strict";var A,y,O,L,C,u,g,o,r,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends T.Disposable{constructor(_,E,a,k,s,i){super();A.set(this,void 0),y.set(this,void 0),O.set(this,void 0),L.set(this,void 0),C.set(this,!1),u.set(this,void 0),g.set(this,void 0),o.set(this,void 0),r.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Te(this,r,"f").event,f.set(this,this._register(new l.Emitter)),this.onDidDispose=Te(this,f,"f").event,Ge(this,O,a,"f"),Ge(this,g,k,"f"),Ge(this,A,_,"f"),Ge(this,y,E,"f"),Ge(this,L,s,"f"),Ge(this,u,i,"f")}dispose(){Te(this,C,"f")||(Ge(this,C,!0,"f"),Te(this,f,"f").fire(),Te(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,g,"f")}set title(_){this.assertNotDisposed(),Te(this,g,"f")!==_&&(Ge(this,g,_,"f"),Te(this,y,"f").$setWebviewViewTitle(Te(this,A,"f"),_))}get description(){return this.assertNotDisposed(),Te(this,o,"f")}set description(_){this.assertNotDisposed(),Te(this,o,"f")!==_&&(Ge(this,o,_,"f"),Te(this,y,"f").$setWebviewViewDescription(Te(this,A,"f"),_))}get visible(){return Te(this,u,"f")}get webview(){return Te(this,L,"f")}get viewType(){return Te(this,O,"f")}_setVisible(_){_===Te(this,u,"f")||Te(this,C,"f")||(Ge(this,u,_,"f"),Te(this,r,"f").fire())}show(_){this.assertNotDisposed(),Te(this,y,"f").$show(Te(this,A,"f"),!!_)}assertNotDisposed(){if(Te(this,C,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,y=new WeakMap,O=new WeakMap,L=new WeakMap,C=new WeakMap,u=new WeakMap,g=new WeakMap,o=new WeakMap,r=new WeakMap,f=new WeakMap;class D{constructor(_,E){this._extHostWebview=E,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(_,E,a,k){if(this._viewProviders.has(E))throw new Error(`View provider for '${E}' already registered`);return this._viewProviders.set(E,{provider:a,extension:_}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(_),E,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new I.Disposable(()=>{this._viewProviders.delete(E),this._proxy.$unregisterWebviewViewProvider(E)})}async $resolveWebviewView(_,E,a,k,s){const i=this._viewProviders.get(E);if(!i)throw new Error(`No view provider found for '${E}'`);const{provider:c,extension:t}=i,n=this._extHostWebview.createNewWebview(_,{},t),m=new p(_,this._proxy,E,a,n,!0);this._webviewViews.set(_,m),await c.resolveWebviewView(m,{state:k},s)}async $onDidChangeWebviewViewVisibility(_,E){this.getWebviewView(_)._setVisible(E)}async $disposeWebviewView(_){const E=this.getWebviewView(_);this._webviewViews.delete(_),E.dispose(),this._extHostWebview.deleteWebview(_)}getWebviewView(_){const E=this._webviewViews.get(_);if(!E)throw new Error("No webview found");return E}}e.ExtHostWebviewViews=D}),define(be[96],Se([1,0,5,4,2,11,9,3,15]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let O=class Xi{constructor(C){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Xi.InitialState,this._proxy=C.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state={...this._state,focused:C},this._onDidChangeWindowState.fire(this._state))}openUri(C,u){let g;if(typeof C=="string"){g=C;try{C=b.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,I.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,g,u)}async asExternalUri(C,u){if((0,I.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(C,u);return b.URI.from(g)}};O.InitialState={focused:!0},O=Ue([Be(0,y.IExtHostRpcService)],O),e.ExtHostWindow=O,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(be[212],Se([1,0,12,22,20,14,5,7,109,178,38]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(S,P){try{return JSON.stringify(S,P)}catch{return"null"}}const g="$$ref$$",o={[g]:-1};class r{constructor(P,B){this.jsonString=P,this.referencedBuffers=B}}function f(S,P=null,B=!1){const F=[];return{jsonString:(B?u:JSON.stringify)(S,(x,W)=>{if(typeof W=="undefined")return o;if(typeof W=="object"){if(W instanceof T.VSBuffer){const V=F.push(W)-1;return{[g]:V}}if(P)return P(x,W)}return W}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=f;function p(S,P,B){return JSON.parse(S,(F,v)=>{if(v){const x=v[g];if(typeof x=="number")return P[x];if(B&&v.$mid===1)return B.transformIncoming(v)}return v})}e.parseJsonAndRestoreBufferRefs=p;function D(S,P){return JSON.stringify(S,P)}function h(S){return S?(P,B)=>B&&B.$mid===1?S.transformOutgoing(B):B:null}var _;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},k=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(P,B=null,F=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=B,this._uriTransformer=F,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let v=0,x=L.ProxyIdentifier.count;v<x;v++)this._locals[v]=null,this._proxies[v]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(v=>this._receiveOneMessage(v))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,y.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:B,sid:F}=P;return this._proxies[B]||(this._proxies[B]=this._createProxy(B,F)),this._proxies[B]}_createProxy(P,B){let F={get:(v,x)=>(typeof x=="string"&&!v[x]&&x.charCodeAt(0)===36&&(v[x]=(...W)=>this._remoteCall(P,x,W)),x===s?B:v[x])};return new Proxy(Object.create(null),F)}set(P,B){return this._locals[P.nid]=B,B}assertRegistered(P){for(let B=0,F=P.length;B<F;B++){const v=P[B];if(!this._locals[v.nid])throw new Error(`Missing proxy instance ${v.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const B=P.byteLength,F=c.read(P,0),v=F.readUInt8(),x=F.readUInt32();switch(v){case 1:case 2:{let{rpcId:W,method:V,args:re}=n.deserializeRequestJSONArgs(F);this._uriTransformer&&(re=(0,y.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(B,x,W,V,re,v===2);break}case 3:case 4:{let{rpcId:W,method:V,args:re}=n.deserializeRequestMixedArgs(F);this._uriTransformer&&(re=(0,y.transformIncomingURIs)(re,this._uriTransformer)),this._receiveRequest(B,x,W,V,re,v===4);break}case 5:{this._logger&&this._logger.logIncoming(B,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(B,x);break}case 7:{this._receiveReply(B,x,void 0);break}case 9:{let W=n.deserializeReplyOKJSON(F);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply(B,x,W);break}case 10:{const W=n.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(B,x,W);break}case 8:{let W=n.deserializeReplyOKVSBuffer(F);this._receiveReply(B,x,W);break}case 11:{let W=n.deserializeReplyErrError(F);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr(B,x,W);break}case 12:{this._receiveReplyErr(B,x,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,B,F,v,x,W){this._logger&&this._logger.logIncoming(P,B,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(F)}.${v}(`,x);const V=String(B);let re,H;if(W){const se=new b.CancellationTokenSource;x.push(se.token),re=this._invokeHandler(F,v,x),H=()=>se.cancel()}else re=this._invokeHandler(F,v,x),H=a;this._cancelInvokedHandlers[V]=H;const R=n.serializeAcknowledged(B);this._logger&&this._logger.logOutgoing(R.byteLength,B,1,"ack"),this._protocol.send(R),re.then(se=>{delete this._cancelInvokedHandlers[V];const de=n.serializeReplyOK(B,se,this._uriReplacer);this._logger&&this._logger.logOutgoing(de.byteLength,B,1,"reply:",se),this._protocol.send(de)},se=>{delete this._cancelInvokedHandlers[V];const de=n.serializeReplyErr(B,se);this._logger&&this._logger.logOutgoing(de.byteLength,B,1,"replyErr:",se),this._protocol.send(de)})}_receiveCancel(P,B){this._logger&&this._logger.logIncoming(P,B,1,"receiveCancel");const F=String(B);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(P,B,F){this._logger&&this._logger.logIncoming(P,B,0,"receiveReply:",F);const v=String(B);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const x=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v],x.resolveOk(F)}_receiveReplyErr(P,B,F){this._logger&&this._logger.logIncoming(P,B,0,"receiveReplyErr:",F);const v=String(B);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const x=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v];let W;F&&(F.$isError?(W=new Error,W.name=F.name,W.message=F.message,W.stack=F.stack):W=F),x.resolveErr(W)}_invokeHandler(P,B,F){try{return Promise.resolve(this._doInvokeHandler(P,B,F))}catch(v){return Promise.reject(v)}}_doInvokeHandler(P,B,F){const v=this._locals[P];if(!v)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(P));let x=v[B];if(typeof x!="function")throw new Error("Unknown method "+B+" on actor "+(0,L.getStringIdentifierForProxy)(P));return x.apply(v,F)}_remoteCall(P,B,F){if(this._isDisposed)return Promise.reject(M.canceled());let v=null;if(F.length>0&&b.CancellationToken.isCancellationToken(F[F.length-1])&&(v=F.pop()),v&&v.isCancellationRequested)return Promise.reject(M.canceled());const x=n.serializeRequestArguments(F,this._uriReplacer),W=++this._lastMessageId,V=String(W),re=new O.LazyPromise;v&&v.onCancellationRequested(()=>{const R=n.serializeCancel(W);this._logger&&this._logger.logOutgoing(R.byteLength,W,0,"cancel"),this._protocol.send(n.serializeCancel(W))}),this._pendingRPCReplies[V]=re,this._onWillSendRequest(W);const H=n.serializeRequest(W,P,B,x,!!v);return this._logger&&this._logger.logOutgoing(H.byteLength,W,0,`request: ${(0,L.getStringIdentifierForProxy)(P)}.${B}(`,F),this._protocol.send(H),re}}e.RPCProtocol=i,C=k,i.UNRESPONSIVE_TIME=3*1e3;class c{constructor(P,B){this._buff=P,this._offset=B}static alloc(P,B,F){let v=new c(T.VSBuffer.alloc(F+1+4),0);return v.writeUInt8(P),v.writeUInt32(B),v}static read(P,B){return new c(P,B)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,F}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,B}static sizeMixedArray(P){let B=0;B+=1;for(let F=0,v=P.length;F<v;F++){const x=P[F];switch(B+=1,x.type){case 1:B+=this.sizeLongString(x.value);break;case 2:B+=this.sizeVSBuffer(x.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(x.value);for(let W=0;W<x.buffers.length;++W)B+=this.sizeVSBuffer(x.buffers[W]);break;case 4:break}}return B}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let B=0,F=P.length;B<F;B++){const v=P[B];switch(v.type){case 1:this.writeUInt8(1),this.writeLongString(v.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v.value);break;case 3:this.writeUInt8(3),this.writeUInt32(v.buffers.length),this.writeLongString(v.value);for(let x=0;x<v.buffers.length;++x)this.writeBuffer(v.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let B=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:B[F]=this.readLongString();break;case 2:B[F]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),W=this.readLongString(),V=[];for(let re=0;re<x;++re)V.push(this.readVSBuffer());B[F]=new L.SerializableObjectWithBuffers(p(W,V,null));break}case 4:B[F]=void 0;break}return B}}c.sizeUInt32=4;var t;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(t||(t={}));class n{static _useMixedArgSerialization(P){for(let B=0,F=P.length;B<F;B++)if(P[B]instanceof T.VSBuffer||P[B]instanceof L.SerializableObjectWithBuffers||typeof P[B]=="undefined")return!0;return!1}static serializeRequestArguments(P,B){if(this._useMixedArgSerialization(P)){const F=[];for(let v=0,x=P.length;v<x;v++){const W=P[v];if(W instanceof T.VSBuffer)F[v]={type:2,value:W};else if(typeof W=="undefined")F[v]={type:4};else if(W instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:re}=f(W.value,B);F[v]={type:3,value:T.VSBuffer.fromString(V),buffers:re}}else F[v]={type:1,value:T.VSBuffer.fromString(D(W,B))}}return{type:1,args:F}}return{type:0,args:D(P,B)}}static serializeRequest(P,B,F,v,x){switch(v.type){case 0:return this._requestJSONArgs(P,B,F,v.args,x);case 1:return this._requestMixedArgs(P,B,F,v.args,x)}}static _requestJSONArgs(P,B,F,v,x){const W=T.VSBuffer.fromString(F),V=T.VSBuffer.fromString(v);let re=0;re+=c.sizeUInt8(),re+=c.sizeShortString(W),re+=c.sizeLongString(V);let H=c.alloc(x?2:1,P,re);return H.writeUInt8(B),H.writeShortString(W),H.writeLongString(V),H.buffer}static deserializeRequestJSONArgs(P){const B=P.readUInt8(),F=P.readShortString(),v=P.readLongString();return{rpcId:B,method:F,args:JSON.parse(v)}}static _requestMixedArgs(P,B,F,v,x){const W=T.VSBuffer.fromString(F);let V=0;V+=c.sizeUInt8(),V+=c.sizeShortString(W),V+=c.sizeMixedArray(v);let re=c.alloc(x?4:3,P,V);return re.writeUInt8(B),re.writeShortString(W),re.writeMixedArray(v),re.buffer}static deserializeRequestMixedArgs(P){const B=P.readUInt8(),F=P.readShortString(),v=P.readMixedArray(),x=new Array(v.length);for(let W=0,V=v.length;W<V;W++){const re=v[W];typeof re=="string"?x[W]=JSON.parse(re):x[W]=re}return{rpcId:B,method:F,args:x}}static serializeAcknowledged(P){return c.alloc(5,P,0).buffer}static serializeCancel(P){return c.alloc(6,P,0).buffer}static serializeReplyOK(P,B,F){if(typeof B=="undefined")return this._serializeReplyOKEmpty(P);if(B instanceof T.VSBuffer)return this._serializeReplyOKVSBuffer(P,B);if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:v,referencedBuffers:x}=f(B.value,F,!0);return this._serializeReplyOKJSONWithBuffers(P,v,x)}else return this._serializeReplyOKJSON(P,u(B,F))}static _serializeReplyOKEmpty(P){return c.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,B){let F=0;F+=c.sizeVSBuffer(B);let v=c.alloc(8,P,F);return v.writeVSBuffer(B),v.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,B){const F=T.VSBuffer.fromString(B);let v=0;v+=c.sizeLongString(F);let x=c.alloc(9,P,v);return x.writeLongString(F),x.buffer}static _serializeReplyOKJSONWithBuffers(P,B,F){const v=T.VSBuffer.fromString(B);let x=0;x+=c.sizeUInt32,x+=c.sizeLongString(v);for(const V of F)x+=c.sizeVSBuffer(V);let W=c.alloc(10,P,x);W.writeUInt32(F.length),W.writeLongString(v);for(const V of F)W.writeBuffer(V);return W.buffer}static deserializeReplyOKJSON(P){const B=P.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(P,B){const F=P.readUInt32(),v=P.readLongString(),x=[];for(let W=0;W<F;++W)x.push(P.readVSBuffer());return new L.SerializableObjectWithBuffers(p(v,x,B))}static serializeReplyErr(P,B){const F=B?u(M.transformErrorForSerialization(B),null):void 0;if(typeof F!="string")return this._serializeReplyErrEmpty(P);const v=T.VSBuffer.fromString(F);let x=0;x+=c.sizeLongString(v);let W=c.alloc(11,P,x);return W.writeLongString(v),W.buffer}static deserializeReplyErrError(P){const B=P.readLongString();return JSON.parse(B)}static _serializeReplyErrEmpty(P){return c.alloc(12,P,0).buffer}}var m;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var d;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(d||(d={}))}),define(be[213],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const l=function(M){const I=A=>{self.removeEventListener("message",I);const y=A.data;Object.defineProperties(self,{postMessage:{value(O,L){y.postMessage(O,L)}},onmessage:{get(){return y.onmessage},set(O){y.onmessage=O}}}),y.addEventListener("message",O=>{self.dispatchEvent(new MessageEvent("message",{data:O.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",I)}.toString();class T extends EventTarget{constructor(M,I,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${l})('${I}'))`,O=new Blob([y],{type:"application/javascript"}),L=URL.createObjectURL(O),C=new MessageChannel,u=L,g={type:"_newWorker",id:u,port:C.port2,url:L,options:A};M(g,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(L),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(o){C.port1.onmessage=o}},onmessageerror:{get(){return C.port1.onmessageerror},set(o){C.port1.onmessageerror=o}}}),C.port1.addEventListener("messageerror",o=>{const r=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(r)}),C.port1.addEventListener("message",o=>{const r=new MessageEvent("message",{data:o.data});this.dispatchEvent(r)}),C.port1.start()}}e.NestedWorker=T}),define(be[214],Se([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(be[215],Se([1,0,35,11,17,21,24,2,3,151,46,174,214]),function(J,e,l,T,b,M,I,A,y,O,L,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let g=class Qi{constructor(r,f,p,D){this.localUserHome=r,this.remoteAgentService=f,this.environmentService=p,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome||r})()}hasValidBasename(r,f,p){return typeof f=="string"||typeof f=="undefined"?this.resolveOS.then(D=>this.doHasValidBasename(r,D,f)):this.doHasValidBasename(r,f,p)}doHasValidBasename(r,f,p){return r.scheme===T.Schemas.file||r.scheme===T.Schemas.vscodeRemote?(0,l.isValidBasename)(p??(0,I.basename)(r),f===1):!0}get defaultUriScheme(){return Qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(r,f){if(r.remoteAuthority)return T.Schemas.vscodeRemote;const p=(0,O.getVirtualWorkspaceScheme)(f.getWorkspace());if(p)return p;const D=f.getWorkspace().folders[0];if(D)return D.uri.scheme;const h=f.getWorkspace().configuration;return h?h.scheme:T.Schemas.file}async userHome(r){return r?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(r=>r===1?b.win32:b.posix)}async fileURI(r){let f="";if(await this.resolveOS===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const D=r.indexOf("/",2);D===-1?(f=r.substring(2),r="/"):(f=r.substring(2,D),r=r.substring(D)||"/")}return A.URI.from({scheme:T.Schemas.file,authority:f,path:r,query:"",fragment:""})}};g=Ue([Be(1,u.IRemoteAgentService),Be(2,C.IWorkbenchEnvironmentService),Be(3,L.IWorkspaceContextService)],g),e.AbstractPathService=g}),define(be[97],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new l(0,0)}with(I){return new l(0,0)}}e.Position=l;class T{constructor(I,A,y,O){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(I,A),this.end=new l(y,O)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new T(0,0,0,0)}with(I){return new T(0,0,0,0)}}e.Range=T;var b;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Se([1,0,16,29,27,35,9,3,17,14,97,12]),function(J,e,l,T,b,M,I,A,y,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",g=" characters skipped \u27EB",o=(u.length+g.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var r;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function p(X){return!!X.preview}e.resultIsMatch=p;function D(X){return!!X.resource}e.isFileMatch=D;function h(X){return!!X.message}e.isProgressMessage=h;var _;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class E{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=E;class a{constructor(ie,he,me){this.ranges=he;const fe=Array.isArray(he)?he:[he];if(me&&me.matchLines===1&&k(fe)){ie=(0,I.getNLines)(ie,me.matchLines);let ae="",pe=0,Ae=0;const Fe=Math.floor(me.charsPerLine/5),He=[];for(const Ye of fe){const Ce=Math.max(Ye.startColumn-Fe,0),Ee=Ye.startColumn+me.charsPerLine;if(Ce>Ae+Fe+o){const De=u+(Ce-Ae)+g;ae+=De+ie.slice(Ce,Ee),pe+=Ce-(Ae+De.length)}else ae+=ie.slice(Ae,Ee);He.push(new i(0,Ye.startColumn-pe,Ye.endColumn-pe)),Ae=Ee}this.preview={text:ae,matches:Array.isArray(this.ranges)?He:He[0]}}else{const ae=Array.isArray(he)?he[0].startLineNumber:he.startLineNumber;this.preview={text:ie,matches:(0,l.mapArrayOrNot)(he,pe=>new s(pe.startLineNumber-ae,pe.startColumn,pe.endLineNumber-ae,pe.endColumn))}}}}e.TextSearchMatch=a;function k(X){const ie=X[0].startLineNumber;for(const he of X)if(he.startLineNumber!==ie||he.endLineNumber!==ie)return!1;return!0}class s{constructor(ie,he,me,fe){this.startLineNumber=ie,this.startColumn=he,this.endLineNumber=me,this.endColumn=fe}}e.SearchRange=s;class i extends s{constructor(ie,he,me){super(ie,he,ie,me)}}e.OneLineRange=i;var c;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function t(X,ie=!0){const he=X&&X.files&&X.files.exclude,me=ie&&X&&X.search&&X.search.exclude;if(!he&&!me)return;if(!he||!me)return he||me;let fe=Object.create(null);return fe=b.mixin(fe,b.deepClone(he)),fe=b.mixin(fe,b.deepClone(me),!0),fe}e.getExcludes=t;function n(X,ie){return X.excludePattern&&T.match(X.excludePattern,ie)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&T.match(X.includePattern,ie)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(he=>{const me=he.folder.fsPath;if(M.isEqualOrParent(ie,me)){const fe=y.relative(me,ie);return!he.includePattern||!!T.match(he.includePattern,fe)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var m;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(ie,he){super(ie);this.code=he}}e.SearchError=d;function S(X){const ie=X.message;if((0,O.isCancellationError)(X))return new d(ie,m.canceled);try{const he=JSON.parse(ie);return new d(he.message,he.code)}catch{return new d(ie,m.other)}}e.deserializeSearchError=S;function P(X){const ie={message:X.message,code:X.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=P;function B(X){return X.type==="error"?!0:X.type==="success"}e.isSerializedSearchComplete=B;function F(X){return X.type==="success"}e.isSerializedSearchSuccess=F;function v(X){return!!X.path}e.isSerializedFileMatch=v;function x(X,ie){const he=X.searchPath?X.searchPath:X.relativePath;return(0,I.fuzzyContains)(he,ie)}e.isFilePatternMatch=x;class W{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function V(X,ie){const he={...X||{},...ie||{}};return Object.keys(he).filter(me=>{const fe=he[me];return typeof fe=="boolean"&&fe})}e.resolvePatternsForProvider=V;class re{constructor(ie,he){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...he.excludePattern||{}},this._parsedExcludeExpression=T.parse(this._excludeExpression);let me=ie.includePattern;he.includePattern&&(me?me={...me,...he.includePattern}:me=he.includePattern),me&&(this._parsedIncludeExpression=T.parse(me))}matchesExcludesSync(ie,he,me){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,he,me))}includedInQuerySync(ie,he,me){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,he,me)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,he,me))}includedInQuery(ie,he,me){const fe=this._parsedExcludeExpression(ie,he,me),ae=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,he,me):!0;return(0,C.isThenable)(fe)?fe.then(pe=>pe?!1:ae()):ae()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=re;function H(X){for(const ie in X)if(typeof X[ie]!="boolean")return!0;return!1}function R(X){if(!X)return;let ie;return he=>(ie||(ie=(X()||Promise.resolve([])).then(me=>me?de(me):{})),ie.then(me=>!!me[he]))}e.hasSiblingPromiseFn=R;function se(X){if(!X)return;let ie;return he=>{if(!ie){const me=X();ie=me?de(me):{}}return!!ie[he]}}e.hasSiblingFn=se;function de(X){const ie={};for(const he of X)ie[he]=!0;return ie}}),define(be[31],Se([1,0,16,12,20,5,23,11,103,24,9,10,2,130,3,13,143,46,30,28,15,8,6,41,4]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_,E,a,k,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(B,F,v){return new O.ExtUri(x=>m(x,v)).isEqual(B,F)}function c(B,F,v){return i(B.uri,F.uri,v)?0:(0,L.compare)(B.uri.toString(),F.uri.toString())}function t(B,F,v){return B.index!==F.index?B.index<F.index?-1:1:i(B.uri,F.uri,v)?(0,L.compare)(B.name,F.name):(0,L.compare)(B.uri.toString(),F.uri.toString())}function n(B,F,v,x){const W=B.slice(0).sort((re,H)=>v(re,H,x)),V=F.slice(0).sort((re,H)=>v(re,H,x));return(0,l.delta)(W,V,(re,H)=>v(re,H,x))}function m(B,F){const v=F.getCapabilities(B.scheme);return!(v&&v&1024)}class d extends p.Workspace{constructor(F,v,x,W,V,re,H){super(F,x.map(R=>new p.WorkspaceFolder(R)),W,V,H);this._name=v,this._isUntitled=re,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(H),x.forEach(R=>{this._workspaceFolders.push(R),this._structure.set(R.uri,R)})}static toExtHostWorkspace(F,v,x,W){if(!F)return{workspace:null,added:[],removed:[]};const{id:V,name:re,folders:H,configuration:R,transient:se,isUntitled:de}=F,X=[],ie=v;v?H.forEach((ae,pe)=>{const Ae=u.URI.revive(ae.uri),Fe=d._findFolder(x||v,Ae,W);Fe?(Fe.name=ae.name,Fe.index=ae.index,X.push(Fe)):X.push({uri:Ae,name:ae.name,index:pe})}):X.push(...H.map(({uri:ae,name:pe,index:Ae})=>({uri:u.URI.revive(ae),name:pe,index:Ae}))),X.sort((ae,pe)=>ae.index<pe.index?-1:1);const he=new d(V,re,X,!!se,R?u.URI.revive(R):null,!!de,ae=>m(ae,W)),{added:me,removed:fe}=n(ie?ie.workspaceFolders:[],he.workspaceFolders,c,W);return{workspace:he,added:me,removed:fe}}static _findFolder(F,v,x){for(let W=0;W<F.folders.length;W++){const V=F.workspaceFolders[W];if(i(V.uri,v,x))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,v){return v&&this._structure.get(F)&&(F=(0,O.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let S=class{constructor(F,v,x,W){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=W,this._extHostFileSystemInfo=x,this._requestIdProvider=new y.Counter,this._barrier=new T.Barrier,this._proxy=F.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(s.MainContext.MainThreadMessageService);const V=v.workspace;this._confirmedWorkspace=V?new d(V.id,V.name,[],!!V.transient,V.configuration?u.URI.revive(V.configuration):null,!!V.isUntitled,re=>m(re,x)):void 0}$initializeWorkspace(F,v){this._trusted=v,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:A.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,v,x,...W){const V=[];if(Array.isArray(W)&&W.forEach(de=>{u.URI.isUri(de.uri)&&!V.some(X=>i(X.uri,de.uri,this._extHostFileSystemInfo))&&V.push({uri:de.uri,name:de.name||(0,O.basenameOrAuthority)(de.uri)})}),this._unconfirmedWorkspace||[v,x].some(de=>typeof de!="number"||de<0)||x===0&&V.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(v+x>re.length)return!1;const H=re.slice(0);H.splice(v,x,...V.map(de=>({uri:de.uri,name:de.name||(0,O.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<H.length;de++){const X=H[de];if(H.some((ie,he)=>he!==de&&i(X.uri,ie.uri,this._extHostFileSystemInfo)))return!1}H.forEach((de,X)=>de.index=X);const{added:R,removed:se}=n(re,H,t,this._extHostFileSystemInfo);if(R.length===0&&se.length===0)return!1;if(this._proxy){const de=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(de,v,x,V).then(void 0,X=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:F.identifier,label:F.displayName||F.name}};this._messageService.$showMessage(f.Severity.Error,(0,g.localize)(0,null,de,X.toString()),ie,[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(F,v){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,v)}async getWorkspaceFolder2(F,v){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,v)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,v){let x,W="";if(typeof F=="string"?(x=u.URI.file(F),W=F):typeof F!="undefined"&&(x=F,W=F.fsPath),!x)return W;const V=this.getWorkspaceFolder(x,!0);if(!V)return W;typeof v=="undefined"&&this._actualWorkspace&&(v=this._actualWorkspace.folders.length>1);let re=(0,O.relativePath)(V.uri,x);return v&&V.name&&(re=`${V.name}/${re}`),re}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:v,added:x,removed:W}=d.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=v||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:W}))}findFiles(F,v,x,W,V=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let re;if(v===null?re=!1:v&&(typeof v=="string"?re=v:re=v.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:R}=P(E.GlobPattern.from(F));return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(H),(0,C.withUndefinedAsNull)(R),(0,C.withUndefinedAsNull)(re),(0,C.withUndefinedAsNull)(x),V).then(se=>Array.isArray(se)?se.map(de=>u.URI.revive(de)):[])}async findTextInFiles(F,v,x,W,V=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),H=typeof v.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:v.previewOptions,{includePattern:R,folder:se}=P(E.GlobPattern.from(v.include)),de=typeof v.exclude=="string"?v.exclude:v.exclude?v.exclude.pattern:void 0,X={ignoreSymlinks:typeof v.followSymlinks=="boolean"?!v.followSymlinks:void 0,disregardIgnoreFiles:typeof v.useIgnoreFiles=="boolean"?!v.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof v.useGlobalIgnoreFiles=="boolean"?!v.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof v.useParentIgnoreFiles=="boolean"?!v.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof v.useDefaultExcludes=="boolean"?!v.useDefaultExcludes:!0,fileEncoding:v.encoding,maxResults:v.maxResults,previewOptions:H,afterContext:v.afterContext,beforeContext:v.beforeContext,includePattern:R,excludePattern:de},ie=!1;if(this._activeSearchCallbacks[re]=he=>{if(ie)return;const me=u.URI.revive(he.resource);he.results.forEach(fe=>{(0,k.resultIsMatch)(fe)?x({uri:me,preview:{text:fe.preview.text,matches:(0,l.mapArrayOrNot)(fe.preview.matches,ae=>new a.Range(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,l.mapArrayOrNot)(fe.ranges,ae=>new a.Range(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):x({uri:me,text:fe.text,lineNumber:fe.lineNumber})})},V.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(se),X,re,V);return delete this._activeSearchCallbacks[re],he||{}}catch(he){throw delete this._activeSearchCallbacks[re],he}}$handleTextSearchResult(F,v){this._activeSearchCallbacks[v]&&this._activeSearchCallbacks[v](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=Ue([Be(0,_.IExtHostRpcService),Be(1,h.IExtHostInitDataService),Be(2,D.IExtHostFileSystemInfo),Be(3,r.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function P(B){let F,v;return B&&(typeof B=="string"?F=B:(F=B.pattern,v=u.URI.revive(B.baseUri))),{includePattern:F,folder:v}}}),define(be[32],Se([1,0,27,5,31,4,6,146,82,10,12,3,15,13,2]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function r(k,s){if(s){const i=s.split(".");let c=k;for(let t=0;c&&t<i.length;t++)c=c[i[t]];return c}}function f(k){return k instanceof o.URI}function p(k){return k&&k.uri instanceof o.URI&&k.languageId&&typeof k.languageId=="string"}function D(k){return k&&!k.uri&&k.languageId&&typeof k.languageId=="string"}function h(k){return k&&k.uri instanceof o.URI&&(!k.name||typeof k.name=="string")&&(!k.index||typeof k.index=="number")}function _(k){if(f(k))return{resource:k};if(p(k))return{resource:k.uri,overrideIdentifier:k.languageId};if(D(k))return{overrideIdentifier:k.languageId};if(h(k))return{resource:k.uri};if(k===null)return{resource:null}}let E=class{constructor(s,i,c){this._proxy=s.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new a(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};E=Ue([Be(0,u.IExtHostRpcService),Be(1,b.IExtHostWorkspace),Be(2,g.ILogService)],E),e.ExtHostConfiguration=E;class a{constructor(s,i,c,t){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=t,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(s,i,c){const t=_(i)||{},n=this._toReadonlyValue(s?r(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,t,c?.identifier);function m(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(S){return typeof r(n,S)!="undefined"},get:(S,P)=>{this._validateConfigurationAccess(s?`${s}.${S}`:S,t,c?.identifier);let B=r(n,S);if(typeof B=="undefined")B=P;else{let F;const v=(x,W)=>{let V;const re=()=>{F=F||(0,l.deepClone)(n),V=V||r(F,W)};return(0,O.isObject)(x)?new Proxy(x,{get:(H,R)=>{if(typeof R=="string"&&R.toLowerCase()==="tojson")return re(),()=>V;if(F)return V=V||r(F,W),V[R];const se=H[R];return typeof R=="string"?v(se,`${W}.${R}`):se},set:(H,R,se)=>(re(),V&&(V[R]=se),!0),deleteProperty:(H,R)=>(re(),V&&delete V[R],!0),defineProperty:(H,R,se)=>(re(),V&&Object.defineProperty(V,R,se),!0)}):x};B=v(B,S)}return B},update:(S,P,B,F)=>{S=s?`${s}.${S}`:S;const v=m(B);return P!==void 0?this._proxy.$updateConfigurationOption(v,S,P,t,F):this._proxy.$removeConfigurationOption(v,S,t,F)},inspect:S=>{S=s?`${s}.${S}`:S;const P=(0,l.deepClone)(this._configuration.inspect(S,t,this._extHostWorkspace.workspace));if(P)return{key:S,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof n=="object"&&(0,l.mixin)(d,n,!1),Object.freeze(d)}_toReadonlyValue(s){const i=c=>(0,O.isObject)(c)?new Proxy(c,{get:(t,n)=>i(t[n]),set:(t,n,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(t,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(t,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}_validateConfigurationAccess(s,i,c){const t=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),n=c?`[${c.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const c=new A.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,n)=>c.affectsConfiguration(t,_(n))})}_toMap(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[98],Se([1,0,2,12,5,4,6,31,49,32,20,40,15,28,3,11,21,13,68,166,14]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(W){function V(H){if(H!=null)return H}W.from=V;function re(H){if(H!=null)return H}W.to=re})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var k;(function(W){function V(H){if(H!=null)return H}W.from=V;function re(H){if(H!=null)return H}W.to=re})(k=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(W){function V(H){if(H!=null)return H}W.from=V;function re(H){if(H!=null)return H}W.to=re})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(W){function V(R){if(R){const se=R;return se&&!!se.process}else return!1}W.is=V;function re(R){if(R==null)return;const se={process:R.process,args:R.args};return R.options&&(se.options=s.from(R.options)),se}W.from=re;function H(R){if(R!=null)return new I.ProcessExecution(R.process,R.args,R.options)}W.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(W){function V(H){if(H!=null)return H}W.from=V;function re(H){if(H!=null)return H}W.to=re})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(W){function V(R){if(R){const se=R;return se&&(!!se.commandLine||!!se.command)}else return!1}W.is=V;function re(R){if(R==null)return;const se={};return R.commandLine!==void 0?se.commandLine=R.commandLine:(se.command=R.command,se.args=R.args),R.options&&(se.options=c.from(R.options)),se}W.from=re;function H(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new I.ShellExecution(R.commandLine,R.options):new I.ShellExecution(R.command,R.args?R.args:[],R.options)}W.to=H})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var n;(function(W){function V(R){if(R){let se=R;return se&&se.customExecution==="customExecution"}else return!1}W.is=V;function re(R){return{customExecution:"customExecution"}}W.from=re;function H(R,se){return se.get(R)}W.to=H})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(W){function V(re,H){let R;return re.scope!==void 0&&typeof re.scope!="number"?R=re.scope.uri:re.scope!==void 0&&typeof re.scope=="number"&&(re.scope===I.TaskScope.Workspace&&H&&H.workspaceFile?R=H.workspaceFile:R=h.USER_TASKS_GROUP_KEY),{id:re._id,workspaceFolder:R}}W.from=V})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(W){function V(re){if(re!=null)return{_id:re.id,isDefault:re.isDefault}}W.from=V})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function(W){function V(R,se){if(R==null)return[];const de=[];for(let X of R){const ie=re(X,se);ie&&de.push(ie)}return de}W.fromMany=V;function re(R,se){if(R==null)return;let de;R.execution instanceof I.ProcessExecution?de=i.from(R.execution):R.execution instanceof I.ShellExecution?de=t.from(R.execution):R.execution&&R.execution instanceof I.CustomExecution&&(de=n.from(R.execution));const X=a.from(R.definition);let ie;return R.scope?typeof R.scope=="number"?ie=R.scope:ie=R.scope.uri:ie=I.TaskScope.Workspace,!X||!ie?void 0:{_id:R._id,definition:X,name:R.name,source:{extensionId:se.identifier.value,label:R.source,scope:ie},execution:de,isBackground:R.isBackground,group:d.from(R.group),presentationOptions:k.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}W.from=re;async function H(R,se,de){if(R==null)return;let X;i.is(R.execution)?X=i.to(R.execution):t.is(R.execution)?X=t.to(R.execution):n.is(R.execution)&&(X=n.to(R._id,de));const ie=a.to(R.definition);let he;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?he=R.source.scope:he=await se.resolveWorkspaceFolder(l.URI.revive(R.source.scope)):he=I.TaskScope.Workspace),!ie||!he)return;const me=new I.Task(ie,he,R.name,R.source.label,X,R.problemMatchers);return R.isBackground!==void 0&&(me.isBackground=R.isBackground),R.group!==void 0&&(me.group=I.TaskGroup.from(R.group._id),me.group&&R.group.isDefault&&(me.group=new I.TaskGroup(me.group.id,me.group.label),R.group.isDefault&&(me.group.isDefault=R.group.isDefault))),R.presentationOptions&&(me.presentationOptions=k.to(R.presentationOptions)),R._id&&(me._id=R._id),R.detail&&(me.detail=R.detail),me}W.to=H})(S=e.TaskDTO||(e.TaskDTO={}));var P;(function(W){function V(H){return H}W.from=V;function re(H){if(!!H)return Object.assign(Object.create(null),H)}W.to=re})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class B{constructor(V,re,H){this._id=re,this._task=H,E.set(this,void 0),Ge(this,E,V,"f")}get task(){return this._task}terminate(){Te(this,E,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}E=new WeakMap;var F;(function(W){function V(re){return{id:re._id,task:void 0}}W.from=V})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let v=class{constructor(V,re,H,R,se,de,X,ie){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=V.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=R,this._configurationService=se,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=X,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,re,H){if(!H)return new I.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:re,provider:H,extension:V}),this._proxy.$registerTaskProvider(R,re),new I.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(V,re){this._proxy.$registerTaskSystem(V,re)}fetchTasks(V){return this._proxy.$fetchTasks(P.from(V)).then(async re=>{const H=[];for(let R of re){const se=await S.to(R,this._workspaceProvider,this._providedCustomExecutions2);se&&H.push(se)}return H})}get taskExecutions(){const V=[];return this._taskExecutions.forEach(re=>V.push(re)),V}terminateTask(V){if(!(V instanceof B))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,re,H){const R=this._providedCustomExecutions2.get(V.id);R&&(this._activeCustomExecutions2.set(V.id,R),this._terminalService.attachPtyToTerminal(re,await R.callback(H))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const re=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:re})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const re=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:re,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const re=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:re,exitCode:V.exitCode})}$provideTasks(V,re){const H=this._handlers.get(V);if(!H)return Promise.reject(new Error("no handler found"));const R=[],se=(0,T.asPromise)(()=>H.provider.provideTasks(L.CancellationToken.None)).then(de=>this.provideTasksInternal(re,R,H,de));return new Promise(de=>{se.then(X=>{Promise.all(R).then(()=>{de(X)})})})}async $resolveTask(V,re){const H=this._handlers.get(V);if(!H)return Promise.reject(new Error("no handler found"));if(re.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${re.definition.type}] cannot be resolved by provider of type [${H.type}].`);const R=await S.to(re,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const se=await H.provider.resolveTask(R,L.CancellationToken.None);if(!se)return;this.checkDeprecation(se,H);const de=S.from(se,H.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(se.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(de.execution)&&await this.addCustomExecution(de,se,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,re,H){const R=await this._proxy.$createTaskId(V);!H&&!this._providedCustomExecutions2.has(R)&&(this._notProvidedCustomExecutions.add(R),this._activeCustomExecutions2.set(R,re.execution)),this._providedCustomExecutions2.set(R,re.execution)}async getTaskExecution(V,re){if(typeof V=="string"){const se=this._taskExecutionPromises.get(V);if(!se)throw new Error("Unexpected: The specified task is missing an execution");return se}let H=this._taskExecutionPromises.get(V.id);if(H)return H;const R=new Promise((se,de)=>{function X(ie,he,me){me?se(new B(ie,he.id,me)):de("Unexpected: Task does not exist.")}re?X(this,V,re):S.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>X(this,V,ie))});return this._taskExecutionPromises.set(V.id,R),R.then(se=>(this._taskExecutions.set(V.id,se),se),se=>Promise.reject(se))}checkDeprecation(V,re){V._deprecated&&this._deprecationService.report("Task.constructor",re.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let H=this._notProvidedCustomExecutions.values(),R=H.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=H.next()}};v=Ue([Be(0,u.IExtHostRpcService),Be(1,g.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,O.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,p.ILogService),Be(7,D.IExtHostApiDeprecationService)],v),e.ExtHostTaskBase=v;let x=class extends v{constructor(V,re,H,R,se,de,X,ie){super(V,re,H,R,se,de,X,ie);this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:f.PlatformToString(0)})}async executeTask(V,re){if(!re.execution)throw new Error("Tasks to execute must include an execution");const H=S.from(re,V);if(H===void 0)throw new Error("Task is not valid");if(n.is(H.execution))await this.addCustomExecution(H,re,!1);else throw new _.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),re);return this._proxy.$executeTask(H).catch(se=>{throw new Error(se)}),R}provideTasksInternal(V,re,H,R){const se=[];if(R)for(let de of R){this.checkDeprecation(de,H),(!de.definition||!V[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const X=S.from(de,H.extension);X&&n.is(X.execution)?(se.push(X),re.push(this.addCustomExecution(X,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:se,extension:H.extension}}async resolveTaskInternal(V){if(n.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,re){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,re,H){}};x=Ue([Be(0,u.IExtHostRpcService),Be(1,g.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,O.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,p.ILogService),Be(7,D.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(be[216],Se([1,0,17,20,43,29,24,193,41]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class O{constructor(u,g,o){this.config=u,this.provider=g,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&M.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&M.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const g=this.config.folderQueries||[];return new Promise((o,r)=>{const f=p=>{this.resultCount++,u(p)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const D=p.toString(),h=l.basename(D);this.globalExcludePattern&&this.globalExcludePattern(D,h)||this.matchFile(f,{base:p,basename:h})}),Promise.all(g.map(p=>this.searchInFolder(p,f))).then(p=>{o({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{r(new Error((0,b.toErrorMessage)(p)))})})}async searchInFolder(u,g){const o=new T.CancellationTokenSource,r=this.getSearchOptionsForFolder(u),f=this.initDirectoryTree(),p=new y.QueryGlobTester(this.config,u),D=!p.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(o),h=A.StopWatch.create();const _=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},r,o.token),E=h.elapsed(),a=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(_&&_.forEach(k=>{const s=l.posix.relative(u.folder.path,k.path);if(D){const i=l.basename(k.path);this.matchFile(g,{base:u.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(f,u.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(f,p,g),{providerTime:E,postProcessTime:a.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(u){const g=(0,y.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),o=(0,y.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:o,includes:g,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},g,o,r){if(o===this.filePattern){const p=l.basename(this.filePattern);this.matchFile(r,{base:g,relativePath:this.filePattern,basename:p})}function f(p){const D=l.basename(p),h=l.dirname(p);let _=u[h];_||(_=u[h]=[],f(h)),_.push({base:g,relativePath:p,basename:D})}f(o)}matchDirectoryTree({rootEntries:u,pathToEntries:g},o,r){const f=this,p=this.filePattern;function D(h){const _=(0,y.hasSiblingFn)(()=>h.map(E=>E.basename));for(let E=0,a=h.length;E<a;E++){const k=h[E],{relativePath:s,basename:i}=k;if(o.matchesExcludesSync(s,i,p!==i?_:void 0))continue;const c=g[s];if(c)D(c);else{if(s===p)continue;f.matchFile(r,k)}if(f.isLimitHit)break}}D(u)}matchFile(u,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(g))}}class L{constructor(){this.sessions=new Map}fileSearch(u,g,o,r){const f=this.getSessionTokenSource(u.cacheKey),p=new O(u,g,f&&f.token);let D=0;const h=_=>{D+=_.length,o(_.map(E=>this.rawMatchToSearchItem(E)))};return this.doSearch(p,L.BATCH_SIZE,h,r).then(_=>({limitHit:_.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:D,detailStats:_.stats}}))}clearCache(u){const g=this.getSessionTokenSource(u);g&&g.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new T.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:I.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,g,o,r){r.onCancellationRequested(()=>{u.cancel()});const f=D=>{D&&(p.push(D),g>0&&p.length>=g&&(o(p),p=[]))};let p=[];return u.search(f).then(D=>(p.length&&o(p),D),D=>(p.length&&o(p),Promise.reject(D)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(be[217],Se([1,0,16,73,29,76,23,11,17,24,9,10,2,236,136,56,13,46,89,215,41]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let E=class{constructor(d,S,P,B,F){this.configurationService=d,this.workspaceContextService=S,this.editorGroupsService=P,this.logService=B,this.pathService=F}text(d,S,P={}){d=this.getContentPattern(d,P);const B=this.configurationService.getValue(),F=S&&S.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(S?.map(p.toWorkspaceFolder),P),type:2,contentPattern:d,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:B.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(d,S){const P=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const B={...d,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(d,S)&&(B.isCaseSensitive=!0),this.isMultiline(d)&&(B.isMultiline=!0),B}file(d,S={}){return{...this.commonQuery(d,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(d,S){return d?(d=Array.isArray(d)?d.map(c):c(d),S?this.parseSearchPaths(d):{pattern:k(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],S={}){const P=this.handleIncludeExclude(S.includePattern,S.expandPatterns),B=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),F=d.length>1,v=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,S,B)):d.map(V=>this.getFolderQueryForRoot(V,S,B,F))).filter(V=>!!V),x={_reason:S._reason,folderQueries:v,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:B.pattern,includePattern:P.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const V=l.coalesce(l.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(se=>se.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(V));const re=V.filter(R=>(0,_.pathIncludedInQuery)(x,R.fsPath)),H=this.commonQueryFromFileList(re);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...x,...H}}const W=S.extraFileResources&&S.extraFileResources.filter(V=>(0,_.pathIncludedInQuery)(x,V.fsPath));return x.extraFileResources=W&&W.length?W:void 0,x}commonQueryFromFileList(d){const S=[],P=new I.ResourceMap,B={};let F=!1;return d.forEach(v=>{if(v.scheme===A.Schemas.walkThrough)return;if((0,O.isAbsolutePath)(v)){const W=this.workspaceContextService.getWorkspaceFolder(v)?.uri??v.with({path:y.dirname(v.fsPath)});let V=P.get(W);V||(F=!0,V={folder:W,includePattern:{}},S.push(V),P.set(W,V));const re=y.relative(W.fsPath,v.fsPath);(0,C.assertIsDefined)(V.includePattern)[re.replace(/\\/g,"/")]=!0}else v.fsPath&&(F=!0,B[v.fsPath]=!0)}),{folderQueries:S,includePattern:B,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(d,S){if(S.isSmartCase){if(d.isRegExp){if(L.containsUppercaseCharacter(d.pattern,!0))return!0}else if(L.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,g.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const S=H=>y.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),B=(Array.isArray(d)?d:s(d)).map(H=>{const R=this.pathService.resolvedUserHome;return R?(0,M.untildify)(H,R.scheme===A.Schemas.file?R.fsPath:R.path):H}),F=T.groupBy(B,H=>S(H)?"searchPaths":"exprSegments"),v=(F.exprSegments||[]).map(H=>L.rtrim(H,"/")).map(H=>L.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),i(H))),x={},W=this.expandSearchPathPatterns(F.searchPaths||[]);W&&W.length&&(x.searchPaths=W);const V=l.flatten(v),re=k(...V);return re&&(x.pattern=re),x}getExcludesForFolder(d,S){return S.disregardExcludeSettings?void 0:(0,_.getExcludes)(d,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const S=l.flatten(d.map(B=>{let{pathPortion:F,globPortion:v}=a(B);v&&(v=t(v));const x=this.expandOneSearchPath(F);return l.flatten(x.map(W=>this.resolveOneSearchPathPattern(W,v)))})),P=new Map;return S.forEach(B=>{const F=B.searchPath.toString(),v=P.get(F);v?B.pattern&&(v.pattern=v.pattern||{},v.pattern[B.pattern]=!0):P.set(F,{searchPath:B.searchPath,pattern:B.pattern?k(B.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(d){if(y.isAbsolute(d)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==A.Schemas.file?[{searchPath:S[0].uri.with({path:d})}]:[{searchPath:u.URI.file(y.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=c(d),d.startsWith("../")||d===".."){const B=y.posix.resolve(S.path,d);return[{searchPath:S.with({path:B})}]}const P=t(d);return[{searchPath:S,pattern:P}]}else{if(d==="./"||d===".\\")return[];{const S=d.replace(/^\.[\/\\]/,""),B=this.workspaceContextService.getWorkspace().folders.map(F=>{const v=S.match(new RegExp(`^${L.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return v?{match:v,folder:F}:null}).filter(C.isDefined);if(B.length)return B.map(F=>{const v=F.match[1];return{searchPath:F.folder.uri,pattern:v&&t(v)}});{const F=d.match(/\.[\/\\](.+)[\/\\]?/),v=F?F[1]:d,x=o.localize(0,null,v);throw new Error(x)}}}}resolveOneSearchPathPattern(d,S){const P=d.pattern&&S?`${d.pattern}/${S}`:d.pattern||S,B=[{searchPath:d.searchPath,pattern:P}];return P&&!P.endsWith("**")&&B.push({searchPath:d.searchPath,pattern:P+"/**"}),B}getFolderQueryForSearchPath(d,S,P){const B=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(d.searchPath),S,P,!1);return B?{...B,includePattern:d.pattern}:null}getFolderQueryForRoot(d,S,P,B){let F;const v=u.URI.isUri(d)?d:d.uri;if(P.searchPaths){const H=P.searchPaths.filter(R=>(0,O.isEqual)(R.searchPath,v))[0];if(H&&!H.pattern)return null;H&&(F=H.pattern)}const x=this.configurationService.getValue({resource:v}),V={...this.getExcludesForFolder(x,S)||{},...F||{}},re=u.URI.isUri(d)?(0,O.basename)(d):d.name;return{folder:v,folderName:B?re:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!x.search.followSymlinks}}};E=Ue([Be(0,r.IConfigurationService),Be(1,p.IWorkspaceContextService),Be(2,D.IEditorGroupsService),Be(3,f.ILogService),Be(4,h.IPathService)],E),e.QueryBuilder=E;function a(m){const d=m.match(/[\*\{\}\(\)\[\]\?]/);if(d){const S=d.index,P=m.substr(0,S).match(/[/|\\][^/\\]*$/);if(P){let B=m.substr(0,P.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:m.substr((P.index||0)+1)}}}return{pathPortion:m}}function k(...m){return m.length?m.reduce((d,S)=>(d[S]=!0,d),Object.create(null)):void 0}function s(m){return b.splitGlobAware(m,",").map(d=>d.trim()).filter(d=>!!d.length)}function i(m){return[`**/${m}/**`,`**/${m}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function c(m){return m.replace(/\\/g,"/")}function t(m){return c(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(m,d){m=l.distinct(m,B=>B.toString());const S=[],P=d.getWorkspace();return m&&m.forEach(B=>{let F;if(d.getWorkbenchState()===2)F=(0,O.relativePath)(P.folders[0].uri,B),F&&F!=="."&&(F="./"+F);else{const v=d.getWorkspaceFolder(B);if(v){const x=v.name;if(P.folders.filter(V=>V.name===x).length===1){const V=(0,O.relativePath)(v.uri,B);V===""?F=`./${v.name}`:F=`./${v.name}/${V}`}else F=B.fsPath}}F&&S.push(F)}),S}e.resolveResourcesForSearchIncludes=n}),define(be[218],Se([1,0,24,2,20,14,3,217,41,46]),function(J,e,l,T,b,M,I,A,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function C(r,f){const p=f.activationEvents;if(!p)return Promise.resolve(void 0);const D=[],h=[];for(const i of p)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||r.forceUsingSearch?h.push(c):D.push(c)}if(D.length===0&&h.length===0)return Promise.resolve(void 0);let _;const E=new Promise((i,c)=>{_=i}),a=i=>_({activationEvent:i}),k=Promise.all(D.map(i=>u(r,i,a))).then(()=>{}),s=g(r,f.identifier,h,a);return Promise.all([k,s]).then(()=>{_(void 0)}),E}e.checkActivateWorkspaceContainsExtension=C;async function u(r,f,p){for(const D of r.folders)if(await r.exists(l.joinPath(T.URI.revive(D),f))){p(`workspaceContains:${f}`);return}}async function g(r,f,p,D){if(p.length===0)return Promise.resolve(void 0);const h=new b.CancellationTokenSource,_=r.checkExists(r.folders,p,h.token),E=setTimeout(async()=>{h.cancel(),r.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${p.join(",")}`)},L);let a=!1;try{a=await _}catch(k){M.isCancellationError(k)||M.onUnexpectedError(k)}h.dispose(),clearTimeout(E),a&&D(`workspaceContains:${p.join(",")}`)}function o(r,f,p,D){const h=r.get(I.IInstantiationService),_=r.get(y.ISearchService),a=h.createInstance(A.QueryBuilder).file(f.map(k=>(0,O.toWorkspaceFolder)(T.URI.revive(k))),{_reason:"checkExists",includePattern:p,exists:!0});return _.fileSearch(a,D).then(k=>!!k.limitHit,k=>M.isCancellationError(k)?!1:Promise.reject(k))}e.checkGlobFileExists=o});var Ge=this&&this.__classPrivateFieldSet||function(J,e,l,T,b){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!b:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?b.call(J,l):b?b.value=l:e.set(J,l),l},Te=this&&this.__classPrivateFieldGet||function(J,e,l,T){if(l==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!T:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?T:l==="a"?T.call(J):T?T.value:e.get(J)};define(be[33],Se([1,0,125,17,72,24,12,7,23,2,13,4,32,176,70,31,25,175,14,26,22,152,6,83,3,28,71,15,57,61,40,5,218,67,154,11]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_,E,a,k,s,i,c,t,n,m,d,S,P,B,F,v){"use strict";var x,W,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let re=class Yi extends A.Disposable{constructor(X,ie,he,me,fe,ae,pe,Ae,Fe,He){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ie,this._extHostContext=he,this._initData=pe,this._extHostWorkspace=me,this._extHostConfiguration=fe,this._logService=ae,this._extHostTunnelService=Fe,this._extHostTerminalService=He,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=X.createChild(new n.ServiceCollection([o.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Ce=>Ye.add(h.ExtensionIdentifier.toKey(Ce))),this._activator=this._register(new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ce,Ee,De)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ce,D.transformErrorForSerialization(Ee),De)},actualActivateExtension:async(Ce,Ee)=>{if(Ye.has(h.ExtensionIdentifier.toKey(Ce)))return await this._mainThreadExtensionsProxy.$activateExtension(Ce,Ee),new g.HostExtension;const De=this._registry.getExtensionDescription(Ce);return this._activateExtension(De,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){D.onUnexpectedError(X)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(X)}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}_activateByEvent(X,ie){return this._activator.activateByEvent(X,ie)}_activateById(X,ie){return this._activator.activateById(X,ie)}activateByIdWithErrors(X,ie){return this._activateById(X,ie).then(()=>{const he=this._activator.getActivatedExtension(X);if(he.activationFailed)return Promise.reject(he.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._registry)}getExtensionExports(X){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(X).exports:null}async _realPathExtensionUri(X){if(X.scheme!==v.Schemas.file)return X;const ie=await this._hostUtils.realpath(X.fsPath);return O.URI.file(ie)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const X=y.TernarySearchTree.forUris(ie=>M.extUriBiasedIgnorePathCase.ignorePathCasing(ie));for(const ie of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ie)){const he=await this._realPathExtensionUri(ie.extensionLocation);X.set(he,ie)}return X})()),this._extensionPathIndex}_deactivate(X){let ie=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return ie;const he=this._activator.getActivatedExtension(X);if(!he)return ie;try{typeof he.module.deactivate=="function"&&(ie=Promise.resolve(he.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(me)}try{(0,A.dispose)(he.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this._logService.error(me)}return ie}async _activateExtension(X,ie){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,ie).then(he=>{const me=he.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,ie),this._logExtensionActivationTimes(X,ie,"success",me),he},he=>{throw this._logExtensionActivationTimes(X,ie,"failure"),he})}_logExtensionActivationTimes(X,ie,he,me){const fe=H(X,ie);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...me||{},outcome:he})}_doActivateExtension(X,ie){const he=H(X,ie);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",he);const me=this._getEntryPoint(X);if(!me)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${X.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this._logService.flush();const fe=new g.ExtensionActivationTimesBuilder(ie.startup);return Promise.all([this._loadCommonJSModule(X.identifier,(0,M.joinPath)(X.extensionLocation,me),fe),this._loadExtensionContext(X)]).then(ae=>(b.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Yi._callActivate(this._logService,X.identifier,ae[0],ae[1],fe))).then(ae=>(b.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),ae))}_loadExtensionContext(X){const ie=new E.ExtensionGlobalMemento(X,this._storage),he=new E.ExtensionMemento(X.identifier.value,!1,this._storage),me=new F.ExtensionSecrets(X,this._secretState),fe=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ae=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ie.whenReady,he.whenReady,this._storagePath.whenReady]).then(()=>{const pe=this;let Ae,Fe;const He=(0,f.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(h.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:he,secrets:me,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Ye){return T.join(X.extensionLocation.fsPath,Ye)},get storagePath(){return pe._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return pe._storagePath.globalValue(X).fsPath},get logPath(){return T.join(pe._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return O.URI.joinPath(pe._initData.logsLocation,X.identifier.value)},get storageUri(){return pe._storagePath.workspaceValue(X)},get globalStorageUri(){return pe._storagePath.globalValue(X)},get extensionMode(){return fe},get extension(){return Ae===void 0&&(Ae=new R(pe,X.identifier,X,ae)),Ae},get extensionRuntime(){return(0,f.checkProposedApiEnabled)(X,"extensionRuntime"),pe.extensionRuntime},get environmentVariableCollection(){return pe._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!Fe){if(!He)return;const Ye=S.Event.buffer(S.Event.fromDOMEventEmitter(He,"message",Ce=>Ce.data));He.start(),Fe={onDidReceiveMessage:Ye,postMessage:He.postMessage.bind(He)}}return Fe}})})}static _callActivate(X,ie,he,me,fe){return he=he||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,ie,he,me,fe).then(ae=>new g.ActivatedExtension(!1,null,fe.build(),he,ae,me.subscriptions))}static _callActivateOptional(X,ie,he,me,fe){if(typeof he.activate=="function")try{fe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ae=typeof global=="object"?global:self,pe=he.activate.apply(ae,[me]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(pe).then(Ae=>(fe.activateResolveStop(),Ae))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(he)}_activateOneStartupFinished(X,ie){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:ie}).then(void 0,he=>{this._logService.error(he)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const X of this._registry.getAllExtensionDescriptions())if(X.activationEvents)for(const ie of X.activationEvents)ie==="onStartupFinished"&&this._activateOneStartupFinished(X,ie)}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const ie=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],he=this._handleWorkspaceContainsEagerExtensions(ie),me=Promise.all([X,he]).then(()=>{});return Promise.race([me,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ie=>this._handleWorkspaceContainsEagerExtension(X,ie))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,ie){if(this.isActivated(ie.identifier))return;const he=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:X.map(ae=>ae.uri),forceUsingSearch:he,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,pe,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(ae,pe,Ae)},fe=await(0,P.checkActivateWorkspaceContainsExtension)(me,ie);if(!!fe)return this._activateById(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:fe.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:ie}=this._initData.environment;if(!X||!ie)throw new Error(l.localize(0,null));const he=await this._loadCommonJSModule(null,ie,new g.ExtensionActivationTimesBuilder(!1));if(!he||typeof he.run!="function")throw new Error(l.localize(1,null,ie.toString()));return new Promise((me,fe)=>{const ae=(Fe,He)=>{Fe?fe(Fe):me(typeof He=="number"&&He>0?1:0)},pe=(0,M.originalFSPath)(ie),Ae=he.run(pe,ae);Ae&&Ae.then&&Ae.then(()=>{me(0)}).catch(Fe=>{fe(Fe instanceof Error&&Fe.stack?Fe.stack:String(Fe))})})}async $extensionTestsExit(X){this._logService.info(`Extension host terminating: test runner requested exit with code ${X}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${X}`),this._logService.flush(),this._hostUtils.exit(X)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,ie){return this._resolvers[X]=ie,(0,A.toDisposable)(()=>{delete this._resolvers[X]})}async _activateAndGetResolver(X){const ie=X.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const he=X.substr(0,ie);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${he}`,!1),{authorityPrefix:he,resolver:this._resolvers[he]}}async $resolveAuthority(X,ie){this._logService.info(`$resolveAuthority invoked for authority (${se(X)})`);const{authorityPrefix:he,resolver:me}=await this._activateAndGetResolver(X);if(!me)return{type:"error",error:{code:k.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${he}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(me)),b.mark(`code/extHost/willResolveAuthority/${he}`);const fe=await me.resolve(X,{resolveAttempt:ie});b.mark(`code/extHost/didResolveAuthorityOK/${he}`);const ae={authority:X,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},pe={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ae,options:pe,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(b.mark(`code/extHost/didResolveAuthorityError/${he}`),fe instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(X,ie){this._logService.info(`$getCanonicalURI invoked for authority (${se(X)})`);const{resolver:he}=await this._activateAndGetResolver(X);if(!he)return null;const me=O.URI.revive(ie);if(typeof he.getCanonicalURI=="undefined")return me;const fe=await(0,I.asPromise)(()=>he.getCanonicalURI(me));return fe||me}$startExtensionHost(X){return this._registry.keepOnly(X),this._startExtensionHost()}$activateByEvent(X,ie){return ie===1?this._activateByEvent(X,!1):this._readyToRunExtensions.wait().then(he=>this._activateByEvent(X,!1))}async $activate(X,ie){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(X)?(await this._activateById(X,ie),!0):!1}async $deltaExtensions(X,ie){X.forEach(me=>me.extensionLocation=O.URI.revive(me.extensionLocation));const he=await this.getExtensionPathIndex();return await Promise.all(ie.map(async me=>{const fe=this._registry.getExtensionDescription(me);fe&&he.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(X.map(async me=>{const fe=await this._realPathExtensionUri(me.extensionLocation);he.set(fe,me)})),this._registry.deltaExtensions(X,ie),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){let ie=_.VSBuffer.alloc(X),he=Math.random()%256;for(let me=0;me<X;me++)ie.writeUInt8(he,me);return ie}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};re=Ue([Be(0,s.IInstantiationService),Be(1,e.IHostUtils),Be(2,t.IExtHostRpcService),Be(3,r.IExtHostWorkspace),Be(4,u.IExtHostConfiguration),Be(5,L.ILogService),Be(6,i.IExtHostInitDataService),Be(7,c.IExtensionStoragePaths),Be(8,m.IExtHostTunnelService),Be(9,d.IExtHostTerminalService)],re),e.AbstractExtHostExtensionService=re;function H(de,X){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class R{constructor(X,ie,he,me){x.set(this,void 0),W.set(this,void 0),V.set(this,void 0),Ge(this,x,X,"f"),Ge(this,W,ie,"f"),Ge(this,V,he.identifier,"f"),this.id=he.identifier.value,this.extensionUri=he.extensionLocation,this.extensionPath=T.normalize((0,M.originalFSPath)(he.extensionLocation)),this.packageJSON=he,this.extensionKind=me}get isActive(){return Te(this,x,"f").isActivated(Te(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,x,"f").getExtensionExports(Te(this,V,"f"))}activate(){return Te(this,x,"f").activateByIdWithErrors(Te(this,V,"f"),{startup:!1,extensionId:Te(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,x=new WeakMap,W=new WeakMap,V=new WeakMap;function se(de){const X=de.indexOf("+");return X===-1?de:de.substring(0,X)}}),define(be[99],Se([1,0,17,2,5,12,4,6,160,31,33,49,168,32,162,15,3,10,58,69]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,f.createDecorator)("IExtHostDebugService");let _=class{constructor(n,m,d,S,P,B){this._workspaceService=m,this._extensionService=d,this._editorsService=S,this._configurationService=P,this._editorTabs=B,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=n.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(v=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,m){const d=n;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let S=`debug:${encodeURIComponent(d.path||"")}`,P="?";return m&&(S+=`${P}session=${encodeURIComponent(m.id)}`,P="&"),S+=`${P}ref=${d.sourceReference}`,T.URI.parse(S)}else{if(d.path)return T.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const m=[];for(const d of n.getAllExtensionDescriptions())if(d.contributes){const S=d.contributes.debuggers;if(S&&S.length>0)for(const P of S)(0,o.isDebuggerMainContribution)(P)&&m.push(P.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(m=>n.push(m)),n}addBreakpoints(n){this.startBreakpoints();const m=n.filter(P=>{const B=P.id;return this._breakpoints.has(B)?!1:(this._breakpoints.set(B,P),!0)});this.fireBreakpointChanges(m,[],[]);const d=[],S=new Map;for(const P of m)if(P instanceof A.SourceBreakpoint){let B=S.get(P.location.uri.toString());B||(B={type:"sourceMulti",uri:P.location.uri,lines:[]},S.set(P.location.uri.toString(),B),d.push(B)),B.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof A.FunctionBreakpoint&&d.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(n){this.startBreakpoints();const m=n.filter(B=>this._breakpoints.delete(B.id));this.fireBreakpointChanges([],m,[]);const d=m.filter(B=>B instanceof A.SourceBreakpoint).map(B=>B.id),S=m.filter(B=>B instanceof A.FunctionBreakpoint).map(B=>B.id),P=m.filter(B=>B instanceof A.DataBreakpoint).map(B=>B.id);return this._debugServiceProxy.$unregisterBreakpoints(d,S,P)}startDebugging(n,m,d){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,m,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,m,d){if(!m)return new A.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:S,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,d,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,S),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(n,m,d){if(!d)return new A.Disposable(()=>{});if(!this.definesDebugType(n,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:S,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,S),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(n,m){if(!m)return new A.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:d,factory:m}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==m)})}async $runInTerminal(n,m){return Promise.resolve(void 0)}async $substituteVariables(n,m){if(!this._variableResolver){const[P,B]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,B)}let d;const S=await this.getFolder(n);return S&&(d={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,m)}createDebugAdapter(n,m){if(n.type==="implementation")return new i(n.implementation)}createSignService(){}async $startDASession(n,m){const d=this,S=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const B=this.convertToDto(P),F=this.createDebugAdapter(B,S);if(!F)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const v=F;return this._debugAdapters.set(n,v),this.getDebugAdapterTrackers(S).then(x=>(x&&this._debugAdaptersTrackers.set(n,x),v.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const V=W,re={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(V.arguments.value);re.body={signature:H},v.sendResponse(re)}else throw new Error("no signer")}catch(H){re.success=!1,re.message=H.message,v.sendResponse(re)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(W),W=(0,o.convertToVSCPaths)(W,!0),d._debugServiceProxy.$acceptDAMessage(n,W)}),v.onError(W=>{x&&x.onError&&x.onError(W),this._debugServiceProxy.$acceptDAError(n,W.name,W.message,W.stack)}),v.onExit(W=>{x&&x.onExit&&x.onExit((0,p.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,p.withNullAsUndefined)(W),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),v.startSession()))})}$sendDAMessage(n,m){m=(0,o.convertToDAPaths)(m,!1);const d=this._debugAdaptersTrackers.get(n);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(m);const S=this._debugAdapters.get(n);S&&S.sendMessage(m)}$stopDASession(n){const m=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),m&&m.onWillStopSession&&m.onWillStopSession();const d=this._debugAdapters.get(n);return this._debugAdapters.delete(n),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const m=[],d=[],S=[];if(n.added)for(const P of n.added){const B=P.id;if(B&&!this._breakpoints.has(B)){let F;if(P.type==="function")F=new A.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")F=new A.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const v=T.URI.revive(P.uri);F=new A.SourceBreakpoint(new A.Location(v,new A.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}F._id=B,this._breakpoints.set(B,F),m.push(F)}}if(n.removed)for(const P of n.removed){const B=this._breakpoints.get(P);B&&(this._breakpoints.delete(P),d.push(B))}if(n.changed){for(const P of n.changed)if(P.id){const B=this._breakpoints.get(P.id);if(B){if(B instanceof A.FunctionBreakpoint&&P.type==="function"){const F=B;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.functionName=P.functionName}else if(B instanceof A.SourceBreakpoint&&P.type==="source"){const F=B;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.location=new A.Location(T.URI.revive(P.uri),new A.Position(P.line,P.character))}S.push(B)}}}this.fireBreakpointChanges(m,d,S)}$provideDebugConfigurations(n,m,d){return(0,M.asPromise)(async()=>{const S=this.getConfigProviderByHandle(n);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(m);return S.provideDebugConfigurations(P,d)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(n,m,d,S){return(0,M.asPromise)(async()=>{const P=this.getConfigProviderByHandle(n);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const B=await this.getFolder(m);return P.resolveDebugConfiguration(B,d,S)})}$resolveDebugConfigurationWithSubstitutedVariables(n,m,d,S){return(0,M.asPromise)(async()=>{const P=this.getConfigProviderByHandle(n);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const B=await this.getFolder(m);return P.resolveDebugConfigurationWithSubstitutedVariables(B,d,S)})}async $provideDebugAdapter(n,m){const d=this.getAdapterDescriptorFactoryByHandle(n);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(m);return this.getAdapterDescriptor(d,S).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(n){const m=await this.getSession(n);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(n){const m=await this.getSession(n);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,m){const d=await this.getSession(n);d&&d._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(n,m){const S={session:await this.getSession(n),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(n){if(n instanceof A.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof A.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const m=this._adapterFactories.filter(d=>d.type===n);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(n){const m=this._adapterFactories.filter(d=>d.handle===n);if(m.length>0)return m[0].factory}getConfigProviderByHandle(n){const m=this._configProviders.filter(d=>d.handle===n);if(m.length>0)return m[0].provider}definesDebugType(n,m){if(n.contributes){const d=n.contributes.debuggers;if(d&&d.length>0){for(const S of d)if(S.label&&S.type&&S.type===m)return!0}}return!1}getDebugAdapterTrackers(n){const d=n.configuration.type,S=this._trackerFactories.filter(P=>P.type===d||P.type==="*").map(P=>(0,M.asPromise)(()=>P.factory.createDebugAdapterTracker(n)).then(B=>B,B=>null));return Promise.race([Promise.all(S).then(P=>{const B=P.filter(F=>!!F);if(B.length>0)return new s(B)}),new Promise((P,B)=>{const F=setTimeout(()=>{clearTimeout(F),B(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(n,m){const d=m.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.DebugAdapterServer(d));if(n){const P=await this._extensionService.getExtensionRegistry();return(0,M.asPromise)(()=>n.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,P))).then(B=>{if(B)return B})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,S))}daExecutableFromPackage(n,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,m,d){(n.length>0||m.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:m,changed:d}))}async getSession(n){if(n)if(typeof n=="string"){const m=this._debugSessions.get(n);if(m)return m}else{let m=this._debugSessions.get(n.id);if(!m){const d=await this.getFolder(n.folderUri),S=n.parent?this._debugSessions.get(n.parent):void 0;m=new E(this._debugServiceProxy,n.id,n.type,n.name,d,n.configuration,S),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(n){if(n){const m=T.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};_=Ue([Be(0,r.IExtHostRpcService),Be(1,O.IExtHostWorkspace),Be(2,L.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,g.IExtHostConfiguration),Be(5,h.IExtHostEditorTabs)],_),e.ExtHostDebugServiceBase=_;class E{constructor(n,m,d,S,P,B,F){this._debugServiceProxy=n,this._id=m,this._type=d,this._name=S,this._workspaceFolder=P,this._configuration=B,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,m)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=E;class a{constructor(n){this.value=Object.freeze({append(m){n.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=a;class k extends u.AbstractVariableResolverService{constructor(n,m,d,S,P,B){function F(){if(m){const v=m.activeEditor();if(v)return v.document.uri;const x=S.tabGroups.groups.find(W=>W.isActive)?.activeTab;if(x!==void 0){if(x.kind instanceof A.TextDiffTabInput||x.kind instanceof A.NotebookDiffEditorTabInput)return x.kind.modified;if(x.kind instanceof A.TextTabInput||x.kind instanceof A.NotebookEditorTabInput||x.kind instanceof A.CustomEditorTabInput)return x.kind.uri}}}super({getFolderUri:v=>{const x=n.filter(W=>W.name===v);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>n.length,getConfigurationValue:(v,x)=>d.getConfiguration(void 0,v).get(x),getAppRoot:()=>D.cwd(),getExecPath:()=>D.env.VSCODE_EXEC_PATH,getFilePath:()=>{const v=F();if(v)return l.normalize(v.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const v=F();if(v){const x=P.getWorkspaceFolder(v);if(x)return l.normalize(x.uri.fsPath)}}},getSelectedText:()=>{if(m){const v=m.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(m){const v=m.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,B?Promise.resolve(B):void 0,Promise.resolve(D.env))}}e.ExtHostVariableResolverService=k;class s{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(m=>m.onError?m.onError(n):void 0)}onExit(n,m){this.trackers.forEach(d=>d.onExit?d.onExit(n,m):void 0)}}class i extends y.AbstractDebugAdapter{constructor(n){super();this.implementation=n,n.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends _{constructor(n,m,d,S,P,B){super(n,m,d,S,P,B)}createVariableResolver(n,m,d){return new k(n,m,d,this._editorTabs)}};c=Ue([Be(0,r.IExtHostRpcService),Be(1,O.IExtHostWorkspace),Be(2,L.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,g.IExtHostConfiguration),Be(5,h.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(be[219],Se([1,0,72,2,4,32,25,26,15,28,3,33,58,13,9]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(E,a,k,s,i,c,t){this._apiFactory=E,this._extensionRegistry=a,this._instaService=k,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=c,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const E=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,a,this._extensionRegistry,E,this._logService)),this.register(this._instaService.createInstance(D,a)),this.register(this._instaService.createInstance(f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,a,this._initData.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(let a of E.nodeModuleName)this._factories.set(a,E);else this._factories.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this._alternatives.push(a=>E.alternativeModuleName(a))}};r=Ue([Be(2,L.IInstantiationService),Be(3,M.IExtHostConfiguration),Be(4,C.IExtHostExtensionService),Be(5,O.IExtHostInitDataService),Be(6,g.ILogService)],r),e.RequireInterceptor=r;let f=class qi{constructor(E){if(E.environment.appRoot&&qi.aliased.size){const a=(0,o.escapeRegExpCharacters)(this.forceForwardSlashes(E.environment.appRoot.fsPath)),k="[a-z0-9_.-]",s=`@${k}+\\/${k}+|${k}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(E){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(E));if(!a)return;const[,k,s,i]=a,c=qi.aliased.get(s);if(c!==void 0)return console.warn(`${s} as been renamed to ${c}, please update your imports`),k+c+i}forceForwardSlashes(E){return E.replace(/\\/g,"/")}};f.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),f=Ue([Be(0,O.IExtHostInitDataService)],f);class p{constructor(E,a,k,s,i){this._apiFactory=E,this._extensionPaths=a,this._extensionRegistry=k,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(E,a){const k=this._extensionPaths.findSubstr(a);if(k){let s=this._extApiImpl.get(A.ExtensionIdentifier.toKey(k.identifier));return s||(s=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(k.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,c)=>s+=`	${c} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(E,a,k){this._extensionPaths=E,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(b.MainContext.MainThreadTelemetry);const{environment:s}=k,i=a.getProxy(b.MainContext.MainThreadKeytar);if(s.appRoot){let c=s.appRoot.fsPath;u.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${c}/node_modules.asar/keytar`),this.alternativeNames.add(`${c}/node_modules/keytar`)}this._impl={getPassword:(c,t)=>i.$getPassword(c,t),setPassword:(c,t,n)=>i.$setPassword(c,t,n),deletePassword:(c,t)=>i.$deletePassword(c,t),findPassword:c=>i.$findPassword(c),findCredentials(c){return i.$findCredentials(c)}}}load(E,a){const k=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:k?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(E){const a=E.length;if(a<=7||!this.alternativeNames)return;const k=a-7;if((E.charAt(k)==="/"||E.charAt(k)==="\\")&&E.endsWith("keytar")&&(E=E.replace(/\\/g,"/"),this.alternativeNames.has(E)))return"keytar"}};D=Ue([Be(1,y.IExtHostRpcService),Be(2,O.IExtHostInitDataService)],D);let h=class{constructor(E,a,k){this._extensionPaths=E,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(b.MainContext.MainThreadTelemetry);const s=k.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,c)=>{const t=T.URI.parse(i);return c?this.callOriginal(i,c):t.scheme==="http"||t.scheme==="https"?s.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?s.$openUri(t,i,{}):this.callOriginal(i,c)}}load(E,a,k){const s=this._extensionPaths.findSubstr(a);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=k(E),this._impl}callOriginal(E,a){return this.sendNoForwardTelemetry(),this._original(E,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=Ue([Be(2,y.IExtHostRpcService)],h)}),define(be[220],Se([1,0,12,14,72,7,2,4,212,13,55,57,28,142,15,62,33,40]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class D{constructor(_,E,a,k,s){this._disposables=new M.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new y.RPCProtocol(_,null,k),E=D._transform(E,this._rpcProtocol);const i=new C.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());i.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:s}),i.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),i.set(r.IURITransformerService,new r.URITransformerService(k)),i.set(f.IHostUtils,a);const c=new g.InstantiationService(i,!0);this._disposables.add(c.invokeFunction(d=>d.get(p.IExtHostTerminalService))),this._disposables.add(c.invokeFunction(d=>d.get(f.IExtHostExtensionService))),this._logService=c.invokeFunction(d=>d.get(O.ILogService)),b.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=c.invokeFunction(d=>d.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(S,P)=>{let B="",F,v;for(const x of P)B+=`
	at ${x.toString()}`,v=x.getFileName(),!F&&v&&(F=d.findSubstr(I.URI.file(v)));return t.set(S,F),`${S.name||"Error"}: ${S.message||""}${B}`}});const n=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(d=>{const S=T.transformErrorForSerialization(d),P=t.get(d);P?n.$onExtensionRuntimeError(P.identifier,S):m.$onUnexpectedError(S)})}async asBrowserUri(_){const E=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return I.URI.revive(await E.$asBrowserUri(_))}terminate(_){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${_}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const E=this._extensionService.deactivateAll();Promise.race([(0,l.timeout)(5e3),E]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(_,E){_.extensions.forEach(k=>k.extensionLocation=I.URI.revive(E.transformIncomingURIs(k.extensionLocation))),_.environment.appRoot=I.URI.revive(E.transformIncomingURIs(_.environment.appRoot));const a=_.environment.extensionDevelopmentLocationURI;return a&&(_.environment.extensionDevelopmentLocationURI=a.map(k=>I.URI.revive(E.transformIncomingURIs(k)))),_.environment.extensionTestsLocationURI=I.URI.revive(E.transformIncomingURIs(_.environment.extensionTestsLocationURI)),_.environment.globalStorageHome=I.URI.revive(E.transformIncomingURIs(_.environment.globalStorageHome)),_.environment.workspaceStorageHome=I.URI.revive(E.transformIncomingURIs(_.environment.workspaceStorageHome)),_.logsLocation=I.URI.revive(E.transformIncomingURIs(_.logsLocation)),_.logFile=I.URI.revive(E.transformIncomingURIs(_.logFile)),_.workspace=E.transformIncomingURIs(_.workspace),_}}e.ExtensionHostMain=D}),define(be[221],Se([1,0,16,12,20,43,11,17,24,10,2,41]),function(J,e,l,T,b,M,I,A,y,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(h,_,E,a){this.query=h,this.provider=_,this.fileUtils=E,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,_){const E=this.query.folderQueries||[],a=new b.CancellationTokenSource;return _.onCancellationRequested(()=>a.cancel()),new Promise((k,s)=>{this.collector=new o(h);let i=!1;const c=(t,n)=>{if(!i&&!this.isLimitHit){const m=this.resultSize(t);f(t)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,i=!0,a.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const d=this.resultSize(t);this.resultCount+=d,(d>0||!f(t))&&this.collector.add(t,n)}};Promise.all(E.map((t,n)=>this.searchInFolder(t,m=>c(m,n),a.token))).then(t=>{a.dispose(),this.collector.flush();const n=t.some(m=>!!m&&!!m.limitHit);k({limitHit:this.isLimitHit||n,messages:(0,l.flatten)(t.map(m=>m?.message?(0,O.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},t=>{a.dispose();const n=(0,M.toErrorMessage)(t);s(new Error(n))})})}resultSize(h){return f(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,_){const E=Array.isArray(h.ranges)?h.ranges:[h.ranges],a=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:E.slice(0,_),preview:{matches:a.slice(0,_),text:h.preview.text},uri:h.uri}}async searchInFolder(h,_,E){const a=new C.QueryGlobTester(this.query,h),k=[],s={report:t=>{if(!this.validateProviderResult(t))return;const n=h.folder.scheme===I.Schemas.file?(0,C.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(t.uri))):void 0,m=y.relativePath(h.folder,t.uri);if(m){const d=a.includedInQuery(m,A.basename(m),n);(0,T.isThenable)(d)?k.push(d.then(S=>{S&&_(t)})):d&&_(t)}}},i=this.getSearchOptionsForFolder(h),c=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,s,E);return k.length&&await Promise.all(k),c}validateProviderResult(h){if(f(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const _=(0,C.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),E=(0,C.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),a={folder:L.URI.from(h.folder),excludes:E,includes:_,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=u;function g(D){return{isCaseSensitive:D.isCaseSensitive||!1,isRegExp:D.isRegExp||!1,isWordMatch:D.isWordMatch||!1,isMultiline:D.isMultiline||!1,pattern:D.pattern}}class o{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,_=>this.sendItems(_))}add(h,_){this._currentFileMatch&&(this._currentFolderIdx!==_||!y.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=_,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(r(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=o;function r(D){return f(D)?{preview:{matches:(0,l.mapArrayOrNot)(D.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:D.preview.text},ranges:(0,l.mapArrayOrNot)(D.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:D.text,lineNumber:D.lineNumber}}function f(D){return!!D.preview}e.extensionResultIsMatch=f;class p{constructor(h,_){this.maxBatchSize=h,this.cb=_,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,_){!h||this.addItemToBatch(h,_)}addItems(h,_){!h||this.addItemsToBatch(h,_)}addItemToBatch(h,_){this.batch.push(h),this.batchSize+=_,this.onUpdate()}addItemsToBatch(h,_){this.batch=this.batch.concat(h),this.batchSize+=_,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(be[100],Se([1,0,7,4,3,216,15,62,13,2,221]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let C=class{constructor(r,f,p){this.extHostRpc=r,this._uriTransformer=f,this._logService=p,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(r){return this._uriTransformer.transformOutgoingScheme(r)}registerTextSearchProvider(r,f){if(this._textSearchUsedSchemes.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this._textSearchUsedSchemes.add(r);const p=this._handlePool++;return this._textSearchProvider.set(p,f),this._proxy.$registerTextSearchProvider(p,this._transformScheme(r)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(r),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(r,f){if(this._fileSearchUsedSchemes.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this._fileSearchUsedSchemes.add(r);const p=this._handlePool++;return this._fileSearchProvider.set(p,f),this._proxy.$registerFileSearchProvider(p,this._transformScheme(r)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(r),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(r,f,p,D){const h=u(p),_=this._fileSearchProvider.get(r);if(_)return this._fileSearchManager.fileSearch(h,_,E=>{this._proxy.$handleFileMatch(r,f,E.map(a=>a.resource))},D);throw new Error("unknown provider: "+r)}$clearCache(r){return this._fileSearchManager.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,f,p,D){const h=this._textSearchProvider.get(r);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const _=u(p);return this.createTextSearchManager(_,h).search(a=>this._proxy.$handleTextMatch(r,f,a),D)}$enableExtensionHostSearch(){}createTextSearchManager(r,f){return new L.TextSearchManager(r,f,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p},"textSearchProvider")}};C=Ue([Be(0,I.IExtHostRpcService),Be(1,A.IURITransformerService),Be(2,y.ILogService)],C),e.ExtHostSearch=C;function u(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(g),extraFileResources:o.extraFileResources&&o.extraFileResources.map(r=>O.URI.revive(r))}}e.reviveQuery=u;function g(o){return{...o,folder:O.URI.revive(o.folder)}}}),define(be[222],Se([1,0,55,95,31,93,32,39,49,40,98,99,100,70,61,68,96,50,30,67,85,69,195,13,177]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_,E,a,k,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(k.ILoggerService,a.ExtHostLoggerService),(0,l.registerSingleton)(k.ILogService,s.ExtHostLogService),(0,l.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService),(0,l.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,l.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,l.registerSingleton)(p.IExtHostConsumerFileSystem,p.ExtHostConsumerFileSystem),(0,l.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,l.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations),(0,l.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,l.registerSingleton)(D.IExtHostFileSystemInfo,D.ExtHostFileSystemInfo),(0,l.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService),(0,l.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,l.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,l.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,l.registerSingleton)(O.IExtHostTerminalService,O.WorkerExtHostTerminalService),(0,l.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,l.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow),(0,l.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,l.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,l.registerSingleton)(_.IExtHostTelemetry,_.ExtHostTelemetry),(0,l.registerSingleton)(E.IExtHostEditorTabs,E.ExtHostEditorTabs)}),define(be[223],Se([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const M=this._dragOperations.get(b);return this._dragOperations.delete(b),M}}addDragOperationTransfer(b,M){this._dragOperations.set(b,M)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,M){this._renderedElements.set(b,M)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=l}),define(be[224],Se([1,0,129,24,2,5,7,12,6,10,16,8,20,87,223]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function r(D,h){if((0,O.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let _;return Array.isArray(D.highlights)&&(_=D.highlights.filter(E=>E.length===2&&typeof E[0]=="number"&&typeof E[1]=="number"),_=_.length?_:void 0),{label:D.label,highlights:_}}}class f{constructor(h,_,E){this._proxy=h,this.commands=_,this.logService=E,this.treeViews=new Map,this.treeDragAndDropService=new o.TreeviewsService;function a(k){return k&&k.$treeViewId&&k.$treeItemHandle}_.registerArgumentProcessor({processArgument:k=>a(k)?this.convertArgument(k):Array.isArray(k)&&k.length>0?k.map(s=>a(s)?this.convertArgument(s):s):k})}registerTreeDataProvider(h,_,E){const a=this.createTreeView(h,{treeDataProvider:_},E);return{dispose:()=>a.dispose()}}createTreeView(h,_,E){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=_.dragAndDropController?.dropMimeTypes??[],k=_.dragAndDropController?.dragMimeTypes??[],s=!!_.dragAndDropController?.handleDrag,i=!!_.dragAndDropController?.handleDrop,c=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:a,dragMimeTypes:k,hasHandleDrag:s,hasHandleDrop:i}),t=this.createExtHostTreeView(h,_,E);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,m)=>t.reveal(n,m),dispose:async()=>{await c,this.treeViews.delete(h),t.dispose()}}}$getChildren(h,_){const E=this.treeViews.get(h);return E?E.getChildren(_):Promise.reject(new Error((0,l.localize)(0,null,h)))}async $handleDrop(h,_,E,a,k,s,i){const c=this.treeViews.get(h);if(!c)return Promise.reject(new Error((0,l.localize)(1,null,h)));const t=g.DataTransferConverter.toDataTransfer(_);return s===h&&i&&await this.addAdditionalTransferItems(t,c,i,a,k),c.onDrop(t,E,a)}async addAdditionalTransferItems(h,_,E,a,k){const s=this.treeDragAndDropService.removeDragOperationTransfer(k);if(s)(await s)?.forEach((i,c)=>{i&&h.set(c,i)});else if(k&&_.handleDrag){const i=_.handleDrag(E,h,a);this.treeDragAndDropService.addDragOperationTransfer(k,i),await i}return h}async $handleDrag(h,_,E,a){const k=this.treeViews.get(h);if(!k)return Promise.reject(new Error((0,l.localize)(2,null,h)));const s=await this.addAdditionalTransferItems(new Map,k,_,a,E);if(!!s)return g.DataTransferConverter.toDataTransferDTO(s)}async $hasResolve(h){const _=this.treeViews.get(h);if(!_)throw new Error((0,l.localize)(3,null,h));return _.hasResolve}$resolve(h,_,E){const a=this.treeViews.get(h);if(!a)throw new Error((0,l.localize)(4,null,h));return a.resolveTreeItem(_,E)}$setExpanded(h,_,E){const a=this.treeViews.get(h);if(!a)throw new Error((0,l.localize)(5,null,h));a.setExpanded(_,E)}$setSelection(h,_){const E=this.treeViews.get(h);if(!E)throw new Error((0,l.localize)(6,null,h));E.setSelection(_)}$setVisible(h,_){const E=this.treeViews.get(h);if(!E)throw new Error((0,l.localize)(7,null,h));E.setVisible(_)}createExtHostTreeView(h,_,E){const a=new p(h,_,this._proxy,this.commands.converter,this.logService,E);return this.treeViews.set(h,a),a}convertArgument(h){const _=this.treeViews.get(h.$treeViewId);return _?_.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=f;class p extends I.Disposable{constructor(h,_,E,a,k,s){super();if(this.viewId=h,this.proxy=E,this.commands=a,this.logService=k,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new M.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new M.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new M.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new M.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new M.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new u.CancellationTokenSource,s.contributes&&s.contributes.views)for(const t in s.contributes.views)for(const n of s.contributes.views[t])n.id===h&&(this._title=n.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,c;this._register(M.Event.debounce(this._onDidChangeData.event,(t,n)=>(t||(t={message:!1,elements:[]}),n.element!==!1&&(i||(i=new Promise(m=>c=m),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(n.element)?t.elements.push(...n.element):t.elements.push(n.element)),n.message&&(t.message=!0),t),200,!0)(({message:t,elements:n})=>{n.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=c;return i=null,this.refresh(n).then(()=>m())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,O.isUndefinedOrNull)(h))}async getChildren(h){const _=h?this.getExtensionElement(h):void 0;if(h&&!_)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let E=this.getChildrenNodes(h);return E||(E=await this.fetchChildrenNodes(_)),E?E.map(a=>a.item):void 0}getExtensionElement(h){return this.elements.get(h)}reveal(h,_){_=_||{select:!0,focus:!1};const E=(0,O.isUndefinedOrNull)(_.select)?!0:_.select,a=(0,O.isUndefinedOrNull)(_.focus)?!1:_.focus,k=(0,O.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(s=>this.resolveTreeNode(h,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(c=>c.item)},{select:E,focus:a,expand:k})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:E,focus:a,expand:k})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,_){const E=this.getExtensionElement(h);E&&(_?this._onDidExpandElement.fire(Object.freeze({element:E})):this._onDidCollapseElement.fire(Object.freeze({element:E})))}setSelection(h){(0,L.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(h,_,E){const a=[];for(const k of h){const s=this.getExtensionElement(k);s&&a.push(s)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,_,E),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(h,_,E){const a=_?this.getExtensionElement(_):void 0;if(!(!a&&_||!this.dndController?.handleDrop))return(0,A.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(a,h,E):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,_){if(!this.dataProvider.resolveTreeItem)return;const E=this.elements.get(h);if(E){const a=this.nodes.get(E);if(a){const k=await this.dataProvider.resolveTreeItem(a.extensionItem,E,_)??a.extensionItem;return a.item.tooltip=this.getTooltip(k.tooltip),a.item.command=this.getCommand(a.disposableStore,k.command),a.item}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(_=>_?this.resolveUnknownParentChain(_).then(E=>this.resolveTreeNode(_,E[E.length-1]).then(a=>(E.push(a),E))):Promise.resolve([]))}resolveParent(h){const _=this.nodes.get(h);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,_){const E=this.nodes.get(h);return E?Promise.resolve(E):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(a=>this.createHandle(h,a,_,!0)).then(a=>this.getChildren(_?_.item.handle:void 0).then(()=>{const k=this.getExtensionElement(a);if(k){const s=this.nodes.get(k);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(h){if(h){let _;if(typeof h=="string"){const E=this.getExtensionElement(h);_=E?this.nodes.get(E):void 0}else _=h;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const _=new u.CancellationTokenSource(this._refreshCancellationSource.token);try{const E=h?this.nodes.get(h):void 0,a=await this.dataProvider.getChildren(h);if(_.token.isCancellationRequested)return;const k=await Promise.all((0,L.coalesce)(a||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,E):null}));return _.token.isCancellationRequested?void 0:(0,L.coalesce)(k)}finally{_.dispose()}}refresh(h){if(h.some(E=>!E))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new u.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const E=this.getHandlesToRefresh(h);if(E.length)return this.refreshHandles(E)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const _=new Set,E=h.map(k=>this.nodes.get(k));for(const k of E)if(k&&!_.has(k.item.handle)){let s=k;for(;s&&s.parent&&E.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&_.add(k.item.handle)}const a=[];return _.forEach(k=>{const s=this.elements.get(k);if(s){const i=this.nodes.get(s);i&&(!i.parent||!_.has(i.parent.item.handle))&&a.push(k)}}),a}refreshHandles(h){const _={};return Promise.all(h.map(E=>this.refreshNode(E).then(a=>{a&&(_[E]=a.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(h){const _=this.getExtensionElement(h);if(_){const E=this.nodes.get(_);if(E)return this.clearChildren(_),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(a=>{if(a){const k=this.createTreeNode(_,a,E.parent);return this.updateNodeCache(_,k,E,E.parent),E.dispose(),k}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,_,E){const a=this.createTreeNode(h,_,E);if(_.id&&this.elements.has(a.item.handle))throw new Error((0,l.localize)(8,null,_.id));return this.addNodeToCache(h,a),this.addNodeToParentCache(a,E),a}getTooltip(h){return y.MarkdownString.isMarkdownString(h)?C.MarkdownString.from(h):h}getCommand(h,_){return _?this.commands.toInternal(_,h):void 0}createTreeNode(h,_,E){const a=new I.DisposableStore,k=this.createHandle(h,_,E),s=this.getLightIconPath(_);return{item:{handle:k,parentHandle:E?E.item.handle:void 0,label:r(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(a,_.command),contextValue:_.contextValue,icon:s,iconDark:this.getDarkIconPath(_)||s,themeIcon:this.getThemeIcon(_),collapsibleState:(0,O.isUndefinedOrNull)(_.collapsibleState)?y.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:E,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(h){return h.iconPath instanceof y.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:_,label:E,resourceUri:a},k,s){if(_)return`${p.ID_HANDLE_PREFIX}/${_}`;const i=r(E,this.extension),c=k?k.item.handle:p.LABEL_HANDLE_PREFIX;let t=i?i.label:a?(0,T.basename)(a):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const n=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,m=this.getChildrenNodes(k)||[];let d,S=0;do{if(d=`${c}/${S}:${t}`,s||!this.elements.has(d)||n===d)break;S++}while(S<=m.length);return d}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon))return typeof h.iconPath=="string"||b.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return b.URI.isUri(h)?h:b.URI.file(h)}addNodeToCache(h,_){this.elements.set(_.item.handle,h),this.nodes.set(h,_)}updateNodeCache(h,_,E,a){this.elements.delete(_.item.handle),this.nodes.delete(h),_.item.handle!==E.item.handle&&this.elements.delete(E.item.handle),this.addNodeToCache(h,_);const k=this.getChildrenNodes(a)||[],s=k.filter(i=>i.item.handle===E.item.handle)[0];s&&k.splice(k.indexOf(s),1,_)}addNodeToParentCache(h,_){_?(_.children||(_.children=[]),_.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const _=this.nodes.get(h);if(_){if(_.children)for(const E of _.children){const a=this.elements.get(E.item.handle);a&&this.clear(a)}_.children=void 0}}else this.clearAll()}clear(h){const _=this.nodes.get(h);if(_){if(_.children)for(const E of _.children){const a=this.elements.get(E.item.handle);a&&this.clear(a)}this.nodes.delete(h),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(be[225],Se([1,0,20,14,5,34,2,116,237,111,77,45,4,92,182,181,39,183,32,184,185,186,170,187,49,33,188,189,192,194,196,95,172,201,202,203,70,40,205,224,8,6,208,51,96,31,73,159,191,84,93,98,99,100,13,62,15,28,197,156,61,68,179,206,155,71,50,211,209,210,180,30,204,207,67,69,85,199,97,200,11,81,198,153,190,7,25,161]),function(J,e,l,T,b,M,I,A,y,O,L,C,u,g,o,r,f,p,D,h,_,E,a,k,s,i,c,t,n,m,d,S,P,B,F,v,x,W,V,re,H,R,se,de,X,ie,he,me,fe,ae,pe,Ae,Fe,He,Ye,Ce,Ee,De,ne,q,Q,w,U,z,j,ee,ce,ve,Oe,Le,Ne,Ve,Je,ke,je,G,Y,ue,Me,We,Xe,Ze,ot,wt,mt,kt,qe,gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(rt){const ft=rt.get(De.IExtHostInitDataService),Ut=rt.get(Ve.IExtHostFileSystemInfo),Pt=rt.get(ce.IExtHostConsumerFileSystem),_t=rt.get(i.IExtHostExtensionService),ct=rt.get(ie.IExtHostWorkspace),At=rt.get(Y.IExtHostTelemetry),Mt=rt.get(D.IExtHostConfiguration),Ft=rt.get(Ce.IURITransformerService),xe=rt.get(Ee.IExtHostRpcService),ge=rt.get(x.IExtHostStorage),we=rt.get(ee.IExtensionStoragePaths),le=rt.get(Ye.ILoggerService),K=rt.get(Ye.ILogService),ye=rt.get(Q.IExtHostTunnelService),Pe=rt.get(w.IExtHostApiDeprecationService),$e=rt.get(X.IExtHostWindow),Ke=rt.get(je.IExtHostSecretState),dt=rt.get(G.IExtHostEditorTabs);xe.set(u.ExtHostContext.ExtHostFileSystemInfo,Ut),xe.set(u.ExtHostContext.ExtHostLogLevelServiceShape,le),xe.set(u.ExtHostContext.ExtHostWorkspace,ct),xe.set(u.ExtHostContext.ExtHostConfiguration,Mt),xe.set(u.ExtHostContext.ExtHostExtensionService,_t),xe.set(u.ExtHostContext.ExtHostStorage,ge),xe.set(u.ExtHostContext.ExtHostTunnelService,ye),xe.set(u.ExtHostContext.ExtHostWindow,$e),xe.set(u.ExtHostContext.ExtHostSecretState,Ke),xe.set(u.ExtHostContext.ExtHostTelemetry,At),xe.set(u.ExtHostContext.ExtHostEditorTabs,dt);const pt=xe.set(u.ExtHostContext.ExtHostDecorations,rt.get(pe.IExtHostDecorations)),vt=xe.set(u.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(s.IExtHostDocumentsAndEditors)),nt=xe.set(u.ExtHostContext.ExtHostCommands,rt.get(f.IExtHostCommands)),ut=xe.set(u.ExtHostContext.ExtHostTerminalService,rt.get(W.IExtHostTerminalService)),at=xe.set(u.ExtHostContext.ExtHostDebugService,rt.get(Fe.IExtHostDebugService)),Lt=xe.set(u.ExtHostContext.ExtHostSearch,rt.get(He.IExtHostSearch)),Et=xe.set(u.ExtHostContext.ExtHostTask,rt.get(Ae.IExtHostTask)),It=xe.set(u.ExtHostContext.ExtHostOutputService,rt.get(S.IExtHostOutputService)),yt=xe.set(u.ExtHostContext.ExtHostUrls,new se.ExtHostUrls(xe)),St=xe.set(u.ExtHostContext.ExtHostDocuments,new k.ExtHostDocuments(xe,vt)),Jt=xe.set(u.ExtHostContext.ExtHostDocumentContentProviders,new E.ExtHostDocumentContentProvider(xe,vt,K)),Wt=xe.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(K,St,xe.getProxy(u.MainContext.MainThreadBulkEdits))),ht=xe.set(u.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(xe,nt,vt,St,we)),Kt=xe.set(u.ExtHostContext.ExtHostNotebookDocuments,new wt.ExtHostNotebookDocuments(K,ht)),Xt=xe.set(u.ExtHostContext.ExtHostNotebookEditors,new ot.ExtHostNotebookEditors(K,xe,ht)),Zt=xe.set(u.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(xe,ft,ht,nt,K)),li=xe.set(u.ExtHostContext.ExtHostNotebookRenderers,new We.ExtHostNotebookRenderers(xe,ht)),Tt=xe.set(u.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(xe,vt)),ei=xe.set(u.ExtHostContext.ExtHostTreeViews,new re.ExtHostTreeViews(xe.getProxy(u.MainContext.MainThreadTreeViews),nt,K)),ci=xe.set(u.ExtHostContext.ExtHostEditorInsets,new me.ExtHostEditorInsets(xe.getProxy(u.MainContext.MainThreadEditorInsets),Tt,ft.remote)),Gt=xe.set(u.ExtHostContext.ExtHostDiagnostics,new h.ExtHostDiagnostics(xe,K,Ut)),ti=xe.set(u.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(xe,St,nt.converter,Ft)),st=xe.set(u.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(xe,Ft,St,nt,Gt,K,Pe)),ui=xe.set(u.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(xe,st)),Bt=xe.set(u.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(xe,K,vt)),zt=xe.set(u.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(xe,ct,nt)),ii=xe.set(u.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(xe,nt,K)),Ci=xe.set(u.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(xe,nt,St)),ni=xe.set(u.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(xe.getProxy(u.MainContext.MainThreadProgress))),di=xe.set(u.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(xe)),bi=xe.set(u.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(xe)),ri=xe.set(u.ExtHostContext.ExtHostAuthentication,new U.ExtHostAuthentication(xe)),Ii=xe.set(u.ExtHostContext.ExtHostTimeline,new z.ExtHostTimeline(xe,nt)),hi=xe.set(u.ExtHostContext.ExtHostWebviews,new de.ExtHostWebviews(xe,ft.remote,ct,K,Pe)),fi=xe.set(u.ExtHostContext.ExtHostWebviewPanels,new Le.ExtHostWebviewPanels(xe,hi,ct)),Ti=xe.set(u.ExtHostContext.ExtHostCustomEditors,new Oe.ExtHostCustomEditors(xe,St,we,hi,fi)),mi=xe.set(u.ExtHostContext.ExtHostWebviewViews,new ve.ExtHostWebviewViews(xe,hi)),Ht=xe.set(u.ExtHostContext.ExtHostTesting,new Je.ExtHostTesting(xe,nt)),ki=xe.set(u.ExtHostContext.ExtHostUriOpeners,new ke.ExtHostUriOpeners(xe));xe.set(u.ExtHostContext.ExtHostInteractive,new mt.ExtHostInteractive(xe,ht,vt,nt));const Pi=(0,he.values)(u.ExtHostContext);xe.assertRegistered(Pi);const Ai=new Ne.ExtHostBulkEdits(xe,vt),si=new r.ExtHostClipboard(xe),gi=new d.ExtHostMessageService(xe,K),wi=new _.ExtHostDialogs(xe),_i=new v.ExtHostStatusBar(xe,nt.converter);return o.ExtHostApiCommands.register(nt),function(Re,Qt,Si){const lt=function(){let Z=!Re.isUnderDevelopment;function oe(){Z||(K.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Ie(it){if(Array.isArray(it))it.forEach(Ie);else if(typeof it=="string")oe();else{const bt=it;typeof bt.scheme=="undefined"&&oe(),typeof bt.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Re,"documentFiltersExclusive")}return it}}(),Vt={getSession(Z,oe,Ie){return ri.getSession(Re,Z,oe,Ie)},async hasSession(Z,oe){return(0,qe.checkProposedApiEnabled)(Re,"authSession"),!!await ri.getSession(Re,Z,oe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,oe,Ie,it){return ri.registerAuthenticationProvider(Z,oe,Ie,it)}},Ri={registerCommand(Z,oe,Ie){return nt.registerCommand(!0,Z,oe,Ie,void 0,Re)},registerTextEditorCommand(Z,oe,Ie){return nt.registerCommand(!0,Z,(...it)=>{const bt=Tt.getActiveTextEditor();if(!bt){K.warn("Cannot execute "+Z+" because there is no active text editor.");return}return bt.edit(Ct=>{oe.apply(Ie,[bt,Ct,...it])}).then(Ct=>{Ct||K.warn("Edits from command "+Z+" were not applied.")},Ct=>{K.warn("An error occurred while running command "+Z,Ct)})},void 0,void 0,Re)},registerDiffInformationCommand:(Z,oe,Ie)=>((0,qe.checkProposedApiEnabled)(Re,"diffCommand"),nt.registerCommand(!0,Z,async(...it)=>{const bt=vt.activeEditor(!0);if(!bt){K.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Ct=await Tt.getDiffInformation(bt.id);oe.apply(Ie,[Ct,...it])},void 0,void 0,Re)),executeCommand(Z,...oe){return nt.executeCommand(Z,...oe)},getCommands(Z=!1){return nt.getCommands(Z)}},Ot={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return si.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Re,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Re,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const Z=Date.now()-new Date(ft.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,oe){return $e.openUri(Z,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ft.environment.appUriScheme)return yt.createAppUri(Z);try{return await $e.asExternalUri(Z,{allowTunneling:!!ft.remote.authority})}catch(oe){if((0,Ze.matchesScheme)(Z,Xe.Schemas.http)||(0,Ze.matchesScheme)(Z,Xe.Schemas.https))return Z;throw oe}},get remoteName(){return(0,ae.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Re,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind}};ft.environment.extensionTestsLocationURI||Object.freeze(Ot);const Yt=ft.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,Oi={createTestController(Z,oe,Ie){return Ht.createTestController(Z,oe,Ie)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Re,"testObserver"),Ht.createTestObserver()},runTests(Z){return(0,qe.checkProposedApiEnabled)(Re,"testObserver"),Ht.runTests(Z)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Re,"testObserver"),Ht.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Re,"testObserver"),Ht.results}},Fi={getExtension(Z){const oe=Qt.getExtensionDescription(Z);if(oe)return new i.Extension(_t,Re.identifier,oe,Yt)},get all(){return Qt.getAllExtensionDescriptions().map(Z=>new i.Extension(_t,Re.identifier,Z,Yt))},get onDidChange(){return Qt.onDidChange}},Ni={createDiagnosticCollection(Z){return Gt.createDiagnosticCollection(Re.identifier,Z)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:Z=>Gt.getDiagnostics(Z),getLanguages(){return ti.getLanguages()},setTextDocumentLanguage(Z,oe){return ti.changeLanguage(Z.uri,oe)},match(Z,oe){return(0,L.score)(H.LanguageSelector.from(Z),oe.uri,oe.languageId,!0,oe.notebook?.notebookType)},registerCodeActionsProvider(Z,oe,Ie){return st.registerCodeActionProvider(Re,lt(Z),oe,Ie)},registerCodeLensProvider(Z,oe){return st.registerCodeLensProvider(Re,lt(Z),oe)},registerDefinitionProvider(Z,oe){return st.registerDefinitionProvider(Re,lt(Z),oe)},registerDeclarationProvider(Z,oe){return st.registerDeclarationProvider(Re,lt(Z),oe)},registerImplementationProvider(Z,oe){return st.registerImplementationProvider(Re,lt(Z),oe)},registerTypeDefinitionProvider(Z,oe){return st.registerTypeDefinitionProvider(Re,lt(Z),oe)},registerHoverProvider(Z,oe){return st.registerHoverProvider(Re,lt(Z),oe,Re.identifier)},registerEvaluatableExpressionProvider(Z,oe){return st.registerEvaluatableExpressionProvider(Re,lt(Z),oe,Re.identifier)},registerInlineValuesProvider(Z,oe){return st.registerInlineValuesProvider(Re,lt(Z),oe,Re.identifier)},registerDocumentHighlightProvider(Z,oe){return st.registerDocumentHighlightProvider(Re,lt(Z),oe)},registerLinkedEditingRangeProvider(Z,oe){return st.registerLinkedEditingRangeProvider(Re,lt(Z),oe)},registerReferenceProvider(Z,oe){return st.registerReferenceProvider(Re,lt(Z),oe)},registerRenameProvider(Z,oe){return st.registerRenameProvider(Re,lt(Z),oe)},registerDocumentSymbolProvider(Z,oe,Ie){return st.registerDocumentSymbolProvider(Re,lt(Z),oe,Ie)},registerWorkspaceSymbolProvider(Z){return st.registerWorkspaceSymbolProvider(Re,Z)},registerDocumentFormattingEditProvider(Z,oe){return st.registerDocumentFormattingEditProvider(Re,lt(Z),oe)},registerDocumentRangeFormattingEditProvider(Z,oe){return st.registerDocumentRangeFormattingEditProvider(Re,lt(Z),oe)},registerOnTypeFormattingEditProvider(Z,oe,Ie,...it){return st.registerOnTypeFormattingEditProvider(Re,lt(Z),oe,[Ie].concat(it))},registerDocumentSemanticTokensProvider(Z,oe,Ie){return st.registerDocumentSemanticTokensProvider(Re,lt(Z),oe,Ie)},registerDocumentRangeSemanticTokensProvider(Z,oe,Ie){return st.registerDocumentRangeSemanticTokensProvider(Re,lt(Z),oe,Ie)},registerSignatureHelpProvider(Z,oe,Ie,...it){return typeof Ie=="object"?st.registerSignatureHelpProvider(Re,lt(Z),oe,Ie):st.registerSignatureHelpProvider(Re,lt(Z),oe,typeof Ie=="undefined"?[]:[Ie,...it])},registerCompletionItemProvider(Z,oe,...Ie){return st.registerCompletionItemProvider(Re,lt(Z),oe,Ie)},registerInlineCompletionItemProvider(Z,oe){return(0,qe.checkProposedApiEnabled)(Re,"inlineCompletions"),st.registerInlineCompletionsProvider(Re,lt(Z),oe)},registerInlineCompletionItemProviderNew(Z,oe){if((0,qe.checkProposedApiEnabled)(Re,"inlineCompletionsNew"),oe.handleDidShowCompletionItem&&!(0,qe.isProposedApiEnabled)(Re,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return st.registerInlineCompletionsProviderNew(Re,lt(Z),oe)},registerDocumentLinkProvider(Z,oe){return st.registerDocumentLinkProvider(Re,lt(Z),oe)},registerColorProvider(Z,oe){return st.registerColorProvider(Re,lt(Z),oe)},registerFoldingRangeProvider(Z,oe){return st.registerFoldingRangeProvider(Re,lt(Z),oe)},registerSelectionRangeProvider(Z,oe){return st.registerSelectionRangeProvider(Re,Z,oe)},registerCallHierarchyProvider(Z,oe){return st.registerCallHierarchyProvider(Re,Z,oe)},registerTypeHierarchyProvider(Z,oe){return st.registerTypeHierarchyProvider(Re,Z,oe)},setLanguageConfiguration:(Z,oe)=>st.setLanguageConfiguration(Re,Z,oe),getTokenInformationAtPosition(Z,oe){return(0,qe.checkProposedApiEnabled)(Re,"tokenInformation"),ti.tokenAtPosition(Z,oe)},registerInlayHintsProvider(Z,oe){return st.registerInlayHintsProvider(Re,Z,oe)},createLanguageStatusItem(Z,oe){return ti.createLanguageStatusItem(Re,Z,oe)}},Mi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(Z,oe,Ie){const it=await(I.URI.isUri(Z)?Promise.resolve(Di.openTextDocument(Z)):Promise.resolve(Z));return Tt.showTextDocument(it,oe,Ie)},createTextEditorDecorationType(Z){return Tt.createTextEditorDecorationType(Re,Z)},onDidChangeActiveTextEditor(Z,oe,Ie){return Tt.onDidChangeActiveTextEditor(Z,oe,Ie)},onDidChangeVisibleTextEditors(Z,oe,Ie){return Tt.onDidChangeVisibleTextEditors(Z,oe,Ie)},onDidChangeTextEditorSelection(Z,oe,Ie){return Tt.onDidChangeTextEditorSelection(Z,oe,Ie)},onDidChangeTextEditorOptions(Z,oe,Ie){return Tt.onDidChangeTextEditorOptions(Z,oe,Ie)},onDidChangeTextEditorVisibleRanges(Z,oe,Ie){return Tt.onDidChangeTextEditorVisibleRanges(Z,oe,Ie)},onDidChangeTextEditorViewColumn(Z,oe,Ie){return Tt.onDidChangeTextEditorViewColumn(Z,oe,Ie)},onDidCloseTerminal(Z,oe,Ie){return ut.onDidCloseTerminal(Z,oe,Ie)},onDidOpenTerminal(Z,oe,Ie){return ut.onDidOpenTerminal(Z,oe,Ie)},onDidChangeActiveTerminal(Z,oe,Ie){return ut.onDidChangeActiveTerminal(Z,oe,Ie)},onDidChangeTerminalDimensions(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"terminalDimensions"),ut.onDidChangeTerminalDimensions(Z,oe,Ie)},onDidChangeTerminalState(Z,oe,Ie){return ut.onDidChangeTerminalState(Z,oe,Ie)},onDidWriteTerminalData(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(Z,oe,Ie)},get state(){return $e.state},onDidChangeWindowState(Z,oe,Ie){return $e.onDidChangeWindowState(Z,oe,Ie)},showInformationMessage(Z,...oe){return gi.showMessage(Re,M.default.Info,Z,oe[0],oe.slice(1))},showWarningMessage(Z,...oe){return gi.showMessage(Re,M.default.Warning,Z,oe[0],oe.slice(1))},showErrorMessage(Z,...oe){return gi.showMessage(Re,M.default.Error,Z,oe[0],oe.slice(1))},showQuickPick(Z,oe,Ie){return zt.showQuickPick(Z,oe,Ie)},showWorkspaceFolderPick(Z){return zt.showWorkspaceFolderPick(Z)},showInputBox(Z,oe){return Z?.validateInput2&&((0,qe.checkProposedApiEnabled)(Re,"inputBoxSeverity"),Z.validateInput=Z.validateInput2),zt.showInput(Z,oe)},showOpenDialog(Z){return wi.showOpenDialog(Z)},showSaveDialog(Z){return wi.showSaveDialog(Z)},createStatusBarItem(Z,oe,Ie){let it,bt,Ct;return typeof Z=="string"?(it=Z,bt=oe,Ct=Ie):(bt=Z,Ct=oe),_i.createStatusBarEntry(Re,it,bt,Ct)},setStatusBarMessage(Z,oe){return _i.setStatusBarMessage(Z,oe)},withScmProgress(Z){return Pe.report("window.withScmProgress",Re,"Use 'withProgress' instead."),ni.withProgress(Re,{location:R.ProgressLocation.SourceControl},(oe,Ie)=>Z({report(it){}}))},withProgress(Z,oe){return ni.withProgress(Re,Z,oe)},createOutputChannel(Z,oe){return It.createOutputChannel(Z,oe,Re)},createWebviewPanel(Z,oe,Ie,it){return fi.createWebviewPanel(Re,Z,oe,Ie,it)},createWebviewTextEditorInset(Z,oe,Ie,it){return(0,qe.checkProposedApiEnabled)(Re,"editorInsets"),ci.createWebviewEditorInset(Z,oe,Ie,it,Re)},createTerminal(Z,oe,Ie){return typeof Z=="object"?"pty"in Z?ut.createExtensionTerminal(Z):ut.createTerminalFromOptions(Z):ut.createTerminal(Z,oe,Ie)},registerTerminalLinkProvider(Z){return ut.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,oe){return ut.registerProfileProvider(Re,Z,oe)},registerTreeDataProvider(Z,oe){return ei.registerTreeDataProvider(Z,oe,Re)},createTreeView(Z,oe){return ei.createTreeView(Z,oe,Re)},registerWebviewPanelSerializer:(Z,oe)=>fi.registerWebviewPanelSerializer(Re,Z,oe),registerCustomEditorProvider:(Z,oe,Ie={})=>Ti.registerCustomEditorProvider(Re,Z,oe,Ie),registerFileDecorationProvider(Z){return pt.registerFileDecorationProvider(Z,Re.identifier)},registerUriHandler(Z){return yt.registerUriHandler(Re.identifier,Z)},createQuickPick(){return zt.createQuickPick(Re)},createInputBox(){return zt.createInputBox(Re)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(Z,oe,Ie){return bi.onDidChangeActiveColorTheme(Z,oe,Ie)},registerWebviewViewProvider(Z,oe,Ie){return mi.registerWebviewViewProvider(Re,Z,oe,Ie?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.onDidChangeActiveNotebookEditor(Z,oe,Ie)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(Z,oe,Ie)},onDidChangeNotebookEditorVisibleRanges(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(Z,oe,Ie)},showNotebookDocument(Z,oe){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.showNotebookDocument(Z,oe)},registerExternalUriOpener(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"externalUriOpener"),ki.registerExternalUriOpener(Re.identifier,Z,oe,Ie)},get tabGroups(){return(0,qe.checkProposedApiEnabled)(Re,"tabs"),dt.tabGroups},getInlineCompletionItemController(Z){return(0,qe.checkProposedApiEnabled)(Re,"inlineCompletions"),n.InlineCompletionController.get(Z)}},Di={get rootPath(){return Pe.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath(Z){throw T.readonly()},getWorkspaceFolder(Z){return ct.getWorkspaceFolder(Z)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name(Z){throw T.readonly()},get workspaceFile(){return ct.workspaceFile},set workspaceFile(Z){throw T.readonly()},updateWorkspaceFolders:(Z,oe,...Ie)=>ct.updateWorkspaceFolders(Re,Z,oe||0,...Ie),onDidChangeWorkspaceFolders:function(Z,oe,Ie){return ct.onDidChangeWorkspace(Z,oe,Ie)},asRelativePath:(Z,oe)=>ct.getRelativePath(Z,oe),findFiles:(Z,oe,Ie,it)=>ct.findFiles(Z,oe,Ie,Re.identifier,it),findTextInFiles:(Z,oe,Ie,it)=>{(0,qe.checkProposedApiEnabled)(Re,"findTextInFiles");let bt,Ct;return typeof oe=="object"?(bt=oe,Ct=Ie):(bt={},Ct=oe,it=Ie),ct.findTextInFiles(Z,bt||{},Ct,Re.identifier,it)},saveAll:Z=>ct.saveAll(Z),applyEdit(Z){return Ai.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,oe,Ie,it)=>Bt.createFileSystemWatcher(ct,Re,Z,oe,Ie,it),get textDocuments(){return St.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw T.readonly()},openTextDocument(Z){let oe;const Ie=Z;if(typeof Z=="string")oe=Promise.resolve(I.URI.file(Z));else if(I.URI.isUri(Z))oe=Promise.resolve(Z);else if(!Ie||typeof Ie=="object")oe=St.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(it=>St.ensureDocumentData(it).then(bt=>bt.document))},onDidOpenTextDocument:(Z,oe,Ie)=>St.onDidAddDocument(Z,oe,Ie),onDidCloseTextDocument:(Z,oe,Ie)=>St.onDidRemoveDocument(Z,oe,Ie),onDidChangeTextDocument:(Z,oe,Ie)=>St.onDidChangeDocument(Z,oe,Ie),onDidSaveTextDocument:(Z,oe,Ie)=>St.onDidSaveDocument(Z,oe,Ie),onWillSaveTextDocument:(Z,oe,Ie)=>Wt.getOnWillSaveTextDocumentEvent(Re)(Z,oe,Ie),onWillDropOnTextEditor:(Z,oe,Ie)=>((0,qe.checkProposedApiEnabled)(Re,"textEditorDrop"),Tt.onWillDropOnTextEditor(Z,oe,Ie)),get notebookDocuments(){return ht.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,oe){let Ie;if(I.URI.isUri(Z))Ie=Z,await ht.openNotebookDocument(Z);else if(typeof Z=="string")Ie=I.URI.revive(await ht.createNotebookDocument({viewType:Z,content:oe}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(Ie).apiNotebook},onDidSaveNotebookDocument(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookDocumentEvents"),Kt.onDidSaveNotebookDocument(Z,oe,Ie)},onDidChangeNotebookDocument(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookDocumentEvents"),Kt.onDidChangeNotebookDocument(Z,oe,Ie)},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(Z,oe,Ie,it){return ht.registerNotebookSerializer(Re,Z,oe,Ie,(0,qe.isProposedApiEnabled)(Re,"notebookLiveShare")?it:void 0)},registerNotebookContentProvider:(Z,oe,Ie,it)=>((0,qe.checkProposedApiEnabled)(Re,"notebookContentProvider"),ht.registerNotebookContentProvider(Re,Z,oe,Ie,(0,qe.isProposedApiEnabled)(Re,"notebookLiveShare")?it:void 0)),onDidChangeConfiguration:(Z,oe,Ie)=>Si.onDidChangeConfiguration(Z,oe,Ie),getConfiguration(Z,oe){return oe=arguments.length===1?void 0:oe,Si.getConfiguration(Z,oe,Re)},registerTextDocumentContentProvider(Z,oe){return Jt.registerTextDocumentContentProvider(Z,oe)},registerTaskProvider:(Z,oe)=>(Pe.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Re,Z,oe)),registerFileSystemProvider(Z,oe,Ie){return(0,kt.combinedDisposable)(ui.registerFileSystemProvider(Re,Z,oe,Ie),Pt.addFileSystemProvider(Z,oe))},get fs(){return Pt.value},registerFileSearchProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Re,"fileSearchProvider"),Lt.registerFileSearchProvider(Z,oe)),registerTextSearchProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Re,"textSearchProvider"),Lt.registerTextSearchProvider(Z,oe)),registerRemoteAuthorityResolver:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Re,"resolvers"),_t.registerRemoteAuthorityResolver(Z,oe)),registerResourceLabelFormatter:Z=>((0,qe.checkProposedApiEnabled)(Re,"resolvers"),di.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,oe,Ie)=>Bt.onDidCreateFile(Z,oe,Ie),onDidDeleteFiles:(Z,oe,Ie)=>Bt.onDidDeleteFile(Z,oe,Ie),onDidRenameFiles:(Z,oe,Ie)=>Bt.onDidRenameFile(Z,oe,Ie),onWillCreateFiles:(Z,oe,Ie)=>Bt.getOnWillCreateFileEvent(Re)(Z,oe,Ie),onWillDeleteFiles:(Z,oe,Ie)=>Bt.getOnWillDeleteFileEvent(Re)(Z,oe,Ie),onWillRenameFiles:(Z,oe,Ie)=>Bt.getOnWillRenameFileEvent(Re)(Z,oe,Ie),openTunnel:Z=>((0,qe.checkProposedApiEnabled)(Re,"resolvers"),ye.openTunnel(Re,Z).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Re,"resolvers"),ye.getTunnels()},onDidChangeTunnels:(Z,oe,Ie)=>((0,qe.checkProposedApiEnabled)(Re,"resolvers"),ye.onDidChangeTunnels(Z,oe,Ie)),registerPortAttributesProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Re,"portsAttributes"),ye.registerPortsAttributesProvider(Z,oe)),registerTimelineProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Re,"timeline"),Ii.registerTimelineProvider(Z,oe,Re.identifier,nt.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:Z=>((0,qe.checkProposedApiEnabled)(Re,"workspaceTrust"),ct.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,oe,Ie)=>ct.onDidGrantWorkspaceTrust(Z,oe,Ie)},Li={get inputBox(){return Pe.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),ii.getLastInputBox(Re)},createSourceControl(Z,oe,Ie){return ii.createSourceControl(Re,Z,oe,Ie)}},Ui={createCommentController(Z,oe){return Ci.createCommentController(Re,Z,oe)}},pi={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(Z,oe,Ie){return at.onDidStartDebugSession(Z,oe,Ie)},onDidTerminateDebugSession(Z,oe,Ie){return at.onDidTerminateDebugSession(Z,oe,Ie)},onDidChangeActiveDebugSession(Z,oe,Ie){return at.onDidChangeActiveDebugSession(Z,oe,Ie)},onDidReceiveDebugSessionCustomEvent(Z,oe,Ie){return at.onDidReceiveDebugSessionCustomEvent(Z,oe,Ie)},onDidChangeBreakpoints(Z,oe,Ie){return at.onDidChangeBreakpoints(Z,oe,Ie)},registerDebugConfigurationProvider(Z,oe,Ie){return at.registerDebugConfigurationProvider(Z,oe,Ie||gt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,oe){return at.registerDebugAdapterDescriptorFactory(Re,Z,oe)},registerDebugAdapterTrackerFactory(Z,oe){return at.registerDebugAdapterTrackerFactory(Z,oe)},startDebugging(Z,oe,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?at.startDebugging(Z,oe,{parentSession:Ie}):at.startDebugging(Z,oe,Ie||{})},stopDebugging(Z){return at.stopDebugging(Z)},addBreakpoints(Z){return at.addBreakpoints(Z)},removeBreakpoints(Z){return at.removeBreakpoints(Z)},asDebugSourceUri(Z,oe){return at.asDebugSourceUri(Z,oe)}},Bi={registerTaskProvider:(Z,oe)=>Et.registerTaskProvider(Re,Z,oe),fetchTasks:Z=>Et.fetchTasks(Z),executeTask:Z=>Et.executeTask(Re,Z),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(Z,oe,Ie)=>Et.onDidStartTask(Z,oe,Ie),onDidEndTask:(Z,oe,Ie)=>Et.onDidEndTask(Z,oe,Ie),onDidStartTaskProcess:(Z,oe,Ie)=>Et.onDidStartTaskProcess(Z,oe,Ie),onDidEndTaskProcess:(Z,oe,Ie)=>Et.onDidEndTaskProcess(Z,oe,Ie)},xi={createNotebookController(Z,oe,Ie,it,bt){return Zt.createNotebookController(Re,Z,oe,Ie,it,(0,qe.isProposedApiEnabled)(Re,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,oe)=>ht.registerNotebookCellStatusBarItemProvider(Re,Z,oe),get onDidSaveNotebookDocument(){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return li.createRendererMessaging(Re,Z)},onDidChangeNotebookDocumentMetadata(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),Kt.onDidChangeNotebookDocumentMetadata(Z,oe,Ie)},onDidChangeNotebookCells(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.onDidChangeNotebookCells(Z,oe,Ie)},onDidChangeNotebookCellExecutionState(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(Z,oe,Ie)},onDidChangeCellOutputs(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.onDidChangeCellOutputs(Z,oe,Ie)},onDidChangeCellMetadata(Z,oe,Ie){return(0,qe.checkProposedApiEnabled)(Re,"notebookEditor"),ht.onDidChangeCellMetadata(Z,oe,Ie)},createConcatTextDocument(Z,oe){return(0,qe.checkProposedApiEnabled)(Re,"notebookConcatTextDocument"),new j.ExtHostNotebookConcatDocument(ht,St,Z,oe)}};return{version:ft.version,authentication:Vt,commands:Ri,comments:Ui,debug:pi,env:Ot,extensions:Fi,languages:Ni,notebooks:xi,scm:Li,tasks:Bi,tests:Oi,window:Mi,workspace:Di,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CommentThreadState:R.CommentThreadState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:gt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:R.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionItemNew:R.InlineSuggestionNew,InlineCompletionList:R.InlineSuggestions,InlineCompletionListNew:R.InlineSuggestionsNew,Hover:R.Hover,IndentAction:O.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TerminalLink:R.TerminalLink,TerminalLocation:R.TerminalLocation,TerminalProfile:R.TerminalProfile,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,TextDocumentChangeReason:R.TextDocumentChangeReason,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,TypeHierarchyItem:R.TypeHierarchyItem,UIKind:g.UIKind,Uri:I.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintLabelPart:R.InlayHintLabelPart,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestResultState:R.TestResultState,TestRunRequest:R.TestRunRequest,TestMessage:R.TestMessage,TestTag:R.TestTag,TestRunProfileKind:R.TestRunProfileKind,TextSearchCompleteMessageType:Me.TextSearchCompleteMessageType,DataTransfer:R.DataTransfer,DataTransferItem:R.DataTransferItem,CoveredCount:R.CoveredCount,FileCoverage:R.FileCoverage,StatementCoverage:R.StatementCoverage,BranchCoverage:R.BranchCoverage,FunctionCoverage:R.FunctionCoverage,WorkspaceTrustState:R.WorkspaceTrustState,LanguageStatusSeverity:R.LanguageStatusSeverity,QuickPickItemKind:R.QuickPickItemKind,InputBoxValidationSeverity:R.InputBoxValidationSeverity,TabKindText:R.TextTabInput,TabKindTextDiff:R.TextDiffTabInput,TabKindCustom:R.CustomEditorTabInput,TabKindNotebook:R.NotebookEditorTabInput,TabKindNotebookDiff:R.NotebookDiffEditorTabInput,TabKindWebview:R.WebviewEditorTabInput,TabKindTerminal:R.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=Nt}),define(be[226],Se([1,0,225,33,2,219,6,12,4]),function(J,e,l,T,b,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class O extends M.RequireInterceptor{_installInterceptor(){}getModule(o,r){for(let f of this._alternatives){let p=f(o);if(p){o=p;break}}if(this._factories.has(o))return this._factories.get(o).load(o,r,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class L extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);u(o,this._initData.environment.isExtensionDevelopmentDebug);const r=this._instaService.invokeFunction(l.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(O,r,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,r,f){r=r.with({path:C(r.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const p=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(r)),D=await fetch(p.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),D.status!==200)throw new Error(D.statusText);const h=await D.text(),_=`${r.toString(!0)}#vscode-extension`,E=`${h}
//# sourceURL=${_}`;let a;try{a=new Function("module","exports","require",E)}catch(c){throw console.error(o?`Loading code for extension ${o.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${r.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const k={},s={exports:k},i=c=>{const t=this._fakeModules.getModule(c,r);if(t===void 0)throw new Error(`Cannot load module '${c}'`);return t};try{return f.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),a(s,k,i),s.exports!==k?s.exports:k}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),f.codeLoadingStop()}}async $setRemoteEnvironment(o){}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const r=Date.now()+o;for(;Date.now()<r&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=L;function C(g,o){return g.endsWith(o)?g:g+o}function u(g,o){r("info","log"),r("log","log"),r("warn","warn"),r("error","error");function r(D,h){const _=console[D];console[D]=function(){g.$logExtensionHostMessage({type:"__$console",severity:h,arguments:p(arguments)}),o&&_.apply(console,arguments)}}const f=1e5;function p(D){const h=[],_=[];if(D.length)for(let E=0;E<D.length;E++){if(typeof D[E]=="undefined")D[E]="undefined";else if(D[E]instanceof Error){const a=D[E];a.stack?D[E]=a.stack:D[E]=a.toString()}_.push(D[E])}try{const E=JSON.stringify(_,function(a,k){if(k&&typeof k=="object"){if(h.indexOf(k)!==-1)return"[Circular]";h.push(k)}return k});return E.length>f?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}}),define(be[227],Se([1,0,55,33,71,226]),function(J,e,l,T,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(T.IExtHostExtensionService,M.ExtHostExtensionService),(0,l.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(be[238],Se([1,0,22,5,92,220,213,17,72,11,2,222,227]),function(J,e,l,T,b,M,I,A,y,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function g(a){return/^(file|vscode-remote):/i.test(a)}const o=fetch.bind(self);function r(a){self.fetch=async function(k,s){return k instanceof Request||g(String(k))&&(k=(await a(L.URI.parse(String(k)))).toString(!0)),o(k,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,s,i,c,t){(async()=>{g(s.toString())&&(s=(await a(L.URI.parse(s.toString()))).toString(!0)),super.open(k,s,i??!0,c,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.Worker;Worker=function(k,s){if(/^file:/i.test(k.toString()))k=O.FileAccess.asBrowserUri(L.URI.parse(k.toString())).toString(!0);else if(/^vscode-remote:/i.test(k.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(d){function S(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const P=fetch.bind(self);self.fetch=function(F,v){return F instanceof Request?P(F,v):P(S(F),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,v,x,W,V){return super.open(F,S(v),x??!0,W,V)}};const B=importScripts.bind(self);self.importScripts=(...F)=>{B(...F.map(S))},B(d)}.toString()}('${k}'))`;s=s||{},s.name=s.name||A.basename(k.toString());const t=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(t);return new a(n,s)}}else self.Worker=class extends I.NestedWorker{constructor(a,k){super(u,a,{name:A.basename(a.toString()),...k})}};const f=new class{constructor(){this.pid=void 0}exit(a){C()}async exists(a){return!0}async realpath(a){return a}};class p{constructor(){const k=new MessageChannel,s=new T.Emitter;let i=!1;u(k.port2,[k.port2]),k.port1.onmessage=c=>{const{data:t}=c;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const n=l.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(n,2)){i=!0,h("received terminate message from renderer");return}s.fire(n)},this.protocol={onMessage:s.event,send:c=>{if(!i){const t=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);k.port1.postMessage(t,[t])}}}}}function D(a){return new Promise(k=>{const s=a.onMessage(i=>{s.dispose();const c=JSON.parse(i.toString());a.send((0,b.createMessageOfType)(0)),k({protocol:a,initData:c})});a.send((0,b.createMessageOfType)(1))})}let h=a=>C();function _(a){return!!a&&typeof a=="object"&&a.type==="vscode.init"&&a.data instanceof Map}function E(){y.mark("code/extHost/willConnectToRenderer");const a=new p;return{onmessage(k){!_(k)||D(a.protocol).then(s=>{y.mark("code/extHost/didWaitForInitData");const i=new M.ExtensionHostMain(s.protocol,s.initData,f,null,k.data);r(c=>i.asBrowserUri(c)),h=c=>i.terminate(c)})}}}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/worker/extensionHostWorker.js.map
